/*
Package exampleoc is a generated package which contains definitions
of structs which generate gNMI paths for a YANG schema. The generated paths are
based on a compressed form of the schema.

This package was generated by /usr/local/google/home/wenbli/gocode/src/github.com/openconfig/ygot4/genutil/names.go
using the following YANG input files:
	- public/release/models/network-instance/openconfig-network-instance.yang
	- public/release/models/optical-transport/openconfig-optical-amplifier.yang
	- public/release/models/optical-transport/openconfig-terminal-device.yang
	- public/release/models/optical-transport/openconfig-transport-line-protection.yang
	- public/release/models/platform/openconfig-platform.yang
	- public/release/models/policy/openconfig-routing-policy.yang
	- public/release/models/lacp/openconfig-lacp.yang
	- public/release/models/system/openconfig-system.yang
	- public/release/models/stp/openconfig-spanning-tree.yang
	- public/release/models/interfaces/openconfig-interfaces.yang
	- public/release/models/interfaces/openconfig-if-ip.yang
	- public/release/models/interfaces/openconfig-if-aggregate.yang
	- public/release/models/interfaces/openconfig-if-ethernet.yang
	- public/release/models/interfaces/openconfig-if-ip-ext.yang
	- public/release/models/relay-agent/openconfig-relay-agent.yang
	- public/release/models/lldp/openconfig-lldp.yang
Imported modules were sourced from:
	- public/...
	- deps/...
*/
package exampleoc

import (
	"github.com/openconfig/ygot/ygot"
)

// AclPath represents the /openconfig-acl/acl YANG schema element.
type AclPath struct {
	*ygot.NodePath
}

// AclPathAny represents the wildcard version of the /openconfig-acl/acl YANG schema element.
type AclPathAny struct {
	*ygot.NodePath
}

// Acl_CounterCapabilityPath represents the /openconfig-acl/acl/state/counter-capability YANG schema element.
type Acl_CounterCapabilityPath struct {
	*ygot.NodePath
}

// Acl_CounterCapabilityPathAny represents the wildcard version of the /openconfig-acl/acl/state/counter-capability YANG schema element.
type Acl_CounterCapabilityPathAny struct {
	*ygot.NodePath
}

// AclSetAny (list): List of ACL sets, each comprising of a list of ACL
// entries
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-sets/acl-set"
// Path from root: "/acl/acl-sets/acl-set"
// Name (wildcarded): string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *AclPath) AclSetAny() *Acl_AclSetPathAny {
	return &Acl_AclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-sets", "acl-set"},
			map[string]interface{}{"name": "*", "type": "*"},
			n,
		),
	}
}

// AclSetAny (list): List of ACL sets, each comprising of a list of ACL
// entries
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-sets/acl-set"
// Path from root: "/acl/acl-sets/acl-set"
// Name (wildcarded): string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *AclPathAny) AclSetAny() *Acl_AclSetPathAny {
	return &Acl_AclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-sets", "acl-set"},
			map[string]interface{}{"name": "*", "type": "*"},
			n,
		),
	}
}

// AclSetAnyType (list): List of ACL sets, each comprising of a list of ACL
// entries
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-sets/acl-set"
// Path from root: "/acl/acl-sets/acl-set"
// Name: string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *AclPath) AclSetAnyType(Name string) *Acl_AclSetPathAny {
	return &Acl_AclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-sets", "acl-set"},
			map[string]interface{}{"name": Name, "type": "*"},
			n,
		),
	}
}

// AclSetAnyType (list): List of ACL sets, each comprising of a list of ACL
// entries
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-sets/acl-set"
// Path from root: "/acl/acl-sets/acl-set"
// Name: string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *AclPathAny) AclSetAnyType(Name string) *Acl_AclSetPathAny {
	return &Acl_AclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-sets", "acl-set"},
			map[string]interface{}{"name": Name, "type": "*"},
			n,
		),
	}
}

// AclSetAnyName (list): List of ACL sets, each comprising of a list of ACL
// entries
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-sets/acl-set"
// Path from root: "/acl/acl-sets/acl-set"
// Name (wildcarded): string
// Type: E_Acl_ACL_TYPE
func (n *AclPath) AclSetAnyName(Type E_Acl_ACL_TYPE) *Acl_AclSetPathAny {
	return &Acl_AclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-sets", "acl-set"},
			map[string]interface{}{"name": "*", "type": Type},
			n,
		),
	}
}

// AclSetAnyName (list): List of ACL sets, each comprising of a list of ACL
// entries
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-sets/acl-set"
// Path from root: "/acl/acl-sets/acl-set"
// Name (wildcarded): string
// Type: E_Acl_ACL_TYPE
func (n *AclPathAny) AclSetAnyName(Type E_Acl_ACL_TYPE) *Acl_AclSetPathAny {
	return &Acl_AclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-sets", "acl-set"},
			map[string]interface{}{"name": "*", "type": Type},
			n,
		),
	}
}

// AclSet (list): List of ACL sets, each comprising of a list of ACL
// entries
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-sets/acl-set"
// Path from root: "/acl/acl-sets/acl-set"
// Name: string
// Type: E_Acl_ACL_TYPE
func (n *AclPath) AclSet(Name string, Type E_Acl_ACL_TYPE) *Acl_AclSetPath {
	return &Acl_AclSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"acl-sets", "acl-set"},
			map[string]interface{}{"name": Name, "type": Type},
			n,
		),
	}
}

// AclSet (list): List of ACL sets, each comprising of a list of ACL
// entries
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-sets/acl-set"
// Path from root: "/acl/acl-sets/acl-set"
// Name: string
// Type: E_Acl_ACL_TYPE
func (n *AclPathAny) AclSet(Name string, Type E_Acl_ACL_TYPE) *Acl_AclSetPathAny {
	return &Acl_AclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-sets", "acl-set"},
			map[string]interface{}{"name": Name, "type": Type},
			n,
		),
	}
}

// CounterCapability (leaf): System reported indication of how ACL counters are reported
// by the target
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/counter-capability"
// Path from root: "/acl/state/counter-capability"
func (n *AclPath) CounterCapability() *Acl_CounterCapabilityPath {
	return &Acl_CounterCapabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counter-capability"},
			map[string]interface{}{},
			n,
		),
	}
}

// CounterCapability (leaf): System reported indication of how ACL counters are reported
// by the target
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/counter-capability"
// Path from root: "/acl/state/counter-capability"
func (n *AclPathAny) CounterCapability() *Acl_CounterCapabilityPathAny {
	return &Acl_CounterCapabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counter-capability"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which ACLs are set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "interfaces/interface"
// Path from root: "/acl/interfaces/interface"
// Id (wildcarded): string
func (n *AclPath) InterfaceAny() *Acl_InterfacePathAny {
	return &Acl_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which ACLs are set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "interfaces/interface"
// Path from root: "/acl/interfaces/interface"
// Id (wildcarded): string
func (n *AclPathAny) InterfaceAny() *Acl_InterfacePathAny {
	return &Acl_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Interface (list): List of interfaces on which ACLs are set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "interfaces/interface"
// Path from root: "/acl/interfaces/interface"
// Id: string
func (n *AclPath) Interface(Id string) *Acl_InterfacePath {
	return &Acl_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Interface (list): List of interfaces on which ACLs are set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "interfaces/interface"
// Path from root: "/acl/interfaces/interface"
// Id: string
func (n *AclPathAny) Interface(Id string) *Acl_InterfacePathAny {
	return &Acl_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Acl_AclSetPath represents the /openconfig-acl/acl/acl-sets/acl-set YANG schema element.
type Acl_AclSetPath struct {
	*ygot.NodePath
}

// Acl_AclSetPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set YANG schema element.
type Acl_AclSetPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_DescriptionPath represents the /openconfig-acl/acl/acl-sets/acl-set/config/description YANG schema element.
type Acl_AclSet_DescriptionPath struct {
	*ygot.NodePath
}

// Acl_AclSet_DescriptionPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/config/description YANG schema element.
type Acl_AclSet_DescriptionPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_NamePath represents the /openconfig-acl/acl/acl-sets/acl-set/config/name YANG schema element.
type Acl_AclSet_NamePath struct {
	*ygot.NodePath
}

// Acl_AclSet_NamePathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/config/name YANG schema element.
type Acl_AclSet_NamePathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_TypePath represents the /openconfig-acl/acl/acl-sets/acl-set/config/type YANG schema element.
type Acl_AclSet_TypePath struct {
	*ygot.NodePath
}

// Acl_AclSet_TypePathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/config/type YANG schema element.
type Acl_AclSet_TypePathAny struct {
	*ygot.NodePath
}

// AclEntryAny (list): List of ACL entries comprising an ACL set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry"
// SequenceId (wildcarded): uint32
func (n *Acl_AclSetPath) AclEntryAny() *Acl_AclSet_AclEntryPathAny {
	return &Acl_AclSet_AclEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": "*"},
			n,
		),
	}
}

// AclEntryAny (list): List of ACL entries comprising an ACL set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry"
// SequenceId (wildcarded): uint32
func (n *Acl_AclSetPathAny) AclEntryAny() *Acl_AclSet_AclEntryPathAny {
	return &Acl_AclSet_AclEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": "*"},
			n,
		),
	}
}

// AclEntry (list): List of ACL entries comprising an ACL set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry"
// SequenceId: uint32
func (n *Acl_AclSetPath) AclEntry(SequenceId uint32) *Acl_AclSet_AclEntryPath {
	return &Acl_AclSet_AclEntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": SequenceId},
			n,
		),
	}
}

// AclEntry (list): List of ACL entries comprising an ACL set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry"
// SequenceId: uint32
func (n *Acl_AclSetPathAny) AclEntry(SequenceId uint32) *Acl_AclSet_AclEntryPathAny {
	return &Acl_AclSet_AclEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": SequenceId},
			n,
		),
	}
}

// Description (leaf): Description, or comment, for the ACL set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/description"
// Path from root: "/acl/acl-sets/acl-set/config/description"
func (n *Acl_AclSetPath) Description() *Acl_AclSet_DescriptionPath {
	return &Acl_AclSet_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): Description, or comment, for the ACL set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/description"
// Path from root: "/acl/acl-sets/acl-set/config/description"
func (n *Acl_AclSetPathAny) Description() *Acl_AclSet_DescriptionPathAny {
	return &Acl_AclSet_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The name of the access-list set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/name"
// Path from root: "/acl/acl-sets/acl-set/config/name"
func (n *Acl_AclSetPath) Name() *Acl_AclSet_NamePath {
	return &Acl_AclSet_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The name of the access-list set
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/name"
// Path from root: "/acl/acl-sets/acl-set/config/name"
func (n *Acl_AclSetPathAny) Name() *Acl_AclSet_NamePathAny {
	return &Acl_AclSet_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type determines the fields allowed in the ACL entries
// belonging to the ACL set (e.g., IPv4, IPv6, etc.)
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/type"
// Path from root: "/acl/acl-sets/acl-set/config/type"
func (n *Acl_AclSetPath) Type() *Acl_AclSet_TypePath {
	return &Acl_AclSet_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type determines the fields allowed in the ACL entries
// belonging to the ACL set (e.g., IPv4, IPv6, etc.)
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/type"
// Path from root: "/acl/acl-sets/acl-set/config/type"
func (n *Acl_AclSetPathAny) Type() *Acl_AclSet_TypePathAny {
	return &Acl_AclSet_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_AclSet_AclEntryPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry YANG schema element.
type Acl_AclSet_AclEntryPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntryPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry YANG schema element.
type Acl_AclSet_AclEntryPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_DescriptionPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/config/description YANG schema element.
type Acl_AclSet_AclEntry_DescriptionPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_DescriptionPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/config/description YANG schema element.
type Acl_AclSet_AclEntry_DescriptionPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_MatchedOctetsPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/state/matched-octets YANG schema element.
type Acl_AclSet_AclEntry_MatchedOctetsPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_MatchedOctetsPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/state/matched-octets YANG schema element.
type Acl_AclSet_AclEntry_MatchedOctetsPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_MatchedPacketsPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/state/matched-packets YANG schema element.
type Acl_AclSet_AclEntry_MatchedPacketsPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_MatchedPacketsPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/state/matched-packets YANG schema element.
type Acl_AclSet_AclEntry_MatchedPacketsPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_SequenceIdPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/config/sequence-id YANG schema element.
type Acl_AclSet_AclEntry_SequenceIdPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_SequenceIdPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/config/sequence-id YANG schema element.
type Acl_AclSet_AclEntry_SequenceIdPathAny struct {
	*ygot.NodePath
}

// Actions (container): Enclosing container for list of ACL actions associated
// with an entry
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "actions"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/actions"
func (n *Acl_AclSet_AclEntryPath) Actions() *Acl_AclSet_AclEntry_ActionsPath {
	return &Acl_AclSet_AclEntry_ActionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"actions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Actions (container): Enclosing container for list of ACL actions associated
// with an entry
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "actions"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/actions"
func (n *Acl_AclSet_AclEntryPathAny) Actions() *Acl_AclSet_AclEntry_ActionsPathAny {
	return &Acl_AclSet_AclEntry_ActionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"actions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): A user-defined description, or comment, for this Access List
// Entry.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/description"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/config/description"
func (n *Acl_AclSet_AclEntryPath) Description() *Acl_AclSet_AclEntry_DescriptionPath {
	return &Acl_AclSet_AclEntry_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): A user-defined description, or comment, for this Access List
// Entry.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/description"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/config/description"
func (n *Acl_AclSet_AclEntryPathAny) Description() *Acl_AclSet_AclEntry_DescriptionPathAny {
	return &Acl_AclSet_AclEntry_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputInterface (container): Input interface container
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "input-interface"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface"
func (n *Acl_AclSet_AclEntryPath) InputInterface() *Acl_AclSet_AclEntry_InputInterfacePath {
	return &Acl_AclSet_AclEntry_InputInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"input-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputInterface (container): Input interface container
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "input-interface"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface"
func (n *Acl_AclSet_AclEntryPathAny) InputInterface() *Acl_AclSet_AclEntry_InputInterfacePathAny {
	return &Acl_AclSet_AclEntry_InputInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"input-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4 (container): Top level container for IPv4 match field data
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "ipv4"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4"
func (n *Acl_AclSet_AclEntryPath) Ipv4() *Acl_AclSet_AclEntry_Ipv4Path {
	return &Acl_AclSet_AclEntry_Ipv4Path{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4 (container): Top level container for IPv4 match field data
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "ipv4"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4"
func (n *Acl_AclSet_AclEntryPathAny) Ipv4() *Acl_AclSet_AclEntry_Ipv4PathAny {
	return &Acl_AclSet_AclEntry_Ipv4PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6 (container): Top-level container for IPv6 match field data
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "ipv6"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6"
func (n *Acl_AclSet_AclEntryPath) Ipv6() *Acl_AclSet_AclEntry_Ipv6Path {
	return &Acl_AclSet_AclEntry_Ipv6Path{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6 (container): Top-level container for IPv6 match field data
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "ipv6"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6"
func (n *Acl_AclSet_AclEntryPathAny) Ipv6() *Acl_AclSet_AclEntry_Ipv6PathAny {
	return &Acl_AclSet_AclEntry_Ipv6PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2 (container): Ethernet header fields
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "l2"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2"
func (n *Acl_AclSet_AclEntryPath) L2() *Acl_AclSet_AclEntry_L2Path {
	return &Acl_AclSet_AclEntry_L2Path{
		NodePath: ygot.NewNodePath(
			[]string{"l2"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2 (container): Ethernet header fields
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "l2"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2"
func (n *Acl_AclSet_AclEntryPathAny) L2() *Acl_AclSet_AclEntry_L2PathAny {
	return &Acl_AclSet_AclEntry_L2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedOctets (leaf): Count of the number of octets (bytes) matching the current
// ACL entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-octets"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/state/matched-octets"
func (n *Acl_AclSet_AclEntryPath) MatchedOctets() *Acl_AclSet_AclEntry_MatchedOctetsPath {
	return &Acl_AclSet_AclEntry_MatchedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedOctets (leaf): Count of the number of octets (bytes) matching the current
// ACL entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-octets"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/state/matched-octets"
func (n *Acl_AclSet_AclEntryPathAny) MatchedOctets() *Acl_AclSet_AclEntry_MatchedOctetsPathAny {
	return &Acl_AclSet_AclEntry_MatchedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedPackets (leaf): Count of the number of packets matching the current ACL
// entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-packets"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/state/matched-packets"
func (n *Acl_AclSet_AclEntryPath) MatchedPackets() *Acl_AclSet_AclEntry_MatchedPacketsPath {
	return &Acl_AclSet_AclEntry_MatchedPacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedPackets (leaf): Count of the number of packets matching the current ACL
// entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-packets"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/state/matched-packets"
func (n *Acl_AclSet_AclEntryPathAny) MatchedPackets() *Acl_AclSet_AclEntry_MatchedPacketsPathAny {
	return &Acl_AclSet_AclEntry_MatchedPacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): MPLS header fields
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "mpls"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls"
func (n *Acl_AclSet_AclEntryPath) Mpls() *Acl_AclSet_AclEntry_MplsPath {
	return &Acl_AclSet_AclEntry_MplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): MPLS header fields
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "mpls"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls"
func (n *Acl_AclSet_AclEntryPathAny) Mpls() *Acl_AclSet_AclEntry_MplsPathAny {
	return &Acl_AclSet_AclEntry_MplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceId (leaf): The sequence id determines the order in which ACL entries
// are applied.  The sequence id must be unique for each entry
// in an ACL set.  Target devices should apply the ACL entry
// rules in ascending order determined by sequence id (low to
// high), rather than the relying only on order in the list.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/sequence-id"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/config/sequence-id"
func (n *Acl_AclSet_AclEntryPath) SequenceId() *Acl_AclSet_AclEntry_SequenceIdPath {
	return &Acl_AclSet_AclEntry_SequenceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sequence-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceId (leaf): The sequence id determines the order in which ACL entries
// are applied.  The sequence id must be unique for each entry
// in an ACL set.  Target devices should apply the ACL entry
// rules in ascending order determined by sequence id (low to
// high), rather than the relying only on order in the list.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/sequence-id"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/config/sequence-id"
func (n *Acl_AclSet_AclEntryPathAny) SequenceId() *Acl_AclSet_AclEntry_SequenceIdPathAny {
	return &Acl_AclSet_AclEntry_SequenceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sequence-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): Transport fields container
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "transport"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/transport"
func (n *Acl_AclSet_AclEntryPath) Transport() *Acl_AclSet_AclEntry_TransportPath {
	return &Acl_AclSet_AclEntry_TransportPath{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): Transport fields container
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "transport"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/transport"
func (n *Acl_AclSet_AclEntryPathAny) Transport() *Acl_AclSet_AclEntry_TransportPathAny {
	return &Acl_AclSet_AclEntry_TransportPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_AclSet_AclEntry_ActionsPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/actions YANG schema element.
type Acl_AclSet_AclEntry_ActionsPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_ActionsPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/actions YANG schema element.
type Acl_AclSet_AclEntry_ActionsPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Actions_ForwardingActionPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/actions/config/forwarding-action YANG schema element.
type Acl_AclSet_AclEntry_Actions_ForwardingActionPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Actions_ForwardingActionPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/actions/config/forwarding-action YANG schema element.
type Acl_AclSet_AclEntry_Actions_ForwardingActionPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Actions_LogActionPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/actions/config/log-action YANG schema element.
type Acl_AclSet_AclEntry_Actions_LogActionPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Actions_LogActionPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/actions/config/log-action YANG schema element.
type Acl_AclSet_AclEntry_Actions_LogActionPathAny struct {
	*ygot.NodePath
}

// ForwardingAction (leaf): Specifies the forwarding action.  One forwarding action
// must be specified for each ACL entry
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/forwarding-action"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/actions/config/forwarding-action"
func (n *Acl_AclSet_AclEntry_ActionsPath) ForwardingAction() *Acl_AclSet_AclEntry_Actions_ForwardingActionPath {
	return &Acl_AclSet_AclEntry_Actions_ForwardingActionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-action"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingAction (leaf): Specifies the forwarding action.  One forwarding action
// must be specified for each ACL entry
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/forwarding-action"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/actions/config/forwarding-action"
func (n *Acl_AclSet_AclEntry_ActionsPathAny) ForwardingAction() *Acl_AclSet_AclEntry_Actions_ForwardingActionPathAny {
	return &Acl_AclSet_AclEntry_Actions_ForwardingActionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-action"},
			map[string]interface{}{},
			n,
		),
	}
}

// LogAction (leaf): Specifies the log action and destination for
// matched packets.  The default is not to log the
// packet.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/log-action"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/actions/config/log-action"
func (n *Acl_AclSet_AclEntry_ActionsPath) LogAction() *Acl_AclSet_AclEntry_Actions_LogActionPath {
	return &Acl_AclSet_AclEntry_Actions_LogActionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "log-action"},
			map[string]interface{}{},
			n,
		),
	}
}

// LogAction (leaf): Specifies the log action and destination for
// matched packets.  The default is not to log the
// packet.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/log-action"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/actions/config/log-action"
func (n *Acl_AclSet_AclEntry_ActionsPathAny) LogAction() *Acl_AclSet_AclEntry_Actions_LogActionPathAny {
	return &Acl_AclSet_AclEntry_Actions_LogActionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "log-action"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_AclSet_AclEntry_InputInterfacePath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface YANG schema element.
type Acl_AclSet_AclEntry_InputInterfacePath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_InputInterfacePathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface YANG schema element.
type Acl_AclSet_AclEntry_InputInterfacePathAny struct {
	*ygot.NodePath
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "interface-ref"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref"
func (n *Acl_AclSet_AclEntry_InputInterfacePath) InterfaceRef() *Acl_AclSet_AclEntry_InputInterface_InterfaceRefPath {
	return &Acl_AclSet_AclEntry_InputInterface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "interface-ref"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref"
func (n *Acl_AclSet_AclEntry_InputInterfacePathAny) InterfaceRef() *Acl_AclSet_AclEntry_InputInterface_InterfaceRefPathAny {
	return &Acl_AclSet_AclEntry_InputInterface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_AclSet_AclEntry_InputInterface_InterfaceRefPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref YANG schema element.
type Acl_AclSet_AclEntry_InputInterface_InterfaceRefPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_InputInterface_InterfaceRefPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref YANG schema element.
type Acl_AclSet_AclEntry_InputInterface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_InputInterface_InterfaceRef_InterfacePath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref/config/interface YANG schema element.
type Acl_AclSet_AclEntry_InputInterface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_InputInterface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref/config/interface YANG schema element.
type Acl_AclSet_AclEntry_InputInterface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_InputInterface_InterfaceRef_SubinterfacePath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref/config/subinterface YANG schema element.
type Acl_AclSet_AclEntry_InputInterface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_InputInterface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref/config/subinterface YANG schema element.
type Acl_AclSet_AclEntry_InputInterface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/interface"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref/config/interface"
func (n *Acl_AclSet_AclEntry_InputInterface_InterfaceRefPath) Interface() *Acl_AclSet_AclEntry_InputInterface_InterfaceRef_InterfacePath {
	return &Acl_AclSet_AclEntry_InputInterface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/interface"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref/config/interface"
func (n *Acl_AclSet_AclEntry_InputInterface_InterfaceRefPathAny) Interface() *Acl_AclSet_AclEntry_InputInterface_InterfaceRef_InterfacePathAny {
	return &Acl_AclSet_AclEntry_InputInterface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/subinterface"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref/config/subinterface"
func (n *Acl_AclSet_AclEntry_InputInterface_InterfaceRefPath) Subinterface() *Acl_AclSet_AclEntry_InputInterface_InterfaceRef_SubinterfacePath {
	return &Acl_AclSet_AclEntry_InputInterface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/subinterface"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/input-interface/interface-ref/config/subinterface"
func (n *Acl_AclSet_AclEntry_InputInterface_InterfaceRefPathAny) Subinterface() *Acl_AclSet_AclEntry_InputInterface_InterfaceRef_SubinterfacePathAny {
	return &Acl_AclSet_AclEntry_InputInterface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_AclSet_AclEntry_Ipv4Path represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4 YANG schema element.
type Acl_AclSet_AclEntry_Ipv4Path struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4PathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4 YANG schema element.
type Acl_AclSet_AclEntry_Ipv4PathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_DestinationAddressPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/destination-address YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_DestinationAddressPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_DestinationAddressPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/destination-address YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_DestinationAddressPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_DscpPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/dscp YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_DscpPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_DscpPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/dscp YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_DscpPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_DscpSetPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/dscp-set YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_DscpSetPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_DscpSetPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/dscp-set YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_DscpSetPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_HopLimitPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/hop-limit YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_HopLimitPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_HopLimitPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/hop-limit YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_HopLimitPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_ProtocolPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/protocol YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_ProtocolPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_ProtocolPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/protocol YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_ProtocolPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_SourceAddressPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/source-address YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_SourceAddressPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv4_SourceAddressPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/source-address YANG schema element.
type Acl_AclSet_AclEntry_Ipv4_SourceAddressPathAny struct {
	*ygot.NodePath
}

// DestinationAddress (leaf): Destination IPv4 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-address"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/destination-address"
func (n *Acl_AclSet_AclEntry_Ipv4Path) DestinationAddress() *Acl_AclSet_AclEntry_Ipv4_DestinationAddressPath {
	return &Acl_AclSet_AclEntry_Ipv4_DestinationAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationAddress (leaf): Destination IPv4 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-address"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/destination-address"
func (n *Acl_AclSet_AclEntry_Ipv4PathAny) DestinationAddress() *Acl_AclSet_AclEntry_Ipv4_DestinationAddressPathAny {
	return &Acl_AclSet_AclEntry_Ipv4_DestinationAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dscp (leaf): Value of diffserv codepoint.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/dscp"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/dscp"
func (n *Acl_AclSet_AclEntry_Ipv4Path) Dscp() *Acl_AclSet_AclEntry_Ipv4_DscpPath {
	return &Acl_AclSet_AclEntry_Ipv4_DscpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dscp (leaf): Value of diffserv codepoint.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/dscp"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/dscp"
func (n *Acl_AclSet_AclEntry_Ipv4PathAny) Dscp() *Acl_AclSet_AclEntry_Ipv4_DscpPathAny {
	return &Acl_AclSet_AclEntry_Ipv4_DscpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DscpSet (leaf): A list of DSCP values to be matched for incoming packets. AN OR match should
// be performed, such that a packet must match one of the values defined in this
// list. If the field is left empty then any DSCP value matches unless the 'dscp'
// leaf is specified. It is not valid to specify both 'dscp' and 'dscp-set together.'
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/dscp-set"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/dscp-set"
func (n *Acl_AclSet_AclEntry_Ipv4Path) DscpSet() *Acl_AclSet_AclEntry_Ipv4_DscpSetPath {
	return &Acl_AclSet_AclEntry_Ipv4_DscpSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// DscpSet (leaf): A list of DSCP values to be matched for incoming packets. AN OR match should
// be performed, such that a packet must match one of the values defined in this
// list. If the field is left empty then any DSCP value matches unless the 'dscp'
// leaf is specified. It is not valid to specify both 'dscp' and 'dscp-set together.'
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/dscp-set"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/dscp-set"
func (n *Acl_AclSet_AclEntry_Ipv4PathAny) DscpSet() *Acl_AclSet_AclEntry_Ipv4_DscpSetPathAny {
	return &Acl_AclSet_AclEntry_Ipv4_DscpSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopLimit (leaf): The IP packet's hop limit -- known as TTL (in hops) in
// IPv4 packets, and hop limit in IPv6
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/hop-limit"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/hop-limit"
func (n *Acl_AclSet_AclEntry_Ipv4Path) HopLimit() *Acl_AclSet_AclEntry_Ipv4_HopLimitPath {
	return &Acl_AclSet_AclEntry_Ipv4_HopLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopLimit (leaf): The IP packet's hop limit -- known as TTL (in hops) in
// IPv4 packets, and hop limit in IPv6
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/hop-limit"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/hop-limit"
func (n *Acl_AclSet_AclEntry_Ipv4PathAny) HopLimit() *Acl_AclSet_AclEntry_Ipv4_HopLimitPathAny {
	return &Acl_AclSet_AclEntry_Ipv4_HopLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): The protocol carried in the IP packet, expressed either
// as its IP protocol number, or by a defined identity.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/protocol"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/protocol"
func (n *Acl_AclSet_AclEntry_Ipv4Path) Protocol() *Acl_AclSet_AclEntry_Ipv4_ProtocolPath {
	return &Acl_AclSet_AclEntry_Ipv4_ProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): The protocol carried in the IP packet, expressed either
// as its IP protocol number, or by a defined identity.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/protocol"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/protocol"
func (n *Acl_AclSet_AclEntry_Ipv4PathAny) Protocol() *Acl_AclSet_AclEntry_Ipv4_ProtocolPathAny {
	return &Acl_AclSet_AclEntry_Ipv4_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IPv4 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-address"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/source-address"
func (n *Acl_AclSet_AclEntry_Ipv4Path) SourceAddress() *Acl_AclSet_AclEntry_Ipv4_SourceAddressPath {
	return &Acl_AclSet_AclEntry_Ipv4_SourceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IPv4 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-address"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv4/config/source-address"
func (n *Acl_AclSet_AclEntry_Ipv4PathAny) SourceAddress() *Acl_AclSet_AclEntry_Ipv4_SourceAddressPathAny {
	return &Acl_AclSet_AclEntry_Ipv4_SourceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_AclSet_AclEntry_Ipv6Path represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6 YANG schema element.
type Acl_AclSet_AclEntry_Ipv6Path struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6PathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6 YANG schema element.
type Acl_AclSet_AclEntry_Ipv6PathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_DestinationAddressPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/destination-address YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_DestinationAddressPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_DestinationAddressPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/destination-address YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_DestinationAddressPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_DestinationFlowLabelPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/destination-flow-label YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_DestinationFlowLabelPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_DestinationFlowLabelPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/destination-flow-label YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_DestinationFlowLabelPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_DscpPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/dscp YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_DscpPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_DscpPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/dscp YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_DscpPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_DscpSetPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/dscp-set YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_DscpSetPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_DscpSetPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/dscp-set YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_DscpSetPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_HopLimitPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/hop-limit YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_HopLimitPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_HopLimitPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/hop-limit YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_HopLimitPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_ProtocolPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/protocol YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_ProtocolPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_ProtocolPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/protocol YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_ProtocolPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_SourceAddressPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/source-address YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_SourceAddressPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_SourceAddressPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/source-address YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_SourceAddressPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_SourceFlowLabelPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/source-flow-label YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_SourceFlowLabelPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Ipv6_SourceFlowLabelPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/source-flow-label YANG schema element.
type Acl_AclSet_AclEntry_Ipv6_SourceFlowLabelPathAny struct {
	*ygot.NodePath
}

// DestinationAddress (leaf): Destination IPv6 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-address"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/destination-address"
func (n *Acl_AclSet_AclEntry_Ipv6Path) DestinationAddress() *Acl_AclSet_AclEntry_Ipv6_DestinationAddressPath {
	return &Acl_AclSet_AclEntry_Ipv6_DestinationAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationAddress (leaf): Destination IPv6 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-address"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/destination-address"
func (n *Acl_AclSet_AclEntry_Ipv6PathAny) DestinationAddress() *Acl_AclSet_AclEntry_Ipv6_DestinationAddressPathAny {
	return &Acl_AclSet_AclEntry_Ipv6_DestinationAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationFlowLabel (leaf): Destination IPv6 Flow label.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-flow-label"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/destination-flow-label"
func (n *Acl_AclSet_AclEntry_Ipv6Path) DestinationFlowLabel() *Acl_AclSet_AclEntry_Ipv6_DestinationFlowLabelPath {
	return &Acl_AclSet_AclEntry_Ipv6_DestinationFlowLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-flow-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationFlowLabel (leaf): Destination IPv6 Flow label.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-flow-label"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/destination-flow-label"
func (n *Acl_AclSet_AclEntry_Ipv6PathAny) DestinationFlowLabel() *Acl_AclSet_AclEntry_Ipv6_DestinationFlowLabelPathAny {
	return &Acl_AclSet_AclEntry_Ipv6_DestinationFlowLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-flow-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dscp (leaf): Value of diffserv codepoint.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/dscp"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/dscp"
func (n *Acl_AclSet_AclEntry_Ipv6Path) Dscp() *Acl_AclSet_AclEntry_Ipv6_DscpPath {
	return &Acl_AclSet_AclEntry_Ipv6_DscpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dscp (leaf): Value of diffserv codepoint.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/dscp"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/dscp"
func (n *Acl_AclSet_AclEntry_Ipv6PathAny) Dscp() *Acl_AclSet_AclEntry_Ipv6_DscpPathAny {
	return &Acl_AclSet_AclEntry_Ipv6_DscpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DscpSet (leaf): A list of DSCP values to be matched for incoming packets. AN OR match should
// be performed, such that a packet must match one of the values defined in this
// list. If the field is left empty then any DSCP value matches unless the 'dscp'
// leaf is specified. It is not valid to specify both 'dscp' and 'dscp-set together.'
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/dscp-set"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/dscp-set"
func (n *Acl_AclSet_AclEntry_Ipv6Path) DscpSet() *Acl_AclSet_AclEntry_Ipv6_DscpSetPath {
	return &Acl_AclSet_AclEntry_Ipv6_DscpSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// DscpSet (leaf): A list of DSCP values to be matched for incoming packets. AN OR match should
// be performed, such that a packet must match one of the values defined in this
// list. If the field is left empty then any DSCP value matches unless the 'dscp'
// leaf is specified. It is not valid to specify both 'dscp' and 'dscp-set together.'
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/dscp-set"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/dscp-set"
func (n *Acl_AclSet_AclEntry_Ipv6PathAny) DscpSet() *Acl_AclSet_AclEntry_Ipv6_DscpSetPathAny {
	return &Acl_AclSet_AclEntry_Ipv6_DscpSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopLimit (leaf): The IP packet's hop limit -- known as TTL (in hops) in
// IPv4 packets, and hop limit in IPv6
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/hop-limit"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/hop-limit"
func (n *Acl_AclSet_AclEntry_Ipv6Path) HopLimit() *Acl_AclSet_AclEntry_Ipv6_HopLimitPath {
	return &Acl_AclSet_AclEntry_Ipv6_HopLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopLimit (leaf): The IP packet's hop limit -- known as TTL (in hops) in
// IPv4 packets, and hop limit in IPv6
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/hop-limit"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/hop-limit"
func (n *Acl_AclSet_AclEntry_Ipv6PathAny) HopLimit() *Acl_AclSet_AclEntry_Ipv6_HopLimitPathAny {
	return &Acl_AclSet_AclEntry_Ipv6_HopLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): The protocol carried in the IP packet, expressed either
// as its IP protocol number, or by a defined identity.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/protocol"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/protocol"
func (n *Acl_AclSet_AclEntry_Ipv6Path) Protocol() *Acl_AclSet_AclEntry_Ipv6_ProtocolPath {
	return &Acl_AclSet_AclEntry_Ipv6_ProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): The protocol carried in the IP packet, expressed either
// as its IP protocol number, or by a defined identity.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/protocol"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/protocol"
func (n *Acl_AclSet_AclEntry_Ipv6PathAny) Protocol() *Acl_AclSet_AclEntry_Ipv6_ProtocolPathAny {
	return &Acl_AclSet_AclEntry_Ipv6_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IPv6 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-address"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/source-address"
func (n *Acl_AclSet_AclEntry_Ipv6Path) SourceAddress() *Acl_AclSet_AclEntry_Ipv6_SourceAddressPath {
	return &Acl_AclSet_AclEntry_Ipv6_SourceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IPv6 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-address"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/source-address"
func (n *Acl_AclSet_AclEntry_Ipv6PathAny) SourceAddress() *Acl_AclSet_AclEntry_Ipv6_SourceAddressPathAny {
	return &Acl_AclSet_AclEntry_Ipv6_SourceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceFlowLabel (leaf): Source IPv6 Flow label.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-flow-label"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/source-flow-label"
func (n *Acl_AclSet_AclEntry_Ipv6Path) SourceFlowLabel() *Acl_AclSet_AclEntry_Ipv6_SourceFlowLabelPath {
	return &Acl_AclSet_AclEntry_Ipv6_SourceFlowLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-flow-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceFlowLabel (leaf): Source IPv6 Flow label.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-flow-label"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/ipv6/config/source-flow-label"
func (n *Acl_AclSet_AclEntry_Ipv6PathAny) SourceFlowLabel() *Acl_AclSet_AclEntry_Ipv6_SourceFlowLabelPathAny {
	return &Acl_AclSet_AclEntry_Ipv6_SourceFlowLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-flow-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_AclSet_AclEntry_L2Path represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2 YANG schema element.
type Acl_AclSet_AclEntry_L2Path struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2PathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2 YANG schema element.
type Acl_AclSet_AclEntry_L2PathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_DestinationMacPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/destination-mac YANG schema element.
type Acl_AclSet_AclEntry_L2_DestinationMacPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_DestinationMacPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/destination-mac YANG schema element.
type Acl_AclSet_AclEntry_L2_DestinationMacPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_DestinationMacMaskPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/destination-mac-mask YANG schema element.
type Acl_AclSet_AclEntry_L2_DestinationMacMaskPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_DestinationMacMaskPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/destination-mac-mask YANG schema element.
type Acl_AclSet_AclEntry_L2_DestinationMacMaskPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_EthertypePath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/ethertype YANG schema element.
type Acl_AclSet_AclEntry_L2_EthertypePath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_EthertypePathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/ethertype YANG schema element.
type Acl_AclSet_AclEntry_L2_EthertypePathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_SourceMacPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/source-mac YANG schema element.
type Acl_AclSet_AclEntry_L2_SourceMacPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_SourceMacPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/source-mac YANG schema element.
type Acl_AclSet_AclEntry_L2_SourceMacPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_SourceMacMaskPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/source-mac-mask YANG schema element.
type Acl_AclSet_AclEntry_L2_SourceMacMaskPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_L2_SourceMacMaskPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/source-mac-mask YANG schema element.
type Acl_AclSet_AclEntry_L2_SourceMacMaskPathAny struct {
	*ygot.NodePath
}

// DestinationMac (leaf): Destination IEEE 802 MAC address.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-mac"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/destination-mac"
func (n *Acl_AclSet_AclEntry_L2Path) DestinationMac() *Acl_AclSet_AclEntry_L2_DestinationMacPath {
	return &Acl_AclSet_AclEntry_L2_DestinationMacPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationMac (leaf): Destination IEEE 802 MAC address.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-mac"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/destination-mac"
func (n *Acl_AclSet_AclEntry_L2PathAny) DestinationMac() *Acl_AclSet_AclEntry_L2_DestinationMacPathAny {
	return &Acl_AclSet_AclEntry_L2_DestinationMacPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationMacMask (leaf): Destination IEEE 802 MAC address mask.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-mac-mask"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/destination-mac-mask"
func (n *Acl_AclSet_AclEntry_L2Path) DestinationMacMask() *Acl_AclSet_AclEntry_L2_DestinationMacMaskPath {
	return &Acl_AclSet_AclEntry_L2_DestinationMacMaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-mac-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationMacMask (leaf): Destination IEEE 802 MAC address mask.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-mac-mask"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/destination-mac-mask"
func (n *Acl_AclSet_AclEntry_L2PathAny) DestinationMacMask() *Acl_AclSet_AclEntry_L2_DestinationMacMaskPathAny {
	return &Acl_AclSet_AclEntry_L2_DestinationMacMaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-mac-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ethertype (leaf): Ethertype field to match in Ethernet packets
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/ethertype"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/ethertype"
func (n *Acl_AclSet_AclEntry_L2Path) Ethertype() *Acl_AclSet_AclEntry_L2_EthertypePath {
	return &Acl_AclSet_AclEntry_L2_EthertypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ethertype"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ethertype (leaf): Ethertype field to match in Ethernet packets
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/ethertype"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/ethertype"
func (n *Acl_AclSet_AclEntry_L2PathAny) Ethertype() *Acl_AclSet_AclEntry_L2_EthertypePathAny {
	return &Acl_AclSet_AclEntry_L2_EthertypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ethertype"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceMac (leaf): Source IEEE 802 MAC address.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-mac"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/source-mac"
func (n *Acl_AclSet_AclEntry_L2Path) SourceMac() *Acl_AclSet_AclEntry_L2_SourceMacPath {
	return &Acl_AclSet_AclEntry_L2_SourceMacPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceMac (leaf): Source IEEE 802 MAC address.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-mac"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/source-mac"
func (n *Acl_AclSet_AclEntry_L2PathAny) SourceMac() *Acl_AclSet_AclEntry_L2_SourceMacPathAny {
	return &Acl_AclSet_AclEntry_L2_SourceMacPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceMacMask (leaf): Source IEEE 802 MAC address mask.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-mac-mask"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/source-mac-mask"
func (n *Acl_AclSet_AclEntry_L2Path) SourceMacMask() *Acl_AclSet_AclEntry_L2_SourceMacMaskPath {
	return &Acl_AclSet_AclEntry_L2_SourceMacMaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-mac-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceMacMask (leaf): Source IEEE 802 MAC address mask.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-mac-mask"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/l2/config/source-mac-mask"
func (n *Acl_AclSet_AclEntry_L2PathAny) SourceMacMask() *Acl_AclSet_AclEntry_L2_SourceMacMaskPathAny {
	return &Acl_AclSet_AclEntry_L2_SourceMacMaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-mac-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_AclSet_AclEntry_MplsPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls YANG schema element.
type Acl_AclSet_AclEntry_MplsPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_MplsPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls YANG schema element.
type Acl_AclSet_AclEntry_MplsPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Mpls_EndLabelValuePath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/end-label-value YANG schema element.
type Acl_AclSet_AclEntry_Mpls_EndLabelValuePath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Mpls_EndLabelValuePathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/end-label-value YANG schema element.
type Acl_AclSet_AclEntry_Mpls_EndLabelValuePathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Mpls_StartLabelValuePath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/start-label-value YANG schema element.
type Acl_AclSet_AclEntry_Mpls_StartLabelValuePath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Mpls_StartLabelValuePathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/start-label-value YANG schema element.
type Acl_AclSet_AclEntry_Mpls_StartLabelValuePathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Mpls_TrafficClassPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/traffic-class YANG schema element.
type Acl_AclSet_AclEntry_Mpls_TrafficClassPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Mpls_TrafficClassPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/traffic-class YANG schema element.
type Acl_AclSet_AclEntry_Mpls_TrafficClassPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Mpls_TtlValuePath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/ttl-value YANG schema element.
type Acl_AclSet_AclEntry_Mpls_TtlValuePath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Mpls_TtlValuePathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/ttl-value YANG schema element.
type Acl_AclSet_AclEntry_Mpls_TtlValuePathAny struct {
	*ygot.NodePath
}

// EndLabelValue (leaf): Match MPLS label value on the MPLS header.
// The usage of this field indicated the upper
// range value in the top of the stack.
// The range that is used is inclusive. The match that
// is done for a particular received pkt_label is:
// start-label-value <= pkt_label <= end-label-value.
// The 20-bit label value in an MPLS label
// stack as specified in RFC 3032.
// This label value does not include the
// encodings of Traffic Class and TTL.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/end-label-value"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/end-label-value"
func (n *Acl_AclSet_AclEntry_MplsPath) EndLabelValue() *Acl_AclSet_AclEntry_Mpls_EndLabelValuePath {
	return &Acl_AclSet_AclEntry_Mpls_EndLabelValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "end-label-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// EndLabelValue (leaf): Match MPLS label value on the MPLS header.
// The usage of this field indicated the upper
// range value in the top of the stack.
// The range that is used is inclusive. The match that
// is done for a particular received pkt_label is:
// start-label-value <= pkt_label <= end-label-value.
// The 20-bit label value in an MPLS label
// stack as specified in RFC 3032.
// This label value does not include the
// encodings of Traffic Class and TTL.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/end-label-value"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/end-label-value"
func (n *Acl_AclSet_AclEntry_MplsPathAny) EndLabelValue() *Acl_AclSet_AclEntry_Mpls_EndLabelValuePathAny {
	return &Acl_AclSet_AclEntry_Mpls_EndLabelValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "end-label-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// StartLabelValue (leaf): Match MPLS label value on the MPLS header.
// The usage of this field indicated the upper
// range value in the top of the stack.
// The range that is used is inclusive. The match that
// is done for a particular received pkt_label is:
// start-label-value <= pkt_label <= end-label-value.
// The 20-bit label value in an MPLS label
// stack as specified in RFC 3032.
// This label value does not include the
// encodings of Traffic Class and TTL.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/start-label-value"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/start-label-value"
func (n *Acl_AclSet_AclEntry_MplsPath) StartLabelValue() *Acl_AclSet_AclEntry_Mpls_StartLabelValuePath {
	return &Acl_AclSet_AclEntry_Mpls_StartLabelValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "start-label-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// StartLabelValue (leaf): Match MPLS label value on the MPLS header.
// The usage of this field indicated the upper
// range value in the top of the stack.
// The range that is used is inclusive. The match that
// is done for a particular received pkt_label is:
// start-label-value <= pkt_label <= end-label-value.
// The 20-bit label value in an MPLS label
// stack as specified in RFC 3032.
// This label value does not include the
// encodings of Traffic Class and TTL.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/start-label-value"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/start-label-value"
func (n *Acl_AclSet_AclEntry_MplsPathAny) StartLabelValue() *Acl_AclSet_AclEntry_Mpls_StartLabelValuePathAny {
	return &Acl_AclSet_AclEntry_Mpls_StartLabelValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "start-label-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficClass (leaf): The value of the MPLS traffic class (TC) bits,
// formerly known as the EXP bits.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/traffic-class"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/traffic-class"
func (n *Acl_AclSet_AclEntry_MplsPath) TrafficClass() *Acl_AclSet_AclEntry_Mpls_TrafficClassPath {
	return &Acl_AclSet_AclEntry_Mpls_TrafficClassPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "traffic-class"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficClass (leaf): The value of the MPLS traffic class (TC) bits,
// formerly known as the EXP bits.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/traffic-class"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/traffic-class"
func (n *Acl_AclSet_AclEntry_MplsPathAny) TrafficClass() *Acl_AclSet_AclEntry_Mpls_TrafficClassPathAny {
	return &Acl_AclSet_AclEntry_Mpls_TrafficClassPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "traffic-class"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtlValue (leaf): Time-to-live MPLS packet value match.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/ttl-value"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/ttl-value"
func (n *Acl_AclSet_AclEntry_MplsPath) TtlValue() *Acl_AclSet_AclEntry_Mpls_TtlValuePath {
	return &Acl_AclSet_AclEntry_Mpls_TtlValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ttl-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtlValue (leaf): Time-to-live MPLS packet value match.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/ttl-value"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/mpls/config/ttl-value"
func (n *Acl_AclSet_AclEntry_MplsPathAny) TtlValue() *Acl_AclSet_AclEntry_Mpls_TtlValuePathAny {
	return &Acl_AclSet_AclEntry_Mpls_TtlValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ttl-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_AclSet_AclEntry_TransportPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/transport YANG schema element.
type Acl_AclSet_AclEntry_TransportPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_TransportPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/transport YANG schema element.
type Acl_AclSet_AclEntry_TransportPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Transport_DestinationPortPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/destination-port YANG schema element.
type Acl_AclSet_AclEntry_Transport_DestinationPortPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Transport_DestinationPortPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/destination-port YANG schema element.
type Acl_AclSet_AclEntry_Transport_DestinationPortPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Transport_SourcePortPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/source-port YANG schema element.
type Acl_AclSet_AclEntry_Transport_SourcePortPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Transport_SourcePortPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/source-port YANG schema element.
type Acl_AclSet_AclEntry_Transport_SourcePortPathAny struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Transport_TcpFlagsPath represents the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/tcp-flags YANG schema element.
type Acl_AclSet_AclEntry_Transport_TcpFlagsPath struct {
	*ygot.NodePath
}

// Acl_AclSet_AclEntry_Transport_TcpFlagsPathAny represents the wildcard version of the /openconfig-acl/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/tcp-flags YANG schema element.
type Acl_AclSet_AclEntry_Transport_TcpFlagsPathAny struct {
	*ygot.NodePath
}

// DestinationPort (leaf): Destination port or range
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-port"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/destination-port"
func (n *Acl_AclSet_AclEntry_TransportPath) DestinationPort() *Acl_AclSet_AclEntry_Transport_DestinationPortPath {
	return &Acl_AclSet_AclEntry_Transport_DestinationPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationPort (leaf): Destination port or range
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/destination-port"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/destination-port"
func (n *Acl_AclSet_AclEntry_TransportPathAny) DestinationPort() *Acl_AclSet_AclEntry_Transport_DestinationPortPathAny {
	return &Acl_AclSet_AclEntry_Transport_DestinationPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourcePort (leaf): Source port or range
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-port"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/source-port"
func (n *Acl_AclSet_AclEntry_TransportPath) SourcePort() *Acl_AclSet_AclEntry_Transport_SourcePortPath {
	return &Acl_AclSet_AclEntry_Transport_SourcePortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourcePort (leaf): Source port or range
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/source-port"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/source-port"
func (n *Acl_AclSet_AclEntry_TransportPathAny) SourcePort() *Acl_AclSet_AclEntry_Transport_SourcePortPathAny {
	return &Acl_AclSet_AclEntry_Transport_SourcePortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// TcpFlags (leaf): List of TCP flags to match
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/tcp-flags"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/tcp-flags"
func (n *Acl_AclSet_AclEntry_TransportPath) TcpFlags() *Acl_AclSet_AclEntry_Transport_TcpFlagsPath {
	return &Acl_AclSet_AclEntry_Transport_TcpFlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tcp-flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// TcpFlags (leaf): List of TCP flags to match
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/tcp-flags"
// Path from root: "/acl/acl-sets/acl-set/acl-entries/acl-entry/transport/config/tcp-flags"
func (n *Acl_AclSet_AclEntry_TransportPathAny) TcpFlags() *Acl_AclSet_AclEntry_Transport_TcpFlagsPathAny {
	return &Acl_AclSet_AclEntry_Transport_TcpFlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tcp-flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_InterfacePath represents the /openconfig-acl/acl/interfaces/interface YANG schema element.
type Acl_InterfacePath struct {
	*ygot.NodePath
}

// Acl_InterfacePathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface YANG schema element.
type Acl_InterfacePathAny struct {
	*ygot.NodePath
}

// Acl_Interface_IdPath represents the /openconfig-acl/acl/interfaces/interface/config/id YANG schema element.
type Acl_Interface_IdPath struct {
	*ygot.NodePath
}

// Acl_Interface_IdPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/config/id YANG schema element.
type Acl_Interface_IdPathAny struct {
	*ygot.NodePath
}

// EgressAclSetAny (list): List of egress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "egress-acl-sets/egress-acl-set"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set"
// SetName (wildcarded): string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *Acl_InterfacePath) EgressAclSetAny() *Acl_Interface_EgressAclSetPathAny {
	return &Acl_Interface_EgressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"egress-acl-sets", "egress-acl-set"},
			map[string]interface{}{"set-name": "*", "type": "*"},
			n,
		),
	}
}

// EgressAclSetAny (list): List of egress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "egress-acl-sets/egress-acl-set"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set"
// SetName (wildcarded): string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *Acl_InterfacePathAny) EgressAclSetAny() *Acl_Interface_EgressAclSetPathAny {
	return &Acl_Interface_EgressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"egress-acl-sets", "egress-acl-set"},
			map[string]interface{}{"set-name": "*", "type": "*"},
			n,
		),
	}
}

// EgressAclSetAnyType (list): List of egress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "egress-acl-sets/egress-acl-set"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set"
// SetName: string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *Acl_InterfacePath) EgressAclSetAnyType(SetName string) *Acl_Interface_EgressAclSetPathAny {
	return &Acl_Interface_EgressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"egress-acl-sets", "egress-acl-set"},
			map[string]interface{}{"set-name": SetName, "type": "*"},
			n,
		),
	}
}

// EgressAclSetAnyType (list): List of egress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "egress-acl-sets/egress-acl-set"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set"
// SetName: string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *Acl_InterfacePathAny) EgressAclSetAnyType(SetName string) *Acl_Interface_EgressAclSetPathAny {
	return &Acl_Interface_EgressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"egress-acl-sets", "egress-acl-set"},
			map[string]interface{}{"set-name": SetName, "type": "*"},
			n,
		),
	}
}

// EgressAclSetAnySetName (list): List of egress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "egress-acl-sets/egress-acl-set"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set"
// SetName (wildcarded): string
// Type: E_Acl_ACL_TYPE
func (n *Acl_InterfacePath) EgressAclSetAnySetName(Type E_Acl_ACL_TYPE) *Acl_Interface_EgressAclSetPathAny {
	return &Acl_Interface_EgressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"egress-acl-sets", "egress-acl-set"},
			map[string]interface{}{"set-name": "*", "type": Type},
			n,
		),
	}
}

// EgressAclSetAnySetName (list): List of egress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "egress-acl-sets/egress-acl-set"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set"
// SetName (wildcarded): string
// Type: E_Acl_ACL_TYPE
func (n *Acl_InterfacePathAny) EgressAclSetAnySetName(Type E_Acl_ACL_TYPE) *Acl_Interface_EgressAclSetPathAny {
	return &Acl_Interface_EgressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"egress-acl-sets", "egress-acl-set"},
			map[string]interface{}{"set-name": "*", "type": Type},
			n,
		),
	}
}

// EgressAclSet (list): List of egress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "egress-acl-sets/egress-acl-set"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set"
// SetName: string
// Type: E_Acl_ACL_TYPE
func (n *Acl_InterfacePath) EgressAclSet(SetName string, Type E_Acl_ACL_TYPE) *Acl_Interface_EgressAclSetPath {
	return &Acl_Interface_EgressAclSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"egress-acl-sets", "egress-acl-set"},
			map[string]interface{}{"set-name": SetName, "type": Type},
			n,
		),
	}
}

// EgressAclSet (list): List of egress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "egress-acl-sets/egress-acl-set"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set"
// SetName: string
// Type: E_Acl_ACL_TYPE
func (n *Acl_InterfacePathAny) EgressAclSet(SetName string, Type E_Acl_ACL_TYPE) *Acl_Interface_EgressAclSetPathAny {
	return &Acl_Interface_EgressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"egress-acl-sets", "egress-acl-set"},
			map[string]interface{}{"set-name": SetName, "type": Type},
			n,
		),
	}
}

// Id (leaf): User-defined identifier for the interface -- a common
// convention could be '<if name>.<subif index>'
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/id"
// Path from root: "/acl/interfaces/interface/config/id"
func (n *Acl_InterfacePath) Id() *Acl_Interface_IdPath {
	return &Acl_Interface_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): User-defined identifier for the interface -- a common
// convention could be '<if name>.<subif index>'
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/id"
// Path from root: "/acl/interfaces/interface/config/id"
func (n *Acl_InterfacePathAny) Id() *Acl_Interface_IdPathAny {
	return &Acl_Interface_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// IngressAclSetAny (list): List of ingress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "ingress-acl-sets/ingress-acl-set"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set"
// SetName (wildcarded): string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *Acl_InterfacePath) IngressAclSetAny() *Acl_Interface_IngressAclSetPathAny {
	return &Acl_Interface_IngressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-acl-sets", "ingress-acl-set"},
			map[string]interface{}{"set-name": "*", "type": "*"},
			n,
		),
	}
}

// IngressAclSetAny (list): List of ingress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "ingress-acl-sets/ingress-acl-set"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set"
// SetName (wildcarded): string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *Acl_InterfacePathAny) IngressAclSetAny() *Acl_Interface_IngressAclSetPathAny {
	return &Acl_Interface_IngressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-acl-sets", "ingress-acl-set"},
			map[string]interface{}{"set-name": "*", "type": "*"},
			n,
		),
	}
}

// IngressAclSetAnyType (list): List of ingress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "ingress-acl-sets/ingress-acl-set"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set"
// SetName: string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *Acl_InterfacePath) IngressAclSetAnyType(SetName string) *Acl_Interface_IngressAclSetPathAny {
	return &Acl_Interface_IngressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-acl-sets", "ingress-acl-set"},
			map[string]interface{}{"set-name": SetName, "type": "*"},
			n,
		),
	}
}

// IngressAclSetAnyType (list): List of ingress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "ingress-acl-sets/ingress-acl-set"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set"
// SetName: string
// Type (wildcarded): E_Acl_ACL_TYPE
func (n *Acl_InterfacePathAny) IngressAclSetAnyType(SetName string) *Acl_Interface_IngressAclSetPathAny {
	return &Acl_Interface_IngressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-acl-sets", "ingress-acl-set"},
			map[string]interface{}{"set-name": SetName, "type": "*"},
			n,
		),
	}
}

// IngressAclSetAnySetName (list): List of ingress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "ingress-acl-sets/ingress-acl-set"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set"
// SetName (wildcarded): string
// Type: E_Acl_ACL_TYPE
func (n *Acl_InterfacePath) IngressAclSetAnySetName(Type E_Acl_ACL_TYPE) *Acl_Interface_IngressAclSetPathAny {
	return &Acl_Interface_IngressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-acl-sets", "ingress-acl-set"},
			map[string]interface{}{"set-name": "*", "type": Type},
			n,
		),
	}
}

// IngressAclSetAnySetName (list): List of ingress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "ingress-acl-sets/ingress-acl-set"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set"
// SetName (wildcarded): string
// Type: E_Acl_ACL_TYPE
func (n *Acl_InterfacePathAny) IngressAclSetAnySetName(Type E_Acl_ACL_TYPE) *Acl_Interface_IngressAclSetPathAny {
	return &Acl_Interface_IngressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-acl-sets", "ingress-acl-set"},
			map[string]interface{}{"set-name": "*", "type": Type},
			n,
		),
	}
}

// IngressAclSet (list): List of ingress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "ingress-acl-sets/ingress-acl-set"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set"
// SetName: string
// Type: E_Acl_ACL_TYPE
func (n *Acl_InterfacePath) IngressAclSet(SetName string, Type E_Acl_ACL_TYPE) *Acl_Interface_IngressAclSetPath {
	return &Acl_Interface_IngressAclSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-acl-sets", "ingress-acl-set"},
			map[string]interface{}{"set-name": SetName, "type": Type},
			n,
		),
	}
}

// IngressAclSet (list): List of ingress ACLs on the interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "ingress-acl-sets/ingress-acl-set"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set"
// SetName: string
// Type: E_Acl_ACL_TYPE
func (n *Acl_InterfacePathAny) IngressAclSet(SetName string, Type E_Acl_ACL_TYPE) *Acl_Interface_IngressAclSetPathAny {
	return &Acl_Interface_IngressAclSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-acl-sets", "ingress-acl-set"},
			map[string]interface{}{"set-name": SetName, "type": Type},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "interface-ref"
// Path from root: "/acl/interfaces/interface/interface-ref"
func (n *Acl_InterfacePath) InterfaceRef() *Acl_Interface_InterfaceRefPath {
	return &Acl_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "interface-ref"
// Path from root: "/acl/interfaces/interface/interface-ref"
func (n *Acl_InterfacePathAny) InterfaceRef() *Acl_Interface_InterfaceRefPathAny {
	return &Acl_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_Interface_EgressAclSetPath represents the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set YANG schema element.
type Acl_Interface_EgressAclSetPath struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSetPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set YANG schema element.
type Acl_Interface_EgressAclSetPathAny struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_SetNamePath represents the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/config/set-name YANG schema element.
type Acl_Interface_EgressAclSet_SetNamePath struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_SetNamePathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/config/set-name YANG schema element.
type Acl_Interface_EgressAclSet_SetNamePathAny struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_TypePath represents the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/config/type YANG schema element.
type Acl_Interface_EgressAclSet_TypePath struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_TypePathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/config/type YANG schema element.
type Acl_Interface_EgressAclSet_TypePathAny struct {
	*ygot.NodePath
}

// AclEntryAny (list): List of ACL entries assigned to an interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry"
// SequenceId (wildcarded): uint32
func (n *Acl_Interface_EgressAclSetPath) AclEntryAny() *Acl_Interface_EgressAclSet_AclEntryPathAny {
	return &Acl_Interface_EgressAclSet_AclEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": "*"},
			n,
		),
	}
}

// AclEntryAny (list): List of ACL entries assigned to an interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry"
// SequenceId (wildcarded): uint32
func (n *Acl_Interface_EgressAclSetPathAny) AclEntryAny() *Acl_Interface_EgressAclSet_AclEntryPathAny {
	return &Acl_Interface_EgressAclSet_AclEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": "*"},
			n,
		),
	}
}

// AclEntry (list): List of ACL entries assigned to an interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry"
// SequenceId: uint32
func (n *Acl_Interface_EgressAclSetPath) AclEntry(SequenceId uint32) *Acl_Interface_EgressAclSet_AclEntryPath {
	return &Acl_Interface_EgressAclSet_AclEntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": SequenceId},
			n,
		),
	}
}

// AclEntry (list): List of ACL entries assigned to an interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry"
// SequenceId: uint32
func (n *Acl_Interface_EgressAclSetPathAny) AclEntry(SequenceId uint32) *Acl_Interface_EgressAclSet_AclEntryPathAny {
	return &Acl_Interface_EgressAclSet_AclEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": SequenceId},
			n,
		),
	}
}

// SetName (leaf): Reference to the ACL set name applied on egress
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/set-name"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/config/set-name"
func (n *Acl_Interface_EgressAclSetPath) SetName() *Acl_Interface_EgressAclSet_SetNamePath {
	return &Acl_Interface_EgressAclSet_SetNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetName (leaf): Reference to the ACL set name applied on egress
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/set-name"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/config/set-name"
func (n *Acl_Interface_EgressAclSetPathAny) SetName() *Acl_Interface_EgressAclSet_SetNamePathAny {
	return &Acl_Interface_EgressAclSet_SetNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Reference to the ACL set type applied on egress.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/type"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/config/type"
func (n *Acl_Interface_EgressAclSetPath) Type() *Acl_Interface_EgressAclSet_TypePath {
	return &Acl_Interface_EgressAclSet_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Reference to the ACL set type applied on egress.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/type"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/config/type"
func (n *Acl_Interface_EgressAclSetPathAny) Type() *Acl_Interface_EgressAclSet_TypePathAny {
	return &Acl_Interface_EgressAclSet_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_Interface_EgressAclSet_AclEntryPath represents the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry YANG schema element.
type Acl_Interface_EgressAclSet_AclEntryPath struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_AclEntryPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry YANG schema element.
type Acl_Interface_EgressAclSet_AclEntryPathAny struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_AclEntry_MatchedOctetsPath represents the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/matched-octets YANG schema element.
type Acl_Interface_EgressAclSet_AclEntry_MatchedOctetsPath struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_AclEntry_MatchedOctetsPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/matched-octets YANG schema element.
type Acl_Interface_EgressAclSet_AclEntry_MatchedOctetsPathAny struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_AclEntry_MatchedPacketsPath represents the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/matched-packets YANG schema element.
type Acl_Interface_EgressAclSet_AclEntry_MatchedPacketsPath struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_AclEntry_MatchedPacketsPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/matched-packets YANG schema element.
type Acl_Interface_EgressAclSet_AclEntry_MatchedPacketsPathAny struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_AclEntry_SequenceIdPath represents the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/sequence-id YANG schema element.
type Acl_Interface_EgressAclSet_AclEntry_SequenceIdPath struct {
	*ygot.NodePath
}

// Acl_Interface_EgressAclSet_AclEntry_SequenceIdPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/sequence-id YANG schema element.
type Acl_Interface_EgressAclSet_AclEntry_SequenceIdPathAny struct {
	*ygot.NodePath
}

// MatchedOctets (leaf): Count of the number of octets (bytes) matching the current
// ACL entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-octets"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/matched-octets"
func (n *Acl_Interface_EgressAclSet_AclEntryPath) MatchedOctets() *Acl_Interface_EgressAclSet_AclEntry_MatchedOctetsPath {
	return &Acl_Interface_EgressAclSet_AclEntry_MatchedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedOctets (leaf): Count of the number of octets (bytes) matching the current
// ACL entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-octets"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/matched-octets"
func (n *Acl_Interface_EgressAclSet_AclEntryPathAny) MatchedOctets() *Acl_Interface_EgressAclSet_AclEntry_MatchedOctetsPathAny {
	return &Acl_Interface_EgressAclSet_AclEntry_MatchedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedPackets (leaf): Count of the number of packets matching the current ACL
// entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-packets"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/matched-packets"
func (n *Acl_Interface_EgressAclSet_AclEntryPath) MatchedPackets() *Acl_Interface_EgressAclSet_AclEntry_MatchedPacketsPath {
	return &Acl_Interface_EgressAclSet_AclEntry_MatchedPacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedPackets (leaf): Count of the number of packets matching the current ACL
// entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-packets"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/matched-packets"
func (n *Acl_Interface_EgressAclSet_AclEntryPathAny) MatchedPackets() *Acl_Interface_EgressAclSet_AclEntry_MatchedPacketsPathAny {
	return &Acl_Interface_EgressAclSet_AclEntry_MatchedPacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceId (leaf): Reference to an entry in the ACL set applied to an
// interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/sequence-id"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/sequence-id"
func (n *Acl_Interface_EgressAclSet_AclEntryPath) SequenceId() *Acl_Interface_EgressAclSet_AclEntry_SequenceIdPath {
	return &Acl_Interface_EgressAclSet_AclEntry_SequenceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sequence-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceId (leaf): Reference to an entry in the ACL set applied to an
// interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/sequence-id"
// Path from root: "/acl/interfaces/interface/egress-acl-sets/egress-acl-set/acl-entries/acl-entry/state/sequence-id"
func (n *Acl_Interface_EgressAclSet_AclEntryPathAny) SequenceId() *Acl_Interface_EgressAclSet_AclEntry_SequenceIdPathAny {
	return &Acl_Interface_EgressAclSet_AclEntry_SequenceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sequence-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_Interface_IngressAclSetPath represents the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set YANG schema element.
type Acl_Interface_IngressAclSetPath struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSetPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set YANG schema element.
type Acl_Interface_IngressAclSetPathAny struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_SetNamePath represents the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/config/set-name YANG schema element.
type Acl_Interface_IngressAclSet_SetNamePath struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_SetNamePathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/config/set-name YANG schema element.
type Acl_Interface_IngressAclSet_SetNamePathAny struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_TypePath represents the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/config/type YANG schema element.
type Acl_Interface_IngressAclSet_TypePath struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_TypePathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/config/type YANG schema element.
type Acl_Interface_IngressAclSet_TypePathAny struct {
	*ygot.NodePath
}

// AclEntryAny (list): List of ACL entries assigned to an interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry"
// SequenceId (wildcarded): uint32
func (n *Acl_Interface_IngressAclSetPath) AclEntryAny() *Acl_Interface_IngressAclSet_AclEntryPathAny {
	return &Acl_Interface_IngressAclSet_AclEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": "*"},
			n,
		),
	}
}

// AclEntryAny (list): List of ACL entries assigned to an interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry"
// SequenceId (wildcarded): uint32
func (n *Acl_Interface_IngressAclSetPathAny) AclEntryAny() *Acl_Interface_IngressAclSet_AclEntryPathAny {
	return &Acl_Interface_IngressAclSet_AclEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": "*"},
			n,
		),
	}
}

// AclEntry (list): List of ACL entries assigned to an interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry"
// SequenceId: uint32
func (n *Acl_Interface_IngressAclSetPath) AclEntry(SequenceId uint32) *Acl_Interface_IngressAclSet_AclEntryPath {
	return &Acl_Interface_IngressAclSet_AclEntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": SequenceId},
			n,
		),
	}
}

// AclEntry (list): List of ACL entries assigned to an interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl-entries/acl-entry"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry"
// SequenceId: uint32
func (n *Acl_Interface_IngressAclSetPathAny) AclEntry(SequenceId uint32) *Acl_Interface_IngressAclSet_AclEntryPathAny {
	return &Acl_Interface_IngressAclSet_AclEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acl-entries", "acl-entry"},
			map[string]interface{}{"sequence-id": SequenceId},
			n,
		),
	}
}

// SetName (leaf): Reference to the ACL set name applied on ingress
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/set-name"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/config/set-name"
func (n *Acl_Interface_IngressAclSetPath) SetName() *Acl_Interface_IngressAclSet_SetNamePath {
	return &Acl_Interface_IngressAclSet_SetNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetName (leaf): Reference to the ACL set name applied on ingress
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/set-name"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/config/set-name"
func (n *Acl_Interface_IngressAclSetPathAny) SetName() *Acl_Interface_IngressAclSet_SetNamePathAny {
	return &Acl_Interface_IngressAclSet_SetNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Reference to the ACL set type applied on ingress
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/type"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/config/type"
func (n *Acl_Interface_IngressAclSetPath) Type() *Acl_Interface_IngressAclSet_TypePath {
	return &Acl_Interface_IngressAclSet_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Reference to the ACL set type applied on ingress
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/type"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/config/type"
func (n *Acl_Interface_IngressAclSetPathAny) Type() *Acl_Interface_IngressAclSet_TypePathAny {
	return &Acl_Interface_IngressAclSet_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_Interface_IngressAclSet_AclEntryPath represents the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry YANG schema element.
type Acl_Interface_IngressAclSet_AclEntryPath struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_AclEntryPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry YANG schema element.
type Acl_Interface_IngressAclSet_AclEntryPathAny struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_AclEntry_MatchedOctetsPath represents the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/matched-octets YANG schema element.
type Acl_Interface_IngressAclSet_AclEntry_MatchedOctetsPath struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_AclEntry_MatchedOctetsPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/matched-octets YANG schema element.
type Acl_Interface_IngressAclSet_AclEntry_MatchedOctetsPathAny struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_AclEntry_MatchedPacketsPath represents the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/matched-packets YANG schema element.
type Acl_Interface_IngressAclSet_AclEntry_MatchedPacketsPath struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_AclEntry_MatchedPacketsPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/matched-packets YANG schema element.
type Acl_Interface_IngressAclSet_AclEntry_MatchedPacketsPathAny struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_AclEntry_SequenceIdPath represents the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/sequence-id YANG schema element.
type Acl_Interface_IngressAclSet_AclEntry_SequenceIdPath struct {
	*ygot.NodePath
}

// Acl_Interface_IngressAclSet_AclEntry_SequenceIdPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/sequence-id YANG schema element.
type Acl_Interface_IngressAclSet_AclEntry_SequenceIdPathAny struct {
	*ygot.NodePath
}

// MatchedOctets (leaf): Count of the number of octets (bytes) matching the current
// ACL entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-octets"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/matched-octets"
func (n *Acl_Interface_IngressAclSet_AclEntryPath) MatchedOctets() *Acl_Interface_IngressAclSet_AclEntry_MatchedOctetsPath {
	return &Acl_Interface_IngressAclSet_AclEntry_MatchedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedOctets (leaf): Count of the number of octets (bytes) matching the current
// ACL entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-octets"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/matched-octets"
func (n *Acl_Interface_IngressAclSet_AclEntryPathAny) MatchedOctets() *Acl_Interface_IngressAclSet_AclEntry_MatchedOctetsPathAny {
	return &Acl_Interface_IngressAclSet_AclEntry_MatchedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedPackets (leaf): Count of the number of packets matching the current ACL
// entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-packets"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/matched-packets"
func (n *Acl_Interface_IngressAclSet_AclEntryPath) MatchedPackets() *Acl_Interface_IngressAclSet_AclEntry_MatchedPacketsPath {
	return &Acl_Interface_IngressAclSet_AclEntry_MatchedPacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedPackets (leaf): Count of the number of packets matching the current ACL
// entry.
//
// An implementation should provide this counter on a
// per-interface per-ACL-entry if possible.
//
// If an implementation only supports ACL counters per entry
// (i.e., not broken out per interface), then the value
// should be equal to the aggregate count across all interfaces.
//
// An implementation that provides counters per entry per
// interface is not required to also provide an aggregate count,
// e.g., per entry -- the user is expected to be able implement
// the required aggregation if such a count is needed.
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/matched-packets"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/matched-packets"
func (n *Acl_Interface_IngressAclSet_AclEntryPathAny) MatchedPackets() *Acl_Interface_IngressAclSet_AclEntry_MatchedPacketsPathAny {
	return &Acl_Interface_IngressAclSet_AclEntry_MatchedPacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceId (leaf): Reference to an entry in the ACL set applied to an
// interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/sequence-id"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/sequence-id"
func (n *Acl_Interface_IngressAclSet_AclEntryPath) SequenceId() *Acl_Interface_IngressAclSet_AclEntry_SequenceIdPath {
	return &Acl_Interface_IngressAclSet_AclEntry_SequenceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sequence-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceId (leaf): Reference to an entry in the ACL set applied to an
// interface
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "state/sequence-id"
// Path from root: "/acl/interfaces/interface/ingress-acl-sets/ingress-acl-set/acl-entries/acl-entry/state/sequence-id"
func (n *Acl_Interface_IngressAclSet_AclEntryPathAny) SequenceId() *Acl_Interface_IngressAclSet_AclEntry_SequenceIdPathAny {
	return &Acl_Interface_IngressAclSet_AclEntry_SequenceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sequence-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Acl_Interface_InterfaceRefPath represents the /openconfig-acl/acl/interfaces/interface/interface-ref YANG schema element.
type Acl_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// Acl_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/interface-ref YANG schema element.
type Acl_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// Acl_Interface_InterfaceRef_InterfacePath represents the /openconfig-acl/acl/interfaces/interface/interface-ref/config/interface YANG schema element.
type Acl_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// Acl_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/interface-ref/config/interface YANG schema element.
type Acl_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// Acl_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-acl/acl/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type Acl_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// Acl_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-acl/acl/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type Acl_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/interface"
// Path from root: "/acl/interfaces/interface/interface-ref/config/interface"
func (n *Acl_Interface_InterfaceRefPath) Interface() *Acl_Interface_InterfaceRef_InterfacePath {
	return &Acl_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/interface"
// Path from root: "/acl/interfaces/interface/interface-ref/config/interface"
func (n *Acl_Interface_InterfaceRefPathAny) Interface() *Acl_Interface_InterfaceRef_InterfacePathAny {
	return &Acl_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/subinterface"
// Path from root: "/acl/interfaces/interface/interface-ref/config/subinterface"
func (n *Acl_Interface_InterfaceRefPath) Subinterface() *Acl_Interface_InterfaceRef_SubinterfacePath {
	return &Acl_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-acl"
// Path from parent: "config/subinterface"
// Path from root: "/acl/interfaces/interface/interface-ref/config/subinterface"
func (n *Acl_Interface_InterfaceRefPathAny) Subinterface() *Acl_Interface_InterfaceRef_SubinterfacePathAny {
	return &Acl_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApsPath represents the /openconfig-transport-line-protection/aps YANG schema element.
type ApsPath struct {
	*ygot.NodePath
}

// ApsPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps YANG schema element.
type ApsPathAny struct {
	*ygot.NodePath
}

// ApsModuleAny (list): List of automatic protection switch modules present
// in the device
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "aps-modules/aps-module"
// Path from root: "/aps/aps-modules/aps-module"
// Name (wildcarded): string
func (n *ApsPath) ApsModuleAny() *Aps_ApsModulePathAny {
	return &Aps_ApsModulePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"aps-modules", "aps-module"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// ApsModuleAny (list): List of automatic protection switch modules present
// in the device
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "aps-modules/aps-module"
// Path from root: "/aps/aps-modules/aps-module"
// Name (wildcarded): string
func (n *ApsPathAny) ApsModuleAny() *Aps_ApsModulePathAny {
	return &Aps_ApsModulePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"aps-modules", "aps-module"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// ApsModule (list): List of automatic protection switch modules present
// in the device
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "aps-modules/aps-module"
// Path from root: "/aps/aps-modules/aps-module"
// Name: string
func (n *ApsPath) ApsModule(Name string) *Aps_ApsModulePath {
	return &Aps_ApsModulePath{
		NodePath: ygot.NewNodePath(
			[]string{"aps-modules", "aps-module"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// ApsModule (list): List of automatic protection switch modules present
// in the device
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "aps-modules/aps-module"
// Path from root: "/aps/aps-modules/aps-module"
// Name: string
func (n *ApsPathAny) ApsModule(Name string) *Aps_ApsModulePathAny {
	return &Aps_ApsModulePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"aps-modules", "aps-module"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Aps_ApsModulePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module YANG schema element.
type Aps_ApsModulePath struct {
	*ygot.NodePath
}

// Aps_ApsModulePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module YANG schema element.
type Aps_ApsModulePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_ActivePathPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/state/active-path YANG schema element.
type Aps_ApsModule_ActivePathPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_ActivePathPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/state/active-path YANG schema element.
type Aps_ApsModule_ActivePathPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_ForceToPortPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/force-to-port YANG schema element.
type Aps_ApsModule_ForceToPortPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_ForceToPortPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/force-to-port YANG schema element.
type Aps_ApsModule_ForceToPortPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_HoldOffTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/hold-off-time YANG schema element.
type Aps_ApsModule_HoldOffTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_HoldOffTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/hold-off-time YANG schema element.
type Aps_ApsModule_HoldOffTimePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_NamePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/name YANG schema element.
type Aps_ApsModule_NamePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_NamePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/name YANG schema element.
type Aps_ApsModule_NamePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_PrimarySwitchHysteresisPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/primary-switch-hysteresis YANG schema element.
type Aps_ApsModule_PrimarySwitchHysteresisPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_PrimarySwitchHysteresisPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/primary-switch-hysteresis YANG schema element.
type Aps_ApsModule_PrimarySwitchHysteresisPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_PrimarySwitchThresholdPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/primary-switch-threshold YANG schema element.
type Aps_ApsModule_PrimarySwitchThresholdPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_PrimarySwitchThresholdPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/primary-switch-threshold YANG schema element.
type Aps_ApsModule_PrimarySwitchThresholdPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_RelativeSwitchThresholdPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/relative-switch-threshold YANG schema element.
type Aps_ApsModule_RelativeSwitchThresholdPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_RelativeSwitchThresholdPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/relative-switch-threshold YANG schema element.
type Aps_ApsModule_RelativeSwitchThresholdPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_RelativeSwitchThresholdOffsetPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/relative-switch-threshold-offset YANG schema element.
type Aps_ApsModule_RelativeSwitchThresholdOffsetPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_RelativeSwitchThresholdOffsetPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/relative-switch-threshold-offset YANG schema element.
type Aps_ApsModule_RelativeSwitchThresholdOffsetPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_RevertivePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/revertive YANG schema element.
type Aps_ApsModule_RevertivePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_RevertivePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/revertive YANG schema element.
type Aps_ApsModule_RevertivePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_SecondarySwitchThresholdPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/secondary-switch-threshold YANG schema element.
type Aps_ApsModule_SecondarySwitchThresholdPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_SecondarySwitchThresholdPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/secondary-switch-threshold YANG schema element.
type Aps_ApsModule_SecondarySwitchThresholdPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_WaitToRestoreTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/wait-to-restore-time YANG schema element.
type Aps_ApsModule_WaitToRestoreTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_WaitToRestoreTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/config/wait-to-restore-time YANG schema element.
type Aps_ApsModule_WaitToRestoreTimePathAny struct {
	*ygot.NodePath
}

// ActivePath (leaf): Indicates which line path on the protection switch is
// currently the active path connected to the common port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/active-path"
// Path from root: "/aps/aps-modules/aps-module/state/active-path"
func (n *Aps_ApsModulePath) ActivePath() *Aps_ApsModule_ActivePathPath {
	return &Aps_ApsModule_ActivePathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActivePath (leaf): Indicates which line path on the protection switch is
// currently the active path connected to the common port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/active-path"
// Path from root: "/aps/aps-modules/aps-module/state/active-path"
func (n *Aps_ApsModulePathAny) ActivePath() *Aps_ApsModule_ActivePathPathAny {
	return &Aps_ApsModule_ActivePathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForceToPort (leaf): Explicitly set the switch to stay on a port regardless of
// its operational condition
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/force-to-port"
// Path from root: "/aps/aps-modules/aps-module/config/force-to-port"
func (n *Aps_ApsModulePath) ForceToPort() *Aps_ApsModule_ForceToPortPath {
	return &Aps_ApsModule_ForceToPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "force-to-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForceToPort (leaf): Explicitly set the switch to stay on a port regardless of
// its operational condition
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/force-to-port"
// Path from root: "/aps/aps-modules/aps-module/config/force-to-port"
func (n *Aps_ApsModulePathAny) ForceToPort() *Aps_ApsModule_ForceToPortPathAny {
	return &Aps_ApsModule_ForceToPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "force-to-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldOffTime (leaf): The time delay between the declaration of an SF or SD
// condition and the initiation of the protection switching
// algorithm
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/hold-off-time"
// Path from root: "/aps/aps-modules/aps-module/config/hold-off-time"
func (n *Aps_ApsModulePath) HoldOffTime() *Aps_ApsModule_HoldOffTimePath {
	return &Aps_ApsModule_HoldOffTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-off-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldOffTime (leaf): The time delay between the declaration of an SF or SD
// condition and the initiation of the protection switching
// algorithm
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/hold-off-time"
// Path from root: "/aps/aps-modules/aps-module/config/hold-off-time"
func (n *Aps_ApsModulePathAny) HoldOffTime() *Aps_ApsModule_HoldOffTimePathAny {
	return &Aps_ApsModule_HoldOffTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-off-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the component name (in the platform model)
// corresponding to this automatic protection switch module
// in the device
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/name"
// Path from root: "/aps/aps-modules/aps-module/config/name"
func (n *Aps_ApsModulePath) Name() *Aps_ApsModule_NamePath {
	return &Aps_ApsModule_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the component name (in the platform model)
// corresponding to this automatic protection switch module
// in the device
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/name"
// Path from root: "/aps/aps-modules/aps-module/config/name"
func (n *Aps_ApsModulePathAny) Name() *Aps_ApsModule_NamePathAny {
	return &Aps_ApsModule_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ports (container): Top level grouping for automatic protection switch ports
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "ports"
// Path from root: "/aps/aps-modules/aps-module/ports"
func (n *Aps_ApsModulePath) Ports() *Aps_ApsModule_PortsPath {
	return &Aps_ApsModule_PortsPath{
		NodePath: ygot.NewNodePath(
			[]string{"ports"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ports (container): Top level grouping for automatic protection switch ports
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "ports"
// Path from root: "/aps/aps-modules/aps-module/ports"
func (n *Aps_ApsModulePathAny) Ports() *Aps_ApsModule_PortsPathAny {
	return &Aps_ApsModule_PortsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ports"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrimarySwitchHysteresis (leaf): The delta in dB between the primary-switch-threshold
// and the signal received on the primary APS_PATH before
// initiating a switch from the secondary APS_PATH to the
// primary APS_PATH, in order to prevent toggling between ports
// when an input signal is very close to the threshold. A zero
// value means the switch hysteresis is disabled.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/primary-switch-hysteresis"
// Path from root: "/aps/aps-modules/aps-module/config/primary-switch-hysteresis"
func (n *Aps_ApsModulePath) PrimarySwitchHysteresis() *Aps_ApsModule_PrimarySwitchHysteresisPath {
	return &Aps_ApsModule_PrimarySwitchHysteresisPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "primary-switch-hysteresis"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrimarySwitchHysteresis (leaf): The delta in dB between the primary-switch-threshold
// and the signal received on the primary APS_PATH before
// initiating a switch from the secondary APS_PATH to the
// primary APS_PATH, in order to prevent toggling between ports
// when an input signal is very close to the threshold. A zero
// value means the switch hysteresis is disabled.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/primary-switch-hysteresis"
// Path from root: "/aps/aps-modules/aps-module/config/primary-switch-hysteresis"
func (n *Aps_ApsModulePathAny) PrimarySwitchHysteresis() *Aps_ApsModule_PrimarySwitchHysteresisPathAny {
	return &Aps_ApsModule_PrimarySwitchHysteresisPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "primary-switch-hysteresis"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrimarySwitchThreshold (leaf): The threshold at which the primary line port will switch to
// the opposite line port in increments of 0.01 dBm. If the
// hardware supports only one switch threshold for primary and
// and secondary ports then it is recommended to set both
// primary-switch-threshold and secondary-switch-threshold to
// the same value to be explicit. When the relative switch
// threshold is enabled, i.e. set to a non-zero value, the
// primary switch threshold will be overridden
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/primary-switch-threshold"
// Path from root: "/aps/aps-modules/aps-module/config/primary-switch-threshold"
func (n *Aps_ApsModulePath) PrimarySwitchThreshold() *Aps_ApsModule_PrimarySwitchThresholdPath {
	return &Aps_ApsModule_PrimarySwitchThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "primary-switch-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrimarySwitchThreshold (leaf): The threshold at which the primary line port will switch to
// the opposite line port in increments of 0.01 dBm. If the
// hardware supports only one switch threshold for primary and
// and secondary ports then it is recommended to set both
// primary-switch-threshold and secondary-switch-threshold to
// the same value to be explicit. When the relative switch
// threshold is enabled, i.e. set to a non-zero value, the
// primary switch threshold will be overridden
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/primary-switch-threshold"
// Path from root: "/aps/aps-modules/aps-module/config/primary-switch-threshold"
func (n *Aps_ApsModulePathAny) PrimarySwitchThreshold() *Aps_ApsModule_PrimarySwitchThresholdPathAny {
	return &Aps_ApsModule_PrimarySwitchThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "primary-switch-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelativeSwitchThreshold (leaf): The delta threshold in dB at which the current line port
// will switch to the opposite line port. It can be set to
// the value of 0dB. When set to 0dB, the threshold is ignored
// and the system automatically applies the primary and
// secondary switch thresholds. When set to a non-zero value,
// it overrides the primary and secondary switch thresholds
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/relative-switch-threshold"
// Path from root: "/aps/aps-modules/aps-module/config/relative-switch-threshold"
func (n *Aps_ApsModulePath) RelativeSwitchThreshold() *Aps_ApsModule_RelativeSwitchThresholdPath {
	return &Aps_ApsModule_RelativeSwitchThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "relative-switch-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelativeSwitchThreshold (leaf): The delta threshold in dB at which the current line port
// will switch to the opposite line port. It can be set to
// the value of 0dB. When set to 0dB, the threshold is ignored
// and the system automatically applies the primary and
// secondary switch thresholds. When set to a non-zero value,
// it overrides the primary and secondary switch thresholds
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/relative-switch-threshold"
// Path from root: "/aps/aps-modules/aps-module/config/relative-switch-threshold"
func (n *Aps_ApsModulePathAny) RelativeSwitchThreshold() *Aps_ApsModule_RelativeSwitchThresholdPathAny {
	return &Aps_ApsModule_RelativeSwitchThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "relative-switch-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelativeSwitchThresholdOffset (leaf): The offset of the relative switch threshold that compensates
// the normal difference of receiving power between the primary
// and secondary line ports. A negative offset corresponds to
// the situation where the secondary line port receives a higher
// power than the primary line port in normal condition， and a
// positive offset means the opposite. The offset will only work
// when the relative switch threshold is set to a non-zero
// value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/relative-switch-threshold-offset"
// Path from root: "/aps/aps-modules/aps-module/config/relative-switch-threshold-offset"
func (n *Aps_ApsModulePath) RelativeSwitchThresholdOffset() *Aps_ApsModule_RelativeSwitchThresholdOffsetPath {
	return &Aps_ApsModule_RelativeSwitchThresholdOffsetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "relative-switch-threshold-offset"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelativeSwitchThresholdOffset (leaf): The offset of the relative switch threshold that compensates
// the normal difference of receiving power between the primary
// and secondary line ports. A negative offset corresponds to
// the situation where the secondary line port receives a higher
// power than the primary line port in normal condition， and a
// positive offset means the opposite. The offset will only work
// when the relative switch threshold is set to a non-zero
// value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/relative-switch-threshold-offset"
// Path from root: "/aps/aps-modules/aps-module/config/relative-switch-threshold-offset"
func (n *Aps_ApsModulePathAny) RelativeSwitchThresholdOffset() *Aps_ApsModule_RelativeSwitchThresholdOffsetPathAny {
	return &Aps_ApsModule_RelativeSwitchThresholdOffsetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "relative-switch-threshold-offset"},
			map[string]interface{}{},
			n,
		),
	}
}

// Revertive (leaf): Revertive behavior of the module. If True, then
// automatically revert after protection switch once the
// fault is restored. This leaf is not valid when the
// relative-switch-threshold is in effect
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/revertive"
// Path from root: "/aps/aps-modules/aps-module/config/revertive"
func (n *Aps_ApsModulePath) Revertive() *Aps_ApsModule_RevertivePath {
	return &Aps_ApsModule_RevertivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "revertive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Revertive (leaf): Revertive behavior of the module. If True, then
// automatically revert after protection switch once the
// fault is restored. This leaf is not valid when the
// relative-switch-threshold is in effect
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/revertive"
// Path from root: "/aps/aps-modules/aps-module/config/revertive"
func (n *Aps_ApsModulePathAny) Revertive() *Aps_ApsModule_RevertivePathAny {
	return &Aps_ApsModule_RevertivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "revertive"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecondarySwitchThreshold (leaf): The threshold at which the secondary line port will switch to
// the opposite line port in increments of 0.01 dBm. If the
// hardware supports only one switch threshold for primary and
// and secondary ports then it is recommended to set both
// primary-switch-threshold and secondary-switch-threshold to
// the same value to be explicit. When the relative switch
// threshold is enabled, i.e. set to a non-zero value, the
// secondary switch threshold will be overridden
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/secondary-switch-threshold"
// Path from root: "/aps/aps-modules/aps-module/config/secondary-switch-threshold"
func (n *Aps_ApsModulePath) SecondarySwitchThreshold() *Aps_ApsModule_SecondarySwitchThresholdPath {
	return &Aps_ApsModule_SecondarySwitchThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secondary-switch-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecondarySwitchThreshold (leaf): The threshold at which the secondary line port will switch to
// the opposite line port in increments of 0.01 dBm. If the
// hardware supports only one switch threshold for primary and
// and secondary ports then it is recommended to set both
// primary-switch-threshold and secondary-switch-threshold to
// the same value to be explicit. When the relative switch
// threshold is enabled, i.e. set to a non-zero value, the
// secondary switch threshold will be overridden
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/secondary-switch-threshold"
// Path from root: "/aps/aps-modules/aps-module/config/secondary-switch-threshold"
func (n *Aps_ApsModulePathAny) SecondarySwitchThreshold() *Aps_ApsModule_SecondarySwitchThresholdPathAny {
	return &Aps_ApsModule_SecondarySwitchThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secondary-switch-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// WaitToRestoreTime (leaf): The time that must elapse before an APS path
// that has recovered from an signal failure (SF) or signal
// degradation (SD) condition can be used again to transport
// the normal traffic signal. During this time period, an SF or
// SD condition shall override the wait-to-restore time period.
// This leaf can only take effect when the revertive leaf
// equals true
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/wait-to-restore-time"
// Path from root: "/aps/aps-modules/aps-module/config/wait-to-restore-time"
func (n *Aps_ApsModulePath) WaitToRestoreTime() *Aps_ApsModule_WaitToRestoreTimePath {
	return &Aps_ApsModule_WaitToRestoreTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "wait-to-restore-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// WaitToRestoreTime (leaf): The time that must elapse before an APS path
// that has recovered from an signal failure (SF) or signal
// degradation (SD) condition can be used again to transport
// the normal traffic signal. During this time period, an SF or
// SD condition shall override the wait-to-restore time period.
// This leaf can only take effect when the revertive leaf
// equals true
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/wait-to-restore-time"
// Path from root: "/aps/aps-modules/aps-module/config/wait-to-restore-time"
func (n *Aps_ApsModulePathAny) WaitToRestoreTime() *Aps_ApsModule_WaitToRestoreTimePathAny {
	return &Aps_ApsModule_WaitToRestoreTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "wait-to-restore-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_PortsPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports YANG schema element.
type Aps_ApsModule_PortsPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_PortsPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports YANG schema element.
type Aps_ApsModule_PortsPathAny struct {
	*ygot.NodePath
}

// CommonIn (container): Container for information related to the line common
// input port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "common-in"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in"
func (n *Aps_ApsModule_PortsPath) CommonIn() *Aps_ApsModule_Ports_CommonInPath {
	return &Aps_ApsModule_Ports_CommonInPath{
		NodePath: ygot.NewNodePath(
			[]string{"common-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommonIn (container): Container for information related to the line common
// input port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "common-in"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in"
func (n *Aps_ApsModule_PortsPathAny) CommonIn() *Aps_ApsModule_Ports_CommonInPathAny {
	return &Aps_ApsModule_Ports_CommonInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"common-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommonOutput (container): Container for information related to the line common
// output port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "common-output"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output"
func (n *Aps_ApsModule_PortsPath) CommonOutput() *Aps_ApsModule_Ports_CommonOutputPath {
	return &Aps_ApsModule_Ports_CommonOutputPath{
		NodePath: ygot.NewNodePath(
			[]string{"common-output"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommonOutput (container): Container for information related to the line common
// output port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "common-output"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output"
func (n *Aps_ApsModule_PortsPathAny) CommonOutput() *Aps_ApsModule_Ports_CommonOutputPathAny {
	return &Aps_ApsModule_Ports_CommonOutputPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"common-output"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinePrimaryIn (container): Container for information related to the line primary
// input port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "line-primary-in"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in"
func (n *Aps_ApsModule_PortsPath) LinePrimaryIn() *Aps_ApsModule_Ports_LinePrimaryInPath {
	return &Aps_ApsModule_Ports_LinePrimaryInPath{
		NodePath: ygot.NewNodePath(
			[]string{"line-primary-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinePrimaryIn (container): Container for information related to the line primary
// input port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "line-primary-in"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in"
func (n *Aps_ApsModule_PortsPathAny) LinePrimaryIn() *Aps_ApsModule_Ports_LinePrimaryInPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"line-primary-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinePrimaryOut (container): Container for information related to the line primary
// output port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "line-primary-out"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out"
func (n *Aps_ApsModule_PortsPath) LinePrimaryOut() *Aps_ApsModule_Ports_LinePrimaryOutPath {
	return &Aps_ApsModule_Ports_LinePrimaryOutPath{
		NodePath: ygot.NewNodePath(
			[]string{"line-primary-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinePrimaryOut (container): Container for information related to the line primary
// output port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "line-primary-out"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out"
func (n *Aps_ApsModule_PortsPathAny) LinePrimaryOut() *Aps_ApsModule_Ports_LinePrimaryOutPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"line-primary-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// LineSecondaryIn (container): Container for information related to the line secondary
// input port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "line-secondary-in"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in"
func (n *Aps_ApsModule_PortsPath) LineSecondaryIn() *Aps_ApsModule_Ports_LineSecondaryInPath {
	return &Aps_ApsModule_Ports_LineSecondaryInPath{
		NodePath: ygot.NewNodePath(
			[]string{"line-secondary-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// LineSecondaryIn (container): Container for information related to the line secondary
// input port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "line-secondary-in"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in"
func (n *Aps_ApsModule_PortsPathAny) LineSecondaryIn() *Aps_ApsModule_Ports_LineSecondaryInPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"line-secondary-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// LineSecondaryOut (container): Container for information related to the line secondary
// output port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "line-secondary-out"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out"
func (n *Aps_ApsModule_PortsPath) LineSecondaryOut() *Aps_ApsModule_Ports_LineSecondaryOutPath {
	return &Aps_ApsModule_Ports_LineSecondaryOutPath{
		NodePath: ygot.NewNodePath(
			[]string{"line-secondary-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// LineSecondaryOut (container): Container for information related to the line secondary
// output port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "line-secondary-out"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out"
func (n *Aps_ApsModule_PortsPathAny) LineSecondaryOut() *Aps_ApsModule_Ports_LineSecondaryOutPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"line-secondary-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_CommonInPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in YANG schema element.
type Aps_ApsModule_Ports_CommonInPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonInPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in YANG schema element.
type Aps_ApsModule_Ports_CommonInPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_AttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_CommonIn_AttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_AttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_CommonIn_AttenuationPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_EnabledPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/config/enabled YANG schema element.
type Aps_ApsModule_Ports_CommonIn_EnabledPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_EnabledPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/config/enabled YANG schema element.
type Aps_ApsModule_Ports_CommonIn_EnabledPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_TargetAttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_CommonIn_TargetAttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_TargetAttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_CommonIn_TargetAttenuationPathAny struct {
	*ygot.NodePath
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/attenuation"
func (n *Aps_ApsModule_Ports_CommonInPath) Attenuation() *Aps_ApsModule_Ports_CommonIn_AttenuationPath {
	return &Aps_ApsModule_Ports_CommonIn_AttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/attenuation"
func (n *Aps_ApsModule_Ports_CommonInPathAny) Attenuation() *Aps_ApsModule_Ports_CommonIn_AttenuationPathAny {
	return &Aps_ApsModule_Ports_CommonIn_AttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// port. Disabling the port turns off alarm reporting for
// the port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/enabled"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/config/enabled"
func (n *Aps_ApsModule_Ports_CommonInPath) Enabled() *Aps_ApsModule_Ports_CommonIn_EnabledPath {
	return &Aps_ApsModule_Ports_CommonIn_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// port. Disabling the port turns off alarm reporting for
// the port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/enabled"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/config/enabled"
func (n *Aps_ApsModule_Ports_CommonInPathAny) Enabled() *Aps_ApsModule_Ports_CommonIn_EnabledPathAny {
	return &Aps_ApsModule_Ports_CommonIn_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical input power of this port in units of
// 0.01dBm. Optical input power represents the signal
// traversing from an external destination into the module.
// The power is measured before any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power"
func (n *Aps_ApsModule_Ports_CommonInPath) OpticalPower() *Aps_ApsModule_Ports_CommonIn_OpticalPowerPath {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical input power of this port in units of
// 0.01dBm. Optical input power represents the signal
// traversing from an external destination into the module.
// The power is measured before any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power"
func (n *Aps_ApsModule_Ports_CommonInPathAny) OpticalPower() *Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/config/target-attenuation"
func (n *Aps_ApsModule_Ports_CommonInPath) TargetAttenuation() *Aps_ApsModule_Ports_CommonIn_TargetAttenuationPath {
	return &Aps_ApsModule_Ports_CommonIn_TargetAttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/config/target-attenuation"
func (n *Aps_ApsModule_Ports_CommonInPathAny) TargetAttenuation() *Aps_ApsModule_Ports_CommonIn_TargetAttenuationPathAny {
	return &Aps_ApsModule_Ports_CommonIn_TargetAttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_CommonIn_OpticalPowerPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPowerPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_AvgPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_AvgPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_AvgPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_AvgPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_InstantPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_InstantPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_InstantPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_InstantPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_IntervalPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_IntervalPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_IntervalPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_MinPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_MinPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_MinPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_MinPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_MinTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_MinTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonIn_OpticalPower_MinTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-in/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_CommonIn_OpticalPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPath) Avg() *Aps_ApsModule_Ports_CommonIn_OpticalPower_AvgPath {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny) Avg() *Aps_ApsModule_Ports_CommonIn_OpticalPower_AvgPathAny {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPath) Instant() *Aps_ApsModule_Ports_CommonIn_OpticalPower_InstantPath {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny) Instant() *Aps_ApsModule_Ports_CommonIn_OpticalPower_InstantPathAny {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPath) Interval() *Aps_ApsModule_Ports_CommonIn_OpticalPower_IntervalPath {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny) Interval() *Aps_ApsModule_Ports_CommonIn_OpticalPower_IntervalPathAny {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/max"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPath) Max() *Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxPath {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/max"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny) Max() *Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxPathAny {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPath) MaxTime() *Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxTimePath {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny) MaxTime() *Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxTimePathAny {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/min"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPath) Min() *Aps_ApsModule_Ports_CommonIn_OpticalPower_MinPath {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/min"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny) Min() *Aps_ApsModule_Ports_CommonIn_OpticalPower_MinPathAny {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPath) MinTime() *Aps_ApsModule_Ports_CommonIn_OpticalPower_MinTimePath {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/common-in/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_CommonIn_OpticalPowerPathAny) MinTime() *Aps_ApsModule_Ports_CommonIn_OpticalPower_MinTimePathAny {
	return &Aps_ApsModule_Ports_CommonIn_OpticalPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_CommonOutputPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output YANG schema element.
type Aps_ApsModule_Ports_CommonOutputPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutputPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output YANG schema element.
type Aps_ApsModule_Ports_CommonOutputPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_AttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_AttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_AttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_AttenuationPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_TargetAttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_TargetAttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_TargetAttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_TargetAttenuationPathAny struct {
	*ygot.NodePath
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/attenuation"
func (n *Aps_ApsModule_Ports_CommonOutputPath) Attenuation() *Aps_ApsModule_Ports_CommonOutput_AttenuationPath {
	return &Aps_ApsModule_Ports_CommonOutput_AttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/attenuation"
func (n *Aps_ApsModule_Ports_CommonOutputPathAny) Attenuation() *Aps_ApsModule_Ports_CommonOutput_AttenuationPathAny {
	return &Aps_ApsModule_Ports_CommonOutput_AttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical output power of this port in units of
// 0.01dBm. Optical output power represents the signal
// traversing from the module to an external destination. The
// power is measured after any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power"
func (n *Aps_ApsModule_Ports_CommonOutputPath) OpticalPower() *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical output power of this port in units of
// 0.01dBm. Optical output power represents the signal
// traversing from the module to an external destination. The
// power is measured after any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power"
func (n *Aps_ApsModule_Ports_CommonOutputPathAny) OpticalPower() *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/config/target-attenuation"
func (n *Aps_ApsModule_Ports_CommonOutputPath) TargetAttenuation() *Aps_ApsModule_Ports_CommonOutput_TargetAttenuationPath {
	return &Aps_ApsModule_Ports_CommonOutput_TargetAttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/config/target-attenuation"
func (n *Aps_ApsModule_Ports_CommonOutputPathAny) TargetAttenuation() *Aps_ApsModule_Ports_CommonOutput_TargetAttenuationPathAny {
	return &Aps_ApsModule_Ports_CommonOutput_TargetAttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_AvgPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_AvgPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_AvgPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_AvgPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_InstantPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_InstantPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_InstantPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_InstantPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_IntervalPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_IntervalPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_IntervalPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/common-output/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath) Avg() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_AvgPath {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny) Avg() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_AvgPathAny {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath) Instant() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_InstantPath {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny) Instant() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_InstantPathAny {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath) Interval() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_IntervalPath {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny) Interval() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_IntervalPathAny {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/max"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath) Max() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxPath {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/max"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny) Max() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxPathAny {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath) MaxTime() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxTimePath {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny) MaxTime() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxTimePathAny {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/min"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath) Min() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinPath {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/min"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny) Min() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinPathAny {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPath) MinTime() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinTimePath {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/common-output/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_CommonOutput_OpticalPowerPathAny) MinTime() *Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinTimePathAny {
	return &Aps_ApsModule_Ports_CommonOutput_OpticalPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_LinePrimaryInPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryInPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryInPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryInPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_AttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_AttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_AttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_AttenuationPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_EnabledPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/config/enabled YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_EnabledPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_EnabledPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/config/enabled YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_EnabledPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_TargetAttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_TargetAttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_TargetAttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_TargetAttenuationPathAny struct {
	*ygot.NodePath
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/attenuation"
func (n *Aps_ApsModule_Ports_LinePrimaryInPath) Attenuation() *Aps_ApsModule_Ports_LinePrimaryIn_AttenuationPath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_AttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/attenuation"
func (n *Aps_ApsModule_Ports_LinePrimaryInPathAny) Attenuation() *Aps_ApsModule_Ports_LinePrimaryIn_AttenuationPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_AttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// port. Disabling the port turns off alarm reporting for
// the port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/enabled"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/config/enabled"
func (n *Aps_ApsModule_Ports_LinePrimaryInPath) Enabled() *Aps_ApsModule_Ports_LinePrimaryIn_EnabledPath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// port. Disabling the port turns off alarm reporting for
// the port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/enabled"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/config/enabled"
func (n *Aps_ApsModule_Ports_LinePrimaryInPathAny) Enabled() *Aps_ApsModule_Ports_LinePrimaryIn_EnabledPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical input power of this port in units of
// 0.01dBm. Optical input power represents the signal
// traversing from an external destination into the module.
// The power is measured before any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power"
func (n *Aps_ApsModule_Ports_LinePrimaryInPath) OpticalPower() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical input power of this port in units of
// 0.01dBm. Optical input power represents the signal
// traversing from an external destination into the module.
// The power is measured before any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power"
func (n *Aps_ApsModule_Ports_LinePrimaryInPathAny) OpticalPower() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/config/target-attenuation"
func (n *Aps_ApsModule_Ports_LinePrimaryInPath) TargetAttenuation() *Aps_ApsModule_Ports_LinePrimaryIn_TargetAttenuationPath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_TargetAttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/config/target-attenuation"
func (n *Aps_ApsModule_Ports_LinePrimaryInPathAny) TargetAttenuation() *Aps_ApsModule_Ports_LinePrimaryIn_TargetAttenuationPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_TargetAttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_AvgPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_AvgPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_AvgPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_AvgPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_InstantPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_InstantPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_InstantPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_InstantPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_IntervalPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_IntervalPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_IntervalPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath) Avg() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_AvgPath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny) Avg() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_AvgPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath) Instant() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_InstantPath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny) Instant() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_InstantPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath) Interval() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_IntervalPath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny) Interval() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_IntervalPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/max"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath) Max() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxPath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/max"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny) Max() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath) MaxTime() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxTimePath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny) MaxTime() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxTimePathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/min"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath) Min() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinPath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/min"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny) Min() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPath) MinTime() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinTimePath {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-in/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPowerPathAny) MinTime() *Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinTimePathAny {
	return &Aps_ApsModule_Ports_LinePrimaryIn_OpticalPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_LinePrimaryOutPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOutPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOutPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOutPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_AttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_AttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_AttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_AttenuationPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_TargetAttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_TargetAttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_TargetAttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_TargetAttenuationPathAny struct {
	*ygot.NodePath
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/attenuation"
func (n *Aps_ApsModule_Ports_LinePrimaryOutPath) Attenuation() *Aps_ApsModule_Ports_LinePrimaryOut_AttenuationPath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_AttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/attenuation"
func (n *Aps_ApsModule_Ports_LinePrimaryOutPathAny) Attenuation() *Aps_ApsModule_Ports_LinePrimaryOut_AttenuationPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_AttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical output power of this port in units of
// 0.01dBm. Optical output power represents the signal
// traversing from the module to an external destination. The
// power is measured after any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power"
func (n *Aps_ApsModule_Ports_LinePrimaryOutPath) OpticalPower() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical output power of this port in units of
// 0.01dBm. Optical output power represents the signal
// traversing from the module to an external destination. The
// power is measured after any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power"
func (n *Aps_ApsModule_Ports_LinePrimaryOutPathAny) OpticalPower() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/config/target-attenuation"
func (n *Aps_ApsModule_Ports_LinePrimaryOutPath) TargetAttenuation() *Aps_ApsModule_Ports_LinePrimaryOut_TargetAttenuationPath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_TargetAttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/config/target-attenuation"
func (n *Aps_ApsModule_Ports_LinePrimaryOutPathAny) TargetAttenuation() *Aps_ApsModule_Ports_LinePrimaryOut_TargetAttenuationPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_TargetAttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_AvgPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_AvgPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_AvgPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_AvgPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_InstantPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_InstantPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_InstantPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_InstantPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_IntervalPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_IntervalPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_IntervalPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath) Avg() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_AvgPath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny) Avg() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_AvgPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath) Instant() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_InstantPath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny) Instant() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_InstantPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath) Interval() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_IntervalPath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny) Interval() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_IntervalPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/max"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath) Max() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxPath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/max"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny) Max() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath) MaxTime() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxTimePath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny) MaxTime() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxTimePathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/min"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath) Min() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinPath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/min"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny) Min() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinPathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPath) MinTime() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinTimePath {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-primary-out/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPowerPathAny) MinTime() *Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinTimePathAny {
	return &Aps_ApsModule_Ports_LinePrimaryOut_OpticalPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_LineSecondaryInPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryInPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryInPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryInPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_AttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_AttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_AttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_AttenuationPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_EnabledPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/config/enabled YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_EnabledPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_EnabledPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/config/enabled YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_EnabledPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_TargetAttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_TargetAttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_TargetAttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_TargetAttenuationPathAny struct {
	*ygot.NodePath
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/attenuation"
func (n *Aps_ApsModule_Ports_LineSecondaryInPath) Attenuation() *Aps_ApsModule_Ports_LineSecondaryIn_AttenuationPath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_AttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/attenuation"
func (n *Aps_ApsModule_Ports_LineSecondaryInPathAny) Attenuation() *Aps_ApsModule_Ports_LineSecondaryIn_AttenuationPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_AttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// port. Disabling the port turns off alarm reporting for
// the port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/enabled"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/config/enabled"
func (n *Aps_ApsModule_Ports_LineSecondaryInPath) Enabled() *Aps_ApsModule_Ports_LineSecondaryIn_EnabledPath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// port. Disabling the port turns off alarm reporting for
// the port
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/enabled"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/config/enabled"
func (n *Aps_ApsModule_Ports_LineSecondaryInPathAny) Enabled() *Aps_ApsModule_Ports_LineSecondaryIn_EnabledPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical input power of this port in units of
// 0.01dBm. Optical input power represents the signal
// traversing from an external destination into the module.
// The power is measured before any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power"
func (n *Aps_ApsModule_Ports_LineSecondaryInPath) OpticalPower() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical input power of this port in units of
// 0.01dBm. Optical input power represents the signal
// traversing from an external destination into the module.
// The power is measured before any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power"
func (n *Aps_ApsModule_Ports_LineSecondaryInPathAny) OpticalPower() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/config/target-attenuation"
func (n *Aps_ApsModule_Ports_LineSecondaryInPath) TargetAttenuation() *Aps_ApsModule_Ports_LineSecondaryIn_TargetAttenuationPath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_TargetAttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB.
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/config/target-attenuation"
func (n *Aps_ApsModule_Ports_LineSecondaryInPathAny) TargetAttenuation() *Aps_ApsModule_Ports_LineSecondaryIn_TargetAttenuationPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_TargetAttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_AvgPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_AvgPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_AvgPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_AvgPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_InstantPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_InstantPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_InstantPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_InstantPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_IntervalPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_IntervalPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_IntervalPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath) Avg() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_AvgPath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny) Avg() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_AvgPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath) Instant() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_InstantPath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny) Instant() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_InstantPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath) Interval() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_IntervalPath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny) Interval() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_IntervalPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/max"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath) Max() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxPath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/max"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny) Max() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath) MaxTime() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxTimePath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny) MaxTime() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxTimePathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/min"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath) Min() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinPath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/min"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny) Min() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPath) MinTime() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinTimePath {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-in/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPowerPathAny) MinTime() *Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinTimePathAny {
	return &Aps_ApsModule_Ports_LineSecondaryIn_OpticalPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_LineSecondaryOutPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOutPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOutPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOutPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_AttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_AttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_AttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/attenuation YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_AttenuationPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_TargetAttenuationPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_TargetAttenuationPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_TargetAttenuationPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/config/target-attenuation YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_TargetAttenuationPathAny struct {
	*ygot.NodePath
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/attenuation"
func (n *Aps_ApsModule_Ports_LineSecondaryOutPath) Attenuation() *Aps_ApsModule_Ports_LineSecondaryOut_AttenuationPath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_AttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Attenuation (leaf): The attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/attenuation"
func (n *Aps_ApsModule_Ports_LineSecondaryOutPathAny) Attenuation() *Aps_ApsModule_Ports_LineSecondaryOut_AttenuationPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_AttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical output power of this port in units of
// 0.01dBm. Optical output power represents the signal
// traversing from the module to an external destination. The
// power is measured after any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power"
func (n *Aps_ApsModule_Ports_LineSecondaryOutPath) OpticalPower() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPower (container): The optical output power of this port in units of
// 0.01dBm. Optical output power represents the signal
// traversing from the module to an external destination. The
// power is measured after any attenuation. If avg/min/max
// statistics are not supported, the target is expected to
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "state/optical-power"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power"
func (n *Aps_ApsModule_Ports_LineSecondaryOutPathAny) OpticalPower() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/config/target-attenuation"
func (n *Aps_ApsModule_Ports_LineSecondaryOutPath) TargetAttenuation() *Aps_ApsModule_Ports_LineSecondaryOut_TargetAttenuationPath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_TargetAttenuationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAttenuation (leaf): Target attenuation of the variable optical attenuator
// associated with the port in increments of 0.01 dB
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "config/target-attenuation"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/config/target-attenuation"
func (n *Aps_ApsModule_Ports_LineSecondaryOutPathAny) TargetAttenuation() *Aps_ApsModule_Ports_LineSecondaryOut_TargetAttenuationPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_TargetAttenuationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-attenuation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_AvgPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_AvgPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_AvgPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/avg YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_AvgPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_InstantPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_InstantPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_InstantPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/instant YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_InstantPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_IntervalPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_IntervalPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_IntervalPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/interval YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/max YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/max-time YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinPath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinPath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinPathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/min YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinPathAny struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinTimePath represents the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinTimePath struct {
	*ygot.NodePath
}

// Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinTimePathAny represents the wildcard version of the /openconfig-transport-line-protection/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/min-time YANG schema element.
type Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath) Avg() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_AvgPath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "avg"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/avg"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny) Avg() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_AvgPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath) Instant() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_InstantPath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "instant"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/instant"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny) Instant() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_InstantPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath) Interval() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_IntervalPath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "interval"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/interval"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny) Interval() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_IntervalPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/max"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath) Max() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxPath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/max"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny) Max() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath) MaxTime() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxTimePath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "max-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/max-time"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny) MaxTime() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxTimePathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/min"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath) Min() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinPath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/min"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny) Min() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinPathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPath) MinTime() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinTimePath {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "min-time"
// Path from root: "/aps/aps-modules/aps-module/ports/line-secondary-out/state/optical-power/min-time"
func (n *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPowerPathAny) MinTime() *Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinTimePathAny {
	return &Aps_ApsModule_Ports_LineSecondaryOut_OpticalPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// BfdPath represents the /openconfig-bfd/bfd YANG schema element.
type BfdPath struct {
	*ygot.NodePath
}

// BfdPathAny represents the wildcard version of the /openconfig-bfd/bfd YANG schema element.
type BfdPathAny struct {
	*ygot.NodePath
}

// InterfaceAny (list): Per-interface configuration and state parameters for BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "interfaces/interface"
// Path from root: "/bfd/interfaces/interface"
// Id (wildcarded): string
func (n *BfdPath) InterfaceAny() *Bfd_InterfacePathAny {
	return &Bfd_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): Per-interface configuration and state parameters for BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "interfaces/interface"
// Path from root: "/bfd/interfaces/interface"
// Id (wildcarded): string
func (n *BfdPathAny) InterfaceAny() *Bfd_InterfacePathAny {
	return &Bfd_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Interface (list): Per-interface configuration and state parameters for BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "interfaces/interface"
// Path from root: "/bfd/interfaces/interface"
// Id: string
func (n *BfdPath) Interface(Id string) *Bfd_InterfacePath {
	return &Bfd_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Interface (list): Per-interface configuration and state parameters for BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "interfaces/interface"
// Path from root: "/bfd/interfaces/interface"
// Id: string
func (n *BfdPathAny) Interface(Id string) *Bfd_InterfacePathAny {
	return &Bfd_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Bfd_InterfacePath represents the /openconfig-bfd/bfd/interfaces/interface YANG schema element.
type Bfd_InterfacePath struct {
	*ygot.NodePath
}

// Bfd_InterfacePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface YANG schema element.
type Bfd_InterfacePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_DesiredMinimumTxIntervalPath represents the /openconfig-bfd/bfd/interfaces/interface/config/desired-minimum-tx-interval YANG schema element.
type Bfd_Interface_DesiredMinimumTxIntervalPath struct {
	*ygot.NodePath
}

// Bfd_Interface_DesiredMinimumTxIntervalPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/config/desired-minimum-tx-interval YANG schema element.
type Bfd_Interface_DesiredMinimumTxIntervalPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_DetectionMultiplierPath represents the /openconfig-bfd/bfd/interfaces/interface/config/detection-multiplier YANG schema element.
type Bfd_Interface_DetectionMultiplierPath struct {
	*ygot.NodePath
}

// Bfd_Interface_DetectionMultiplierPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/config/detection-multiplier YANG schema element.
type Bfd_Interface_DetectionMultiplierPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_EnablePerMemberLinkPath represents the /openconfig-bfd/bfd/interfaces/interface/config/enable-per-member-link YANG schema element.
type Bfd_Interface_EnablePerMemberLinkPath struct {
	*ygot.NodePath
}

// Bfd_Interface_EnablePerMemberLinkPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/config/enable-per-member-link YANG schema element.
type Bfd_Interface_EnablePerMemberLinkPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_EnabledPath represents the /openconfig-bfd/bfd/interfaces/interface/config/enabled YANG schema element.
type Bfd_Interface_EnabledPath struct {
	*ygot.NodePath
}

// Bfd_Interface_EnabledPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/config/enabled YANG schema element.
type Bfd_Interface_EnabledPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_IdPath represents the /openconfig-bfd/bfd/interfaces/interface/config/id YANG schema element.
type Bfd_Interface_IdPath struct {
	*ygot.NodePath
}

// Bfd_Interface_IdPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/config/id YANG schema element.
type Bfd_Interface_IdPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_LocalAddressPath represents the /openconfig-bfd/bfd/interfaces/interface/config/local-address YANG schema element.
type Bfd_Interface_LocalAddressPath struct {
	*ygot.NodePath
}

// Bfd_Interface_LocalAddressPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/config/local-address YANG schema element.
type Bfd_Interface_LocalAddressPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_RequiredMinimumReceivePath represents the /openconfig-bfd/bfd/interfaces/interface/config/required-minimum-receive YANG schema element.
type Bfd_Interface_RequiredMinimumReceivePath struct {
	*ygot.NodePath
}

// Bfd_Interface_RequiredMinimumReceivePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/config/required-minimum-receive YANG schema element.
type Bfd_Interface_RequiredMinimumReceivePathAny struct {
	*ygot.NodePath
}

// DesiredMinimumTxInterval (leaf): The minimum interval between transmission of BFD control
// packets that the operator desires. This value is advertised to
// the peer, however the actual interval used is specified by
// taking the maximum of desired-minimum-tx-interval and the
// value of the remote required-minimum-receive interval value.
//
// This value is specified as an integer number of microseconds.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/desired-minimum-tx-interval"
// Path from root: "/bfd/interfaces/interface/config/desired-minimum-tx-interval"
func (n *Bfd_InterfacePath) DesiredMinimumTxInterval() *Bfd_Interface_DesiredMinimumTxIntervalPath {
	return &Bfd_Interface_DesiredMinimumTxIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "desired-minimum-tx-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesiredMinimumTxInterval (leaf): The minimum interval between transmission of BFD control
// packets that the operator desires. This value is advertised to
// the peer, however the actual interval used is specified by
// taking the maximum of desired-minimum-tx-interval and the
// value of the remote required-minimum-receive interval value.
//
// This value is specified as an integer number of microseconds.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/desired-minimum-tx-interval"
// Path from root: "/bfd/interfaces/interface/config/desired-minimum-tx-interval"
func (n *Bfd_InterfacePathAny) DesiredMinimumTxInterval() *Bfd_Interface_DesiredMinimumTxIntervalPathAny {
	return &Bfd_Interface_DesiredMinimumTxIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "desired-minimum-tx-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// DetectionMultiplier (leaf): The number of packets that must be missed to declare this
// session as down. The detection interval for the BFD session
// is calculated by multiplying the value of the negotiated
// transmission interval by this value.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/detection-multiplier"
// Path from root: "/bfd/interfaces/interface/config/detection-multiplier"
func (n *Bfd_InterfacePath) DetectionMultiplier() *Bfd_Interface_DetectionMultiplierPath {
	return &Bfd_Interface_DetectionMultiplierPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "detection-multiplier"},
			map[string]interface{}{},
			n,
		),
	}
}

// DetectionMultiplier (leaf): The number of packets that must be missed to declare this
// session as down. The detection interval for the BFD session
// is calculated by multiplying the value of the negotiated
// transmission interval by this value.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/detection-multiplier"
// Path from root: "/bfd/interfaces/interface/config/detection-multiplier"
func (n *Bfd_InterfacePathAny) DetectionMultiplier() *Bfd_Interface_DetectionMultiplierPathAny {
	return &Bfd_Interface_DetectionMultiplierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "detection-multiplier"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnablePerMemberLink (leaf): When this leaf is set to true - BFD will be enabled on
// each member interface of the aggregated Ethernet bundle.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/enable-per-member-link"
// Path from root: "/bfd/interfaces/interface/config/enable-per-member-link"
func (n *Bfd_InterfacePath) EnablePerMemberLink() *Bfd_Interface_EnablePerMemberLinkPath {
	return &Bfd_Interface_EnablePerMemberLinkPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-per-member-link"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnablePerMemberLink (leaf): When this leaf is set to true - BFD will be enabled on
// each member interface of the aggregated Ethernet bundle.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/enable-per-member-link"
// Path from root: "/bfd/interfaces/interface/config/enable-per-member-link"
func (n *Bfd_InterfacePathAny) EnablePerMemberLink() *Bfd_Interface_EnablePerMemberLinkPathAny {
	return &Bfd_Interface_EnablePerMemberLinkPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-per-member-link"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true then the BFD session is enabled
// on the specified interface - if it is set to false, it is
// administratively disabled.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/enabled"
// Path from root: "/bfd/interfaces/interface/config/enabled"
func (n *Bfd_InterfacePath) Enabled() *Bfd_Interface_EnabledPath {
	return &Bfd_Interface_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true then the BFD session is enabled
// on the specified interface - if it is set to false, it is
// administratively disabled.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/enabled"
// Path from root: "/bfd/interfaces/interface/config/enabled"
func (n *Bfd_InterfacePathAny) Enabled() *Bfd_Interface_EnabledPathAny {
	return &Bfd_Interface_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique identifier for the interface.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/id"
// Path from root: "/bfd/interfaces/interface/config/id"
func (n *Bfd_InterfacePath) Id() *Bfd_Interface_IdPath {
	return &Bfd_Interface_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique identifier for the interface.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/id"
// Path from root: "/bfd/interfaces/interface/config/id"
func (n *Bfd_InterfacePathAny) Id() *Bfd_Interface_IdPathAny {
	return &Bfd_Interface_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-bfd"
// Path from parent: "interface-ref"
// Path from root: "/bfd/interfaces/interface/interface-ref"
func (n *Bfd_InterfacePath) InterfaceRef() *Bfd_Interface_InterfaceRefPath {
	return &Bfd_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-bfd"
// Path from parent: "interface-ref"
// Path from root: "/bfd/interfaces/interface/interface-ref"
func (n *Bfd_InterfacePathAny) InterfaceRef() *Bfd_Interface_InterfaceRefPathAny {
	return &Bfd_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): The source IP address to be used for BFD sessions over this
// interface.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/local-address"
// Path from root: "/bfd/interfaces/interface/config/local-address"
func (n *Bfd_InterfacePath) LocalAddress() *Bfd_Interface_LocalAddressPath {
	return &Bfd_Interface_LocalAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): The source IP address to be used for BFD sessions over this
// interface.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/local-address"
// Path from root: "/bfd/interfaces/interface/config/local-address"
func (n *Bfd_InterfacePathAny) LocalAddress() *Bfd_Interface_LocalAddressPathAny {
	return &Bfd_Interface_LocalAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MicroBfdSessionAny (list): This list contains configuration and state parameters
// relating to micro-BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "micro-bfd-sessions/micro-bfd-session"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session"
// MemberInterface (wildcarded): string
func (n *Bfd_InterfacePath) MicroBfdSessionAny() *Bfd_Interface_MicroBfdSessionPathAny {
	return &Bfd_Interface_MicroBfdSessionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"micro-bfd-sessions", "micro-bfd-session"},
			map[string]interface{}{"member-interface": "*"},
			n,
		),
	}
}

// MicroBfdSessionAny (list): This list contains configuration and state parameters
// relating to micro-BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "micro-bfd-sessions/micro-bfd-session"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session"
// MemberInterface (wildcarded): string
func (n *Bfd_InterfacePathAny) MicroBfdSessionAny() *Bfd_Interface_MicroBfdSessionPathAny {
	return &Bfd_Interface_MicroBfdSessionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"micro-bfd-sessions", "micro-bfd-session"},
			map[string]interface{}{"member-interface": "*"},
			n,
		),
	}
}

// MicroBfdSession (list): This list contains configuration and state parameters
// relating to micro-BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "micro-bfd-sessions/micro-bfd-session"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session"
// MemberInterface: string
func (n *Bfd_InterfacePath) MicroBfdSession(MemberInterface string) *Bfd_Interface_MicroBfdSessionPath {
	return &Bfd_Interface_MicroBfdSessionPath{
		NodePath: ygot.NewNodePath(
			[]string{"micro-bfd-sessions", "micro-bfd-session"},
			map[string]interface{}{"member-interface": MemberInterface},
			n,
		),
	}
}

// MicroBfdSession (list): This list contains configuration and state parameters
// relating to micro-BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "micro-bfd-sessions/micro-bfd-session"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session"
// MemberInterface: string
func (n *Bfd_InterfacePathAny) MicroBfdSession(MemberInterface string) *Bfd_Interface_MicroBfdSessionPathAny {
	return &Bfd_Interface_MicroBfdSessionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"micro-bfd-sessions", "micro-bfd-session"},
			map[string]interface{}{"member-interface": MemberInterface},
			n,
		),
	}
}

// PeerAny (list): Parameters relating to the BFD peer specified by the
// remote address.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "peers/peer"
// Path from root: "/bfd/interfaces/interface/peers/peer"
// LocalDiscriminator (wildcarded): string
func (n *Bfd_InterfacePath) PeerAny() *Bfd_Interface_PeerPathAny {
	return &Bfd_Interface_PeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"peers", "peer"},
			map[string]interface{}{"local-discriminator": "*"},
			n,
		),
	}
}

// PeerAny (list): Parameters relating to the BFD peer specified by the
// remote address.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "peers/peer"
// Path from root: "/bfd/interfaces/interface/peers/peer"
// LocalDiscriminator (wildcarded): string
func (n *Bfd_InterfacePathAny) PeerAny() *Bfd_Interface_PeerPathAny {
	return &Bfd_Interface_PeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"peers", "peer"},
			map[string]interface{}{"local-discriminator": "*"},
			n,
		),
	}
}

// Peer (list): Parameters relating to the BFD peer specified by the
// remote address.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "peers/peer"
// Path from root: "/bfd/interfaces/interface/peers/peer"
// LocalDiscriminator: string
func (n *Bfd_InterfacePath) Peer(LocalDiscriminator string) *Bfd_Interface_PeerPath {
	return &Bfd_Interface_PeerPath{
		NodePath: ygot.NewNodePath(
			[]string{"peers", "peer"},
			map[string]interface{}{"local-discriminator": LocalDiscriminator},
			n,
		),
	}
}

// Peer (list): Parameters relating to the BFD peer specified by the
// remote address.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "peers/peer"
// Path from root: "/bfd/interfaces/interface/peers/peer"
// LocalDiscriminator: string
func (n *Bfd_InterfacePathAny) Peer(LocalDiscriminator string) *Bfd_Interface_PeerPathAny {
	return &Bfd_Interface_PeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"peers", "peer"},
			map[string]interface{}{"local-discriminator": LocalDiscriminator},
			n,
		),
	}
}

// RequiredMinimumReceive (leaf): The minimum interval between received BFD control packets that
// this system should support. This value is advertised to the
// remote peer to indicate the maximum frequency (i.e., minimum
// inter-packet interval) between BFD control packets that is
// acceptable to the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/required-minimum-receive"
// Path from root: "/bfd/interfaces/interface/config/required-minimum-receive"
func (n *Bfd_InterfacePath) RequiredMinimumReceive() *Bfd_Interface_RequiredMinimumReceivePath {
	return &Bfd_Interface_RequiredMinimumReceivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "required-minimum-receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// RequiredMinimumReceive (leaf): The minimum interval between received BFD control packets that
// this system should support. This value is advertised to the
// remote peer to indicate the maximum frequency (i.e., minimum
// inter-packet interval) between BFD control packets that is
// acceptable to the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/required-minimum-receive"
// Path from root: "/bfd/interfaces/interface/config/required-minimum-receive"
func (n *Bfd_InterfacePathAny) RequiredMinimumReceive() *Bfd_Interface_RequiredMinimumReceivePathAny {
	return &Bfd_Interface_RequiredMinimumReceivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "required-minimum-receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bfd_Interface_InterfaceRefPath represents the /openconfig-bfd/bfd/interfaces/interface/interface-ref YANG schema element.
type Bfd_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// Bfd_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/interface-ref YANG schema element.
type Bfd_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_InterfaceRef_InterfacePath represents the /openconfig-bfd/bfd/interfaces/interface/interface-ref/config/interface YANG schema element.
type Bfd_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// Bfd_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/interface-ref/config/interface YANG schema element.
type Bfd_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-bfd/bfd/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type Bfd_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// Bfd_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type Bfd_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/interface"
// Path from root: "/bfd/interfaces/interface/interface-ref/config/interface"
func (n *Bfd_Interface_InterfaceRefPath) Interface() *Bfd_Interface_InterfaceRef_InterfacePath {
	return &Bfd_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/interface"
// Path from root: "/bfd/interfaces/interface/interface-ref/config/interface"
func (n *Bfd_Interface_InterfaceRefPathAny) Interface() *Bfd_Interface_InterfaceRef_InterfacePathAny {
	return &Bfd_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/subinterface"
// Path from root: "/bfd/interfaces/interface/interface-ref/config/subinterface"
func (n *Bfd_Interface_InterfaceRefPath) Subinterface() *Bfd_Interface_InterfaceRef_SubinterfacePath {
	return &Bfd_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/subinterface"
// Path from root: "/bfd/interfaces/interface/interface-ref/config/subinterface"
func (n *Bfd_Interface_InterfaceRefPathAny) Subinterface() *Bfd_Interface_InterfaceRef_SubinterfacePathAny {
	return &Bfd_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bfd_Interface_MicroBfdSessionPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session YANG schema element.
type Bfd_Interface_MicroBfdSessionPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSessionPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session YANG schema element.
type Bfd_Interface_MicroBfdSessionPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_DemandModeRequestedPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/demand-mode-requested YANG schema element.
type Bfd_Interface_MicroBfdSession_DemandModeRequestedPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_DemandModeRequestedPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/demand-mode-requested YANG schema element.
type Bfd_Interface_MicroBfdSession_DemandModeRequestedPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_FailureTransitionsPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/failure-transitions YANG schema element.
type Bfd_Interface_MicroBfdSession_FailureTransitionsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_FailureTransitionsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/failure-transitions YANG schema element.
type Bfd_Interface_MicroBfdSession_FailureTransitionsPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_LastFailureTimePath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/last-failure-time YANG schema element.
type Bfd_Interface_MicroBfdSession_LastFailureTimePath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_LastFailureTimePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/last-failure-time YANG schema element.
type Bfd_Interface_MicroBfdSession_LastFailureTimePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_LocalAddressPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/local-address YANG schema element.
type Bfd_Interface_MicroBfdSession_LocalAddressPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_LocalAddressPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/local-address YANG schema element.
type Bfd_Interface_MicroBfdSession_LocalAddressPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_LocalDiagnosticCodePath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/local-diagnostic-code YANG schema element.
type Bfd_Interface_MicroBfdSession_LocalDiagnosticCodePath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_LocalDiagnosticCodePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/local-diagnostic-code YANG schema element.
type Bfd_Interface_MicroBfdSession_LocalDiagnosticCodePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_LocalDiscriminatorPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/local-discriminator YANG schema element.
type Bfd_Interface_MicroBfdSession_LocalDiscriminatorPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_LocalDiscriminatorPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/local-discriminator YANG schema element.
type Bfd_Interface_MicroBfdSession_LocalDiscriminatorPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_MemberInterfacePath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/member-interface YANG schema element.
type Bfd_Interface_MicroBfdSession_MemberInterfacePath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_MemberInterfacePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/member-interface YANG schema element.
type Bfd_Interface_MicroBfdSession_MemberInterfacePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteAddressPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/remote-address YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteAddressPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteAddressPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/remote-address YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteAddressPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteAuthenticationEnabledPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-authentication-enabled YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteAuthenticationEnabledPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteAuthenticationEnabledPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-authentication-enabled YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteAuthenticationEnabledPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteControlPlaneIndependentPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-control-plane-independent YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteControlPlaneIndependentPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteControlPlaneIndependentPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-control-plane-independent YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteControlPlaneIndependentPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteDiagnosticCodePath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-diagnostic-code YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteDiagnosticCodePath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteDiagnosticCodePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-diagnostic-code YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteDiagnosticCodePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteDiscriminatorPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-discriminator YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteDiscriminatorPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteDiscriminatorPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-discriminator YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteDiscriminatorPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteMinimumReceiveIntervalPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-minimum-receive-interval YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteMinimumReceiveIntervalPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteMinimumReceiveIntervalPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-minimum-receive-interval YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteMinimumReceiveIntervalPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteSessionStatePath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-session-state YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteSessionStatePath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_RemoteSessionStatePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-session-state YANG schema element.
type Bfd_Interface_MicroBfdSession_RemoteSessionStatePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_SessionStatePath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/session-state YANG schema element.
type Bfd_Interface_MicroBfdSession_SessionStatePath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_SessionStatePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/session-state YANG schema element.
type Bfd_Interface_MicroBfdSession_SessionStatePathAny struct {
	*ygot.NodePath
}

// Async (container): Operational state parameters specifically relating to
// asynchronous mode of BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/async"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async"
func (n *Bfd_Interface_MicroBfdSessionPath) Async() *Bfd_Interface_MicroBfdSession_AsyncPath {
	return &Bfd_Interface_MicroBfdSession_AsyncPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "async"},
			map[string]interface{}{},
			n,
		),
	}
}

// Async (container): Operational state parameters specifically relating to
// asynchronous mode of BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/async"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async"
func (n *Bfd_Interface_MicroBfdSessionPathAny) Async() *Bfd_Interface_MicroBfdSession_AsyncPathAny {
	return &Bfd_Interface_MicroBfdSession_AsyncPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "async"},
			map[string]interface{}{},
			n,
		),
	}
}

// DemandModeRequested (leaf): This leaf is set to true when the remote system has requested
// demand mode be run for this session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/demand-mode-requested"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/demand-mode-requested"
func (n *Bfd_Interface_MicroBfdSessionPath) DemandModeRequested() *Bfd_Interface_MicroBfdSession_DemandModeRequestedPath {
	return &Bfd_Interface_MicroBfdSession_DemandModeRequestedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "demand-mode-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// DemandModeRequested (leaf): This leaf is set to true when the remote system has requested
// demand mode be run for this session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/demand-mode-requested"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/demand-mode-requested"
func (n *Bfd_Interface_MicroBfdSessionPathAny) DemandModeRequested() *Bfd_Interface_MicroBfdSession_DemandModeRequestedPathAny {
	return &Bfd_Interface_MicroBfdSession_DemandModeRequestedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "demand-mode-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// FailureTransitions (leaf): The number of times that the BFD session has transitioned
// out of the UP state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/failure-transitions"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/failure-transitions"
func (n *Bfd_Interface_MicroBfdSessionPath) FailureTransitions() *Bfd_Interface_MicroBfdSession_FailureTransitionsPath {
	return &Bfd_Interface_MicroBfdSession_FailureTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "failure-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// FailureTransitions (leaf): The number of times that the BFD session has transitioned
// out of the UP state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/failure-transitions"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/failure-transitions"
func (n *Bfd_Interface_MicroBfdSessionPathAny) FailureTransitions() *Bfd_Interface_MicroBfdSession_FailureTransitionsPathAny {
	return &Bfd_Interface_MicroBfdSession_FailureTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "failure-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastFailureTime (leaf): The time of the last transition of the BFD session out of
// the UP state, expressed as the number of nanoseconds since
// the Unix epoch.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/last-failure-time"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/last-failure-time"
func (n *Bfd_Interface_MicroBfdSessionPath) LastFailureTime() *Bfd_Interface_MicroBfdSession_LastFailureTimePath {
	return &Bfd_Interface_MicroBfdSession_LastFailureTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-failure-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastFailureTime (leaf): The time of the last transition of the BFD session out of
// the UP state, expressed as the number of nanoseconds since
// the Unix epoch.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/last-failure-time"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/last-failure-time"
func (n *Bfd_Interface_MicroBfdSessionPathAny) LastFailureTime() *Bfd_Interface_MicroBfdSession_LastFailureTimePathAny {
	return &Bfd_Interface_MicroBfdSession_LastFailureTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-failure-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): The local IP address used by the system for the micro-BFD session
// specified.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/local-address"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/local-address"
func (n *Bfd_Interface_MicroBfdSessionPath) LocalAddress() *Bfd_Interface_MicroBfdSession_LocalAddressPath {
	return &Bfd_Interface_MicroBfdSession_LocalAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): The local IP address used by the system for the micro-BFD session
// specified.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/local-address"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/local-address"
func (n *Bfd_Interface_MicroBfdSessionPathAny) LocalAddress() *Bfd_Interface_MicroBfdSession_LocalAddressPathAny {
	return &Bfd_Interface_MicroBfdSession_LocalAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalDiagnosticCode (leaf): The local BFD diagnostic code indicating the most recent
// reason for failure of this BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-diagnostic-code"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/local-diagnostic-code"
func (n *Bfd_Interface_MicroBfdSessionPath) LocalDiagnosticCode() *Bfd_Interface_MicroBfdSession_LocalDiagnosticCodePath {
	return &Bfd_Interface_MicroBfdSession_LocalDiagnosticCodePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-diagnostic-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalDiagnosticCode (leaf): The local BFD diagnostic code indicating the most recent
// reason for failure of this BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-diagnostic-code"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/local-diagnostic-code"
func (n *Bfd_Interface_MicroBfdSessionPathAny) LocalDiagnosticCode() *Bfd_Interface_MicroBfdSession_LocalDiagnosticCodePathAny {
	return &Bfd_Interface_MicroBfdSession_LocalDiagnosticCodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-diagnostic-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalDiscriminator (leaf): A unique identifier used by the local system to identify this
// BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-discriminator"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/local-discriminator"
func (n *Bfd_Interface_MicroBfdSessionPath) LocalDiscriminator() *Bfd_Interface_MicroBfdSession_LocalDiscriminatorPath {
	return &Bfd_Interface_MicroBfdSession_LocalDiscriminatorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalDiscriminator (leaf): A unique identifier used by the local system to identify this
// BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-discriminator"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/local-discriminator"
func (n *Bfd_Interface_MicroBfdSessionPathAny) LocalDiscriminator() *Bfd_Interface_MicroBfdSession_LocalDiscriminatorPathAny {
	return &Bfd_Interface_MicroBfdSession_LocalDiscriminatorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// MemberInterface (leaf): Reference to a member link of the aggregate interface being
// described.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/member-interface"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/member-interface"
func (n *Bfd_Interface_MicroBfdSessionPath) MemberInterface() *Bfd_Interface_MicroBfdSession_MemberInterfacePath {
	return &Bfd_Interface_MicroBfdSession_MemberInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "member-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// MemberInterface (leaf): Reference to a member link of the aggregate interface being
// described.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/member-interface"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/member-interface"
func (n *Bfd_Interface_MicroBfdSessionPathAny) MemberInterface() *Bfd_Interface_MicroBfdSession_MemberInterfacePathAny {
	return &Bfd_Interface_MicroBfdSession_MemberInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "member-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): The remote IP destination that should be used by the system for
// the micro-BFD session specified.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/remote-address"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/remote-address"
func (n *Bfd_Interface_MicroBfdSessionPath) RemoteAddress() *Bfd_Interface_MicroBfdSession_RemoteAddressPath {
	return &Bfd_Interface_MicroBfdSession_RemoteAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): The remote IP destination that should be used by the system for
// the micro-BFD session specified.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "config/remote-address"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/config/remote-address"
func (n *Bfd_Interface_MicroBfdSessionPathAny) RemoteAddress() *Bfd_Interface_MicroBfdSession_RemoteAddressPathAny {
	return &Bfd_Interface_MicroBfdSession_RemoteAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAuthenticationEnabled (leaf): This leaf is set to true when the remote system has specified
// that authentication is present for the BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-authentication-enabled"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-authentication-enabled"
func (n *Bfd_Interface_MicroBfdSessionPath) RemoteAuthenticationEnabled() *Bfd_Interface_MicroBfdSession_RemoteAuthenticationEnabledPath {
	return &Bfd_Interface_MicroBfdSession_RemoteAuthenticationEnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-authentication-enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAuthenticationEnabled (leaf): This leaf is set to true when the remote system has specified
// that authentication is present for the BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-authentication-enabled"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-authentication-enabled"
func (n *Bfd_Interface_MicroBfdSessionPathAny) RemoteAuthenticationEnabled() *Bfd_Interface_MicroBfdSession_RemoteAuthenticationEnabledPathAny {
	return &Bfd_Interface_MicroBfdSession_RemoteAuthenticationEnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-authentication-enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteControlPlaneIndependent (leaf): This leaf is set to true when the remote system has specified
// that the hardware implementing this BFD session is independent
// of the control plane's liveliness.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-control-plane-independent"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-control-plane-independent"
func (n *Bfd_Interface_MicroBfdSessionPath) RemoteControlPlaneIndependent() *Bfd_Interface_MicroBfdSession_RemoteControlPlaneIndependentPath {
	return &Bfd_Interface_MicroBfdSession_RemoteControlPlaneIndependentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-control-plane-independent"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteControlPlaneIndependent (leaf): This leaf is set to true when the remote system has specified
// that the hardware implementing this BFD session is independent
// of the control plane's liveliness.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-control-plane-independent"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-control-plane-independent"
func (n *Bfd_Interface_MicroBfdSessionPathAny) RemoteControlPlaneIndependent() *Bfd_Interface_MicroBfdSession_RemoteControlPlaneIndependentPathAny {
	return &Bfd_Interface_MicroBfdSession_RemoteControlPlaneIndependentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-control-plane-independent"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteDiagnosticCode (leaf): The remote BFD diagnostic code indicating the remote system's
// reason for failure of the BFD session
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-diagnostic-code"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-diagnostic-code"
func (n *Bfd_Interface_MicroBfdSessionPath) RemoteDiagnosticCode() *Bfd_Interface_MicroBfdSession_RemoteDiagnosticCodePath {
	return &Bfd_Interface_MicroBfdSession_RemoteDiagnosticCodePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-diagnostic-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteDiagnosticCode (leaf): The remote BFD diagnostic code indicating the remote system's
// reason for failure of the BFD session
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-diagnostic-code"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-diagnostic-code"
func (n *Bfd_Interface_MicroBfdSessionPathAny) RemoteDiagnosticCode() *Bfd_Interface_MicroBfdSession_RemoteDiagnosticCodePathAny {
	return &Bfd_Interface_MicroBfdSession_RemoteDiagnosticCodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-diagnostic-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteDiscriminator (leaf): A unique identified used by the remote system to identify this
// BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-discriminator"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-discriminator"
func (n *Bfd_Interface_MicroBfdSessionPath) RemoteDiscriminator() *Bfd_Interface_MicroBfdSession_RemoteDiscriminatorPath {
	return &Bfd_Interface_MicroBfdSession_RemoteDiscriminatorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteDiscriminator (leaf): A unique identified used by the remote system to identify this
// BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-discriminator"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-discriminator"
func (n *Bfd_Interface_MicroBfdSessionPathAny) RemoteDiscriminator() *Bfd_Interface_MicroBfdSession_RemoteDiscriminatorPathAny {
	return &Bfd_Interface_MicroBfdSession_RemoteDiscriminatorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteMinimumReceiveInterval (leaf): The value of the minimum receive interval that was specified
// in the most recent BFD control packet received from the peer.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-minimum-receive-interval"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-minimum-receive-interval"
func (n *Bfd_Interface_MicroBfdSessionPath) RemoteMinimumReceiveInterval() *Bfd_Interface_MicroBfdSession_RemoteMinimumReceiveIntervalPath {
	return &Bfd_Interface_MicroBfdSession_RemoteMinimumReceiveIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-minimum-receive-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteMinimumReceiveInterval (leaf): The value of the minimum receive interval that was specified
// in the most recent BFD control packet received from the peer.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-minimum-receive-interval"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-minimum-receive-interval"
func (n *Bfd_Interface_MicroBfdSessionPathAny) RemoteMinimumReceiveInterval() *Bfd_Interface_MicroBfdSession_RemoteMinimumReceiveIntervalPathAny {
	return &Bfd_Interface_MicroBfdSession_RemoteMinimumReceiveIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-minimum-receive-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteSessionState (leaf): The reported state of the BFD session according to the remote
// system. This state reflects the last state reported in a BFD
// control packet.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-session-state"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-session-state"
func (n *Bfd_Interface_MicroBfdSessionPath) RemoteSessionState() *Bfd_Interface_MicroBfdSession_RemoteSessionStatePath {
	return &Bfd_Interface_MicroBfdSession_RemoteSessionStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteSessionState (leaf): The reported state of the BFD session according to the remote
// system. This state reflects the last state reported in a BFD
// control packet.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-session-state"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/remote-session-state"
func (n *Bfd_Interface_MicroBfdSessionPathAny) RemoteSessionState() *Bfd_Interface_MicroBfdSession_RemoteSessionStatePathAny {
	return &Bfd_Interface_MicroBfdSession_RemoteSessionStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionState (leaf): The state of the BFD session perceived by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/session-state"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/session-state"
func (n *Bfd_Interface_MicroBfdSessionPath) SessionState() *Bfd_Interface_MicroBfdSession_SessionStatePath {
	return &Bfd_Interface_MicroBfdSession_SessionStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionState (leaf): The state of the BFD session perceived by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/session-state"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/session-state"
func (n *Bfd_Interface_MicroBfdSessionPathAny) SessionState() *Bfd_Interface_MicroBfdSession_SessionStatePathAny {
	return &Bfd_Interface_MicroBfdSession_SessionStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bfd_Interface_MicroBfdSession_AsyncPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async YANG schema element.
type Bfd_Interface_MicroBfdSession_AsyncPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_AsyncPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async YANG schema element.
type Bfd_Interface_MicroBfdSession_AsyncPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_LastPacketReceivedPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/last-packet-received YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_LastPacketReceivedPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_LastPacketReceivedPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/last-packet-received YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_LastPacketReceivedPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_LastPacketTransmittedPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/last-packet-transmitted YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_LastPacketTransmittedPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_LastPacketTransmittedPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/last-packet-transmitted YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_LastPacketTransmittedPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_ReceivedPacketsPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/received-packets YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_ReceivedPacketsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_ReceivedPacketsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/received-packets YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_ReceivedPacketsPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_TransmittedPacketsPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/transmitted-packets YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_TransmittedPacketsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_TransmittedPacketsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/transmitted-packets YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_TransmittedPacketsPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_UpTransitionsPath represents the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/up-transitions YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_UpTransitionsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_MicroBfdSession_Async_UpTransitionsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/up-transitions YANG schema element.
type Bfd_Interface_MicroBfdSession_Async_UpTransitionsPathAny struct {
	*ygot.NodePath
}

// LastPacketReceived (leaf): The date and time at which the last BFD packet
// was received for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-received"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/last-packet-received"
func (n *Bfd_Interface_MicroBfdSession_AsyncPath) LastPacketReceived() *Bfd_Interface_MicroBfdSession_Async_LastPacketReceivedPath {
	return &Bfd_Interface_MicroBfdSession_Async_LastPacketReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketReceived (leaf): The date and time at which the last BFD packet
// was received for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-received"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/last-packet-received"
func (n *Bfd_Interface_MicroBfdSession_AsyncPathAny) LastPacketReceived() *Bfd_Interface_MicroBfdSession_Async_LastPacketReceivedPathAny {
	return &Bfd_Interface_MicroBfdSession_Async_LastPacketReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketTransmitted (leaf): The date and time at which the last BFD packet
// was transmitted for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-transmitted"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/last-packet-transmitted"
func (n *Bfd_Interface_MicroBfdSession_AsyncPath) LastPacketTransmitted() *Bfd_Interface_MicroBfdSession_Async_LastPacketTransmittedPath {
	return &Bfd_Interface_MicroBfdSession_Async_LastPacketTransmittedPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-transmitted"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketTransmitted (leaf): The date and time at which the last BFD packet
// was transmitted for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-transmitted"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/last-packet-transmitted"
func (n *Bfd_Interface_MicroBfdSession_AsyncPathAny) LastPacketTransmitted() *Bfd_Interface_MicroBfdSession_Async_LastPacketTransmittedPathAny {
	return &Bfd_Interface_MicroBfdSession_Async_LastPacketTransmittedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-transmitted"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedPackets (leaf): The number of packets that have been received by the
// local system from the remote neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "received-packets"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/received-packets"
func (n *Bfd_Interface_MicroBfdSession_AsyncPath) ReceivedPackets() *Bfd_Interface_MicroBfdSession_Async_ReceivedPacketsPath {
	return &Bfd_Interface_MicroBfdSession_Async_ReceivedPacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"received-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedPackets (leaf): The number of packets that have been received by the
// local system from the remote neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "received-packets"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/received-packets"
func (n *Bfd_Interface_MicroBfdSession_AsyncPathAny) ReceivedPackets() *Bfd_Interface_MicroBfdSession_Async_ReceivedPacketsPathAny {
	return &Bfd_Interface_MicroBfdSession_Async_ReceivedPacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"received-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmittedPackets (leaf): The number of packets that have been transmitted
// by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "transmitted-packets"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/transmitted-packets"
func (n *Bfd_Interface_MicroBfdSession_AsyncPath) TransmittedPackets() *Bfd_Interface_MicroBfdSession_Async_TransmittedPacketsPath {
	return &Bfd_Interface_MicroBfdSession_Async_TransmittedPacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"transmitted-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmittedPackets (leaf): The number of packets that have been transmitted
// by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "transmitted-packets"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/transmitted-packets"
func (n *Bfd_Interface_MicroBfdSession_AsyncPathAny) TransmittedPackets() *Bfd_Interface_MicroBfdSession_Async_TransmittedPacketsPathAny {
	return &Bfd_Interface_MicroBfdSession_Async_TransmittedPacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transmitted-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpTransitions (leaf): The number of times that the adjacency with the neighbor
// has transitioned into the up state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "up-transitions"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/up-transitions"
func (n *Bfd_Interface_MicroBfdSession_AsyncPath) UpTransitions() *Bfd_Interface_MicroBfdSession_Async_UpTransitionsPath {
	return &Bfd_Interface_MicroBfdSession_Async_UpTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"up-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpTransitions (leaf): The number of times that the adjacency with the neighbor
// has transitioned into the up state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "up-transitions"
// Path from root: "/bfd/interfaces/interface/micro-bfd-sessions/micro-bfd-session/state/async/up-transitions"
func (n *Bfd_Interface_MicroBfdSession_AsyncPathAny) UpTransitions() *Bfd_Interface_MicroBfdSession_Async_UpTransitionsPathAny {
	return &Bfd_Interface_MicroBfdSession_Async_UpTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"up-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bfd_Interface_PeerPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer YANG schema element.
type Bfd_Interface_PeerPath struct {
	*ygot.NodePath
}

// Bfd_Interface_PeerPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer YANG schema element.
type Bfd_Interface_PeerPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_DemandModeRequestedPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/demand-mode-requested YANG schema element.
type Bfd_Interface_Peer_DemandModeRequestedPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_DemandModeRequestedPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/demand-mode-requested YANG schema element.
type Bfd_Interface_Peer_DemandModeRequestedPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_FailureTransitionsPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/failure-transitions YANG schema element.
type Bfd_Interface_Peer_FailureTransitionsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_FailureTransitionsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/failure-transitions YANG schema element.
type Bfd_Interface_Peer_FailureTransitionsPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_LastFailureTimePath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/last-failure-time YANG schema element.
type Bfd_Interface_Peer_LastFailureTimePath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_LastFailureTimePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/last-failure-time YANG schema element.
type Bfd_Interface_Peer_LastFailureTimePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_LocalAddressPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/local-address YANG schema element.
type Bfd_Interface_Peer_LocalAddressPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_LocalAddressPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/local-address YANG schema element.
type Bfd_Interface_Peer_LocalAddressPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_LocalDiagnosticCodePath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/local-diagnostic-code YANG schema element.
type Bfd_Interface_Peer_LocalDiagnosticCodePath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_LocalDiagnosticCodePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/local-diagnostic-code YANG schema element.
type Bfd_Interface_Peer_LocalDiagnosticCodePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_LocalDiscriminatorPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/local-discriminator YANG schema element.
type Bfd_Interface_Peer_LocalDiscriminatorPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_LocalDiscriminatorPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/local-discriminator YANG schema element.
type Bfd_Interface_Peer_LocalDiscriminatorPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteAddressPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-address YANG schema element.
type Bfd_Interface_Peer_RemoteAddressPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteAddressPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-address YANG schema element.
type Bfd_Interface_Peer_RemoteAddressPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteAuthenticationEnabledPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-authentication-enabled YANG schema element.
type Bfd_Interface_Peer_RemoteAuthenticationEnabledPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteAuthenticationEnabledPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-authentication-enabled YANG schema element.
type Bfd_Interface_Peer_RemoteAuthenticationEnabledPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteControlPlaneIndependentPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-control-plane-independent YANG schema element.
type Bfd_Interface_Peer_RemoteControlPlaneIndependentPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteControlPlaneIndependentPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-control-plane-independent YANG schema element.
type Bfd_Interface_Peer_RemoteControlPlaneIndependentPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteDiagnosticCodePath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-diagnostic-code YANG schema element.
type Bfd_Interface_Peer_RemoteDiagnosticCodePath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteDiagnosticCodePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-diagnostic-code YANG schema element.
type Bfd_Interface_Peer_RemoteDiagnosticCodePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteDiscriminatorPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-discriminator YANG schema element.
type Bfd_Interface_Peer_RemoteDiscriminatorPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteDiscriminatorPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-discriminator YANG schema element.
type Bfd_Interface_Peer_RemoteDiscriminatorPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteMinimumReceiveIntervalPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-minimum-receive-interval YANG schema element.
type Bfd_Interface_Peer_RemoteMinimumReceiveIntervalPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteMinimumReceiveIntervalPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-minimum-receive-interval YANG schema element.
type Bfd_Interface_Peer_RemoteMinimumReceiveIntervalPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteSessionStatePath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-session-state YANG schema element.
type Bfd_Interface_Peer_RemoteSessionStatePath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_RemoteSessionStatePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/remote-session-state YANG schema element.
type Bfd_Interface_Peer_RemoteSessionStatePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_SessionStatePath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/session-state YANG schema element.
type Bfd_Interface_Peer_SessionStatePath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_SessionStatePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/session-state YANG schema element.
type Bfd_Interface_Peer_SessionStatePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_SubscribedProtocolsPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/subscribed-protocols YANG schema element.
type Bfd_Interface_Peer_SubscribedProtocolsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_SubscribedProtocolsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/subscribed-protocols YANG schema element.
type Bfd_Interface_Peer_SubscribedProtocolsPathAny struct {
	*ygot.NodePath
}

// Async (container): Operational state parameters specifically relating to
// asynchronous mode of BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/async"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async"
func (n *Bfd_Interface_PeerPath) Async() *Bfd_Interface_Peer_AsyncPath {
	return &Bfd_Interface_Peer_AsyncPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "async"},
			map[string]interface{}{},
			n,
		),
	}
}

// Async (container): Operational state parameters specifically relating to
// asynchronous mode of BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/async"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async"
func (n *Bfd_Interface_PeerPathAny) Async() *Bfd_Interface_Peer_AsyncPathAny {
	return &Bfd_Interface_Peer_AsyncPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "async"},
			map[string]interface{}{},
			n,
		),
	}
}

// DemandModeRequested (leaf): This leaf is set to true when the remote system has requested
// demand mode be run for this session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/demand-mode-requested"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/demand-mode-requested"
func (n *Bfd_Interface_PeerPath) DemandModeRequested() *Bfd_Interface_Peer_DemandModeRequestedPath {
	return &Bfd_Interface_Peer_DemandModeRequestedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "demand-mode-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// DemandModeRequested (leaf): This leaf is set to true when the remote system has requested
// demand mode be run for this session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/demand-mode-requested"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/demand-mode-requested"
func (n *Bfd_Interface_PeerPathAny) DemandModeRequested() *Bfd_Interface_Peer_DemandModeRequestedPathAny {
	return &Bfd_Interface_Peer_DemandModeRequestedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "demand-mode-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// Echo (container): Operational state parameters specifically relating to the
// echo mode of BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/echo"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo"
func (n *Bfd_Interface_PeerPath) Echo() *Bfd_Interface_Peer_EchoPath {
	return &Bfd_Interface_Peer_EchoPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "echo"},
			map[string]interface{}{},
			n,
		),
	}
}

// Echo (container): Operational state parameters specifically relating to the
// echo mode of BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/echo"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo"
func (n *Bfd_Interface_PeerPathAny) Echo() *Bfd_Interface_Peer_EchoPathAny {
	return &Bfd_Interface_Peer_EchoPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "echo"},
			map[string]interface{}{},
			n,
		),
	}
}

// FailureTransitions (leaf): The number of times that the BFD session has transitioned
// out of the UP state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/failure-transitions"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/failure-transitions"
func (n *Bfd_Interface_PeerPath) FailureTransitions() *Bfd_Interface_Peer_FailureTransitionsPath {
	return &Bfd_Interface_Peer_FailureTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "failure-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// FailureTransitions (leaf): The number of times that the BFD session has transitioned
// out of the UP state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/failure-transitions"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/failure-transitions"
func (n *Bfd_Interface_PeerPathAny) FailureTransitions() *Bfd_Interface_Peer_FailureTransitionsPathAny {
	return &Bfd_Interface_Peer_FailureTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "failure-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastFailureTime (leaf): The time of the last transition of the BFD session out of
// the UP state, expressed as the number of nanoseconds since
// the Unix epoch.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/last-failure-time"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/last-failure-time"
func (n *Bfd_Interface_PeerPath) LastFailureTime() *Bfd_Interface_Peer_LastFailureTimePath {
	return &Bfd_Interface_Peer_LastFailureTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-failure-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastFailureTime (leaf): The time of the last transition of the BFD session out of
// the UP state, expressed as the number of nanoseconds since
// the Unix epoch.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/last-failure-time"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/last-failure-time"
func (n *Bfd_Interface_PeerPathAny) LastFailureTime() *Bfd_Interface_Peer_LastFailureTimePathAny {
	return &Bfd_Interface_Peer_LastFailureTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-failure-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): The IP address used by the local system for this BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-address"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/local-address"
func (n *Bfd_Interface_PeerPath) LocalAddress() *Bfd_Interface_Peer_LocalAddressPath {
	return &Bfd_Interface_Peer_LocalAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): The IP address used by the local system for this BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-address"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/local-address"
func (n *Bfd_Interface_PeerPathAny) LocalAddress() *Bfd_Interface_Peer_LocalAddressPathAny {
	return &Bfd_Interface_Peer_LocalAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalDiagnosticCode (leaf): The local BFD diagnostic code indicating the most recent
// reason for failure of this BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-diagnostic-code"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/local-diagnostic-code"
func (n *Bfd_Interface_PeerPath) LocalDiagnosticCode() *Bfd_Interface_Peer_LocalDiagnosticCodePath {
	return &Bfd_Interface_Peer_LocalDiagnosticCodePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-diagnostic-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalDiagnosticCode (leaf): The local BFD diagnostic code indicating the most recent
// reason for failure of this BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-diagnostic-code"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/local-diagnostic-code"
func (n *Bfd_Interface_PeerPathAny) LocalDiagnosticCode() *Bfd_Interface_Peer_LocalDiagnosticCodePathAny {
	return &Bfd_Interface_Peer_LocalDiagnosticCodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-diagnostic-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalDiscriminator (leaf): A unique identifier used by the local system to identify this
// BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-discriminator"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/local-discriminator"
func (n *Bfd_Interface_PeerPath) LocalDiscriminator() *Bfd_Interface_Peer_LocalDiscriminatorPath {
	return &Bfd_Interface_Peer_LocalDiscriminatorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalDiscriminator (leaf): A unique identifier used by the local system to identify this
// BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/local-discriminator"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/local-discriminator"
func (n *Bfd_Interface_PeerPathAny) LocalDiscriminator() *Bfd_Interface_Peer_LocalDiscriminatorPathAny {
	return &Bfd_Interface_Peer_LocalDiscriminatorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): The IP address used by the remote system for this BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-address"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-address"
func (n *Bfd_Interface_PeerPath) RemoteAddress() *Bfd_Interface_Peer_RemoteAddressPath {
	return &Bfd_Interface_Peer_RemoteAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): The IP address used by the remote system for this BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-address"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-address"
func (n *Bfd_Interface_PeerPathAny) RemoteAddress() *Bfd_Interface_Peer_RemoteAddressPathAny {
	return &Bfd_Interface_Peer_RemoteAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAuthenticationEnabled (leaf): This leaf is set to true when the remote system has specified
// that authentication is present for the BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-authentication-enabled"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-authentication-enabled"
func (n *Bfd_Interface_PeerPath) RemoteAuthenticationEnabled() *Bfd_Interface_Peer_RemoteAuthenticationEnabledPath {
	return &Bfd_Interface_Peer_RemoteAuthenticationEnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-authentication-enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAuthenticationEnabled (leaf): This leaf is set to true when the remote system has specified
// that authentication is present for the BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-authentication-enabled"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-authentication-enabled"
func (n *Bfd_Interface_PeerPathAny) RemoteAuthenticationEnabled() *Bfd_Interface_Peer_RemoteAuthenticationEnabledPathAny {
	return &Bfd_Interface_Peer_RemoteAuthenticationEnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-authentication-enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteControlPlaneIndependent (leaf): This leaf is set to true when the remote system has specified
// that the hardware implementing this BFD session is independent
// of the control plane's liveliness.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-control-plane-independent"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-control-plane-independent"
func (n *Bfd_Interface_PeerPath) RemoteControlPlaneIndependent() *Bfd_Interface_Peer_RemoteControlPlaneIndependentPath {
	return &Bfd_Interface_Peer_RemoteControlPlaneIndependentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-control-plane-independent"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteControlPlaneIndependent (leaf): This leaf is set to true when the remote system has specified
// that the hardware implementing this BFD session is independent
// of the control plane's liveliness.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-control-plane-independent"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-control-plane-independent"
func (n *Bfd_Interface_PeerPathAny) RemoteControlPlaneIndependent() *Bfd_Interface_Peer_RemoteControlPlaneIndependentPathAny {
	return &Bfd_Interface_Peer_RemoteControlPlaneIndependentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-control-plane-independent"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteDiagnosticCode (leaf): The remote BFD diagnostic code indicating the remote system's
// reason for failure of the BFD session
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-diagnostic-code"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-diagnostic-code"
func (n *Bfd_Interface_PeerPath) RemoteDiagnosticCode() *Bfd_Interface_Peer_RemoteDiagnosticCodePath {
	return &Bfd_Interface_Peer_RemoteDiagnosticCodePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-diagnostic-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteDiagnosticCode (leaf): The remote BFD diagnostic code indicating the remote system's
// reason for failure of the BFD session
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-diagnostic-code"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-diagnostic-code"
func (n *Bfd_Interface_PeerPathAny) RemoteDiagnosticCode() *Bfd_Interface_Peer_RemoteDiagnosticCodePathAny {
	return &Bfd_Interface_Peer_RemoteDiagnosticCodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-diagnostic-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteDiscriminator (leaf): A unique identified used by the remote system to identify this
// BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-discriminator"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-discriminator"
func (n *Bfd_Interface_PeerPath) RemoteDiscriminator() *Bfd_Interface_Peer_RemoteDiscriminatorPath {
	return &Bfd_Interface_Peer_RemoteDiscriminatorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteDiscriminator (leaf): A unique identified used by the remote system to identify this
// BFD session.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-discriminator"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-discriminator"
func (n *Bfd_Interface_PeerPathAny) RemoteDiscriminator() *Bfd_Interface_Peer_RemoteDiscriminatorPathAny {
	return &Bfd_Interface_Peer_RemoteDiscriminatorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteMinimumReceiveInterval (leaf): The value of the minimum receive interval that was specified
// in the most recent BFD control packet received from the peer.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-minimum-receive-interval"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-minimum-receive-interval"
func (n *Bfd_Interface_PeerPath) RemoteMinimumReceiveInterval() *Bfd_Interface_Peer_RemoteMinimumReceiveIntervalPath {
	return &Bfd_Interface_Peer_RemoteMinimumReceiveIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-minimum-receive-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteMinimumReceiveInterval (leaf): The value of the minimum receive interval that was specified
// in the most recent BFD control packet received from the peer.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-minimum-receive-interval"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-minimum-receive-interval"
func (n *Bfd_Interface_PeerPathAny) RemoteMinimumReceiveInterval() *Bfd_Interface_Peer_RemoteMinimumReceiveIntervalPathAny {
	return &Bfd_Interface_Peer_RemoteMinimumReceiveIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-minimum-receive-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteSessionState (leaf): The reported state of the BFD session according to the remote
// system. This state reflects the last state reported in a BFD
// control packet.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-session-state"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-session-state"
func (n *Bfd_Interface_PeerPath) RemoteSessionState() *Bfd_Interface_Peer_RemoteSessionStatePath {
	return &Bfd_Interface_Peer_RemoteSessionStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteSessionState (leaf): The reported state of the BFD session according to the remote
// system. This state reflects the last state reported in a BFD
// control packet.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/remote-session-state"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/remote-session-state"
func (n *Bfd_Interface_PeerPathAny) RemoteSessionState() *Bfd_Interface_Peer_RemoteSessionStatePathAny {
	return &Bfd_Interface_Peer_RemoteSessionStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionState (leaf): The state of the BFD session perceived by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/session-state"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/session-state"
func (n *Bfd_Interface_PeerPath) SessionState() *Bfd_Interface_Peer_SessionStatePath {
	return &Bfd_Interface_Peer_SessionStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionState (leaf): The state of the BFD session perceived by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/session-state"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/session-state"
func (n *Bfd_Interface_PeerPathAny) SessionState() *Bfd_Interface_Peer_SessionStatePathAny {
	return &Bfd_Interface_Peer_SessionStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubscribedProtocols (leaf): Indicates the set of protocols that currently use
// this BFD session for liveliness detection.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/subscribed-protocols"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/subscribed-protocols"
func (n *Bfd_Interface_PeerPath) SubscribedProtocols() *Bfd_Interface_Peer_SubscribedProtocolsPath {
	return &Bfd_Interface_Peer_SubscribedProtocolsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subscribed-protocols"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubscribedProtocols (leaf): Indicates the set of protocols that currently use
// this BFD session for liveliness detection.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "state/subscribed-protocols"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/subscribed-protocols"
func (n *Bfd_Interface_PeerPathAny) SubscribedProtocols() *Bfd_Interface_Peer_SubscribedProtocolsPathAny {
	return &Bfd_Interface_Peer_SubscribedProtocolsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subscribed-protocols"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bfd_Interface_Peer_AsyncPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async YANG schema element.
type Bfd_Interface_Peer_AsyncPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_AsyncPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async YANG schema element.
type Bfd_Interface_Peer_AsyncPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_LastPacketReceivedPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/last-packet-received YANG schema element.
type Bfd_Interface_Peer_Async_LastPacketReceivedPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_LastPacketReceivedPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/last-packet-received YANG schema element.
type Bfd_Interface_Peer_Async_LastPacketReceivedPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_LastPacketTransmittedPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/last-packet-transmitted YANG schema element.
type Bfd_Interface_Peer_Async_LastPacketTransmittedPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_LastPacketTransmittedPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/last-packet-transmitted YANG schema element.
type Bfd_Interface_Peer_Async_LastPacketTransmittedPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_ReceivedPacketsPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/received-packets YANG schema element.
type Bfd_Interface_Peer_Async_ReceivedPacketsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_ReceivedPacketsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/received-packets YANG schema element.
type Bfd_Interface_Peer_Async_ReceivedPacketsPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_TransmittedPacketsPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/transmitted-packets YANG schema element.
type Bfd_Interface_Peer_Async_TransmittedPacketsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_TransmittedPacketsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/transmitted-packets YANG schema element.
type Bfd_Interface_Peer_Async_TransmittedPacketsPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_UpTransitionsPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/up-transitions YANG schema element.
type Bfd_Interface_Peer_Async_UpTransitionsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Async_UpTransitionsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/async/up-transitions YANG schema element.
type Bfd_Interface_Peer_Async_UpTransitionsPathAny struct {
	*ygot.NodePath
}

// LastPacketReceived (leaf): The date and time at which the last BFD packet
// was received for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-received"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/last-packet-received"
func (n *Bfd_Interface_Peer_AsyncPath) LastPacketReceived() *Bfd_Interface_Peer_Async_LastPacketReceivedPath {
	return &Bfd_Interface_Peer_Async_LastPacketReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketReceived (leaf): The date and time at which the last BFD packet
// was received for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-received"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/last-packet-received"
func (n *Bfd_Interface_Peer_AsyncPathAny) LastPacketReceived() *Bfd_Interface_Peer_Async_LastPacketReceivedPathAny {
	return &Bfd_Interface_Peer_Async_LastPacketReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketTransmitted (leaf): The date and time at which the last BFD packet
// was transmitted for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-transmitted"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/last-packet-transmitted"
func (n *Bfd_Interface_Peer_AsyncPath) LastPacketTransmitted() *Bfd_Interface_Peer_Async_LastPacketTransmittedPath {
	return &Bfd_Interface_Peer_Async_LastPacketTransmittedPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-transmitted"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketTransmitted (leaf): The date and time at which the last BFD packet
// was transmitted for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-transmitted"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/last-packet-transmitted"
func (n *Bfd_Interface_Peer_AsyncPathAny) LastPacketTransmitted() *Bfd_Interface_Peer_Async_LastPacketTransmittedPathAny {
	return &Bfd_Interface_Peer_Async_LastPacketTransmittedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-transmitted"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedPackets (leaf): The number of packets that have been received by the
// local system from the remote neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "received-packets"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/received-packets"
func (n *Bfd_Interface_Peer_AsyncPath) ReceivedPackets() *Bfd_Interface_Peer_Async_ReceivedPacketsPath {
	return &Bfd_Interface_Peer_Async_ReceivedPacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"received-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedPackets (leaf): The number of packets that have been received by the
// local system from the remote neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "received-packets"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/received-packets"
func (n *Bfd_Interface_Peer_AsyncPathAny) ReceivedPackets() *Bfd_Interface_Peer_Async_ReceivedPacketsPathAny {
	return &Bfd_Interface_Peer_Async_ReceivedPacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"received-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmittedPackets (leaf): The number of packets that have been transmitted
// by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "transmitted-packets"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/transmitted-packets"
func (n *Bfd_Interface_Peer_AsyncPath) TransmittedPackets() *Bfd_Interface_Peer_Async_TransmittedPacketsPath {
	return &Bfd_Interface_Peer_Async_TransmittedPacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"transmitted-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmittedPackets (leaf): The number of packets that have been transmitted
// by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "transmitted-packets"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/transmitted-packets"
func (n *Bfd_Interface_Peer_AsyncPathAny) TransmittedPackets() *Bfd_Interface_Peer_Async_TransmittedPacketsPathAny {
	return &Bfd_Interface_Peer_Async_TransmittedPacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transmitted-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpTransitions (leaf): The number of times that the adjacency with the neighbor
// has transitioned into the up state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "up-transitions"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/up-transitions"
func (n *Bfd_Interface_Peer_AsyncPath) UpTransitions() *Bfd_Interface_Peer_Async_UpTransitionsPath {
	return &Bfd_Interface_Peer_Async_UpTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"up-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpTransitions (leaf): The number of times that the adjacency with the neighbor
// has transitioned into the up state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "up-transitions"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/async/up-transitions"
func (n *Bfd_Interface_Peer_AsyncPathAny) UpTransitions() *Bfd_Interface_Peer_Async_UpTransitionsPathAny {
	return &Bfd_Interface_Peer_Async_UpTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"up-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bfd_Interface_Peer_EchoPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo YANG schema element.
type Bfd_Interface_Peer_EchoPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_EchoPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo YANG schema element.
type Bfd_Interface_Peer_EchoPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_ActivePath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/active YANG schema element.
type Bfd_Interface_Peer_Echo_ActivePath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_ActivePathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/active YANG schema element.
type Bfd_Interface_Peer_Echo_ActivePathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_LastPacketReceivedPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/last-packet-received YANG schema element.
type Bfd_Interface_Peer_Echo_LastPacketReceivedPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_LastPacketReceivedPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/last-packet-received YANG schema element.
type Bfd_Interface_Peer_Echo_LastPacketReceivedPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_LastPacketTransmittedPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/last-packet-transmitted YANG schema element.
type Bfd_Interface_Peer_Echo_LastPacketTransmittedPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_LastPacketTransmittedPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/last-packet-transmitted YANG schema element.
type Bfd_Interface_Peer_Echo_LastPacketTransmittedPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_ReceivedPacketsPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/received-packets YANG schema element.
type Bfd_Interface_Peer_Echo_ReceivedPacketsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_ReceivedPacketsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/received-packets YANG schema element.
type Bfd_Interface_Peer_Echo_ReceivedPacketsPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_TransmittedPacketsPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/transmitted-packets YANG schema element.
type Bfd_Interface_Peer_Echo_TransmittedPacketsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_TransmittedPacketsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/transmitted-packets YANG schema element.
type Bfd_Interface_Peer_Echo_TransmittedPacketsPathAny struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_UpTransitionsPath represents the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/up-transitions YANG schema element.
type Bfd_Interface_Peer_Echo_UpTransitionsPath struct {
	*ygot.NodePath
}

// Bfd_Interface_Peer_Echo_UpTransitionsPathAny represents the wildcard version of the /openconfig-bfd/bfd/interfaces/interface/peers/peer/state/echo/up-transitions YANG schema element.
type Bfd_Interface_Peer_Echo_UpTransitionsPathAny struct {
	*ygot.NodePath
}

// Active (leaf): This leaf is set to true when echo mode is running between
// the local and remote system. When it is set to false, solely
// asynchronous mode is active.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "active"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/active"
func (n *Bfd_Interface_Peer_EchoPath) Active() *Bfd_Interface_Peer_Echo_ActivePath {
	return &Bfd_Interface_Peer_Echo_ActivePath{
		NodePath: ygot.NewNodePath(
			[]string{"active"},
			map[string]interface{}{},
			n,
		),
	}
}

// Active (leaf): This leaf is set to true when echo mode is running between
// the local and remote system. When it is set to false, solely
// asynchronous mode is active.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "active"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/active"
func (n *Bfd_Interface_Peer_EchoPathAny) Active() *Bfd_Interface_Peer_Echo_ActivePathAny {
	return &Bfd_Interface_Peer_Echo_ActivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"active"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketReceived (leaf): The date and time at which the last BFD packet
// was received for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-received"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/last-packet-received"
func (n *Bfd_Interface_Peer_EchoPath) LastPacketReceived() *Bfd_Interface_Peer_Echo_LastPacketReceivedPath {
	return &Bfd_Interface_Peer_Echo_LastPacketReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketReceived (leaf): The date and time at which the last BFD packet
// was received for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-received"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/last-packet-received"
func (n *Bfd_Interface_Peer_EchoPathAny) LastPacketReceived() *Bfd_Interface_Peer_Echo_LastPacketReceivedPathAny {
	return &Bfd_Interface_Peer_Echo_LastPacketReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketTransmitted (leaf): The date and time at which the last BFD packet
// was transmitted for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-transmitted"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/last-packet-transmitted"
func (n *Bfd_Interface_Peer_EchoPath) LastPacketTransmitted() *Bfd_Interface_Peer_Echo_LastPacketTransmittedPath {
	return &Bfd_Interface_Peer_Echo_LastPacketTransmittedPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-transmitted"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPacketTransmitted (leaf): The date and time at which the last BFD packet
// was transmitted for this session, expressed as the number
// of nanoseconds since the Unix Epoch (January 1, 1970,
// 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "last-packet-transmitted"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/last-packet-transmitted"
func (n *Bfd_Interface_Peer_EchoPathAny) LastPacketTransmitted() *Bfd_Interface_Peer_Echo_LastPacketTransmittedPathAny {
	return &Bfd_Interface_Peer_Echo_LastPacketTransmittedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-packet-transmitted"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedPackets (leaf): The number of packets that have been received by the
// local system from the remote neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "received-packets"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/received-packets"
func (n *Bfd_Interface_Peer_EchoPath) ReceivedPackets() *Bfd_Interface_Peer_Echo_ReceivedPacketsPath {
	return &Bfd_Interface_Peer_Echo_ReceivedPacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"received-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedPackets (leaf): The number of packets that have been received by the
// local system from the remote neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "received-packets"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/received-packets"
func (n *Bfd_Interface_Peer_EchoPathAny) ReceivedPackets() *Bfd_Interface_Peer_Echo_ReceivedPacketsPathAny {
	return &Bfd_Interface_Peer_Echo_ReceivedPacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"received-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmittedPackets (leaf): The number of packets that have been transmitted
// by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "transmitted-packets"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/transmitted-packets"
func (n *Bfd_Interface_Peer_EchoPath) TransmittedPackets() *Bfd_Interface_Peer_Echo_TransmittedPacketsPath {
	return &Bfd_Interface_Peer_Echo_TransmittedPacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"transmitted-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmittedPackets (leaf): The number of packets that have been transmitted
// by the local system.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "transmitted-packets"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/transmitted-packets"
func (n *Bfd_Interface_Peer_EchoPathAny) TransmittedPackets() *Bfd_Interface_Peer_Echo_TransmittedPacketsPathAny {
	return &Bfd_Interface_Peer_Echo_TransmittedPacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transmitted-packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpTransitions (leaf): The number of times that the adjacency with the neighbor
// has transitioned into the up state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "up-transitions"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/up-transitions"
func (n *Bfd_Interface_Peer_EchoPath) UpTransitions() *Bfd_Interface_Peer_Echo_UpTransitionsPath {
	return &Bfd_Interface_Peer_Echo_UpTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"up-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpTransitions (leaf): The number of times that the adjacency with the neighbor
// has transitioned into the up state.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "up-transitions"
// Path from root: "/bfd/interfaces/interface/peers/peer/state/echo/up-transitions"
func (n *Bfd_Interface_Peer_EchoPathAny) UpTransitions() *Bfd_Interface_Peer_Echo_UpTransitionsPathAny {
	return &Bfd_Interface_Peer_Echo_UpTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"up-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// ComponentPath represents the /openconfig-platform/components/component YANG schema element.
type ComponentPath struct {
	*ygot.NodePath
}

// ComponentPathAny represents the wildcard version of the /openconfig-platform/components/component YANG schema element.
type ComponentPathAny struct {
	*ygot.NodePath
}

// Component_AllocatedPowerPath represents the /openconfig-platform/components/component/state/allocated-power YANG schema element.
type Component_AllocatedPowerPath struct {
	*ygot.NodePath
}

// Component_AllocatedPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/state/allocated-power YANG schema element.
type Component_AllocatedPowerPathAny struct {
	*ygot.NodePath
}

// Component_DescriptionPath represents the /openconfig-platform/components/component/state/description YANG schema element.
type Component_DescriptionPath struct {
	*ygot.NodePath
}

// Component_DescriptionPathAny represents the wildcard version of the /openconfig-platform/components/component/state/description YANG schema element.
type Component_DescriptionPathAny struct {
	*ygot.NodePath
}

// Component_EmptyPath represents the /openconfig-platform/components/component/state/empty YANG schema element.
type Component_EmptyPath struct {
	*ygot.NodePath
}

// Component_EmptyPathAny represents the wildcard version of the /openconfig-platform/components/component/state/empty YANG schema element.
type Component_EmptyPathAny struct {
	*ygot.NodePath
}

// Component_EquipmentFailurePath represents the /openconfig-platform/components/component/state/equipment-failure YANG schema element.
type Component_EquipmentFailurePath struct {
	*ygot.NodePath
}

// Component_EquipmentFailurePathAny represents the wildcard version of the /openconfig-platform/components/component/state/equipment-failure YANG schema element.
type Component_EquipmentFailurePathAny struct {
	*ygot.NodePath
}

// Component_EquipmentMismatchPath represents the /openconfig-platform/components/component/state/equipment-mismatch YANG schema element.
type Component_EquipmentMismatchPath struct {
	*ygot.NodePath
}

// Component_EquipmentMismatchPathAny represents the wildcard version of the /openconfig-platform/components/component/state/equipment-mismatch YANG schema element.
type Component_EquipmentMismatchPathAny struct {
	*ygot.NodePath
}

// Component_FirmwareVersionPath represents the /openconfig-platform/components/component/state/firmware-version YANG schema element.
type Component_FirmwareVersionPath struct {
	*ygot.NodePath
}

// Component_FirmwareVersionPathAny represents the wildcard version of the /openconfig-platform/components/component/state/firmware-version YANG schema element.
type Component_FirmwareVersionPathAny struct {
	*ygot.NodePath
}

// Component_HardwareVersionPath represents the /openconfig-platform/components/component/state/hardware-version YANG schema element.
type Component_HardwareVersionPath struct {
	*ygot.NodePath
}

// Component_HardwareVersionPathAny represents the wildcard version of the /openconfig-platform/components/component/state/hardware-version YANG schema element.
type Component_HardwareVersionPathAny struct {
	*ygot.NodePath
}

// Component_IdPath represents the /openconfig-platform/components/component/state/id YANG schema element.
type Component_IdPath struct {
	*ygot.NodePath
}

// Component_IdPathAny represents the wildcard version of the /openconfig-platform/components/component/state/id YANG schema element.
type Component_IdPathAny struct {
	*ygot.NodePath
}

// Component_LastRebootReasonPath represents the /openconfig-platform/components/component/state/last-reboot-reason YANG schema element.
type Component_LastRebootReasonPath struct {
	*ygot.NodePath
}

// Component_LastRebootReasonPathAny represents the wildcard version of the /openconfig-platform/components/component/state/last-reboot-reason YANG schema element.
type Component_LastRebootReasonPathAny struct {
	*ygot.NodePath
}

// Component_LastRebootTimePath represents the /openconfig-platform/components/component/state/last-reboot-time YANG schema element.
type Component_LastRebootTimePath struct {
	*ygot.NodePath
}

// Component_LastRebootTimePathAny represents the wildcard version of the /openconfig-platform/components/component/state/last-reboot-time YANG schema element.
type Component_LastRebootTimePathAny struct {
	*ygot.NodePath
}

// Component_LastSwitchoverTimePath represents the /openconfig-platform/components/component/state/last-switchover-time YANG schema element.
type Component_LastSwitchoverTimePath struct {
	*ygot.NodePath
}

// Component_LastSwitchoverTimePathAny represents the wildcard version of the /openconfig-platform/components/component/state/last-switchover-time YANG schema element.
type Component_LastSwitchoverTimePathAny struct {
	*ygot.NodePath
}

// Component_LocationPath represents the /openconfig-platform/components/component/state/location YANG schema element.
type Component_LocationPath struct {
	*ygot.NodePath
}

// Component_LocationPathAny represents the wildcard version of the /openconfig-platform/components/component/state/location YANG schema element.
type Component_LocationPathAny struct {
	*ygot.NodePath
}

// Component_MfgDatePath represents the /openconfig-platform/components/component/state/mfg-date YANG schema element.
type Component_MfgDatePath struct {
	*ygot.NodePath
}

// Component_MfgDatePathAny represents the wildcard version of the /openconfig-platform/components/component/state/mfg-date YANG schema element.
type Component_MfgDatePathAny struct {
	*ygot.NodePath
}

// Component_MfgNamePath represents the /openconfig-platform/components/component/state/mfg-name YANG schema element.
type Component_MfgNamePath struct {
	*ygot.NodePath
}

// Component_MfgNamePathAny represents the wildcard version of the /openconfig-platform/components/component/state/mfg-name YANG schema element.
type Component_MfgNamePathAny struct {
	*ygot.NodePath
}

// Component_NamePath represents the /openconfig-platform/components/component/config/name YANG schema element.
type Component_NamePath struct {
	*ygot.NodePath
}

// Component_NamePathAny represents the wildcard version of the /openconfig-platform/components/component/config/name YANG schema element.
type Component_NamePathAny struct {
	*ygot.NodePath
}

// Component_OperStatusPath represents the /openconfig-platform/components/component/state/oper-status YANG schema element.
type Component_OperStatusPath struct {
	*ygot.NodePath
}

// Component_OperStatusPathAny represents the wildcard version of the /openconfig-platform/components/component/state/oper-status YANG schema element.
type Component_OperStatusPathAny struct {
	*ygot.NodePath
}

// Component_ParentPath represents the /openconfig-platform/components/component/state/parent YANG schema element.
type Component_ParentPath struct {
	*ygot.NodePath
}

// Component_ParentPathAny represents the wildcard version of the /openconfig-platform/components/component/state/parent YANG schema element.
type Component_ParentPathAny struct {
	*ygot.NodePath
}

// Component_PartNoPath represents the /openconfig-platform/components/component/state/part-no YANG schema element.
type Component_PartNoPath struct {
	*ygot.NodePath
}

// Component_PartNoPathAny represents the wildcard version of the /openconfig-platform/components/component/state/part-no YANG schema element.
type Component_PartNoPathAny struct {
	*ygot.NodePath
}

// Component_RedundantRolePath represents the /openconfig-platform/components/component/state/redundant-role YANG schema element.
type Component_RedundantRolePath struct {
	*ygot.NodePath
}

// Component_RedundantRolePathAny represents the wildcard version of the /openconfig-platform/components/component/state/redundant-role YANG schema element.
type Component_RedundantRolePathAny struct {
	*ygot.NodePath
}

// Component_RemovablePath represents the /openconfig-platform/components/component/state/removable YANG schema element.
type Component_RemovablePath struct {
	*ygot.NodePath
}

// Component_RemovablePathAny represents the wildcard version of the /openconfig-platform/components/component/state/removable YANG schema element.
type Component_RemovablePathAny struct {
	*ygot.NodePath
}

// Component_SerialNoPath represents the /openconfig-platform/components/component/state/serial-no YANG schema element.
type Component_SerialNoPath struct {
	*ygot.NodePath
}

// Component_SerialNoPathAny represents the wildcard version of the /openconfig-platform/components/component/state/serial-no YANG schema element.
type Component_SerialNoPathAny struct {
	*ygot.NodePath
}

// Component_SoftwareVersionPath represents the /openconfig-platform/components/component/state/software-version YANG schema element.
type Component_SoftwareVersionPath struct {
	*ygot.NodePath
}

// Component_SoftwareVersionPathAny represents the wildcard version of the /openconfig-platform/components/component/state/software-version YANG schema element.
type Component_SoftwareVersionPathAny struct {
	*ygot.NodePath
}

// Component_TypePath represents the /openconfig-platform/components/component/state/type YANG schema element.
type Component_TypePath struct {
	*ygot.NodePath
}

// Component_TypePathAny represents the wildcard version of the /openconfig-platform/components/component/state/type YANG schema element.
type Component_TypePathAny struct {
	*ygot.NodePath
}

// Component_UsedPowerPath represents the /openconfig-platform/components/component/state/used-power YANG schema element.
type Component_UsedPowerPath struct {
	*ygot.NodePath
}

// Component_UsedPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/state/used-power YANG schema element.
type Component_UsedPowerPathAny struct {
	*ygot.NodePath
}

// AllocatedPower (leaf): Power allocated by the system for the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/allocated-power"
// Path from root: "/components/component/state/allocated-power"
func (n *ComponentPath) AllocatedPower() *Component_AllocatedPowerPath {
	return &Component_AllocatedPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "allocated-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllocatedPower (leaf): Power allocated by the system for the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/allocated-power"
// Path from root: "/components/component/state/allocated-power"
func (n *ComponentPathAny) AllocatedPower() *Component_AllocatedPowerPathAny {
	return &Component_AllocatedPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "allocated-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backplane (container): Data for backplane components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "backplane"
// Path from root: "/components/component/backplane"
func (n *ComponentPath) Backplane() *Component_BackplanePath {
	return &Component_BackplanePath{
		NodePath: ygot.NewNodePath(
			[]string{"backplane"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backplane (container): Data for backplane components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "backplane"
// Path from root: "/components/component/backplane"
func (n *ComponentPathAny) Backplane() *Component_BackplanePathAny {
	return &Component_BackplanePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"backplane"},
			map[string]interface{}{},
			n,
		),
	}
}

// Chassis (container): Data for chassis components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "chassis"
// Path from root: "/components/component/chassis"
func (n *ComponentPath) Chassis() *Component_ChassisPath {
	return &Component_ChassisPath{
		NodePath: ygot.NewNodePath(
			[]string{"chassis"},
			map[string]interface{}{},
			n,
		),
	}
}

// Chassis (container): Data for chassis components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "chassis"
// Path from root: "/components/component/chassis"
func (n *ComponentPathAny) Chassis() *Component_ChassisPathAny {
	return &Component_ChassisPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"chassis"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cpu (container): Data for cpu components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "cpu"
// Path from root: "/components/component/cpu"
func (n *ComponentPath) Cpu() *Component_CpuPath {
	return &Component_CpuPath{
		NodePath: ygot.NewNodePath(
			[]string{"cpu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cpu (container): Data for cpu components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "cpu"
// Path from root: "/components/component/cpu"
func (n *ComponentPathAny) Cpu() *Component_CpuPathAny {
	return &Component_CpuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"cpu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): System-supplied description of the component
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/description"
// Path from root: "/components/component/state/description"
func (n *ComponentPath) Description() *Component_DescriptionPath {
	return &Component_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): System-supplied description of the component
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/description"
// Path from root: "/components/component/state/description"
func (n *ComponentPathAny) Description() *Component_DescriptionPathAny {
	return &Component_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Empty (leaf): The empty leaf may be used by the device to indicate that a
// component position exists but is not populated.  Using this
// flag, it is possible for the management system to learn how
// many positions are available (e.g., occupied vs. empty
// linecard slots in a chassis).
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/empty"
// Path from root: "/components/component/state/empty"
func (n *ComponentPath) Empty() *Component_EmptyPath {
	return &Component_EmptyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "empty"},
			map[string]interface{}{},
			n,
		),
	}
}

// Empty (leaf): The empty leaf may be used by the device to indicate that a
// component position exists but is not populated.  Using this
// flag, it is possible for the management system to learn how
// many positions are available (e.g., occupied vs. empty
// linecard slots in a chassis).
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/empty"
// Path from root: "/components/component/state/empty"
func (n *ComponentPathAny) Empty() *Component_EmptyPathAny {
	return &Component_EmptyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "empty"},
			map[string]interface{}{},
			n,
		),
	}
}

// EquipmentFailure (leaf): If true, the hardware indicates that the component's physical equipment
// has failed
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/equipment-failure"
// Path from root: "/components/component/state/equipment-failure"
func (n *ComponentPath) EquipmentFailure() *Component_EquipmentFailurePath {
	return &Component_EquipmentFailurePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "equipment-failure"},
			map[string]interface{}{},
			n,
		),
	}
}

// EquipmentFailure (leaf): If true, the hardware indicates that the component's physical equipment
// has failed
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/equipment-failure"
// Path from root: "/components/component/state/equipment-failure"
func (n *ComponentPathAny) EquipmentFailure() *Component_EquipmentFailurePathAny {
	return &Component_EquipmentFailurePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "equipment-failure"},
			map[string]interface{}{},
			n,
		),
	}
}

// EquipmentMismatch (leaf): If true, the hardware indicates that the component inserted into the
// affected component's physical location is of a different type than what
// is configured
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/equipment-mismatch"
// Path from root: "/components/component/state/equipment-mismatch"
func (n *ComponentPath) EquipmentMismatch() *Component_EquipmentMismatchPath {
	return &Component_EquipmentMismatchPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "equipment-mismatch"},
			map[string]interface{}{},
			n,
		),
	}
}

// EquipmentMismatch (leaf): If true, the hardware indicates that the component inserted into the
// affected component's physical location is of a different type than what
// is configured
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/equipment-mismatch"
// Path from root: "/components/component/state/equipment-mismatch"
func (n *ComponentPathAny) EquipmentMismatch() *Component_EquipmentMismatchPathAny {
	return &Component_EquipmentMismatchPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "equipment-mismatch"},
			map[string]interface{}{},
			n,
		),
	}
}

// Fabric (container): Data for fabric components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "fabric"
// Path from root: "/components/component/fabric"
func (n *ComponentPath) Fabric() *Component_FabricPath {
	return &Component_FabricPath{
		NodePath: ygot.NewNodePath(
			[]string{"fabric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Fabric (container): Data for fabric components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "fabric"
// Path from root: "/components/component/fabric"
func (n *ComponentPathAny) Fabric() *Component_FabricPathAny {
	return &Component_FabricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"fabric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Fan (container): Data for fan components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "fan"
// Path from root: "/components/component/fan"
func (n *ComponentPath) Fan() *Component_FanPath {
	return &Component_FanPath{
		NodePath: ygot.NewNodePath(
			[]string{"fan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Fan (container): Data for fan components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "fan"
// Path from root: "/components/component/fan"
func (n *ComponentPathAny) Fan() *Component_FanPathAny {
	return &Component_FanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"fan"},
			map[string]interface{}{},
			n,
		),
	}
}

// FirmwareVersion (leaf): For hardware components, this is the version of associated
// firmware that is running on the component, if applicable.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/firmware-version"
// Path from root: "/components/component/state/firmware-version"
func (n *ComponentPath) FirmwareVersion() *Component_FirmwareVersionPath {
	return &Component_FirmwareVersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "firmware-version"},
			map[string]interface{}{},
			n,
		),
	}
}

// FirmwareVersion (leaf): For hardware components, this is the version of associated
// firmware that is running on the component, if applicable.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/firmware-version"
// Path from root: "/components/component/state/firmware-version"
func (n *ComponentPathAny) FirmwareVersion() *Component_FirmwareVersionPathAny {
	return &Component_FirmwareVersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "firmware-version"},
			map[string]interface{}{},
			n,
		),
	}
}

// HardwareVersion (leaf): For hardware components, this is the hardware revision of
// the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/hardware-version"
// Path from root: "/components/component/state/hardware-version"
func (n *ComponentPath) HardwareVersion() *Component_HardwareVersionPath {
	return &Component_HardwareVersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hardware-version"},
			map[string]interface{}{},
			n,
		),
	}
}

// HardwareVersion (leaf): For hardware components, this is the hardware revision of
// the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/hardware-version"
// Path from root: "/components/component/state/hardware-version"
func (n *ComponentPathAny) HardwareVersion() *Component_HardwareVersionPathAny {
	return &Component_HardwareVersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hardware-version"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Unique identifier assigned by the system for the
// component
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/id"
// Path from root: "/components/component/state/id"
func (n *ComponentPath) Id() *Component_IdPath {
	return &Component_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Unique identifier assigned by the system for the
// component
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/id"
// Path from root: "/components/component/state/id"
func (n *ComponentPathAny) Id() *Component_IdPathAny {
	return &Component_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// IntegratedCircuit (container): Data for chip components, such as ASIC, NPUs, etc.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "integrated-circuit"
// Path from root: "/components/component/integrated-circuit"
func (n *ComponentPath) IntegratedCircuit() *Component_IntegratedCircuitPath {
	return &Component_IntegratedCircuitPath{
		NodePath: ygot.NewNodePath(
			[]string{"integrated-circuit"},
			map[string]interface{}{},
			n,
		),
	}
}

// IntegratedCircuit (container): Data for chip components, such as ASIC, NPUs, etc.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "integrated-circuit"
// Path from root: "/components/component/integrated-circuit"
func (n *ComponentPathAny) IntegratedCircuit() *Component_IntegratedCircuitPathAny {
	return &Component_IntegratedCircuitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"integrated-circuit"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastRebootReason (leaf): This reports the reason of the last reboot of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/last-reboot-reason"
// Path from root: "/components/component/state/last-reboot-reason"
func (n *ComponentPath) LastRebootReason() *Component_LastRebootReasonPath {
	return &Component_LastRebootReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-reboot-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastRebootReason (leaf): This reports the reason of the last reboot of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/last-reboot-reason"
// Path from root: "/components/component/state/last-reboot-reason"
func (n *ComponentPathAny) LastRebootReason() *Component_LastRebootReasonPathAny {
	return &Component_LastRebootReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-reboot-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastRebootTime (leaf): This reports the time of the last reboot of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/last-reboot-time"
// Path from root: "/components/component/state/last-reboot-time"
func (n *ComponentPath) LastRebootTime() *Component_LastRebootTimePath {
	return &Component_LastRebootTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-reboot-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastRebootTime (leaf): This reports the time of the last reboot of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/last-reboot-time"
// Path from root: "/components/component/state/last-reboot-time"
func (n *ComponentPathAny) LastRebootTime() *Component_LastRebootTimePathAny {
	return &Component_LastRebootTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-reboot-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastSwitchoverReason (container): For components that have redundant roles (e.g. two
// supervisors in a device, one as primary the other as secondary),
// this reports the reason of the last change of the
// component's role.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/last-switchover-reason"
// Path from root: "/components/component/state/last-switchover-reason"
func (n *ComponentPath) LastSwitchoverReason() *Component_LastSwitchoverReasonPath {
	return &Component_LastSwitchoverReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-switchover-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastSwitchoverReason (container): For components that have redundant roles (e.g. two
// supervisors in a device, one as primary the other as secondary),
// this reports the reason of the last change of the
// component's role.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/last-switchover-reason"
// Path from root: "/components/component/state/last-switchover-reason"
func (n *ComponentPathAny) LastSwitchoverReason() *Component_LastSwitchoverReasonPathAny {
	return &Component_LastSwitchoverReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-switchover-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastSwitchoverTime (leaf): For components that have redundant roles (e.g. two
// supervisors in a device, one as primary the other as
// secondary), this reports the time of the last change of
// the component's role.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/last-switchover-time"
// Path from root: "/components/component/state/last-switchover-time"
func (n *ComponentPath) LastSwitchoverTime() *Component_LastSwitchoverTimePath {
	return &Component_LastSwitchoverTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-switchover-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastSwitchoverTime (leaf): For components that have redundant roles (e.g. two
// supervisors in a device, one as primary the other as
// secondary), this reports the time of the last change of
// the component's role.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/last-switchover-time"
// Path from root: "/components/component/state/last-switchover-time"
func (n *ComponentPathAny) LastSwitchoverTime() *Component_LastSwitchoverTimePathAny {
	return &Component_LastSwitchoverTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-switchover-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Location (leaf): System-supplied description of the location of the
// component within the system. This could be a bay position,
// slot number, socket location, etc. For component types that
// have an explicit slot-id attribute, such as linecards, the
// system should populate the more specific slot-id.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/location"
// Path from root: "/components/component/state/location"
func (n *ComponentPath) Location() *Component_LocationPath {
	return &Component_LocationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "location"},
			map[string]interface{}{},
			n,
		),
	}
}

// Location (leaf): System-supplied description of the location of the
// component within the system. This could be a bay position,
// slot number, socket location, etc. For component types that
// have an explicit slot-id attribute, such as linecards, the
// system should populate the more specific slot-id.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/location"
// Path from root: "/components/component/state/location"
func (n *ComponentPathAny) Location() *Component_LocationPathAny {
	return &Component_LocationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "location"},
			map[string]interface{}{},
			n,
		),
	}
}

// Memory (container): For components that have associated memory, these values
// report information about available and utilized memory.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/memory"
// Path from root: "/components/component/state/memory"
func (n *ComponentPath) Memory() *Component_MemoryPath {
	return &Component_MemoryPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "memory"},
			map[string]interface{}{},
			n,
		),
	}
}

// Memory (container): For components that have associated memory, these values
// report information about available and utilized memory.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/memory"
// Path from root: "/components/component/state/memory"
func (n *ComponentPathAny) Memory() *Component_MemoryPathAny {
	return &Component_MemoryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "memory"},
			map[string]interface{}{},
			n,
		),
	}
}

// MfgDate (leaf): System-supplied representation of the component's
// manufacturing date.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/mfg-date"
// Path from root: "/components/component/state/mfg-date"
func (n *ComponentPath) MfgDate() *Component_MfgDatePath {
	return &Component_MfgDatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mfg-date"},
			map[string]interface{}{},
			n,
		),
	}
}

// MfgDate (leaf): System-supplied representation of the component's
// manufacturing date.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/mfg-date"
// Path from root: "/components/component/state/mfg-date"
func (n *ComponentPathAny) MfgDate() *Component_MfgDatePathAny {
	return &Component_MfgDatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mfg-date"},
			map[string]interface{}{},
			n,
		),
	}
}

// MfgName (leaf): System-supplied identifier for the manufacturer of the
// component.  This data is particularly useful when a
// component manufacturer is different than the overall
// device vendor.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/mfg-name"
// Path from root: "/components/component/state/mfg-name"
func (n *ComponentPath) MfgName() *Component_MfgNamePath {
	return &Component_MfgNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mfg-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// MfgName (leaf): System-supplied identifier for the manufacturer of the
// component.  This data is particularly useful when a
// component manufacturer is different than the overall
// device vendor.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/mfg-name"
// Path from root: "/components/component/state/mfg-name"
func (n *ComponentPathAny) MfgName() *Component_MfgNamePathAny {
	return &Component_MfgNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mfg-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Device name for the component -- this may not be a
// configurable parameter on many implementations.  Where
// component preconfiguration is supported, for example,
// the component name may be configurable.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/name"
// Path from root: "/components/component/config/name"
func (n *ComponentPath) Name() *Component_NamePath {
	return &Component_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Device name for the component -- this may not be a
// configurable parameter on many implementations.  Where
// component preconfiguration is supported, for example,
// the component name may be configurable.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/name"
// Path from root: "/components/component/config/name"
func (n *ComponentPathAny) Name() *Component_NamePathAny {
	return &Component_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperStatus (leaf): If applicable, this reports the current operational status
// of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/oper-status"
// Path from root: "/components/component/state/oper-status"
func (n *ComponentPath) OperStatus() *Component_OperStatusPath {
	return &Component_OperStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperStatus (leaf): If applicable, this reports the current operational status
// of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/oper-status"
// Path from root: "/components/component/state/oper-status"
func (n *ComponentPathAny) OperStatus() *Component_OperStatusPathAny {
	return &Component_OperStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalChannel (container): Enclosing container for the list of optical channels
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "optical-channel"
// Path from root: "/components/component/optical-channel"
func (n *ComponentPath) OpticalChannel() *Component_OpticalChannelPath {
	return &Component_OpticalChannelPath{
		NodePath: ygot.NewNodePath(
			[]string{"optical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalChannel (container): Enclosing container for the list of optical channels
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "optical-channel"
// Path from root: "/components/component/optical-channel"
func (n *ComponentPathAny) OpticalChannel() *Component_OpticalChannelPathAny {
	return &Component_OpticalChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"optical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// Parent (leaf): Reference to the name of the parent component.  Note that
// this reference must be kept synchronized with the
// corresponding subcomponent reference from the parent
// component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/parent"
// Path from root: "/components/component/state/parent"
func (n *ComponentPath) Parent() *Component_ParentPath {
	return &Component_ParentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "parent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Parent (leaf): Reference to the name of the parent component.  Note that
// this reference must be kept synchronized with the
// corresponding subcomponent reference from the parent
// component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/parent"
// Path from root: "/components/component/state/parent"
func (n *ComponentPathAny) Parent() *Component_ParentPathAny {
	return &Component_ParentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "parent"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartNo (leaf): System-assigned part number for the component.  This should
// be present in particular if the component is also an FRU
// (field replaceable unit)
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/part-no"
// Path from root: "/components/component/state/part-no"
func (n *ComponentPath) PartNo() *Component_PartNoPath {
	return &Component_PartNoPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "part-no"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartNo (leaf): System-assigned part number for the component.  This should
// be present in particular if the component is also an FRU
// (field replaceable unit)
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/part-no"
// Path from root: "/components/component/state/part-no"
func (n *ComponentPathAny) PartNo() *Component_PartNoPathAny {
	return &Component_PartNoPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "part-no"},
			map[string]interface{}{},
			n,
		),
	}
}

// Pcie (container): Components that are connected to the system over the Peripheral
// Component Interconnect Express (PCIe), report the fatal, non-fatal
// and correctable PCIe error counts.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/pcie"
// Path from root: "/components/component/state/pcie"
func (n *ComponentPath) Pcie() *Component_PciePath {
	return &Component_PciePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pcie"},
			map[string]interface{}{},
			n,
		),
	}
}

// Pcie (container): Components that are connected to the system over the Peripheral
// Component Interconnect Express (PCIe), report the fatal, non-fatal
// and correctable PCIe error counts.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/pcie"
// Path from root: "/components/component/state/pcie"
func (n *ComponentPathAny) Pcie() *Component_PciePathAny {
	return &Component_PciePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pcie"},
			map[string]interface{}{},
			n,
		),
	}
}

// Port (container): Data for physical port components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "port"
// Path from root: "/components/component/port"
func (n *ComponentPath) Port() *Component_PortPath {
	return &Component_PortPath{
		NodePath: ygot.NewNodePath(
			[]string{"port"},
			map[string]interface{}{},
			n,
		),
	}
}

// Port (container): Data for physical port components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "port"
// Path from root: "/components/component/port"
func (n *ComponentPathAny) Port() *Component_PortPathAny {
	return &Component_PortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"port"},
			map[string]interface{}{},
			n,
		),
	}
}

// PowerSupply (container): Data for power supply components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "power-supply"
// Path from root: "/components/component/power-supply"
func (n *ComponentPath) PowerSupply() *Component_PowerSupplyPath {
	return &Component_PowerSupplyPath{
		NodePath: ygot.NewNodePath(
			[]string{"power-supply"},
			map[string]interface{}{},
			n,
		),
	}
}

// PowerSupply (container): Data for power supply components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "power-supply"
// Path from root: "/components/component/power-supply"
func (n *ComponentPathAny) PowerSupply() *Component_PowerSupplyPathAny {
	return &Component_PowerSupplyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"power-supply"},
			map[string]interface{}{},
			n,
		),
	}
}

// PropertyAny (list): List of system properties for the component
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "properties/property"
// Path from root: "/components/component/properties/property"
// Name (wildcarded): string
func (n *ComponentPath) PropertyAny() *Component_PropertyPathAny {
	return &Component_PropertyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"properties", "property"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// PropertyAny (list): List of system properties for the component
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "properties/property"
// Path from root: "/components/component/properties/property"
// Name (wildcarded): string
func (n *ComponentPathAny) PropertyAny() *Component_PropertyPathAny {
	return &Component_PropertyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"properties", "property"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Property (list): List of system properties for the component
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "properties/property"
// Path from root: "/components/component/properties/property"
// Name: string
func (n *ComponentPath) Property(Name string) *Component_PropertyPath {
	return &Component_PropertyPath{
		NodePath: ygot.NewNodePath(
			[]string{"properties", "property"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Property (list): List of system properties for the component
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "properties/property"
// Path from root: "/components/component/properties/property"
// Name: string
func (n *ComponentPathAny) Property(Name string) *Component_PropertyPathAny {
	return &Component_PropertyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"properties", "property"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// RedundantRole (leaf): For components that have redundant roles (e.g. two
// supervisors in a device, one as primary the other as secondary),
// this reports the role of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/redundant-role"
// Path from root: "/components/component/state/redundant-role"
func (n *ComponentPath) RedundantRole() *Component_RedundantRolePath {
	return &Component_RedundantRolePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "redundant-role"},
			map[string]interface{}{},
			n,
		),
	}
}

// RedundantRole (leaf): For components that have redundant roles (e.g. two
// supervisors in a device, one as primary the other as secondary),
// this reports the role of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/redundant-role"
// Path from root: "/components/component/state/redundant-role"
func (n *ComponentPathAny) RedundantRole() *Component_RedundantRolePathAny {
	return &Component_RedundantRolePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "redundant-role"},
			map[string]interface{}{},
			n,
		),
	}
}

// Removable (leaf): If true, this component is removable or is a field
// replaceable unit
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/removable"
// Path from root: "/components/component/state/removable"
func (n *ComponentPath) Removable() *Component_RemovablePath {
	return &Component_RemovablePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "removable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Removable (leaf): If true, this component is removable or is a field
// replaceable unit
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/removable"
// Path from root: "/components/component/state/removable"
func (n *ComponentPathAny) Removable() *Component_RemovablePathAny {
	return &Component_RemovablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "removable"},
			map[string]interface{}{},
			n,
		),
	}
}

// SerialNo (leaf): System-assigned serial number of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/serial-no"
// Path from root: "/components/component/state/serial-no"
func (n *ComponentPath) SerialNo() *Component_SerialNoPath {
	return &Component_SerialNoPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "serial-no"},
			map[string]interface{}{},
			n,
		),
	}
}

// SerialNo (leaf): System-assigned serial number of the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/serial-no"
// Path from root: "/components/component/state/serial-no"
func (n *ComponentPathAny) SerialNo() *Component_SerialNoPathAny {
	return &Component_SerialNoPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "serial-no"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftwareModule (container): Data for software module components, i.e., for components
// with type=SOFTWARE_MODULE
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "software-module"
// Path from root: "/components/component/software-module"
func (n *ComponentPath) SoftwareModule() *Component_SoftwareModulePath {
	return &Component_SoftwareModulePath{
		NodePath: ygot.NewNodePath(
			[]string{"software-module"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftwareModule (container): Data for software module components, i.e., for components
// with type=SOFTWARE_MODULE
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "software-module"
// Path from root: "/components/component/software-module"
func (n *ComponentPathAny) SoftwareModule() *Component_SoftwareModulePathAny {
	return &Component_SoftwareModulePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"software-module"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftwareVersion (leaf): For software components such as operating system or other
// software module, this is the version of the currently
// running software.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/software-version"
// Path from root: "/components/component/state/software-version"
func (n *ComponentPath) SoftwareVersion() *Component_SoftwareVersionPath {
	return &Component_SoftwareVersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "software-version"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftwareVersion (leaf): For software components such as operating system or other
// software module, this is the version of the currently
// running software.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/software-version"
// Path from root: "/components/component/state/software-version"
func (n *ComponentPathAny) SoftwareVersion() *Component_SoftwareVersionPathAny {
	return &Component_SoftwareVersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "software-version"},
			map[string]interface{}{},
			n,
		),
	}
}

// Storage (container): Data for storage components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "storage"
// Path from root: "/components/component/storage"
func (n *ComponentPath) Storage() *Component_StoragePath {
	return &Component_StoragePath{
		NodePath: ygot.NewNodePath(
			[]string{"storage"},
			map[string]interface{}{},
			n,
		),
	}
}

// Storage (container): Data for storage components
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "storage"
// Path from root: "/components/component/storage"
func (n *ComponentPathAny) Storage() *Component_StoragePathAny {
	return &Component_StoragePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"storage"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubcomponentAny (list): List of subcomponent references
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "subcomponents/subcomponent"
// Path from root: "/components/component/subcomponents/subcomponent"
// Name (wildcarded): string
func (n *ComponentPath) SubcomponentAny() *Component_SubcomponentPathAny {
	return &Component_SubcomponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subcomponents", "subcomponent"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// SubcomponentAny (list): List of subcomponent references
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "subcomponents/subcomponent"
// Path from root: "/components/component/subcomponents/subcomponent"
// Name (wildcarded): string
func (n *ComponentPathAny) SubcomponentAny() *Component_SubcomponentPathAny {
	return &Component_SubcomponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subcomponents", "subcomponent"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Subcomponent (list): List of subcomponent references
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "subcomponents/subcomponent"
// Path from root: "/components/component/subcomponents/subcomponent"
// Name: string
func (n *ComponentPath) Subcomponent(Name string) *Component_SubcomponentPath {
	return &Component_SubcomponentPath{
		NodePath: ygot.NewNodePath(
			[]string{"subcomponents", "subcomponent"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Subcomponent (list): List of subcomponent references
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "subcomponents/subcomponent"
// Path from root: "/components/component/subcomponents/subcomponent"
// Name: string
func (n *ComponentPathAny) Subcomponent(Name string) *Component_SubcomponentPathAny {
	return &Component_SubcomponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subcomponents", "subcomponent"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Temperature (container): Temperature in degrees Celsius of the component. Values include
// the instantaneous, average, minimum, and maximum statistics. If
// avg/min/max statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/temperature"
// Path from root: "/components/component/state/temperature"
func (n *ComponentPath) Temperature() *Component_TemperaturePath {
	return &Component_TemperaturePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "temperature"},
			map[string]interface{}{},
			n,
		),
	}
}

// Temperature (container): Temperature in degrees Celsius of the component. Values include
// the instantaneous, average, minimum, and maximum statistics. If
// avg/min/max statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/temperature"
// Path from root: "/components/component/state/temperature"
func (n *ComponentPathAny) Temperature() *Component_TemperaturePathAny {
	return &Component_TemperaturePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "temperature"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transceiver (container): Top-level container for client port transceiver data
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "transceiver"
// Path from root: "/components/component/transceiver"
func (n *ComponentPath) Transceiver() *Component_TransceiverPath {
	return &Component_TransceiverPath{
		NodePath: ygot.NewNodePath(
			[]string{"transceiver"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transceiver (container): Top-level container for client port transceiver data
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "transceiver"
// Path from root: "/components/component/transceiver"
func (n *ComponentPathAny) Transceiver() *Component_TransceiverPathAny {
	return &Component_TransceiverPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transceiver"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Type of component as identified by the system
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/type"
// Path from root: "/components/component/state/type"
func (n *ComponentPath) Type() *Component_TypePath {
	return &Component_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Type of component as identified by the system
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/type"
// Path from root: "/components/component/state/type"
func (n *ComponentPathAny) Type() *Component_TypePathAny {
	return &Component_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UsedPower (leaf): Actual power used by the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/used-power"
// Path from root: "/components/component/state/used-power"
func (n *ComponentPath) UsedPower() *Component_UsedPowerPath {
	return &Component_UsedPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "used-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// UsedPower (leaf): Actual power used by the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/used-power"
// Path from root: "/components/component/state/used-power"
func (n *ComponentPathAny) UsedPower() *Component_UsedPowerPathAny {
	return &Component_UsedPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "used-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_BackplanePath represents the /openconfig-platform/components/component/backplane YANG schema element.
type Component_BackplanePath struct {
	*ygot.NodePath
}

// Component_BackplanePathAny represents the wildcard version of the /openconfig-platform/components/component/backplane YANG schema element.
type Component_BackplanePathAny struct {
	*ygot.NodePath
}

// Component_ChassisPath represents the /openconfig-platform/components/component/chassis YANG schema element.
type Component_ChassisPath struct {
	*ygot.NodePath
}

// Component_ChassisPathAny represents the wildcard version of the /openconfig-platform/components/component/chassis YANG schema element.
type Component_ChassisPathAny struct {
	*ygot.NodePath
}

// Component_CpuPath represents the /openconfig-platform/components/component/cpu YANG schema element.
type Component_CpuPath struct {
	*ygot.NodePath
}

// Component_CpuPathAny represents the wildcard version of the /openconfig-platform/components/component/cpu YANG schema element.
type Component_CpuPathAny struct {
	*ygot.NodePath
}

// Component_FabricPath represents the /openconfig-platform/components/component/fabric YANG schema element.
type Component_FabricPath struct {
	*ygot.NodePath
}

// Component_FabricPathAny represents the wildcard version of the /openconfig-platform/components/component/fabric YANG schema element.
type Component_FabricPathAny struct {
	*ygot.NodePath
}

// Component_FanPath represents the /openconfig-platform/components/component/fan YANG schema element.
type Component_FanPath struct {
	*ygot.NodePath
}

// Component_FanPathAny represents the wildcard version of the /openconfig-platform/components/component/fan YANG schema element.
type Component_FanPathAny struct {
	*ygot.NodePath
}

// Component_IntegratedCircuitPath represents the /openconfig-platform/components/component/integrated-circuit YANG schema element.
type Component_IntegratedCircuitPath struct {
	*ygot.NodePath
}

// Component_IntegratedCircuitPathAny represents the wildcard version of the /openconfig-platform/components/component/integrated-circuit YANG schema element.
type Component_IntegratedCircuitPathAny struct {
	*ygot.NodePath
}

// Component_LastSwitchoverReasonPath represents the /openconfig-platform/components/component/state/last-switchover-reason YANG schema element.
type Component_LastSwitchoverReasonPath struct {
	*ygot.NodePath
}

// Component_LastSwitchoverReasonPathAny represents the wildcard version of the /openconfig-platform/components/component/state/last-switchover-reason YANG schema element.
type Component_LastSwitchoverReasonPathAny struct {
	*ygot.NodePath
}

// Component_LastSwitchoverReason_DetailsPath represents the /openconfig-platform/components/component/state/last-switchover-reason/details YANG schema element.
type Component_LastSwitchoverReason_DetailsPath struct {
	*ygot.NodePath
}

// Component_LastSwitchoverReason_DetailsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/last-switchover-reason/details YANG schema element.
type Component_LastSwitchoverReason_DetailsPathAny struct {
	*ygot.NodePath
}

// Component_LastSwitchoverReason_TriggerPath represents the /openconfig-platform/components/component/state/last-switchover-reason/trigger YANG schema element.
type Component_LastSwitchoverReason_TriggerPath struct {
	*ygot.NodePath
}

// Component_LastSwitchoverReason_TriggerPathAny represents the wildcard version of the /openconfig-platform/components/component/state/last-switchover-reason/trigger YANG schema element.
type Component_LastSwitchoverReason_TriggerPathAny struct {
	*ygot.NodePath
}

// Details (leaf): Records detailed description of why the switchover happens.
// For example, when system initiated the switchover, this leaf
// can be used to record the specific reason, e.g. due to critical
// errors of the routing daemon in the primary role.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "details"
// Path from root: "/components/component/state/last-switchover-reason/details"
func (n *Component_LastSwitchoverReasonPath) Details() *Component_LastSwitchoverReason_DetailsPath {
	return &Component_LastSwitchoverReason_DetailsPath{
		NodePath: ygot.NewNodePath(
			[]string{"details"},
			map[string]interface{}{},
			n,
		),
	}
}

// Details (leaf): Records detailed description of why the switchover happens.
// For example, when system initiated the switchover, this leaf
// can be used to record the specific reason, e.g. due to critical
// errors of the routing daemon in the primary role.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "details"
// Path from root: "/components/component/state/last-switchover-reason/details"
func (n *Component_LastSwitchoverReasonPathAny) Details() *Component_LastSwitchoverReason_DetailsPathAny {
	return &Component_LastSwitchoverReason_DetailsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"details"},
			map[string]interface{}{},
			n,
		),
	}
}

// Trigger (leaf): Records the generic triggers, e.g. user or system
// initiated the switchover.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "trigger"
// Path from root: "/components/component/state/last-switchover-reason/trigger"
func (n *Component_LastSwitchoverReasonPath) Trigger() *Component_LastSwitchoverReason_TriggerPath {
	return &Component_LastSwitchoverReason_TriggerPath{
		NodePath: ygot.NewNodePath(
			[]string{"trigger"},
			map[string]interface{}{},
			n,
		),
	}
}

// Trigger (leaf): Records the generic triggers, e.g. user or system
// initiated the switchover.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "trigger"
// Path from root: "/components/component/state/last-switchover-reason/trigger"
func (n *Component_LastSwitchoverReasonPathAny) Trigger() *Component_LastSwitchoverReason_TriggerPathAny {
	return &Component_LastSwitchoverReason_TriggerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"trigger"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_MemoryPath represents the /openconfig-platform/components/component/state/memory YANG schema element.
type Component_MemoryPath struct {
	*ygot.NodePath
}

// Component_MemoryPathAny represents the wildcard version of the /openconfig-platform/components/component/state/memory YANG schema element.
type Component_MemoryPathAny struct {
	*ygot.NodePath
}

// Component_Memory_AvailablePath represents the /openconfig-platform/components/component/state/memory/available YANG schema element.
type Component_Memory_AvailablePath struct {
	*ygot.NodePath
}

// Component_Memory_AvailablePathAny represents the wildcard version of the /openconfig-platform/components/component/state/memory/available YANG schema element.
type Component_Memory_AvailablePathAny struct {
	*ygot.NodePath
}

// Component_Memory_UtilizedPath represents the /openconfig-platform/components/component/state/memory/utilized YANG schema element.
type Component_Memory_UtilizedPath struct {
	*ygot.NodePath
}

// Component_Memory_UtilizedPathAny represents the wildcard version of the /openconfig-platform/components/component/state/memory/utilized YANG schema element.
type Component_Memory_UtilizedPathAny struct {
	*ygot.NodePath
}

// Available (leaf): The available memory physically installed, or logically
// allocated to the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "available"
// Path from root: "/components/component/state/memory/available"
func (n *Component_MemoryPath) Available() *Component_Memory_AvailablePath {
	return &Component_Memory_AvailablePath{
		NodePath: ygot.NewNodePath(
			[]string{"available"},
			map[string]interface{}{},
			n,
		),
	}
}

// Available (leaf): The available memory physically installed, or logically
// allocated to the component.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "available"
// Path from root: "/components/component/state/memory/available"
func (n *Component_MemoryPathAny) Available() *Component_Memory_AvailablePathAny {
	return &Component_Memory_AvailablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"available"},
			map[string]interface{}{},
			n,
		),
	}
}

// Utilized (leaf): The memory currently in use by processes running on
// the component, not considering reserved memory that is
// not available for use.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "utilized"
// Path from root: "/components/component/state/memory/utilized"
func (n *Component_MemoryPath) Utilized() *Component_Memory_UtilizedPath {
	return &Component_Memory_UtilizedPath{
		NodePath: ygot.NewNodePath(
			[]string{"utilized"},
			map[string]interface{}{},
			n,
		),
	}
}

// Utilized (leaf): The memory currently in use by processes running on
// the component, not considering reserved memory that is
// not available for use.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "utilized"
// Path from root: "/components/component/state/memory/utilized"
func (n *Component_MemoryPathAny) Utilized() *Component_Memory_UtilizedPathAny {
	return &Component_Memory_UtilizedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"utilized"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannelPath represents the /openconfig-platform/components/component/optical-channel YANG schema element.
type Component_OpticalChannelPath struct {
	*ygot.NodePath
}

// Component_OpticalChannelPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel YANG schema element.
type Component_OpticalChannelPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_FecUncorrectableBlocksPath represents the /openconfig-platform/components/component/optical-channel/state/fec-uncorrectable-blocks YANG schema element.
type Component_OpticalChannel_FecUncorrectableBlocksPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_FecUncorrectableBlocksPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/fec-uncorrectable-blocks YANG schema element.
type Component_OpticalChannel_FecUncorrectableBlocksPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_FrequencyPath represents the /openconfig-platform/components/component/optical-channel/config/frequency YANG schema element.
type Component_OpticalChannel_FrequencyPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_FrequencyPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/config/frequency YANG schema element.
type Component_OpticalChannel_FrequencyPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_GroupIdPath represents the /openconfig-platform/components/component/optical-channel/state/group-id YANG schema element.
type Component_OpticalChannel_GroupIdPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_GroupIdPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/group-id YANG schema element.
type Component_OpticalChannel_GroupIdPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LinePortPath represents the /openconfig-platform/components/component/optical-channel/config/line-port YANG schema element.
type Component_OpticalChannel_LinePortPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LinePortPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/config/line-port YANG schema element.
type Component_OpticalChannel_LinePortPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OperationalModePath represents the /openconfig-platform/components/component/optical-channel/config/operational-mode YANG schema element.
type Component_OpticalChannel_OperationalModePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OperationalModePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/config/operational-mode YANG schema element.
type Component_OpticalChannel_OperationalModePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_TargetOutputPowerPath represents the /openconfig-platform/components/component/optical-channel/config/target-output-power YANG schema element.
type Component_OpticalChannel_TargetOutputPowerPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_TargetOutputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/config/target-output-power YANG schema element.
type Component_OpticalChannel_TargetOutputPowerPathAny struct {
	*ygot.NodePath
}

// CarrierFrequencyOffset (container): Carrier frequency offset in MHz with 1 decimal precision.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not supported,
// the target is expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/carrier-frequency-offset"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset"
func (n *Component_OpticalChannelPath) CarrierFrequencyOffset() *Component_OpticalChannel_CarrierFrequencyOffsetPath {
	return &Component_OpticalChannel_CarrierFrequencyOffsetPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "carrier-frequency-offset"},
			map[string]interface{}{},
			n,
		),
	}
}

// CarrierFrequencyOffset (container): Carrier frequency offset in MHz with 1 decimal precision.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not supported,
// the target is expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/carrier-frequency-offset"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset"
func (n *Component_OpticalChannelPathAny) CarrierFrequencyOffset() *Component_OpticalChannel_CarrierFrequencyOffsetPathAny {
	return &Component_OpticalChannel_CarrierFrequencyOffsetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "carrier-frequency-offset"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChromaticDispersion (container): Chromatic Dispersion of an optical channel in
// picoseconds / nanometer (ps/nm) as reported by receiver
// with two decimal precision. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected to just
// supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/chromatic-dispersion"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion"
func (n *Component_OpticalChannelPath) ChromaticDispersion() *Component_OpticalChannel_ChromaticDispersionPath {
	return &Component_OpticalChannel_ChromaticDispersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chromatic-dispersion"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChromaticDispersion (container): Chromatic Dispersion of an optical channel in
// picoseconds / nanometer (ps/nm) as reported by receiver
// with two decimal precision. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected to just
// supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/chromatic-dispersion"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion"
func (n *Component_OpticalChannelPathAny) ChromaticDispersion() *Component_OpticalChannel_ChromaticDispersionPathAny {
	return &Component_OpticalChannel_ChromaticDispersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chromatic-dispersion"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esnr (container): Electrical signal to noise ratio. Baud rate
// normalized signal to noise ratio based on
// error vector magnitude in dB with two decimal
// precision. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/esnr"
// Path from root: "/components/component/optical-channel/state/esnr"
func (n *Component_OpticalChannelPath) Esnr() *Component_OpticalChannel_EsnrPath {
	return &Component_OpticalChannel_EsnrPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esnr"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esnr (container): Electrical signal to noise ratio. Baud rate
// normalized signal to noise ratio based on
// error vector magnitude in dB with two decimal
// precision. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/esnr"
// Path from root: "/components/component/optical-channel/state/esnr"
func (n *Component_OpticalChannelPathAny) Esnr() *Component_OpticalChannel_EsnrPathAny {
	return &Component_OpticalChannel_EsnrPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esnr"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableBlocks (leaf): The number of blocks or frames that were uncorrectable by
// the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-uncorrectable-blocks"
// Path from root: "/components/component/optical-channel/state/fec-uncorrectable-blocks"
func (n *Component_OpticalChannelPath) FecUncorrectableBlocks() *Component_OpticalChannel_FecUncorrectableBlocksPath {
	return &Component_OpticalChannel_FecUncorrectableBlocksPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableBlocks (leaf): The number of blocks or frames that were uncorrectable by
// the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-uncorrectable-blocks"
// Path from root: "/components/component/optical-channel/state/fec-uncorrectable-blocks"
func (n *Component_OpticalChannelPathAny) FecUncorrectableBlocks() *Component_OpticalChannel_FecUncorrectableBlocksPathAny {
	return &Component_OpticalChannel_FecUncorrectableBlocksPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// Frequency (leaf): Frequency of the optical channel, expressed in MHz
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/frequency"
// Path from root: "/components/component/optical-channel/config/frequency"
func (n *Component_OpticalChannelPath) Frequency() *Component_OpticalChannel_FrequencyPath {
	return &Component_OpticalChannel_FrequencyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "frequency"},
			map[string]interface{}{},
			n,
		),
	}
}

// Frequency (leaf): Frequency of the optical channel, expressed in MHz
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/frequency"
// Path from root: "/components/component/optical-channel/config/frequency"
func (n *Component_OpticalChannelPathAny) Frequency() *Component_OpticalChannel_FrequencyPathAny {
	return &Component_OpticalChannel_FrequencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "frequency"},
			map[string]interface{}{},
			n,
		),
	}
}

// GroupId (leaf): If the device places constraints on which optical
// channels must be managed together (e.g., transmitted on the
// same line port), it can indicate that by setting the group-id
// to the same value across related optical channels.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/group-id"
// Path from root: "/components/component/optical-channel/state/group-id"
func (n *Component_OpticalChannelPath) GroupId() *Component_OpticalChannel_GroupIdPath {
	return &Component_OpticalChannel_GroupIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "group-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// GroupId (leaf): If the device places constraints on which optical
// channels must be managed together (e.g., transmitted on the
// same line port), it can indicate that by setting the group-id
// to the same value across related optical channels.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/group-id"
// Path from root: "/components/component/optical-channel/state/group-id"
func (n *Component_OpticalChannelPathAny) GroupId() *Component_OpticalChannel_GroupIdPathAny {
	return &Component_OpticalChannel_GroupIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "group-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPower (container): The input optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/input-power"
// Path from root: "/components/component/optical-channel/state/input-power"
func (n *Component_OpticalChannelPath) InputPower() *Component_OpticalChannel_InputPowerPath {
	return &Component_OpticalChannel_InputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPower (container): The input optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/input-power"
// Path from root: "/components/component/optical-channel/state/input-power"
func (n *Component_OpticalChannelPathAny) InputPower() *Component_OpticalChannel_InputPowerPathAny {
	return &Component_OpticalChannel_InputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-bias-current"
// Path from root: "/components/component/optical-channel/state/laser-bias-current"
func (n *Component_OpticalChannelPath) LaserBiasCurrent() *Component_OpticalChannel_LaserBiasCurrentPath {
	return &Component_OpticalChannel_LaserBiasCurrentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-bias-current"
// Path from root: "/components/component/optical-channel/state/laser-bias-current"
func (n *Component_OpticalChannelPathAny) LaserBiasCurrent() *Component_OpticalChannel_LaserBiasCurrentPathAny {
	return &Component_OpticalChannel_LaserBiasCurrentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinePort (leaf): Reference to the line-side physical port that carries
// this optical channel.  The target port should be
// a component in the physical inventory data model.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/line-port"
// Path from root: "/components/component/optical-channel/config/line-port"
func (n *Component_OpticalChannelPath) LinePort() *Component_OpticalChannel_LinePortPath {
	return &Component_OpticalChannel_LinePortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "line-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinePort (leaf): Reference to the line-side physical port that carries
// this optical channel.  The target port should be
// a component in the physical inventory data model.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/line-port"
// Path from root: "/components/component/optical-channel/config/line-port"
func (n *Component_OpticalChannelPathAny) LinePort() *Component_OpticalChannel_LinePortPathAny {
	return &Component_OpticalChannel_LinePortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "line-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulationErrorRatio (container): Modulation error ratio in dB with two decimal precision. Values
// include the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulation-error-ratio"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio"
func (n *Component_OpticalChannelPath) ModulationErrorRatio() *Component_OpticalChannel_ModulationErrorRatioPath {
	return &Component_OpticalChannel_ModulationErrorRatioPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulation-error-ratio"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulationErrorRatio (container): Modulation error ratio in dB with two decimal precision. Values
// include the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulation-error-ratio"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio"
func (n *Component_OpticalChannelPathAny) ModulationErrorRatio() *Component_OpticalChannel_ModulationErrorRatioPathAny {
	return &Component_OpticalChannel_ModulationErrorRatioPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulation-error-ratio"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasXPhase (container): The X-Phase bias of the coherent modulator. This is
// represented as a percentage with 2 decimal precision. This
// term is defined by OIF Implementation Agreement for
// Coherent CMIS. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply
// the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-x-phase"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase"
func (n *Component_OpticalChannelPath) ModulatorBiasXPhase() *Component_OpticalChannel_ModulatorBiasXPhasePath {
	return &Component_OpticalChannel_ModulatorBiasXPhasePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-x-phase"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasXPhase (container): The X-Phase bias of the coherent modulator. This is
// represented as a percentage with 2 decimal precision. This
// term is defined by OIF Implementation Agreement for
// Coherent CMIS. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply
// the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-x-phase"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase"
func (n *Component_OpticalChannelPathAny) ModulatorBiasXPhase() *Component_OpticalChannel_ModulatorBiasXPhasePathAny {
	return &Component_OpticalChannel_ModulatorBiasXPhasePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-x-phase"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasXi (container): The bias on in-phase path and Polarization X of
// the coherent modulator. This is represented as a percentage
// with 2 decimal precision. This term is defined by OIF
// Implementation Agreement for Coherent CMIS. Values include
// the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-xi"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi"
func (n *Component_OpticalChannelPath) ModulatorBiasXi() *Component_OpticalChannel_ModulatorBiasXiPath {
	return &Component_OpticalChannel_ModulatorBiasXiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-xi"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasXi (container): The bias on in-phase path and Polarization X of
// the coherent modulator. This is represented as a percentage
// with 2 decimal precision. This term is defined by OIF
// Implementation Agreement for Coherent CMIS. Values include
// the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-xi"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi"
func (n *Component_OpticalChannelPathAny) ModulatorBiasXi() *Component_OpticalChannel_ModulatorBiasXiPathAny {
	return &Component_OpticalChannel_ModulatorBiasXiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-xi"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasXq (container): The bias on quadrature path and Polarization X of
// the coherent modulator. This is represented as a percentage
// with 2 decimal precision. This term is defined by OIF
// Implementation Agreement for Coherent CMIS. Values include
// the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-xq"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq"
func (n *Component_OpticalChannelPath) ModulatorBiasXq() *Component_OpticalChannel_ModulatorBiasXqPath {
	return &Component_OpticalChannel_ModulatorBiasXqPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-xq"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasXq (container): The bias on quadrature path and Polarization X of
// the coherent modulator. This is represented as a percentage
// with 2 decimal precision. This term is defined by OIF
// Implementation Agreement for Coherent CMIS. Values include
// the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-xq"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq"
func (n *Component_OpticalChannelPathAny) ModulatorBiasXq() *Component_OpticalChannel_ModulatorBiasXqPathAny {
	return &Component_OpticalChannel_ModulatorBiasXqPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-xq"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasYPhase (container): The Y-Phase bias of the coherent modulator. This is
// represented as a percentage with 2 decimal precision. This
// term is defined by OIF Implementation Agreement for
// Coherent CMIS. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply
// the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-y-phase"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase"
func (n *Component_OpticalChannelPath) ModulatorBiasYPhase() *Component_OpticalChannel_ModulatorBiasYPhasePath {
	return &Component_OpticalChannel_ModulatorBiasYPhasePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-y-phase"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasYPhase (container): The Y-Phase bias of the coherent modulator. This is
// represented as a percentage with 2 decimal precision. This
// term is defined by OIF Implementation Agreement for
// Coherent CMIS. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply
// the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-y-phase"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase"
func (n *Component_OpticalChannelPathAny) ModulatorBiasYPhase() *Component_OpticalChannel_ModulatorBiasYPhasePathAny {
	return &Component_OpticalChannel_ModulatorBiasYPhasePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-y-phase"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasYi (container): The bias on in-phase path and Polarization Y of
// the coherent modulator. This is represented as a percentage
// with 2 decimal precision. This term is defined by OIF
// Implementation Agreement for Coherent CMIS. Values include
// the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-yi"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi"
func (n *Component_OpticalChannelPath) ModulatorBiasYi() *Component_OpticalChannel_ModulatorBiasYiPath {
	return &Component_OpticalChannel_ModulatorBiasYiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-yi"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasYi (container): The bias on in-phase path and Polarization Y of
// the coherent modulator. This is represented as a percentage
// with 2 decimal precision. This term is defined by OIF
// Implementation Agreement for Coherent CMIS. Values include
// the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-yi"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi"
func (n *Component_OpticalChannelPathAny) ModulatorBiasYi() *Component_OpticalChannel_ModulatorBiasYiPathAny {
	return &Component_OpticalChannel_ModulatorBiasYiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-yi"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasYq (container): The bias on quadrature path and Polarization Y of
// the coherent modulator. This is represented as a percentage
// with 2 decimal precision. This term is defined by OIF
// Implementation Agreement for Coherent CMIS. Values include
// the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-yq"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq"
func (n *Component_OpticalChannelPath) ModulatorBiasYq() *Component_OpticalChannel_ModulatorBiasYqPath {
	return &Component_OpticalChannel_ModulatorBiasYqPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-yq"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModulatorBiasYq (container): The bias on quadrature path and Polarization Y of
// the coherent modulator. This is represented as a percentage
// with 2 decimal precision. This term is defined by OIF
// Implementation Agreement for Coherent CMIS. Values include
// the instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/modulator-bias-yq"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq"
func (n *Component_OpticalChannelPathAny) ModulatorBiasYq() *Component_OpticalChannel_ModulatorBiasYqPathAny {
	return &Component_OpticalChannel_ModulatorBiasYqPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "modulator-bias-yq"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperationalMode (leaf): Vendor-specific mode identifier -- sets the operational
// mode for the channel.  The specified operational mode must
// exist in the list of supported operational modes supplied
// by the device
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/operational-mode"
// Path from root: "/components/component/optical-channel/config/operational-mode"
func (n *Component_OpticalChannelPath) OperationalMode() *Component_OpticalChannel_OperationalModePath {
	return &Component_OpticalChannel_OperationalModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "operational-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperationalMode (leaf): Vendor-specific mode identifier -- sets the operational
// mode for the channel.  The specified operational mode must
// exist in the list of supported operational modes supplied
// by the device
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/operational-mode"
// Path from root: "/components/component/optical-channel/config/operational-mode"
func (n *Component_OpticalChannelPathAny) OperationalMode() *Component_OpticalChannel_OperationalModePathAny {
	return &Component_OpticalChannel_OperationalModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "operational-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Osnr (container): Optical signal to noise ratio at 12.5GHz noise bandwidth
// in dB with two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target
// is expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/osnr"
// Path from root: "/components/component/optical-channel/state/osnr"
func (n *Component_OpticalChannelPath) Osnr() *Component_OpticalChannel_OsnrPath {
	return &Component_OpticalChannel_OsnrPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "osnr"},
			map[string]interface{}{},
			n,
		),
	}
}

// Osnr (container): Optical signal to noise ratio at 12.5GHz noise bandwidth
// in dB with two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target
// is expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/osnr"
// Path from root: "/components/component/optical-channel/state/osnr"
func (n *Component_OpticalChannelPathAny) Osnr() *Component_OpticalChannel_OsnrPathAny {
	return &Component_OpticalChannel_OsnrPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "osnr"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): The output optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-power"
// Path from root: "/components/component/optical-channel/state/output-power"
func (n *Component_OpticalChannelPath) OutputPower() *Component_OpticalChannel_OutputPowerPath {
	return &Component_OpticalChannel_OutputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): The output optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-power"
// Path from root: "/components/component/optical-channel/state/output-power"
func (n *Component_OpticalChannelPathAny) OutputPower() *Component_OpticalChannel_OutputPowerPathAny {
	return &Component_OpticalChannel_OutputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// PolarizationDependentLoss (container): Polarization Dependent Loss of an optical channel
// in dB as reported by receiver with two decimal precision.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/polarization-dependent-loss"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss"
func (n *Component_OpticalChannelPath) PolarizationDependentLoss() *Component_OpticalChannel_PolarizationDependentLossPath {
	return &Component_OpticalChannel_PolarizationDependentLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "polarization-dependent-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// PolarizationDependentLoss (container): Polarization Dependent Loss of an optical channel
// in dB as reported by receiver with two decimal precision.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/polarization-dependent-loss"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss"
func (n *Component_OpticalChannelPathAny) PolarizationDependentLoss() *Component_OpticalChannel_PolarizationDependentLossPathAny {
	return &Component_OpticalChannel_PolarizationDependentLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "polarization-dependent-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// PolarizationModeDispersion (container): Polarization Mode Dispersion of an optical channel
// in picosends (ps) as reported by receiver with two decimal
// precision. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/polarization-mode-dispersion"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion"
func (n *Component_OpticalChannelPath) PolarizationModeDispersion() *Component_OpticalChannel_PolarizationModeDispersionPath {
	return &Component_OpticalChannel_PolarizationModeDispersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "polarization-mode-dispersion"},
			map[string]interface{}{},
			n,
		),
	}
}

// PolarizationModeDispersion (container): Polarization Mode Dispersion of an optical channel
// in picosends (ps) as reported by receiver with two decimal
// precision. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/polarization-mode-dispersion"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion"
func (n *Component_OpticalChannelPathAny) PolarizationModeDispersion() *Component_OpticalChannel_PolarizationModeDispersionPathAny {
	return &Component_OpticalChannel_PolarizationModeDispersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "polarization-mode-dispersion"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostFecBer (container): Bit error rate after forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/post-fec-ber"
// Path from root: "/components/component/optical-channel/state/post-fec-ber"
func (n *Component_OpticalChannelPath) PostFecBer() *Component_OpticalChannel_PostFecBerPath {
	return &Component_OpticalChannel_PostFecBerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "post-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostFecBer (container): Bit error rate after forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/post-fec-ber"
// Path from root: "/components/component/optical-channel/state/post-fec-ber"
func (n *Component_OpticalChannelPathAny) PostFecBer() *Component_OpticalChannel_PostFecBerPathAny {
	return &Component_OpticalChannel_PostFecBerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "post-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreFecBer (container): Bit error rate before forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/pre-fec-ber"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber"
func (n *Component_OpticalChannelPath) PreFecBer() *Component_OpticalChannel_PreFecBerPath {
	return &Component_OpticalChannel_PreFecBerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pre-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreFecBer (container): Bit error rate before forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/pre-fec-ber"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber"
func (n *Component_OpticalChannelPathAny) PreFecBer() *Component_OpticalChannel_PreFecBerPathAny {
	return &Component_OpticalChannel_PreFecBerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pre-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// QValue (container): Quality value (factor) in dB of a channel with two
// decimal precision. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/q-value"
// Path from root: "/components/component/optical-channel/state/q-value"
func (n *Component_OpticalChannelPath) QValue() *Component_OpticalChannel_QValuePath {
	return &Component_OpticalChannel_QValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "q-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// QValue (container): Quality value (factor) in dB of a channel with two
// decimal precision. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/q-value"
// Path from root: "/components/component/optical-channel/state/q-value"
func (n *Component_OpticalChannelPathAny) QValue() *Component_OpticalChannel_QValuePathAny {
	return &Component_OpticalChannel_QValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "q-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecondOrderPolarizationModeDispersion (container): Second Order Polarization Mode Dispersion of an optical
// channel in picoseconds squared (ps^2) as reported by
// receiver with two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target
// is expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/second-order-polarization-mode-dispersion"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion"
func (n *Component_OpticalChannelPath) SecondOrderPolarizationModeDispersion() *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "second-order-polarization-mode-dispersion"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecondOrderPolarizationModeDispersion (container): Second Order Polarization Mode Dispersion of an optical
// channel in picoseconds squared (ps^2) as reported by
// receiver with two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target
// is expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/second-order-polarization-mode-dispersion"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion"
func (n *Component_OpticalChannelPathAny) SecondOrderPolarizationModeDispersion() *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "second-order-polarization-mode-dispersion"},
			map[string]interface{}{},
			n,
		),
	}
}

// SopRoc (container): State-of-polarization rate-of-change (SOP-ROC) in krad/s with 1
// decimal precision. This term is defined by OIF Implementation
// Agreement for Coherent CMIS. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected to just
// supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/sop-roc"
// Path from root: "/components/component/optical-channel/state/sop-roc"
func (n *Component_OpticalChannelPath) SopRoc() *Component_OpticalChannel_SopRocPath {
	return &Component_OpticalChannel_SopRocPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sop-roc"},
			map[string]interface{}{},
			n,
		),
	}
}

// SopRoc (container): State-of-polarization rate-of-change (SOP-ROC) in krad/s with 1
// decimal precision. This term is defined by OIF Implementation
// Agreement for Coherent CMIS. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected to just
// supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/sop-roc"
// Path from root: "/components/component/optical-channel/state/sop-roc"
func (n *Component_OpticalChannelPathAny) SopRoc() *Component_OpticalChannel_SopRocPathAny {
	return &Component_OpticalChannel_SopRocPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sop-roc"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetOutputPower (leaf): Target output optical power level of the optical channel,
// expressed in increments of 0.01 dBm (decibel-milliwats)
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/target-output-power"
// Path from root: "/components/component/optical-channel/config/target-output-power"
func (n *Component_OpticalChannelPath) TargetOutputPower() *Component_OpticalChannel_TargetOutputPowerPath {
	return &Component_OpticalChannel_TargetOutputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetOutputPower (leaf): Target output optical power level of the optical channel,
// expressed in increments of 0.01 dBm (decibel-milliwats)
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/target-output-power"
// Path from root: "/components/component/optical-channel/config/target-output-power"
func (n *Component_OpticalChannelPathAny) TargetOutputPower() *Component_OpticalChannel_TargetOutputPowerPathAny {
	return &Component_OpticalChannel_TargetOutputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_CarrierFrequencyOffsetPath represents the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffsetPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffsetPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffsetPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/avg YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/avg YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/instant YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/instant YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/interval YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/interval YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/max YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/max YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/max-time YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/max-time YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_MinPath represents the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/min YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/min YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/min-time YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_CarrierFrequencyOffset_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/carrier-frequency-offset/min-time YANG schema element.
type Component_OpticalChannel_CarrierFrequencyOffset_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/avg"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPath) Avg() *Component_OpticalChannel_CarrierFrequencyOffset_AvgPath {
	return &Component_OpticalChannel_CarrierFrequencyOffset_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/avg"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPathAny) Avg() *Component_OpticalChannel_CarrierFrequencyOffset_AvgPathAny {
	return &Component_OpticalChannel_CarrierFrequencyOffset_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/instant"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPath) Instant() *Component_OpticalChannel_CarrierFrequencyOffset_InstantPath {
	return &Component_OpticalChannel_CarrierFrequencyOffset_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/instant"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPathAny) Instant() *Component_OpticalChannel_CarrierFrequencyOffset_InstantPathAny {
	return &Component_OpticalChannel_CarrierFrequencyOffset_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/interval"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPath) Interval() *Component_OpticalChannel_CarrierFrequencyOffset_IntervalPath {
	return &Component_OpticalChannel_CarrierFrequencyOffset_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/interval"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPathAny) Interval() *Component_OpticalChannel_CarrierFrequencyOffset_IntervalPathAny {
	return &Component_OpticalChannel_CarrierFrequencyOffset_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/max"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPath) Max() *Component_OpticalChannel_CarrierFrequencyOffset_MaxPath {
	return &Component_OpticalChannel_CarrierFrequencyOffset_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/max"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPathAny) Max() *Component_OpticalChannel_CarrierFrequencyOffset_MaxPathAny {
	return &Component_OpticalChannel_CarrierFrequencyOffset_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/max-time"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPath) MaxTime() *Component_OpticalChannel_CarrierFrequencyOffset_MaxTimePath {
	return &Component_OpticalChannel_CarrierFrequencyOffset_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/max-time"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPathAny) MaxTime() *Component_OpticalChannel_CarrierFrequencyOffset_MaxTimePathAny {
	return &Component_OpticalChannel_CarrierFrequencyOffset_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/min"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPath) Min() *Component_OpticalChannel_CarrierFrequencyOffset_MinPath {
	return &Component_OpticalChannel_CarrierFrequencyOffset_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/min"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPathAny) Min() *Component_OpticalChannel_CarrierFrequencyOffset_MinPathAny {
	return &Component_OpticalChannel_CarrierFrequencyOffset_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/min-time"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPath) MinTime() *Component_OpticalChannel_CarrierFrequencyOffset_MinTimePath {
	return &Component_OpticalChannel_CarrierFrequencyOffset_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/carrier-frequency-offset/min-time"
func (n *Component_OpticalChannel_CarrierFrequencyOffsetPathAny) MinTime() *Component_OpticalChannel_CarrierFrequencyOffset_MinTimePathAny {
	return &Component_OpticalChannel_CarrierFrequencyOffset_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_ChromaticDispersionPath represents the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion YANG schema element.
type Component_OpticalChannel_ChromaticDispersionPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersionPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion YANG schema element.
type Component_OpticalChannel_ChromaticDispersionPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/avg YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/avg YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/instant YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/instant YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/interval YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/interval YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/max YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/max YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/max-time YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/max-time YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_MinPath represents the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/min YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/min YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/min-time YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ChromaticDispersion_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/chromatic-dispersion/min-time YANG schema element.
type Component_OpticalChannel_ChromaticDispersion_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/avg"
func (n *Component_OpticalChannel_ChromaticDispersionPath) Avg() *Component_OpticalChannel_ChromaticDispersion_AvgPath {
	return &Component_OpticalChannel_ChromaticDispersion_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/avg"
func (n *Component_OpticalChannel_ChromaticDispersionPathAny) Avg() *Component_OpticalChannel_ChromaticDispersion_AvgPathAny {
	return &Component_OpticalChannel_ChromaticDispersion_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/instant"
func (n *Component_OpticalChannel_ChromaticDispersionPath) Instant() *Component_OpticalChannel_ChromaticDispersion_InstantPath {
	return &Component_OpticalChannel_ChromaticDispersion_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/instant"
func (n *Component_OpticalChannel_ChromaticDispersionPathAny) Instant() *Component_OpticalChannel_ChromaticDispersion_InstantPathAny {
	return &Component_OpticalChannel_ChromaticDispersion_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/interval"
func (n *Component_OpticalChannel_ChromaticDispersionPath) Interval() *Component_OpticalChannel_ChromaticDispersion_IntervalPath {
	return &Component_OpticalChannel_ChromaticDispersion_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/interval"
func (n *Component_OpticalChannel_ChromaticDispersionPathAny) Interval() *Component_OpticalChannel_ChromaticDispersion_IntervalPathAny {
	return &Component_OpticalChannel_ChromaticDispersion_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/max"
func (n *Component_OpticalChannel_ChromaticDispersionPath) Max() *Component_OpticalChannel_ChromaticDispersion_MaxPath {
	return &Component_OpticalChannel_ChromaticDispersion_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/max"
func (n *Component_OpticalChannel_ChromaticDispersionPathAny) Max() *Component_OpticalChannel_ChromaticDispersion_MaxPathAny {
	return &Component_OpticalChannel_ChromaticDispersion_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/max-time"
func (n *Component_OpticalChannel_ChromaticDispersionPath) MaxTime() *Component_OpticalChannel_ChromaticDispersion_MaxTimePath {
	return &Component_OpticalChannel_ChromaticDispersion_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/max-time"
func (n *Component_OpticalChannel_ChromaticDispersionPathAny) MaxTime() *Component_OpticalChannel_ChromaticDispersion_MaxTimePathAny {
	return &Component_OpticalChannel_ChromaticDispersion_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/min"
func (n *Component_OpticalChannel_ChromaticDispersionPath) Min() *Component_OpticalChannel_ChromaticDispersion_MinPath {
	return &Component_OpticalChannel_ChromaticDispersion_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/min"
func (n *Component_OpticalChannel_ChromaticDispersionPathAny) Min() *Component_OpticalChannel_ChromaticDispersion_MinPathAny {
	return &Component_OpticalChannel_ChromaticDispersion_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/min-time"
func (n *Component_OpticalChannel_ChromaticDispersionPath) MinTime() *Component_OpticalChannel_ChromaticDispersion_MinTimePath {
	return &Component_OpticalChannel_ChromaticDispersion_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/chromatic-dispersion/min-time"
func (n *Component_OpticalChannel_ChromaticDispersionPathAny) MinTime() *Component_OpticalChannel_ChromaticDispersion_MinTimePathAny {
	return &Component_OpticalChannel_ChromaticDispersion_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_EsnrPath represents the /openconfig-platform/components/component/optical-channel/state/esnr YANG schema element.
type Component_OpticalChannel_EsnrPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_EsnrPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/esnr YANG schema element.
type Component_OpticalChannel_EsnrPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/esnr/avg YANG schema element.
type Component_OpticalChannel_Esnr_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/esnr/avg YANG schema element.
type Component_OpticalChannel_Esnr_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/esnr/instant YANG schema element.
type Component_OpticalChannel_Esnr_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/esnr/instant YANG schema element.
type Component_OpticalChannel_Esnr_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/esnr/interval YANG schema element.
type Component_OpticalChannel_Esnr_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/esnr/interval YANG schema element.
type Component_OpticalChannel_Esnr_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/esnr/max YANG schema element.
type Component_OpticalChannel_Esnr_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/esnr/max YANG schema element.
type Component_OpticalChannel_Esnr_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/esnr/max-time YANG schema element.
type Component_OpticalChannel_Esnr_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/esnr/max-time YANG schema element.
type Component_OpticalChannel_Esnr_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_MinPath represents the /openconfig-platform/components/component/optical-channel/state/esnr/min YANG schema element.
type Component_OpticalChannel_Esnr_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/esnr/min YANG schema element.
type Component_OpticalChannel_Esnr_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/esnr/min-time YANG schema element.
type Component_OpticalChannel_Esnr_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Esnr_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/esnr/min-time YANG schema element.
type Component_OpticalChannel_Esnr_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/esnr/avg"
func (n *Component_OpticalChannel_EsnrPath) Avg() *Component_OpticalChannel_Esnr_AvgPath {
	return &Component_OpticalChannel_Esnr_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/esnr/avg"
func (n *Component_OpticalChannel_EsnrPathAny) Avg() *Component_OpticalChannel_Esnr_AvgPathAny {
	return &Component_OpticalChannel_Esnr_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/esnr/instant"
func (n *Component_OpticalChannel_EsnrPath) Instant() *Component_OpticalChannel_Esnr_InstantPath {
	return &Component_OpticalChannel_Esnr_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/esnr/instant"
func (n *Component_OpticalChannel_EsnrPathAny) Instant() *Component_OpticalChannel_Esnr_InstantPathAny {
	return &Component_OpticalChannel_Esnr_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/esnr/interval"
func (n *Component_OpticalChannel_EsnrPath) Interval() *Component_OpticalChannel_Esnr_IntervalPath {
	return &Component_OpticalChannel_Esnr_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/esnr/interval"
func (n *Component_OpticalChannel_EsnrPathAny) Interval() *Component_OpticalChannel_Esnr_IntervalPathAny {
	return &Component_OpticalChannel_Esnr_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/esnr/max"
func (n *Component_OpticalChannel_EsnrPath) Max() *Component_OpticalChannel_Esnr_MaxPath {
	return &Component_OpticalChannel_Esnr_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/esnr/max"
func (n *Component_OpticalChannel_EsnrPathAny) Max() *Component_OpticalChannel_Esnr_MaxPathAny {
	return &Component_OpticalChannel_Esnr_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/esnr/max-time"
func (n *Component_OpticalChannel_EsnrPath) MaxTime() *Component_OpticalChannel_Esnr_MaxTimePath {
	return &Component_OpticalChannel_Esnr_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/esnr/max-time"
func (n *Component_OpticalChannel_EsnrPathAny) MaxTime() *Component_OpticalChannel_Esnr_MaxTimePathAny {
	return &Component_OpticalChannel_Esnr_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/esnr/min"
func (n *Component_OpticalChannel_EsnrPath) Min() *Component_OpticalChannel_Esnr_MinPath {
	return &Component_OpticalChannel_Esnr_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/esnr/min"
func (n *Component_OpticalChannel_EsnrPathAny) Min() *Component_OpticalChannel_Esnr_MinPathAny {
	return &Component_OpticalChannel_Esnr_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/esnr/min-time"
func (n *Component_OpticalChannel_EsnrPath) MinTime() *Component_OpticalChannel_Esnr_MinTimePath {
	return &Component_OpticalChannel_Esnr_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/esnr/min-time"
func (n *Component_OpticalChannel_EsnrPathAny) MinTime() *Component_OpticalChannel_Esnr_MinTimePathAny {
	return &Component_OpticalChannel_Esnr_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_InputPowerPath represents the /openconfig-platform/components/component/optical-channel/state/input-power YANG schema element.
type Component_OpticalChannel_InputPowerPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/input-power YANG schema element.
type Component_OpticalChannel_InputPowerPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/input-power/avg YANG schema element.
type Component_OpticalChannel_InputPower_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/input-power/avg YANG schema element.
type Component_OpticalChannel_InputPower_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/input-power/instant YANG schema element.
type Component_OpticalChannel_InputPower_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/input-power/instant YANG schema element.
type Component_OpticalChannel_InputPower_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/input-power/interval YANG schema element.
type Component_OpticalChannel_InputPower_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/input-power/interval YANG schema element.
type Component_OpticalChannel_InputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/input-power/max YANG schema element.
type Component_OpticalChannel_InputPower_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/input-power/max YANG schema element.
type Component_OpticalChannel_InputPower_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/input-power/max-time YANG schema element.
type Component_OpticalChannel_InputPower_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/input-power/max-time YANG schema element.
type Component_OpticalChannel_InputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_MinPath represents the /openconfig-platform/components/component/optical-channel/state/input-power/min YANG schema element.
type Component_OpticalChannel_InputPower_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/input-power/min YANG schema element.
type Component_OpticalChannel_InputPower_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/input-power/min-time YANG schema element.
type Component_OpticalChannel_InputPower_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_InputPower_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/input-power/min-time YANG schema element.
type Component_OpticalChannel_InputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/input-power/avg"
func (n *Component_OpticalChannel_InputPowerPath) Avg() *Component_OpticalChannel_InputPower_AvgPath {
	return &Component_OpticalChannel_InputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/input-power/avg"
func (n *Component_OpticalChannel_InputPowerPathAny) Avg() *Component_OpticalChannel_InputPower_AvgPathAny {
	return &Component_OpticalChannel_InputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/input-power/instant"
func (n *Component_OpticalChannel_InputPowerPath) Instant() *Component_OpticalChannel_InputPower_InstantPath {
	return &Component_OpticalChannel_InputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/input-power/instant"
func (n *Component_OpticalChannel_InputPowerPathAny) Instant() *Component_OpticalChannel_InputPower_InstantPathAny {
	return &Component_OpticalChannel_InputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/input-power/interval"
func (n *Component_OpticalChannel_InputPowerPath) Interval() *Component_OpticalChannel_InputPower_IntervalPath {
	return &Component_OpticalChannel_InputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/input-power/interval"
func (n *Component_OpticalChannel_InputPowerPathAny) Interval() *Component_OpticalChannel_InputPower_IntervalPathAny {
	return &Component_OpticalChannel_InputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/input-power/max"
func (n *Component_OpticalChannel_InputPowerPath) Max() *Component_OpticalChannel_InputPower_MaxPath {
	return &Component_OpticalChannel_InputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/input-power/max"
func (n *Component_OpticalChannel_InputPowerPathAny) Max() *Component_OpticalChannel_InputPower_MaxPathAny {
	return &Component_OpticalChannel_InputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/input-power/max-time"
func (n *Component_OpticalChannel_InputPowerPath) MaxTime() *Component_OpticalChannel_InputPower_MaxTimePath {
	return &Component_OpticalChannel_InputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/input-power/max-time"
func (n *Component_OpticalChannel_InputPowerPathAny) MaxTime() *Component_OpticalChannel_InputPower_MaxTimePathAny {
	return &Component_OpticalChannel_InputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/input-power/min"
func (n *Component_OpticalChannel_InputPowerPath) Min() *Component_OpticalChannel_InputPower_MinPath {
	return &Component_OpticalChannel_InputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/input-power/min"
func (n *Component_OpticalChannel_InputPowerPathAny) Min() *Component_OpticalChannel_InputPower_MinPathAny {
	return &Component_OpticalChannel_InputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/input-power/min-time"
func (n *Component_OpticalChannel_InputPowerPath) MinTime() *Component_OpticalChannel_InputPower_MinTimePath {
	return &Component_OpticalChannel_InputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/input-power/min-time"
func (n *Component_OpticalChannel_InputPowerPathAny) MinTime() *Component_OpticalChannel_InputPower_MinTimePathAny {
	return &Component_OpticalChannel_InputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_LaserBiasCurrentPath represents the /openconfig-platform/components/component/optical-channel/state/laser-bias-current YANG schema element.
type Component_OpticalChannel_LaserBiasCurrentPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrentPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/laser-bias-current YANG schema element.
type Component_OpticalChannel_LaserBiasCurrentPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/avg YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/avg YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/instant YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/instant YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/interval YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/interval YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/max YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/max YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/max-time YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/max-time YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_MinPath represents the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/min YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/min YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/min-time YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_LaserBiasCurrent_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/laser-bias-current/min-time YANG schema element.
type Component_OpticalChannel_LaserBiasCurrent_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/avg"
func (n *Component_OpticalChannel_LaserBiasCurrentPath) Avg() *Component_OpticalChannel_LaserBiasCurrent_AvgPath {
	return &Component_OpticalChannel_LaserBiasCurrent_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/avg"
func (n *Component_OpticalChannel_LaserBiasCurrentPathAny) Avg() *Component_OpticalChannel_LaserBiasCurrent_AvgPathAny {
	return &Component_OpticalChannel_LaserBiasCurrent_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/instant"
func (n *Component_OpticalChannel_LaserBiasCurrentPath) Instant() *Component_OpticalChannel_LaserBiasCurrent_InstantPath {
	return &Component_OpticalChannel_LaserBiasCurrent_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/instant"
func (n *Component_OpticalChannel_LaserBiasCurrentPathAny) Instant() *Component_OpticalChannel_LaserBiasCurrent_InstantPathAny {
	return &Component_OpticalChannel_LaserBiasCurrent_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/interval"
func (n *Component_OpticalChannel_LaserBiasCurrentPath) Interval() *Component_OpticalChannel_LaserBiasCurrent_IntervalPath {
	return &Component_OpticalChannel_LaserBiasCurrent_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/interval"
func (n *Component_OpticalChannel_LaserBiasCurrentPathAny) Interval() *Component_OpticalChannel_LaserBiasCurrent_IntervalPathAny {
	return &Component_OpticalChannel_LaserBiasCurrent_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/max"
func (n *Component_OpticalChannel_LaserBiasCurrentPath) Max() *Component_OpticalChannel_LaserBiasCurrent_MaxPath {
	return &Component_OpticalChannel_LaserBiasCurrent_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/max"
func (n *Component_OpticalChannel_LaserBiasCurrentPathAny) Max() *Component_OpticalChannel_LaserBiasCurrent_MaxPathAny {
	return &Component_OpticalChannel_LaserBiasCurrent_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/max-time"
func (n *Component_OpticalChannel_LaserBiasCurrentPath) MaxTime() *Component_OpticalChannel_LaserBiasCurrent_MaxTimePath {
	return &Component_OpticalChannel_LaserBiasCurrent_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/max-time"
func (n *Component_OpticalChannel_LaserBiasCurrentPathAny) MaxTime() *Component_OpticalChannel_LaserBiasCurrent_MaxTimePathAny {
	return &Component_OpticalChannel_LaserBiasCurrent_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/min"
func (n *Component_OpticalChannel_LaserBiasCurrentPath) Min() *Component_OpticalChannel_LaserBiasCurrent_MinPath {
	return &Component_OpticalChannel_LaserBiasCurrent_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/min"
func (n *Component_OpticalChannel_LaserBiasCurrentPathAny) Min() *Component_OpticalChannel_LaserBiasCurrent_MinPathAny {
	return &Component_OpticalChannel_LaserBiasCurrent_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/min-time"
func (n *Component_OpticalChannel_LaserBiasCurrentPath) MinTime() *Component_OpticalChannel_LaserBiasCurrent_MinTimePath {
	return &Component_OpticalChannel_LaserBiasCurrent_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/laser-bias-current/min-time"
func (n *Component_OpticalChannel_LaserBiasCurrentPathAny) MinTime() *Component_OpticalChannel_LaserBiasCurrent_MinTimePathAny {
	return &Component_OpticalChannel_LaserBiasCurrent_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_ModulationErrorRatioPath represents the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio YANG schema element.
type Component_OpticalChannel_ModulationErrorRatioPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatioPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio YANG schema element.
type Component_OpticalChannel_ModulationErrorRatioPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/avg YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/avg YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/instant YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/instant YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/interval YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/interval YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/max YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/max YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/max-time YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/max-time YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_MinPath represents the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/min YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/min YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/min-time YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulationErrorRatio_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulation-error-ratio/min-time YANG schema element.
type Component_OpticalChannel_ModulationErrorRatio_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/avg"
func (n *Component_OpticalChannel_ModulationErrorRatioPath) Avg() *Component_OpticalChannel_ModulationErrorRatio_AvgPath {
	return &Component_OpticalChannel_ModulationErrorRatio_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/avg"
func (n *Component_OpticalChannel_ModulationErrorRatioPathAny) Avg() *Component_OpticalChannel_ModulationErrorRatio_AvgPathAny {
	return &Component_OpticalChannel_ModulationErrorRatio_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/instant"
func (n *Component_OpticalChannel_ModulationErrorRatioPath) Instant() *Component_OpticalChannel_ModulationErrorRatio_InstantPath {
	return &Component_OpticalChannel_ModulationErrorRatio_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/instant"
func (n *Component_OpticalChannel_ModulationErrorRatioPathAny) Instant() *Component_OpticalChannel_ModulationErrorRatio_InstantPathAny {
	return &Component_OpticalChannel_ModulationErrorRatio_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/interval"
func (n *Component_OpticalChannel_ModulationErrorRatioPath) Interval() *Component_OpticalChannel_ModulationErrorRatio_IntervalPath {
	return &Component_OpticalChannel_ModulationErrorRatio_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/interval"
func (n *Component_OpticalChannel_ModulationErrorRatioPathAny) Interval() *Component_OpticalChannel_ModulationErrorRatio_IntervalPathAny {
	return &Component_OpticalChannel_ModulationErrorRatio_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/max"
func (n *Component_OpticalChannel_ModulationErrorRatioPath) Max() *Component_OpticalChannel_ModulationErrorRatio_MaxPath {
	return &Component_OpticalChannel_ModulationErrorRatio_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/max"
func (n *Component_OpticalChannel_ModulationErrorRatioPathAny) Max() *Component_OpticalChannel_ModulationErrorRatio_MaxPathAny {
	return &Component_OpticalChannel_ModulationErrorRatio_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/max-time"
func (n *Component_OpticalChannel_ModulationErrorRatioPath) MaxTime() *Component_OpticalChannel_ModulationErrorRatio_MaxTimePath {
	return &Component_OpticalChannel_ModulationErrorRatio_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/max-time"
func (n *Component_OpticalChannel_ModulationErrorRatioPathAny) MaxTime() *Component_OpticalChannel_ModulationErrorRatio_MaxTimePathAny {
	return &Component_OpticalChannel_ModulationErrorRatio_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/min"
func (n *Component_OpticalChannel_ModulationErrorRatioPath) Min() *Component_OpticalChannel_ModulationErrorRatio_MinPath {
	return &Component_OpticalChannel_ModulationErrorRatio_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/min"
func (n *Component_OpticalChannel_ModulationErrorRatioPathAny) Min() *Component_OpticalChannel_ModulationErrorRatio_MinPathAny {
	return &Component_OpticalChannel_ModulationErrorRatio_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/min-time"
func (n *Component_OpticalChannel_ModulationErrorRatioPath) MinTime() *Component_OpticalChannel_ModulationErrorRatio_MinTimePath {
	return &Component_OpticalChannel_ModulationErrorRatio_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulation-error-ratio/min-time"
func (n *Component_OpticalChannel_ModulationErrorRatioPathAny) MinTime() *Component_OpticalChannel_ModulationErrorRatio_MinTimePathAny {
	return &Component_OpticalChannel_ModulationErrorRatio_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_ModulatorBiasXPhasePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhasePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhasePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhasePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_MinPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXPhase_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-x-phase/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXPhase_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/avg"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePath) Avg() *Component_OpticalChannel_ModulatorBiasXPhase_AvgPath {
	return &Component_OpticalChannel_ModulatorBiasXPhase_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/avg"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePathAny) Avg() *Component_OpticalChannel_ModulatorBiasXPhase_AvgPathAny {
	return &Component_OpticalChannel_ModulatorBiasXPhase_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/instant"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePath) Instant() *Component_OpticalChannel_ModulatorBiasXPhase_InstantPath {
	return &Component_OpticalChannel_ModulatorBiasXPhase_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/instant"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePathAny) Instant() *Component_OpticalChannel_ModulatorBiasXPhase_InstantPathAny {
	return &Component_OpticalChannel_ModulatorBiasXPhase_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/interval"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePath) Interval() *Component_OpticalChannel_ModulatorBiasXPhase_IntervalPath {
	return &Component_OpticalChannel_ModulatorBiasXPhase_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/interval"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePathAny) Interval() *Component_OpticalChannel_ModulatorBiasXPhase_IntervalPathAny {
	return &Component_OpticalChannel_ModulatorBiasXPhase_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/max"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePath) Max() *Component_OpticalChannel_ModulatorBiasXPhase_MaxPath {
	return &Component_OpticalChannel_ModulatorBiasXPhase_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/max"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePathAny) Max() *Component_OpticalChannel_ModulatorBiasXPhase_MaxPathAny {
	return &Component_OpticalChannel_ModulatorBiasXPhase_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/max-time"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePath) MaxTime() *Component_OpticalChannel_ModulatorBiasXPhase_MaxTimePath {
	return &Component_OpticalChannel_ModulatorBiasXPhase_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/max-time"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePathAny) MaxTime() *Component_OpticalChannel_ModulatorBiasXPhase_MaxTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasXPhase_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/min"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePath) Min() *Component_OpticalChannel_ModulatorBiasXPhase_MinPath {
	return &Component_OpticalChannel_ModulatorBiasXPhase_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/min"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePathAny) Min() *Component_OpticalChannel_ModulatorBiasXPhase_MinPathAny {
	return &Component_OpticalChannel_ModulatorBiasXPhase_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/min-time"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePath) MinTime() *Component_OpticalChannel_ModulatorBiasXPhase_MinTimePath {
	return &Component_OpticalChannel_ModulatorBiasXPhase_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-x-phase/min-time"
func (n *Component_OpticalChannel_ModulatorBiasXPhasePathAny) MinTime() *Component_OpticalChannel_ModulatorBiasXPhase_MinTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasXPhase_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_ModulatorBiasXiPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi YANG schema element.
type Component_OpticalChannel_ModulatorBiasXiPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXiPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi YANG schema element.
type Component_OpticalChannel_ModulatorBiasXiPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_MinPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXi_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xi/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXi_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/avg"
func (n *Component_OpticalChannel_ModulatorBiasXiPath) Avg() *Component_OpticalChannel_ModulatorBiasXi_AvgPath {
	return &Component_OpticalChannel_ModulatorBiasXi_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/avg"
func (n *Component_OpticalChannel_ModulatorBiasXiPathAny) Avg() *Component_OpticalChannel_ModulatorBiasXi_AvgPathAny {
	return &Component_OpticalChannel_ModulatorBiasXi_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/instant"
func (n *Component_OpticalChannel_ModulatorBiasXiPath) Instant() *Component_OpticalChannel_ModulatorBiasXi_InstantPath {
	return &Component_OpticalChannel_ModulatorBiasXi_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/instant"
func (n *Component_OpticalChannel_ModulatorBiasXiPathAny) Instant() *Component_OpticalChannel_ModulatorBiasXi_InstantPathAny {
	return &Component_OpticalChannel_ModulatorBiasXi_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/interval"
func (n *Component_OpticalChannel_ModulatorBiasXiPath) Interval() *Component_OpticalChannel_ModulatorBiasXi_IntervalPath {
	return &Component_OpticalChannel_ModulatorBiasXi_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/interval"
func (n *Component_OpticalChannel_ModulatorBiasXiPathAny) Interval() *Component_OpticalChannel_ModulatorBiasXi_IntervalPathAny {
	return &Component_OpticalChannel_ModulatorBiasXi_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/max"
func (n *Component_OpticalChannel_ModulatorBiasXiPath) Max() *Component_OpticalChannel_ModulatorBiasXi_MaxPath {
	return &Component_OpticalChannel_ModulatorBiasXi_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/max"
func (n *Component_OpticalChannel_ModulatorBiasXiPathAny) Max() *Component_OpticalChannel_ModulatorBiasXi_MaxPathAny {
	return &Component_OpticalChannel_ModulatorBiasXi_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/max-time"
func (n *Component_OpticalChannel_ModulatorBiasXiPath) MaxTime() *Component_OpticalChannel_ModulatorBiasXi_MaxTimePath {
	return &Component_OpticalChannel_ModulatorBiasXi_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/max-time"
func (n *Component_OpticalChannel_ModulatorBiasXiPathAny) MaxTime() *Component_OpticalChannel_ModulatorBiasXi_MaxTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasXi_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/min"
func (n *Component_OpticalChannel_ModulatorBiasXiPath) Min() *Component_OpticalChannel_ModulatorBiasXi_MinPath {
	return &Component_OpticalChannel_ModulatorBiasXi_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/min"
func (n *Component_OpticalChannel_ModulatorBiasXiPathAny) Min() *Component_OpticalChannel_ModulatorBiasXi_MinPathAny {
	return &Component_OpticalChannel_ModulatorBiasXi_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/min-time"
func (n *Component_OpticalChannel_ModulatorBiasXiPath) MinTime() *Component_OpticalChannel_ModulatorBiasXi_MinTimePath {
	return &Component_OpticalChannel_ModulatorBiasXi_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xi/min-time"
func (n *Component_OpticalChannel_ModulatorBiasXiPathAny) MinTime() *Component_OpticalChannel_ModulatorBiasXi_MinTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasXi_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_ModulatorBiasXqPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq YANG schema element.
type Component_OpticalChannel_ModulatorBiasXqPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXqPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq YANG schema element.
type Component_OpticalChannel_ModulatorBiasXqPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_MinPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasXq_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-xq/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasXq_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/avg"
func (n *Component_OpticalChannel_ModulatorBiasXqPath) Avg() *Component_OpticalChannel_ModulatorBiasXq_AvgPath {
	return &Component_OpticalChannel_ModulatorBiasXq_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/avg"
func (n *Component_OpticalChannel_ModulatorBiasXqPathAny) Avg() *Component_OpticalChannel_ModulatorBiasXq_AvgPathAny {
	return &Component_OpticalChannel_ModulatorBiasXq_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/instant"
func (n *Component_OpticalChannel_ModulatorBiasXqPath) Instant() *Component_OpticalChannel_ModulatorBiasXq_InstantPath {
	return &Component_OpticalChannel_ModulatorBiasXq_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/instant"
func (n *Component_OpticalChannel_ModulatorBiasXqPathAny) Instant() *Component_OpticalChannel_ModulatorBiasXq_InstantPathAny {
	return &Component_OpticalChannel_ModulatorBiasXq_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/interval"
func (n *Component_OpticalChannel_ModulatorBiasXqPath) Interval() *Component_OpticalChannel_ModulatorBiasXq_IntervalPath {
	return &Component_OpticalChannel_ModulatorBiasXq_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/interval"
func (n *Component_OpticalChannel_ModulatorBiasXqPathAny) Interval() *Component_OpticalChannel_ModulatorBiasXq_IntervalPathAny {
	return &Component_OpticalChannel_ModulatorBiasXq_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/max"
func (n *Component_OpticalChannel_ModulatorBiasXqPath) Max() *Component_OpticalChannel_ModulatorBiasXq_MaxPath {
	return &Component_OpticalChannel_ModulatorBiasXq_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/max"
func (n *Component_OpticalChannel_ModulatorBiasXqPathAny) Max() *Component_OpticalChannel_ModulatorBiasXq_MaxPathAny {
	return &Component_OpticalChannel_ModulatorBiasXq_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/max-time"
func (n *Component_OpticalChannel_ModulatorBiasXqPath) MaxTime() *Component_OpticalChannel_ModulatorBiasXq_MaxTimePath {
	return &Component_OpticalChannel_ModulatorBiasXq_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/max-time"
func (n *Component_OpticalChannel_ModulatorBiasXqPathAny) MaxTime() *Component_OpticalChannel_ModulatorBiasXq_MaxTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasXq_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/min"
func (n *Component_OpticalChannel_ModulatorBiasXqPath) Min() *Component_OpticalChannel_ModulatorBiasXq_MinPath {
	return &Component_OpticalChannel_ModulatorBiasXq_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/min"
func (n *Component_OpticalChannel_ModulatorBiasXqPathAny) Min() *Component_OpticalChannel_ModulatorBiasXq_MinPathAny {
	return &Component_OpticalChannel_ModulatorBiasXq_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/min-time"
func (n *Component_OpticalChannel_ModulatorBiasXqPath) MinTime() *Component_OpticalChannel_ModulatorBiasXq_MinTimePath {
	return &Component_OpticalChannel_ModulatorBiasXq_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-xq/min-time"
func (n *Component_OpticalChannel_ModulatorBiasXqPathAny) MinTime() *Component_OpticalChannel_ModulatorBiasXq_MinTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasXq_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_ModulatorBiasYPhasePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhasePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhasePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhasePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_MinPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYPhase_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-y-phase/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYPhase_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/avg"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePath) Avg() *Component_OpticalChannel_ModulatorBiasYPhase_AvgPath {
	return &Component_OpticalChannel_ModulatorBiasYPhase_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/avg"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePathAny) Avg() *Component_OpticalChannel_ModulatorBiasYPhase_AvgPathAny {
	return &Component_OpticalChannel_ModulatorBiasYPhase_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/instant"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePath) Instant() *Component_OpticalChannel_ModulatorBiasYPhase_InstantPath {
	return &Component_OpticalChannel_ModulatorBiasYPhase_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/instant"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePathAny) Instant() *Component_OpticalChannel_ModulatorBiasYPhase_InstantPathAny {
	return &Component_OpticalChannel_ModulatorBiasYPhase_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/interval"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePath) Interval() *Component_OpticalChannel_ModulatorBiasYPhase_IntervalPath {
	return &Component_OpticalChannel_ModulatorBiasYPhase_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/interval"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePathAny) Interval() *Component_OpticalChannel_ModulatorBiasYPhase_IntervalPathAny {
	return &Component_OpticalChannel_ModulatorBiasYPhase_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/max"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePath) Max() *Component_OpticalChannel_ModulatorBiasYPhase_MaxPath {
	return &Component_OpticalChannel_ModulatorBiasYPhase_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/max"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePathAny) Max() *Component_OpticalChannel_ModulatorBiasYPhase_MaxPathAny {
	return &Component_OpticalChannel_ModulatorBiasYPhase_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/max-time"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePath) MaxTime() *Component_OpticalChannel_ModulatorBiasYPhase_MaxTimePath {
	return &Component_OpticalChannel_ModulatorBiasYPhase_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/max-time"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePathAny) MaxTime() *Component_OpticalChannel_ModulatorBiasYPhase_MaxTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasYPhase_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/min"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePath) Min() *Component_OpticalChannel_ModulatorBiasYPhase_MinPath {
	return &Component_OpticalChannel_ModulatorBiasYPhase_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/min"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePathAny) Min() *Component_OpticalChannel_ModulatorBiasYPhase_MinPathAny {
	return &Component_OpticalChannel_ModulatorBiasYPhase_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/min-time"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePath) MinTime() *Component_OpticalChannel_ModulatorBiasYPhase_MinTimePath {
	return &Component_OpticalChannel_ModulatorBiasYPhase_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-y-phase/min-time"
func (n *Component_OpticalChannel_ModulatorBiasYPhasePathAny) MinTime() *Component_OpticalChannel_ModulatorBiasYPhase_MinTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasYPhase_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_ModulatorBiasYiPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi YANG schema element.
type Component_OpticalChannel_ModulatorBiasYiPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYiPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi YANG schema element.
type Component_OpticalChannel_ModulatorBiasYiPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_MinPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYi_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yi/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYi_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/avg"
func (n *Component_OpticalChannel_ModulatorBiasYiPath) Avg() *Component_OpticalChannel_ModulatorBiasYi_AvgPath {
	return &Component_OpticalChannel_ModulatorBiasYi_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/avg"
func (n *Component_OpticalChannel_ModulatorBiasYiPathAny) Avg() *Component_OpticalChannel_ModulatorBiasYi_AvgPathAny {
	return &Component_OpticalChannel_ModulatorBiasYi_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/instant"
func (n *Component_OpticalChannel_ModulatorBiasYiPath) Instant() *Component_OpticalChannel_ModulatorBiasYi_InstantPath {
	return &Component_OpticalChannel_ModulatorBiasYi_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/instant"
func (n *Component_OpticalChannel_ModulatorBiasYiPathAny) Instant() *Component_OpticalChannel_ModulatorBiasYi_InstantPathAny {
	return &Component_OpticalChannel_ModulatorBiasYi_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/interval"
func (n *Component_OpticalChannel_ModulatorBiasYiPath) Interval() *Component_OpticalChannel_ModulatorBiasYi_IntervalPath {
	return &Component_OpticalChannel_ModulatorBiasYi_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/interval"
func (n *Component_OpticalChannel_ModulatorBiasYiPathAny) Interval() *Component_OpticalChannel_ModulatorBiasYi_IntervalPathAny {
	return &Component_OpticalChannel_ModulatorBiasYi_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/max"
func (n *Component_OpticalChannel_ModulatorBiasYiPath) Max() *Component_OpticalChannel_ModulatorBiasYi_MaxPath {
	return &Component_OpticalChannel_ModulatorBiasYi_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/max"
func (n *Component_OpticalChannel_ModulatorBiasYiPathAny) Max() *Component_OpticalChannel_ModulatorBiasYi_MaxPathAny {
	return &Component_OpticalChannel_ModulatorBiasYi_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/max-time"
func (n *Component_OpticalChannel_ModulatorBiasYiPath) MaxTime() *Component_OpticalChannel_ModulatorBiasYi_MaxTimePath {
	return &Component_OpticalChannel_ModulatorBiasYi_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/max-time"
func (n *Component_OpticalChannel_ModulatorBiasYiPathAny) MaxTime() *Component_OpticalChannel_ModulatorBiasYi_MaxTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasYi_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/min"
func (n *Component_OpticalChannel_ModulatorBiasYiPath) Min() *Component_OpticalChannel_ModulatorBiasYi_MinPath {
	return &Component_OpticalChannel_ModulatorBiasYi_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/min"
func (n *Component_OpticalChannel_ModulatorBiasYiPathAny) Min() *Component_OpticalChannel_ModulatorBiasYi_MinPathAny {
	return &Component_OpticalChannel_ModulatorBiasYi_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/min-time"
func (n *Component_OpticalChannel_ModulatorBiasYiPath) MinTime() *Component_OpticalChannel_ModulatorBiasYi_MinTimePath {
	return &Component_OpticalChannel_ModulatorBiasYi_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yi/min-time"
func (n *Component_OpticalChannel_ModulatorBiasYiPathAny) MinTime() *Component_OpticalChannel_ModulatorBiasYi_MinTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasYi_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_ModulatorBiasYqPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq YANG schema element.
type Component_OpticalChannel_ModulatorBiasYqPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYqPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq YANG schema element.
type Component_OpticalChannel_ModulatorBiasYqPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/avg YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/instant YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/interval YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/max YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/max-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_MinPath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/min YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_ModulatorBiasYq_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/modulator-bias-yq/min-time YANG schema element.
type Component_OpticalChannel_ModulatorBiasYq_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/avg"
func (n *Component_OpticalChannel_ModulatorBiasYqPath) Avg() *Component_OpticalChannel_ModulatorBiasYq_AvgPath {
	return &Component_OpticalChannel_ModulatorBiasYq_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/avg"
func (n *Component_OpticalChannel_ModulatorBiasYqPathAny) Avg() *Component_OpticalChannel_ModulatorBiasYq_AvgPathAny {
	return &Component_OpticalChannel_ModulatorBiasYq_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/instant"
func (n *Component_OpticalChannel_ModulatorBiasYqPath) Instant() *Component_OpticalChannel_ModulatorBiasYq_InstantPath {
	return &Component_OpticalChannel_ModulatorBiasYq_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/instant"
func (n *Component_OpticalChannel_ModulatorBiasYqPathAny) Instant() *Component_OpticalChannel_ModulatorBiasYq_InstantPathAny {
	return &Component_OpticalChannel_ModulatorBiasYq_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/interval"
func (n *Component_OpticalChannel_ModulatorBiasYqPath) Interval() *Component_OpticalChannel_ModulatorBiasYq_IntervalPath {
	return &Component_OpticalChannel_ModulatorBiasYq_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/interval"
func (n *Component_OpticalChannel_ModulatorBiasYqPathAny) Interval() *Component_OpticalChannel_ModulatorBiasYq_IntervalPathAny {
	return &Component_OpticalChannel_ModulatorBiasYq_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/max"
func (n *Component_OpticalChannel_ModulatorBiasYqPath) Max() *Component_OpticalChannel_ModulatorBiasYq_MaxPath {
	return &Component_OpticalChannel_ModulatorBiasYq_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/max"
func (n *Component_OpticalChannel_ModulatorBiasYqPathAny) Max() *Component_OpticalChannel_ModulatorBiasYq_MaxPathAny {
	return &Component_OpticalChannel_ModulatorBiasYq_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/max-time"
func (n *Component_OpticalChannel_ModulatorBiasYqPath) MaxTime() *Component_OpticalChannel_ModulatorBiasYq_MaxTimePath {
	return &Component_OpticalChannel_ModulatorBiasYq_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/max-time"
func (n *Component_OpticalChannel_ModulatorBiasYqPathAny) MaxTime() *Component_OpticalChannel_ModulatorBiasYq_MaxTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasYq_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/min"
func (n *Component_OpticalChannel_ModulatorBiasYqPath) Min() *Component_OpticalChannel_ModulatorBiasYq_MinPath {
	return &Component_OpticalChannel_ModulatorBiasYq_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/min"
func (n *Component_OpticalChannel_ModulatorBiasYqPathAny) Min() *Component_OpticalChannel_ModulatorBiasYq_MinPathAny {
	return &Component_OpticalChannel_ModulatorBiasYq_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/min-time"
func (n *Component_OpticalChannel_ModulatorBiasYqPath) MinTime() *Component_OpticalChannel_ModulatorBiasYq_MinTimePath {
	return &Component_OpticalChannel_ModulatorBiasYq_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/modulator-bias-yq/min-time"
func (n *Component_OpticalChannel_ModulatorBiasYqPathAny) MinTime() *Component_OpticalChannel_ModulatorBiasYq_MinTimePathAny {
	return &Component_OpticalChannel_ModulatorBiasYq_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_OsnrPath represents the /openconfig-platform/components/component/optical-channel/state/osnr YANG schema element.
type Component_OpticalChannel_OsnrPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OsnrPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/osnr YANG schema element.
type Component_OpticalChannel_OsnrPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/osnr/avg YANG schema element.
type Component_OpticalChannel_Osnr_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/osnr/avg YANG schema element.
type Component_OpticalChannel_Osnr_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/osnr/instant YANG schema element.
type Component_OpticalChannel_Osnr_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/osnr/instant YANG schema element.
type Component_OpticalChannel_Osnr_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/osnr/interval YANG schema element.
type Component_OpticalChannel_Osnr_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/osnr/interval YANG schema element.
type Component_OpticalChannel_Osnr_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/osnr/max YANG schema element.
type Component_OpticalChannel_Osnr_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/osnr/max YANG schema element.
type Component_OpticalChannel_Osnr_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/osnr/max-time YANG schema element.
type Component_OpticalChannel_Osnr_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/osnr/max-time YANG schema element.
type Component_OpticalChannel_Osnr_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_MinPath represents the /openconfig-platform/components/component/optical-channel/state/osnr/min YANG schema element.
type Component_OpticalChannel_Osnr_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/osnr/min YANG schema element.
type Component_OpticalChannel_Osnr_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/osnr/min-time YANG schema element.
type Component_OpticalChannel_Osnr_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_Osnr_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/osnr/min-time YANG schema element.
type Component_OpticalChannel_Osnr_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/osnr/avg"
func (n *Component_OpticalChannel_OsnrPath) Avg() *Component_OpticalChannel_Osnr_AvgPath {
	return &Component_OpticalChannel_Osnr_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/osnr/avg"
func (n *Component_OpticalChannel_OsnrPathAny) Avg() *Component_OpticalChannel_Osnr_AvgPathAny {
	return &Component_OpticalChannel_Osnr_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/osnr/instant"
func (n *Component_OpticalChannel_OsnrPath) Instant() *Component_OpticalChannel_Osnr_InstantPath {
	return &Component_OpticalChannel_Osnr_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/osnr/instant"
func (n *Component_OpticalChannel_OsnrPathAny) Instant() *Component_OpticalChannel_Osnr_InstantPathAny {
	return &Component_OpticalChannel_Osnr_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/osnr/interval"
func (n *Component_OpticalChannel_OsnrPath) Interval() *Component_OpticalChannel_Osnr_IntervalPath {
	return &Component_OpticalChannel_Osnr_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/osnr/interval"
func (n *Component_OpticalChannel_OsnrPathAny) Interval() *Component_OpticalChannel_Osnr_IntervalPathAny {
	return &Component_OpticalChannel_Osnr_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/osnr/max"
func (n *Component_OpticalChannel_OsnrPath) Max() *Component_OpticalChannel_Osnr_MaxPath {
	return &Component_OpticalChannel_Osnr_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/osnr/max"
func (n *Component_OpticalChannel_OsnrPathAny) Max() *Component_OpticalChannel_Osnr_MaxPathAny {
	return &Component_OpticalChannel_Osnr_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/osnr/max-time"
func (n *Component_OpticalChannel_OsnrPath) MaxTime() *Component_OpticalChannel_Osnr_MaxTimePath {
	return &Component_OpticalChannel_Osnr_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/osnr/max-time"
func (n *Component_OpticalChannel_OsnrPathAny) MaxTime() *Component_OpticalChannel_Osnr_MaxTimePathAny {
	return &Component_OpticalChannel_Osnr_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/osnr/min"
func (n *Component_OpticalChannel_OsnrPath) Min() *Component_OpticalChannel_Osnr_MinPath {
	return &Component_OpticalChannel_Osnr_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/osnr/min"
func (n *Component_OpticalChannel_OsnrPathAny) Min() *Component_OpticalChannel_Osnr_MinPathAny {
	return &Component_OpticalChannel_Osnr_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/osnr/min-time"
func (n *Component_OpticalChannel_OsnrPath) MinTime() *Component_OpticalChannel_Osnr_MinTimePath {
	return &Component_OpticalChannel_Osnr_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/osnr/min-time"
func (n *Component_OpticalChannel_OsnrPathAny) MinTime() *Component_OpticalChannel_Osnr_MinTimePathAny {
	return &Component_OpticalChannel_Osnr_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_OutputPowerPath represents the /openconfig-platform/components/component/optical-channel/state/output-power YANG schema element.
type Component_OpticalChannel_OutputPowerPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/output-power YANG schema element.
type Component_OpticalChannel_OutputPowerPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/output-power/avg YANG schema element.
type Component_OpticalChannel_OutputPower_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/output-power/avg YANG schema element.
type Component_OpticalChannel_OutputPower_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/output-power/instant YANG schema element.
type Component_OpticalChannel_OutputPower_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/output-power/instant YANG schema element.
type Component_OpticalChannel_OutputPower_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/output-power/interval YANG schema element.
type Component_OpticalChannel_OutputPower_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/output-power/interval YANG schema element.
type Component_OpticalChannel_OutputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/output-power/max YANG schema element.
type Component_OpticalChannel_OutputPower_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/output-power/max YANG schema element.
type Component_OpticalChannel_OutputPower_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/output-power/max-time YANG schema element.
type Component_OpticalChannel_OutputPower_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/output-power/max-time YANG schema element.
type Component_OpticalChannel_OutputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_MinPath represents the /openconfig-platform/components/component/optical-channel/state/output-power/min YANG schema element.
type Component_OpticalChannel_OutputPower_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/output-power/min YANG schema element.
type Component_OpticalChannel_OutputPower_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/output-power/min-time YANG schema element.
type Component_OpticalChannel_OutputPower_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_OutputPower_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/output-power/min-time YANG schema element.
type Component_OpticalChannel_OutputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/output-power/avg"
func (n *Component_OpticalChannel_OutputPowerPath) Avg() *Component_OpticalChannel_OutputPower_AvgPath {
	return &Component_OpticalChannel_OutputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/output-power/avg"
func (n *Component_OpticalChannel_OutputPowerPathAny) Avg() *Component_OpticalChannel_OutputPower_AvgPathAny {
	return &Component_OpticalChannel_OutputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/output-power/instant"
func (n *Component_OpticalChannel_OutputPowerPath) Instant() *Component_OpticalChannel_OutputPower_InstantPath {
	return &Component_OpticalChannel_OutputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/output-power/instant"
func (n *Component_OpticalChannel_OutputPowerPathAny) Instant() *Component_OpticalChannel_OutputPower_InstantPathAny {
	return &Component_OpticalChannel_OutputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/output-power/interval"
func (n *Component_OpticalChannel_OutputPowerPath) Interval() *Component_OpticalChannel_OutputPower_IntervalPath {
	return &Component_OpticalChannel_OutputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/output-power/interval"
func (n *Component_OpticalChannel_OutputPowerPathAny) Interval() *Component_OpticalChannel_OutputPower_IntervalPathAny {
	return &Component_OpticalChannel_OutputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/output-power/max"
func (n *Component_OpticalChannel_OutputPowerPath) Max() *Component_OpticalChannel_OutputPower_MaxPath {
	return &Component_OpticalChannel_OutputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/output-power/max"
func (n *Component_OpticalChannel_OutputPowerPathAny) Max() *Component_OpticalChannel_OutputPower_MaxPathAny {
	return &Component_OpticalChannel_OutputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/output-power/max-time"
func (n *Component_OpticalChannel_OutputPowerPath) MaxTime() *Component_OpticalChannel_OutputPower_MaxTimePath {
	return &Component_OpticalChannel_OutputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/output-power/max-time"
func (n *Component_OpticalChannel_OutputPowerPathAny) MaxTime() *Component_OpticalChannel_OutputPower_MaxTimePathAny {
	return &Component_OpticalChannel_OutputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/output-power/min"
func (n *Component_OpticalChannel_OutputPowerPath) Min() *Component_OpticalChannel_OutputPower_MinPath {
	return &Component_OpticalChannel_OutputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/output-power/min"
func (n *Component_OpticalChannel_OutputPowerPathAny) Min() *Component_OpticalChannel_OutputPower_MinPathAny {
	return &Component_OpticalChannel_OutputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/output-power/min-time"
func (n *Component_OpticalChannel_OutputPowerPath) MinTime() *Component_OpticalChannel_OutputPower_MinTimePath {
	return &Component_OpticalChannel_OutputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/output-power/min-time"
func (n *Component_OpticalChannel_OutputPowerPathAny) MinTime() *Component_OpticalChannel_OutputPower_MinTimePathAny {
	return &Component_OpticalChannel_OutputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_PolarizationDependentLossPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss YANG schema element.
type Component_OpticalChannel_PolarizationDependentLossPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLossPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss YANG schema element.
type Component_OpticalChannel_PolarizationDependentLossPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/avg YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/avg YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/instant YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/instant YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/interval YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/interval YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/max YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/max YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/max-time YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/max-time YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_MinPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/min YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/min YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/min-time YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationDependentLoss_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-dependent-loss/min-time YANG schema element.
type Component_OpticalChannel_PolarizationDependentLoss_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/avg"
func (n *Component_OpticalChannel_PolarizationDependentLossPath) Avg() *Component_OpticalChannel_PolarizationDependentLoss_AvgPath {
	return &Component_OpticalChannel_PolarizationDependentLoss_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/avg"
func (n *Component_OpticalChannel_PolarizationDependentLossPathAny) Avg() *Component_OpticalChannel_PolarizationDependentLoss_AvgPathAny {
	return &Component_OpticalChannel_PolarizationDependentLoss_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/instant"
func (n *Component_OpticalChannel_PolarizationDependentLossPath) Instant() *Component_OpticalChannel_PolarizationDependentLoss_InstantPath {
	return &Component_OpticalChannel_PolarizationDependentLoss_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/instant"
func (n *Component_OpticalChannel_PolarizationDependentLossPathAny) Instant() *Component_OpticalChannel_PolarizationDependentLoss_InstantPathAny {
	return &Component_OpticalChannel_PolarizationDependentLoss_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/interval"
func (n *Component_OpticalChannel_PolarizationDependentLossPath) Interval() *Component_OpticalChannel_PolarizationDependentLoss_IntervalPath {
	return &Component_OpticalChannel_PolarizationDependentLoss_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/interval"
func (n *Component_OpticalChannel_PolarizationDependentLossPathAny) Interval() *Component_OpticalChannel_PolarizationDependentLoss_IntervalPathAny {
	return &Component_OpticalChannel_PolarizationDependentLoss_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/max"
func (n *Component_OpticalChannel_PolarizationDependentLossPath) Max() *Component_OpticalChannel_PolarizationDependentLoss_MaxPath {
	return &Component_OpticalChannel_PolarizationDependentLoss_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/max"
func (n *Component_OpticalChannel_PolarizationDependentLossPathAny) Max() *Component_OpticalChannel_PolarizationDependentLoss_MaxPathAny {
	return &Component_OpticalChannel_PolarizationDependentLoss_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/max-time"
func (n *Component_OpticalChannel_PolarizationDependentLossPath) MaxTime() *Component_OpticalChannel_PolarizationDependentLoss_MaxTimePath {
	return &Component_OpticalChannel_PolarizationDependentLoss_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/max-time"
func (n *Component_OpticalChannel_PolarizationDependentLossPathAny) MaxTime() *Component_OpticalChannel_PolarizationDependentLoss_MaxTimePathAny {
	return &Component_OpticalChannel_PolarizationDependentLoss_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/min"
func (n *Component_OpticalChannel_PolarizationDependentLossPath) Min() *Component_OpticalChannel_PolarizationDependentLoss_MinPath {
	return &Component_OpticalChannel_PolarizationDependentLoss_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/min"
func (n *Component_OpticalChannel_PolarizationDependentLossPathAny) Min() *Component_OpticalChannel_PolarizationDependentLoss_MinPathAny {
	return &Component_OpticalChannel_PolarizationDependentLoss_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/min-time"
func (n *Component_OpticalChannel_PolarizationDependentLossPath) MinTime() *Component_OpticalChannel_PolarizationDependentLoss_MinTimePath {
	return &Component_OpticalChannel_PolarizationDependentLoss_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/polarization-dependent-loss/min-time"
func (n *Component_OpticalChannel_PolarizationDependentLossPathAny) MinTime() *Component_OpticalChannel_PolarizationDependentLoss_MinTimePathAny {
	return &Component_OpticalChannel_PolarizationDependentLoss_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_PolarizationModeDispersionPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersionPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersionPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersionPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/avg YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/avg YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/instant YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/instant YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/interval YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/interval YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/max YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/max YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/max-time YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/max-time YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_MinPath represents the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/min YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/min YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/min-time YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PolarizationModeDispersion_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/polarization-mode-dispersion/min-time YANG schema element.
type Component_OpticalChannel_PolarizationModeDispersion_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/avg"
func (n *Component_OpticalChannel_PolarizationModeDispersionPath) Avg() *Component_OpticalChannel_PolarizationModeDispersion_AvgPath {
	return &Component_OpticalChannel_PolarizationModeDispersion_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/avg"
func (n *Component_OpticalChannel_PolarizationModeDispersionPathAny) Avg() *Component_OpticalChannel_PolarizationModeDispersion_AvgPathAny {
	return &Component_OpticalChannel_PolarizationModeDispersion_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/instant"
func (n *Component_OpticalChannel_PolarizationModeDispersionPath) Instant() *Component_OpticalChannel_PolarizationModeDispersion_InstantPath {
	return &Component_OpticalChannel_PolarizationModeDispersion_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/instant"
func (n *Component_OpticalChannel_PolarizationModeDispersionPathAny) Instant() *Component_OpticalChannel_PolarizationModeDispersion_InstantPathAny {
	return &Component_OpticalChannel_PolarizationModeDispersion_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/interval"
func (n *Component_OpticalChannel_PolarizationModeDispersionPath) Interval() *Component_OpticalChannel_PolarizationModeDispersion_IntervalPath {
	return &Component_OpticalChannel_PolarizationModeDispersion_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/interval"
func (n *Component_OpticalChannel_PolarizationModeDispersionPathAny) Interval() *Component_OpticalChannel_PolarizationModeDispersion_IntervalPathAny {
	return &Component_OpticalChannel_PolarizationModeDispersion_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/max"
func (n *Component_OpticalChannel_PolarizationModeDispersionPath) Max() *Component_OpticalChannel_PolarizationModeDispersion_MaxPath {
	return &Component_OpticalChannel_PolarizationModeDispersion_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/max"
func (n *Component_OpticalChannel_PolarizationModeDispersionPathAny) Max() *Component_OpticalChannel_PolarizationModeDispersion_MaxPathAny {
	return &Component_OpticalChannel_PolarizationModeDispersion_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/max-time"
func (n *Component_OpticalChannel_PolarizationModeDispersionPath) MaxTime() *Component_OpticalChannel_PolarizationModeDispersion_MaxTimePath {
	return &Component_OpticalChannel_PolarizationModeDispersion_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/max-time"
func (n *Component_OpticalChannel_PolarizationModeDispersionPathAny) MaxTime() *Component_OpticalChannel_PolarizationModeDispersion_MaxTimePathAny {
	return &Component_OpticalChannel_PolarizationModeDispersion_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/min"
func (n *Component_OpticalChannel_PolarizationModeDispersionPath) Min() *Component_OpticalChannel_PolarizationModeDispersion_MinPath {
	return &Component_OpticalChannel_PolarizationModeDispersion_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/min"
func (n *Component_OpticalChannel_PolarizationModeDispersionPathAny) Min() *Component_OpticalChannel_PolarizationModeDispersion_MinPathAny {
	return &Component_OpticalChannel_PolarizationModeDispersion_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/min-time"
func (n *Component_OpticalChannel_PolarizationModeDispersionPath) MinTime() *Component_OpticalChannel_PolarizationModeDispersion_MinTimePath {
	return &Component_OpticalChannel_PolarizationModeDispersion_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/polarization-mode-dispersion/min-time"
func (n *Component_OpticalChannel_PolarizationModeDispersionPathAny) MinTime() *Component_OpticalChannel_PolarizationModeDispersion_MinTimePathAny {
	return &Component_OpticalChannel_PolarizationModeDispersion_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_PostFecBerPath represents the /openconfig-platform/components/component/optical-channel/state/post-fec-ber YANG schema element.
type Component_OpticalChannel_PostFecBerPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBerPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/post-fec-ber YANG schema element.
type Component_OpticalChannel_PostFecBerPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/avg YANG schema element.
type Component_OpticalChannel_PostFecBer_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/avg YANG schema element.
type Component_OpticalChannel_PostFecBer_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/instant YANG schema element.
type Component_OpticalChannel_PostFecBer_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/instant YANG schema element.
type Component_OpticalChannel_PostFecBer_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/interval YANG schema element.
type Component_OpticalChannel_PostFecBer_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/interval YANG schema element.
type Component_OpticalChannel_PostFecBer_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/max YANG schema element.
type Component_OpticalChannel_PostFecBer_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/max YANG schema element.
type Component_OpticalChannel_PostFecBer_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/max-time YANG schema element.
type Component_OpticalChannel_PostFecBer_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/max-time YANG schema element.
type Component_OpticalChannel_PostFecBer_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_MinPath represents the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/min YANG schema element.
type Component_OpticalChannel_PostFecBer_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/min YANG schema element.
type Component_OpticalChannel_PostFecBer_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/min-time YANG schema element.
type Component_OpticalChannel_PostFecBer_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PostFecBer_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/post-fec-ber/min-time YANG schema element.
type Component_OpticalChannel_PostFecBer_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/avg"
func (n *Component_OpticalChannel_PostFecBerPath) Avg() *Component_OpticalChannel_PostFecBer_AvgPath {
	return &Component_OpticalChannel_PostFecBer_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/avg"
func (n *Component_OpticalChannel_PostFecBerPathAny) Avg() *Component_OpticalChannel_PostFecBer_AvgPathAny {
	return &Component_OpticalChannel_PostFecBer_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/instant"
func (n *Component_OpticalChannel_PostFecBerPath) Instant() *Component_OpticalChannel_PostFecBer_InstantPath {
	return &Component_OpticalChannel_PostFecBer_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/instant"
func (n *Component_OpticalChannel_PostFecBerPathAny) Instant() *Component_OpticalChannel_PostFecBer_InstantPathAny {
	return &Component_OpticalChannel_PostFecBer_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/interval"
func (n *Component_OpticalChannel_PostFecBerPath) Interval() *Component_OpticalChannel_PostFecBer_IntervalPath {
	return &Component_OpticalChannel_PostFecBer_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/interval"
func (n *Component_OpticalChannel_PostFecBerPathAny) Interval() *Component_OpticalChannel_PostFecBer_IntervalPathAny {
	return &Component_OpticalChannel_PostFecBer_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/max"
func (n *Component_OpticalChannel_PostFecBerPath) Max() *Component_OpticalChannel_PostFecBer_MaxPath {
	return &Component_OpticalChannel_PostFecBer_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/max"
func (n *Component_OpticalChannel_PostFecBerPathAny) Max() *Component_OpticalChannel_PostFecBer_MaxPathAny {
	return &Component_OpticalChannel_PostFecBer_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/max-time"
func (n *Component_OpticalChannel_PostFecBerPath) MaxTime() *Component_OpticalChannel_PostFecBer_MaxTimePath {
	return &Component_OpticalChannel_PostFecBer_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/max-time"
func (n *Component_OpticalChannel_PostFecBerPathAny) MaxTime() *Component_OpticalChannel_PostFecBer_MaxTimePathAny {
	return &Component_OpticalChannel_PostFecBer_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/min"
func (n *Component_OpticalChannel_PostFecBerPath) Min() *Component_OpticalChannel_PostFecBer_MinPath {
	return &Component_OpticalChannel_PostFecBer_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/min"
func (n *Component_OpticalChannel_PostFecBerPathAny) Min() *Component_OpticalChannel_PostFecBer_MinPathAny {
	return &Component_OpticalChannel_PostFecBer_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/min-time"
func (n *Component_OpticalChannel_PostFecBerPath) MinTime() *Component_OpticalChannel_PostFecBer_MinTimePath {
	return &Component_OpticalChannel_PostFecBer_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/post-fec-ber/min-time"
func (n *Component_OpticalChannel_PostFecBerPathAny) MinTime() *Component_OpticalChannel_PostFecBer_MinTimePathAny {
	return &Component_OpticalChannel_PostFecBer_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_PreFecBerPath represents the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber YANG schema element.
type Component_OpticalChannel_PreFecBerPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBerPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber YANG schema element.
type Component_OpticalChannel_PreFecBerPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/avg YANG schema element.
type Component_OpticalChannel_PreFecBer_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/avg YANG schema element.
type Component_OpticalChannel_PreFecBer_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/instant YANG schema element.
type Component_OpticalChannel_PreFecBer_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/instant YANG schema element.
type Component_OpticalChannel_PreFecBer_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/interval YANG schema element.
type Component_OpticalChannel_PreFecBer_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/interval YANG schema element.
type Component_OpticalChannel_PreFecBer_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/max YANG schema element.
type Component_OpticalChannel_PreFecBer_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/max YANG schema element.
type Component_OpticalChannel_PreFecBer_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/max-time YANG schema element.
type Component_OpticalChannel_PreFecBer_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/max-time YANG schema element.
type Component_OpticalChannel_PreFecBer_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_MinPath represents the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/min YANG schema element.
type Component_OpticalChannel_PreFecBer_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/min YANG schema element.
type Component_OpticalChannel_PreFecBer_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/min-time YANG schema element.
type Component_OpticalChannel_PreFecBer_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_PreFecBer_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/pre-fec-ber/min-time YANG schema element.
type Component_OpticalChannel_PreFecBer_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/avg"
func (n *Component_OpticalChannel_PreFecBerPath) Avg() *Component_OpticalChannel_PreFecBer_AvgPath {
	return &Component_OpticalChannel_PreFecBer_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/avg"
func (n *Component_OpticalChannel_PreFecBerPathAny) Avg() *Component_OpticalChannel_PreFecBer_AvgPathAny {
	return &Component_OpticalChannel_PreFecBer_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/instant"
func (n *Component_OpticalChannel_PreFecBerPath) Instant() *Component_OpticalChannel_PreFecBer_InstantPath {
	return &Component_OpticalChannel_PreFecBer_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/instant"
func (n *Component_OpticalChannel_PreFecBerPathAny) Instant() *Component_OpticalChannel_PreFecBer_InstantPathAny {
	return &Component_OpticalChannel_PreFecBer_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/interval"
func (n *Component_OpticalChannel_PreFecBerPath) Interval() *Component_OpticalChannel_PreFecBer_IntervalPath {
	return &Component_OpticalChannel_PreFecBer_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/interval"
func (n *Component_OpticalChannel_PreFecBerPathAny) Interval() *Component_OpticalChannel_PreFecBer_IntervalPathAny {
	return &Component_OpticalChannel_PreFecBer_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/max"
func (n *Component_OpticalChannel_PreFecBerPath) Max() *Component_OpticalChannel_PreFecBer_MaxPath {
	return &Component_OpticalChannel_PreFecBer_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/max"
func (n *Component_OpticalChannel_PreFecBerPathAny) Max() *Component_OpticalChannel_PreFecBer_MaxPathAny {
	return &Component_OpticalChannel_PreFecBer_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/max-time"
func (n *Component_OpticalChannel_PreFecBerPath) MaxTime() *Component_OpticalChannel_PreFecBer_MaxTimePath {
	return &Component_OpticalChannel_PreFecBer_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/max-time"
func (n *Component_OpticalChannel_PreFecBerPathAny) MaxTime() *Component_OpticalChannel_PreFecBer_MaxTimePathAny {
	return &Component_OpticalChannel_PreFecBer_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/min"
func (n *Component_OpticalChannel_PreFecBerPath) Min() *Component_OpticalChannel_PreFecBer_MinPath {
	return &Component_OpticalChannel_PreFecBer_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/min"
func (n *Component_OpticalChannel_PreFecBerPathAny) Min() *Component_OpticalChannel_PreFecBer_MinPathAny {
	return &Component_OpticalChannel_PreFecBer_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/min-time"
func (n *Component_OpticalChannel_PreFecBerPath) MinTime() *Component_OpticalChannel_PreFecBer_MinTimePath {
	return &Component_OpticalChannel_PreFecBer_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/pre-fec-ber/min-time"
func (n *Component_OpticalChannel_PreFecBerPathAny) MinTime() *Component_OpticalChannel_PreFecBer_MinTimePathAny {
	return &Component_OpticalChannel_PreFecBer_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_QValuePath represents the /openconfig-platform/components/component/optical-channel/state/q-value YANG schema element.
type Component_OpticalChannel_QValuePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValuePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/q-value YANG schema element.
type Component_OpticalChannel_QValuePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/q-value/avg YANG schema element.
type Component_OpticalChannel_QValue_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/q-value/avg YANG schema element.
type Component_OpticalChannel_QValue_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/q-value/instant YANG schema element.
type Component_OpticalChannel_QValue_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/q-value/instant YANG schema element.
type Component_OpticalChannel_QValue_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/q-value/interval YANG schema element.
type Component_OpticalChannel_QValue_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/q-value/interval YANG schema element.
type Component_OpticalChannel_QValue_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/q-value/max YANG schema element.
type Component_OpticalChannel_QValue_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/q-value/max YANG schema element.
type Component_OpticalChannel_QValue_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/q-value/max-time YANG schema element.
type Component_OpticalChannel_QValue_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/q-value/max-time YANG schema element.
type Component_OpticalChannel_QValue_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_MinPath represents the /openconfig-platform/components/component/optical-channel/state/q-value/min YANG schema element.
type Component_OpticalChannel_QValue_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/q-value/min YANG schema element.
type Component_OpticalChannel_QValue_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/q-value/min-time YANG schema element.
type Component_OpticalChannel_QValue_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_QValue_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/q-value/min-time YANG schema element.
type Component_OpticalChannel_QValue_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/q-value/avg"
func (n *Component_OpticalChannel_QValuePath) Avg() *Component_OpticalChannel_QValue_AvgPath {
	return &Component_OpticalChannel_QValue_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/q-value/avg"
func (n *Component_OpticalChannel_QValuePathAny) Avg() *Component_OpticalChannel_QValue_AvgPathAny {
	return &Component_OpticalChannel_QValue_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/q-value/instant"
func (n *Component_OpticalChannel_QValuePath) Instant() *Component_OpticalChannel_QValue_InstantPath {
	return &Component_OpticalChannel_QValue_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/q-value/instant"
func (n *Component_OpticalChannel_QValuePathAny) Instant() *Component_OpticalChannel_QValue_InstantPathAny {
	return &Component_OpticalChannel_QValue_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/q-value/interval"
func (n *Component_OpticalChannel_QValuePath) Interval() *Component_OpticalChannel_QValue_IntervalPath {
	return &Component_OpticalChannel_QValue_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/q-value/interval"
func (n *Component_OpticalChannel_QValuePathAny) Interval() *Component_OpticalChannel_QValue_IntervalPathAny {
	return &Component_OpticalChannel_QValue_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/q-value/max"
func (n *Component_OpticalChannel_QValuePath) Max() *Component_OpticalChannel_QValue_MaxPath {
	return &Component_OpticalChannel_QValue_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/q-value/max"
func (n *Component_OpticalChannel_QValuePathAny) Max() *Component_OpticalChannel_QValue_MaxPathAny {
	return &Component_OpticalChannel_QValue_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/q-value/max-time"
func (n *Component_OpticalChannel_QValuePath) MaxTime() *Component_OpticalChannel_QValue_MaxTimePath {
	return &Component_OpticalChannel_QValue_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/q-value/max-time"
func (n *Component_OpticalChannel_QValuePathAny) MaxTime() *Component_OpticalChannel_QValue_MaxTimePathAny {
	return &Component_OpticalChannel_QValue_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/q-value/min"
func (n *Component_OpticalChannel_QValuePath) Min() *Component_OpticalChannel_QValue_MinPath {
	return &Component_OpticalChannel_QValue_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/q-value/min"
func (n *Component_OpticalChannel_QValuePathAny) Min() *Component_OpticalChannel_QValue_MinPathAny {
	return &Component_OpticalChannel_QValue_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/q-value/min-time"
func (n *Component_OpticalChannel_QValuePath) MinTime() *Component_OpticalChannel_QValue_MinTimePath {
	return &Component_OpticalChannel_QValue_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/q-value/min-time"
func (n *Component_OpticalChannel_QValuePathAny) MinTime() *Component_OpticalChannel_QValue_MinTimePathAny {
	return &Component_OpticalChannel_QValue_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath represents the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/avg YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/avg YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/instant YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/instant YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/interval YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/interval YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/max YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/max YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/max-time YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/max-time YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinPath represents the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/min YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/min YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/min-time YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/second-order-polarization-mode-dispersion/min-time YANG schema element.
type Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/avg"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath) Avg() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_AvgPath {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/avg"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny) Avg() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_AvgPathAny {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/instant"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath) Instant() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_InstantPath {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/instant"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny) Instant() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_InstantPathAny {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/interval"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath) Interval() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_IntervalPath {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/interval"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny) Interval() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_IntervalPathAny {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/max"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath) Max() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxPath {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/max"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny) Max() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxPathAny {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/max-time"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath) MaxTime() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxTimePath {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/max-time"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny) MaxTime() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxTimePathAny {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/min"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath) Min() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinPath {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/min"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny) Min() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinPathAny {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/min-time"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPath) MinTime() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinTimePath {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/second-order-polarization-mode-dispersion/min-time"
func (n *Component_OpticalChannel_SecondOrderPolarizationModeDispersionPathAny) MinTime() *Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinTimePathAny {
	return &Component_OpticalChannel_SecondOrderPolarizationModeDispersion_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_OpticalChannel_SopRocPath represents the /openconfig-platform/components/component/optical-channel/state/sop-roc YANG schema element.
type Component_OpticalChannel_SopRocPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRocPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/sop-roc YANG schema element.
type Component_OpticalChannel_SopRocPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_AvgPath represents the /openconfig-platform/components/component/optical-channel/state/sop-roc/avg YANG schema element.
type Component_OpticalChannel_SopRoc_AvgPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/sop-roc/avg YANG schema element.
type Component_OpticalChannel_SopRoc_AvgPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_InstantPath represents the /openconfig-platform/components/component/optical-channel/state/sop-roc/instant YANG schema element.
type Component_OpticalChannel_SopRoc_InstantPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/sop-roc/instant YANG schema element.
type Component_OpticalChannel_SopRoc_InstantPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_IntervalPath represents the /openconfig-platform/components/component/optical-channel/state/sop-roc/interval YANG schema element.
type Component_OpticalChannel_SopRoc_IntervalPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/sop-roc/interval YANG schema element.
type Component_OpticalChannel_SopRoc_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_MaxPath represents the /openconfig-platform/components/component/optical-channel/state/sop-roc/max YANG schema element.
type Component_OpticalChannel_SopRoc_MaxPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/sop-roc/max YANG schema element.
type Component_OpticalChannel_SopRoc_MaxPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_MaxTimePath represents the /openconfig-platform/components/component/optical-channel/state/sop-roc/max-time YANG schema element.
type Component_OpticalChannel_SopRoc_MaxTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/sop-roc/max-time YANG schema element.
type Component_OpticalChannel_SopRoc_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_MinPath represents the /openconfig-platform/components/component/optical-channel/state/sop-roc/min YANG schema element.
type Component_OpticalChannel_SopRoc_MinPath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/sop-roc/min YANG schema element.
type Component_OpticalChannel_SopRoc_MinPathAny struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_MinTimePath represents the /openconfig-platform/components/component/optical-channel/state/sop-roc/min-time YANG schema element.
type Component_OpticalChannel_SopRoc_MinTimePath struct {
	*ygot.NodePath
}

// Component_OpticalChannel_SopRoc_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/optical-channel/state/sop-roc/min-time YANG schema element.
type Component_OpticalChannel_SopRoc_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/sop-roc/avg"
func (n *Component_OpticalChannel_SopRocPath) Avg() *Component_OpticalChannel_SopRoc_AvgPath {
	return &Component_OpticalChannel_SopRoc_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/optical-channel/state/sop-roc/avg"
func (n *Component_OpticalChannel_SopRocPathAny) Avg() *Component_OpticalChannel_SopRoc_AvgPathAny {
	return &Component_OpticalChannel_SopRoc_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/sop-roc/instant"
func (n *Component_OpticalChannel_SopRocPath) Instant() *Component_OpticalChannel_SopRoc_InstantPath {
	return &Component_OpticalChannel_SopRoc_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/optical-channel/state/sop-roc/instant"
func (n *Component_OpticalChannel_SopRocPathAny) Instant() *Component_OpticalChannel_SopRoc_InstantPathAny {
	return &Component_OpticalChannel_SopRoc_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/sop-roc/interval"
func (n *Component_OpticalChannel_SopRocPath) Interval() *Component_OpticalChannel_SopRoc_IntervalPath {
	return &Component_OpticalChannel_SopRoc_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/optical-channel/state/sop-roc/interval"
func (n *Component_OpticalChannel_SopRocPathAny) Interval() *Component_OpticalChannel_SopRoc_IntervalPathAny {
	return &Component_OpticalChannel_SopRoc_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/sop-roc/max"
func (n *Component_OpticalChannel_SopRocPath) Max() *Component_OpticalChannel_SopRoc_MaxPath {
	return &Component_OpticalChannel_SopRoc_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/optical-channel/state/sop-roc/max"
func (n *Component_OpticalChannel_SopRocPathAny) Max() *Component_OpticalChannel_SopRoc_MaxPathAny {
	return &Component_OpticalChannel_SopRoc_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/sop-roc/max-time"
func (n *Component_OpticalChannel_SopRocPath) MaxTime() *Component_OpticalChannel_SopRoc_MaxTimePath {
	return &Component_OpticalChannel_SopRoc_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/optical-channel/state/sop-roc/max-time"
func (n *Component_OpticalChannel_SopRocPathAny) MaxTime() *Component_OpticalChannel_SopRoc_MaxTimePathAny {
	return &Component_OpticalChannel_SopRoc_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/sop-roc/min"
func (n *Component_OpticalChannel_SopRocPath) Min() *Component_OpticalChannel_SopRoc_MinPath {
	return &Component_OpticalChannel_SopRoc_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/optical-channel/state/sop-roc/min"
func (n *Component_OpticalChannel_SopRocPathAny) Min() *Component_OpticalChannel_SopRoc_MinPathAny {
	return &Component_OpticalChannel_SopRoc_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/sop-roc/min-time"
func (n *Component_OpticalChannel_SopRocPath) MinTime() *Component_OpticalChannel_SopRoc_MinTimePath {
	return &Component_OpticalChannel_SopRoc_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/optical-channel/state/sop-roc/min-time"
func (n *Component_OpticalChannel_SopRocPathAny) MinTime() *Component_OpticalChannel_SopRoc_MinTimePathAny {
	return &Component_OpticalChannel_SopRoc_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_PciePath represents the /openconfig-platform/components/component/state/pcie YANG schema element.
type Component_PciePath struct {
	*ygot.NodePath
}

// Component_PciePathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie YANG schema element.
type Component_PciePathAny struct {
	*ygot.NodePath
}

// CorrectableErrors (container): The count of the correctable PCIe errors.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "correctable-errors"
// Path from root: "/components/component/state/pcie/correctable-errors"
func (n *Component_PciePath) CorrectableErrors() *Component_Pcie_CorrectableErrorsPath {
	return &Component_Pcie_CorrectableErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"correctable-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CorrectableErrors (container): The count of the correctable PCIe errors.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "correctable-errors"
// Path from root: "/components/component/state/pcie/correctable-errors"
func (n *Component_PciePathAny) CorrectableErrors() *Component_Pcie_CorrectableErrorsPathAny {
	return &Component_Pcie_CorrectableErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"correctable-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// FatalErrors (container): The count of the fatal PCIe errors.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "fatal-errors"
// Path from root: "/components/component/state/pcie/fatal-errors"
func (n *Component_PciePath) FatalErrors() *Component_Pcie_FatalErrorsPath {
	return &Component_Pcie_FatalErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"fatal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// FatalErrors (container): The count of the fatal PCIe errors.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "fatal-errors"
// Path from root: "/components/component/state/pcie/fatal-errors"
func (n *Component_PciePathAny) FatalErrors() *Component_Pcie_FatalErrorsPathAny {
	return &Component_Pcie_FatalErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"fatal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// NonFatalErrors (container): The count of the non-fatal PCIe errors.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "non-fatal-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors"
func (n *Component_PciePath) NonFatalErrors() *Component_Pcie_NonFatalErrorsPath {
	return &Component_Pcie_NonFatalErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"non-fatal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// NonFatalErrors (container): The count of the non-fatal PCIe errors.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "non-fatal-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors"
func (n *Component_PciePathAny) NonFatalErrors() *Component_Pcie_NonFatalErrorsPathAny {
	return &Component_Pcie_NonFatalErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"non-fatal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Pcie_CorrectableErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors YANG schema element.
type Component_Pcie_CorrectableErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors YANG schema element.
type Component_Pcie_CorrectableErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_AdvisoryNonFatalErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors/advisory-non-fatal-errors YANG schema element.
type Component_Pcie_CorrectableErrors_AdvisoryNonFatalErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_AdvisoryNonFatalErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors/advisory-non-fatal-errors YANG schema element.
type Component_Pcie_CorrectableErrors_AdvisoryNonFatalErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_BadDllpErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors/bad-dllp-errors YANG schema element.
type Component_Pcie_CorrectableErrors_BadDllpErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_BadDllpErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors/bad-dllp-errors YANG schema element.
type Component_Pcie_CorrectableErrors_BadDllpErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_BadTlpErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors/bad-tlp-errors YANG schema element.
type Component_Pcie_CorrectableErrors_BadTlpErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_BadTlpErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors/bad-tlp-errors YANG schema element.
type Component_Pcie_CorrectableErrors_BadTlpErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_HdrLogOverflowErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors/hdr-log-overflow-errors YANG schema element.
type Component_Pcie_CorrectableErrors_HdrLogOverflowErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_HdrLogOverflowErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors/hdr-log-overflow-errors YANG schema element.
type Component_Pcie_CorrectableErrors_HdrLogOverflowErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_InternalErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors/internal-errors YANG schema element.
type Component_Pcie_CorrectableErrors_InternalErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_InternalErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors/internal-errors YANG schema element.
type Component_Pcie_CorrectableErrors_InternalErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_ReceiverErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors/receiver-errors YANG schema element.
type Component_Pcie_CorrectableErrors_ReceiverErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_ReceiverErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors/receiver-errors YANG schema element.
type Component_Pcie_CorrectableErrors_ReceiverErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_RelayRolloverErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors/relay-rollover-errors YANG schema element.
type Component_Pcie_CorrectableErrors_RelayRolloverErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_RelayRolloverErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors/relay-rollover-errors YANG schema element.
type Component_Pcie_CorrectableErrors_RelayRolloverErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_ReplayTimeoutErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors/replay-timeout-errors YANG schema element.
type Component_Pcie_CorrectableErrors_ReplayTimeoutErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_ReplayTimeoutErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors/replay-timeout-errors YANG schema element.
type Component_Pcie_CorrectableErrors_ReplayTimeoutErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_TotalErrorsPath represents the /openconfig-platform/components/component/state/pcie/correctable-errors/total-errors YANG schema element.
type Component_Pcie_CorrectableErrors_TotalErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_CorrectableErrors_TotalErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/correctable-errors/total-errors YANG schema element.
type Component_Pcie_CorrectableErrors_TotalErrorsPathAny struct {
	*ygot.NodePath
}

// AdvisoryNonFatalErrors (leaf): Number of advisory non fatal errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "advisory-non-fatal-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/advisory-non-fatal-errors"
func (n *Component_Pcie_CorrectableErrorsPath) AdvisoryNonFatalErrors() *Component_Pcie_CorrectableErrors_AdvisoryNonFatalErrorsPath {
	return &Component_Pcie_CorrectableErrors_AdvisoryNonFatalErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"advisory-non-fatal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvisoryNonFatalErrors (leaf): Number of advisory non fatal errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "advisory-non-fatal-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/advisory-non-fatal-errors"
func (n *Component_Pcie_CorrectableErrorsPathAny) AdvisoryNonFatalErrors() *Component_Pcie_CorrectableErrors_AdvisoryNonFatalErrorsPathAny {
	return &Component_Pcie_CorrectableErrors_AdvisoryNonFatalErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"advisory-non-fatal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadDllpErrors (leaf): Number of DLLPs with bad LCRC detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "bad-dllp-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/bad-dllp-errors"
func (n *Component_Pcie_CorrectableErrorsPath) BadDllpErrors() *Component_Pcie_CorrectableErrors_BadDllpErrorsPath {
	return &Component_Pcie_CorrectableErrors_BadDllpErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"bad-dllp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadDllpErrors (leaf): Number of DLLPs with bad LCRC detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "bad-dllp-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/bad-dllp-errors"
func (n *Component_Pcie_CorrectableErrorsPathAny) BadDllpErrors() *Component_Pcie_CorrectableErrors_BadDllpErrorsPathAny {
	return &Component_Pcie_CorrectableErrors_BadDllpErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bad-dllp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadTlpErrors (leaf): Number of TLPs with bad LCRC detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "bad-tlp-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/bad-tlp-errors"
func (n *Component_Pcie_CorrectableErrorsPath) BadTlpErrors() *Component_Pcie_CorrectableErrors_BadTlpErrorsPath {
	return &Component_Pcie_CorrectableErrors_BadTlpErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"bad-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadTlpErrors (leaf): Number of TLPs with bad LCRC detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "bad-tlp-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/bad-tlp-errors"
func (n *Component_Pcie_CorrectableErrorsPathAny) BadTlpErrors() *Component_Pcie_CorrectableErrors_BadTlpErrorsPathAny {
	return &Component_Pcie_CorrectableErrors_BadTlpErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bad-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// HdrLogOverflowErrors (leaf): Number of header log overflow errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "hdr-log-overflow-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/hdr-log-overflow-errors"
func (n *Component_Pcie_CorrectableErrorsPath) HdrLogOverflowErrors() *Component_Pcie_CorrectableErrors_HdrLogOverflowErrorsPath {
	return &Component_Pcie_CorrectableErrors_HdrLogOverflowErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"hdr-log-overflow-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// HdrLogOverflowErrors (leaf): Number of header log overflow errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "hdr-log-overflow-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/hdr-log-overflow-errors"
func (n *Component_Pcie_CorrectableErrorsPathAny) HdrLogOverflowErrors() *Component_Pcie_CorrectableErrors_HdrLogOverflowErrorsPathAny {
	return &Component_Pcie_CorrectableErrors_HdrLogOverflowErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hdr-log-overflow-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalErrors (leaf): Number of internal errors detected by PCIe device since the system
// booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "internal-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/internal-errors"
func (n *Component_Pcie_CorrectableErrorsPath) InternalErrors() *Component_Pcie_CorrectableErrors_InternalErrorsPath {
	return &Component_Pcie_CorrectableErrors_InternalErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"internal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalErrors (leaf): Number of internal errors detected by PCIe device since the system
// booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "internal-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/internal-errors"
func (n *Component_Pcie_CorrectableErrorsPathAny) InternalErrors() *Component_Pcie_CorrectableErrors_InternalErrorsPathAny {
	return &Component_Pcie_CorrectableErrors_InternalErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"internal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceiverErrors (leaf): Number of receiver errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "receiver-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/receiver-errors"
func (n *Component_Pcie_CorrectableErrorsPath) ReceiverErrors() *Component_Pcie_CorrectableErrors_ReceiverErrorsPath {
	return &Component_Pcie_CorrectableErrors_ReceiverErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"receiver-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceiverErrors (leaf): Number of receiver errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "receiver-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/receiver-errors"
func (n *Component_Pcie_CorrectableErrorsPathAny) ReceiverErrors() *Component_Pcie_CorrectableErrors_ReceiverErrorsPathAny {
	return &Component_Pcie_CorrectableErrors_ReceiverErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"receiver-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayRolloverErrors (leaf): Number of relay rollover errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "relay-rollover-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/relay-rollover-errors"
func (n *Component_Pcie_CorrectableErrorsPath) RelayRolloverErrors() *Component_Pcie_CorrectableErrors_RelayRolloverErrorsPath {
	return &Component_Pcie_CorrectableErrors_RelayRolloverErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"relay-rollover-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayRolloverErrors (leaf): Number of relay rollover errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "relay-rollover-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/relay-rollover-errors"
func (n *Component_Pcie_CorrectableErrorsPathAny) RelayRolloverErrors() *Component_Pcie_CorrectableErrors_RelayRolloverErrorsPathAny {
	return &Component_Pcie_CorrectableErrors_RelayRolloverErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"relay-rollover-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReplayTimeoutErrors (leaf): Number of replay timeout errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "replay-timeout-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/replay-timeout-errors"
func (n *Component_Pcie_CorrectableErrorsPath) ReplayTimeoutErrors() *Component_Pcie_CorrectableErrors_ReplayTimeoutErrorsPath {
	return &Component_Pcie_CorrectableErrors_ReplayTimeoutErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"replay-timeout-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReplayTimeoutErrors (leaf): Number of replay timeout errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "replay-timeout-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/replay-timeout-errors"
func (n *Component_Pcie_CorrectableErrorsPathAny) ReplayTimeoutErrors() *Component_Pcie_CorrectableErrors_ReplayTimeoutErrorsPathAny {
	return &Component_Pcie_CorrectableErrors_ReplayTimeoutErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"replay-timeout-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalErrors (leaf): Total number of correctable errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "total-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/total-errors"
func (n *Component_Pcie_CorrectableErrorsPath) TotalErrors() *Component_Pcie_CorrectableErrors_TotalErrorsPath {
	return &Component_Pcie_CorrectableErrors_TotalErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"total-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalErrors (leaf): Total number of correctable errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "total-errors"
// Path from root: "/components/component/state/pcie/correctable-errors/total-errors"
func (n *Component_Pcie_CorrectableErrorsPathAny) TotalErrors() *Component_Pcie_CorrectableErrors_TotalErrorsPathAny {
	return &Component_Pcie_CorrectableErrors_TotalErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"total-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Pcie_FatalErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors YANG schema element.
type Component_Pcie_FatalErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors YANG schema element.
type Component_Pcie_FatalErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_AcsViolationErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/acs-violation-errors YANG schema element.
type Component_Pcie_FatalErrors_AcsViolationErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_AcsViolationErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/acs-violation-errors YANG schema element.
type Component_Pcie_FatalErrors_AcsViolationErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_AtomicOpBlockedErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/atomic-op-blocked-errors YANG schema element.
type Component_Pcie_FatalErrors_AtomicOpBlockedErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_AtomicOpBlockedErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/atomic-op-blocked-errors YANG schema element.
type Component_Pcie_FatalErrors_AtomicOpBlockedErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_BlockedTlpErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/blocked-tlp-errors YANG schema element.
type Component_Pcie_FatalErrors_BlockedTlpErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_BlockedTlpErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/blocked-tlp-errors YANG schema element.
type Component_Pcie_FatalErrors_BlockedTlpErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_CompletionAbortErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/completion-abort-errors YANG schema element.
type Component_Pcie_FatalErrors_CompletionAbortErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_CompletionAbortErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/completion-abort-errors YANG schema element.
type Component_Pcie_FatalErrors_CompletionAbortErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_CompletionTimeoutErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/completion-timeout-errors YANG schema element.
type Component_Pcie_FatalErrors_CompletionTimeoutErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_CompletionTimeoutErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/completion-timeout-errors YANG schema element.
type Component_Pcie_FatalErrors_CompletionTimeoutErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_DataLinkErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/data-link-errors YANG schema element.
type Component_Pcie_FatalErrors_DataLinkErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_DataLinkErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/data-link-errors YANG schema element.
type Component_Pcie_FatalErrors_DataLinkErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_EcrcErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/ecrc-errors YANG schema element.
type Component_Pcie_FatalErrors_EcrcErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_EcrcErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/ecrc-errors YANG schema element.
type Component_Pcie_FatalErrors_EcrcErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_FlowControlProtocolErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/flow-control-protocol-errors YANG schema element.
type Component_Pcie_FatalErrors_FlowControlProtocolErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_FlowControlProtocolErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/flow-control-protocol-errors YANG schema element.
type Component_Pcie_FatalErrors_FlowControlProtocolErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_InternalErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/internal-errors YANG schema element.
type Component_Pcie_FatalErrors_InternalErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_InternalErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/internal-errors YANG schema element.
type Component_Pcie_FatalErrors_InternalErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_MalformedTlpErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/malformed-tlp-errors YANG schema element.
type Component_Pcie_FatalErrors_MalformedTlpErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_MalformedTlpErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/malformed-tlp-errors YANG schema element.
type Component_Pcie_FatalErrors_MalformedTlpErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_PoisonedTlpErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/poisoned-tlp-errors YANG schema element.
type Component_Pcie_FatalErrors_PoisonedTlpErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_PoisonedTlpErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/poisoned-tlp-errors YANG schema element.
type Component_Pcie_FatalErrors_PoisonedTlpErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_ReceiverOverflowErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/receiver-overflow-errors YANG schema element.
type Component_Pcie_FatalErrors_ReceiverOverflowErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_ReceiverOverflowErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/receiver-overflow-errors YANG schema element.
type Component_Pcie_FatalErrors_ReceiverOverflowErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_SurpriseDownErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/surprise-down-errors YANG schema element.
type Component_Pcie_FatalErrors_SurpriseDownErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_SurpriseDownErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/surprise-down-errors YANG schema element.
type Component_Pcie_FatalErrors_SurpriseDownErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_TlpPrefixBlockedErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/tlp-prefix-blocked-errors YANG schema element.
type Component_Pcie_FatalErrors_TlpPrefixBlockedErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_TlpPrefixBlockedErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/tlp-prefix-blocked-errors YANG schema element.
type Component_Pcie_FatalErrors_TlpPrefixBlockedErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_TotalErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/total-errors YANG schema element.
type Component_Pcie_FatalErrors_TotalErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_TotalErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/total-errors YANG schema element.
type Component_Pcie_FatalErrors_TotalErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_UndefinedErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/undefined-errors YANG schema element.
type Component_Pcie_FatalErrors_UndefinedErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_UndefinedErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/undefined-errors YANG schema element.
type Component_Pcie_FatalErrors_UndefinedErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_UnexpectedCompletionErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/unexpected-completion-errors YANG schema element.
type Component_Pcie_FatalErrors_UnexpectedCompletionErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_UnexpectedCompletionErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/unexpected-completion-errors YANG schema element.
type Component_Pcie_FatalErrors_UnexpectedCompletionErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_UnsupportedRequestErrorsPath represents the /openconfig-platform/components/component/state/pcie/fatal-errors/unsupported-request-errors YANG schema element.
type Component_Pcie_FatalErrors_UnsupportedRequestErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_FatalErrors_UnsupportedRequestErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/fatal-errors/unsupported-request-errors YANG schema element.
type Component_Pcie_FatalErrors_UnsupportedRequestErrorsPathAny struct {
	*ygot.NodePath
}

// AcsViolationErrors (leaf): Number of access control errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "acs-violation-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/acs-violation-errors"
func (n *Component_Pcie_FatalErrorsPath) AcsViolationErrors() *Component_Pcie_FatalErrors_AcsViolationErrorsPath {
	return &Component_Pcie_FatalErrors_AcsViolationErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"acs-violation-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// AcsViolationErrors (leaf): Number of access control errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "acs-violation-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/acs-violation-errors"
func (n *Component_Pcie_FatalErrorsPathAny) AcsViolationErrors() *Component_Pcie_FatalErrors_AcsViolationErrorsPathAny {
	return &Component_Pcie_FatalErrors_AcsViolationErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acs-violation-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// AtomicOpBlockedErrors (leaf): Number of atomic operation blocked errors detected by PCIe
// device since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "atomic-op-blocked-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/atomic-op-blocked-errors"
func (n *Component_Pcie_FatalErrorsPath) AtomicOpBlockedErrors() *Component_Pcie_FatalErrors_AtomicOpBlockedErrorsPath {
	return &Component_Pcie_FatalErrors_AtomicOpBlockedErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"atomic-op-blocked-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// AtomicOpBlockedErrors (leaf): Number of atomic operation blocked errors detected by PCIe
// device since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "atomic-op-blocked-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/atomic-op-blocked-errors"
func (n *Component_Pcie_FatalErrorsPathAny) AtomicOpBlockedErrors() *Component_Pcie_FatalErrors_AtomicOpBlockedErrorsPathAny {
	return &Component_Pcie_FatalErrors_AtomicOpBlockedErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"atomic-op-blocked-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// BlockedTlpErrors (leaf): Number of blocked TLP errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "blocked-tlp-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/blocked-tlp-errors"
func (n *Component_Pcie_FatalErrorsPath) BlockedTlpErrors() *Component_Pcie_FatalErrors_BlockedTlpErrorsPath {
	return &Component_Pcie_FatalErrors_BlockedTlpErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"blocked-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// BlockedTlpErrors (leaf): Number of blocked TLP errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "blocked-tlp-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/blocked-tlp-errors"
func (n *Component_Pcie_FatalErrorsPathAny) BlockedTlpErrors() *Component_Pcie_FatalErrors_BlockedTlpErrorsPathAny {
	return &Component_Pcie_FatalErrors_BlockedTlpErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"blocked-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CompletionAbortErrors (leaf): Number of completion abort errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "completion-abort-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/completion-abort-errors"
func (n *Component_Pcie_FatalErrorsPath) CompletionAbortErrors() *Component_Pcie_FatalErrors_CompletionAbortErrorsPath {
	return &Component_Pcie_FatalErrors_CompletionAbortErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"completion-abort-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CompletionAbortErrors (leaf): Number of completion abort errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "completion-abort-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/completion-abort-errors"
func (n *Component_Pcie_FatalErrorsPathAny) CompletionAbortErrors() *Component_Pcie_FatalErrors_CompletionAbortErrorsPathAny {
	return &Component_Pcie_FatalErrors_CompletionAbortErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"completion-abort-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CompletionTimeoutErrors (leaf): Number of completion timeout errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "completion-timeout-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/completion-timeout-errors"
func (n *Component_Pcie_FatalErrorsPath) CompletionTimeoutErrors() *Component_Pcie_FatalErrors_CompletionTimeoutErrorsPath {
	return &Component_Pcie_FatalErrors_CompletionTimeoutErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"completion-timeout-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CompletionTimeoutErrors (leaf): Number of completion timeout errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "completion-timeout-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/completion-timeout-errors"
func (n *Component_Pcie_FatalErrorsPathAny) CompletionTimeoutErrors() *Component_Pcie_FatalErrors_CompletionTimeoutErrorsPathAny {
	return &Component_Pcie_FatalErrors_CompletionTimeoutErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"completion-timeout-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// DataLinkErrors (leaf): Number of data-link errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "data-link-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/data-link-errors"
func (n *Component_Pcie_FatalErrorsPath) DataLinkErrors() *Component_Pcie_FatalErrors_DataLinkErrorsPath {
	return &Component_Pcie_FatalErrors_DataLinkErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"data-link-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// DataLinkErrors (leaf): Number of data-link errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "data-link-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/data-link-errors"
func (n *Component_Pcie_FatalErrorsPathAny) DataLinkErrors() *Component_Pcie_FatalErrors_DataLinkErrorsPathAny {
	return &Component_Pcie_FatalErrors_DataLinkErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"data-link-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// EcrcErrors (leaf): Number of ECRC errors detected by PCIe device since the system
// booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "ecrc-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/ecrc-errors"
func (n *Component_Pcie_FatalErrorsPath) EcrcErrors() *Component_Pcie_FatalErrors_EcrcErrorsPath {
	return &Component_Pcie_FatalErrors_EcrcErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"ecrc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// EcrcErrors (leaf): Number of ECRC errors detected by PCIe device since the system
// booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "ecrc-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/ecrc-errors"
func (n *Component_Pcie_FatalErrorsPathAny) EcrcErrors() *Component_Pcie_FatalErrors_EcrcErrorsPathAny {
	return &Component_Pcie_FatalErrors_EcrcErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ecrc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// FlowControlProtocolErrors (leaf): Number of flow control protocol errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "flow-control-protocol-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/flow-control-protocol-errors"
func (n *Component_Pcie_FatalErrorsPath) FlowControlProtocolErrors() *Component_Pcie_FatalErrors_FlowControlProtocolErrorsPath {
	return &Component_Pcie_FatalErrors_FlowControlProtocolErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"flow-control-protocol-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// FlowControlProtocolErrors (leaf): Number of flow control protocol errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "flow-control-protocol-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/flow-control-protocol-errors"
func (n *Component_Pcie_FatalErrorsPathAny) FlowControlProtocolErrors() *Component_Pcie_FatalErrors_FlowControlProtocolErrorsPathAny {
	return &Component_Pcie_FatalErrors_FlowControlProtocolErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"flow-control-protocol-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalErrors (leaf): Number of internal errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "internal-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/internal-errors"
func (n *Component_Pcie_FatalErrorsPath) InternalErrors() *Component_Pcie_FatalErrors_InternalErrorsPath {
	return &Component_Pcie_FatalErrors_InternalErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"internal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalErrors (leaf): Number of internal errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "internal-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/internal-errors"
func (n *Component_Pcie_FatalErrorsPathAny) InternalErrors() *Component_Pcie_FatalErrors_InternalErrorsPathAny {
	return &Component_Pcie_FatalErrors_InternalErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"internal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// MalformedTlpErrors (leaf): Number of malformed TLP errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "malformed-tlp-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/malformed-tlp-errors"
func (n *Component_Pcie_FatalErrorsPath) MalformedTlpErrors() *Component_Pcie_FatalErrors_MalformedTlpErrorsPath {
	return &Component_Pcie_FatalErrors_MalformedTlpErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"malformed-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// MalformedTlpErrors (leaf): Number of malformed TLP errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "malformed-tlp-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/malformed-tlp-errors"
func (n *Component_Pcie_FatalErrorsPathAny) MalformedTlpErrors() *Component_Pcie_FatalErrors_MalformedTlpErrorsPathAny {
	return &Component_Pcie_FatalErrors_MalformedTlpErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"malformed-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// PoisonedTlpErrors (leaf): Number of poisoned TLP errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "poisoned-tlp-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/poisoned-tlp-errors"
func (n *Component_Pcie_FatalErrorsPath) PoisonedTlpErrors() *Component_Pcie_FatalErrors_PoisonedTlpErrorsPath {
	return &Component_Pcie_FatalErrors_PoisonedTlpErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"poisoned-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// PoisonedTlpErrors (leaf): Number of poisoned TLP errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "poisoned-tlp-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/poisoned-tlp-errors"
func (n *Component_Pcie_FatalErrorsPathAny) PoisonedTlpErrors() *Component_Pcie_FatalErrors_PoisonedTlpErrorsPathAny {
	return &Component_Pcie_FatalErrors_PoisonedTlpErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"poisoned-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceiverOverflowErrors (leaf): Number of receiver overflow errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "receiver-overflow-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/receiver-overflow-errors"
func (n *Component_Pcie_FatalErrorsPath) ReceiverOverflowErrors() *Component_Pcie_FatalErrors_ReceiverOverflowErrorsPath {
	return &Component_Pcie_FatalErrors_ReceiverOverflowErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"receiver-overflow-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceiverOverflowErrors (leaf): Number of receiver overflow errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "receiver-overflow-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/receiver-overflow-errors"
func (n *Component_Pcie_FatalErrorsPathAny) ReceiverOverflowErrors() *Component_Pcie_FatalErrors_ReceiverOverflowErrorsPathAny {
	return &Component_Pcie_FatalErrors_ReceiverOverflowErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"receiver-overflow-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// SurpriseDownErrors (leaf): Number of unexpected link down errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "surprise-down-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/surprise-down-errors"
func (n *Component_Pcie_FatalErrorsPath) SurpriseDownErrors() *Component_Pcie_FatalErrors_SurpriseDownErrorsPath {
	return &Component_Pcie_FatalErrors_SurpriseDownErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"surprise-down-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// SurpriseDownErrors (leaf): Number of unexpected link down errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "surprise-down-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/surprise-down-errors"
func (n *Component_Pcie_FatalErrorsPathAny) SurpriseDownErrors() *Component_Pcie_FatalErrors_SurpriseDownErrorsPathAny {
	return &Component_Pcie_FatalErrors_SurpriseDownErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"surprise-down-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlpPrefixBlockedErrors (leaf): Number of TLP prefix blocked errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "tlp-prefix-blocked-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/tlp-prefix-blocked-errors"
func (n *Component_Pcie_FatalErrorsPath) TlpPrefixBlockedErrors() *Component_Pcie_FatalErrors_TlpPrefixBlockedErrorsPath {
	return &Component_Pcie_FatalErrors_TlpPrefixBlockedErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlp-prefix-blocked-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlpPrefixBlockedErrors (leaf): Number of TLP prefix blocked errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "tlp-prefix-blocked-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/tlp-prefix-blocked-errors"
func (n *Component_Pcie_FatalErrorsPathAny) TlpPrefixBlockedErrors() *Component_Pcie_FatalErrors_TlpPrefixBlockedErrorsPathAny {
	return &Component_Pcie_FatalErrors_TlpPrefixBlockedErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlp-prefix-blocked-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalErrors (leaf): Total number of uncorrectable errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "total-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/total-errors"
func (n *Component_Pcie_FatalErrorsPath) TotalErrors() *Component_Pcie_FatalErrors_TotalErrorsPath {
	return &Component_Pcie_FatalErrors_TotalErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"total-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalErrors (leaf): Total number of uncorrectable errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "total-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/total-errors"
func (n *Component_Pcie_FatalErrorsPathAny) TotalErrors() *Component_Pcie_FatalErrors_TotalErrorsPathAny {
	return &Component_Pcie_FatalErrors_TotalErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"total-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UndefinedErrors (leaf): Number of undefined errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "undefined-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/undefined-errors"
func (n *Component_Pcie_FatalErrorsPath) UndefinedErrors() *Component_Pcie_FatalErrors_UndefinedErrorsPath {
	return &Component_Pcie_FatalErrors_UndefinedErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UndefinedErrors (leaf): Number of undefined errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "undefined-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/undefined-errors"
func (n *Component_Pcie_FatalErrorsPathAny) UndefinedErrors() *Component_Pcie_FatalErrors_UndefinedErrorsPathAny {
	return &Component_Pcie_FatalErrors_UndefinedErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnexpectedCompletionErrors (leaf): Number of unexpected completion errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "unexpected-completion-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/unexpected-completion-errors"
func (n *Component_Pcie_FatalErrorsPath) UnexpectedCompletionErrors() *Component_Pcie_FatalErrors_UnexpectedCompletionErrorsPath {
	return &Component_Pcie_FatalErrors_UnexpectedCompletionErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"unexpected-completion-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnexpectedCompletionErrors (leaf): Number of unexpected completion errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "unexpected-completion-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/unexpected-completion-errors"
func (n *Component_Pcie_FatalErrorsPathAny) UnexpectedCompletionErrors() *Component_Pcie_FatalErrors_UnexpectedCompletionErrorsPathAny {
	return &Component_Pcie_FatalErrors_UnexpectedCompletionErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unexpected-completion-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnsupportedRequestErrors (leaf): Number of unsupported request errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "unsupported-request-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/unsupported-request-errors"
func (n *Component_Pcie_FatalErrorsPath) UnsupportedRequestErrors() *Component_Pcie_FatalErrors_UnsupportedRequestErrorsPath {
	return &Component_Pcie_FatalErrors_UnsupportedRequestErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"unsupported-request-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnsupportedRequestErrors (leaf): Number of unsupported request errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "unsupported-request-errors"
// Path from root: "/components/component/state/pcie/fatal-errors/unsupported-request-errors"
func (n *Component_Pcie_FatalErrorsPathAny) UnsupportedRequestErrors() *Component_Pcie_FatalErrors_UnsupportedRequestErrorsPathAny {
	return &Component_Pcie_FatalErrors_UnsupportedRequestErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unsupported-request-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Pcie_NonFatalErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors YANG schema element.
type Component_Pcie_NonFatalErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors YANG schema element.
type Component_Pcie_NonFatalErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_AcsViolationErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/acs-violation-errors YANG schema element.
type Component_Pcie_NonFatalErrors_AcsViolationErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_AcsViolationErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/acs-violation-errors YANG schema element.
type Component_Pcie_NonFatalErrors_AcsViolationErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_AtomicOpBlockedErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/atomic-op-blocked-errors YANG schema element.
type Component_Pcie_NonFatalErrors_AtomicOpBlockedErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_AtomicOpBlockedErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/atomic-op-blocked-errors YANG schema element.
type Component_Pcie_NonFatalErrors_AtomicOpBlockedErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_BlockedTlpErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/blocked-tlp-errors YANG schema element.
type Component_Pcie_NonFatalErrors_BlockedTlpErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_BlockedTlpErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/blocked-tlp-errors YANG schema element.
type Component_Pcie_NonFatalErrors_BlockedTlpErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_CompletionAbortErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/completion-abort-errors YANG schema element.
type Component_Pcie_NonFatalErrors_CompletionAbortErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_CompletionAbortErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/completion-abort-errors YANG schema element.
type Component_Pcie_NonFatalErrors_CompletionAbortErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_CompletionTimeoutErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/completion-timeout-errors YANG schema element.
type Component_Pcie_NonFatalErrors_CompletionTimeoutErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_CompletionTimeoutErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/completion-timeout-errors YANG schema element.
type Component_Pcie_NonFatalErrors_CompletionTimeoutErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_DataLinkErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/data-link-errors YANG schema element.
type Component_Pcie_NonFatalErrors_DataLinkErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_DataLinkErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/data-link-errors YANG schema element.
type Component_Pcie_NonFatalErrors_DataLinkErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_EcrcErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/ecrc-errors YANG schema element.
type Component_Pcie_NonFatalErrors_EcrcErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_EcrcErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/ecrc-errors YANG schema element.
type Component_Pcie_NonFatalErrors_EcrcErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_FlowControlProtocolErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/flow-control-protocol-errors YANG schema element.
type Component_Pcie_NonFatalErrors_FlowControlProtocolErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_FlowControlProtocolErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/flow-control-protocol-errors YANG schema element.
type Component_Pcie_NonFatalErrors_FlowControlProtocolErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_InternalErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/internal-errors YANG schema element.
type Component_Pcie_NonFatalErrors_InternalErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_InternalErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/internal-errors YANG schema element.
type Component_Pcie_NonFatalErrors_InternalErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_MalformedTlpErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/malformed-tlp-errors YANG schema element.
type Component_Pcie_NonFatalErrors_MalformedTlpErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_MalformedTlpErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/malformed-tlp-errors YANG schema element.
type Component_Pcie_NonFatalErrors_MalformedTlpErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_PoisonedTlpErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/poisoned-tlp-errors YANG schema element.
type Component_Pcie_NonFatalErrors_PoisonedTlpErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_PoisonedTlpErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/poisoned-tlp-errors YANG schema element.
type Component_Pcie_NonFatalErrors_PoisonedTlpErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_ReceiverOverflowErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/receiver-overflow-errors YANG schema element.
type Component_Pcie_NonFatalErrors_ReceiverOverflowErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_ReceiverOverflowErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/receiver-overflow-errors YANG schema element.
type Component_Pcie_NonFatalErrors_ReceiverOverflowErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_SurpriseDownErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/surprise-down-errors YANG schema element.
type Component_Pcie_NonFatalErrors_SurpriseDownErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_SurpriseDownErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/surprise-down-errors YANG schema element.
type Component_Pcie_NonFatalErrors_SurpriseDownErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_TlpPrefixBlockedErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/tlp-prefix-blocked-errors YANG schema element.
type Component_Pcie_NonFatalErrors_TlpPrefixBlockedErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_TlpPrefixBlockedErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/tlp-prefix-blocked-errors YANG schema element.
type Component_Pcie_NonFatalErrors_TlpPrefixBlockedErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_TotalErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/total-errors YANG schema element.
type Component_Pcie_NonFatalErrors_TotalErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_TotalErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/total-errors YANG schema element.
type Component_Pcie_NonFatalErrors_TotalErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_UndefinedErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/undefined-errors YANG schema element.
type Component_Pcie_NonFatalErrors_UndefinedErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_UndefinedErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/undefined-errors YANG schema element.
type Component_Pcie_NonFatalErrors_UndefinedErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_UnexpectedCompletionErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/unexpected-completion-errors YANG schema element.
type Component_Pcie_NonFatalErrors_UnexpectedCompletionErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_UnexpectedCompletionErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/unexpected-completion-errors YANG schema element.
type Component_Pcie_NonFatalErrors_UnexpectedCompletionErrorsPathAny struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_UnsupportedRequestErrorsPath represents the /openconfig-platform/components/component/state/pcie/non-fatal-errors/unsupported-request-errors YANG schema element.
type Component_Pcie_NonFatalErrors_UnsupportedRequestErrorsPath struct {
	*ygot.NodePath
}

// Component_Pcie_NonFatalErrors_UnsupportedRequestErrorsPathAny represents the wildcard version of the /openconfig-platform/components/component/state/pcie/non-fatal-errors/unsupported-request-errors YANG schema element.
type Component_Pcie_NonFatalErrors_UnsupportedRequestErrorsPathAny struct {
	*ygot.NodePath
}

// AcsViolationErrors (leaf): Number of access control errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "acs-violation-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/acs-violation-errors"
func (n *Component_Pcie_NonFatalErrorsPath) AcsViolationErrors() *Component_Pcie_NonFatalErrors_AcsViolationErrorsPath {
	return &Component_Pcie_NonFatalErrors_AcsViolationErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"acs-violation-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// AcsViolationErrors (leaf): Number of access control errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "acs-violation-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/acs-violation-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) AcsViolationErrors() *Component_Pcie_NonFatalErrors_AcsViolationErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_AcsViolationErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"acs-violation-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// AtomicOpBlockedErrors (leaf): Number of atomic operation blocked errors detected by PCIe
// device since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "atomic-op-blocked-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/atomic-op-blocked-errors"
func (n *Component_Pcie_NonFatalErrorsPath) AtomicOpBlockedErrors() *Component_Pcie_NonFatalErrors_AtomicOpBlockedErrorsPath {
	return &Component_Pcie_NonFatalErrors_AtomicOpBlockedErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"atomic-op-blocked-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// AtomicOpBlockedErrors (leaf): Number of atomic operation blocked errors detected by PCIe
// device since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "atomic-op-blocked-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/atomic-op-blocked-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) AtomicOpBlockedErrors() *Component_Pcie_NonFatalErrors_AtomicOpBlockedErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_AtomicOpBlockedErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"atomic-op-blocked-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// BlockedTlpErrors (leaf): Number of blocked TLP errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "blocked-tlp-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/blocked-tlp-errors"
func (n *Component_Pcie_NonFatalErrorsPath) BlockedTlpErrors() *Component_Pcie_NonFatalErrors_BlockedTlpErrorsPath {
	return &Component_Pcie_NonFatalErrors_BlockedTlpErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"blocked-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// BlockedTlpErrors (leaf): Number of blocked TLP errors detected by PCIe device since
// the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "blocked-tlp-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/blocked-tlp-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) BlockedTlpErrors() *Component_Pcie_NonFatalErrors_BlockedTlpErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_BlockedTlpErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"blocked-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CompletionAbortErrors (leaf): Number of completion abort errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "completion-abort-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/completion-abort-errors"
func (n *Component_Pcie_NonFatalErrorsPath) CompletionAbortErrors() *Component_Pcie_NonFatalErrors_CompletionAbortErrorsPath {
	return &Component_Pcie_NonFatalErrors_CompletionAbortErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"completion-abort-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CompletionAbortErrors (leaf): Number of completion abort errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "completion-abort-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/completion-abort-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) CompletionAbortErrors() *Component_Pcie_NonFatalErrors_CompletionAbortErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_CompletionAbortErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"completion-abort-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CompletionTimeoutErrors (leaf): Number of completion timeout errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "completion-timeout-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/completion-timeout-errors"
func (n *Component_Pcie_NonFatalErrorsPath) CompletionTimeoutErrors() *Component_Pcie_NonFatalErrors_CompletionTimeoutErrorsPath {
	return &Component_Pcie_NonFatalErrors_CompletionTimeoutErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"completion-timeout-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CompletionTimeoutErrors (leaf): Number of completion timeout errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "completion-timeout-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/completion-timeout-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) CompletionTimeoutErrors() *Component_Pcie_NonFatalErrors_CompletionTimeoutErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_CompletionTimeoutErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"completion-timeout-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// DataLinkErrors (leaf): Number of data-link errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "data-link-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/data-link-errors"
func (n *Component_Pcie_NonFatalErrorsPath) DataLinkErrors() *Component_Pcie_NonFatalErrors_DataLinkErrorsPath {
	return &Component_Pcie_NonFatalErrors_DataLinkErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"data-link-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// DataLinkErrors (leaf): Number of data-link errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "data-link-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/data-link-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) DataLinkErrors() *Component_Pcie_NonFatalErrors_DataLinkErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_DataLinkErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"data-link-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// EcrcErrors (leaf): Number of ECRC errors detected by PCIe device since the system
// booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "ecrc-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/ecrc-errors"
func (n *Component_Pcie_NonFatalErrorsPath) EcrcErrors() *Component_Pcie_NonFatalErrors_EcrcErrorsPath {
	return &Component_Pcie_NonFatalErrors_EcrcErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"ecrc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// EcrcErrors (leaf): Number of ECRC errors detected by PCIe device since the system
// booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "ecrc-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/ecrc-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) EcrcErrors() *Component_Pcie_NonFatalErrors_EcrcErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_EcrcErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ecrc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// FlowControlProtocolErrors (leaf): Number of flow control protocol errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "flow-control-protocol-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/flow-control-protocol-errors"
func (n *Component_Pcie_NonFatalErrorsPath) FlowControlProtocolErrors() *Component_Pcie_NonFatalErrors_FlowControlProtocolErrorsPath {
	return &Component_Pcie_NonFatalErrors_FlowControlProtocolErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"flow-control-protocol-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// FlowControlProtocolErrors (leaf): Number of flow control protocol errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "flow-control-protocol-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/flow-control-protocol-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) FlowControlProtocolErrors() *Component_Pcie_NonFatalErrors_FlowControlProtocolErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_FlowControlProtocolErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"flow-control-protocol-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalErrors (leaf): Number of internal errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "internal-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/internal-errors"
func (n *Component_Pcie_NonFatalErrorsPath) InternalErrors() *Component_Pcie_NonFatalErrors_InternalErrorsPath {
	return &Component_Pcie_NonFatalErrors_InternalErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"internal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalErrors (leaf): Number of internal errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "internal-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/internal-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) InternalErrors() *Component_Pcie_NonFatalErrors_InternalErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_InternalErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"internal-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// MalformedTlpErrors (leaf): Number of malformed TLP errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "malformed-tlp-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/malformed-tlp-errors"
func (n *Component_Pcie_NonFatalErrorsPath) MalformedTlpErrors() *Component_Pcie_NonFatalErrors_MalformedTlpErrorsPath {
	return &Component_Pcie_NonFatalErrors_MalformedTlpErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"malformed-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// MalformedTlpErrors (leaf): Number of malformed TLP errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "malformed-tlp-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/malformed-tlp-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) MalformedTlpErrors() *Component_Pcie_NonFatalErrors_MalformedTlpErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_MalformedTlpErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"malformed-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// PoisonedTlpErrors (leaf): Number of poisoned TLP errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "poisoned-tlp-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/poisoned-tlp-errors"
func (n *Component_Pcie_NonFatalErrorsPath) PoisonedTlpErrors() *Component_Pcie_NonFatalErrors_PoisonedTlpErrorsPath {
	return &Component_Pcie_NonFatalErrors_PoisonedTlpErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"poisoned-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// PoisonedTlpErrors (leaf): Number of poisoned TLP errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "poisoned-tlp-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/poisoned-tlp-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) PoisonedTlpErrors() *Component_Pcie_NonFatalErrors_PoisonedTlpErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_PoisonedTlpErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"poisoned-tlp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceiverOverflowErrors (leaf): Number of receiver overflow errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "receiver-overflow-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/receiver-overflow-errors"
func (n *Component_Pcie_NonFatalErrorsPath) ReceiverOverflowErrors() *Component_Pcie_NonFatalErrors_ReceiverOverflowErrorsPath {
	return &Component_Pcie_NonFatalErrors_ReceiverOverflowErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"receiver-overflow-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceiverOverflowErrors (leaf): Number of receiver overflow errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "receiver-overflow-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/receiver-overflow-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) ReceiverOverflowErrors() *Component_Pcie_NonFatalErrors_ReceiverOverflowErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_ReceiverOverflowErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"receiver-overflow-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// SurpriseDownErrors (leaf): Number of unexpected link down errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "surprise-down-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/surprise-down-errors"
func (n *Component_Pcie_NonFatalErrorsPath) SurpriseDownErrors() *Component_Pcie_NonFatalErrors_SurpriseDownErrorsPath {
	return &Component_Pcie_NonFatalErrors_SurpriseDownErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"surprise-down-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// SurpriseDownErrors (leaf): Number of unexpected link down errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "surprise-down-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/surprise-down-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) SurpriseDownErrors() *Component_Pcie_NonFatalErrors_SurpriseDownErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_SurpriseDownErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"surprise-down-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlpPrefixBlockedErrors (leaf): Number of TLP prefix blocked errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "tlp-prefix-blocked-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/tlp-prefix-blocked-errors"
func (n *Component_Pcie_NonFatalErrorsPath) TlpPrefixBlockedErrors() *Component_Pcie_NonFatalErrors_TlpPrefixBlockedErrorsPath {
	return &Component_Pcie_NonFatalErrors_TlpPrefixBlockedErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlp-prefix-blocked-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlpPrefixBlockedErrors (leaf): Number of TLP prefix blocked errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "tlp-prefix-blocked-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/tlp-prefix-blocked-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) TlpPrefixBlockedErrors() *Component_Pcie_NonFatalErrors_TlpPrefixBlockedErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_TlpPrefixBlockedErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlp-prefix-blocked-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalErrors (leaf): Total number of uncorrectable errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "total-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/total-errors"
func (n *Component_Pcie_NonFatalErrorsPath) TotalErrors() *Component_Pcie_NonFatalErrors_TotalErrorsPath {
	return &Component_Pcie_NonFatalErrors_TotalErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"total-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalErrors (leaf): Total number of uncorrectable errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "total-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/total-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) TotalErrors() *Component_Pcie_NonFatalErrors_TotalErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_TotalErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"total-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UndefinedErrors (leaf): Number of undefined errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "undefined-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/undefined-errors"
func (n *Component_Pcie_NonFatalErrorsPath) UndefinedErrors() *Component_Pcie_NonFatalErrors_UndefinedErrorsPath {
	return &Component_Pcie_NonFatalErrors_UndefinedErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UndefinedErrors (leaf): Number of undefined errors detected by PCIe device since the
// system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "undefined-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/undefined-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) UndefinedErrors() *Component_Pcie_NonFatalErrors_UndefinedErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_UndefinedErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnexpectedCompletionErrors (leaf): Number of unexpected completion errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "unexpected-completion-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/unexpected-completion-errors"
func (n *Component_Pcie_NonFatalErrorsPath) UnexpectedCompletionErrors() *Component_Pcie_NonFatalErrors_UnexpectedCompletionErrorsPath {
	return &Component_Pcie_NonFatalErrors_UnexpectedCompletionErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"unexpected-completion-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnexpectedCompletionErrors (leaf): Number of unexpected completion errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "unexpected-completion-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/unexpected-completion-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) UnexpectedCompletionErrors() *Component_Pcie_NonFatalErrors_UnexpectedCompletionErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_UnexpectedCompletionErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unexpected-completion-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnsupportedRequestErrors (leaf): Number of unsupported request errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "unsupported-request-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/unsupported-request-errors"
func (n *Component_Pcie_NonFatalErrorsPath) UnsupportedRequestErrors() *Component_Pcie_NonFatalErrors_UnsupportedRequestErrorsPath {
	return &Component_Pcie_NonFatalErrors_UnsupportedRequestErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"unsupported-request-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnsupportedRequestErrors (leaf): Number of unsupported request errors detected by PCIe device
// since the system booted, according to PCIe AER driver.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "unsupported-request-errors"
// Path from root: "/components/component/state/pcie/non-fatal-errors/unsupported-request-errors"
func (n *Component_Pcie_NonFatalErrorsPathAny) UnsupportedRequestErrors() *Component_Pcie_NonFatalErrors_UnsupportedRequestErrorsPathAny {
	return &Component_Pcie_NonFatalErrors_UnsupportedRequestErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unsupported-request-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_PortPath represents the /openconfig-platform/components/component/port YANG schema element.
type Component_PortPath struct {
	*ygot.NodePath
}

// Component_PortPathAny represents the wildcard version of the /openconfig-platform/components/component/port YANG schema element.
type Component_PortPathAny struct {
	*ygot.NodePath
}

// BreakoutMode (container): Top-level container for port breakout-mode data.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "breakout-mode"
// Path from root: "/components/component/port/breakout-mode"
func (n *Component_PortPath) BreakoutMode() *Component_Port_BreakoutModePath {
	return &Component_Port_BreakoutModePath{
		NodePath: ygot.NewNodePath(
			[]string{"breakout-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// BreakoutMode (container): Top-level container for port breakout-mode data.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "breakout-mode"
// Path from root: "/components/component/port/breakout-mode"
func (n *Component_PortPathAny) BreakoutMode() *Component_Port_BreakoutModePathAny {
	return &Component_Port_BreakoutModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"breakout-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPort (container): Contains data specific to ports on optical transport
// devices.
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "optical-port"
// Path from root: "/components/component/port/optical-port"
func (n *Component_PortPath) OpticalPort() *Component_Port_OpticalPortPath {
	return &Component_Port_OpticalPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"optical-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPort (container): Contains data specific to ports on optical transport
// devices.
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "optical-port"
// Path from root: "/components/component/port/optical-port"
func (n *Component_PortPathAny) OpticalPort() *Component_Port_OpticalPortPathAny {
	return &Component_Port_OpticalPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"optical-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Port_BreakoutModePath represents the /openconfig-platform/components/component/port/breakout-mode YANG schema element.
type Component_Port_BreakoutModePath struct {
	*ygot.NodePath
}

// Component_Port_BreakoutModePathAny represents the wildcard version of the /openconfig-platform/components/component/port/breakout-mode YANG schema element.
type Component_Port_BreakoutModePathAny struct {
	*ygot.NodePath
}

// GroupAny (list): List of breakout groups.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "groups/group"
// Path from root: "/components/component/port/breakout-mode/groups/group"
// Index (wildcarded): uint8
func (n *Component_Port_BreakoutModePath) GroupAny() *Component_Port_BreakoutMode_GroupPathAny {
	return &Component_Port_BreakoutMode_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"groups", "group"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// GroupAny (list): List of breakout groups.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "groups/group"
// Path from root: "/components/component/port/breakout-mode/groups/group"
// Index (wildcarded): uint8
func (n *Component_Port_BreakoutModePathAny) GroupAny() *Component_Port_BreakoutMode_GroupPathAny {
	return &Component_Port_BreakoutMode_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"groups", "group"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// Group (list): List of breakout groups.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "groups/group"
// Path from root: "/components/component/port/breakout-mode/groups/group"
// Index: uint8
func (n *Component_Port_BreakoutModePath) Group(Index uint8) *Component_Port_BreakoutMode_GroupPath {
	return &Component_Port_BreakoutMode_GroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"groups", "group"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Group (list): List of breakout groups.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "groups/group"
// Path from root: "/components/component/port/breakout-mode/groups/group"
// Index: uint8
func (n *Component_Port_BreakoutModePathAny) Group(Index uint8) *Component_Port_BreakoutMode_GroupPathAny {
	return &Component_Port_BreakoutMode_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"groups", "group"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Component_Port_BreakoutMode_GroupPath represents the /openconfig-platform/components/component/port/breakout-mode/groups/group YANG schema element.
type Component_Port_BreakoutMode_GroupPath struct {
	*ygot.NodePath
}

// Component_Port_BreakoutMode_GroupPathAny represents the wildcard version of the /openconfig-platform/components/component/port/breakout-mode/groups/group YANG schema element.
type Component_Port_BreakoutMode_GroupPathAny struct {
	*ygot.NodePath
}

// Component_Port_BreakoutMode_Group_BreakoutSpeedPath represents the /openconfig-platform/components/component/port/breakout-mode/groups/group/config/breakout-speed YANG schema element.
type Component_Port_BreakoutMode_Group_BreakoutSpeedPath struct {
	*ygot.NodePath
}

// Component_Port_BreakoutMode_Group_BreakoutSpeedPathAny represents the wildcard version of the /openconfig-platform/components/component/port/breakout-mode/groups/group/config/breakout-speed YANG schema element.
type Component_Port_BreakoutMode_Group_BreakoutSpeedPathAny struct {
	*ygot.NodePath
}

// Component_Port_BreakoutMode_Group_IndexPath represents the /openconfig-platform/components/component/port/breakout-mode/groups/group/config/index YANG schema element.
type Component_Port_BreakoutMode_Group_IndexPath struct {
	*ygot.NodePath
}

// Component_Port_BreakoutMode_Group_IndexPathAny represents the wildcard version of the /openconfig-platform/components/component/port/breakout-mode/groups/group/config/index YANG schema element.
type Component_Port_BreakoutMode_Group_IndexPathAny struct {
	*ygot.NodePath
}

// Component_Port_BreakoutMode_Group_NumBreakoutsPath represents the /openconfig-platform/components/component/port/breakout-mode/groups/group/config/num-breakouts YANG schema element.
type Component_Port_BreakoutMode_Group_NumBreakoutsPath struct {
	*ygot.NodePath
}

// Component_Port_BreakoutMode_Group_NumBreakoutsPathAny represents the wildcard version of the /openconfig-platform/components/component/port/breakout-mode/groups/group/config/num-breakouts YANG schema element.
type Component_Port_BreakoutMode_Group_NumBreakoutsPathAny struct {
	*ygot.NodePath
}

// Component_Port_BreakoutMode_Group_NumPhysicalChannelsPath represents the /openconfig-platform/components/component/port/breakout-mode/groups/group/config/num-physical-channels YANG schema element.
type Component_Port_BreakoutMode_Group_NumPhysicalChannelsPath struct {
	*ygot.NodePath
}

// Component_Port_BreakoutMode_Group_NumPhysicalChannelsPathAny represents the wildcard version of the /openconfig-platform/components/component/port/breakout-mode/groups/group/config/num-physical-channels YANG schema element.
type Component_Port_BreakoutMode_Group_NumPhysicalChannelsPathAny struct {
	*ygot.NodePath
}

// BreakoutSpeed (leaf): Speed of interfaces in this breakout group, supported
// values are defined by the ETHERNET_SPEED identity.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/breakout-speed"
// Path from root: "/components/component/port/breakout-mode/groups/group/config/breakout-speed"
func (n *Component_Port_BreakoutMode_GroupPath) BreakoutSpeed() *Component_Port_BreakoutMode_Group_BreakoutSpeedPath {
	return &Component_Port_BreakoutMode_Group_BreakoutSpeedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "breakout-speed"},
			map[string]interface{}{},
			n,
		),
	}
}

// BreakoutSpeed (leaf): Speed of interfaces in this breakout group, supported
// values are defined by the ETHERNET_SPEED identity.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/breakout-speed"
// Path from root: "/components/component/port/breakout-mode/groups/group/config/breakout-speed"
func (n *Component_Port_BreakoutMode_GroupPathAny) BreakoutSpeed() *Component_Port_BreakoutMode_Group_BreakoutSpeedPathAny {
	return &Component_Port_BreakoutMode_Group_BreakoutSpeedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "breakout-speed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Each index specifies breakouts that are identical in
// terms of speed and the number of physical channels.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/index"
// Path from root: "/components/component/port/breakout-mode/groups/group/config/index"
func (n *Component_Port_BreakoutMode_GroupPath) Index() *Component_Port_BreakoutMode_Group_IndexPath {
	return &Component_Port_BreakoutMode_Group_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Each index specifies breakouts that are identical in
// terms of speed and the number of physical channels.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/index"
// Path from root: "/components/component/port/breakout-mode/groups/group/config/index"
func (n *Component_Port_BreakoutMode_GroupPathAny) Index() *Component_Port_BreakoutMode_Group_IndexPathAny {
	return &Component_Port_BreakoutMode_Group_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// NumBreakouts (leaf): Sets the number of interfaces using this breakout group.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/num-breakouts"
// Path from root: "/components/component/port/breakout-mode/groups/group/config/num-breakouts"
func (n *Component_Port_BreakoutMode_GroupPath) NumBreakouts() *Component_Port_BreakoutMode_Group_NumBreakoutsPath {
	return &Component_Port_BreakoutMode_Group_NumBreakoutsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "num-breakouts"},
			map[string]interface{}{},
			n,
		),
	}
}

// NumBreakouts (leaf): Sets the number of interfaces using this breakout group.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/num-breakouts"
// Path from root: "/components/component/port/breakout-mode/groups/group/config/num-breakouts"
func (n *Component_Port_BreakoutMode_GroupPathAny) NumBreakouts() *Component_Port_BreakoutMode_Group_NumBreakoutsPathAny {
	return &Component_Port_BreakoutMode_Group_NumBreakoutsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "num-breakouts"},
			map[string]interface{}{},
			n,
		),
	}
}

// NumPhysicalChannels (leaf): Sets the number of lanes or physical channels assigned
// to the interfaces in this breakout group. This leaf need
// not be set if there is only one breakout group where all
// the interfaces are of equal speed and have equal number
// of physical channels
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/num-physical-channels"
// Path from root: "/components/component/port/breakout-mode/groups/group/config/num-physical-channels"
func (n *Component_Port_BreakoutMode_GroupPath) NumPhysicalChannels() *Component_Port_BreakoutMode_Group_NumPhysicalChannelsPath {
	return &Component_Port_BreakoutMode_Group_NumPhysicalChannelsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "num-physical-channels"},
			map[string]interface{}{},
			n,
		),
	}
}

// NumPhysicalChannels (leaf): Sets the number of lanes or physical channels assigned
// to the interfaces in this breakout group. This leaf need
// not be set if there is only one breakout group where all
// the interfaces are of equal speed and have equal number
// of physical channels
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/num-physical-channels"
// Path from root: "/components/component/port/breakout-mode/groups/group/config/num-physical-channels"
func (n *Component_Port_BreakoutMode_GroupPathAny) NumPhysicalChannels() *Component_Port_BreakoutMode_Group_NumPhysicalChannelsPathAny {
	return &Component_Port_BreakoutMode_Group_NumPhysicalChannelsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "num-physical-channels"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Port_OpticalPortPath represents the /openconfig-platform/components/component/port/optical-port YANG schema element.
type Component_Port_OpticalPortPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPortPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port YANG schema element.
type Component_Port_OpticalPortPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_AdminStatePath represents the /openconfig-platform/components/component/port/optical-port/config/admin-state YANG schema element.
type Component_Port_OpticalPort_AdminStatePath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_AdminStatePathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/config/admin-state YANG schema element.
type Component_Port_OpticalPort_AdminStatePathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OpticalPortTypePath represents the /openconfig-platform/components/component/port/optical-port/state/optical-port-type YANG schema element.
type Component_Port_OpticalPort_OpticalPortTypePath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OpticalPortTypePathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/optical-port-type YANG schema element.
type Component_Port_OpticalPort_OpticalPortTypePathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_TiltPath represents the /openconfig-platform/components/component/port/optical-port/state/tilt YANG schema element.
type Component_Port_OpticalPort_TiltPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_TiltPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/tilt YANG schema element.
type Component_Port_OpticalPort_TiltPathAny struct {
	*ygot.NodePath
}

// AdminState (leaf): Sets the admin state of the optical-port
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/admin-state"
// Path from root: "/components/component/port/optical-port/config/admin-state"
func (n *Component_Port_OpticalPortPath) AdminState() *Component_Port_OpticalPort_AdminStatePath {
	return &Component_Port_OpticalPort_AdminStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminState (leaf): Sets the admin state of the optical-port
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/admin-state"
// Path from root: "/components/component/port/optical-port/config/admin-state"
func (n *Component_Port_OpticalPortPathAny) AdminState() *Component_Port_OpticalPort_AdminStatePathAny {
	return &Component_Port_OpticalPort_AdminStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPower (container): For line system device ports, this value indicates
// the total input optical power of the port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/input-power"
// Path from root: "/components/component/port/optical-port/state/input-power"
func (n *Component_Port_OpticalPortPath) InputPower() *Component_Port_OpticalPort_InputPowerPath {
	return &Component_Port_OpticalPort_InputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPower (container): For line system device ports, this value indicates
// the total input optical power of the port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/input-power"
// Path from root: "/components/component/port/optical-port/state/input-power"
func (n *Component_Port_OpticalPortPathAny) InputPower() *Component_Port_OpticalPort_InputPowerPathAny {
	return &Component_Port_OpticalPort_InputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPortType (leaf): For physical ports belonging to optical transport
// devices, this indicates the type of optical port.  This is an
// informational field that should be made available by the
// device.
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/optical-port-type"
// Path from root: "/components/component/port/optical-port/state/optical-port-type"
func (n *Component_Port_OpticalPortPath) OpticalPortType() *Component_Port_OpticalPort_OpticalPortTypePath {
	return &Component_Port_OpticalPort_OpticalPortTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-port-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalPortType (leaf): For physical ports belonging to optical transport
// devices, this indicates the type of optical port.  This is an
// informational field that should be made available by the
// device.
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/optical-port-type"
// Path from root: "/components/component/port/optical-port/state/optical-port-type"
func (n *Component_Port_OpticalPortPathAny) OpticalPortType() *Component_Port_OpticalPort_OpticalPortTypePathAny {
	return &Component_Port_OpticalPort_OpticalPortTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-port-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): For line system device ports, this value indicates
// the total output optical power of the port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-power"
// Path from root: "/components/component/port/optical-port/state/output-power"
func (n *Component_Port_OpticalPortPath) OutputPower() *Component_Port_OpticalPort_OutputPowerPath {
	return &Component_Port_OpticalPort_OutputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): For line system device ports, this value indicates
// the total output optical power of the port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-power"
// Path from root: "/components/component/port/optical-port/state/output-power"
func (n *Component_Port_OpticalPortPathAny) OutputPower() *Component_Port_OpticalPort_OutputPowerPathAny {
	return &Component_Port_OpticalPort_OutputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tilt (leaf): The total tilt measured on the port. This is applicable to
//       ports of type INGRESS and EGRESS.
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/tilt"
// Path from root: "/components/component/port/optical-port/state/tilt"
func (n *Component_Port_OpticalPortPath) Tilt() *Component_Port_OpticalPort_TiltPath {
	return &Component_Port_OpticalPort_TiltPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tilt"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tilt (leaf): The total tilt measured on the port. This is applicable to
//       ports of type INGRESS and EGRESS.
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/tilt"
// Path from root: "/components/component/port/optical-port/state/tilt"
func (n *Component_Port_OpticalPortPathAny) Tilt() *Component_Port_OpticalPort_TiltPathAny {
	return &Component_Port_OpticalPort_TiltPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tilt"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Port_OpticalPort_InputPowerPath represents the /openconfig-platform/components/component/port/optical-port/state/input-power YANG schema element.
type Component_Port_OpticalPort_InputPowerPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/input-power YANG schema element.
type Component_Port_OpticalPort_InputPowerPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_AvgPath represents the /openconfig-platform/components/component/port/optical-port/state/input-power/avg YANG schema element.
type Component_Port_OpticalPort_InputPower_AvgPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/input-power/avg YANG schema element.
type Component_Port_OpticalPort_InputPower_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_InstantPath represents the /openconfig-platform/components/component/port/optical-port/state/input-power/instant YANG schema element.
type Component_Port_OpticalPort_InputPower_InstantPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/input-power/instant YANG schema element.
type Component_Port_OpticalPort_InputPower_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_IntervalPath represents the /openconfig-platform/components/component/port/optical-port/state/input-power/interval YANG schema element.
type Component_Port_OpticalPort_InputPower_IntervalPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/input-power/interval YANG schema element.
type Component_Port_OpticalPort_InputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_MaxPath represents the /openconfig-platform/components/component/port/optical-port/state/input-power/max YANG schema element.
type Component_Port_OpticalPort_InputPower_MaxPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/input-power/max YANG schema element.
type Component_Port_OpticalPort_InputPower_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_MaxTimePath represents the /openconfig-platform/components/component/port/optical-port/state/input-power/max-time YANG schema element.
type Component_Port_OpticalPort_InputPower_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/input-power/max-time YANG schema element.
type Component_Port_OpticalPort_InputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_MinPath represents the /openconfig-platform/components/component/port/optical-port/state/input-power/min YANG schema element.
type Component_Port_OpticalPort_InputPower_MinPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/input-power/min YANG schema element.
type Component_Port_OpticalPort_InputPower_MinPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_MinTimePath represents the /openconfig-platform/components/component/port/optical-port/state/input-power/min-time YANG schema element.
type Component_Port_OpticalPort_InputPower_MinTimePath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_InputPower_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/input-power/min-time YANG schema element.
type Component_Port_OpticalPort_InputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/port/optical-port/state/input-power/avg"
func (n *Component_Port_OpticalPort_InputPowerPath) Avg() *Component_Port_OpticalPort_InputPower_AvgPath {
	return &Component_Port_OpticalPort_InputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/port/optical-port/state/input-power/avg"
func (n *Component_Port_OpticalPort_InputPowerPathAny) Avg() *Component_Port_OpticalPort_InputPower_AvgPathAny {
	return &Component_Port_OpticalPort_InputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/port/optical-port/state/input-power/instant"
func (n *Component_Port_OpticalPort_InputPowerPath) Instant() *Component_Port_OpticalPort_InputPower_InstantPath {
	return &Component_Port_OpticalPort_InputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/port/optical-port/state/input-power/instant"
func (n *Component_Port_OpticalPort_InputPowerPathAny) Instant() *Component_Port_OpticalPort_InputPower_InstantPathAny {
	return &Component_Port_OpticalPort_InputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/port/optical-port/state/input-power/interval"
func (n *Component_Port_OpticalPort_InputPowerPath) Interval() *Component_Port_OpticalPort_InputPower_IntervalPath {
	return &Component_Port_OpticalPort_InputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/port/optical-port/state/input-power/interval"
func (n *Component_Port_OpticalPort_InputPowerPathAny) Interval() *Component_Port_OpticalPort_InputPower_IntervalPathAny {
	return &Component_Port_OpticalPort_InputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/port/optical-port/state/input-power/max"
func (n *Component_Port_OpticalPort_InputPowerPath) Max() *Component_Port_OpticalPort_InputPower_MaxPath {
	return &Component_Port_OpticalPort_InputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/port/optical-port/state/input-power/max"
func (n *Component_Port_OpticalPort_InputPowerPathAny) Max() *Component_Port_OpticalPort_InputPower_MaxPathAny {
	return &Component_Port_OpticalPort_InputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/port/optical-port/state/input-power/max-time"
func (n *Component_Port_OpticalPort_InputPowerPath) MaxTime() *Component_Port_OpticalPort_InputPower_MaxTimePath {
	return &Component_Port_OpticalPort_InputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/port/optical-port/state/input-power/max-time"
func (n *Component_Port_OpticalPort_InputPowerPathAny) MaxTime() *Component_Port_OpticalPort_InputPower_MaxTimePathAny {
	return &Component_Port_OpticalPort_InputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/port/optical-port/state/input-power/min"
func (n *Component_Port_OpticalPort_InputPowerPath) Min() *Component_Port_OpticalPort_InputPower_MinPath {
	return &Component_Port_OpticalPort_InputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/port/optical-port/state/input-power/min"
func (n *Component_Port_OpticalPort_InputPowerPathAny) Min() *Component_Port_OpticalPort_InputPower_MinPathAny {
	return &Component_Port_OpticalPort_InputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/port/optical-port/state/input-power/min-time"
func (n *Component_Port_OpticalPort_InputPowerPath) MinTime() *Component_Port_OpticalPort_InputPower_MinTimePath {
	return &Component_Port_OpticalPort_InputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/port/optical-port/state/input-power/min-time"
func (n *Component_Port_OpticalPort_InputPowerPathAny) MinTime() *Component_Port_OpticalPort_InputPower_MinTimePathAny {
	return &Component_Port_OpticalPort_InputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Port_OpticalPort_OutputPowerPath represents the /openconfig-platform/components/component/port/optical-port/state/output-power YANG schema element.
type Component_Port_OpticalPort_OutputPowerPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/output-power YANG schema element.
type Component_Port_OpticalPort_OutputPowerPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_AvgPath represents the /openconfig-platform/components/component/port/optical-port/state/output-power/avg YANG schema element.
type Component_Port_OpticalPort_OutputPower_AvgPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/output-power/avg YANG schema element.
type Component_Port_OpticalPort_OutputPower_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_InstantPath represents the /openconfig-platform/components/component/port/optical-port/state/output-power/instant YANG schema element.
type Component_Port_OpticalPort_OutputPower_InstantPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/output-power/instant YANG schema element.
type Component_Port_OpticalPort_OutputPower_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_IntervalPath represents the /openconfig-platform/components/component/port/optical-port/state/output-power/interval YANG schema element.
type Component_Port_OpticalPort_OutputPower_IntervalPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/output-power/interval YANG schema element.
type Component_Port_OpticalPort_OutputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_MaxPath represents the /openconfig-platform/components/component/port/optical-port/state/output-power/max YANG schema element.
type Component_Port_OpticalPort_OutputPower_MaxPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/output-power/max YANG schema element.
type Component_Port_OpticalPort_OutputPower_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_MaxTimePath represents the /openconfig-platform/components/component/port/optical-port/state/output-power/max-time YANG schema element.
type Component_Port_OpticalPort_OutputPower_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/output-power/max-time YANG schema element.
type Component_Port_OpticalPort_OutputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_MinPath represents the /openconfig-platform/components/component/port/optical-port/state/output-power/min YANG schema element.
type Component_Port_OpticalPort_OutputPower_MinPath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/output-power/min YANG schema element.
type Component_Port_OpticalPort_OutputPower_MinPathAny struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_MinTimePath represents the /openconfig-platform/components/component/port/optical-port/state/output-power/min-time YANG schema element.
type Component_Port_OpticalPort_OutputPower_MinTimePath struct {
	*ygot.NodePath
}

// Component_Port_OpticalPort_OutputPower_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/port/optical-port/state/output-power/min-time YANG schema element.
type Component_Port_OpticalPort_OutputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/port/optical-port/state/output-power/avg"
func (n *Component_Port_OpticalPort_OutputPowerPath) Avg() *Component_Port_OpticalPort_OutputPower_AvgPath {
	return &Component_Port_OpticalPort_OutputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/port/optical-port/state/output-power/avg"
func (n *Component_Port_OpticalPort_OutputPowerPathAny) Avg() *Component_Port_OpticalPort_OutputPower_AvgPathAny {
	return &Component_Port_OpticalPort_OutputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/port/optical-port/state/output-power/instant"
func (n *Component_Port_OpticalPort_OutputPowerPath) Instant() *Component_Port_OpticalPort_OutputPower_InstantPath {
	return &Component_Port_OpticalPort_OutputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/port/optical-port/state/output-power/instant"
func (n *Component_Port_OpticalPort_OutputPowerPathAny) Instant() *Component_Port_OpticalPort_OutputPower_InstantPathAny {
	return &Component_Port_OpticalPort_OutputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/port/optical-port/state/output-power/interval"
func (n *Component_Port_OpticalPort_OutputPowerPath) Interval() *Component_Port_OpticalPort_OutputPower_IntervalPath {
	return &Component_Port_OpticalPort_OutputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/port/optical-port/state/output-power/interval"
func (n *Component_Port_OpticalPort_OutputPowerPathAny) Interval() *Component_Port_OpticalPort_OutputPower_IntervalPathAny {
	return &Component_Port_OpticalPort_OutputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/port/optical-port/state/output-power/max"
func (n *Component_Port_OpticalPort_OutputPowerPath) Max() *Component_Port_OpticalPort_OutputPower_MaxPath {
	return &Component_Port_OpticalPort_OutputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/port/optical-port/state/output-power/max"
func (n *Component_Port_OpticalPort_OutputPowerPathAny) Max() *Component_Port_OpticalPort_OutputPower_MaxPathAny {
	return &Component_Port_OpticalPort_OutputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/port/optical-port/state/output-power/max-time"
func (n *Component_Port_OpticalPort_OutputPowerPath) MaxTime() *Component_Port_OpticalPort_OutputPower_MaxTimePath {
	return &Component_Port_OpticalPort_OutputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/port/optical-port/state/output-power/max-time"
func (n *Component_Port_OpticalPort_OutputPowerPathAny) MaxTime() *Component_Port_OpticalPort_OutputPower_MaxTimePathAny {
	return &Component_Port_OpticalPort_OutputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/port/optical-port/state/output-power/min"
func (n *Component_Port_OpticalPort_OutputPowerPath) Min() *Component_Port_OpticalPort_OutputPower_MinPath {
	return &Component_Port_OpticalPort_OutputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/port/optical-port/state/output-power/min"
func (n *Component_Port_OpticalPort_OutputPowerPathAny) Min() *Component_Port_OpticalPort_OutputPower_MinPathAny {
	return &Component_Port_OpticalPort_OutputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/port/optical-port/state/output-power/min-time"
func (n *Component_Port_OpticalPort_OutputPowerPath) MinTime() *Component_Port_OpticalPort_OutputPower_MinTimePath {
	return &Component_Port_OpticalPort_OutputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/port/optical-port/state/output-power/min-time"
func (n *Component_Port_OpticalPort_OutputPowerPathAny) MinTime() *Component_Port_OpticalPort_OutputPower_MinTimePathAny {
	return &Component_Port_OpticalPort_OutputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_PowerSupplyPath represents the /openconfig-platform/components/component/power-supply YANG schema element.
type Component_PowerSupplyPath struct {
	*ygot.NodePath
}

// Component_PowerSupplyPathAny represents the wildcard version of the /openconfig-platform/components/component/power-supply YANG schema element.
type Component_PowerSupplyPathAny struct {
	*ygot.NodePath
}

// Component_PropertyPath represents the /openconfig-platform/components/component/properties/property YANG schema element.
type Component_PropertyPath struct {
	*ygot.NodePath
}

// Component_PropertyPathAny represents the wildcard version of the /openconfig-platform/components/component/properties/property YANG schema element.
type Component_PropertyPathAny struct {
	*ygot.NodePath
}

// Component_Property_ConfigurablePath represents the /openconfig-platform/components/component/properties/property/state/configurable YANG schema element.
type Component_Property_ConfigurablePath struct {
	*ygot.NodePath
}

// Component_Property_ConfigurablePathAny represents the wildcard version of the /openconfig-platform/components/component/properties/property/state/configurable YANG schema element.
type Component_Property_ConfigurablePathAny struct {
	*ygot.NodePath
}

// Component_Property_NamePath represents the /openconfig-platform/components/component/properties/property/config/name YANG schema element.
type Component_Property_NamePath struct {
	*ygot.NodePath
}

// Component_Property_NamePathAny represents the wildcard version of the /openconfig-platform/components/component/properties/property/config/name YANG schema element.
type Component_Property_NamePathAny struct {
	*ygot.NodePath
}

// Component_Property_ValuePath represents the /openconfig-platform/components/component/properties/property/config/value YANG schema element.
type Component_Property_ValuePath struct {
	*ygot.NodePath
}

// Component_Property_ValuePathAny represents the wildcard version of the /openconfig-platform/components/component/properties/property/config/value YANG schema element.
type Component_Property_ValuePathAny struct {
	*ygot.NodePath
}

// Configurable (leaf): Indication whether the property is user-configurable
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/configurable"
// Path from root: "/components/component/properties/property/state/configurable"
func (n *Component_PropertyPath) Configurable() *Component_Property_ConfigurablePath {
	return &Component_Property_ConfigurablePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "configurable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Configurable (leaf): Indication whether the property is user-configurable
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/configurable"
// Path from root: "/components/component/properties/property/state/configurable"
func (n *Component_PropertyPathAny) Configurable() *Component_Property_ConfigurablePathAny {
	return &Component_Property_ConfigurablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "configurable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): System-supplied name of the property -- this is typically
// non-configurable
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/name"
// Path from root: "/components/component/properties/property/config/name"
func (n *Component_PropertyPath) Name() *Component_Property_NamePath {
	return &Component_Property_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): System-supplied name of the property -- this is typically
// non-configurable
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/name"
// Path from root: "/components/component/properties/property/config/name"
func (n *Component_PropertyPathAny) Name() *Component_Property_NamePathAny {
	return &Component_Property_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Property values can take on a variety of types.  Signed and
// unsigned integer types may be provided in smaller sizes,
// e.g., int8, uint16, etc.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/value"
// Path from root: "/components/component/properties/property/config/value"
func (n *Component_PropertyPath) Value() *Component_Property_ValuePath {
	return &Component_Property_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Property values can take on a variety of types.  Signed and
// unsigned integer types may be provided in smaller sizes,
// e.g., int8, uint16, etc.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/value"
// Path from root: "/components/component/properties/property/config/value"
func (n *Component_PropertyPathAny) Value() *Component_Property_ValuePathAny {
	return &Component_Property_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_SoftwareModulePath represents the /openconfig-platform/components/component/software-module YANG schema element.
type Component_SoftwareModulePath struct {
	*ygot.NodePath
}

// Component_SoftwareModulePathAny represents the wildcard version of the /openconfig-platform/components/component/software-module YANG schema element.
type Component_SoftwareModulePathAny struct {
	*ygot.NodePath
}

// Component_StoragePath represents the /openconfig-platform/components/component/storage YANG schema element.
type Component_StoragePath struct {
	*ygot.NodePath
}

// Component_StoragePathAny represents the wildcard version of the /openconfig-platform/components/component/storage YANG schema element.
type Component_StoragePathAny struct {
	*ygot.NodePath
}

// Component_SubcomponentPath represents the /openconfig-platform/components/component/subcomponents/subcomponent YANG schema element.
type Component_SubcomponentPath struct {
	*ygot.NodePath
}

// Component_SubcomponentPathAny represents the wildcard version of the /openconfig-platform/components/component/subcomponents/subcomponent YANG schema element.
type Component_SubcomponentPathAny struct {
	*ygot.NodePath
}

// Component_Subcomponent_NamePath represents the /openconfig-platform/components/component/subcomponents/subcomponent/config/name YANG schema element.
type Component_Subcomponent_NamePath struct {
	*ygot.NodePath
}

// Component_Subcomponent_NamePathAny represents the wildcard version of the /openconfig-platform/components/component/subcomponents/subcomponent/config/name YANG schema element.
type Component_Subcomponent_NamePathAny struct {
	*ygot.NodePath
}

// Name (leaf): Reference to the name of the subcomponent
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/name"
// Path from root: "/components/component/subcomponents/subcomponent/config/name"
func (n *Component_SubcomponentPath) Name() *Component_Subcomponent_NamePath {
	return &Component_Subcomponent_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the name of the subcomponent
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/name"
// Path from root: "/components/component/subcomponents/subcomponent/config/name"
func (n *Component_SubcomponentPathAny) Name() *Component_Subcomponent_NamePathAny {
	return &Component_Subcomponent_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_TemperaturePath represents the /openconfig-platform/components/component/state/temperature YANG schema element.
type Component_TemperaturePath struct {
	*ygot.NodePath
}

// Component_TemperaturePathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature YANG schema element.
type Component_TemperaturePathAny struct {
	*ygot.NodePath
}

// Component_Temperature_AlarmSeverityPath represents the /openconfig-platform/components/component/state/temperature/alarm-severity YANG schema element.
type Component_Temperature_AlarmSeverityPath struct {
	*ygot.NodePath
}

// Component_Temperature_AlarmSeverityPathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/alarm-severity YANG schema element.
type Component_Temperature_AlarmSeverityPathAny struct {
	*ygot.NodePath
}

// Component_Temperature_AlarmStatusPath represents the /openconfig-platform/components/component/state/temperature/alarm-status YANG schema element.
type Component_Temperature_AlarmStatusPath struct {
	*ygot.NodePath
}

// Component_Temperature_AlarmStatusPathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/alarm-status YANG schema element.
type Component_Temperature_AlarmStatusPathAny struct {
	*ygot.NodePath
}

// Component_Temperature_AlarmThresholdPath represents the /openconfig-platform/components/component/state/temperature/alarm-threshold YANG schema element.
type Component_Temperature_AlarmThresholdPath struct {
	*ygot.NodePath
}

// Component_Temperature_AlarmThresholdPathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/alarm-threshold YANG schema element.
type Component_Temperature_AlarmThresholdPathAny struct {
	*ygot.NodePath
}

// Component_Temperature_AvgPath represents the /openconfig-platform/components/component/state/temperature/avg YANG schema element.
type Component_Temperature_AvgPath struct {
	*ygot.NodePath
}

// Component_Temperature_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/avg YANG schema element.
type Component_Temperature_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Temperature_InstantPath represents the /openconfig-platform/components/component/state/temperature/instant YANG schema element.
type Component_Temperature_InstantPath struct {
	*ygot.NodePath
}

// Component_Temperature_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/instant YANG schema element.
type Component_Temperature_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Temperature_IntervalPath represents the /openconfig-platform/components/component/state/temperature/interval YANG schema element.
type Component_Temperature_IntervalPath struct {
	*ygot.NodePath
}

// Component_Temperature_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/interval YANG schema element.
type Component_Temperature_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Temperature_MaxPath represents the /openconfig-platform/components/component/state/temperature/max YANG schema element.
type Component_Temperature_MaxPath struct {
	*ygot.NodePath
}

// Component_Temperature_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/max YANG schema element.
type Component_Temperature_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Temperature_MaxTimePath represents the /openconfig-platform/components/component/state/temperature/max-time YANG schema element.
type Component_Temperature_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Temperature_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/max-time YANG schema element.
type Component_Temperature_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Temperature_MinPath represents the /openconfig-platform/components/component/state/temperature/min YANG schema element.
type Component_Temperature_MinPath struct {
	*ygot.NodePath
}

// Component_Temperature_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/min YANG schema element.
type Component_Temperature_MinPathAny struct {
	*ygot.NodePath
}

// Component_Temperature_MinTimePath represents the /openconfig-platform/components/component/state/temperature/min-time YANG schema element.
type Component_Temperature_MinTimePath struct {
	*ygot.NodePath
}

// Component_Temperature_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/state/temperature/min-time YANG schema element.
type Component_Temperature_MinTimePathAny struct {
	*ygot.NodePath
}

// AlarmSeverity (leaf): The severity of the current alarm.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "alarm-severity"
// Path from root: "/components/component/state/temperature/alarm-severity"
func (n *Component_TemperaturePath) AlarmSeverity() *Component_Temperature_AlarmSeverityPath {
	return &Component_Temperature_AlarmSeverityPath{
		NodePath: ygot.NewNodePath(
			[]string{"alarm-severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlarmSeverity (leaf): The severity of the current alarm.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "alarm-severity"
// Path from root: "/components/component/state/temperature/alarm-severity"
func (n *Component_TemperaturePathAny) AlarmSeverity() *Component_Temperature_AlarmSeverityPathAny {
	return &Component_Temperature_AlarmSeverityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"alarm-severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlarmStatus (leaf): A value of true indicates the alarm has been raised or
// asserted.  The value should be false when the alarm is
// cleared.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "alarm-status"
// Path from root: "/components/component/state/temperature/alarm-status"
func (n *Component_TemperaturePath) AlarmStatus() *Component_Temperature_AlarmStatusPath {
	return &Component_Temperature_AlarmStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"alarm-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlarmStatus (leaf): A value of true indicates the alarm has been raised or
// asserted.  The value should be false when the alarm is
// cleared.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "alarm-status"
// Path from root: "/components/component/state/temperature/alarm-status"
func (n *Component_TemperaturePathAny) AlarmStatus() *Component_Temperature_AlarmStatusPathAny {
	return &Component_Temperature_AlarmStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"alarm-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlarmThreshold (leaf): The threshold value that was crossed for this alarm.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "alarm-threshold"
// Path from root: "/components/component/state/temperature/alarm-threshold"
func (n *Component_TemperaturePath) AlarmThreshold() *Component_Temperature_AlarmThresholdPath {
	return &Component_Temperature_AlarmThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"alarm-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlarmThreshold (leaf): The threshold value that was crossed for this alarm.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "alarm-threshold"
// Path from root: "/components/component/state/temperature/alarm-threshold"
func (n *Component_TemperaturePathAny) AlarmThreshold() *Component_Temperature_AlarmThresholdPathAny {
	return &Component_Temperature_AlarmThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"alarm-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// sampling period.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/state/temperature/avg"
func (n *Component_TemperaturePath) Avg() *Component_Temperature_AvgPath {
	return &Component_Temperature_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// sampling period.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/state/temperature/avg"
func (n *Component_TemperaturePathAny) Avg() *Component_Temperature_AvgPathAny {
	return &Component_Temperature_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/state/temperature/instant"
func (n *Component_TemperaturePath) Instant() *Component_Temperature_InstantPath {
	return &Component_Temperature_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/state/temperature/instant"
func (n *Component_TemperaturePathAny) Instant() *Component_Temperature_InstantPathAny {
	return &Component_Temperature_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/state/temperature/interval"
func (n *Component_TemperaturePath) Interval() *Component_Temperature_IntervalPath {
	return &Component_Temperature_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/state/temperature/interval"
func (n *Component_TemperaturePathAny) Interval() *Component_Temperature_IntervalPathAny {
	return &Component_Temperature_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/state/temperature/max"
func (n *Component_TemperaturePath) Max() *Component_Temperature_MaxPath {
	return &Component_Temperature_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/state/temperature/max"
func (n *Component_TemperaturePathAny) Max() *Component_Temperature_MaxPathAny {
	return &Component_Temperature_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/state/temperature/max-time"
func (n *Component_TemperaturePath) MaxTime() *Component_Temperature_MaxTimePath {
	return &Component_Temperature_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/state/temperature/max-time"
func (n *Component_TemperaturePathAny) MaxTime() *Component_Temperature_MaxTimePathAny {
	return &Component_Temperature_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/state/temperature/min"
func (n *Component_TemperaturePath) Min() *Component_Temperature_MinPath {
	return &Component_Temperature_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/state/temperature/min"
func (n *Component_TemperaturePathAny) Min() *Component_Temperature_MinPathAny {
	return &Component_Temperature_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/state/temperature/min-time"
func (n *Component_TemperaturePath) MinTime() *Component_Temperature_MinTimePath {
	return &Component_Temperature_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/state/temperature/min-time"
func (n *Component_TemperaturePathAny) MinTime() *Component_Temperature_MinTimePathAny {
	return &Component_Temperature_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_TransceiverPath represents the /openconfig-platform/components/component/transceiver YANG schema element.
type Component_TransceiverPath struct {
	*ygot.NodePath
}

// Component_TransceiverPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver YANG schema element.
type Component_TransceiverPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_ConnectorTypePath represents the /openconfig-platform/components/component/transceiver/state/connector-type YANG schema element.
type Component_Transceiver_ConnectorTypePath struct {
	*ygot.NodePath
}

// Component_Transceiver_ConnectorTypePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/connector-type YANG schema element.
type Component_Transceiver_ConnectorTypePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_DateCodePath represents the /openconfig-platform/components/component/transceiver/state/date-code YANG schema element.
type Component_Transceiver_DateCodePath struct {
	*ygot.NodePath
}

// Component_Transceiver_DateCodePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/date-code YANG schema element.
type Component_Transceiver_DateCodePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_EnabledPath represents the /openconfig-platform/components/component/transceiver/config/enabled YANG schema element.
type Component_Transceiver_EnabledPath struct {
	*ygot.NodePath
}

// Component_Transceiver_EnabledPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/config/enabled YANG schema element.
type Component_Transceiver_EnabledPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_EthernetPmdPath represents the /openconfig-platform/components/component/transceiver/state/ethernet-pmd YANG schema element.
type Component_Transceiver_EthernetPmdPath struct {
	*ygot.NodePath
}

// Component_Transceiver_EthernetPmdPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/ethernet-pmd YANG schema element.
type Component_Transceiver_EthernetPmdPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_EthernetPmdPreconfPath represents the /openconfig-platform/components/component/transceiver/config/ethernet-pmd-preconf YANG schema element.
type Component_Transceiver_EthernetPmdPreconfPath struct {
	*ygot.NodePath
}

// Component_Transceiver_EthernetPmdPreconfPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/config/ethernet-pmd-preconf YANG schema element.
type Component_Transceiver_EthernetPmdPreconfPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_FaultConditionPath represents the /openconfig-platform/components/component/transceiver/state/fault-condition YANG schema element.
type Component_Transceiver_FaultConditionPath struct {
	*ygot.NodePath
}

// Component_Transceiver_FaultConditionPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/fault-condition YANG schema element.
type Component_Transceiver_FaultConditionPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_FecCorrectedBitsPath represents the /openconfig-platform/components/component/transceiver/state/fec-corrected-bits YANG schema element.
type Component_Transceiver_FecCorrectedBitsPath struct {
	*ygot.NodePath
}

// Component_Transceiver_FecCorrectedBitsPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/fec-corrected-bits YANG schema element.
type Component_Transceiver_FecCorrectedBitsPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_FecCorrectedBytesPath represents the /openconfig-platform/components/component/transceiver/state/fec-corrected-bytes YANG schema element.
type Component_Transceiver_FecCorrectedBytesPath struct {
	*ygot.NodePath
}

// Component_Transceiver_FecCorrectedBytesPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/fec-corrected-bytes YANG schema element.
type Component_Transceiver_FecCorrectedBytesPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_FecModePath represents the /openconfig-platform/components/component/transceiver/config/fec-mode YANG schema element.
type Component_Transceiver_FecModePath struct {
	*ygot.NodePath
}

// Component_Transceiver_FecModePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/config/fec-mode YANG schema element.
type Component_Transceiver_FecModePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_FecStatusPath represents the /openconfig-platform/components/component/transceiver/state/fec-status YANG schema element.
type Component_Transceiver_FecStatusPath struct {
	*ygot.NodePath
}

// Component_Transceiver_FecStatusPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/fec-status YANG schema element.
type Component_Transceiver_FecStatusPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_FecUncorrectableBlocksPath represents the /openconfig-platform/components/component/transceiver/state/fec-uncorrectable-blocks YANG schema element.
type Component_Transceiver_FecUncorrectableBlocksPath struct {
	*ygot.NodePath
}

// Component_Transceiver_FecUncorrectableBlocksPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/fec-uncorrectable-blocks YANG schema element.
type Component_Transceiver_FecUncorrectableBlocksPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_FecUncorrectableWordsPath represents the /openconfig-platform/components/component/transceiver/state/fec-uncorrectable-words YANG schema element.
type Component_Transceiver_FecUncorrectableWordsPath struct {
	*ygot.NodePath
}

// Component_Transceiver_FecUncorrectableWordsPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/fec-uncorrectable-words YANG schema element.
type Component_Transceiver_FecUncorrectableWordsPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_FormFactorPath represents the /openconfig-platform/components/component/transceiver/state/form-factor YANG schema element.
type Component_Transceiver_FormFactorPath struct {
	*ygot.NodePath
}

// Component_Transceiver_FormFactorPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/form-factor YANG schema element.
type Component_Transceiver_FormFactorPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_FormFactorPreconfPath represents the /openconfig-platform/components/component/transceiver/config/form-factor-preconf YANG schema element.
type Component_Transceiver_FormFactorPreconfPath struct {
	*ygot.NodePath
}

// Component_Transceiver_FormFactorPreconfPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/config/form-factor-preconf YANG schema element.
type Component_Transceiver_FormFactorPreconfPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_ModuleFunctionalTypePath represents the /openconfig-platform/components/component/transceiver/config/module-functional-type YANG schema element.
type Component_Transceiver_ModuleFunctionalTypePath struct {
	*ygot.NodePath
}

// Component_Transceiver_ModuleFunctionalTypePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/config/module-functional-type YANG schema element.
type Component_Transceiver_ModuleFunctionalTypePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_OtnComplianceCodePath represents the /openconfig-platform/components/component/transceiver/state/otn-compliance-code YANG schema element.
type Component_Transceiver_OtnComplianceCodePath struct {
	*ygot.NodePath
}

// Component_Transceiver_OtnComplianceCodePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/otn-compliance-code YANG schema element.
type Component_Transceiver_OtnComplianceCodePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PresentPath represents the /openconfig-platform/components/component/transceiver/state/present YANG schema element.
type Component_Transceiver_PresentPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PresentPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/present YANG schema element.
type Component_Transceiver_PresentPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_SerialNoPath represents the /openconfig-platform/components/component/transceiver/state/serial-no YANG schema element.
type Component_Transceiver_SerialNoPath struct {
	*ygot.NodePath
}

// Component_Transceiver_SerialNoPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/serial-no YANG schema element.
type Component_Transceiver_SerialNoPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_SonetSdhComplianceCodePath represents the /openconfig-platform/components/component/transceiver/state/sonet-sdh-compliance-code YANG schema element.
type Component_Transceiver_SonetSdhComplianceCodePath struct {
	*ygot.NodePath
}

// Component_Transceiver_SonetSdhComplianceCodePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/sonet-sdh-compliance-code YANG schema element.
type Component_Transceiver_SonetSdhComplianceCodePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_VendorPath represents the /openconfig-platform/components/component/transceiver/state/vendor YANG schema element.
type Component_Transceiver_VendorPath struct {
	*ygot.NodePath
}

// Component_Transceiver_VendorPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/vendor YANG schema element.
type Component_Transceiver_VendorPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_VendorPartPath represents the /openconfig-platform/components/component/transceiver/state/vendor-part YANG schema element.
type Component_Transceiver_VendorPartPath struct {
	*ygot.NodePath
}

// Component_Transceiver_VendorPartPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/vendor-part YANG schema element.
type Component_Transceiver_VendorPartPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_VendorRevPath represents the /openconfig-platform/components/component/transceiver/state/vendor-rev YANG schema element.
type Component_Transceiver_VendorRevPath struct {
	*ygot.NodePath
}

// Component_Transceiver_VendorRevPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/vendor-rev YANG schema element.
type Component_Transceiver_VendorRevPathAny struct {
	*ygot.NodePath
}

// ChannelAny (list): List of client channels, keyed by index within a physical
// client port.  A physical port with a single channel would
// have a single zero-indexed element
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "physical-channels/channel"
// Path from root: "/components/component/transceiver/physical-channels/channel"
// Index (wildcarded): uint16
func (n *Component_TransceiverPath) ChannelAny() *Component_Transceiver_ChannelPathAny {
	return &Component_Transceiver_ChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"physical-channels", "channel"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// ChannelAny (list): List of client channels, keyed by index within a physical
// client port.  A physical port with a single channel would
// have a single zero-indexed element
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "physical-channels/channel"
// Path from root: "/components/component/transceiver/physical-channels/channel"
// Index (wildcarded): uint16
func (n *Component_TransceiverPathAny) ChannelAny() *Component_Transceiver_ChannelPathAny {
	return &Component_Transceiver_ChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"physical-channels", "channel"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// Channel (list): List of client channels, keyed by index within a physical
// client port.  A physical port with a single channel would
// have a single zero-indexed element
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "physical-channels/channel"
// Path from root: "/components/component/transceiver/physical-channels/channel"
// Index: uint16
func (n *Component_TransceiverPath) Channel(Index uint16) *Component_Transceiver_ChannelPath {
	return &Component_Transceiver_ChannelPath{
		NodePath: ygot.NewNodePath(
			[]string{"physical-channels", "channel"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Channel (list): List of client channels, keyed by index within a physical
// client port.  A physical port with a single channel would
// have a single zero-indexed element
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "physical-channels/channel"
// Path from root: "/components/component/transceiver/physical-channels/channel"
// Index: uint16
func (n *Component_TransceiverPathAny) Channel(Index uint16) *Component_Transceiver_ChannelPathAny {
	return &Component_Transceiver_ChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"physical-channels", "channel"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// ConnectorType (leaf): Connector type used on this port
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/connector-type"
// Path from root: "/components/component/transceiver/state/connector-type"
func (n *Component_TransceiverPath) ConnectorType() *Component_Transceiver_ConnectorTypePath {
	return &Component_Transceiver_ConnectorTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connector-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectorType (leaf): Connector type used on this port
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/connector-type"
// Path from root: "/components/component/transceiver/state/connector-type"
func (n *Component_TransceiverPathAny) ConnectorType() *Component_Transceiver_ConnectorTypePathAny {
	return &Component_Transceiver_ConnectorTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connector-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// DateCode (leaf): Representation of the transceiver date code, typically
// stored as YYMMDD.  The time portion of the value is
// undefined and not intended to be read.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/date-code"
// Path from root: "/components/component/transceiver/state/date-code"
func (n *Component_TransceiverPath) DateCode() *Component_Transceiver_DateCodePath {
	return &Component_Transceiver_DateCodePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "date-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// DateCode (leaf): Representation of the transceiver date code, typically
// stored as YYMMDD.  The time portion of the value is
// undefined and not intended to be read.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/date-code"
// Path from root: "/components/component/transceiver/state/date-code"
func (n *Component_TransceiverPathAny) DateCode() *Component_Transceiver_DateCodePathAny {
	return &Component_Transceiver_DateCodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "date-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Turns power on / off to the transceiver -- provides a means
// to power on/off the transceiver (in the case of SFP, SFP+,
// QSFP,...) or enable high-power mode (in the case of CFP,
// CFP2, CFP4) and is optionally supported (device can choose to
// always enable).  True = power on / high power, False =
// powered off
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/enabled"
// Path from root: "/components/component/transceiver/config/enabled"
func (n *Component_TransceiverPath) Enabled() *Component_Transceiver_EnabledPath {
	return &Component_Transceiver_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Turns power on / off to the transceiver -- provides a means
// to power on/off the transceiver (in the case of SFP, SFP+,
// QSFP,...) or enable high-power mode (in the case of CFP,
// CFP2, CFP4) and is optionally supported (device can choose to
// always enable).  True = power on / high power, False =
// powered off
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/enabled"
// Path from root: "/components/component/transceiver/config/enabled"
func (n *Component_TransceiverPathAny) Enabled() *Component_Transceiver_EnabledPathAny {
	return &Component_Transceiver_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// EthernetPmd (leaf): Ethernet PMD (physical medium dependent sublayer) that the
// transceiver supports. The SFF/QSFP MSAs have registers for
// this and CFP MSA has similar.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/ethernet-pmd"
// Path from root: "/components/component/transceiver/state/ethernet-pmd"
func (n *Component_TransceiverPath) EthernetPmd() *Component_Transceiver_EthernetPmdPath {
	return &Component_Transceiver_EthernetPmdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-pmd"},
			map[string]interface{}{},
			n,
		),
	}
}

// EthernetPmd (leaf): Ethernet PMD (physical medium dependent sublayer) that the
// transceiver supports. The SFF/QSFP MSAs have registers for
// this and CFP MSA has similar.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/ethernet-pmd"
// Path from root: "/components/component/transceiver/state/ethernet-pmd"
func (n *Component_TransceiverPathAny) EthernetPmd() *Component_Transceiver_EthernetPmdPathAny {
	return &Component_Transceiver_EthernetPmdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-pmd"},
			map[string]interface{}{},
			n,
		),
	}
}

// EthernetPmdPreconf (leaf): The Ethernet PMD is a property of the optical transceiver
// used on the port, indicating the type of physical connection.
// It is included in configuration data to allow pre-configuring
// a port/transceiver with the expected PMD.  The actual PMD is
// indicated by the ethernet-pmd state leaf.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/ethernet-pmd-preconf"
// Path from root: "/components/component/transceiver/config/ethernet-pmd-preconf"
func (n *Component_TransceiverPath) EthernetPmdPreconf() *Component_Transceiver_EthernetPmdPreconfPath {
	return &Component_Transceiver_EthernetPmdPreconfPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ethernet-pmd-preconf"},
			map[string]interface{}{},
			n,
		),
	}
}

// EthernetPmdPreconf (leaf): The Ethernet PMD is a property of the optical transceiver
// used on the port, indicating the type of physical connection.
// It is included in configuration data to allow pre-configuring
// a port/transceiver with the expected PMD.  The actual PMD is
// indicated by the ethernet-pmd state leaf.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/ethernet-pmd-preconf"
// Path from root: "/components/component/transceiver/config/ethernet-pmd-preconf"
func (n *Component_TransceiverPathAny) EthernetPmdPreconf() *Component_Transceiver_EthernetPmdPreconfPathAny {
	return &Component_Transceiver_EthernetPmdPreconfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ethernet-pmd-preconf"},
			map[string]interface{}{},
			n,
		),
	}
}

// FaultCondition (leaf): Indicates if a fault condition exists in the transceiver
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fault-condition"
// Path from root: "/components/component/transceiver/state/fault-condition"
func (n *Component_TransceiverPath) FaultCondition() *Component_Transceiver_FaultConditionPath {
	return &Component_Transceiver_FaultConditionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fault-condition"},
			map[string]interface{}{},
			n,
		),
	}
}

// FaultCondition (leaf): Indicates if a fault condition exists in the transceiver
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fault-condition"
// Path from root: "/components/component/transceiver/state/fault-condition"
func (n *Component_TransceiverPathAny) FaultCondition() *Component_Transceiver_FaultConditionPathAny {
	return &Component_Transceiver_FaultConditionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fault-condition"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecCorrectedBits (leaf): The number of bits that were corrected by the FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-corrected-bits"
// Path from root: "/components/component/transceiver/state/fec-corrected-bits"
func (n *Component_TransceiverPath) FecCorrectedBits() *Component_Transceiver_FecCorrectedBitsPath {
	return &Component_Transceiver_FecCorrectedBitsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-corrected-bits"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecCorrectedBits (leaf): The number of bits that were corrected by the FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-corrected-bits"
// Path from root: "/components/component/transceiver/state/fec-corrected-bits"
func (n *Component_TransceiverPathAny) FecCorrectedBits() *Component_Transceiver_FecCorrectedBitsPathAny {
	return &Component_Transceiver_FecCorrectedBitsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-corrected-bits"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecCorrectedBytes (leaf): The number of bytes that were corrected by the FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-corrected-bytes"
// Path from root: "/components/component/transceiver/state/fec-corrected-bytes"
func (n *Component_TransceiverPath) FecCorrectedBytes() *Component_Transceiver_FecCorrectedBytesPath {
	return &Component_Transceiver_FecCorrectedBytesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-corrected-bytes"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecCorrectedBytes (leaf): The number of bytes that were corrected by the FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-corrected-bytes"
// Path from root: "/components/component/transceiver/state/fec-corrected-bytes"
func (n *Component_TransceiverPathAny) FecCorrectedBytes() *Component_Transceiver_FecCorrectedBytesPathAny {
	return &Component_Transceiver_FecCorrectedBytesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-corrected-bytes"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecMode (leaf): The FEC mode indicates the mode of operation for the
// transceiver's FEC. This defines typical operational modes
// and does not aim to specify more granular FEC capabilities.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/fec-mode"
// Path from root: "/components/component/transceiver/config/fec-mode"
func (n *Component_TransceiverPath) FecMode() *Component_Transceiver_FecModePath {
	return &Component_Transceiver_FecModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "fec-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecMode (leaf): The FEC mode indicates the mode of operation for the
// transceiver's FEC. This defines typical operational modes
// and does not aim to specify more granular FEC capabilities.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/fec-mode"
// Path from root: "/components/component/transceiver/config/fec-mode"
func (n *Component_TransceiverPathAny) FecMode() *Component_Transceiver_FecModePathAny {
	return &Component_Transceiver_FecModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "fec-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecStatus (leaf): Operational status of FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-status"
// Path from root: "/components/component/transceiver/state/fec-status"
func (n *Component_TransceiverPath) FecStatus() *Component_Transceiver_FecStatusPath {
	return &Component_Transceiver_FecStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecStatus (leaf): Operational status of FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-status"
// Path from root: "/components/component/transceiver/state/fec-status"
func (n *Component_TransceiverPathAny) FecStatus() *Component_Transceiver_FecStatusPathAny {
	return &Component_Transceiver_FecStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableBlocks (leaf): The number of blocks that were uncorrectable by the FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-uncorrectable-blocks"
// Path from root: "/components/component/transceiver/state/fec-uncorrectable-blocks"
func (n *Component_TransceiverPath) FecUncorrectableBlocks() *Component_Transceiver_FecUncorrectableBlocksPath {
	return &Component_Transceiver_FecUncorrectableBlocksPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableBlocks (leaf): The number of blocks that were uncorrectable by the FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-uncorrectable-blocks"
// Path from root: "/components/component/transceiver/state/fec-uncorrectable-blocks"
func (n *Component_TransceiverPathAny) FecUncorrectableBlocks() *Component_Transceiver_FecUncorrectableBlocksPathAny {
	return &Component_Transceiver_FecUncorrectableBlocksPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableWords (leaf): The number of words that were uncorrectable by the FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-uncorrectable-words"
// Path from root: "/components/component/transceiver/state/fec-uncorrectable-words"
func (n *Component_TransceiverPath) FecUncorrectableWords() *Component_Transceiver_FecUncorrectableWordsPath {
	return &Component_Transceiver_FecUncorrectableWordsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-words"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableWords (leaf): The number of words that were uncorrectable by the FEC
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/fec-uncorrectable-words"
// Path from root: "/components/component/transceiver/state/fec-uncorrectable-words"
func (n *Component_TransceiverPathAny) FecUncorrectableWords() *Component_Transceiver_FecUncorrectableWordsPathAny {
	return &Component_Transceiver_FecUncorrectableWordsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-words"},
			map[string]interface{}{},
			n,
		),
	}
}

// FormFactor (leaf): Indicates the type of optical transceiver used on this
// port.  If the client port is built into the device and not
// pluggable, then non-pluggable is the corresponding state. If
// a device port supports multiple form factors (e.g. QSFP28
// and QSFP+, then the value of the transceiver installed shall
// be reported. If no transceiver is present, then the value of
// the highest rate form factor shall be reported
// (QSFP28, for example).
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/form-factor"
// Path from root: "/components/component/transceiver/state/form-factor"
func (n *Component_TransceiverPath) FormFactor() *Component_Transceiver_FormFactorPath {
	return &Component_Transceiver_FormFactorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "form-factor"},
			map[string]interface{}{},
			n,
		),
	}
}

// FormFactor (leaf): Indicates the type of optical transceiver used on this
// port.  If the client port is built into the device and not
// pluggable, then non-pluggable is the corresponding state. If
// a device port supports multiple form factors (e.g. QSFP28
// and QSFP+, then the value of the transceiver installed shall
// be reported. If no transceiver is present, then the value of
// the highest rate form factor shall be reported
// (QSFP28, for example).
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/form-factor"
// Path from root: "/components/component/transceiver/state/form-factor"
func (n *Component_TransceiverPathAny) FormFactor() *Component_Transceiver_FormFactorPathAny {
	return &Component_Transceiver_FormFactorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "form-factor"},
			map[string]interface{}{},
			n,
		),
	}
}

// FormFactorPreconf (leaf): Indicates the type of optical transceiver used on this
// port.  If the client port is built into the device and not
// pluggable, then non-pluggable is the corresponding state. If
// a device port supports multiple form factors (e.g. QSFP28
// and QSFP+, then the value of the transceiver installed shall
// be reported. If no transceiver is present, then the value of
// the highest rate form factor shall be reported
// (QSFP28, for example).
//
// The form factor is included in configuration data to allow
// pre-configuring a device with the expected type of
// transceiver ahead of deployment.  The corresponding state
// leaf should reflect the actual transceiver type plugged into
// the system.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/form-factor-preconf"
// Path from root: "/components/component/transceiver/config/form-factor-preconf"
func (n *Component_TransceiverPath) FormFactorPreconf() *Component_Transceiver_FormFactorPreconfPath {
	return &Component_Transceiver_FormFactorPreconfPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "form-factor-preconf"},
			map[string]interface{}{},
			n,
		),
	}
}

// FormFactorPreconf (leaf): Indicates the type of optical transceiver used on this
// port.  If the client port is built into the device and not
// pluggable, then non-pluggable is the corresponding state. If
// a device port supports multiple form factors (e.g. QSFP28
// and QSFP+, then the value of the transceiver installed shall
// be reported. If no transceiver is present, then the value of
// the highest rate form factor shall be reported
// (QSFP28, for example).
//
// The form factor is included in configuration data to allow
// pre-configuring a device with the expected type of
// transceiver ahead of deployment.  The corresponding state
// leaf should reflect the actual transceiver type plugged into
// the system.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/form-factor-preconf"
// Path from root: "/components/component/transceiver/config/form-factor-preconf"
func (n *Component_TransceiverPathAny) FormFactorPreconf() *Component_Transceiver_FormFactorPreconfPathAny {
	return &Component_Transceiver_FormFactorPreconfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "form-factor-preconf"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPower (container): The input optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/input-power"
// Path from root: "/components/component/transceiver/state/input-power"
func (n *Component_TransceiverPath) InputPower() *Component_Transceiver_InputPowerPath {
	return &Component_Transceiver_InputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPower (container): The input optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/input-power"
// Path from root: "/components/component/transceiver/state/input-power"
func (n *Component_TransceiverPathAny) InputPower() *Component_Transceiver_InputPowerPathAny {
	return &Component_Transceiver_InputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-bias-current"
// Path from root: "/components/component/transceiver/state/laser-bias-current"
func (n *Component_TransceiverPath) LaserBiasCurrent() *Component_Transceiver_LaserBiasCurrentPath {
	return &Component_Transceiver_LaserBiasCurrentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-bias-current"
// Path from root: "/components/component/transceiver/state/laser-bias-current"
func (n *Component_TransceiverPathAny) LaserBiasCurrent() *Component_Transceiver_LaserBiasCurrentPathAny {
	return &Component_Transceiver_LaserBiasCurrentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModuleFunctionalType (leaf): Indicates the module functional type which represents the
// functional capability of the transceiver. For example, this
// would specify the module is a digital coherent optic or a
// standard grey optic that performs on-off keying.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/module-functional-type"
// Path from root: "/components/component/transceiver/config/module-functional-type"
func (n *Component_TransceiverPath) ModuleFunctionalType() *Component_Transceiver_ModuleFunctionalTypePath {
	return &Component_Transceiver_ModuleFunctionalTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "module-functional-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModuleFunctionalType (leaf): Indicates the module functional type which represents the
// functional capability of the transceiver. For example, this
// would specify the module is a digital coherent optic or a
// standard grey optic that performs on-off keying.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/module-functional-type"
// Path from root: "/components/component/transceiver/config/module-functional-type"
func (n *Component_TransceiverPathAny) ModuleFunctionalType() *Component_Transceiver_ModuleFunctionalTypePathAny {
	return &Component_Transceiver_ModuleFunctionalTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "module-functional-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// OtnComplianceCode (leaf): OTN application code supported by the port
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/otn-compliance-code"
// Path from root: "/components/component/transceiver/state/otn-compliance-code"
func (n *Component_TransceiverPath) OtnComplianceCode() *Component_Transceiver_OtnComplianceCodePath {
	return &Component_Transceiver_OtnComplianceCodePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "otn-compliance-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// OtnComplianceCode (leaf): OTN application code supported by the port
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/otn-compliance-code"
// Path from root: "/components/component/transceiver/state/otn-compliance-code"
func (n *Component_TransceiverPathAny) OtnComplianceCode() *Component_Transceiver_OtnComplianceCodePathAny {
	return &Component_Transceiver_OtnComplianceCodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "otn-compliance-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): The output optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-power"
// Path from root: "/components/component/transceiver/state/output-power"
func (n *Component_TransceiverPath) OutputPower() *Component_Transceiver_OutputPowerPath {
	return &Component_Transceiver_OutputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): The output optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-power"
// Path from root: "/components/component/transceiver/state/output-power"
func (n *Component_TransceiverPathAny) OutputPower() *Component_Transceiver_OutputPowerPathAny {
	return &Component_Transceiver_OutputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostFecBer (container): Bit error rate after forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/post-fec-ber"
// Path from root: "/components/component/transceiver/state/post-fec-ber"
func (n *Component_TransceiverPath) PostFecBer() *Component_Transceiver_PostFecBerPath {
	return &Component_Transceiver_PostFecBerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "post-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostFecBer (container): Bit error rate after forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/post-fec-ber"
// Path from root: "/components/component/transceiver/state/post-fec-ber"
func (n *Component_TransceiverPathAny) PostFecBer() *Component_Transceiver_PostFecBerPathAny {
	return &Component_Transceiver_PostFecBerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "post-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreFecBer (container): Bit error rate before forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/pre-fec-ber"
// Path from root: "/components/component/transceiver/state/pre-fec-ber"
func (n *Component_TransceiverPath) PreFecBer() *Component_Transceiver_PreFecBerPath {
	return &Component_Transceiver_PreFecBerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pre-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreFecBer (container): Bit error rate before forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/pre-fec-ber"
// Path from root: "/components/component/transceiver/state/pre-fec-ber"
func (n *Component_TransceiverPathAny) PreFecBer() *Component_Transceiver_PreFecBerPathAny {
	return &Component_Transceiver_PreFecBerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pre-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// Present (leaf): Indicates whether a transceiver is present in
// the specified client port.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/present"
// Path from root: "/components/component/transceiver/state/present"
func (n *Component_TransceiverPath) Present() *Component_Transceiver_PresentPath {
	return &Component_Transceiver_PresentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "present"},
			map[string]interface{}{},
			n,
		),
	}
}

// Present (leaf): Indicates whether a transceiver is present in
// the specified client port.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/present"
// Path from root: "/components/component/transceiver/state/present"
func (n *Component_TransceiverPathAny) Present() *Component_Transceiver_PresentPathAny {
	return &Component_Transceiver_PresentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "present"},
			map[string]interface{}{},
			n,
		),
	}
}

// SerialNo (leaf): Transceiver serial number. 16-octet field that contains
// ASCII characters, left-aligned and padded on the right with
// ASCII spaces (20h). If part serial number is undefined, all
// 16 octets = 0h
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/serial-no"
// Path from root: "/components/component/transceiver/state/serial-no"
func (n *Component_TransceiverPath) SerialNo() *Component_Transceiver_SerialNoPath {
	return &Component_Transceiver_SerialNoPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "serial-no"},
			map[string]interface{}{},
			n,
		),
	}
}

// SerialNo (leaf): Transceiver serial number. 16-octet field that contains
// ASCII characters, left-aligned and padded on the right with
// ASCII spaces (20h). If part serial number is undefined, all
// 16 octets = 0h
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/serial-no"
// Path from root: "/components/component/transceiver/state/serial-no"
func (n *Component_TransceiverPathAny) SerialNo() *Component_Transceiver_SerialNoPathAny {
	return &Component_Transceiver_SerialNoPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "serial-no"},
			map[string]interface{}{},
			n,
		),
	}
}

// SonetSdhComplianceCode (leaf): SONET/SDH application code supported by the port
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/sonet-sdh-compliance-code"
// Path from root: "/components/component/transceiver/state/sonet-sdh-compliance-code"
func (n *Component_TransceiverPath) SonetSdhComplianceCode() *Component_Transceiver_SonetSdhComplianceCodePath {
	return &Component_Transceiver_SonetSdhComplianceCodePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sonet-sdh-compliance-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// SonetSdhComplianceCode (leaf): SONET/SDH application code supported by the port
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/sonet-sdh-compliance-code"
// Path from root: "/components/component/transceiver/state/sonet-sdh-compliance-code"
func (n *Component_TransceiverPathAny) SonetSdhComplianceCode() *Component_Transceiver_SonetSdhComplianceCodePathAny {
	return &Component_Transceiver_SonetSdhComplianceCodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sonet-sdh-compliance-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// SupplyVoltage (container): Supply voltage to the transceiver in volts with 2 decimal
// precision. Values include the instantaneous, average, minimum,
// and maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the instant
// value.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/supply-voltage"
// Path from root: "/components/component/transceiver/state/supply-voltage"
func (n *Component_TransceiverPath) SupplyVoltage() *Component_Transceiver_SupplyVoltagePath {
	return &Component_Transceiver_SupplyVoltagePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "supply-voltage"},
			map[string]interface{}{},
			n,
		),
	}
}

// SupplyVoltage (container): Supply voltage to the transceiver in volts with 2 decimal
// precision. Values include the instantaneous, average, minimum,
// and maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the instant
// value.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/supply-voltage"
// Path from root: "/components/component/transceiver/state/supply-voltage"
func (n *Component_TransceiverPathAny) SupplyVoltage() *Component_Transceiver_SupplyVoltagePathAny {
	return &Component_Transceiver_SupplyVoltagePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "supply-voltage"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vendor (leaf): Full name of transceiver vendor. 16-octet field that
// contains ASCII characters, left-aligned and padded on the
// right with ASCII spaces (20h)
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/vendor"
// Path from root: "/components/component/transceiver/state/vendor"
func (n *Component_TransceiverPath) Vendor() *Component_Transceiver_VendorPath {
	return &Component_Transceiver_VendorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vendor"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vendor (leaf): Full name of transceiver vendor. 16-octet field that
// contains ASCII characters, left-aligned and padded on the
// right with ASCII spaces (20h)
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/vendor"
// Path from root: "/components/component/transceiver/state/vendor"
func (n *Component_TransceiverPathAny) Vendor() *Component_Transceiver_VendorPathAny {
	return &Component_Transceiver_VendorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vendor"},
			map[string]interface{}{},
			n,
		),
	}
}

// VendorPart (leaf): Transceiver vendor's part number. 16-octet field that
// contains ASCII characters, left-aligned and padded on the
// right with ASCII spaces (20h). If part number is undefined,
// all 16 octets = 0h
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/vendor-part"
// Path from root: "/components/component/transceiver/state/vendor-part"
func (n *Component_TransceiverPath) VendorPart() *Component_Transceiver_VendorPartPath {
	return &Component_Transceiver_VendorPartPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vendor-part"},
			map[string]interface{}{},
			n,
		),
	}
}

// VendorPart (leaf): Transceiver vendor's part number. 16-octet field that
// contains ASCII characters, left-aligned and padded on the
// right with ASCII spaces (20h). If part number is undefined,
// all 16 octets = 0h
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/vendor-part"
// Path from root: "/components/component/transceiver/state/vendor-part"
func (n *Component_TransceiverPathAny) VendorPart() *Component_Transceiver_VendorPartPathAny {
	return &Component_Transceiver_VendorPartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vendor-part"},
			map[string]interface{}{},
			n,
		),
	}
}

// VendorRev (leaf): Transceiver vendor's revision number. 2-octet field that
// contains ASCII characters, left-aligned and padded on the
// right with ASCII spaces (20h)
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/vendor-rev"
// Path from root: "/components/component/transceiver/state/vendor-rev"
func (n *Component_TransceiverPath) VendorRev() *Component_Transceiver_VendorRevPath {
	return &Component_Transceiver_VendorRevPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vendor-rev"},
			map[string]interface{}{},
			n,
		),
	}
}

// VendorRev (leaf): Transceiver vendor's revision number. 2-octet field that
// contains ASCII characters, left-aligned and padded on the
// right with ASCII spaces (20h)
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/vendor-rev"
// Path from root: "/components/component/transceiver/state/vendor-rev"
func (n *Component_TransceiverPathAny) VendorRev() *Component_Transceiver_VendorRevPathAny {
	return &Component_Transceiver_VendorRevPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vendor-rev"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_ChannelPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel YANG schema element.
type Component_Transceiver_ChannelPath struct {
	*ygot.NodePath
}

// Component_Transceiver_ChannelPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel YANG schema element.
type Component_Transceiver_ChannelPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_AssociatedOpticalChannelPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/associated-optical-channel YANG schema element.
type Component_Transceiver_Channel_AssociatedOpticalChannelPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_AssociatedOpticalChannelPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/associated-optical-channel YANG schema element.
type Component_Transceiver_Channel_AssociatedOpticalChannelPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_DescriptionPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/description YANG schema element.
type Component_Transceiver_Channel_DescriptionPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_DescriptionPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/description YANG schema element.
type Component_Transceiver_Channel_DescriptionPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_IndexPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/index YANG schema element.
type Component_Transceiver_Channel_IndexPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_IndexPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/index YANG schema element.
type Component_Transceiver_Channel_IndexPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserAgePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-age YANG schema element.
type Component_Transceiver_Channel_LaserAgePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserAgePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-age YANG schema element.
type Component_Transceiver_Channel_LaserAgePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputFrequencyPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-frequency YANG schema element.
type Component_Transceiver_Channel_OutputFrequencyPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputFrequencyPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-frequency YANG schema element.
type Component_Transceiver_Channel_OutputFrequencyPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetOutputPowerPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/target-output-power YANG schema element.
type Component_Transceiver_Channel_TargetOutputPowerPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetOutputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/target-output-power YANG schema element.
type Component_Transceiver_Channel_TargetOutputPowerPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TxLaserPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/tx-laser YANG schema element.
type Component_Transceiver_Channel_TxLaserPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TxLaserPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/config/tx-laser YANG schema element.
type Component_Transceiver_Channel_TxLaserPathAny struct {
	*ygot.NodePath
}

// AssociatedOpticalChannel (leaf): A physical channel may reference an optical channel
// component. If the physical channel does make this optional
// reference, then a limited set of leaves will apply within
// the physical channel to avoid duplication within the optical
// channel.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/associated-optical-channel"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/associated-optical-channel"
func (n *Component_Transceiver_ChannelPath) AssociatedOpticalChannel() *Component_Transceiver_Channel_AssociatedOpticalChannelPath {
	return &Component_Transceiver_Channel_AssociatedOpticalChannelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "associated-optical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssociatedOpticalChannel (leaf): A physical channel may reference an optical channel
// component. If the physical channel does make this optional
// reference, then a limited set of leaves will apply within
// the physical channel to avoid duplication within the optical
// channel.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/associated-optical-channel"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/associated-optical-channel"
func (n *Component_Transceiver_ChannelPathAny) AssociatedOpticalChannel() *Component_Transceiver_Channel_AssociatedOpticalChannelPathAny {
	return &Component_Transceiver_Channel_AssociatedOpticalChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "associated-optical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): Text description for the client physical channel
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/description"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/description"
func (n *Component_Transceiver_ChannelPath) Description() *Component_Transceiver_Channel_DescriptionPath {
	return &Component_Transceiver_Channel_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): Text description for the client physical channel
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/description"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/description"
func (n *Component_Transceiver_ChannelPathAny) Description() *Component_Transceiver_Channel_DescriptionPathAny {
	return &Component_Transceiver_Channel_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of the physical channnel or lane within a physical
// client port
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/index"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/index"
func (n *Component_Transceiver_ChannelPath) Index() *Component_Transceiver_Channel_IndexPath {
	return &Component_Transceiver_Channel_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of the physical channnel or lane within a physical
// client port
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/index"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/index"
func (n *Component_Transceiver_ChannelPathAny) Index() *Component_Transceiver_Channel_IndexPathAny {
	return &Component_Transceiver_Channel_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPower (container): The input optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/input-power"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power"
func (n *Component_Transceiver_ChannelPath) InputPower() *Component_Transceiver_Channel_InputPowerPath {
	return &Component_Transceiver_Channel_InputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPower (container): The input optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/input-power"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power"
func (n *Component_Transceiver_ChannelPathAny) InputPower() *Component_Transceiver_Channel_InputPowerPathAny {
	return &Component_Transceiver_Channel_InputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserAge (leaf): Laser age (0% at beginning of life, 100% end of life) in integer
// percentage. This term is defined by Common Management Interface
// Specification (CMIS).
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-age"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-age"
func (n *Component_Transceiver_ChannelPath) LaserAge() *Component_Transceiver_Channel_LaserAgePath {
	return &Component_Transceiver_Channel_LaserAgePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-age"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserAge (leaf): Laser age (0% at beginning of life, 100% end of life) in integer
// percentage. This term is defined by Common Management Interface
// Specification (CMIS).
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-age"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-age"
func (n *Component_Transceiver_ChannelPathAny) LaserAge() *Component_Transceiver_Channel_LaserAgePathAny {
	return &Component_Transceiver_Channel_LaserAgePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-age"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-bias-current"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current"
func (n *Component_Transceiver_ChannelPath) LaserBiasCurrent() *Component_Transceiver_Channel_LaserBiasCurrentPath {
	return &Component_Transceiver_Channel_LaserBiasCurrentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to two decimal precision. Values include the
// instantaneous, average, minimum, and maximum statistics.
// If avg/min/max statistics are not supported, the target is
// expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-bias-current"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current"
func (n *Component_Transceiver_ChannelPathAny) LaserBiasCurrent() *Component_Transceiver_Channel_LaserBiasCurrentPathAny {
	return &Component_Transceiver_Channel_LaserBiasCurrentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserTemperature (container): Laser temperature for the cooled laser in degrees Celsius with 1
// decimal precision. This term is defined by Common Management
// Interface Specification (CMIS). Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply the
// instant value.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-temperature"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature"
func (n *Component_Transceiver_ChannelPath) LaserTemperature() *Component_Transceiver_Channel_LaserTemperaturePath {
	return &Component_Transceiver_Channel_LaserTemperaturePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-temperature"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserTemperature (container): Laser temperature for the cooled laser in degrees Celsius with 1
// decimal precision. This term is defined by Common Management
// Interface Specification (CMIS). Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply the
// instant value.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/laser-temperature"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature"
func (n *Component_Transceiver_ChannelPathAny) LaserTemperature() *Component_Transceiver_Channel_LaserTemperaturePathAny {
	return &Component_Transceiver_Channel_LaserTemperaturePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-temperature"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputFrequency (leaf): The frequency in MHz of the individual physical channel
// (e.g. ITU C50 - 195.0THz and would be reported as
// 195,000,000 MHz in this model). This attribute is not
// configurable on most client ports.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-frequency"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-frequency"
func (n *Component_Transceiver_ChannelPath) OutputFrequency() *Component_Transceiver_Channel_OutputFrequencyPath {
	return &Component_Transceiver_Channel_OutputFrequencyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-frequency"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputFrequency (leaf): The frequency in MHz of the individual physical channel
// (e.g. ITU C50 - 195.0THz and would be reported as
// 195,000,000 MHz in this model). This attribute is not
// configurable on most client ports.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-frequency"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-frequency"
func (n *Component_Transceiver_ChannelPathAny) OutputFrequency() *Component_Transceiver_Channel_OutputFrequencyPathAny {
	return &Component_Transceiver_Channel_OutputFrequencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-frequency"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): The output optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-power"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power"
func (n *Component_Transceiver_ChannelPath) OutputPower() *Component_Transceiver_Channel_OutputPowerPath {
	return &Component_Transceiver_Channel_OutputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): The output optical power of a physical channel in units
// of 0.01dBm, which may be associated with individual
// physical channels, or an aggregate of multiple physical
// channels (i.e., for the overall transceiver). For an
// aggregate, this may be a measurement from a photodetector
// or a a calculation performed on the device by summing up
// all of the related individual physical channels.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/output-power"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power"
func (n *Component_Transceiver_ChannelPathAny) OutputPower() *Component_Transceiver_Channel_OutputPowerPathAny {
	return &Component_Transceiver_Channel_OutputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetFrequencyDeviation (container): The difference in MHz with 1 decimal precision between the target
// center frequency and the actual current center frequency . This term
// is defined by Common Management Interface Specification (CMIS) and
// referred to as laser frequency error or laser ferquency deviation.
// Values include the instantaneous, average, minimum, and maximum
// statistics. If avg/min/max statistics are not supported, the target
// is expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/target-frequency-deviation"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation"
func (n *Component_Transceiver_ChannelPath) TargetFrequencyDeviation() *Component_Transceiver_Channel_TargetFrequencyDeviationPath {
	return &Component_Transceiver_Channel_TargetFrequencyDeviationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "target-frequency-deviation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetFrequencyDeviation (container): The difference in MHz with 1 decimal precision between the target
// center frequency and the actual current center frequency . This term
// is defined by Common Management Interface Specification (CMIS) and
// referred to as laser frequency error or laser ferquency deviation.
// Values include the instantaneous, average, minimum, and maximum
// statistics. If avg/min/max statistics are not supported, the target
// is expected to just supply the instant value.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/target-frequency-deviation"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation"
func (n *Component_Transceiver_ChannelPathAny) TargetFrequencyDeviation() *Component_Transceiver_Channel_TargetFrequencyDeviationPathAny {
	return &Component_Transceiver_Channel_TargetFrequencyDeviationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "target-frequency-deviation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetOutputPower (leaf): Target output optical power level of the optical channel,
// expressed in increments of 0.01 dBm (decibel-milliwats)
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/target-output-power"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/target-output-power"
func (n *Component_Transceiver_ChannelPath) TargetOutputPower() *Component_Transceiver_Channel_TargetOutputPowerPath {
	return &Component_Transceiver_Channel_TargetOutputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetOutputPower (leaf): Target output optical power level of the optical channel,
// expressed in increments of 0.01 dBm (decibel-milliwats)
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/target-output-power"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/target-output-power"
func (n *Component_Transceiver_ChannelPathAny) TargetOutputPower() *Component_Transceiver_Channel_TargetOutputPowerPathAny {
	return &Component_Transceiver_Channel_TargetOutputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TecCurrent (container): The amount of current flowing to the TC of a cooled laser in percentage
// with 2 decimal precision. This term is defined by Common Management
// Interface Specification (CMIS). Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply the instant
// value.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/tec-current"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current"
func (n *Component_Transceiver_ChannelPath) TecCurrent() *Component_Transceiver_Channel_TecCurrentPath {
	return &Component_Transceiver_Channel_TecCurrentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tec-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// TecCurrent (container): The amount of current flowing to the TC of a cooled laser in percentage
// with 2 decimal precision. This term is defined by Common Management
// Interface Specification (CMIS). Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max statistics
// are not supported, the target is expected to just supply the instant
// value.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "state/tec-current"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current"
func (n *Component_Transceiver_ChannelPathAny) TecCurrent() *Component_Transceiver_Channel_TecCurrentPathAny {
	return &Component_Transceiver_Channel_TecCurrentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tec-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// TxLaser (leaf): Enable (true) or disable (false) the transmit label for the
// channel
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/tx-laser"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/tx-laser"
func (n *Component_Transceiver_ChannelPath) TxLaser() *Component_Transceiver_Channel_TxLaserPath {
	return &Component_Transceiver_Channel_TxLaserPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tx-laser"},
			map[string]interface{}{},
			n,
		),
	}
}

// TxLaser (leaf): Enable (true) or disable (false) the transmit label for the
// channel
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-platform"
// Path from parent: "config/tx-laser"
// Path from root: "/components/component/transceiver/physical-channels/channel/config/tx-laser"
func (n *Component_Transceiver_ChannelPathAny) TxLaser() *Component_Transceiver_Channel_TxLaserPathAny {
	return &Component_Transceiver_Channel_TxLaserPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tx-laser"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_Channel_InputPowerPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power YANG schema element.
type Component_Transceiver_Channel_InputPowerPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power YANG schema element.
type Component_Transceiver_Channel_InputPowerPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_AvgPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/avg YANG schema element.
type Component_Transceiver_Channel_InputPower_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/avg YANG schema element.
type Component_Transceiver_Channel_InputPower_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_InstantPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/instant YANG schema element.
type Component_Transceiver_Channel_InputPower_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/instant YANG schema element.
type Component_Transceiver_Channel_InputPower_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_IntervalPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/interval YANG schema element.
type Component_Transceiver_Channel_InputPower_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/interval YANG schema element.
type Component_Transceiver_Channel_InputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_MaxPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/max YANG schema element.
type Component_Transceiver_Channel_InputPower_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/max YANG schema element.
type Component_Transceiver_Channel_InputPower_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_MaxTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/max-time YANG schema element.
type Component_Transceiver_Channel_InputPower_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/max-time YANG schema element.
type Component_Transceiver_Channel_InputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_MinPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/min YANG schema element.
type Component_Transceiver_Channel_InputPower_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/min YANG schema element.
type Component_Transceiver_Channel_InputPower_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_MinTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/min-time YANG schema element.
type Component_Transceiver_Channel_InputPower_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_InputPower_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/input-power/min-time YANG schema element.
type Component_Transceiver_Channel_InputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/avg"
func (n *Component_Transceiver_Channel_InputPowerPath) Avg() *Component_Transceiver_Channel_InputPower_AvgPath {
	return &Component_Transceiver_Channel_InputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/avg"
func (n *Component_Transceiver_Channel_InputPowerPathAny) Avg() *Component_Transceiver_Channel_InputPower_AvgPathAny {
	return &Component_Transceiver_Channel_InputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/instant"
func (n *Component_Transceiver_Channel_InputPowerPath) Instant() *Component_Transceiver_Channel_InputPower_InstantPath {
	return &Component_Transceiver_Channel_InputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/instant"
func (n *Component_Transceiver_Channel_InputPowerPathAny) Instant() *Component_Transceiver_Channel_InputPower_InstantPathAny {
	return &Component_Transceiver_Channel_InputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/interval"
func (n *Component_Transceiver_Channel_InputPowerPath) Interval() *Component_Transceiver_Channel_InputPower_IntervalPath {
	return &Component_Transceiver_Channel_InputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/interval"
func (n *Component_Transceiver_Channel_InputPowerPathAny) Interval() *Component_Transceiver_Channel_InputPower_IntervalPathAny {
	return &Component_Transceiver_Channel_InputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/max"
func (n *Component_Transceiver_Channel_InputPowerPath) Max() *Component_Transceiver_Channel_InputPower_MaxPath {
	return &Component_Transceiver_Channel_InputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/max"
func (n *Component_Transceiver_Channel_InputPowerPathAny) Max() *Component_Transceiver_Channel_InputPower_MaxPathAny {
	return &Component_Transceiver_Channel_InputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/max-time"
func (n *Component_Transceiver_Channel_InputPowerPath) MaxTime() *Component_Transceiver_Channel_InputPower_MaxTimePath {
	return &Component_Transceiver_Channel_InputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/max-time"
func (n *Component_Transceiver_Channel_InputPowerPathAny) MaxTime() *Component_Transceiver_Channel_InputPower_MaxTimePathAny {
	return &Component_Transceiver_Channel_InputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/min"
func (n *Component_Transceiver_Channel_InputPowerPath) Min() *Component_Transceiver_Channel_InputPower_MinPath {
	return &Component_Transceiver_Channel_InputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/min"
func (n *Component_Transceiver_Channel_InputPowerPathAny) Min() *Component_Transceiver_Channel_InputPower_MinPathAny {
	return &Component_Transceiver_Channel_InputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/min-time"
func (n *Component_Transceiver_Channel_InputPowerPath) MinTime() *Component_Transceiver_Channel_InputPower_MinTimePath {
	return &Component_Transceiver_Channel_InputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/input-power/min-time"
func (n *Component_Transceiver_Channel_InputPowerPathAny) MinTime() *Component_Transceiver_Channel_InputPower_MinTimePathAny {
	return &Component_Transceiver_Channel_InputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_Channel_LaserBiasCurrentPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrentPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrentPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrentPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_AvgPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/avg YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/avg YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_InstantPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/instant YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/instant YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_IntervalPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/interval YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/interval YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_MaxPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/max YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/max YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_MaxTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/max-time YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/max-time YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_MinPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/min YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/min YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_MinTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/min-time YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserBiasCurrent_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-bias-current/min-time YANG schema element.
type Component_Transceiver_Channel_LaserBiasCurrent_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/avg"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPath) Avg() *Component_Transceiver_Channel_LaserBiasCurrent_AvgPath {
	return &Component_Transceiver_Channel_LaserBiasCurrent_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/avg"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPathAny) Avg() *Component_Transceiver_Channel_LaserBiasCurrent_AvgPathAny {
	return &Component_Transceiver_Channel_LaserBiasCurrent_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/instant"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPath) Instant() *Component_Transceiver_Channel_LaserBiasCurrent_InstantPath {
	return &Component_Transceiver_Channel_LaserBiasCurrent_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/instant"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPathAny) Instant() *Component_Transceiver_Channel_LaserBiasCurrent_InstantPathAny {
	return &Component_Transceiver_Channel_LaserBiasCurrent_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/interval"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPath) Interval() *Component_Transceiver_Channel_LaserBiasCurrent_IntervalPath {
	return &Component_Transceiver_Channel_LaserBiasCurrent_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/interval"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPathAny) Interval() *Component_Transceiver_Channel_LaserBiasCurrent_IntervalPathAny {
	return &Component_Transceiver_Channel_LaserBiasCurrent_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/max"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPath) Max() *Component_Transceiver_Channel_LaserBiasCurrent_MaxPath {
	return &Component_Transceiver_Channel_LaserBiasCurrent_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/max"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPathAny) Max() *Component_Transceiver_Channel_LaserBiasCurrent_MaxPathAny {
	return &Component_Transceiver_Channel_LaserBiasCurrent_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/max-time"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPath) MaxTime() *Component_Transceiver_Channel_LaserBiasCurrent_MaxTimePath {
	return &Component_Transceiver_Channel_LaserBiasCurrent_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/max-time"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPathAny) MaxTime() *Component_Transceiver_Channel_LaserBiasCurrent_MaxTimePathAny {
	return &Component_Transceiver_Channel_LaserBiasCurrent_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/min"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPath) Min() *Component_Transceiver_Channel_LaserBiasCurrent_MinPath {
	return &Component_Transceiver_Channel_LaserBiasCurrent_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/min"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPathAny) Min() *Component_Transceiver_Channel_LaserBiasCurrent_MinPathAny {
	return &Component_Transceiver_Channel_LaserBiasCurrent_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/min-time"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPath) MinTime() *Component_Transceiver_Channel_LaserBiasCurrent_MinTimePath {
	return &Component_Transceiver_Channel_LaserBiasCurrent_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-bias-current/min-time"
func (n *Component_Transceiver_Channel_LaserBiasCurrentPathAny) MinTime() *Component_Transceiver_Channel_LaserBiasCurrent_MinTimePathAny {
	return &Component_Transceiver_Channel_LaserBiasCurrent_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_Channel_LaserTemperaturePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature YANG schema element.
type Component_Transceiver_Channel_LaserTemperaturePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperaturePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature YANG schema element.
type Component_Transceiver_Channel_LaserTemperaturePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_AvgPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/avg YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/avg YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_InstantPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/instant YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/instant YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_IntervalPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/interval YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/interval YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_MaxPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/max YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/max YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_MaxTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/max-time YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/max-time YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_MinPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/min YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/min YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_MinTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/min-time YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_LaserTemperature_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/laser-temperature/min-time YANG schema element.
type Component_Transceiver_Channel_LaserTemperature_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// sampling period.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/avg"
func (n *Component_Transceiver_Channel_LaserTemperaturePath) Avg() *Component_Transceiver_Channel_LaserTemperature_AvgPath {
	return &Component_Transceiver_Channel_LaserTemperature_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// sampling period.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/avg"
func (n *Component_Transceiver_Channel_LaserTemperaturePathAny) Avg() *Component_Transceiver_Channel_LaserTemperature_AvgPathAny {
	return &Component_Transceiver_Channel_LaserTemperature_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/instant"
func (n *Component_Transceiver_Channel_LaserTemperaturePath) Instant() *Component_Transceiver_Channel_LaserTemperature_InstantPath {
	return &Component_Transceiver_Channel_LaserTemperature_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/instant"
func (n *Component_Transceiver_Channel_LaserTemperaturePathAny) Instant() *Component_Transceiver_Channel_LaserTemperature_InstantPathAny {
	return &Component_Transceiver_Channel_LaserTemperature_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/interval"
func (n *Component_Transceiver_Channel_LaserTemperaturePath) Interval() *Component_Transceiver_Channel_LaserTemperature_IntervalPath {
	return &Component_Transceiver_Channel_LaserTemperature_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/interval"
func (n *Component_Transceiver_Channel_LaserTemperaturePathAny) Interval() *Component_Transceiver_Channel_LaserTemperature_IntervalPathAny {
	return &Component_Transceiver_Channel_LaserTemperature_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/max"
func (n *Component_Transceiver_Channel_LaserTemperaturePath) Max() *Component_Transceiver_Channel_LaserTemperature_MaxPath {
	return &Component_Transceiver_Channel_LaserTemperature_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/max"
func (n *Component_Transceiver_Channel_LaserTemperaturePathAny) Max() *Component_Transceiver_Channel_LaserTemperature_MaxPathAny {
	return &Component_Transceiver_Channel_LaserTemperature_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/max-time"
func (n *Component_Transceiver_Channel_LaserTemperaturePath) MaxTime() *Component_Transceiver_Channel_LaserTemperature_MaxTimePath {
	return &Component_Transceiver_Channel_LaserTemperature_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/max-time"
func (n *Component_Transceiver_Channel_LaserTemperaturePathAny) MaxTime() *Component_Transceiver_Channel_LaserTemperature_MaxTimePathAny {
	return &Component_Transceiver_Channel_LaserTemperature_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/min"
func (n *Component_Transceiver_Channel_LaserTemperaturePath) Min() *Component_Transceiver_Channel_LaserTemperature_MinPath {
	return &Component_Transceiver_Channel_LaserTemperature_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/min"
func (n *Component_Transceiver_Channel_LaserTemperaturePathAny) Min() *Component_Transceiver_Channel_LaserTemperature_MinPathAny {
	return &Component_Transceiver_Channel_LaserTemperature_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/min-time"
func (n *Component_Transceiver_Channel_LaserTemperaturePath) MinTime() *Component_Transceiver_Channel_LaserTemperature_MinTimePath {
	return &Component_Transceiver_Channel_LaserTemperature_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/laser-temperature/min-time"
func (n *Component_Transceiver_Channel_LaserTemperaturePathAny) MinTime() *Component_Transceiver_Channel_LaserTemperature_MinTimePathAny {
	return &Component_Transceiver_Channel_LaserTemperature_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_Channel_OutputPowerPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power YANG schema element.
type Component_Transceiver_Channel_OutputPowerPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power YANG schema element.
type Component_Transceiver_Channel_OutputPowerPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_AvgPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/avg YANG schema element.
type Component_Transceiver_Channel_OutputPower_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/avg YANG schema element.
type Component_Transceiver_Channel_OutputPower_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_InstantPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/instant YANG schema element.
type Component_Transceiver_Channel_OutputPower_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/instant YANG schema element.
type Component_Transceiver_Channel_OutputPower_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_IntervalPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/interval YANG schema element.
type Component_Transceiver_Channel_OutputPower_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/interval YANG schema element.
type Component_Transceiver_Channel_OutputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_MaxPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/max YANG schema element.
type Component_Transceiver_Channel_OutputPower_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/max YANG schema element.
type Component_Transceiver_Channel_OutputPower_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_MaxTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/max-time YANG schema element.
type Component_Transceiver_Channel_OutputPower_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/max-time YANG schema element.
type Component_Transceiver_Channel_OutputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_MinPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/min YANG schema element.
type Component_Transceiver_Channel_OutputPower_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/min YANG schema element.
type Component_Transceiver_Channel_OutputPower_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_MinTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/min-time YANG schema element.
type Component_Transceiver_Channel_OutputPower_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_OutputPower_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/output-power/min-time YANG schema element.
type Component_Transceiver_Channel_OutputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/avg"
func (n *Component_Transceiver_Channel_OutputPowerPath) Avg() *Component_Transceiver_Channel_OutputPower_AvgPath {
	return &Component_Transceiver_Channel_OutputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/avg"
func (n *Component_Transceiver_Channel_OutputPowerPathAny) Avg() *Component_Transceiver_Channel_OutputPower_AvgPathAny {
	return &Component_Transceiver_Channel_OutputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/instant"
func (n *Component_Transceiver_Channel_OutputPowerPath) Instant() *Component_Transceiver_Channel_OutputPower_InstantPath {
	return &Component_Transceiver_Channel_OutputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/instant"
func (n *Component_Transceiver_Channel_OutputPowerPathAny) Instant() *Component_Transceiver_Channel_OutputPower_InstantPathAny {
	return &Component_Transceiver_Channel_OutputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/interval"
func (n *Component_Transceiver_Channel_OutputPowerPath) Interval() *Component_Transceiver_Channel_OutputPower_IntervalPath {
	return &Component_Transceiver_Channel_OutputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/interval"
func (n *Component_Transceiver_Channel_OutputPowerPathAny) Interval() *Component_Transceiver_Channel_OutputPower_IntervalPathAny {
	return &Component_Transceiver_Channel_OutputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/max"
func (n *Component_Transceiver_Channel_OutputPowerPath) Max() *Component_Transceiver_Channel_OutputPower_MaxPath {
	return &Component_Transceiver_Channel_OutputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/max"
func (n *Component_Transceiver_Channel_OutputPowerPathAny) Max() *Component_Transceiver_Channel_OutputPower_MaxPathAny {
	return &Component_Transceiver_Channel_OutputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/max-time"
func (n *Component_Transceiver_Channel_OutputPowerPath) MaxTime() *Component_Transceiver_Channel_OutputPower_MaxTimePath {
	return &Component_Transceiver_Channel_OutputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/max-time"
func (n *Component_Transceiver_Channel_OutputPowerPathAny) MaxTime() *Component_Transceiver_Channel_OutputPower_MaxTimePathAny {
	return &Component_Transceiver_Channel_OutputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/min"
func (n *Component_Transceiver_Channel_OutputPowerPath) Min() *Component_Transceiver_Channel_OutputPower_MinPath {
	return &Component_Transceiver_Channel_OutputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/min"
func (n *Component_Transceiver_Channel_OutputPowerPathAny) Min() *Component_Transceiver_Channel_OutputPower_MinPathAny {
	return &Component_Transceiver_Channel_OutputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/min-time"
func (n *Component_Transceiver_Channel_OutputPowerPath) MinTime() *Component_Transceiver_Channel_OutputPower_MinTimePath {
	return &Component_Transceiver_Channel_OutputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/output-power/min-time"
func (n *Component_Transceiver_Channel_OutputPowerPathAny) MinTime() *Component_Transceiver_Channel_OutputPower_MinTimePathAny {
	return &Component_Transceiver_Channel_OutputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_Channel_TargetFrequencyDeviationPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviationPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviationPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviationPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_AvgPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/avg YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/avg YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_InstantPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/instant YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/instant YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_IntervalPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/interval YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/interval YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_MaxPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/max YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/max YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_MaxTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/max-time YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/max-time YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_MinPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/min YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/min YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_MinTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/min-time YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TargetFrequencyDeviation_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/min-time YANG schema element.
type Component_Transceiver_Channel_TargetFrequencyDeviation_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/avg"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPath) Avg() *Component_Transceiver_Channel_TargetFrequencyDeviation_AvgPath {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/avg"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPathAny) Avg() *Component_Transceiver_Channel_TargetFrequencyDeviation_AvgPathAny {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/instant"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPath) Instant() *Component_Transceiver_Channel_TargetFrequencyDeviation_InstantPath {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/instant"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPathAny) Instant() *Component_Transceiver_Channel_TargetFrequencyDeviation_InstantPathAny {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/interval"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPath) Interval() *Component_Transceiver_Channel_TargetFrequencyDeviation_IntervalPath {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/interval"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPathAny) Interval() *Component_Transceiver_Channel_TargetFrequencyDeviation_IntervalPathAny {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/max"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPath) Max() *Component_Transceiver_Channel_TargetFrequencyDeviation_MaxPath {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/max"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPathAny) Max() *Component_Transceiver_Channel_TargetFrequencyDeviation_MaxPathAny {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/max-time"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPath) MaxTime() *Component_Transceiver_Channel_TargetFrequencyDeviation_MaxTimePath {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/max-time"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPathAny) MaxTime() *Component_Transceiver_Channel_TargetFrequencyDeviation_MaxTimePathAny {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/min"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPath) Min() *Component_Transceiver_Channel_TargetFrequencyDeviation_MinPath {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/min"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPathAny) Min() *Component_Transceiver_Channel_TargetFrequencyDeviation_MinPathAny {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/min-time"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPath) MinTime() *Component_Transceiver_Channel_TargetFrequencyDeviation_MinTimePath {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/target-frequency-deviation/min-time"
func (n *Component_Transceiver_Channel_TargetFrequencyDeviationPathAny) MinTime() *Component_Transceiver_Channel_TargetFrequencyDeviation_MinTimePathAny {
	return &Component_Transceiver_Channel_TargetFrequencyDeviation_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_Channel_TecCurrentPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current YANG schema element.
type Component_Transceiver_Channel_TecCurrentPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrentPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current YANG schema element.
type Component_Transceiver_Channel_TecCurrentPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_AvgPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/avg YANG schema element.
type Component_Transceiver_Channel_TecCurrent_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/avg YANG schema element.
type Component_Transceiver_Channel_TecCurrent_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_InstantPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/instant YANG schema element.
type Component_Transceiver_Channel_TecCurrent_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/instant YANG schema element.
type Component_Transceiver_Channel_TecCurrent_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_IntervalPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/interval YANG schema element.
type Component_Transceiver_Channel_TecCurrent_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/interval YANG schema element.
type Component_Transceiver_Channel_TecCurrent_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_MaxPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/max YANG schema element.
type Component_Transceiver_Channel_TecCurrent_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/max YANG schema element.
type Component_Transceiver_Channel_TecCurrent_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_MaxTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/max-time YANG schema element.
type Component_Transceiver_Channel_TecCurrent_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/max-time YANG schema element.
type Component_Transceiver_Channel_TecCurrent_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_MinPath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/min YANG schema element.
type Component_Transceiver_Channel_TecCurrent_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/min YANG schema element.
type Component_Transceiver_Channel_TecCurrent_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_MinTimePath represents the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/min-time YANG schema element.
type Component_Transceiver_Channel_TecCurrent_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_Channel_TecCurrent_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/physical-channels/channel/state/tec-current/min-time YANG schema element.
type Component_Transceiver_Channel_TecCurrent_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/avg"
func (n *Component_Transceiver_Channel_TecCurrentPath) Avg() *Component_Transceiver_Channel_TecCurrent_AvgPath {
	return &Component_Transceiver_Channel_TecCurrent_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/avg"
func (n *Component_Transceiver_Channel_TecCurrentPathAny) Avg() *Component_Transceiver_Channel_TecCurrent_AvgPathAny {
	return &Component_Transceiver_Channel_TecCurrent_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/instant"
func (n *Component_Transceiver_Channel_TecCurrentPath) Instant() *Component_Transceiver_Channel_TecCurrent_InstantPath {
	return &Component_Transceiver_Channel_TecCurrent_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/instant"
func (n *Component_Transceiver_Channel_TecCurrentPathAny) Instant() *Component_Transceiver_Channel_TecCurrent_InstantPathAny {
	return &Component_Transceiver_Channel_TecCurrent_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/interval"
func (n *Component_Transceiver_Channel_TecCurrentPath) Interval() *Component_Transceiver_Channel_TecCurrent_IntervalPath {
	return &Component_Transceiver_Channel_TecCurrent_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/interval"
func (n *Component_Transceiver_Channel_TecCurrentPathAny) Interval() *Component_Transceiver_Channel_TecCurrent_IntervalPathAny {
	return &Component_Transceiver_Channel_TecCurrent_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/max"
func (n *Component_Transceiver_Channel_TecCurrentPath) Max() *Component_Transceiver_Channel_TecCurrent_MaxPath {
	return &Component_Transceiver_Channel_TecCurrent_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/max"
func (n *Component_Transceiver_Channel_TecCurrentPathAny) Max() *Component_Transceiver_Channel_TecCurrent_MaxPathAny {
	return &Component_Transceiver_Channel_TecCurrent_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/max-time"
func (n *Component_Transceiver_Channel_TecCurrentPath) MaxTime() *Component_Transceiver_Channel_TecCurrent_MaxTimePath {
	return &Component_Transceiver_Channel_TecCurrent_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/max-time"
func (n *Component_Transceiver_Channel_TecCurrentPathAny) MaxTime() *Component_Transceiver_Channel_TecCurrent_MaxTimePathAny {
	return &Component_Transceiver_Channel_TecCurrent_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/min"
func (n *Component_Transceiver_Channel_TecCurrentPath) Min() *Component_Transceiver_Channel_TecCurrent_MinPath {
	return &Component_Transceiver_Channel_TecCurrent_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/min"
func (n *Component_Transceiver_Channel_TecCurrentPathAny) Min() *Component_Transceiver_Channel_TecCurrent_MinPathAny {
	return &Component_Transceiver_Channel_TecCurrent_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/min-time"
func (n *Component_Transceiver_Channel_TecCurrentPath) MinTime() *Component_Transceiver_Channel_TecCurrent_MinTimePath {
	return &Component_Transceiver_Channel_TecCurrent_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/physical-channels/channel/state/tec-current/min-time"
func (n *Component_Transceiver_Channel_TecCurrentPathAny) MinTime() *Component_Transceiver_Channel_TecCurrent_MinTimePathAny {
	return &Component_Transceiver_Channel_TecCurrent_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_InputPowerPath represents the /openconfig-platform/components/component/transceiver/state/input-power YANG schema element.
type Component_Transceiver_InputPowerPath struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/input-power YANG schema element.
type Component_Transceiver_InputPowerPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_AvgPath represents the /openconfig-platform/components/component/transceiver/state/input-power/avg YANG schema element.
type Component_Transceiver_InputPower_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/input-power/avg YANG schema element.
type Component_Transceiver_InputPower_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_InstantPath represents the /openconfig-platform/components/component/transceiver/state/input-power/instant YANG schema element.
type Component_Transceiver_InputPower_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/input-power/instant YANG schema element.
type Component_Transceiver_InputPower_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_IntervalPath represents the /openconfig-platform/components/component/transceiver/state/input-power/interval YANG schema element.
type Component_Transceiver_InputPower_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/input-power/interval YANG schema element.
type Component_Transceiver_InputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_MaxPath represents the /openconfig-platform/components/component/transceiver/state/input-power/max YANG schema element.
type Component_Transceiver_InputPower_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/input-power/max YANG schema element.
type Component_Transceiver_InputPower_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_MaxTimePath represents the /openconfig-platform/components/component/transceiver/state/input-power/max-time YANG schema element.
type Component_Transceiver_InputPower_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/input-power/max-time YANG schema element.
type Component_Transceiver_InputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_MinPath represents the /openconfig-platform/components/component/transceiver/state/input-power/min YANG schema element.
type Component_Transceiver_InputPower_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/input-power/min YANG schema element.
type Component_Transceiver_InputPower_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_MinTimePath represents the /openconfig-platform/components/component/transceiver/state/input-power/min-time YANG schema element.
type Component_Transceiver_InputPower_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_InputPower_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/input-power/min-time YANG schema element.
type Component_Transceiver_InputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/input-power/avg"
func (n *Component_Transceiver_InputPowerPath) Avg() *Component_Transceiver_InputPower_AvgPath {
	return &Component_Transceiver_InputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/input-power/avg"
func (n *Component_Transceiver_InputPowerPathAny) Avg() *Component_Transceiver_InputPower_AvgPathAny {
	return &Component_Transceiver_InputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/input-power/instant"
func (n *Component_Transceiver_InputPowerPath) Instant() *Component_Transceiver_InputPower_InstantPath {
	return &Component_Transceiver_InputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/input-power/instant"
func (n *Component_Transceiver_InputPowerPathAny) Instant() *Component_Transceiver_InputPower_InstantPathAny {
	return &Component_Transceiver_InputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/input-power/interval"
func (n *Component_Transceiver_InputPowerPath) Interval() *Component_Transceiver_InputPower_IntervalPath {
	return &Component_Transceiver_InputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/input-power/interval"
func (n *Component_Transceiver_InputPowerPathAny) Interval() *Component_Transceiver_InputPower_IntervalPathAny {
	return &Component_Transceiver_InputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/input-power/max"
func (n *Component_Transceiver_InputPowerPath) Max() *Component_Transceiver_InputPower_MaxPath {
	return &Component_Transceiver_InputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/input-power/max"
func (n *Component_Transceiver_InputPowerPathAny) Max() *Component_Transceiver_InputPower_MaxPathAny {
	return &Component_Transceiver_InputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/input-power/max-time"
func (n *Component_Transceiver_InputPowerPath) MaxTime() *Component_Transceiver_InputPower_MaxTimePath {
	return &Component_Transceiver_InputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/input-power/max-time"
func (n *Component_Transceiver_InputPowerPathAny) MaxTime() *Component_Transceiver_InputPower_MaxTimePathAny {
	return &Component_Transceiver_InputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/input-power/min"
func (n *Component_Transceiver_InputPowerPath) Min() *Component_Transceiver_InputPower_MinPath {
	return &Component_Transceiver_InputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/input-power/min"
func (n *Component_Transceiver_InputPowerPathAny) Min() *Component_Transceiver_InputPower_MinPathAny {
	return &Component_Transceiver_InputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/input-power/min-time"
func (n *Component_Transceiver_InputPowerPath) MinTime() *Component_Transceiver_InputPower_MinTimePath {
	return &Component_Transceiver_InputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/input-power/min-time"
func (n *Component_Transceiver_InputPowerPathAny) MinTime() *Component_Transceiver_InputPower_MinTimePathAny {
	return &Component_Transceiver_InputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_LaserBiasCurrentPath represents the /openconfig-platform/components/component/transceiver/state/laser-bias-current YANG schema element.
type Component_Transceiver_LaserBiasCurrentPath struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrentPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/laser-bias-current YANG schema element.
type Component_Transceiver_LaserBiasCurrentPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_AvgPath represents the /openconfig-platform/components/component/transceiver/state/laser-bias-current/avg YANG schema element.
type Component_Transceiver_LaserBiasCurrent_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/laser-bias-current/avg YANG schema element.
type Component_Transceiver_LaserBiasCurrent_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_InstantPath represents the /openconfig-platform/components/component/transceiver/state/laser-bias-current/instant YANG schema element.
type Component_Transceiver_LaserBiasCurrent_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/laser-bias-current/instant YANG schema element.
type Component_Transceiver_LaserBiasCurrent_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_IntervalPath represents the /openconfig-platform/components/component/transceiver/state/laser-bias-current/interval YANG schema element.
type Component_Transceiver_LaserBiasCurrent_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/laser-bias-current/interval YANG schema element.
type Component_Transceiver_LaserBiasCurrent_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_MaxPath represents the /openconfig-platform/components/component/transceiver/state/laser-bias-current/max YANG schema element.
type Component_Transceiver_LaserBiasCurrent_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/laser-bias-current/max YANG schema element.
type Component_Transceiver_LaserBiasCurrent_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_MaxTimePath represents the /openconfig-platform/components/component/transceiver/state/laser-bias-current/max-time YANG schema element.
type Component_Transceiver_LaserBiasCurrent_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/laser-bias-current/max-time YANG schema element.
type Component_Transceiver_LaserBiasCurrent_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_MinPath represents the /openconfig-platform/components/component/transceiver/state/laser-bias-current/min YANG schema element.
type Component_Transceiver_LaserBiasCurrent_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/laser-bias-current/min YANG schema element.
type Component_Transceiver_LaserBiasCurrent_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_MinTimePath represents the /openconfig-platform/components/component/transceiver/state/laser-bias-current/min-time YANG schema element.
type Component_Transceiver_LaserBiasCurrent_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_LaserBiasCurrent_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/laser-bias-current/min-time YANG schema element.
type Component_Transceiver_LaserBiasCurrent_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/laser-bias-current/avg"
func (n *Component_Transceiver_LaserBiasCurrentPath) Avg() *Component_Transceiver_LaserBiasCurrent_AvgPath {
	return &Component_Transceiver_LaserBiasCurrent_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/laser-bias-current/avg"
func (n *Component_Transceiver_LaserBiasCurrentPathAny) Avg() *Component_Transceiver_LaserBiasCurrent_AvgPathAny {
	return &Component_Transceiver_LaserBiasCurrent_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/laser-bias-current/instant"
func (n *Component_Transceiver_LaserBiasCurrentPath) Instant() *Component_Transceiver_LaserBiasCurrent_InstantPath {
	return &Component_Transceiver_LaserBiasCurrent_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/laser-bias-current/instant"
func (n *Component_Transceiver_LaserBiasCurrentPathAny) Instant() *Component_Transceiver_LaserBiasCurrent_InstantPathAny {
	return &Component_Transceiver_LaserBiasCurrent_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/laser-bias-current/interval"
func (n *Component_Transceiver_LaserBiasCurrentPath) Interval() *Component_Transceiver_LaserBiasCurrent_IntervalPath {
	return &Component_Transceiver_LaserBiasCurrent_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/laser-bias-current/interval"
func (n *Component_Transceiver_LaserBiasCurrentPathAny) Interval() *Component_Transceiver_LaserBiasCurrent_IntervalPathAny {
	return &Component_Transceiver_LaserBiasCurrent_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/laser-bias-current/max"
func (n *Component_Transceiver_LaserBiasCurrentPath) Max() *Component_Transceiver_LaserBiasCurrent_MaxPath {
	return &Component_Transceiver_LaserBiasCurrent_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/laser-bias-current/max"
func (n *Component_Transceiver_LaserBiasCurrentPathAny) Max() *Component_Transceiver_LaserBiasCurrent_MaxPathAny {
	return &Component_Transceiver_LaserBiasCurrent_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/laser-bias-current/max-time"
func (n *Component_Transceiver_LaserBiasCurrentPath) MaxTime() *Component_Transceiver_LaserBiasCurrent_MaxTimePath {
	return &Component_Transceiver_LaserBiasCurrent_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/laser-bias-current/max-time"
func (n *Component_Transceiver_LaserBiasCurrentPathAny) MaxTime() *Component_Transceiver_LaserBiasCurrent_MaxTimePathAny {
	return &Component_Transceiver_LaserBiasCurrent_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/laser-bias-current/min"
func (n *Component_Transceiver_LaserBiasCurrentPath) Min() *Component_Transceiver_LaserBiasCurrent_MinPath {
	return &Component_Transceiver_LaserBiasCurrent_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/laser-bias-current/min"
func (n *Component_Transceiver_LaserBiasCurrentPathAny) Min() *Component_Transceiver_LaserBiasCurrent_MinPathAny {
	return &Component_Transceiver_LaserBiasCurrent_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/laser-bias-current/min-time"
func (n *Component_Transceiver_LaserBiasCurrentPath) MinTime() *Component_Transceiver_LaserBiasCurrent_MinTimePath {
	return &Component_Transceiver_LaserBiasCurrent_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/laser-bias-current/min-time"
func (n *Component_Transceiver_LaserBiasCurrentPathAny) MinTime() *Component_Transceiver_LaserBiasCurrent_MinTimePathAny {
	return &Component_Transceiver_LaserBiasCurrent_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_OutputPowerPath represents the /openconfig-platform/components/component/transceiver/state/output-power YANG schema element.
type Component_Transceiver_OutputPowerPath struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPowerPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/output-power YANG schema element.
type Component_Transceiver_OutputPowerPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_AvgPath represents the /openconfig-platform/components/component/transceiver/state/output-power/avg YANG schema element.
type Component_Transceiver_OutputPower_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/output-power/avg YANG schema element.
type Component_Transceiver_OutputPower_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_InstantPath represents the /openconfig-platform/components/component/transceiver/state/output-power/instant YANG schema element.
type Component_Transceiver_OutputPower_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/output-power/instant YANG schema element.
type Component_Transceiver_OutputPower_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_IntervalPath represents the /openconfig-platform/components/component/transceiver/state/output-power/interval YANG schema element.
type Component_Transceiver_OutputPower_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/output-power/interval YANG schema element.
type Component_Transceiver_OutputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_MaxPath represents the /openconfig-platform/components/component/transceiver/state/output-power/max YANG schema element.
type Component_Transceiver_OutputPower_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/output-power/max YANG schema element.
type Component_Transceiver_OutputPower_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_MaxTimePath represents the /openconfig-platform/components/component/transceiver/state/output-power/max-time YANG schema element.
type Component_Transceiver_OutputPower_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/output-power/max-time YANG schema element.
type Component_Transceiver_OutputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_MinPath represents the /openconfig-platform/components/component/transceiver/state/output-power/min YANG schema element.
type Component_Transceiver_OutputPower_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/output-power/min YANG schema element.
type Component_Transceiver_OutputPower_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_MinTimePath represents the /openconfig-platform/components/component/transceiver/state/output-power/min-time YANG schema element.
type Component_Transceiver_OutputPower_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_OutputPower_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/output-power/min-time YANG schema element.
type Component_Transceiver_OutputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/output-power/avg"
func (n *Component_Transceiver_OutputPowerPath) Avg() *Component_Transceiver_OutputPower_AvgPath {
	return &Component_Transceiver_OutputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/output-power/avg"
func (n *Component_Transceiver_OutputPowerPathAny) Avg() *Component_Transceiver_OutputPower_AvgPathAny {
	return &Component_Transceiver_OutputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/output-power/instant"
func (n *Component_Transceiver_OutputPowerPath) Instant() *Component_Transceiver_OutputPower_InstantPath {
	return &Component_Transceiver_OutputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/output-power/instant"
func (n *Component_Transceiver_OutputPowerPathAny) Instant() *Component_Transceiver_OutputPower_InstantPathAny {
	return &Component_Transceiver_OutputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/output-power/interval"
func (n *Component_Transceiver_OutputPowerPath) Interval() *Component_Transceiver_OutputPower_IntervalPath {
	return &Component_Transceiver_OutputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/output-power/interval"
func (n *Component_Transceiver_OutputPowerPathAny) Interval() *Component_Transceiver_OutputPower_IntervalPathAny {
	return &Component_Transceiver_OutputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/output-power/max"
func (n *Component_Transceiver_OutputPowerPath) Max() *Component_Transceiver_OutputPower_MaxPath {
	return &Component_Transceiver_OutputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/output-power/max"
func (n *Component_Transceiver_OutputPowerPathAny) Max() *Component_Transceiver_OutputPower_MaxPathAny {
	return &Component_Transceiver_OutputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/output-power/max-time"
func (n *Component_Transceiver_OutputPowerPath) MaxTime() *Component_Transceiver_OutputPower_MaxTimePath {
	return &Component_Transceiver_OutputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/output-power/max-time"
func (n *Component_Transceiver_OutputPowerPathAny) MaxTime() *Component_Transceiver_OutputPower_MaxTimePathAny {
	return &Component_Transceiver_OutputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/output-power/min"
func (n *Component_Transceiver_OutputPowerPath) Min() *Component_Transceiver_OutputPower_MinPath {
	return &Component_Transceiver_OutputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/output-power/min"
func (n *Component_Transceiver_OutputPowerPathAny) Min() *Component_Transceiver_OutputPower_MinPathAny {
	return &Component_Transceiver_OutputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/output-power/min-time"
func (n *Component_Transceiver_OutputPowerPath) MinTime() *Component_Transceiver_OutputPower_MinTimePath {
	return &Component_Transceiver_OutputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/output-power/min-time"
func (n *Component_Transceiver_OutputPowerPathAny) MinTime() *Component_Transceiver_OutputPower_MinTimePathAny {
	return &Component_Transceiver_OutputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_PostFecBerPath represents the /openconfig-platform/components/component/transceiver/state/post-fec-ber YANG schema element.
type Component_Transceiver_PostFecBerPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBerPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/post-fec-ber YANG schema element.
type Component_Transceiver_PostFecBerPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_AvgPath represents the /openconfig-platform/components/component/transceiver/state/post-fec-ber/avg YANG schema element.
type Component_Transceiver_PostFecBer_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/post-fec-ber/avg YANG schema element.
type Component_Transceiver_PostFecBer_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_InstantPath represents the /openconfig-platform/components/component/transceiver/state/post-fec-ber/instant YANG schema element.
type Component_Transceiver_PostFecBer_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/post-fec-ber/instant YANG schema element.
type Component_Transceiver_PostFecBer_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_IntervalPath represents the /openconfig-platform/components/component/transceiver/state/post-fec-ber/interval YANG schema element.
type Component_Transceiver_PostFecBer_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/post-fec-ber/interval YANG schema element.
type Component_Transceiver_PostFecBer_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_MaxPath represents the /openconfig-platform/components/component/transceiver/state/post-fec-ber/max YANG schema element.
type Component_Transceiver_PostFecBer_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/post-fec-ber/max YANG schema element.
type Component_Transceiver_PostFecBer_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_MaxTimePath represents the /openconfig-platform/components/component/transceiver/state/post-fec-ber/max-time YANG schema element.
type Component_Transceiver_PostFecBer_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/post-fec-ber/max-time YANG schema element.
type Component_Transceiver_PostFecBer_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_MinPath represents the /openconfig-platform/components/component/transceiver/state/post-fec-ber/min YANG schema element.
type Component_Transceiver_PostFecBer_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/post-fec-ber/min YANG schema element.
type Component_Transceiver_PostFecBer_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_MinTimePath represents the /openconfig-platform/components/component/transceiver/state/post-fec-ber/min-time YANG schema element.
type Component_Transceiver_PostFecBer_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_PostFecBer_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/post-fec-ber/min-time YANG schema element.
type Component_Transceiver_PostFecBer_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/post-fec-ber/avg"
func (n *Component_Transceiver_PostFecBerPath) Avg() *Component_Transceiver_PostFecBer_AvgPath {
	return &Component_Transceiver_PostFecBer_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/post-fec-ber/avg"
func (n *Component_Transceiver_PostFecBerPathAny) Avg() *Component_Transceiver_PostFecBer_AvgPathAny {
	return &Component_Transceiver_PostFecBer_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/post-fec-ber/instant"
func (n *Component_Transceiver_PostFecBerPath) Instant() *Component_Transceiver_PostFecBer_InstantPath {
	return &Component_Transceiver_PostFecBer_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/post-fec-ber/instant"
func (n *Component_Transceiver_PostFecBerPathAny) Instant() *Component_Transceiver_PostFecBer_InstantPathAny {
	return &Component_Transceiver_PostFecBer_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/post-fec-ber/interval"
func (n *Component_Transceiver_PostFecBerPath) Interval() *Component_Transceiver_PostFecBer_IntervalPath {
	return &Component_Transceiver_PostFecBer_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/post-fec-ber/interval"
func (n *Component_Transceiver_PostFecBerPathAny) Interval() *Component_Transceiver_PostFecBer_IntervalPathAny {
	return &Component_Transceiver_PostFecBer_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/post-fec-ber/max"
func (n *Component_Transceiver_PostFecBerPath) Max() *Component_Transceiver_PostFecBer_MaxPath {
	return &Component_Transceiver_PostFecBer_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/post-fec-ber/max"
func (n *Component_Transceiver_PostFecBerPathAny) Max() *Component_Transceiver_PostFecBer_MaxPathAny {
	return &Component_Transceiver_PostFecBer_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/post-fec-ber/max-time"
func (n *Component_Transceiver_PostFecBerPath) MaxTime() *Component_Transceiver_PostFecBer_MaxTimePath {
	return &Component_Transceiver_PostFecBer_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/post-fec-ber/max-time"
func (n *Component_Transceiver_PostFecBerPathAny) MaxTime() *Component_Transceiver_PostFecBer_MaxTimePathAny {
	return &Component_Transceiver_PostFecBer_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/post-fec-ber/min"
func (n *Component_Transceiver_PostFecBerPath) Min() *Component_Transceiver_PostFecBer_MinPath {
	return &Component_Transceiver_PostFecBer_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/post-fec-ber/min"
func (n *Component_Transceiver_PostFecBerPathAny) Min() *Component_Transceiver_PostFecBer_MinPathAny {
	return &Component_Transceiver_PostFecBer_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/post-fec-ber/min-time"
func (n *Component_Transceiver_PostFecBerPath) MinTime() *Component_Transceiver_PostFecBer_MinTimePath {
	return &Component_Transceiver_PostFecBer_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/post-fec-ber/min-time"
func (n *Component_Transceiver_PostFecBerPathAny) MinTime() *Component_Transceiver_PostFecBer_MinTimePathAny {
	return &Component_Transceiver_PostFecBer_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_PreFecBerPath represents the /openconfig-platform/components/component/transceiver/state/pre-fec-ber YANG schema element.
type Component_Transceiver_PreFecBerPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBerPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/pre-fec-ber YANG schema element.
type Component_Transceiver_PreFecBerPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_AvgPath represents the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/avg YANG schema element.
type Component_Transceiver_PreFecBer_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/avg YANG schema element.
type Component_Transceiver_PreFecBer_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_InstantPath represents the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/instant YANG schema element.
type Component_Transceiver_PreFecBer_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/instant YANG schema element.
type Component_Transceiver_PreFecBer_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_IntervalPath represents the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/interval YANG schema element.
type Component_Transceiver_PreFecBer_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/interval YANG schema element.
type Component_Transceiver_PreFecBer_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_MaxPath represents the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/max YANG schema element.
type Component_Transceiver_PreFecBer_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/max YANG schema element.
type Component_Transceiver_PreFecBer_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_MaxTimePath represents the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/max-time YANG schema element.
type Component_Transceiver_PreFecBer_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/max-time YANG schema element.
type Component_Transceiver_PreFecBer_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_MinPath represents the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/min YANG schema element.
type Component_Transceiver_PreFecBer_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/min YANG schema element.
type Component_Transceiver_PreFecBer_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_MinTimePath represents the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/min-time YANG schema element.
type Component_Transceiver_PreFecBer_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_PreFecBer_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/pre-fec-ber/min-time YANG schema element.
type Component_Transceiver_PreFecBer_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/avg"
func (n *Component_Transceiver_PreFecBerPath) Avg() *Component_Transceiver_PreFecBer_AvgPath {
	return &Component_Transceiver_PreFecBer_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/avg"
func (n *Component_Transceiver_PreFecBerPathAny) Avg() *Component_Transceiver_PreFecBer_AvgPathAny {
	return &Component_Transceiver_PreFecBer_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/instant"
func (n *Component_Transceiver_PreFecBerPath) Instant() *Component_Transceiver_PreFecBer_InstantPath {
	return &Component_Transceiver_PreFecBer_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/instant"
func (n *Component_Transceiver_PreFecBerPathAny) Instant() *Component_Transceiver_PreFecBer_InstantPathAny {
	return &Component_Transceiver_PreFecBer_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/interval"
func (n *Component_Transceiver_PreFecBerPath) Interval() *Component_Transceiver_PreFecBer_IntervalPath {
	return &Component_Transceiver_PreFecBer_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/interval"
func (n *Component_Transceiver_PreFecBerPathAny) Interval() *Component_Transceiver_PreFecBer_IntervalPathAny {
	return &Component_Transceiver_PreFecBer_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/max"
func (n *Component_Transceiver_PreFecBerPath) Max() *Component_Transceiver_PreFecBer_MaxPath {
	return &Component_Transceiver_PreFecBer_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/max"
func (n *Component_Transceiver_PreFecBerPathAny) Max() *Component_Transceiver_PreFecBer_MaxPathAny {
	return &Component_Transceiver_PreFecBer_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/max-time"
func (n *Component_Transceiver_PreFecBerPath) MaxTime() *Component_Transceiver_PreFecBer_MaxTimePath {
	return &Component_Transceiver_PreFecBer_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/max-time"
func (n *Component_Transceiver_PreFecBerPathAny) MaxTime() *Component_Transceiver_PreFecBer_MaxTimePathAny {
	return &Component_Transceiver_PreFecBer_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/min"
func (n *Component_Transceiver_PreFecBerPath) Min() *Component_Transceiver_PreFecBer_MinPath {
	return &Component_Transceiver_PreFecBer_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/min"
func (n *Component_Transceiver_PreFecBerPathAny) Min() *Component_Transceiver_PreFecBer_MinPathAny {
	return &Component_Transceiver_PreFecBer_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/min-time"
func (n *Component_Transceiver_PreFecBerPath) MinTime() *Component_Transceiver_PreFecBer_MinTimePath {
	return &Component_Transceiver_PreFecBer_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/pre-fec-ber/min-time"
func (n *Component_Transceiver_PreFecBerPathAny) MinTime() *Component_Transceiver_PreFecBer_MinTimePathAny {
	return &Component_Transceiver_PreFecBer_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component_Transceiver_SupplyVoltagePath represents the /openconfig-platform/components/component/transceiver/state/supply-voltage YANG schema element.
type Component_Transceiver_SupplyVoltagePath struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltagePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/supply-voltage YANG schema element.
type Component_Transceiver_SupplyVoltagePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_AvgPath represents the /openconfig-platform/components/component/transceiver/state/supply-voltage/avg YANG schema element.
type Component_Transceiver_SupplyVoltage_AvgPath struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_AvgPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/supply-voltage/avg YANG schema element.
type Component_Transceiver_SupplyVoltage_AvgPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_InstantPath represents the /openconfig-platform/components/component/transceiver/state/supply-voltage/instant YANG schema element.
type Component_Transceiver_SupplyVoltage_InstantPath struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_InstantPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/supply-voltage/instant YANG schema element.
type Component_Transceiver_SupplyVoltage_InstantPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_IntervalPath represents the /openconfig-platform/components/component/transceiver/state/supply-voltage/interval YANG schema element.
type Component_Transceiver_SupplyVoltage_IntervalPath struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_IntervalPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/supply-voltage/interval YANG schema element.
type Component_Transceiver_SupplyVoltage_IntervalPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_MaxPath represents the /openconfig-platform/components/component/transceiver/state/supply-voltage/max YANG schema element.
type Component_Transceiver_SupplyVoltage_MaxPath struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_MaxPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/supply-voltage/max YANG schema element.
type Component_Transceiver_SupplyVoltage_MaxPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_MaxTimePath represents the /openconfig-platform/components/component/transceiver/state/supply-voltage/max-time YANG schema element.
type Component_Transceiver_SupplyVoltage_MaxTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_MaxTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/supply-voltage/max-time YANG schema element.
type Component_Transceiver_SupplyVoltage_MaxTimePathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_MinPath represents the /openconfig-platform/components/component/transceiver/state/supply-voltage/min YANG schema element.
type Component_Transceiver_SupplyVoltage_MinPath struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_MinPathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/supply-voltage/min YANG schema element.
type Component_Transceiver_SupplyVoltage_MinPathAny struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_MinTimePath represents the /openconfig-platform/components/component/transceiver/state/supply-voltage/min-time YANG schema element.
type Component_Transceiver_SupplyVoltage_MinTimePath struct {
	*ygot.NodePath
}

// Component_Transceiver_SupplyVoltage_MinTimePathAny represents the wildcard version of the /openconfig-platform/components/component/transceiver/state/supply-voltage/min-time YANG schema element.
type Component_Transceiver_SupplyVoltage_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// sampling period.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/supply-voltage/avg"
func (n *Component_Transceiver_SupplyVoltagePath) Avg() *Component_Transceiver_SupplyVoltage_AvgPath {
	return &Component_Transceiver_SupplyVoltage_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// sampling period.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "avg"
// Path from root: "/components/component/transceiver/state/supply-voltage/avg"
func (n *Component_Transceiver_SupplyVoltagePathAny) Avg() *Component_Transceiver_SupplyVoltage_AvgPathAny {
	return &Component_Transceiver_SupplyVoltage_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/supply-voltage/instant"
func (n *Component_Transceiver_SupplyVoltagePath) Instant() *Component_Transceiver_SupplyVoltage_InstantPath {
	return &Component_Transceiver_SupplyVoltage_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "instant"
// Path from root: "/components/component/transceiver/state/supply-voltage/instant"
func (n *Component_Transceiver_SupplyVoltagePathAny) Instant() *Component_Transceiver_SupplyVoltage_InstantPathAny {
	return &Component_Transceiver_SupplyVoltage_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/supply-voltage/interval"
func (n *Component_Transceiver_SupplyVoltagePath) Interval() *Component_Transceiver_SupplyVoltage_IntervalPath {
	return &Component_Transceiver_SupplyVoltage_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "interval"
// Path from root: "/components/component/transceiver/state/supply-voltage/interval"
func (n *Component_Transceiver_SupplyVoltagePathAny) Interval() *Component_Transceiver_SupplyVoltage_IntervalPathAny {
	return &Component_Transceiver_SupplyVoltage_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/supply-voltage/max"
func (n *Component_Transceiver_SupplyVoltagePath) Max() *Component_Transceiver_SupplyVoltage_MaxPath {
	return &Component_Transceiver_SupplyVoltage_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max"
// Path from root: "/components/component/transceiver/state/supply-voltage/max"
func (n *Component_Transceiver_SupplyVoltagePathAny) Max() *Component_Transceiver_SupplyVoltage_MaxPathAny {
	return &Component_Transceiver_SupplyVoltage_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/supply-voltage/max-time"
func (n *Component_Transceiver_SupplyVoltagePath) MaxTime() *Component_Transceiver_SupplyVoltage_MaxTimePath {
	return &Component_Transceiver_SupplyVoltage_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "max-time"
// Path from root: "/components/component/transceiver/state/supply-voltage/max-time"
func (n *Component_Transceiver_SupplyVoltagePathAny) MaxTime() *Component_Transceiver_SupplyVoltage_MaxTimePathAny {
	return &Component_Transceiver_SupplyVoltage_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/supply-voltage/min"
func (n *Component_Transceiver_SupplyVoltagePath) Min() *Component_Transceiver_SupplyVoltage_MinPath {
	return &Component_Transceiver_SupplyVoltage_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the sampling
// period
// ----------------------------------------
// Defining module: "openconfig-platform-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min"
// Path from root: "/components/component/transceiver/state/supply-voltage/min"
func (n *Component_Transceiver_SupplyVoltagePathAny) Min() *Component_Transceiver_SupplyVoltage_MinPathAny {
	return &Component_Transceiver_SupplyVoltage_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/supply-voltage/min-time"
func (n *Component_Transceiver_SupplyVoltagePath) MinTime() *Component_Transceiver_SupplyVoltage_MinTimePath {
	return &Component_Transceiver_SupplyVoltage_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-platform"
// Path from parent: "min-time"
// Path from root: "/components/component/transceiver/state/supply-voltage/min-time"
func (n *Component_Transceiver_SupplyVoltagePathAny) MinTime() *Component_Transceiver_SupplyVoltage_MinTimePathAny {
	return &Component_Transceiver_SupplyVoltage_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// DevicePath represents the /device YANG schema element.
type DevicePath struct {
	*ygot.DeviceRootBase
}

// DeviceRoot returns a new path object from which YANG paths can be constructed.
func DeviceRoot(id string) *DevicePath {
	return &DevicePath{ygot.NewDeviceRootBase(id)}
}

// Acl (container): Top level enclosing container for ACL model config
// and operational state data
// ----------------------------------------
// Defining module: "openconfig-acl"
// Instantiating module: "openconfig-acl"
// Path from parent: "acl"
// Path from root: "/acl"
func (n *DevicePath) Acl() *AclPath {
	return &AclPath{
		NodePath: ygot.NewNodePath(
			[]string{"acl"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aps (container): Top level grouping for automatic protection switch data
// ----------------------------------------
// Defining module: "openconfig-transport-line-protection"
// Instantiating module: "openconfig-transport-line-protection"
// Path from parent: "aps"
// Path from root: "/aps"
func (n *DevicePath) Aps() *ApsPath {
	return &ApsPath{
		NodePath: ygot.NewNodePath(
			[]string{"aps"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bfd (container): Configuration and operational state parameters for BFD.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-bfd"
// Path from parent: "bfd"
// Path from root: "/bfd"
func (n *DevicePath) Bfd() *BfdPath {
	return &BfdPath{
		NodePath: ygot.NewNodePath(
			[]string{"bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// ComponentAny (list): List of components, keyed by component name.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "components/component"
// Path from root: "/components/component"
// Name (wildcarded): string
func (n *DevicePath) ComponentAny() *ComponentPathAny {
	return &ComponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"components", "component"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Component (list): List of components, keyed by component name.
// ----------------------------------------
// Defining module: "openconfig-platform"
// Instantiating module: "openconfig-platform"
// Path from parent: "components/component"
// Path from root: "/components/component"
// Name: string
func (n *DevicePath) Component(Name string) *ComponentPath {
	return &ComponentPath{
		NodePath: ygot.NewNodePath(
			[]string{"components", "component"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// InterfaceAny (list): The list of named interfaces on the device.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interfaces/interface"
// Path from root: "/interfaces/interface"
// Name (wildcarded): string
func (n *DevicePath) InterfaceAny() *InterfacePathAny {
	return &InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Interface (list): The list of named interfaces on the device.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interfaces/interface"
// Path from root: "/interfaces/interface"
// Name: string
func (n *DevicePath) Interface(Name string) *InterfacePath {
	return &InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// KeychainAny (list): List of defined keychains.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "keychains/keychain"
// Path from root: "/keychains/keychain"
// Name (wildcarded): string
func (n *DevicePath) KeychainAny() *KeychainPathAny {
	return &KeychainPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"keychains", "keychain"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Keychain (list): List of defined keychains.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "keychains/keychain"
// Path from root: "/keychains/keychain"
// Name: string
func (n *DevicePath) Keychain(Name string) *KeychainPath {
	return &KeychainPath{
		NodePath: ygot.NewNodePath(
			[]string{"keychains", "keychain"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Lacp (container): Configuration and operational state data for LACP protocol
// operation on the aggregate interface
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp"
// Path from root: "/lacp"
func (n *DevicePath) Lacp() *LacpPath {
	return &LacpPath{
		NodePath: ygot.NewNodePath(
			[]string{"lacp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lldp (container): Top-level container for LLDP configuration and state data
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "lldp"
// Path from root: "/lldp"
func (n *DevicePath) Lldp() *LldpPath {
	return &LldpPath{
		NodePath: ygot.NewNodePath(
			[]string{"lldp"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalRoutes (container): Top-level container for local routes
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "local-routes"
// Path from root: "/local-routes"
func (n *DevicePath) LocalRoutes() *LocalRoutesPath {
	return &LocalRoutesPath{
		NodePath: ygot.NewNodePath(
			[]string{"local-routes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Messages (container): Top-level container for Syslog messages.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "messages"
// Path from root: "/messages"
func (n *DevicePath) Messages() *MessagesPath {
	return &MessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstanceAny (list): Network instances configured on the local system
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "network-instances/network-instance"
// Path from root: "/network-instances/network-instance"
// Name (wildcarded): string
func (n *DevicePath) NetworkInstanceAny() *NetworkInstancePathAny {
	return &NetworkInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"network-instances", "network-instance"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// NetworkInstance (list): Network instances configured on the local system
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "network-instances/network-instance"
// Path from root: "/network-instances/network-instance"
// Name: string
func (n *DevicePath) NetworkInstance(Name string) *NetworkInstancePath {
	return &NetworkInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"network-instances", "network-instance"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// OpticalAmplifier (container): Enclosing container for amplifiers and supervisory channels
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "optical-amplifier"
// Path from root: "/optical-amplifier"
func (n *DevicePath) OpticalAmplifier() *OpticalAmplifierPath {
	return &OpticalAmplifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"optical-amplifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent (container): Top level container for relay-agent configuration and
// operational state data
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "relay-agent"
// Path from root: "/relay-agent"
func (n *DevicePath) RelayAgent() *RelayAgentPath {
	return &RelayAgentPath{
		NodePath: ygot.NewNodePath(
			[]string{"relay-agent"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy (container): Top-level container for all routing policy configuration
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "routing-policy"
// Path from root: "/routing-policy"
func (n *DevicePath) RoutingPolicy() *RoutingPolicyPath {
	return &RoutingPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"routing-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp (container): Top-level container for spanning tree configuration and
// state data
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "stp"
// Path from root: "/stp"
func (n *DevicePath) Stp() *StpPath {
	return &StpPath{
		NodePath: ygot.NewNodePath(
			[]string{"stp"},
			map[string]interface{}{},
			n,
		),
	}
}

// System (container): Enclosing container for system-related configuration and
// operational state data
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "system"
// Path from root: "/system"
func (n *DevicePath) System() *SystemPath {
	return &SystemPath{
		NodePath: ygot.NewNodePath(
			[]string{"system"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice (container): Top-level container for the terminal device
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "terminal-device"
// Path from root: "/terminal-device"
func (n *DevicePath) TerminalDevice() *TerminalDevicePath {
	return &TerminalDevicePath{
		NodePath: ygot.NewNodePath(
			[]string{"terminal-device"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfacePath represents the /openconfig-interfaces/interfaces/interface YANG schema element.
type InterfacePath struct {
	*ygot.NodePath
}

// InterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface YANG schema element.
type InterfacePathAny struct {
	*ygot.NodePath
}

// Interface_AdminStatusPath represents the /openconfig-interfaces/interfaces/interface/state/admin-status YANG schema element.
type Interface_AdminStatusPath struct {
	*ygot.NodePath
}

// Interface_AdminStatusPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/admin-status YANG schema element.
type Interface_AdminStatusPathAny struct {
	*ygot.NodePath
}

// Interface_CpuPath represents the /openconfig-interfaces/interfaces/interface/state/cpu YANG schema element.
type Interface_CpuPath struct {
	*ygot.NodePath
}

// Interface_CpuPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/cpu YANG schema element.
type Interface_CpuPathAny struct {
	*ygot.NodePath
}

// Interface_DescriptionPath represents the /openconfig-interfaces/interfaces/interface/config/description YANG schema element.
type Interface_DescriptionPath struct {
	*ygot.NodePath
}

// Interface_DescriptionPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/config/description YANG schema element.
type Interface_DescriptionPathAny struct {
	*ygot.NodePath
}

// Interface_EnabledPath represents the /openconfig-interfaces/interfaces/interface/config/enabled YANG schema element.
type Interface_EnabledPath struct {
	*ygot.NodePath
}

// Interface_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/config/enabled YANG schema element.
type Interface_EnabledPathAny struct {
	*ygot.NodePath
}

// Interface_HardwarePortPath represents the /openconfig-interfaces/interfaces/interface/state/hardware-port YANG schema element.
type Interface_HardwarePortPath struct {
	*ygot.NodePath
}

// Interface_HardwarePortPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/hardware-port YANG schema element.
type Interface_HardwarePortPathAny struct {
	*ygot.NodePath
}

// Interface_IfindexPath represents the /openconfig-interfaces/interfaces/interface/state/ifindex YANG schema element.
type Interface_IfindexPath struct {
	*ygot.NodePath
}

// Interface_IfindexPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/ifindex YANG schema element.
type Interface_IfindexPathAny struct {
	*ygot.NodePath
}

// Interface_LastChangePath represents the /openconfig-interfaces/interfaces/interface/state/last-change YANG schema element.
type Interface_LastChangePath struct {
	*ygot.NodePath
}

// Interface_LastChangePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/last-change YANG schema element.
type Interface_LastChangePathAny struct {
	*ygot.NodePath
}

// Interface_LogicalPath represents the /openconfig-interfaces/interfaces/interface/state/logical YANG schema element.
type Interface_LogicalPath struct {
	*ygot.NodePath
}

// Interface_LogicalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/logical YANG schema element.
type Interface_LogicalPathAny struct {
	*ygot.NodePath
}

// Interface_LoopbackModePath represents the /openconfig-interfaces/interfaces/interface/config/loopback-mode YANG schema element.
type Interface_LoopbackModePath struct {
	*ygot.NodePath
}

// Interface_LoopbackModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/config/loopback-mode YANG schema element.
type Interface_LoopbackModePathAny struct {
	*ygot.NodePath
}

// Interface_ManagementPath represents the /openconfig-interfaces/interfaces/interface/state/management YANG schema element.
type Interface_ManagementPath struct {
	*ygot.NodePath
}

// Interface_ManagementPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/management YANG schema element.
type Interface_ManagementPathAny struct {
	*ygot.NodePath
}

// Interface_MtuPath represents the /openconfig-interfaces/interfaces/interface/config/mtu YANG schema element.
type Interface_MtuPath struct {
	*ygot.NodePath
}

// Interface_MtuPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/config/mtu YANG schema element.
type Interface_MtuPathAny struct {
	*ygot.NodePath
}

// Interface_NamePath represents the /openconfig-interfaces/interfaces/interface/config/name YANG schema element.
type Interface_NamePath struct {
	*ygot.NodePath
}

// Interface_NamePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/config/name YANG schema element.
type Interface_NamePathAny struct {
	*ygot.NodePath
}

// Interface_OperStatusPath represents the /openconfig-interfaces/interfaces/interface/state/oper-status YANG schema element.
type Interface_OperStatusPath struct {
	*ygot.NodePath
}

// Interface_OperStatusPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/oper-status YANG schema element.
type Interface_OperStatusPathAny struct {
	*ygot.NodePath
}

// Interface_PhysicalChannelPath represents the /openconfig-interfaces/interfaces/interface/state/physical-channel YANG schema element.
type Interface_PhysicalChannelPath struct {
	*ygot.NodePath
}

// Interface_PhysicalChannelPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/physical-channel YANG schema element.
type Interface_PhysicalChannelPathAny struct {
	*ygot.NodePath
}

// Interface_TpidPath represents the /openconfig-interfaces/interfaces/interface/config/tpid YANG schema element.
type Interface_TpidPath struct {
	*ygot.NodePath
}

// Interface_TpidPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/config/tpid YANG schema element.
type Interface_TpidPathAny struct {
	*ygot.NodePath
}

// Interface_TransceiverPath represents the /openconfig-interfaces/interfaces/interface/state/transceiver YANG schema element.
type Interface_TransceiverPath struct {
	*ygot.NodePath
}

// Interface_TransceiverPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/transceiver YANG schema element.
type Interface_TransceiverPathAny struct {
	*ygot.NodePath
}

// Interface_TypePath represents the /openconfig-interfaces/interfaces/interface/config/type YANG schema element.
type Interface_TypePath struct {
	*ygot.NodePath
}

// Interface_TypePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/config/type YANG schema element.
type Interface_TypePathAny struct {
	*ygot.NodePath
}

// AdminStatus (leaf): The desired state of the interface.  In RFC 7223 this leaf
// has the same read semantics as ifAdminStatus.  Here, it
// reflects the administrative state as set by enabling or
// disabling the interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/admin-status"
// Path from root: "/interfaces/interface/state/admin-status"
func (n *InterfacePath) AdminStatus() *Interface_AdminStatusPath {
	return &Interface_AdminStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminStatus (leaf): The desired state of the interface.  In RFC 7223 this leaf
// has the same read semantics as ifAdminStatus.  Here, it
// reflects the administrative state as set by enabling or
// disabling the interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/admin-status"
// Path from root: "/interfaces/interface/state/admin-status"
func (n *InterfacePathAny) AdminStatus() *Interface_AdminStatusPathAny {
	return &Interface_AdminStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aggregation (container): Options for logical interfaces representing
// aggregates
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "aggregation"
// Path from root: "/interfaces/interface/aggregation"
func (n *InterfacePath) Aggregation() *Interface_AggregationPath {
	return &Interface_AggregationPath{
		NodePath: ygot.NewNodePath(
			[]string{"aggregation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aggregation (container): Options for logical interfaces representing
// aggregates
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "aggregation"
// Path from root: "/interfaces/interface/aggregation"
func (n *InterfacePathAny) Aggregation() *Interface_AggregationPathAny {
	return &Interface_AggregationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"aggregation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): A collection of interface-related statistics objects.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/state/counters"
func (n *InterfacePath) Counters() *Interface_CountersPath {
	return &Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): A collection of interface-related statistics objects.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/state/counters"
func (n *InterfacePathAny) Counters() *Interface_CountersPathAny {
	return &Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cpu (leaf): When set to true, the interface is for traffic
// that is handled by the system CPU, sometimes also called the
// control plane interface.  On systems that represent the CPU
// interface as an Ethernet interface, for example, this leaf
// should be used to distinguish the CPU interface from dataplane
// interfaces.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/cpu"
// Path from root: "/interfaces/interface/state/cpu"
func (n *InterfacePath) Cpu() *Interface_CpuPath {
	return &Interface_CpuPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cpu (leaf): When set to true, the interface is for traffic
// that is handled by the system CPU, sometimes also called the
// control plane interface.  On systems that represent the CPU
// interface as an Ethernet interface, for example, this leaf
// should be used to distinguish the CPU interface from dataplane
// interfaces.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/cpu"
// Path from root: "/interfaces/interface/state/cpu"
func (n *InterfacePathAny) Cpu() *Interface_CpuPathAny {
	return &Interface_CpuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): A textual description of the interface.
//
// A server implementation MAY map this leaf to the ifAlias
// MIB object.  Such an implementation needs to use some
// mechanism to handle the differences in size and characters
// allowed between this leaf and ifAlias.  The definition of
// such a mechanism is outside the scope of this document.
//
// Since ifAlias is defined to be stored in non-volatile
// storage, the MIB implementation MUST map ifAlias to the
// value of 'description' in the persistently stored
// datastore.
//
// Specifically, if the device supports ':startup', when
// ifAlias is read the device MUST return the value of
// 'description' in the 'startup' datastore, and when it is
// written, it MUST be written to the 'running' and 'startup'
// datastores.  Note that it is up to the implementation to
//
// decide whether to modify this single leaf in 'startup' or
// perform an implicit copy-config from 'running' to
// 'startup'.
//
// If the device does not support ':startup', ifAlias MUST
// be mapped to the 'description' leaf in the 'running'
// datastore.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/description"
// Path from root: "/interfaces/interface/config/description"
func (n *InterfacePath) Description() *Interface_DescriptionPath {
	return &Interface_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): A textual description of the interface.
//
// A server implementation MAY map this leaf to the ifAlias
// MIB object.  Such an implementation needs to use some
// mechanism to handle the differences in size and characters
// allowed between this leaf and ifAlias.  The definition of
// such a mechanism is outside the scope of this document.
//
// Since ifAlias is defined to be stored in non-volatile
// storage, the MIB implementation MUST map ifAlias to the
// value of 'description' in the persistently stored
// datastore.
//
// Specifically, if the device supports ':startup', when
// ifAlias is read the device MUST return the value of
// 'description' in the 'startup' datastore, and when it is
// written, it MUST be written to the 'running' and 'startup'
// datastores.  Note that it is up to the implementation to
//
// decide whether to modify this single leaf in 'startup' or
// perform an implicit copy-config from 'running' to
// 'startup'.
//
// If the device does not support ':startup', ifAlias MUST
// be mapped to the 'description' leaf in the 'running'
// datastore.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/description"
// Path from root: "/interfaces/interface/config/description"
func (n *InterfacePathAny) Description() *Interface_DescriptionPathAny {
	return &Interface_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// interface.
//
// Systems that implement the IF-MIB use the value of this
// leaf in the 'running' datastore to set
// IF-MIB.ifAdminStatus to 'up' or 'down' after an ifEntry
// has been initialized, as described in RFC 2863.
//
// Changes in this leaf in the 'running' datastore are
// reflected in ifAdminStatus, but if ifAdminStatus is
// changed over SNMP, this leaf is not affected.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/config/enabled"
func (n *InterfacePath) Enabled() *Interface_EnabledPath {
	return &Interface_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// interface.
//
// Systems that implement the IF-MIB use the value of this
// leaf in the 'running' datastore to set
// IF-MIB.ifAdminStatus to 'up' or 'down' after an ifEntry
// has been initialized, as described in RFC 2863.
//
// Changes in this leaf in the 'running' datastore are
// reflected in ifAdminStatus, but if ifAdminStatus is
// changed over SNMP, this leaf is not affected.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/config/enabled"
func (n *InterfacePathAny) Enabled() *Interface_EnabledPathAny {
	return &Interface_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ethernet (container): Top-level container for ethernet configuration
// and state
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ethernet"
// Path from root: "/interfaces/interface/ethernet"
func (n *InterfacePath) Ethernet() *Interface_EthernetPath {
	return &Interface_EthernetPath{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ethernet (container): Top-level container for ethernet configuration
// and state
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ethernet"
// Path from root: "/interfaces/interface/ethernet"
func (n *InterfacePathAny) Ethernet() *Interface_EthernetPathAny {
	return &Interface_EthernetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet"},
			map[string]interface{}{},
			n,
		),
	}
}

// HardwarePort (leaf): For non-channelized interfaces, references the hardware port
// corresponding to the base interface.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/hardware-port"
// Path from root: "/interfaces/interface/state/hardware-port"
func (n *InterfacePath) HardwarePort() *Interface_HardwarePortPath {
	return &Interface_HardwarePortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hardware-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// HardwarePort (leaf): For non-channelized interfaces, references the hardware port
// corresponding to the base interface.
// ----------------------------------------
// Defining module: "openconfig-platform-port"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/hardware-port"
// Path from root: "/interfaces/interface/state/hardware-port"
func (n *InterfacePathAny) HardwarePort() *Interface_HardwarePortPathAny {
	return &Interface_HardwarePortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hardware-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (container): Top-level container for hold-time settings to enable
// dampening advertisements of interface transitions.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "hold-time"
// Path from root: "/interfaces/interface/hold-time"
func (n *InterfacePath) HoldTime() *Interface_HoldTimePath {
	return &Interface_HoldTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (container): Top-level container for hold-time settings to enable
// dampening advertisements of interface transitions.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "hold-time"
// Path from root: "/interfaces/interface/hold-time"
func (n *InterfacePathAny) HoldTime() *Interface_HoldTimePathAny {
	return &Interface_HoldTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ifindex (leaf): System assigned number for each interface.  Corresponds to
// ifIndex object in SNMP Interface MIB
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/ifindex"
// Path from root: "/interfaces/interface/state/ifindex"
func (n *InterfacePath) Ifindex() *Interface_IfindexPath {
	return &Interface_IfindexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ifindex"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ifindex (leaf): System assigned number for each interface.  Corresponds to
// ifIndex object in SNMP Interface MIB
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/ifindex"
// Path from root: "/interfaces/interface/state/ifindex"
func (n *InterfacePathAny) Ifindex() *Interface_IfindexPathAny {
	return &Interface_IfindexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ifindex"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastChange (leaf): This timestamp indicates the absolute time of the last
// state change of the interface (e.g., up-to-down transition).
// This is different than the SNMP ifLastChange object in the
// standard interface MIB in that it is not relative to the
// system boot time (i.e,. sysUpTime).
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/last-change"
// Path from root: "/interfaces/interface/state/last-change"
func (n *InterfacePath) LastChange() *Interface_LastChangePath {
	return &Interface_LastChangePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastChange (leaf): This timestamp indicates the absolute time of the last
// state change of the interface (e.g., up-to-down transition).
// This is different than the SNMP ifLastChange object in the
// standard interface MIB in that it is not relative to the
// system boot time (i.e,. sysUpTime).
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/last-change"
// Path from root: "/interfaces/interface/state/last-change"
func (n *InterfacePathAny) LastChange() *Interface_LastChangePathAny {
	return &Interface_LastChangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// Logical (leaf): When set to true, the interface is a logical interface
// which does not have an associated physical port or
// channel on the system.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/logical"
// Path from root: "/interfaces/interface/state/logical"
func (n *InterfacePath) Logical() *Interface_LogicalPath {
	return &Interface_LogicalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "logical"},
			map[string]interface{}{},
			n,
		),
	}
}

// Logical (leaf): When set to true, the interface is a logical interface
// which does not have an associated physical port or
// channel on the system.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/logical"
// Path from root: "/interfaces/interface/state/logical"
func (n *InterfacePathAny) Logical() *Interface_LogicalPathAny {
	return &Interface_LogicalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "logical"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoopbackMode (leaf): When set to true, the interface is logically looped back,
// such that packets that are forwarded via the interface
// are received on the same interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/loopback-mode"
// Path from root: "/interfaces/interface/config/loopback-mode"
func (n *InterfacePath) LoopbackMode() *Interface_LoopbackModePath {
	return &Interface_LoopbackModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "loopback-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoopbackMode (leaf): When set to true, the interface is logically looped back,
// such that packets that are forwarded via the interface
// are received on the same interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/loopback-mode"
// Path from root: "/interfaces/interface/config/loopback-mode"
func (n *InterfacePathAny) LoopbackMode() *Interface_LoopbackModePathAny {
	return &Interface_LoopbackModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "loopback-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Management (leaf): When set to true, the interface is a dedicated
// management interface that is not connected to dataplane
// interfaces.  It may be used to connect the system to an
// out-of-band management network, for example.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/management"
// Path from root: "/interfaces/interface/state/management"
func (n *InterfacePath) Management() *Interface_ManagementPath {
	return &Interface_ManagementPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management"},
			map[string]interface{}{},
			n,
		),
	}
}

// Management (leaf): When set to true, the interface is a dedicated
// management interface that is not connected to dataplane
// interfaces.  It may be used to connect the system to an
// out-of-band management network, for example.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/management"
// Path from root: "/interfaces/interface/state/management"
func (n *InterfacePathAny) Management() *Interface_ManagementPathAny {
	return &Interface_ManagementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): Set the max transmission unit size in octets
// for the physical interface.  If this is not set, the mtu is
// set to the operational default -- e.g., 1514 bytes on an
// Ethernet interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/config/mtu"
func (n *InterfacePath) Mtu() *Interface_MtuPath {
	return &Interface_MtuPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): Set the max transmission unit size in octets
// for the physical interface.  If this is not set, the mtu is
// set to the operational default -- e.g., 1514 bytes on an
// Ethernet interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/config/mtu"
func (n *InterfacePathAny) Mtu() *Interface_MtuPathAny {
	return &Interface_MtuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The name of the interface.
//
// A device MAY restrict the allowed values for this leaf,
// possibly depending on the type of the interface.
// For system-controlled interfaces, this leaf is the
// device-specific name of the interface.  The 'config false'
// list interfaces/interface[name]/state contains the currently
// existing interfaces on the device.
//
// If a client tries to create configuration for a
// system-controlled interface that is not present in the
// corresponding state list, the server MAY reject
// the request if the implementation does not support
// pre-provisioning of interfaces or if the name refers to
// an interface that can never exist in the system.  A
// NETCONF server MUST reply with an rpc-error with the
// error-tag 'invalid-value' in this case.
//
// The IETF model in RFC 7223 provides YANG features for the
// following (i.e., pre-provisioning and arbitrary-names),
// however they are omitted here:
//
//  If the device supports pre-provisioning of interface
//  configuration, the 'pre-provisioning' feature is
//  advertised.
//
//  If the device allows arbitrarily named user-controlled
//  interfaces, the 'arbitrary-names' feature is advertised.
//
// When a configured user-controlled interface is created by
// the system, it is instantiated with the same name in the
// /interfaces/interface[name]/state list.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/name"
// Path from root: "/interfaces/interface/config/name"
func (n *InterfacePath) Name() *Interface_NamePath {
	return &Interface_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The name of the interface.
//
// A device MAY restrict the allowed values for this leaf,
// possibly depending on the type of the interface.
// For system-controlled interfaces, this leaf is the
// device-specific name of the interface.  The 'config false'
// list interfaces/interface[name]/state contains the currently
// existing interfaces on the device.
//
// If a client tries to create configuration for a
// system-controlled interface that is not present in the
// corresponding state list, the server MAY reject
// the request if the implementation does not support
// pre-provisioning of interfaces or if the name refers to
// an interface that can never exist in the system.  A
// NETCONF server MUST reply with an rpc-error with the
// error-tag 'invalid-value' in this case.
//
// The IETF model in RFC 7223 provides YANG features for the
// following (i.e., pre-provisioning and arbitrary-names),
// however they are omitted here:
//
//  If the device supports pre-provisioning of interface
//  configuration, the 'pre-provisioning' feature is
//  advertised.
//
//  If the device allows arbitrarily named user-controlled
//  interfaces, the 'arbitrary-names' feature is advertised.
//
// When a configured user-controlled interface is created by
// the system, it is instantiated with the same name in the
// /interfaces/interface[name]/state list.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/name"
// Path from root: "/interfaces/interface/config/name"
func (n *InterfacePathAny) Name() *Interface_NamePathAny {
	return &Interface_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperStatus (leaf): The current operational state of the interface.
//
// This leaf has the same semantics as ifOperStatus.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/oper-status"
// Path from root: "/interfaces/interface/state/oper-status"
func (n *InterfacePath) OperStatus() *Interface_OperStatusPath {
	return &Interface_OperStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperStatus (leaf): The current operational state of the interface.
//
// This leaf has the same semantics as ifOperStatus.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/oper-status"
// Path from root: "/interfaces/interface/state/oper-status"
func (n *InterfacePathAny) OperStatus() *Interface_OperStatusPathAny {
	return &Interface_OperStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// PhysicalChannel (leaf): For a channelized interface, list of references to the
// physical channels (lanes) corresponding to the interface.
// The physical channels are elements of a transceiver component
// in the platform model.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/physical-channel"
// Path from root: "/interfaces/interface/state/physical-channel"
func (n *InterfacePath) PhysicalChannel() *Interface_PhysicalChannelPath {
	return &Interface_PhysicalChannelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "physical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// PhysicalChannel (leaf): For a channelized interface, list of references to the
// physical channels (lanes) corresponding to the interface.
// The physical channels are elements of a transceiver component
// in the platform model.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/physical-channel"
// Path from root: "/interfaces/interface/state/physical-channel"
func (n *InterfacePathAny) PhysicalChannel() *Interface_PhysicalChannelPathAny {
	return &Interface_PhysicalChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "physical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutedVlan (container): Top-level container for routed vlan interfaces.  These
// logical interfaces are also known as SVI (switched virtual
// interface), IRB (integrated routing and bridging), RVI
// (routed VLAN interface)
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "routed-vlan"
// Path from root: "/interfaces/interface/routed-vlan"
func (n *InterfacePath) RoutedVlan() *Interface_RoutedVlanPath {
	return &Interface_RoutedVlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"routed-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutedVlan (container): Top-level container for routed vlan interfaces.  These
// logical interfaces are also known as SVI (switched virtual
// interface), IRB (integrated routing and bridging), RVI
// (routed VLAN interface)
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "routed-vlan"
// Path from root: "/interfaces/interface/routed-vlan"
func (n *InterfacePathAny) RoutedVlan() *Interface_RoutedVlanPathAny {
	return &Interface_RoutedVlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routed-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sonet (container): Data related to SONET/SDH interfaces
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "sonet"
// Path from root: "/interfaces/interface/sonet"
func (n *InterfacePath) Sonet() *Interface_SonetPath {
	return &Interface_SonetPath{
		NodePath: ygot.NewNodePath(
			[]string{"sonet"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sonet (container): Data related to SONET/SDH interfaces
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "sonet"
// Path from root: "/interfaces/interface/sonet"
func (n *InterfacePathAny) Sonet() *Interface_SonetPathAny {
	return &Interface_SonetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sonet"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubinterfaceAny (list): The list of subinterfaces (logical interfaces) associated
// with a physical interface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "subinterfaces/subinterface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface"
// Index (wildcarded): uint32
func (n *InterfacePath) SubinterfaceAny() *Interface_SubinterfacePathAny {
	return &Interface_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subinterfaces", "subinterface"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// SubinterfaceAny (list): The list of subinterfaces (logical interfaces) associated
// with a physical interface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "subinterfaces/subinterface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface"
// Index (wildcarded): uint32
func (n *InterfacePathAny) SubinterfaceAny() *Interface_SubinterfacePathAny {
	return &Interface_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subinterfaces", "subinterface"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// Subinterface (list): The list of subinterfaces (logical interfaces) associated
// with a physical interface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "subinterfaces/subinterface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface"
// Index: uint32
func (n *InterfacePath) Subinterface(Index uint32) *Interface_SubinterfacePath {
	return &Interface_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"subinterfaces", "subinterface"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Subinterface (list): The list of subinterfaces (logical interfaces) associated
// with a physical interface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "subinterfaces/subinterface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface"
// Index: uint32
func (n *InterfacePathAny) Subinterface(Index uint32) *Interface_SubinterfacePathAny {
	return &Interface_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subinterfaces", "subinterface"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Tpid (leaf): Optionally set the tag protocol identifier field (TPID) that
// is accepted on the VLAN
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/tpid"
// Path from root: "/interfaces/interface/config/tpid"
func (n *InterfacePath) Tpid() *Interface_TpidPath {
	return &Interface_TpidPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tpid (leaf): Optionally set the tag protocol identifier field (TPID) that
// is accepted on the VLAN
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/tpid"
// Path from root: "/interfaces/interface/config/tpid"
func (n *InterfacePathAny) Tpid() *Interface_TpidPathAny {
	return &Interface_TpidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transceiver (leaf): Provides a reference to the transceiver subcomponent that
// corresponds to the physical port component for this interface.
// The device must only populate this leaf with a reference to
// a component of type TRANSCEIVER.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/transceiver"
// Path from root: "/interfaces/interface/state/transceiver"
func (n *InterfacePath) Transceiver() *Interface_TransceiverPath {
	return &Interface_TransceiverPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transceiver"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transceiver (leaf): Provides a reference to the transceiver subcomponent that
// corresponds to the physical port component for this interface.
// The device must only populate this leaf with a reference to
// a component of type TRANSCEIVER.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/transceiver"
// Path from root: "/interfaces/interface/state/transceiver"
func (n *InterfacePathAny) Transceiver() *Interface_TransceiverPathAny {
	return &Interface_TransceiverPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transceiver"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the interface.
//
// When an interface entry is created, a server MAY
// initialize the type leaf with a valid value, e.g., if it
// is possible to derive the type from the name of the
// interface.
//
// If a client tries to set the type of an interface to a
// value that can never be used by the system, e.g., if the
// type is not supported or if the type does not match the
// name of the interface, the server MUST reject the request.
// A NETCONF server MUST reply with an rpc-error with the
// error-tag 'invalid-value' in this case.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/type"
// Path from root: "/interfaces/interface/config/type"
func (n *InterfacePath) Type() *Interface_TypePath {
	return &Interface_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the interface.
//
// When an interface entry is created, a server MAY
// initialize the type leaf with a valid value, e.g., if it
// is possible to derive the type from the name of the
// interface.
//
// If a client tries to set the type of an interface to a
// value that can never be used by the system, e.g., if the
// type is not supported or if the type does not match the
// name of the interface, the server MUST reject the request.
// A NETCONF server MUST reply with an rpc-error with the
// error-tag 'invalid-value' in this case.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/type"
// Path from root: "/interfaces/interface/config/type"
func (n *InterfacePathAny) Type() *Interface_TypePathAny {
	return &Interface_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_AggregationPath represents the /openconfig-interfaces/interfaces/interface/aggregation YANG schema element.
type Interface_AggregationPath struct {
	*ygot.NodePath
}

// Interface_AggregationPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation YANG schema element.
type Interface_AggregationPathAny struct {
	*ygot.NodePath
}

// Interface_Aggregation_LagSpeedPath represents the /openconfig-interfaces/interfaces/interface/aggregation/state/lag-speed YANG schema element.
type Interface_Aggregation_LagSpeedPath struct {
	*ygot.NodePath
}

// Interface_Aggregation_LagSpeedPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation/state/lag-speed YANG schema element.
type Interface_Aggregation_LagSpeedPathAny struct {
	*ygot.NodePath
}

// Interface_Aggregation_LagTypePath represents the /openconfig-interfaces/interfaces/interface/aggregation/config/lag-type YANG schema element.
type Interface_Aggregation_LagTypePath struct {
	*ygot.NodePath
}

// Interface_Aggregation_LagTypePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation/config/lag-type YANG schema element.
type Interface_Aggregation_LagTypePathAny struct {
	*ygot.NodePath
}

// Interface_Aggregation_MemberPath represents the /openconfig-interfaces/interfaces/interface/aggregation/state/member YANG schema element.
type Interface_Aggregation_MemberPath struct {
	*ygot.NodePath
}

// Interface_Aggregation_MemberPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation/state/member YANG schema element.
type Interface_Aggregation_MemberPathAny struct {
	*ygot.NodePath
}

// Interface_Aggregation_MinLinksPath represents the /openconfig-interfaces/interfaces/interface/aggregation/config/min-links YANG schema element.
type Interface_Aggregation_MinLinksPath struct {
	*ygot.NodePath
}

// Interface_Aggregation_MinLinksPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation/config/min-links YANG schema element.
type Interface_Aggregation_MinLinksPathAny struct {
	*ygot.NodePath
}

// LagSpeed (leaf): Reports effective speed of the aggregate interface,
// based on speed of active member interfaces
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/lag-speed"
// Path from root: "/interfaces/interface/aggregation/state/lag-speed"
func (n *Interface_AggregationPath) LagSpeed() *Interface_Aggregation_LagSpeedPath {
	return &Interface_Aggregation_LagSpeedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lag-speed"},
			map[string]interface{}{},
			n,
		),
	}
}

// LagSpeed (leaf): Reports effective speed of the aggregate interface,
// based on speed of active member interfaces
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/lag-speed"
// Path from root: "/interfaces/interface/aggregation/state/lag-speed"
func (n *Interface_AggregationPathAny) LagSpeed() *Interface_Aggregation_LagSpeedPathAny {
	return &Interface_Aggregation_LagSpeedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lag-speed"},
			map[string]interface{}{},
			n,
		),
	}
}

// LagType (leaf): Sets the type of LAG, i.e., how it is
// configured / maintained
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/lag-type"
// Path from root: "/interfaces/interface/aggregation/config/lag-type"
func (n *Interface_AggregationPath) LagType() *Interface_Aggregation_LagTypePath {
	return &Interface_Aggregation_LagTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lag-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LagType (leaf): Sets the type of LAG, i.e., how it is
// configured / maintained
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/lag-type"
// Path from root: "/interfaces/interface/aggregation/config/lag-type"
func (n *Interface_AggregationPathAny) LagType() *Interface_Aggregation_LagTypePathAny {
	return &Interface_Aggregation_LagTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lag-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Member (leaf): List of current member interfaces for the aggregate,
// expressed as references to existing interfaces
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/member"
// Path from root: "/interfaces/interface/aggregation/state/member"
func (n *Interface_AggregationPath) Member() *Interface_Aggregation_MemberPath {
	return &Interface_Aggregation_MemberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "member"},
			map[string]interface{}{},
			n,
		),
	}
}

// Member (leaf): List of current member interfaces for the aggregate,
// expressed as references to existing interfaces
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/member"
// Path from root: "/interfaces/interface/aggregation/state/member"
func (n *Interface_AggregationPathAny) Member() *Interface_Aggregation_MemberPathAny {
	return &Interface_Aggregation_MemberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "member"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinLinks (leaf): Specifies the mininum number of member
// interfaces that must be active for the aggregate interface
// to be available
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/min-links"
// Path from root: "/interfaces/interface/aggregation/config/min-links"
func (n *Interface_AggregationPath) MinLinks() *Interface_Aggregation_MinLinksPath {
	return &Interface_Aggregation_MinLinksPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "min-links"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinLinks (leaf): Specifies the mininum number of member
// interfaces that must be active for the aggregate interface
// to be available
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/min-links"
// Path from root: "/interfaces/interface/aggregation/config/min-links"
func (n *Interface_AggregationPathAny) MinLinks() *Interface_Aggregation_MinLinksPathAny {
	return &Interface_Aggregation_MinLinksPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "min-links"},
			map[string]interface{}{},
			n,
		),
	}
}

// SwitchedVlan (container): Enclosing container for VLAN interface-specific
// data on Ethernet interfaces.  These are for standard
// L2, switched-style VLANs.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "switched-vlan"
// Path from root: "/interfaces/interface/aggregation/switched-vlan"
func (n *Interface_AggregationPath) SwitchedVlan() *Interface_Aggregation_SwitchedVlanPath {
	return &Interface_Aggregation_SwitchedVlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"switched-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// SwitchedVlan (container): Enclosing container for VLAN interface-specific
// data on Ethernet interfaces.  These are for standard
// L2, switched-style VLANs.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "switched-vlan"
// Path from root: "/interfaces/interface/aggregation/switched-vlan"
func (n *Interface_AggregationPathAny) SwitchedVlan() *Interface_Aggregation_SwitchedVlanPathAny {
	return &Interface_Aggregation_SwitchedVlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"switched-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Aggregation_SwitchedVlanPath represents the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan YANG schema element.
type Interface_Aggregation_SwitchedVlanPath struct {
	*ygot.NodePath
}

// Interface_Aggregation_SwitchedVlanPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan YANG schema element.
type Interface_Aggregation_SwitchedVlanPathAny struct {
	*ygot.NodePath
}

// Interface_Aggregation_SwitchedVlan_AccessVlanPath represents the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan/config/access-vlan YANG schema element.
type Interface_Aggregation_SwitchedVlan_AccessVlanPath struct {
	*ygot.NodePath
}

// Interface_Aggregation_SwitchedVlan_AccessVlanPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan/config/access-vlan YANG schema element.
type Interface_Aggregation_SwitchedVlan_AccessVlanPathAny struct {
	*ygot.NodePath
}

// Interface_Aggregation_SwitchedVlan_InterfaceModePath represents the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan/config/interface-mode YANG schema element.
type Interface_Aggregation_SwitchedVlan_InterfaceModePath struct {
	*ygot.NodePath
}

// Interface_Aggregation_SwitchedVlan_InterfaceModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan/config/interface-mode YANG schema element.
type Interface_Aggregation_SwitchedVlan_InterfaceModePathAny struct {
	*ygot.NodePath
}

// Interface_Aggregation_SwitchedVlan_NativeVlanPath represents the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan/config/native-vlan YANG schema element.
type Interface_Aggregation_SwitchedVlan_NativeVlanPath struct {
	*ygot.NodePath
}

// Interface_Aggregation_SwitchedVlan_NativeVlanPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan/config/native-vlan YANG schema element.
type Interface_Aggregation_SwitchedVlan_NativeVlanPathAny struct {
	*ygot.NodePath
}

// Interface_Aggregation_SwitchedVlan_TrunkVlansPath represents the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan/config/trunk-vlans YANG schema element.
type Interface_Aggregation_SwitchedVlan_TrunkVlansPath struct {
	*ygot.NodePath
}

// Interface_Aggregation_SwitchedVlan_TrunkVlansPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/aggregation/switched-vlan/config/trunk-vlans YANG schema element.
type Interface_Aggregation_SwitchedVlan_TrunkVlansPathAny struct {
	*ygot.NodePath
}

// AccessVlan (leaf): Assign the access vlan to the access port.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/access-vlan"
// Path from root: "/interfaces/interface/aggregation/switched-vlan/config/access-vlan"
func (n *Interface_Aggregation_SwitchedVlanPath) AccessVlan() *Interface_Aggregation_SwitchedVlan_AccessVlanPath {
	return &Interface_Aggregation_SwitchedVlan_AccessVlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "access-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// AccessVlan (leaf): Assign the access vlan to the access port.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/access-vlan"
// Path from root: "/interfaces/interface/aggregation/switched-vlan/config/access-vlan"
func (n *Interface_Aggregation_SwitchedVlanPathAny) AccessVlan() *Interface_Aggregation_SwitchedVlan_AccessVlanPathAny {
	return &Interface_Aggregation_SwitchedVlan_AccessVlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "access-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceMode (leaf): Set the interface to access or trunk mode for
// VLANs
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface-mode"
// Path from root: "/interfaces/interface/aggregation/switched-vlan/config/interface-mode"
func (n *Interface_Aggregation_SwitchedVlanPath) InterfaceMode() *Interface_Aggregation_SwitchedVlan_InterfaceModePath {
	return &Interface_Aggregation_SwitchedVlan_InterfaceModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceMode (leaf): Set the interface to access or trunk mode for
// VLANs
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface-mode"
// Path from root: "/interfaces/interface/aggregation/switched-vlan/config/interface-mode"
func (n *Interface_Aggregation_SwitchedVlanPathAny) InterfaceMode() *Interface_Aggregation_SwitchedVlan_InterfaceModePathAny {
	return &Interface_Aggregation_SwitchedVlan_InterfaceModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// NativeVlan (leaf): Set the native VLAN id for untagged frames arriving on
// a trunk interface.  Tagged frames sent on an interface
// configured with a native VLAN should have their tags
// stripped prior to transmission. This configuration is only
// valid on a trunk interface.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/native-vlan"
// Path from root: "/interfaces/interface/aggregation/switched-vlan/config/native-vlan"
func (n *Interface_Aggregation_SwitchedVlanPath) NativeVlan() *Interface_Aggregation_SwitchedVlan_NativeVlanPath {
	return &Interface_Aggregation_SwitchedVlan_NativeVlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "native-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// NativeVlan (leaf): Set the native VLAN id for untagged frames arriving on
// a trunk interface.  Tagged frames sent on an interface
// configured with a native VLAN should have their tags
// stripped prior to transmission. This configuration is only
// valid on a trunk interface.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/native-vlan"
// Path from root: "/interfaces/interface/aggregation/switched-vlan/config/native-vlan"
func (n *Interface_Aggregation_SwitchedVlanPathAny) NativeVlan() *Interface_Aggregation_SwitchedVlan_NativeVlanPathAny {
	return &Interface_Aggregation_SwitchedVlan_NativeVlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "native-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrunkVlans (leaf): Specify VLANs, or ranges thereof, that the interface may
// carry when in trunk mode.  If not specified, all VLANs are
// allowed on the interface. Ranges are specified in the form
// x..y, where x<y - ranges are assumed to be inclusive (such
// that the VLAN range is x <= range <= y.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/trunk-vlans"
// Path from root: "/interfaces/interface/aggregation/switched-vlan/config/trunk-vlans"
func (n *Interface_Aggregation_SwitchedVlanPath) TrunkVlans() *Interface_Aggregation_SwitchedVlan_TrunkVlansPath {
	return &Interface_Aggregation_SwitchedVlan_TrunkVlansPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trunk-vlans"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrunkVlans (leaf): Specify VLANs, or ranges thereof, that the interface may
// carry when in trunk mode.  If not specified, all VLANs are
// allowed on the interface. Ranges are specified in the form
// x..y, where x<y - ranges are assumed to be inclusive (such
// that the VLAN range is x <= range <= y.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/trunk-vlans"
// Path from root: "/interfaces/interface/aggregation/switched-vlan/config/trunk-vlans"
func (n *Interface_Aggregation_SwitchedVlanPathAny) TrunkVlans() *Interface_Aggregation_SwitchedVlan_TrunkVlansPathAny {
	return &Interface_Aggregation_SwitchedVlan_TrunkVlansPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trunk-vlans"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_CountersPath represents the /openconfig-interfaces/interfaces/interface/state/counters YANG schema element.
type Interface_CountersPath struct {
	*ygot.NodePath
}

// Interface_CountersPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters YANG schema element.
type Interface_CountersPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_CarrierTransitionsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/carrier-transitions YANG schema element.
type Interface_Counters_CarrierTransitionsPath struct {
	*ygot.NodePath
}

// Interface_Counters_CarrierTransitionsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/carrier-transitions YANG schema element.
type Interface_Counters_CarrierTransitionsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_InBroadcastPktsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/in-broadcast-pkts YANG schema element.
type Interface_Counters_InBroadcastPktsPath struct {
	*ygot.NodePath
}

// Interface_Counters_InBroadcastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/in-broadcast-pkts YANG schema element.
type Interface_Counters_InBroadcastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_InDiscardsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/in-discards YANG schema element.
type Interface_Counters_InDiscardsPath struct {
	*ygot.NodePath
}

// Interface_Counters_InDiscardsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/in-discards YANG schema element.
type Interface_Counters_InDiscardsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_InErrorsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/in-errors YANG schema element.
type Interface_Counters_InErrorsPath struct {
	*ygot.NodePath
}

// Interface_Counters_InErrorsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/in-errors YANG schema element.
type Interface_Counters_InErrorsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_InFcsErrorsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/in-fcs-errors YANG schema element.
type Interface_Counters_InFcsErrorsPath struct {
	*ygot.NodePath
}

// Interface_Counters_InFcsErrorsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/in-fcs-errors YANG schema element.
type Interface_Counters_InFcsErrorsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_InMulticastPktsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/in-multicast-pkts YANG schema element.
type Interface_Counters_InMulticastPktsPath struct {
	*ygot.NodePath
}

// Interface_Counters_InMulticastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/in-multicast-pkts YANG schema element.
type Interface_Counters_InMulticastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_InOctetsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/in-octets YANG schema element.
type Interface_Counters_InOctetsPath struct {
	*ygot.NodePath
}

// Interface_Counters_InOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/in-octets YANG schema element.
type Interface_Counters_InOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_InPktsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/in-pkts YANG schema element.
type Interface_Counters_InPktsPath struct {
	*ygot.NodePath
}

// Interface_Counters_InPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/in-pkts YANG schema element.
type Interface_Counters_InPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_InUnicastPktsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/in-unicast-pkts YANG schema element.
type Interface_Counters_InUnicastPktsPath struct {
	*ygot.NodePath
}

// Interface_Counters_InUnicastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/in-unicast-pkts YANG schema element.
type Interface_Counters_InUnicastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_InUnknownProtosPath represents the /openconfig-interfaces/interfaces/interface/state/counters/in-unknown-protos YANG schema element.
type Interface_Counters_InUnknownProtosPath struct {
	*ygot.NodePath
}

// Interface_Counters_InUnknownProtosPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/in-unknown-protos YANG schema element.
type Interface_Counters_InUnknownProtosPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_LastClearPath represents the /openconfig-interfaces/interfaces/interface/state/counters/last-clear YANG schema element.
type Interface_Counters_LastClearPath struct {
	*ygot.NodePath
}

// Interface_Counters_LastClearPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/last-clear YANG schema element.
type Interface_Counters_LastClearPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_OutBroadcastPktsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/out-broadcast-pkts YANG schema element.
type Interface_Counters_OutBroadcastPktsPath struct {
	*ygot.NodePath
}

// Interface_Counters_OutBroadcastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/out-broadcast-pkts YANG schema element.
type Interface_Counters_OutBroadcastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_OutDiscardsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/out-discards YANG schema element.
type Interface_Counters_OutDiscardsPath struct {
	*ygot.NodePath
}

// Interface_Counters_OutDiscardsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/out-discards YANG schema element.
type Interface_Counters_OutDiscardsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_OutErrorsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/out-errors YANG schema element.
type Interface_Counters_OutErrorsPath struct {
	*ygot.NodePath
}

// Interface_Counters_OutErrorsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/out-errors YANG schema element.
type Interface_Counters_OutErrorsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_OutMulticastPktsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/out-multicast-pkts YANG schema element.
type Interface_Counters_OutMulticastPktsPath struct {
	*ygot.NodePath
}

// Interface_Counters_OutMulticastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/out-multicast-pkts YANG schema element.
type Interface_Counters_OutMulticastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_OutOctetsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/out-octets YANG schema element.
type Interface_Counters_OutOctetsPath struct {
	*ygot.NodePath
}

// Interface_Counters_OutOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/out-octets YANG schema element.
type Interface_Counters_OutOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_OutPktsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/out-pkts YANG schema element.
type Interface_Counters_OutPktsPath struct {
	*ygot.NodePath
}

// Interface_Counters_OutPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/out-pkts YANG schema element.
type Interface_Counters_OutPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Counters_OutUnicastPktsPath represents the /openconfig-interfaces/interfaces/interface/state/counters/out-unicast-pkts YANG schema element.
type Interface_Counters_OutUnicastPktsPath struct {
	*ygot.NodePath
}

// Interface_Counters_OutUnicastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/state/counters/out-unicast-pkts YANG schema element.
type Interface_Counters_OutUnicastPktsPathAny struct {
	*ygot.NodePath
}

// CarrierTransitions (leaf): Number of times the interface state has transitioned
// between up and down since the time the device restarted
// or the last-clear time, whichever is most recent.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "carrier-transitions"
// Path from root: "/interfaces/interface/state/counters/carrier-transitions"
func (n *Interface_CountersPath) CarrierTransitions() *Interface_Counters_CarrierTransitionsPath {
	return &Interface_Counters_CarrierTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"carrier-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// CarrierTransitions (leaf): Number of times the interface state has transitioned
// between up and down since the time the device restarted
// or the last-clear time, whichever is most recent.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "carrier-transitions"
// Path from root: "/interfaces/interface/state/counters/carrier-transitions"
func (n *Interface_CountersPathAny) CarrierTransitions() *Interface_Counters_CarrierTransitionsPathAny {
	return &Interface_Counters_CarrierTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"carrier-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// InBroadcastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were addressed to a broadcast
// address at this sub-layer.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-broadcast-pkts"
// Path from root: "/interfaces/interface/state/counters/in-broadcast-pkts"
func (n *Interface_CountersPath) InBroadcastPkts() *Interface_Counters_InBroadcastPktsPath {
	return &Interface_Counters_InBroadcastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-broadcast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InBroadcastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were addressed to a broadcast
// address at this sub-layer.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-broadcast-pkts"
// Path from root: "/interfaces/interface/state/counters/in-broadcast-pkts"
func (n *Interface_CountersPathAny) InBroadcastPkts() *Interface_Counters_InBroadcastPktsPathAny {
	return &Interface_Counters_InBroadcastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-broadcast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InDiscards (leaf): The number of inbound packets that were chosen to be
// discarded even though no errors had been detected to
// prevent their being deliverable to a higher-layer
// protocol.  One possible reason for discarding such a
// packet could be to free up buffer space.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discards"
// Path from root: "/interfaces/interface/state/counters/in-discards"
func (n *Interface_CountersPath) InDiscards() *Interface_Counters_InDiscardsPath {
	return &Interface_Counters_InDiscardsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-discards"},
			map[string]interface{}{},
			n,
		),
	}
}

// InDiscards (leaf): The number of inbound packets that were chosen to be
// discarded even though no errors had been detected to
// prevent their being deliverable to a higher-layer
// protocol.  One possible reason for discarding such a
// packet could be to free up buffer space.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discards"
// Path from root: "/interfaces/interface/state/counters/in-discards"
func (n *Interface_CountersPathAny) InDiscards() *Interface_Counters_InDiscardsPathAny {
	return &Interface_Counters_InDiscardsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-discards"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrors (leaf): For packet-oriented interfaces, the number of inbound
// packets that contained errors preventing them from being
// deliverable to a higher-layer protocol.  For character-
// oriented or fixed-length interfaces, the number of
// inbound transmission units that contained errors
// preventing them from being deliverable to a higher-layer
// protocol.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-errors"
// Path from root: "/interfaces/interface/state/counters/in-errors"
func (n *Interface_CountersPath) InErrors() *Interface_Counters_InErrorsPath {
	return &Interface_Counters_InErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrors (leaf): For packet-oriented interfaces, the number of inbound
// packets that contained errors preventing them from being
// deliverable to a higher-layer protocol.  For character-
// oriented or fixed-length interfaces, the number of
// inbound transmission units that contained errors
// preventing them from being deliverable to a higher-layer
// protocol.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-errors"
// Path from root: "/interfaces/interface/state/counters/in-errors"
func (n *Interface_CountersPathAny) InErrors() *Interface_Counters_InErrorsPathAny {
	return &Interface_Counters_InErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InFcsErrors (leaf): Number of received packets which had errors in the
// frame check sequence (FCS), i.e., framing errors.
//
// Discontinuities in the value of this counter can occur
// when the device is re-initialization as indicated by the
// value of 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-fcs-errors"
// Path from root: "/interfaces/interface/state/counters/in-fcs-errors"
func (n *Interface_CountersPath) InFcsErrors() *Interface_Counters_InFcsErrorsPath {
	return &Interface_Counters_InFcsErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-fcs-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InFcsErrors (leaf): Number of received packets which had errors in the
// frame check sequence (FCS), i.e., framing errors.
//
// Discontinuities in the value of this counter can occur
// when the device is re-initialization as indicated by the
// value of 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-fcs-errors"
// Path from root: "/interfaces/interface/state/counters/in-fcs-errors"
func (n *Interface_CountersPathAny) InFcsErrors() *Interface_Counters_InFcsErrorsPathAny {
	return &Interface_Counters_InFcsErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-fcs-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMulticastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were addressed to a multicast
// address at this sub-layer.  For a MAC-layer protocol,
// this includes both Group and Functional addresses.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-multicast-pkts"
// Path from root: "/interfaces/interface/state/counters/in-multicast-pkts"
func (n *Interface_CountersPath) InMulticastPkts() *Interface_Counters_InMulticastPktsPath {
	return &Interface_Counters_InMulticastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-multicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMulticastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were addressed to a multicast
// address at this sub-layer.  For a MAC-layer protocol,
// this includes both Group and Functional addresses.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-multicast-pkts"
// Path from root: "/interfaces/interface/state/counters/in-multicast-pkts"
func (n *Interface_CountersPathAny) InMulticastPkts() *Interface_Counters_InMulticastPktsPathAny {
	return &Interface_Counters_InMulticastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-multicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received on the interface,
// including framing characters.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/state/counters/in-octets"
func (n *Interface_CountersPath) InOctets() *Interface_Counters_InOctetsPath {
	return &Interface_Counters_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received on the interface,
// including framing characters.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/state/counters/in-octets"
func (n *Interface_CountersPathAny) InOctets() *Interface_Counters_InOctetsPathAny {
	return &Interface_Counters_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of packets received on the interface,
// including all unicast, multicast, broadcast and bad packets
// etc.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/state/counters/in-pkts"
func (n *Interface_CountersPath) InPkts() *Interface_Counters_InPktsPath {
	return &Interface_Counters_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of packets received on the interface,
// including all unicast, multicast, broadcast and bad packets
// etc.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/state/counters/in-pkts"
func (n *Interface_CountersPathAny) InPkts() *Interface_Counters_InPktsPathAny {
	return &Interface_Counters_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUnicastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were not addressed to a
// multicast or broadcast address at this sub-layer.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-unicast-pkts"
// Path from root: "/interfaces/interface/state/counters/in-unicast-pkts"
func (n *Interface_CountersPath) InUnicastPkts() *Interface_Counters_InUnicastPktsPath {
	return &Interface_Counters_InUnicastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-unicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUnicastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were not addressed to a
// multicast or broadcast address at this sub-layer.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-unicast-pkts"
// Path from root: "/interfaces/interface/state/counters/in-unicast-pkts"
func (n *Interface_CountersPathAny) InUnicastPkts() *Interface_Counters_InUnicastPktsPathAny {
	return &Interface_Counters_InUnicastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-unicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUnknownProtos (leaf): For packet-oriented interfaces, the number of packets
// received via the interface that were discarded because
// of an unknown or unsupported protocol.  For
// character-oriented or fixed-length interfaces that
// support protocol multiplexing, the number of
// transmission units received via the interface that were
// discarded because of an unknown or unsupported protocol.
// For any interface that does not support protocol
// multiplexing, this counter is not present.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-unknown-protos"
// Path from root: "/interfaces/interface/state/counters/in-unknown-protos"
func (n *Interface_CountersPath) InUnknownProtos() *Interface_Counters_InUnknownProtosPath {
	return &Interface_Counters_InUnknownProtosPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-unknown-protos"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUnknownProtos (leaf): For packet-oriented interfaces, the number of packets
// received via the interface that were discarded because
// of an unknown or unsupported protocol.  For
// character-oriented or fixed-length interfaces that
// support protocol multiplexing, the number of
// transmission units received via the interface that were
// discarded because of an unknown or unsupported protocol.
// For any interface that does not support protocol
// multiplexing, this counter is not present.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-unknown-protos"
// Path from root: "/interfaces/interface/state/counters/in-unknown-protos"
func (n *Interface_CountersPathAny) InUnknownProtos() *Interface_Counters_InUnknownProtosPathAny {
	return &Interface_Counters_InUnknownProtosPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-unknown-protos"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Timestamp of the last time the interface counters were
// cleared.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "last-clear"
// Path from root: "/interfaces/interface/state/counters/last-clear"
func (n *Interface_CountersPath) LastClear() *Interface_Counters_LastClearPath {
	return &Interface_Counters_LastClearPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Timestamp of the last time the interface counters were
// cleared.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "last-clear"
// Path from root: "/interfaces/interface/state/counters/last-clear"
func (n *Interface_CountersPathAny) LastClear() *Interface_Counters_LastClearPathAny {
	return &Interface_Counters_LastClearPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutBroadcastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were addressed to a
// broadcast address at this sub-layer, including those
// that were discarded or not sent.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-broadcast-pkts"
// Path from root: "/interfaces/interface/state/counters/out-broadcast-pkts"
func (n *Interface_CountersPath) OutBroadcastPkts() *Interface_Counters_OutBroadcastPktsPath {
	return &Interface_Counters_OutBroadcastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-broadcast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutBroadcastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were addressed to a
// broadcast address at this sub-layer, including those
// that were discarded or not sent.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-broadcast-pkts"
// Path from root: "/interfaces/interface/state/counters/out-broadcast-pkts"
func (n *Interface_CountersPathAny) OutBroadcastPkts() *Interface_Counters_OutBroadcastPktsPathAny {
	return &Interface_Counters_OutBroadcastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-broadcast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscards (leaf): The number of outbound packets that were chosen to be
// discarded even though no errors had been detected to
// prevent their being transmitted.  One possible reason
// for discarding such a packet could be to free up buffer
// space.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discards"
// Path from root: "/interfaces/interface/state/counters/out-discards"
func (n *Interface_CountersPath) OutDiscards() *Interface_Counters_OutDiscardsPath {
	return &Interface_Counters_OutDiscardsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-discards"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscards (leaf): The number of outbound packets that were chosen to be
// discarded even though no errors had been detected to
// prevent their being transmitted.  One possible reason
// for discarding such a packet could be to free up buffer
// space.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discards"
// Path from root: "/interfaces/interface/state/counters/out-discards"
func (n *Interface_CountersPathAny) OutDiscards() *Interface_Counters_OutDiscardsPathAny {
	return &Interface_Counters_OutDiscardsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-discards"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrors (leaf): For packet-oriented interfaces, the number of outbound
// packets that could not be transmitted because of errors.
// For character-oriented or fixed-length interfaces, the
// number of outbound transmission units that could not be
// transmitted because of errors.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-errors"
// Path from root: "/interfaces/interface/state/counters/out-errors"
func (n *Interface_CountersPath) OutErrors() *Interface_Counters_OutErrorsPath {
	return &Interface_Counters_OutErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrors (leaf): For packet-oriented interfaces, the number of outbound
// packets that could not be transmitted because of errors.
// For character-oriented or fixed-length interfaces, the
// number of outbound transmission units that could not be
// transmitted because of errors.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-errors"
// Path from root: "/interfaces/interface/state/counters/out-errors"
func (n *Interface_CountersPathAny) OutErrors() *Interface_Counters_OutErrorsPathAny {
	return &Interface_Counters_OutErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMulticastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were addressed to a
// multicast address at this sub-layer, including those
// that were discarded or not sent.  For a MAC-layer
// protocol, this includes both Group and Functional
// addresses.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-multicast-pkts"
// Path from root: "/interfaces/interface/state/counters/out-multicast-pkts"
func (n *Interface_CountersPath) OutMulticastPkts() *Interface_Counters_OutMulticastPktsPath {
	return &Interface_Counters_OutMulticastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-multicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMulticastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were addressed to a
// multicast address at this sub-layer, including those
// that were discarded or not sent.  For a MAC-layer
// protocol, this includes both Group and Functional
// addresses.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-multicast-pkts"
// Path from root: "/interfaces/interface/state/counters/out-multicast-pkts"
func (n *Interface_CountersPathAny) OutMulticastPkts() *Interface_Counters_OutMulticastPktsPathAny {
	return &Interface_Counters_OutMulticastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-multicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets transmitted out of the
// interface, including framing characters.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/state/counters/out-octets"
func (n *Interface_CountersPath) OutOctets() *Interface_Counters_OutOctetsPath {
	return &Interface_Counters_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets transmitted out of the
// interface, including framing characters.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/state/counters/out-octets"
func (n *Interface_CountersPathAny) OutOctets() *Interface_Counters_OutOctetsPathAny {
	return &Interface_Counters_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of packets transmitted out of the
// interface, including all unicast, multicast, broadcast,
// and bad packets etc.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/state/counters/out-pkts"
func (n *Interface_CountersPath) OutPkts() *Interface_Counters_OutPktsPath {
	return &Interface_Counters_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of packets transmitted out of the
// interface, including all unicast, multicast, broadcast,
// and bad packets etc.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/state/counters/out-pkts"
func (n *Interface_CountersPathAny) OutPkts() *Interface_Counters_OutPktsPathAny {
	return &Interface_Counters_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutUnicastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were not addressed
// to a multicast or broadcast address at this sub-layer,
// including those that were discarded or not sent.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-unicast-pkts"
// Path from root: "/interfaces/interface/state/counters/out-unicast-pkts"
func (n *Interface_CountersPath) OutUnicastPkts() *Interface_Counters_OutUnicastPktsPath {
	return &Interface_Counters_OutUnicastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-unicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutUnicastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were not addressed
// to a multicast or broadcast address at this sub-layer,
// including those that were discarded or not sent.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-unicast-pkts"
// Path from root: "/interfaces/interface/state/counters/out-unicast-pkts"
func (n *Interface_CountersPathAny) OutUnicastPkts() *Interface_Counters_OutUnicastPktsPathAny {
	return &Interface_Counters_OutUnicastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-unicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_EthernetPath represents the /openconfig-interfaces/interfaces/interface/ethernet YANG schema element.
type Interface_EthernetPath struct {
	*ygot.NodePath
}

// Interface_EthernetPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet YANG schema element.
type Interface_EthernetPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_AggregateIdPath represents the /openconfig-interfaces/interfaces/interface/ethernet/config/aggregate-id YANG schema element.
type Interface_Ethernet_AggregateIdPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_AggregateIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/config/aggregate-id YANG schema element.
type Interface_Ethernet_AggregateIdPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_AutoNegotiatePath represents the /openconfig-interfaces/interfaces/interface/ethernet/config/auto-negotiate YANG schema element.
type Interface_Ethernet_AutoNegotiatePath struct {
	*ygot.NodePath
}

// Interface_Ethernet_AutoNegotiatePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/config/auto-negotiate YANG schema element.
type Interface_Ethernet_AutoNegotiatePathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_DuplexModePath represents the /openconfig-interfaces/interfaces/interface/ethernet/config/duplex-mode YANG schema element.
type Interface_Ethernet_DuplexModePath struct {
	*ygot.NodePath
}

// Interface_Ethernet_DuplexModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/config/duplex-mode YANG schema element.
type Interface_Ethernet_DuplexModePathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_EnableFlowControlPath represents the /openconfig-interfaces/interfaces/interface/ethernet/config/enable-flow-control YANG schema element.
type Interface_Ethernet_EnableFlowControlPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_EnableFlowControlPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/config/enable-flow-control YANG schema element.
type Interface_Ethernet_EnableFlowControlPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_FecModePath represents the /openconfig-interfaces/interfaces/interface/ethernet/config/fec-mode YANG schema element.
type Interface_Ethernet_FecModePath struct {
	*ygot.NodePath
}

// Interface_Ethernet_FecModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/config/fec-mode YANG schema element.
type Interface_Ethernet_FecModePathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_HwMacAddressPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/hw-mac-address YANG schema element.
type Interface_Ethernet_HwMacAddressPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_HwMacAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/hw-mac-address YANG schema element.
type Interface_Ethernet_HwMacAddressPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_MacAddressPath represents the /openconfig-interfaces/interfaces/interface/ethernet/config/mac-address YANG schema element.
type Interface_Ethernet_MacAddressPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_MacAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/config/mac-address YANG schema element.
type Interface_Ethernet_MacAddressPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_NegotiatedDuplexModePath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/negotiated-duplex-mode YANG schema element.
type Interface_Ethernet_NegotiatedDuplexModePath struct {
	*ygot.NodePath
}

// Interface_Ethernet_NegotiatedDuplexModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/negotiated-duplex-mode YANG schema element.
type Interface_Ethernet_NegotiatedDuplexModePathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_NegotiatedPortSpeedPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/negotiated-port-speed YANG schema element.
type Interface_Ethernet_NegotiatedPortSpeedPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_NegotiatedPortSpeedPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/negotiated-port-speed YANG schema element.
type Interface_Ethernet_NegotiatedPortSpeedPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_PortSpeedPath represents the /openconfig-interfaces/interfaces/interface/ethernet/config/port-speed YANG schema element.
type Interface_Ethernet_PortSpeedPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_PortSpeedPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/config/port-speed YANG schema element.
type Interface_Ethernet_PortSpeedPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_StandaloneLinkTrainingPath represents the /openconfig-interfaces/interfaces/interface/ethernet/config/standalone-link-training YANG schema element.
type Interface_Ethernet_StandaloneLinkTrainingPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_StandaloneLinkTrainingPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/config/standalone-link-training YANG schema element.
type Interface_Ethernet_StandaloneLinkTrainingPathAny struct {
	*ygot.NodePath
}

// AggregateId (leaf): Specify the logical aggregate interface to which
// this interface belongs
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/aggregate-id"
// Path from root: "/interfaces/interface/ethernet/config/aggregate-id"
func (n *Interface_EthernetPath) AggregateId() *Interface_Ethernet_AggregateIdPath {
	return &Interface_Ethernet_AggregateIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "aggregate-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// AggregateId (leaf): Specify the logical aggregate interface to which
// this interface belongs
// ----------------------------------------
// Defining module: "openconfig-if-aggregate"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/aggregate-id"
// Path from root: "/interfaces/interface/ethernet/config/aggregate-id"
func (n *Interface_EthernetPathAny) AggregateId() *Interface_Ethernet_AggregateIdPathAny {
	return &Interface_Ethernet_AggregateIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "aggregate-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// AutoNegotiate (leaf): Set to TRUE to request the interface to auto-negotiate
// transmission parameters with its peer interface.  When
// set to FALSE, the transmission parameters are specified
// manually.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/auto-negotiate"
// Path from root: "/interfaces/interface/ethernet/config/auto-negotiate"
func (n *Interface_EthernetPath) AutoNegotiate() *Interface_Ethernet_AutoNegotiatePath {
	return &Interface_Ethernet_AutoNegotiatePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auto-negotiate"},
			map[string]interface{}{},
			n,
		),
	}
}

// AutoNegotiate (leaf): Set to TRUE to request the interface to auto-negotiate
// transmission parameters with its peer interface.  When
// set to FALSE, the transmission parameters are specified
// manually.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/auto-negotiate"
// Path from root: "/interfaces/interface/ethernet/config/auto-negotiate"
func (n *Interface_EthernetPathAny) AutoNegotiate() *Interface_Ethernet_AutoNegotiatePathAny {
	return &Interface_Ethernet_AutoNegotiatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auto-negotiate"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Ethernet interface counters
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/ethernet/state/counters"
func (n *Interface_EthernetPath) Counters() *Interface_Ethernet_CountersPath {
	return &Interface_Ethernet_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Ethernet interface counters
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/ethernet/state/counters"
func (n *Interface_EthernetPathAny) Counters() *Interface_Ethernet_CountersPathAny {
	return &Interface_Ethernet_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// DuplexMode (leaf): When auto-negotiate is TRUE, this optionally sets the
// duplex mode that will be advertised to the peer.  If
// unspecified, the interface should negotiate the duplex mode
// directly (typically full-duplex).  When auto-negotiate is
// FALSE, this sets the duplex mode on the interface directly.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/duplex-mode"
// Path from root: "/interfaces/interface/ethernet/config/duplex-mode"
func (n *Interface_EthernetPath) DuplexMode() *Interface_Ethernet_DuplexModePath {
	return &Interface_Ethernet_DuplexModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "duplex-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// DuplexMode (leaf): When auto-negotiate is TRUE, this optionally sets the
// duplex mode that will be advertised to the peer.  If
// unspecified, the interface should negotiate the duplex mode
// directly (typically full-duplex).  When auto-negotiate is
// FALSE, this sets the duplex mode on the interface directly.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/duplex-mode"
// Path from root: "/interfaces/interface/ethernet/config/duplex-mode"
func (n *Interface_EthernetPathAny) DuplexMode() *Interface_Ethernet_DuplexModePathAny {
	return &Interface_Ethernet_DuplexModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "duplex-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableFlowControl (leaf): Enable or disable flow control for this interface.
// Ethernet flow control is a mechanism by which a receiver
// may send PAUSE frames to a sender to stop transmission for
// a specified time.
//
// This setting should override auto-negotiated flow control
// settings.  If left unspecified, and auto-negotiate is TRUE,
// flow control mode is negotiated with the peer interface.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enable-flow-control"
// Path from root: "/interfaces/interface/ethernet/config/enable-flow-control"
func (n *Interface_EthernetPath) EnableFlowControl() *Interface_Ethernet_EnableFlowControlPath {
	return &Interface_Ethernet_EnableFlowControlPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-flow-control"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableFlowControl (leaf): Enable or disable flow control for this interface.
// Ethernet flow control is a mechanism by which a receiver
// may send PAUSE frames to a sender to stop transmission for
// a specified time.
//
// This setting should override auto-negotiated flow control
// settings.  If left unspecified, and auto-negotiate is TRUE,
// flow control mode is negotiated with the peer interface.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enable-flow-control"
// Path from root: "/interfaces/interface/ethernet/config/enable-flow-control"
func (n *Interface_EthernetPathAny) EnableFlowControl() *Interface_Ethernet_EnableFlowControlPathAny {
	return &Interface_Ethernet_EnableFlowControlPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-flow-control"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecMode (leaf): The FEC mode applied to the physical channels associated with
// the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/fec-mode"
// Path from root: "/interfaces/interface/ethernet/config/fec-mode"
func (n *Interface_EthernetPath) FecMode() *Interface_Ethernet_FecModePath {
	return &Interface_Ethernet_FecModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "fec-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecMode (leaf): The FEC mode applied to the physical channels associated with
// the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/fec-mode"
// Path from root: "/interfaces/interface/ethernet/config/fec-mode"
func (n *Interface_EthernetPathAny) FecMode() *Interface_Ethernet_FecModePathAny {
	return &Interface_Ethernet_FecModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "fec-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// HwMacAddress (leaf): Represents the 'burned-in', or system-assigned, MAC
// address for the Ethernet interface.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/hw-mac-address"
// Path from root: "/interfaces/interface/ethernet/state/hw-mac-address"
func (n *Interface_EthernetPath) HwMacAddress() *Interface_Ethernet_HwMacAddressPath {
	return &Interface_Ethernet_HwMacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hw-mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// HwMacAddress (leaf): Represents the 'burned-in', or system-assigned, MAC
// address for the Ethernet interface.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/hw-mac-address"
// Path from root: "/interfaces/interface/ethernet/state/hw-mac-address"
func (n *Interface_EthernetPathAny) HwMacAddress() *Interface_Ethernet_HwMacAddressPathAny {
	return &Interface_Ethernet_HwMacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hw-mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): Assigns a MAC address to the Ethernet interface.  If not
// specified, the corresponding operational state leaf is
// expected to show the system-assigned MAC address.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mac-address"
// Path from root: "/interfaces/interface/ethernet/config/mac-address"
func (n *Interface_EthernetPath) MacAddress() *Interface_Ethernet_MacAddressPath {
	return &Interface_Ethernet_MacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): Assigns a MAC address to the Ethernet interface.  If not
// specified, the corresponding operational state leaf is
// expected to show the system-assigned MAC address.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mac-address"
// Path from root: "/interfaces/interface/ethernet/config/mac-address"
func (n *Interface_EthernetPathAny) MacAddress() *Interface_Ethernet_MacAddressPathAny {
	return &Interface_Ethernet_MacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NegotiatedDuplexMode (leaf): When auto-negotiate is set to TRUE, and the interface has
// completed auto-negotiation with the remote peer, this value
// shows the duplex mode that has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/negotiated-duplex-mode"
// Path from root: "/interfaces/interface/ethernet/state/negotiated-duplex-mode"
func (n *Interface_EthernetPath) NegotiatedDuplexMode() *Interface_Ethernet_NegotiatedDuplexModePath {
	return &Interface_Ethernet_NegotiatedDuplexModePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "negotiated-duplex-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// NegotiatedDuplexMode (leaf): When auto-negotiate is set to TRUE, and the interface has
// completed auto-negotiation with the remote peer, this value
// shows the duplex mode that has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/negotiated-duplex-mode"
// Path from root: "/interfaces/interface/ethernet/state/negotiated-duplex-mode"
func (n *Interface_EthernetPathAny) NegotiatedDuplexMode() *Interface_Ethernet_NegotiatedDuplexModePathAny {
	return &Interface_Ethernet_NegotiatedDuplexModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "negotiated-duplex-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// NegotiatedPortSpeed (leaf): When auto-negotiate is set to TRUE, and the interface has
// completed auto-negotiation with the remote peer, this value
// shows the interface speed that has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/negotiated-port-speed"
// Path from root: "/interfaces/interface/ethernet/state/negotiated-port-speed"
func (n *Interface_EthernetPath) NegotiatedPortSpeed() *Interface_Ethernet_NegotiatedPortSpeedPath {
	return &Interface_Ethernet_NegotiatedPortSpeedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "negotiated-port-speed"},
			map[string]interface{}{},
			n,
		),
	}
}

// NegotiatedPortSpeed (leaf): When auto-negotiate is set to TRUE, and the interface has
// completed auto-negotiation with the remote peer, this value
// shows the interface speed that has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/negotiated-port-speed"
// Path from root: "/interfaces/interface/ethernet/state/negotiated-port-speed"
func (n *Interface_EthernetPathAny) NegotiatedPortSpeed() *Interface_Ethernet_NegotiatedPortSpeedPathAny {
	return &Interface_Ethernet_NegotiatedPortSpeedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "negotiated-port-speed"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortSpeed (leaf): When auto-negotiate is TRUE, this optionally sets the
// port-speed mode that will be advertised to the peer for
// negotiation.  If unspecified, it is expected that the
// interface will select the highest speed available based on
// negotiation.  When auto-negotiate is set to FALSE, sets the
// link speed to a fixed value -- supported values are defined
// by ETHERNET_SPEED identities
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/port-speed"
// Path from root: "/interfaces/interface/ethernet/config/port-speed"
func (n *Interface_EthernetPath) PortSpeed() *Interface_Ethernet_PortSpeedPath {
	return &Interface_Ethernet_PortSpeedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port-speed"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortSpeed (leaf): When auto-negotiate is TRUE, this optionally sets the
// port-speed mode that will be advertised to the peer for
// negotiation.  If unspecified, it is expected that the
// interface will select the highest speed available based on
// negotiation.  When auto-negotiate is set to FALSE, sets the
// link speed to a fixed value -- supported values are defined
// by ETHERNET_SPEED identities
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/port-speed"
// Path from root: "/interfaces/interface/ethernet/config/port-speed"
func (n *Interface_EthernetPathAny) PortSpeed() *Interface_Ethernet_PortSpeedPathAny {
	return &Interface_Ethernet_PortSpeedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port-speed"},
			map[string]interface{}{},
			n,
		),
	}
}

// StandaloneLinkTraining (leaf): Link training is automatic tuning of the SerDes transmit and
// receive parameters to ensure an optimal connection over copper
// links. It is normally run as part of the auto negotiation
// sequence as specified in IEEE 802.3 Clause 73.
//
// Standalone link training is used when full auto negotiation is
// not desired on an Ethernet link but link training is needed.
// It is configured by setting the standalone-link-training leaf
// to TRUE and augo-negotiate leaf to FALSE.
//
// Note: If auto-negotiate is true, then the value of standalone
// link training leaf will be ignored.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/standalone-link-training"
// Path from root: "/interfaces/interface/ethernet/config/standalone-link-training"
func (n *Interface_EthernetPath) StandaloneLinkTraining() *Interface_Ethernet_StandaloneLinkTrainingPath {
	return &Interface_Ethernet_StandaloneLinkTrainingPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "standalone-link-training"},
			map[string]interface{}{},
			n,
		),
	}
}

// StandaloneLinkTraining (leaf): Link training is automatic tuning of the SerDes transmit and
// receive parameters to ensure an optimal connection over copper
// links. It is normally run as part of the auto negotiation
// sequence as specified in IEEE 802.3 Clause 73.
//
// Standalone link training is used when full auto negotiation is
// not desired on an Ethernet link but link training is needed.
// It is configured by setting the standalone-link-training leaf
// to TRUE and augo-negotiate leaf to FALSE.
//
// Note: If auto-negotiate is true, then the value of standalone
// link training leaf will be ignored.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/standalone-link-training"
// Path from root: "/interfaces/interface/ethernet/config/standalone-link-training"
func (n *Interface_EthernetPathAny) StandaloneLinkTraining() *Interface_Ethernet_StandaloneLinkTrainingPathAny {
	return &Interface_Ethernet_StandaloneLinkTrainingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "standalone-link-training"},
			map[string]interface{}{},
			n,
		),
	}
}

// SwitchedVlan (container): Enclosing container for VLAN interface-specific
// data on Ethernet interfaces.  These are for standard
// L2, switched-style VLANs.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "switched-vlan"
// Path from root: "/interfaces/interface/ethernet/switched-vlan"
func (n *Interface_EthernetPath) SwitchedVlan() *Interface_Ethernet_SwitchedVlanPath {
	return &Interface_Ethernet_SwitchedVlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"switched-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// SwitchedVlan (container): Enclosing container for VLAN interface-specific
// data on Ethernet interfaces.  These are for standard
// L2, switched-style VLANs.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "switched-vlan"
// Path from root: "/interfaces/interface/ethernet/switched-vlan"
func (n *Interface_EthernetPathAny) SwitchedVlan() *Interface_Ethernet_SwitchedVlanPathAny {
	return &Interface_Ethernet_SwitchedVlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"switched-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Ethernet_CountersPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters YANG schema element.
type Interface_Ethernet_CountersPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_CountersPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters YANG schema element.
type Interface_Ethernet_CountersPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_In_8021QFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-8021q-frames YANG schema element.
type Interface_Ethernet_Counters_In_8021QFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_In_8021QFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-8021q-frames YANG schema element.
type Interface_Ethernet_Counters_In_8021QFramesPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InBlockErrorsPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-block-errors YANG schema element.
type Interface_Ethernet_Counters_InBlockErrorsPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InBlockErrorsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-block-errors YANG schema element.
type Interface_Ethernet_Counters_InBlockErrorsPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InCarrierErrorsPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-carrier-errors YANG schema element.
type Interface_Ethernet_Counters_InCarrierErrorsPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InCarrierErrorsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-carrier-errors YANG schema element.
type Interface_Ethernet_Counters_InCarrierErrorsPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InCrcErrorsPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-crc-errors YANG schema element.
type Interface_Ethernet_Counters_InCrcErrorsPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InCrcErrorsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-crc-errors YANG schema element.
type Interface_Ethernet_Counters_InCrcErrorsPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InFragmentFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-fragment-frames YANG schema element.
type Interface_Ethernet_Counters_InFragmentFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InFragmentFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-fragment-frames YANG schema element.
type Interface_Ethernet_Counters_InFragmentFramesPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InInterruptedTxPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-interrupted-tx YANG schema element.
type Interface_Ethernet_Counters_InInterruptedTxPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InInterruptedTxPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-interrupted-tx YANG schema element.
type Interface_Ethernet_Counters_InInterruptedTxPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InJabberFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-jabber-frames YANG schema element.
type Interface_Ethernet_Counters_InJabberFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InJabberFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-jabber-frames YANG schema element.
type Interface_Ethernet_Counters_InJabberFramesPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InLateCollisionPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-late-collision YANG schema element.
type Interface_Ethernet_Counters_InLateCollisionPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InLateCollisionPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-late-collision YANG schema element.
type Interface_Ethernet_Counters_InLateCollisionPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InMacControlFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-mac-control-frames YANG schema element.
type Interface_Ethernet_Counters_InMacControlFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InMacControlFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-mac-control-frames YANG schema element.
type Interface_Ethernet_Counters_InMacControlFramesPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InMacErrorsRxPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-mac-errors-rx YANG schema element.
type Interface_Ethernet_Counters_InMacErrorsRxPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InMacErrorsRxPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-mac-errors-rx YANG schema element.
type Interface_Ethernet_Counters_InMacErrorsRxPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InMacPauseFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-mac-pause-frames YANG schema element.
type Interface_Ethernet_Counters_InMacPauseFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InMacPauseFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-mac-pause-frames YANG schema element.
type Interface_Ethernet_Counters_InMacPauseFramesPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InMaxsizeExceededPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-maxsize-exceeded YANG schema element.
type Interface_Ethernet_Counters_InMaxsizeExceededPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InMaxsizeExceededPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-maxsize-exceeded YANG schema element.
type Interface_Ethernet_Counters_InMaxsizeExceededPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InOversizeFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-oversize-frames YANG schema element.
type Interface_Ethernet_Counters_InOversizeFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InOversizeFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-oversize-frames YANG schema element.
type Interface_Ethernet_Counters_InOversizeFramesPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InSingleCollisionPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-single-collision YANG schema element.
type Interface_Ethernet_Counters_InSingleCollisionPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InSingleCollisionPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-single-collision YANG schema element.
type Interface_Ethernet_Counters_InSingleCollisionPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InSymbolErrorPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-symbol-error YANG schema element.
type Interface_Ethernet_Counters_InSymbolErrorPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InSymbolErrorPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-symbol-error YANG schema element.
type Interface_Ethernet_Counters_InSymbolErrorPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InUndersizeFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-undersize-frames YANG schema element.
type Interface_Ethernet_Counters_InUndersizeFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_InUndersizeFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/in-undersize-frames YANG schema element.
type Interface_Ethernet_Counters_InUndersizeFramesPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_Out_8021QFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/out-8021q-frames YANG schema element.
type Interface_Ethernet_Counters_Out_8021QFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_Out_8021QFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/out-8021q-frames YANG schema element.
type Interface_Ethernet_Counters_Out_8021QFramesPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_OutMacControlFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/out-mac-control-frames YANG schema element.
type Interface_Ethernet_Counters_OutMacControlFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_OutMacControlFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/out-mac-control-frames YANG schema element.
type Interface_Ethernet_Counters_OutMacControlFramesPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_OutMacErrorsTxPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/out-mac-errors-tx YANG schema element.
type Interface_Ethernet_Counters_OutMacErrorsTxPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_OutMacErrorsTxPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/out-mac-errors-tx YANG schema element.
type Interface_Ethernet_Counters_OutMacErrorsTxPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_OutMacPauseFramesPath represents the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/out-mac-pause-frames YANG schema element.
type Interface_Ethernet_Counters_OutMacPauseFramesPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_Counters_OutMacPauseFramesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/state/counters/out-mac-pause-frames YANG schema element.
type Interface_Ethernet_Counters_OutMacPauseFramesPathAny struct {
	*ygot.NodePath
}

// In_8021QFrames (leaf): Number of 802.1q tagged frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-8021q-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-8021q-frames"
func (n *Interface_Ethernet_CountersPath) In_8021QFrames() *Interface_Ethernet_Counters_In_8021QFramesPath {
	return &Interface_Ethernet_Counters_In_8021QFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-8021q-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// In_8021QFrames (leaf): Number of 802.1q tagged frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-8021q-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-8021q-frames"
func (n *Interface_Ethernet_CountersPathAny) In_8021QFrames() *Interface_Ethernet_Counters_In_8021QFramesPathAny {
	return &Interface_Ethernet_Counters_In_8021QFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-8021q-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InBlockErrors (leaf): The number of received errored blocks. Error detection codes
// are capable of detecting whether one or more errors have
// occurred in a given sequence of bits – the block. It is
// normally not possible to determine the exact number of errored
// bits within the block
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-block-errors"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-block-errors"
func (n *Interface_Ethernet_CountersPath) InBlockErrors() *Interface_Ethernet_Counters_InBlockErrorsPath {
	return &Interface_Ethernet_Counters_InBlockErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-block-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InBlockErrors (leaf): The number of received errored blocks. Error detection codes
// are capable of detecting whether one or more errors have
// occurred in a given sequence of bits – the block. It is
// normally not possible to determine the exact number of errored
// bits within the block
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-block-errors"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-block-errors"
func (n *Interface_Ethernet_CountersPathAny) InBlockErrors() *Interface_Ethernet_Counters_InBlockErrorsPathAny {
	return &Interface_Ethernet_Counters_InBlockErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-block-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InCarrierErrors (leaf): The number of received errored frames due to a carrier issue.
// The value refers to MIB counter for
// dot3StatsCarrierSenseErrors
// oid=1.3.6.1.2.1.10.7.2.1.11
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-carrier-errors"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-carrier-errors"
func (n *Interface_Ethernet_CountersPath) InCarrierErrors() *Interface_Ethernet_Counters_InCarrierErrorsPath {
	return &Interface_Ethernet_Counters_InCarrierErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-carrier-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InCarrierErrors (leaf): The number of received errored frames due to a carrier issue.
// The value refers to MIB counter for
// dot3StatsCarrierSenseErrors
// oid=1.3.6.1.2.1.10.7.2.1.11
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-carrier-errors"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-carrier-errors"
func (n *Interface_Ethernet_CountersPathAny) InCarrierErrors() *Interface_Ethernet_Counters_InCarrierErrorsPathAny {
	return &Interface_Ethernet_Counters_InCarrierErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-carrier-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InCrcErrors (leaf): The total number of frames received that
// had a length (excluding framing bits, but
// including FCS octets) of between 64 and 1518
// octets, inclusive, but had either a bad
// Frame Check Sequence (FCS) with an integral
// number of octets (FCS Error) or a bad FCS with
// a non-integral number of octets (Alignment Error)
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-crc-errors"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-crc-errors"
func (n *Interface_Ethernet_CountersPath) InCrcErrors() *Interface_Ethernet_Counters_InCrcErrorsPath {
	return &Interface_Ethernet_Counters_InCrcErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-crc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InCrcErrors (leaf): The total number of frames received that
// had a length (excluding framing bits, but
// including FCS octets) of between 64 and 1518
// octets, inclusive, but had either a bad
// Frame Check Sequence (FCS) with an integral
// number of octets (FCS Error) or a bad FCS with
// a non-integral number of octets (Alignment Error)
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-crc-errors"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-crc-errors"
func (n *Interface_Ethernet_CountersPathAny) InCrcErrors() *Interface_Ethernet_Counters_InCrcErrorsPathAny {
	return &Interface_Ethernet_Counters_InCrcErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-crc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InFragmentFrames (leaf): The total number of frames received that were less than
// 64 octets in length (excluding framing bits but including
// FCS octets) and had either a bad Frame Check Sequence
// (FCS) with an integral number of octets (FCS Error) or a
// bad FCS with a non-integral number of octets (Alignment
// Error).
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-fragment-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-fragment-frames"
func (n *Interface_Ethernet_CountersPath) InFragmentFrames() *Interface_Ethernet_Counters_InFragmentFramesPath {
	return &Interface_Ethernet_Counters_InFragmentFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-fragment-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InFragmentFrames (leaf): The total number of frames received that were less than
// 64 octets in length (excluding framing bits but including
// FCS octets) and had either a bad Frame Check Sequence
// (FCS) with an integral number of octets (FCS Error) or a
// bad FCS with a non-integral number of octets (Alignment
// Error).
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-fragment-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-fragment-frames"
func (n *Interface_Ethernet_CountersPathAny) InFragmentFrames() *Interface_Ethernet_Counters_InFragmentFramesPathAny {
	return &Interface_Ethernet_Counters_InFragmentFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-fragment-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InInterruptedTx (leaf): The number of received errored frames due to interrupted
// transmission issue. The value refers to MIB counter for
// dot3StatsDeferredTransmissions
// oid=1.3.6.1.2.1.10.7.2.1.7
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-interrupted-tx"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-interrupted-tx"
func (n *Interface_Ethernet_CountersPath) InInterruptedTx() *Interface_Ethernet_Counters_InInterruptedTxPath {
	return &Interface_Ethernet_Counters_InInterruptedTxPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-interrupted-tx"},
			map[string]interface{}{},
			n,
		),
	}
}

// InInterruptedTx (leaf): The number of received errored frames due to interrupted
// transmission issue. The value refers to MIB counter for
// dot3StatsDeferredTransmissions
// oid=1.3.6.1.2.1.10.7.2.1.7
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-interrupted-tx"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-interrupted-tx"
func (n *Interface_Ethernet_CountersPathAny) InInterruptedTx() *Interface_Ethernet_Counters_InInterruptedTxPathAny {
	return &Interface_Ethernet_Counters_InInterruptedTxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-interrupted-tx"},
			map[string]interface{}{},
			n,
		),
	}
}

// InJabberFrames (leaf): Number of jabber frames received on the
// interface.  Jabber frames are typically defined as oversize
// frames which also have a bad CRC.  Implementations may use
// slightly different definitions of what constitutes a jabber
// frame.  Often indicative of a NIC hardware problem.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-jabber-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-jabber-frames"
func (n *Interface_Ethernet_CountersPath) InJabberFrames() *Interface_Ethernet_Counters_InJabberFramesPath {
	return &Interface_Ethernet_Counters_InJabberFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-jabber-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InJabberFrames (leaf): Number of jabber frames received on the
// interface.  Jabber frames are typically defined as oversize
// frames which also have a bad CRC.  Implementations may use
// slightly different definitions of what constitutes a jabber
// frame.  Often indicative of a NIC hardware problem.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-jabber-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-jabber-frames"
func (n *Interface_Ethernet_CountersPathAny) InJabberFrames() *Interface_Ethernet_Counters_InJabberFramesPathAny {
	return &Interface_Ethernet_Counters_InJabberFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-jabber-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InLateCollision (leaf): The number of received errored frames due to late collision
// issue. The value refers to MIB counter for
// dot3StatsLateCollisions
// oid=1.3.6.1.2.1.10.7.2.1.8
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-late-collision"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-late-collision"
func (n *Interface_Ethernet_CountersPath) InLateCollision() *Interface_Ethernet_Counters_InLateCollisionPath {
	return &Interface_Ethernet_Counters_InLateCollisionPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-late-collision"},
			map[string]interface{}{},
			n,
		),
	}
}

// InLateCollision (leaf): The number of received errored frames due to late collision
// issue. The value refers to MIB counter for
// dot3StatsLateCollisions
// oid=1.3.6.1.2.1.10.7.2.1.8
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-late-collision"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-late-collision"
func (n *Interface_Ethernet_CountersPathAny) InLateCollision() *Interface_Ethernet_Counters_InLateCollisionPathAny {
	return &Interface_Ethernet_Counters_InLateCollisionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-late-collision"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacControlFrames (leaf): MAC layer control frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-mac-control-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-mac-control-frames"
func (n *Interface_Ethernet_CountersPath) InMacControlFrames() *Interface_Ethernet_Counters_InMacControlFramesPath {
	return &Interface_Ethernet_Counters_InMacControlFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-mac-control-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacControlFrames (leaf): MAC layer control frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-mac-control-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-mac-control-frames"
func (n *Interface_Ethernet_CountersPathAny) InMacControlFrames() *Interface_Ethernet_Counters_InMacControlFramesPathAny {
	return &Interface_Ethernet_Counters_InMacControlFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-mac-control-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacErrorsRx (leaf): The number of received errored frames due to MAC errors
// received. The value refers to MIB counter for
// dot3StatsInternalMacReceiveErrors
// oid=1.3.6.1.2.1.10.7.2.1.16
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-mac-errors-rx"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-mac-errors-rx"
func (n *Interface_Ethernet_CountersPath) InMacErrorsRx() *Interface_Ethernet_Counters_InMacErrorsRxPath {
	return &Interface_Ethernet_Counters_InMacErrorsRxPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-mac-errors-rx"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacErrorsRx (leaf): The number of received errored frames due to MAC errors
// received. The value refers to MIB counter for
// dot3StatsInternalMacReceiveErrors
// oid=1.3.6.1.2.1.10.7.2.1.16
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-mac-errors-rx"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-mac-errors-rx"
func (n *Interface_Ethernet_CountersPathAny) InMacErrorsRx() *Interface_Ethernet_Counters_InMacErrorsRxPathAny {
	return &Interface_Ethernet_Counters_InMacErrorsRxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-mac-errors-rx"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacPauseFrames (leaf): MAC layer PAUSE frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-mac-pause-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-mac-pause-frames"
func (n *Interface_Ethernet_CountersPath) InMacPauseFrames() *Interface_Ethernet_Counters_InMacPauseFramesPath {
	return &Interface_Ethernet_Counters_InMacPauseFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-mac-pause-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacPauseFrames (leaf): MAC layer PAUSE frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-mac-pause-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-mac-pause-frames"
func (n *Interface_Ethernet_CountersPathAny) InMacPauseFrames() *Interface_Ethernet_Counters_InMacPauseFramesPathAny {
	return &Interface_Ethernet_Counters_InMacPauseFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-mac-pause-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMaxsizeExceeded (leaf): The total number frames received that are well-formed but
// dropped due to exceeding the maximum frame size on the interface
// (e.g., MTU or MRU)
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-maxsize-exceeded"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-maxsize-exceeded"
func (n *Interface_Ethernet_CountersPath) InMaxsizeExceeded() *Interface_Ethernet_Counters_InMaxsizeExceededPath {
	return &Interface_Ethernet_Counters_InMaxsizeExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-maxsize-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMaxsizeExceeded (leaf): The total number frames received that are well-formed but
// dropped due to exceeding the maximum frame size on the interface
// (e.g., MTU or MRU)
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-maxsize-exceeded"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-maxsize-exceeded"
func (n *Interface_Ethernet_CountersPathAny) InMaxsizeExceeded() *Interface_Ethernet_Counters_InMaxsizeExceededPathAny {
	return &Interface_Ethernet_Counters_InMaxsizeExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-maxsize-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOversizeFrames (leaf): The total number of frames received that were
// longer than 1518 octets (excluding framing bits,
// but including FCS octets) and were otherwise
// well formed.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-oversize-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-oversize-frames"
func (n *Interface_Ethernet_CountersPath) InOversizeFrames() *Interface_Ethernet_Counters_InOversizeFramesPath {
	return &Interface_Ethernet_Counters_InOversizeFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-oversize-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOversizeFrames (leaf): The total number of frames received that were
// longer than 1518 octets (excluding framing bits,
// but including FCS octets) and were otherwise
// well formed.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-oversize-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-oversize-frames"
func (n *Interface_Ethernet_CountersPathAny) InOversizeFrames() *Interface_Ethernet_Counters_InOversizeFramesPathAny {
	return &Interface_Ethernet_Counters_InOversizeFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-oversize-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSingleCollision (leaf): The number of received errored frames due to single collision
// issue. The value refers to MIB counter for
// dot3StatsSingleCollisionFrames
// oid=1.3.6.1.2.1.10.7.2.1.4
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-single-collision"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-single-collision"
func (n *Interface_Ethernet_CountersPath) InSingleCollision() *Interface_Ethernet_Counters_InSingleCollisionPath {
	return &Interface_Ethernet_Counters_InSingleCollisionPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-single-collision"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSingleCollision (leaf): The number of received errored frames due to single collision
// issue. The value refers to MIB counter for
// dot3StatsSingleCollisionFrames
// oid=1.3.6.1.2.1.10.7.2.1.4
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-single-collision"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-single-collision"
func (n *Interface_Ethernet_CountersPathAny) InSingleCollision() *Interface_Ethernet_Counters_InSingleCollisionPathAny {
	return &Interface_Ethernet_Counters_InSingleCollisionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-single-collision"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSymbolError (leaf): The number of received errored frames due to symbol error.
// The value refers to MIB counter for
// in-symbol-error
// oid=1.3.6.1.2.1.10.7.2.1.18
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-symbol-error"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-symbol-error"
func (n *Interface_Ethernet_CountersPath) InSymbolError() *Interface_Ethernet_Counters_InSymbolErrorPath {
	return &Interface_Ethernet_Counters_InSymbolErrorPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-symbol-error"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSymbolError (leaf): The number of received errored frames due to symbol error.
// The value refers to MIB counter for
// in-symbol-error
// oid=1.3.6.1.2.1.10.7.2.1.18
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-symbol-error"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-symbol-error"
func (n *Interface_Ethernet_CountersPathAny) InSymbolError() *Interface_Ethernet_Counters_InSymbolErrorPathAny {
	return &Interface_Ethernet_Counters_InSymbolErrorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-symbol-error"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUndersizeFrames (leaf): The total number of frames received that were
// less than 64 octets long (excluding framing bits,
// but including FCS octets) and were otherwise well
// formed.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-undersize-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-undersize-frames"
func (n *Interface_Ethernet_CountersPath) InUndersizeFrames() *Interface_Ethernet_Counters_InUndersizeFramesPath {
	return &Interface_Ethernet_Counters_InUndersizeFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-undersize-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUndersizeFrames (leaf): The total number of frames received that were
// less than 64 octets long (excluding framing bits,
// but including FCS octets) and were otherwise well
// formed.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-undersize-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/in-undersize-frames"
func (n *Interface_Ethernet_CountersPathAny) InUndersizeFrames() *Interface_Ethernet_Counters_InUndersizeFramesPathAny {
	return &Interface_Ethernet_Counters_InUndersizeFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-undersize-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// Out_8021QFrames (leaf): Number of 802.1q tagged frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-8021q-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/out-8021q-frames"
func (n *Interface_Ethernet_CountersPath) Out_8021QFrames() *Interface_Ethernet_Counters_Out_8021QFramesPath {
	return &Interface_Ethernet_Counters_Out_8021QFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-8021q-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// Out_8021QFrames (leaf): Number of 802.1q tagged frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-8021q-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/out-8021q-frames"
func (n *Interface_Ethernet_CountersPathAny) Out_8021QFrames() *Interface_Ethernet_Counters_Out_8021QFramesPathAny {
	return &Interface_Ethernet_Counters_Out_8021QFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-8021q-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacControlFrames (leaf): MAC layer control frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-mac-control-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/out-mac-control-frames"
func (n *Interface_Ethernet_CountersPath) OutMacControlFrames() *Interface_Ethernet_Counters_OutMacControlFramesPath {
	return &Interface_Ethernet_Counters_OutMacControlFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-mac-control-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacControlFrames (leaf): MAC layer control frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-mac-control-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/out-mac-control-frames"
func (n *Interface_Ethernet_CountersPathAny) OutMacControlFrames() *Interface_Ethernet_Counters_OutMacControlFramesPathAny {
	return &Interface_Ethernet_Counters_OutMacControlFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-mac-control-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacErrorsTx (leaf): The number of sent errored frames due to MAC errors
// transmitted. The value refers to MIB counter for
// dot3StatsInternalMacTransmitErrors
// oid=1.3.6.1.2.1.10.7.2.1.10
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-mac-errors-tx"
// Path from root: "/interfaces/interface/ethernet/state/counters/out-mac-errors-tx"
func (n *Interface_Ethernet_CountersPath) OutMacErrorsTx() *Interface_Ethernet_Counters_OutMacErrorsTxPath {
	return &Interface_Ethernet_Counters_OutMacErrorsTxPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-mac-errors-tx"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacErrorsTx (leaf): The number of sent errored frames due to MAC errors
// transmitted. The value refers to MIB counter for
// dot3StatsInternalMacTransmitErrors
// oid=1.3.6.1.2.1.10.7.2.1.10
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-mac-errors-tx"
// Path from root: "/interfaces/interface/ethernet/state/counters/out-mac-errors-tx"
func (n *Interface_Ethernet_CountersPathAny) OutMacErrorsTx() *Interface_Ethernet_Counters_OutMacErrorsTxPathAny {
	return &Interface_Ethernet_Counters_OutMacErrorsTxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-mac-errors-tx"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacPauseFrames (leaf): MAC layer PAUSE frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-mac-pause-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/out-mac-pause-frames"
func (n *Interface_Ethernet_CountersPath) OutMacPauseFrames() *Interface_Ethernet_Counters_OutMacPauseFramesPath {
	return &Interface_Ethernet_Counters_OutMacPauseFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-mac-pause-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacPauseFrames (leaf): MAC layer PAUSE frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-mac-pause-frames"
// Path from root: "/interfaces/interface/ethernet/state/counters/out-mac-pause-frames"
func (n *Interface_Ethernet_CountersPathAny) OutMacPauseFrames() *Interface_Ethernet_Counters_OutMacPauseFramesPathAny {
	return &Interface_Ethernet_Counters_OutMacPauseFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-mac-pause-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Ethernet_SwitchedVlanPath represents the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan YANG schema element.
type Interface_Ethernet_SwitchedVlanPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_SwitchedVlanPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan YANG schema element.
type Interface_Ethernet_SwitchedVlanPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_SwitchedVlan_AccessVlanPath represents the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan/config/access-vlan YANG schema element.
type Interface_Ethernet_SwitchedVlan_AccessVlanPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_SwitchedVlan_AccessVlanPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan/config/access-vlan YANG schema element.
type Interface_Ethernet_SwitchedVlan_AccessVlanPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_SwitchedVlan_InterfaceModePath represents the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan/config/interface-mode YANG schema element.
type Interface_Ethernet_SwitchedVlan_InterfaceModePath struct {
	*ygot.NodePath
}

// Interface_Ethernet_SwitchedVlan_InterfaceModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan/config/interface-mode YANG schema element.
type Interface_Ethernet_SwitchedVlan_InterfaceModePathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_SwitchedVlan_NativeVlanPath represents the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan/config/native-vlan YANG schema element.
type Interface_Ethernet_SwitchedVlan_NativeVlanPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_SwitchedVlan_NativeVlanPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan/config/native-vlan YANG schema element.
type Interface_Ethernet_SwitchedVlan_NativeVlanPathAny struct {
	*ygot.NodePath
}

// Interface_Ethernet_SwitchedVlan_TrunkVlansPath represents the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan/config/trunk-vlans YANG schema element.
type Interface_Ethernet_SwitchedVlan_TrunkVlansPath struct {
	*ygot.NodePath
}

// Interface_Ethernet_SwitchedVlan_TrunkVlansPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/ethernet/switched-vlan/config/trunk-vlans YANG schema element.
type Interface_Ethernet_SwitchedVlan_TrunkVlansPathAny struct {
	*ygot.NodePath
}

// AccessVlan (leaf): Assign the access vlan to the access port.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/access-vlan"
// Path from root: "/interfaces/interface/ethernet/switched-vlan/config/access-vlan"
func (n *Interface_Ethernet_SwitchedVlanPath) AccessVlan() *Interface_Ethernet_SwitchedVlan_AccessVlanPath {
	return &Interface_Ethernet_SwitchedVlan_AccessVlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "access-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// AccessVlan (leaf): Assign the access vlan to the access port.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/access-vlan"
// Path from root: "/interfaces/interface/ethernet/switched-vlan/config/access-vlan"
func (n *Interface_Ethernet_SwitchedVlanPathAny) AccessVlan() *Interface_Ethernet_SwitchedVlan_AccessVlanPathAny {
	return &Interface_Ethernet_SwitchedVlan_AccessVlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "access-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceMode (leaf): Set the interface to access or trunk mode for
// VLANs
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface-mode"
// Path from root: "/interfaces/interface/ethernet/switched-vlan/config/interface-mode"
func (n *Interface_Ethernet_SwitchedVlanPath) InterfaceMode() *Interface_Ethernet_SwitchedVlan_InterfaceModePath {
	return &Interface_Ethernet_SwitchedVlan_InterfaceModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceMode (leaf): Set the interface to access or trunk mode for
// VLANs
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface-mode"
// Path from root: "/interfaces/interface/ethernet/switched-vlan/config/interface-mode"
func (n *Interface_Ethernet_SwitchedVlanPathAny) InterfaceMode() *Interface_Ethernet_SwitchedVlan_InterfaceModePathAny {
	return &Interface_Ethernet_SwitchedVlan_InterfaceModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// NativeVlan (leaf): Set the native VLAN id for untagged frames arriving on
// a trunk interface.  Tagged frames sent on an interface
// configured with a native VLAN should have their tags
// stripped prior to transmission. This configuration is only
// valid on a trunk interface.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/native-vlan"
// Path from root: "/interfaces/interface/ethernet/switched-vlan/config/native-vlan"
func (n *Interface_Ethernet_SwitchedVlanPath) NativeVlan() *Interface_Ethernet_SwitchedVlan_NativeVlanPath {
	return &Interface_Ethernet_SwitchedVlan_NativeVlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "native-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// NativeVlan (leaf): Set the native VLAN id for untagged frames arriving on
// a trunk interface.  Tagged frames sent on an interface
// configured with a native VLAN should have their tags
// stripped prior to transmission. This configuration is only
// valid on a trunk interface.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/native-vlan"
// Path from root: "/interfaces/interface/ethernet/switched-vlan/config/native-vlan"
func (n *Interface_Ethernet_SwitchedVlanPathAny) NativeVlan() *Interface_Ethernet_SwitchedVlan_NativeVlanPathAny {
	return &Interface_Ethernet_SwitchedVlan_NativeVlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "native-vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrunkVlans (leaf): Specify VLANs, or ranges thereof, that the interface may
// carry when in trunk mode.  If not specified, all VLANs are
// allowed on the interface. Ranges are specified in the form
// x..y, where x<y - ranges are assumed to be inclusive (such
// that the VLAN range is x <= range <= y.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/trunk-vlans"
// Path from root: "/interfaces/interface/ethernet/switched-vlan/config/trunk-vlans"
func (n *Interface_Ethernet_SwitchedVlanPath) TrunkVlans() *Interface_Ethernet_SwitchedVlan_TrunkVlansPath {
	return &Interface_Ethernet_SwitchedVlan_TrunkVlansPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trunk-vlans"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrunkVlans (leaf): Specify VLANs, or ranges thereof, that the interface may
// carry when in trunk mode.  If not specified, all VLANs are
// allowed on the interface. Ranges are specified in the form
// x..y, where x<y - ranges are assumed to be inclusive (such
// that the VLAN range is x <= range <= y.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/trunk-vlans"
// Path from root: "/interfaces/interface/ethernet/switched-vlan/config/trunk-vlans"
func (n *Interface_Ethernet_SwitchedVlanPathAny) TrunkVlans() *Interface_Ethernet_SwitchedVlan_TrunkVlansPathAny {
	return &Interface_Ethernet_SwitchedVlan_TrunkVlansPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trunk-vlans"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_HoldTimePath represents the /openconfig-interfaces/interfaces/interface/hold-time YANG schema element.
type Interface_HoldTimePath struct {
	*ygot.NodePath
}

// Interface_HoldTimePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/hold-time YANG schema element.
type Interface_HoldTimePathAny struct {
	*ygot.NodePath
}

// Interface_HoldTime_DownPath represents the /openconfig-interfaces/interfaces/interface/hold-time/config/down YANG schema element.
type Interface_HoldTime_DownPath struct {
	*ygot.NodePath
}

// Interface_HoldTime_DownPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/hold-time/config/down YANG schema element.
type Interface_HoldTime_DownPathAny struct {
	*ygot.NodePath
}

// Interface_HoldTime_UpPath represents the /openconfig-interfaces/interfaces/interface/hold-time/config/up YANG schema element.
type Interface_HoldTime_UpPath struct {
	*ygot.NodePath
}

// Interface_HoldTime_UpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/hold-time/config/up YANG schema element.
type Interface_HoldTime_UpPathAny struct {
	*ygot.NodePath
}

// Down (leaf): Dampens advertisement when the interface transitions from
// up to down.  A zero value means dampening is turned off,
// i.e., immediate notification.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/down"
// Path from root: "/interfaces/interface/hold-time/config/down"
func (n *Interface_HoldTimePath) Down() *Interface_HoldTime_DownPath {
	return &Interface_HoldTime_DownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "down"},
			map[string]interface{}{},
			n,
		),
	}
}

// Down (leaf): Dampens advertisement when the interface transitions from
// up to down.  A zero value means dampening is turned off,
// i.e., immediate notification.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/down"
// Path from root: "/interfaces/interface/hold-time/config/down"
func (n *Interface_HoldTimePathAny) Down() *Interface_HoldTime_DownPathAny {
	return &Interface_HoldTime_DownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "down"},
			map[string]interface{}{},
			n,
		),
	}
}

// Up (leaf): Dampens advertisement when the interface
// transitions from down to up.  A zero value means dampening
// is turned off, i.e., immediate notification.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/up"
// Path from root: "/interfaces/interface/hold-time/config/up"
func (n *Interface_HoldTimePath) Up() *Interface_HoldTime_UpPath {
	return &Interface_HoldTime_UpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "up"},
			map[string]interface{}{},
			n,
		),
	}
}

// Up (leaf): Dampens advertisement when the interface
// transitions from down to up.  A zero value means dampening
// is turned off, i.e., immediate notification.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/up"
// Path from root: "/interfaces/interface/hold-time/config/up"
func (n *Interface_HoldTimePathAny) Up() *Interface_HoldTime_UpPathAny {
	return &Interface_HoldTime_UpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "up"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlanPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan YANG schema element.
type Interface_RoutedVlanPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlanPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan YANG schema element.
type Interface_RoutedVlanPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_VlanPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/config/vlan YANG schema element.
type Interface_RoutedVlan_VlanPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_VlanPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/config/vlan YANG schema element.
type Interface_RoutedVlan_VlanPathAny struct {
	*ygot.NodePath
}

// Ipv4 (container): Parameters for the IPv4 address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ipv4"
// Path from root: "/interfaces/interface/routed-vlan/ipv4"
func (n *Interface_RoutedVlanPath) Ipv4() *Interface_RoutedVlan_Ipv4Path {
	return &Interface_RoutedVlan_Ipv4Path{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4 (container): Parameters for the IPv4 address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ipv4"
// Path from root: "/interfaces/interface/routed-vlan/ipv4"
func (n *Interface_RoutedVlanPathAny) Ipv4() *Interface_RoutedVlan_Ipv4PathAny {
	return &Interface_RoutedVlan_Ipv4PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6 (container): Parameters for the IPv6 address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ipv6"
// Path from root: "/interfaces/interface/routed-vlan/ipv6"
func (n *Interface_RoutedVlanPath) Ipv6() *Interface_RoutedVlan_Ipv6Path {
	return &Interface_RoutedVlan_Ipv6Path{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6 (container): Parameters for the IPv6 address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ipv6"
// Path from root: "/interfaces/interface/routed-vlan/ipv6"
func (n *Interface_RoutedVlanPathAny) Ipv6() *Interface_RoutedVlan_Ipv6PathAny {
	return &Interface_RoutedVlan_Ipv6PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (leaf): References the VLAN for which this IP interface
// provides routing services -- similar to a switch virtual
// interface (SVI), or integrated routing and bridging interface
// (IRB) in some implementations.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan"
// Path from root: "/interfaces/interface/routed-vlan/config/vlan"
func (n *Interface_RoutedVlanPath) Vlan() *Interface_RoutedVlan_VlanPath {
	return &Interface_RoutedVlan_VlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (leaf): References the VLAN for which this IP interface
// provides routing services -- similar to a switch virtual
// interface (SVI), or integrated routing and bridging interface
// (IRB) in some implementations.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan"
// Path from root: "/interfaces/interface/routed-vlan/config/vlan"
func (n *Interface_RoutedVlanPathAny) Vlan() *Interface_RoutedVlan_VlanPathAny {
	return &Interface_RoutedVlan_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv4Path represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4 YANG schema element.
type Interface_RoutedVlan_Ipv4Path struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4PathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4 YANG schema element.
type Interface_RoutedVlan_Ipv4PathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_DhcpClientPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/config/dhcp-client YANG schema element.
type Interface_RoutedVlan_Ipv4_DhcpClientPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_DhcpClientPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/config/dhcp-client YANG schema element.
type Interface_RoutedVlan_Ipv4_DhcpClientPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_EnabledPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/config/enabled YANG schema element.
type Interface_RoutedVlan_Ipv4_EnabledPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/config/enabled YANG schema element.
type Interface_RoutedVlan_Ipv4_EnabledPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_MtuPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/config/mtu YANG schema element.
type Interface_RoutedVlan_Ipv4_MtuPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_MtuPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/config/mtu YANG schema element.
type Interface_RoutedVlan_Ipv4_MtuPathAny struct {
	*ygot.NodePath
}

// AddressAny (list): The list of configured IPv4 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address"
// Ip (wildcarded): string
func (n *Interface_RoutedVlan_Ipv4Path) AddressAny() *Interface_RoutedVlan_Ipv4_AddressPathAny {
	return &Interface_RoutedVlan_Ipv4_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// AddressAny (list): The list of configured IPv4 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address"
// Ip (wildcarded): string
func (n *Interface_RoutedVlan_Ipv4PathAny) AddressAny() *Interface_RoutedVlan_Ipv4_AddressPathAny {
	return &Interface_RoutedVlan_Ipv4_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// Address (list): The list of configured IPv4 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address"
// Ip: string
func (n *Interface_RoutedVlan_Ipv4Path) Address(Ip string) *Interface_RoutedVlan_Ipv4_AddressPath {
	return &Interface_RoutedVlan_Ipv4_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Address (list): The list of configured IPv4 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address"
// Ip: string
func (n *Interface_RoutedVlan_Ipv4PathAny) Address(Ip string) *Interface_RoutedVlan_Ipv4_AddressPathAny {
	return &Interface_RoutedVlan_Ipv4_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Counters (container): Packet and byte counters for IP transmission and
// reception for the address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters"
func (n *Interface_RoutedVlan_Ipv4Path) Counters() *Interface_RoutedVlan_Ipv4_CountersPath {
	return &Interface_RoutedVlan_Ipv4_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Packet and byte counters for IP transmission and
// reception for the address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters"
func (n *Interface_RoutedVlan_Ipv4PathAny) Counters() *Interface_RoutedVlan_Ipv4_CountersPathAny {
	return &Interface_RoutedVlan_Ipv4_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpClient (leaf): Enables a DHCP client on the interface in order to request
// an address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dhcp-client"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/config/dhcp-client"
func (n *Interface_RoutedVlan_Ipv4Path) DhcpClient() *Interface_RoutedVlan_Ipv4_DhcpClientPath {
	return &Interface_RoutedVlan_Ipv4_DhcpClientPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dhcp-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpClient (leaf): Enables a DHCP client on the interface in order to request
// an address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dhcp-client"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/config/dhcp-client"
func (n *Interface_RoutedVlan_Ipv4PathAny) DhcpClient() *Interface_RoutedVlan_Ipv4_DhcpClientPathAny {
	return &Interface_RoutedVlan_Ipv4_DhcpClientPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dhcp-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Controls whether IPv4 is enabled or disabled on this
// interface.  When IPv4 is enabled, this interface is
// connected to an IPv4 stack, and the interface can send
// and receive IPv4 packets.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/config/enabled"
func (n *Interface_RoutedVlan_Ipv4Path) Enabled() *Interface_RoutedVlan_Ipv4_EnabledPath {
	return &Interface_RoutedVlan_Ipv4_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Controls whether IPv4 is enabled or disabled on this
// interface.  When IPv4 is enabled, this interface is
// connected to an IPv4 stack, and the interface can send
// and receive IPv4 packets.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/config/enabled"
func (n *Interface_RoutedVlan_Ipv4PathAny) Enabled() *Interface_RoutedVlan_Ipv4_EnabledPathAny {
	return &Interface_RoutedVlan_Ipv4_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The size, in octets, of the largest IPv4 packet that the
// interface will send and receive.
//
// The server may restrict the allowed values for this leaf,
// depending on the interface's type.
//
// If this leaf is not configured, the operationally used MTU
// depends on the interface's type.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/config/mtu"
func (n *Interface_RoutedVlan_Ipv4Path) Mtu() *Interface_RoutedVlan_Ipv4_MtuPath {
	return &Interface_RoutedVlan_Ipv4_MtuPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The size, in octets, of the largest IPv4 packet that the
// interface will send and receive.
//
// The server may restrict the allowed values for this leaf,
// depending on the interface's type.
//
// If this leaf is not configured, the operationally used MTU
// depends on the interface's type.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/config/mtu"
func (n *Interface_RoutedVlan_Ipv4PathAny) Mtu() *Interface_RoutedVlan_Ipv4_MtuPathAny {
	return &Interface_RoutedVlan_Ipv4_MtuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): A list of mappings from IPv4 addresses to
// link-layer addresses.
//
// Entries in this list are used as static entries in the
// ARP Cache.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor"
// Ip (wildcarded): string
func (n *Interface_RoutedVlan_Ipv4Path) NeighborAny() *Interface_RoutedVlan_Ipv4_NeighborPathAny {
	return &Interface_RoutedVlan_Ipv4_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// NeighborAny (list): A list of mappings from IPv4 addresses to
// link-layer addresses.
//
// Entries in this list are used as static entries in the
// ARP Cache.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor"
// Ip (wildcarded): string
func (n *Interface_RoutedVlan_Ipv4PathAny) NeighborAny() *Interface_RoutedVlan_Ipv4_NeighborPathAny {
	return &Interface_RoutedVlan_Ipv4_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// Neighbor (list): A list of mappings from IPv4 addresses to
// link-layer addresses.
//
// Entries in this list are used as static entries in the
// ARP Cache.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor"
// Ip: string
func (n *Interface_RoutedVlan_Ipv4Path) Neighbor(Ip string) *Interface_RoutedVlan_Ipv4_NeighborPath {
	return &Interface_RoutedVlan_Ipv4_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Neighbor (list): A list of mappings from IPv4 addresses to
// link-layer addresses.
//
// Entries in this list are used as static entries in the
// ARP Cache.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor"
// Ip: string
func (n *Interface_RoutedVlan_Ipv4PathAny) Neighbor(Ip string) *Interface_RoutedVlan_Ipv4_NeighborPathAny {
	return &Interface_RoutedVlan_Ipv4_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// ProxyArp (container): Configuration and operational state parameters
// relating to proxy ARP. This functionality allows a
// system to respond to ARP requests that are not
// explicitly destined to the local system.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "proxy-arp"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/proxy-arp"
func (n *Interface_RoutedVlan_Ipv4Path) ProxyArp() *Interface_RoutedVlan_Ipv4_ProxyArpPath {
	return &Interface_RoutedVlan_Ipv4_ProxyArpPath{
		NodePath: ygot.NewNodePath(
			[]string{"proxy-arp"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProxyArp (container): Configuration and operational state parameters
// relating to proxy ARP. This functionality allows a
// system to respond to ARP requests that are not
// explicitly destined to the local system.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "proxy-arp"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/proxy-arp"
func (n *Interface_RoutedVlan_Ipv4PathAny) ProxyArp() *Interface_RoutedVlan_Ipv4_ProxyArpPathAny {
	return &Interface_RoutedVlan_Ipv4_ProxyArpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"proxy-arp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unnumbered (container): Top-level container for setting unnumbered interfaces.
// Includes reference the interface that provides the
// address information
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "unnumbered"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered"
func (n *Interface_RoutedVlan_Ipv4Path) Unnumbered() *Interface_RoutedVlan_Ipv4_UnnumberedPath {
	return &Interface_RoutedVlan_Ipv4_UnnumberedPath{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unnumbered (container): Top-level container for setting unnumbered interfaces.
// Includes reference the interface that provides the
// address information
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "unnumbered"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered"
func (n *Interface_RoutedVlan_Ipv4PathAny) Unnumbered() *Interface_RoutedVlan_Ipv4_UnnumberedPathAny {
	return &Interface_RoutedVlan_Ipv4_UnnumberedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv4_AddressPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address YANG schema element.
type Interface_RoutedVlan_Ipv4_AddressPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_AddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address YANG schema element.
type Interface_RoutedVlan_Ipv4_AddressPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_IpPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/config/ip YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_IpPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_IpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/config/ip YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_IpPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_OriginPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/state/origin YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_OriginPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_OriginPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/state/origin YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_OriginPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_PrefixLengthPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/config/prefix-length YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_PrefixLengthPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_PrefixLengthPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/config/prefix-length YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_PrefixLengthPathAny struct {
	*ygot.NodePath
}

// Ip (leaf): The IPv4 address on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/config/ip"
func (n *Interface_RoutedVlan_Ipv4_AddressPath) Ip() *Interface_RoutedVlan_Ipv4_Address_IpPath {
	return &Interface_RoutedVlan_Ipv4_Address_IpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ip (leaf): The IPv4 address on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/config/ip"
func (n *Interface_RoutedVlan_Ipv4_AddressPathAny) Ip() *Interface_RoutedVlan_Ipv4_Address_IpPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_IpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this address, e.g., statically configured,
// assigned by DHCP, etc..
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/state/origin"
func (n *Interface_RoutedVlan_Ipv4_AddressPath) Origin() *Interface_RoutedVlan_Ipv4_Address_OriginPath {
	return &Interface_RoutedVlan_Ipv4_Address_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this address, e.g., statically configured,
// assigned by DHCP, etc..
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/state/origin"
func (n *Interface_RoutedVlan_Ipv4_AddressPathAny) Origin() *Interface_RoutedVlan_Ipv4_Address_OriginPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the subnet prefix.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/prefix-length"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/config/prefix-length"
func (n *Interface_RoutedVlan_Ipv4_AddressPath) PrefixLength() *Interface_RoutedVlan_Ipv4_Address_PrefixLengthPath {
	return &Interface_RoutedVlan_Ipv4_Address_PrefixLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the subnet prefix.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/prefix-length"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/config/prefix-length"
func (n *Interface_RoutedVlan_Ipv4_AddressPathAny) PrefixLength() *Interface_RoutedVlan_Ipv4_Address_PrefixLengthPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_PrefixLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// VrrpGroupAny (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group"
// VirtualRouterId (wildcarded): uint8
func (n *Interface_RoutedVlan_Ipv4_AddressPath) VrrpGroupAny() *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": "*"},
			n,
		),
	}
}

// VrrpGroupAny (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group"
// VirtualRouterId (wildcarded): uint8
func (n *Interface_RoutedVlan_Ipv4_AddressPathAny) VrrpGroupAny() *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": "*"},
			n,
		),
	}
}

// VrrpGroup (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group"
// VirtualRouterId: uint8
func (n *Interface_RoutedVlan_Ipv4_AddressPath) VrrpGroup(VirtualRouterId uint8) *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": VirtualRouterId},
			n,
		),
	}
}

// VrrpGroup (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group"
// VirtualRouterId: uint8
func (n *Interface_RoutedVlan_Ipv4_AddressPathAny) VrrpGroup(VirtualRouterId uint8) *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": VirtualRouterId},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AcceptModePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/accept-mode YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AcceptModePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AcceptModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/accept-mode YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AcceptModePathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AdvertisementIntervalPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/advertisement-interval YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AdvertisementIntervalPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AdvertisementIntervalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/advertisement-interval YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AdvertisementIntervalPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_CurrentPriorityPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/state/current-priority YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_CurrentPriorityPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_CurrentPriorityPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/state/current-priority YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_CurrentPriorityPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/preempt YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/preempt YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptDelayPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/preempt-delay YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptDelayPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptDelayPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/preempt-delay YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptDelayPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PriorityPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/priority YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PriorityPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PriorityPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/priority YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PriorityPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualAddressPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-address YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualAddressPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-address YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualAddressPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualRouterIdPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-router-id YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualRouterIdPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualRouterIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-router-id YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualRouterIdPathAny struct {
	*ygot.NodePath
}

// AcceptMode (leaf): Configure whether packets destined for
// virtual addresses are accepted even when the virtual
// address is not owned by the router interface
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/accept-mode"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/accept-mode"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath) AcceptMode() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AcceptModePath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AcceptModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accept-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AcceptMode (leaf): Configure whether packets destined for
// virtual addresses are accepted even when the virtual
// address is not owned by the router interface
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/accept-mode"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/accept-mode"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny) AcceptMode() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AcceptModePathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AcceptModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accept-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisementInterval (leaf): Sets the interval between successive VRRP
// advertisements -- RFC 5798 defines this as a 12-bit
// value expressed as 0.1 seconds, with default 100, i.e.,
// 1 second.  Several implementation express this in units of
// seconds
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/advertisement-interval"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/advertisement-interval"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath) AdvertisementInterval() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AdvertisementIntervalPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AdvertisementIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisementInterval (leaf): Sets the interval between successive VRRP
// advertisements -- RFC 5798 defines this as a 12-bit
// value expressed as 0.1 seconds, with default 100, i.e.,
// 1 second.  Several implementation express this in units of
// seconds
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/advertisement-interval"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/advertisement-interval"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny) AdvertisementInterval() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AdvertisementIntervalPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_AdvertisementIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPriority (leaf): Operational value of the priority for the
// interface in the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/current-priority"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/state/current-priority"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath) CurrentPriority() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_CurrentPriorityPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_CurrentPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPriority (leaf): Operational value of the priority for the
// interface in the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/current-priority"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/state/current-priority"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny) CurrentPriority() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_CurrentPriorityPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_CurrentPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceTracking (container): Top-level container for VRRP interface tracking
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-tracking"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath) InterfaceTracking() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-tracking"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceTracking (container): Top-level container for VRRP interface tracking
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-tracking"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny) InterfaceTracking() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-tracking"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preempt (leaf): When set to true, enables preemption by a higher
// priority backup router of a lower priority master router
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/preempt"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath) Preempt() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preempt (leaf): When set to true, enables preemption by a higher
// priority backup router of a lower priority master router
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/preempt"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny) Preempt() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreemptDelay (leaf): Set the delay the higher priority router waits
// before preempting
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt-delay"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/preempt-delay"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath) PreemptDelay() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptDelayPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreemptDelay (leaf): Set the delay the higher priority router waits
// before preempting
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt-delay"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/preempt-delay"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny) PreemptDelay() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptDelayPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PreemptDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Specifies the sending VRRP interface's priority
// for the virtual router.  Higher values equal higher
// priority
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/priority"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath) Priority() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PriorityPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Specifies the sending VRRP interface's priority
// for the virtual router.  Higher values equal higher
// priority
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/priority"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny) Priority() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PriorityPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualAddress (leaf): Configure one or more virtual addresses for the
// VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-address"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-address"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath) VirtualAddress() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualAddressPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualAddress (leaf): Configure one or more virtual addresses for the
// VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-address"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-address"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny) VirtualAddress() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualAddressPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualRouterId (leaf): Set the virtual router id for use by the VRRP group.  This
// usually also determines the virtual MAC address that is
// generated for the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-router-id"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-router-id"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPath) VirtualRouterId() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualRouterIdPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualRouterId (leaf): Set the virtual router id for use by the VRRP group.  This
// usually also determines the virtual MAC address that is
// generated for the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-router-id"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-router-id"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroupPathAny) VirtualRouterId() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualRouterIdPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_VirtualRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface YANG schema element.
type Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny struct {
	*ygot.NodePath
}

// PriorityDecrement (leaf): Set the value to subtract from priority when
// the tracked interface goes down
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority-decrement"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPath) PriorityDecrement() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority-decrement"},
			map[string]interface{}{},
			n,
		),
	}
}

// PriorityDecrement (leaf): Set the value to subtract from priority when
// the tracked interface goes down
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority-decrement"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny) PriorityDecrement() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority-decrement"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrackInterface (leaf): Sets a list of one or more interfaces that should
// be tracked for up/down events to dynamically change the
// priority state of the VRRP group, and potentially
// change the mastership if the tracked interface going
// down lowers the priority sufficiently.  Any of the tracked
// interfaces going down will cause the priority to be lowered.
// Some implementations may only support a single
// tracked interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/track-interface"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPath) TrackInterface() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "track-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrackInterface (leaf): Sets a list of one or more interfaces that should
// be tracked for up/down events to dynamically change the
// priority state of the VRRP group, and potentially
// change the mastership if the tracked interface going
// down lowers the priority sufficiently.  Any of the tracked
// interfaces going down will cause the priority to be lowered.
// Some implementations may only support a single
// tracked interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/track-interface"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface"
func (n *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny) TrackInterface() *Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny {
	return &Interface_RoutedVlan_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "track-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv4_CountersPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters YANG schema element.
type Interface_RoutedVlan_Ipv4_CountersPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_CountersPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters YANG schema element.
type Interface_RoutedVlan_Ipv4_CountersPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InDiscardedPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-discarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InDiscardedPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InDiscardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-discarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InDiscardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InErrorPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-error-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InErrorPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InErrorPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-error-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InErrorPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InForwardedOctetsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-forwarded-octets YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InForwardedOctetsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InForwardedOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-forwarded-octets YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InForwardedOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InForwardedPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-forwarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InForwardedPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InForwardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-forwarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InForwardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InOctetsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-octets YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InOctetsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-octets YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_InPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/in-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_InPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutDiscardedPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-discarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutDiscardedPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutDiscardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-discarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutDiscardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutErrorPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-error-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutErrorPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutErrorPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-error-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutErrorPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutForwardedOctetsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-forwarded-octets YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutForwardedOctetsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutForwardedOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-forwarded-octets YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutForwardedOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutForwardedPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-forwarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutForwardedPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutForwardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-forwarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutForwardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutOctetsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-octets YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutOctetsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-octets YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Counters_OutPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/state/counters/out-pkts YANG schema element.
type Interface_RoutedVlan_Ipv4_Counters_OutPktsPathAny struct {
	*ygot.NodePath
}

// InDiscardedPkts (leaf): The number of input IP packets for the
// specified address family, for which no problems were
// encountered to prevent their continued processing, but
// were discarded (e.g., for lack of buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-discarded-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) InDiscardedPkts() *Interface_RoutedVlan_Ipv4_Counters_InDiscardedPktsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_InDiscardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InDiscardedPkts (leaf): The number of input IP packets for the
// specified address family, for which no problems were
// encountered to prevent their continued processing, but
// were discarded (e.g., for lack of buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-discarded-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) InDiscardedPkts() *Interface_RoutedVlan_Ipv4_Counters_InDiscardedPktsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_InDiscardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrorPkts (leaf): Number of IP packets discarded due to errors for the
// specified address family, including errors in the IP
// header, no route found to the IP destination, invalid
// address, unknown protocol, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-error-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-error-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) InErrorPkts() *Interface_RoutedVlan_Ipv4_Counters_InErrorPktsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_InErrorPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrorPkts (leaf): Number of IP packets discarded due to errors for the
// specified address family, including errors in the IP
// header, no route found to the IP destination, invalid
// address, unknown protocol, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-error-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-error-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) InErrorPkts() *Interface_RoutedVlan_Ipv4_Counters_InErrorPktsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_InErrorPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedOctets (leaf): The number of octets received in input IP packets
// for the specified address family for which the device was
// not their final IP destination and for which the
// device attempted to find a route to forward them to that
// final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-forwarded-octets"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) InForwardedOctets() *Interface_RoutedVlan_Ipv4_Counters_InForwardedOctetsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_InForwardedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedOctets (leaf): The number of octets received in input IP packets
// for the specified address family for which the device was
// not their final IP destination and for which the
// device attempted to find a route to forward them to that
// final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-forwarded-octets"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) InForwardedOctets() *Interface_RoutedVlan_Ipv4_Counters_InForwardedOctetsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_InForwardedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedPkts (leaf): The number of input packets for which the device was not
// their final IP destination and for which the device
// attempted to find a route to forward them to that final
// destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-forwarded-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) InForwardedPkts() *Interface_RoutedVlan_Ipv4_Counters_InForwardedPktsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_InForwardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedPkts (leaf): The number of input packets for which the device was not
// their final IP destination and for which the device
// attempted to find a route to forward them to that final
// destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-forwarded-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) InForwardedPkts() *Interface_RoutedVlan_Ipv4_Counters_InForwardedPktsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_InForwardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received in input IP packets
// for the specified address family, including those received
// in error.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-octets"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) InOctets() *Interface_RoutedVlan_Ipv4_Counters_InOctetsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received in input IP packets
// for the specified address family, including those received
// in error.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-octets"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) InOctets() *Interface_RoutedVlan_Ipv4_Counters_InOctetsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of IP packets received for the specified
// address family, including those received in error
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) InPkts() *Interface_RoutedVlan_Ipv4_Counters_InPktsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of IP packets received for the specified
// address family, including those received in error
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/in-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) InPkts() *Interface_RoutedVlan_Ipv4_Counters_InPktsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscardedPkts (leaf): The number of output IP packets for the
// specified address family for which no problem was
// encountered to prevent their transmission to their
// destination, but were discarded (e.g., for lack of
// buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-discarded-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) OutDiscardedPkts() *Interface_RoutedVlan_Ipv4_Counters_OutDiscardedPktsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_OutDiscardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscardedPkts (leaf): The number of output IP packets for the
// specified address family for which no problem was
// encountered to prevent their transmission to their
// destination, but were discarded (e.g., for lack of
// buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-discarded-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) OutDiscardedPkts() *Interface_RoutedVlan_Ipv4_Counters_OutDiscardedPktsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_OutDiscardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrorPkts (leaf): Number of IP packets for the specified address family
// locally generated and discarded due to errors, including
// no route found to the IP destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-error-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-error-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) OutErrorPkts() *Interface_RoutedVlan_Ipv4_Counters_OutErrorPktsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_OutErrorPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrorPkts (leaf): Number of IP packets for the specified address family
// locally generated and discarded due to errors, including
// no route found to the IP destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-error-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-error-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) OutErrorPkts() *Interface_RoutedVlan_Ipv4_Counters_OutErrorPktsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_OutErrorPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedOctets (leaf): The number of octets in packets for which this entity was
// not their final IP destination and for which it was
// successful in finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-forwarded-octets"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) OutForwardedOctets() *Interface_RoutedVlan_Ipv4_Counters_OutForwardedOctetsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_OutForwardedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedOctets (leaf): The number of octets in packets for which this entity was
// not their final IP destination and for which it was
// successful in finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-forwarded-octets"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) OutForwardedOctets() *Interface_RoutedVlan_Ipv4_Counters_OutForwardedOctetsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_OutForwardedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedPkts (leaf): The number of packets for which this entity was not their
// final IP destination and for which it was successful in
// finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-forwarded-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) OutForwardedPkts() *Interface_RoutedVlan_Ipv4_Counters_OutForwardedPktsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_OutForwardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedPkts (leaf): The number of packets for which this entity was not their
// final IP destination and for which it was successful in
// finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-forwarded-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) OutForwardedPkts() *Interface_RoutedVlan_Ipv4_Counters_OutForwardedPktsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_OutForwardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets in IP packets for the
// specified address family that the device
// supplied to the lower layers for transmission.  This
// includes packets generated locally and those forwarded by
// the device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-octets"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) OutOctets() *Interface_RoutedVlan_Ipv4_Counters_OutOctetsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets in IP packets for the
// specified address family that the device
// supplied to the lower layers for transmission.  This
// includes packets generated locally and those forwarded by
// the device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-octets"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) OutOctets() *Interface_RoutedVlan_Ipv4_Counters_OutOctetsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of IP packets for the
// specified address family that the device supplied
// to the lower layers for transmission.  This includes
// packets generated locally and those forwarded by the
// device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPath) OutPkts() *Interface_RoutedVlan_Ipv4_Counters_OutPktsPath {
	return &Interface_RoutedVlan_Ipv4_Counters_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of IP packets for the
// specified address family that the device supplied
// to the lower layers for transmission.  This includes
// packets generated locally and those forwarded by the
// device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/state/counters/out-pkts"
func (n *Interface_RoutedVlan_Ipv4_CountersPathAny) OutPkts() *Interface_RoutedVlan_Ipv4_Counters_OutPktsPathAny {
	return &Interface_RoutedVlan_Ipv4_Counters_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv4_NeighborPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor YANG schema element.
type Interface_RoutedVlan_Ipv4_NeighborPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_NeighborPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor YANG schema element.
type Interface_RoutedVlan_Ipv4_NeighborPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Neighbor_IpPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/config/ip YANG schema element.
type Interface_RoutedVlan_Ipv4_Neighbor_IpPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Neighbor_IpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/config/ip YANG schema element.
type Interface_RoutedVlan_Ipv4_Neighbor_IpPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Neighbor_LinkLayerAddressPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/config/link-layer-address YANG schema element.
type Interface_RoutedVlan_Ipv4_Neighbor_LinkLayerAddressPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Neighbor_LinkLayerAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/config/link-layer-address YANG schema element.
type Interface_RoutedVlan_Ipv4_Neighbor_LinkLayerAddressPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Neighbor_OriginPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/state/origin YANG schema element.
type Interface_RoutedVlan_Ipv4_Neighbor_OriginPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Neighbor_OriginPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/state/origin YANG schema element.
type Interface_RoutedVlan_Ipv4_Neighbor_OriginPathAny struct {
	*ygot.NodePath
}

// Ip (leaf): The IPv4 address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/config/ip"
func (n *Interface_RoutedVlan_Ipv4_NeighborPath) Ip() *Interface_RoutedVlan_Ipv4_Neighbor_IpPath {
	return &Interface_RoutedVlan_Ipv4_Neighbor_IpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ip (leaf): The IPv4 address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/config/ip"
func (n *Interface_RoutedVlan_Ipv4_NeighborPathAny) Ip() *Interface_RoutedVlan_Ipv4_Neighbor_IpPathAny {
	return &Interface_RoutedVlan_Ipv4_Neighbor_IpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLayerAddress (leaf): The link-layer address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/link-layer-address"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/config/link-layer-address"
func (n *Interface_RoutedVlan_Ipv4_NeighborPath) LinkLayerAddress() *Interface_RoutedVlan_Ipv4_Neighbor_LinkLayerAddressPath {
	return &Interface_RoutedVlan_Ipv4_Neighbor_LinkLayerAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-layer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLayerAddress (leaf): The link-layer address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/link-layer-address"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/config/link-layer-address"
func (n *Interface_RoutedVlan_Ipv4_NeighborPathAny) LinkLayerAddress() *Interface_RoutedVlan_Ipv4_Neighbor_LinkLayerAddressPathAny {
	return &Interface_RoutedVlan_Ipv4_Neighbor_LinkLayerAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-layer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this neighbor entry, static or dynamic.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/state/origin"
func (n *Interface_RoutedVlan_Ipv4_NeighborPath) Origin() *Interface_RoutedVlan_Ipv4_Neighbor_OriginPath {
	return &Interface_RoutedVlan_Ipv4_Neighbor_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this neighbor entry, static or dynamic.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/neighbors/neighbor/state/origin"
func (n *Interface_RoutedVlan_Ipv4_NeighborPathAny) Origin() *Interface_RoutedVlan_Ipv4_Neighbor_OriginPathAny {
	return &Interface_RoutedVlan_Ipv4_Neighbor_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv4_ProxyArpPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/proxy-arp YANG schema element.
type Interface_RoutedVlan_Ipv4_ProxyArpPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_ProxyArpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/proxy-arp YANG schema element.
type Interface_RoutedVlan_Ipv4_ProxyArpPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_ProxyArp_ModePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/proxy-arp/config/mode YANG schema element.
type Interface_RoutedVlan_Ipv4_ProxyArp_ModePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_ProxyArp_ModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/proxy-arp/config/mode YANG schema element.
type Interface_RoutedVlan_Ipv4_ProxyArp_ModePathAny struct {
	*ygot.NodePath
}

// Mode (leaf): When set to a value other than DISABLE, the local system should
// respond to ARP requests that are for target addresses other than
// those that are configured on the local subinterface using its own
// MAC address as the target hardware address. If the REMOTE_ONLY
// value is specified, replies are only sent when the target address
// falls outside the locally configured subnets on the interface,
// whereas with the ALL value, all requests, regardless of their
// target address are replied to.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mode"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/proxy-arp/config/mode"
func (n *Interface_RoutedVlan_Ipv4_ProxyArpPath) Mode() *Interface_RoutedVlan_Ipv4_ProxyArp_ModePath {
	return &Interface_RoutedVlan_Ipv4_ProxyArp_ModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): When set to a value other than DISABLE, the local system should
// respond to ARP requests that are for target addresses other than
// those that are configured on the local subinterface using its own
// MAC address as the target hardware address. If the REMOTE_ONLY
// value is specified, replies are only sent when the target address
// falls outside the locally configured subnets on the interface,
// whereas with the ALL value, all requests, regardless of their
// target address are replied to.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mode"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/proxy-arp/config/mode"
func (n *Interface_RoutedVlan_Ipv4_ProxyArpPathAny) Mode() *Interface_RoutedVlan_Ipv4_ProxyArp_ModePathAny {
	return &Interface_RoutedVlan_Ipv4_ProxyArp_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv4_UnnumberedPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered YANG schema element.
type Interface_RoutedVlan_Ipv4_UnnumberedPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_UnnumberedPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered YANG schema element.
type Interface_RoutedVlan_Ipv4_UnnumberedPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Unnumbered_EnabledPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered/config/enabled YANG schema element.
type Interface_RoutedVlan_Ipv4_Unnumbered_EnabledPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Unnumbered_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered/config/enabled YANG schema element.
type Interface_RoutedVlan_Ipv4_Unnumbered_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Indicates that the subinterface is unnumbered.  By default
// the subinterface is numbered, i.e., expected to have an
// IP address configuration.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered/config/enabled"
func (n *Interface_RoutedVlan_Ipv4_UnnumberedPath) Enabled() *Interface_RoutedVlan_Ipv4_Unnumbered_EnabledPath {
	return &Interface_RoutedVlan_Ipv4_Unnumbered_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Indicates that the subinterface is unnumbered.  By default
// the subinterface is numbered, i.e., expected to have an
// IP address configuration.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered/config/enabled"
func (n *Interface_RoutedVlan_Ipv4_UnnumberedPathAny) Enabled() *Interface_RoutedVlan_Ipv4_Unnumbered_EnabledPathAny {
	return &Interface_RoutedVlan_Ipv4_Unnumbered_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-ref"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref"
func (n *Interface_RoutedVlan_Ipv4_UnnumberedPath) InterfaceRef() *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPath {
	return &Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-ref"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref"
func (n *Interface_RoutedVlan_Ipv4_UnnumberedPathAny) InterfaceRef() *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPathAny {
	return &Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref YANG schema element.
type Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref YANG schema element.
type Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_InterfacePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref/config/interface YANG schema element.
type Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref/config/interface YANG schema element.
type Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_SubinterfacePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref/config/subinterface YANG schema element.
type Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref/config/subinterface YANG schema element.
type Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref/config/interface"
func (n *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPath) Interface() *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_InterfacePath {
	return &Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref/config/interface"
func (n *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPathAny) Interface() *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_InterfacePathAny {
	return &Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/subinterface"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref/config/subinterface"
func (n *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPath) Subinterface() *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_SubinterfacePath {
	return &Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/subinterface"
// Path from root: "/interfaces/interface/routed-vlan/ipv4/unnumbered/interface-ref/config/subinterface"
func (n *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRefPathAny) Subinterface() *Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_SubinterfacePathAny {
	return &Interface_RoutedVlan_Ipv4_Unnumbered_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv6Path represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6 YANG schema element.
type Interface_RoutedVlan_Ipv6Path struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6PathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6 YANG schema element.
type Interface_RoutedVlan_Ipv6PathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_DhcpClientPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/config/dhcp-client YANG schema element.
type Interface_RoutedVlan_Ipv6_DhcpClientPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_DhcpClientPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/config/dhcp-client YANG schema element.
type Interface_RoutedVlan_Ipv6_DhcpClientPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_DupAddrDetectTransmitsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/config/dup-addr-detect-transmits YANG schema element.
type Interface_RoutedVlan_Ipv6_DupAddrDetectTransmitsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_DupAddrDetectTransmitsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/config/dup-addr-detect-transmits YANG schema element.
type Interface_RoutedVlan_Ipv6_DupAddrDetectTransmitsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_EnabledPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/config/enabled YANG schema element.
type Interface_RoutedVlan_Ipv6_EnabledPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/config/enabled YANG schema element.
type Interface_RoutedVlan_Ipv6_EnabledPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_MtuPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/config/mtu YANG schema element.
type Interface_RoutedVlan_Ipv6_MtuPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_MtuPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/config/mtu YANG schema element.
type Interface_RoutedVlan_Ipv6_MtuPathAny struct {
	*ygot.NodePath
}

// AddressAny (list): The list of configured IPv6 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address"
// Ip (wildcarded): string
func (n *Interface_RoutedVlan_Ipv6Path) AddressAny() *Interface_RoutedVlan_Ipv6_AddressPathAny {
	return &Interface_RoutedVlan_Ipv6_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// AddressAny (list): The list of configured IPv6 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address"
// Ip (wildcarded): string
func (n *Interface_RoutedVlan_Ipv6PathAny) AddressAny() *Interface_RoutedVlan_Ipv6_AddressPathAny {
	return &Interface_RoutedVlan_Ipv6_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// Address (list): The list of configured IPv6 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address"
// Ip: string
func (n *Interface_RoutedVlan_Ipv6Path) Address(Ip string) *Interface_RoutedVlan_Ipv6_AddressPath {
	return &Interface_RoutedVlan_Ipv6_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Address (list): The list of configured IPv6 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address"
// Ip: string
func (n *Interface_RoutedVlan_Ipv6PathAny) Address(Ip string) *Interface_RoutedVlan_Ipv6_AddressPathAny {
	return &Interface_RoutedVlan_Ipv6_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Counters (container): Packet and byte counters for IP transmission and
// reception for the address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters"
func (n *Interface_RoutedVlan_Ipv6Path) Counters() *Interface_RoutedVlan_Ipv6_CountersPath {
	return &Interface_RoutedVlan_Ipv6_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Packet and byte counters for IP transmission and
// reception for the address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters"
func (n *Interface_RoutedVlan_Ipv6PathAny) Counters() *Interface_RoutedVlan_Ipv6_CountersPathAny {
	return &Interface_RoutedVlan_Ipv6_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpClient (leaf): Enables a DHCP client on the interface in order to request
// an address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dhcp-client"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/config/dhcp-client"
func (n *Interface_RoutedVlan_Ipv6Path) DhcpClient() *Interface_RoutedVlan_Ipv6_DhcpClientPath {
	return &Interface_RoutedVlan_Ipv6_DhcpClientPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dhcp-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpClient (leaf): Enables a DHCP client on the interface in order to request
// an address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dhcp-client"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/config/dhcp-client"
func (n *Interface_RoutedVlan_Ipv6PathAny) DhcpClient() *Interface_RoutedVlan_Ipv6_DhcpClientPathAny {
	return &Interface_RoutedVlan_Ipv6_DhcpClientPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dhcp-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// DupAddrDetectTransmits (leaf): The number of consecutive Neighbor Solicitation messages
// sent while performing Duplicate Address Detection on a
// tentative address.  A value of zero indicates that
// Duplicate Address Detection is not performed on
// tentative addresses.  A value of one indicates a single
// transmission with no follow-up retransmissions.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dup-addr-detect-transmits"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/config/dup-addr-detect-transmits"
func (n *Interface_RoutedVlan_Ipv6Path) DupAddrDetectTransmits() *Interface_RoutedVlan_Ipv6_DupAddrDetectTransmitsPath {
	return &Interface_RoutedVlan_Ipv6_DupAddrDetectTransmitsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dup-addr-detect-transmits"},
			map[string]interface{}{},
			n,
		),
	}
}

// DupAddrDetectTransmits (leaf): The number of consecutive Neighbor Solicitation messages
// sent while performing Duplicate Address Detection on a
// tentative address.  A value of zero indicates that
// Duplicate Address Detection is not performed on
// tentative addresses.  A value of one indicates a single
// transmission with no follow-up retransmissions.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dup-addr-detect-transmits"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/config/dup-addr-detect-transmits"
func (n *Interface_RoutedVlan_Ipv6PathAny) DupAddrDetectTransmits() *Interface_RoutedVlan_Ipv6_DupAddrDetectTransmitsPathAny {
	return &Interface_RoutedVlan_Ipv6_DupAddrDetectTransmitsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dup-addr-detect-transmits"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Controls whether IPv6 is enabled or disabled on this
// interface.  When IPv6 is enabled, this interface is
// connected to an IPv6 stack, and the interface can send
// and receive IPv6 packets.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/config/enabled"
func (n *Interface_RoutedVlan_Ipv6Path) Enabled() *Interface_RoutedVlan_Ipv6_EnabledPath {
	return &Interface_RoutedVlan_Ipv6_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Controls whether IPv6 is enabled or disabled on this
// interface.  When IPv6 is enabled, this interface is
// connected to an IPv6 stack, and the interface can send
// and receive IPv6 packets.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/config/enabled"
func (n *Interface_RoutedVlan_Ipv6PathAny) Enabled() *Interface_RoutedVlan_Ipv6_EnabledPathAny {
	return &Interface_RoutedVlan_Ipv6_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The size, in octets, of the largest IPv6 packet that the
// interface will send and receive.
//
// The server may restrict the allowed values for this leaf,
// depending on the interface's type.
//
// If this leaf is not configured, the operationally used MTU
// depends on the interface's type.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/config/mtu"
func (n *Interface_RoutedVlan_Ipv6Path) Mtu() *Interface_RoutedVlan_Ipv6_MtuPath {
	return &Interface_RoutedVlan_Ipv6_MtuPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The size, in octets, of the largest IPv6 packet that the
// interface will send and receive.
//
// The server may restrict the allowed values for this leaf,
// depending on the interface's type.
//
// If this leaf is not configured, the operationally used MTU
// depends on the interface's type.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/config/mtu"
func (n *Interface_RoutedVlan_Ipv6PathAny) Mtu() *Interface_RoutedVlan_Ipv6_MtuPathAny {
	return &Interface_RoutedVlan_Ipv6_MtuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): List of IPv6 neighbors
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor"
// Ip (wildcarded): string
func (n *Interface_RoutedVlan_Ipv6Path) NeighborAny() *Interface_RoutedVlan_Ipv6_NeighborPathAny {
	return &Interface_RoutedVlan_Ipv6_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of IPv6 neighbors
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor"
// Ip (wildcarded): string
func (n *Interface_RoutedVlan_Ipv6PathAny) NeighborAny() *Interface_RoutedVlan_Ipv6_NeighborPathAny {
	return &Interface_RoutedVlan_Ipv6_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// Neighbor (list): List of IPv6 neighbors
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor"
// Ip: string
func (n *Interface_RoutedVlan_Ipv6Path) Neighbor(Ip string) *Interface_RoutedVlan_Ipv6_NeighborPath {
	return &Interface_RoutedVlan_Ipv6_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Neighbor (list): List of IPv6 neighbors
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor"
// Ip: string
func (n *Interface_RoutedVlan_Ipv6PathAny) Neighbor(Ip string) *Interface_RoutedVlan_Ipv6_NeighborPathAny {
	return &Interface_RoutedVlan_Ipv6_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// RouterAdvertisement (container): Configuration and operational state parameters relating to
// router advertisements.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "router-advertisement"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/router-advertisement"
func (n *Interface_RoutedVlan_Ipv6Path) RouterAdvertisement() *Interface_RoutedVlan_Ipv6_RouterAdvertisementPath {
	return &Interface_RoutedVlan_Ipv6_RouterAdvertisementPath{
		NodePath: ygot.NewNodePath(
			[]string{"router-advertisement"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterAdvertisement (container): Configuration and operational state parameters relating to
// router advertisements.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "router-advertisement"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/router-advertisement"
func (n *Interface_RoutedVlan_Ipv6PathAny) RouterAdvertisement() *Interface_RoutedVlan_Ipv6_RouterAdvertisementPathAny {
	return &Interface_RoutedVlan_Ipv6_RouterAdvertisementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"router-advertisement"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unnumbered (container): Top-level container for setting unnumbered interfaces.
// Includes reference the interface that provides the
// address information
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "unnumbered"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered"
func (n *Interface_RoutedVlan_Ipv6Path) Unnumbered() *Interface_RoutedVlan_Ipv6_UnnumberedPath {
	return &Interface_RoutedVlan_Ipv6_UnnumberedPath{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unnumbered (container): Top-level container for setting unnumbered interfaces.
// Includes reference the interface that provides the
// address information
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "unnumbered"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered"
func (n *Interface_RoutedVlan_Ipv6PathAny) Unnumbered() *Interface_RoutedVlan_Ipv6_UnnumberedPathAny {
	return &Interface_RoutedVlan_Ipv6_UnnumberedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv6_AddressPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address YANG schema element.
type Interface_RoutedVlan_Ipv6_AddressPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_AddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address YANG schema element.
type Interface_RoutedVlan_Ipv6_AddressPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_IpPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/config/ip YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_IpPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_IpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/config/ip YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_IpPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_OriginPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/state/origin YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_OriginPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_OriginPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/state/origin YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_OriginPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_PrefixLengthPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/config/prefix-length YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_PrefixLengthPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_PrefixLengthPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/config/prefix-length YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_PrefixLengthPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_StatusPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/state/status YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_StatusPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_StatusPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/state/status YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_StatusPathAny struct {
	*ygot.NodePath
}

// Ip (leaf): The IPv6 address on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/config/ip"
func (n *Interface_RoutedVlan_Ipv6_AddressPath) Ip() *Interface_RoutedVlan_Ipv6_Address_IpPath {
	return &Interface_RoutedVlan_Ipv6_Address_IpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ip (leaf): The IPv6 address on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/config/ip"
func (n *Interface_RoutedVlan_Ipv6_AddressPathAny) Ip() *Interface_RoutedVlan_Ipv6_Address_IpPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_IpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this address, e.g., static, dhcp, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/state/origin"
func (n *Interface_RoutedVlan_Ipv6_AddressPath) Origin() *Interface_RoutedVlan_Ipv6_Address_OriginPath {
	return &Interface_RoutedVlan_Ipv6_Address_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this address, e.g., static, dhcp, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/state/origin"
func (n *Interface_RoutedVlan_Ipv6_AddressPathAny) Origin() *Interface_RoutedVlan_Ipv6_Address_OriginPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the subnet prefix.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/prefix-length"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/config/prefix-length"
func (n *Interface_RoutedVlan_Ipv6_AddressPath) PrefixLength() *Interface_RoutedVlan_Ipv6_Address_PrefixLengthPath {
	return &Interface_RoutedVlan_Ipv6_Address_PrefixLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the subnet prefix.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/prefix-length"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/config/prefix-length"
func (n *Interface_RoutedVlan_Ipv6_AddressPathAny) PrefixLength() *Interface_RoutedVlan_Ipv6_Address_PrefixLengthPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_PrefixLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Status (leaf): The status of an address.  Most of the states correspond
// to states from the IPv6 Stateless Address
// Autoconfiguration protocol.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/status"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/state/status"
func (n *Interface_RoutedVlan_Ipv6_AddressPath) Status() *Interface_RoutedVlan_Ipv6_Address_StatusPath {
	return &Interface_RoutedVlan_Ipv6_Address_StatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "status"},
			map[string]interface{}{},
			n,
		),
	}
}

// Status (leaf): The status of an address.  Most of the states correspond
// to states from the IPv6 Stateless Address
// Autoconfiguration protocol.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/status"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/state/status"
func (n *Interface_RoutedVlan_Ipv6_AddressPathAny) Status() *Interface_RoutedVlan_Ipv6_Address_StatusPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_StatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "status"},
			map[string]interface{}{},
			n,
		),
	}
}

// VrrpGroupAny (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group"
// VirtualRouterId (wildcarded): uint8
func (n *Interface_RoutedVlan_Ipv6_AddressPath) VrrpGroupAny() *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": "*"},
			n,
		),
	}
}

// VrrpGroupAny (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group"
// VirtualRouterId (wildcarded): uint8
func (n *Interface_RoutedVlan_Ipv6_AddressPathAny) VrrpGroupAny() *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": "*"},
			n,
		),
	}
}

// VrrpGroup (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group"
// VirtualRouterId: uint8
func (n *Interface_RoutedVlan_Ipv6_AddressPath) VrrpGroup(VirtualRouterId uint8) *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": VirtualRouterId},
			n,
		),
	}
}

// VrrpGroup (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group"
// VirtualRouterId: uint8
func (n *Interface_RoutedVlan_Ipv6_AddressPathAny) VrrpGroup(VirtualRouterId uint8) *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": VirtualRouterId},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AcceptModePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/accept-mode YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AcceptModePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AcceptModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/accept-mode YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AcceptModePathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AdvertisementIntervalPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/advertisement-interval YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AdvertisementIntervalPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AdvertisementIntervalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/advertisement-interval YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AdvertisementIntervalPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_CurrentPriorityPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/state/current-priority YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_CurrentPriorityPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_CurrentPriorityPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/state/current-priority YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_CurrentPriorityPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/preempt YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/preempt YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptDelayPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/preempt-delay YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptDelayPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptDelayPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/preempt-delay YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptDelayPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PriorityPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/priority YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PriorityPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PriorityPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/priority YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PriorityPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualAddressPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-address YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualAddressPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-address YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualAddressPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualLinkLocalPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-link-local YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualLinkLocalPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualLinkLocalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-link-local YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualLinkLocalPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualRouterIdPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-router-id YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualRouterIdPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualRouterIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-router-id YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualRouterIdPathAny struct {
	*ygot.NodePath
}

// AcceptMode (leaf): Configure whether packets destined for
// virtual addresses are accepted even when the virtual
// address is not owned by the router interface
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/accept-mode"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/accept-mode"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) AcceptMode() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AcceptModePath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AcceptModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accept-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AcceptMode (leaf): Configure whether packets destined for
// virtual addresses are accepted even when the virtual
// address is not owned by the router interface
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/accept-mode"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/accept-mode"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) AcceptMode() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AcceptModePathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AcceptModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accept-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisementInterval (leaf): Sets the interval between successive VRRP
// advertisements -- RFC 5798 defines this as a 12-bit
// value expressed as 0.1 seconds, with default 100, i.e.,
// 1 second.  Several implementation express this in units of
// seconds
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/advertisement-interval"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/advertisement-interval"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) AdvertisementInterval() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AdvertisementIntervalPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AdvertisementIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisementInterval (leaf): Sets the interval between successive VRRP
// advertisements -- RFC 5798 defines this as a 12-bit
// value expressed as 0.1 seconds, with default 100, i.e.,
// 1 second.  Several implementation express this in units of
// seconds
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/advertisement-interval"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/advertisement-interval"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) AdvertisementInterval() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AdvertisementIntervalPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_AdvertisementIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPriority (leaf): Operational value of the priority for the
// interface in the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/current-priority"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/state/current-priority"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) CurrentPriority() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_CurrentPriorityPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_CurrentPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPriority (leaf): Operational value of the priority for the
// interface in the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/current-priority"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/state/current-priority"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) CurrentPriority() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_CurrentPriorityPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_CurrentPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceTracking (container): Top-level container for VRRP interface tracking
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-tracking"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) InterfaceTracking() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-tracking"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceTracking (container): Top-level container for VRRP interface tracking
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-tracking"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) InterfaceTracking() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-tracking"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preempt (leaf): When set to true, enables preemption by a higher
// priority backup router of a lower priority master router
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/preempt"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) Preempt() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preempt (leaf): When set to true, enables preemption by a higher
// priority backup router of a lower priority master router
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/preempt"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) Preempt() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreemptDelay (leaf): Set the delay the higher priority router waits
// before preempting
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt-delay"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/preempt-delay"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) PreemptDelay() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptDelayPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreemptDelay (leaf): Set the delay the higher priority router waits
// before preempting
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt-delay"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/preempt-delay"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) PreemptDelay() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptDelayPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PreemptDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Specifies the sending VRRP interface's priority
// for the virtual router.  Higher values equal higher
// priority
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/priority"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) Priority() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PriorityPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Specifies the sending VRRP interface's priority
// for the virtual router.  Higher values equal higher
// priority
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/priority"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) Priority() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PriorityPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualAddress (leaf): Configure one or more virtual addresses for the
// VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-address"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-address"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) VirtualAddress() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualAddressPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualAddress (leaf): Configure one or more virtual addresses for the
// VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-address"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-address"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) VirtualAddress() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualAddressPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualLinkLocal (leaf): For VRRP on IPv6 interfaces, sets the virtual link local
// address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-link-local"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-link-local"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) VirtualLinkLocal() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualLinkLocalPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualLinkLocalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-link-local"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualLinkLocal (leaf): For VRRP on IPv6 interfaces, sets the virtual link local
// address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-link-local"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-link-local"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) VirtualLinkLocal() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualLinkLocalPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualLinkLocalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-link-local"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualRouterId (leaf): Set the virtual router id for use by the VRRP group.  This
// usually also determines the virtual MAC address that is
// generated for the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-router-id"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-router-id"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPath) VirtualRouterId() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualRouterIdPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualRouterId (leaf): Set the virtual router id for use by the VRRP group.  This
// usually also determines the virtual MAC address that is
// generated for the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-router-id"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-router-id"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroupPathAny) VirtualRouterId() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualRouterIdPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_VirtualRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface YANG schema element.
type Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny struct {
	*ygot.NodePath
}

// PriorityDecrement (leaf): Set the value to subtract from priority when
// the tracked interface goes down
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority-decrement"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPath) PriorityDecrement() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority-decrement"},
			map[string]interface{}{},
			n,
		),
	}
}

// PriorityDecrement (leaf): Set the value to subtract from priority when
// the tracked interface goes down
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority-decrement"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny) PriorityDecrement() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority-decrement"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrackInterface (leaf): Sets a list of one or more interfaces that should
// be tracked for up/down events to dynamically change the
// priority state of the VRRP group, and potentially
// change the mastership if the tracked interface going
// down lowers the priority sufficiently.  Any of the tracked
// interfaces going down will cause the priority to be lowered.
// Some implementations may only support a single
// tracked interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/track-interface"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPath) TrackInterface() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "track-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrackInterface (leaf): Sets a list of one or more interfaces that should
// be tracked for up/down events to dynamically change the
// priority state of the VRRP group, and potentially
// change the mastership if the tracked interface going
// down lowers the priority sufficiently.  Any of the tracked
// interfaces going down will cause the priority to be lowered.
// Some implementations may only support a single
// tracked interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/track-interface"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface"
func (n *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny) TrackInterface() *Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny {
	return &Interface_RoutedVlan_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "track-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv6_CountersPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters YANG schema element.
type Interface_RoutedVlan_Ipv6_CountersPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_CountersPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters YANG schema element.
type Interface_RoutedVlan_Ipv6_CountersPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InDiscardedPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-discarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InDiscardedPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InDiscardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-discarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InDiscardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InErrorPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-error-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InErrorPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InErrorPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-error-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InErrorPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InForwardedOctetsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-forwarded-octets YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InForwardedOctetsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InForwardedOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-forwarded-octets YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InForwardedOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InForwardedPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-forwarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InForwardedPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InForwardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-forwarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InForwardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InOctetsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-octets YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InOctetsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-octets YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_InPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/in-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_InPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutDiscardedPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-discarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutDiscardedPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutDiscardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-discarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutDiscardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutErrorPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-error-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutErrorPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutErrorPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-error-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutErrorPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutForwardedOctetsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-forwarded-octets YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutForwardedOctetsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutForwardedOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-forwarded-octets YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutForwardedOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutForwardedPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-forwarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutForwardedPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutForwardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-forwarded-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutForwardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutOctetsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-octets YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutOctetsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-octets YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutPktsPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutPktsPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Counters_OutPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/state/counters/out-pkts YANG schema element.
type Interface_RoutedVlan_Ipv6_Counters_OutPktsPathAny struct {
	*ygot.NodePath
}

// InDiscardedPkts (leaf): The number of input IP packets for the
// specified address family, for which no problems were
// encountered to prevent their continued processing, but
// were discarded (e.g., for lack of buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-discarded-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) InDiscardedPkts() *Interface_RoutedVlan_Ipv6_Counters_InDiscardedPktsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_InDiscardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InDiscardedPkts (leaf): The number of input IP packets for the
// specified address family, for which no problems were
// encountered to prevent their continued processing, but
// were discarded (e.g., for lack of buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-discarded-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) InDiscardedPkts() *Interface_RoutedVlan_Ipv6_Counters_InDiscardedPktsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_InDiscardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrorPkts (leaf): Number of IP packets discarded due to errors for the
// specified address family, including errors in the IP
// header, no route found to the IP destination, invalid
// address, unknown protocol, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-error-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-error-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) InErrorPkts() *Interface_RoutedVlan_Ipv6_Counters_InErrorPktsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_InErrorPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrorPkts (leaf): Number of IP packets discarded due to errors for the
// specified address family, including errors in the IP
// header, no route found to the IP destination, invalid
// address, unknown protocol, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-error-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-error-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) InErrorPkts() *Interface_RoutedVlan_Ipv6_Counters_InErrorPktsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_InErrorPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedOctets (leaf): The number of octets received in input IP packets
// for the specified address family for which the device was
// not their final IP destination and for which the
// device attempted to find a route to forward them to that
// final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-forwarded-octets"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) InForwardedOctets() *Interface_RoutedVlan_Ipv6_Counters_InForwardedOctetsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_InForwardedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedOctets (leaf): The number of octets received in input IP packets
// for the specified address family for which the device was
// not their final IP destination and for which the
// device attempted to find a route to forward them to that
// final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-forwarded-octets"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) InForwardedOctets() *Interface_RoutedVlan_Ipv6_Counters_InForwardedOctetsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_InForwardedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedPkts (leaf): The number of input packets for which the device was not
// their final IP destination and for which the device
// attempted to find a route to forward them to that final
// destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-forwarded-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) InForwardedPkts() *Interface_RoutedVlan_Ipv6_Counters_InForwardedPktsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_InForwardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedPkts (leaf): The number of input packets for which the device was not
// their final IP destination and for which the device
// attempted to find a route to forward them to that final
// destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-forwarded-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) InForwardedPkts() *Interface_RoutedVlan_Ipv6_Counters_InForwardedPktsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_InForwardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received in input IP packets
// for the specified address family, including those received
// in error.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-octets"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) InOctets() *Interface_RoutedVlan_Ipv6_Counters_InOctetsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received in input IP packets
// for the specified address family, including those received
// in error.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-octets"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) InOctets() *Interface_RoutedVlan_Ipv6_Counters_InOctetsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of IP packets received for the specified
// address family, including those received in error
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) InPkts() *Interface_RoutedVlan_Ipv6_Counters_InPktsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of IP packets received for the specified
// address family, including those received in error
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/in-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) InPkts() *Interface_RoutedVlan_Ipv6_Counters_InPktsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscardedPkts (leaf): The number of output IP packets for the
// specified address family for which no problem was
// encountered to prevent their transmission to their
// destination, but were discarded (e.g., for lack of
// buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-discarded-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) OutDiscardedPkts() *Interface_RoutedVlan_Ipv6_Counters_OutDiscardedPktsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_OutDiscardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscardedPkts (leaf): The number of output IP packets for the
// specified address family for which no problem was
// encountered to prevent their transmission to their
// destination, but were discarded (e.g., for lack of
// buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-discarded-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) OutDiscardedPkts() *Interface_RoutedVlan_Ipv6_Counters_OutDiscardedPktsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_OutDiscardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrorPkts (leaf): Number of IP packets for the specified address family
// locally generated and discarded due to errors, including
// no route found to the IP destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-error-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-error-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) OutErrorPkts() *Interface_RoutedVlan_Ipv6_Counters_OutErrorPktsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_OutErrorPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrorPkts (leaf): Number of IP packets for the specified address family
// locally generated and discarded due to errors, including
// no route found to the IP destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-error-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-error-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) OutErrorPkts() *Interface_RoutedVlan_Ipv6_Counters_OutErrorPktsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_OutErrorPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedOctets (leaf): The number of octets in packets for which this entity was
// not their final IP destination and for which it was
// successful in finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-forwarded-octets"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) OutForwardedOctets() *Interface_RoutedVlan_Ipv6_Counters_OutForwardedOctetsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_OutForwardedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedOctets (leaf): The number of octets in packets for which this entity was
// not their final IP destination and for which it was
// successful in finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-forwarded-octets"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) OutForwardedOctets() *Interface_RoutedVlan_Ipv6_Counters_OutForwardedOctetsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_OutForwardedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedPkts (leaf): The number of packets for which this entity was not their
// final IP destination and for which it was successful in
// finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-forwarded-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) OutForwardedPkts() *Interface_RoutedVlan_Ipv6_Counters_OutForwardedPktsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_OutForwardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedPkts (leaf): The number of packets for which this entity was not their
// final IP destination and for which it was successful in
// finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-forwarded-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) OutForwardedPkts() *Interface_RoutedVlan_Ipv6_Counters_OutForwardedPktsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_OutForwardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets in IP packets for the
// specified address family that the device
// supplied to the lower layers for transmission.  This
// includes packets generated locally and those forwarded by
// the device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-octets"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) OutOctets() *Interface_RoutedVlan_Ipv6_Counters_OutOctetsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets in IP packets for the
// specified address family that the device
// supplied to the lower layers for transmission.  This
// includes packets generated locally and those forwarded by
// the device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-octets"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) OutOctets() *Interface_RoutedVlan_Ipv6_Counters_OutOctetsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of IP packets for the
// specified address family that the device supplied
// to the lower layers for transmission.  This includes
// packets generated locally and those forwarded by the
// device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPath) OutPkts() *Interface_RoutedVlan_Ipv6_Counters_OutPktsPath {
	return &Interface_RoutedVlan_Ipv6_Counters_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of IP packets for the
// specified address family that the device supplied
// to the lower layers for transmission.  This includes
// packets generated locally and those forwarded by the
// device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/state/counters/out-pkts"
func (n *Interface_RoutedVlan_Ipv6_CountersPathAny) OutPkts() *Interface_RoutedVlan_Ipv6_Counters_OutPktsPathAny {
	return &Interface_RoutedVlan_Ipv6_Counters_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv6_NeighborPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor YANG schema element.
type Interface_RoutedVlan_Ipv6_NeighborPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_NeighborPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor YANG schema element.
type Interface_RoutedVlan_Ipv6_NeighborPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_IpPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/config/ip YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_IpPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_IpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/config/ip YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_IpPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_IsRouterPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/is-router YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_IsRouterPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_IsRouterPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/is-router YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_IsRouterPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_LinkLayerAddressPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/config/link-layer-address YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_LinkLayerAddressPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_LinkLayerAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/config/link-layer-address YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_LinkLayerAddressPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_NeighborStatePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/neighbor-state YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_NeighborStatePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_NeighborStatePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/neighbor-state YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_NeighborStatePathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_OriginPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/origin YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_OriginPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Neighbor_OriginPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/origin YANG schema element.
type Interface_RoutedVlan_Ipv6_Neighbor_OriginPathAny struct {
	*ygot.NodePath
}

// Ip (leaf): The IPv6 address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/config/ip"
func (n *Interface_RoutedVlan_Ipv6_NeighborPath) Ip() *Interface_RoutedVlan_Ipv6_Neighbor_IpPath {
	return &Interface_RoutedVlan_Ipv6_Neighbor_IpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ip (leaf): The IPv6 address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/config/ip"
func (n *Interface_RoutedVlan_Ipv6_NeighborPathAny) Ip() *Interface_RoutedVlan_Ipv6_Neighbor_IpPathAny {
	return &Interface_RoutedVlan_Ipv6_Neighbor_IpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsRouter (leaf): Indicates that the neighbor node acts as a router.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/is-router"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/is-router"
func (n *Interface_RoutedVlan_Ipv6_NeighborPath) IsRouter() *Interface_RoutedVlan_Ipv6_Neighbor_IsRouterPath {
	return &Interface_RoutedVlan_Ipv6_Neighbor_IsRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "is-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsRouter (leaf): Indicates that the neighbor node acts as a router.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/is-router"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/is-router"
func (n *Interface_RoutedVlan_Ipv6_NeighborPathAny) IsRouter() *Interface_RoutedVlan_Ipv6_Neighbor_IsRouterPathAny {
	return &Interface_RoutedVlan_Ipv6_Neighbor_IsRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "is-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLayerAddress (leaf): The link-layer address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/link-layer-address"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/config/link-layer-address"
func (n *Interface_RoutedVlan_Ipv6_NeighborPath) LinkLayerAddress() *Interface_RoutedVlan_Ipv6_Neighbor_LinkLayerAddressPath {
	return &Interface_RoutedVlan_Ipv6_Neighbor_LinkLayerAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-layer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLayerAddress (leaf): The link-layer address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/link-layer-address"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/config/link-layer-address"
func (n *Interface_RoutedVlan_Ipv6_NeighborPathAny) LinkLayerAddress() *Interface_RoutedVlan_Ipv6_Neighbor_LinkLayerAddressPathAny {
	return &Interface_RoutedVlan_Ipv6_Neighbor_LinkLayerAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-layer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborState (leaf): The Neighbor Unreachability Detection state of this
// entry.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/neighbor-state"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/neighbor-state"
func (n *Interface_RoutedVlan_Ipv6_NeighborPath) NeighborState() *Interface_RoutedVlan_Ipv6_Neighbor_NeighborStatePath {
	return &Interface_RoutedVlan_Ipv6_Neighbor_NeighborStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborState (leaf): The Neighbor Unreachability Detection state of this
// entry.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/neighbor-state"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/neighbor-state"
func (n *Interface_RoutedVlan_Ipv6_NeighborPathAny) NeighborState() *Interface_RoutedVlan_Ipv6_Neighbor_NeighborStatePathAny {
	return &Interface_RoutedVlan_Ipv6_Neighbor_NeighborStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this neighbor entry.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/origin"
func (n *Interface_RoutedVlan_Ipv6_NeighborPath) Origin() *Interface_RoutedVlan_Ipv6_Neighbor_OriginPath {
	return &Interface_RoutedVlan_Ipv6_Neighbor_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this neighbor entry.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/neighbors/neighbor/state/origin"
func (n *Interface_RoutedVlan_Ipv6_NeighborPathAny) Origin() *Interface_RoutedVlan_Ipv6_Neighbor_OriginPathAny {
	return &Interface_RoutedVlan_Ipv6_Neighbor_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv6_RouterAdvertisementPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/router-advertisement YANG schema element.
type Interface_RoutedVlan_Ipv6_RouterAdvertisementPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_RouterAdvertisementPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/router-advertisement YANG schema element.
type Interface_RoutedVlan_Ipv6_RouterAdvertisementPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_RouterAdvertisement_IntervalPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/interval YANG schema element.
type Interface_RoutedVlan_Ipv6_RouterAdvertisement_IntervalPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_RouterAdvertisement_IntervalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/interval YANG schema element.
type Interface_RoutedVlan_Ipv6_RouterAdvertisement_IntervalPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_RouterAdvertisement_LifetimePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/lifetime YANG schema element.
type Interface_RoutedVlan_Ipv6_RouterAdvertisement_LifetimePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_RouterAdvertisement_LifetimePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/lifetime YANG schema element.
type Interface_RoutedVlan_Ipv6_RouterAdvertisement_LifetimePathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_RouterAdvertisement_SuppressPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/suppress YANG schema element.
type Interface_RoutedVlan_Ipv6_RouterAdvertisement_SuppressPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_RouterAdvertisement_SuppressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/suppress YANG schema element.
type Interface_RoutedVlan_Ipv6_RouterAdvertisement_SuppressPathAny struct {
	*ygot.NodePath
}

// Interval (leaf): The interval between periodic router advertisement neighbor
// discovery messages sent on this interface expressed in
// seconds.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interval"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/interval"
func (n *Interface_RoutedVlan_Ipv6_RouterAdvertisementPath) Interval() *Interface_RoutedVlan_Ipv6_RouterAdvertisement_IntervalPath {
	return &Interface_RoutedVlan_Ipv6_RouterAdvertisement_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): The interval between periodic router advertisement neighbor
// discovery messages sent on this interface expressed in
// seconds.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interval"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/interval"
func (n *Interface_RoutedVlan_Ipv6_RouterAdvertisementPathAny) Interval() *Interface_RoutedVlan_Ipv6_RouterAdvertisement_IntervalPathAny {
	return &Interface_RoutedVlan_Ipv6_RouterAdvertisement_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lifetime (leaf): The lifetime advertised in the router advertisement neighbor
// discovery message on this interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/lifetime"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/lifetime"
func (n *Interface_RoutedVlan_Ipv6_RouterAdvertisementPath) Lifetime() *Interface_RoutedVlan_Ipv6_RouterAdvertisement_LifetimePath {
	return &Interface_RoutedVlan_Ipv6_RouterAdvertisement_LifetimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lifetime (leaf): The lifetime advertised in the router advertisement neighbor
// discovery message on this interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/lifetime"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/lifetime"
func (n *Interface_RoutedVlan_Ipv6_RouterAdvertisementPathAny) Lifetime() *Interface_RoutedVlan_Ipv6_RouterAdvertisement_LifetimePathAny {
	return &Interface_RoutedVlan_Ipv6_RouterAdvertisement_LifetimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// Suppress (leaf): When set to true, router advertisement neighbor discovery
// messages are not transmitted on this interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/suppress"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/suppress"
func (n *Interface_RoutedVlan_Ipv6_RouterAdvertisementPath) Suppress() *Interface_RoutedVlan_Ipv6_RouterAdvertisement_SuppressPath {
	return &Interface_RoutedVlan_Ipv6_RouterAdvertisement_SuppressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "suppress"},
			map[string]interface{}{},
			n,
		),
	}
}

// Suppress (leaf): When set to true, router advertisement neighbor discovery
// messages are not transmitted on this interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/suppress"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/router-advertisement/config/suppress"
func (n *Interface_RoutedVlan_Ipv6_RouterAdvertisementPathAny) Suppress() *Interface_RoutedVlan_Ipv6_RouterAdvertisement_SuppressPathAny {
	return &Interface_RoutedVlan_Ipv6_RouterAdvertisement_SuppressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "suppress"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv6_UnnumberedPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered YANG schema element.
type Interface_RoutedVlan_Ipv6_UnnumberedPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_UnnumberedPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered YANG schema element.
type Interface_RoutedVlan_Ipv6_UnnumberedPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Unnumbered_EnabledPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered/config/enabled YANG schema element.
type Interface_RoutedVlan_Ipv6_Unnumbered_EnabledPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Unnumbered_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered/config/enabled YANG schema element.
type Interface_RoutedVlan_Ipv6_Unnumbered_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Indicates that the subinterface is unnumbered.  By default
// the subinterface is numbered, i.e., expected to have an
// IP address configuration.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered/config/enabled"
func (n *Interface_RoutedVlan_Ipv6_UnnumberedPath) Enabled() *Interface_RoutedVlan_Ipv6_Unnumbered_EnabledPath {
	return &Interface_RoutedVlan_Ipv6_Unnumbered_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Indicates that the subinterface is unnumbered.  By default
// the subinterface is numbered, i.e., expected to have an
// IP address configuration.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered/config/enabled"
func (n *Interface_RoutedVlan_Ipv6_UnnumberedPathAny) Enabled() *Interface_RoutedVlan_Ipv6_Unnumbered_EnabledPathAny {
	return &Interface_RoutedVlan_Ipv6_Unnumbered_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-ref"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref"
func (n *Interface_RoutedVlan_Ipv6_UnnumberedPath) InterfaceRef() *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPath {
	return &Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-ref"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref"
func (n *Interface_RoutedVlan_Ipv6_UnnumberedPathAny) InterfaceRef() *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPathAny {
	return &Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref YANG schema element.
type Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref YANG schema element.
type Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_InterfacePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref/config/interface YANG schema element.
type Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref/config/interface YANG schema element.
type Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_SubinterfacePath represents the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref/config/subinterface YANG schema element.
type Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref/config/subinterface YANG schema element.
type Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref/config/interface"
func (n *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPath) Interface() *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_InterfacePath {
	return &Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref/config/interface"
func (n *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPathAny) Interface() *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_InterfacePathAny {
	return &Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/subinterface"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref/config/subinterface"
func (n *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPath) Subinterface() *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_SubinterfacePath {
	return &Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/subinterface"
// Path from root: "/interfaces/interface/routed-vlan/ipv6/unnumbered/interface-ref/config/subinterface"
func (n *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRefPathAny) Subinterface() *Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_SubinterfacePathAny {
	return &Interface_RoutedVlan_Ipv6_Unnumbered_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_SonetPath represents the /openconfig-interfaces/interfaces/interface/sonet YANG schema element.
type Interface_SonetPath struct {
	*ygot.NodePath
}

// Interface_SonetPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/sonet YANG schema element.
type Interface_SonetPathAny struct {
	*ygot.NodePath
}

// Interface_SubinterfacePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface YANG schema element.
type Interface_SubinterfacePath struct {
	*ygot.NodePath
}

// Interface_SubinterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface YANG schema element.
type Interface_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_AdminStatusPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/admin-status YANG schema element.
type Interface_Subinterface_AdminStatusPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_AdminStatusPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/admin-status YANG schema element.
type Interface_Subinterface_AdminStatusPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_CpuPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/cpu YANG schema element.
type Interface_Subinterface_CpuPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_CpuPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/cpu YANG schema element.
type Interface_Subinterface_CpuPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_DescriptionPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/config/description YANG schema element.
type Interface_Subinterface_DescriptionPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_DescriptionPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/config/description YANG schema element.
type Interface_Subinterface_DescriptionPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_EnabledPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/config/enabled YANG schema element.
type Interface_Subinterface_EnabledPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/config/enabled YANG schema element.
type Interface_Subinterface_EnabledPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_IfindexPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/ifindex YANG schema element.
type Interface_Subinterface_IfindexPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_IfindexPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/ifindex YANG schema element.
type Interface_Subinterface_IfindexPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_IndexPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/config/index YANG schema element.
type Interface_Subinterface_IndexPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_IndexPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/config/index YANG schema element.
type Interface_Subinterface_IndexPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_LastChangePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/last-change YANG schema element.
type Interface_Subinterface_LastChangePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_LastChangePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/last-change YANG schema element.
type Interface_Subinterface_LastChangePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_LogicalPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/logical YANG schema element.
type Interface_Subinterface_LogicalPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_LogicalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/logical YANG schema element.
type Interface_Subinterface_LogicalPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_ManagementPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/management YANG schema element.
type Interface_Subinterface_ManagementPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_ManagementPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/management YANG schema element.
type Interface_Subinterface_ManagementPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_NamePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/name YANG schema element.
type Interface_Subinterface_NamePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_NamePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/name YANG schema element.
type Interface_Subinterface_NamePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_OperStatusPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/oper-status YANG schema element.
type Interface_Subinterface_OperStatusPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_OperStatusPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/oper-status YANG schema element.
type Interface_Subinterface_OperStatusPathAny struct {
	*ygot.NodePath
}

// AdminStatus (leaf): The desired state of the interface.  In RFC 7223 this leaf
// has the same read semantics as ifAdminStatus.  Here, it
// reflects the administrative state as set by enabling or
// disabling the interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/admin-status"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/admin-status"
func (n *Interface_SubinterfacePath) AdminStatus() *Interface_Subinterface_AdminStatusPath {
	return &Interface_Subinterface_AdminStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminStatus (leaf): The desired state of the interface.  In RFC 7223 this leaf
// has the same read semantics as ifAdminStatus.  Here, it
// reflects the administrative state as set by enabling or
// disabling the interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/admin-status"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/admin-status"
func (n *Interface_SubinterfacePathAny) AdminStatus() *Interface_Subinterface_AdminStatusPathAny {
	return &Interface_Subinterface_AdminStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): A collection of interface-related statistics objects.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters"
func (n *Interface_SubinterfacePath) Counters() *Interface_Subinterface_CountersPath {
	return &Interface_Subinterface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): A collection of interface-related statistics objects.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters"
func (n *Interface_SubinterfacePathAny) Counters() *Interface_Subinterface_CountersPathAny {
	return &Interface_Subinterface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cpu (leaf): When set to true, the interface is for traffic
// that is handled by the system CPU, sometimes also called the
// control plane interface.  On systems that represent the CPU
// interface as an Ethernet interface, for example, this leaf
// should be used to distinguish the CPU interface from dataplane
// interfaces.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/cpu"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/cpu"
func (n *Interface_SubinterfacePath) Cpu() *Interface_Subinterface_CpuPath {
	return &Interface_Subinterface_CpuPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cpu (leaf): When set to true, the interface is for traffic
// that is handled by the system CPU, sometimes also called the
// control plane interface.  On systems that represent the CPU
// interface as an Ethernet interface, for example, this leaf
// should be used to distinguish the CPU interface from dataplane
// interfaces.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/cpu"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/cpu"
func (n *Interface_SubinterfacePathAny) Cpu() *Interface_Subinterface_CpuPathAny {
	return &Interface_Subinterface_CpuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): A textual description of the interface.
//
// A server implementation MAY map this leaf to the ifAlias
// MIB object.  Such an implementation needs to use some
// mechanism to handle the differences in size and characters
// allowed between this leaf and ifAlias.  The definition of
// such a mechanism is outside the scope of this document.
//
// Since ifAlias is defined to be stored in non-volatile
// storage, the MIB implementation MUST map ifAlias to the
// value of 'description' in the persistently stored
// datastore.
//
// Specifically, if the device supports ':startup', when
// ifAlias is read the device MUST return the value of
// 'description' in the 'startup' datastore, and when it is
// written, it MUST be written to the 'running' and 'startup'
// datastores.  Note that it is up to the implementation to
//
// decide whether to modify this single leaf in 'startup' or
// perform an implicit copy-config from 'running' to
// 'startup'.
//
// If the device does not support ':startup', ifAlias MUST
// be mapped to the 'description' leaf in the 'running'
// datastore.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/description"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/config/description"
func (n *Interface_SubinterfacePath) Description() *Interface_Subinterface_DescriptionPath {
	return &Interface_Subinterface_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): A textual description of the interface.
//
// A server implementation MAY map this leaf to the ifAlias
// MIB object.  Such an implementation needs to use some
// mechanism to handle the differences in size and characters
// allowed between this leaf and ifAlias.  The definition of
// such a mechanism is outside the scope of this document.
//
// Since ifAlias is defined to be stored in non-volatile
// storage, the MIB implementation MUST map ifAlias to the
// value of 'description' in the persistently stored
// datastore.
//
// Specifically, if the device supports ':startup', when
// ifAlias is read the device MUST return the value of
// 'description' in the 'startup' datastore, and when it is
// written, it MUST be written to the 'running' and 'startup'
// datastores.  Note that it is up to the implementation to
//
// decide whether to modify this single leaf in 'startup' or
// perform an implicit copy-config from 'running' to
// 'startup'.
//
// If the device does not support ':startup', ifAlias MUST
// be mapped to the 'description' leaf in the 'running'
// datastore.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/description"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/config/description"
func (n *Interface_SubinterfacePathAny) Description() *Interface_Subinterface_DescriptionPathAny {
	return &Interface_Subinterface_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// interface.
//
// Systems that implement the IF-MIB use the value of this
// leaf in the 'running' datastore to set
// IF-MIB.ifAdminStatus to 'up' or 'down' after an ifEntry
// has been initialized, as described in RFC 2863.
//
// Changes in this leaf in the 'running' datastore are
// reflected in ifAdminStatus, but if ifAdminStatus is
// changed over SNMP, this leaf is not affected.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/config/enabled"
func (n *Interface_SubinterfacePath) Enabled() *Interface_Subinterface_EnabledPath {
	return &Interface_Subinterface_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf contains the configured, desired state of the
// interface.
//
// Systems that implement the IF-MIB use the value of this
// leaf in the 'running' datastore to set
// IF-MIB.ifAdminStatus to 'up' or 'down' after an ifEntry
// has been initialized, as described in RFC 2863.
//
// Changes in this leaf in the 'running' datastore are
// reflected in ifAdminStatus, but if ifAdminStatus is
// changed over SNMP, this leaf is not affected.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/config/enabled"
func (n *Interface_SubinterfacePathAny) Enabled() *Interface_Subinterface_EnabledPathAny {
	return &Interface_Subinterface_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ifindex (leaf): System assigned number for each interface.  Corresponds to
// ifIndex object in SNMP Interface MIB
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/ifindex"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/ifindex"
func (n *Interface_SubinterfacePath) Ifindex() *Interface_Subinterface_IfindexPath {
	return &Interface_Subinterface_IfindexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ifindex"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ifindex (leaf): System assigned number for each interface.  Corresponds to
// ifIndex object in SNMP Interface MIB
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/ifindex"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/ifindex"
func (n *Interface_SubinterfacePathAny) Ifindex() *Interface_Subinterface_IfindexPathAny {
	return &Interface_Subinterface_IfindexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ifindex"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): The index of the subinterface, or logical interface number.
// On systems with no support for subinterfaces, or not using
// subinterfaces, this value should default to 0, i.e., the
// default subinterface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/index"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/config/index"
func (n *Interface_SubinterfacePath) Index() *Interface_Subinterface_IndexPath {
	return &Interface_Subinterface_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): The index of the subinterface, or logical interface number.
// On systems with no support for subinterfaces, or not using
// subinterfaces, this value should default to 0, i.e., the
// default subinterface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/index"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/config/index"
func (n *Interface_SubinterfacePathAny) Index() *Interface_Subinterface_IndexPathAny {
	return &Interface_Subinterface_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4 (container): Parameters for the IPv4 address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ipv4"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4"
func (n *Interface_SubinterfacePath) Ipv4() *Interface_Subinterface_Ipv4Path {
	return &Interface_Subinterface_Ipv4Path{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4 (container): Parameters for the IPv4 address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ipv4"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4"
func (n *Interface_SubinterfacePathAny) Ipv4() *Interface_Subinterface_Ipv4PathAny {
	return &Interface_Subinterface_Ipv4PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6 (container): Parameters for the IPv6 address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ipv6"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6"
func (n *Interface_SubinterfacePath) Ipv6() *Interface_Subinterface_Ipv6Path {
	return &Interface_Subinterface_Ipv6Path{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6 (container): Parameters for the IPv6 address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ipv6"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6"
func (n *Interface_SubinterfacePathAny) Ipv6() *Interface_Subinterface_Ipv6PathAny {
	return &Interface_Subinterface_Ipv6PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastChange (leaf): This timestamp indicates the absolute time of the last
// state change of the interface (e.g., up-to-down transition).
// This is different than the SNMP ifLastChange object in the
// standard interface MIB in that it is not relative to the
// system boot time (i.e,. sysUpTime).
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/last-change"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/last-change"
func (n *Interface_SubinterfacePath) LastChange() *Interface_Subinterface_LastChangePath {
	return &Interface_Subinterface_LastChangePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastChange (leaf): This timestamp indicates the absolute time of the last
// state change of the interface (e.g., up-to-down transition).
// This is different than the SNMP ifLastChange object in the
// standard interface MIB in that it is not relative to the
// system boot time (i.e,. sysUpTime).
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/last-change"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/last-change"
func (n *Interface_SubinterfacePathAny) LastChange() *Interface_Subinterface_LastChangePathAny {
	return &Interface_Subinterface_LastChangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// Logical (leaf): When set to true, the interface is a logical interface
// which does not have an associated physical port or
// channel on the system.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/logical"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/logical"
func (n *Interface_SubinterfacePath) Logical() *Interface_Subinterface_LogicalPath {
	return &Interface_Subinterface_LogicalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "logical"},
			map[string]interface{}{},
			n,
		),
	}
}

// Logical (leaf): When set to true, the interface is a logical interface
// which does not have an associated physical port or
// channel on the system.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/logical"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/logical"
func (n *Interface_SubinterfacePathAny) Logical() *Interface_Subinterface_LogicalPathAny {
	return &Interface_Subinterface_LogicalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "logical"},
			map[string]interface{}{},
			n,
		),
	}
}

// Management (leaf): When set to true, the interface is a dedicated
// management interface that is not connected to dataplane
// interfaces.  It may be used to connect the system to an
// out-of-band management network, for example.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/management"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/management"
func (n *Interface_SubinterfacePath) Management() *Interface_Subinterface_ManagementPath {
	return &Interface_Subinterface_ManagementPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management"},
			map[string]interface{}{},
			n,
		),
	}
}

// Management (leaf): When set to true, the interface is a dedicated
// management interface that is not connected to dataplane
// interfaces.  It may be used to connect the system to an
// out-of-band management network, for example.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/management"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/management"
func (n *Interface_SubinterfacePathAny) Management() *Interface_Subinterface_ManagementPathAny {
	return &Interface_Subinterface_ManagementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The system-assigned name for the sub-interface.  This MAY
// be a combination of the base interface name and the
// subinterface index, or some other convention used by the
// system.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/name"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/name"
func (n *Interface_SubinterfacePath) Name() *Interface_Subinterface_NamePath {
	return &Interface_Subinterface_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The system-assigned name for the sub-interface.  This MAY
// be a combination of the base interface name and the
// subinterface index, or some other convention used by the
// system.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/name"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/name"
func (n *Interface_SubinterfacePathAny) Name() *Interface_Subinterface_NamePathAny {
	return &Interface_Subinterface_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperStatus (leaf): The current operational state of the interface.
//
// This leaf has the same semantics as ifOperStatus.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/oper-status"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/oper-status"
func (n *Interface_SubinterfacePath) OperStatus() *Interface_Subinterface_OperStatusPath {
	return &Interface_Subinterface_OperStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperStatus (leaf): The current operational state of the interface.
//
// This leaf has the same semantics as ifOperStatus.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/oper-status"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/oper-status"
func (n *Interface_SubinterfacePathAny) OperStatus() *Interface_Subinterface_OperStatusPathAny {
	return &Interface_Subinterface_OperStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (container): Enclosing container for VLAN interface-specific
// data on subinterfaces
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vlan"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan"
func (n *Interface_SubinterfacePath) Vlan() *Interface_Subinterface_VlanPath {
	return &Interface_Subinterface_VlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (container): Enclosing container for VLAN interface-specific
// data on subinterfaces
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vlan"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan"
func (n *Interface_SubinterfacePathAny) Vlan() *Interface_Subinterface_VlanPathAny {
	return &Interface_Subinterface_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_CountersPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters YANG schema element.
type Interface_Subinterface_CountersPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_CountersPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters YANG schema element.
type Interface_Subinterface_CountersPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_CarrierTransitionsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/carrier-transitions YANG schema element.
type Interface_Subinterface_Counters_CarrierTransitionsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_CarrierTransitionsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/carrier-transitions YANG schema element.
type Interface_Subinterface_Counters_CarrierTransitionsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InBroadcastPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-broadcast-pkts YANG schema element.
type Interface_Subinterface_Counters_InBroadcastPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InBroadcastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-broadcast-pkts YANG schema element.
type Interface_Subinterface_Counters_InBroadcastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InDiscardsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-discards YANG schema element.
type Interface_Subinterface_Counters_InDiscardsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InDiscardsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-discards YANG schema element.
type Interface_Subinterface_Counters_InDiscardsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InErrorsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-errors YANG schema element.
type Interface_Subinterface_Counters_InErrorsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InErrorsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-errors YANG schema element.
type Interface_Subinterface_Counters_InErrorsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InFcsErrorsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-fcs-errors YANG schema element.
type Interface_Subinterface_Counters_InFcsErrorsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InFcsErrorsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-fcs-errors YANG schema element.
type Interface_Subinterface_Counters_InFcsErrorsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InMulticastPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-multicast-pkts YANG schema element.
type Interface_Subinterface_Counters_InMulticastPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InMulticastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-multicast-pkts YANG schema element.
type Interface_Subinterface_Counters_InMulticastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-octets YANG schema element.
type Interface_Subinterface_Counters_InOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-octets YANG schema element.
type Interface_Subinterface_Counters_InOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-pkts YANG schema element.
type Interface_Subinterface_Counters_InPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-pkts YANG schema element.
type Interface_Subinterface_Counters_InPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InUnicastPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-unicast-pkts YANG schema element.
type Interface_Subinterface_Counters_InUnicastPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InUnicastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-unicast-pkts YANG schema element.
type Interface_Subinterface_Counters_InUnicastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InUnknownProtosPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-unknown-protos YANG schema element.
type Interface_Subinterface_Counters_InUnknownProtosPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_InUnknownProtosPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/in-unknown-protos YANG schema element.
type Interface_Subinterface_Counters_InUnknownProtosPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_LastClearPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/last-clear YANG schema element.
type Interface_Subinterface_Counters_LastClearPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_LastClearPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/last-clear YANG schema element.
type Interface_Subinterface_Counters_LastClearPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutBroadcastPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-broadcast-pkts YANG schema element.
type Interface_Subinterface_Counters_OutBroadcastPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutBroadcastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-broadcast-pkts YANG schema element.
type Interface_Subinterface_Counters_OutBroadcastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutDiscardsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-discards YANG schema element.
type Interface_Subinterface_Counters_OutDiscardsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutDiscardsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-discards YANG schema element.
type Interface_Subinterface_Counters_OutDiscardsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutErrorsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-errors YANG schema element.
type Interface_Subinterface_Counters_OutErrorsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutErrorsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-errors YANG schema element.
type Interface_Subinterface_Counters_OutErrorsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutMulticastPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-multicast-pkts YANG schema element.
type Interface_Subinterface_Counters_OutMulticastPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutMulticastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-multicast-pkts YANG schema element.
type Interface_Subinterface_Counters_OutMulticastPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-octets YANG schema element.
type Interface_Subinterface_Counters_OutOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-octets YANG schema element.
type Interface_Subinterface_Counters_OutOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-pkts YANG schema element.
type Interface_Subinterface_Counters_OutPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-pkts YANG schema element.
type Interface_Subinterface_Counters_OutPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutUnicastPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-unicast-pkts YANG schema element.
type Interface_Subinterface_Counters_OutUnicastPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Counters_OutUnicastPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/state/counters/out-unicast-pkts YANG schema element.
type Interface_Subinterface_Counters_OutUnicastPktsPathAny struct {
	*ygot.NodePath
}

// CarrierTransitions (leaf): Number of times the interface state has transitioned
// between up and down since the time the device restarted
// or the last-clear time, whichever is most recent.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "carrier-transitions"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/carrier-transitions"
func (n *Interface_Subinterface_CountersPath) CarrierTransitions() *Interface_Subinterface_Counters_CarrierTransitionsPath {
	return &Interface_Subinterface_Counters_CarrierTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"carrier-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// CarrierTransitions (leaf): Number of times the interface state has transitioned
// between up and down since the time the device restarted
// or the last-clear time, whichever is most recent.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "carrier-transitions"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/carrier-transitions"
func (n *Interface_Subinterface_CountersPathAny) CarrierTransitions() *Interface_Subinterface_Counters_CarrierTransitionsPathAny {
	return &Interface_Subinterface_Counters_CarrierTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"carrier-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// InBroadcastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were addressed to a broadcast
// address at this sub-layer.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-broadcast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-broadcast-pkts"
func (n *Interface_Subinterface_CountersPath) InBroadcastPkts() *Interface_Subinterface_Counters_InBroadcastPktsPath {
	return &Interface_Subinterface_Counters_InBroadcastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-broadcast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InBroadcastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were addressed to a broadcast
// address at this sub-layer.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-broadcast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-broadcast-pkts"
func (n *Interface_Subinterface_CountersPathAny) InBroadcastPkts() *Interface_Subinterface_Counters_InBroadcastPktsPathAny {
	return &Interface_Subinterface_Counters_InBroadcastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-broadcast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InDiscards (leaf): The number of inbound packets that were chosen to be
// discarded even though no errors had been detected to
// prevent their being deliverable to a higher-layer
// protocol.  One possible reason for discarding such a
// packet could be to free up buffer space.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discards"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-discards"
func (n *Interface_Subinterface_CountersPath) InDiscards() *Interface_Subinterface_Counters_InDiscardsPath {
	return &Interface_Subinterface_Counters_InDiscardsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-discards"},
			map[string]interface{}{},
			n,
		),
	}
}

// InDiscards (leaf): The number of inbound packets that were chosen to be
// discarded even though no errors had been detected to
// prevent their being deliverable to a higher-layer
// protocol.  One possible reason for discarding such a
// packet could be to free up buffer space.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discards"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-discards"
func (n *Interface_Subinterface_CountersPathAny) InDiscards() *Interface_Subinterface_Counters_InDiscardsPathAny {
	return &Interface_Subinterface_Counters_InDiscardsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-discards"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrors (leaf): For packet-oriented interfaces, the number of inbound
// packets that contained errors preventing them from being
// deliverable to a higher-layer protocol.  For character-
// oriented or fixed-length interfaces, the number of
// inbound transmission units that contained errors
// preventing them from being deliverable to a higher-layer
// protocol.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-errors"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-errors"
func (n *Interface_Subinterface_CountersPath) InErrors() *Interface_Subinterface_Counters_InErrorsPath {
	return &Interface_Subinterface_Counters_InErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrors (leaf): For packet-oriented interfaces, the number of inbound
// packets that contained errors preventing them from being
// deliverable to a higher-layer protocol.  For character-
// oriented or fixed-length interfaces, the number of
// inbound transmission units that contained errors
// preventing them from being deliverable to a higher-layer
// protocol.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-errors"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-errors"
func (n *Interface_Subinterface_CountersPathAny) InErrors() *Interface_Subinterface_Counters_InErrorsPathAny {
	return &Interface_Subinterface_Counters_InErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InFcsErrors (leaf): Number of received packets which had errors in the
// frame check sequence (FCS), i.e., framing errors.
//
// Discontinuities in the value of this counter can occur
// when the device is re-initialization as indicated by the
// value of 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-fcs-errors"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-fcs-errors"
func (n *Interface_Subinterface_CountersPath) InFcsErrors() *Interface_Subinterface_Counters_InFcsErrorsPath {
	return &Interface_Subinterface_Counters_InFcsErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-fcs-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InFcsErrors (leaf): Number of received packets which had errors in the
// frame check sequence (FCS), i.e., framing errors.
//
// Discontinuities in the value of this counter can occur
// when the device is re-initialization as indicated by the
// value of 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-fcs-errors"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-fcs-errors"
func (n *Interface_Subinterface_CountersPathAny) InFcsErrors() *Interface_Subinterface_Counters_InFcsErrorsPathAny {
	return &Interface_Subinterface_Counters_InFcsErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-fcs-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMulticastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were addressed to a multicast
// address at this sub-layer.  For a MAC-layer protocol,
// this includes both Group and Functional addresses.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-multicast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-multicast-pkts"
func (n *Interface_Subinterface_CountersPath) InMulticastPkts() *Interface_Subinterface_Counters_InMulticastPktsPath {
	return &Interface_Subinterface_Counters_InMulticastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-multicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMulticastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were addressed to a multicast
// address at this sub-layer.  For a MAC-layer protocol,
// this includes both Group and Functional addresses.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-multicast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-multicast-pkts"
func (n *Interface_Subinterface_CountersPathAny) InMulticastPkts() *Interface_Subinterface_Counters_InMulticastPktsPathAny {
	return &Interface_Subinterface_Counters_InMulticastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-multicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received on the interface,
// including framing characters.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-octets"
func (n *Interface_Subinterface_CountersPath) InOctets() *Interface_Subinterface_Counters_InOctetsPath {
	return &Interface_Subinterface_Counters_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received on the interface,
// including framing characters.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-octets"
func (n *Interface_Subinterface_CountersPathAny) InOctets() *Interface_Subinterface_Counters_InOctetsPathAny {
	return &Interface_Subinterface_Counters_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of packets received on the interface,
// including all unicast, multicast, broadcast and bad packets
// etc.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-pkts"
func (n *Interface_Subinterface_CountersPath) InPkts() *Interface_Subinterface_Counters_InPktsPath {
	return &Interface_Subinterface_Counters_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of packets received on the interface,
// including all unicast, multicast, broadcast and bad packets
// etc.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-pkts"
func (n *Interface_Subinterface_CountersPathAny) InPkts() *Interface_Subinterface_Counters_InPktsPathAny {
	return &Interface_Subinterface_Counters_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUnicastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were not addressed to a
// multicast or broadcast address at this sub-layer.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-unicast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-unicast-pkts"
func (n *Interface_Subinterface_CountersPath) InUnicastPkts() *Interface_Subinterface_Counters_InUnicastPktsPath {
	return &Interface_Subinterface_Counters_InUnicastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-unicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUnicastPkts (leaf): The number of packets, delivered by this sub-layer to a
// higher (sub-)layer, that were not addressed to a
// multicast or broadcast address at this sub-layer.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-unicast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-unicast-pkts"
func (n *Interface_Subinterface_CountersPathAny) InUnicastPkts() *Interface_Subinterface_Counters_InUnicastPktsPathAny {
	return &Interface_Subinterface_Counters_InUnicastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-unicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUnknownProtos (leaf): For packet-oriented interfaces, the number of packets
// received via the interface that were discarded because
// of an unknown or unsupported protocol.  For
// character-oriented or fixed-length interfaces that
// support protocol multiplexing, the number of
// transmission units received via the interface that were
// discarded because of an unknown or unsupported protocol.
// For any interface that does not support protocol
// multiplexing, this counter is not present.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-unknown-protos"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-unknown-protos"
func (n *Interface_Subinterface_CountersPath) InUnknownProtos() *Interface_Subinterface_Counters_InUnknownProtosPath {
	return &Interface_Subinterface_Counters_InUnknownProtosPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-unknown-protos"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUnknownProtos (leaf): For packet-oriented interfaces, the number of packets
// received via the interface that were discarded because
// of an unknown or unsupported protocol.  For
// character-oriented or fixed-length interfaces that
// support protocol multiplexing, the number of
// transmission units received via the interface that were
// discarded because of an unknown or unsupported protocol.
// For any interface that does not support protocol
// multiplexing, this counter is not present.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-unknown-protos"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/in-unknown-protos"
func (n *Interface_Subinterface_CountersPathAny) InUnknownProtos() *Interface_Subinterface_Counters_InUnknownProtosPathAny {
	return &Interface_Subinterface_Counters_InUnknownProtosPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-unknown-protos"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Timestamp of the last time the interface counters were
// cleared.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "last-clear"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/last-clear"
func (n *Interface_Subinterface_CountersPath) LastClear() *Interface_Subinterface_Counters_LastClearPath {
	return &Interface_Subinterface_Counters_LastClearPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Timestamp of the last time the interface counters were
// cleared.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "last-clear"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/last-clear"
func (n *Interface_Subinterface_CountersPathAny) LastClear() *Interface_Subinterface_Counters_LastClearPathAny {
	return &Interface_Subinterface_Counters_LastClearPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutBroadcastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were addressed to a
// broadcast address at this sub-layer, including those
// that were discarded or not sent.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-broadcast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-broadcast-pkts"
func (n *Interface_Subinterface_CountersPath) OutBroadcastPkts() *Interface_Subinterface_Counters_OutBroadcastPktsPath {
	return &Interface_Subinterface_Counters_OutBroadcastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-broadcast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutBroadcastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were addressed to a
// broadcast address at this sub-layer, including those
// that were discarded or not sent.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-broadcast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-broadcast-pkts"
func (n *Interface_Subinterface_CountersPathAny) OutBroadcastPkts() *Interface_Subinterface_Counters_OutBroadcastPktsPathAny {
	return &Interface_Subinterface_Counters_OutBroadcastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-broadcast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscards (leaf): The number of outbound packets that were chosen to be
// discarded even though no errors had been detected to
// prevent their being transmitted.  One possible reason
// for discarding such a packet could be to free up buffer
// space.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discards"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-discards"
func (n *Interface_Subinterface_CountersPath) OutDiscards() *Interface_Subinterface_Counters_OutDiscardsPath {
	return &Interface_Subinterface_Counters_OutDiscardsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-discards"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscards (leaf): The number of outbound packets that were chosen to be
// discarded even though no errors had been detected to
// prevent their being transmitted.  One possible reason
// for discarding such a packet could be to free up buffer
// space.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discards"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-discards"
func (n *Interface_Subinterface_CountersPathAny) OutDiscards() *Interface_Subinterface_Counters_OutDiscardsPathAny {
	return &Interface_Subinterface_Counters_OutDiscardsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-discards"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrors (leaf): For packet-oriented interfaces, the number of outbound
// packets that could not be transmitted because of errors.
// For character-oriented or fixed-length interfaces, the
// number of outbound transmission units that could not be
// transmitted because of errors.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-errors"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-errors"
func (n *Interface_Subinterface_CountersPath) OutErrors() *Interface_Subinterface_Counters_OutErrorsPath {
	return &Interface_Subinterface_Counters_OutErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrors (leaf): For packet-oriented interfaces, the number of outbound
// packets that could not be transmitted because of errors.
// For character-oriented or fixed-length interfaces, the
// number of outbound transmission units that could not be
// transmitted because of errors.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-errors"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-errors"
func (n *Interface_Subinterface_CountersPathAny) OutErrors() *Interface_Subinterface_Counters_OutErrorsPathAny {
	return &Interface_Subinterface_Counters_OutErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMulticastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were addressed to a
// multicast address at this sub-layer, including those
// that were discarded or not sent.  For a MAC-layer
// protocol, this includes both Group and Functional
// addresses.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-multicast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-multicast-pkts"
func (n *Interface_Subinterface_CountersPath) OutMulticastPkts() *Interface_Subinterface_Counters_OutMulticastPktsPath {
	return &Interface_Subinterface_Counters_OutMulticastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-multicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMulticastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were addressed to a
// multicast address at this sub-layer, including those
// that were discarded or not sent.  For a MAC-layer
// protocol, this includes both Group and Functional
// addresses.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-multicast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-multicast-pkts"
func (n *Interface_Subinterface_CountersPathAny) OutMulticastPkts() *Interface_Subinterface_Counters_OutMulticastPktsPathAny {
	return &Interface_Subinterface_Counters_OutMulticastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-multicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets transmitted out of the
// interface, including framing characters.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-octets"
func (n *Interface_Subinterface_CountersPath) OutOctets() *Interface_Subinterface_Counters_OutOctetsPath {
	return &Interface_Subinterface_Counters_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets transmitted out of the
// interface, including framing characters.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-octets"
func (n *Interface_Subinterface_CountersPathAny) OutOctets() *Interface_Subinterface_Counters_OutOctetsPathAny {
	return &Interface_Subinterface_Counters_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of packets transmitted out of the
// interface, including all unicast, multicast, broadcast,
// and bad packets etc.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-pkts"
func (n *Interface_Subinterface_CountersPath) OutPkts() *Interface_Subinterface_Counters_OutPktsPath {
	return &Interface_Subinterface_Counters_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of packets transmitted out of the
// interface, including all unicast, multicast, broadcast,
// and bad packets etc.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-pkts"
func (n *Interface_Subinterface_CountersPathAny) OutPkts() *Interface_Subinterface_Counters_OutPktsPathAny {
	return &Interface_Subinterface_Counters_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutUnicastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were not addressed
// to a multicast or broadcast address at this sub-layer,
// including those that were discarded or not sent.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-unicast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-unicast-pkts"
func (n *Interface_Subinterface_CountersPath) OutUnicastPkts() *Interface_Subinterface_Counters_OutUnicastPktsPath {
	return &Interface_Subinterface_Counters_OutUnicastPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-unicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutUnicastPkts (leaf): The total number of packets that higher-level protocols
// requested be transmitted, and that were not addressed
// to a multicast or broadcast address at this sub-layer,
// including those that were discarded or not sent.
//
// Discontinuities in the value of this counter can occur
// at re-initialization of the management system, and at
// other times as indicated by the value of
// 'last-clear'.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-unicast-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/state/counters/out-unicast-pkts"
func (n *Interface_Subinterface_CountersPathAny) OutUnicastPkts() *Interface_Subinterface_Counters_OutUnicastPktsPathAny {
	return &Interface_Subinterface_Counters_OutUnicastPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-unicast-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv4Path represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4 YANG schema element.
type Interface_Subinterface_Ipv4Path struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4PathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4 YANG schema element.
type Interface_Subinterface_Ipv4PathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_DhcpClientPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/config/dhcp-client YANG schema element.
type Interface_Subinterface_Ipv4_DhcpClientPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_DhcpClientPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/config/dhcp-client YANG schema element.
type Interface_Subinterface_Ipv4_DhcpClientPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_EnabledPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/config/enabled YANG schema element.
type Interface_Subinterface_Ipv4_EnabledPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/config/enabled YANG schema element.
type Interface_Subinterface_Ipv4_EnabledPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_MtuPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/config/mtu YANG schema element.
type Interface_Subinterface_Ipv4_MtuPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_MtuPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/config/mtu YANG schema element.
type Interface_Subinterface_Ipv4_MtuPathAny struct {
	*ygot.NodePath
}

// AddressAny (list): The list of configured IPv4 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address"
// Ip (wildcarded): string
func (n *Interface_Subinterface_Ipv4Path) AddressAny() *Interface_Subinterface_Ipv4_AddressPathAny {
	return &Interface_Subinterface_Ipv4_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// AddressAny (list): The list of configured IPv4 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address"
// Ip (wildcarded): string
func (n *Interface_Subinterface_Ipv4PathAny) AddressAny() *Interface_Subinterface_Ipv4_AddressPathAny {
	return &Interface_Subinterface_Ipv4_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// Address (list): The list of configured IPv4 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address"
// Ip: string
func (n *Interface_Subinterface_Ipv4Path) Address(Ip string) *Interface_Subinterface_Ipv4_AddressPath {
	return &Interface_Subinterface_Ipv4_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Address (list): The list of configured IPv4 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address"
// Ip: string
func (n *Interface_Subinterface_Ipv4PathAny) Address(Ip string) *Interface_Subinterface_Ipv4_AddressPathAny {
	return &Interface_Subinterface_Ipv4_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Counters (container): Packet and byte counters for IP transmission and
// reception for the address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters"
func (n *Interface_Subinterface_Ipv4Path) Counters() *Interface_Subinterface_Ipv4_CountersPath {
	return &Interface_Subinterface_Ipv4_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Packet and byte counters for IP transmission and
// reception for the address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters"
func (n *Interface_Subinterface_Ipv4PathAny) Counters() *Interface_Subinterface_Ipv4_CountersPathAny {
	return &Interface_Subinterface_Ipv4_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpClient (leaf): Enables a DHCP client on the interface in order to request
// an address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dhcp-client"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/config/dhcp-client"
func (n *Interface_Subinterface_Ipv4Path) DhcpClient() *Interface_Subinterface_Ipv4_DhcpClientPath {
	return &Interface_Subinterface_Ipv4_DhcpClientPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dhcp-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpClient (leaf): Enables a DHCP client on the interface in order to request
// an address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dhcp-client"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/config/dhcp-client"
func (n *Interface_Subinterface_Ipv4PathAny) DhcpClient() *Interface_Subinterface_Ipv4_DhcpClientPathAny {
	return &Interface_Subinterface_Ipv4_DhcpClientPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dhcp-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Controls whether IPv4 is enabled or disabled on this
// interface.  When IPv4 is enabled, this interface is
// connected to an IPv4 stack, and the interface can send
// and receive IPv4 packets.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/config/enabled"
func (n *Interface_Subinterface_Ipv4Path) Enabled() *Interface_Subinterface_Ipv4_EnabledPath {
	return &Interface_Subinterface_Ipv4_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Controls whether IPv4 is enabled or disabled on this
// interface.  When IPv4 is enabled, this interface is
// connected to an IPv4 stack, and the interface can send
// and receive IPv4 packets.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/config/enabled"
func (n *Interface_Subinterface_Ipv4PathAny) Enabled() *Interface_Subinterface_Ipv4_EnabledPathAny {
	return &Interface_Subinterface_Ipv4_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The size, in octets, of the largest IPv4 packet that the
// interface will send and receive.
//
// The server may restrict the allowed values for this leaf,
// depending on the interface's type.
//
// If this leaf is not configured, the operationally used MTU
// depends on the interface's type.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/config/mtu"
func (n *Interface_Subinterface_Ipv4Path) Mtu() *Interface_Subinterface_Ipv4_MtuPath {
	return &Interface_Subinterface_Ipv4_MtuPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The size, in octets, of the largest IPv4 packet that the
// interface will send and receive.
//
// The server may restrict the allowed values for this leaf,
// depending on the interface's type.
//
// If this leaf is not configured, the operationally used MTU
// depends on the interface's type.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/config/mtu"
func (n *Interface_Subinterface_Ipv4PathAny) Mtu() *Interface_Subinterface_Ipv4_MtuPathAny {
	return &Interface_Subinterface_Ipv4_MtuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): A list of mappings from IPv4 addresses to
// link-layer addresses.
//
// Entries in this list are used as static entries in the
// ARP Cache.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor"
// Ip (wildcarded): string
func (n *Interface_Subinterface_Ipv4Path) NeighborAny() *Interface_Subinterface_Ipv4_NeighborPathAny {
	return &Interface_Subinterface_Ipv4_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// NeighborAny (list): A list of mappings from IPv4 addresses to
// link-layer addresses.
//
// Entries in this list are used as static entries in the
// ARP Cache.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor"
// Ip (wildcarded): string
func (n *Interface_Subinterface_Ipv4PathAny) NeighborAny() *Interface_Subinterface_Ipv4_NeighborPathAny {
	return &Interface_Subinterface_Ipv4_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// Neighbor (list): A list of mappings from IPv4 addresses to
// link-layer addresses.
//
// Entries in this list are used as static entries in the
// ARP Cache.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor"
// Ip: string
func (n *Interface_Subinterface_Ipv4Path) Neighbor(Ip string) *Interface_Subinterface_Ipv4_NeighborPath {
	return &Interface_Subinterface_Ipv4_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Neighbor (list): A list of mappings from IPv4 addresses to
// link-layer addresses.
//
// Entries in this list are used as static entries in the
// ARP Cache.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor"
// Ip: string
func (n *Interface_Subinterface_Ipv4PathAny) Neighbor(Ip string) *Interface_Subinterface_Ipv4_NeighborPathAny {
	return &Interface_Subinterface_Ipv4_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// ProxyArp (container): Configuration and operational state parameters
// relating to proxy ARP. This functionality allows a
// system to respond to ARP requests that are not
// explicitly destined to the local system.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "proxy-arp"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/proxy-arp"
func (n *Interface_Subinterface_Ipv4Path) ProxyArp() *Interface_Subinterface_Ipv4_ProxyArpPath {
	return &Interface_Subinterface_Ipv4_ProxyArpPath{
		NodePath: ygot.NewNodePath(
			[]string{"proxy-arp"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProxyArp (container): Configuration and operational state parameters
// relating to proxy ARP. This functionality allows a
// system to respond to ARP requests that are not
// explicitly destined to the local system.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "proxy-arp"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/proxy-arp"
func (n *Interface_Subinterface_Ipv4PathAny) ProxyArp() *Interface_Subinterface_Ipv4_ProxyArpPathAny {
	return &Interface_Subinterface_Ipv4_ProxyArpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"proxy-arp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unnumbered (container): Top-level container for setting unnumbered interfaces.
// Includes reference the interface that provides the
// address information
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "unnumbered"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered"
func (n *Interface_Subinterface_Ipv4Path) Unnumbered() *Interface_Subinterface_Ipv4_UnnumberedPath {
	return &Interface_Subinterface_Ipv4_UnnumberedPath{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unnumbered (container): Top-level container for setting unnumbered interfaces.
// Includes reference the interface that provides the
// address information
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "unnumbered"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered"
func (n *Interface_Subinterface_Ipv4PathAny) Unnumbered() *Interface_Subinterface_Ipv4_UnnumberedPathAny {
	return &Interface_Subinterface_Ipv4_UnnumberedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv4_AddressPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address YANG schema element.
type Interface_Subinterface_Ipv4_AddressPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_AddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address YANG schema element.
type Interface_Subinterface_Ipv4_AddressPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_IpPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/config/ip YANG schema element.
type Interface_Subinterface_Ipv4_Address_IpPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_IpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/config/ip YANG schema element.
type Interface_Subinterface_Ipv4_Address_IpPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_OriginPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/state/origin YANG schema element.
type Interface_Subinterface_Ipv4_Address_OriginPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_OriginPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/state/origin YANG schema element.
type Interface_Subinterface_Ipv4_Address_OriginPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_PrefixLengthPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/config/prefix-length YANG schema element.
type Interface_Subinterface_Ipv4_Address_PrefixLengthPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_PrefixLengthPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/config/prefix-length YANG schema element.
type Interface_Subinterface_Ipv4_Address_PrefixLengthPathAny struct {
	*ygot.NodePath
}

// Ip (leaf): The IPv4 address on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/config/ip"
func (n *Interface_Subinterface_Ipv4_AddressPath) Ip() *Interface_Subinterface_Ipv4_Address_IpPath {
	return &Interface_Subinterface_Ipv4_Address_IpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ip (leaf): The IPv4 address on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/config/ip"
func (n *Interface_Subinterface_Ipv4_AddressPathAny) Ip() *Interface_Subinterface_Ipv4_Address_IpPathAny {
	return &Interface_Subinterface_Ipv4_Address_IpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this address, e.g., statically configured,
// assigned by DHCP, etc..
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/state/origin"
func (n *Interface_Subinterface_Ipv4_AddressPath) Origin() *Interface_Subinterface_Ipv4_Address_OriginPath {
	return &Interface_Subinterface_Ipv4_Address_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this address, e.g., statically configured,
// assigned by DHCP, etc..
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/state/origin"
func (n *Interface_Subinterface_Ipv4_AddressPathAny) Origin() *Interface_Subinterface_Ipv4_Address_OriginPathAny {
	return &Interface_Subinterface_Ipv4_Address_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the subnet prefix.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/prefix-length"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/config/prefix-length"
func (n *Interface_Subinterface_Ipv4_AddressPath) PrefixLength() *Interface_Subinterface_Ipv4_Address_PrefixLengthPath {
	return &Interface_Subinterface_Ipv4_Address_PrefixLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the subnet prefix.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/prefix-length"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/config/prefix-length"
func (n *Interface_Subinterface_Ipv4_AddressPathAny) PrefixLength() *Interface_Subinterface_Ipv4_Address_PrefixLengthPathAny {
	return &Interface_Subinterface_Ipv4_Address_PrefixLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// VrrpGroupAny (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group"
// VirtualRouterId (wildcarded): uint8
func (n *Interface_Subinterface_Ipv4_AddressPath) VrrpGroupAny() *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": "*"},
			n,
		),
	}
}

// VrrpGroupAny (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group"
// VirtualRouterId (wildcarded): uint8
func (n *Interface_Subinterface_Ipv4_AddressPathAny) VrrpGroupAny() *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": "*"},
			n,
		),
	}
}

// VrrpGroup (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group"
// VirtualRouterId: uint8
func (n *Interface_Subinterface_Ipv4_AddressPath) VrrpGroup(VirtualRouterId uint8) *Interface_Subinterface_Ipv4_Address_VrrpGroupPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": VirtualRouterId},
			n,
		),
	}
}

// VrrpGroup (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group"
// VirtualRouterId: uint8
func (n *Interface_Subinterface_Ipv4_AddressPathAny) VrrpGroup(VirtualRouterId uint8) *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": VirtualRouterId},
			n,
		),
	}
}

// Interface_Subinterface_Ipv4_Address_VrrpGroupPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroupPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_AcceptModePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/accept-mode YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_AcceptModePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_AcceptModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/accept-mode YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_AcceptModePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_AdvertisementIntervalPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/advertisement-interval YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_AdvertisementIntervalPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_AdvertisementIntervalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/advertisement-interval YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_AdvertisementIntervalPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_CurrentPriorityPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/state/current-priority YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_CurrentPriorityPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_CurrentPriorityPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/state/current-priority YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_CurrentPriorityPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/preempt YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/preempt YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptDelayPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/preempt-delay YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptDelayPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptDelayPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/preempt-delay YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptDelayPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_PriorityPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/priority YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_PriorityPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_PriorityPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/priority YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_PriorityPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualAddressPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-address YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualAddressPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-address YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualAddressPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualRouterIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-router-id YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualRouterIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualRouterIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-router-id YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualRouterIdPathAny struct {
	*ygot.NodePath
}

// AcceptMode (leaf): Configure whether packets destined for
// virtual addresses are accepted even when the virtual
// address is not owned by the router interface
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/accept-mode"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/accept-mode"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPath) AcceptMode() *Interface_Subinterface_Ipv4_Address_VrrpGroup_AcceptModePath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_AcceptModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accept-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AcceptMode (leaf): Configure whether packets destined for
// virtual addresses are accepted even when the virtual
// address is not owned by the router interface
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/accept-mode"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/accept-mode"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny) AcceptMode() *Interface_Subinterface_Ipv4_Address_VrrpGroup_AcceptModePathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_AcceptModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accept-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisementInterval (leaf): Sets the interval between successive VRRP
// advertisements -- RFC 5798 defines this as a 12-bit
// value expressed as 0.1 seconds, with default 100, i.e.,
// 1 second.  Several implementation express this in units of
// seconds
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/advertisement-interval"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/advertisement-interval"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPath) AdvertisementInterval() *Interface_Subinterface_Ipv4_Address_VrrpGroup_AdvertisementIntervalPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_AdvertisementIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisementInterval (leaf): Sets the interval between successive VRRP
// advertisements -- RFC 5798 defines this as a 12-bit
// value expressed as 0.1 seconds, with default 100, i.e.,
// 1 second.  Several implementation express this in units of
// seconds
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/advertisement-interval"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/advertisement-interval"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny) AdvertisementInterval() *Interface_Subinterface_Ipv4_Address_VrrpGroup_AdvertisementIntervalPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_AdvertisementIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPriority (leaf): Operational value of the priority for the
// interface in the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/current-priority"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/state/current-priority"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPath) CurrentPriority() *Interface_Subinterface_Ipv4_Address_VrrpGroup_CurrentPriorityPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_CurrentPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPriority (leaf): Operational value of the priority for the
// interface in the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/current-priority"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/state/current-priority"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny) CurrentPriority() *Interface_Subinterface_Ipv4_Address_VrrpGroup_CurrentPriorityPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_CurrentPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceTracking (container): Top-level container for VRRP interface tracking
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-tracking"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPath) InterfaceTracking() *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-tracking"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceTracking (container): Top-level container for VRRP interface tracking
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-tracking"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny) InterfaceTracking() *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-tracking"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preempt (leaf): When set to true, enables preemption by a higher
// priority backup router of a lower priority master router
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/preempt"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPath) Preempt() *Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preempt (leaf): When set to true, enables preemption by a higher
// priority backup router of a lower priority master router
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/preempt"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny) Preempt() *Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreemptDelay (leaf): Set the delay the higher priority router waits
// before preempting
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt-delay"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/preempt-delay"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPath) PreemptDelay() *Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptDelayPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreemptDelay (leaf): Set the delay the higher priority router waits
// before preempting
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt-delay"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/preempt-delay"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny) PreemptDelay() *Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptDelayPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_PreemptDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Specifies the sending VRRP interface's priority
// for the virtual router.  Higher values equal higher
// priority
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/priority"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPath) Priority() *Interface_Subinterface_Ipv4_Address_VrrpGroup_PriorityPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Specifies the sending VRRP interface's priority
// for the virtual router.  Higher values equal higher
// priority
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/priority"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny) Priority() *Interface_Subinterface_Ipv4_Address_VrrpGroup_PriorityPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualAddress (leaf): Configure one or more virtual addresses for the
// VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-address"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPath) VirtualAddress() *Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualAddressPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualAddress (leaf): Configure one or more virtual addresses for the
// VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-address"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny) VirtualAddress() *Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualAddressPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualRouterId (leaf): Set the virtual router id for use by the VRRP group.  This
// usually also determines the virtual MAC address that is
// generated for the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-router-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-router-id"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPath) VirtualRouterId() *Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualRouterIdPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualRouterId (leaf): Set the virtual router id for use by the VRRP group.  This
// usually also determines the virtual MAC address that is
// generated for the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-router-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/config/virtual-router-id"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroupPathAny) VirtualRouterId() *Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualRouterIdPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_VirtualRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface YANG schema element.
type Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny struct {
	*ygot.NodePath
}

// PriorityDecrement (leaf): Set the value to subtract from priority when
// the tracked interface goes down
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority-decrement"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPath) PriorityDecrement() *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority-decrement"},
			map[string]interface{}{},
			n,
		),
	}
}

// PriorityDecrement (leaf): Set the value to subtract from priority when
// the tracked interface goes down
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority-decrement"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny) PriorityDecrement() *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority-decrement"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrackInterface (leaf): Sets a list of one or more interfaces that should
// be tracked for up/down events to dynamically change the
// priority state of the VRRP group, and potentially
// change the mastership if the tracked interface going
// down lowers the priority sufficiently.  Any of the tracked
// interfaces going down will cause the priority to be lowered.
// Some implementations may only support a single
// tracked interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/track-interface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPath) TrackInterface() *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "track-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrackInterface (leaf): Sets a list of one or more interfaces that should
// be tracked for up/down events to dynamically change the
// priority state of the VRRP group, and potentially
// change the mastership if the tracked interface going
// down lowers the priority sufficiently.  Any of the tracked
// interfaces going down will cause the priority to be lowered.
// Some implementations may only support a single
// tracked interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/track-interface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface"
func (n *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTrackingPathAny) TrackInterface() *Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny {
	return &Interface_Subinterface_Ipv4_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "track-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv4_CountersPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters YANG schema element.
type Interface_Subinterface_Ipv4_CountersPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_CountersPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters YANG schema element.
type Interface_Subinterface_Ipv4_CountersPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InDiscardedPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-discarded-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InDiscardedPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InDiscardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-discarded-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InDiscardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InErrorPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-error-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InErrorPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InErrorPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-error-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InErrorPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InForwardedOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-forwarded-octets YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InForwardedOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InForwardedOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-forwarded-octets YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InForwardedOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InForwardedPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-forwarded-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InForwardedPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InForwardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-forwarded-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InForwardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-octets YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-octets YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_InPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_InPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutDiscardedPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-discarded-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutDiscardedPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutDiscardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-discarded-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutDiscardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutErrorPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-error-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutErrorPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutErrorPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-error-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutErrorPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutForwardedOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-forwarded-octets YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutForwardedOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutForwardedOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-forwarded-octets YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutForwardedOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutForwardedPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-forwarded-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutForwardedPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutForwardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-forwarded-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutForwardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-octets YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-octets YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Counters_OutPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-pkts YANG schema element.
type Interface_Subinterface_Ipv4_Counters_OutPktsPathAny struct {
	*ygot.NodePath
}

// InDiscardedPkts (leaf): The number of input IP packets for the
// specified address family, for which no problems were
// encountered to prevent their continued processing, but
// were discarded (e.g., for lack of buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-discarded-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPath) InDiscardedPkts() *Interface_Subinterface_Ipv4_Counters_InDiscardedPktsPath {
	return &Interface_Subinterface_Ipv4_Counters_InDiscardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InDiscardedPkts (leaf): The number of input IP packets for the
// specified address family, for which no problems were
// encountered to prevent their continued processing, but
// were discarded (e.g., for lack of buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-discarded-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) InDiscardedPkts() *Interface_Subinterface_Ipv4_Counters_InDiscardedPktsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_InDiscardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrorPkts (leaf): Number of IP packets discarded due to errors for the
// specified address family, including errors in the IP
// header, no route found to the IP destination, invalid
// address, unknown protocol, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-error-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-error-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPath) InErrorPkts() *Interface_Subinterface_Ipv4_Counters_InErrorPktsPath {
	return &Interface_Subinterface_Ipv4_Counters_InErrorPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrorPkts (leaf): Number of IP packets discarded due to errors for the
// specified address family, including errors in the IP
// header, no route found to the IP destination, invalid
// address, unknown protocol, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-error-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-error-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) InErrorPkts() *Interface_Subinterface_Ipv4_Counters_InErrorPktsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_InErrorPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedOctets (leaf): The number of octets received in input IP packets
// for the specified address family for which the device was
// not their final IP destination and for which the
// device attempted to find a route to forward them to that
// final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-forwarded-octets"
func (n *Interface_Subinterface_Ipv4_CountersPath) InForwardedOctets() *Interface_Subinterface_Ipv4_Counters_InForwardedOctetsPath {
	return &Interface_Subinterface_Ipv4_Counters_InForwardedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedOctets (leaf): The number of octets received in input IP packets
// for the specified address family for which the device was
// not their final IP destination and for which the
// device attempted to find a route to forward them to that
// final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-forwarded-octets"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) InForwardedOctets() *Interface_Subinterface_Ipv4_Counters_InForwardedOctetsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_InForwardedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedPkts (leaf): The number of input packets for which the device was not
// their final IP destination and for which the device
// attempted to find a route to forward them to that final
// destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-forwarded-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPath) InForwardedPkts() *Interface_Subinterface_Ipv4_Counters_InForwardedPktsPath {
	return &Interface_Subinterface_Ipv4_Counters_InForwardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedPkts (leaf): The number of input packets for which the device was not
// their final IP destination and for which the device
// attempted to find a route to forward them to that final
// destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-forwarded-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) InForwardedPkts() *Interface_Subinterface_Ipv4_Counters_InForwardedPktsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_InForwardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received in input IP packets
// for the specified address family, including those received
// in error.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-octets"
func (n *Interface_Subinterface_Ipv4_CountersPath) InOctets() *Interface_Subinterface_Ipv4_Counters_InOctetsPath {
	return &Interface_Subinterface_Ipv4_Counters_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received in input IP packets
// for the specified address family, including those received
// in error.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-octets"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) InOctets() *Interface_Subinterface_Ipv4_Counters_InOctetsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of IP packets received for the specified
// address family, including those received in error
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPath) InPkts() *Interface_Subinterface_Ipv4_Counters_InPktsPath {
	return &Interface_Subinterface_Ipv4_Counters_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of IP packets received for the specified
// address family, including those received in error
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/in-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) InPkts() *Interface_Subinterface_Ipv4_Counters_InPktsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscardedPkts (leaf): The number of output IP packets for the
// specified address family for which no problem was
// encountered to prevent their transmission to their
// destination, but were discarded (e.g., for lack of
// buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-discarded-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPath) OutDiscardedPkts() *Interface_Subinterface_Ipv4_Counters_OutDiscardedPktsPath {
	return &Interface_Subinterface_Ipv4_Counters_OutDiscardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscardedPkts (leaf): The number of output IP packets for the
// specified address family for which no problem was
// encountered to prevent their transmission to their
// destination, but were discarded (e.g., for lack of
// buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-discarded-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) OutDiscardedPkts() *Interface_Subinterface_Ipv4_Counters_OutDiscardedPktsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_OutDiscardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrorPkts (leaf): Number of IP packets for the specified address family
// locally generated and discarded due to errors, including
// no route found to the IP destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-error-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-error-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPath) OutErrorPkts() *Interface_Subinterface_Ipv4_Counters_OutErrorPktsPath {
	return &Interface_Subinterface_Ipv4_Counters_OutErrorPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrorPkts (leaf): Number of IP packets for the specified address family
// locally generated and discarded due to errors, including
// no route found to the IP destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-error-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-error-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) OutErrorPkts() *Interface_Subinterface_Ipv4_Counters_OutErrorPktsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_OutErrorPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedOctets (leaf): The number of octets in packets for which this entity was
// not their final IP destination and for which it was
// successful in finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-forwarded-octets"
func (n *Interface_Subinterface_Ipv4_CountersPath) OutForwardedOctets() *Interface_Subinterface_Ipv4_Counters_OutForwardedOctetsPath {
	return &Interface_Subinterface_Ipv4_Counters_OutForwardedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedOctets (leaf): The number of octets in packets for which this entity was
// not their final IP destination and for which it was
// successful in finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-forwarded-octets"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) OutForwardedOctets() *Interface_Subinterface_Ipv4_Counters_OutForwardedOctetsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_OutForwardedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedPkts (leaf): The number of packets for which this entity was not their
// final IP destination and for which it was successful in
// finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-forwarded-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPath) OutForwardedPkts() *Interface_Subinterface_Ipv4_Counters_OutForwardedPktsPath {
	return &Interface_Subinterface_Ipv4_Counters_OutForwardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedPkts (leaf): The number of packets for which this entity was not their
// final IP destination and for which it was successful in
// finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-forwarded-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) OutForwardedPkts() *Interface_Subinterface_Ipv4_Counters_OutForwardedPktsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_OutForwardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets in IP packets for the
// specified address family that the device
// supplied to the lower layers for transmission.  This
// includes packets generated locally and those forwarded by
// the device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-octets"
func (n *Interface_Subinterface_Ipv4_CountersPath) OutOctets() *Interface_Subinterface_Ipv4_Counters_OutOctetsPath {
	return &Interface_Subinterface_Ipv4_Counters_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets in IP packets for the
// specified address family that the device
// supplied to the lower layers for transmission.  This
// includes packets generated locally and those forwarded by
// the device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-octets"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) OutOctets() *Interface_Subinterface_Ipv4_Counters_OutOctetsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of IP packets for the
// specified address family that the device supplied
// to the lower layers for transmission.  This includes
// packets generated locally and those forwarded by the
// device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPath) OutPkts() *Interface_Subinterface_Ipv4_Counters_OutPktsPath {
	return &Interface_Subinterface_Ipv4_Counters_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of IP packets for the
// specified address family that the device supplied
// to the lower layers for transmission.  This includes
// packets generated locally and those forwarded by the
// device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/state/counters/out-pkts"
func (n *Interface_Subinterface_Ipv4_CountersPathAny) OutPkts() *Interface_Subinterface_Ipv4_Counters_OutPktsPathAny {
	return &Interface_Subinterface_Ipv4_Counters_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv4_NeighborPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor YANG schema element.
type Interface_Subinterface_Ipv4_NeighborPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_NeighborPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor YANG schema element.
type Interface_Subinterface_Ipv4_NeighborPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Neighbor_IpPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/config/ip YANG schema element.
type Interface_Subinterface_Ipv4_Neighbor_IpPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Neighbor_IpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/config/ip YANG schema element.
type Interface_Subinterface_Ipv4_Neighbor_IpPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Neighbor_LinkLayerAddressPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/config/link-layer-address YANG schema element.
type Interface_Subinterface_Ipv4_Neighbor_LinkLayerAddressPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Neighbor_LinkLayerAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/config/link-layer-address YANG schema element.
type Interface_Subinterface_Ipv4_Neighbor_LinkLayerAddressPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Neighbor_OriginPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/state/origin YANG schema element.
type Interface_Subinterface_Ipv4_Neighbor_OriginPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Neighbor_OriginPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/state/origin YANG schema element.
type Interface_Subinterface_Ipv4_Neighbor_OriginPathAny struct {
	*ygot.NodePath
}

// Ip (leaf): The IPv4 address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/config/ip"
func (n *Interface_Subinterface_Ipv4_NeighborPath) Ip() *Interface_Subinterface_Ipv4_Neighbor_IpPath {
	return &Interface_Subinterface_Ipv4_Neighbor_IpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ip (leaf): The IPv4 address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/config/ip"
func (n *Interface_Subinterface_Ipv4_NeighborPathAny) Ip() *Interface_Subinterface_Ipv4_Neighbor_IpPathAny {
	return &Interface_Subinterface_Ipv4_Neighbor_IpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLayerAddress (leaf): The link-layer address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/link-layer-address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/config/link-layer-address"
func (n *Interface_Subinterface_Ipv4_NeighborPath) LinkLayerAddress() *Interface_Subinterface_Ipv4_Neighbor_LinkLayerAddressPath {
	return &Interface_Subinterface_Ipv4_Neighbor_LinkLayerAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-layer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLayerAddress (leaf): The link-layer address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/link-layer-address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/config/link-layer-address"
func (n *Interface_Subinterface_Ipv4_NeighborPathAny) LinkLayerAddress() *Interface_Subinterface_Ipv4_Neighbor_LinkLayerAddressPathAny {
	return &Interface_Subinterface_Ipv4_Neighbor_LinkLayerAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-layer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this neighbor entry, static or dynamic.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/state/origin"
func (n *Interface_Subinterface_Ipv4_NeighborPath) Origin() *Interface_Subinterface_Ipv4_Neighbor_OriginPath {
	return &Interface_Subinterface_Ipv4_Neighbor_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this neighbor entry, static or dynamic.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/neighbors/neighbor/state/origin"
func (n *Interface_Subinterface_Ipv4_NeighborPathAny) Origin() *Interface_Subinterface_Ipv4_Neighbor_OriginPathAny {
	return &Interface_Subinterface_Ipv4_Neighbor_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv4_ProxyArpPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/proxy-arp YANG schema element.
type Interface_Subinterface_Ipv4_ProxyArpPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_ProxyArpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/proxy-arp YANG schema element.
type Interface_Subinterface_Ipv4_ProxyArpPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_ProxyArp_ModePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/proxy-arp/config/mode YANG schema element.
type Interface_Subinterface_Ipv4_ProxyArp_ModePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_ProxyArp_ModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/proxy-arp/config/mode YANG schema element.
type Interface_Subinterface_Ipv4_ProxyArp_ModePathAny struct {
	*ygot.NodePath
}

// Mode (leaf): When set to a value other than DISABLE, the local system should
// respond to ARP requests that are for target addresses other than
// those that are configured on the local subinterface using its own
// MAC address as the target hardware address. If the REMOTE_ONLY
// value is specified, replies are only sent when the target address
// falls outside the locally configured subnets on the interface,
// whereas with the ALL value, all requests, regardless of their
// target address are replied to.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mode"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/proxy-arp/config/mode"
func (n *Interface_Subinterface_Ipv4_ProxyArpPath) Mode() *Interface_Subinterface_Ipv4_ProxyArp_ModePath {
	return &Interface_Subinterface_Ipv4_ProxyArp_ModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): When set to a value other than DISABLE, the local system should
// respond to ARP requests that are for target addresses other than
// those that are configured on the local subinterface using its own
// MAC address as the target hardware address. If the REMOTE_ONLY
// value is specified, replies are only sent when the target address
// falls outside the locally configured subnets on the interface,
// whereas with the ALL value, all requests, regardless of their
// target address are replied to.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mode"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/proxy-arp/config/mode"
func (n *Interface_Subinterface_Ipv4_ProxyArpPathAny) Mode() *Interface_Subinterface_Ipv4_ProxyArp_ModePathAny {
	return &Interface_Subinterface_Ipv4_ProxyArp_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv4_UnnumberedPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered YANG schema element.
type Interface_Subinterface_Ipv4_UnnumberedPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_UnnumberedPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered YANG schema element.
type Interface_Subinterface_Ipv4_UnnumberedPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Unnumbered_EnabledPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/config/enabled YANG schema element.
type Interface_Subinterface_Ipv4_Unnumbered_EnabledPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Unnumbered_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/config/enabled YANG schema element.
type Interface_Subinterface_Ipv4_Unnumbered_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Indicates that the subinterface is unnumbered.  By default
// the subinterface is numbered, i.e., expected to have an
// IP address configuration.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/config/enabled"
func (n *Interface_Subinterface_Ipv4_UnnumberedPath) Enabled() *Interface_Subinterface_Ipv4_Unnumbered_EnabledPath {
	return &Interface_Subinterface_Ipv4_Unnumbered_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Indicates that the subinterface is unnumbered.  By default
// the subinterface is numbered, i.e., expected to have an
// IP address configuration.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/config/enabled"
func (n *Interface_Subinterface_Ipv4_UnnumberedPathAny) Enabled() *Interface_Subinterface_Ipv4_Unnumbered_EnabledPathAny {
	return &Interface_Subinterface_Ipv4_Unnumbered_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-ref"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref"
func (n *Interface_Subinterface_Ipv4_UnnumberedPath) InterfaceRef() *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPath {
	return &Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-ref"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref"
func (n *Interface_Subinterface_Ipv4_UnnumberedPathAny) InterfaceRef() *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPathAny {
	return &Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref YANG schema element.
type Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref YANG schema element.
type Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_InterfacePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref/config/interface YANG schema element.
type Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref/config/interface YANG schema element.
type Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_SubinterfacePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref/config/subinterface YANG schema element.
type Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref/config/subinterface YANG schema element.
type Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref/config/interface"
func (n *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPath) Interface() *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_InterfacePath {
	return &Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref/config/interface"
func (n *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPathAny) Interface() *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_InterfacePathAny {
	return &Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/subinterface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref/config/subinterface"
func (n *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPath) Subinterface() *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_SubinterfacePath {
	return &Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/subinterface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv4/unnumbered/interface-ref/config/subinterface"
func (n *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRefPathAny) Subinterface() *Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_SubinterfacePathAny {
	return &Interface_Subinterface_Ipv4_Unnumbered_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6Path represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6 YANG schema element.
type Interface_Subinterface_Ipv6Path struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6PathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6 YANG schema element.
type Interface_Subinterface_Ipv6PathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_DhcpClientPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/config/dhcp-client YANG schema element.
type Interface_Subinterface_Ipv6_DhcpClientPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_DhcpClientPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/config/dhcp-client YANG schema element.
type Interface_Subinterface_Ipv6_DhcpClientPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_DupAddrDetectTransmitsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/config/dup-addr-detect-transmits YANG schema element.
type Interface_Subinterface_Ipv6_DupAddrDetectTransmitsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_DupAddrDetectTransmitsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/config/dup-addr-detect-transmits YANG schema element.
type Interface_Subinterface_Ipv6_DupAddrDetectTransmitsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_EnabledPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/config/enabled YANG schema element.
type Interface_Subinterface_Ipv6_EnabledPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/config/enabled YANG schema element.
type Interface_Subinterface_Ipv6_EnabledPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_MtuPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/config/mtu YANG schema element.
type Interface_Subinterface_Ipv6_MtuPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_MtuPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/config/mtu YANG schema element.
type Interface_Subinterface_Ipv6_MtuPathAny struct {
	*ygot.NodePath
}

// AddressAny (list): The list of configured IPv6 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address"
// Ip (wildcarded): string
func (n *Interface_Subinterface_Ipv6Path) AddressAny() *Interface_Subinterface_Ipv6_AddressPathAny {
	return &Interface_Subinterface_Ipv6_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// AddressAny (list): The list of configured IPv6 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address"
// Ip (wildcarded): string
func (n *Interface_Subinterface_Ipv6PathAny) AddressAny() *Interface_Subinterface_Ipv6_AddressPathAny {
	return &Interface_Subinterface_Ipv6_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// Address (list): The list of configured IPv6 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address"
// Ip: string
func (n *Interface_Subinterface_Ipv6Path) Address(Ip string) *Interface_Subinterface_Ipv6_AddressPath {
	return &Interface_Subinterface_Ipv6_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Address (list): The list of configured IPv6 addresses on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "addresses/address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address"
// Ip: string
func (n *Interface_Subinterface_Ipv6PathAny) Address(Ip string) *Interface_Subinterface_Ipv6_AddressPathAny {
	return &Interface_Subinterface_Ipv6_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"addresses", "address"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Autoconf (container): Top-level container for IPv6 autoconf
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "autoconf"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf"
func (n *Interface_Subinterface_Ipv6Path) Autoconf() *Interface_Subinterface_Ipv6_AutoconfPath {
	return &Interface_Subinterface_Ipv6_AutoconfPath{
		NodePath: ygot.NewNodePath(
			[]string{"autoconf"},
			map[string]interface{}{},
			n,
		),
	}
}

// Autoconf (container): Top-level container for IPv6 autoconf
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "autoconf"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf"
func (n *Interface_Subinterface_Ipv6PathAny) Autoconf() *Interface_Subinterface_Ipv6_AutoconfPathAny {
	return &Interface_Subinterface_Ipv6_AutoconfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"autoconf"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Packet and byte counters for IP transmission and
// reception for the address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters"
func (n *Interface_Subinterface_Ipv6Path) Counters() *Interface_Subinterface_Ipv6_CountersPath {
	return &Interface_Subinterface_Ipv6_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Packet and byte counters for IP transmission and
// reception for the address family.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/counters"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters"
func (n *Interface_Subinterface_Ipv6PathAny) Counters() *Interface_Subinterface_Ipv6_CountersPathAny {
	return &Interface_Subinterface_Ipv6_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpClient (leaf): Enables a DHCP client on the interface in order to request
// an address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dhcp-client"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/config/dhcp-client"
func (n *Interface_Subinterface_Ipv6Path) DhcpClient() *Interface_Subinterface_Ipv6_DhcpClientPath {
	return &Interface_Subinterface_Ipv6_DhcpClientPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dhcp-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpClient (leaf): Enables a DHCP client on the interface in order to request
// an address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dhcp-client"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/config/dhcp-client"
func (n *Interface_Subinterface_Ipv6PathAny) DhcpClient() *Interface_Subinterface_Ipv6_DhcpClientPathAny {
	return &Interface_Subinterface_Ipv6_DhcpClientPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dhcp-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// DupAddrDetectTransmits (leaf): The number of consecutive Neighbor Solicitation messages
// sent while performing Duplicate Address Detection on a
// tentative address.  A value of zero indicates that
// Duplicate Address Detection is not performed on
// tentative addresses.  A value of one indicates a single
// transmission with no follow-up retransmissions.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dup-addr-detect-transmits"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/config/dup-addr-detect-transmits"
func (n *Interface_Subinterface_Ipv6Path) DupAddrDetectTransmits() *Interface_Subinterface_Ipv6_DupAddrDetectTransmitsPath {
	return &Interface_Subinterface_Ipv6_DupAddrDetectTransmitsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dup-addr-detect-transmits"},
			map[string]interface{}{},
			n,
		),
	}
}

// DupAddrDetectTransmits (leaf): The number of consecutive Neighbor Solicitation messages
// sent while performing Duplicate Address Detection on a
// tentative address.  A value of zero indicates that
// Duplicate Address Detection is not performed on
// tentative addresses.  A value of one indicates a single
// transmission with no follow-up retransmissions.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/dup-addr-detect-transmits"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/config/dup-addr-detect-transmits"
func (n *Interface_Subinterface_Ipv6PathAny) DupAddrDetectTransmits() *Interface_Subinterface_Ipv6_DupAddrDetectTransmitsPathAny {
	return &Interface_Subinterface_Ipv6_DupAddrDetectTransmitsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dup-addr-detect-transmits"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Controls whether IPv6 is enabled or disabled on this
// interface.  When IPv6 is enabled, this interface is
// connected to an IPv6 stack, and the interface can send
// and receive IPv6 packets.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/config/enabled"
func (n *Interface_Subinterface_Ipv6Path) Enabled() *Interface_Subinterface_Ipv6_EnabledPath {
	return &Interface_Subinterface_Ipv6_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Controls whether IPv6 is enabled or disabled on this
// interface.  When IPv6 is enabled, this interface is
// connected to an IPv6 stack, and the interface can send
// and receive IPv6 packets.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/config/enabled"
func (n *Interface_Subinterface_Ipv6PathAny) Enabled() *Interface_Subinterface_Ipv6_EnabledPathAny {
	return &Interface_Subinterface_Ipv6_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The size, in octets, of the largest IPv6 packet that the
// interface will send and receive.
//
// The server may restrict the allowed values for this leaf,
// depending on the interface's type.
//
// If this leaf is not configured, the operationally used MTU
// depends on the interface's type.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/config/mtu"
func (n *Interface_Subinterface_Ipv6Path) Mtu() *Interface_Subinterface_Ipv6_MtuPath {
	return &Interface_Subinterface_Ipv6_MtuPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The size, in octets, of the largest IPv6 packet that the
// interface will send and receive.
//
// The server may restrict the allowed values for this leaf,
// depending on the interface's type.
//
// If this leaf is not configured, the operationally used MTU
// depends on the interface's type.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/mtu"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/config/mtu"
func (n *Interface_Subinterface_Ipv6PathAny) Mtu() *Interface_Subinterface_Ipv6_MtuPathAny {
	return &Interface_Subinterface_Ipv6_MtuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): List of IPv6 neighbors
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor"
// Ip (wildcarded): string
func (n *Interface_Subinterface_Ipv6Path) NeighborAny() *Interface_Subinterface_Ipv6_NeighborPathAny {
	return &Interface_Subinterface_Ipv6_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of IPv6 neighbors
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor"
// Ip (wildcarded): string
func (n *Interface_Subinterface_Ipv6PathAny) NeighborAny() *Interface_Subinterface_Ipv6_NeighborPathAny {
	return &Interface_Subinterface_Ipv6_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": "*"},
			n,
		),
	}
}

// Neighbor (list): List of IPv6 neighbors
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor"
// Ip: string
func (n *Interface_Subinterface_Ipv6Path) Neighbor(Ip string) *Interface_Subinterface_Ipv6_NeighborPath {
	return &Interface_Subinterface_Ipv6_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// Neighbor (list): List of IPv6 neighbors
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "neighbors/neighbor"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor"
// Ip: string
func (n *Interface_Subinterface_Ipv6PathAny) Neighbor(Ip string) *Interface_Subinterface_Ipv6_NeighborPathAny {
	return &Interface_Subinterface_Ipv6_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"ip": Ip},
			n,
		),
	}
}

// RouterAdvertisement (container): Configuration and operational state parameters relating to
// router advertisements.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "router-advertisement"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement"
func (n *Interface_Subinterface_Ipv6Path) RouterAdvertisement() *Interface_Subinterface_Ipv6_RouterAdvertisementPath {
	return &Interface_Subinterface_Ipv6_RouterAdvertisementPath{
		NodePath: ygot.NewNodePath(
			[]string{"router-advertisement"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterAdvertisement (container): Configuration and operational state parameters relating to
// router advertisements.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "router-advertisement"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement"
func (n *Interface_Subinterface_Ipv6PathAny) RouterAdvertisement() *Interface_Subinterface_Ipv6_RouterAdvertisementPathAny {
	return &Interface_Subinterface_Ipv6_RouterAdvertisementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"router-advertisement"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unnumbered (container): Top-level container for setting unnumbered interfaces.
// Includes reference the interface that provides the
// address information
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "unnumbered"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered"
func (n *Interface_Subinterface_Ipv6Path) Unnumbered() *Interface_Subinterface_Ipv6_UnnumberedPath {
	return &Interface_Subinterface_Ipv6_UnnumberedPath{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unnumbered (container): Top-level container for setting unnumbered interfaces.
// Includes reference the interface that provides the
// address information
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "unnumbered"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered"
func (n *Interface_Subinterface_Ipv6PathAny) Unnumbered() *Interface_Subinterface_Ipv6_UnnumberedPathAny {
	return &Interface_Subinterface_Ipv6_UnnumberedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6_AddressPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address YANG schema element.
type Interface_Subinterface_Ipv6_AddressPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_AddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address YANG schema element.
type Interface_Subinterface_Ipv6_AddressPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_IpPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/config/ip YANG schema element.
type Interface_Subinterface_Ipv6_Address_IpPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_IpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/config/ip YANG schema element.
type Interface_Subinterface_Ipv6_Address_IpPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_OriginPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/state/origin YANG schema element.
type Interface_Subinterface_Ipv6_Address_OriginPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_OriginPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/state/origin YANG schema element.
type Interface_Subinterface_Ipv6_Address_OriginPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_PrefixLengthPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/config/prefix-length YANG schema element.
type Interface_Subinterface_Ipv6_Address_PrefixLengthPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_PrefixLengthPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/config/prefix-length YANG schema element.
type Interface_Subinterface_Ipv6_Address_PrefixLengthPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_StatusPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/state/status YANG schema element.
type Interface_Subinterface_Ipv6_Address_StatusPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_StatusPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/state/status YANG schema element.
type Interface_Subinterface_Ipv6_Address_StatusPathAny struct {
	*ygot.NodePath
}

// Ip (leaf): The IPv6 address on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/config/ip"
func (n *Interface_Subinterface_Ipv6_AddressPath) Ip() *Interface_Subinterface_Ipv6_Address_IpPath {
	return &Interface_Subinterface_Ipv6_Address_IpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ip (leaf): The IPv6 address on the interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/config/ip"
func (n *Interface_Subinterface_Ipv6_AddressPathAny) Ip() *Interface_Subinterface_Ipv6_Address_IpPathAny {
	return &Interface_Subinterface_Ipv6_Address_IpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this address, e.g., static, dhcp, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/state/origin"
func (n *Interface_Subinterface_Ipv6_AddressPath) Origin() *Interface_Subinterface_Ipv6_Address_OriginPath {
	return &Interface_Subinterface_Ipv6_Address_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this address, e.g., static, dhcp, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/state/origin"
func (n *Interface_Subinterface_Ipv6_AddressPathAny) Origin() *Interface_Subinterface_Ipv6_Address_OriginPathAny {
	return &Interface_Subinterface_Ipv6_Address_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the subnet prefix.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/prefix-length"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/config/prefix-length"
func (n *Interface_Subinterface_Ipv6_AddressPath) PrefixLength() *Interface_Subinterface_Ipv6_Address_PrefixLengthPath {
	return &Interface_Subinterface_Ipv6_Address_PrefixLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the subnet prefix.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/prefix-length"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/config/prefix-length"
func (n *Interface_Subinterface_Ipv6_AddressPathAny) PrefixLength() *Interface_Subinterface_Ipv6_Address_PrefixLengthPathAny {
	return &Interface_Subinterface_Ipv6_Address_PrefixLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Status (leaf): The status of an address.  Most of the states correspond
// to states from the IPv6 Stateless Address
// Autoconfiguration protocol.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/status"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/state/status"
func (n *Interface_Subinterface_Ipv6_AddressPath) Status() *Interface_Subinterface_Ipv6_Address_StatusPath {
	return &Interface_Subinterface_Ipv6_Address_StatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "status"},
			map[string]interface{}{},
			n,
		),
	}
}

// Status (leaf): The status of an address.  Most of the states correspond
// to states from the IPv6 Stateless Address
// Autoconfiguration protocol.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/status"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/state/status"
func (n *Interface_Subinterface_Ipv6_AddressPathAny) Status() *Interface_Subinterface_Ipv6_Address_StatusPathAny {
	return &Interface_Subinterface_Ipv6_Address_StatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "status"},
			map[string]interface{}{},
			n,
		),
	}
}

// VrrpGroupAny (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group"
// VirtualRouterId (wildcarded): uint8
func (n *Interface_Subinterface_Ipv6_AddressPath) VrrpGroupAny() *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": "*"},
			n,
		),
	}
}

// VrrpGroupAny (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group"
// VirtualRouterId (wildcarded): uint8
func (n *Interface_Subinterface_Ipv6_AddressPathAny) VrrpGroupAny() *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": "*"},
			n,
		),
	}
}

// VrrpGroup (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group"
// VirtualRouterId: uint8
func (n *Interface_Subinterface_Ipv6_AddressPath) VrrpGroup(VirtualRouterId uint8) *Interface_Subinterface_Ipv6_Address_VrrpGroupPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": VirtualRouterId},
			n,
		),
	}
}

// VrrpGroup (list): List of VRRP groups, keyed by virtual router id
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "vrrp/vrrp-group"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group"
// VirtualRouterId: uint8
func (n *Interface_Subinterface_Ipv6_AddressPathAny) VrrpGroup(VirtualRouterId uint8) *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vrrp", "vrrp-group"},
			map[string]interface{}{"virtual-router-id": VirtualRouterId},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6_Address_VrrpGroupPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroupPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_AcceptModePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/accept-mode YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_AcceptModePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_AcceptModePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/accept-mode YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_AcceptModePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_AdvertisementIntervalPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/advertisement-interval YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_AdvertisementIntervalPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_AdvertisementIntervalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/advertisement-interval YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_AdvertisementIntervalPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_CurrentPriorityPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/state/current-priority YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_CurrentPriorityPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_CurrentPriorityPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/state/current-priority YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_CurrentPriorityPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/preempt YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/preempt YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptDelayPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/preempt-delay YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptDelayPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptDelayPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/preempt-delay YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptDelayPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_PriorityPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/priority YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_PriorityPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_PriorityPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/priority YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_PriorityPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualAddressPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-address YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualAddressPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-address YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualAddressPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualLinkLocalPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-link-local YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualLinkLocalPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualLinkLocalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-link-local YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualLinkLocalPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualRouterIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-router-id YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualRouterIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualRouterIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-router-id YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualRouterIdPathAny struct {
	*ygot.NodePath
}

// AcceptMode (leaf): Configure whether packets destined for
// virtual addresses are accepted even when the virtual
// address is not owned by the router interface
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/accept-mode"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/accept-mode"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) AcceptMode() *Interface_Subinterface_Ipv6_Address_VrrpGroup_AcceptModePath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_AcceptModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accept-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AcceptMode (leaf): Configure whether packets destined for
// virtual addresses are accepted even when the virtual
// address is not owned by the router interface
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/accept-mode"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/accept-mode"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) AcceptMode() *Interface_Subinterface_Ipv6_Address_VrrpGroup_AcceptModePathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_AcceptModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accept-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisementInterval (leaf): Sets the interval between successive VRRP
// advertisements -- RFC 5798 defines this as a 12-bit
// value expressed as 0.1 seconds, with default 100, i.e.,
// 1 second.  Several implementation express this in units of
// seconds
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/advertisement-interval"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/advertisement-interval"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) AdvertisementInterval() *Interface_Subinterface_Ipv6_Address_VrrpGroup_AdvertisementIntervalPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_AdvertisementIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisementInterval (leaf): Sets the interval between successive VRRP
// advertisements -- RFC 5798 defines this as a 12-bit
// value expressed as 0.1 seconds, with default 100, i.e.,
// 1 second.  Several implementation express this in units of
// seconds
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/advertisement-interval"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/advertisement-interval"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) AdvertisementInterval() *Interface_Subinterface_Ipv6_Address_VrrpGroup_AdvertisementIntervalPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_AdvertisementIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPriority (leaf): Operational value of the priority for the
// interface in the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/current-priority"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/state/current-priority"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) CurrentPriority() *Interface_Subinterface_Ipv6_Address_VrrpGroup_CurrentPriorityPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_CurrentPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPriority (leaf): Operational value of the priority for the
// interface in the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/current-priority"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/state/current-priority"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) CurrentPriority() *Interface_Subinterface_Ipv6_Address_VrrpGroup_CurrentPriorityPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_CurrentPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceTracking (container): Top-level container for VRRP interface tracking
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-tracking"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) InterfaceTracking() *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-tracking"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceTracking (container): Top-level container for VRRP interface tracking
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-tracking"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) InterfaceTracking() *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-tracking"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preempt (leaf): When set to true, enables preemption by a higher
// priority backup router of a lower priority master router
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/preempt"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) Preempt() *Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preempt (leaf): When set to true, enables preemption by a higher
// priority backup router of a lower priority master router
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/preempt"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) Preempt() *Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreemptDelay (leaf): Set the delay the higher priority router waits
// before preempting
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt-delay"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/preempt-delay"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) PreemptDelay() *Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptDelayPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreemptDelay (leaf): Set the delay the higher priority router waits
// before preempting
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/preempt-delay"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/preempt-delay"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) PreemptDelay() *Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptDelayPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_PreemptDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preempt-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Specifies the sending VRRP interface's priority
// for the virtual router.  Higher values equal higher
// priority
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/priority"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) Priority() *Interface_Subinterface_Ipv6_Address_VrrpGroup_PriorityPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Specifies the sending VRRP interface's priority
// for the virtual router.  Higher values equal higher
// priority
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/priority"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) Priority() *Interface_Subinterface_Ipv6_Address_VrrpGroup_PriorityPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualAddress (leaf): Configure one or more virtual addresses for the
// VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-address"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) VirtualAddress() *Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualAddressPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualAddress (leaf): Configure one or more virtual addresses for the
// VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-address"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) VirtualAddress() *Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualAddressPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualLinkLocal (leaf): For VRRP on IPv6 interfaces, sets the virtual link local
// address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-link-local"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-link-local"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) VirtualLinkLocal() *Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualLinkLocalPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualLinkLocalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-link-local"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualLinkLocal (leaf): For VRRP on IPv6 interfaces, sets the virtual link local
// address
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-link-local"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-link-local"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) VirtualLinkLocal() *Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualLinkLocalPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualLinkLocalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-link-local"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualRouterId (leaf): Set the virtual router id for use by the VRRP group.  This
// usually also determines the virtual MAC address that is
// generated for the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-router-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-router-id"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPath) VirtualRouterId() *Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualRouterIdPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualRouterId (leaf): Set the virtual router id for use by the VRRP group.  This
// usually also determines the virtual MAC address that is
// generated for the VRRP group
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/virtual-router-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/config/virtual-router-id"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroupPathAny) VirtualRouterId() *Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualRouterIdPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_VirtualRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface YANG schema element.
type Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny struct {
	*ygot.NodePath
}

// PriorityDecrement (leaf): Set the value to subtract from priority when
// the tracked interface goes down
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority-decrement"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPath) PriorityDecrement() *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority-decrement"},
			map[string]interface{}{},
			n,
		),
	}
}

// PriorityDecrement (leaf): Set the value to subtract from priority when
// the tracked interface goes down
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/priority-decrement"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/priority-decrement"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny) PriorityDecrement() *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_PriorityDecrementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority-decrement"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrackInterface (leaf): Sets a list of one or more interfaces that should
// be tracked for up/down events to dynamically change the
// priority state of the VRRP group, and potentially
// change the mastership if the tracked interface going
// down lowers the priority sufficiently.  Any of the tracked
// interfaces going down will cause the priority to be lowered.
// Some implementations may only support a single
// tracked interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/track-interface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPath) TrackInterface() *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "track-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrackInterface (leaf): Sets a list of one or more interfaces that should
// be tracked for up/down events to dynamically change the
// priority state of the VRRP group, and potentially
// change the mastership if the tracked interface going
// down lowers the priority sufficiently.  Any of the tracked
// interfaces going down will cause the priority to be lowered.
// Some implementations may only support a single
// tracked interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/track-interface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/addresses/address/vrrp/vrrp-group/interface-tracking/config/track-interface"
func (n *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTrackingPathAny) TrackInterface() *Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny {
	return &Interface_Subinterface_Ipv6_Address_VrrpGroup_InterfaceTracking_TrackInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "track-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6_AutoconfPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf YANG schema element.
type Interface_Subinterface_Ipv6_AutoconfPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_AutoconfPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf YANG schema element.
type Interface_Subinterface_Ipv6_AutoconfPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Autoconf_CreateGlobalAddressesPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/create-global-addresses YANG schema element.
type Interface_Subinterface_Ipv6_Autoconf_CreateGlobalAddressesPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Autoconf_CreateGlobalAddressesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/create-global-addresses YANG schema element.
type Interface_Subinterface_Ipv6_Autoconf_CreateGlobalAddressesPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Autoconf_CreateTemporaryAddressesPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/create-temporary-addresses YANG schema element.
type Interface_Subinterface_Ipv6_Autoconf_CreateTemporaryAddressesPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Autoconf_CreateTemporaryAddressesPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/create-temporary-addresses YANG schema element.
type Interface_Subinterface_Ipv6_Autoconf_CreateTemporaryAddressesPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Autoconf_TemporaryPreferredLifetimePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/temporary-preferred-lifetime YANG schema element.
type Interface_Subinterface_Ipv6_Autoconf_TemporaryPreferredLifetimePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Autoconf_TemporaryPreferredLifetimePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/temporary-preferred-lifetime YANG schema element.
type Interface_Subinterface_Ipv6_Autoconf_TemporaryPreferredLifetimePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Autoconf_TemporaryValidLifetimePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/temporary-valid-lifetime YANG schema element.
type Interface_Subinterface_Ipv6_Autoconf_TemporaryValidLifetimePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Autoconf_TemporaryValidLifetimePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/temporary-valid-lifetime YANG schema element.
type Interface_Subinterface_Ipv6_Autoconf_TemporaryValidLifetimePathAny struct {
	*ygot.NodePath
}

// CreateGlobalAddresses (leaf): [adapted from IETF IP model RFC 7277]
//
// If enabled, the host creates global addresses as
// described in RFC 4862.
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/create-global-addresses"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/create-global-addresses"
func (n *Interface_Subinterface_Ipv6_AutoconfPath) CreateGlobalAddresses() *Interface_Subinterface_Ipv6_Autoconf_CreateGlobalAddressesPath {
	return &Interface_Subinterface_Ipv6_Autoconf_CreateGlobalAddressesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "create-global-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// CreateGlobalAddresses (leaf): [adapted from IETF IP model RFC 7277]
//
// If enabled, the host creates global addresses as
// described in RFC 4862.
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/create-global-addresses"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/create-global-addresses"
func (n *Interface_Subinterface_Ipv6_AutoconfPathAny) CreateGlobalAddresses() *Interface_Subinterface_Ipv6_Autoconf_CreateGlobalAddressesPathAny {
	return &Interface_Subinterface_Ipv6_Autoconf_CreateGlobalAddressesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "create-global-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// CreateTemporaryAddresses (leaf): [adapted from IETF IP model RFC 7277]
//
// If enabled, the host creates temporary addresses as
// described in RFC 4941.
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/create-temporary-addresses"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/create-temporary-addresses"
func (n *Interface_Subinterface_Ipv6_AutoconfPath) CreateTemporaryAddresses() *Interface_Subinterface_Ipv6_Autoconf_CreateTemporaryAddressesPath {
	return &Interface_Subinterface_Ipv6_Autoconf_CreateTemporaryAddressesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "create-temporary-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// CreateTemporaryAddresses (leaf): [adapted from IETF IP model RFC 7277]
//
// If enabled, the host creates temporary addresses as
// described in RFC 4941.
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/create-temporary-addresses"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/create-temporary-addresses"
func (n *Interface_Subinterface_Ipv6_AutoconfPathAny) CreateTemporaryAddresses() *Interface_Subinterface_Ipv6_Autoconf_CreateTemporaryAddressesPathAny {
	return &Interface_Subinterface_Ipv6_Autoconf_CreateTemporaryAddressesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "create-temporary-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// TemporaryPreferredLifetime (leaf): [adapted from IETF IP model RFC 7277]
//
// The time period during which the temporary address is
// preferred.
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/temporary-preferred-lifetime"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/temporary-preferred-lifetime"
func (n *Interface_Subinterface_Ipv6_AutoconfPath) TemporaryPreferredLifetime() *Interface_Subinterface_Ipv6_Autoconf_TemporaryPreferredLifetimePath {
	return &Interface_Subinterface_Ipv6_Autoconf_TemporaryPreferredLifetimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "temporary-preferred-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// TemporaryPreferredLifetime (leaf): [adapted from IETF IP model RFC 7277]
//
// The time period during which the temporary address is
// preferred.
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/temporary-preferred-lifetime"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/temporary-preferred-lifetime"
func (n *Interface_Subinterface_Ipv6_AutoconfPathAny) TemporaryPreferredLifetime() *Interface_Subinterface_Ipv6_Autoconf_TemporaryPreferredLifetimePathAny {
	return &Interface_Subinterface_Ipv6_Autoconf_TemporaryPreferredLifetimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "temporary-preferred-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// TemporaryValidLifetime (leaf): [adapted from IETF IP model RFC 7277]
//
// The time period during which the temporary address
// is valid.
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/temporary-valid-lifetime"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/temporary-valid-lifetime"
func (n *Interface_Subinterface_Ipv6_AutoconfPath) TemporaryValidLifetime() *Interface_Subinterface_Ipv6_Autoconf_TemporaryValidLifetimePath {
	return &Interface_Subinterface_Ipv6_Autoconf_TemporaryValidLifetimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "temporary-valid-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// TemporaryValidLifetime (leaf): [adapted from IETF IP model RFC 7277]
//
// The time period during which the temporary address
// is valid.
// ----------------------------------------
// Defining module: "openconfig-if-ip-ext"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/temporary-valid-lifetime"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/autoconf/config/temporary-valid-lifetime"
func (n *Interface_Subinterface_Ipv6_AutoconfPathAny) TemporaryValidLifetime() *Interface_Subinterface_Ipv6_Autoconf_TemporaryValidLifetimePathAny {
	return &Interface_Subinterface_Ipv6_Autoconf_TemporaryValidLifetimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "temporary-valid-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6_CountersPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters YANG schema element.
type Interface_Subinterface_Ipv6_CountersPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_CountersPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters YANG schema element.
type Interface_Subinterface_Ipv6_CountersPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InDiscardedPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-discarded-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InDiscardedPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InDiscardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-discarded-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InDiscardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InErrorPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-error-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InErrorPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InErrorPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-error-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InErrorPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InForwardedOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-forwarded-octets YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InForwardedOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InForwardedOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-forwarded-octets YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InForwardedOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InForwardedPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-forwarded-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InForwardedPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InForwardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-forwarded-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InForwardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-octets YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-octets YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_InPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_InPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutDiscardedPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-discarded-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutDiscardedPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutDiscardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-discarded-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutDiscardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutErrorPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-error-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutErrorPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutErrorPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-error-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutErrorPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutForwardedOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-forwarded-octets YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutForwardedOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutForwardedOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-forwarded-octets YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutForwardedOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutForwardedPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-forwarded-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutForwardedPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutForwardedPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-forwarded-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutForwardedPktsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutOctetsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-octets YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutOctetsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutOctetsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-octets YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutOctetsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutPktsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutPktsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Counters_OutPktsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-pkts YANG schema element.
type Interface_Subinterface_Ipv6_Counters_OutPktsPathAny struct {
	*ygot.NodePath
}

// InDiscardedPkts (leaf): The number of input IP packets for the
// specified address family, for which no problems were
// encountered to prevent their continued processing, but
// were discarded (e.g., for lack of buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-discarded-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPath) InDiscardedPkts() *Interface_Subinterface_Ipv6_Counters_InDiscardedPktsPath {
	return &Interface_Subinterface_Ipv6_Counters_InDiscardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InDiscardedPkts (leaf): The number of input IP packets for the
// specified address family, for which no problems were
// encountered to prevent their continued processing, but
// were discarded (e.g., for lack of buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-discarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-discarded-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) InDiscardedPkts() *Interface_Subinterface_Ipv6_Counters_InDiscardedPktsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_InDiscardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrorPkts (leaf): Number of IP packets discarded due to errors for the
// specified address family, including errors in the IP
// header, no route found to the IP destination, invalid
// address, unknown protocol, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-error-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-error-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPath) InErrorPkts() *Interface_Subinterface_Ipv6_Counters_InErrorPktsPath {
	return &Interface_Subinterface_Ipv6_Counters_InErrorPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InErrorPkts (leaf): Number of IP packets discarded due to errors for the
// specified address family, including errors in the IP
// header, no route found to the IP destination, invalid
// address, unknown protocol, etc.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-error-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-error-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) InErrorPkts() *Interface_Subinterface_Ipv6_Counters_InErrorPktsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_InErrorPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedOctets (leaf): The number of octets received in input IP packets
// for the specified address family for which the device was
// not their final IP destination and for which the
// device attempted to find a route to forward them to that
// final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-forwarded-octets"
func (n *Interface_Subinterface_Ipv6_CountersPath) InForwardedOctets() *Interface_Subinterface_Ipv6_Counters_InForwardedOctetsPath {
	return &Interface_Subinterface_Ipv6_Counters_InForwardedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedOctets (leaf): The number of octets received in input IP packets
// for the specified address family for which the device was
// not their final IP destination and for which the
// device attempted to find a route to forward them to that
// final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-forwarded-octets"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) InForwardedOctets() *Interface_Subinterface_Ipv6_Counters_InForwardedOctetsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_InForwardedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedPkts (leaf): The number of input packets for which the device was not
// their final IP destination and for which the device
// attempted to find a route to forward them to that final
// destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-forwarded-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPath) InForwardedPkts() *Interface_Subinterface_Ipv6_Counters_InForwardedPktsPath {
	return &Interface_Subinterface_Ipv6_Counters_InForwardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InForwardedPkts (leaf): The number of input packets for which the device was not
// their final IP destination and for which the device
// attempted to find a route to forward them to that final
// destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-forwarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-forwarded-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) InForwardedPkts() *Interface_Subinterface_Ipv6_Counters_InForwardedPktsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_InForwardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received in input IP packets
// for the specified address family, including those received
// in error.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-octets"
func (n *Interface_Subinterface_Ipv6_CountersPath) InOctets() *Interface_Subinterface_Ipv6_Counters_InOctetsPath {
	return &Interface_Subinterface_Ipv6_Counters_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The total number of octets received in input IP packets
// for the specified address family, including those received
// in error.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-octets"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) InOctets() *Interface_Subinterface_Ipv6_Counters_InOctetsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of IP packets received for the specified
// address family, including those received in error
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPath) InPkts() *Interface_Subinterface_Ipv6_Counters_InPktsPath {
	return &Interface_Subinterface_Ipv6_Counters_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): The total number of IP packets received for the specified
// address family, including those received in error
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "in-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/in-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) InPkts() *Interface_Subinterface_Ipv6_Counters_InPktsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscardedPkts (leaf): The number of output IP packets for the
// specified address family for which no problem was
// encountered to prevent their transmission to their
// destination, but were discarded (e.g., for lack of
// buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-discarded-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPath) OutDiscardedPkts() *Interface_Subinterface_Ipv6_Counters_OutDiscardedPktsPath {
	return &Interface_Subinterface_Ipv6_Counters_OutDiscardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutDiscardedPkts (leaf): The number of output IP packets for the
// specified address family for which no problem was
// encountered to prevent their transmission to their
// destination, but were discarded (e.g., for lack of
// buffer space).
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-discarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-discarded-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) OutDiscardedPkts() *Interface_Subinterface_Ipv6_Counters_OutDiscardedPktsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_OutDiscardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-discarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrorPkts (leaf): Number of IP packets for the specified address family
// locally generated and discarded due to errors, including
// no route found to the IP destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-error-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-error-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPath) OutErrorPkts() *Interface_Subinterface_Ipv6_Counters_OutErrorPktsPath {
	return &Interface_Subinterface_Ipv6_Counters_OutErrorPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutErrorPkts (leaf): Number of IP packets for the specified address family
// locally generated and discarded due to errors, including
// no route found to the IP destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-error-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-error-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) OutErrorPkts() *Interface_Subinterface_Ipv6_Counters_OutErrorPktsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_OutErrorPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-error-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedOctets (leaf): The number of octets in packets for which this entity was
// not their final IP destination and for which it was
// successful in finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-forwarded-octets"
func (n *Interface_Subinterface_Ipv6_CountersPath) OutForwardedOctets() *Interface_Subinterface_Ipv6_Counters_OutForwardedOctetsPath {
	return &Interface_Subinterface_Ipv6_Counters_OutForwardedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedOctets (leaf): The number of octets in packets for which this entity was
// not their final IP destination and for which it was
// successful in finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-forwarded-octets"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) OutForwardedOctets() *Interface_Subinterface_Ipv6_Counters_OutForwardedOctetsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_OutForwardedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedPkts (leaf): The number of packets for which this entity was not their
// final IP destination and for which it was successful in
// finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-forwarded-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPath) OutForwardedPkts() *Interface_Subinterface_Ipv6_Counters_OutForwardedPktsPath {
	return &Interface_Subinterface_Ipv6_Counters_OutForwardedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutForwardedPkts (leaf): The number of packets for which this entity was not their
// final IP destination and for which it was successful in
// finding a path to their final destination.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-forwarded-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-forwarded-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) OutForwardedPkts() *Interface_Subinterface_Ipv6_Counters_OutForwardedPktsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_OutForwardedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-forwarded-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets in IP packets for the
// specified address family that the device
// supplied to the lower layers for transmission.  This
// includes packets generated locally and those forwarded by
// the device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-octets"
func (n *Interface_Subinterface_Ipv6_CountersPath) OutOctets() *Interface_Subinterface_Ipv6_Counters_OutOctetsPath {
	return &Interface_Subinterface_Ipv6_Counters_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The total number of octets in IP packets for the
// specified address family that the device
// supplied to the lower layers for transmission.  This
// includes packets generated locally and those forwarded by
// the device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-octets"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-octets"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) OutOctets() *Interface_Subinterface_Ipv6_Counters_OutOctetsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of IP packets for the
// specified address family that the device supplied
// to the lower layers for transmission.  This includes
// packets generated locally and those forwarded by the
// device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPath) OutPkts() *Interface_Subinterface_Ipv6_Counters_OutPktsPath {
	return &Interface_Subinterface_Ipv6_Counters_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): The total number of IP packets for the
// specified address family that the device supplied
// to the lower layers for transmission.  This includes
// packets generated locally and those forwarded by the
// device.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "out-pkts"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/state/counters/out-pkts"
func (n *Interface_Subinterface_Ipv6_CountersPathAny) OutPkts() *Interface_Subinterface_Ipv6_Counters_OutPktsPathAny {
	return &Interface_Subinterface_Ipv6_Counters_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6_NeighborPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor YANG schema element.
type Interface_Subinterface_Ipv6_NeighborPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_NeighborPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor YANG schema element.
type Interface_Subinterface_Ipv6_NeighborPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_IpPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/config/ip YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_IpPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_IpPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/config/ip YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_IpPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_IsRouterPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/is-router YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_IsRouterPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_IsRouterPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/is-router YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_IsRouterPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_LinkLayerAddressPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/config/link-layer-address YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_LinkLayerAddressPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_LinkLayerAddressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/config/link-layer-address YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_LinkLayerAddressPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_NeighborStatePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/neighbor-state YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_NeighborStatePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_NeighborStatePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/neighbor-state YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_NeighborStatePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_OriginPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/origin YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_OriginPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Neighbor_OriginPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/origin YANG schema element.
type Interface_Subinterface_Ipv6_Neighbor_OriginPathAny struct {
	*ygot.NodePath
}

// Ip (leaf): The IPv6 address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/config/ip"
func (n *Interface_Subinterface_Ipv6_NeighborPath) Ip() *Interface_Subinterface_Ipv6_Neighbor_IpPath {
	return &Interface_Subinterface_Ipv6_Neighbor_IpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ip (leaf): The IPv6 address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/ip"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/config/ip"
func (n *Interface_Subinterface_Ipv6_NeighborPathAny) Ip() *Interface_Subinterface_Ipv6_Neighbor_IpPathAny {
	return &Interface_Subinterface_Ipv6_Neighbor_IpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsRouter (leaf): Indicates that the neighbor node acts as a router.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/is-router"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/is-router"
func (n *Interface_Subinterface_Ipv6_NeighborPath) IsRouter() *Interface_Subinterface_Ipv6_Neighbor_IsRouterPath {
	return &Interface_Subinterface_Ipv6_Neighbor_IsRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "is-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsRouter (leaf): Indicates that the neighbor node acts as a router.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/is-router"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/is-router"
func (n *Interface_Subinterface_Ipv6_NeighborPathAny) IsRouter() *Interface_Subinterface_Ipv6_Neighbor_IsRouterPathAny {
	return &Interface_Subinterface_Ipv6_Neighbor_IsRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "is-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLayerAddress (leaf): The link-layer address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/link-layer-address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/config/link-layer-address"
func (n *Interface_Subinterface_Ipv6_NeighborPath) LinkLayerAddress() *Interface_Subinterface_Ipv6_Neighbor_LinkLayerAddressPath {
	return &Interface_Subinterface_Ipv6_Neighbor_LinkLayerAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-layer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLayerAddress (leaf): The link-layer address of the neighbor node.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/link-layer-address"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/config/link-layer-address"
func (n *Interface_Subinterface_Ipv6_NeighborPathAny) LinkLayerAddress() *Interface_Subinterface_Ipv6_Neighbor_LinkLayerAddressPathAny {
	return &Interface_Subinterface_Ipv6_Neighbor_LinkLayerAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-layer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborState (leaf): The Neighbor Unreachability Detection state of this
// entry.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/neighbor-state"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/neighbor-state"
func (n *Interface_Subinterface_Ipv6_NeighborPath) NeighborState() *Interface_Subinterface_Ipv6_Neighbor_NeighborStatePath {
	return &Interface_Subinterface_Ipv6_Neighbor_NeighborStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborState (leaf): The Neighbor Unreachability Detection state of this
// entry.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/neighbor-state"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/neighbor-state"
func (n *Interface_Subinterface_Ipv6_NeighborPathAny) NeighborState() *Interface_Subinterface_Ipv6_Neighbor_NeighborStatePathAny {
	return &Interface_Subinterface_Ipv6_Neighbor_NeighborStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this neighbor entry.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/origin"
func (n *Interface_Subinterface_Ipv6_NeighborPath) Origin() *Interface_Subinterface_Ipv6_Neighbor_OriginPath {
	return &Interface_Subinterface_Ipv6_Neighbor_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): The origin of this neighbor entry.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "state/origin"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/neighbors/neighbor/state/origin"
func (n *Interface_Subinterface_Ipv6_NeighborPathAny) Origin() *Interface_Subinterface_Ipv6_Neighbor_OriginPathAny {
	return &Interface_Subinterface_Ipv6_Neighbor_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6_RouterAdvertisementPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement YANG schema element.
type Interface_Subinterface_Ipv6_RouterAdvertisementPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_RouterAdvertisementPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement YANG schema element.
type Interface_Subinterface_Ipv6_RouterAdvertisementPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_RouterAdvertisement_IntervalPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/interval YANG schema element.
type Interface_Subinterface_Ipv6_RouterAdvertisement_IntervalPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_RouterAdvertisement_IntervalPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/interval YANG schema element.
type Interface_Subinterface_Ipv6_RouterAdvertisement_IntervalPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_RouterAdvertisement_LifetimePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/lifetime YANG schema element.
type Interface_Subinterface_Ipv6_RouterAdvertisement_LifetimePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_RouterAdvertisement_LifetimePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/lifetime YANG schema element.
type Interface_Subinterface_Ipv6_RouterAdvertisement_LifetimePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_RouterAdvertisement_SuppressPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/suppress YANG schema element.
type Interface_Subinterface_Ipv6_RouterAdvertisement_SuppressPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_RouterAdvertisement_SuppressPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/suppress YANG schema element.
type Interface_Subinterface_Ipv6_RouterAdvertisement_SuppressPathAny struct {
	*ygot.NodePath
}

// Interval (leaf): The interval between periodic router advertisement neighbor
// discovery messages sent on this interface expressed in
// seconds.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interval"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/interval"
func (n *Interface_Subinterface_Ipv6_RouterAdvertisementPath) Interval() *Interface_Subinterface_Ipv6_RouterAdvertisement_IntervalPath {
	return &Interface_Subinterface_Ipv6_RouterAdvertisement_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): The interval between periodic router advertisement neighbor
// discovery messages sent on this interface expressed in
// seconds.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interval"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/interval"
func (n *Interface_Subinterface_Ipv6_RouterAdvertisementPathAny) Interval() *Interface_Subinterface_Ipv6_RouterAdvertisement_IntervalPathAny {
	return &Interface_Subinterface_Ipv6_RouterAdvertisement_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lifetime (leaf): The lifetime advertised in the router advertisement neighbor
// discovery message on this interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/lifetime"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/lifetime"
func (n *Interface_Subinterface_Ipv6_RouterAdvertisementPath) Lifetime() *Interface_Subinterface_Ipv6_RouterAdvertisement_LifetimePath {
	return &Interface_Subinterface_Ipv6_RouterAdvertisement_LifetimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lifetime (leaf): The lifetime advertised in the router advertisement neighbor
// discovery message on this interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/lifetime"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/lifetime"
func (n *Interface_Subinterface_Ipv6_RouterAdvertisementPathAny) Lifetime() *Interface_Subinterface_Ipv6_RouterAdvertisement_LifetimePathAny {
	return &Interface_Subinterface_Ipv6_RouterAdvertisement_LifetimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// Suppress (leaf): When set to true, router advertisement neighbor discovery
// messages are not transmitted on this interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/suppress"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/suppress"
func (n *Interface_Subinterface_Ipv6_RouterAdvertisementPath) Suppress() *Interface_Subinterface_Ipv6_RouterAdvertisement_SuppressPath {
	return &Interface_Subinterface_Ipv6_RouterAdvertisement_SuppressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "suppress"},
			map[string]interface{}{},
			n,
		),
	}
}

// Suppress (leaf): When set to true, router advertisement neighbor discovery
// messages are not transmitted on this interface.
// ----------------------------------------
// Defining module: "openconfig-if-ip"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/suppress"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/router-advertisement/config/suppress"
func (n *Interface_Subinterface_Ipv6_RouterAdvertisementPathAny) Suppress() *Interface_Subinterface_Ipv6_RouterAdvertisement_SuppressPathAny {
	return &Interface_Subinterface_Ipv6_RouterAdvertisement_SuppressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "suppress"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6_UnnumberedPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered YANG schema element.
type Interface_Subinterface_Ipv6_UnnumberedPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_UnnumberedPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered YANG schema element.
type Interface_Subinterface_Ipv6_UnnumberedPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Unnumbered_EnabledPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/config/enabled YANG schema element.
type Interface_Subinterface_Ipv6_Unnumbered_EnabledPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Unnumbered_EnabledPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/config/enabled YANG schema element.
type Interface_Subinterface_Ipv6_Unnumbered_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Indicates that the subinterface is unnumbered.  By default
// the subinterface is numbered, i.e., expected to have an
// IP address configuration.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/config/enabled"
func (n *Interface_Subinterface_Ipv6_UnnumberedPath) Enabled() *Interface_Subinterface_Ipv6_Unnumbered_EnabledPath {
	return &Interface_Subinterface_Ipv6_Unnumbered_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Indicates that the subinterface is unnumbered.  By default
// the subinterface is numbered, i.e., expected to have an
// IP address configuration.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/enabled"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/config/enabled"
func (n *Interface_Subinterface_Ipv6_UnnumberedPathAny) Enabled() *Interface_Subinterface_Ipv6_Unnumbered_EnabledPathAny {
	return &Interface_Subinterface_Ipv6_Unnumbered_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-ref"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref"
func (n *Interface_Subinterface_Ipv6_UnnumberedPath) InterfaceRef() *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPath {
	return &Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "interface-ref"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref"
func (n *Interface_Subinterface_Ipv6_UnnumberedPathAny) InterfaceRef() *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPathAny {
	return &Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref YANG schema element.
type Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref YANG schema element.
type Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_InterfacePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref/config/interface YANG schema element.
type Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref/config/interface YANG schema element.
type Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_SubinterfacePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref/config/subinterface YANG schema element.
type Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref/config/subinterface YANG schema element.
type Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref/config/interface"
func (n *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPath) Interface() *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_InterfacePath {
	return &Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/interface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref/config/interface"
func (n *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPathAny) Interface() *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_InterfacePathAny {
	return &Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/subinterface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref/config/subinterface"
func (n *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPath) Subinterface() *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_SubinterfacePath {
	return &Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/subinterface"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/ipv6/unnumbered/interface-ref/config/subinterface"
func (n *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRefPathAny) Subinterface() *Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_SubinterfacePathAny {
	return &Interface_Subinterface_Ipv6_Unnumbered_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_VlanPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan YANG schema element.
type Interface_Subinterface_VlanPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_VlanPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan YANG schema element.
type Interface_Subinterface_VlanPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_VlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/config/vlan-id YANG schema element.
type Interface_Subinterface_Vlan_VlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_VlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/config/vlan-id YANG schema element.
type Interface_Subinterface_Vlan_VlanIdPathAny struct {
	*ygot.NodePath
}

// EgressMapping (container): Egress VLAN and label behaviors for packets that are
// destined for output via this subinterface.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "egress-mapping"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping"
func (n *Interface_Subinterface_VlanPath) EgressMapping() *Interface_Subinterface_Vlan_EgressMappingPath {
	return &Interface_Subinterface_Vlan_EgressMappingPath{
		NodePath: ygot.NewNodePath(
			[]string{"egress-mapping"},
			map[string]interface{}{},
			n,
		),
	}
}

// EgressMapping (container): Egress VLAN and label behaviors for packets that are
// destined for output via this subinterface.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "egress-mapping"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping"
func (n *Interface_Subinterface_VlanPathAny) EgressMapping() *Interface_Subinterface_Vlan_EgressMappingPathAny {
	return &Interface_Subinterface_Vlan_EgressMappingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"egress-mapping"},
			map[string]interface{}{},
			n,
		),
	}
}

// IngressMapping (container): Ingress VLAN stack behaviors for packets that arrive on
// this subinterface after their VLAN idenitifer(s) have been
// matched.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ingress-mapping"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping"
func (n *Interface_Subinterface_VlanPath) IngressMapping() *Interface_Subinterface_Vlan_IngressMappingPath {
	return &Interface_Subinterface_Vlan_IngressMappingPath{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-mapping"},
			map[string]interface{}{},
			n,
		),
	}
}

// IngressMapping (container): Ingress VLAN stack behaviors for packets that arrive on
// this subinterface after their VLAN idenitifer(s) have been
// matched.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "ingress-mapping"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping"
func (n *Interface_Subinterface_VlanPathAny) IngressMapping() *Interface_Subinterface_Vlan_IngressMappingPathAny {
	return &Interface_Subinterface_Vlan_IngressMappingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress-mapping"},
			map[string]interface{}{},
			n,
		),
	}
}

// Match (container): Configuration for various VLAN tag matching schemes,
// including single-tagged 802.1q packets and double-tagged
// 802.1ad 'Q-in-Q' packets. Typically only one of the subordinate
// containers should be specified.
//
// Wildcards may be matched by specifying range values of 2-4094.
// If implementations have a more efficient way to match Wildcards
// then they should recognize this pattern and translate accordingly.
//
// Implementations are expected to return errors for combinations
// that they do not support, or provide deviations to the same effect.
//
// For simple VLAN configurations without an 'egress-mapping' then
// using the 'single-tagged' and 'double-tagged' VLAN matches that
// resolve to specific values, these specify the VLAN identifiers
// applied to packets on egress.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "match"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match"
func (n *Interface_Subinterface_VlanPath) Match() *Interface_Subinterface_Vlan_MatchPath {
	return &Interface_Subinterface_Vlan_MatchPath{
		NodePath: ygot.NewNodePath(
			[]string{"match"},
			map[string]interface{}{},
			n,
		),
	}
}

// Match (container): Configuration for various VLAN tag matching schemes,
// including single-tagged 802.1q packets and double-tagged
// 802.1ad 'Q-in-Q' packets. Typically only one of the subordinate
// containers should be specified.
//
// Wildcards may be matched by specifying range values of 2-4094.
// If implementations have a more efficient way to match Wildcards
// then they should recognize this pattern and translate accordingly.
//
// Implementations are expected to return errors for combinations
// that they do not support, or provide deviations to the same effect.
//
// For simple VLAN configurations without an 'egress-mapping' then
// using the 'single-tagged' and 'double-tagged' VLAN matches that
// resolve to specific values, these specify the VLAN identifiers
// applied to packets on egress.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "match"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match"
func (n *Interface_Subinterface_VlanPathAny) Match() *Interface_Subinterface_Vlan_MatchPathAny {
	return &Interface_Subinterface_Vlan_MatchPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"match"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): VLAN id for the subinterface -- specified inline for the
// case of a local VLAN.  The id is scoped to the
// subinterface, and could be repeated on different
// subinterfaces.
// Deprecation note: See adjacent elements in the 'vlan' container for
// making more expressive VLAN matches.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/config/vlan-id"
func (n *Interface_Subinterface_VlanPath) VlanId() *Interface_Subinterface_Vlan_VlanIdPath {
	return &Interface_Subinterface_Vlan_VlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): VLAN id for the subinterface -- specified inline for the
// case of a local VLAN.  The id is scoped to the
// subinterface, and could be repeated on different
// subinterfaces.
// Deprecation note: See adjacent elements in the 'vlan' container for
// making more expressive VLAN matches.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/config/vlan-id"
func (n *Interface_Subinterface_VlanPathAny) VlanId() *Interface_Subinterface_Vlan_VlanIdPathAny {
	return &Interface_Subinterface_Vlan_VlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_EgressMappingPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping YANG schema element.
type Interface_Subinterface_Vlan_EgressMappingPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_EgressMappingPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping YANG schema element.
type Interface_Subinterface_Vlan_EgressMappingPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_EgressMapping_TpidPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/tpid YANG schema element.
type Interface_Subinterface_Vlan_EgressMapping_TpidPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_EgressMapping_TpidPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/tpid YANG schema element.
type Interface_Subinterface_Vlan_EgressMapping_TpidPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_EgressMapping_VlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/vlan-id YANG schema element.
type Interface_Subinterface_Vlan_EgressMapping_VlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_EgressMapping_VlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/vlan-id YANG schema element.
type Interface_Subinterface_Vlan_EgressMapping_VlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_EgressMapping_VlanStackActionPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/vlan-stack-action YANG schema element.
type Interface_Subinterface_Vlan_EgressMapping_VlanStackActionPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_EgressMapping_VlanStackActionPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/vlan-stack-action YANG schema element.
type Interface_Subinterface_Vlan_EgressMapping_VlanStackActionPathAny struct {
	*ygot.NodePath
}

// Tpid (leaf): Optionally override the tag protocol identifier field (TPID) that
// is used by the action configured by 'vlan-stack-action' when
// modifying the VLAN stack.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/tpid"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/tpid"
func (n *Interface_Subinterface_Vlan_EgressMappingPath) Tpid() *Interface_Subinterface_Vlan_EgressMapping_TpidPath {
	return &Interface_Subinterface_Vlan_EgressMapping_TpidPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tpid (leaf): Optionally override the tag protocol identifier field (TPID) that
// is used by the action configured by 'vlan-stack-action' when
// modifying the VLAN stack.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/tpid"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/tpid"
func (n *Interface_Subinterface_Vlan_EgressMappingPathAny) Tpid() *Interface_Subinterface_Vlan_EgressMapping_TpidPathAny {
	return &Interface_Subinterface_Vlan_EgressMapping_TpidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): Optionally specifies a fixed VLAN identifier that is used by the
// action configured in 'vlan-stack-action'. For example, if the action
// is 'POP' then a VLAN identifier is removed from the stack but the
// value of this leaf is used instead. This value must be non-zero if
// the 'vlan-stack-action' is one of 'PUSH' or 'SWAP'.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/vlan-id"
func (n *Interface_Subinterface_Vlan_EgressMappingPath) VlanId() *Interface_Subinterface_Vlan_EgressMapping_VlanIdPath {
	return &Interface_Subinterface_Vlan_EgressMapping_VlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): Optionally specifies a fixed VLAN identifier that is used by the
// action configured in 'vlan-stack-action'. For example, if the action
// is 'POP' then a VLAN identifier is removed from the stack but the
// value of this leaf is used instead. This value must be non-zero if
// the 'vlan-stack-action' is one of 'PUSH' or 'SWAP'.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/vlan-id"
func (n *Interface_Subinterface_Vlan_EgressMappingPathAny) VlanId() *Interface_Subinterface_Vlan_EgressMapping_VlanIdPathAny {
	return &Interface_Subinterface_Vlan_EgressMapping_VlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanStackAction (leaf): The action to take on the VLAN stack of a packet. This is
// optionally used in conjunction with adjacent leaves to override
// the values of the action.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-stack-action"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/vlan-stack-action"
func (n *Interface_Subinterface_Vlan_EgressMappingPath) VlanStackAction() *Interface_Subinterface_Vlan_EgressMapping_VlanStackActionPath {
	return &Interface_Subinterface_Vlan_EgressMapping_VlanStackActionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-stack-action"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanStackAction (leaf): The action to take on the VLAN stack of a packet. This is
// optionally used in conjunction with adjacent leaves to override
// the values of the action.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-stack-action"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/egress-mapping/config/vlan-stack-action"
func (n *Interface_Subinterface_Vlan_EgressMappingPathAny) VlanStackAction() *Interface_Subinterface_Vlan_EgressMapping_VlanStackActionPathAny {
	return &Interface_Subinterface_Vlan_EgressMapping_VlanStackActionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-stack-action"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_IngressMappingPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping YANG schema element.
type Interface_Subinterface_Vlan_IngressMappingPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_IngressMappingPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping YANG schema element.
type Interface_Subinterface_Vlan_IngressMappingPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_IngressMapping_TpidPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/tpid YANG schema element.
type Interface_Subinterface_Vlan_IngressMapping_TpidPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_IngressMapping_TpidPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/tpid YANG schema element.
type Interface_Subinterface_Vlan_IngressMapping_TpidPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_IngressMapping_VlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/vlan-id YANG schema element.
type Interface_Subinterface_Vlan_IngressMapping_VlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_IngressMapping_VlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/vlan-id YANG schema element.
type Interface_Subinterface_Vlan_IngressMapping_VlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_IngressMapping_VlanStackActionPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/vlan-stack-action YANG schema element.
type Interface_Subinterface_Vlan_IngressMapping_VlanStackActionPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_IngressMapping_VlanStackActionPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/vlan-stack-action YANG schema element.
type Interface_Subinterface_Vlan_IngressMapping_VlanStackActionPathAny struct {
	*ygot.NodePath
}

// Tpid (leaf): Optionally override the tag protocol identifier field (TPID) that
// is used by the action configured by 'vlan-stack-action' when
// modifying the VLAN stack.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/tpid"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/tpid"
func (n *Interface_Subinterface_Vlan_IngressMappingPath) Tpid() *Interface_Subinterface_Vlan_IngressMapping_TpidPath {
	return &Interface_Subinterface_Vlan_IngressMapping_TpidPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tpid (leaf): Optionally override the tag protocol identifier field (TPID) that
// is used by the action configured by 'vlan-stack-action' when
// modifying the VLAN stack.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/tpid"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/tpid"
func (n *Interface_Subinterface_Vlan_IngressMappingPathAny) Tpid() *Interface_Subinterface_Vlan_IngressMapping_TpidPathAny {
	return &Interface_Subinterface_Vlan_IngressMapping_TpidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): Optionally specifies a fixed VLAN identifier that is used by the
// action configured in 'vlan-stack-action'. For example, if the action
// is 'PUSH' then this VLAN identifier is added to the the stack.
// This value must be non-zero if the 'vlan-stack-action' is one of
// 'PUSH' or 'SWAP'.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/vlan-id"
func (n *Interface_Subinterface_Vlan_IngressMappingPath) VlanId() *Interface_Subinterface_Vlan_IngressMapping_VlanIdPath {
	return &Interface_Subinterface_Vlan_IngressMapping_VlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): Optionally specifies a fixed VLAN identifier that is used by the
// action configured in 'vlan-stack-action'. For example, if the action
// is 'PUSH' then this VLAN identifier is added to the the stack.
// This value must be non-zero if the 'vlan-stack-action' is one of
// 'PUSH' or 'SWAP'.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/vlan-id"
func (n *Interface_Subinterface_Vlan_IngressMappingPathAny) VlanId() *Interface_Subinterface_Vlan_IngressMapping_VlanIdPathAny {
	return &Interface_Subinterface_Vlan_IngressMapping_VlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanStackAction (leaf): The action to take on the VLAN stack of a packet. This is
// optionally used in conjunction with adjacent leaves to override
// the values of the action.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-stack-action"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/vlan-stack-action"
func (n *Interface_Subinterface_Vlan_IngressMappingPath) VlanStackAction() *Interface_Subinterface_Vlan_IngressMapping_VlanStackActionPath {
	return &Interface_Subinterface_Vlan_IngressMapping_VlanStackActionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-stack-action"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanStackAction (leaf): The action to take on the VLAN stack of a packet. This is
// optionally used in conjunction with adjacent leaves to override
// the values of the action.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-stack-action"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/ingress-mapping/config/vlan-stack-action"
func (n *Interface_Subinterface_Vlan_IngressMappingPathAny) VlanStackAction() *Interface_Subinterface_Vlan_IngressMapping_VlanStackActionPathAny {
	return &Interface_Subinterface_Vlan_IngressMapping_VlanStackActionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-stack-action"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_MatchPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match YANG schema element.
type Interface_Subinterface_Vlan_MatchPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_MatchPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match YANG schema element.
type Interface_Subinterface_Vlan_MatchPathAny struct {
	*ygot.NodePath
}

// DoubleTagged (container): Match double-tagged packets against inner exact and outer exact
// VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged"
func (n *Interface_Subinterface_Vlan_MatchPath) DoubleTagged() *Interface_Subinterface_Vlan_Match_DoubleTaggedPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedPath{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTagged (container): Match double-tagged packets against inner exact and outer exact
// VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged"
func (n *Interface_Subinterface_Vlan_MatchPathAny) DoubleTagged() *Interface_Subinterface_Vlan_Match_DoubleTaggedPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedInnerList (container): Match double-tagged packets against an inner list and outer exact
// VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-inner-list"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list"
func (n *Interface_Subinterface_Vlan_MatchPath) DoubleTaggedInnerList() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPath{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-inner-list"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedInnerList (container): Match double-tagged packets against an inner list and outer exact
// VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-inner-list"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list"
func (n *Interface_Subinterface_Vlan_MatchPathAny) DoubleTaggedInnerList() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-inner-list"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedInnerOuterRange (container): Match double-tagged packets against an inner range and an outer
// range of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-inner-outer-range"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range"
func (n *Interface_Subinterface_Vlan_MatchPath) DoubleTaggedInnerOuterRange() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePath{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-inner-outer-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedInnerOuterRange (container): Match double-tagged packets against an inner range and an outer
// range of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-inner-outer-range"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range"
func (n *Interface_Subinterface_Vlan_MatchPathAny) DoubleTaggedInnerOuterRange() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-inner-outer-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedInnerRange (container): Match double-tagged packets against an inner range and outer
// exact VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-inner-range"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range"
func (n *Interface_Subinterface_Vlan_MatchPath) DoubleTaggedInnerRange() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePath{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-inner-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedInnerRange (container): Match double-tagged packets against an inner range and outer
// exact VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-inner-range"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range"
func (n *Interface_Subinterface_Vlan_MatchPathAny) DoubleTaggedInnerRange() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-inner-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedOuterList (container): Match double-tagged packets against an inner exact and outer list
// of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-outer-list"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list"
func (n *Interface_Subinterface_Vlan_MatchPath) DoubleTaggedOuterList() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPath{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-outer-list"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedOuterList (container): Match double-tagged packets against an inner exact and outer list
// of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-outer-list"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list"
func (n *Interface_Subinterface_Vlan_MatchPathAny) DoubleTaggedOuterList() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-outer-list"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedOuterRange (container): Match double-tagged packets against an inner exact and an outer
// range of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-outer-range"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range"
func (n *Interface_Subinterface_Vlan_MatchPath) DoubleTaggedOuterRange() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePath{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-outer-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// DoubleTaggedOuterRange (container): Match double-tagged packets against an inner exact and an outer
// range of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "double-tagged-outer-range"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range"
func (n *Interface_Subinterface_Vlan_MatchPathAny) DoubleTaggedOuterRange() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"double-tagged-outer-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// SingleTagged (container): Match single-tagged packets with an exact VLAN identifier.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "single-tagged"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged"
func (n *Interface_Subinterface_Vlan_MatchPath) SingleTagged() *Interface_Subinterface_Vlan_Match_SingleTaggedPath {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedPath{
		NodePath: ygot.NewNodePath(
			[]string{"single-tagged"},
			map[string]interface{}{},
			n,
		),
	}
}

// SingleTagged (container): Match single-tagged packets with an exact VLAN identifier.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "single-tagged"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged"
func (n *Interface_Subinterface_Vlan_MatchPathAny) SingleTagged() *Interface_Subinterface_Vlan_Match_SingleTaggedPathAny {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"single-tagged"},
			map[string]interface{}{},
			n,
		),
	}
}

// SingleTaggedList (container): Match single-tagged packets with a list of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "single-tagged-list"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-list"
func (n *Interface_Subinterface_Vlan_MatchPath) SingleTaggedList() *Interface_Subinterface_Vlan_Match_SingleTaggedListPath {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedListPath{
		NodePath: ygot.NewNodePath(
			[]string{"single-tagged-list"},
			map[string]interface{}{},
			n,
		),
	}
}

// SingleTaggedList (container): Match single-tagged packets with a list of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "single-tagged-list"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-list"
func (n *Interface_Subinterface_Vlan_MatchPathAny) SingleTaggedList() *Interface_Subinterface_Vlan_Match_SingleTaggedListPathAny {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"single-tagged-list"},
			map[string]interface{}{},
			n,
		),
	}
}

// SingleTaggedRange (container): Match single-tagged packets with a range of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "single-tagged-range"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range"
func (n *Interface_Subinterface_Vlan_MatchPath) SingleTaggedRange() *Interface_Subinterface_Vlan_Match_SingleTaggedRangePath {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedRangePath{
		NodePath: ygot.NewNodePath(
			[]string{"single-tagged-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// SingleTaggedRange (container): Match single-tagged packets with a range of VLAN identifiers.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "single-tagged-range"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range"
func (n *Interface_Subinterface_Vlan_MatchPathAny) SingleTaggedRange() *Interface_Subinterface_Vlan_Match_SingleTaggedRangePathAny {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedRangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"single-tagged-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTagged_InnerVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged/config/inner-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTagged_InnerVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTagged_InnerVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged/config/inner-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTagged_InnerVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTagged_OuterVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged/config/outer-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTagged_OuterVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTagged_OuterVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged/config/outer-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTagged_OuterVlanIdPathAny struct {
	*ygot.NodePath
}

// InnerVlanId (leaf): Inner VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged/config/inner-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedPath) InnerVlanId() *Interface_Subinterface_Vlan_Match_DoubleTagged_InnerVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTagged_InnerVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerVlanId (leaf): Inner VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged/config/inner-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedPathAny) InnerVlanId() *Interface_Subinterface_Vlan_Match_DoubleTagged_InnerVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTagged_InnerVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterVlanId (leaf): Outer VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged/config/outer-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedPath) OuterVlanId() *Interface_Subinterface_Vlan_Match_DoubleTagged_OuterVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTagged_OuterVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterVlanId (leaf): Outer VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged/config/outer-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedPathAny) OuterVlanId() *Interface_Subinterface_Vlan_Match_DoubleTagged_OuterVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTagged_OuterVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_InnerVlanIdsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list/config/inner-vlan-ids YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_InnerVlanIdsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_InnerVlanIdsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list/config/inner-vlan-ids YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_InnerVlanIdsPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_OuterVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list/config/outer-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_OuterVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_OuterVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list/config/outer-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_OuterVlanIdPathAny struct {
	*ygot.NodePath
}

// InnerVlanIds (leaf): Inner VLAN identifiers for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-vlan-ids"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list/config/inner-vlan-ids"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPath) InnerVlanIds() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_InnerVlanIdsPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_InnerVlanIdsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-vlan-ids"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerVlanIds (leaf): Inner VLAN identifiers for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-vlan-ids"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list/config/inner-vlan-ids"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPathAny) InnerVlanIds() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_InnerVlanIdsPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_InnerVlanIdsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-vlan-ids"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterVlanId (leaf): Outer VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list/config/outer-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPath) OuterVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_OuterVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_OuterVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterVlanId (leaf): Outer VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-list/config/outer-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerListPathAny) OuterVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_OuterVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerList_OuterVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerHighVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/inner-high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerHighVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerHighVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/inner-high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerHighVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerLowVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/inner-low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerLowVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerLowVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/inner-low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerLowVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterHighVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/outer-high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterHighVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterHighVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/outer-high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterHighVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterLowVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/outer-low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterLowVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterLowVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/outer-low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterLowVlanIdPathAny struct {
	*ygot.NodePath
}

// InnerHighVlanId (leaf): The high-value inner VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/inner-high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePath) InnerHighVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerHighVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerHighVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerHighVlanId (leaf): The high-value inner VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/inner-high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePathAny) InnerHighVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerHighVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerHighVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerLowVlanId (leaf): The low-value inner VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/inner-low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePath) InnerLowVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerLowVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerLowVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerLowVlanId (leaf): The low-value inner VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/inner-low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePathAny) InnerLowVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerLowVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_InnerLowVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterHighVlanId (leaf): The high-value outer VLAN identifier for double-tagged packets.
// The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/outer-high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePath) OuterHighVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterHighVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterHighVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterHighVlanId (leaf): The high-value outer VLAN identifier for double-tagged packets.
// The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/outer-high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePathAny) OuterHighVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterHighVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterHighVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterLowVlanId (leaf): The low-value outer VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/outer-low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePath) OuterLowVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterLowVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterLowVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterLowVlanId (leaf): The low-value outer VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-outer-range/config/outer-low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRangePathAny) OuterLowVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterLowVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerOuterRange_OuterLowVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerHighVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/inner-high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerHighVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerHighVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/inner-high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerHighVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerLowVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/inner-low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerLowVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerLowVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/inner-low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerLowVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_OuterVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/outer-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_OuterVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_OuterVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/outer-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_OuterVlanIdPathAny struct {
	*ygot.NodePath
}

// InnerHighVlanId (leaf): The high-value inner VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/inner-high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePath) InnerHighVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerHighVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerHighVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerHighVlanId (leaf): The high-value inner VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/inner-high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePathAny) InnerHighVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerHighVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerHighVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerLowVlanId (leaf): The low-value inner VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/inner-low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePath) InnerLowVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerLowVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerLowVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerLowVlanId (leaf): The low-value inner VLAN identifier in a range for double-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/inner-low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePathAny) InnerLowVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerLowVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_InnerLowVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterVlanId (leaf): Outer VLAN identifier of double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/outer-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePath) OuterVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_OuterVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_OuterVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterVlanId (leaf): Outer VLAN identifier of double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-inner-range/config/outer-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRangePathAny) OuterVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_OuterVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedInnerRange_OuterVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_InnerVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list/config/inner-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_InnerVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_InnerVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list/config/inner-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_InnerVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_OuterVlanIdsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list/config/outer-vlan-ids YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_OuterVlanIdsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_OuterVlanIdsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list/config/outer-vlan-ids YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_OuterVlanIdsPathAny struct {
	*ygot.NodePath
}

// InnerVlanId (leaf): Inner VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list/config/inner-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPath) InnerVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_InnerVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_InnerVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerVlanId (leaf): Inner VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list/config/inner-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPathAny) InnerVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_InnerVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_InnerVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterVlanIds (leaf): Outer VLAN identifiers for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-vlan-ids"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list/config/outer-vlan-ids"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPath) OuterVlanIds() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_OuterVlanIdsPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_OuterVlanIdsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-vlan-ids"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterVlanIds (leaf): Outer VLAN identifiers for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-vlan-ids"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-list/config/outer-vlan-ids"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterListPathAny) OuterVlanIds() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_OuterVlanIdsPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterList_OuterVlanIdsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-vlan-ids"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_InnerVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/inner-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_InnerVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_InnerVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/inner-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_InnerVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterHighVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/outer-high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterHighVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterHighVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/outer-high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterHighVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterLowVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/outer-low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterLowVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterLowVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/outer-low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterLowVlanIdPathAny struct {
	*ygot.NodePath
}

// InnerVlanId (leaf): Inner VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/inner-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePath) InnerVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_InnerVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_InnerVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InnerVlanId (leaf): Inner VLAN identifier for double-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/inner-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/inner-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePathAny) InnerVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_InnerVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_InnerVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "inner-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterHighVlanId (leaf): The high-value outer VLAN identifier for double-tagged packets.
// The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/outer-high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePath) OuterHighVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterHighVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterHighVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterHighVlanId (leaf): The high-value outer VLAN identifier for double-tagged packets.
// The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/outer-high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePathAny) OuterHighVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterHighVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterHighVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterLowVlanId (leaf): The low-value outer VLAN identifier for double-tagged packets.
// The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/outer-low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePath) OuterLowVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterLowVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterLowVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuterLowVlanId (leaf): The low-value outer VLAN identifier for double-tagged packets.
// The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/outer-low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/double-tagged-outer-range/config/outer-low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRangePathAny) OuterLowVlanId() *Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterLowVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_DoubleTaggedOuterRange_OuterLowVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "outer-low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_Match_SingleTaggedPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTaggedPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTagged_VlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged/config/vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTagged_VlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTagged_VlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged/config/vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTagged_VlanIdPathAny struct {
	*ygot.NodePath
}

// VlanId (leaf): VLAN identifier for single-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged/config/vlan-id"
func (n *Interface_Subinterface_Vlan_Match_SingleTaggedPath) VlanId() *Interface_Subinterface_Vlan_Match_SingleTagged_VlanIdPath {
	return &Interface_Subinterface_Vlan_Match_SingleTagged_VlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): VLAN identifier for single-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged/config/vlan-id"
func (n *Interface_Subinterface_Vlan_Match_SingleTaggedPathAny) VlanId() *Interface_Subinterface_Vlan_Match_SingleTagged_VlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_SingleTagged_VlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_Match_SingleTaggedListPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-list YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedListPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTaggedListPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-list YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedListPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTaggedList_VlanIdsPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-list/config/vlan-ids YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedList_VlanIdsPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTaggedList_VlanIdsPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-list/config/vlan-ids YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedList_VlanIdsPathAny struct {
	*ygot.NodePath
}

// VlanIds (leaf): VLAN identifiers for single-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-ids"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-list/config/vlan-ids"
func (n *Interface_Subinterface_Vlan_Match_SingleTaggedListPath) VlanIds() *Interface_Subinterface_Vlan_Match_SingleTaggedList_VlanIdsPath {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedList_VlanIdsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-ids"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanIds (leaf): VLAN identifiers for single-tagged packets.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/vlan-ids"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-list/config/vlan-ids"
func (n *Interface_Subinterface_Vlan_Match_SingleTaggedListPathAny) VlanIds() *Interface_Subinterface_Vlan_Match_SingleTaggedList_VlanIdsPathAny {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedList_VlanIdsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-ids"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface_Subinterface_Vlan_Match_SingleTaggedRangePath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedRangePath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTaggedRangePathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedRangePathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTaggedRange_HighVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range/config/high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedRange_HighVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTaggedRange_HighVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range/config/high-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedRange_HighVlanIdPathAny struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTaggedRange_LowVlanIdPath represents the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range/config/low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedRange_LowVlanIdPath struct {
	*ygot.NodePath
}

// Interface_Subinterface_Vlan_Match_SingleTaggedRange_LowVlanIdPathAny represents the wildcard version of the /openconfig-interfaces/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range/config/low-vlan-id YANG schema element.
type Interface_Subinterface_Vlan_Match_SingleTaggedRange_LowVlanIdPathAny struct {
	*ygot.NodePath
}

// HighVlanId (leaf): The high-value VLAN identifier in a range for single-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range/config/high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_SingleTaggedRangePath) HighVlanId() *Interface_Subinterface_Vlan_Match_SingleTaggedRange_HighVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedRange_HighVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// HighVlanId (leaf): The high-value VLAN identifier in a range for single-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/high-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range/config/high-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_SingleTaggedRangePathAny) HighVlanId() *Interface_Subinterface_Vlan_Match_SingleTaggedRange_HighVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedRange_HighVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "high-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LowVlanId (leaf): The low-value VLAN identifier in a range for single-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range/config/low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_SingleTaggedRangePath) LowVlanId() *Interface_Subinterface_Vlan_Match_SingleTaggedRange_LowVlanIdPath {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedRange_LowVlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LowVlanId (leaf): The low-value VLAN identifier in a range for single-tagged
// packets. The range is matched inclusively.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-interfaces"
// Path from parent: "config/low-vlan-id"
// Path from root: "/interfaces/interface/subinterfaces/subinterface/vlan/match/single-tagged-range/config/low-vlan-id"
func (n *Interface_Subinterface_Vlan_Match_SingleTaggedRangePathAny) LowVlanId() *Interface_Subinterface_Vlan_Match_SingleTaggedRange_LowVlanIdPathAny {
	return &Interface_Subinterface_Vlan_Match_SingleTaggedRange_LowVlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "low-vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeychainPath represents the /openconfig-keychain/keychains/keychain YANG schema element.
type KeychainPath struct {
	*ygot.NodePath
}

// KeychainPathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain YANG schema element.
type KeychainPathAny struct {
	*ygot.NodePath
}

// Keychain_NamePath represents the /openconfig-keychain/keychains/keychain/config/name YANG schema element.
type Keychain_NamePath struct {
	*ygot.NodePath
}

// Keychain_NamePathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/config/name YANG schema element.
type Keychain_NamePathAny struct {
	*ygot.NodePath
}

// Keychain_TolerancePath represents the /openconfig-keychain/keychains/keychain/config/tolerance YANG schema element.
type Keychain_TolerancePath struct {
	*ygot.NodePath
}

// Keychain_TolerancePathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/config/tolerance YANG schema element.
type Keychain_TolerancePathAny struct {
	*ygot.NodePath
}

// KeyAny (list): List of configured keys for the keychain.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "keys/key"
// Path from root: "/keychains/keychain/keys/key"
// KeyId (wildcarded): uint64
func (n *KeychainPath) KeyAny() *Keychain_KeyPathAny {
	return &Keychain_KeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"keys", "key"},
			map[string]interface{}{"key-id": "*"},
			n,
		),
	}
}

// KeyAny (list): List of configured keys for the keychain.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "keys/key"
// Path from root: "/keychains/keychain/keys/key"
// KeyId (wildcarded): uint64
func (n *KeychainPathAny) KeyAny() *Keychain_KeyPathAny {
	return &Keychain_KeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"keys", "key"},
			map[string]interface{}{"key-id": "*"},
			n,
		),
	}
}

// Key (list): List of configured keys for the keychain.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "keys/key"
// Path from root: "/keychains/keychain/keys/key"
// KeyId: uint64
func (n *KeychainPath) Key(KeyId uint64) *Keychain_KeyPath {
	return &Keychain_KeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"keys", "key"},
			map[string]interface{}{"key-id": KeyId},
			n,
		),
	}
}

// Key (list): List of configured keys for the keychain.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "keys/key"
// Path from root: "/keychains/keychain/keys/key"
// KeyId: uint64
func (n *KeychainPathAny) Key(KeyId uint64) *Keychain_KeyPathAny {
	return &Keychain_KeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"keys", "key"},
			map[string]interface{}{"key-id": KeyId},
			n,
		),
	}
}

// Name (leaf): Keychain name.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/name"
// Path from root: "/keychains/keychain/config/name"
func (n *KeychainPath) Name() *Keychain_NamePath {
	return &Keychain_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Keychain name.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/name"
// Path from root: "/keychains/keychain/config/name"
func (n *KeychainPathAny) Name() *Keychain_NamePathAny {
	return &Keychain_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tolerance (leaf): Tolerance (overlap time) that a receive key should be accepted.  May be
// expressed as range in seconds, or using the FOREVER value to indicate
// that the key does not expire.  The default value should be 0, i.e., no
// tolerance.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/tolerance"
// Path from root: "/keychains/keychain/config/tolerance"
func (n *KeychainPath) Tolerance() *Keychain_TolerancePath {
	return &Keychain_TolerancePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tolerance"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tolerance (leaf): Tolerance (overlap time) that a receive key should be accepted.  May be
// expressed as range in seconds, or using the FOREVER value to indicate
// that the key does not expire.  The default value should be 0, i.e., no
// tolerance.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/tolerance"
// Path from root: "/keychains/keychain/config/tolerance"
func (n *KeychainPathAny) Tolerance() *Keychain_TolerancePathAny {
	return &Keychain_TolerancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tolerance"},
			map[string]interface{}{},
			n,
		),
	}
}

// Keychain_KeyPath represents the /openconfig-keychain/keychains/keychain/keys/key YANG schema element.
type Keychain_KeyPath struct {
	*ygot.NodePath
}

// Keychain_KeyPathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key YANG schema element.
type Keychain_KeyPathAny struct {
	*ygot.NodePath
}

// Keychain_Key_CryptoAlgorithmPath represents the /openconfig-keychain/keychains/keychain/keys/key/config/crypto-algorithm YANG schema element.
type Keychain_Key_CryptoAlgorithmPath struct {
	*ygot.NodePath
}

// Keychain_Key_CryptoAlgorithmPathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/config/crypto-algorithm YANG schema element.
type Keychain_Key_CryptoAlgorithmPathAny struct {
	*ygot.NodePath
}

// Keychain_Key_KeyIdPath represents the /openconfig-keychain/keychains/keychain/keys/key/config/key-id YANG schema element.
type Keychain_Key_KeyIdPath struct {
	*ygot.NodePath
}

// Keychain_Key_KeyIdPathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/config/key-id YANG schema element.
type Keychain_Key_KeyIdPathAny struct {
	*ygot.NodePath
}

// Keychain_Key_SecretKeyPath represents the /openconfig-keychain/keychains/keychain/keys/key/config/secret-key YANG schema element.
type Keychain_Key_SecretKeyPath struct {
	*ygot.NodePath
}

// Keychain_Key_SecretKeyPathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/config/secret-key YANG schema element.
type Keychain_Key_SecretKeyPathAny struct {
	*ygot.NodePath
}

// CryptoAlgorithm (leaf): Cryptographic algorithm associated with the key.  Note that not all cryptographic
// algorithms are available in all contexts (e.g., across different protocols).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/crypto-algorithm"
// Path from root: "/keychains/keychain/keys/key/config/crypto-algorithm"
func (n *Keychain_KeyPath) CryptoAlgorithm() *Keychain_Key_CryptoAlgorithmPath {
	return &Keychain_Key_CryptoAlgorithmPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "crypto-algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// CryptoAlgorithm (leaf): Cryptographic algorithm associated with the key.  Note that not all cryptographic
// algorithms are available in all contexts (e.g., across different protocols).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/crypto-algorithm"
// Path from root: "/keychains/keychain/keys/key/config/crypto-algorithm"
func (n *Keychain_KeyPathAny) CryptoAlgorithm() *Keychain_Key_CryptoAlgorithmPathAny {
	return &Keychain_Key_CryptoAlgorithmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "crypto-algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeyId (leaf): Identifier for the key within the keychain.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/key-id"
// Path from root: "/keychains/keychain/keys/key/config/key-id"
func (n *Keychain_KeyPath) KeyId() *Keychain_Key_KeyIdPath {
	return &Keychain_Key_KeyIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "key-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeyId (leaf): Identifier for the key within the keychain.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/key-id"
// Path from root: "/keychains/keychain/keys/key/config/key-id"
func (n *Keychain_KeyPathAny) KeyId() *Keychain_Key_KeyIdPathAny {
	return &Keychain_Key_KeyIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "key-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceiveLifetime (container): Specify the validity lifetime of the key in the receive direction.
// Some platforms may only support symmetric send and receive lifetimes,
// in which case the receive-lifetime is typically not specified.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "receive-lifetime"
// Path from root: "/keychains/keychain/keys/key/receive-lifetime"
func (n *Keychain_KeyPath) ReceiveLifetime() *Keychain_Key_ReceiveLifetimePath {
	return &Keychain_Key_ReceiveLifetimePath{
		NodePath: ygot.NewNodePath(
			[]string{"receive-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceiveLifetime (container): Specify the validity lifetime of the key in the receive direction.
// Some platforms may only support symmetric send and receive lifetimes,
// in which case the receive-lifetime is typically not specified.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "receive-lifetime"
// Path from root: "/keychains/keychain/keys/key/receive-lifetime"
func (n *Keychain_KeyPathAny) ReceiveLifetime() *Keychain_Key_ReceiveLifetimePathAny {
	return &Keychain_Key_ReceiveLifetimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"receive-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKey (leaf): Authentication key supplied as an encrypted value.  The system should store and
// return the key in encrypted form.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/secret-key"
// Path from root: "/keychains/keychain/keys/key/config/secret-key"
func (n *Keychain_KeyPath) SecretKey() *Keychain_Key_SecretKeyPath {
	return &Keychain_Key_SecretKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKey (leaf): Authentication key supplied as an encrypted value.  The system should store and
// return the key in encrypted form.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/secret-key"
// Path from root: "/keychains/keychain/keys/key/config/secret-key"
func (n *Keychain_KeyPathAny) SecretKey() *Keychain_Key_SecretKeyPathAny {
	return &Keychain_Key_SecretKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendLifetime (container): Specifies the lifetime of the key for sending authentication
// information to the peer.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "send-lifetime"
// Path from root: "/keychains/keychain/keys/key/send-lifetime"
func (n *Keychain_KeyPath) SendLifetime() *Keychain_Key_SendLifetimePath {
	return &Keychain_Key_SendLifetimePath{
		NodePath: ygot.NewNodePath(
			[]string{"send-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendLifetime (container): Specifies the lifetime of the key for sending authentication
// information to the peer.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "send-lifetime"
// Path from root: "/keychains/keychain/keys/key/send-lifetime"
func (n *Keychain_KeyPathAny) SendLifetime() *Keychain_Key_SendLifetimePathAny {
	return &Keychain_Key_SendLifetimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"send-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// Keychain_Key_ReceiveLifetimePath represents the /openconfig-keychain/keychains/keychain/keys/key/receive-lifetime YANG schema element.
type Keychain_Key_ReceiveLifetimePath struct {
	*ygot.NodePath
}

// Keychain_Key_ReceiveLifetimePathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/receive-lifetime YANG schema element.
type Keychain_Key_ReceiveLifetimePathAny struct {
	*ygot.NodePath
}

// Keychain_Key_ReceiveLifetime_EndTimePath represents the /openconfig-keychain/keychains/keychain/keys/key/receive-lifetime/config/end-time YANG schema element.
type Keychain_Key_ReceiveLifetime_EndTimePath struct {
	*ygot.NodePath
}

// Keychain_Key_ReceiveLifetime_EndTimePathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/receive-lifetime/config/end-time YANG schema element.
type Keychain_Key_ReceiveLifetime_EndTimePathAny struct {
	*ygot.NodePath
}

// Keychain_Key_ReceiveLifetime_StartTimePath represents the /openconfig-keychain/keychains/keychain/keys/key/receive-lifetime/config/start-time YANG schema element.
type Keychain_Key_ReceiveLifetime_StartTimePath struct {
	*ygot.NodePath
}

// Keychain_Key_ReceiveLifetime_StartTimePathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/receive-lifetime/config/start-time YANG schema element.
type Keychain_Key_ReceiveLifetime_StartTimePathAny struct {
	*ygot.NodePath
}

// EndTime (leaf): The time at which the key becomes invalid for use.
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// Leaving this value unset, or setting it to 0, indicates that
// the key remains valid forever (no end time).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/end-time"
// Path from root: "/keychains/keychain/keys/key/receive-lifetime/config/end-time"
func (n *Keychain_Key_ReceiveLifetimePath) EndTime() *Keychain_Key_ReceiveLifetime_EndTimePath {
	return &Keychain_Key_ReceiveLifetime_EndTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "end-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// EndTime (leaf): The time at which the key becomes invalid for use.
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// Leaving this value unset, or setting it to 0, indicates that
// the key remains valid forever (no end time).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/end-time"
// Path from root: "/keychains/keychain/keys/key/receive-lifetime/config/end-time"
func (n *Keychain_Key_ReceiveLifetimePathAny) EndTime() *Keychain_Key_ReceiveLifetime_EndTimePathAny {
	return &Keychain_Key_ReceiveLifetime_EndTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "end-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StartTime (leaf): The time at which the key becomes valid for use.
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/start-time"
// Path from root: "/keychains/keychain/keys/key/receive-lifetime/config/start-time"
func (n *Keychain_Key_ReceiveLifetimePath) StartTime() *Keychain_Key_ReceiveLifetime_StartTimePath {
	return &Keychain_Key_ReceiveLifetime_StartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "start-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StartTime (leaf): The time at which the key becomes valid for use.
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/start-time"
// Path from root: "/keychains/keychain/keys/key/receive-lifetime/config/start-time"
func (n *Keychain_Key_ReceiveLifetimePathAny) StartTime() *Keychain_Key_ReceiveLifetime_StartTimePathAny {
	return &Keychain_Key_ReceiveLifetime_StartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "start-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Keychain_Key_SendLifetimePath represents the /openconfig-keychain/keychains/keychain/keys/key/send-lifetime YANG schema element.
type Keychain_Key_SendLifetimePath struct {
	*ygot.NodePath
}

// Keychain_Key_SendLifetimePathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/send-lifetime YANG schema element.
type Keychain_Key_SendLifetimePathAny struct {
	*ygot.NodePath
}

// Keychain_Key_SendLifetime_EndTimePath represents the /openconfig-keychain/keychains/keychain/keys/key/send-lifetime/config/end-time YANG schema element.
type Keychain_Key_SendLifetime_EndTimePath struct {
	*ygot.NodePath
}

// Keychain_Key_SendLifetime_EndTimePathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/send-lifetime/config/end-time YANG schema element.
type Keychain_Key_SendLifetime_EndTimePathAny struct {
	*ygot.NodePath
}

// Keychain_Key_SendLifetime_SendAndReceivePath represents the /openconfig-keychain/keychains/keychain/keys/key/send-lifetime/config/send-and-receive YANG schema element.
type Keychain_Key_SendLifetime_SendAndReceivePath struct {
	*ygot.NodePath
}

// Keychain_Key_SendLifetime_SendAndReceivePathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/send-lifetime/config/send-and-receive YANG schema element.
type Keychain_Key_SendLifetime_SendAndReceivePathAny struct {
	*ygot.NodePath
}

// Keychain_Key_SendLifetime_StartTimePath represents the /openconfig-keychain/keychains/keychain/keys/key/send-lifetime/config/start-time YANG schema element.
type Keychain_Key_SendLifetime_StartTimePath struct {
	*ygot.NodePath
}

// Keychain_Key_SendLifetime_StartTimePathAny represents the wildcard version of the /openconfig-keychain/keychains/keychain/keys/key/send-lifetime/config/start-time YANG schema element.
type Keychain_Key_SendLifetime_StartTimePathAny struct {
	*ygot.NodePath
}

// EndTime (leaf): The time at which the key becomes invalid for use.
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// Leaving this value unset, or setting it to 0, indicates that
// the key remains valid forever (no end time).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/end-time"
// Path from root: "/keychains/keychain/keys/key/send-lifetime/config/end-time"
func (n *Keychain_Key_SendLifetimePath) EndTime() *Keychain_Key_SendLifetime_EndTimePath {
	return &Keychain_Key_SendLifetime_EndTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "end-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// EndTime (leaf): The time at which the key becomes invalid for use.
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// Leaving this value unset, or setting it to 0, indicates that
// the key remains valid forever (no end time).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/end-time"
// Path from root: "/keychains/keychain/keys/key/send-lifetime/config/end-time"
func (n *Keychain_Key_SendLifetimePathAny) EndTime() *Keychain_Key_SendLifetime_EndTimePathAny {
	return &Keychain_Key_SendLifetime_EndTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "end-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendAndReceive (leaf): When this is set to true (the default value), the specified
// send lifetime is also used in the receive direction.  When set
// to false, the device should use the specified receive-lifetime
// for the receive direction (asymmetric mode).  If send-and-receive
// is false, and the device does not support asymmetric configuration,
// the config should be rejected as unsupported.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/send-and-receive"
// Path from root: "/keychains/keychain/keys/key/send-lifetime/config/send-and-receive"
func (n *Keychain_Key_SendLifetimePath) SendAndReceive() *Keychain_Key_SendLifetime_SendAndReceivePath {
	return &Keychain_Key_SendLifetime_SendAndReceivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-and-receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendAndReceive (leaf): When this is set to true (the default value), the specified
// send lifetime is also used in the receive direction.  When set
// to false, the device should use the specified receive-lifetime
// for the receive direction (asymmetric mode).  If send-and-receive
// is false, and the device does not support asymmetric configuration,
// the config should be rejected as unsupported.
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/send-and-receive"
// Path from root: "/keychains/keychain/keys/key/send-lifetime/config/send-and-receive"
func (n *Keychain_Key_SendLifetimePathAny) SendAndReceive() *Keychain_Key_SendLifetime_SendAndReceivePathAny {
	return &Keychain_Key_SendLifetime_SendAndReceivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-and-receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// StartTime (leaf): The time at which the key becomes valid for use.
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/start-time"
// Path from root: "/keychains/keychain/keys/key/send-lifetime/config/start-time"
func (n *Keychain_Key_SendLifetimePath) StartTime() *Keychain_Key_SendLifetime_StartTimePath {
	return &Keychain_Key_SendLifetime_StartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "start-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StartTime (leaf): The time at which the key becomes valid for use.
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-keychain"
// Instantiating module: "openconfig-keychain"
// Path from parent: "config/start-time"
// Path from root: "/keychains/keychain/keys/key/send-lifetime/config/start-time"
func (n *Keychain_Key_SendLifetimePathAny) StartTime() *Keychain_Key_SendLifetime_StartTimePathAny {
	return &Keychain_Key_SendLifetime_StartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "start-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpPath represents the /openconfig-lacp/lacp YANG schema element.
type LacpPath struct {
	*ygot.NodePath
}

// LacpPathAny represents the wildcard version of the /openconfig-lacp/lacp YANG schema element.
type LacpPathAny struct {
	*ygot.NodePath
}

// Lacp_SystemPriorityPath represents the /openconfig-lacp/lacp/config/system-priority YANG schema element.
type Lacp_SystemPriorityPath struct {
	*ygot.NodePath
}

// Lacp_SystemPriorityPathAny represents the wildcard version of the /openconfig-lacp/lacp/config/system-priority YANG schema element.
type Lacp_SystemPriorityPathAny struct {
	*ygot.NodePath
}

// InterfaceAny (list): List of aggregate interfaces managed by LACP
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "interfaces/interface"
// Path from root: "/lacp/interfaces/interface"
// Name (wildcarded): string
func (n *LacpPath) InterfaceAny() *Lacp_InterfacePathAny {
	return &Lacp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of aggregate interfaces managed by LACP
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "interfaces/interface"
// Path from root: "/lacp/interfaces/interface"
// Name (wildcarded): string
func (n *LacpPathAny) InterfaceAny() *Lacp_InterfacePathAny {
	return &Lacp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Interface (list): List of aggregate interfaces managed by LACP
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "interfaces/interface"
// Path from root: "/lacp/interfaces/interface"
// Name: string
func (n *LacpPath) Interface(Name string) *Lacp_InterfacePath {
	return &Lacp_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Interface (list): List of aggregate interfaces managed by LACP
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "interfaces/interface"
// Path from root: "/lacp/interfaces/interface"
// Name: string
func (n *LacpPathAny) Interface(Name string) *Lacp_InterfacePathAny {
	return &Lacp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// SystemPriority (leaf): Sytem priority used by the node on this LAG interface.
// Lower value is higher priority for determining which node
// is the controlling system.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/system-priority"
// Path from root: "/lacp/config/system-priority"
func (n *LacpPath) SystemPriority() *Lacp_SystemPriorityPath {
	return &Lacp_SystemPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemPriority (leaf): Sytem priority used by the node on this LAG interface.
// Lower value is higher priority for determining which node
// is the controlling system.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/system-priority"
// Path from root: "/lacp/config/system-priority"
func (n *LacpPathAny) SystemPriority() *Lacp_SystemPriorityPathAny {
	return &Lacp_SystemPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lacp_InterfacePath represents the /openconfig-lacp/lacp/interfaces/interface YANG schema element.
type Lacp_InterfacePath struct {
	*ygot.NodePath
}

// Lacp_InterfacePathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface YANG schema element.
type Lacp_InterfacePathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_IntervalPath represents the /openconfig-lacp/lacp/interfaces/interface/config/interval YANG schema element.
type Lacp_Interface_IntervalPath struct {
	*ygot.NodePath
}

// Lacp_Interface_IntervalPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/config/interval YANG schema element.
type Lacp_Interface_IntervalPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_LacpModePath represents the /openconfig-lacp/lacp/interfaces/interface/config/lacp-mode YANG schema element.
type Lacp_Interface_LacpModePath struct {
	*ygot.NodePath
}

// Lacp_Interface_LacpModePathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/config/lacp-mode YANG schema element.
type Lacp_Interface_LacpModePathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_NamePath represents the /openconfig-lacp/lacp/interfaces/interface/config/name YANG schema element.
type Lacp_Interface_NamePath struct {
	*ygot.NodePath
}

// Lacp_Interface_NamePathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/config/name YANG schema element.
type Lacp_Interface_NamePathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_SystemIdMacPath represents the /openconfig-lacp/lacp/interfaces/interface/config/system-id-mac YANG schema element.
type Lacp_Interface_SystemIdMacPath struct {
	*ygot.NodePath
}

// Lacp_Interface_SystemIdMacPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/config/system-id-mac YANG schema element.
type Lacp_Interface_SystemIdMacPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_SystemPriorityPath represents the /openconfig-lacp/lacp/interfaces/interface/config/system-priority YANG schema element.
type Lacp_Interface_SystemPriorityPath struct {
	*ygot.NodePath
}

// Lacp_Interface_SystemPriorityPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/config/system-priority YANG schema element.
type Lacp_Interface_SystemPriorityPathAny struct {
	*ygot.NodePath
}

// Interval (leaf): Set the period between LACP messages -- uses
// the lacp-period-type enumeration.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/interval"
// Path from root: "/lacp/interfaces/interface/config/interval"
func (n *Lacp_InterfacePath) Interval() *Lacp_Interface_IntervalPath {
	return &Lacp_Interface_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): Set the period between LACP messages -- uses
// the lacp-period-type enumeration.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/interval"
// Path from root: "/lacp/interfaces/interface/config/interval"
func (n *Lacp_InterfacePathAny) Interval() *Lacp_Interface_IntervalPathAny {
	return &Lacp_Interface_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpMode (leaf): ACTIVE is to initiate the transmission of LACP packets.
// PASSIVE is to wait for peer to initiate the transmission of
// LACP packets.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/lacp-mode"
// Path from root: "/lacp/interfaces/interface/config/lacp-mode"
func (n *Lacp_InterfacePath) LacpMode() *Lacp_Interface_LacpModePath {
	return &Lacp_Interface_LacpModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lacp-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpMode (leaf): ACTIVE is to initiate the transmission of LACP packets.
// PASSIVE is to wait for peer to initiate the transmission of
// LACP packets.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/lacp-mode"
// Path from root: "/lacp/interfaces/interface/config/lacp-mode"
func (n *Lacp_InterfacePathAny) LacpMode() *Lacp_Interface_LacpModePathAny {
	return &Lacp_Interface_LacpModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lacp-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// MemberAny (list): List of member interfaces and their associated status for
// a LACP-controlled aggregate interface.  Member list is not
// configurable here -- each interface indicates items
// its participation in the LAG.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "members/member"
// Path from root: "/lacp/interfaces/interface/members/member"
// Interface (wildcarded): string
func (n *Lacp_InterfacePath) MemberAny() *Lacp_Interface_MemberPathAny {
	return &Lacp_Interface_MemberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"members", "member"},
			map[string]interface{}{"interface": "*"},
			n,
		),
	}
}

// MemberAny (list): List of member interfaces and their associated status for
// a LACP-controlled aggregate interface.  Member list is not
// configurable here -- each interface indicates items
// its participation in the LAG.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "members/member"
// Path from root: "/lacp/interfaces/interface/members/member"
// Interface (wildcarded): string
func (n *Lacp_InterfacePathAny) MemberAny() *Lacp_Interface_MemberPathAny {
	return &Lacp_Interface_MemberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"members", "member"},
			map[string]interface{}{"interface": "*"},
			n,
		),
	}
}

// Member (list): List of member interfaces and their associated status for
// a LACP-controlled aggregate interface.  Member list is not
// configurable here -- each interface indicates items
// its participation in the LAG.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "members/member"
// Path from root: "/lacp/interfaces/interface/members/member"
// Interface: string
func (n *Lacp_InterfacePath) Member(Interface string) *Lacp_Interface_MemberPath {
	return &Lacp_Interface_MemberPath{
		NodePath: ygot.NewNodePath(
			[]string{"members", "member"},
			map[string]interface{}{"interface": Interface},
			n,
		),
	}
}

// Member (list): List of member interfaces and their associated status for
// a LACP-controlled aggregate interface.  Member list is not
// configurable here -- each interface indicates items
// its participation in the LAG.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "members/member"
// Path from root: "/lacp/interfaces/interface/members/member"
// Interface: string
func (n *Lacp_InterfacePathAny) Member(Interface string) *Lacp_Interface_MemberPathAny {
	return &Lacp_Interface_MemberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"members", "member"},
			map[string]interface{}{"interface": Interface},
			n,
		),
	}
}

// Name (leaf): Reference to the interface on which LACP should be
// configured.   The type of the target interface must be
// ieee8023adLag
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/name"
// Path from root: "/lacp/interfaces/interface/config/name"
func (n *Lacp_InterfacePath) Name() *Lacp_Interface_NamePath {
	return &Lacp_Interface_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the interface on which LACP should be
// configured.   The type of the target interface must be
// ieee8023adLag
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/name"
// Path from root: "/lacp/interfaces/interface/config/name"
func (n *Lacp_InterfacePathAny) Name() *Lacp_Interface_NamePathAny {
	return &Lacp_Interface_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemIdMac (leaf): The MAC address portion of the node's System ID. This is
// combined with the system priority to construct the 8-octet
// system-id
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/system-id-mac"
// Path from root: "/lacp/interfaces/interface/config/system-id-mac"
func (n *Lacp_InterfacePath) SystemIdMac() *Lacp_Interface_SystemIdMacPath {
	return &Lacp_Interface_SystemIdMacPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-id-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemIdMac (leaf): The MAC address portion of the node's System ID. This is
// combined with the system priority to construct the 8-octet
// system-id
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/system-id-mac"
// Path from root: "/lacp/interfaces/interface/config/system-id-mac"
func (n *Lacp_InterfacePathAny) SystemIdMac() *Lacp_Interface_SystemIdMacPathAny {
	return &Lacp_Interface_SystemIdMacPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-id-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemPriority (leaf): Sytem priority used by the node on this LAG interface.
// Lower value is higher priority for determining which node
// is the controlling system.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/system-priority"
// Path from root: "/lacp/interfaces/interface/config/system-priority"
func (n *Lacp_InterfacePath) SystemPriority() *Lacp_Interface_SystemPriorityPath {
	return &Lacp_Interface_SystemPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemPriority (leaf): Sytem priority used by the node on this LAG interface.
// Lower value is higher priority for determining which node
// is the controlling system.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "config/system-priority"
// Path from root: "/lacp/interfaces/interface/config/system-priority"
func (n *Lacp_InterfacePathAny) SystemPriority() *Lacp_Interface_SystemPriorityPathAny {
	return &Lacp_Interface_SystemPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lacp_Interface_MemberPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member YANG schema element.
type Lacp_Interface_MemberPath struct {
	*ygot.NodePath
}

// Lacp_Interface_MemberPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member YANG schema element.
type Lacp_Interface_MemberPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_ActivityPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/activity YANG schema element.
type Lacp_Interface_Member_ActivityPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_ActivityPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/activity YANG schema element.
type Lacp_Interface_Member_ActivityPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_AggregatablePath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/aggregatable YANG schema element.
type Lacp_Interface_Member_AggregatablePath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_AggregatablePathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/aggregatable YANG schema element.
type Lacp_Interface_Member_AggregatablePathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_CollectingPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/collecting YANG schema element.
type Lacp_Interface_Member_CollectingPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_CollectingPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/collecting YANG schema element.
type Lacp_Interface_Member_CollectingPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_DistributingPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/distributing YANG schema element.
type Lacp_Interface_Member_DistributingPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_DistributingPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/distributing YANG schema element.
type Lacp_Interface_Member_DistributingPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_InterfacePath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/interface YANG schema element.
type Lacp_Interface_Member_InterfacePath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_InterfacePathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/interface YANG schema element.
type Lacp_Interface_Member_InterfacePathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_LastChangePath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/last-change YANG schema element.
type Lacp_Interface_Member_LastChangePath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_LastChangePathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/last-change YANG schema element.
type Lacp_Interface_Member_LastChangePathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_OperKeyPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/oper-key YANG schema element.
type Lacp_Interface_Member_OperKeyPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_OperKeyPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/oper-key YANG schema element.
type Lacp_Interface_Member_OperKeyPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_PartnerIdPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/partner-id YANG schema element.
type Lacp_Interface_Member_PartnerIdPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_PartnerIdPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/partner-id YANG schema element.
type Lacp_Interface_Member_PartnerIdPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_PartnerKeyPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/partner-key YANG schema element.
type Lacp_Interface_Member_PartnerKeyPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_PartnerKeyPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/partner-key YANG schema element.
type Lacp_Interface_Member_PartnerKeyPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_PartnerPortNumPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/partner-port-num YANG schema element.
type Lacp_Interface_Member_PartnerPortNumPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_PartnerPortNumPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/partner-port-num YANG schema element.
type Lacp_Interface_Member_PartnerPortNumPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_PortNumPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/port-num YANG schema element.
type Lacp_Interface_Member_PortNumPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_PortNumPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/port-num YANG schema element.
type Lacp_Interface_Member_PortNumPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_SynchronizationPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/synchronization YANG schema element.
type Lacp_Interface_Member_SynchronizationPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_SynchronizationPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/synchronization YANG schema element.
type Lacp_Interface_Member_SynchronizationPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_SystemIdPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/system-id YANG schema element.
type Lacp_Interface_Member_SystemIdPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_SystemIdPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/system-id YANG schema element.
type Lacp_Interface_Member_SystemIdPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_TimeoutPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/timeout YANG schema element.
type Lacp_Interface_Member_TimeoutPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_TimeoutPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/timeout YANG schema element.
type Lacp_Interface_Member_TimeoutPathAny struct {
	*ygot.NodePath
}

// Activity (leaf): Indicates participant is active or passive
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/activity"
// Path from root: "/lacp/interfaces/interface/members/member/state/activity"
func (n *Lacp_Interface_MemberPath) Activity() *Lacp_Interface_Member_ActivityPath {
	return &Lacp_Interface_Member_ActivityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "activity"},
			map[string]interface{}{},
			n,
		),
	}
}

// Activity (leaf): Indicates participant is active or passive
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/activity"
// Path from root: "/lacp/interfaces/interface/members/member/state/activity"
func (n *Lacp_Interface_MemberPathAny) Activity() *Lacp_Interface_Member_ActivityPathAny {
	return &Lacp_Interface_Member_ActivityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "activity"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aggregatable (leaf): A true value indicates that the participant will allow
// the link to be used as part of the aggregate. A false
// value indicates the link should be used as an individual
// link
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/aggregatable"
// Path from root: "/lacp/interfaces/interface/members/member/state/aggregatable"
func (n *Lacp_Interface_MemberPath) Aggregatable() *Lacp_Interface_Member_AggregatablePath {
	return &Lacp_Interface_Member_AggregatablePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "aggregatable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aggregatable (leaf): A true value indicates that the participant will allow
// the link to be used as part of the aggregate. A false
// value indicates the link should be used as an individual
// link
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/aggregatable"
// Path from root: "/lacp/interfaces/interface/members/member/state/aggregatable"
func (n *Lacp_Interface_MemberPathAny) Aggregatable() *Lacp_Interface_Member_AggregatablePathAny {
	return &Lacp_Interface_Member_AggregatablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "aggregatable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Collecting (leaf): If true, the participant is collecting incoming frames
// on the link, otherwise false
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/collecting"
// Path from root: "/lacp/interfaces/interface/members/member/state/collecting"
func (n *Lacp_Interface_MemberPath) Collecting() *Lacp_Interface_Member_CollectingPath {
	return &Lacp_Interface_Member_CollectingPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "collecting"},
			map[string]interface{}{},
			n,
		),
	}
}

// Collecting (leaf): If true, the participant is collecting incoming frames
// on the link, otherwise false
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/collecting"
// Path from root: "/lacp/interfaces/interface/members/member/state/collecting"
func (n *Lacp_Interface_MemberPathAny) Collecting() *Lacp_Interface_Member_CollectingPathAny {
	return &Lacp_Interface_Member_CollectingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "collecting"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): LACP protocol counters
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/counters"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters"
func (n *Lacp_Interface_MemberPath) Counters() *Lacp_Interface_Member_CountersPath {
	return &Lacp_Interface_Member_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): LACP protocol counters
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/counters"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters"
func (n *Lacp_Interface_MemberPathAny) Counters() *Lacp_Interface_Member_CountersPathAny {
	return &Lacp_Interface_Member_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Distributing (leaf): When true, the participant is distributing outgoing
// frames; when false, distribution is disabled
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/distributing"
// Path from root: "/lacp/interfaces/interface/members/member/state/distributing"
func (n *Lacp_Interface_MemberPath) Distributing() *Lacp_Interface_Member_DistributingPath {
	return &Lacp_Interface_Member_DistributingPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "distributing"},
			map[string]interface{}{},
			n,
		),
	}
}

// Distributing (leaf): When true, the participant is distributing outgoing
// frames; when false, distribution is disabled
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/distributing"
// Path from root: "/lacp/interfaces/interface/members/member/state/distributing"
func (n *Lacp_Interface_MemberPathAny) Distributing() *Lacp_Interface_Member_DistributingPathAny {
	return &Lacp_Interface_Member_DistributingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "distributing"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to interface member of the LACP aggregate
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/interface"
// Path from root: "/lacp/interfaces/interface/members/member/state/interface"
func (n *Lacp_Interface_MemberPath) Interface() *Lacp_Interface_Member_InterfacePath {
	return &Lacp_Interface_Member_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to interface member of the LACP aggregate
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/interface"
// Path from root: "/lacp/interfaces/interface/members/member/state/interface"
func (n *Lacp_Interface_MemberPathAny) Interface() *Lacp_Interface_Member_InterfacePathAny {
	return &Lacp_Interface_Member_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastChange (leaf): The timestamp indicates the absolute time of the last state
// change of a LACP timeout. The last state change of the LACP
// timeout is defined as what is reported as the operating state
// to the system. The state change is both a timeout event and
// when the timeout event is no longer active. The value is the
// timestamp in nanoseconds relative to the Unix Epoch
// (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/last-change"
// Path from root: "/lacp/interfaces/interface/members/member/state/last-change"
func (n *Lacp_Interface_MemberPath) LastChange() *Lacp_Interface_Member_LastChangePath {
	return &Lacp_Interface_Member_LastChangePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastChange (leaf): The timestamp indicates the absolute time of the last state
// change of a LACP timeout. The last state change of the LACP
// timeout is defined as what is reported as the operating state
// to the system. The state change is both a timeout event and
// when the timeout event is no longer active. The value is the
// timestamp in nanoseconds relative to the Unix Epoch
// (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/last-change"
// Path from root: "/lacp/interfaces/interface/members/member/state/last-change"
func (n *Lacp_Interface_MemberPathAny) LastChange() *Lacp_Interface_Member_LastChangePathAny {
	return &Lacp_Interface_Member_LastChangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperKey (leaf): Current operational value of the key for the aggregate
// interface
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/oper-key"
// Path from root: "/lacp/interfaces/interface/members/member/state/oper-key"
func (n *Lacp_Interface_MemberPath) OperKey() *Lacp_Interface_Member_OperKeyPath {
	return &Lacp_Interface_Member_OperKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperKey (leaf): Current operational value of the key for the aggregate
// interface
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/oper-key"
// Path from root: "/lacp/interfaces/interface/members/member/state/oper-key"
func (n *Lacp_Interface_MemberPathAny) OperKey() *Lacp_Interface_Member_OperKeyPathAny {
	return &Lacp_Interface_Member_OperKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartnerId (leaf): MAC address representing the protocol partner's interface
// system ID
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/partner-id"
// Path from root: "/lacp/interfaces/interface/members/member/state/partner-id"
func (n *Lacp_Interface_MemberPath) PartnerId() *Lacp_Interface_Member_PartnerIdPath {
	return &Lacp_Interface_Member_PartnerIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partner-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartnerId (leaf): MAC address representing the protocol partner's interface
// system ID
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/partner-id"
// Path from root: "/lacp/interfaces/interface/members/member/state/partner-id"
func (n *Lacp_Interface_MemberPathAny) PartnerId() *Lacp_Interface_Member_PartnerIdPathAny {
	return &Lacp_Interface_Member_PartnerIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partner-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartnerKey (leaf): Operational value of the protocol partner's key
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/partner-key"
// Path from root: "/lacp/interfaces/interface/members/member/state/partner-key"
func (n *Lacp_Interface_MemberPath) PartnerKey() *Lacp_Interface_Member_PartnerKeyPath {
	return &Lacp_Interface_Member_PartnerKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partner-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartnerKey (leaf): Operational value of the protocol partner's key
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/partner-key"
// Path from root: "/lacp/interfaces/interface/members/member/state/partner-key"
func (n *Lacp_Interface_MemberPathAny) PartnerKey() *Lacp_Interface_Member_PartnerKeyPathAny {
	return &Lacp_Interface_Member_PartnerKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partner-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartnerPortNum (leaf): Port number of the partner (remote) port for this member
// port
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/partner-port-num"
// Path from root: "/lacp/interfaces/interface/members/member/state/partner-port-num"
func (n *Lacp_Interface_MemberPath) PartnerPortNum() *Lacp_Interface_Member_PartnerPortNumPath {
	return &Lacp_Interface_Member_PartnerPortNumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partner-port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartnerPortNum (leaf): Port number of the partner (remote) port for this member
// port
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/partner-port-num"
// Path from root: "/lacp/interfaces/interface/members/member/state/partner-port-num"
func (n *Lacp_Interface_MemberPathAny) PartnerPortNum() *Lacp_Interface_Member_PartnerPortNumPathAny {
	return &Lacp_Interface_Member_PartnerPortNumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partner-port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortNum (leaf): Port number of the local (actor) aggregation member
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/port-num"
// Path from root: "/lacp/interfaces/interface/members/member/state/port-num"
func (n *Lacp_Interface_MemberPath) PortNum() *Lacp_Interface_Member_PortNumPath {
	return &Lacp_Interface_Member_PortNumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortNum (leaf): Port number of the local (actor) aggregation member
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/port-num"
// Path from root: "/lacp/interfaces/interface/members/member/state/port-num"
func (n *Lacp_Interface_MemberPathAny) PortNum() *Lacp_Interface_Member_PortNumPathAny {
	return &Lacp_Interface_Member_PortNumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// Synchronization (leaf): Indicates whether the participant is in-sync or
// out-of-sync
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/synchronization"
// Path from root: "/lacp/interfaces/interface/members/member/state/synchronization"
func (n *Lacp_Interface_MemberPath) Synchronization() *Lacp_Interface_Member_SynchronizationPath {
	return &Lacp_Interface_Member_SynchronizationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "synchronization"},
			map[string]interface{}{},
			n,
		),
	}
}

// Synchronization (leaf): Indicates whether the participant is in-sync or
// out-of-sync
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/synchronization"
// Path from root: "/lacp/interfaces/interface/members/member/state/synchronization"
func (n *Lacp_Interface_MemberPathAny) Synchronization() *Lacp_Interface_Member_SynchronizationPathAny {
	return &Lacp_Interface_Member_SynchronizationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "synchronization"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): MAC address that defines the local system ID for the
// aggregate interface
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/system-id"
// Path from root: "/lacp/interfaces/interface/members/member/state/system-id"
func (n *Lacp_Interface_MemberPath) SystemId() *Lacp_Interface_Member_SystemIdPath {
	return &Lacp_Interface_Member_SystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): MAC address that defines the local system ID for the
// aggregate interface
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/system-id"
// Path from root: "/lacp/interfaces/interface/members/member/state/system-id"
func (n *Lacp_Interface_MemberPathAny) SystemId() *Lacp_Interface_Member_SystemIdPathAny {
	return &Lacp_Interface_Member_SystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): The timeout type (short or long) used by the
// participant
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/timeout"
// Path from root: "/lacp/interfaces/interface/members/member/state/timeout"
func (n *Lacp_Interface_MemberPath) Timeout() *Lacp_Interface_Member_TimeoutPath {
	return &Lacp_Interface_Member_TimeoutPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): The timeout type (short or long) used by the
// participant
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "state/timeout"
// Path from root: "/lacp/interfaces/interface/members/member/state/timeout"
func (n *Lacp_Interface_MemberPathAny) Timeout() *Lacp_Interface_Member_TimeoutPathAny {
	return &Lacp_Interface_Member_TimeoutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lacp_Interface_Member_CountersPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters YANG schema element.
type Lacp_Interface_Member_CountersPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_CountersPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters YANG schema element.
type Lacp_Interface_Member_CountersPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpErrorsPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-errors YANG schema element.
type Lacp_Interface_Member_Counters_LacpErrorsPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpErrorsPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-errors YANG schema element.
type Lacp_Interface_Member_Counters_LacpErrorsPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpInPktsPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-in-pkts YANG schema element.
type Lacp_Interface_Member_Counters_LacpInPktsPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpInPktsPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-in-pkts YANG schema element.
type Lacp_Interface_Member_Counters_LacpInPktsPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpOutPktsPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-out-pkts YANG schema element.
type Lacp_Interface_Member_Counters_LacpOutPktsPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpOutPktsPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-out-pkts YANG schema element.
type Lacp_Interface_Member_Counters_LacpOutPktsPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpRxErrorsPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-rx-errors YANG schema element.
type Lacp_Interface_Member_Counters_LacpRxErrorsPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpRxErrorsPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-rx-errors YANG schema element.
type Lacp_Interface_Member_Counters_LacpRxErrorsPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpTimeoutTransitionsPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-timeout-transitions YANG schema element.
type Lacp_Interface_Member_Counters_LacpTimeoutTransitionsPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpTimeoutTransitionsPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-timeout-transitions YANG schema element.
type Lacp_Interface_Member_Counters_LacpTimeoutTransitionsPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpTxErrorsPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-tx-errors YANG schema element.
type Lacp_Interface_Member_Counters_LacpTxErrorsPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpTxErrorsPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-tx-errors YANG schema element.
type Lacp_Interface_Member_Counters_LacpTxErrorsPathAny struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpUnknownErrorsPath represents the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-unknown-errors YANG schema element.
type Lacp_Interface_Member_Counters_LacpUnknownErrorsPath struct {
	*ygot.NodePath
}

// Lacp_Interface_Member_Counters_LacpUnknownErrorsPathAny represents the wildcard version of the /openconfig-lacp/lacp/interfaces/interface/members/member/state/counters/lacp-unknown-errors YANG schema element.
type Lacp_Interface_Member_Counters_LacpUnknownErrorsPathAny struct {
	*ygot.NodePath
}

// LacpErrors (leaf): Number of LACPDU illegal packet errors
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-errors"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-errors"
func (n *Lacp_Interface_Member_CountersPath) LacpErrors() *Lacp_Interface_Member_Counters_LacpErrorsPath {
	return &Lacp_Interface_Member_Counters_LacpErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpErrors (leaf): Number of LACPDU illegal packet errors
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-errors"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-errors"
func (n *Lacp_Interface_Member_CountersPathAny) LacpErrors() *Lacp_Interface_Member_Counters_LacpErrorsPathAny {
	return &Lacp_Interface_Member_Counters_LacpErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpInPkts (leaf): Number of LACPDUs received
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-in-pkts"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-in-pkts"
func (n *Lacp_Interface_Member_CountersPath) LacpInPkts() *Lacp_Interface_Member_Counters_LacpInPktsPath {
	return &Lacp_Interface_Member_Counters_LacpInPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpInPkts (leaf): Number of LACPDUs received
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-in-pkts"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-in-pkts"
func (n *Lacp_Interface_Member_CountersPathAny) LacpInPkts() *Lacp_Interface_Member_Counters_LacpInPktsPathAny {
	return &Lacp_Interface_Member_Counters_LacpInPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpOutPkts (leaf): Number of LACPDUs transmitted
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-out-pkts"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-out-pkts"
func (n *Lacp_Interface_Member_CountersPath) LacpOutPkts() *Lacp_Interface_Member_Counters_LacpOutPktsPath {
	return &Lacp_Interface_Member_Counters_LacpOutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpOutPkts (leaf): Number of LACPDUs transmitted
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-out-pkts"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-out-pkts"
func (n *Lacp_Interface_Member_CountersPathAny) LacpOutPkts() *Lacp_Interface_Member_Counters_LacpOutPktsPathAny {
	return &Lacp_Interface_Member_Counters_LacpOutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpRxErrors (leaf): Number of LACPDU receive packet errors
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-rx-errors"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-rx-errors"
func (n *Lacp_Interface_Member_CountersPath) LacpRxErrors() *Lacp_Interface_Member_Counters_LacpRxErrorsPath {
	return &Lacp_Interface_Member_Counters_LacpRxErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-rx-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpRxErrors (leaf): Number of LACPDU receive packet errors
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-rx-errors"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-rx-errors"
func (n *Lacp_Interface_Member_CountersPathAny) LacpRxErrors() *Lacp_Interface_Member_Counters_LacpRxErrorsPathAny {
	return &Lacp_Interface_Member_Counters_LacpRxErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-rx-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpTimeoutTransitions (leaf): Number of times the LACP state has transitioned
// with a timeout since the time the device restarted
// or the interface was brought up, whichever is most
// recent. The last state change of the LACP timeout
// is defined as what is reported as the operating state
// to the system. The state change is both a timeout
// event and when the timeout event is no longer active.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-timeout-transitions"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-timeout-transitions"
func (n *Lacp_Interface_Member_CountersPath) LacpTimeoutTransitions() *Lacp_Interface_Member_Counters_LacpTimeoutTransitionsPath {
	return &Lacp_Interface_Member_Counters_LacpTimeoutTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-timeout-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpTimeoutTransitions (leaf): Number of times the LACP state has transitioned
// with a timeout since the time the device restarted
// or the interface was brought up, whichever is most
// recent. The last state change of the LACP timeout
// is defined as what is reported as the operating state
// to the system. The state change is both a timeout
// event and when the timeout event is no longer active.
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-timeout-transitions"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-timeout-transitions"
func (n *Lacp_Interface_Member_CountersPathAny) LacpTimeoutTransitions() *Lacp_Interface_Member_Counters_LacpTimeoutTransitionsPathAny {
	return &Lacp_Interface_Member_Counters_LacpTimeoutTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-timeout-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpTxErrors (leaf): Number of LACPDU transmit packet errors
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-tx-errors"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-tx-errors"
func (n *Lacp_Interface_Member_CountersPath) LacpTxErrors() *Lacp_Interface_Member_Counters_LacpTxErrorsPath {
	return &Lacp_Interface_Member_Counters_LacpTxErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-tx-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpTxErrors (leaf): Number of LACPDU transmit packet errors
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-tx-errors"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-tx-errors"
func (n *Lacp_Interface_Member_CountersPathAny) LacpTxErrors() *Lacp_Interface_Member_Counters_LacpTxErrorsPathAny {
	return &Lacp_Interface_Member_Counters_LacpTxErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-tx-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpUnknownErrors (leaf): Number of LACPDU unknown packet errors
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-unknown-errors"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-unknown-errors"
func (n *Lacp_Interface_Member_CountersPath) LacpUnknownErrors() *Lacp_Interface_Member_Counters_LacpUnknownErrorsPath {
	return &Lacp_Interface_Member_Counters_LacpUnknownErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-unknown-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// LacpUnknownErrors (leaf): Number of LACPDU unknown packet errors
// ----------------------------------------
// Defining module: "openconfig-lacp"
// Instantiating module: "openconfig-lacp"
// Path from parent: "lacp-unknown-errors"
// Path from root: "/lacp/interfaces/interface/members/member/state/counters/lacp-unknown-errors"
func (n *Lacp_Interface_Member_CountersPathAny) LacpUnknownErrors() *Lacp_Interface_Member_Counters_LacpUnknownErrorsPathAny {
	return &Lacp_Interface_Member_Counters_LacpUnknownErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lacp-unknown-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// LldpPath represents the /openconfig-lldp/lldp YANG schema element.
type LldpPath struct {
	*ygot.NodePath
}

// LldpPathAny represents the wildcard version of the /openconfig-lldp/lldp YANG schema element.
type LldpPathAny struct {
	*ygot.NodePath
}

// Lldp_ChassisIdPath represents the /openconfig-lldp/lldp/config/chassis-id YANG schema element.
type Lldp_ChassisIdPath struct {
	*ygot.NodePath
}

// Lldp_ChassisIdPathAny represents the wildcard version of the /openconfig-lldp/lldp/config/chassis-id YANG schema element.
type Lldp_ChassisIdPathAny struct {
	*ygot.NodePath
}

// Lldp_ChassisIdTypePath represents the /openconfig-lldp/lldp/config/chassis-id-type YANG schema element.
type Lldp_ChassisIdTypePath struct {
	*ygot.NodePath
}

// Lldp_ChassisIdTypePathAny represents the wildcard version of the /openconfig-lldp/lldp/config/chassis-id-type YANG schema element.
type Lldp_ChassisIdTypePathAny struct {
	*ygot.NodePath
}

// Lldp_EnabledPath represents the /openconfig-lldp/lldp/config/enabled YANG schema element.
type Lldp_EnabledPath struct {
	*ygot.NodePath
}

// Lldp_EnabledPathAny represents the wildcard version of the /openconfig-lldp/lldp/config/enabled YANG schema element.
type Lldp_EnabledPathAny struct {
	*ygot.NodePath
}

// Lldp_HelloTimerPath represents the /openconfig-lldp/lldp/config/hello-timer YANG schema element.
type Lldp_HelloTimerPath struct {
	*ygot.NodePath
}

// Lldp_HelloTimerPathAny represents the wildcard version of the /openconfig-lldp/lldp/config/hello-timer YANG schema element.
type Lldp_HelloTimerPathAny struct {
	*ygot.NodePath
}

// Lldp_SuppressTlvAdvertisementPath represents the /openconfig-lldp/lldp/config/suppress-tlv-advertisement YANG schema element.
type Lldp_SuppressTlvAdvertisementPath struct {
	*ygot.NodePath
}

// Lldp_SuppressTlvAdvertisementPathAny represents the wildcard version of the /openconfig-lldp/lldp/config/suppress-tlv-advertisement YANG schema element.
type Lldp_SuppressTlvAdvertisementPathAny struct {
	*ygot.NodePath
}

// Lldp_SystemDescriptionPath represents the /openconfig-lldp/lldp/config/system-description YANG schema element.
type Lldp_SystemDescriptionPath struct {
	*ygot.NodePath
}

// Lldp_SystemDescriptionPathAny represents the wildcard version of the /openconfig-lldp/lldp/config/system-description YANG schema element.
type Lldp_SystemDescriptionPathAny struct {
	*ygot.NodePath
}

// Lldp_SystemNamePath represents the /openconfig-lldp/lldp/config/system-name YANG schema element.
type Lldp_SystemNamePath struct {
	*ygot.NodePath
}

// Lldp_SystemNamePathAny represents the wildcard version of the /openconfig-lldp/lldp/config/system-name YANG schema element.
type Lldp_SystemNamePathAny struct {
	*ygot.NodePath
}

// ChassisId (leaf): The Chassis ID is a mandatory TLV which identifies the
// chassis component of the endpoint identifier associated with
// the transmitting LLDP agent
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/chassis-id"
// Path from root: "/lldp/config/chassis-id"
func (n *LldpPath) ChassisId() *Lldp_ChassisIdPath {
	return &Lldp_ChassisIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "chassis-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisId (leaf): The Chassis ID is a mandatory TLV which identifies the
// chassis component of the endpoint identifier associated with
// the transmitting LLDP agent
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/chassis-id"
// Path from root: "/lldp/config/chassis-id"
func (n *LldpPathAny) ChassisId() *Lldp_ChassisIdPathAny {
	return &Lldp_ChassisIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "chassis-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisIdType (leaf): This field identifies the format and source of the chassis
// identifier string. It is an enumerator defined by the
// LldpChassisIdSubtype object from IEEE 802.1AB MIB.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/chassis-id-type"
// Path from root: "/lldp/config/chassis-id-type"
func (n *LldpPath) ChassisIdType() *Lldp_ChassisIdTypePath {
	return &Lldp_ChassisIdTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "chassis-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisIdType (leaf): This field identifies the format and source of the chassis
// identifier string. It is an enumerator defined by the
// LldpChassisIdSubtype object from IEEE 802.1AB MIB.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/chassis-id-type"
// Path from root: "/lldp/config/chassis-id-type"
func (n *LldpPathAny) ChassisIdType() *Lldp_ChassisIdTypePathAny {
	return &Lldp_ChassisIdTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "chassis-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Global LLDP counters
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/counters"
// Path from root: "/lldp/state/counters"
func (n *LldpPath) Counters() *Lldp_CountersPath {
	return &Lldp_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Global LLDP counters
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/counters"
// Path from root: "/lldp/state/counters"
func (n *LldpPathAny) Counters() *Lldp_CountersPathAny {
	return &Lldp_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): System level state of the LLDP protocol.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/enabled"
// Path from root: "/lldp/config/enabled"
func (n *LldpPath) Enabled() *Lldp_EnabledPath {
	return &Lldp_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): System level state of the LLDP protocol.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/enabled"
// Path from root: "/lldp/config/enabled"
func (n *LldpPathAny) Enabled() *Lldp_EnabledPathAny {
	return &Lldp_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloTimer (leaf): System level hello timer for the LLDP protocol.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/hello-timer"
// Path from root: "/lldp/config/hello-timer"
func (n *LldpPath) HelloTimer() *Lldp_HelloTimerPath {
	return &Lldp_HelloTimerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloTimer (leaf): System level hello timer for the LLDP protocol.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/hello-timer"
// Path from root: "/lldp/config/hello-timer"
func (n *LldpPathAny) HelloTimer() *Lldp_HelloTimerPathAny {
	return &Lldp_HelloTimerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which LLDP is enabled / available
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "interfaces/interface"
// Path from root: "/lldp/interfaces/interface"
// Name (wildcarded): string
func (n *LldpPath) InterfaceAny() *Lldp_InterfacePathAny {
	return &Lldp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which LLDP is enabled / available
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "interfaces/interface"
// Path from root: "/lldp/interfaces/interface"
// Name (wildcarded): string
func (n *LldpPathAny) InterfaceAny() *Lldp_InterfacePathAny {
	return &Lldp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Interface (list): List of interfaces on which LLDP is enabled / available
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "interfaces/interface"
// Path from root: "/lldp/interfaces/interface"
// Name: string
func (n *LldpPath) Interface(Name string) *Lldp_InterfacePath {
	return &Lldp_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Interface (list): List of interfaces on which LLDP is enabled / available
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "interfaces/interface"
// Path from root: "/lldp/interfaces/interface"
// Name: string
func (n *LldpPathAny) Interface(Name string) *Lldp_InterfacePathAny {
	return &Lldp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// SuppressTlvAdvertisement (leaf): Indicates whether the local system should suppress the
// advertisement of particular TLVs with the LLDP PDUs that it
// transmits. Where a TLV type is specified within this list, it
// should not be included in any LLDP PDU transmitted by the
// local agent.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/suppress-tlv-advertisement"
// Path from root: "/lldp/config/suppress-tlv-advertisement"
func (n *LldpPath) SuppressTlvAdvertisement() *Lldp_SuppressTlvAdvertisementPath {
	return &Lldp_SuppressTlvAdvertisementPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "suppress-tlv-advertisement"},
			map[string]interface{}{},
			n,
		),
	}
}

// SuppressTlvAdvertisement (leaf): Indicates whether the local system should suppress the
// advertisement of particular TLVs with the LLDP PDUs that it
// transmits. Where a TLV type is specified within this list, it
// should not be included in any LLDP PDU transmitted by the
// local agent.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/suppress-tlv-advertisement"
// Path from root: "/lldp/config/suppress-tlv-advertisement"
func (n *LldpPathAny) SuppressTlvAdvertisement() *Lldp_SuppressTlvAdvertisementPathAny {
	return &Lldp_SuppressTlvAdvertisementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "suppress-tlv-advertisement"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemDescription (leaf): The system description field shall contain an alpha-numeric
// string that is the textual description of the network entity.
// The system description should include the full name and
// version identification of the system's hardware type,
// software operating system, and networking software. If
// implementations support IETF RFC 3418, the sysDescr object
// should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/system-description"
// Path from root: "/lldp/config/system-description"
func (n *LldpPath) SystemDescription() *Lldp_SystemDescriptionPath {
	return &Lldp_SystemDescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemDescription (leaf): The system description field shall contain an alpha-numeric
// string that is the textual description of the network entity.
// The system description should include the full name and
// version identification of the system's hardware type,
// software operating system, and networking software. If
// implementations support IETF RFC 3418, the sysDescr object
// should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/system-description"
// Path from root: "/lldp/config/system-description"
func (n *LldpPathAny) SystemDescription() *Lldp_SystemDescriptionPathAny {
	return &Lldp_SystemDescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemName (leaf): The system name field shall contain an alpha-numeric string
// that indicates the system's administratively assigned name.
// The system name should be the system's fully qualified domain
// name. If implementations support IETF RFC 3418, the sysName
// object should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/system-name"
// Path from root: "/lldp/config/system-name"
func (n *LldpPath) SystemName() *Lldp_SystemNamePath {
	return &Lldp_SystemNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemName (leaf): The system name field shall contain an alpha-numeric string
// that indicates the system's administratively assigned name.
// The system name should be the system's fully qualified domain
// name. If implementations support IETF RFC 3418, the sysName
// object should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/system-name"
// Path from root: "/lldp/config/system-name"
func (n *LldpPathAny) SystemName() *Lldp_SystemNamePathAny {
	return &Lldp_SystemNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "system-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lldp_CountersPath represents the /openconfig-lldp/lldp/state/counters YANG schema element.
type Lldp_CountersPath struct {
	*ygot.NodePath
}

// Lldp_CountersPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters YANG schema element.
type Lldp_CountersPathAny struct {
	*ygot.NodePath
}

// Lldp_Counters_EntriesAgedOutPath represents the /openconfig-lldp/lldp/state/counters/entries-aged-out YANG schema element.
type Lldp_Counters_EntriesAgedOutPath struct {
	*ygot.NodePath
}

// Lldp_Counters_EntriesAgedOutPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters/entries-aged-out YANG schema element.
type Lldp_Counters_EntriesAgedOutPathAny struct {
	*ygot.NodePath
}

// Lldp_Counters_FrameDiscardPath represents the /openconfig-lldp/lldp/state/counters/frame-discard YANG schema element.
type Lldp_Counters_FrameDiscardPath struct {
	*ygot.NodePath
}

// Lldp_Counters_FrameDiscardPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters/frame-discard YANG schema element.
type Lldp_Counters_FrameDiscardPathAny struct {
	*ygot.NodePath
}

// Lldp_Counters_FrameErrorInPath represents the /openconfig-lldp/lldp/state/counters/frame-error-in YANG schema element.
type Lldp_Counters_FrameErrorInPath struct {
	*ygot.NodePath
}

// Lldp_Counters_FrameErrorInPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters/frame-error-in YANG schema element.
type Lldp_Counters_FrameErrorInPathAny struct {
	*ygot.NodePath
}

// Lldp_Counters_FrameInPath represents the /openconfig-lldp/lldp/state/counters/frame-in YANG schema element.
type Lldp_Counters_FrameInPath struct {
	*ygot.NodePath
}

// Lldp_Counters_FrameInPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters/frame-in YANG schema element.
type Lldp_Counters_FrameInPathAny struct {
	*ygot.NodePath
}

// Lldp_Counters_FrameOutPath represents the /openconfig-lldp/lldp/state/counters/frame-out YANG schema element.
type Lldp_Counters_FrameOutPath struct {
	*ygot.NodePath
}

// Lldp_Counters_FrameOutPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters/frame-out YANG schema element.
type Lldp_Counters_FrameOutPathAny struct {
	*ygot.NodePath
}

// Lldp_Counters_LastClearPath represents the /openconfig-lldp/lldp/state/counters/last-clear YANG schema element.
type Lldp_Counters_LastClearPath struct {
	*ygot.NodePath
}

// Lldp_Counters_LastClearPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters/last-clear YANG schema element.
type Lldp_Counters_LastClearPathAny struct {
	*ygot.NodePath
}

// Lldp_Counters_TlvAcceptedPath represents the /openconfig-lldp/lldp/state/counters/tlv-accepted YANG schema element.
type Lldp_Counters_TlvAcceptedPath struct {
	*ygot.NodePath
}

// Lldp_Counters_TlvAcceptedPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters/tlv-accepted YANG schema element.
type Lldp_Counters_TlvAcceptedPathAny struct {
	*ygot.NodePath
}

// Lldp_Counters_TlvDiscardPath represents the /openconfig-lldp/lldp/state/counters/tlv-discard YANG schema element.
type Lldp_Counters_TlvDiscardPath struct {
	*ygot.NodePath
}

// Lldp_Counters_TlvDiscardPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters/tlv-discard YANG schema element.
type Lldp_Counters_TlvDiscardPathAny struct {
	*ygot.NodePath
}

// Lldp_Counters_TlvUnknownPath represents the /openconfig-lldp/lldp/state/counters/tlv-unknown YANG schema element.
type Lldp_Counters_TlvUnknownPath struct {
	*ygot.NodePath
}

// Lldp_Counters_TlvUnknownPathAny represents the wildcard version of the /openconfig-lldp/lldp/state/counters/tlv-unknown YANG schema element.
type Lldp_Counters_TlvUnknownPathAny struct {
	*ygot.NodePath
}

// EntriesAgedOut (leaf): The number of entries aged out due to timeout.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "entries-aged-out"
// Path from root: "/lldp/state/counters/entries-aged-out"
func (n *Lldp_CountersPath) EntriesAgedOut() *Lldp_Counters_EntriesAgedOutPath {
	return &Lldp_Counters_EntriesAgedOutPath{
		NodePath: ygot.NewNodePath(
			[]string{"entries-aged-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntriesAgedOut (leaf): The number of entries aged out due to timeout.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "entries-aged-out"
// Path from root: "/lldp/state/counters/entries-aged-out"
func (n *Lldp_CountersPathAny) EntriesAgedOut() *Lldp_Counters_EntriesAgedOutPathAny {
	return &Lldp_Counters_EntriesAgedOutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries-aged-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameDiscard (leaf): The number of LLDP frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-discard"
// Path from root: "/lldp/state/counters/frame-discard"
func (n *Lldp_CountersPath) FrameDiscard() *Lldp_Counters_FrameDiscardPath {
	return &Lldp_Counters_FrameDiscardPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameDiscard (leaf): The number of LLDP frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-discard"
// Path from root: "/lldp/state/counters/frame-discard"
func (n *Lldp_CountersPathAny) FrameDiscard() *Lldp_Counters_FrameDiscardPathAny {
	return &Lldp_Counters_FrameDiscardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorIn (leaf): The number of LLDP frames received with errors.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-error-in"
// Path from root: "/lldp/state/counters/frame-error-in"
func (n *Lldp_CountersPath) FrameErrorIn() *Lldp_Counters_FrameErrorInPath {
	return &Lldp_Counters_FrameErrorInPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorIn (leaf): The number of LLDP frames received with errors.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-error-in"
// Path from root: "/lldp/state/counters/frame-error-in"
func (n *Lldp_CountersPathAny) FrameErrorIn() *Lldp_Counters_FrameErrorInPathAny {
	return &Lldp_Counters_FrameErrorInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameIn (leaf): The number of lldp frames received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-in"
// Path from root: "/lldp/state/counters/frame-in"
func (n *Lldp_CountersPath) FrameIn() *Lldp_Counters_FrameInPath {
	return &Lldp_Counters_FrameInPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameIn (leaf): The number of lldp frames received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-in"
// Path from root: "/lldp/state/counters/frame-in"
func (n *Lldp_CountersPathAny) FrameIn() *Lldp_Counters_FrameInPathAny {
	return &Lldp_Counters_FrameInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameOut (leaf): The number of frames transmitted out.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-out"
// Path from root: "/lldp/state/counters/frame-out"
func (n *Lldp_CountersPath) FrameOut() *Lldp_Counters_FrameOutPath {
	return &Lldp_Counters_FrameOutPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameOut (leaf): The number of frames transmitted out.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-out"
// Path from root: "/lldp/state/counters/frame-out"
func (n *Lldp_CountersPathAny) FrameOut() *Lldp_Counters_FrameOutPathAny {
	return &Lldp_Counters_FrameOutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Indicates the last time the counters were
// cleared.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "last-clear"
// Path from root: "/lldp/state/counters/last-clear"
func (n *Lldp_CountersPath) LastClear() *Lldp_Counters_LastClearPath {
	return &Lldp_Counters_LastClearPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Indicates the last time the counters were
// cleared.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "last-clear"
// Path from root: "/lldp/state/counters/last-clear"
func (n *Lldp_CountersPathAny) LastClear() *Lldp_Counters_LastClearPathAny {
	return &Lldp_Counters_LastClearPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvAccepted (leaf): The number of valid TLVs received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-accepted"
// Path from root: "/lldp/state/counters/tlv-accepted"
func (n *Lldp_CountersPath) TlvAccepted() *Lldp_Counters_TlvAcceptedPath {
	return &Lldp_Counters_TlvAcceptedPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-accepted"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvAccepted (leaf): The number of valid TLVs received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-accepted"
// Path from root: "/lldp/state/counters/tlv-accepted"
func (n *Lldp_CountersPathAny) TlvAccepted() *Lldp_Counters_TlvAcceptedPathAny {
	return &Lldp_Counters_TlvAcceptedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-accepted"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvDiscard (leaf): The number of TLV frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-discard"
// Path from root: "/lldp/state/counters/tlv-discard"
func (n *Lldp_CountersPath) TlvDiscard() *Lldp_Counters_TlvDiscardPath {
	return &Lldp_Counters_TlvDiscardPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvDiscard (leaf): The number of TLV frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-discard"
// Path from root: "/lldp/state/counters/tlv-discard"
func (n *Lldp_CountersPathAny) TlvDiscard() *Lldp_Counters_TlvDiscardPathAny {
	return &Lldp_Counters_TlvDiscardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvUnknown (leaf): The number of frames received with unknown TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-unknown"
// Path from root: "/lldp/state/counters/tlv-unknown"
func (n *Lldp_CountersPath) TlvUnknown() *Lldp_Counters_TlvUnknownPath {
	return &Lldp_Counters_TlvUnknownPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-unknown"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvUnknown (leaf): The number of frames received with unknown TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-unknown"
// Path from root: "/lldp/state/counters/tlv-unknown"
func (n *Lldp_CountersPathAny) TlvUnknown() *Lldp_Counters_TlvUnknownPathAny {
	return &Lldp_Counters_TlvUnknownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-unknown"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lldp_InterfacePath represents the /openconfig-lldp/lldp/interfaces/interface YANG schema element.
type Lldp_InterfacePath struct {
	*ygot.NodePath
}

// Lldp_InterfacePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface YANG schema element.
type Lldp_InterfacePathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_EnabledPath represents the /openconfig-lldp/lldp/interfaces/interface/config/enabled YANG schema element.
type Lldp_Interface_EnabledPath struct {
	*ygot.NodePath
}

// Lldp_Interface_EnabledPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/config/enabled YANG schema element.
type Lldp_Interface_EnabledPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_NamePath represents the /openconfig-lldp/lldp/interfaces/interface/config/name YANG schema element.
type Lldp_Interface_NamePath struct {
	*ygot.NodePath
}

// Lldp_Interface_NamePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/config/name YANG schema element.
type Lldp_Interface_NamePathAny struct {
	*ygot.NodePath
}

// Counters (container): LLDP counters on each interface
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/counters"
// Path from root: "/lldp/interfaces/interface/state/counters"
func (n *Lldp_InterfacePath) Counters() *Lldp_Interface_CountersPath {
	return &Lldp_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): LLDP counters on each interface
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/counters"
// Path from root: "/lldp/interfaces/interface/state/counters"
func (n *Lldp_InterfacePathAny) Counters() *Lldp_Interface_CountersPathAny {
	return &Lldp_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enable or disable the LLDP protocol on the interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/enabled"
// Path from root: "/lldp/interfaces/interface/config/enabled"
func (n *Lldp_InterfacePath) Enabled() *Lldp_Interface_EnabledPath {
	return &Lldp_Interface_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enable or disable the LLDP protocol on the interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/enabled"
// Path from root: "/lldp/interfaces/interface/config/enabled"
func (n *Lldp_InterfacePathAny) Enabled() *Lldp_Interface_EnabledPathAny {
	return &Lldp_Interface_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the LLDP Ethernet interface
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/name"
// Path from root: "/lldp/interfaces/interface/config/name"
func (n *Lldp_InterfacePath) Name() *Lldp_Interface_NamePath {
	return &Lldp_Interface_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the LLDP Ethernet interface
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "config/name"
// Path from root: "/lldp/interfaces/interface/config/name"
func (n *Lldp_InterfacePathAny) Name() *Lldp_Interface_NamePathAny {
	return &Lldp_Interface_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): List of LLDP neighbors
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "neighbors/neighbor"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor"
// Id (wildcarded): string
func (n *Lldp_InterfacePath) NeighborAny() *Lldp_Interface_NeighborPathAny {
	return &Lldp_Interface_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of LLDP neighbors
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "neighbors/neighbor"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor"
// Id (wildcarded): string
func (n *Lldp_InterfacePathAny) NeighborAny() *Lldp_Interface_NeighborPathAny {
	return &Lldp_Interface_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Neighbor (list): List of LLDP neighbors
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "neighbors/neighbor"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor"
// Id: string
func (n *Lldp_InterfacePath) Neighbor(Id string) *Lldp_Interface_NeighborPath {
	return &Lldp_Interface_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Neighbor (list): List of LLDP neighbors
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "neighbors/neighbor"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor"
// Id: string
func (n *Lldp_InterfacePathAny) Neighbor(Id string) *Lldp_Interface_NeighborPathAny {
	return &Lldp_Interface_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Lldp_Interface_CountersPath represents the /openconfig-lldp/lldp/interfaces/interface/state/counters YANG schema element.
type Lldp_Interface_CountersPath struct {
	*ygot.NodePath
}

// Lldp_Interface_CountersPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/state/counters YANG schema element.
type Lldp_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameDiscardPath represents the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-discard YANG schema element.
type Lldp_Interface_Counters_FrameDiscardPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameDiscardPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-discard YANG schema element.
type Lldp_Interface_Counters_FrameDiscardPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameErrorInPath represents the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-error-in YANG schema element.
type Lldp_Interface_Counters_FrameErrorInPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameErrorInPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-error-in YANG schema element.
type Lldp_Interface_Counters_FrameErrorInPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameErrorOutPath represents the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-error-out YANG schema element.
type Lldp_Interface_Counters_FrameErrorOutPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameErrorOutPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-error-out YANG schema element.
type Lldp_Interface_Counters_FrameErrorOutPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameInPath represents the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-in YANG schema element.
type Lldp_Interface_Counters_FrameInPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameInPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-in YANG schema element.
type Lldp_Interface_Counters_FrameInPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameOutPath represents the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-out YANG schema element.
type Lldp_Interface_Counters_FrameOutPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_FrameOutPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/state/counters/frame-out YANG schema element.
type Lldp_Interface_Counters_FrameOutPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_LastClearPath represents the /openconfig-lldp/lldp/interfaces/interface/state/counters/last-clear YANG schema element.
type Lldp_Interface_Counters_LastClearPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_LastClearPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/state/counters/last-clear YANG schema element.
type Lldp_Interface_Counters_LastClearPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_TlvDiscardPath represents the /openconfig-lldp/lldp/interfaces/interface/state/counters/tlv-discard YANG schema element.
type Lldp_Interface_Counters_TlvDiscardPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_TlvDiscardPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/state/counters/tlv-discard YANG schema element.
type Lldp_Interface_Counters_TlvDiscardPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_TlvUnknownPath represents the /openconfig-lldp/lldp/interfaces/interface/state/counters/tlv-unknown YANG schema element.
type Lldp_Interface_Counters_TlvUnknownPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Counters_TlvUnknownPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/state/counters/tlv-unknown YANG schema element.
type Lldp_Interface_Counters_TlvUnknownPathAny struct {
	*ygot.NodePath
}

// FrameDiscard (leaf): The number of LLDP frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-discard"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-discard"
func (n *Lldp_Interface_CountersPath) FrameDiscard() *Lldp_Interface_Counters_FrameDiscardPath {
	return &Lldp_Interface_Counters_FrameDiscardPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameDiscard (leaf): The number of LLDP frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-discard"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-discard"
func (n *Lldp_Interface_CountersPathAny) FrameDiscard() *Lldp_Interface_Counters_FrameDiscardPathAny {
	return &Lldp_Interface_Counters_FrameDiscardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorIn (leaf): The number of LLDP frames received with errors.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-error-in"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-error-in"
func (n *Lldp_Interface_CountersPath) FrameErrorIn() *Lldp_Interface_Counters_FrameErrorInPath {
	return &Lldp_Interface_Counters_FrameErrorInPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorIn (leaf): The number of LLDP frames received with errors.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-error-in"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-error-in"
func (n *Lldp_Interface_CountersPathAny) FrameErrorIn() *Lldp_Interface_Counters_FrameErrorInPathAny {
	return &Lldp_Interface_Counters_FrameErrorInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorOut (leaf): The number of frame transmit errors on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-error-out"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-error-out"
func (n *Lldp_Interface_CountersPath) FrameErrorOut() *Lldp_Interface_Counters_FrameErrorOutPath {
	return &Lldp_Interface_Counters_FrameErrorOutPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorOut (leaf): The number of frame transmit errors on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-error-out"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-error-out"
func (n *Lldp_Interface_CountersPathAny) FrameErrorOut() *Lldp_Interface_Counters_FrameErrorOutPathAny {
	return &Lldp_Interface_Counters_FrameErrorOutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameIn (leaf): The number of lldp frames received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-in"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-in"
func (n *Lldp_Interface_CountersPath) FrameIn() *Lldp_Interface_Counters_FrameInPath {
	return &Lldp_Interface_Counters_FrameInPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameIn (leaf): The number of lldp frames received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-in"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-in"
func (n *Lldp_Interface_CountersPathAny) FrameIn() *Lldp_Interface_Counters_FrameInPathAny {
	return &Lldp_Interface_Counters_FrameInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameOut (leaf): The number of frames transmitted out.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-out"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-out"
func (n *Lldp_Interface_CountersPath) FrameOut() *Lldp_Interface_Counters_FrameOutPath {
	return &Lldp_Interface_Counters_FrameOutPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameOut (leaf): The number of frames transmitted out.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "frame-out"
// Path from root: "/lldp/interfaces/interface/state/counters/frame-out"
func (n *Lldp_Interface_CountersPathAny) FrameOut() *Lldp_Interface_Counters_FrameOutPathAny {
	return &Lldp_Interface_Counters_FrameOutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Indicates the last time the counters were
// cleared.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "last-clear"
// Path from root: "/lldp/interfaces/interface/state/counters/last-clear"
func (n *Lldp_Interface_CountersPath) LastClear() *Lldp_Interface_Counters_LastClearPath {
	return &Lldp_Interface_Counters_LastClearPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Indicates the last time the counters were
// cleared.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "last-clear"
// Path from root: "/lldp/interfaces/interface/state/counters/last-clear"
func (n *Lldp_Interface_CountersPathAny) LastClear() *Lldp_Interface_Counters_LastClearPathAny {
	return &Lldp_Interface_Counters_LastClearPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvDiscard (leaf): The number of TLV frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-discard"
// Path from root: "/lldp/interfaces/interface/state/counters/tlv-discard"
func (n *Lldp_Interface_CountersPath) TlvDiscard() *Lldp_Interface_Counters_TlvDiscardPath {
	return &Lldp_Interface_Counters_TlvDiscardPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvDiscard (leaf): The number of TLV frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-discard"
// Path from root: "/lldp/interfaces/interface/state/counters/tlv-discard"
func (n *Lldp_Interface_CountersPathAny) TlvDiscard() *Lldp_Interface_Counters_TlvDiscardPathAny {
	return &Lldp_Interface_Counters_TlvDiscardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvUnknown (leaf): The number of frames received with unknown TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-unknown"
// Path from root: "/lldp/interfaces/interface/state/counters/tlv-unknown"
func (n *Lldp_Interface_CountersPath) TlvUnknown() *Lldp_Interface_Counters_TlvUnknownPath {
	return &Lldp_Interface_Counters_TlvUnknownPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-unknown"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvUnknown (leaf): The number of frames received with unknown TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "tlv-unknown"
// Path from root: "/lldp/interfaces/interface/state/counters/tlv-unknown"
func (n *Lldp_Interface_CountersPathAny) TlvUnknown() *Lldp_Interface_Counters_TlvUnknownPathAny {
	return &Lldp_Interface_Counters_TlvUnknownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-unknown"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lldp_Interface_NeighborPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor YANG schema element.
type Lldp_Interface_NeighborPath struct {
	*ygot.NodePath
}

// Lldp_Interface_NeighborPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor YANG schema element.
type Lldp_Interface_NeighborPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_AgePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/age YANG schema element.
type Lldp_Interface_Neighbor_AgePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_AgePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/age YANG schema element.
type Lldp_Interface_Neighbor_AgePathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_ChassisIdPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/chassis-id YANG schema element.
type Lldp_Interface_Neighbor_ChassisIdPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_ChassisIdPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/chassis-id YANG schema element.
type Lldp_Interface_Neighbor_ChassisIdPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_ChassisIdTypePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/chassis-id-type YANG schema element.
type Lldp_Interface_Neighbor_ChassisIdTypePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_ChassisIdTypePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/chassis-id-type YANG schema element.
type Lldp_Interface_Neighbor_ChassisIdTypePathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_IdPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/id YANG schema element.
type Lldp_Interface_Neighbor_IdPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_IdPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/id YANG schema element.
type Lldp_Interface_Neighbor_IdPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_LastUpdatePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/last-update YANG schema element.
type Lldp_Interface_Neighbor_LastUpdatePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_LastUpdatePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/last-update YANG schema element.
type Lldp_Interface_Neighbor_LastUpdatePathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_ManagementAddressPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/management-address YANG schema element.
type Lldp_Interface_Neighbor_ManagementAddressPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_ManagementAddressPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/management-address YANG schema element.
type Lldp_Interface_Neighbor_ManagementAddressPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_ManagementAddressTypePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/management-address-type YANG schema element.
type Lldp_Interface_Neighbor_ManagementAddressTypePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_ManagementAddressTypePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/management-address-type YANG schema element.
type Lldp_Interface_Neighbor_ManagementAddressTypePathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_PortDescriptionPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/port-description YANG schema element.
type Lldp_Interface_Neighbor_PortDescriptionPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_PortDescriptionPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/port-description YANG schema element.
type Lldp_Interface_Neighbor_PortDescriptionPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_PortIdPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/port-id YANG schema element.
type Lldp_Interface_Neighbor_PortIdPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_PortIdPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/port-id YANG schema element.
type Lldp_Interface_Neighbor_PortIdPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_PortIdTypePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/port-id-type YANG schema element.
type Lldp_Interface_Neighbor_PortIdTypePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_PortIdTypePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/port-id-type YANG schema element.
type Lldp_Interface_Neighbor_PortIdTypePathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_SystemDescriptionPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/system-description YANG schema element.
type Lldp_Interface_Neighbor_SystemDescriptionPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_SystemDescriptionPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/system-description YANG schema element.
type Lldp_Interface_Neighbor_SystemDescriptionPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_SystemNamePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/system-name YANG schema element.
type Lldp_Interface_Neighbor_SystemNamePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_SystemNamePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/system-name YANG schema element.
type Lldp_Interface_Neighbor_SystemNamePathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_TtlPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/ttl YANG schema element.
type Lldp_Interface_Neighbor_TtlPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_TtlPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/state/ttl YANG schema element.
type Lldp_Interface_Neighbor_TtlPathAny struct {
	*ygot.NodePath
}

// Age (leaf): Age since discovery
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/age"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/age"
func (n *Lldp_Interface_NeighborPath) Age() *Lldp_Interface_Neighbor_AgePath {
	return &Lldp_Interface_Neighbor_AgePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "age"},
			map[string]interface{}{},
			n,
		),
	}
}

// Age (leaf): Age since discovery
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/age"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/age"
func (n *Lldp_Interface_NeighborPathAny) Age() *Lldp_Interface_Neighbor_AgePathAny {
	return &Lldp_Interface_Neighbor_AgePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "age"},
			map[string]interface{}{},
			n,
		),
	}
}

// CapabilityAny (list): List of LLDP system capabilities advertised by the
// neighbor
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "capabilities/capability"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability"
// Name (wildcarded): E_LldpTypes_LLDP_SYSTEM_CAPABILITY
func (n *Lldp_Interface_NeighborPath) CapabilityAny() *Lldp_Interface_Neighbor_CapabilityPathAny {
	return &Lldp_Interface_Neighbor_CapabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"capabilities", "capability"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// CapabilityAny (list): List of LLDP system capabilities advertised by the
// neighbor
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "capabilities/capability"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability"
// Name (wildcarded): E_LldpTypes_LLDP_SYSTEM_CAPABILITY
func (n *Lldp_Interface_NeighborPathAny) CapabilityAny() *Lldp_Interface_Neighbor_CapabilityPathAny {
	return &Lldp_Interface_Neighbor_CapabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"capabilities", "capability"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Capability (list): List of LLDP system capabilities advertised by the
// neighbor
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "capabilities/capability"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability"
// Name: E_LldpTypes_LLDP_SYSTEM_CAPABILITY
func (n *Lldp_Interface_NeighborPath) Capability(Name E_LldpTypes_LLDP_SYSTEM_CAPABILITY) *Lldp_Interface_Neighbor_CapabilityPath {
	return &Lldp_Interface_Neighbor_CapabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"capabilities", "capability"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Capability (list): List of LLDP system capabilities advertised by the
// neighbor
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "capabilities/capability"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability"
// Name: E_LldpTypes_LLDP_SYSTEM_CAPABILITY
func (n *Lldp_Interface_NeighborPathAny) Capability(Name E_LldpTypes_LLDP_SYSTEM_CAPABILITY) *Lldp_Interface_Neighbor_CapabilityPathAny {
	return &Lldp_Interface_Neighbor_CapabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"capabilities", "capability"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// ChassisId (leaf): The Chassis ID is a mandatory TLV which identifies the
// chassis component of the endpoint identifier associated with
// the transmitting LLDP agent
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/chassis-id"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/chassis-id"
func (n *Lldp_Interface_NeighborPath) ChassisId() *Lldp_Interface_Neighbor_ChassisIdPath {
	return &Lldp_Interface_Neighbor_ChassisIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chassis-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisId (leaf): The Chassis ID is a mandatory TLV which identifies the
// chassis component of the endpoint identifier associated with
// the transmitting LLDP agent
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/chassis-id"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/chassis-id"
func (n *Lldp_Interface_NeighborPathAny) ChassisId() *Lldp_Interface_Neighbor_ChassisIdPathAny {
	return &Lldp_Interface_Neighbor_ChassisIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chassis-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisIdType (leaf): This field identifies the format and source of the chassis
// identifier string. It is an enumerator defined by the
// LldpChassisIdSubtype object from IEEE 802.1AB MIB.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/chassis-id-type"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/chassis-id-type"
func (n *Lldp_Interface_NeighborPath) ChassisIdType() *Lldp_Interface_Neighbor_ChassisIdTypePath {
	return &Lldp_Interface_Neighbor_ChassisIdTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chassis-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisIdType (leaf): This field identifies the format and source of the chassis
// identifier string. It is an enumerator defined by the
// LldpChassisIdSubtype object from IEEE 802.1AB MIB.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/chassis-id-type"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/chassis-id-type"
func (n *Lldp_Interface_NeighborPathAny) ChassisIdType() *Lldp_Interface_Neighbor_ChassisIdTypePathAny {
	return &Lldp_Interface_Neighbor_ChassisIdTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chassis-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): System generated identifier for the neighbor on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/id"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/id"
func (n *Lldp_Interface_NeighborPath) Id() *Lldp_Interface_Neighbor_IdPath {
	return &Lldp_Interface_Neighbor_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): System generated identifier for the neighbor on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/id"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/id"
func (n *Lldp_Interface_NeighborPathAny) Id() *Lldp_Interface_Neighbor_IdPathAny {
	return &Lldp_Interface_Neighbor_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastUpdate (leaf): Seconds since last update received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/last-update"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/last-update"
func (n *Lldp_Interface_NeighborPath) LastUpdate() *Lldp_Interface_Neighbor_LastUpdatePath {
	return &Lldp_Interface_Neighbor_LastUpdatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-update"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastUpdate (leaf): Seconds since last update received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/last-update"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/last-update"
func (n *Lldp_Interface_NeighborPathAny) LastUpdate() *Lldp_Interface_Neighbor_LastUpdatePathAny {
	return &Lldp_Interface_Neighbor_LastUpdatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-update"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManagementAddress (leaf): The Management Address is a mandatory TLV which identifies a
// network address associated with the local LLDP agent, which
// can be used to reach the agent on the port identified in the
// Port ID TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/management-address"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/management-address"
func (n *Lldp_Interface_NeighborPath) ManagementAddress() *Lldp_Interface_Neighbor_ManagementAddressPath {
	return &Lldp_Interface_Neighbor_ManagementAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManagementAddress (leaf): The Management Address is a mandatory TLV which identifies a
// network address associated with the local LLDP agent, which
// can be used to reach the agent on the port identified in the
// Port ID TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/management-address"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/management-address"
func (n *Lldp_Interface_NeighborPathAny) ManagementAddress() *Lldp_Interface_Neighbor_ManagementAddressPathAny {
	return &Lldp_Interface_Neighbor_ManagementAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManagementAddressType (leaf): The enumerated value for the network address type
// identified in this TLV. This enumeration is defined in the
// 'Assigned Numbers' RFC [RFC3232] and the
// ianaAddressFamilyNumbers object.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/management-address-type"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/management-address-type"
func (n *Lldp_Interface_NeighborPath) ManagementAddressType() *Lldp_Interface_Neighbor_ManagementAddressTypePath {
	return &Lldp_Interface_Neighbor_ManagementAddressTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management-address-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManagementAddressType (leaf): The enumerated value for the network address type
// identified in this TLV. This enumeration is defined in the
// 'Assigned Numbers' RFC [RFC3232] and the
// ianaAddressFamilyNumbers object.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/management-address-type"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/management-address-type"
func (n *Lldp_Interface_NeighborPathAny) ManagementAddressType() *Lldp_Interface_Neighbor_ManagementAddressTypePathAny {
	return &Lldp_Interface_Neighbor_ManagementAddressTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management-address-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortDescription (leaf): The binary string containing the actual port identifier for
// the port which this LLDP PDU was transmitted. The source and
// format of this field is defined by PtopoPortId from
// RFC2922.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/port-description"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/port-description"
func (n *Lldp_Interface_NeighborPath) PortDescription() *Lldp_Interface_Neighbor_PortDescriptionPath {
	return &Lldp_Interface_Neighbor_PortDescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortDescription (leaf): The binary string containing the actual port identifier for
// the port which this LLDP PDU was transmitted. The source and
// format of this field is defined by PtopoPortId from
// RFC2922.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/port-description"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/port-description"
func (n *Lldp_Interface_NeighborPathAny) PortDescription() *Lldp_Interface_Neighbor_PortDescriptionPathAny {
	return &Lldp_Interface_Neighbor_PortDescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortId (leaf): The Port ID is a mandatory TLV which identifies the port
// component of the endpoint identifier associated with the
// transmitting LLDP agent. If the specified port is an IEEE
// 802.3 Repeater port, then this TLV is optional.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/port-id"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/port-id"
func (n *Lldp_Interface_NeighborPath) PortId() *Lldp_Interface_Neighbor_PortIdPath {
	return &Lldp_Interface_Neighbor_PortIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortId (leaf): The Port ID is a mandatory TLV which identifies the port
// component of the endpoint identifier associated with the
// transmitting LLDP agent. If the specified port is an IEEE
// 802.3 Repeater port, then this TLV is optional.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/port-id"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/port-id"
func (n *Lldp_Interface_NeighborPathAny) PortId() *Lldp_Interface_Neighbor_PortIdPathAny {
	return &Lldp_Interface_Neighbor_PortIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortIdType (leaf): This field identifies the format and source of the port
// identifier string. It is an enumerator defined by the
// PtopoPortIdType object from RFC2922.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/port-id-type"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/port-id-type"
func (n *Lldp_Interface_NeighborPath) PortIdType() *Lldp_Interface_Neighbor_PortIdTypePath {
	return &Lldp_Interface_Neighbor_PortIdTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortIdType (leaf): This field identifies the format and source of the port
// identifier string. It is an enumerator defined by the
// PtopoPortIdType object from RFC2922.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/port-id-type"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/port-id-type"
func (n *Lldp_Interface_NeighborPathAny) PortIdType() *Lldp_Interface_Neighbor_PortIdTypePathAny {
	return &Lldp_Interface_Neighbor_PortIdTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemDescription (leaf): The system description field shall contain an alpha-numeric
// string that is the textual description of the network entity.
// The system description should include the full name and
// version identification of the system's hardware type,
// software operating system, and networking software. If
// implementations support IETF RFC 3418, the sysDescr object
// should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/system-description"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/system-description"
func (n *Lldp_Interface_NeighborPath) SystemDescription() *Lldp_Interface_Neighbor_SystemDescriptionPath {
	return &Lldp_Interface_Neighbor_SystemDescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemDescription (leaf): The system description field shall contain an alpha-numeric
// string that is the textual description of the network entity.
// The system description should include the full name and
// version identification of the system's hardware type,
// software operating system, and networking software. If
// implementations support IETF RFC 3418, the sysDescr object
// should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/system-description"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/system-description"
func (n *Lldp_Interface_NeighborPathAny) SystemDescription() *Lldp_Interface_Neighbor_SystemDescriptionPathAny {
	return &Lldp_Interface_Neighbor_SystemDescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemName (leaf): The system name field shall contain an alpha-numeric string
// that indicates the system's administratively assigned name.
// The system name should be the system's fully qualified domain
// name. If implementations support IETF RFC 3418, the sysName
// object should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/system-name"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/system-name"
func (n *Lldp_Interface_NeighborPath) SystemName() *Lldp_Interface_Neighbor_SystemNamePath {
	return &Lldp_Interface_Neighbor_SystemNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemName (leaf): The system name field shall contain an alpha-numeric string
// that indicates the system's administratively assigned name.
// The system name should be the system's fully qualified domain
// name. If implementations support IETF RFC 3418, the sysName
// object should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/system-name"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/system-name"
func (n *Lldp_Interface_NeighborPathAny) SystemName() *Lldp_Interface_Neighbor_SystemNamePathAny {
	return &Lldp_Interface_Neighbor_SystemNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvAny (list): List of custom LLDP TLVs from a neighbor
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "custom-tlvs/tlv"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv"
func (n *Lldp_Interface_NeighborPath) TlvAny() *Lldp_Interface_Neighbor_TlvPathAny {
	return &Lldp_Interface_Neighbor_TlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"custom-tlvs", "tlv"},
			map[string]interface{}{"type": "*", "oui": "*", "oui-subtype": "*"},
			n,
		),
	}
}

// TlvAny (list): List of custom LLDP TLVs from a neighbor
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "custom-tlvs/tlv"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv"
func (n *Lldp_Interface_NeighborPathAny) TlvAny() *Lldp_Interface_Neighbor_TlvPathAny {
	return &Lldp_Interface_Neighbor_TlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"custom-tlvs", "tlv"},
			map[string]interface{}{"type": "*", "oui": "*", "oui-subtype": "*"},
			n,
		),
	}
}

// WithType sets Lldp_Interface_Neighbor_TlvPathAny's key "type" to the specified value.
// Type: int32
func (n *Lldp_Interface_Neighbor_TlvPathAny) WithType(Type int32) *Lldp_Interface_Neighbor_TlvPathAny {
	ygot.ModifyKey(n.NodePath, "type", Type)
	return n
}

// WithOui sets Lldp_Interface_Neighbor_TlvPathAny's key "oui" to the specified value.
// Oui: string
func (n *Lldp_Interface_Neighbor_TlvPathAny) WithOui(Oui string) *Lldp_Interface_Neighbor_TlvPathAny {
	ygot.ModifyKey(n.NodePath, "oui", Oui)
	return n
}

// WithOuiSubtype sets Lldp_Interface_Neighbor_TlvPathAny's key "oui-subtype" to the specified value.
// OuiSubtype: string
func (n *Lldp_Interface_Neighbor_TlvPathAny) WithOuiSubtype(OuiSubtype string) *Lldp_Interface_Neighbor_TlvPathAny {
	ygot.ModifyKey(n.NodePath, "oui-subtype", OuiSubtype)
	return n
}

// Ttl (leaf): The time-to-live (TTL) is a mandatory TLV which indicates
// how long information from the neighbor should be considered
// valid.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/ttl"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/ttl"
func (n *Lldp_Interface_NeighborPath) Ttl() *Lldp_Interface_Neighbor_TtlPath {
	return &Lldp_Interface_Neighbor_TtlPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ttl (leaf): The time-to-live (TTL) is a mandatory TLV which indicates
// how long information from the neighbor should be considered
// valid.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/ttl"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/state/ttl"
func (n *Lldp_Interface_NeighborPathAny) Ttl() *Lldp_Interface_Neighbor_TtlPathAny {
	return &Lldp_Interface_Neighbor_TtlPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lldp_Interface_Neighbor_CapabilityPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability YANG schema element.
type Lldp_Interface_Neighbor_CapabilityPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_CapabilityPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability YANG schema element.
type Lldp_Interface_Neighbor_CapabilityPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Capability_EnabledPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability/state/enabled YANG schema element.
type Lldp_Interface_Neighbor_Capability_EnabledPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Capability_EnabledPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability/state/enabled YANG schema element.
type Lldp_Interface_Neighbor_Capability_EnabledPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Capability_NamePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability/state/name YANG schema element.
type Lldp_Interface_Neighbor_Capability_NamePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Capability_NamePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability/state/name YANG schema element.
type Lldp_Interface_Neighbor_Capability_NamePathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Indicates whether the corresponding system capability is
// enabled on the neighbor.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/enabled"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability/state/enabled"
func (n *Lldp_Interface_Neighbor_CapabilityPath) Enabled() *Lldp_Interface_Neighbor_Capability_EnabledPath {
	return &Lldp_Interface_Neighbor_Capability_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Indicates whether the corresponding system capability is
// enabled on the neighbor.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/enabled"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability/state/enabled"
func (n *Lldp_Interface_Neighbor_CapabilityPathAny) Enabled() *Lldp_Interface_Neighbor_Capability_EnabledPathAny {
	return &Lldp_Interface_Neighbor_Capability_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Name of the system capability advertised by the neighbor.
// Capabilities are represented in a bitmap that defines the
// primary functions of the system. The capabilities are
// defined in IEEE 802.1AB.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/name"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability/state/name"
func (n *Lldp_Interface_Neighbor_CapabilityPath) Name() *Lldp_Interface_Neighbor_Capability_NamePath {
	return &Lldp_Interface_Neighbor_Capability_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Name of the system capability advertised by the neighbor.
// Capabilities are represented in a bitmap that defines the
// primary functions of the system. The capabilities are
// defined in IEEE 802.1AB.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/name"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/capabilities/capability/state/name"
func (n *Lldp_Interface_Neighbor_CapabilityPathAny) Name() *Lldp_Interface_Neighbor_Capability_NamePathAny {
	return &Lldp_Interface_Neighbor_Capability_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lldp_Interface_Neighbor_TlvPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv YANG schema element.
type Lldp_Interface_Neighbor_TlvPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_TlvPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv YANG schema element.
type Lldp_Interface_Neighbor_TlvPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Tlv_OuiPath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/oui YANG schema element.
type Lldp_Interface_Neighbor_Tlv_OuiPath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Tlv_OuiPathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/oui YANG schema element.
type Lldp_Interface_Neighbor_Tlv_OuiPathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Tlv_OuiSubtypePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/oui-subtype YANG schema element.
type Lldp_Interface_Neighbor_Tlv_OuiSubtypePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Tlv_OuiSubtypePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/oui-subtype YANG schema element.
type Lldp_Interface_Neighbor_Tlv_OuiSubtypePathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Tlv_TypePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/type YANG schema element.
type Lldp_Interface_Neighbor_Tlv_TypePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Tlv_TypePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/type YANG schema element.
type Lldp_Interface_Neighbor_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Tlv_ValuePath represents the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/value YANG schema element.
type Lldp_Interface_Neighbor_Tlv_ValuePath struct {
	*ygot.NodePath
}

// Lldp_Interface_Neighbor_Tlv_ValuePathAny represents the wildcard version of the /openconfig-lldp/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/value YANG schema element.
type Lldp_Interface_Neighbor_Tlv_ValuePathAny struct {
	*ygot.NodePath
}

// Oui (leaf): The organizationally unique identifier field shall contain
// the organization's OUI as defined in Clause 9 of IEEE Std
// 802. The high-order octet is 0 and the low-order 3 octets
// are the SMI Network Management Private Enterprise Code of
// the Vendor in network byte order, as defined in the
// 'Assigned Numbers' RFC [RFC3232].
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/oui"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/oui"
func (n *Lldp_Interface_Neighbor_TlvPath) Oui() *Lldp_Interface_Neighbor_Tlv_OuiPath {
	return &Lldp_Interface_Neighbor_Tlv_OuiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oui"},
			map[string]interface{}{},
			n,
		),
	}
}

// Oui (leaf): The organizationally unique identifier field shall contain
// the organization's OUI as defined in Clause 9 of IEEE Std
// 802. The high-order octet is 0 and the low-order 3 octets
// are the SMI Network Management Private Enterprise Code of
// the Vendor in network byte order, as defined in the
// 'Assigned Numbers' RFC [RFC3232].
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/oui"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/oui"
func (n *Lldp_Interface_Neighbor_TlvPathAny) Oui() *Lldp_Interface_Neighbor_Tlv_OuiPathAny {
	return &Lldp_Interface_Neighbor_Tlv_OuiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oui"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuiSubtype (leaf): The organizationally defined subtype field shall contain a
// unique subtype value assigned by the defining organization.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/oui-subtype"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/oui-subtype"
func (n *Lldp_Interface_Neighbor_TlvPath) OuiSubtype() *Lldp_Interface_Neighbor_Tlv_OuiSubtypePath {
	return &Lldp_Interface_Neighbor_Tlv_OuiSubtypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oui-subtype"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuiSubtype (leaf): The organizationally defined subtype field shall contain a
// unique subtype value assigned by the defining organization.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/oui-subtype"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/oui-subtype"
func (n *Lldp_Interface_Neighbor_TlvPathAny) OuiSubtype() *Lldp_Interface_Neighbor_Tlv_OuiSubtypePathAny {
	return &Lldp_Interface_Neighbor_Tlv_OuiSubtypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oui-subtype"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The integer value identifying the type of information
// contained in the value field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/type"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/type"
func (n *Lldp_Interface_Neighbor_TlvPath) Type() *Lldp_Interface_Neighbor_Tlv_TypePath {
	return &Lldp_Interface_Neighbor_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The integer value identifying the type of information
// contained in the value field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/type"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/type"
func (n *Lldp_Interface_Neighbor_TlvPathAny) Type() *Lldp_Interface_Neighbor_Tlv_TypePathAny {
	return &Lldp_Interface_Neighbor_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): A variable-length octet-string containing the
// instance-specific information for this TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/value"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/value"
func (n *Lldp_Interface_Neighbor_TlvPath) Value() *Lldp_Interface_Neighbor_Tlv_ValuePath {
	return &Lldp_Interface_Neighbor_Tlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): A variable-length octet-string containing the
// instance-specific information for this TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-lldp"
// Path from parent: "state/value"
// Path from root: "/lldp/interfaces/interface/neighbors/neighbor/custom-tlvs/tlv/state/value"
func (n *Lldp_Interface_Neighbor_TlvPathAny) Value() *Lldp_Interface_Neighbor_Tlv_ValuePathAny {
	return &Lldp_Interface_Neighbor_Tlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalRoutesPath represents the /openconfig-local-routing/local-routes YANG schema element.
type LocalRoutesPath struct {
	*ygot.NodePath
}

// LocalRoutesPathAny represents the wildcard version of the /openconfig-local-routing/local-routes YANG schema element.
type LocalRoutesPathAny struct {
	*ygot.NodePath
}

// AggregateAny (list): List of aggregates
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "local-aggregates/aggregate"
// Path from root: "/local-routes/local-aggregates/aggregate"
// Prefix (wildcarded): string
func (n *LocalRoutesPath) AggregateAny() *LocalRoutes_AggregatePathAny {
	return &LocalRoutes_AggregatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"local-aggregates", "aggregate"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// AggregateAny (list): List of aggregates
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "local-aggregates/aggregate"
// Path from root: "/local-routes/local-aggregates/aggregate"
// Prefix (wildcarded): string
func (n *LocalRoutesPathAny) AggregateAny() *LocalRoutes_AggregatePathAny {
	return &LocalRoutes_AggregatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"local-aggregates", "aggregate"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Aggregate (list): List of aggregates
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "local-aggregates/aggregate"
// Path from root: "/local-routes/local-aggregates/aggregate"
// Prefix: string
func (n *LocalRoutesPath) Aggregate(Prefix string) *LocalRoutes_AggregatePath {
	return &LocalRoutes_AggregatePath{
		NodePath: ygot.NewNodePath(
			[]string{"local-aggregates", "aggregate"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Aggregate (list): List of aggregates
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "local-aggregates/aggregate"
// Path from root: "/local-routes/local-aggregates/aggregate"
// Prefix: string
func (n *LocalRoutesPathAny) Aggregate(Prefix string) *LocalRoutes_AggregatePathAny {
	return &LocalRoutes_AggregatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"local-aggregates", "aggregate"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// StaticAny (list): List of locally configured static routes
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "static-routes/static"
// Path from root: "/local-routes/static-routes/static"
// Prefix (wildcarded): string
func (n *LocalRoutesPath) StaticAny() *LocalRoutes_StaticPathAny {
	return &LocalRoutes_StaticPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-routes", "static"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// StaticAny (list): List of locally configured static routes
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "static-routes/static"
// Path from root: "/local-routes/static-routes/static"
// Prefix (wildcarded): string
func (n *LocalRoutesPathAny) StaticAny() *LocalRoutes_StaticPathAny {
	return &LocalRoutes_StaticPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-routes", "static"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Static (list): List of locally configured static routes
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "static-routes/static"
// Path from root: "/local-routes/static-routes/static"
// Prefix: string
func (n *LocalRoutesPath) Static(Prefix string) *LocalRoutes_StaticPath {
	return &LocalRoutes_StaticPath{
		NodePath: ygot.NewNodePath(
			[]string{"static-routes", "static"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Static (list): List of locally configured static routes
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "static-routes/static"
// Path from root: "/local-routes/static-routes/static"
// Prefix: string
func (n *LocalRoutesPathAny) Static(Prefix string) *LocalRoutes_StaticPathAny {
	return &LocalRoutes_StaticPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-routes", "static"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// LocalRoutes_AggregatePath represents the /openconfig-local-routing/local-routes/local-aggregates/aggregate YANG schema element.
type LocalRoutes_AggregatePath struct {
	*ygot.NodePath
}

// LocalRoutes_AggregatePathAny represents the wildcard version of the /openconfig-local-routing/local-routes/local-aggregates/aggregate YANG schema element.
type LocalRoutes_AggregatePathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Aggregate_DescriptionPath represents the /openconfig-local-routing/local-routes/local-aggregates/aggregate/config/description YANG schema element.
type LocalRoutes_Aggregate_DescriptionPath struct {
	*ygot.NodePath
}

// LocalRoutes_Aggregate_DescriptionPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/local-aggregates/aggregate/config/description YANG schema element.
type LocalRoutes_Aggregate_DescriptionPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Aggregate_DiscardPath represents the /openconfig-local-routing/local-routes/local-aggregates/aggregate/config/discard YANG schema element.
type LocalRoutes_Aggregate_DiscardPath struct {
	*ygot.NodePath
}

// LocalRoutes_Aggregate_DiscardPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/local-aggregates/aggregate/config/discard YANG schema element.
type LocalRoutes_Aggregate_DiscardPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Aggregate_PrefixPath represents the /openconfig-local-routing/local-routes/local-aggregates/aggregate/config/prefix YANG schema element.
type LocalRoutes_Aggregate_PrefixPath struct {
	*ygot.NodePath
}

// LocalRoutes_Aggregate_PrefixPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/local-aggregates/aggregate/config/prefix YANG schema element.
type LocalRoutes_Aggregate_PrefixPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Aggregate_SetTagPath represents the /openconfig-local-routing/local-routes/local-aggregates/aggregate/config/set-tag YANG schema element.
type LocalRoutes_Aggregate_SetTagPath struct {
	*ygot.NodePath
}

// LocalRoutes_Aggregate_SetTagPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/local-aggregates/aggregate/config/set-tag YANG schema element.
type LocalRoutes_Aggregate_SetTagPathAny struct {
	*ygot.NodePath
}

// Description (leaf): An optional textual description for the route.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/description"
// Path from root: "/local-routes/local-aggregates/aggregate/config/description"
func (n *LocalRoutes_AggregatePath) Description() *LocalRoutes_Aggregate_DescriptionPath {
	return &LocalRoutes_Aggregate_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): An optional textual description for the route.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/description"
// Path from root: "/local-routes/local-aggregates/aggregate/config/description"
func (n *LocalRoutes_AggregatePathAny) Description() *LocalRoutes_Aggregate_DescriptionPathAny {
	return &LocalRoutes_Aggregate_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Discard (leaf): When true, install the aggregate route with a discard
// next-hop -- traffic destined to the aggregate will be
// discarded with no ICMP message generated.  When false,
// traffic destined to an aggregate address when no
// constituent routes are present will generate an ICMP
// unreachable message.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/discard"
// Path from root: "/local-routes/local-aggregates/aggregate/config/discard"
func (n *LocalRoutes_AggregatePath) Discard() *LocalRoutes_Aggregate_DiscardPath {
	return &LocalRoutes_Aggregate_DiscardPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// Discard (leaf): When true, install the aggregate route with a discard
// next-hop -- traffic destined to the aggregate will be
// discarded with no ICMP message generated.  When false,
// traffic destined to an aggregate address when no
// constituent routes are present will generate an ICMP
// unreachable message.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/discard"
// Path from root: "/local-routes/local-aggregates/aggregate/config/discard"
func (n *LocalRoutes_AggregatePathAny) Discard() *LocalRoutes_Aggregate_DiscardPathAny {
	return &LocalRoutes_Aggregate_DiscardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Aggregate prefix to be advertised
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/prefix"
// Path from root: "/local-routes/local-aggregates/aggregate/config/prefix"
func (n *LocalRoutes_AggregatePath) Prefix() *LocalRoutes_Aggregate_PrefixPath {
	return &LocalRoutes_Aggregate_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Aggregate prefix to be advertised
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/prefix"
// Path from root: "/local-routes/local-aggregates/aggregate/config/prefix"
func (n *LocalRoutes_AggregatePathAny) Prefix() *LocalRoutes_Aggregate_PrefixPathAny {
	return &LocalRoutes_Aggregate_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (leaf): Set a generic tag value on the route. This tag can be
// used for filtering routes that are distributed to other
// routing protocols.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/set-tag"
// Path from root: "/local-routes/local-aggregates/aggregate/config/set-tag"
func (n *LocalRoutes_AggregatePath) SetTag() *LocalRoutes_Aggregate_SetTagPath {
	return &LocalRoutes_Aggregate_SetTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (leaf): Set a generic tag value on the route. This tag can be
// used for filtering routes that are distributed to other
// routing protocols.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/set-tag"
// Path from root: "/local-routes/local-aggregates/aggregate/config/set-tag"
func (n *LocalRoutes_AggregatePathAny) SetTag() *LocalRoutes_Aggregate_SetTagPathAny {
	return &LocalRoutes_Aggregate_SetTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalRoutes_StaticPath represents the /openconfig-local-routing/local-routes/static-routes/static YANG schema element.
type LocalRoutes_StaticPath struct {
	*ygot.NodePath
}

// LocalRoutes_StaticPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static YANG schema element.
type LocalRoutes_StaticPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_DescriptionPath represents the /openconfig-local-routing/local-routes/static-routes/static/config/description YANG schema element.
type LocalRoutes_Static_DescriptionPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_DescriptionPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/config/description YANG schema element.
type LocalRoutes_Static_DescriptionPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_PrefixPath represents the /openconfig-local-routing/local-routes/static-routes/static/config/prefix YANG schema element.
type LocalRoutes_Static_PrefixPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_PrefixPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/config/prefix YANG schema element.
type LocalRoutes_Static_PrefixPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_SetTagPath represents the /openconfig-local-routing/local-routes/static-routes/static/config/set-tag YANG schema element.
type LocalRoutes_Static_SetTagPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_SetTagPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/config/set-tag YANG schema element.
type LocalRoutes_Static_SetTagPathAny struct {
	*ygot.NodePath
}

// Description (leaf): An optional textual description for the route.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/description"
// Path from root: "/local-routes/static-routes/static/config/description"
func (n *LocalRoutes_StaticPath) Description() *LocalRoutes_Static_DescriptionPath {
	return &LocalRoutes_Static_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): An optional textual description for the route.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/description"
// Path from root: "/local-routes/static-routes/static/config/description"
func (n *LocalRoutes_StaticPathAny) Description() *LocalRoutes_Static_DescriptionPathAny {
	return &LocalRoutes_Static_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopAny (list): A list of next-hops to be utilised for the static
// route being specified.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "next-hops/next-hop"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop"
// Index (wildcarded): string
func (n *LocalRoutes_StaticPath) NextHopAny() *LocalRoutes_Static_NextHopPathAny {
	return &LocalRoutes_Static_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHopAny (list): A list of next-hops to be utilised for the static
// route being specified.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "next-hops/next-hop"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop"
// Index (wildcarded): string
func (n *LocalRoutes_StaticPathAny) NextHopAny() *LocalRoutes_Static_NextHopPathAny {
	return &LocalRoutes_Static_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHop (list): A list of next-hops to be utilised for the static
// route being specified.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "next-hops/next-hop"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop"
// Index: string
func (n *LocalRoutes_StaticPath) NextHop(Index string) *LocalRoutes_Static_NextHopPath {
	return &LocalRoutes_Static_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NextHop (list): A list of next-hops to be utilised for the static
// route being specified.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "next-hops/next-hop"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop"
// Index: string
func (n *LocalRoutes_StaticPathAny) NextHop(Index string) *LocalRoutes_Static_NextHopPathAny {
	return &LocalRoutes_Static_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Prefix (leaf): Destination prefix for the static route, either IPv4 or
// IPv6.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/prefix"
// Path from root: "/local-routes/static-routes/static/config/prefix"
func (n *LocalRoutes_StaticPath) Prefix() *LocalRoutes_Static_PrefixPath {
	return &LocalRoutes_Static_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Destination prefix for the static route, either IPv4 or
// IPv6.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/prefix"
// Path from root: "/local-routes/static-routes/static/config/prefix"
func (n *LocalRoutes_StaticPathAny) Prefix() *LocalRoutes_Static_PrefixPathAny {
	return &LocalRoutes_Static_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (leaf): Set a generic tag value on the route. This tag can be
// used for filtering routes that are distributed to other
// routing protocols.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/set-tag"
// Path from root: "/local-routes/static-routes/static/config/set-tag"
func (n *LocalRoutes_StaticPath) SetTag() *LocalRoutes_Static_SetTagPath {
	return &LocalRoutes_Static_SetTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (leaf): Set a generic tag value on the route. This tag can be
// used for filtering routes that are distributed to other
// routing protocols.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/set-tag"
// Path from root: "/local-routes/static-routes/static/config/set-tag"
func (n *LocalRoutes_StaticPathAny) SetTag() *LocalRoutes_Static_SetTagPathAny {
	return &LocalRoutes_Static_SetTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalRoutes_Static_NextHopPath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop YANG schema element.
type LocalRoutes_Static_NextHopPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHopPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop YANG schema element.
type LocalRoutes_Static_NextHopPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_IndexPath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/config/index YANG schema element.
type LocalRoutes_Static_NextHop_IndexPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_IndexPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/config/index YANG schema element.
type LocalRoutes_Static_NextHop_IndexPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_MetricPath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/config/metric YANG schema element.
type LocalRoutes_Static_NextHop_MetricPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_MetricPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/config/metric YANG schema element.
type LocalRoutes_Static_NextHop_MetricPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_NextHopPath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/config/next-hop YANG schema element.
type LocalRoutes_Static_NextHop_NextHopPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_NextHopPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/config/next-hop YANG schema element.
type LocalRoutes_Static_NextHop_NextHopPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_RecursePath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/config/recurse YANG schema element.
type LocalRoutes_Static_NextHop_RecursePath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_RecursePathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/config/recurse YANG schema element.
type LocalRoutes_Static_NextHop_RecursePathAny struct {
	*ygot.NodePath
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "enable-bfd"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/enable-bfd"
func (n *LocalRoutes_Static_NextHopPath) EnableBfd() *LocalRoutes_Static_NextHop_EnableBfdPath {
	return &LocalRoutes_Static_NextHop_EnableBfdPath{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "enable-bfd"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/enable-bfd"
func (n *LocalRoutes_Static_NextHopPathAny) EnableBfd() *LocalRoutes_Static_NextHop_EnableBfdPathAny {
	return &LocalRoutes_Static_NextHop_EnableBfdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): An user-specified identifier utilised to uniquely reference
// the next-hop entry in the next-hop list. The value of this
// index has no semantic meaning other than for referencing
// the entry.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/index"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/config/index"
func (n *LocalRoutes_Static_NextHopPath) Index() *LocalRoutes_Static_NextHop_IndexPath {
	return &LocalRoutes_Static_NextHop_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): An user-specified identifier utilised to uniquely reference
// the next-hop entry in the next-hop list. The value of this
// index has no semantic meaning other than for referencing
// the entry.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/index"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/config/index"
func (n *LocalRoutes_Static_NextHopPathAny) Index() *LocalRoutes_Static_NextHop_IndexPathAny {
	return &LocalRoutes_Static_NextHop_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "interface-ref"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/interface-ref"
func (n *LocalRoutes_Static_NextHopPath) InterfaceRef() *LocalRoutes_Static_NextHop_InterfaceRefPath {
	return &LocalRoutes_Static_NextHop_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "interface-ref"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/interface-ref"
func (n *LocalRoutes_Static_NextHopPathAny) InterfaceRef() *LocalRoutes_Static_NextHop_InterfaceRefPathAny {
	return &LocalRoutes_Static_NextHop_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): A metric which is utilised to specify the preference of
// the next-hop entry when it is injected into the RIB. The
// lower the metric, the more preferable the prefix is. When
// this value is not specified the metric is inherited from
// the default metric utilised for static routes within the
// network instance that the static routes are being
// instantiated. When multiple next-hops are specified for a
// static route, the metric is utilised to determine which of
// the next-hops is to be installed in the RIB. When multiple
// next-hops have the same metric (be it specified, or simply
// the default) then these next-hops should all be installed
// in the RIB
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/metric"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/config/metric"
func (n *LocalRoutes_Static_NextHopPath) Metric() *LocalRoutes_Static_NextHop_MetricPath {
	return &LocalRoutes_Static_NextHop_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): A metric which is utilised to specify the preference of
// the next-hop entry when it is injected into the RIB. The
// lower the metric, the more preferable the prefix is. When
// this value is not specified the metric is inherited from
// the default metric utilised for static routes within the
// network instance that the static routes are being
// instantiated. When multiple next-hops are specified for a
// static route, the metric is utilised to determine which of
// the next-hops is to be installed in the RIB. When multiple
// next-hops have the same metric (be it specified, or simply
// the default) then these next-hops should all be installed
// in the RIB
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/metric"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/config/metric"
func (n *LocalRoutes_Static_NextHopPathAny) Metric() *LocalRoutes_Static_NextHop_MetricPathAny {
	return &LocalRoutes_Static_NextHop_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): The next-hop that is to be used for the static route
// - this may be specified as an IP address, an interface
// or a pre-defined next-hop type - for instance, DROP or
// LOCAL_LINK. When this leaf is not set, and the interface-ref
// value is specified for the next-hop, then the system should
// treat the prefix as though it is directly connected to the
// interface.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/next-hop"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/config/next-hop"
func (n *LocalRoutes_Static_NextHopPath) NextHop() *LocalRoutes_Static_NextHop_NextHopPath {
	return &LocalRoutes_Static_NextHop_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): The next-hop that is to be used for the static route
// - this may be specified as an IP address, an interface
// or a pre-defined next-hop type - for instance, DROP or
// LOCAL_LINK. When this leaf is not set, and the interface-ref
// value is specified for the next-hop, then the system should
// treat the prefix as though it is directly connected to the
// interface.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/next-hop"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/config/next-hop"
func (n *LocalRoutes_Static_NextHopPathAny) NextHop() *LocalRoutes_Static_NextHop_NextHopPathAny {
	return &LocalRoutes_Static_NextHop_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// Recurse (leaf): Determines whether the next-hop should be allowed to
// be looked up recursively - i.e., via a RIB entry which has
// been installed by a routing protocol, or another static route
// - rather than needing to be connected directly to an
// interface of the local system within the current network
// instance. When the interface reference specified within the
// next-hop entry is set (i.e., is not null) then forwarding is
// restricted to being via the interface specified - and
// recursion is hence disabled.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/recurse"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/config/recurse"
func (n *LocalRoutes_Static_NextHopPath) Recurse() *LocalRoutes_Static_NextHop_RecursePath {
	return &LocalRoutes_Static_NextHop_RecursePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "recurse"},
			map[string]interface{}{},
			n,
		),
	}
}

// Recurse (leaf): Determines whether the next-hop should be allowed to
// be looked up recursively - i.e., via a RIB entry which has
// been installed by a routing protocol, or another static route
// - rather than needing to be connected directly to an
// interface of the local system within the current network
// instance. When the interface reference specified within the
// next-hop entry is set (i.e., is not null) then forwarding is
// restricted to being via the interface specified - and
// recursion is hence disabled.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/recurse"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/config/recurse"
func (n *LocalRoutes_Static_NextHopPathAny) Recurse() *LocalRoutes_Static_NextHop_RecursePathAny {
	return &LocalRoutes_Static_NextHop_RecursePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "recurse"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalRoutes_Static_NextHop_EnableBfdPath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/enable-bfd YANG schema element.
type LocalRoutes_Static_NextHop_EnableBfdPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_EnableBfdPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/enable-bfd YANG schema element.
type LocalRoutes_Static_NextHop_EnableBfdPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_EnableBfd_EnabledPath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/enable-bfd/config/enabled YANG schema element.
type LocalRoutes_Static_NextHop_EnableBfd_EnabledPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_EnableBfd_EnabledPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/enable-bfd/config/enabled YANG schema element.
type LocalRoutes_Static_NextHop_EnableBfd_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/enabled"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/enable-bfd/config/enabled"
func (n *LocalRoutes_Static_NextHop_EnableBfdPath) Enabled() *LocalRoutes_Static_NextHop_EnableBfd_EnabledPath {
	return &LocalRoutes_Static_NextHop_EnableBfd_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/enabled"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/enable-bfd/config/enabled"
func (n *LocalRoutes_Static_NextHop_EnableBfdPathAny) Enabled() *LocalRoutes_Static_NextHop_EnableBfd_EnabledPathAny {
	return &LocalRoutes_Static_NextHop_EnableBfd_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalRoutes_Static_NextHop_InterfaceRefPath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/interface-ref YANG schema element.
type LocalRoutes_Static_NextHop_InterfaceRefPath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_InterfaceRefPathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/interface-ref YANG schema element.
type LocalRoutes_Static_NextHop_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_InterfaceRef_InterfacePath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/interface-ref/config/interface YANG schema element.
type LocalRoutes_Static_NextHop_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/interface-ref/config/interface YANG schema element.
type LocalRoutes_Static_NextHop_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_InterfaceRef_SubinterfacePath represents the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/interface-ref/config/subinterface YANG schema element.
type LocalRoutes_Static_NextHop_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// LocalRoutes_Static_NextHop_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-local-routing/local-routes/static-routes/static/next-hops/next-hop/interface-ref/config/subinterface YANG schema element.
type LocalRoutes_Static_NextHop_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/interface"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/interface-ref/config/interface"
func (n *LocalRoutes_Static_NextHop_InterfaceRefPath) Interface() *LocalRoutes_Static_NextHop_InterfaceRef_InterfacePath {
	return &LocalRoutes_Static_NextHop_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/interface"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/interface-ref/config/interface"
func (n *LocalRoutes_Static_NextHop_InterfaceRefPathAny) Interface() *LocalRoutes_Static_NextHop_InterfaceRef_InterfacePathAny {
	return &LocalRoutes_Static_NextHop_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/subinterface"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/interface-ref/config/subinterface"
func (n *LocalRoutes_Static_NextHop_InterfaceRefPath) Subinterface() *LocalRoutes_Static_NextHop_InterfaceRef_SubinterfacePath {
	return &LocalRoutes_Static_NextHop_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-local-routing"
// Path from parent: "config/subinterface"
// Path from root: "/local-routes/static-routes/static/next-hops/next-hop/interface-ref/config/subinterface"
func (n *LocalRoutes_Static_NextHop_InterfaceRefPathAny) Subinterface() *LocalRoutes_Static_NextHop_InterfaceRef_SubinterfacePathAny {
	return &LocalRoutes_Static_NextHop_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// MessagesPath represents the /openconfig-messages/messages YANG schema element.
type MessagesPath struct {
	*ygot.NodePath
}

// MessagesPathAny represents the wildcard version of the /openconfig-messages/messages YANG schema element.
type MessagesPathAny struct {
	*ygot.NodePath
}

// Messages_SeverityPath represents the /openconfig-messages/messages/config/severity YANG schema element.
type Messages_SeverityPath struct {
	*ygot.NodePath
}

// Messages_SeverityPathAny represents the wildcard version of the /openconfig-messages/messages/config/severity YANG schema element.
type Messages_SeverityPathAny struct {
	*ygot.NodePath
}

// DebugServiceAny (list): List of debugging entries.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "debug-entries/debug-service"
// Path from root: "/messages/debug-entries/debug-service"
// Service (wildcarded): E_Messages_DEBUG_SERVICE
func (n *MessagesPath) DebugServiceAny() *Messages_DebugServicePathAny {
	return &Messages_DebugServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"debug-entries", "debug-service"},
			map[string]interface{}{"service": "*"},
			n,
		),
	}
}

// DebugServiceAny (list): List of debugging entries.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "debug-entries/debug-service"
// Path from root: "/messages/debug-entries/debug-service"
// Service (wildcarded): E_Messages_DEBUG_SERVICE
func (n *MessagesPathAny) DebugServiceAny() *Messages_DebugServicePathAny {
	return &Messages_DebugServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"debug-entries", "debug-service"},
			map[string]interface{}{"service": "*"},
			n,
		),
	}
}

// DebugService (list): List of debugging entries.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "debug-entries/debug-service"
// Path from root: "/messages/debug-entries/debug-service"
// Service: E_Messages_DEBUG_SERVICE
func (n *MessagesPath) DebugService(Service E_Messages_DEBUG_SERVICE) *Messages_DebugServicePath {
	return &Messages_DebugServicePath{
		NodePath: ygot.NewNodePath(
			[]string{"debug-entries", "debug-service"},
			map[string]interface{}{"service": Service},
			n,
		),
	}
}

// DebugService (list): List of debugging entries.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "debug-entries/debug-service"
// Path from root: "/messages/debug-entries/debug-service"
// Service: E_Messages_DEBUG_SERVICE
func (n *MessagesPathAny) DebugService(Service E_Messages_DEBUG_SERVICE) *Messages_DebugServicePathAny {
	return &Messages_DebugServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"debug-entries", "debug-service"},
			map[string]interface{}{"service": Service},
			n,
		),
	}
}

// Message (container): Syslog messages the client is Subscribing to. This is all
// messages currently configured to be sent according to
// syslog-severity.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "state/message"
// Path from root: "/messages/state/message"
func (n *MessagesPath) Message() *Messages_MessagePath {
	return &Messages_MessagePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "message"},
			map[string]interface{}{},
			n,
		),
	}
}

// Message (container): Syslog messages the client is Subscribing to. This is all
// messages currently configured to be sent according to
// syslog-severity.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "state/message"
// Path from root: "/messages/state/message"
func (n *MessagesPathAny) Message() *Messages_MessagePathAny {
	return &Messages_MessagePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "message"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): Specifies that only messages of the given severity (or
// greater severity) are sent over the RPC.
//
// This is analogous to differentiating which severity is to be
// sent to legacy Syslog servers, as opposed to local buffer or
// files.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "config/severity"
// Path from root: "/messages/config/severity"
func (n *MessagesPath) Severity() *Messages_SeverityPath {
	return &Messages_SeverityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): Specifies that only messages of the given severity (or
// greater severity) are sent over the RPC.
//
// This is analogous to differentiating which severity is to be
// sent to legacy Syslog servers, as opposed to local buffer or
// files.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "config/severity"
// Path from root: "/messages/config/severity"
func (n *MessagesPathAny) Severity() *Messages_SeverityPathAny {
	return &Messages_SeverityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// Messages_DebugServicePath represents the /openconfig-messages/messages/debug-entries/debug-service YANG schema element.
type Messages_DebugServicePath struct {
	*ygot.NodePath
}

// Messages_DebugServicePathAny represents the wildcard version of the /openconfig-messages/messages/debug-entries/debug-service YANG schema element.
type Messages_DebugServicePathAny struct {
	*ygot.NodePath
}

// Messages_DebugService_EnabledPath represents the /openconfig-messages/messages/debug-entries/debug-service/config/enabled YANG schema element.
type Messages_DebugService_EnabledPath struct {
	*ygot.NodePath
}

// Messages_DebugService_EnabledPathAny represents the wildcard version of the /openconfig-messages/messages/debug-entries/debug-service/config/enabled YANG schema element.
type Messages_DebugService_EnabledPathAny struct {
	*ygot.NodePath
}

// Messages_DebugService_ServicePath represents the /openconfig-messages/messages/debug-entries/debug-service/config/service YANG schema element.
type Messages_DebugService_ServicePath struct {
	*ygot.NodePath
}

// Messages_DebugService_ServicePathAny represents the wildcard version of the /openconfig-messages/messages/debug-entries/debug-service/config/service YANG schema element.
type Messages_DebugService_ServicePathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Enable and disable debugging.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "config/enabled"
// Path from root: "/messages/debug-entries/debug-service/config/enabled"
func (n *Messages_DebugServicePath) Enabled() *Messages_DebugService_EnabledPath {
	return &Messages_DebugService_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enable and disable debugging.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "config/enabled"
// Path from root: "/messages/debug-entries/debug-service/config/enabled"
func (n *Messages_DebugServicePathAny) Enabled() *Messages_DebugService_EnabledPathAny {
	return &Messages_DebugService_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Service (leaf): Enumeration of all services which can have debugging enabled.
// Vendors are to augment this base identity with their platform
// or OS specific debug options.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "config/service"
// Path from root: "/messages/debug-entries/debug-service/config/service"
func (n *Messages_DebugServicePath) Service() *Messages_DebugService_ServicePath {
	return &Messages_DebugService_ServicePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "service"},
			map[string]interface{}{},
			n,
		),
	}
}

// Service (leaf): Enumeration of all services which can have debugging enabled.
// Vendors are to augment this base identity with their platform
// or OS specific debug options.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "config/service"
// Path from root: "/messages/debug-entries/debug-service/config/service"
func (n *Messages_DebugServicePathAny) Service() *Messages_DebugService_ServicePathAny {
	return &Messages_DebugService_ServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "service"},
			map[string]interface{}{},
			n,
		),
	}
}

// Messages_MessagePath represents the /openconfig-messages/messages/state/message YANG schema element.
type Messages_MessagePath struct {
	*ygot.NodePath
}

// Messages_MessagePathAny represents the wildcard version of the /openconfig-messages/messages/state/message YANG schema element.
type Messages_MessagePathAny struct {
	*ygot.NodePath
}

// Messages_Message_AppNamePath represents the /openconfig-messages/messages/state/message/app-name YANG schema element.
type Messages_Message_AppNamePath struct {
	*ygot.NodePath
}

// Messages_Message_AppNamePathAny represents the wildcard version of the /openconfig-messages/messages/state/message/app-name YANG schema element.
type Messages_Message_AppNamePathAny struct {
	*ygot.NodePath
}

// Messages_Message_MsgPath represents the /openconfig-messages/messages/state/message/msg YANG schema element.
type Messages_Message_MsgPath struct {
	*ygot.NodePath
}

// Messages_Message_MsgPathAny represents the wildcard version of the /openconfig-messages/messages/state/message/msg YANG schema element.
type Messages_Message_MsgPathAny struct {
	*ygot.NodePath
}

// Messages_Message_MsgidPath represents the /openconfig-messages/messages/state/message/msgid YANG schema element.
type Messages_Message_MsgidPath struct {
	*ygot.NodePath
}

// Messages_Message_MsgidPathAny represents the wildcard version of the /openconfig-messages/messages/state/message/msgid YANG schema element.
type Messages_Message_MsgidPathAny struct {
	*ygot.NodePath
}

// Messages_Message_PriorityPath represents the /openconfig-messages/messages/state/message/priority YANG schema element.
type Messages_Message_PriorityPath struct {
	*ygot.NodePath
}

// Messages_Message_PriorityPathAny represents the wildcard version of the /openconfig-messages/messages/state/message/priority YANG schema element.
type Messages_Message_PriorityPathAny struct {
	*ygot.NodePath
}

// Messages_Message_ProcidPath represents the /openconfig-messages/messages/state/message/procid YANG schema element.
type Messages_Message_ProcidPath struct {
	*ygot.NodePath
}

// Messages_Message_ProcidPathAny represents the wildcard version of the /openconfig-messages/messages/state/message/procid YANG schema element.
type Messages_Message_ProcidPathAny struct {
	*ygot.NodePath
}

// AppName (leaf): The APP-NAME field SHOULD identify the device or
// application that originated the message.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "app-name"
// Path from root: "/messages/state/message/app-name"
func (n *Messages_MessagePath) AppName() *Messages_Message_AppNamePath {
	return &Messages_Message_AppNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"app-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AppName (leaf): The APP-NAME field SHOULD identify the device or
// application that originated the message.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "app-name"
// Path from root: "/messages/state/message/app-name"
func (n *Messages_MessagePathAny) AppName() *Messages_Message_AppNamePathAny {
	return &Messages_Message_AppNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"app-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Msg (leaf): Message payload. If other leafs within this container not
// supported, this leaf MAY include the entire message,
// inclding pri, procid, app-name etc..
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "msg"
// Path from root: "/messages/state/message/msg"
func (n *Messages_MessagePath) Msg() *Messages_Message_MsgPath {
	return &Messages_Message_MsgPath{
		NodePath: ygot.NewNodePath(
			[]string{"msg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Msg (leaf): Message payload. If other leafs within this container not
// supported, this leaf MAY include the entire message,
// inclding pri, procid, app-name etc..
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "msg"
// Path from root: "/messages/state/message/msg"
func (n *Messages_MessagePathAny) Msg() *Messages_Message_MsgPathAny {
	return &Messages_Message_MsgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"msg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Msgid (leaf): The MSGID SHOULD identify the type of message. For
// example, a firewall might use the MSGID 'TCPIN' for
// incoming TCP traffic and the MSGID 'TCPOUT' for outgoing
// TCP traffic.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "msgid"
// Path from root: "/messages/state/message/msgid"
func (n *Messages_MessagePath) Msgid() *Messages_Message_MsgidPath {
	return &Messages_Message_MsgidPath{
		NodePath: ygot.NewNodePath(
			[]string{"msgid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Msgid (leaf): The MSGID SHOULD identify the type of message. For
// example, a firewall might use the MSGID 'TCPIN' for
// incoming TCP traffic and the MSGID 'TCPOUT' for outgoing
// TCP traffic.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "msgid"
// Path from root: "/messages/state/message/msgid"
func (n *Messages_MessagePathAny) Msgid() *Messages_Message_MsgidPathAny {
	return &Messages_Message_MsgidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"msgid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The Priority value (PRIVAL) represents both the
// Facility and Severity.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "priority"
// Path from root: "/messages/state/message/priority"
func (n *Messages_MessagePath) Priority() *Messages_Message_PriorityPath {
	return &Messages_Message_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The Priority value (PRIVAL) represents both the
// Facility and Severity.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "priority"
// Path from root: "/messages/state/message/priority"
func (n *Messages_MessagePathAny) Priority() *Messages_Message_PriorityPathAny {
	return &Messages_Message_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Procid (leaf): PROCID is a value that is included in the message, having
// no interoperable meaning, except that a change in the value
// indicates there has been a discontinuity in syslog
// reporting.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "procid"
// Path from root: "/messages/state/message/procid"
func (n *Messages_MessagePath) Procid() *Messages_Message_ProcidPath {
	return &Messages_Message_ProcidPath{
		NodePath: ygot.NewNodePath(
			[]string{"procid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Procid (leaf): PROCID is a value that is included in the message, having
// no interoperable meaning, except that a change in the value
// indicates there has been a discontinuity in syslog
// reporting.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-messages"
// Path from parent: "procid"
// Path from root: "/messages/state/message/procid"
func (n *Messages_MessagePathAny) Procid() *Messages_Message_ProcidPathAny {
	return &Messages_Message_ProcidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"procid"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstancePath represents the /openconfig-network-instance/network-instances/network-instance YANG schema element.
type NetworkInstancePath struct {
	*ygot.NodePath
}

// NetworkInstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance YANG schema element.
type NetworkInstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_DescriptionPath represents the /openconfig-network-instance/network-instances/network-instance/config/description YANG schema element.
type NetworkInstance_DescriptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_DescriptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/config/description YANG schema element.
type NetworkInstance_DescriptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/config/enabled YANG schema element.
type NetworkInstance_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/config/enabled YANG schema element.
type NetworkInstance_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_EnabledAddressFamiliesPath represents the /openconfig-network-instance/network-instances/network-instance/config/enabled-address-families YANG schema element.
type NetworkInstance_EnabledAddressFamiliesPath struct {
	*ygot.NodePath
}

// NetworkInstance_EnabledAddressFamiliesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/config/enabled-address-families YANG schema element.
type NetworkInstance_EnabledAddressFamiliesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_MtuPath represents the /openconfig-network-instance/network-instances/network-instance/config/mtu YANG schema element.
type NetworkInstance_MtuPath struct {
	*ygot.NodePath
}

// NetworkInstance_MtuPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/config/mtu YANG schema element.
type NetworkInstance_MtuPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_NamePath represents the /openconfig-network-instance/network-instances/network-instance/config/name YANG schema element.
type NetworkInstance_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/config/name YANG schema element.
type NetworkInstance_NamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_RouteDistinguisherPath represents the /openconfig-network-instance/network-instances/network-instance/config/route-distinguisher YANG schema element.
type NetworkInstance_RouteDistinguisherPath struct {
	*ygot.NodePath
}

// NetworkInstance_RouteDistinguisherPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/config/route-distinguisher YANG schema element.
type NetworkInstance_RouteDistinguisherPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/config/router-id YANG schema element.
type NetworkInstance_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/config/router-id YANG schema element.
type NetworkInstance_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_TypePath represents the /openconfig-network-instance/network-instances/network-instance/config/type YANG schema element.
type NetworkInstance_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/config/type YANG schema element.
type NetworkInstance_TypePathAny struct {
	*ygot.NodePath
}

// Afts (container): The abstract forwarding tables (AFTs) that are associated
// with the network instance. An AFT is instantiated per-protocol
// running within the network-instance - such that one exists for
// IPv4 Unicast, IPv6 Unicast, MPLS, L2 forwarding entries, etc.
// A forwarding entry within the FIB has a set of next-hops,
// which may be a reference to an entry within another table -
// e.g., where a Layer 3 next-hop has an associated Layer 2
// forwarding entry.
// ----------------------------------------
// Defining module: "openconfig-aft"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afts"
// Path from root: "/network-instances/network-instance/afts"
func (n *NetworkInstancePath) Afts() *NetworkInstance_AftsPath {
	return &NetworkInstance_AftsPath{
		NodePath: ygot.NewNodePath(
			[]string{"afts"},
			map[string]interface{}{},
			n,
		),
	}
}

// Afts (container): The abstract forwarding tables (AFTs) that are associated
// with the network instance. An AFT is instantiated per-protocol
// running within the network-instance - such that one exists for
// IPv4 Unicast, IPv6 Unicast, MPLS, L2 forwarding entries, etc.
// A forwarding entry within the FIB has a set of next-hops,
// which may be a reference to an entry within another table -
// e.g., where a Layer 3 next-hop has an associated Layer 2
// forwarding entry.
// ----------------------------------------
// Defining module: "openconfig-aft"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afts"
// Path from root: "/network-instances/network-instance/afts"
func (n *NetworkInstancePathAny) Afts() *NetworkInstance_AftsPathAny {
	return &NetworkInstance_AftsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afts"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionPointAny (list): A connection point within a Layer 2 network instance.
// Each connection-point consists of a set of interfaces
// only one of which is active at any one time. Other than
// the specification of whether an interface is local
// (i.e., exists within this network-instance), or remote,
// all configuration and state parameters are common
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "connection-points/connection-point"
// Path from root: "/network-instances/network-instance/connection-points/connection-point"
// ConnectionPointId (wildcarded): string
func (n *NetworkInstancePath) ConnectionPointAny() *NetworkInstance_ConnectionPointPathAny {
	return &NetworkInstance_ConnectionPointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"connection-points", "connection-point"},
			map[string]interface{}{"connection-point-id": "*"},
			n,
		),
	}
}

// ConnectionPointAny (list): A connection point within a Layer 2 network instance.
// Each connection-point consists of a set of interfaces
// only one of which is active at any one time. Other than
// the specification of whether an interface is local
// (i.e., exists within this network-instance), or remote,
// all configuration and state parameters are common
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "connection-points/connection-point"
// Path from root: "/network-instances/network-instance/connection-points/connection-point"
// ConnectionPointId (wildcarded): string
func (n *NetworkInstancePathAny) ConnectionPointAny() *NetworkInstance_ConnectionPointPathAny {
	return &NetworkInstance_ConnectionPointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"connection-points", "connection-point"},
			map[string]interface{}{"connection-point-id": "*"},
			n,
		),
	}
}

// ConnectionPoint (list): A connection point within a Layer 2 network instance.
// Each connection-point consists of a set of interfaces
// only one of which is active at any one time. Other than
// the specification of whether an interface is local
// (i.e., exists within this network-instance), or remote,
// all configuration and state parameters are common
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "connection-points/connection-point"
// Path from root: "/network-instances/network-instance/connection-points/connection-point"
// ConnectionPointId: string
func (n *NetworkInstancePath) ConnectionPoint(ConnectionPointId string) *NetworkInstance_ConnectionPointPath {
	return &NetworkInstance_ConnectionPointPath{
		NodePath: ygot.NewNodePath(
			[]string{"connection-points", "connection-point"},
			map[string]interface{}{"connection-point-id": ConnectionPointId},
			n,
		),
	}
}

// ConnectionPoint (list): A connection point within a Layer 2 network instance.
// Each connection-point consists of a set of interfaces
// only one of which is active at any one time. Other than
// the specification of whether an interface is local
// (i.e., exists within this network-instance), or remote,
// all configuration and state parameters are common
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "connection-points/connection-point"
// Path from root: "/network-instances/network-instance/connection-points/connection-point"
// ConnectionPointId: string
func (n *NetworkInstancePathAny) ConnectionPoint(ConnectionPointId string) *NetworkInstance_ConnectionPointPathAny {
	return &NetworkInstance_ConnectionPointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"connection-points", "connection-point"},
			map[string]interface{}{"connection-point-id": ConnectionPointId},
			n,
		),
	}
}

// Description (leaf): A free-form string to be used by the network operator to
// describe the function of this network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/config/description"
func (n *NetworkInstancePath) Description() *NetworkInstance_DescriptionPath {
	return &NetworkInstance_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): A free-form string to be used by the network operator to
// describe the function of this network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/config/description"
func (n *NetworkInstancePathAny) Description() *NetworkInstance_DescriptionPathAny {
	return &NetworkInstance_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the network instance should be configured to be
// active on the network element
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/config/enabled"
func (n *NetworkInstancePath) Enabled() *NetworkInstance_EnabledPath {
	return &NetworkInstance_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the network instance should be configured to be
// active on the network element
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/config/enabled"
func (n *NetworkInstancePathAny) Enabled() *NetworkInstance_EnabledPathAny {
	return &NetworkInstance_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnabledAddressFamilies (leaf): The address families that are to be enabled for this
// network instance.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled-address-families"
// Path from root: "/network-instances/network-instance/config/enabled-address-families"
func (n *NetworkInstancePath) EnabledAddressFamilies() *NetworkInstance_EnabledAddressFamiliesPath {
	return &NetworkInstance_EnabledAddressFamiliesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled-address-families"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnabledAddressFamilies (leaf): The address families that are to be enabled for this
// network instance.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled-address-families"
// Path from root: "/network-instances/network-instance/config/enabled-address-families"
func (n *NetworkInstancePathAny) EnabledAddressFamilies() *NetworkInstance_EnabledAddressFamiliesPathAny {
	return &NetworkInstance_EnabledAddressFamiliesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled-address-families"},
			map[string]interface{}{},
			n,
		),
	}
}

// Encapsulation (container): Configuration parameters relating to the encapsulation
// used for the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "encapsulation"
// Path from root: "/network-instances/network-instance/encapsulation"
func (n *NetworkInstancePath) Encapsulation() *NetworkInstance_EncapsulationPath {
	return &NetworkInstance_EncapsulationPath{
		NodePath: ygot.NewNodePath(
			[]string{"encapsulation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Encapsulation (container): Configuration parameters relating to the encapsulation
// used for the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "encapsulation"
// Path from root: "/network-instances/network-instance/encapsulation"
func (n *NetworkInstancePathAny) Encapsulation() *NetworkInstance_EncapsulationPathAny {
	return &NetworkInstance_EncapsulationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"encapsulation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Evpn (container): Configuration of parameters for EVPN related bridge domains
// (MAC VRFs) and layer3 VRFs (IP VRFs)
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "evpn"
// Path from root: "/network-instances/network-instance/evpn"
func (n *NetworkInstancePath) Evpn() *NetworkInstance_EvpnPath {
	return &NetworkInstance_EvpnPath{
		NodePath: ygot.NewNodePath(
			[]string{"evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// Evpn (container): Configuration of parameters for EVPN related bridge domains
// (MAC VRFs) and layer3 VRFs (IP VRFs)
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "evpn"
// Path from root: "/network-instances/network-instance/evpn"
func (n *NetworkInstancePathAny) Evpn() *NetworkInstance_EvpnPathAny {
	return &NetworkInstance_EvpnPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// Fdb (container): Operational state and configuration parameters relating to
// the forwarding database of the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "fdb"
// Path from root: "/network-instances/network-instance/fdb"
func (n *NetworkInstancePath) Fdb() *NetworkInstance_FdbPath {
	return &NetworkInstance_FdbPath{
		NodePath: ygot.NewNodePath(
			[]string{"fdb"},
			map[string]interface{}{},
			n,
		),
	}
}

// Fdb (container): Operational state and configuration parameters relating to
// the forwarding database of the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "fdb"
// Path from root: "/network-instances/network-instance/fdb"
func (n *NetworkInstancePathAny) Fdb() *NetworkInstance_FdbPathAny {
	return &NetworkInstance_FdbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"fdb"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterInstancePolicies (container): Policies dictating how RIB or FIB entries are imported
// to and exported from this instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-instance-policies"
// Path from root: "/network-instances/network-instance/inter-instance-policies"
func (n *NetworkInstancePath) InterInstancePolicies() *NetworkInstance_InterInstancePoliciesPath {
	return &NetworkInstance_InterInstancePoliciesPath{
		NodePath: ygot.NewNodePath(
			[]string{"inter-instance-policies"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterInstancePolicies (container): Policies dictating how RIB or FIB entries are imported
// to and exported from this instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-instance-policies"
// Path from root: "/network-instances/network-instance/inter-instance-policies"
func (n *NetworkInstancePathAny) InterInstancePolicies() *NetworkInstance_InterInstancePoliciesPathAny {
	return &NetworkInstance_InterInstancePoliciesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inter-instance-policies"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): An interface associated with the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/interfaces/interface"
// Id (wildcarded): string
func (n *NetworkInstancePath) InterfaceAny() *NetworkInstance_InterfacePathAny {
	return &NetworkInstance_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): An interface associated with the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/interfaces/interface"
// Id (wildcarded): string
func (n *NetworkInstancePathAny) InterfaceAny() *NetworkInstance_InterfacePathAny {
	return &NetworkInstance_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Interface (list): An interface associated with the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/interfaces/interface"
// Id: string
func (n *NetworkInstancePath) Interface(Id string) *NetworkInstance_InterfacePath {
	return &NetworkInstance_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Interface (list): An interface associated with the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/interfaces/interface"
// Id: string
func (n *NetworkInstancePathAny) Interface(Id string) *NetworkInstance_InterfacePathAny {
	return &NetworkInstance_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Mpls (container): Anchor point for mpls configuration and operational
// data
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/mpls"
func (n *NetworkInstancePath) Mpls() *NetworkInstance_MplsPath {
	return &NetworkInstance_MplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): Anchor point for mpls configuration and operational
// data
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/mpls"
func (n *NetworkInstancePathAny) Mpls() *NetworkInstance_MplsPathAny {
	return &NetworkInstance_MplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The maximum frame size which should be supported for this
// instance for Layer 2 frames
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mtu"
// Path from root: "/network-instances/network-instance/config/mtu"
func (n *NetworkInstancePath) Mtu() *NetworkInstance_MtuPath {
	return &NetworkInstance_MtuPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mtu (leaf): The maximum frame size which should be supported for this
// instance for Layer 2 frames
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mtu"
// Path from root: "/network-instances/network-instance/config/mtu"
func (n *NetworkInstancePathAny) Mtu() *NetworkInstance_MtuPathAny {
	return &NetworkInstance_MtuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): An operator-assigned unique name for the network instance.
// If the operator does not designate a name for the instance of
// type 'DEFAULT_INSTANCE' (e.g. config), the implementation
// should use the name of 'DEFAULT' (e.g. state).
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/config/name"
func (n *NetworkInstancePath) Name() *NetworkInstance_NamePath {
	return &NetworkInstance_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): An operator-assigned unique name for the network instance.
// If the operator does not designate a name for the instance of
// type 'DEFAULT_INSTANCE' (e.g. config), the implementation
// should use the name of 'DEFAULT' (e.g. state).
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/config/name"
func (n *NetworkInstancePathAny) Name() *NetworkInstance_NamePathAny {
	return &NetworkInstance_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// PolicyForwarding (container): Configuration and operational state relating to policy-forwarding within
// a network instance.
// ----------------------------------------
// Defining module: "openconfig-policy-forwarding"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policy-forwarding"
// Path from root: "/network-instances/network-instance/policy-forwarding"
func (n *NetworkInstancePath) PolicyForwarding() *NetworkInstance_PolicyForwardingPath {
	return &NetworkInstance_PolicyForwardingPath{
		NodePath: ygot.NewNodePath(
			[]string{"policy-forwarding"},
			map[string]interface{}{},
			n,
		),
	}
}

// PolicyForwarding (container): Configuration and operational state relating to policy-forwarding within
// a network instance.
// ----------------------------------------
// Defining module: "openconfig-policy-forwarding"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policy-forwarding"
// Path from root: "/network-instances/network-instance/policy-forwarding"
func (n *NetworkInstancePathAny) PolicyForwarding() *NetworkInstance_PolicyForwardingPathAny {
	return &NetworkInstance_PolicyForwardingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policy-forwarding"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtocolAny (list): A process (instance) of a routing protocol. Some
// systems may not support more than one instance of
// a particular routing protocol
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protocols/protocol"
// Path from root: "/network-instances/network-instance/protocols/protocol"
// Identifier (wildcarded): E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// Name (wildcarded): string
func (n *NetworkInstancePath) ProtocolAny() *NetworkInstance_ProtocolPathAny {
	return &NetworkInstance_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"protocols", "protocol"},
			map[string]interface{}{"identifier": "*", "name": "*"},
			n,
		),
	}
}

// ProtocolAny (list): A process (instance) of a routing protocol. Some
// systems may not support more than one instance of
// a particular routing protocol
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protocols/protocol"
// Path from root: "/network-instances/network-instance/protocols/protocol"
// Identifier (wildcarded): E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// Name (wildcarded): string
func (n *NetworkInstancePathAny) ProtocolAny() *NetworkInstance_ProtocolPathAny {
	return &NetworkInstance_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"protocols", "protocol"},
			map[string]interface{}{"identifier": "*", "name": "*"},
			n,
		),
	}
}

// ProtocolAnyName (list): A process (instance) of a routing protocol. Some
// systems may not support more than one instance of
// a particular routing protocol
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protocols/protocol"
// Path from root: "/network-instances/network-instance/protocols/protocol"
// Identifier: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// Name (wildcarded): string
func (n *NetworkInstancePath) ProtocolAnyName(Identifier E_PolicyTypes_INSTALL_PROTOCOL_TYPE) *NetworkInstance_ProtocolPathAny {
	return &NetworkInstance_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"protocols", "protocol"},
			map[string]interface{}{"identifier": Identifier, "name": "*"},
			n,
		),
	}
}

// ProtocolAnyName (list): A process (instance) of a routing protocol. Some
// systems may not support more than one instance of
// a particular routing protocol
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protocols/protocol"
// Path from root: "/network-instances/network-instance/protocols/protocol"
// Identifier: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// Name (wildcarded): string
func (n *NetworkInstancePathAny) ProtocolAnyName(Identifier E_PolicyTypes_INSTALL_PROTOCOL_TYPE) *NetworkInstance_ProtocolPathAny {
	return &NetworkInstance_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"protocols", "protocol"},
			map[string]interface{}{"identifier": Identifier, "name": "*"},
			n,
		),
	}
}

// ProtocolAnyIdentifier (list): A process (instance) of a routing protocol. Some
// systems may not support more than one instance of
// a particular routing protocol
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protocols/protocol"
// Path from root: "/network-instances/network-instance/protocols/protocol"
// Identifier (wildcarded): E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// Name: string
func (n *NetworkInstancePath) ProtocolAnyIdentifier(Name string) *NetworkInstance_ProtocolPathAny {
	return &NetworkInstance_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"protocols", "protocol"},
			map[string]interface{}{"identifier": "*", "name": Name},
			n,
		),
	}
}

// ProtocolAnyIdentifier (list): A process (instance) of a routing protocol. Some
// systems may not support more than one instance of
// a particular routing protocol
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protocols/protocol"
// Path from root: "/network-instances/network-instance/protocols/protocol"
// Identifier (wildcarded): E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// Name: string
func (n *NetworkInstancePathAny) ProtocolAnyIdentifier(Name string) *NetworkInstance_ProtocolPathAny {
	return &NetworkInstance_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"protocols", "protocol"},
			map[string]interface{}{"identifier": "*", "name": Name},
			n,
		),
	}
}

// Protocol (list): A process (instance) of a routing protocol. Some
// systems may not support more than one instance of
// a particular routing protocol
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protocols/protocol"
// Path from root: "/network-instances/network-instance/protocols/protocol"
// Identifier: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// Name: string
func (n *NetworkInstancePath) Protocol(Identifier E_PolicyTypes_INSTALL_PROTOCOL_TYPE, Name string) *NetworkInstance_ProtocolPath {
	return &NetworkInstance_ProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"protocols", "protocol"},
			map[string]interface{}{"identifier": Identifier, "name": Name},
			n,
		),
	}
}

// Protocol (list): A process (instance) of a routing protocol. Some
// systems may not support more than one instance of
// a particular routing protocol
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protocols/protocol"
// Path from root: "/network-instances/network-instance/protocols/protocol"
// Identifier: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// Name: string
func (n *NetworkInstancePathAny) Protocol(Identifier E_PolicyTypes_INSTALL_PROTOCOL_TYPE, Name string) *NetworkInstance_ProtocolPathAny {
	return &NetworkInstance_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"protocols", "protocol"},
			map[string]interface{}{"identifier": Identifier, "name": Name},
			n,
		),
	}
}

// RouteDistinguisher (leaf): The route distinguisher that should be used for the local
// VRF or VSI instance when it is signalled via BGP.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-distinguisher"
// Path from root: "/network-instances/network-instance/config/route-distinguisher"
func (n *NetworkInstancePath) RouteDistinguisher() *NetworkInstance_RouteDistinguisherPath {
	return &NetworkInstance_RouteDistinguisherPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteDistinguisher (leaf): The route distinguisher that should be used for the local
// VRF or VSI instance when it is signalled via BGP.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-distinguisher"
// Path from root: "/network-instances/network-instance/config/route-distinguisher"
func (n *NetworkInstancePathAny) RouteDistinguisher() *NetworkInstance_RouteDistinguisherPathAny {
	return &NetworkInstance_RouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteLimitAny (list): A route limit applying to a particular address family.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-limits/route-limit"
// Path from root: "/network-instances/network-instance/route-limits/route-limit"
// Afi (wildcarded): E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePath) RouteLimitAny() *NetworkInstance_RouteLimitPathAny {
	return &NetworkInstance_RouteLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"route-limits", "route-limit"},
			map[string]interface{}{"afi": "*"},
			n,
		),
	}
}

// RouteLimitAny (list): A route limit applying to a particular address family.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-limits/route-limit"
// Path from root: "/network-instances/network-instance/route-limits/route-limit"
// Afi (wildcarded): E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePathAny) RouteLimitAny() *NetworkInstance_RouteLimitPathAny {
	return &NetworkInstance_RouteLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"route-limits", "route-limit"},
			map[string]interface{}{"afi": "*"},
			n,
		),
	}
}

// RouteLimit (list): A route limit applying to a particular address family.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-limits/route-limit"
// Path from root: "/network-instances/network-instance/route-limits/route-limit"
// Afi: E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePath) RouteLimit(Afi E_Types_ADDRESS_FAMILY) *NetworkInstance_RouteLimitPath {
	return &NetworkInstance_RouteLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"route-limits", "route-limit"},
			map[string]interface{}{"afi": Afi},
			n,
		),
	}
}

// RouteLimit (list): A route limit applying to a particular address family.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-limits/route-limit"
// Path from root: "/network-instances/network-instance/route-limits/route-limit"
// Afi: E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePathAny) RouteLimit(Afi E_Types_ADDRESS_FAMILY) *NetworkInstance_RouteLimitPathAny {
	return &NetworkInstance_RouteLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"route-limits", "route-limit"},
			map[string]interface{}{"afi": Afi},
			n,
		),
	}
}

// RouterId (leaf): A identifier for the local network instance - typically
// used within associated routing protocols or signalling
// routing information in another network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/router-id"
// Path from root: "/network-instances/network-instance/config/router-id"
func (n *NetworkInstancePath) RouterId() *NetworkInstance_RouterIdPath {
	return &NetworkInstance_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): A identifier for the local network instance - typically
// used within associated routing protocols or signalling
// routing information in another network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/router-id"
// Path from root: "/network-instances/network-instance/config/router-id"
func (n *NetworkInstancePathAny) RouterId() *NetworkInstance_RouterIdPathAny {
	return &NetworkInstance_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRouting (container): Configuration and operational state parameters relating to
// segment routing.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing"
// Path from root: "/network-instances/network-instance/segment-routing"
func (n *NetworkInstancePath) SegmentRouting() *NetworkInstance_SegmentRoutingPath {
	return &NetworkInstance_SegmentRoutingPath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRouting (container): Configuration and operational state parameters relating to
// segment routing.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing"
// Path from root: "/network-instances/network-instance/segment-routing"
func (n *NetworkInstancePathAny) SegmentRouting() *NetworkInstance_SegmentRoutingPathAny {
	return &NetworkInstance_SegmentRoutingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing"},
			map[string]interface{}{},
			n,
		),
	}
}

// TableAny (list): A network instance manages one or more forwarding or
// routing tables. These may reflect a Layer 2 forwarding
// information base, a Layer 3 routing table, or an MPLS
// LFIB.
//
// The table populated by a protocol within an instance is
// identified by the protocol identifier (e.g., BGP, IS-IS)
// and the address family (e.g., IPv4, IPv6) supported by
// that protocol. Multiple instances of the same protocol
// populate a single table -- such that
// a single IS-IS or OSPF IPv4 table exists per network
// instance.
//
// An implementation is expected to create entries within
// this list when the relevant protocol context is enabled.
// i.e., when a BGP instance is created with IPv4 and IPv6
// address families enabled, the protocol=BGP,
// address-family=IPv4 table is created by the system.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tables/table"
// Path from root: "/network-instances/network-instance/tables/table"
// Protocol (wildcarded): E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// AddressFamily (wildcarded): E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePath) TableAny() *NetworkInstance_TablePathAny {
	return &NetworkInstance_TablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tables", "table"},
			map[string]interface{}{"protocol": "*", "address-family": "*"},
			n,
		),
	}
}

// TableAny (list): A network instance manages one or more forwarding or
// routing tables. These may reflect a Layer 2 forwarding
// information base, a Layer 3 routing table, or an MPLS
// LFIB.
//
// The table populated by a protocol within an instance is
// identified by the protocol identifier (e.g., BGP, IS-IS)
// and the address family (e.g., IPv4, IPv6) supported by
// that protocol. Multiple instances of the same protocol
// populate a single table -- such that
// a single IS-IS or OSPF IPv4 table exists per network
// instance.
//
// An implementation is expected to create entries within
// this list when the relevant protocol context is enabled.
// i.e., when a BGP instance is created with IPv4 and IPv6
// address families enabled, the protocol=BGP,
// address-family=IPv4 table is created by the system.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tables/table"
// Path from root: "/network-instances/network-instance/tables/table"
// Protocol (wildcarded): E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// AddressFamily (wildcarded): E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePathAny) TableAny() *NetworkInstance_TablePathAny {
	return &NetworkInstance_TablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tables", "table"},
			map[string]interface{}{"protocol": "*", "address-family": "*"},
			n,
		),
	}
}

// TableAnyAddressFamily (list): A network instance manages one or more forwarding or
// routing tables. These may reflect a Layer 2 forwarding
// information base, a Layer 3 routing table, or an MPLS
// LFIB.
//
// The table populated by a protocol within an instance is
// identified by the protocol identifier (e.g., BGP, IS-IS)
// and the address family (e.g., IPv4, IPv6) supported by
// that protocol. Multiple instances of the same protocol
// populate a single table -- such that
// a single IS-IS or OSPF IPv4 table exists per network
// instance.
//
// An implementation is expected to create entries within
// this list when the relevant protocol context is enabled.
// i.e., when a BGP instance is created with IPv4 and IPv6
// address families enabled, the protocol=BGP,
// address-family=IPv4 table is created by the system.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tables/table"
// Path from root: "/network-instances/network-instance/tables/table"
// Protocol: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// AddressFamily (wildcarded): E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePath) TableAnyAddressFamily(Protocol E_PolicyTypes_INSTALL_PROTOCOL_TYPE) *NetworkInstance_TablePathAny {
	return &NetworkInstance_TablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tables", "table"},
			map[string]interface{}{"protocol": Protocol, "address-family": "*"},
			n,
		),
	}
}

// TableAnyAddressFamily (list): A network instance manages one or more forwarding or
// routing tables. These may reflect a Layer 2 forwarding
// information base, a Layer 3 routing table, or an MPLS
// LFIB.
//
// The table populated by a protocol within an instance is
// identified by the protocol identifier (e.g., BGP, IS-IS)
// and the address family (e.g., IPv4, IPv6) supported by
// that protocol. Multiple instances of the same protocol
// populate a single table -- such that
// a single IS-IS or OSPF IPv4 table exists per network
// instance.
//
// An implementation is expected to create entries within
// this list when the relevant protocol context is enabled.
// i.e., when a BGP instance is created with IPv4 and IPv6
// address families enabled, the protocol=BGP,
// address-family=IPv4 table is created by the system.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tables/table"
// Path from root: "/network-instances/network-instance/tables/table"
// Protocol: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// AddressFamily (wildcarded): E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePathAny) TableAnyAddressFamily(Protocol E_PolicyTypes_INSTALL_PROTOCOL_TYPE) *NetworkInstance_TablePathAny {
	return &NetworkInstance_TablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tables", "table"},
			map[string]interface{}{"protocol": Protocol, "address-family": "*"},
			n,
		),
	}
}

// TableAnyProtocol (list): A network instance manages one or more forwarding or
// routing tables. These may reflect a Layer 2 forwarding
// information base, a Layer 3 routing table, or an MPLS
// LFIB.
//
// The table populated by a protocol within an instance is
// identified by the protocol identifier (e.g., BGP, IS-IS)
// and the address family (e.g., IPv4, IPv6) supported by
// that protocol. Multiple instances of the same protocol
// populate a single table -- such that
// a single IS-IS or OSPF IPv4 table exists per network
// instance.
//
// An implementation is expected to create entries within
// this list when the relevant protocol context is enabled.
// i.e., when a BGP instance is created with IPv4 and IPv6
// address families enabled, the protocol=BGP,
// address-family=IPv4 table is created by the system.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tables/table"
// Path from root: "/network-instances/network-instance/tables/table"
// Protocol (wildcarded): E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// AddressFamily: E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePath) TableAnyProtocol(AddressFamily E_Types_ADDRESS_FAMILY) *NetworkInstance_TablePathAny {
	return &NetworkInstance_TablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tables", "table"},
			map[string]interface{}{"protocol": "*", "address-family": AddressFamily},
			n,
		),
	}
}

// TableAnyProtocol (list): A network instance manages one or more forwarding or
// routing tables. These may reflect a Layer 2 forwarding
// information base, a Layer 3 routing table, or an MPLS
// LFIB.
//
// The table populated by a protocol within an instance is
// identified by the protocol identifier (e.g., BGP, IS-IS)
// and the address family (e.g., IPv4, IPv6) supported by
// that protocol. Multiple instances of the same protocol
// populate a single table -- such that
// a single IS-IS or OSPF IPv4 table exists per network
// instance.
//
// An implementation is expected to create entries within
// this list when the relevant protocol context is enabled.
// i.e., when a BGP instance is created with IPv4 and IPv6
// address families enabled, the protocol=BGP,
// address-family=IPv4 table is created by the system.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tables/table"
// Path from root: "/network-instances/network-instance/tables/table"
// Protocol (wildcarded): E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// AddressFamily: E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePathAny) TableAnyProtocol(AddressFamily E_Types_ADDRESS_FAMILY) *NetworkInstance_TablePathAny {
	return &NetworkInstance_TablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tables", "table"},
			map[string]interface{}{"protocol": "*", "address-family": AddressFamily},
			n,
		),
	}
}

// Table (list): A network instance manages one or more forwarding or
// routing tables. These may reflect a Layer 2 forwarding
// information base, a Layer 3 routing table, or an MPLS
// LFIB.
//
// The table populated by a protocol within an instance is
// identified by the protocol identifier (e.g., BGP, IS-IS)
// and the address family (e.g., IPv4, IPv6) supported by
// that protocol. Multiple instances of the same protocol
// populate a single table -- such that
// a single IS-IS or OSPF IPv4 table exists per network
// instance.
//
// An implementation is expected to create entries within
// this list when the relevant protocol context is enabled.
// i.e., when a BGP instance is created with IPv4 and IPv6
// address families enabled, the protocol=BGP,
// address-family=IPv4 table is created by the system.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tables/table"
// Path from root: "/network-instances/network-instance/tables/table"
// Protocol: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// AddressFamily: E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePath) Table(Protocol E_PolicyTypes_INSTALL_PROTOCOL_TYPE, AddressFamily E_Types_ADDRESS_FAMILY) *NetworkInstance_TablePath {
	return &NetworkInstance_TablePath{
		NodePath: ygot.NewNodePath(
			[]string{"tables", "table"},
			map[string]interface{}{"protocol": Protocol, "address-family": AddressFamily},
			n,
		),
	}
}

// Table (list): A network instance manages one or more forwarding or
// routing tables. These may reflect a Layer 2 forwarding
// information base, a Layer 3 routing table, or an MPLS
// LFIB.
//
// The table populated by a protocol within an instance is
// identified by the protocol identifier (e.g., BGP, IS-IS)
// and the address family (e.g., IPv4, IPv6) supported by
// that protocol. Multiple instances of the same protocol
// populate a single table -- such that
// a single IS-IS or OSPF IPv4 table exists per network
// instance.
//
// An implementation is expected to create entries within
// this list when the relevant protocol context is enabled.
// i.e., when a BGP instance is created with IPv4 and IPv6
// address families enabled, the protocol=BGP,
// address-family=IPv4 table is created by the system.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tables/table"
// Path from root: "/network-instances/network-instance/tables/table"
// Protocol: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
// AddressFamily: E_Types_ADDRESS_FAMILY
func (n *NetworkInstancePathAny) Table(Protocol E_PolicyTypes_INSTALL_PROTOCOL_TYPE, AddressFamily E_Types_ADDRESS_FAMILY) *NetworkInstance_TablePathAny {
	return &NetworkInstance_TablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tables", "table"},
			map[string]interface{}{"protocol": Protocol, "address-family": AddressFamily},
			n,
		),
	}
}

// TableConnectionAny (list): A list of connections between pairs of routing or
// forwarding tables, the leaking of entries between
// which is specified by the import policy.
//
// A connection connecting a source table to a destination
// table implies that routes that match the policy specified
// for the connection are available for the destination
// protocol to advertise, or match within its policies.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "table-connections/table-connection"
// Path from root: "/network-instances/network-instance/table-connections/table-connection"
func (n *NetworkInstancePath) TableConnectionAny() *NetworkInstance_TableConnectionPathAny {
	return &NetworkInstance_TableConnectionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"table-connections", "table-connection"},
			map[string]interface{}{"src-protocol": "*", "dst-protocol": "*", "address-family": "*"},
			n,
		),
	}
}

// TableConnectionAny (list): A list of connections between pairs of routing or
// forwarding tables, the leaking of entries between
// which is specified by the import policy.
//
// A connection connecting a source table to a destination
// table implies that routes that match the policy specified
// for the connection are available for the destination
// protocol to advertise, or match within its policies.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "table-connections/table-connection"
// Path from root: "/network-instances/network-instance/table-connections/table-connection"
func (n *NetworkInstancePathAny) TableConnectionAny() *NetworkInstance_TableConnectionPathAny {
	return &NetworkInstance_TableConnectionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"table-connections", "table-connection"},
			map[string]interface{}{"src-protocol": "*", "dst-protocol": "*", "address-family": "*"},
			n,
		),
	}
}

// WithSrcProtocol sets NetworkInstance_TableConnectionPathAny's key "src-protocol" to the specified value.
// SrcProtocol: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
func (n *NetworkInstance_TableConnectionPathAny) WithSrcProtocol(SrcProtocol E_PolicyTypes_INSTALL_PROTOCOL_TYPE) *NetworkInstance_TableConnectionPathAny {
	ygot.ModifyKey(n.NodePath, "src-protocol", SrcProtocol)
	return n
}

// WithDstProtocol sets NetworkInstance_TableConnectionPathAny's key "dst-protocol" to the specified value.
// DstProtocol: E_PolicyTypes_INSTALL_PROTOCOL_TYPE
func (n *NetworkInstance_TableConnectionPathAny) WithDstProtocol(DstProtocol E_PolicyTypes_INSTALL_PROTOCOL_TYPE) *NetworkInstance_TableConnectionPathAny {
	ygot.ModifyKey(n.NodePath, "dst-protocol", DstProtocol)
	return n
}

// WithAddressFamily sets NetworkInstance_TableConnectionPathAny's key "address-family" to the specified value.
// AddressFamily: E_Types_ADDRESS_FAMILY
func (n *NetworkInstance_TableConnectionPathAny) WithAddressFamily(AddressFamily E_Types_ADDRESS_FAMILY) *NetworkInstance_TableConnectionPathAny {
	ygot.ModifyKey(n.NodePath, "address-family", AddressFamily)
	return n
}

// Type (leaf): The type of network instance. The value of this leaf
// indicates the type of forwarding entries that should be
// supported by this network instance. Signalling protocols also
// use the network instance type to infer the type of service
// they advertise; for example MPLS signalling for an L2VSI
// network instance would infer a VPLS service whereas a type of
// L2PTP would infer a VPWS (pseudo-wire) service.
//
// An implementation must support only a single network-instance
// of type 'DEFAULT_INSTANCE'.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/config/type"
func (n *NetworkInstancePath) Type() *NetworkInstance_TypePath {
	return &NetworkInstance_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of network instance. The value of this leaf
// indicates the type of forwarding entries that should be
// supported by this network instance. Signalling protocols also
// use the network instance type to infer the type of service
// they advertise; for example MPLS signalling for an L2VSI
// network instance would infer a VPLS service whereas a type of
// L2PTP would infer a VPWS (pseudo-wire) service.
//
// An implementation must support only a single network-instance
// of type 'DEFAULT_INSTANCE'.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/config/type"
func (n *NetworkInstancePathAny) Type() *NetworkInstance_TypePathAny {
	return &NetworkInstance_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanAny (list): Configured VLANs keyed by id
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "vlans/vlan"
// Path from root: "/network-instances/network-instance/vlans/vlan"
// VlanId (wildcarded): uint16
func (n *NetworkInstancePath) VlanAny() *NetworkInstance_VlanPathAny {
	return &NetworkInstance_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vlans", "vlan"},
			map[string]interface{}{"vlan-id": "*"},
			n,
		),
	}
}

// VlanAny (list): Configured VLANs keyed by id
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "vlans/vlan"
// Path from root: "/network-instances/network-instance/vlans/vlan"
// VlanId (wildcarded): uint16
func (n *NetworkInstancePathAny) VlanAny() *NetworkInstance_VlanPathAny {
	return &NetworkInstance_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vlans", "vlan"},
			map[string]interface{}{"vlan-id": "*"},
			n,
		),
	}
}

// Vlan (list): Configured VLANs keyed by id
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "vlans/vlan"
// Path from root: "/network-instances/network-instance/vlans/vlan"
// VlanId: uint16
func (n *NetworkInstancePath) Vlan(VlanId uint16) *NetworkInstance_VlanPath {
	return &NetworkInstance_VlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"vlans", "vlan"},
			map[string]interface{}{"vlan-id": VlanId},
			n,
		),
	}
}

// Vlan (list): Configured VLANs keyed by id
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "vlans/vlan"
// Path from root: "/network-instances/network-instance/vlans/vlan"
// VlanId: uint16
func (n *NetworkInstancePathAny) Vlan(VlanId uint16) *NetworkInstance_VlanPathAny {
	return &NetworkInstance_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vlans", "vlan"},
			map[string]interface{}{"vlan-id": VlanId},
			n,
		),
	}
}

// NetworkInstance_AftsPath represents the /openconfig-network-instance/network-instances/network-instance/afts YANG schema element.
type NetworkInstance_AftsPath struct {
	*ygot.NodePath
}

// NetworkInstance_AftsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts YANG schema element.
type NetworkInstance_AftsPathAny struct {
	*ygot.NodePath
}

// Ipv4EntryAny (list): List of the IPv4 unicast entries within the abstract
// forwarding table. This list is keyed by the destination IPv4
// prefix.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv4"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast/ipv4-entry"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry"
// Prefix (wildcarded): string
func (n *NetworkInstance_AftsPath) Ipv4EntryAny() *NetworkInstance_Afts_Ipv4EntryPathAny {
	return &NetworkInstance_Afts_Ipv4EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast", "ipv4-entry"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Ipv4EntryAny (list): List of the IPv4 unicast entries within the abstract
// forwarding table. This list is keyed by the destination IPv4
// prefix.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv4"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast/ipv4-entry"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry"
// Prefix (wildcarded): string
func (n *NetworkInstance_AftsPathAny) Ipv4EntryAny() *NetworkInstance_Afts_Ipv4EntryPathAny {
	return &NetworkInstance_Afts_Ipv4EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast", "ipv4-entry"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Ipv4Entry (list): List of the IPv4 unicast entries within the abstract
// forwarding table. This list is keyed by the destination IPv4
// prefix.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv4"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast/ipv4-entry"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry"
// Prefix: string
func (n *NetworkInstance_AftsPath) Ipv4Entry(Prefix string) *NetworkInstance_Afts_Ipv4EntryPath {
	return &NetworkInstance_Afts_Ipv4EntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast", "ipv4-entry"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Ipv4Entry (list): List of the IPv4 unicast entries within the abstract
// forwarding table. This list is keyed by the destination IPv4
// prefix.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv4"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast/ipv4-entry"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry"
// Prefix: string
func (n *NetworkInstance_AftsPathAny) Ipv4Entry(Prefix string) *NetworkInstance_Afts_Ipv4EntryPathAny {
	return &NetworkInstance_Afts_Ipv4EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast", "ipv4-entry"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Ipv6EntryAny (list): List of the IPv6 unicast entries within the abstract
// forwarding table. This list is keyed by the destination IPv6
// prefix.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv6"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast/ipv6-entry"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry"
// Prefix (wildcarded): string
func (n *NetworkInstance_AftsPath) Ipv6EntryAny() *NetworkInstance_Afts_Ipv6EntryPathAny {
	return &NetworkInstance_Afts_Ipv6EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast", "ipv6-entry"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Ipv6EntryAny (list): List of the IPv6 unicast entries within the abstract
// forwarding table. This list is keyed by the destination IPv6
// prefix.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv6"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast/ipv6-entry"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry"
// Prefix (wildcarded): string
func (n *NetworkInstance_AftsPathAny) Ipv6EntryAny() *NetworkInstance_Afts_Ipv6EntryPathAny {
	return &NetworkInstance_Afts_Ipv6EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast", "ipv6-entry"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Ipv6Entry (list): List of the IPv6 unicast entries within the abstract
// forwarding table. This list is keyed by the destination IPv6
// prefix.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv6"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast/ipv6-entry"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry"
// Prefix: string
func (n *NetworkInstance_AftsPath) Ipv6Entry(Prefix string) *NetworkInstance_Afts_Ipv6EntryPath {
	return &NetworkInstance_Afts_Ipv6EntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast", "ipv6-entry"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Ipv6Entry (list): List of the IPv6 unicast entries within the abstract
// forwarding table. This list is keyed by the destination IPv6
// prefix.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv6"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast/ipv6-entry"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry"
// Prefix: string
func (n *NetworkInstance_AftsPathAny) Ipv6Entry(Prefix string) *NetworkInstance_Afts_Ipv6EntryPathAny {
	return &NetworkInstance_Afts_Ipv6EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast", "ipv6-entry"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// LabelEntryAny (list): List of the MPLS entries within the abstract
// forwarding table. This list is keyed by the top-most MPLS
// label.
// ----------------------------------------
// Defining module: "openconfig-aft-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls/label-entry"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry"
// Label (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_AftsPath) LabelEntryAny() *NetworkInstance_Afts_LabelEntryPathAny {
	return &NetworkInstance_Afts_LabelEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls", "label-entry"},
			map[string]interface{}{"label": "*"},
			n,
		),
	}
}

// LabelEntryAny (list): List of the MPLS entries within the abstract
// forwarding table. This list is keyed by the top-most MPLS
// label.
// ----------------------------------------
// Defining module: "openconfig-aft-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls/label-entry"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry"
// Label (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_AftsPathAny) LabelEntryAny() *NetworkInstance_Afts_LabelEntryPathAny {
	return &NetworkInstance_Afts_LabelEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls", "label-entry"},
			map[string]interface{}{"label": "*"},
			n,
		),
	}
}

// LabelEntry (list): List of the MPLS entries within the abstract
// forwarding table. This list is keyed by the top-most MPLS
// label.
// ----------------------------------------
// Defining module: "openconfig-aft-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls/label-entry"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry"
// Label: [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_AftsPath) LabelEntry(Label NetworkInstance_Afts_LabelEntry_Label_Union) *NetworkInstance_Afts_LabelEntryPath {
	return &NetworkInstance_Afts_LabelEntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"mpls", "label-entry"},
			map[string]interface{}{"label": Label},
			n,
		),
	}
}

// LabelEntry (list): List of the MPLS entries within the abstract
// forwarding table. This list is keyed by the top-most MPLS
// label.
// ----------------------------------------
// Defining module: "openconfig-aft-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls/label-entry"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry"
// Label: [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_AftsPathAny) LabelEntry(Label NetworkInstance_Afts_LabelEntry_Label_Union) *NetworkInstance_Afts_LabelEntryPathAny {
	return &NetworkInstance_Afts_LabelEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls", "label-entry"},
			map[string]interface{}{"label": Label},
			n,
		),
	}
}

// MacEntryAny (list): List of the Ethernet entries within the abstract
// forwarding table. This list is keyed by the outer MAC address
// of the Ethernet frame.
// ----------------------------------------
// Defining module: "openconfig-aft-ethernet"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ethernet/mac-entry"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry"
// MacAddress (wildcarded): string
func (n *NetworkInstance_AftsPath) MacEntryAny() *NetworkInstance_Afts_MacEntryPathAny {
	return &NetworkInstance_Afts_MacEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet", "mac-entry"},
			map[string]interface{}{"mac-address": "*"},
			n,
		),
	}
}

// MacEntryAny (list): List of the Ethernet entries within the abstract
// forwarding table. This list is keyed by the outer MAC address
// of the Ethernet frame.
// ----------------------------------------
// Defining module: "openconfig-aft-ethernet"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ethernet/mac-entry"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry"
// MacAddress (wildcarded): string
func (n *NetworkInstance_AftsPathAny) MacEntryAny() *NetworkInstance_Afts_MacEntryPathAny {
	return &NetworkInstance_Afts_MacEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet", "mac-entry"},
			map[string]interface{}{"mac-address": "*"},
			n,
		),
	}
}

// MacEntry (list): List of the Ethernet entries within the abstract
// forwarding table. This list is keyed by the outer MAC address
// of the Ethernet frame.
// ----------------------------------------
// Defining module: "openconfig-aft-ethernet"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ethernet/mac-entry"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry"
// MacAddress: string
func (n *NetworkInstance_AftsPath) MacEntry(MacAddress string) *NetworkInstance_Afts_MacEntryPath {
	return &NetworkInstance_Afts_MacEntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet", "mac-entry"},
			map[string]interface{}{"mac-address": MacAddress},
			n,
		),
	}
}

// MacEntry (list): List of the Ethernet entries within the abstract
// forwarding table. This list is keyed by the outer MAC address
// of the Ethernet frame.
// ----------------------------------------
// Defining module: "openconfig-aft-ethernet"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ethernet/mac-entry"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry"
// MacAddress: string
func (n *NetworkInstance_AftsPathAny) MacEntry(MacAddress string) *NetworkInstance_Afts_MacEntryPathAny {
	return &NetworkInstance_Afts_MacEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet", "mac-entry"},
			map[string]interface{}{"mac-address": MacAddress},
			n,
		),
	}
}

// NextHopAny (list): A next-hop associated with the forwarding instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_AftsPath) NextHopAny() *NetworkInstance_Afts_NextHopPathAny {
	return &NetworkInstance_Afts_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHopAny (list): A next-hop associated with the forwarding instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_AftsPathAny) NextHopAny() *NetworkInstance_Afts_NextHopPathAny {
	return &NetworkInstance_Afts_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHop (list): A next-hop associated with the forwarding instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_AftsPath) NextHop(Index uint64) *NetworkInstance_Afts_NextHopPath {
	return &NetworkInstance_Afts_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NextHop (list): A next-hop associated with the forwarding instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_AftsPathAny) NextHop(Index uint64) *NetworkInstance_Afts_NextHopPathAny {
	return &NetworkInstance_Afts_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NextHopGroupAny (list): An individual set of next-hops grouped into a common group.
// Each entry within an abstract forwarding table points to a
// next-hop-group. Entries in the next-hop-group are forwarded to
// according to the weights specified for each next-hop group.
//
// If an entry within the next-hop group becomes unusable, for
// example due to an interface failure, the remaining entries
// are used until all entries become unusable - at which point
// the backup next-hop-group (if specified) is used.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hop-groups/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group"
// Id (wildcarded): uint64
func (n *NetworkInstance_AftsPath) NextHopGroupAny() *NetworkInstance_Afts_NextHopGroupPathAny {
	return &NetworkInstance_Afts_NextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hop-groups", "next-hop-group"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// NextHopGroupAny (list): An individual set of next-hops grouped into a common group.
// Each entry within an abstract forwarding table points to a
// next-hop-group. Entries in the next-hop-group are forwarded to
// according to the weights specified for each next-hop group.
//
// If an entry within the next-hop group becomes unusable, for
// example due to an interface failure, the remaining entries
// are used until all entries become unusable - at which point
// the backup next-hop-group (if specified) is used.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hop-groups/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group"
// Id (wildcarded): uint64
func (n *NetworkInstance_AftsPathAny) NextHopGroupAny() *NetworkInstance_Afts_NextHopGroupPathAny {
	return &NetworkInstance_Afts_NextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hop-groups", "next-hop-group"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// NextHopGroup (list): An individual set of next-hops grouped into a common group.
// Each entry within an abstract forwarding table points to a
// next-hop-group. Entries in the next-hop-group are forwarded to
// according to the weights specified for each next-hop group.
//
// If an entry within the next-hop group becomes unusable, for
// example due to an interface failure, the remaining entries
// are used until all entries become unusable - at which point
// the backup next-hop-group (if specified) is used.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hop-groups/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group"
// Id: uint64
func (n *NetworkInstance_AftsPath) NextHopGroup(Id uint64) *NetworkInstance_Afts_NextHopGroupPath {
	return &NetworkInstance_Afts_NextHopGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"next-hop-groups", "next-hop-group"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// NextHopGroup (list): An individual set of next-hops grouped into a common group.
// Each entry within an abstract forwarding table points to a
// next-hop-group. Entries in the next-hop-group are forwarded to
// according to the weights specified for each next-hop group.
//
// If an entry within the next-hop group becomes unusable, for
// example due to an interface failure, the remaining entries
// are used until all entries become unusable - at which point
// the backup next-hop-group (if specified) is used.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hop-groups/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group"
// Id: uint64
func (n *NetworkInstance_AftsPathAny) NextHopGroup(Id uint64) *NetworkInstance_Afts_NextHopGroupPathAny {
	return &NetworkInstance_Afts_NextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hop-groups", "next-hop-group"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// PolicyForwardingEntryAny (list): List of the policy forwarding entries within the abstract
// forwarding table. Each entry is uniquely identified by an
// index on the system, due to the arbitrary match conditions
// that may be implemented within the policy forwarding AFT.
// The index may change upon changes of the entry if, and only
// if, the device exporting the AFT replaces the entire entry
// by removing the previous entry and replacing it with a
// subsequent updated version.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policy-forwarding/policy-forwarding-entry"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry"
// Index (wildcarded): uint64
func (n *NetworkInstance_AftsPath) PolicyForwardingEntryAny() *NetworkInstance_Afts_PolicyForwardingEntryPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policy-forwarding", "policy-forwarding-entry"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// PolicyForwardingEntryAny (list): List of the policy forwarding entries within the abstract
// forwarding table. Each entry is uniquely identified by an
// index on the system, due to the arbitrary match conditions
// that may be implemented within the policy forwarding AFT.
// The index may change upon changes of the entry if, and only
// if, the device exporting the AFT replaces the entire entry
// by removing the previous entry and replacing it with a
// subsequent updated version.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policy-forwarding/policy-forwarding-entry"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry"
// Index (wildcarded): uint64
func (n *NetworkInstance_AftsPathAny) PolicyForwardingEntryAny() *NetworkInstance_Afts_PolicyForwardingEntryPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policy-forwarding", "policy-forwarding-entry"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// PolicyForwardingEntry (list): List of the policy forwarding entries within the abstract
// forwarding table. Each entry is uniquely identified by an
// index on the system, due to the arbitrary match conditions
// that may be implemented within the policy forwarding AFT.
// The index may change upon changes of the entry if, and only
// if, the device exporting the AFT replaces the entire entry
// by removing the previous entry and replacing it with a
// subsequent updated version.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policy-forwarding/policy-forwarding-entry"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry"
// Index: uint64
func (n *NetworkInstance_AftsPath) PolicyForwardingEntry(Index uint64) *NetworkInstance_Afts_PolicyForwardingEntryPath {
	return &NetworkInstance_Afts_PolicyForwardingEntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"policy-forwarding", "policy-forwarding-entry"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// PolicyForwardingEntry (list): List of the policy forwarding entries within the abstract
// forwarding table. Each entry is uniquely identified by an
// index on the system, due to the arbitrary match conditions
// that may be implemented within the policy forwarding AFT.
// The index may change upon changes of the entry if, and only
// if, the device exporting the AFT replaces the entire entry
// by removing the previous entry and replacing it with a
// subsequent updated version.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policy-forwarding/policy-forwarding-entry"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry"
// Index: uint64
func (n *NetworkInstance_AftsPathAny) PolicyForwardingEntry(Index uint64) *NetworkInstance_Afts_PolicyForwardingEntryPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policy-forwarding", "policy-forwarding-entry"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NetworkInstance_Afts_Ipv4EntryPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry YANG schema element.
type NetworkInstance_Afts_Ipv4EntryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4EntryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry YANG schema element.
type NetworkInstance_Afts_Ipv4EntryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_DecapsulateHeaderPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/decapsulate-header YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_DecapsulateHeaderPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_DecapsulateHeaderPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/decapsulate-header YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_DecapsulateHeaderPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_EntryMetadataPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_EntryMetadataPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_EntryMetadataPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_EntryMetadataPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_NextHopGroupPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_NextHopGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_NextHopGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_NextHopGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_NextHopGroupNetworkInstancePath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_NextHopGroupNetworkInstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_NextHopGroupNetworkInstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_NextHopGroupNetworkInstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_OctetsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_OctetsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_OctetsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_OctetsForwardedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_OriginProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/origin-protocol YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_OriginProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_OriginProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/origin-protocol YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_OriginProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_PacketsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_PacketsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_PacketsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_PacketsForwardedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/prefix YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv4Entry_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/prefix YANG schema element.
type NetworkInstance_Afts_Ipv4Entry_PrefixPathAny struct {
	*ygot.NodePath
}

// DecapsulateHeader (leaf): When forwarding a packet to the specified next-hop, the local
// system performs a decapsulation of the packet - removing the
// specified header type. In the case that no next-hop is
// specified, the packet header is removed, and a subsequent
// forwarding lookup is performed on the packet encapsulated
// within the header, matched within the relevant AFT within the
// specified network-instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/decapsulate-header"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/decapsulate-header"
func (n *NetworkInstance_Afts_Ipv4EntryPath) DecapsulateHeader() *NetworkInstance_Afts_Ipv4Entry_DecapsulateHeaderPath {
	return &NetworkInstance_Afts_Ipv4Entry_DecapsulateHeaderPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "decapsulate-header"},
			map[string]interface{}{},
			n,
		),
	}
}

// DecapsulateHeader (leaf): When forwarding a packet to the specified next-hop, the local
// system performs a decapsulation of the packet - removing the
// specified header type. In the case that no next-hop is
// specified, the packet header is removed, and a subsequent
// forwarding lookup is performed on the packet encapsulated
// within the header, matched within the relevant AFT within the
// specified network-instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/decapsulate-header"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/decapsulate-header"
func (n *NetworkInstance_Afts_Ipv4EntryPathAny) DecapsulateHeader() *NetworkInstance_Afts_Ipv4Entry_DecapsulateHeaderPathAny {
	return &NetworkInstance_Afts_Ipv4Entry_DecapsulateHeaderPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "decapsulate-header"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_Ipv4EntryPath) EntryMetadata() *NetworkInstance_Afts_Ipv4Entry_EntryMetadataPath {
	return &NetworkInstance_Afts_Ipv4Entry_EntryMetadataPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_Ipv4EntryPathAny) EntryMetadata() *NetworkInstance_Afts_Ipv4Entry_EntryMetadataPathAny {
	return &NetworkInstance_Afts_Ipv4Entry_EntryMetadataPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_Ipv4EntryPath) NextHopGroup() *NetworkInstance_Afts_Ipv4Entry_NextHopGroupPath {
	return &NetworkInstance_Afts_Ipv4Entry_NextHopGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_Ipv4EntryPathAny) NextHopGroup() *NetworkInstance_Afts_Ipv4Entry_NextHopGroupPathAny {
	return &NetworkInstance_Afts_Ipv4Entry_NextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_Ipv4EntryPath) NextHopGroupNetworkInstance() *NetworkInstance_Afts_Ipv4Entry_NextHopGroupNetworkInstancePath {
	return &NetworkInstance_Afts_Ipv4Entry_NextHopGroupNetworkInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_Ipv4EntryPathAny) NextHopGroupNetworkInstance() *NetworkInstance_Afts_Ipv4Entry_NextHopGroupNetworkInstancePathAny {
	return &NetworkInstance_Afts_Ipv4Entry_NextHopGroupNetworkInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_Ipv4EntryPath) OctetsForwarded() *NetworkInstance_Afts_Ipv4Entry_OctetsForwardedPath {
	return &NetworkInstance_Afts_Ipv4Entry_OctetsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_Ipv4EntryPathAny) OctetsForwarded() *NetworkInstance_Afts_Ipv4Entry_OctetsForwardedPathAny {
	return &NetworkInstance_Afts_Ipv4Entry_OctetsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginProtocol (leaf): The protocol from which the AFT entry was learned.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin-protocol"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/origin-protocol"
func (n *NetworkInstance_Afts_Ipv4EntryPath) OriginProtocol() *NetworkInstance_Afts_Ipv4Entry_OriginProtocolPath {
	return &NetworkInstance_Afts_Ipv4Entry_OriginProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginProtocol (leaf): The protocol from which the AFT entry was learned.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin-protocol"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/origin-protocol"
func (n *NetworkInstance_Afts_Ipv4EntryPathAny) OriginProtocol() *NetworkInstance_Afts_Ipv4Entry_OriginProtocolPathAny {
	return &NetworkInstance_Afts_Ipv4Entry_OriginProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_Ipv4EntryPath) PacketsForwarded() *NetworkInstance_Afts_Ipv4Entry_PacketsForwardedPath {
	return &NetworkInstance_Afts_Ipv4Entry_PacketsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_Ipv4EntryPathAny) PacketsForwarded() *NetworkInstance_Afts_Ipv4Entry_PacketsForwardedPathAny {
	return &NetworkInstance_Afts_Ipv4Entry_PacketsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv4 destination prefix that should be matched to
// utilise the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv4"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/prefix"
func (n *NetworkInstance_Afts_Ipv4EntryPath) Prefix() *NetworkInstance_Afts_Ipv4Entry_PrefixPath {
	return &NetworkInstance_Afts_Ipv4Entry_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv4 destination prefix that should be matched to
// utilise the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv4"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/afts/ipv4-unicast/ipv4-entry/state/prefix"
func (n *NetworkInstance_Afts_Ipv4EntryPathAny) Prefix() *NetworkInstance_Afts_Ipv4Entry_PrefixPathAny {
	return &NetworkInstance_Afts_Ipv4Entry_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_Ipv6EntryPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry YANG schema element.
type NetworkInstance_Afts_Ipv6EntryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6EntryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry YANG schema element.
type NetworkInstance_Afts_Ipv6EntryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_DecapsulateHeaderPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/decapsulate-header YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_DecapsulateHeaderPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_DecapsulateHeaderPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/decapsulate-header YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_DecapsulateHeaderPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_EntryMetadataPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_EntryMetadataPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_EntryMetadataPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_EntryMetadataPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_NextHopGroupPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_NextHopGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_NextHopGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_NextHopGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_NextHopGroupNetworkInstancePath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_NextHopGroupNetworkInstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_NextHopGroupNetworkInstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_NextHopGroupNetworkInstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_OctetsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_OctetsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_OctetsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_OctetsForwardedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_OriginProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/origin-protocol YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_OriginProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_OriginProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/origin-protocol YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_OriginProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_PacketsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_PacketsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_PacketsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_PacketsForwardedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/prefix YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_Ipv6Entry_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/prefix YANG schema element.
type NetworkInstance_Afts_Ipv6Entry_PrefixPathAny struct {
	*ygot.NodePath
}

// DecapsulateHeader (leaf): When forwarding a packet to the specified next-hop, the local
// system performs a decapsulation of the packet - removing the
// specified header type. In the case that no next-hop is
// specified, the packet header is removed, and a subsequent
// forwarding lookup is performed on the packet encapsulated
// within the header, matched within the relevant AFT within the
// specified network-instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/decapsulate-header"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/decapsulate-header"
func (n *NetworkInstance_Afts_Ipv6EntryPath) DecapsulateHeader() *NetworkInstance_Afts_Ipv6Entry_DecapsulateHeaderPath {
	return &NetworkInstance_Afts_Ipv6Entry_DecapsulateHeaderPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "decapsulate-header"},
			map[string]interface{}{},
			n,
		),
	}
}

// DecapsulateHeader (leaf): When forwarding a packet to the specified next-hop, the local
// system performs a decapsulation of the packet - removing the
// specified header type. In the case that no next-hop is
// specified, the packet header is removed, and a subsequent
// forwarding lookup is performed on the packet encapsulated
// within the header, matched within the relevant AFT within the
// specified network-instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/decapsulate-header"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/decapsulate-header"
func (n *NetworkInstance_Afts_Ipv6EntryPathAny) DecapsulateHeader() *NetworkInstance_Afts_Ipv6Entry_DecapsulateHeaderPathAny {
	return &NetworkInstance_Afts_Ipv6Entry_DecapsulateHeaderPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "decapsulate-header"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_Ipv6EntryPath) EntryMetadata() *NetworkInstance_Afts_Ipv6Entry_EntryMetadataPath {
	return &NetworkInstance_Afts_Ipv6Entry_EntryMetadataPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_Ipv6EntryPathAny) EntryMetadata() *NetworkInstance_Afts_Ipv6Entry_EntryMetadataPathAny {
	return &NetworkInstance_Afts_Ipv6Entry_EntryMetadataPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_Ipv6EntryPath) NextHopGroup() *NetworkInstance_Afts_Ipv6Entry_NextHopGroupPath {
	return &NetworkInstance_Afts_Ipv6Entry_NextHopGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_Ipv6EntryPathAny) NextHopGroup() *NetworkInstance_Afts_Ipv6Entry_NextHopGroupPathAny {
	return &NetworkInstance_Afts_Ipv6Entry_NextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_Ipv6EntryPath) NextHopGroupNetworkInstance() *NetworkInstance_Afts_Ipv6Entry_NextHopGroupNetworkInstancePath {
	return &NetworkInstance_Afts_Ipv6Entry_NextHopGroupNetworkInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_Ipv6EntryPathAny) NextHopGroupNetworkInstance() *NetworkInstance_Afts_Ipv6Entry_NextHopGroupNetworkInstancePathAny {
	return &NetworkInstance_Afts_Ipv6Entry_NextHopGroupNetworkInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_Ipv6EntryPath) OctetsForwarded() *NetworkInstance_Afts_Ipv6Entry_OctetsForwardedPath {
	return &NetworkInstance_Afts_Ipv6Entry_OctetsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_Ipv6EntryPathAny) OctetsForwarded() *NetworkInstance_Afts_Ipv6Entry_OctetsForwardedPathAny {
	return &NetworkInstance_Afts_Ipv6Entry_OctetsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginProtocol (leaf): The protocol from which the AFT entry was learned.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin-protocol"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/origin-protocol"
func (n *NetworkInstance_Afts_Ipv6EntryPath) OriginProtocol() *NetworkInstance_Afts_Ipv6Entry_OriginProtocolPath {
	return &NetworkInstance_Afts_Ipv6Entry_OriginProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginProtocol (leaf): The protocol from which the AFT entry was learned.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin-protocol"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/origin-protocol"
func (n *NetworkInstance_Afts_Ipv6EntryPathAny) OriginProtocol() *NetworkInstance_Afts_Ipv6Entry_OriginProtocolPathAny {
	return &NetworkInstance_Afts_Ipv6Entry_OriginProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_Ipv6EntryPath) PacketsForwarded() *NetworkInstance_Afts_Ipv6Entry_PacketsForwardedPath {
	return &NetworkInstance_Afts_Ipv6Entry_PacketsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_Ipv6EntryPathAny) PacketsForwarded() *NetworkInstance_Afts_Ipv6Entry_PacketsForwardedPathAny {
	return &NetworkInstance_Afts_Ipv6Entry_PacketsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv6 destination prefix that should be matched to
// utilise the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv6"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/prefix"
func (n *NetworkInstance_Afts_Ipv6EntryPath) Prefix() *NetworkInstance_Afts_Ipv6Entry_PrefixPath {
	return &NetworkInstance_Afts_Ipv6Entry_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv6 destination prefix that should be matched to
// utilise the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-ipv6"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/afts/ipv6-unicast/ipv6-entry/state/prefix"
func (n *NetworkInstance_Afts_Ipv6EntryPathAny) Prefix() *NetworkInstance_Afts_Ipv6Entry_PrefixPathAny {
	return &NetworkInstance_Afts_Ipv6Entry_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_LabelEntryPath represents the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry YANG schema element.
type NetworkInstance_Afts_LabelEntryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry YANG schema element.
type NetworkInstance_Afts_LabelEntryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_EntryMetadataPath represents the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_LabelEntry_EntryMetadataPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_EntryMetadataPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_LabelEntry_EntryMetadataPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/label YANG schema element.
type NetworkInstance_Afts_LabelEntry_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/label YANG schema element.
type NetworkInstance_Afts_LabelEntry_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_NextHopGroupPath represents the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_LabelEntry_NextHopGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_NextHopGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_LabelEntry_NextHopGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_NextHopGroupNetworkInstancePath represents the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_LabelEntry_NextHopGroupNetworkInstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_NextHopGroupNetworkInstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_LabelEntry_NextHopGroupNetworkInstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_OctetsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_LabelEntry_OctetsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_OctetsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_LabelEntry_OctetsForwardedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_PacketsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_LabelEntry_PacketsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_PacketsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_LabelEntry_PacketsForwardedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_PoppedMplsLabelStackPath represents the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/popped-mpls-label-stack YANG schema element.
type NetworkInstance_Afts_LabelEntry_PoppedMplsLabelStackPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_LabelEntry_PoppedMplsLabelStackPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/mpls/label-entry/state/popped-mpls-label-stack YANG schema element.
type NetworkInstance_Afts_LabelEntry_PoppedMplsLabelStackPathAny struct {
	*ygot.NodePath
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_LabelEntryPath) EntryMetadata() *NetworkInstance_Afts_LabelEntry_EntryMetadataPath {
	return &NetworkInstance_Afts_LabelEntry_EntryMetadataPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_LabelEntryPathAny) EntryMetadata() *NetworkInstance_Afts_LabelEntry_EntryMetadataPathAny {
	return &NetworkInstance_Afts_LabelEntry_EntryMetadataPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): The top-most MPLS label that should be matched to
// utilise the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/label"
func (n *NetworkInstance_Afts_LabelEntryPath) Label() *NetworkInstance_Afts_LabelEntry_LabelPath {
	return &NetworkInstance_Afts_LabelEntry_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): The top-most MPLS label that should be matched to
// utilise the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/label"
func (n *NetworkInstance_Afts_LabelEntryPathAny) Label() *NetworkInstance_Afts_LabelEntry_LabelPathAny {
	return &NetworkInstance_Afts_LabelEntry_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_LabelEntryPath) NextHopGroup() *NetworkInstance_Afts_LabelEntry_NextHopGroupPath {
	return &NetworkInstance_Afts_LabelEntry_NextHopGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_LabelEntryPathAny) NextHopGroup() *NetworkInstance_Afts_LabelEntry_NextHopGroupPathAny {
	return &NetworkInstance_Afts_LabelEntry_NextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_LabelEntryPath) NextHopGroupNetworkInstance() *NetworkInstance_Afts_LabelEntry_NextHopGroupNetworkInstancePath {
	return &NetworkInstance_Afts_LabelEntry_NextHopGroupNetworkInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_LabelEntryPathAny) NextHopGroupNetworkInstance() *NetworkInstance_Afts_LabelEntry_NextHopGroupNetworkInstancePathAny {
	return &NetworkInstance_Afts_LabelEntry_NextHopGroupNetworkInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_LabelEntryPath) OctetsForwarded() *NetworkInstance_Afts_LabelEntry_OctetsForwardedPath {
	return &NetworkInstance_Afts_LabelEntry_OctetsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_LabelEntryPathAny) OctetsForwarded() *NetworkInstance_Afts_LabelEntry_OctetsForwardedPathAny {
	return &NetworkInstance_Afts_LabelEntry_OctetsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_LabelEntryPath) PacketsForwarded() *NetworkInstance_Afts_LabelEntry_PacketsForwardedPath {
	return &NetworkInstance_Afts_LabelEntry_PacketsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_LabelEntryPathAny) PacketsForwarded() *NetworkInstance_Afts_LabelEntry_PacketsForwardedPathAny {
	return &NetworkInstance_Afts_LabelEntry_PacketsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PoppedMplsLabelStack (leaf): The MPLS label stack to be popped from the packet when
// switched by the system. The stack is encoded as a leaf-list
// such that the first entry is the label that is outer-most (i.e.,
// furthest from the bottom of the stack).
//
// If the local system pops the outer-most label 400, then the
// value of this list is [400,]. If the local system removes two
// labels, the outer-most being 500, and the second of which is
// 400, then the value of the list is [500, 400].
//
// A swap operation is reflected by entries in the
// popped-mpls-label-stack and pushed-mpls-label-stack nodes.
// ----------------------------------------
// Defining module: "openconfig-aft-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/popped-mpls-label-stack"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/popped-mpls-label-stack"
func (n *NetworkInstance_Afts_LabelEntryPath) PoppedMplsLabelStack() *NetworkInstance_Afts_LabelEntry_PoppedMplsLabelStackPath {
	return &NetworkInstance_Afts_LabelEntry_PoppedMplsLabelStackPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "popped-mpls-label-stack"},
			map[string]interface{}{},
			n,
		),
	}
}

// PoppedMplsLabelStack (leaf): The MPLS label stack to be popped from the packet when
// switched by the system. The stack is encoded as a leaf-list
// such that the first entry is the label that is outer-most (i.e.,
// furthest from the bottom of the stack).
//
// If the local system pops the outer-most label 400, then the
// value of this list is [400,]. If the local system removes two
// labels, the outer-most being 500, and the second of which is
// 400, then the value of the list is [500, 400].
//
// A swap operation is reflected by entries in the
// popped-mpls-label-stack and pushed-mpls-label-stack nodes.
// ----------------------------------------
// Defining module: "openconfig-aft-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/popped-mpls-label-stack"
// Path from root: "/network-instances/network-instance/afts/mpls/label-entry/state/popped-mpls-label-stack"
func (n *NetworkInstance_Afts_LabelEntryPathAny) PoppedMplsLabelStack() *NetworkInstance_Afts_LabelEntry_PoppedMplsLabelStackPathAny {
	return &NetworkInstance_Afts_LabelEntry_PoppedMplsLabelStackPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "popped-mpls-label-stack"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_MacEntryPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry YANG schema element.
type NetworkInstance_Afts_MacEntryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry YANG schema element.
type NetworkInstance_Afts_MacEntryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_EntryMetadataPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_MacEntry_EntryMetadataPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_EntryMetadataPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_MacEntry_EntryMetadataPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_MacAddressPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/mac-address YANG schema element.
type NetworkInstance_Afts_MacEntry_MacAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_MacAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/mac-address YANG schema element.
type NetworkInstance_Afts_MacEntry_MacAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_NextHopGroupPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_MacEntry_NextHopGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_NextHopGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_MacEntry_NextHopGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_NextHopGroupNetworkInstancePath represents the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_MacEntry_NextHopGroupNetworkInstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_NextHopGroupNetworkInstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_MacEntry_NextHopGroupNetworkInstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_OctetsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_MacEntry_OctetsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_OctetsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_MacEntry_OctetsForwardedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_PacketsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_MacEntry_PacketsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_MacEntry_PacketsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/ethernet/mac-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_MacEntry_PacketsForwardedPathAny struct {
	*ygot.NodePath
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_MacEntryPath) EntryMetadata() *NetworkInstance_Afts_MacEntry_EntryMetadataPath {
	return &NetworkInstance_Afts_MacEntry_EntryMetadataPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_MacEntryPathAny) EntryMetadata() *NetworkInstance_Afts_MacEntry_EntryMetadataPathAny {
	return &NetworkInstance_Afts_MacEntry_EntryMetadataPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The outer MAC address of the Ethernet frame that must
// be matched for the AFT entry to be utilised.
// ----------------------------------------
// Defining module: "openconfig-aft-ethernet"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/mac-address"
func (n *NetworkInstance_Afts_MacEntryPath) MacAddress() *NetworkInstance_Afts_MacEntry_MacAddressPath {
	return &NetworkInstance_Afts_MacEntry_MacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The outer MAC address of the Ethernet frame that must
// be matched for the AFT entry to be utilised.
// ----------------------------------------
// Defining module: "openconfig-aft-ethernet"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/mac-address"
func (n *NetworkInstance_Afts_MacEntryPathAny) MacAddress() *NetworkInstance_Afts_MacEntry_MacAddressPathAny {
	return &NetworkInstance_Afts_MacEntry_MacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_MacEntryPath) NextHopGroup() *NetworkInstance_Afts_MacEntry_NextHopGroupPath {
	return &NetworkInstance_Afts_MacEntry_NextHopGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_MacEntryPathAny) NextHopGroup() *NetworkInstance_Afts_MacEntry_NextHopGroupPathAny {
	return &NetworkInstance_Afts_MacEntry_NextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_MacEntryPath) NextHopGroupNetworkInstance() *NetworkInstance_Afts_MacEntry_NextHopGroupNetworkInstancePath {
	return &NetworkInstance_Afts_MacEntry_NextHopGroupNetworkInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_MacEntryPathAny) NextHopGroupNetworkInstance() *NetworkInstance_Afts_MacEntry_NextHopGroupNetworkInstancePathAny {
	return &NetworkInstance_Afts_MacEntry_NextHopGroupNetworkInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_MacEntryPath) OctetsForwarded() *NetworkInstance_Afts_MacEntry_OctetsForwardedPath {
	return &NetworkInstance_Afts_MacEntry_OctetsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_MacEntryPathAny) OctetsForwarded() *NetworkInstance_Afts_MacEntry_OctetsForwardedPathAny {
	return &NetworkInstance_Afts_MacEntry_OctetsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_MacEntryPath) PacketsForwarded() *NetworkInstance_Afts_MacEntry_PacketsForwardedPath {
	return &NetworkInstance_Afts_MacEntry_PacketsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/ethernet/mac-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_MacEntryPathAny) PacketsForwarded() *NetworkInstance_Afts_MacEntry_PacketsForwardedPathAny {
	return &NetworkInstance_Afts_MacEntry_PacketsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop YANG schema element.
type NetworkInstance_Afts_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop YANG schema element.
type NetworkInstance_Afts_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_EncapsulateHeaderPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/encapsulate-header YANG schema element.
type NetworkInstance_Afts_NextHop_EncapsulateHeaderPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_EncapsulateHeaderPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/encapsulate-header YANG schema element.
type NetworkInstance_Afts_NextHop_EncapsulateHeaderPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_Afts_NextHop_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_Afts_NextHop_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_IpAddressPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/ip-address YANG schema element.
type NetworkInstance_Afts_NextHop_IpAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_IpAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/ip-address YANG schema element.
type NetworkInstance_Afts_NextHop_IpAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_LspNamePath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/lsp-name YANG schema element.
type NetworkInstance_Afts_NextHop_LspNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_LspNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/lsp-name YANG schema element.
type NetworkInstance_Afts_NextHop_LspNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_MacAddressPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/mac-address YANG schema element.
type NetworkInstance_Afts_NextHop_MacAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_MacAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/mac-address YANG schema element.
type NetworkInstance_Afts_NextHop_MacAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_OriginProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/origin-protocol YANG schema element.
type NetworkInstance_Afts_NextHop_OriginProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_OriginProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/origin-protocol YANG schema element.
type NetworkInstance_Afts_NextHop_OriginProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_PopTopLabelPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/pop-top-label YANG schema element.
type NetworkInstance_Afts_NextHop_PopTopLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_PopTopLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/pop-top-label YANG schema element.
type NetworkInstance_Afts_NextHop_PopTopLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_ProgrammedIndexPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/programmed-index YANG schema element.
type NetworkInstance_Afts_NextHop_ProgrammedIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_ProgrammedIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/programmed-index YANG schema element.
type NetworkInstance_Afts_NextHop_ProgrammedIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_PushedMplsLabelStackPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/pushed-mpls-label-stack YANG schema element.
type NetworkInstance_Afts_NextHop_PushedMplsLabelStackPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_PushedMplsLabelStackPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/pushed-mpls-label-stack YANG schema element.
type NetworkInstance_Afts_NextHop_PushedMplsLabelStackPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_TunnelSrcIpAddressPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/tunnel-src-ip-address YANG schema element.
type NetworkInstance_Afts_NextHop_TunnelSrcIpAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_TunnelSrcIpAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/tunnel-src-ip-address YANG schema element.
type NetworkInstance_Afts_NextHop_TunnelSrcIpAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_VniLabelPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/vni-label YANG schema element.
type NetworkInstance_Afts_NextHop_VniLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_VniLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/state/vni-label YANG schema element.
type NetworkInstance_Afts_NextHop_VniLabelPathAny struct {
	*ygot.NodePath
}

// EncapsulateHeader (leaf): When forwarding a packet to the specified next-hop the local
// system performs an encapsulation of the packet - adding the
// specified header type.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/encapsulate-header"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/encapsulate-header"
func (n *NetworkInstance_Afts_NextHopPath) EncapsulateHeader() *NetworkInstance_Afts_NextHop_EncapsulateHeaderPath {
	return &NetworkInstance_Afts_NextHop_EncapsulateHeaderPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "encapsulate-header"},
			map[string]interface{}{},
			n,
		),
	}
}

// EncapsulateHeader (leaf): When forwarding a packet to the specified next-hop the local
// system performs an encapsulation of the packet - adding the
// specified header type.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/encapsulate-header"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/encapsulate-header"
func (n *NetworkInstance_Afts_NextHopPathAny) EncapsulateHeader() *NetworkInstance_Afts_NextHop_EncapsulateHeaderPathAny {
	return &NetworkInstance_Afts_NextHop_EncapsulateHeaderPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "encapsulate-header"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): A unique entry for the next-hop.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/index"
func (n *NetworkInstance_Afts_NextHopPath) Index() *NetworkInstance_Afts_NextHop_IndexPath {
	return &NetworkInstance_Afts_NextHop_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): A unique entry for the next-hop.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/index"
func (n *NetworkInstance_Afts_NextHopPathAny) Index() *NetworkInstance_Afts_NextHop_IndexPathAny {
	return &NetworkInstance_Afts_NextHop_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/interface-ref"
func (n *NetworkInstance_Afts_NextHopPath) InterfaceRef() *NetworkInstance_Afts_NextHop_InterfaceRefPath {
	return &NetworkInstance_Afts_NextHop_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/interface-ref"
func (n *NetworkInstance_Afts_NextHopPathAny) InterfaceRef() *NetworkInstance_Afts_NextHop_InterfaceRefPathAny {
	return &NetworkInstance_Afts_NextHop_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpAddress (leaf): The IP address of the next-hop system.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-address"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/ip-address"
func (n *NetworkInstance_Afts_NextHopPath) IpAddress() *NetworkInstance_Afts_NextHop_IpAddressPath {
	return &NetworkInstance_Afts_NextHop_IpAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpAddress (leaf): The IP address of the next-hop system.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-address"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/ip-address"
func (n *NetworkInstance_Afts_NextHopPathAny) IpAddress() *NetworkInstance_Afts_NextHop_IpAddressPathAny {
	return &NetworkInstance_Afts_NextHop_IpAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpInIp (container): When specified, the packet has an IP-in-IP header applied to it before
// forwarding to the specified next-hop.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ip-in-ip"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip"
func (n *NetworkInstance_Afts_NextHopPath) IpInIp() *NetworkInstance_Afts_NextHop_IpInIpPath {
	return &NetworkInstance_Afts_NextHop_IpInIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ip-in-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpInIp (container): When specified, the packet has an IP-in-IP header applied to it before
// forwarding to the specified next-hop.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ip-in-ip"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip"
func (n *NetworkInstance_Afts_NextHopPathAny) IpInIp() *NetworkInstance_Afts_NextHop_IpInIpPathAny {
	return &NetworkInstance_Afts_NextHop_IpInIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ip-in-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspName (leaf): Where applicable, the protocol name for the next-hop labelled
// forwarding entry. This leaf is applicable only to next-hops
// which include MPLS label information, and its value typically
// corresponds to the RSVP-TE LSP name.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lsp-name"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/lsp-name"
func (n *NetworkInstance_Afts_NextHopPath) LspName() *NetworkInstance_Afts_NextHop_LspNamePath {
	return &NetworkInstance_Afts_NextHop_LspNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lsp-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspName (leaf): Where applicable, the protocol name for the next-hop labelled
// forwarding entry. This leaf is applicable only to next-hops
// which include MPLS label information, and its value typically
// corresponds to the RSVP-TE LSP name.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lsp-name"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/lsp-name"
func (n *NetworkInstance_Afts_NextHopPathAny) LspName() *NetworkInstance_Afts_NextHop_LspNamePathAny {
	return &NetworkInstance_Afts_NextHop_LspNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lsp-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The MAC address of the next-hop if resolved by the local
// network instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/mac-address"
func (n *NetworkInstance_Afts_NextHopPath) MacAddress() *NetworkInstance_Afts_NextHop_MacAddressPath {
	return &NetworkInstance_Afts_NextHop_MacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The MAC address of the next-hop if resolved by the local
// network instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/mac-address"
func (n *NetworkInstance_Afts_NextHopPathAny) MacAddress() *NetworkInstance_Afts_NextHop_MacAddressPathAny {
	return &NetworkInstance_Afts_NextHop_MacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginProtocol (leaf): The protocol from which the AFT entry was learned.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin-protocol"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/origin-protocol"
func (n *NetworkInstance_Afts_NextHopPath) OriginProtocol() *NetworkInstance_Afts_NextHop_OriginProtocolPath {
	return &NetworkInstance_Afts_NextHop_OriginProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginProtocol (leaf): The protocol from which the AFT entry was learned.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin-protocol"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/origin-protocol"
func (n *NetworkInstance_Afts_NextHopPathAny) OriginProtocol() *NetworkInstance_Afts_NextHop_OriginProtocolPathAny {
	return &NetworkInstance_Afts_NextHop_OriginProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// PopTopLabel (leaf): Flag that controls pop action, i.e., the top-most MPLS label
// should be popped from the packet when switched by the system.
//
// The top-most MPLS label associated with pop action is equal to
// the label key used in 'mpls' AFT 'label-entry' list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pop-top-label"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/pop-top-label"
func (n *NetworkInstance_Afts_NextHopPath) PopTopLabel() *NetworkInstance_Afts_NextHop_PopTopLabelPath {
	return &NetworkInstance_Afts_NextHop_PopTopLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pop-top-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// PopTopLabel (leaf): Flag that controls pop action, i.e., the top-most MPLS label
// should be popped from the packet when switched by the system.
//
// The top-most MPLS label associated with pop action is equal to
// the label key used in 'mpls' AFT 'label-entry' list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pop-top-label"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/pop-top-label"
func (n *NetworkInstance_Afts_NextHopPathAny) PopTopLabel() *NetworkInstance_Afts_NextHop_PopTopLabelPathAny {
	return &NetworkInstance_Afts_NextHop_PopTopLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pop-top-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProgrammedIndex (leaf): In some routing protocols, or route injection mechanisms it
// is possible to set the index of the next-hop via configuration
// or the protocol itself. In some systems it may not be possible
// to maintain the index provided by an external client when
// advertising the same entry via telemetry.
//
// This leaf reflects the configured or client-supplied index of
// the next-hop. This allows a client to create an assocation or
// mapping back to the original index pushed by the client, and
// the ID used as a key in the next-hop AFT list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/programmed-index"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/programmed-index"
func (n *NetworkInstance_Afts_NextHopPath) ProgrammedIndex() *NetworkInstance_Afts_NextHop_ProgrammedIndexPath {
	return &NetworkInstance_Afts_NextHop_ProgrammedIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "programmed-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProgrammedIndex (leaf): In some routing protocols, or route injection mechanisms it
// is possible to set the index of the next-hop via configuration
// or the protocol itself. In some systems it may not be possible
// to maintain the index provided by an external client when
// advertising the same entry via telemetry.
//
// This leaf reflects the configured or client-supplied index of
// the next-hop. This allows a client to create an assocation or
// mapping back to the original index pushed by the client, and
// the ID used as a key in the next-hop AFT list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/programmed-index"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/programmed-index"
func (n *NetworkInstance_Afts_NextHopPathAny) ProgrammedIndex() *NetworkInstance_Afts_NextHop_ProgrammedIndexPathAny {
	return &NetworkInstance_Afts_NextHop_ProgrammedIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "programmed-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushedMplsLabelStack (leaf): The MPLS label stack imposed when forwarding packets to the
// next-hop
// - the stack is encoded as a leaf list whereby the order of the
//  entries is such that the first entry in the list is the
//  label at the bottom of the stack to be pushed.
//
// To this end, a packet which is to forwarded to a device using
// a service label of 42, and a transport label of 8072 will be
// represented with a label stack list of [42, 8072].
//
// The MPLS label stack list is ordered by the user, such that no
// system re-ordering of leaves is permitted by the system.
//
// A swap operation is reflected by entries in the
// popped-mpls-label-stack and pushed-mpls-label-stack nodes.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pushed-mpls-label-stack"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/pushed-mpls-label-stack"
func (n *NetworkInstance_Afts_NextHopPath) PushedMplsLabelStack() *NetworkInstance_Afts_NextHop_PushedMplsLabelStackPath {
	return &NetworkInstance_Afts_NextHop_PushedMplsLabelStackPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pushed-mpls-label-stack"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushedMplsLabelStack (leaf): The MPLS label stack imposed when forwarding packets to the
// next-hop
// - the stack is encoded as a leaf list whereby the order of the
//  entries is such that the first entry in the list is the
//  label at the bottom of the stack to be pushed.
//
// To this end, a packet which is to forwarded to a device using
// a service label of 42, and a transport label of 8072 will be
// represented with a label stack list of [42, 8072].
//
// The MPLS label stack list is ordered by the user, such that no
// system re-ordering of leaves is permitted by the system.
//
// A swap operation is reflected by entries in the
// popped-mpls-label-stack and pushed-mpls-label-stack nodes.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pushed-mpls-label-stack"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/pushed-mpls-label-stack"
func (n *NetworkInstance_Afts_NextHopPathAny) PushedMplsLabelStack() *NetworkInstance_Afts_NextHop_PushedMplsLabelStackPathAny {
	return &NetworkInstance_Afts_NextHop_PushedMplsLabelStackPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pushed-mpls-label-stack"},
			map[string]interface{}{},
			n,
		),
	}
}

// TunnelSrcIpAddress (leaf): Where applicable this represents the tunnel source ip address.
// For VXLAN this represents the source VTEP ip address
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tunnel-src-ip-address"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/tunnel-src-ip-address"
func (n *NetworkInstance_Afts_NextHopPath) TunnelSrcIpAddress() *NetworkInstance_Afts_NextHop_TunnelSrcIpAddressPath {
	return &NetworkInstance_Afts_NextHop_TunnelSrcIpAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tunnel-src-ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// TunnelSrcIpAddress (leaf): Where applicable this represents the tunnel source ip address.
// For VXLAN this represents the source VTEP ip address
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tunnel-src-ip-address"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/tunnel-src-ip-address"
func (n *NetworkInstance_Afts_NextHopPathAny) TunnelSrcIpAddress() *NetworkInstance_Afts_NextHop_TunnelSrcIpAddressPathAny {
	return &NetworkInstance_Afts_NextHop_TunnelSrcIpAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tunnel-src-ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// VniLabel (leaf): Where applicable, the next hop label representing the virtual
// network identifier (VNI) for the forwarding entry. This leaf is
// applicable only to next-hops which include VXLAN encapsulation
// header information
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vni-label"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/vni-label"
func (n *NetworkInstance_Afts_NextHopPath) VniLabel() *NetworkInstance_Afts_NextHop_VniLabelPath {
	return &NetworkInstance_Afts_NextHop_VniLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vni-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// VniLabel (leaf): Where applicable, the next hop label representing the virtual
// network identifier (VNI) for the forwarding entry. This leaf is
// applicable only to next-hops which include VXLAN encapsulation
// header information
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vni-label"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/state/vni-label"
func (n *NetworkInstance_Afts_NextHopPathAny) VniLabel() *NetworkInstance_Afts_NextHop_VniLabelPathAny {
	return &NetworkInstance_Afts_NextHop_VniLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vni-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_NextHopGroupPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group YANG schema element.
type NetworkInstance_Afts_NextHopGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group YANG schema element.
type NetworkInstance_Afts_NextHopGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_BackupNextHopGroupPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/backup-next-hop-group YANG schema element.
type NetworkInstance_Afts_NextHopGroup_BackupNextHopGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_BackupNextHopGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/backup-next-hop-group YANG schema element.
type NetworkInstance_Afts_NextHopGroup_BackupNextHopGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/color YANG schema element.
type NetworkInstance_Afts_NextHopGroup_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/color YANG schema element.
type NetworkInstance_Afts_NextHopGroup_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_IdPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/id YANG schema element.
type NetworkInstance_Afts_NextHopGroup_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/id YANG schema element.
type NetworkInstance_Afts_NextHopGroup_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_ProgrammedIdPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/programmed-id YANG schema element.
type NetworkInstance_Afts_NextHopGroup_ProgrammedIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_ProgrammedIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/programmed-id YANG schema element.
type NetworkInstance_Afts_NextHopGroup_ProgrammedIdPathAny struct {
	*ygot.NodePath
}

// BackupNextHopGroup (leaf): The backup next-hop-group for the current group. When all
// entries within the next-hop group become unusable, the backup
// next-hop group is used if specified.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup-next-hop-group"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/backup-next-hop-group"
func (n *NetworkInstance_Afts_NextHopGroupPath) BackupNextHopGroup() *NetworkInstance_Afts_NextHopGroup_BackupNextHopGroupPath {
	return &NetworkInstance_Afts_NextHopGroup_BackupNextHopGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup-next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// BackupNextHopGroup (leaf): The backup next-hop-group for the current group. When all
// entries within the next-hop group become unusable, the backup
// next-hop group is used if specified.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup-next-hop-group"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/backup-next-hop-group"
func (n *NetworkInstance_Afts_NextHopGroupPathAny) BackupNextHopGroup() *NetworkInstance_Afts_NextHopGroup_BackupNextHopGroupPathAny {
	return &NetworkInstance_Afts_NextHopGroup_BackupNextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup-next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): An arbitrary colour that is used as an identifier for the next-hop
// group. Some next-hop resolutions may utilise the colour to select
// the particular next-hop-group that a routing entry should be resolved
// to. In this case, next-hop-group selection may be based on colour
// matches rather than the protocol specified next-hop.
//
// Regardless of whether the next-hop-group's specified colour is
// used to select an AFT's active forwarding entry, the next-hop-group
// referenced by an entry should be the currently active value.
//
// Next-hop-groups that are installed on the system through a protocol
// that allows injection of such entries (e.g., BGP using the SR-TE
// Policy SAFI, or gRPC-based RIB programming) should have the colour
// specified in the injecting protocol within this leaf.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/color"
func (n *NetworkInstance_Afts_NextHopGroupPath) Color() *NetworkInstance_Afts_NextHopGroup_ColorPath {
	return &NetworkInstance_Afts_NextHopGroup_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): An arbitrary colour that is used as an identifier for the next-hop
// group. Some next-hop resolutions may utilise the colour to select
// the particular next-hop-group that a routing entry should be resolved
// to. In this case, next-hop-group selection may be based on colour
// matches rather than the protocol specified next-hop.
//
// Regardless of whether the next-hop-group's specified colour is
// used to select an AFT's active forwarding entry, the next-hop-group
// referenced by an entry should be the currently active value.
//
// Next-hop-groups that are installed on the system through a protocol
// that allows injection of such entries (e.g., BGP using the SR-TE
// Policy SAFI, or gRPC-based RIB programming) should have the colour
// specified in the injecting protocol within this leaf.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/color"
func (n *NetworkInstance_Afts_NextHopGroupPathAny) Color() *NetworkInstance_Afts_NextHopGroup_ColorPathAny {
	return &NetworkInstance_Afts_NextHopGroup_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConditionAny (list): A conditional next-hop-group that is used by the AFT
// entry. The conditions that are specified within the
// group are logically ANDed together. If a condition
// is a leaf-list field its contents are logically ORed.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "conditional/condition"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition"
// Id (wildcarded): uint64
func (n *NetworkInstance_Afts_NextHopGroupPath) ConditionAny() *NetworkInstance_Afts_NextHopGroup_ConditionPathAny {
	return &NetworkInstance_Afts_NextHopGroup_ConditionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"conditional", "condition"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// ConditionAny (list): A conditional next-hop-group that is used by the AFT
// entry. The conditions that are specified within the
// group are logically ANDed together. If a condition
// is a leaf-list field its contents are logically ORed.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "conditional/condition"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition"
// Id (wildcarded): uint64
func (n *NetworkInstance_Afts_NextHopGroupPathAny) ConditionAny() *NetworkInstance_Afts_NextHopGroup_ConditionPathAny {
	return &NetworkInstance_Afts_NextHopGroup_ConditionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"conditional", "condition"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Condition (list): A conditional next-hop-group that is used by the AFT
// entry. The conditions that are specified within the
// group are logically ANDed together. If a condition
// is a leaf-list field its contents are logically ORed.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "conditional/condition"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition"
// Id: uint64
func (n *NetworkInstance_Afts_NextHopGroupPath) Condition(Id uint64) *NetworkInstance_Afts_NextHopGroup_ConditionPath {
	return &NetworkInstance_Afts_NextHopGroup_ConditionPath{
		NodePath: ygot.NewNodePath(
			[]string{"conditional", "condition"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Condition (list): A conditional next-hop-group that is used by the AFT
// entry. The conditions that are specified within the
// group are logically ANDed together. If a condition
// is a leaf-list field its contents are logically ORed.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "conditional/condition"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition"
// Id: uint64
func (n *NetworkInstance_Afts_NextHopGroupPathAny) Condition(Id uint64) *NetworkInstance_Afts_NextHopGroup_ConditionPathAny {
	return &NetworkInstance_Afts_NextHopGroup_ConditionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"conditional", "condition"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Id (leaf): A unique identifier for the next-hop-group. This index
// is not expected to be consistent across reboots, or
// reprogramming of the next-hop-group. When updating
// a next-hop-group, if the group is removed by the system
// or assigned an alternate identifier, the system should
// send telemetry notifications deleting the previous
// identifier. If the identifier of the next-hop-group
// is changed, all AFT entries that reference it must
// also be updated.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/id"
func (n *NetworkInstance_Afts_NextHopGroupPath) Id() *NetworkInstance_Afts_NextHopGroup_IdPath {
	return &NetworkInstance_Afts_NextHopGroup_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique identifier for the next-hop-group. This index
// is not expected to be consistent across reboots, or
// reprogramming of the next-hop-group. When updating
// a next-hop-group, if the group is removed by the system
// or assigned an alternate identifier, the system should
// send telemetry notifications deleting the previous
// identifier. If the identifier of the next-hop-group
// is changed, all AFT entries that reference it must
// also be updated.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/id"
func (n *NetworkInstance_Afts_NextHopGroupPathAny) Id() *NetworkInstance_Afts_NextHopGroup_IdPathAny {
	return &NetworkInstance_Afts_NextHopGroup_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopAny (list): An individual next-hop within the next-hop-group. Each
// next-hop is a reference to an entry within the next-hop
// list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_Afts_NextHopGroupPath) NextHopAny() *NetworkInstance_Afts_NextHopGroup_NextHopPathAny {
	return &NetworkInstance_Afts_NextHopGroup_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHopAny (list): An individual next-hop within the next-hop-group. Each
// next-hop is a reference to an entry within the next-hop
// list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_Afts_NextHopGroupPathAny) NextHopAny() *NetworkInstance_Afts_NextHopGroup_NextHopPathAny {
	return &NetworkInstance_Afts_NextHopGroup_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHop (list): An individual next-hop within the next-hop-group. Each
// next-hop is a reference to an entry within the next-hop
// list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_Afts_NextHopGroupPath) NextHop(Index uint64) *NetworkInstance_Afts_NextHopGroup_NextHopPath {
	return &NetworkInstance_Afts_NextHopGroup_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NextHop (list): An individual next-hop within the next-hop-group. Each
// next-hop is a reference to an entry within the next-hop
// list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_Afts_NextHopGroupPathAny) NextHop(Index uint64) *NetworkInstance_Afts_NextHopGroup_NextHopPathAny {
	return &NetworkInstance_Afts_NextHopGroup_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// ProgrammedId (leaf): In some routing protocols or route injection mechanisms it
// is possible to supply the ID of the next-hop-group via
// configuration or the protocol itself. In some systems, it
// may not be possible to use this same ID when returning the
// NHG via telemetry.
//
// This leaf reflects the ID of the next-hop group that was
// used by the original programming mechanism.
//
// This leaf allows a client to create an association between
// a programmed next-hop's original ID, and the ID that is
// extracted via telemetry as a key in the next-hop-group AFT
// list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/programmed-id"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/programmed-id"
func (n *NetworkInstance_Afts_NextHopGroupPath) ProgrammedId() *NetworkInstance_Afts_NextHopGroup_ProgrammedIdPath {
	return &NetworkInstance_Afts_NextHopGroup_ProgrammedIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "programmed-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProgrammedId (leaf): In some routing protocols or route injection mechanisms it
// is possible to supply the ID of the next-hop-group via
// configuration or the protocol itself. In some systems, it
// may not be possible to use this same ID when returning the
// NHG via telemetry.
//
// This leaf reflects the ID of the next-hop group that was
// used by the original programming mechanism.
//
// This leaf allows a client to create an association between
// a programmed next-hop's original ID, and the ID that is
// extracted via telemetry as a key in the next-hop-group AFT
// list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/programmed-id"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/state/programmed-id"
func (n *NetworkInstance_Afts_NextHopGroupPathAny) ProgrammedId() *NetworkInstance_Afts_NextHopGroup_ProgrammedIdPathAny {
	return &NetworkInstance_Afts_NextHopGroup_ProgrammedIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "programmed-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_NextHopGroup_ConditionPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition YANG schema element.
type NetworkInstance_Afts_NextHopGroup_ConditionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_ConditionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition YANG schema element.
type NetworkInstance_Afts_NextHopGroup_ConditionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_DscpPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/dscp YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_DscpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_DscpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/dscp YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_DscpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_IdPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/id YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/id YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_NextHopGroupPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_NextHopGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_NextHopGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_NextHopGroupPathAny struct {
	*ygot.NodePath
}

// Dscp (leaf): A set of DSCP values that must be matched by an input packet for
// the next-hop-group specified to be selected. A logical OR is applied
// across the DSCP values.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dscp"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/dscp"
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPath) Dscp() *NetworkInstance_Afts_NextHopGroup_Condition_DscpPath {
	return &NetworkInstance_Afts_NextHopGroup_Condition_DscpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dscp (leaf): A set of DSCP values that must be matched by an input packet for
// the next-hop-group specified to be selected. A logical OR is applied
// across the DSCP values.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dscp"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/dscp"
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPathAny) Dscp() *NetworkInstance_Afts_NextHopGroup_Condition_DscpPathAny {
	return &NetworkInstance_Afts_NextHopGroup_Condition_DscpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique identifier for the conditional criteria.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/id"
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPath) Id() *NetworkInstance_Afts_NextHopGroup_Condition_IdPath {
	return &NetworkInstance_Afts_NextHopGroup_Condition_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique identifier for the conditional criteria.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/id"
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPathAny) Id() *NetworkInstance_Afts_NextHopGroup_Condition_IdPathAny {
	return &NetworkInstance_Afts_NextHopGroup_Condition_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputInterfaceAny (list): The input interface that must be matched for the condition to be met.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "input-interfaces/input-interface"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface"
// Id (wildcarded): string
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPath) InputInterfaceAny() *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"input-interfaces", "input-interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InputInterfaceAny (list): The input interface that must be matched for the condition to be met.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "input-interfaces/input-interface"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface"
// Id (wildcarded): string
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPathAny) InputInterfaceAny() *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"input-interfaces", "input-interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InputInterface (list): The input interface that must be matched for the condition to be met.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "input-interfaces/input-interface"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface"
// Id: string
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPath) InputInterface(Id string) *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePath {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"input-interfaces", "input-interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// InputInterface (list): The input interface that must be matched for the condition to be met.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "input-interfaces/input-interface"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface"
// Id: string
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPathAny) InputInterface(Id string) *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"input-interfaces", "input-interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// NextHopGroup (leaf): The next-hop-group that is used by the system for packets that match
// the criteria specified.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/next-hop-group"
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPath) NextHopGroup() *NetworkInstance_Afts_NextHopGroup_Condition_NextHopGroupPath {
	return &NetworkInstance_Afts_NextHopGroup_Condition_NextHopGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): The next-hop-group that is used by the system for packets that match
// the criteria specified.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/state/next-hop-group"
func (n *NetworkInstance_Afts_NextHopGroup_ConditionPathAny) NextHopGroup() *NetworkInstance_Afts_NextHopGroup_Condition_NextHopGroupPathAny {
	return &NetworkInstance_Afts_NextHopGroup_Condition_NextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_IdPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/id YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/id YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/interface YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/interface YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/subinterface YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/subinterface YANG schema element.
type NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Id (leaf): A unique reference for the input interface.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/id"
func (n *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePath) Id() *NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_IdPath {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique reference for the input interface.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/id"
func (n *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny) Id() *NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_IdPathAny {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/interface"
func (n *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePath) Interface() *NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_InterfacePath {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/interface"
func (n *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny) Interface() *NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_InterfacePathAny {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/subinterface"
func (n *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePath) Subinterface() *NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_SubinterfacePath {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/conditional/condition/input-interfaces/input-interface/state/subinterface"
func (n *NetworkInstance_Afts_NextHopGroup_Condition_InputInterfacePathAny) Subinterface() *NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_SubinterfacePathAny {
	return &NetworkInstance_Afts_NextHopGroup_Condition_InputInterface_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_NextHopGroup_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop YANG schema element.
type NetworkInstance_Afts_NextHopGroup_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop YANG schema element.
type NetworkInstance_Afts_NextHopGroup_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_NextHop_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_Afts_NextHopGroup_NextHop_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_NextHop_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_Afts_NextHopGroup_NextHop_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_NextHop_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop/state/weight YANG schema element.
type NetworkInstance_Afts_NextHopGroup_NextHop_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHopGroup_NextHop_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop/state/weight YANG schema element.
type NetworkInstance_Afts_NextHopGroup_NextHop_WeightPathAny struct {
	*ygot.NodePath
}

// Index (leaf): A reference to the identifier for the next-hop to which
// the entry in the next-hop group corresponds.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop/state/index"
func (n *NetworkInstance_Afts_NextHopGroup_NextHopPath) Index() *NetworkInstance_Afts_NextHopGroup_NextHop_IndexPath {
	return &NetworkInstance_Afts_NextHopGroup_NextHop_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): A reference to the identifier for the next-hop to which
// the entry in the next-hop group corresponds.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop/state/index"
func (n *NetworkInstance_Afts_NextHopGroup_NextHopPathAny) Index() *NetworkInstance_Afts_NextHopGroup_NextHop_IndexPathAny {
	return &NetworkInstance_Afts_NextHopGroup_NextHop_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): The weight applied to the next-hop within the group. Traffic
// is balanced across the next-hops within the group in the
// proportion of weight/(sum of weights of the next-hops within
// the next-hop group).
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop/state/weight"
func (n *NetworkInstance_Afts_NextHopGroup_NextHopPath) Weight() *NetworkInstance_Afts_NextHopGroup_NextHop_WeightPath {
	return &NetworkInstance_Afts_NextHopGroup_NextHop_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): The weight applied to the next-hop within the group. Traffic
// is balanced across the next-hops within the group in the
// proportion of weight/(sum of weights of the next-hops within
// the next-hop group).
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/afts/next-hop-groups/next-hop-group/next-hops/next-hop/state/weight"
func (n *NetworkInstance_Afts_NextHopGroup_NextHopPathAny) Weight() *NetworkInstance_Afts_NextHopGroup_NextHop_WeightPathAny {
	return &NetworkInstance_Afts_NextHopGroup_NextHop_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_NextHop_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/interface-ref YANG schema element.
type NetworkInstance_Afts_NextHop_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/interface-ref YANG schema element.
type NetworkInstance_Afts_NextHop_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/interface-ref/state/interface YANG schema element.
type NetworkInstance_Afts_NextHop_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/interface-ref/state/interface YANG schema element.
type NetworkInstance_Afts_NextHop_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/interface-ref/state/subinterface YANG schema element.
type NetworkInstance_Afts_NextHop_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/interface-ref/state/subinterface YANG schema element.
type NetworkInstance_Afts_NextHop_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/interface-ref/state/interface"
func (n *NetworkInstance_Afts_NextHop_InterfaceRefPath) Interface() *NetworkInstance_Afts_NextHop_InterfaceRef_InterfacePath {
	return &NetworkInstance_Afts_NextHop_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/interface-ref/state/interface"
func (n *NetworkInstance_Afts_NextHop_InterfaceRefPathAny) Interface() *NetworkInstance_Afts_NextHop_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Afts_NextHop_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/interface-ref/state/subinterface"
func (n *NetworkInstance_Afts_NextHop_InterfaceRefPath) Subinterface() *NetworkInstance_Afts_NextHop_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Afts_NextHop_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/interface-ref/state/subinterface"
func (n *NetworkInstance_Afts_NextHop_InterfaceRefPathAny) Subinterface() *NetworkInstance_Afts_NextHop_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Afts_NextHop_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_NextHop_IpInIpPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip YANG schema element.
type NetworkInstance_Afts_NextHop_IpInIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_IpInIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip YANG schema element.
type NetworkInstance_Afts_NextHop_IpInIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_IpInIp_DstIpPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip/state/dst-ip YANG schema element.
type NetworkInstance_Afts_NextHop_IpInIp_DstIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_IpInIp_DstIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip/state/dst-ip YANG schema element.
type NetworkInstance_Afts_NextHop_IpInIp_DstIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_IpInIp_SrcIpPath represents the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip/state/src-ip YANG schema element.
type NetworkInstance_Afts_NextHop_IpInIp_SrcIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_NextHop_IpInIp_SrcIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip/state/src-ip YANG schema element.
type NetworkInstance_Afts_NextHop_IpInIp_SrcIpPathAny struct {
	*ygot.NodePath
}

// DstIp (leaf): Destination IP address to use for the encapsulated packet.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dst-ip"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip/state/dst-ip"
func (n *NetworkInstance_Afts_NextHop_IpInIpPath) DstIp() *NetworkInstance_Afts_NextHop_IpInIp_DstIpPath {
	return &NetworkInstance_Afts_NextHop_IpInIp_DstIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dst-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// DstIp (leaf): Destination IP address to use for the encapsulated packet.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dst-ip"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip/state/dst-ip"
func (n *NetworkInstance_Afts_NextHop_IpInIpPathAny) DstIp() *NetworkInstance_Afts_NextHop_IpInIp_DstIpPathAny {
	return &NetworkInstance_Afts_NextHop_IpInIp_DstIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dst-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrcIp (leaf): Source IP address to use for the encapsulated packet.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/src-ip"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip/state/src-ip"
func (n *NetworkInstance_Afts_NextHop_IpInIpPath) SrcIp() *NetworkInstance_Afts_NextHop_IpInIp_SrcIpPath {
	return &NetworkInstance_Afts_NextHop_IpInIp_SrcIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "src-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrcIp (leaf): Source IP address to use for the encapsulated packet.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/src-ip"
// Path from root: "/network-instances/network-instance/afts/next-hops/next-hop/ip-in-ip/state/src-ip"
func (n *NetworkInstance_Afts_NextHop_IpInIpPathAny) SrcIp() *NetworkInstance_Afts_NextHop_IpInIp_SrcIpPathAny {
	return &NetworkInstance_Afts_NextHop_IpInIp_SrcIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "src-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Afts_PolicyForwardingEntryPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_EntryMetadataPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_EntryMetadataPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_EntryMetadataPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/entry-metadata YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_EntryMetadataPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/index YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/index YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_IpDscpPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-dscp YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_IpDscpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_IpDscpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-dscp YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_IpDscpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_IpPrefixPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-prefix YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_IpPrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_IpPrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-prefix YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_IpPrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_IpProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-protocol YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_IpProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_IpProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-protocol YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_IpProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_L4DstPortPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/l4-dst-port YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_L4DstPortPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_L4DstPortPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/l4-dst-port YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_L4DstPortPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_L4SrcPortPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/l4-src-port YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_L4SrcPortPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_L4SrcPortPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/l4-src-port YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_L4SrcPortPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_MacAddressPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mac-address YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_MacAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_MacAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mac-address YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_MacAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_MplsLabelPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mpls-label YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_MplsLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_MplsLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mpls-label YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_MplsLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_MplsTcPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mpls-tc YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_MplsTcPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_MplsTcPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mpls-tc YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_MplsTcPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/next-hop-group YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupNetworkInstancePath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupNetworkInstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupNetworkInstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/next-hop-group-network-instance YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupNetworkInstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_OctetsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_OctetsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_OctetsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/octets-forwarded YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_OctetsForwardedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_PacketsForwardedPath represents the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_PacketsForwardedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Afts_PolicyForwardingEntry_PacketsForwardedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/packets-forwarded YANG schema element.
type NetworkInstance_Afts_PolicyForwardingEntry_PacketsForwardedPathAny struct {
	*ygot.NodePath
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) EntryMetadata() *NetworkInstance_Afts_PolicyForwardingEntry_EntryMetadataPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_EntryMetadataPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryMetadata (leaf): Metadata persistently stored with the entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-metadata"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/entry-metadata"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) EntryMetadata() *NetworkInstance_Afts_PolicyForwardingEntry_EntryMetadataPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_EntryMetadataPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-metadata"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): An arbitrary 64-bit index identifying the policy forwarding
// AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/index"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) Index() *NetworkInstance_Afts_PolicyForwardingEntry_IndexPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): An arbitrary 64-bit index identifying the policy forwarding
// AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/index"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) Index() *NetworkInstance_Afts_PolicyForwardingEntry_IndexPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpDscp (leaf): The value of the differentiated services code point (DSCP) to
// be matched for the forwarding entry. The value is specified in
// cases where specific class-based forwarding based on IP is
// implemented by the device.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-dscp"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-dscp"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) IpDscp() *NetworkInstance_Afts_PolicyForwardingEntry_IpDscpPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_IpDscpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpDscp (leaf): The value of the differentiated services code point (DSCP) to
// be matched for the forwarding entry. The value is specified in
// cases where specific class-based forwarding based on IP is
// implemented by the device.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-dscp"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-dscp"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) IpDscp() *NetworkInstance_Afts_PolicyForwardingEntry_IpDscpPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_IpDscpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefix (leaf): The IP prefix that the forwarding entry matches.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-prefix"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) IpPrefix() *NetworkInstance_Afts_PolicyForwardingEntry_IpPrefixPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_IpPrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefix (leaf): The IP prefix that the forwarding entry matches.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-prefix"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) IpPrefix() *NetworkInstance_Afts_PolicyForwardingEntry_IpPrefixPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_IpPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpProtocol (leaf): The value of the IP protocol field of an IPv4 packet, or the
// next-header field of an IPv6 packet which is to be matched by
// the AFT entry. This field is utilised where forwarding is
// performed based on L4 information.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-protocol"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-protocol"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) IpProtocol() *NetworkInstance_Afts_PolicyForwardingEntry_IpProtocolPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_IpProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpProtocol (leaf): The value of the IP protocol field of an IPv4 packet, or the
// next-header field of an IPv6 packet which is to be matched by
// the AFT entry. This field is utilised where forwarding is
// performed based on L4 information.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-protocol"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/ip-protocol"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) IpProtocol() *NetworkInstance_Afts_PolicyForwardingEntry_IpProtocolPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_IpProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// L4DstPort (leaf): The value of the destination port field of the transport
// header that is to be matched by the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l4-dst-port"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/l4-dst-port"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) L4DstPort() *NetworkInstance_Afts_PolicyForwardingEntry_L4DstPortPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_L4DstPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l4-dst-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// L4DstPort (leaf): The value of the destination port field of the transport
// header that is to be matched by the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l4-dst-port"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/l4-dst-port"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) L4DstPort() *NetworkInstance_Afts_PolicyForwardingEntry_L4DstPortPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_L4DstPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l4-dst-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// L4SrcPort (leaf): The value of the source port field of the transport header
// that is to be matched by the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l4-src-port"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/l4-src-port"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) L4SrcPort() *NetworkInstance_Afts_PolicyForwardingEntry_L4SrcPortPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_L4SrcPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l4-src-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// L4SrcPort (leaf): The value of the source port field of the transport header
// that is to be matched by the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l4-src-port"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/l4-src-port"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) L4SrcPort() *NetworkInstance_Afts_PolicyForwardingEntry_L4SrcPortPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_L4SrcPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l4-src-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The MAC address that the forwarding entry matches. Used for
// Layer 2 forwarding entries, e.g., within a VSI instance.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mac-address"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) MacAddress() *NetworkInstance_Afts_PolicyForwardingEntry_MacAddressPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_MacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The MAC address that the forwarding entry matches. Used for
// Layer 2 forwarding entries, e.g., within a VSI instance.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mac-address"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) MacAddress() *NetworkInstance_Afts_PolicyForwardingEntry_MacAddressPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_MacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabel (leaf): The MPLS label that the forwarding entry matches. Used for
// MPLS forwarding entries, whereby the local device acts as an
// LSR.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-label"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mpls-label"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) MplsLabel() *NetworkInstance_Afts_PolicyForwardingEntry_MplsLabelPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_MplsLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabel (leaf): The MPLS label that the forwarding entry matches. Used for
// MPLS forwarding entries, whereby the local device acts as an
// LSR.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-label"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mpls-label"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) MplsLabel() *NetworkInstance_Afts_PolicyForwardingEntry_MplsLabelPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_MplsLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTc (leaf): The value of the MPLS Traffic Class bits (formerly known as
// the MPLS experimental bits) that are to be matched by the AFT
// entry.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-tc"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mpls-tc"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) MplsTc() *NetworkInstance_Afts_PolicyForwardingEntry_MplsTcPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_MplsTcPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-tc"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTc (leaf): The value of the MPLS Traffic Class bits (formerly known as
// the MPLS experimental bits) that are to be matched by the AFT
// entry.
// ----------------------------------------
// Defining module: "openconfig-aft-pf"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-tc"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/mpls-tc"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) MplsTc() *NetworkInstance_Afts_PolicyForwardingEntry_MplsTcPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_MplsTcPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-tc"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) NextHopGroup() *NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroup (leaf): A reference to the next-hop-group that is in use for the entry
// within the AFT. Traffic is distributed across the set of next-hops
// within the next-hop group according to the weight.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/next-hop-group"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) NextHopGroup() *NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) NextHopGroupNetworkInstance() *NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupNetworkInstancePath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupNetworkInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopGroupNetworkInstance (leaf): The network instance to look up the next-hop-group in.  If
// unspecified, the next hop group is in the local network
// instance.  The referenced network-instance must be an existing
// network instance on the device and have corresponding entries
// in the /network-instances/network-instance list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop-group-network-instance"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/next-hop-group-network-instance"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) NextHopGroupNetworkInstance() *NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupNetworkInstancePathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_NextHopGroupNetworkInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop-group-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) OctetsForwarded() *NetworkInstance_Afts_PolicyForwardingEntry_OctetsForwardedPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_OctetsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// OctetsForwarded (leaf): The number of octets which have matched, and been forwarded,
// based on the AFT entry
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/octets-forwarded"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/octets-forwarded"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) OctetsForwarded() *NetworkInstance_Afts_PolicyForwardingEntry_OctetsForwardedPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_OctetsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "octets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPath) PacketsForwarded() *NetworkInstance_Afts_PolicyForwardingEntry_PacketsForwardedPath {
	return &NetworkInstance_Afts_PolicyForwardingEntry_PacketsForwardedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketsForwarded (leaf): The number of packets which have matched, and been forwarded,
// based on the AFT entry.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/packets-forwarded"
// Path from root: "/network-instances/network-instance/afts/policy-forwarding/policy-forwarding-entry/state/packets-forwarded"
func (n *NetworkInstance_Afts_PolicyForwardingEntryPathAny) PacketsForwarded() *NetworkInstance_Afts_PolicyForwardingEntry_PacketsForwardedPathAny {
	return &NetworkInstance_Afts_PolicyForwardingEntry_PacketsForwardedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "packets-forwarded"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_ConnectionPointPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point YANG schema element.
type NetworkInstance_ConnectionPointPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point YANG schema element.
type NetworkInstance_ConnectionPointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_ConnectionPointIdPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/config/connection-point-id YANG schema element.
type NetworkInstance_ConnectionPoint_ConnectionPointIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_ConnectionPointIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/config/connection-point-id YANG schema element.
type NetworkInstance_ConnectionPoint_ConnectionPointIdPathAny struct {
	*ygot.NodePath
}

// ConnectionPointId (leaf): An identifier for a connection point
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/connection-point-id"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/config/connection-point-id"
func (n *NetworkInstance_ConnectionPointPath) ConnectionPointId() *NetworkInstance_ConnectionPoint_ConnectionPointIdPath {
	return &NetworkInstance_ConnectionPoint_ConnectionPointIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "connection-point-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionPointId (leaf): An identifier for a connection point
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/connection-point-id"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/config/connection-point-id"
func (n *NetworkInstance_ConnectionPointPathAny) ConnectionPointId() *NetworkInstance_ConnectionPoint_ConnectionPointIdPathAny {
	return &NetworkInstance_ConnectionPoint_ConnectionPointIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "connection-point-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// EndpointAny (list): A list of the endpoints (interfaces or remote
// connection points that can be used for this
// connection point). The active endpoint is selected
// based on the precedence that it is configured
// with
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoints/endpoint"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint"
// EndpointId (wildcarded): string
func (n *NetworkInstance_ConnectionPointPath) EndpointAny() *NetworkInstance_ConnectionPoint_EndpointPathAny {
	return &NetworkInstance_ConnectionPoint_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"endpoints", "endpoint"},
			map[string]interface{}{"endpoint-id": "*"},
			n,
		),
	}
}

// EndpointAny (list): A list of the endpoints (interfaces or remote
// connection points that can be used for this
// connection point). The active endpoint is selected
// based on the precedence that it is configured
// with
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoints/endpoint"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint"
// EndpointId (wildcarded): string
func (n *NetworkInstance_ConnectionPointPathAny) EndpointAny() *NetworkInstance_ConnectionPoint_EndpointPathAny {
	return &NetworkInstance_ConnectionPoint_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"endpoints", "endpoint"},
			map[string]interface{}{"endpoint-id": "*"},
			n,
		),
	}
}

// Endpoint (list): A list of the endpoints (interfaces or remote
// connection points that can be used for this
// connection point). The active endpoint is selected
// based on the precedence that it is configured
// with
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoints/endpoint"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint"
// EndpointId: string
func (n *NetworkInstance_ConnectionPointPath) Endpoint(EndpointId string) *NetworkInstance_ConnectionPoint_EndpointPath {
	return &NetworkInstance_ConnectionPoint_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"endpoints", "endpoint"},
			map[string]interface{}{"endpoint-id": EndpointId},
			n,
		),
	}
}

// Endpoint (list): A list of the endpoints (interfaces or remote
// connection points that can be used for this
// connection point). The active endpoint is selected
// based on the precedence that it is configured
// with
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoints/endpoint"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint"
// EndpointId: string
func (n *NetworkInstance_ConnectionPointPathAny) Endpoint(EndpointId string) *NetworkInstance_ConnectionPoint_EndpointPathAny {
	return &NetworkInstance_ConnectionPoint_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"endpoints", "endpoint"},
			map[string]interface{}{"endpoint-id": EndpointId},
			n,
		),
	}
}

// NetworkInstance_ConnectionPoint_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint YANG schema element.
type NetworkInstance_ConnectionPoint_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint YANG schema element.
type NetworkInstance_ConnectionPoint_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_ActivePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/state/active YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_ActivePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_ActivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/state/active YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_ActivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_EndpointIdPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/endpoint-id YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_EndpointIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_EndpointIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/endpoint-id YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_EndpointIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_PrecedencePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/precedence YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_PrecedencePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_PrecedencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/precedence YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_PrecedencePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_TypePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/type YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/type YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_TypePathAny struct {
	*ygot.NodePath
}

// Active (leaf): When the backup endpoint is active, the value of this
// parameter is set to true
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/state/active"
func (n *NetworkInstance_ConnectionPoint_EndpointPath) Active() *NetworkInstance_ConnectionPoint_Endpoint_ActivePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_ActivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// Active (leaf): When the backup endpoint is active, the value of this
// parameter is set to true
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/state/active"
func (n *NetworkInstance_ConnectionPoint_EndpointPathAny) Active() *NetworkInstance_ConnectionPoint_Endpoint_ActivePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_ActivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// EndpointId (leaf): An identifier for the endpoint
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/endpoint-id"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/endpoint-id"
func (n *NetworkInstance_ConnectionPoint_EndpointPath) EndpointId() *NetworkInstance_ConnectionPoint_Endpoint_EndpointIdPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_EndpointIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "endpoint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// EndpointId (leaf): An identifier for the endpoint
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/endpoint-id"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/endpoint-id"
func (n *NetworkInstance_ConnectionPoint_EndpointPathAny) EndpointId() *NetworkInstance_ConnectionPoint_Endpoint_EndpointIdPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_EndpointIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "endpoint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Local (container): Configuration and operational state parameters
// relating to a local interface
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "local"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local"
func (n *NetworkInstance_ConnectionPoint_EndpointPath) Local() *NetworkInstance_ConnectionPoint_Endpoint_LocalPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_LocalPath{
		NodePath: ygot.NewNodePath(
			[]string{"local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Local (container): Configuration and operational state parameters
// relating to a local interface
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "local"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local"
func (n *NetworkInstance_ConnectionPoint_EndpointPathAny) Local() *NetworkInstance_ConnectionPoint_Endpoint_LocalPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_LocalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Precedence (leaf): The precedence of the endpoint - the lowest precendence
// viable endpoint will be utilised as the active endpoint
// within a connection
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/precedence"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/precedence"
func (n *NetworkInstance_ConnectionPoint_EndpointPath) Precedence() *NetworkInstance_ConnectionPoint_Endpoint_PrecedencePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_PrecedencePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "precedence"},
			map[string]interface{}{},
			n,
		),
	}
}

// Precedence (leaf): The precedence of the endpoint - the lowest precendence
// viable endpoint will be utilised as the active endpoint
// within a connection
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/precedence"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/precedence"
func (n *NetworkInstance_ConnectionPoint_EndpointPathAny) Precedence() *NetworkInstance_ConnectionPoint_Endpoint_PrecedencePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_PrecedencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "precedence"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (container): Configuration and operational state parameters
// relating to a remote interface
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "remote"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote"
func (n *NetworkInstance_ConnectionPoint_EndpointPath) Remote() *NetworkInstance_ConnectionPoint_Endpoint_RemotePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_RemotePath{
		NodePath: ygot.NewNodePath(
			[]string{"remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (container): Configuration and operational state parameters
// relating to a remote interface
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "remote"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote"
func (n *NetworkInstance_ConnectionPoint_EndpointPathAny) Remote() *NetworkInstance_ConnectionPoint_Endpoint_RemotePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_RemotePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of endpoint that is referred to by the current
// endpoint
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/type"
func (n *NetworkInstance_ConnectionPoint_EndpointPath) Type() *NetworkInstance_ConnectionPoint_Endpoint_TypePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of endpoint that is referred to by the current
// endpoint
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/config/type"
func (n *NetworkInstance_ConnectionPoint_EndpointPathAny) Type() *NetworkInstance_ConnectionPoint_Endpoint_TypePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vxlan (container): Configuration and operational state parameters
// relating to a VXLAN tunnel end-point interface
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "vxlan"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan"
func (n *NetworkInstance_ConnectionPoint_EndpointPath) Vxlan() *NetworkInstance_ConnectionPoint_Endpoint_VxlanPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_VxlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"vxlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vxlan (container): Configuration and operational state parameters
// relating to a VXLAN tunnel end-point interface
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "vxlan"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan"
func (n *NetworkInstance_ConnectionPoint_EndpointPathAny) Vxlan() *NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vxlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_ConnectionPoint_Endpoint_LocalPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_LocalPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_LocalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_LocalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/interface YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/interface YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_SiteIdPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-id YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_SiteIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_SiteIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-id YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_SiteIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockOffsetPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-label-block-offset YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockOffsetPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockOffsetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-label-block-offset YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockOffsetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockSizePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-label-block-size YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockSizePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockSizePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-label-block-size YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockSizePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/subinterface YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Local_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/subinterface YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Local_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/interface"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPath) Interface() *NetworkInstance_ConnectionPoint_Endpoint_Local_InterfacePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/interface"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPathAny) Interface() *NetworkInstance_ConnectionPoint_Endpoint_Local_InterfacePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// SiteId (leaf): The VE ID as defined in RFC4761 (VPLS) or CE ID as defined in
// RFC6624 (l2vpn) to uniquely identify this endpoint (site) as part
// of the BGP discovery of remote endpoints for layer 2 services.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/site-id"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-id"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPath) SiteId() *NetworkInstance_ConnectionPoint_Endpoint_Local_SiteIdPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_SiteIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "site-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SiteId (leaf): The VE ID as defined in RFC4761 (VPLS) or CE ID as defined in
// RFC6624 (l2vpn) to uniquely identify this endpoint (site) as part
// of the BGP discovery of remote endpoints for layer 2 services.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/site-id"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-id"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPathAny) SiteId() *NetworkInstance_ConnectionPoint_Endpoint_Local_SiteIdPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_SiteIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "site-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SiteLabelBlockOffset (leaf): The VPLS label block offset that is signaled with the 'site-id'.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/site-label-block-offset"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-label-block-offset"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPath) SiteLabelBlockOffset() *NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockOffsetPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockOffsetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "site-label-block-offset"},
			map[string]interface{}{},
			n,
		),
	}
}

// SiteLabelBlockOffset (leaf): The VPLS label block offset that is signaled with the 'site-id'.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/site-label-block-offset"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-label-block-offset"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPathAny) SiteLabelBlockOffset() *NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockOffsetPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockOffsetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "site-label-block-offset"},
			map[string]interface{}{},
			n,
		),
	}
}

// SiteLabelBlockSize (leaf): The VPLS label block size that is signaled with the 'site-id'.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/site-label-block-size"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-label-block-size"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPath) SiteLabelBlockSize() *NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockSizePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockSizePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "site-label-block-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// SiteLabelBlockSize (leaf): The VPLS label block size that is signaled with the 'site-id'.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/site-label-block-size"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/site-label-block-size"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPathAny) SiteLabelBlockSize() *NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockSizePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_SiteLabelBlockSizePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "site-label-block-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/subinterface"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPath) Subinterface() *NetworkInstance_ConnectionPoint_Endpoint_Local_SubinterfacePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/local/config/subinterface"
func (n *NetworkInstance_ConnectionPoint_Endpoint_LocalPathAny) Subinterface() *NetworkInstance_ConnectionPoint_Endpoint_Local_SubinterfacePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Local_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_ConnectionPoint_Endpoint_RemotePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_RemotePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_RemotePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_RemotePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Remote_RemoteSystemPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/remote-system YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Remote_RemoteSystemPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Remote_RemoteSystemPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/remote-system YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Remote_RemoteSystemPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Remote_SiteIdPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/site-id YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Remote_SiteIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Remote_SiteIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/site-id YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Remote_SiteIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Remote_VirtualCircuitIdentifierPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/virtual-circuit-identifier YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Remote_VirtualCircuitIdentifierPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Remote_VirtualCircuitIdentifierPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/virtual-circuit-identifier YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Remote_VirtualCircuitIdentifierPathAny struct {
	*ygot.NodePath
}

// RemoteSystem (leaf): The IP address of the device which hosts the
// remote end-point
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remote-system"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/remote-system"
func (n *NetworkInstance_ConnectionPoint_Endpoint_RemotePath) RemoteSystem() *NetworkInstance_ConnectionPoint_Endpoint_Remote_RemoteSystemPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Remote_RemoteSystemPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-system"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteSystem (leaf): The IP address of the device which hosts the
// remote end-point
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remote-system"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/remote-system"
func (n *NetworkInstance_ConnectionPoint_Endpoint_RemotePathAny) RemoteSystem() *NetworkInstance_ConnectionPoint_Endpoint_Remote_RemoteSystemPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Remote_RemoteSystemPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-system"},
			map[string]interface{}{},
			n,
		),
	}
}

// SiteId (leaf): Identifies remote sites. When BGP discovery is used this
// is the customer edge identifier
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/site-id"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/site-id"
func (n *NetworkInstance_ConnectionPoint_Endpoint_RemotePath) SiteId() *NetworkInstance_ConnectionPoint_Endpoint_Remote_SiteIdPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Remote_SiteIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "site-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SiteId (leaf): Identifies remote sites. When BGP discovery is used this
// is the customer edge identifier
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/site-id"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/site-id"
func (n *NetworkInstance_ConnectionPoint_Endpoint_RemotePathAny) SiteId() *NetworkInstance_ConnectionPoint_Endpoint_Remote_SiteIdPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Remote_SiteIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "site-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualCircuitIdentifier (leaf): The virtual-circuit identifier that identifies the
// connection at the remote end-point
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/virtual-circuit-identifier"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/virtual-circuit-identifier"
func (n *NetworkInstance_ConnectionPoint_Endpoint_RemotePath) VirtualCircuitIdentifier() *NetworkInstance_ConnectionPoint_Endpoint_Remote_VirtualCircuitIdentifierPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Remote_VirtualCircuitIdentifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-circuit-identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualCircuitIdentifier (leaf): The virtual-circuit identifier that identifies the
// connection at the remote end-point
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/virtual-circuit-identifier"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/remote/config/virtual-circuit-identifier"
func (n *NetworkInstance_ConnectionPoint_Endpoint_RemotePathAny) VirtualCircuitIdentifier() *NetworkInstance_ConnectionPoint_Endpoint_Remote_VirtualCircuitIdentifierPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Remote_VirtualCircuitIdentifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "virtual-circuit-identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_ConnectionPoint_Endpoint_VxlanPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_VxlanPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_DescriptionPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/description YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_DescriptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_DescriptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/description YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_DescriptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/enabled YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/enabled YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_SourceInterfacePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/source-interface YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_SourceInterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_SourceInterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/source-interface YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_SourceInterfacePathAny struct {
	*ygot.NodePath
}

// Description (leaf): Description to identify the VXLAN tunnel endpoint It
// is a unique name identifying the overlay endpoint
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/description"
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPath) Description() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_DescriptionPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): Description to identify the VXLAN tunnel endpoint It
// is a unique name identifying the overlay endpoint
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/description"
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny) Description() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_DescriptionPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): VXLAN tunnel endpoint administrative state.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/enabled"
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPath) Enabled() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EnabledPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): VXLAN tunnel endpoint administrative state.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/enabled"
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny) Enabled() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EnabledPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// EndpointPeerAny (list): List of VTEP peers and associated state information
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoint-peers/endpoint-peer"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer"
// PeerAddress (wildcarded): string
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPath) EndpointPeerAny() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"endpoint-peers", "endpoint-peer"},
			map[string]interface{}{"peer-address": "*"},
			n,
		),
	}
}

// EndpointPeerAny (list): List of VTEP peers and associated state information
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoint-peers/endpoint-peer"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer"
// PeerAddress (wildcarded): string
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny) EndpointPeerAny() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"endpoint-peers", "endpoint-peer"},
			map[string]interface{}{"peer-address": "*"},
			n,
		),
	}
}

// EndpointPeer (list): List of VTEP peers and associated state information
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoint-peers/endpoint-peer"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer"
// PeerAddress: string
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPath) EndpointPeer(PeerAddress string) *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPath{
		NodePath: ygot.NewNodePath(
			[]string{"endpoint-peers", "endpoint-peer"},
			map[string]interface{}{"peer-address": PeerAddress},
			n,
		),
	}
}

// EndpointPeer (list): List of VTEP peers and associated state information
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoint-peers/endpoint-peer"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer"
// PeerAddress: string
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny) EndpointPeer(PeerAddress string) *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"endpoint-peers", "endpoint-peer"},
			map[string]interface{}{"peer-address": PeerAddress},
			n,
		),
	}
}

// EndpointVniAny (list): List of L2VNIs and L3VNIs learned on the local VTEP
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoint-vnis/endpoint-vni"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni"
// Vni (wildcarded): uint32
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPath) EndpointVniAny() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"endpoint-vnis", "endpoint-vni"},
			map[string]interface{}{"vni": "*"},
			n,
		),
	}
}

// EndpointVniAny (list): List of L2VNIs and L3VNIs learned on the local VTEP
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoint-vnis/endpoint-vni"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni"
// Vni (wildcarded): uint32
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny) EndpointVniAny() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"endpoint-vnis", "endpoint-vni"},
			map[string]interface{}{"vni": "*"},
			n,
		),
	}
}

// EndpointVni (list): List of L2VNIs and L3VNIs learned on the local VTEP
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoint-vnis/endpoint-vni"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni"
// Vni: uint32
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPath) EndpointVni(Vni uint32) *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath{
		NodePath: ygot.NewNodePath(
			[]string{"endpoint-vnis", "endpoint-vni"},
			map[string]interface{}{"vni": Vni},
			n,
		),
	}
}

// EndpointVni (list): List of L2VNIs and L3VNIs learned on the local VTEP
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "endpoint-vnis/endpoint-vni"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni"
// Vni: uint32
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny) EndpointVni(Vni uint32) *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"endpoint-vnis", "endpoint-vni"},
			map[string]interface{}{"vni": Vni},
			n,
		),
	}
}

// SourceInterface (leaf): Source loopback interface name
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-interface"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/source-interface"
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPath) SourceInterface() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_SourceInterfacePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_SourceInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceInterface (leaf): Source loopback interface name
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-interface"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/config/source-interface"
func (n *NetworkInstance_ConnectionPoint_Endpoint_VxlanPathAny) SourceInterface() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_SourceInterfacePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_SourceInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_ControlPlaneVnisPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/control-plane-vnis YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_ControlPlaneVnisPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_ControlPlaneVnisPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/control-plane-vnis YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_ControlPlaneVnisPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerAddressPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/peer-address YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/peer-address YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerStatePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/peer-state YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/peer-state YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerStatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_RouterMacPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/router-mac YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_RouterMacPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_RouterMacPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/router-mac YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_RouterMacPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_UptimePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/uptime YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_UptimePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_UptimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/uptime YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_UptimePathAny struct {
	*ygot.NodePath
}

// ControlPlaneVnis (leaf): The control-plane VNIs are all of the VNIs that are discovered by the
// control-plane behind this peer VTEP
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/control-plane-vnis"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/control-plane-vnis"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPath) ControlPlaneVnis() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_ControlPlaneVnisPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_ControlPlaneVnisPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "control-plane-vnis"},
			map[string]interface{}{},
			n,
		),
	}
}

// ControlPlaneVnis (leaf): The control-plane VNIs are all of the VNIs that are discovered by the
// control-plane behind this peer VTEP
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/control-plane-vnis"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/control-plane-vnis"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny) ControlPlaneVnis() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_ControlPlaneVnisPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_ControlPlaneVnisPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "control-plane-vnis"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerAddress (leaf): IP address of the remote VXLAN Tunnel Endpoint peer
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-address"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/peer-address"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPath) PeerAddress() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerAddressPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerAddress (leaf): IP address of the remote VXLAN Tunnel Endpoint peer
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-address"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/peer-address"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny) PeerAddress() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerAddressPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerState (leaf): State parameters related to the remote VTEP peer state
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-state"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/peer-state"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPath) PeerState() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerStatePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerState (leaf): State parameters related to the remote VTEP peer state
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-state"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/peer-state"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny) PeerState() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerStatePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_PeerStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterMac (leaf): MAC address of the remote VTEP
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-mac"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/router-mac"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPath) RouterMac() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_RouterMacPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_RouterMacPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterMac (leaf): MAC address of the remote VTEP
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-mac"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/router-mac"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny) RouterMac() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_RouterMacPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_RouterMacPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// Uptime (leaf): This timestamp indicates the time elapsed relative to the moment that
// the remote VTEP peer was discovered.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/uptime"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/uptime"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPath) Uptime() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_UptimePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_UptimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "uptime"},
			map[string]interface{}{},
			n,
		),
	}
}

// Uptime (leaf): This timestamp indicates the time elapsed relative to the moment that
// the remote VTEP peer was discovered.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/uptime"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-peers/endpoint-peer/state/uptime"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeerPathAny) Uptime() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_UptimePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointPeer_UptimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "uptime"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_BridgeDomainPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/bridge-domain YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_BridgeDomainPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_BridgeDomainPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/bridge-domain YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_BridgeDomainPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_L3VrfNamePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/l3-vrf-name YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_L3VrfNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_L3VrfNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/l3-vrf-name YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_L3VrfNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_LearningModePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/learning-mode YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_LearningModePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_LearningModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/learning-mode YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_LearningModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_MultidestinationTrafficPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/multidestination-traffic YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_MultidestinationTrafficPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_MultidestinationTrafficPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/multidestination-traffic YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_MultidestinationTrafficPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_SviStatePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/svi-state YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_SviStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_SviStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/svi-state YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_SviStatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniPath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniPath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniStatePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni-state YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni-state YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniStatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniTypePath represents the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni-type YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni-type YANG schema element.
type NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniTypePathAny struct {
	*ygot.NodePath
}

// BridgeDomain (leaf): This reflects the configured VLAN or Bridge Domain that maps to this
// L2VNI in the VXLAN fabric
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bridge-domain"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/bridge-domain"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath) BridgeDomain() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_BridgeDomainPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_BridgeDomainPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bridge-domain"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgeDomain (leaf): This reflects the configured VLAN or Bridge Domain that maps to this
// L2VNI in the VXLAN fabric
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bridge-domain"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/bridge-domain"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny) BridgeDomain() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_BridgeDomainPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_BridgeDomainPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bridge-domain"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VrfName (leaf): This refects the configured VRF instance that maps to this L3VNI
// that is used for routing between subnets in the VXLAN fabric
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l3-vrf-name"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/l3-vrf-name"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath) L3VrfName() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_L3VrfNamePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_L3VrfNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l3-vrf-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VrfName (leaf): This refects the configured VRF instance that maps to this L3VNI
// that is used for routing between subnets in the VXLAN fabric
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l3-vrf-name"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/l3-vrf-name"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny) L3VrfName() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_L3VrfNamePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_L3VrfNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l3-vrf-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// LearningMode (leaf): Indicates whether the learning mode for this VNI is either
// control-plane or data-plane
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/learning-mode"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/learning-mode"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath) LearningMode() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_LearningModePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_LearningModePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "learning-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// LearningMode (leaf): Indicates whether the learning mode for this VNI is either
// control-plane or data-plane
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/learning-mode"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/learning-mode"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny) LearningMode() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_LearningModePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_LearningModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "learning-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultidestinationTraffic (leaf): The data plane for overlays needs to handle the transport of
// multidestination traffic. Multidestination traffic is typically
// referred to as (BUM) which stands for broadcast, unknown unicast,
// or multicast. The two most common methods that can accommodate this
// replication and transport in the underlay are IP multicast and
// ingress replication
// (also called head-end replication or unicast mode).
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multidestination-traffic"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/multidestination-traffic"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath) MultidestinationTraffic() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_MultidestinationTrafficPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_MultidestinationTrafficPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multidestination-traffic"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultidestinationTraffic (leaf): The data plane for overlays needs to handle the transport of
// multidestination traffic. Multidestination traffic is typically
// referred to as (BUM) which stands for broadcast, unknown unicast,
// or multicast. The two most common methods that can accommodate this
// replication and transport in the underlay are IP multicast and
// ingress replication
// (also called head-end replication or unicast mode).
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multidestination-traffic"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/multidestination-traffic"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny) MultidestinationTraffic() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_MultidestinationTrafficPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_MultidestinationTrafficPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multidestination-traffic"},
			map[string]interface{}{},
			n,
		),
	}
}

// SviState (leaf): Operational status of the SVI mapped to the L3VNI that is used for
// routing between subnets in the VXLAN fabric
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/svi-state"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/svi-state"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath) SviState() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_SviStatePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_SviStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "svi-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// SviState (leaf): Operational status of the SVI mapped to the L3VNI that is used for
// routing between subnets in the VXLAN fabric
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/svi-state"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/svi-state"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny) SviState() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_SviStatePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_SviStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "svi-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vni (leaf): L2VNI or L3VNI Identifier
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vni"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath) Vni() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniPath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vni (leaf): L2VNI or L3VNI Identifier
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vni"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny) Vni() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniPathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// VniState (leaf): Operational state of the L2VNI or L3VNI
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vni-state"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni-state"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath) VniState() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniStatePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vni-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// VniState (leaf): Operational state of the L2VNI or L3VNI
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vni-state"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni-state"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny) VniState() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniStatePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vni-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// VniType (leaf): The type of virtual network identfier
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vni-type"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni-type"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPath) VniType() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniTypePath {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vni-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// VniType (leaf): The type of virtual network identfier
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vni-type"
// Path from root: "/network-instances/network-instance/connection-points/connection-point/endpoints/endpoint/vxlan/endpoint-vnis/endpoint-vni/state/vni-type"
func (n *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVniPathAny) VniType() *NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniTypePathAny {
	return &NetworkInstance_ConnectionPoint_Endpoint_Vxlan_EndpointVni_VniTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vni-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_EncapsulationPath represents the /openconfig-network-instance/network-instances/network-instance/encapsulation YANG schema element.
type NetworkInstance_EncapsulationPath struct {
	*ygot.NodePath
}

// NetworkInstance_EncapsulationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/encapsulation YANG schema element.
type NetworkInstance_EncapsulationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Encapsulation_ControlWordPath represents the /openconfig-network-instance/network-instances/network-instance/encapsulation/config/control-word YANG schema element.
type NetworkInstance_Encapsulation_ControlWordPath struct {
	*ygot.NodePath
}

// NetworkInstance_Encapsulation_ControlWordPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/encapsulation/config/control-word YANG schema element.
type NetworkInstance_Encapsulation_ControlWordPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Encapsulation_EncapsulationTypePath represents the /openconfig-network-instance/network-instances/network-instance/encapsulation/config/encapsulation-type YANG schema element.
type NetworkInstance_Encapsulation_EncapsulationTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Encapsulation_EncapsulationTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/encapsulation/config/encapsulation-type YANG schema element.
type NetworkInstance_Encapsulation_EncapsulationTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Encapsulation_LabelAllocationModePath represents the /openconfig-network-instance/network-instances/network-instance/encapsulation/config/label-allocation-mode YANG schema element.
type NetworkInstance_Encapsulation_LabelAllocationModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Encapsulation_LabelAllocationModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/encapsulation/config/label-allocation-mode YANG schema element.
type NetworkInstance_Encapsulation_LabelAllocationModePathAny struct {
	*ygot.NodePath
}

// ControlWord (leaf): Whether the control-word should be used for the network
// instance
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/control-word"
// Path from root: "/network-instances/network-instance/encapsulation/config/control-word"
func (n *NetworkInstance_EncapsulationPath) ControlWord() *NetworkInstance_Encapsulation_ControlWordPath {
	return &NetworkInstance_Encapsulation_ControlWordPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "control-word"},
			map[string]interface{}{},
			n,
		),
	}
}

// ControlWord (leaf): Whether the control-word should be used for the network
// instance
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/control-word"
// Path from root: "/network-instances/network-instance/encapsulation/config/control-word"
func (n *NetworkInstance_EncapsulationPathAny) ControlWord() *NetworkInstance_Encapsulation_ControlWordPathAny {
	return &NetworkInstance_Encapsulation_ControlWordPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "control-word"},
			map[string]interface{}{},
			n,
		),
	}
}

// EncapsulationType (leaf): The on-the-wire encapsulation that should be used when
// sending traffic from this network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/encapsulation-type"
// Path from root: "/network-instances/network-instance/encapsulation/config/encapsulation-type"
func (n *NetworkInstance_EncapsulationPath) EncapsulationType() *NetworkInstance_Encapsulation_EncapsulationTypePath {
	return &NetworkInstance_Encapsulation_EncapsulationTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "encapsulation-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// EncapsulationType (leaf): The on-the-wire encapsulation that should be used when
// sending traffic from this network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/encapsulation-type"
// Path from root: "/network-instances/network-instance/encapsulation/config/encapsulation-type"
func (n *NetworkInstance_EncapsulationPathAny) EncapsulationType() *NetworkInstance_Encapsulation_EncapsulationTypePathAny {
	return &NetworkInstance_Encapsulation_EncapsulationTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "encapsulation-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LabelAllocationMode (leaf): The label allocation mode to be used for L3 entries
// in the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/label-allocation-mode"
// Path from root: "/network-instances/network-instance/encapsulation/config/label-allocation-mode"
func (n *NetworkInstance_EncapsulationPath) LabelAllocationMode() *NetworkInstance_Encapsulation_LabelAllocationModePath {
	return &NetworkInstance_Encapsulation_LabelAllocationModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "label-allocation-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// LabelAllocationMode (leaf): The label allocation mode to be used for L3 entries
// in the network instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/label-allocation-mode"
// Path from root: "/network-instances/network-instance/encapsulation/config/label-allocation-mode"
func (n *NetworkInstance_EncapsulationPathAny) LabelAllocationMode() *NetworkInstance_Encapsulation_LabelAllocationModePathAny {
	return &NetworkInstance_Encapsulation_LabelAllocationModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "label-allocation-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_EvpnPath represents the /openconfig-network-instance/network-instances/network-instance/evpn YANG schema element.
type NetworkInstance_EvpnPath struct {
	*ygot.NodePath
}

// NetworkInstance_EvpnPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn YANG schema element.
type NetworkInstance_EvpnPathAny struct {
	*ygot.NodePath
}

// EthernetSegmentAny (list): List of Ethernet Segments.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ethernet-segments/ethernet-segment"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment"
// Name (wildcarded): string
func (n *NetworkInstance_EvpnPath) EthernetSegmentAny() *NetworkInstance_Evpn_EthernetSegmentPathAny {
	return &NetworkInstance_Evpn_EthernetSegmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet-segments", "ethernet-segment"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// EthernetSegmentAny (list): List of Ethernet Segments.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ethernet-segments/ethernet-segment"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment"
// Name (wildcarded): string
func (n *NetworkInstance_EvpnPathAny) EthernetSegmentAny() *NetworkInstance_Evpn_EthernetSegmentPathAny {
	return &NetworkInstance_Evpn_EthernetSegmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet-segments", "ethernet-segment"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// EthernetSegment (list): List of Ethernet Segments.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ethernet-segments/ethernet-segment"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment"
// Name: string
func (n *NetworkInstance_EvpnPath) EthernetSegment(Name string) *NetworkInstance_Evpn_EthernetSegmentPath {
	return &NetworkInstance_Evpn_EthernetSegmentPath{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet-segments", "ethernet-segment"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// EthernetSegment (list): List of Ethernet Segments.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ethernet-segments/ethernet-segment"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment"
// Name: string
func (n *NetworkInstance_EvpnPathAny) EthernetSegment(Name string) *NetworkInstance_Evpn_EthernetSegmentPathAny {
	return &NetworkInstance_Evpn_EthernetSegmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet-segments", "ethernet-segment"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// EvpnInstanceAny (list): An EVPN instance (EVI) comprises Customer Edge devices
// (CEs) that are connected to Provider Edge devices (PEs). One
// network instance (representing a single MAC VRF) can
// participate in one or more EVPN Instances. For each EVPN instance
// in which the forwarding instance participates an
// EVPN instance needs to be created.
//
// The model supports BGP MPLS-Based Ethernet VPNs
// (RFC 7432) and  Network Virtualization Overlay Solution
// Using Ethernet VPN (RFC 8365). The use of MPLS or VXLAN
// is selected via the encapsulation container within
// EVPN instance. One use case requiring participating in
// two EVIs is the Interconnect Solution for EVPN Overlay
// networks (see draft-ietf-bess-dci-evpn-overlay-10)
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "evpn-instances/evpn-instance"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance"
// Evi (wildcarded): string
func (n *NetworkInstance_EvpnPath) EvpnInstanceAny() *NetworkInstance_Evpn_EvpnInstancePathAny {
	return &NetworkInstance_Evpn_EvpnInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"evpn-instances", "evpn-instance"},
			map[string]interface{}{"evi": "*"},
			n,
		),
	}
}

// EvpnInstanceAny (list): An EVPN instance (EVI) comprises Customer Edge devices
// (CEs) that are connected to Provider Edge devices (PEs). One
// network instance (representing a single MAC VRF) can
// participate in one or more EVPN Instances. For each EVPN instance
// in which the forwarding instance participates an
// EVPN instance needs to be created.
//
// The model supports BGP MPLS-Based Ethernet VPNs
// (RFC 7432) and  Network Virtualization Overlay Solution
// Using Ethernet VPN (RFC 8365). The use of MPLS or VXLAN
// is selected via the encapsulation container within
// EVPN instance. One use case requiring participating in
// two EVIs is the Interconnect Solution for EVPN Overlay
// networks (see draft-ietf-bess-dci-evpn-overlay-10)
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "evpn-instances/evpn-instance"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance"
// Evi (wildcarded): string
func (n *NetworkInstance_EvpnPathAny) EvpnInstanceAny() *NetworkInstance_Evpn_EvpnInstancePathAny {
	return &NetworkInstance_Evpn_EvpnInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"evpn-instances", "evpn-instance"},
			map[string]interface{}{"evi": "*"},
			n,
		),
	}
}

// EvpnInstance (list): An EVPN instance (EVI) comprises Customer Edge devices
// (CEs) that are connected to Provider Edge devices (PEs). One
// network instance (representing a single MAC VRF) can
// participate in one or more EVPN Instances. For each EVPN instance
// in which the forwarding instance participates an
// EVPN instance needs to be created.
//
// The model supports BGP MPLS-Based Ethernet VPNs
// (RFC 7432) and  Network Virtualization Overlay Solution
// Using Ethernet VPN (RFC 8365). The use of MPLS or VXLAN
// is selected via the encapsulation container within
// EVPN instance. One use case requiring participating in
// two EVIs is the Interconnect Solution for EVPN Overlay
// networks (see draft-ietf-bess-dci-evpn-overlay-10)
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "evpn-instances/evpn-instance"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance"
// Evi: string
func (n *NetworkInstance_EvpnPath) EvpnInstance(Evi string) *NetworkInstance_Evpn_EvpnInstancePath {
	return &NetworkInstance_Evpn_EvpnInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"evpn-instances", "evpn-instance"},
			map[string]interface{}{"evi": Evi},
			n,
		),
	}
}

// EvpnInstance (list): An EVPN instance (EVI) comprises Customer Edge devices
// (CEs) that are connected to Provider Edge devices (PEs). One
// network instance (representing a single MAC VRF) can
// participate in one or more EVPN Instances. For each EVPN instance
// in which the forwarding instance participates an
// EVPN instance needs to be created.
//
// The model supports BGP MPLS-Based Ethernet VPNs
// (RFC 7432) and  Network Virtualization Overlay Solution
// Using Ethernet VPN (RFC 8365). The use of MPLS or VXLAN
// is selected via the encapsulation container within
// EVPN instance. One use case requiring participating in
// two EVIs is the Interconnect Solution for EVPN Overlay
// networks (see draft-ietf-bess-dci-evpn-overlay-10)
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "evpn-instances/evpn-instance"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance"
// Evi: string
func (n *NetworkInstance_EvpnPathAny) EvpnInstance(Evi string) *NetworkInstance_Evpn_EvpnInstancePathAny {
	return &NetworkInstance_Evpn_EvpnInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"evpn-instances", "evpn-instance"},
			map[string]interface{}{"evi": Evi},
			n,
		),
	}
}

// NetworkInstance_Evpn_EthernetSegmentPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment YANG schema element.
type NetworkInstance_Evpn_EthernetSegmentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegmentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment YANG schema element.
type NetworkInstance_Evpn_EthernetSegmentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_EsiPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/esi YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_EsiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_EsiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/esi YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_EsiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_EsiTypePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/esi-type YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_EsiTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_EsiTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/esi-type YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_EsiTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/interface YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/interface YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_NamePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/name YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/name YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_NamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_RedundancyModePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/redundancy-mode YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_RedundancyModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_RedundancyModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/redundancy-mode YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_RedundancyModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/subinterface YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/subinterface YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_SubinterfacePathAny struct {
	*ygot.NodePath
}

// DfElection (container): Top container for the configuration and state parameters
// for the Designated forwarding Election
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "df-election"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election"
func (n *NetworkInstance_Evpn_EthernetSegmentPath) DfElection() *NetworkInstance_Evpn_EthernetSegment_DfElectionPath {
	return &NetworkInstance_Evpn_EthernetSegment_DfElectionPath{
		NodePath: ygot.NewNodePath(
			[]string{"df-election"},
			map[string]interface{}{},
			n,
		),
	}
}

// DfElection (container): Top container for the configuration and state parameters
// for the Designated forwarding Election
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "df-election"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election"
func (n *NetworkInstance_Evpn_EthernetSegmentPathAny) DfElection() *NetworkInstance_Evpn_EthernetSegment_DfElectionPathAny {
	return &NetworkInstance_Evpn_EthernetSegment_DfElectionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"df-election"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): Ethernet Segment Identifier (ESI) value.
// For ESI Type 0: The esi leaf value is directly configured by the operator.
// For ESI Type 1: The AUTO enum must be used.
// For ESI Type 2: The AUTO enum must be used.
// For ESI Type 3: The directly configured or AUTO enum must be used.
// For ESI Type 4: The directly configured or AUTO enum must be used.
// For ESI Type 5: The directly configured or AUTO enum must be used.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/esi"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/esi"
func (n *NetworkInstance_Evpn_EthernetSegmentPath) Esi() *NetworkInstance_Evpn_EthernetSegment_EsiPath {
	return &NetworkInstance_Evpn_EthernetSegment_EsiPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): Ethernet Segment Identifier (ESI) value.
// For ESI Type 0: The esi leaf value is directly configured by the operator.
// For ESI Type 1: The AUTO enum must be used.
// For ESI Type 2: The AUTO enum must be used.
// For ESI Type 3: The directly configured or AUTO enum must be used.
// For ESI Type 4: The directly configured or AUTO enum must be used.
// For ESI Type 5: The directly configured or AUTO enum must be used.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/esi"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/esi"
func (n *NetworkInstance_Evpn_EthernetSegmentPathAny) Esi() *NetworkInstance_Evpn_EthernetSegment_EsiPathAny {
	return &NetworkInstance_Evpn_EthernetSegment_EsiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// EsiType (leaf): ESI Type is a 1-octet field (most significant octet) that
// specifies the format of the remaining 9 octets (ESI Value).
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/esi-type"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/esi-type"
func (n *NetworkInstance_Evpn_EthernetSegmentPath) EsiType() *NetworkInstance_Evpn_EthernetSegment_EsiTypePath {
	return &NetworkInstance_Evpn_EthernetSegment_EsiTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "esi-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// EsiType (leaf): ESI Type is a 1-octet field (most significant octet) that
// specifies the format of the remaining 9 octets (ESI Value).
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/esi-type"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/esi-type"
func (n *NetworkInstance_Evpn_EthernetSegmentPathAny) EsiType() *NetworkInstance_Evpn_EthernetSegment_EsiTypePathAny {
	return &NetworkInstance_Evpn_EthernetSegment_EsiTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "esi-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/interface"
func (n *NetworkInstance_Evpn_EthernetSegmentPath) Interface() *NetworkInstance_Evpn_EthernetSegment_InterfacePath {
	return &NetworkInstance_Evpn_EthernetSegment_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/interface"
func (n *NetworkInstance_Evpn_EthernetSegmentPathAny) Interface() *NetworkInstance_Evpn_EthernetSegment_InterfacePathAny {
	return &NetworkInstance_Evpn_EthernetSegment_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Ethernet Segment name
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/name"
func (n *NetworkInstance_Evpn_EthernetSegmentPath) Name() *NetworkInstance_Evpn_EthernetSegment_NamePath {
	return &NetworkInstance_Evpn_EthernetSegment_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Ethernet Segment name
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/name"
func (n *NetworkInstance_Evpn_EthernetSegmentPathAny) Name() *NetworkInstance_Evpn_EthernetSegment_NamePathAny {
	return &NetworkInstance_Evpn_EthernetSegment_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// RedundancyMode (leaf): Multihoming options for load balancing of
// traffic in the Ethernet Segment.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/redundancy-mode"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/redundancy-mode"
func (n *NetworkInstance_Evpn_EthernetSegmentPath) RedundancyMode() *NetworkInstance_Evpn_EthernetSegment_RedundancyModePath {
	return &NetworkInstance_Evpn_EthernetSegment_RedundancyModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "redundancy-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// RedundancyMode (leaf): Multihoming options for load balancing of
// traffic in the Ethernet Segment.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/redundancy-mode"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/redundancy-mode"
func (n *NetworkInstance_Evpn_EthernetSegmentPathAny) RedundancyMode() *NetworkInstance_Evpn_EthernetSegment_RedundancyModePathAny {
	return &NetworkInstance_Evpn_EthernetSegment_RedundancyModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "redundancy-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/subinterface"
func (n *NetworkInstance_Evpn_EthernetSegmentPath) Subinterface() *NetworkInstance_Evpn_EthernetSegment_SubinterfacePath {
	return &NetworkInstance_Evpn_EthernetSegment_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/config/subinterface"
func (n *NetworkInstance_Evpn_EthernetSegmentPathAny) Subinterface() *NetworkInstance_Evpn_EthernetSegment_SubinterfacePathAny {
	return &NetworkInstance_Evpn_EthernetSegment_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Evpn_EthernetSegment_DfElectionPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElectionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_DfElectionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElectionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_DfElection_DfElectionMethodPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/df-election-method YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElection_DfElectionMethodPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_DfElection_DfElectionMethodPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/df-election-method YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElection_DfElectionMethodPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_DfElection_ElectionWaitTimePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/election-wait-time YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElection_ElectionWaitTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_DfElection_ElectionWaitTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/election-wait-time YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElection_ElectionWaitTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_DfElection_PreferencePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/preference YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElection_PreferencePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_DfElection_PreferencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/preference YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElection_PreferencePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_DfElection_RevertivePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/revertive YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElection_RevertivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EthernetSegment_DfElection_RevertivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/revertive YANG schema element.
type NetworkInstance_Evpn_EthernetSegment_DfElection_RevertivePathAny struct {
	*ygot.NodePath
}

// DfElectionMethod (leaf): Select the Designated Forwarder Election (DF) election method
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/df-election-method"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/df-election-method"
func (n *NetworkInstance_Evpn_EthernetSegment_DfElectionPath) DfElectionMethod() *NetworkInstance_Evpn_EthernetSegment_DfElection_DfElectionMethodPath {
	return &NetworkInstance_Evpn_EthernetSegment_DfElection_DfElectionMethodPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "df-election-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// DfElectionMethod (leaf): Select the Designated Forwarder Election (DF) election method
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/df-election-method"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/df-election-method"
func (n *NetworkInstance_Evpn_EthernetSegment_DfElectionPathAny) DfElectionMethod() *NetworkInstance_Evpn_EthernetSegment_DfElection_DfElectionMethodPathAny {
	return &NetworkInstance_Evpn_EthernetSegment_DfElection_DfElectionMethodPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "df-election-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// ElectionWaitTime (leaf): Designated Forwarder Election wait-time. When the DF timer expires,
// the PE device selects the DF based on the highest preference value
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/election-wait-time"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/election-wait-time"
func (n *NetworkInstance_Evpn_EthernetSegment_DfElectionPath) ElectionWaitTime() *NetworkInstance_Evpn_EthernetSegment_DfElection_ElectionWaitTimePath {
	return &NetworkInstance_Evpn_EthernetSegment_DfElection_ElectionWaitTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "election-wait-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// ElectionWaitTime (leaf): Designated Forwarder Election wait-time. When the DF timer expires,
// the PE device selects the DF based on the highest preference value
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/election-wait-time"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/election-wait-time"
func (n *NetworkInstance_Evpn_EthernetSegment_DfElectionPathAny) ElectionWaitTime() *NetworkInstance_Evpn_EthernetSegment_DfElection_ElectionWaitTimePathAny {
	return &NetworkInstance_Evpn_EthernetSegment_DfElection_ElectionWaitTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "election-wait-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): Defines a 2-octet value that indicates the PE
// preference to become the DF in the Ethernet-Segment.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/preference"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/preference"
func (n *NetworkInstance_Evpn_EthernetSegment_DfElectionPath) Preference() *NetworkInstance_Evpn_EthernetSegment_DfElection_PreferencePath {
	return &NetworkInstance_Evpn_EthernetSegment_DfElection_PreferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): Defines a 2-octet value that indicates the PE
// preference to become the DF in the Ethernet-Segment.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/preference"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/preference"
func (n *NetworkInstance_Evpn_EthernetSegment_DfElectionPathAny) Preference() *NetworkInstance_Evpn_EthernetSegment_DfElection_PreferencePathAny {
	return &NetworkInstance_Evpn_EthernetSegment_DfElection_PreferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// Revertive (leaf): The 'preempt' or 'revertive' behavior. This option will allow a
// non-revertive behavior in the DF election.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/revertive"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/revertive"
func (n *NetworkInstance_Evpn_EthernetSegment_DfElectionPath) Revertive() *NetworkInstance_Evpn_EthernetSegment_DfElection_RevertivePath {
	return &NetworkInstance_Evpn_EthernetSegment_DfElection_RevertivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "revertive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Revertive (leaf): The 'preempt' or 'revertive' behavior. This option will allow a
// non-revertive behavior in the DF election.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/revertive"
// Path from root: "/network-instances/network-instance/evpn/ethernet-segments/ethernet-segment/df-election/config/revertive"
func (n *NetworkInstance_Evpn_EthernetSegment_DfElectionPathAny) Revertive() *NetworkInstance_Evpn_EthernetSegment_DfElection_RevertivePathAny {
	return &NetworkInstance_Evpn_EthernetSegment_DfElection_RevertivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "revertive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Evpn_EvpnInstancePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance YANG schema element.
type NetworkInstance_Evpn_EvpnInstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance YANG schema element.
type NetworkInstance_Evpn_EvpnInstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_EncapsulationTypePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/encapsulation-type YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_EncapsulationTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_EncapsulationTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/encapsulation-type YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_EncapsulationTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_EviPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/evi YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_EviPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_EviPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/evi YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_EviPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_MulticastGroupPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/multicast-group YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_MulticastGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_MulticastGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/multicast-group YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_MulticastGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_MulticastMaskPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/multicast-mask YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_MulticastMaskPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_MulticastMaskPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/multicast-mask YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_MulticastMaskPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_ReplicationModePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/replication-mode YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ReplicationModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_ReplicationModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/replication-mode YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ReplicationModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_RouteDistinguisherPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/route-distinguisher YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_RouteDistinguisherPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_RouteDistinguisherPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/route-distinguisher YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_RouteDistinguisherPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_ServiceTypePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/service-type YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ServiceTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_ServiceTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/service-type YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ServiceTypePathAny struct {
	*ygot.NodePath
}

// BComponentAny (list): List of B-components. The b-component learns and forwards
// traffic on the backbone in order to reduce the number of
// BGP MAC Advertisement routes by aggregating Customer/Client
// MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "pbb/b-component"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component"
// BComponentName (wildcarded): string
func (n *NetworkInstance_Evpn_EvpnInstancePath) BComponentAny() *NetworkInstance_Evpn_EvpnInstance_BComponentPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_BComponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"pbb", "b-component"},
			map[string]interface{}{"b-component-name": "*"},
			n,
		),
	}
}

// BComponentAny (list): List of B-components. The b-component learns and forwards
// traffic on the backbone in order to reduce the number of
// BGP MAC Advertisement routes by aggregating Customer/Client
// MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "pbb/b-component"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component"
// BComponentName (wildcarded): string
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) BComponentAny() *NetworkInstance_Evpn_EvpnInstance_BComponentPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_BComponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"pbb", "b-component"},
			map[string]interface{}{"b-component-name": "*"},
			n,
		),
	}
}

// BComponent (list): List of B-components. The b-component learns and forwards
// traffic on the backbone in order to reduce the number of
// BGP MAC Advertisement routes by aggregating Customer/Client
// MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "pbb/b-component"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component"
// BComponentName: string
func (n *NetworkInstance_Evpn_EvpnInstancePath) BComponent(BComponentName string) *NetworkInstance_Evpn_EvpnInstance_BComponentPath {
	return &NetworkInstance_Evpn_EvpnInstance_BComponentPath{
		NodePath: ygot.NewNodePath(
			[]string{"pbb", "b-component"},
			map[string]interface{}{"b-component-name": BComponentName},
			n,
		),
	}
}

// BComponent (list): List of B-components. The b-component learns and forwards
// traffic on the backbone in order to reduce the number of
// BGP MAC Advertisement routes by aggregating Customer/Client
// MAC (C-MAC) addresses via Provider Backbone MAC (B-MAC) address.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "pbb/b-component"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component"
// BComponentName: string
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) BComponent(BComponentName string) *NetworkInstance_Evpn_EvpnInstance_BComponentPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_BComponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"pbb", "b-component"},
			map[string]interface{}{"b-component-name": BComponentName},
			n,
		),
	}
}

// EncapsulationType (leaf): The on-the-wire encapsulation that should be used when
// exchanging traffic from this network instance to/from
// destinations belonging to the EVI. The use of MPLS or
// VXLAN is selected using this container.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/encapsulation-type"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/encapsulation-type"
func (n *NetworkInstance_Evpn_EvpnInstancePath) EncapsulationType() *NetworkInstance_Evpn_EvpnInstance_EncapsulationTypePath {
	return &NetworkInstance_Evpn_EvpnInstance_EncapsulationTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "encapsulation-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// EncapsulationType (leaf): The on-the-wire encapsulation that should be used when
// exchanging traffic from this network instance to/from
// destinations belonging to the EVI. The use of MPLS or
// VXLAN is selected using this container.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/encapsulation-type"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/encapsulation-type"
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) EncapsulationType() *NetworkInstance_Evpn_EvpnInstance_EncapsulationTypePathAny {
	return &NetworkInstance_Evpn_EvpnInstance_EncapsulationTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "encapsulation-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Evi (leaf): EVPN Instance (EVI) identifier
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/evi"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/evi"
func (n *NetworkInstance_Evpn_EvpnInstancePath) Evi() *NetworkInstance_Evpn_EvpnInstance_EviPath {
	return &NetworkInstance_Evpn_EvpnInstance_EviPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "evi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Evi (leaf): EVPN Instance (EVI) identifier
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/evi"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/evi"
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) Evi() *NetworkInstance_Evpn_EvpnInstance_EviPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_EviPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "evi"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportExportPolicy (container): Top container to set the import and export policies
// associated with a EVI
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "import-export-policy"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy"
func (n *NetworkInstance_Evpn_EvpnInstancePath) ImportExportPolicy() *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPath {
	return &NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"import-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportExportPolicy (container): Top container to set the import and export policies
// associated with a EVI
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "import-export-policy"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy"
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) ImportExportPolicy() *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"import-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastGroup (leaf): Multicast group address for BUM traffic
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-group"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/multicast-group"
func (n *NetworkInstance_Evpn_EvpnInstancePath) MulticastGroup() *NetworkInstance_Evpn_EvpnInstance_MulticastGroupPath {
	return &NetworkInstance_Evpn_EvpnInstance_MulticastGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastGroup (leaf): Multicast group address for BUM traffic
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-group"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/multicast-group"
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) MulticastGroup() *NetworkInstance_Evpn_EvpnInstance_MulticastGroupPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_MulticastGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastMask (leaf): Multicast group address mask
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-mask"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/multicast-mask"
func (n *NetworkInstance_Evpn_EvpnInstancePath) MulticastMask() *NetworkInstance_Evpn_EvpnInstance_MulticastMaskPath {
	return &NetworkInstance_Evpn_EvpnInstance_MulticastMaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastMask (leaf): Multicast group address mask
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-mask"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/multicast-mask"
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) MulticastMask() *NetworkInstance_Evpn_EvpnInstance_MulticastMaskPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_MulticastMaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReplicationMode (leaf): Replication mode to handle BUM traffic
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/replication-mode"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/replication-mode"
func (n *NetworkInstance_Evpn_EvpnInstancePath) ReplicationMode() *NetworkInstance_Evpn_EvpnInstance_ReplicationModePath {
	return &NetworkInstance_Evpn_EvpnInstance_ReplicationModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "replication-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReplicationMode (leaf): Replication mode to handle BUM traffic
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/replication-mode"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/replication-mode"
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) ReplicationMode() *NetworkInstance_Evpn_EvpnInstance_ReplicationModePathAny {
	return &NetworkInstance_Evpn_EvpnInstance_ReplicationModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "replication-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteDistinguisher (leaf): Route Distinguisher (RD) associated to the EVPN-instance.
// An RD MUST be assigned for a given EVPN-instance on a PE.
// This RD MUST be unique across all EVPN-instances on a PE.
// The route-distinguisher at this level overrides
// the route-distinguisher value defined under
// network-instance/config.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-distinguisher"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/route-distinguisher"
func (n *NetworkInstance_Evpn_EvpnInstancePath) RouteDistinguisher() *NetworkInstance_Evpn_EvpnInstance_RouteDistinguisherPath {
	return &NetworkInstance_Evpn_EvpnInstance_RouteDistinguisherPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteDistinguisher (leaf): Route Distinguisher (RD) associated to the EVPN-instance.
// An RD MUST be assigned for a given EVPN-instance on a PE.
// This RD MUST be unique across all EVPN-instances on a PE.
// The route-distinguisher at this level overrides
// the route-distinguisher value defined under
// network-instance/config.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-distinguisher"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/route-distinguisher"
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) RouteDistinguisher() *NetworkInstance_Evpn_EvpnInstance_RouteDistinguisherPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_RouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// ServiceType (leaf): Specifies the type of EVPN that is being created according
// to the values in the EVPN_TYPES identity.
// The options are VLAN-based, VLAN-Bundle or VLAN-aware.
// VLAN-Based services consists of an EVPN instance of only a
// single broadcast domain, the proper network-instance type used
// for this kind of services is L2VSI.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/service-type"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/service-type"
func (n *NetworkInstance_Evpn_EvpnInstancePath) ServiceType() *NetworkInstance_Evpn_EvpnInstance_ServiceTypePath {
	return &NetworkInstance_Evpn_EvpnInstance_ServiceTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "service-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// ServiceType (leaf): Specifies the type of EVPN that is being created according
// to the values in the EVPN_TYPES identity.
// The options are VLAN-based, VLAN-Bundle or VLAN-aware.
// VLAN-Based services consists of an EVPN instance of only a
// single broadcast domain, the proper network-instance type used
// for this kind of services is L2VSI.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/service-type"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/config/service-type"
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) ServiceType() *NetworkInstance_Evpn_EvpnInstance_ServiceTypePathAny {
	return &NetworkInstance_Evpn_EvpnInstance_ServiceTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "service-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vxlan (container): Top container related to Overlay Solution in EVPN.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "vxlan"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan"
func (n *NetworkInstance_Evpn_EvpnInstancePath) Vxlan() *NetworkInstance_Evpn_EvpnInstance_VxlanPath {
	return &NetworkInstance_Evpn_EvpnInstance_VxlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"vxlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vxlan (container): Top container related to Overlay Solution in EVPN.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "vxlan"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan"
func (n *NetworkInstance_Evpn_EvpnInstancePathAny) Vxlan() *NetworkInstance_Evpn_EvpnInstance_VxlanPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_VxlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"vxlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Evpn_EvpnInstance_BComponentPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_BComponentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_BComponent_BComponentNamePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/config/b-component-name YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponent_BComponentNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_BComponent_BComponentNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/config/b-component-name YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponent_BComponentNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_BComponent_BackboneSrcMacPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/config/backbone-src-mac YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponent_BackboneSrcMacPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_BComponent_BackboneSrcMacPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/config/backbone-src-mac YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponent_BackboneSrcMacPathAny struct {
	*ygot.NodePath
}

// BComponentName (leaf): Type of the associated b-component
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/b-component-name"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/config/b-component-name"
func (n *NetworkInstance_Evpn_EvpnInstance_BComponentPath) BComponentName() *NetworkInstance_Evpn_EvpnInstance_BComponent_BComponentNamePath {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_BComponentNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "b-component-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// BComponentName (leaf): Type of the associated b-component
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/b-component-name"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/config/b-component-name"
func (n *NetworkInstance_Evpn_EvpnInstance_BComponentPathAny) BComponentName() *NetworkInstance_Evpn_EvpnInstance_BComponent_BComponentNamePathAny {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_BComponentNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "b-component-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// BackboneSrcMac (leaf): EVPN will run independently in both components,
// the I-component MAC-VRF and B-component MAC-VRF.
// The backbone-src-mac assigns the b-component MAC.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/backbone-src-mac"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/config/backbone-src-mac"
func (n *NetworkInstance_Evpn_EvpnInstance_BComponentPath) BackboneSrcMac() *NetworkInstance_Evpn_EvpnInstance_BComponent_BackboneSrcMacPath {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_BackboneSrcMacPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "backbone-src-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// BackboneSrcMac (leaf): EVPN will run independently in both components,
// the I-component MAC-VRF and B-component MAC-VRF.
// The backbone-src-mac assigns the b-component MAC.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/backbone-src-mac"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/config/backbone-src-mac"
func (n *NetworkInstance_Evpn_EvpnInstance_BComponentPathAny) BackboneSrcMac() *NetworkInstance_Evpn_EvpnInstance_BComponent_BackboneSrcMacPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_BackboneSrcMacPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "backbone-src-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// IComponentAny (list): list of i-components
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "i-components/i-component"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component"
// ISid (wildcarded): uint32
func (n *NetworkInstance_Evpn_EvpnInstance_BComponentPath) IComponentAny() *NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"i-components", "i-component"},
			map[string]interface{}{"i-sid": "*"},
			n,
		),
	}
}

// IComponentAny (list): list of i-components
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "i-components/i-component"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component"
// ISid (wildcarded): uint32
func (n *NetworkInstance_Evpn_EvpnInstance_BComponentPathAny) IComponentAny() *NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"i-components", "i-component"},
			map[string]interface{}{"i-sid": "*"},
			n,
		),
	}
}

// IComponent (list): list of i-components
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "i-components/i-component"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component"
// ISid: uint32
func (n *NetworkInstance_Evpn_EvpnInstance_BComponentPath) IComponent(ISid uint32) *NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPath {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPath{
		NodePath: ygot.NewNodePath(
			[]string{"i-components", "i-component"},
			map[string]interface{}{"i-sid": ISid},
			n,
		),
	}
}

// IComponent (list): list of i-components
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "i-components/i-component"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component"
// ISid: uint32
func (n *NetworkInstance_Evpn_EvpnInstance_BComponentPathAny) IComponent(ISid uint32) *NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"i-components", "i-component"},
			map[string]interface{}{"i-sid": ISid},
			n,
		),
	}
}

// NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_BComponent_IComponent_ISidPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component/config/i-sid YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponent_IComponent_ISidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_BComponent_IComponent_ISidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component/config/i-sid YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_BComponent_IComponent_ISidPathAny struct {
	*ygot.NodePath
}

// ISid (leaf): Service Instance Identifier 24 bits and global within a PBB
// network. I-SID defines the service instance that the frame should be
// mapped to.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/i-sid"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component/config/i-sid"
func (n *NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPath) ISid() *NetworkInstance_Evpn_EvpnInstance_BComponent_IComponent_ISidPath {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_IComponent_ISidPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "i-sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// ISid (leaf): Service Instance Identifier 24 bits and global within a PBB
// network. I-SID defines the service instance that the frame should be
// mapped to.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/i-sid"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/pbb/b-component/i-components/i-component/config/i-sid"
func (n *NetworkInstance_Evpn_EvpnInstance_BComponent_IComponentPathAny) ISid() *NetworkInstance_Evpn_EvpnInstance_BComponent_IComponent_ISidPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_BComponent_IComponent_ISidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "i-sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ExportRouteTargetPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy/config/export-route-target YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ExportRouteTargetPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ExportRouteTargetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy/config/export-route-target YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ExportRouteTargetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ImportRouteTargetPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy/config/import-route-target YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ImportRouteTargetPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ImportRouteTargetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy/config/import-route-target YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ImportRouteTargetPathAny struct {
	*ygot.NodePath
}

// ExportRouteTarget (leaf): Export Route Target (RT) in the network-instance on a PE.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-route-target"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy/config/export-route-target"
func (n *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPath) ExportRouteTarget() *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ExportRouteTargetPath {
	return &NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ExportRouteTargetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-route-target"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportRouteTarget (leaf): Export Route Target (RT) in the network-instance on a PE.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-route-target"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy/config/export-route-target"
func (n *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPathAny) ExportRouteTarget() *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ExportRouteTargetPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ExportRouteTargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-route-target"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportRouteTarget (leaf): Import Route Target (RT) in the network-instance on a PE.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-route-target"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy/config/import-route-target"
func (n *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPath) ImportRouteTarget() *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ImportRouteTargetPath {
	return &NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ImportRouteTargetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-route-target"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportRouteTarget (leaf): Import Route Target (RT) in the network-instance on a PE.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-route-target"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/import-export-policy/config/import-route-target"
func (n *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicyPathAny) ImportRouteTarget() *NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ImportRouteTargetPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_ImportExportPolicy_ImportRouteTargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-route-target"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Evpn_EvpnInstance_VxlanPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_VxlanPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_VxlanPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_VxlanPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_HostReachabilityBgpPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/host-reachability-bgp YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_HostReachabilityBgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_HostReachabilityBgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/host-reachability-bgp YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_HostReachabilityBgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastGroupPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/multicast-group YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/multicast-group YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastMaskPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/multicast-mask YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastMaskPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastMaskPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/multicast-mask YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastMaskPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/overlay-endpoint YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/overlay-endpoint YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointNetworkInstancePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/overlay-endpoint-network-instance YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointNetworkInstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointNetworkInstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/overlay-endpoint-network-instance YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointNetworkInstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_VniPath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/vni YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_VniPath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_VniPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/vni YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_VniPathAny struct {
	*ygot.NodePath
}

// AnycastSourceInterface (container): Anycast source interface references
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "anycast-source-interface"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPath) AnycastSourceInterface() *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePath {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"anycast-source-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// AnycastSourceInterface (container): Anycast source interface references
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "anycast-source-interface"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPathAny) AnycastSourceInterface() *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePathAny {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"anycast-source-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// HostReachabilityBgp (leaf): Enable or Disable the BGP control plane to be
// used to exchange  updates from the NVE interface
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/host-reachability-bgp"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/host-reachability-bgp"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPath) HostReachabilityBgp() *NetworkInstance_Evpn_EvpnInstance_Vxlan_HostReachabilityBgpPath {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_HostReachabilityBgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "host-reachability-bgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// HostReachabilityBgp (leaf): Enable or Disable the BGP control plane to be
// used to exchange  updates from the NVE interface
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/host-reachability-bgp"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/host-reachability-bgp"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPathAny) HostReachabilityBgp() *NetworkInstance_Evpn_EvpnInstance_Vxlan_HostReachabilityBgpPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_HostReachabilityBgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "host-reachability-bgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastGroup (leaf): Multicast group address for BUM traffic
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-group"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/multicast-group"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPath) MulticastGroup() *NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastGroupPath {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastGroup (leaf): Multicast group address for BUM traffic
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-group"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/multicast-group"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPathAny) MulticastGroup() *NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastGroupPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastMask (leaf): Multicast group address mask
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-mask"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/multicast-mask"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPath) MulticastMask() *NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastMaskPath {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastMaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastMask (leaf): Multicast group address mask
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-mask"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/multicast-mask"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPathAny) MulticastMask() *NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastMaskPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_MulticastMaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// OverlayEndpoint (leaf): Associate the EVI with an VXLAN Endpoint defined under connection
// points. The network instance to resolve the overlay-endpoint within.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/overlay-endpoint"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/overlay-endpoint"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPath) OverlayEndpoint() *NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointPath {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "overlay-endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// OverlayEndpoint (leaf): Associate the EVI with an VXLAN Endpoint defined under connection
// points. The network instance to resolve the overlay-endpoint within.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/overlay-endpoint"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/overlay-endpoint"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPathAny) OverlayEndpoint() *NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "overlay-endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// OverlayEndpointNetworkInstance (leaf): The network instance to resolve the overlay-endpoint within.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/overlay-endpoint-network-instance"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/overlay-endpoint-network-instance"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPath) OverlayEndpointNetworkInstance() *NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointNetworkInstancePath {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointNetworkInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "overlay-endpoint-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// OverlayEndpointNetworkInstance (leaf): The network instance to resolve the overlay-endpoint within.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/overlay-endpoint-network-instance"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/overlay-endpoint-network-instance"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPathAny) OverlayEndpointNetworkInstance() *NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointNetworkInstancePathAny {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_OverlayEndpointNetworkInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "overlay-endpoint-network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vni (leaf): Virtual Network Identifier (VNI) associated to the EVI. This VNI is used for
// ingress and egress in the VXLAN domain.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/vni"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/vni"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPath) Vni() *NetworkInstance_Evpn_EvpnInstance_Vxlan_VniPath {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_VniPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vni (leaf): Virtual Network Identifier (VNI) associated to the EVI. This VNI is used for
// ingress and egress in the VXLAN domain.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/vni"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/config/vni"
func (n *NetworkInstance_Evpn_EvpnInstance_VxlanPathAny) Vni() *NetworkInstance_Evpn_EvpnInstance_Vxlan_VniPathAny {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_VniPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface/config/interface YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface/config/interface YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface/config/subinterface YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface/config/subinterface YANG schema element.
type NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface/config/interface"
func (n *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePath) Interface() *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_InterfacePath {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface/config/interface"
func (n *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePathAny) Interface() *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_InterfacePathAny {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface/config/subinterface"
func (n *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePath) Subinterface() *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_SubinterfacePath {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/evpn/evpn-instances/evpn-instance/vxlan/anycast-source-interface/config/subinterface"
func (n *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterfacePathAny) Subinterface() *NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_SubinterfacePathAny {
	return &NetworkInstance_Evpn_EvpnInstance_Vxlan_AnycastSourceInterface_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_FdbPath represents the /openconfig-network-instance/network-instances/network-instance/fdb YANG schema element.
type NetworkInstance_FdbPath struct {
	*ygot.NodePath
}

// NetworkInstance_FdbPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb YANG schema element.
type NetworkInstance_FdbPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_AnycastGatewayMacPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/config/anycast-gateway-mac YANG schema element.
type NetworkInstance_Fdb_AnycastGatewayMacPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_AnycastGatewayMacPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/config/anycast-gateway-mac YANG schema element.
type NetworkInstance_Fdb_AnycastGatewayMacPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_FloodUnknownUnicastSupressionPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/config/flood-unknown-unicast-supression YANG schema element.
type NetworkInstance_Fdb_FloodUnknownUnicastSupressionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_FloodUnknownUnicastSupressionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/config/flood-unknown-unicast-supression YANG schema element.
type NetworkInstance_Fdb_FloodUnknownUnicastSupressionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacAgingTimePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/config/mac-aging-time YANG schema element.
type NetworkInstance_Fdb_MacAgingTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacAgingTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/config/mac-aging-time YANG schema element.
type NetworkInstance_Fdb_MacAgingTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacLearningPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/config/mac-learning YANG schema element.
type NetworkInstance_Fdb_MacLearningPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacLearningPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/config/mac-learning YANG schema element.
type NetworkInstance_Fdb_MacLearningPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MaximumEntriesPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/config/maximum-entries YANG schema element.
type NetworkInstance_Fdb_MaximumEntriesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MaximumEntriesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/config/maximum-entries YANG schema element.
type NetworkInstance_Fdb_MaximumEntriesPathAny struct {
	*ygot.NodePath
}

// AnycastGatewayMac (leaf): Configure the anycast gateway MAC address that all VTEPs
// use for the network instance. When a VM sends an Address
// Resolution Protocol (ARP) request for the anycast gateway
// IP address in a VXLAN virtual network, the VTEP responds
// with the configured anycast MAC address.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/anycast-gateway-mac"
// Path from root: "/network-instances/network-instance/fdb/config/anycast-gateway-mac"
func (n *NetworkInstance_FdbPath) AnycastGatewayMac() *NetworkInstance_Fdb_AnycastGatewayMacPath {
	return &NetworkInstance_Fdb_AnycastGatewayMacPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "anycast-gateway-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// AnycastGatewayMac (leaf): Configure the anycast gateway MAC address that all VTEPs
// use for the network instance. When a VM sends an Address
// Resolution Protocol (ARP) request for the anycast gateway
// IP address in a VXLAN virtual network, the VTEP responds
// with the configured anycast MAC address.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/anycast-gateway-mac"
// Path from root: "/network-instances/network-instance/fdb/config/anycast-gateway-mac"
func (n *NetworkInstance_FdbPathAny) AnycastGatewayMac() *NetworkInstance_Fdb_AnycastGatewayMacPathAny {
	return &NetworkInstance_Fdb_AnycastGatewayMacPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "anycast-gateway-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// ArpProxy (container): Top Container related to ARP-Proxy
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "arp-proxy"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy"
func (n *NetworkInstance_FdbPath) ArpProxy() *NetworkInstance_Fdb_ArpProxyPath {
	return &NetworkInstance_Fdb_ArpProxyPath{
		NodePath: ygot.NewNodePath(
			[]string{"arp-proxy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ArpProxy (container): Top Container related to ARP-Proxy
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "arp-proxy"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy"
func (n *NetworkInstance_FdbPathAny) ArpProxy() *NetworkInstance_Fdb_ArpProxyPathAny {
	return &NetworkInstance_Fdb_ArpProxyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"arp-proxy"},
			map[string]interface{}{},
			n,
		),
	}
}

// FloodUnknownUnicastSupression (leaf): Enable (TRUE) or disable (FALSE) the Unknown Unicast Flooding
// Suppression. If the Unknown Unicast Flooding Suppression is on,
// the unicast traffic towards an unknown host will be dropped.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/flood-unknown-unicast-supression"
// Path from root: "/network-instances/network-instance/fdb/config/flood-unknown-unicast-supression"
func (n *NetworkInstance_FdbPath) FloodUnknownUnicastSupression() *NetworkInstance_Fdb_FloodUnknownUnicastSupressionPath {
	return &NetworkInstance_Fdb_FloodUnknownUnicastSupressionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "flood-unknown-unicast-supression"},
			map[string]interface{}{},
			n,
		),
	}
}

// FloodUnknownUnicastSupression (leaf): Enable (TRUE) or disable (FALSE) the Unknown Unicast Flooding
// Suppression. If the Unknown Unicast Flooding Suppression is on,
// the unicast traffic towards an unknown host will be dropped.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/flood-unknown-unicast-supression"
// Path from root: "/network-instances/network-instance/fdb/config/flood-unknown-unicast-supression"
func (n *NetworkInstance_FdbPathAny) FloodUnknownUnicastSupression() *NetworkInstance_Fdb_FloodUnknownUnicastSupressionPathAny {
	return &NetworkInstance_Fdb_FloodUnknownUnicastSupressionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "flood-unknown-unicast-supression"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2Rib (container): Operational state container for MAC address and MAC-IP address
// information that is learned and installed into the MAC VRF Layer 2
// Routing Information Base (L2RIB)
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2rib"
// Path from root: "/network-instances/network-instance/fdb/l2rib"
func (n *NetworkInstance_FdbPath) L2Rib() *NetworkInstance_Fdb_L2RibPath {
	return &NetworkInstance_Fdb_L2RibPath{
		NodePath: ygot.NewNodePath(
			[]string{"l2rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2Rib (container): Operational state container for MAC address and MAC-IP address
// information that is learned and installed into the MAC VRF Layer 2
// Routing Information Base (L2RIB)
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2rib"
// Path from root: "/network-instances/network-instance/fdb/l2rib"
func (n *NetworkInstance_FdbPathAny) L2Rib() *NetworkInstance_Fdb_L2RibPathAny {
	return &NetworkInstance_Fdb_L2RibPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAgingTime (leaf): The number of seconds of inactivity after which the entry
// in the local FDB is timed out.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-aging-time"
// Path from root: "/network-instances/network-instance/fdb/config/mac-aging-time"
func (n *NetworkInstance_FdbPath) MacAgingTime() *NetworkInstance_Fdb_MacAgingTimePath {
	return &NetworkInstance_Fdb_MacAgingTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-aging-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAgingTime (leaf): The number of seconds of inactivity after which the entry
// in the local FDB is timed out.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-aging-time"
// Path from root: "/network-instances/network-instance/fdb/config/mac-aging-time"
func (n *NetworkInstance_FdbPathAny) MacAgingTime() *NetworkInstance_Fdb_MacAgingTimePathAny {
	return &NetworkInstance_Fdb_MacAgingTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-aging-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacLearning (leaf): When this leaf is set to true, MAC learning is enabled for
// the network instance, such that MAC addresses are learned
// from ingress frames and added to the FDB.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-learning"
// Path from root: "/network-instances/network-instance/fdb/config/mac-learning"
func (n *NetworkInstance_FdbPath) MacLearning() *NetworkInstance_Fdb_MacLearningPath {
	return &NetworkInstance_Fdb_MacLearningPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-learning"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacLearning (leaf): When this leaf is set to true, MAC learning is enabled for
// the network instance, such that MAC addresses are learned
// from ingress frames and added to the FDB.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-learning"
// Path from root: "/network-instances/network-instance/fdb/config/mac-learning"
func (n *NetworkInstance_FdbPathAny) MacLearning() *NetworkInstance_Fdb_MacLearningPathAny {
	return &NetworkInstance_Fdb_MacLearningPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-learning"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacMobility (container): Top grouping the configuration and state data related to mac
// mobility.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mac-mobility"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility"
func (n *NetworkInstance_FdbPath) MacMobility() *NetworkInstance_Fdb_MacMobilityPath {
	return &NetworkInstance_Fdb_MacMobilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"mac-mobility"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacMobility (container): Top grouping the configuration and state data related to mac
// mobility.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mac-mobility"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility"
func (n *NetworkInstance_FdbPathAny) MacMobility() *NetworkInstance_Fdb_MacMobilityPathAny {
	return &NetworkInstance_Fdb_MacMobilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mac-mobility"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacTable (container): Table of learned or statically configured MAC addresses and
// corresponding VLANs in the bridge domain
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mac-table"
// Path from root: "/network-instances/network-instance/fdb/mac-table"
func (n *NetworkInstance_FdbPath) MacTable() *NetworkInstance_Fdb_MacTablePath {
	return &NetworkInstance_Fdb_MacTablePath{
		NodePath: ygot.NewNodePath(
			[]string{"mac-table"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacTable (container): Table of learned or statically configured MAC addresses and
// corresponding VLANs in the bridge domain
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mac-table"
// Path from root: "/network-instances/network-instance/fdb/mac-table"
func (n *NetworkInstance_FdbPathAny) MacTable() *NetworkInstance_Fdb_MacTablePathAny {
	return &NetworkInstance_Fdb_MacTablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mac-table"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumEntries (leaf): The maximum number of MAC address entries that should be
// accepted into the FDB
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-entries"
// Path from root: "/network-instances/network-instance/fdb/config/maximum-entries"
func (n *NetworkInstance_FdbPath) MaximumEntries() *NetworkInstance_Fdb_MaximumEntriesPath {
	return &NetworkInstance_Fdb_MaximumEntriesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-entries"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumEntries (leaf): The maximum number of MAC address entries that should be
// accepted into the FDB
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-entries"
// Path from root: "/network-instances/network-instance/fdb/config/maximum-entries"
func (n *NetworkInstance_FdbPathAny) MaximumEntries() *NetworkInstance_Fdb_MaximumEntriesPathAny {
	return &NetworkInstance_Fdb_MaximumEntriesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-entries"},
			map[string]interface{}{},
			n,
		),
	}
}

// NdProxy (container): Top Container related to ND-Proxy.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "nd-proxy"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy"
func (n *NetworkInstance_FdbPath) NdProxy() *NetworkInstance_Fdb_NdProxyPath {
	return &NetworkInstance_Fdb_NdProxyPath{
		NodePath: ygot.NewNodePath(
			[]string{"nd-proxy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NdProxy (container): Top Container related to ND-Proxy.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "nd-proxy"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy"
func (n *NetworkInstance_FdbPathAny) NdProxy() *NetworkInstance_Fdb_NdProxyPathAny {
	return &NetworkInstance_Fdb_NdProxyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"nd-proxy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_ArpProxyPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy YANG schema element.
type NetworkInstance_Fdb_ArpProxyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_ArpProxyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy YANG schema element.
type NetworkInstance_Fdb_ArpProxyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_ArpProxy_ArpSuppressionPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy/config/arp-suppression YANG schema element.
type NetworkInstance_Fdb_ArpProxy_ArpSuppressionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_ArpProxy_ArpSuppressionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy/config/arp-suppression YANG schema element.
type NetworkInstance_Fdb_ArpProxy_ArpSuppressionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_ArpProxy_DuplicateIpDetectionIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy/config/duplicate-ip-detection-interval YANG schema element.
type NetworkInstance_Fdb_ArpProxy_DuplicateIpDetectionIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_ArpProxy_DuplicateIpDetectionIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy/config/duplicate-ip-detection-interval YANG schema element.
type NetworkInstance_Fdb_ArpProxy_DuplicateIpDetectionIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_ArpProxy_EnablePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy/config/enable YANG schema element.
type NetworkInstance_Fdb_ArpProxy_EnablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_ArpProxy_EnablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy/config/enable YANG schema element.
type NetworkInstance_Fdb_ArpProxy_EnablePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_ArpProxy_IpMobilityThresholdPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy/config/ip-mobility-threshold YANG schema element.
type NetworkInstance_Fdb_ArpProxy_IpMobilityThresholdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_ArpProxy_IpMobilityThresholdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/arp-proxy/config/ip-mobility-threshold YANG schema element.
type NetworkInstance_Fdb_ArpProxy_IpMobilityThresholdPathAny struct {
	*ygot.NodePath
}

// ArpSuppression (leaf): Enable (TRUE) or disable (FALSE) ARP suppression. If true
// the  Address Resolution Protocol (ARP) queries for an
// IP address that is not on that network are suppressed.
// Address Resolution Protocol (ARP) suppression is a
// technique used to reduce the amount of ARP broadcast
// flooding within individual VXLAN segments, that is between
// VMs connected to the same logical switch.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/arp-suppression"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy/config/arp-suppression"
func (n *NetworkInstance_Fdb_ArpProxyPath) ArpSuppression() *NetworkInstance_Fdb_ArpProxy_ArpSuppressionPath {
	return &NetworkInstance_Fdb_ArpProxy_ArpSuppressionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "arp-suppression"},
			map[string]interface{}{},
			n,
		),
	}
}

// ArpSuppression (leaf): Enable (TRUE) or disable (FALSE) ARP suppression. If true
// the  Address Resolution Protocol (ARP) queries for an
// IP address that is not on that network are suppressed.
// Address Resolution Protocol (ARP) suppression is a
// technique used to reduce the amount of ARP broadcast
// flooding within individual VXLAN segments, that is between
// VMs connected to the same logical switch.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/arp-suppression"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy/config/arp-suppression"
func (n *NetworkInstance_Fdb_ArpProxyPathAny) ArpSuppression() *NetworkInstance_Fdb_ArpProxy_ArpSuppressionPathAny {
	return &NetworkInstance_Fdb_ArpProxy_ArpSuppressionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "arp-suppression"},
			map[string]interface{}{},
			n,
		),
	}
}

// DuplicateIpDetectionInterval (leaf): The time interval used in detecting a duplicate IP address.
// Duplicate ip detection number of host moves
// allowed within interval period
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/duplicate-ip-detection-interval"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy/config/duplicate-ip-detection-interval"
func (n *NetworkInstance_Fdb_ArpProxyPath) DuplicateIpDetectionInterval() *NetworkInstance_Fdb_ArpProxy_DuplicateIpDetectionIntervalPath {
	return &NetworkInstance_Fdb_ArpProxy_DuplicateIpDetectionIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "duplicate-ip-detection-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// DuplicateIpDetectionInterval (leaf): The time interval used in detecting a duplicate IP address.
// Duplicate ip detection number of host moves
// allowed within interval period
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/duplicate-ip-detection-interval"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy/config/duplicate-ip-detection-interval"
func (n *NetworkInstance_Fdb_ArpProxyPathAny) DuplicateIpDetectionInterval() *NetworkInstance_Fdb_ArpProxy_DuplicateIpDetectionIntervalPathAny {
	return &NetworkInstance_Fdb_ArpProxy_DuplicateIpDetectionIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "duplicate-ip-detection-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enable (TRUE) or disable (FALSE) ARP proxy. If true
// a proxy server on the network answers the
// Address Resolution Protocol (ARP) queries for an
// IP address that is not on that network.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy/config/enable"
func (n *NetworkInstance_Fdb_ArpProxyPath) Enable() *NetworkInstance_Fdb_ArpProxy_EnablePath {
	return &NetworkInstance_Fdb_ArpProxy_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enable (TRUE) or disable (FALSE) ARP proxy. If true
// a proxy server on the network answers the
// Address Resolution Protocol (ARP) queries for an
// IP address that is not on that network.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy/config/enable"
func (n *NetworkInstance_Fdb_ArpProxyPathAny) Enable() *NetworkInstance_Fdb_ArpProxy_EnablePathAny {
	return &NetworkInstance_Fdb_ArpProxy_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpMobilityThreshold (leaf): Enable (TRUE) or disable (FALSE). It is possible for a given host
// or end-station (as defined by its IP address) to move from one
// Ethernet segment to another. The number of IP mobility events that
// are detected for a given IP address within the detection-threshold
// before it is identified as a duplicate IP address.
// Once the detection threshold is reached, updates for the IP address
// are suppressed.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ip-mobility-threshold"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy/config/ip-mobility-threshold"
func (n *NetworkInstance_Fdb_ArpProxyPath) IpMobilityThreshold() *NetworkInstance_Fdb_ArpProxy_IpMobilityThresholdPath {
	return &NetworkInstance_Fdb_ArpProxy_IpMobilityThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-mobility-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpMobilityThreshold (leaf): Enable (TRUE) or disable (FALSE). It is possible for a given host
// or end-station (as defined by its IP address) to move from one
// Ethernet segment to another. The number of IP mobility events that
// are detected for a given IP address within the detection-threshold
// before it is identified as a duplicate IP address.
// Once the detection threshold is reached, updates for the IP address
// are suppressed.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ip-mobility-threshold"
// Path from root: "/network-instances/network-instance/fdb/arp-proxy/config/ip-mobility-threshold"
func (n *NetworkInstance_Fdb_ArpProxyPathAny) IpMobilityThreshold() *NetworkInstance_Fdb_ArpProxy_IpMobilityThresholdPathAny {
	return &NetworkInstance_Fdb_ArpProxy_IpMobilityThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-mobility-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_L2RibPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib YANG schema element.
type NetworkInstance_Fdb_L2RibPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2RibPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib YANG schema element.
type NetworkInstance_Fdb_L2RibPathAny struct {
	*ygot.NodePath
}

// MacIpTable (container): Operational state container for MAC-IP address information installed
// into the MAC VRF of the L2RIB
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mac-ip-table"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table"
func (n *NetworkInstance_Fdb_L2RibPath) MacIpTable() *NetworkInstance_Fdb_L2Rib_MacIpTablePath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTablePath{
		NodePath: ygot.NewNodePath(
			[]string{"mac-ip-table"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacIpTable (container): Operational state container for MAC-IP address information installed
// into the MAC VRF of the L2RIB
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mac-ip-table"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table"
func (n *NetworkInstance_Fdb_L2RibPathAny) MacIpTable() *NetworkInstance_Fdb_L2Rib_MacIpTablePathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mac-ip-table"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacTable (container): Operational state container for MAC address information installed
// into the MAC VRF of the L2RIB
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mac-table"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table"
func (n *NetworkInstance_Fdb_L2RibPath) MacTable() *NetworkInstance_Fdb_L2Rib_MacTablePath {
	return &NetworkInstance_Fdb_L2Rib_MacTablePath{
		NodePath: ygot.NewNodePath(
			[]string{"mac-table"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacTable (container): Operational state container for MAC address information installed
// into the MAC VRF of the L2RIB
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mac-table"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table"
func (n *NetworkInstance_Fdb_L2RibPathAny) MacTable() *NetworkInstance_Fdb_L2Rib_MacTablePathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mac-table"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_L2Rib_MacIpTablePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTablePathAny struct {
	*ygot.NodePath
}

// EntryAny (list): List of learned MAC-IP addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry"
// MacAddress (wildcarded): string
// HostIp (wildcarded): string
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePath) EntryAny() *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*", "host-ip": "*"},
			n,
		),
	}
}

// EntryAny (list): List of learned MAC-IP addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry"
// MacAddress (wildcarded): string
// HostIp (wildcarded): string
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePathAny) EntryAny() *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*", "host-ip": "*"},
			n,
		),
	}
}

// EntryAnyHostIp (list): List of learned MAC-IP addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry"
// MacAddress: string
// HostIp (wildcarded): string
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePath) EntryAnyHostIp(MacAddress string) *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress, "host-ip": "*"},
			n,
		),
	}
}

// EntryAnyHostIp (list): List of learned MAC-IP addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry"
// MacAddress: string
// HostIp (wildcarded): string
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePathAny) EntryAnyHostIp(MacAddress string) *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress, "host-ip": "*"},
			n,
		),
	}
}

// EntryAnyMacAddress (list): List of learned MAC-IP addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry"
// MacAddress (wildcarded): string
// HostIp: string
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePath) EntryAnyMacAddress(HostIp string) *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*", "host-ip": HostIp},
			n,
		),
	}
}

// EntryAnyMacAddress (list): List of learned MAC-IP addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry"
// MacAddress (wildcarded): string
// HostIp: string
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePathAny) EntryAnyMacAddress(HostIp string) *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*", "host-ip": HostIp},
			n,
		),
	}
}

// Entry (list): List of learned MAC-IP addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry"
// MacAddress: string
// HostIp: string
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePath) Entry(MacAddress string, HostIp string) *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress, "host-ip": HostIp},
			n,
		),
	}
}

// Entry (list): List of learned MAC-IP addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry"
// MacAddress: string
// HostIp: string
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePathAny) Entry(MacAddress string, HostIp string) *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress, "host-ip": HostIp},
			n,
		),
	}
}

// NextHopAny (list): List of next hop attributes for each MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePath) NextHopAny() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHopAny (list): List of next hop attributes for each MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePathAny) NextHopAny() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHop (list): List of next hop attributes for each MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePath) NextHop(Index uint64) *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NextHop (list): List of next hop attributes for each MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_Fdb_L2Rib_MacIpTablePathAny) NextHop(Index uint64) *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_EviPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/evi YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_EviPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_EviPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/evi YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_EviPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_HostIpPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/host-ip YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_HostIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_HostIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/host-ip YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_HostIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L2VniPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/l2-vni YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L2VniPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L2VniPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/l2-vni YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L2VniPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L3VniPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/l3-vni YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L3VniPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L3VniPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/l3-vni YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L3VniPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_MacAddressPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/mac-address YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_MacAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_MacAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/mac-address YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_MacAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_VlanPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/vlan YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_VlanPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_VlanPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/vlan YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_VlanPathAny struct {
	*ygot.NodePath
}

// Evi (leaf): EVPN Instance Identifier for the MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/evi"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/evi"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath) Evi() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_EviPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_EviPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "evi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Evi (leaf): EVPN Instance Identifier for the MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/evi"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/evi"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny) Evi() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_EviPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_EviPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "evi"},
			map[string]interface{}{},
			n,
		),
	}
}

// HostIp (leaf): Host IP address of the CE device for the L2RIB MAC-IP entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/host-ip"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/host-ip"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath) HostIp() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_HostIpPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_HostIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "host-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// HostIp (leaf): Host IP address of the CE device for the L2RIB MAC-IP entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/host-ip"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/host-ip"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny) HostIp() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_HostIpPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_HostIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "host-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2Vni (leaf): Layer2 VNI segment mapped to given vlan-id
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l2-vni"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/l2-vni"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath) L2Vni() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L2VniPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L2VniPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l2-vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2Vni (leaf): Layer2 VNI segment mapped to given vlan-id
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l2-vni"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/l2-vni"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny) L2Vni() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L2VniPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L2VniPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l2-vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3Vni (leaf): Symmetric IRB uses the same forwarding semantics when routing
// between IP subnets with VRF Lite or MPLS L3VPNs. With symmetric IRB,
// all traffic egressing and returning from a VTEP uses the same VNI.
// Specifically, the same Layer 3 VNI (L3VNI) associated with the VRF
// is used for all routed traffic. Layer3 VNI used for inter-subnet
// routing
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l3-vni"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/l3-vni"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath) L3Vni() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L3VniPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L3VniPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l3-vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3Vni (leaf): Symmetric IRB uses the same forwarding semantics when routing
// between IP subnets with VRF Lite or MPLS L3VPNs. With symmetric IRB,
// all traffic egressing and returning from a VTEP uses the same VNI.
// Specifically, the same Layer 3 VNI (L3VNI) associated with the VRF
// is used for all routed traffic. Layer3 VNI used for inter-subnet
// routing
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l3-vni"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/l3-vni"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny) L3Vni() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L3VniPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_L3VniPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l3-vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): MAC address of the L2RIB MAC or MAC-IP entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/mac-address"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath) MacAddress() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_MacAddressPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_MacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): MAC address of the L2RIB MAC or MAC-IP entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/mac-address"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny) MacAddress() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_MacAddressPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_MacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProducerAny (list): List of producers for each MAC-IP table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "producers/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer"
// Producer (wildcarded): E_Producer_Producer
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath) ProducerAny() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"producers", "producer"},
			map[string]interface{}{"producer": "*"},
			n,
		),
	}
}

// ProducerAny (list): List of producers for each MAC-IP table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "producers/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer"
// Producer (wildcarded): E_Producer_Producer
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny) ProducerAny() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"producers", "producer"},
			map[string]interface{}{"producer": "*"},
			n,
		),
	}
}

// Producer (list): List of producers for each MAC-IP table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "producers/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer"
// Producer: E_Producer_Producer
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath) Producer(Producer E_Producer_Producer) *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath{
		NodePath: ygot.NewNodePath(
			[]string{"producers", "producer"},
			map[string]interface{}{"producer": Producer},
			n,
		),
	}
}

// Producer (list): List of producers for each MAC-IP table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "producers/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer"
// Producer: E_Producer_Producer
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny) Producer(Producer E_Producer_Producer) *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"producers", "producer"},
			map[string]interface{}{"producer": Producer},
			n,
		),
	}
}

// Vlan (leaf): VLAN on which the MAC or MAC-IP address is present.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vlan"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/vlan"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPath) Vlan() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_VlanPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_VlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (leaf): VLAN on which the MAC or MAC-IP address is present.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vlan"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/state/vlan"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_EntryPathAny) Vlan() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_VlanPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_EsiPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/esi YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_EsiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_EsiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/esi YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_EsiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_MobilityStatePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/mobility-state YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_MobilityStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_MobilityStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/mobility-state YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_MobilityStatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/next-hop YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/next-hop YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_ProducerPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/producer YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_ProducerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_ProducerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/producer YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_ProducerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_SeqNumberPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/seq-number YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_SeqNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_SeqNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/seq-number YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_SeqNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_StickyPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/sticky YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_StickyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_StickyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/sticky YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_StickyPathAny struct {
	*ygot.NodePath
}

// Esi (leaf): Ethernet Segment Identifier for local and remote routes
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/esi"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath) Esi() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_EsiPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_EsiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): Ethernet Segment Identifier for local and remote routes
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/esi"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny) Esi() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_EsiPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_EsiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// MobilityState (leaf): Indicates if learned MAC address is duplicate or frozen
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mobility-state"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/mobility-state"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath) MobilityState() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_MobilityStatePath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_MobilityStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mobility-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// MobilityState (leaf): Indicates if learned MAC address is duplicate or frozen
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mobility-state"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/mobility-state"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny) MobilityState() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_MobilityStatePathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_MobilityStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mobility-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): Leafref next-hop for the MAC-IP table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/next-hop"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath) NextHop() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_NextHopPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): Leafref next-hop for the MAC-IP table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/next-hop"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny) NextHop() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_NextHopPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// Producer (leaf): Source of the learned L2RIB route
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/producer"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath) Producer() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_ProducerPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_ProducerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "producer"},
			map[string]interface{}{},
			n,
		),
	}
}

// Producer (leaf): Source of the learned L2RIB route
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/producer"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny) Producer() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_ProducerPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_ProducerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "producer"},
			map[string]interface{}{},
			n,
		),
	}
}

// SeqNumber (leaf): The sequence number is used to ensure that PEs retain the correct
// MAC/IP Advertisement route when multiple updates occur for the same
// MAC address
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/seq-number"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/seq-number"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath) SeqNumber() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_SeqNumberPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_SeqNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "seq-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// SeqNumber (leaf): The sequence number is used to ensure that PEs retain the correct
// MAC/IP Advertisement route when multiple updates occur for the same
// MAC address
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/seq-number"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/seq-number"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny) SeqNumber() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_SeqNumberPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_SeqNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "seq-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sticky (leaf): MAC address is sticky and not subjected to MAC moves
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sticky"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/sticky"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPath) Sticky() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_StickyPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_StickyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sticky"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sticky (leaf): MAC address is sticky and not subjected to MAC moves
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sticky"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/entries/entry/producers/producer/state/sticky"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_ProducerPathAny) Sticky() *NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_StickyPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_Entry_Producer_StickyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sticky"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/interface YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/interface YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/label YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/label YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_PeerIpPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/peer-ip YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_PeerIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_PeerIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/peer-ip YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_PeerIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/subinterface YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/subinterface YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Index (leaf): A unique entry for the next-hop.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/index"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPath) Index() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_IndexPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): A unique entry for the next-hop.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/index"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny) Index() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_IndexPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/interface"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPath) Interface() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_InterfacePath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/interface"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny) Interface() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_InterfacePathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): Next hop label representing the l2vni for the route
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/label"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPath) Label() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_LabelPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): Next hop label representing the l2vni for the route
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/label"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny) Label() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_LabelPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): Next hop peer address
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/peer-ip"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPath) PeerIp() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_PeerIpPath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_PeerIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): Next hop peer address
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/peer-ip"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny) PeerIp() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_PeerIpPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_PeerIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/subinterface"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPath) Subinterface() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_SubinterfacePath {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-ip-table/next-hops/next-hop/state/subinterface"
func (n *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHopPathAny) Subinterface() *NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_SubinterfacePathAny {
	return &NetworkInstance_Fdb_L2Rib_MacIpTable_NextHop_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_L2Rib_MacTablePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTablePathAny struct {
	*ygot.NodePath
}

// EntryAny (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry"
// MacAddress (wildcarded): string
func (n *NetworkInstance_Fdb_L2Rib_MacTablePath) EntryAny() *NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*"},
			n,
		),
	}
}

// EntryAny (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry"
// MacAddress (wildcarded): string
func (n *NetworkInstance_Fdb_L2Rib_MacTablePathAny) EntryAny() *NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*"},
			n,
		),
	}
}

// Entry (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry"
// MacAddress: string
func (n *NetworkInstance_Fdb_L2Rib_MacTablePath) Entry(MacAddress string) *NetworkInstance_Fdb_L2Rib_MacTable_EntryPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_EntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress},
			n,
		),
	}
}

// Entry (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry"
// MacAddress: string
func (n *NetworkInstance_Fdb_L2Rib_MacTablePathAny) Entry(MacAddress string) *NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress},
			n,
		),
	}
}

// NextHopAny (list): List of next hop attributes for each MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_Fdb_L2Rib_MacTablePath) NextHopAny() *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHopAny (list): List of next hop attributes for each MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_Fdb_L2Rib_MacTablePathAny) NextHopAny() *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHop (list): List of next hop attributes for each MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_Fdb_L2Rib_MacTablePath) NextHop(Index uint64) *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NextHop (list): List of next hop attributes for each MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_Fdb_L2Rib_MacTablePathAny) NextHop(Index uint64) *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NetworkInstance_Fdb_L2Rib_MacTable_EntryPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_EntryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_EviPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/evi YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_EviPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_EviPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/evi YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_EviPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_L2VniPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/l2-vni YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_L2VniPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_L2VniPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/l2-vni YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_L2VniPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_MacAddressPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/mac-address YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_MacAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_MacAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/mac-address YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_MacAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_VlanPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/vlan YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_VlanPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_VlanPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/vlan YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_VlanPathAny struct {
	*ygot.NodePath
}

// Evi (leaf): EVPN Instance Identifier for the MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/evi"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/evi"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPath) Evi() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_EviPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_EviPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "evi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Evi (leaf): EVPN Instance Identifier for the MAC or MAC-IP
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/evi"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/evi"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny) Evi() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_EviPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_EviPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "evi"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2Vni (leaf): Layer2 VNI segment mapped to given vlan-id
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l2-vni"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/l2-vni"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPath) L2Vni() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_L2VniPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_L2VniPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l2-vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2Vni (leaf): Layer2 VNI segment mapped to given vlan-id
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/l2-vni"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/l2-vni"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny) L2Vni() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_L2VniPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_L2VniPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "l2-vni"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): MAC address of the L2RIB MAC or MAC-IP entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/mac-address"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPath) MacAddress() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_MacAddressPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_MacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): MAC address of the L2RIB MAC or MAC-IP entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/mac-address"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny) MacAddress() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_MacAddressPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_MacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProducerAny (list): List of producers for each MAC table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "producers/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer"
// Producer (wildcarded): E_Producer_Producer
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPath) ProducerAny() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"producers", "producer"},
			map[string]interface{}{"producer": "*"},
			n,
		),
	}
}

// ProducerAny (list): List of producers for each MAC table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "producers/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer"
// Producer (wildcarded): E_Producer_Producer
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny) ProducerAny() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"producers", "producer"},
			map[string]interface{}{"producer": "*"},
			n,
		),
	}
}

// Producer (list): List of producers for each MAC table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "producers/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer"
// Producer: E_Producer_Producer
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPath) Producer(Producer E_Producer_Producer) *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath{
		NodePath: ygot.NewNodePath(
			[]string{"producers", "producer"},
			map[string]interface{}{"producer": Producer},
			n,
		),
	}
}

// Producer (list): List of producers for each MAC table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "producers/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer"
// Producer: E_Producer_Producer
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny) Producer(Producer E_Producer_Producer) *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"producers", "producer"},
			map[string]interface{}{"producer": Producer},
			n,
		),
	}
}

// Vlan (leaf): VLAN on which the MAC or MAC-IP address is present.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vlan"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/vlan"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPath) Vlan() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_VlanPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_VlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (leaf): VLAN on which the MAC or MAC-IP address is present.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/vlan"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/state/vlan"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_EntryPathAny) Vlan() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_VlanPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DerivedFromMacIpPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/derived-from-mac-ip YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DerivedFromMacIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DerivedFromMacIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/derived-from-mac-ip YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DerivedFromMacIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DirectlyReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/directly-received YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DirectlyReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DirectlyReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/directly-received YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DirectlyReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_EsiPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/esi YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_EsiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_EsiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/esi YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_EsiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_MobilityStatePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/mobility-state YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_MobilityStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_MobilityStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/mobility-state YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_MobilityStatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/next-hop YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/next-hop YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_ProducerPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/producer YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_ProducerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_ProducerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/producer YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_ProducerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_SeqNumberPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/seq-number YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_SeqNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_SeqNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/seq-number YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_SeqNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_StickyPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/sticky YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_StickyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_StickyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/sticky YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_StickyPathAny struct {
	*ygot.NodePath
}

// DerivedFromMacIp (leaf): Derived from BGP MAC-IP route-type 2
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/derived-from-mac-ip"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/derived-from-mac-ip"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath) DerivedFromMacIp() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DerivedFromMacIpPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DerivedFromMacIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "derived-from-mac-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// DerivedFromMacIp (leaf): Derived from BGP MAC-IP route-type 2
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/derived-from-mac-ip"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/derived-from-mac-ip"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny) DerivedFromMacIp() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DerivedFromMacIpPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DerivedFromMacIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "derived-from-mac-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// DirectlyReceived (leaf): BGP learned MAC route-type 2
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/directly-received"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/directly-received"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath) DirectlyReceived() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DirectlyReceivedPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DirectlyReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "directly-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DirectlyReceived (leaf): BGP learned MAC route-type 2
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/directly-received"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/directly-received"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny) DirectlyReceived() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DirectlyReceivedPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_DirectlyReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "directly-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): Ethernet Segment Identifier for local and remote routes
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/esi"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath) Esi() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_EsiPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_EsiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): Ethernet Segment Identifier for local and remote routes
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/esi"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny) Esi() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_EsiPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_EsiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// MobilityState (leaf): Indicates if learned MAC address is duplicate or frozen
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mobility-state"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/mobility-state"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath) MobilityState() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_MobilityStatePath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_MobilityStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mobility-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// MobilityState (leaf): Indicates if learned MAC address is duplicate or frozen
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mobility-state"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/mobility-state"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny) MobilityState() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_MobilityStatePathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_MobilityStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mobility-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): Leafref next-hop for the MAC-IP table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/next-hop"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath) NextHop() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_NextHopPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): Leafref next-hop for the MAC-IP table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/next-hop"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny) NextHop() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_NextHopPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// Producer (leaf): Source of the learned L2RIB route
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/producer"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath) Producer() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_ProducerPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_ProducerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "producer"},
			map[string]interface{}{},
			n,
		),
	}
}

// Producer (leaf): Source of the learned L2RIB route
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/producer"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/producer"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny) Producer() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_ProducerPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_ProducerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "producer"},
			map[string]interface{}{},
			n,
		),
	}
}

// SeqNumber (leaf): The sequence number is used to ensure that PEs retain the correct
// MAC/IP Advertisement route when multiple updates occur for the same
// MAC address
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/seq-number"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/seq-number"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath) SeqNumber() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_SeqNumberPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_SeqNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "seq-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// SeqNumber (leaf): The sequence number is used to ensure that PEs retain the correct
// MAC/IP Advertisement route when multiple updates occur for the same
// MAC address
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/seq-number"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/seq-number"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny) SeqNumber() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_SeqNumberPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_SeqNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "seq-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sticky (leaf): MAC address is sticky and not subjected to MAC moves
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sticky"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/sticky"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPath) Sticky() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_StickyPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_StickyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sticky"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sticky (leaf): MAC address is sticky and not subjected to MAC moves
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sticky"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/entries/entry/producers/producer/state/sticky"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_Entry_ProducerPathAny) Sticky() *NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_StickyPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_Entry_Producer_StickyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sticky"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/interface YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/interface YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/label YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/label YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_PeerIpPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/peer-ip YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_PeerIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_PeerIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/peer-ip YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_PeerIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/subinterface YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_L2Rib_MacTable_NextHop_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/subinterface YANG schema element.
type NetworkInstance_Fdb_L2Rib_MacTable_NextHop_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Index (leaf): A unique entry for the next-hop.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/index"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPath) Index() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_IndexPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): A unique entry for the next-hop.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/index"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny) Index() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_IndexPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/interface"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPath) Interface() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_InterfacePath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/interface"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny) Interface() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_InterfacePathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): Next hop label representing the l2vni for the route
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/label"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPath) Label() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_LabelPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): Next hop label representing the l2vni for the route
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/label"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny) Label() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_LabelPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): Next hop peer address
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/peer-ip"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPath) PeerIp() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_PeerIpPath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_PeerIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): Next hop peer address
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/peer-ip"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny) PeerIp() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_PeerIpPathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_PeerIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/subinterface"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPath) Subinterface() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_SubinterfacePath {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/fdb/l2rib/mac-table/next-hops/next-hop/state/subinterface"
func (n *NetworkInstance_Fdb_L2Rib_MacTable_NextHopPathAny) Subinterface() *NetworkInstance_Fdb_L2Rib_MacTable_NextHop_SubinterfacePathAny {
	return &NetworkInstance_Fdb_L2Rib_MacTable_NextHop_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_MacMobilityPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility YANG schema element.
type NetworkInstance_Fdb_MacMobilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility YANG schema element.
type NetworkInstance_Fdb_MacMobilityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_DuplicateIpDetectionIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/duplicate-ip-detection-interval YANG schema element.
type NetworkInstance_Fdb_MacMobility_DuplicateIpDetectionIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_DuplicateIpDetectionIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/duplicate-ip-detection-interval YANG schema element.
type NetworkInstance_Fdb_MacMobility_DuplicateIpDetectionIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_IpMobilityThresholdPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/ip-mobility-threshold YANG schema element.
type NetworkInstance_Fdb_MacMobility_IpMobilityThresholdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_IpMobilityThresholdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/ip-mobility-threshold YANG schema element.
type NetworkInstance_Fdb_MacMobility_IpMobilityThresholdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_MacMobilityPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility YANG schema element.
type NetworkInstance_Fdb_MacMobility_MacMobilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_MacMobilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility YANG schema element.
type NetworkInstance_Fdb_MacMobility_MacMobilityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_MacMobilityThresholdPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility-threshold YANG schema element.
type NetworkInstance_Fdb_MacMobility_MacMobilityThresholdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_MacMobilityThresholdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility-threshold YANG schema element.
type NetworkInstance_Fdb_MacMobility_MacMobilityThresholdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_MacMobilityWindowPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility-window YANG schema element.
type NetworkInstance_Fdb_MacMobility_MacMobilityWindowPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacMobility_MacMobilityWindowPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility-window YANG schema element.
type NetworkInstance_Fdb_MacMobility_MacMobilityWindowPathAny struct {
	*ygot.NodePath
}

// DuplicateIpDetectionInterval (leaf): The time interval used in detecting a duplicate IP address.
// Duplicate ip detection number of host moves
// allowed within interval period
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/duplicate-ip-detection-interval"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/duplicate-ip-detection-interval"
func (n *NetworkInstance_Fdb_MacMobilityPath) DuplicateIpDetectionInterval() *NetworkInstance_Fdb_MacMobility_DuplicateIpDetectionIntervalPath {
	return &NetworkInstance_Fdb_MacMobility_DuplicateIpDetectionIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "duplicate-ip-detection-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// DuplicateIpDetectionInterval (leaf): The time interval used in detecting a duplicate IP address.
// Duplicate ip detection number of host moves
// allowed within interval period
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/duplicate-ip-detection-interval"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/duplicate-ip-detection-interval"
func (n *NetworkInstance_Fdb_MacMobilityPathAny) DuplicateIpDetectionInterval() *NetworkInstance_Fdb_MacMobility_DuplicateIpDetectionIntervalPathAny {
	return &NetworkInstance_Fdb_MacMobility_DuplicateIpDetectionIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "duplicate-ip-detection-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpMobilityThreshold (leaf): Enable (TRUE) or disable (FALSE). It is possible for a given host
// or end-station (as defined by its IP address) to move from one
// Ethernet segment to another. The number of IP mobility events that
// are detected for a given IP address within the detection-threshold
// before it is identified as a duplicate IP address.
// Once the detection threshold is reached, updates for the IP address
// are suppressed.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ip-mobility-threshold"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/ip-mobility-threshold"
func (n *NetworkInstance_Fdb_MacMobilityPath) IpMobilityThreshold() *NetworkInstance_Fdb_MacMobility_IpMobilityThresholdPath {
	return &NetworkInstance_Fdb_MacMobility_IpMobilityThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-mobility-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpMobilityThreshold (leaf): Enable (TRUE) or disable (FALSE). It is possible for a given host
// or end-station (as defined by its IP address) to move from one
// Ethernet segment to another. The number of IP mobility events that
// are detected for a given IP address within the detection-threshold
// before it is identified as a duplicate IP address.
// Once the detection threshold is reached, updates for the IP address
// are suppressed.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ip-mobility-threshold"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/ip-mobility-threshold"
func (n *NetworkInstance_Fdb_MacMobilityPathAny) IpMobilityThreshold() *NetworkInstance_Fdb_MacMobility_IpMobilityThresholdPathAny {
	return &NetworkInstance_Fdb_MacMobility_IpMobilityThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-mobility-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacMobility (leaf): Enable (TRUE) or disable (FALSE). It is possible for a given host
// or end-station (as defined by its MAC address) to move from one
// Ethernet segment to another; this is referred to as 'MAC Mobility'
// or 'MAC move. The configuration attributes includes: mac-mobility-window
// and mac-mobility-threshold
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-mobility"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility"
func (n *NetworkInstance_Fdb_MacMobilityPath) MacMobility() *NetworkInstance_Fdb_MacMobility_MacMobilityPath {
	return &NetworkInstance_Fdb_MacMobility_MacMobilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-mobility"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacMobility (leaf): Enable (TRUE) or disable (FALSE). It is possible for a given host
// or end-station (as defined by its MAC address) to move from one
// Ethernet segment to another; this is referred to as 'MAC Mobility'
// or 'MAC move. The configuration attributes includes: mac-mobility-window
// and mac-mobility-threshold
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-mobility"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility"
func (n *NetworkInstance_Fdb_MacMobilityPathAny) MacMobility() *NetworkInstance_Fdb_MacMobility_MacMobilityPathAny {
	return &NetworkInstance_Fdb_MacMobility_MacMobilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-mobility"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacMobilityThreshold (leaf): The number of MAC mobility events that are detected for a
// given MAC address within the detection-window before it is identified
// as a duplicate MAC address. Once the detection threshold is reached,
// updates for the MAC address are suppressed.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-mobility-threshold"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility-threshold"
func (n *NetworkInstance_Fdb_MacMobilityPath) MacMobilityThreshold() *NetworkInstance_Fdb_MacMobility_MacMobilityThresholdPath {
	return &NetworkInstance_Fdb_MacMobility_MacMobilityThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-mobility-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacMobilityThreshold (leaf): The number of MAC mobility events that are detected for a
// given MAC address within the detection-window before it is identified
// as a duplicate MAC address. Once the detection threshold is reached,
// updates for the MAC address are suppressed.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-mobility-threshold"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility-threshold"
func (n *NetworkInstance_Fdb_MacMobilityPathAny) MacMobilityThreshold() *NetworkInstance_Fdb_MacMobility_MacMobilityThresholdPathAny {
	return &NetworkInstance_Fdb_MacMobility_MacMobilityThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-mobility-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacMobilityWindow (leaf): The time interval used in detecting a duplicate MAC address.
// The value can be from 5 through 600 seconds.
// The default is 180 seconds
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-mobility-window"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility-window"
func (n *NetworkInstance_Fdb_MacMobilityPath) MacMobilityWindow() *NetworkInstance_Fdb_MacMobility_MacMobilityWindowPath {
	return &NetworkInstance_Fdb_MacMobility_MacMobilityWindowPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-mobility-window"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacMobilityWindow (leaf): The time interval used in detecting a duplicate MAC address.
// The value can be from 5 through 600 seconds.
// The default is 180 seconds
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-mobility-window"
// Path from root: "/network-instances/network-instance/fdb/mac-mobility/config/mac-mobility-window"
func (n *NetworkInstance_Fdb_MacMobilityPathAny) MacMobilityWindow() *NetworkInstance_Fdb_MacMobility_MacMobilityWindowPathAny {
	return &NetworkInstance_Fdb_MacMobility_MacMobilityWindowPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-mobility-window"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_MacTablePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table YANG schema element.
type NetworkInstance_Fdb_MacTablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table YANG schema element.
type NetworkInstance_Fdb_MacTablePathAny struct {
	*ygot.NodePath
}

// EntryAny (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry"
// MacAddress (wildcarded): string
// Vlan (wildcarded): uint16
func (n *NetworkInstance_Fdb_MacTablePath) EntryAny() *NetworkInstance_Fdb_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*", "vlan": "*"},
			n,
		),
	}
}

// EntryAny (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry"
// MacAddress (wildcarded): string
// Vlan (wildcarded): uint16
func (n *NetworkInstance_Fdb_MacTablePathAny) EntryAny() *NetworkInstance_Fdb_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*", "vlan": "*"},
			n,
		),
	}
}

// EntryAnyVlan (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry"
// MacAddress: string
// Vlan (wildcarded): uint16
func (n *NetworkInstance_Fdb_MacTablePath) EntryAnyVlan(MacAddress string) *NetworkInstance_Fdb_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress, "vlan": "*"},
			n,
		),
	}
}

// EntryAnyVlan (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry"
// MacAddress: string
// Vlan (wildcarded): uint16
func (n *NetworkInstance_Fdb_MacTablePathAny) EntryAnyVlan(MacAddress string) *NetworkInstance_Fdb_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress, "vlan": "*"},
			n,
		),
	}
}

// EntryAnyMacAddress (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry"
// MacAddress (wildcarded): string
// Vlan: uint16
func (n *NetworkInstance_Fdb_MacTablePath) EntryAnyMacAddress(Vlan uint16) *NetworkInstance_Fdb_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*", "vlan": Vlan},
			n,
		),
	}
}

// EntryAnyMacAddress (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry"
// MacAddress (wildcarded): string
// Vlan: uint16
func (n *NetworkInstance_Fdb_MacTablePathAny) EntryAnyMacAddress(Vlan uint16) *NetworkInstance_Fdb_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": "*", "vlan": Vlan},
			n,
		),
	}
}

// Entry (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry"
// MacAddress: string
// Vlan: uint16
func (n *NetworkInstance_Fdb_MacTablePath) Entry(MacAddress string, Vlan uint16) *NetworkInstance_Fdb_MacTable_EntryPath {
	return &NetworkInstance_Fdb_MacTable_EntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress, "vlan": Vlan},
			n,
		),
	}
}

// Entry (list): List of learned MAC addresses
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "entries/entry"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry"
// MacAddress: string
// Vlan: uint16
func (n *NetworkInstance_Fdb_MacTablePathAny) Entry(MacAddress string, Vlan uint16) *NetworkInstance_Fdb_MacTable_EntryPathAny {
	return &NetworkInstance_Fdb_MacTable_EntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"entries", "entry"},
			map[string]interface{}{"mac-address": MacAddress, "vlan": Vlan},
			n,
		),
	}
}

// NetworkInstance_Fdb_MacTable_EntryPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry YANG schema element.
type NetworkInstance_Fdb_MacTable_EntryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_EntryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry YANG schema element.
type NetworkInstance_Fdb_MacTable_EntryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_AgePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/state/age YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_AgePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_AgePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/state/age YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_AgePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_EntryTypePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/state/entry-type YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_EntryTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_EntryTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/state/entry-type YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_EntryTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_EviPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/state/evi YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_EviPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_EviPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/state/evi YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_EviPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_MacAddressPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/config/mac-address YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_MacAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_MacAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/config/mac-address YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_MacAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_VlanPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/config/vlan YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_VlanPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_VlanPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/config/vlan YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_VlanPathAny struct {
	*ygot.NodePath
}

// Age (leaf): The time in seconds since the MAC address has been in the
// table
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/age"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/state/age"
func (n *NetworkInstance_Fdb_MacTable_EntryPath) Age() *NetworkInstance_Fdb_MacTable_Entry_AgePath {
	return &NetworkInstance_Fdb_MacTable_Entry_AgePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "age"},
			map[string]interface{}{},
			n,
		),
	}
}

// Age (leaf): The time in seconds since the MAC address has been in the
// table
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/age"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/state/age"
func (n *NetworkInstance_Fdb_MacTable_EntryPathAny) Age() *NetworkInstance_Fdb_MacTable_Entry_AgePathAny {
	return &NetworkInstance_Fdb_MacTable_Entry_AgePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "age"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryType (leaf): Indicates whether the entry was statically configured, or
// dynamically learned.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-type"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/state/entry-type"
func (n *NetworkInstance_Fdb_MacTable_EntryPath) EntryType() *NetworkInstance_Fdb_MacTable_Entry_EntryTypePath {
	return &NetworkInstance_Fdb_MacTable_Entry_EntryTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryType (leaf): Indicates whether the entry was statically configured, or
// dynamically learned.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-type"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/state/entry-type"
func (n *NetworkInstance_Fdb_MacTable_EntryPathAny) EntryType() *NetworkInstance_Fdb_MacTable_Entry_EntryTypePathAny {
	return &NetworkInstance_Fdb_MacTable_Entry_EntryTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Evi (leaf): EVPN EVI to associate with the BD/VLAN
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/evi"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/state/evi"
func (n *NetworkInstance_Fdb_MacTable_EntryPath) Evi() *NetworkInstance_Fdb_MacTable_Entry_EviPath {
	return &NetworkInstance_Fdb_MacTable_Entry_EviPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "evi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Evi (leaf): EVPN EVI to associate with the BD/VLAN
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/evi"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/state/evi"
func (n *NetworkInstance_Fdb_MacTable_EntryPathAny) Evi() *NetworkInstance_Fdb_MacTable_Entry_EviPathAny {
	return &NetworkInstance_Fdb_MacTable_Entry_EviPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "evi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (container): Reference to the base and/or subinterface for the
// MAC table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/interface"
func (n *NetworkInstance_Fdb_MacTable_EntryPath) Interface() *NetworkInstance_Fdb_MacTable_Entry_InterfacePath {
	return &NetworkInstance_Fdb_MacTable_Entry_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (container): Reference to the base and/or subinterface for the
// MAC table entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/interface"
func (n *NetworkInstance_Fdb_MacTable_EntryPathAny) Interface() *NetworkInstance_Fdb_MacTable_Entry_InterfacePathAny {
	return &NetworkInstance_Fdb_MacTable_Entry_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): MAC address for the dynamic or static MAC table
// entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-address"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/config/mac-address"
func (n *NetworkInstance_Fdb_MacTable_EntryPath) MacAddress() *NetworkInstance_Fdb_MacTable_Entry_MacAddressPath {
	return &NetworkInstance_Fdb_MacTable_Entry_MacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): MAC address for the dynamic or static MAC table
// entry
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-address"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/config/mac-address"
func (n *NetworkInstance_Fdb_MacTable_EntryPathAny) MacAddress() *NetworkInstance_Fdb_MacTable_Entry_MacAddressPathAny {
	return &NetworkInstance_Fdb_MacTable_Entry_MacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (leaf): VLAN on which the MAC address is present. The same MAC
// address may be seen on multiple VLANs in some cases.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/vlan"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/config/vlan"
func (n *NetworkInstance_Fdb_MacTable_EntryPath) Vlan() *NetworkInstance_Fdb_MacTable_Entry_VlanPath {
	return &NetworkInstance_Fdb_MacTable_Entry_VlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (leaf): VLAN on which the MAC address is present. The same MAC
// address may be seen on multiple VLANs in some cases.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/vlan"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/config/vlan"
func (n *NetworkInstance_Fdb_MacTable_EntryPathAny) Vlan() *NetworkInstance_Fdb_MacTable_Entry_VlanPathAny {
	return &NetworkInstance_Fdb_MacTable_Entry_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_MacTable_Entry_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/interface YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/interface YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_InterfacePathAny struct {
	*ygot.NodePath
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref"
func (n *NetworkInstance_Fdb_MacTable_Entry_InterfacePath) InterfaceRef() *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPath {
	return &NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref"
func (n *NetworkInstance_Fdb_MacTable_Entry_InterfacePathAny) InterfaceRef() *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref/config/interface"
func (n *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPath) Interface() *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref/config/interface"
func (n *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/fdb/mac-table/entries/entry/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Fdb_MacTable_Entry_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Fdb_NdProxyPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy YANG schema element.
type NetworkInstance_Fdb_NdProxyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_NdProxyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy YANG schema element.
type NetworkInstance_Fdb_NdProxyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_NdProxy_DuplicateIpDetectionIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy/config/duplicate-ip-detection-interval YANG schema element.
type NetworkInstance_Fdb_NdProxy_DuplicateIpDetectionIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_NdProxy_DuplicateIpDetectionIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy/config/duplicate-ip-detection-interval YANG schema element.
type NetworkInstance_Fdb_NdProxy_DuplicateIpDetectionIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_NdProxy_EnablePath represents the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy/config/enable YANG schema element.
type NetworkInstance_Fdb_NdProxy_EnablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_NdProxy_EnablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy/config/enable YANG schema element.
type NetworkInstance_Fdb_NdProxy_EnablePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_NdProxy_IpMobilityThresholdPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy/config/ip-mobility-threshold YANG schema element.
type NetworkInstance_Fdb_NdProxy_IpMobilityThresholdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_NdProxy_IpMobilityThresholdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy/config/ip-mobility-threshold YANG schema element.
type NetworkInstance_Fdb_NdProxy_IpMobilityThresholdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_NdProxy_NdSuppressionPath represents the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy/config/nd-suppression YANG schema element.
type NetworkInstance_Fdb_NdProxy_NdSuppressionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Fdb_NdProxy_NdSuppressionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/fdb/nd-proxy/config/nd-suppression YANG schema element.
type NetworkInstance_Fdb_NdProxy_NdSuppressionPathAny struct {
	*ygot.NodePath
}

// DuplicateIpDetectionInterval (leaf): The time interval used in detecting a duplicate IP address.
// Duplicate ip detection number of host moves
// allowed within interval period
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/duplicate-ip-detection-interval"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy/config/duplicate-ip-detection-interval"
func (n *NetworkInstance_Fdb_NdProxyPath) DuplicateIpDetectionInterval() *NetworkInstance_Fdb_NdProxy_DuplicateIpDetectionIntervalPath {
	return &NetworkInstance_Fdb_NdProxy_DuplicateIpDetectionIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "duplicate-ip-detection-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// DuplicateIpDetectionInterval (leaf): The time interval used in detecting a duplicate IP address.
// Duplicate ip detection number of host moves
// allowed within interval period
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/duplicate-ip-detection-interval"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy/config/duplicate-ip-detection-interval"
func (n *NetworkInstance_Fdb_NdProxyPathAny) DuplicateIpDetectionInterval() *NetworkInstance_Fdb_NdProxy_DuplicateIpDetectionIntervalPathAny {
	return &NetworkInstance_Fdb_NdProxy_DuplicateIpDetectionIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "duplicate-ip-detection-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enable (TRUE) or disable (FALSE) Neighbor Discovery (ND)
// proxy. If true a proxy server on the network answers the
// NDP packets for an IP address that is not on that network.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy/config/enable"
func (n *NetworkInstance_Fdb_NdProxyPath) Enable() *NetworkInstance_Fdb_NdProxy_EnablePath {
	return &NetworkInstance_Fdb_NdProxy_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enable (TRUE) or disable (FALSE) Neighbor Discovery (ND)
// proxy. If true a proxy server on the network answers the
// NDP packets for an IP address that is not on that network.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy/config/enable"
func (n *NetworkInstance_Fdb_NdProxyPathAny) Enable() *NetworkInstance_Fdb_NdProxy_EnablePathAny {
	return &NetworkInstance_Fdb_NdProxy_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpMobilityThreshold (leaf): Enable (TRUE) or disable (FALSE). It is possible for a given host
// or end-station (as defined by its IP address) to move from one
// Ethernet segment to another. The number of IP mobility events that
// are detected for a given IP address within the detection-threshold
// before it is identified as a duplicate IP address.
// Once the detection threshold is reached, updates for the IP address
// are suppressed.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ip-mobility-threshold"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy/config/ip-mobility-threshold"
func (n *NetworkInstance_Fdb_NdProxyPath) IpMobilityThreshold() *NetworkInstance_Fdb_NdProxy_IpMobilityThresholdPath {
	return &NetworkInstance_Fdb_NdProxy_IpMobilityThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-mobility-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpMobilityThreshold (leaf): Enable (TRUE) or disable (FALSE). It is possible for a given host
// or end-station (as defined by its IP address) to move from one
// Ethernet segment to another. The number of IP mobility events that
// are detected for a given IP address within the detection-threshold
// before it is identified as a duplicate IP address.
// Once the detection threshold is reached, updates for the IP address
// are suppressed.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ip-mobility-threshold"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy/config/ip-mobility-threshold"
func (n *NetworkInstance_Fdb_NdProxyPathAny) IpMobilityThreshold() *NetworkInstance_Fdb_NdProxy_IpMobilityThresholdPathAny {
	return &NetworkInstance_Fdb_NdProxy_IpMobilityThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-mobility-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// NdSuppression (leaf): Enable (TRUE) or disable (FALSE) Neighbor Discovery suppression.
// If true the NDP queries for an IP address that is not on that
// network are suppressed. NDP suppression is a
// technique used to reduce the amount of NDP Packets
// flooding within individual VXLAN segments, that is between
// VMs connected to the same logical switch.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/nd-suppression"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy/config/nd-suppression"
func (n *NetworkInstance_Fdb_NdProxyPath) NdSuppression() *NetworkInstance_Fdb_NdProxy_NdSuppressionPath {
	return &NetworkInstance_Fdb_NdProxy_NdSuppressionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "nd-suppression"},
			map[string]interface{}{},
			n,
		),
	}
}

// NdSuppression (leaf): Enable (TRUE) or disable (FALSE) Neighbor Discovery suppression.
// If true the NDP queries for an IP address that is not on that
// network are suppressed. NDP suppression is a
// technique used to reduce the amount of NDP Packets
// flooding within individual VXLAN segments, that is between
// VMs connected to the same logical switch.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/nd-suppression"
// Path from root: "/network-instances/network-instance/fdb/nd-proxy/config/nd-suppression"
func (n *NetworkInstance_Fdb_NdProxyPathAny) NdSuppression() *NetworkInstance_Fdb_NdProxy_NdSuppressionPathAny {
	return &NetworkInstance_Fdb_NdProxy_NdSuppressionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "nd-suppression"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_InterInstancePoliciesPath represents the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies YANG schema element.
type NetworkInstance_InterInstancePoliciesPath struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePoliciesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies YANG schema element.
type NetworkInstance_InterInstancePoliciesPathAny struct {
	*ygot.NodePath
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy"
func (n *NetworkInstance_InterInstancePoliciesPath) ApplyPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicyPath {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy"
func (n *NetworkInstance_InterInstancePoliciesPathAny) ApplyPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicyPathAny {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportExportPolicy (container): Top container to set the import and export policies
// associated with a EVI
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "import-export-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/import-export-policy"
func (n *NetworkInstance_InterInstancePoliciesPath) ImportExportPolicy() *NetworkInstance_InterInstancePolicies_ImportExportPolicyPath {
	return &NetworkInstance_InterInstancePolicies_ImportExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"import-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportExportPolicy (container): Top container to set the import and export policies
// associated with a EVI
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "import-export-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/import-export-policy"
func (n *NetworkInstance_InterInstancePoliciesPathAny) ImportExportPolicy() *NetworkInstance_InterInstancePolicies_ImportExportPolicyPathAny {
	return &NetworkInstance_InterInstancePolicies_ImportExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"import-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_InterInstancePolicies_ApplyPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ApplyPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ApplyPolicy_ExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicy_ExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ApplyPolicy_ExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicy_ExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ApplyPolicy_ImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicy_ImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ApplyPolicy_ImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ApplyPolicy_ImportPolicyPathAny struct {
	*ygot.NodePath
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy/config/default-export-policy"
func (n *NetworkInstance_InterInstancePolicies_ApplyPolicyPath) DefaultExportPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultExportPolicyPath {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy/config/default-export-policy"
func (n *NetworkInstance_InterInstancePolicies_ApplyPolicyPathAny) DefaultExportPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultExportPolicyPathAny {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy/config/default-import-policy"
func (n *NetworkInstance_InterInstancePolicies_ApplyPolicyPath) DefaultImportPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultImportPolicyPath {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy/config/default-import-policy"
func (n *NetworkInstance_InterInstancePolicies_ApplyPolicyPathAny) DefaultImportPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultImportPolicyPathAny {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicy_DefaultImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy/config/export-policy"
func (n *NetworkInstance_InterInstancePolicies_ApplyPolicyPath) ExportPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicy_ExportPolicyPath {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicy_ExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy/config/export-policy"
func (n *NetworkInstance_InterInstancePolicies_ApplyPolicyPathAny) ExportPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicy_ExportPolicyPathAny {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicy_ExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy/config/import-policy"
func (n *NetworkInstance_InterInstancePolicies_ApplyPolicyPath) ImportPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicy_ImportPolicyPath {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicy_ImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/inter-instance-policies/apply-policy/config/import-policy"
func (n *NetworkInstance_InterInstancePolicies_ApplyPolicyPathAny) ImportPolicy() *NetworkInstance_InterInstancePolicies_ApplyPolicy_ImportPolicyPathAny {
	return &NetworkInstance_InterInstancePolicies_ApplyPolicy_ImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_InterInstancePolicies_ImportExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/import-export-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ImportExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ImportExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/import-export-policy YANG schema element.
type NetworkInstance_InterInstancePolicies_ImportExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ImportExportPolicy_ExportRouteTargetPath represents the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/import-export-policy/config/export-route-target YANG schema element.
type NetworkInstance_InterInstancePolicies_ImportExportPolicy_ExportRouteTargetPath struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ImportExportPolicy_ExportRouteTargetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/import-export-policy/config/export-route-target YANG schema element.
type NetworkInstance_InterInstancePolicies_ImportExportPolicy_ExportRouteTargetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ImportExportPolicy_ImportRouteTargetPath represents the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/import-export-policy/config/import-route-target YANG schema element.
type NetworkInstance_InterInstancePolicies_ImportExportPolicy_ImportRouteTargetPath struct {
	*ygot.NodePath
}

// NetworkInstance_InterInstancePolicies_ImportExportPolicy_ImportRouteTargetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/inter-instance-policies/import-export-policy/config/import-route-target YANG schema element.
type NetworkInstance_InterInstancePolicies_ImportExportPolicy_ImportRouteTargetPathAny struct {
	*ygot.NodePath
}

// ExportRouteTarget (leaf): Export Route Target (RT) in the network-instance on a PE.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-route-target"
// Path from root: "/network-instances/network-instance/inter-instance-policies/import-export-policy/config/export-route-target"
func (n *NetworkInstance_InterInstancePolicies_ImportExportPolicyPath) ExportRouteTarget() *NetworkInstance_InterInstancePolicies_ImportExportPolicy_ExportRouteTargetPath {
	return &NetworkInstance_InterInstancePolicies_ImportExportPolicy_ExportRouteTargetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-route-target"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportRouteTarget (leaf): Export Route Target (RT) in the network-instance on a PE.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-route-target"
// Path from root: "/network-instances/network-instance/inter-instance-policies/import-export-policy/config/export-route-target"
func (n *NetworkInstance_InterInstancePolicies_ImportExportPolicyPathAny) ExportRouteTarget() *NetworkInstance_InterInstancePolicies_ImportExportPolicy_ExportRouteTargetPathAny {
	return &NetworkInstance_InterInstancePolicies_ImportExportPolicy_ExportRouteTargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-route-target"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportRouteTarget (leaf): Import Route Target (RT) in the network-instance on a PE.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-route-target"
// Path from root: "/network-instances/network-instance/inter-instance-policies/import-export-policy/config/import-route-target"
func (n *NetworkInstance_InterInstancePolicies_ImportExportPolicyPath) ImportRouteTarget() *NetworkInstance_InterInstancePolicies_ImportExportPolicy_ImportRouteTargetPath {
	return &NetworkInstance_InterInstancePolicies_ImportExportPolicy_ImportRouteTargetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-route-target"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportRouteTarget (leaf): Import Route Target (RT) in the network-instance on a PE.
// ----------------------------------------
// Defining module: "openconfig-evpn"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-route-target"
// Path from root: "/network-instances/network-instance/inter-instance-policies/import-export-policy/config/import-route-target"
func (n *NetworkInstance_InterInstancePolicies_ImportExportPolicyPathAny) ImportRouteTarget() *NetworkInstance_InterInstancePolicies_ImportExportPolicy_ImportRouteTargetPathAny {
	return &NetworkInstance_InterInstancePolicies_ImportExportPolicy_ImportRouteTargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-route-target"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/interfaces/interface YANG schema element.
type NetworkInstance_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/interfaces/interface YANG schema element.
type NetworkInstance_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_AssociatedAddressFamiliesPath represents the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/associated-address-families YANG schema element.
type NetworkInstance_Interface_AssociatedAddressFamiliesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_AssociatedAddressFamiliesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/associated-address-families YANG schema element.
type NetworkInstance_Interface_AssociatedAddressFamiliesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_IdPath represents the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/id YANG schema element.
type NetworkInstance_Interface_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/id YANG schema element.
type NetworkInstance_Interface_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/interface YANG schema element.
type NetworkInstance_Interface_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/interface YANG schema element.
type NetworkInstance_Interface_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_IrbAnycastGatewayPath represents the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/irb-anycast-gateway YANG schema element.
type NetworkInstance_Interface_IrbAnycastGatewayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_IrbAnycastGatewayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/irb-anycast-gateway YANG schema element.
type NetworkInstance_Interface_IrbAnycastGatewayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_MacPinningPath represents the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/mac-pinning YANG schema element.
type NetworkInstance_Interface_MacPinningPath struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_MacPinningPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/mac-pinning YANG schema element.
type NetworkInstance_Interface_MacPinningPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/subinterface YANG schema element.
type NetworkInstance_Interface_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Interface_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/interfaces/interface/config/subinterface YANG schema element.
type NetworkInstance_Interface_SubinterfacePathAny struct {
	*ygot.NodePath
}

// AssociatedAddressFamilies (leaf): The address families on the subinterface which are to be
// associated with this network instance. When this leaf-list
// is empty and the network instance requires Layer 3 information
// the address families for which the network instance is
// enabled should be imported. If the value of this leaf-list
// is specified then the association MUST only be made for
// those address families that are included in the list.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/associated-address-families"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/associated-address-families"
func (n *NetworkInstance_InterfacePath) AssociatedAddressFamilies() *NetworkInstance_Interface_AssociatedAddressFamiliesPath {
	return &NetworkInstance_Interface_AssociatedAddressFamiliesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "associated-address-families"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssociatedAddressFamilies (leaf): The address families on the subinterface which are to be
// associated with this network instance. When this leaf-list
// is empty and the network instance requires Layer 3 information
// the address families for which the network instance is
// enabled should be imported. If the value of this leaf-list
// is specified then the association MUST only be made for
// those address families that are included in the list.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/associated-address-families"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/associated-address-families"
func (n *NetworkInstance_InterfacePathAny) AssociatedAddressFamilies() *NetworkInstance_Interface_AssociatedAddressFamiliesPathAny {
	return &NetworkInstance_Interface_AssociatedAddressFamiliesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "associated-address-families"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique identifier for this interface - this is expressed
// as a free-text string
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/id"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/id"
func (n *NetworkInstance_InterfacePath) Id() *NetworkInstance_Interface_IdPath {
	return &NetworkInstance_Interface_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique identifier for this interface - this is expressed
// as a free-text string
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/id"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/id"
func (n *NetworkInstance_InterfacePathAny) Id() *NetworkInstance_Interface_IdPathAny {
	return &NetworkInstance_Interface_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/interface"
func (n *NetworkInstance_InterfacePath) Interface() *NetworkInstance_Interface_InterfacePath {
	return &NetworkInstance_Interface_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/interface"
func (n *NetworkInstance_InterfacePathAny) Interface() *NetworkInstance_Interface_InterfacePathAny {
	return &NetworkInstance_Interface_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// IrbAnycastGateway (leaf): Associate VLAN SVI with anycast Gateway.
// The SVI is the layer3 interface for the mac-vrf
// when the SVI is being used as the first hop default gw.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/irb-anycast-gateway"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/irb-anycast-gateway"
func (n *NetworkInstance_InterfacePath) IrbAnycastGateway() *NetworkInstance_Interface_IrbAnycastGatewayPath {
	return &NetworkInstance_Interface_IrbAnycastGatewayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "irb-anycast-gateway"},
			map[string]interface{}{},
			n,
		),
	}
}

// IrbAnycastGateway (leaf): Associate VLAN SVI with anycast Gateway.
// The SVI is the layer3 interface for the mac-vrf
// when the SVI is being used as the first hop default gw.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/irb-anycast-gateway"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/irb-anycast-gateway"
func (n *NetworkInstance_InterfacePathAny) IrbAnycastGateway() *NetworkInstance_Interface_IrbAnycastGatewayPathAny {
	return &NetworkInstance_Interface_IrbAnycastGatewayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "irb-anycast-gateway"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacPinning (leaf): Enable (TRUE) or disable (FALSE). There are scenarios in which
// it is desired to configure some MAC addresses as static so
// that they are not subjected to MAC moves. If you enable MAC pinning
// on a CE interface, that MAC address cannot be moved to any
// other CE interface
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-pinning"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/mac-pinning"
func (n *NetworkInstance_InterfacePath) MacPinning() *NetworkInstance_Interface_MacPinningPath {
	return &NetworkInstance_Interface_MacPinningPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-pinning"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacPinning (leaf): Enable (TRUE) or disable (FALSE). There are scenarios in which
// it is desired to configure some MAC addresses as static so
// that they are not subjected to MAC moves. If you enable MAC pinning
// on a CE interface, that MAC address cannot be moved to any
// other CE interface
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mac-pinning"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/mac-pinning"
func (n *NetworkInstance_InterfacePathAny) MacPinning() *NetworkInstance_Interface_MacPinningPathAny {
	return &NetworkInstance_Interface_MacPinningPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mac-pinning"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/subinterface"
func (n *NetworkInstance_InterfacePath) Subinterface() *NetworkInstance_Interface_SubinterfacePath {
	return &NetworkInstance_Interface_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/interfaces/interface/config/subinterface"
func (n *NetworkInstance_InterfacePathAny) Subinterface() *NetworkInstance_Interface_SubinterfacePathAny {
	return &NetworkInstance_Interface_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_MplsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls YANG schema element.
type NetworkInstance_MplsPath struct {
	*ygot.NodePath
}

// NetworkInstance_MplsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls YANG schema element.
type NetworkInstance_MplsPathAny struct {
	*ygot.NodePath
}

// Global (container): general mpls configuration applicable to any
// type of LSP and signaling protocol - label ranges,
// entropy label supportmay be added here
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/mpls/global"
func (n *NetworkInstance_MplsPath) Global() *NetworkInstance_Mpls_GlobalPath {
	return &NetworkInstance_Mpls_GlobalPath{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// Global (container): general mpls configuration applicable to any
// type of LSP and signaling protocol - label ranges,
// entropy label supportmay be added here
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/mpls/global"
func (n *NetworkInstance_MplsPathAny) Global() *NetworkInstance_Mpls_GlobalPathAny {
	return &NetworkInstance_Mpls_GlobalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of TE interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_MplsPath) InterfaceAny() *NetworkInstance_Mpls_InterfacePathAny {
	return &NetworkInstance_Mpls_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-interface-attributes", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of TE interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_MplsPathAny) InterfaceAny() *NetworkInstance_Mpls_InterfacePathAny {
	return &NetworkInstance_Mpls_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-interface-attributes", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// Interface (list): List of TE interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface"
// InterfaceId: string
func (n *NetworkInstance_MplsPath) Interface(InterfaceId string) *NetworkInstance_Mpls_InterfacePath {
	return &NetworkInstance_Mpls_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"te-interface-attributes", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Interface (list): List of TE interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface"
// InterfaceId: string
func (n *NetworkInstance_MplsPathAny) Interface(InterfaceId string) *NetworkInstance_Mpls_InterfacePathAny {
	return &NetworkInstance_Mpls_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-interface-attributes", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Lsps (container): LSP definitions and configuration
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsps"
// Path from root: "/network-instances/network-instance/mpls/lsps"
func (n *NetworkInstance_MplsPath) Lsps() *NetworkInstance_Mpls_LspsPath {
	return &NetworkInstance_Mpls_LspsPath{
		NodePath: ygot.NewNodePath(
			[]string{"lsps"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lsps (container): LSP definitions and configuration
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsps"
// Path from root: "/network-instances/network-instance/mpls/lsps"
func (n *NetworkInstance_MplsPathAny) Lsps() *NetworkInstance_Mpls_LspsPathAny {
	return &NetworkInstance_Mpls_LspsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsps"},
			map[string]interface{}{},
			n,
		),
	}
}

// SignalingProtocols (container): top-level signaling protocol configuration
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "signaling-protocols"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols"
func (n *NetworkInstance_MplsPath) SignalingProtocols() *NetworkInstance_Mpls_SignalingProtocolsPath {
	return &NetworkInstance_Mpls_SignalingProtocolsPath{
		NodePath: ygot.NewNodePath(
			[]string{"signaling-protocols"},
			map[string]interface{}{},
			n,
		),
	}
}

// SignalingProtocols (container): top-level signaling protocol configuration
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "signaling-protocols"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols"
func (n *NetworkInstance_MplsPathAny) SignalingProtocols() *NetworkInstance_Mpls_SignalingProtocolsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocolsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"signaling-protocols"},
			map[string]interface{}{},
			n,
		),
	}
}

// TeGlobalAttributes (container): traffic-engineering global attributes
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-global-attributes"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes"
func (n *NetworkInstance_MplsPath) TeGlobalAttributes() *NetworkInstance_Mpls_TeGlobalAttributesPath {
	return &NetworkInstance_Mpls_TeGlobalAttributesPath{
		NodePath: ygot.NewNodePath(
			[]string{"te-global-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// TeGlobalAttributes (container): traffic-engineering global attributes
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-global-attributes"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes"
func (n *NetworkInstance_MplsPathAny) TeGlobalAttributes() *NetworkInstance_Mpls_TeGlobalAttributesPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-global-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_GlobalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global YANG schema element.
type NetworkInstance_Mpls_GlobalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_GlobalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global YANG schema element.
type NetworkInstance_Mpls_GlobalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_NullLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/config/null-label YANG schema element.
type NetworkInstance_Mpls_Global_NullLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_NullLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/config/null-label YANG schema element.
type NetworkInstance_Mpls_Global_NullLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_PwEncapsulationPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/config/pw-encapsulation YANG schema element.
type NetworkInstance_Mpls_Global_PwEncapsulationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_PwEncapsulationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/config/pw-encapsulation YANG schema element.
type NetworkInstance_Mpls_Global_PwEncapsulationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_TtlPropagationPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/config/ttl-propagation YANG schema element.
type NetworkInstance_Mpls_Global_TtlPropagationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_TtlPropagationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/config/ttl-propagation YANG schema element.
type NetworkInstance_Mpls_Global_TtlPropagationPathAny struct {
	*ygot.NodePath
}

// InterfaceAny (list): List of TE interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Mpls_GlobalPath) InterfaceAny() *NetworkInstance_Mpls_Global_InterfacePathAny {
	return &NetworkInstance_Mpls_Global_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of TE interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Mpls_GlobalPathAny) InterfaceAny() *NetworkInstance_Mpls_Global_InterfacePathAny {
	return &NetworkInstance_Mpls_Global_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// Interface (list): List of TE interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface"
// InterfaceId: string
func (n *NetworkInstance_Mpls_GlobalPath) Interface(InterfaceId string) *NetworkInstance_Mpls_Global_InterfacePath {
	return &NetworkInstance_Mpls_Global_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Interface (list): List of TE interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface"
// InterfaceId: string
func (n *NetworkInstance_Mpls_GlobalPathAny) Interface(InterfaceId string) *NetworkInstance_Mpls_Global_InterfacePathAny {
	return &NetworkInstance_Mpls_Global_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// NullLabel (leaf): The null-label type used, implicit or explicit
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/null-label"
// Path from root: "/network-instances/network-instance/mpls/global/config/null-label"
func (n *NetworkInstance_Mpls_GlobalPath) NullLabel() *NetworkInstance_Mpls_Global_NullLabelPath {
	return &NetworkInstance_Mpls_Global_NullLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "null-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NullLabel (leaf): The null-label type used, implicit or explicit
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/null-label"
// Path from root: "/network-instances/network-instance/mpls/global/config/null-label"
func (n *NetworkInstance_Mpls_GlobalPathAny) NullLabel() *NetworkInstance_Mpls_Global_NullLabelPathAny {
	return &NetworkInstance_Mpls_Global_NullLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "null-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// PwEncapsulation (leaf): The PDU type to use with pseudowires.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/pw-encapsulation"
// Path from root: "/network-instances/network-instance/mpls/global/config/pw-encapsulation"
func (n *NetworkInstance_Mpls_GlobalPath) PwEncapsulation() *NetworkInstance_Mpls_Global_PwEncapsulationPath {
	return &NetworkInstance_Mpls_Global_PwEncapsulationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "pw-encapsulation"},
			map[string]interface{}{},
			n,
		),
	}
}

// PwEncapsulation (leaf): The PDU type to use with pseudowires.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/pw-encapsulation"
// Path from root: "/network-instances/network-instance/mpls/global/config/pw-encapsulation"
func (n *NetworkInstance_Mpls_GlobalPathAny) PwEncapsulation() *NetworkInstance_Mpls_Global_PwEncapsulationPathAny {
	return &NetworkInstance_Mpls_Global_PwEncapsulationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "pw-encapsulation"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReservedLabelBlockAny (list): A range of labels starting with the start-label up to and including
// the end label that should be allocated for use by a specific protocol.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reserved-label-blocks/reserved-label-block"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block"
// LocalId (wildcarded): string
func (n *NetworkInstance_Mpls_GlobalPath) ReservedLabelBlockAny() *NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reserved-label-blocks", "reserved-label-block"},
			map[string]interface{}{"local-id": "*"},
			n,
		),
	}
}

// ReservedLabelBlockAny (list): A range of labels starting with the start-label up to and including
// the end label that should be allocated for use by a specific protocol.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reserved-label-blocks/reserved-label-block"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block"
// LocalId (wildcarded): string
func (n *NetworkInstance_Mpls_GlobalPathAny) ReservedLabelBlockAny() *NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reserved-label-blocks", "reserved-label-block"},
			map[string]interface{}{"local-id": "*"},
			n,
		),
	}
}

// ReservedLabelBlock (list): A range of labels starting with the start-label up to and including
// the end label that should be allocated for use by a specific protocol.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reserved-label-blocks/reserved-label-block"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block"
// LocalId: string
func (n *NetworkInstance_Mpls_GlobalPath) ReservedLabelBlock(LocalId string) *NetworkInstance_Mpls_Global_ReservedLabelBlockPath {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlockPath{
		NodePath: ygot.NewNodePath(
			[]string{"reserved-label-blocks", "reserved-label-block"},
			map[string]interface{}{"local-id": LocalId},
			n,
		),
	}
}

// ReservedLabelBlock (list): A range of labels starting with the start-label up to and including
// the end label that should be allocated for use by a specific protocol.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reserved-label-blocks/reserved-label-block"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block"
// LocalId: string
func (n *NetworkInstance_Mpls_GlobalPathAny) ReservedLabelBlock(LocalId string) *NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reserved-label-blocks", "reserved-label-block"},
			map[string]interface{}{"local-id": LocalId},
			n,
		),
	}
}

// TtlPropagation (leaf): Enables TTL propagation across the MPLS domain.
// When ttl-propagation is set to true, the IP TTL
// is copied into the MPLS header TTL when pushing
// a label to an IP packet. If false, the IP TTL is
// not copied into the MPLS header TTL and, therefore,
// the IP TTL is not updated in the MPLS domain.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ttl-propagation"
// Path from root: "/network-instances/network-instance/mpls/global/config/ttl-propagation"
func (n *NetworkInstance_Mpls_GlobalPath) TtlPropagation() *NetworkInstance_Mpls_Global_TtlPropagationPath {
	return &NetworkInstance_Mpls_Global_TtlPropagationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ttl-propagation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtlPropagation (leaf): Enables TTL propagation across the MPLS domain.
// When ttl-propagation is set to true, the IP TTL
// is copied into the MPLS header TTL when pushing
// a label to an IP packet. If false, the IP TTL is
// not copied into the MPLS header TTL and, therefore,
// the IP TTL is not updated in the MPLS domain.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ttl-propagation"
// Path from root: "/network-instances/network-instance/mpls/global/config/ttl-propagation"
func (n *NetworkInstance_Mpls_GlobalPathAny) TtlPropagation() *NetworkInstance_Mpls_Global_TtlPropagationPathAny {
	return &NetworkInstance_Mpls_Global_TtlPropagationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ttl-propagation"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Global_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface YANG schema element.
type NetworkInstance_Mpls_Global_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface YANG schema element.
type NetworkInstance_Mpls_Global_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_Interface_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_Global_Interface_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_Interface_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_Global_Interface_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_Interface_MplsEnabledPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/config/mpls-enabled YANG schema element.
type NetworkInstance_Mpls_Global_Interface_MplsEnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_Interface_MplsEnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/config/mpls-enabled YANG schema element.
type NetworkInstance_Mpls_Global_Interface_MplsEnabledPathAny struct {
	*ygot.NodePath
}

// InterfaceId (leaf): Indentifier for the MPLS interface
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/config/interface-id"
func (n *NetworkInstance_Mpls_Global_InterfacePath) InterfaceId() *NetworkInstance_Mpls_Global_Interface_InterfaceIdPath {
	return &NetworkInstance_Mpls_Global_Interface_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Indentifier for the MPLS interface
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/config/interface-id"
func (n *NetworkInstance_Mpls_Global_InterfacePathAny) InterfaceId() *NetworkInstance_Mpls_Global_Interface_InterfaceIdPathAny {
	return &NetworkInstance_Mpls_Global_Interface_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref"
func (n *NetworkInstance_Mpls_Global_InterfacePath) InterfaceRef() *NetworkInstance_Mpls_Global_Interface_InterfaceRefPath {
	return &NetworkInstance_Mpls_Global_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref"
func (n *NetworkInstance_Mpls_Global_InterfacePathAny) InterfaceRef() *NetworkInstance_Mpls_Global_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Mpls_Global_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsEnabled (leaf): Enable MPLS forwarding on this interface
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mpls-enabled"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/config/mpls-enabled"
func (n *NetworkInstance_Mpls_Global_InterfacePath) MplsEnabled() *NetworkInstance_Mpls_Global_Interface_MplsEnabledPath {
	return &NetworkInstance_Mpls_Global_Interface_MplsEnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mpls-enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsEnabled (leaf): Enable MPLS forwarding on this interface
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mpls-enabled"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/config/mpls-enabled"
func (n *NetworkInstance_Mpls_Global_InterfacePathAny) MplsEnabled() *NetworkInstance_Mpls_Global_Interface_MplsEnabledPathAny {
	return &NetworkInstance_Mpls_Global_Interface_MplsEnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mpls-enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Global_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_Global_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_Global_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_Global_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_Global_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_Global_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_Global_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_Global_Interface_InterfaceRefPath) Interface() *NetworkInstance_Mpls_Global_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Mpls_Global_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_Global_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Mpls_Global_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Mpls_Global_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_Global_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Mpls_Global_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Mpls_Global_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/global/interface-attributes/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_Global_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Mpls_Global_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Mpls_Global_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Global_ReservedLabelBlockPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block YANG schema element.
type NetworkInstance_Mpls_Global_ReservedLabelBlockPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block YANG schema element.
type NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_ReservedLabelBlock_LocalIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/local-id YANG schema element.
type NetworkInstance_Mpls_Global_ReservedLabelBlock_LocalIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_ReservedLabelBlock_LocalIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/local-id YANG schema element.
type NetworkInstance_Mpls_Global_ReservedLabelBlock_LocalIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_ReservedLabelBlock_LowerBoundPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/lower-bound YANG schema element.
type NetworkInstance_Mpls_Global_ReservedLabelBlock_LowerBoundPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_ReservedLabelBlock_LowerBoundPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/lower-bound YANG schema element.
type NetworkInstance_Mpls_Global_ReservedLabelBlock_LowerBoundPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_ReservedLabelBlock_UpperBoundPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/upper-bound YANG schema element.
type NetworkInstance_Mpls_Global_ReservedLabelBlock_UpperBoundPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Global_ReservedLabelBlock_UpperBoundPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/upper-bound YANG schema element.
type NetworkInstance_Mpls_Global_ReservedLabelBlock_UpperBoundPathAny struct {
	*ygot.NodePath
}

// LocalId (leaf): A local identifier for the global label block allocation.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-id"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/local-id"
func (n *NetworkInstance_Mpls_Global_ReservedLabelBlockPath) LocalId() *NetworkInstance_Mpls_Global_ReservedLabelBlock_LocalIdPath {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlock_LocalIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalId (leaf): A local identifier for the global label block allocation.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-id"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/local-id"
func (n *NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny) LocalId() *NetworkInstance_Mpls_Global_ReservedLabelBlock_LocalIdPathAny {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlock_LocalIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LowerBound (leaf): Lower bound of the global label block. The block is defined to include
// this label.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lower-bound"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/lower-bound"
func (n *NetworkInstance_Mpls_Global_ReservedLabelBlockPath) LowerBound() *NetworkInstance_Mpls_Global_ReservedLabelBlock_LowerBoundPath {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlock_LowerBoundPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lower-bound"},
			map[string]interface{}{},
			n,
		),
	}
}

// LowerBound (leaf): Lower bound of the global label block. The block is defined to include
// this label.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lower-bound"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/lower-bound"
func (n *NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny) LowerBound() *NetworkInstance_Mpls_Global_ReservedLabelBlock_LowerBoundPathAny {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlock_LowerBoundPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lower-bound"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpperBound (leaf): Upper bound for the global label block. The block is defined to include
// this label.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/upper-bound"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/upper-bound"
func (n *NetworkInstance_Mpls_Global_ReservedLabelBlockPath) UpperBound() *NetworkInstance_Mpls_Global_ReservedLabelBlock_UpperBoundPath {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlock_UpperBoundPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "upper-bound"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpperBound (leaf): Upper bound for the global label block. The block is defined to include
// this label.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/upper-bound"
// Path from root: "/network-instances/network-instance/mpls/global/reserved-label-blocks/reserved-label-block/config/upper-bound"
func (n *NetworkInstance_Mpls_Global_ReservedLabelBlockPathAny) UpperBound() *NetworkInstance_Mpls_Global_ReservedLabelBlock_UpperBoundPathAny {
	return &NetworkInstance_Mpls_Global_ReservedLabelBlock_UpperBoundPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "upper-bound"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface YANG schema element.
type NetworkInstance_Mpls_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface YANG schema element.
type NetworkInstance_Mpls_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/config/admin-group YANG schema element.
type NetworkInstance_Mpls_Interface_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/config/admin-group YANG schema element.
type NetworkInstance_Mpls_Interface_AdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_Interface_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_Interface_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_SrlgMembershipPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/config/srlg-membership YANG schema element.
type NetworkInstance_Mpls_Interface_SrlgMembershipPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_SrlgMembershipPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/config/srlg-membership YANG schema element.
type NetworkInstance_Mpls_Interface_SrlgMembershipPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_TeMetricPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/config/te-metric YANG schema element.
type NetworkInstance_Mpls_Interface_TeMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_TeMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/config/te-metric YANG schema element.
type NetworkInstance_Mpls_Interface_TeMetricPathAny struct {
	*ygot.NodePath
}

// AdminGroup (leaf): list of admin groups (by name) on the interface
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/admin-group"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/config/admin-group"
func (n *NetworkInstance_Mpls_InterfacePath) AdminGroup() *NetworkInstance_Mpls_Interface_AdminGroupPath {
	return &NetworkInstance_Mpls_Interface_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroup (leaf): list of admin groups (by name) on the interface
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/admin-group"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/config/admin-group"
func (n *NetworkInstance_Mpls_InterfacePathAny) AdminGroup() *NetworkInstance_Mpls_Interface_AdminGroupPathAny {
	return &NetworkInstance_Mpls_Interface_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgpFloodingBandwidth (container): Interface bandwidth change percentages
// that trigger update events into the IGP traffic
// engineering database (TED)
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-flooding-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth"
func (n *NetworkInstance_Mpls_InterfacePath) IgpFloodingBandwidth() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"igp-flooding-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgpFloodingBandwidth (container): Interface bandwidth change percentages
// that trigger update events into the IGP traffic
// engineering database (TED)
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-flooding-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth"
func (n *NetworkInstance_Mpls_InterfacePathAny) IgpFloodingBandwidth() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"igp-flooding-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Id of the interface
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/config/interface-id"
func (n *NetworkInstance_Mpls_InterfacePath) InterfaceId() *NetworkInstance_Mpls_Interface_InterfaceIdPath {
	return &NetworkInstance_Mpls_Interface_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Id of the interface
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/config/interface-id"
func (n *NetworkInstance_Mpls_InterfacePathAny) InterfaceId() *NetworkInstance_Mpls_Interface_InterfaceIdPathAny {
	return &NetworkInstance_Mpls_Interface_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref"
func (n *NetworkInstance_Mpls_InterfacePath) InterfaceRef() *NetworkInstance_Mpls_Interface_InterfaceRefPath {
	return &NetworkInstance_Mpls_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref"
func (n *NetworkInstance_Mpls_InterfacePathAny) InterfaceRef() *NetworkInstance_Mpls_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Mpls_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrlgMembership (leaf): list of references to named shared risk link groups that the
// interface belongs to.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/srlg-membership"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/config/srlg-membership"
func (n *NetworkInstance_Mpls_InterfacePath) SrlgMembership() *NetworkInstance_Mpls_Interface_SrlgMembershipPath {
	return &NetworkInstance_Mpls_Interface_SrlgMembershipPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "srlg-membership"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrlgMembership (leaf): list of references to named shared risk link groups that the
// interface belongs to.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/srlg-membership"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/config/srlg-membership"
func (n *NetworkInstance_Mpls_InterfacePathAny) SrlgMembership() *NetworkInstance_Mpls_Interface_SrlgMembershipPathAny {
	return &NetworkInstance_Mpls_Interface_SrlgMembershipPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "srlg-membership"},
			map[string]interface{}{},
			n,
		),
	}
}

// TeMetric (leaf): TE specific metric for the link
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/te-metric"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/config/te-metric"
func (n *NetworkInstance_Mpls_InterfacePath) TeMetric() *NetworkInstance_Mpls_Interface_TeMetricPath {
	return &NetworkInstance_Mpls_Interface_TeMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "te-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// TeMetric (leaf): TE specific metric for the link
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/te-metric"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/config/te-metric"
func (n *NetworkInstance_Mpls_InterfacePathAny) TeMetric() *NetworkInstance_Mpls_Interface_TeMetricPathAny {
	return &NetworkInstance_Mpls_Interface_TeMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "te-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DeltaPercentagePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/delta-percentage YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DeltaPercentagePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DeltaPercentagePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/delta-percentage YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DeltaPercentagePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DownThresholdsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/down-thresholds YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DownThresholdsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DownThresholdsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/down-thresholds YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DownThresholdsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdSpecificationPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/threshold-specification YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdSpecificationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdSpecificationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/threshold-specification YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdSpecificationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdTypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/threshold-type YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/threshold-type YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpDownThresholdsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/up-down-thresholds YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpDownThresholdsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpDownThresholdsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/up-down-thresholds YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpDownThresholdsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpThresholdsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/up-thresholds YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpThresholdsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpThresholdsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/up-thresholds YANG schema element.
type NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpThresholdsPathAny struct {
	*ygot.NodePath
}

// DeltaPercentage (leaf): The percentage of the maximum-reservable-bandwidth
// considered as the delta that results in an IGP update
// being flooded
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/delta-percentage"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/delta-percentage"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath) DeltaPercentage() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DeltaPercentagePath {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DeltaPercentagePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "delta-percentage"},
			map[string]interface{}{},
			n,
		),
	}
}

// DeltaPercentage (leaf): The percentage of the maximum-reservable-bandwidth
// considered as the delta that results in an IGP update
// being flooded
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/delta-percentage"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/delta-percentage"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny) DeltaPercentage() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DeltaPercentagePathAny {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DeltaPercentagePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "delta-percentage"},
			map[string]interface{}{},
			n,
		),
	}
}

// DownThresholds (leaf): The thresholds (expressed as a percentage of the maximum
// reservable bandwidth) at which bandwidth updates are to be
// triggered when the bandwidth is decreasing.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/down-thresholds"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/down-thresholds"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath) DownThresholds() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DownThresholdsPath {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DownThresholdsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "down-thresholds"},
			map[string]interface{}{},
			n,
		),
	}
}

// DownThresholds (leaf): The thresholds (expressed as a percentage of the maximum
// reservable bandwidth) at which bandwidth updates are to be
// triggered when the bandwidth is decreasing.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/down-thresholds"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/down-thresholds"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny) DownThresholds() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DownThresholdsPathAny {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_DownThresholdsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "down-thresholds"},
			map[string]interface{}{},
			n,
		),
	}
}

// ThresholdSpecification (leaf): This value specifies whether a single set of threshold
// values should be used for both increasing and decreasing
// bandwidth when determining whether to trigger updated
// bandwidth values to be flooded in the IGP TE extensions.
// MIRRORED-UP-DOWN indicates that a single value (or set of
// values) should be used for both increasing and decreasing
// values, where SEPARATE-UP-DOWN specifies that the increasing
// and decreasing values will be separately specified
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/threshold-specification"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/threshold-specification"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath) ThresholdSpecification() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdSpecificationPath {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdSpecificationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "threshold-specification"},
			map[string]interface{}{},
			n,
		),
	}
}

// ThresholdSpecification (leaf): This value specifies whether a single set of threshold
// values should be used for both increasing and decreasing
// bandwidth when determining whether to trigger updated
// bandwidth values to be flooded in the IGP TE extensions.
// MIRRORED-UP-DOWN indicates that a single value (or set of
// values) should be used for both increasing and decreasing
// values, where SEPARATE-UP-DOWN specifies that the increasing
// and decreasing values will be separately specified
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/threshold-specification"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/threshold-specification"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny) ThresholdSpecification() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdSpecificationPathAny {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdSpecificationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "threshold-specification"},
			map[string]interface{}{},
			n,
		),
	}
}

// ThresholdType (leaf): The type of threshold that should be used to specify the
// values at which bandwidth is flooded. DELTA indicates that
// the local system should flood IGP updates when a change in
// reserved bandwidth >= the specified delta occurs on the
// interface. Where THRESHOLD_CROSSED is specified, the local
// system should trigger an update (and hence flood) the
// reserved bandwidth when the reserved bandwidth changes such
// that it crosses, or becomes equal to one of the threshold
// values
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/threshold-type"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/threshold-type"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath) ThresholdType() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdTypePath {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "threshold-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// ThresholdType (leaf): The type of threshold that should be used to specify the
// values at which bandwidth is flooded. DELTA indicates that
// the local system should flood IGP updates when a change in
// reserved bandwidth >= the specified delta occurs on the
// interface. Where THRESHOLD_CROSSED is specified, the local
// system should trigger an update (and hence flood) the
// reserved bandwidth when the reserved bandwidth changes such
// that it crosses, or becomes equal to one of the threshold
// values
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/threshold-type"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/threshold-type"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny) ThresholdType() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdTypePathAny {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_ThresholdTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "threshold-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDownThresholds (leaf): The thresholds (expressed as a percentage of the maximum
// reservable bandwidth of the interface) at which bandwidth
// updates are flooded - used both when the bandwidth is
// increasing and decreasing
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/up-down-thresholds"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/up-down-thresholds"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath) UpDownThresholds() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpDownThresholdsPath {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpDownThresholdsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "up-down-thresholds"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDownThresholds (leaf): The thresholds (expressed as a percentage of the maximum
// reservable bandwidth of the interface) at which bandwidth
// updates are flooded - used both when the bandwidth is
// increasing and decreasing
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/up-down-thresholds"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/up-down-thresholds"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny) UpDownThresholds() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpDownThresholdsPathAny {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpDownThresholdsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "up-down-thresholds"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpThresholds (leaf): The thresholds (expressed as a percentage of the maximum
// reservable bandwidth) at which bandwidth updates are to be
// triggered when the bandwidth is increasing.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/up-thresholds"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/up-thresholds"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPath) UpThresholds() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpThresholdsPath {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpThresholdsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "up-thresholds"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpThresholds (leaf): The thresholds (expressed as a percentage of the maximum
// reservable bandwidth) at which bandwidth updates are to be
// triggered when the bandwidth is increasing.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/up-thresholds"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/igp-flooding-bandwidth/config/up-thresholds"
func (n *NetworkInstance_Mpls_Interface_IgpFloodingBandwidthPathAny) UpThresholds() *NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpThresholdsPathAny {
	return &NetworkInstance_Mpls_Interface_IgpFloodingBandwidth_UpThresholdsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "up-thresholds"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_Interface_InterfaceRefPath) Interface() *NetworkInstance_Mpls_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Mpls_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Mpls_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Mpls_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Mpls_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Mpls_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/te-interface-attributes/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Mpls_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Mpls_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_LspsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps YANG schema element.
type NetworkInstance_Mpls_LspsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_LspsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps YANG schema element.
type NetworkInstance_Mpls_LspsPathAny struct {
	*ygot.NodePath
}

// ConstrainedPath (container): traffic-engineered LSPs supporting different
// path computation and signaling methods
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constrained-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path"
func (n *NetworkInstance_Mpls_LspsPath) ConstrainedPath() *NetworkInstance_Mpls_Lsps_ConstrainedPathPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"constrained-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConstrainedPath (container): traffic-engineered LSPs supporting different
// path computation and signaling methods
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constrained-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path"
func (n *NetworkInstance_Mpls_LspsPathAny) ConstrainedPath() *NetworkInstance_Mpls_Lsps_ConstrainedPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constrained-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaticLspAny (list): list of defined static LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-lsps/static-lsp"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_LspsPath) StaticLspAny() *NetworkInstance_Mpls_Lsps_StaticLspPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-lsps", "static-lsp"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// StaticLspAny (list): list of defined static LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-lsps/static-lsp"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_LspsPathAny) StaticLspAny() *NetworkInstance_Mpls_Lsps_StaticLspPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-lsps", "static-lsp"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// StaticLsp (list): list of defined static LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-lsps/static-lsp"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp"
// Name: string
func (n *NetworkInstance_Mpls_LspsPath) StaticLsp(Name string) *NetworkInstance_Mpls_Lsps_StaticLspPath {
	return &NetworkInstance_Mpls_Lsps_StaticLspPath{
		NodePath: ygot.NewNodePath(
			[]string{"static-lsps", "static-lsp"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// StaticLsp (list): list of defined static LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-lsps/static-lsp"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp"
// Name: string
func (n *NetworkInstance_Mpls_LspsPathAny) StaticLsp(Name string) *NetworkInstance_Mpls_Lsps_StaticLspPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-lsps", "static-lsp"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// UnconstrainedPath (container): LSPs that use the IGP-determined path, i.e., non
// traffic-engineered, or non constrained-path
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/unconstrained-path"
func (n *NetworkInstance_Mpls_LspsPath) UnconstrainedPath() *NetworkInstance_Mpls_Lsps_UnconstrainedPathPath {
	return &NetworkInstance_Mpls_Lsps_UnconstrainedPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnconstrainedPath (container): LSPs that use the IGP-determined path, i.e., non
// traffic-engineered, or non constrained-path
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/unconstrained-path"
func (n *NetworkInstance_Mpls_LspsPathAny) UnconstrainedPath() *NetworkInstance_Mpls_Lsps_UnconstrainedPathPathAny {
	return &NetworkInstance_Mpls_Lsps_UnconstrainedPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPathPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPathPathAny struct {
	*ygot.NodePath
}

// NamedExplicitPathAny (list): A list of explicit paths
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "named-explicit-paths/named-explicit-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPathPath) NamedExplicitPathAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"named-explicit-paths", "named-explicit-path"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// NamedExplicitPathAny (list): A list of explicit paths
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "named-explicit-paths/named-explicit-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPathPathAny) NamedExplicitPathAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"named-explicit-paths", "named-explicit-path"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// NamedExplicitPath (list): A list of explicit paths
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "named-explicit-paths/named-explicit-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path"
// Name: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPathPath) NamedExplicitPath(Name string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"named-explicit-paths", "named-explicit-path"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// NamedExplicitPath (list): A list of explicit paths
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "named-explicit-paths/named-explicit-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path"
// Name: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPathPathAny) NamedExplicitPath(Name string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"named-explicit-paths", "named-explicit-path"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// TunnelAny (list): List of TE tunnels. This list contains only the LSPs that the
// current device originates (i.e., for which it is the head-end).
// Where the signaling protocol utilised for an LSP allows a mid-point
// or tail device to be aware of the LSP (e.g., RSVP-TE), then the
// associated sessions are maintained per protocol
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnels/tunnel"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPathPath) TunnelAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tunnels", "tunnel"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// TunnelAny (list): List of TE tunnels. This list contains only the LSPs that the
// current device originates (i.e., for which it is the head-end).
// Where the signaling protocol utilised for an LSP allows a mid-point
// or tail device to be aware of the LSP (e.g., RSVP-TE), then the
// associated sessions are maintained per protocol
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnels/tunnel"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPathPathAny) TunnelAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tunnels", "tunnel"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Tunnel (list): List of TE tunnels. This list contains only the LSPs that the
// current device originates (i.e., for which it is the head-end).
// Where the signaling protocol utilised for an LSP allows a mid-point
// or tail device to be aware of the LSP (e.g., RSVP-TE), then the
// associated sessions are maintained per protocol
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnels/tunnel"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel"
// Name: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPathPath) Tunnel(Name string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath{
		NodePath: ygot.NewNodePath(
			[]string{"tunnels", "tunnel"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Tunnel (list): List of TE tunnels. This list contains only the LSPs that the
// current device originates (i.e., for which it is the head-end).
// Where the signaling protocol utilised for an LSP allows a mid-point
// or tail device to be aware of the LSP (e.g., RSVP-TE), then the
// associated sessions are maintained per protocol
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnels/tunnel"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel"
// Name: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPathPathAny) Tunnel(Name string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tunnels", "tunnel"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_NamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_NamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidProtectionRequiredPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/sid-protection-required YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidProtectionRequiredPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidProtectionRequiredPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/sid-protection-required YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidProtectionRequiredPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidSelectionModePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/sid-selection-mode YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidSelectionModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidSelectionModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/sid-selection-mode YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidSelectionModePathAny struct {
	*ygot.NodePath
}

// ExplicitRouteObjectAny (list): List of explicit route objects
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "explicit-route-objects/explicit-route-object"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object"
// Index (wildcarded): uint8
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPath) ExplicitRouteObjectAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"explicit-route-objects", "explicit-route-object"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// ExplicitRouteObjectAny (list): List of explicit route objects
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "explicit-route-objects/explicit-route-object"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object"
// Index (wildcarded): uint8
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny) ExplicitRouteObjectAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"explicit-route-objects", "explicit-route-object"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// ExplicitRouteObject (list): List of explicit route objects
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "explicit-route-objects/explicit-route-object"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object"
// Index: uint8
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPath) ExplicitRouteObject(Index uint8) *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPath{
		NodePath: ygot.NewNodePath(
			[]string{"explicit-route-objects", "explicit-route-object"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// ExplicitRouteObject (list): List of explicit route objects
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "explicit-route-objects/explicit-route-object"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object"
// Index: uint8
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny) ExplicitRouteObject(Index uint8) *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"explicit-route-objects", "explicit-route-object"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Name (leaf): A string name that uniquely identifies an explicit
// path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPath) Name() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_NamePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): A string name that uniquely identifies an explicit
// path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny) Name() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_NamePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidProtectionRequired (leaf): When this value is set to true, only SIDs that are
// protected are to be selected by the calculating method
// when the explicit path is instantiated by a SR-TE LSP.
// ----------------------------------------
// Defining module: "openconfig-mpls-sr"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sid-protection-required"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/sid-protection-required"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPath) SidProtectionRequired() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidProtectionRequiredPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidProtectionRequiredPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sid-protection-required"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidProtectionRequired (leaf): When this value is set to true, only SIDs that are
// protected are to be selected by the calculating method
// when the explicit path is instantiated by a SR-TE LSP.
// ----------------------------------------
// Defining module: "openconfig-mpls-sr"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sid-protection-required"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/sid-protection-required"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny) SidProtectionRequired() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidProtectionRequiredPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidProtectionRequiredPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sid-protection-required"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidSelectionMode (leaf): The restrictions placed on the SIDs to be selected by the
// calculation method for the explicit path when it is
// instantiated for a SR-TE LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-sr"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sid-selection-mode"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/sid-selection-mode"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPath) SidSelectionMode() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidSelectionModePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidSelectionModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sid-selection-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidSelectionMode (leaf): The restrictions placed on the SIDs to be selected by the
// calculation method for the explicit path when it is
// instantiated for a SR-TE LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-sr"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sid-selection-mode"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/config/sid-selection-mode"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPathPathAny) SidSelectionMode() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidSelectionModePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_SidSelectionModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sid-selection-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/address YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/address YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_HopTypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/hop-type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_HopTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_HopTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/hop-type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_HopTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/index YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/index YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_IndexPathAny struct {
	*ygot.NodePath
}

// Address (leaf): router hop for the LSP path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/address"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/address"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPath) Address() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_AddressPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): router hop for the LSP path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/address"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/address"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny) Address() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_AddressPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopType (leaf): strict or loose hop
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hop-type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/hop-type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPath) HopType() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_HopTypePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_HopTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopType (leaf): strict or loose hop
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hop-type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/hop-type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny) HopType() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_HopTypePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_HopTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of this explicit route object to express
// the order of hops in the path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/index"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/index"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPath) Index() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_IndexPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of this explicit route object to express
// the order of hops in the path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/index"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/named-explicit-paths/named-explicit-path/explicit-route-objects/explicit-route-object/config/index"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObjectPathAny) Index() *NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_IndexPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_NamedExplicitPath_ExplicitRouteObject_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AdminStatusPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/admin-status YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AdminStatusPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AdminStatusPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/admin-status YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AdminStatusPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AutoGeneratedPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/auto-generated YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AutoGeneratedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AutoGeneratedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/auto-generated YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AutoGeneratedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_DescriptionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/description YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_DescriptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_DescriptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/description YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_DescriptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_HoldPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/hold-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_HoldPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_HoldPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/hold-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_HoldPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricTypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/metric-type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/metric-type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_NamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_NamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_OperStatusPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/oper-status YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_OperStatusPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_OperStatusPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/oper-status YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_OperStatusPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_PreferencePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/preference YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_PreferencePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_PreferencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/preference YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_PreferencePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ProtectionStyleRequestedPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/protection-style-requested YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ProtectionStyleRequestedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ProtectionStyleRequestedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/protection-style-requested YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ProtectionStyleRequestedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ReoptimizeTimerPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/reoptimize-timer YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ReoptimizeTimerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ReoptimizeTimerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/reoptimize-timer YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ReoptimizeTimerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_RolePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/role YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_RolePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_RolePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/role YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_RolePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SetupPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/setup-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SetupPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SetupPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/setup-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SetupPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ShortcutEligiblePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/shortcut-eligible YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ShortcutEligiblePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ShortcutEligiblePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/shortcut-eligible YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ShortcutEligiblePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SignalingProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/signaling-protocol YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SignalingProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SignalingProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/signaling-protocol YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SignalingProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SoftPreemptionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/soft-preemption YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SoftPreemptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SoftPreemptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/soft-preemption YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SoftPreemptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SourcePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/source YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SourcePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SourcePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/source YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SourcePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_TypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_TypePathAny struct {
	*ygot.NodePath
}

// AdminStatus (leaf): TE tunnel administrative state.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/admin-status"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/admin-status"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) AdminStatus() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AdminStatusPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AdminStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminStatus (leaf): TE tunnel administrative state.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/admin-status"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/admin-status"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) AdminStatus() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AdminStatusPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AdminStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// AutoGenerated (leaf): If the LSP was auto-generated by the system this leaf
// should be set to true. Examples of auto-generated LSPs
// are dynamically created backup LSPs to meet a FRR
// policy.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auto-generated"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/auto-generated"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) AutoGenerated() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AutoGeneratedPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AutoGeneratedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auto-generated"},
			map[string]interface{}{},
			n,
		),
	}
}

// AutoGenerated (leaf): If the LSP was auto-generated by the system this leaf
// should be set to true. Examples of auto-generated LSPs
// are dynamically created backup LSPs to meet a FRR
// policy.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auto-generated"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/auto-generated"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) AutoGenerated() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AutoGeneratedPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_AutoGeneratedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auto-generated"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (container): Bandwidth configuration for TE LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) Bandwidth() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (container): Bandwidth configuration for TE LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) Bandwidth() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): State data for MPLS label switched paths. This state
// data is specific to a single label switched path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) Counters() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): State data for MPLS label switched paths. This state
// data is specific to a single label switched path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) Counters() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): optional text description for the tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/description"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) Description() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_DescriptionPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): optional text description for the tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/description"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) Description() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_DescriptionPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldPriority (leaf): preemption priority once the LSP is established,
// lower is higher priority; default 0 indicates other LSPs
// will not preempt the LSPs once established
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/hold-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) HoldPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_HoldPriorityPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_HoldPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldPriority (leaf): preemption priority once the LSP is established,
// lower is higher priority; default 0 indicates other LSPs
// will not preempt the LSPs once established
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/hold-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) HoldPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_HoldPriorityPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_HoldPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The value of the metric that should be specified. The value
// supplied in this leaf is used in conjunction with the metric
// type to determine the value of the metric used by the system.
// Where the metric-type is set to LSP_METRIC_ABSOLUTE - the
// value of this leaf is used directly; where it is set to
// LSP_METRIC_RELATIVE, the relevant (positive or negative)
// offset is used to formulate the metric; where metric-type
// is LSP_METRIC_INHERITED, the value of this leaf is not
// utilised
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) Metric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The value of the metric that should be specified. The value
// supplied in this leaf is used in conjunction with the metric
// type to determine the value of the metric used by the system.
// Where the metric-type is set to LSP_METRIC_ABSOLUTE - the
// value of this leaf is used directly; where it is set to
// LSP_METRIC_RELATIVE, the relevant (positive or negative)
// offset is used to formulate the metric; where metric-type
// is LSP_METRIC_INHERITED, the value of this leaf is not
// utilised
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) Metric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// MetricType (leaf): The type of metric specification that should be used to set
// the LSP(s) metric
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric-type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/metric-type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) MetricType() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricTypePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// MetricType (leaf): The type of metric specification that should be used to set
// the LSP(s) metric
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric-type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/metric-type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) MetricType() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricTypePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_MetricTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The tunnel name
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) Name() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_NamePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The tunnel name
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) Name() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_NamePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperStatus (leaf): The operational status of the TE tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/oper-status"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/oper-status"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) OperStatus() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_OperStatusPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_OperStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// OperStatus (leaf): The operational status of the TE tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/oper-status"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/oper-status"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) OperStatus() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_OperStatusPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_OperStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oper-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// P2PTunnelAttributes (container): Parameters related to LSPs of type P2P
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-tunnel-attributes"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) P2PTunnelAttributes() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPath{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-tunnel-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// P2PTunnelAttributes (container): Parameters related to LSPs of type P2P
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-tunnel-attributes"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) P2PTunnelAttributes() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-tunnel-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): Specifies a preference for this tunnel.
// A lower number signifies a better preference
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/preference"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/preference"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) Preference() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_PreferencePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_PreferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): Specifies a preference for this tunnel.
// A lower number signifies a better preference
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/preference"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/preference"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) Preference() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_PreferencePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_PreferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtectionStyleRequested (leaf): style of mpls frr protection desired: can be
// link, link-node or unprotected.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protection-style-requested"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/protection-style-requested"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) ProtectionStyleRequested() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ProtectionStyleRequestedPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ProtectionStyleRequestedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protection-style-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtectionStyleRequested (leaf): style of mpls frr protection desired: can be
// link, link-node or unprotected.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protection-style-requested"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/protection-style-requested"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) ProtectionStyleRequested() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ProtectionStyleRequestedPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ProtectionStyleRequestedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protection-style-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReoptimizeTimer (leaf): frequency of reoptimization of
// a traffic engineered LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reoptimize-timer"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/reoptimize-timer"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) ReoptimizeTimer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ReoptimizeTimerPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ReoptimizeTimerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reoptimize-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReoptimizeTimer (leaf): frequency of reoptimization of
// a traffic engineered LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reoptimize-timer"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/reoptimize-timer"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) ReoptimizeTimer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ReoptimizeTimerPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ReoptimizeTimerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reoptimize-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): The lsp role at the current node, whether it is headend,
// transit or tailend.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/role"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/role"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) Role() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_RolePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_RolePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): The lsp role at the current node, whether it is headend,
// transit or tailend.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/role"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/role"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) Role() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_RolePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_RolePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriority (leaf): RSVP-TE preemption priority during LSP setup, lower is
// higher priority; default 7 indicates that LSP will not
// preempt established LSPs during setup
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/setup-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/setup-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) SetupPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SetupPriorityPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SetupPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "setup-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriority (leaf): RSVP-TE preemption priority during LSP setup, lower is
// higher priority; default 7 indicates that LSP will not
// preempt established LSPs during setup
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/setup-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/setup-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) SetupPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SetupPriorityPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "setup-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// ShortcutEligible (leaf): Whether this LSP is considered to be eligible for us as a
// shortcut in the IGP. In the case that this leaf is set to
// true, the IGP SPF calculation uses the metric specified to
// determine whether traffic should be carried over this LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/shortcut-eligible"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/shortcut-eligible"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) ShortcutEligible() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ShortcutEligiblePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ShortcutEligiblePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "shortcut-eligible"},
			map[string]interface{}{},
			n,
		),
	}
}

// ShortcutEligible (leaf): Whether this LSP is considered to be eligible for us as a
// shortcut in the IGP. In the case that this leaf is set to
// true, the IGP SPF calculation uses the metric specified to
// determine whether traffic should be carried over this LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/shortcut-eligible"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/shortcut-eligible"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) ShortcutEligible() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ShortcutEligiblePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_ShortcutEligiblePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "shortcut-eligible"},
			map[string]interface{}{},
			n,
		),
	}
}

// SignalingProtocol (leaf): Signaling protocol used to set up this tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/signaling-protocol"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/signaling-protocol"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) SignalingProtocol() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SignalingProtocolPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SignalingProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "signaling-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// SignalingProtocol (leaf): Signaling protocol used to set up this tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/signaling-protocol"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/signaling-protocol"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) SignalingProtocol() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SignalingProtocolPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SignalingProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "signaling-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftPreemption (leaf): Enables RSVP soft-preemption on this LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/soft-preemption"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/soft-preemption"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) SoftPreemption() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SoftPreemptionPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SoftPreemptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "soft-preemption"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftPreemption (leaf): Enables RSVP soft-preemption on this LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/soft-preemption"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/soft-preemption"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) SoftPreemption() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SoftPreemptionPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SoftPreemptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "soft-preemption"},
			map[string]interface{}{},
			n,
		),
	}
}

// Source (leaf): RSVP-TE tunnel source address
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/source"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) Source() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SourcePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SourcePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// Source (leaf): RSVP-TE tunnel source address
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/source"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) Source() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SourcePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_SourcePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Tunnel type, p2p or p2mp
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPath) Type() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_TypePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Tunnel type, p2p or p2mp
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/config/type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_TunnelPathAny) Type() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_TypePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SetBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/config/set-bandwidth YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SetBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SetBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/config/set-bandwidth YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SetBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SignaledBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/state/signaled-bandwidth YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SignaledBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SignaledBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/state/signaled-bandwidth YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SignaledBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SpecificationTypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/config/specification-type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SpecificationTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SpecificationTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/config/specification-type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SpecificationTypePathAny struct {
	*ygot.NodePath
}

// AutoBandwidth (container): Parameters related to auto-bandwidth
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "auto-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPath) AutoBandwidth() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"auto-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// AutoBandwidth (container): Parameters related to auto-bandwidth
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "auto-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPathAny) AutoBandwidth() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"auto-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetBandwidth (leaf): set bandwidth explicitly, e.g., using
// offline calculation
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/config/set-bandwidth"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPath) SetBandwidth() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SetBandwidthPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SetBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetBandwidth (leaf): set bandwidth explicitly, e.g., using
// offline calculation
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/config/set-bandwidth"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPathAny) SetBandwidth() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SetBandwidthPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SetBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SignaledBandwidth (leaf): The currently signaled bandwidth of the LSP. In the case where
// the bandwidth is specified explicitly, then this will match the
// value of the set-bandwidth leaf; in cases where the bandwidth is
// dynamically computed by the system, the current value of the
// bandwidth should be reflected.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/signaled-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/state/signaled-bandwidth"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPath) SignaledBandwidth() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SignaledBandwidthPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SignaledBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "signaled-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SignaledBandwidth (leaf): The currently signaled bandwidth of the LSP. In the case where
// the bandwidth is specified explicitly, then this will match the
// value of the set-bandwidth leaf; in cases where the bandwidth is
// dynamically computed by the system, the current value of the
// bandwidth should be reflected.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/signaled-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/state/signaled-bandwidth"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPathAny) SignaledBandwidth() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SignaledBandwidthPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SignaledBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "signaled-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpecificationType (leaf): The method used for settign the bandwidth, either explicitly
// specified or configured
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/specification-type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/config/specification-type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPath) SpecificationType() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SpecificationTypePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SpecificationTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "specification-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpecificationType (leaf): The method used for settign the bandwidth, either explicitly
// specified or configured
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/specification-type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/config/specification-type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_BandwidthPathAny) SpecificationType() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SpecificationTypePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_SpecificationTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "specification-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/adjust-interval YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/adjust-interval YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustThresholdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/adjust-threshold YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustThresholdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustThresholdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/adjust-threshold YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustThresholdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/enabled YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/enabled YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_IntervalHighBwPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/state/interval-high-bw YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_IntervalHighBwPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_IntervalHighBwPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/state/interval-high-bw YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_IntervalHighBwPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MaxBwPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/max-bw YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MaxBwPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MaxBwPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/max-bw YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MaxBwPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MinBwPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/min-bw YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MinBwPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MinBwPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/min-bw YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MinBwPathAny struct {
	*ygot.NodePath
}

// AdjustInterval (leaf): time in seconds between adjustments to
// LSP bandwidth
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/adjust-interval"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/adjust-interval"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath) AdjustInterval() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustIntervalPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "adjust-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjustInterval (leaf): time in seconds between adjustments to
// LSP bandwidth
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/adjust-interval"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/adjust-interval"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny) AdjustInterval() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustIntervalPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "adjust-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjustThreshold (leaf): percentage difference between the LSP's
// specified bandwidth and its current bandwidth
// allocation -- if the difference is greater than the
// specified percentage, auto-bandwidth adjustment is
// triggered
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/adjust-threshold"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/adjust-threshold"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath) AdjustThreshold() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustThresholdPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "adjust-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjustThreshold (leaf): percentage difference between the LSP's
// specified bandwidth and its current bandwidth
// allocation -- if the difference is greater than the
// specified percentage, auto-bandwidth adjustment is
// triggered
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/adjust-threshold"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/adjust-threshold"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny) AdjustThreshold() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustThresholdPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_AdjustThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "adjust-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): enables mpls auto-bandwidth on the
// lsp
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/enabled"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath) Enabled() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_EnabledPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): enables mpls auto-bandwidth on the
// lsp
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/enabled"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny) Enabled() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_EnabledPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// IntervalHighBw (leaf): The maximum measured bandwidth during the current
// auto-bandwidth adjust interval expressed in kilobits
// per second.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interval-high-bw"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/state/interval-high-bw"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath) IntervalHighBw() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_IntervalHighBwPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_IntervalHighBwPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interval-high-bw"},
			map[string]interface{}{},
			n,
		),
	}
}

// IntervalHighBw (leaf): The maximum measured bandwidth during the current
// auto-bandwidth adjust interval expressed in kilobits
// per second.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interval-high-bw"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/state/interval-high-bw"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny) IntervalHighBw() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_IntervalHighBwPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_IntervalHighBwPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interval-high-bw"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxBw (leaf): set the maximum bandwidth in Kbps for an
// auto-bandwidth LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-bw"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/max-bw"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath) MaxBw() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MaxBwPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MaxBwPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-bw"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxBw (leaf): set the maximum bandwidth in Kbps for an
// auto-bandwidth LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-bw"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/max-bw"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny) MaxBw() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MaxBwPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MaxBwPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-bw"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinBw (leaf): set the minimum bandwidth in Kbps for an
// auto-bandwidth LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/min-bw"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/min-bw"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath) MinBw() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MinBwPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MinBwPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "min-bw"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinBw (leaf): set the minimum bandwidth in Kbps for an
// auto-bandwidth LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/min-bw"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/config/min-bw"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny) MinBw() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MinBwPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_MinBwPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "min-bw"},
			map[string]interface{}{},
			n,
		),
	}
}

// Overflow (container): configuration of MPLS overflow bandwidth
// adjustement for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "overflow"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath) Overflow() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPath{
		NodePath: ygot.NewNodePath(
			[]string{"overflow"},
			map[string]interface{}{},
			n,
		),
	}
}

// Overflow (container): configuration of MPLS overflow bandwidth
// adjustement for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "overflow"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny) Overflow() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"overflow"},
			map[string]interface{}{},
			n,
		),
	}
}

// Underflow (container): configuration of MPLS underflow bandwidth
// adjustement for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "underflow"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPath) Underflow() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPath{
		NodePath: ygot.NewNodePath(
			[]string{"underflow"},
			map[string]interface{}{},
			n,
		),
	}
}

// Underflow (container): configuration of MPLS underflow bandwidth
// adjustement for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "underflow"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidthPathAny) Underflow() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"underflow"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/enabled YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/enabled YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_OverflowThresholdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/overflow-threshold YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_OverflowThresholdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_OverflowThresholdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/overflow-threshold YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_OverflowThresholdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_TriggerEventCountPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/trigger-event-count YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_TriggerEventCountPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_TriggerEventCountPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/trigger-event-count YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_TriggerEventCountPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): enables mpls lsp bandwidth overflow
// adjustment on the lsp
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/enabled"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPath) Enabled() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_EnabledPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): enables mpls lsp bandwidth overflow
// adjustment on the lsp
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/enabled"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPathAny) Enabled() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_EnabledPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// OverflowThreshold (leaf): bandwidth percentage change to trigger
// an overflow event
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/overflow-threshold"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/overflow-threshold"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPath) OverflowThreshold() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_OverflowThresholdPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_OverflowThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "overflow-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// OverflowThreshold (leaf): bandwidth percentage change to trigger
// an overflow event
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/overflow-threshold"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/overflow-threshold"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPathAny) OverflowThreshold() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_OverflowThresholdPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_OverflowThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "overflow-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// TriggerEventCount (leaf): number of consecutive overflow sample
// events needed to trigger an overflow adjustment
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/trigger-event-count"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/trigger-event-count"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPath) TriggerEventCount() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_TriggerEventCountPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_TriggerEventCountPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trigger-event-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// TriggerEventCount (leaf): number of consecutive overflow sample
// events needed to trigger an overflow adjustment
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/trigger-event-count"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/overflow/config/trigger-event-count"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_OverflowPathAny) TriggerEventCount() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_TriggerEventCountPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Overflow_TriggerEventCountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trigger-event-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/enabled YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/enabled YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_TriggerEventCountPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/trigger-event-count YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_TriggerEventCountPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_TriggerEventCountPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/trigger-event-count YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_TriggerEventCountPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_UnderflowThresholdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/underflow-threshold YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_UnderflowThresholdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_UnderflowThresholdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/underflow-threshold YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_UnderflowThresholdPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): enables bandwidth underflow
// adjustment on the lsp
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/enabled"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPath) Enabled() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_EnabledPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): enables bandwidth underflow
// adjustment on the lsp
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/enabled"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPathAny) Enabled() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_EnabledPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// TriggerEventCount (leaf): number of consecutive underflow sample
// events needed to trigger an underflow adjustment
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/trigger-event-count"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/trigger-event-count"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPath) TriggerEventCount() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_TriggerEventCountPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_TriggerEventCountPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trigger-event-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// TriggerEventCount (leaf): number of consecutive underflow sample
// events needed to trigger an underflow adjustment
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/trigger-event-count"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/trigger-event-count"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPathAny) TriggerEventCount() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_TriggerEventCountPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_TriggerEventCountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trigger-event-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnderflowThreshold (leaf): bandwidth percentage change to trigger
// and underflow event
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/underflow-threshold"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/underflow-threshold"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPath) UnderflowThreshold() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_UnderflowThresholdPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_UnderflowThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "underflow-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnderflowThreshold (leaf): bandwidth percentage change to trigger
// and underflow event
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/underflow-threshold"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/bandwidth/auto-bandwidth/underflow/config/underflow-threshold"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_UnderflowPathAny) UnderflowThreshold() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_UnderflowThresholdPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Bandwidth_AutoBandwidth_Underflow_UnderflowThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "underflow-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_BytesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/bytes YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_BytesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_BytesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/bytes YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_BytesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_CurrentPathTimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/current-path-time YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_CurrentPathTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_CurrentPathTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/current-path-time YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_CurrentPathTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_NextReoptimizationTimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/next-reoptimization-time YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_NextReoptimizationTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_NextReoptimizationTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/next-reoptimization-time YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_NextReoptimizationTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_OnlineTimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/online-time YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_OnlineTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_OnlineTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/online-time YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_OnlineTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PacketsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/packets YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PacketsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PacketsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/packets YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PacketsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PathChangesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/path-changes YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PathChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PathChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/path-changes YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PathChangesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_StateChangesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/state-changes YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_StateChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_StateChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/state-changes YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_StateChangesPathAny struct {
	*ygot.NodePath
}

// Bytes (leaf): Number of bytes that have been forwarded over the
// label switched path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bytes"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/bytes"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath) Bytes() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_BytesPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_BytesPath{
		NodePath: ygot.NewNodePath(
			[]string{"bytes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bytes (leaf): Number of bytes that have been forwarded over the
// label switched path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bytes"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/bytes"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny) Bytes() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_BytesPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_BytesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bytes"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPathTime (leaf): Indicates the time the LSP switched onto its
// current path. The value is reset upon a LSP path
// change.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "current-path-time"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/current-path-time"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath) CurrentPathTime() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_CurrentPathTimePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_CurrentPathTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"current-path-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentPathTime (leaf): Indicates the time the LSP switched onto its
// current path. The value is reset upon a LSP path
// change.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "current-path-time"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/current-path-time"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny) CurrentPathTime() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_CurrentPathTimePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_CurrentPathTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"current-path-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextReoptimizationTime (leaf): Indicates the next scheduled time the LSP
// will be reoptimized.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-reoptimization-time"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/next-reoptimization-time"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath) NextReoptimizationTime() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_NextReoptimizationTimePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_NextReoptimizationTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"next-reoptimization-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextReoptimizationTime (leaf): Indicates the next scheduled time the LSP
// will be reoptimized.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-reoptimization-time"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/next-reoptimization-time"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny) NextReoptimizationTime() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_NextReoptimizationTimePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_NextReoptimizationTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-reoptimization-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OnlineTime (leaf): Indication of the time the label switched path
// transitioned to an Oper Up or in-service state.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "online-time"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/online-time"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath) OnlineTime() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_OnlineTimePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_OnlineTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"online-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OnlineTime (leaf): Indication of the time the label switched path
// transitioned to an Oper Up or in-service state.
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "online-time"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/online-time"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny) OnlineTime() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_OnlineTimePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_OnlineTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"online-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Packets (leaf): Number of pacets that have been forwarded over the
// label switched path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "packets"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/packets"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath) Packets() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PacketsPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PacketsPath{
		NodePath: ygot.NewNodePath(
			[]string{"packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// Packets (leaf): Number of pacets that have been forwarded over the
// label switched path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "packets"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/packets"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny) Packets() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PacketsPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PacketsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"packets"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathChanges (leaf): Number of path changes for the label switched path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-changes"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/path-changes"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath) PathChanges() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PathChangesPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PathChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"path-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathChanges (leaf): Number of path changes for the label switched path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-changes"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/path-changes"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny) PathChanges() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PathChangesPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_PathChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// StateChanges (leaf): Number of state changes for the label switched path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state-changes"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/state-changes"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPath) StateChanges() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_StateChangesPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_StateChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// StateChanges (leaf): Number of state changes for the label switched path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state-changes"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/state/counters/state-changes"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_CountersPathAny) StateChanges() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_StateChangesPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_Counters_StateChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_DestinationPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/config/destination YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_DestinationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_DestinationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/config/destination YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_DestinationPathAny struct {
	*ygot.NodePath
}

// Destination (leaf): P2P tunnel destination address
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/config/destination"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPath) Destination() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_DestinationPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_DestinationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination"},
			map[string]interface{}{},
			n,
		),
	}
}

// Destination (leaf): P2P tunnel destination address
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/config/destination"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPathAny) Destination() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_DestinationPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_DestinationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination"},
			map[string]interface{}{},
			n,
		),
	}
}

// P2PPrimaryPathAny (list): List of p2p primary paths for a tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-primary-path/p2p-primary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPath) P2PPrimaryPathAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-primary-path", "p2p-primary-path"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// P2PPrimaryPathAny (list): List of p2p primary paths for a tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-primary-path/p2p-primary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPathAny) P2PPrimaryPathAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-primary-path", "p2p-primary-path"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// P2PPrimaryPath (list): List of p2p primary paths for a tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-primary-path/p2p-primary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path"
// Name: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPath) P2PPrimaryPath(Name string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-primary-path", "p2p-primary-path"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// P2PPrimaryPath (list): List of p2p primary paths for a tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-primary-path/p2p-primary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path"
// Name: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPathAny) P2PPrimaryPath(Name string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-primary-path", "p2p-primary-path"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// P2PSecondaryPathAny (list): List of p2p primary paths for a tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-secondary-paths/p2p-secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPath) P2PSecondaryPathAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-secondary-paths", "p2p-secondary-path"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// P2PSecondaryPathAny (list): List of p2p primary paths for a tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-secondary-paths/p2p-secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPathAny) P2PSecondaryPathAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-secondary-paths", "p2p-secondary-path"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// P2PSecondaryPath (list): List of p2p primary paths for a tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-secondary-paths/p2p-secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path"
// Name: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPath) P2PSecondaryPath(Name string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-secondary-paths", "p2p-secondary-path"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// P2PSecondaryPath (list): List of p2p primary paths for a tunnel
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "p2p-secondary-paths/p2p-secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path"
// Name: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributesPathAny) P2PSecondaryPath(Name string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"p2p-secondary-paths", "p2p-secondary-path"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AssociatedRsvpSessionsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/associated-rsvp-sessions YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AssociatedRsvpSessionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AssociatedRsvpSessionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/associated-rsvp-sessions YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AssociatedRsvpSessionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfMetricPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/cspf-metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/cspf-metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfTiebreakerPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/cspf-tiebreaker YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfTiebreakerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfTiebreakerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/cspf-tiebreaker YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfTiebreakerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_ExplicitPathNamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/explicit-path-name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_ExplicitPathNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_ExplicitPathNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/explicit-path-name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_ExplicitPathNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_HoldPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/hold-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_HoldPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_HoldPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/hold-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_HoldPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_NamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_NamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationMethodPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/path-computation-method YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationMethodPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationMethodPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/path-computation-method YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationMethodPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationServerPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/path-computation-server YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationServerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationServerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/path-computation-server YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationServerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PreferencePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/preference YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PreferencePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PreferencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/preference YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PreferencePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_RetryTimerPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/retry-timer YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_RetryTimerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_RetryTimerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/retry-timer YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_RetryTimerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SetupPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/setup-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SetupPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SetupPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/setup-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SetupPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SpfMetricPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/spf-metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SpfMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SpfMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/spf-metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SpfMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_UseCspfPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/use-cspf YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_UseCspfPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_UseCspfPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/use-cspf YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_UseCspfPathAny struct {
	*ygot.NodePath
}

// AdminGroups (container): Top-level container for include/exclude constraints for
// link affinities
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-groups"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) AdminGroups() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPath{
		NodePath: ygot.NewNodePath(
			[]string{"admin-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroups (container): Top-level container for include/exclude constraints for
// link affinities
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-groups"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) AdminGroups() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"admin-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssociatedRsvpSessions (leaf): If the signalling protocol specified for this path is
// RSVP-TE, this leaf-list provides a reference to the associated
// sessions within the RSVP-TE protocol sessions list, such
// that details of the signaling can be retrieved. More than
// one session may exist during re-signalling such as
// make-before-break.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/associated-rsvp-sessions"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/associated-rsvp-sessions"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) AssociatedRsvpSessions() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AssociatedRsvpSessionsPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AssociatedRsvpSessionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "associated-rsvp-sessions"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssociatedRsvpSessions (leaf): If the signalling protocol specified for this path is
// RSVP-TE, this leaf-list provides a reference to the associated
// sessions within the RSVP-TE protocol sessions list, such
// that details of the signaling can be retrieved. More than
// one session may exist during re-signalling such as
// make-before-break.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/associated-rsvp-sessions"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/associated-rsvp-sessions"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) AssociatedRsvpSessions() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AssociatedRsvpSessionsPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AssociatedRsvpSessionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "associated-rsvp-sessions"},
			map[string]interface{}{},
			n,
		),
	}
}

// CandidateSecondaryPathAny (list): List of secondary paths which may be utilised when the
// current primary path is in use
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "candidate-secondary-paths/candidate-secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path"
// SecondaryPath (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) CandidateSecondaryPathAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"candidate-secondary-paths", "candidate-secondary-path"},
			map[string]interface{}{"secondary-path": "*"},
			n,
		),
	}
}

// CandidateSecondaryPathAny (list): List of secondary paths which may be utilised when the
// current primary path is in use
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "candidate-secondary-paths/candidate-secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path"
// SecondaryPath (wildcarded): string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) CandidateSecondaryPathAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"candidate-secondary-paths", "candidate-secondary-path"},
			map[string]interface{}{"secondary-path": "*"},
			n,
		),
	}
}

// CandidateSecondaryPath (list): List of secondary paths which may be utilised when the
// current primary path is in use
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "candidate-secondary-paths/candidate-secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path"
// SecondaryPath: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) CandidateSecondaryPath(SecondaryPath string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"candidate-secondary-paths", "candidate-secondary-path"},
			map[string]interface{}{"secondary-path": SecondaryPath},
			n,
		),
	}
}

// CandidateSecondaryPath (list): List of secondary paths which may be utilised when the
// current primary path is in use
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "candidate-secondary-paths/candidate-secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path"
// SecondaryPath: string
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) CandidateSecondaryPath(SecondaryPath string) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"candidate-secondary-paths", "candidate-secondary-path"},
			map[string]interface{}{"secondary-path": SecondaryPath},
			n,
		),
	}
}

// CspfMetric (leaf): The IGP metric of the path currently used by the LSP.
// This value is used to represent the metric of the path
// used by the LSP following the execution of the CSPF
// algorithm and signalling of the LSP.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/cspf-metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/cspf-metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) CspfMetric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfMetricPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cspf-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// CspfMetric (leaf): The IGP metric of the path currently used by the LSP.
// This value is used to represent the metric of the path
// used by the LSP following the execution of the CSPF
// algorithm and signalling of the LSP.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/cspf-metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/cspf-metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) CspfMetric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfMetricPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cspf-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// CspfTiebreaker (leaf): Determine the tie-breaking method to choose between
// equally desirable paths during CSFP computation
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/cspf-tiebreaker"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/cspf-tiebreaker"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) CspfTiebreaker() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfTiebreakerPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfTiebreakerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cspf-tiebreaker"},
			map[string]interface{}{},
			n,
		),
	}
}

// CspfTiebreaker (leaf): Determine the tie-breaking method to choose between
// equally desirable paths during CSFP computation
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/cspf-tiebreaker"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/cspf-tiebreaker"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) CspfTiebreaker() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfTiebreakerPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CspfTiebreakerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cspf-tiebreaker"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExplicitPathName (leaf): reference to a defined path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/explicit-path-name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/explicit-path-name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) ExplicitPathName() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_ExplicitPathNamePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_ExplicitPathNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "explicit-path-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExplicitPathName (leaf): reference to a defined path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/explicit-path-name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/explicit-path-name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) ExplicitPathName() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_ExplicitPathNamePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_ExplicitPathNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "explicit-path-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldPriority (leaf): preemption priority once the LSP is established,
// lower is higher priority; default 0 indicates other LSPs
// will not preempt the LSPs once established
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/hold-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) HoldPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_HoldPriorityPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_HoldPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldPriority (leaf): preemption priority once the LSP is established,
// lower is higher priority; default 0 indicates other LSPs
// will not preempt the LSPs once established
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/hold-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) HoldPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_HoldPriorityPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_HoldPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Path name
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) Name() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_NamePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Path name
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) Name() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_NamePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathComputationMethod (leaf): The method used for computing the path, either
// locally computed, queried from a server or not
// computed at all (explicitly configured).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-computation-method"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/path-computation-method"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) PathComputationMethod() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationMethodPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationMethodPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-computation-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathComputationMethod (leaf): The method used for computing the path, either
// locally computed, queried from a server or not
// computed at all (explicitly configured).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-computation-method"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/path-computation-method"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) PathComputationMethod() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationMethodPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationMethodPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-computation-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathComputationServer (leaf): Address of the external path computation
// server
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-computation-server"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/path-computation-server"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) PathComputationServer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationServerPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationServerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-computation-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathComputationServer (leaf): Address of the external path computation
// server
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-computation-server"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/path-computation-server"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) PathComputationServer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationServerPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathComputationServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-computation-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathMetricBoundConstraintAny (list): A list of metric bounds that are applied as constraints to the LSP.
// It act as a logical AND, hence all of them must be satisfied.
// If not, it will return an error.
// Constraints within this list may be applicable to either
// the local CSPF process (where data is available to the local device)
// or be communicated to a PCE for calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-metric-bound-constraints/path-metric-bound-constraint"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint"
// Type (wildcarded): E_MplsTypes_PATH_METRIC_TYPE
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) PathMetricBoundConstraintAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-metric-bound-constraints", "path-metric-bound-constraint"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// PathMetricBoundConstraintAny (list): A list of metric bounds that are applied as constraints to the LSP.
// It act as a logical AND, hence all of them must be satisfied.
// If not, it will return an error.
// Constraints within this list may be applicable to either
// the local CSPF process (where data is available to the local device)
// or be communicated to a PCE for calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-metric-bound-constraints/path-metric-bound-constraint"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint"
// Type (wildcarded): E_MplsTypes_PATH_METRIC_TYPE
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) PathMetricBoundConstraintAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-metric-bound-constraints", "path-metric-bound-constraint"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// PathMetricBoundConstraint (list): A list of metric bounds that are applied as constraints to the LSP.
// It act as a logical AND, hence all of them must be satisfied.
// If not, it will return an error.
// Constraints within this list may be applicable to either
// the local CSPF process (where data is available to the local device)
// or be communicated to a PCE for calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-metric-bound-constraints/path-metric-bound-constraint"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint"
// Type: E_MplsTypes_PATH_METRIC_TYPE
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) PathMetricBoundConstraint(Type E_MplsTypes_PATH_METRIC_TYPE) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"path-metric-bound-constraints", "path-metric-bound-constraint"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// PathMetricBoundConstraint (list): A list of metric bounds that are applied as constraints to the LSP.
// It act as a logical AND, hence all of them must be satisfied.
// If not, it will return an error.
// Constraints within this list may be applicable to either
// the local CSPF process (where data is available to the local device)
// or be communicated to a PCE for calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-metric-bound-constraints/path-metric-bound-constraint"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint"
// Type: E_MplsTypes_PATH_METRIC_TYPE
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) PathMetricBoundConstraint(Type E_MplsTypes_PATH_METRIC_TYPE) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-metric-bound-constraints", "path-metric-bound-constraint"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Preference (leaf): Specifies a preference for this path. The lower the
// number higher the preference
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/preference"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/preference"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) Preference() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PreferencePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PreferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): Specifies a preference for this path. The lower the
// number higher the preference
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/preference"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/preference"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) Preference() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PreferencePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PreferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetryTimer (leaf): sets the time between attempts to establish the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/retry-timer"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/retry-timer"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) RetryTimer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_RetryTimerPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_RetryTimerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "retry-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetryTimer (leaf): sets the time between attempts to establish the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/retry-timer"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/retry-timer"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) RetryTimer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_RetryTimerPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_RetryTimerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "retry-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriority (leaf): RSVP-TE preemption priority during LSP setup, lower is
// higher priority; default 7 indicates that LSP will not
// preempt established LSPs during setup
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/setup-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/setup-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) SetupPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SetupPriorityPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SetupPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "setup-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriority (leaf): RSVP-TE preemption priority during LSP setup, lower is
// higher priority; default 7 indicates that LSP will not
// preempt established LSPs during setup
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/setup-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/setup-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) SetupPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SetupPriorityPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "setup-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfMetric (leaf): The IGP metric of the shortest path to the LSP destination.
// This value is used to compare the current metric of the
// constrained path to the shortest path that is available in
// the network topology.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/spf-metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/spf-metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) SpfMetric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SpfMetricPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SpfMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "spf-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfMetric (leaf): The IGP metric of the shortest path to the LSP destination.
// This value is used to compare the current metric of the
// constrained path to the shortest path that is available in
// the network topology.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/spf-metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/state/spf-metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) SpfMetric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SpfMetricPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_SpfMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "spf-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseCspf (leaf): Flag to enable CSPF for locally computed LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/use-cspf"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/use-cspf"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPath) UseCspf() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_UseCspfPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_UseCspfPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "use-cspf"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseCspf (leaf): Flag to enable CSPF for locally computed LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/use-cspf"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/config/use-cspf"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPathPathAny) UseCspf() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_UseCspfPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_UseCspfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "use-cspf"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_ExcludeGroupPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/exclude-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_ExcludeGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_ExcludeGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/exclude-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_ExcludeGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAllGroupPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/include-all-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAllGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAllGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/include-all-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAllGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAnyGroupPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/include-any-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAnyGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAnyGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/include-any-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAnyGroupPathAny struct {
	*ygot.NodePath
}

// ExcludeGroup (leaf): list of references to named admin-groups to exclude in
// path calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/exclude-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/exclude-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPath) ExcludeGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_ExcludeGroupPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_ExcludeGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "exclude-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExcludeGroup (leaf): list of references to named admin-groups to exclude in
// path calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/exclude-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/exclude-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPathAny) ExcludeGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_ExcludeGroupPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_ExcludeGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "exclude-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncludeAllGroup (leaf): list of references to named admin-groups of which all must
// be included
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include-all-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/include-all-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPath) IncludeAllGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAllGroupPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAllGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include-all-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncludeAllGroup (leaf): list of references to named admin-groups of which all must
// be included
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include-all-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/include-all-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPathAny) IncludeAllGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAllGroupPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAllGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include-all-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncludeAnyGroup (leaf): list of references to named admin-groups of which one must
// be included
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include-any-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/include-any-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPath) IncludeAnyGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAnyGroupPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAnyGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include-any-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncludeAnyGroup (leaf): list of references to named admin-groups of which one must
// be included
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include-any-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/admin-groups/config/include-any-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroupsPathAny) IncludeAnyGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAnyGroupPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_AdminGroups_IncludeAnyGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include-any-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_ActivePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/state/active YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_ActivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_ActivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/state/active YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_ActivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/config/priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/config/priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_PriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_SecondaryPathPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/config/secondary-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_SecondaryPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_SecondaryPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/config/secondary-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_SecondaryPathPathAny struct {
	*ygot.NodePath
}

// Active (leaf): Indicates the current active path option that has
// been selected of the candidate secondary paths
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/state/active"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPath) Active() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_ActivePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_ActivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// Active (leaf): Indicates the current active path option that has
// been selected of the candidate secondary paths
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/state/active"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny) Active() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_ActivePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_ActivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The priority of the specified secondary path option. Higher
// priority options are less preferable - such that a secondary
// path reference with a priority of 0 is the most preferred
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/config/priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPath) Priority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_PriorityPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The priority of the specified secondary path option. Higher
// priority options are less preferable - such that a secondary
// path reference with a priority of 0 is the most preferred
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/config/priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny) Priority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_PriorityPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecondaryPath (leaf): A reference to the secondary path that should be utilised
// when the containing primary path option is in use
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/config/secondary-path"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPath) SecondaryPath() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_SecondaryPathPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_SecondaryPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secondary-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecondaryPath (leaf): A reference to the secondary path that should be utilised
// when the containing primary path option is in use
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/secondary-path"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/candidate-secondary-paths/candidate-secondary-path/config/secondary-path"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPathPathAny) SecondaryPath() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_SecondaryPathPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_CandidateSecondaryPath_SecondaryPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secondary-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_MetricUpperBoundPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/metric-upper-bound YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_MetricUpperBoundPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_MetricUpperBoundPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/metric-upper-bound YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_MetricUpperBoundPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_TypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_TypePathAny struct {
	*ygot.NodePath
}

// MetricUpperBound (leaf): Upper bound on end-to-end path metric. A zero indicate
// an unbounded upper limit for the specific metric-type.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric-upper-bound"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/metric-upper-bound"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPath) MetricUpperBound() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_MetricUpperBoundPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_MetricUpperBoundPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric-upper-bound"},
			map[string]interface{}{},
			n,
		),
	}
}

// MetricUpperBound (leaf): Upper bound on end-to-end path metric. A zero indicate
// an unbounded upper limit for the specific metric-type.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric-upper-bound"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/metric-upper-bound"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny) MetricUpperBound() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_MetricUpperBoundPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_MetricUpperBoundPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric-upper-bound"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Identifies an entry in the list of metric-types
// bound for the TE path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPath) Type() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_TypePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Identifies an entry in the list of metric-types
// bound for the TE path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-primary-path/p2p-primary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraintPathAny) Type() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_TypePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PPrimaryPath_PathMetricBoundConstraint_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AssociatedRsvpSessionsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/associated-rsvp-sessions YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AssociatedRsvpSessionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AssociatedRsvpSessionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/associated-rsvp-sessions YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AssociatedRsvpSessionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfMetricPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/cspf-metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/cspf-metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfTiebreakerPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/cspf-tiebreaker YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfTiebreakerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfTiebreakerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/cspf-tiebreaker YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfTiebreakerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_ExplicitPathNamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/explicit-path-name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_ExplicitPathNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_ExplicitPathNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/explicit-path-name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_ExplicitPathNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_HoldPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/hold-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_HoldPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_HoldPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/hold-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_HoldPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_NamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_NamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationMethodPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/path-computation-method YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationMethodPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationMethodPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/path-computation-method YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationMethodPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationServerPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/path-computation-server YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationServerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationServerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/path-computation-server YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationServerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PreferencePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/preference YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PreferencePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PreferencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/preference YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PreferencePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_RetryTimerPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/retry-timer YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_RetryTimerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_RetryTimerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/retry-timer YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_RetryTimerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SetupPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/setup-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SetupPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SetupPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/setup-priority YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SetupPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SpfMetricPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/spf-metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SpfMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SpfMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/spf-metric YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SpfMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_UseCspfPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/use-cspf YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_UseCspfPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_UseCspfPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/use-cspf YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_UseCspfPathAny struct {
	*ygot.NodePath
}

// AdminGroups (container): Top-level container for include/exclude constraints for
// link affinities
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-groups"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) AdminGroups() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPath{
		NodePath: ygot.NewNodePath(
			[]string{"admin-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroups (container): Top-level container for include/exclude constraints for
// link affinities
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-groups"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) AdminGroups() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"admin-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssociatedRsvpSessions (leaf): If the signalling protocol specified for this path is
// RSVP-TE, this leaf-list provides a reference to the associated
// sessions within the RSVP-TE protocol sessions list, such
// that details of the signaling can be retrieved. More than
// one session may exist during re-signalling such as
// make-before-break.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/associated-rsvp-sessions"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/associated-rsvp-sessions"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) AssociatedRsvpSessions() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AssociatedRsvpSessionsPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AssociatedRsvpSessionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "associated-rsvp-sessions"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssociatedRsvpSessions (leaf): If the signalling protocol specified for this path is
// RSVP-TE, this leaf-list provides a reference to the associated
// sessions within the RSVP-TE protocol sessions list, such
// that details of the signaling can be retrieved. More than
// one session may exist during re-signalling such as
// make-before-break.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/associated-rsvp-sessions"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/associated-rsvp-sessions"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) AssociatedRsvpSessions() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AssociatedRsvpSessionsPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AssociatedRsvpSessionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "associated-rsvp-sessions"},
			map[string]interface{}{},
			n,
		),
	}
}

// CspfMetric (leaf): The IGP metric of the path currently used by the LSP.
// This value is used to represent the metric of the path
// used by the LSP following the execution of the CSPF
// algorithm and signalling of the LSP.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/cspf-metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/cspf-metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) CspfMetric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfMetricPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cspf-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// CspfMetric (leaf): The IGP metric of the path currently used by the LSP.
// This value is used to represent the metric of the path
// used by the LSP following the execution of the CSPF
// algorithm and signalling of the LSP.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/cspf-metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/cspf-metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) CspfMetric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfMetricPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cspf-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// CspfTiebreaker (leaf): Determine the tie-breaking method to choose between
// equally desirable paths during CSFP computation
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/cspf-tiebreaker"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/cspf-tiebreaker"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) CspfTiebreaker() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfTiebreakerPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfTiebreakerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cspf-tiebreaker"},
			map[string]interface{}{},
			n,
		),
	}
}

// CspfTiebreaker (leaf): Determine the tie-breaking method to choose between
// equally desirable paths during CSFP computation
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/cspf-tiebreaker"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/cspf-tiebreaker"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) CspfTiebreaker() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfTiebreakerPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_CspfTiebreakerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cspf-tiebreaker"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExplicitPathName (leaf): reference to a defined path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/explicit-path-name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/explicit-path-name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) ExplicitPathName() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_ExplicitPathNamePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_ExplicitPathNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "explicit-path-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExplicitPathName (leaf): reference to a defined path
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/explicit-path-name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/explicit-path-name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) ExplicitPathName() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_ExplicitPathNamePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_ExplicitPathNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "explicit-path-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldPriority (leaf): preemption priority once the LSP is established,
// lower is higher priority; default 0 indicates other LSPs
// will not preempt the LSPs once established
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/hold-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) HoldPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_HoldPriorityPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_HoldPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldPriority (leaf): preemption priority once the LSP is established,
// lower is higher priority; default 0 indicates other LSPs
// will not preempt the LSPs once established
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/hold-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) HoldPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_HoldPriorityPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_HoldPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Path name
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) Name() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_NamePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Path name
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/name"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) Name() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_NamePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathComputationMethod (leaf): The method used for computing the path, either
// locally computed, queried from a server or not
// computed at all (explicitly configured).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-computation-method"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/path-computation-method"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) PathComputationMethod() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationMethodPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationMethodPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-computation-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathComputationMethod (leaf): The method used for computing the path, either
// locally computed, queried from a server or not
// computed at all (explicitly configured).
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-computation-method"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/path-computation-method"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) PathComputationMethod() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationMethodPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationMethodPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-computation-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathComputationServer (leaf): Address of the external path computation
// server
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-computation-server"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/path-computation-server"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) PathComputationServer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationServerPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationServerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-computation-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathComputationServer (leaf): Address of the external path computation
// server
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-computation-server"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/path-computation-server"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) PathComputationServer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationServerPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathComputationServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-computation-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathMetricBoundConstraintAny (list): A list of metric bounds that are applied as constraints to the LSP.
// It act as a logical AND, hence all of them must be satisfied.
// If not, it will return an error.
// Constraints within this list may be applicable to either
// the local CSPF process (where data is available to the local device)
// or be communicated to a PCE for calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-metric-bound-constraints/path-metric-bound-constraint"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint"
// Type (wildcarded): E_MplsTypes_PATH_METRIC_TYPE
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) PathMetricBoundConstraintAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-metric-bound-constraints", "path-metric-bound-constraint"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// PathMetricBoundConstraintAny (list): A list of metric bounds that are applied as constraints to the LSP.
// It act as a logical AND, hence all of them must be satisfied.
// If not, it will return an error.
// Constraints within this list may be applicable to either
// the local CSPF process (where data is available to the local device)
// or be communicated to a PCE for calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-metric-bound-constraints/path-metric-bound-constraint"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint"
// Type (wildcarded): E_MplsTypes_PATH_METRIC_TYPE
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) PathMetricBoundConstraintAny() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-metric-bound-constraints", "path-metric-bound-constraint"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// PathMetricBoundConstraint (list): A list of metric bounds that are applied as constraints to the LSP.
// It act as a logical AND, hence all of them must be satisfied.
// If not, it will return an error.
// Constraints within this list may be applicable to either
// the local CSPF process (where data is available to the local device)
// or be communicated to a PCE for calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-metric-bound-constraints/path-metric-bound-constraint"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint"
// Type: E_MplsTypes_PATH_METRIC_TYPE
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) PathMetricBoundConstraint(Type E_MplsTypes_PATH_METRIC_TYPE) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"path-metric-bound-constraints", "path-metric-bound-constraint"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// PathMetricBoundConstraint (list): A list of metric bounds that are applied as constraints to the LSP.
// It act as a logical AND, hence all of them must be satisfied.
// If not, it will return an error.
// Constraints within this list may be applicable to either
// the local CSPF process (where data is available to the local device)
// or be communicated to a PCE for calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-metric-bound-constraints/path-metric-bound-constraint"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint"
// Type: E_MplsTypes_PATH_METRIC_TYPE
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) PathMetricBoundConstraint(Type E_MplsTypes_PATH_METRIC_TYPE) *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-metric-bound-constraints", "path-metric-bound-constraint"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Preference (leaf): Specifies a preference for this path. The lower the
// number higher the preference
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/preference"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/preference"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) Preference() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PreferencePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PreferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): Specifies a preference for this path. The lower the
// number higher the preference
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/preference"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/preference"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) Preference() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PreferencePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PreferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetryTimer (leaf): sets the time between attempts to establish the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/retry-timer"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/retry-timer"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) RetryTimer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_RetryTimerPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_RetryTimerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "retry-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetryTimer (leaf): sets the time between attempts to establish the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/retry-timer"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/retry-timer"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) RetryTimer() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_RetryTimerPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_RetryTimerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "retry-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriority (leaf): RSVP-TE preemption priority during LSP setup, lower is
// higher priority; default 7 indicates that LSP will not
// preempt established LSPs during setup
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/setup-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/setup-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) SetupPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SetupPriorityPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SetupPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "setup-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriority (leaf): RSVP-TE preemption priority during LSP setup, lower is
// higher priority; default 7 indicates that LSP will not
// preempt established LSPs during setup
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/setup-priority"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/setup-priority"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) SetupPriority() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SetupPriorityPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "setup-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfMetric (leaf): The IGP metric of the shortest path to the LSP destination.
// This value is used to compare the current metric of the
// constrained path to the shortest path that is available in
// the network topology.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/spf-metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/spf-metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) SpfMetric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SpfMetricPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SpfMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "spf-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfMetric (leaf): The IGP metric of the shortest path to the LSP destination.
// This value is used to compare the current metric of the
// constrained path to the shortest path that is available in
// the network topology.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/spf-metric"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/state/spf-metric"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) SpfMetric() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SpfMetricPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_SpfMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "spf-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseCspf (leaf): Flag to enable CSPF for locally computed LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/use-cspf"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/use-cspf"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPath) UseCspf() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_UseCspfPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_UseCspfPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "use-cspf"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseCspf (leaf): Flag to enable CSPF for locally computed LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/use-cspf"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/config/use-cspf"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPathPathAny) UseCspf() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_UseCspfPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_UseCspfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "use-cspf"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_ExcludeGroupPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/exclude-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_ExcludeGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_ExcludeGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/exclude-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_ExcludeGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAllGroupPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/include-all-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAllGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAllGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/include-all-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAllGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAnyGroupPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/include-any-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAnyGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAnyGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/include-any-group YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAnyGroupPathAny struct {
	*ygot.NodePath
}

// ExcludeGroup (leaf): list of references to named admin-groups to exclude in
// path calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/exclude-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/exclude-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPath) ExcludeGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_ExcludeGroupPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_ExcludeGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "exclude-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExcludeGroup (leaf): list of references to named admin-groups to exclude in
// path calculation.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/exclude-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/exclude-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPathAny) ExcludeGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_ExcludeGroupPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_ExcludeGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "exclude-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncludeAllGroup (leaf): list of references to named admin-groups of which all must
// be included
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include-all-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/include-all-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPath) IncludeAllGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAllGroupPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAllGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include-all-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncludeAllGroup (leaf): list of references to named admin-groups of which all must
// be included
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include-all-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/include-all-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPathAny) IncludeAllGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAllGroupPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAllGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include-all-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncludeAnyGroup (leaf): list of references to named admin-groups of which one must
// be included
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include-any-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/include-any-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPath) IncludeAnyGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAnyGroupPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAnyGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include-any-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncludeAnyGroup (leaf): list of references to named admin-groups of which one must
// be included
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include-any-group"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/admin-groups/config/include-any-group"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroupsPathAny) IncludeAnyGroup() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAnyGroupPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_AdminGroups_IncludeAnyGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include-any-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_MetricUpperBoundPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/metric-upper-bound YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_MetricUpperBoundPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_MetricUpperBoundPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/metric-upper-bound YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_MetricUpperBoundPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_TypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/type YANG schema element.
type NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_TypePathAny struct {
	*ygot.NodePath
}

// MetricUpperBound (leaf): Upper bound on end-to-end path metric. A zero indicate
// an unbounded upper limit for the specific metric-type.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric-upper-bound"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/metric-upper-bound"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPath) MetricUpperBound() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_MetricUpperBoundPath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_MetricUpperBoundPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric-upper-bound"},
			map[string]interface{}{},
			n,
		),
	}
}

// MetricUpperBound (leaf): Upper bound on end-to-end path metric. A zero indicate
// an unbounded upper limit for the specific metric-type.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric-upper-bound"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/metric-upper-bound"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny) MetricUpperBound() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_MetricUpperBoundPathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_MetricUpperBoundPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric-upper-bound"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Identifies an entry in the list of metric-types
// bound for the TE path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPath) Type() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_TypePath {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Identifies an entry in the list of metric-types
// bound for the TE path.
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/mpls/lsps/constrained-path/tunnels/tunnel/p2p-tunnel-attributes/p2p-secondary-paths/p2p-secondary-path/path-metric-bound-constraints/path-metric-bound-constraint/config/type"
func (n *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraintPathAny) Type() *NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_TypePathAny {
	return &NetworkInstance_Mpls_Lsps_ConstrainedPath_Tunnel_P2PTunnelAttributes_P2PSecondaryPath_PathMetricBoundConstraint_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_StaticLspPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLspPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLspPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLspPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_NamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/config/name YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_NamePathAny struct {
	*ygot.NodePath
}

// Egress (container): Static LSPs for which the router is an
//  egress node
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "egress"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress"
func (n *NetworkInstance_Mpls_Lsps_StaticLspPath) Egress() *NetworkInstance_Mpls_Lsps_StaticLsp_EgressPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_EgressPath{
		NodePath: ygot.NewNodePath(
			[]string{"egress"},
			map[string]interface{}{},
			n,
		),
	}
}

// Egress (container): Static LSPs for which the router is an
//  egress node
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "egress"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress"
func (n *NetworkInstance_Mpls_Lsps_StaticLspPathAny) Egress() *NetworkInstance_Mpls_Lsps_StaticLsp_EgressPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_EgressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"egress"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ingress (container): Static LSPs for which the router is an
//  ingress node
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ingress"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress"
func (n *NetworkInstance_Mpls_Lsps_StaticLspPath) Ingress() *NetworkInstance_Mpls_Lsps_StaticLsp_IngressPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_IngressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ingress"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ingress (container): Static LSPs for which the router is an
//  ingress node
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ingress"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress"
func (n *NetworkInstance_Mpls_Lsps_StaticLspPathAny) Ingress() *NetworkInstance_Mpls_Lsps_StaticLsp_IngressPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_IngressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): name to identify the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/config/name"
func (n *NetworkInstance_Mpls_Lsps_StaticLspPath) Name() *NetworkInstance_Mpls_Lsps_StaticLsp_NamePath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): name to identify the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/config/name"
func (n *NetworkInstance_Mpls_Lsps_StaticLspPathAny) Name() *NetworkInstance_Mpls_Lsps_StaticLsp_NamePathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transit (container): Static LSPs for which the router is an
//  transit node
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transit"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit"
func (n *NetworkInstance_Mpls_Lsps_StaticLspPath) Transit() *NetworkInstance_Mpls_Lsps_StaticLsp_TransitPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_TransitPath{
		NodePath: ygot.NewNodePath(
			[]string{"transit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transit (container): Static LSPs for which the router is an
//  transit node
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transit"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit"
func (n *NetworkInstance_Mpls_Lsps_StaticLspPathAny) Transit() *NetworkInstance_Mpls_Lsps_StaticLsp_TransitPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_TransitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transit"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_StaticLsp_EgressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_EgressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_EgressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_EgressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Egress_IncomingLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/incoming-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Egress_IncomingLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Egress_IncomingLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/incoming-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Egress_IncomingLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Egress_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/next-hop YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Egress_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Egress_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/next-hop YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Egress_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Egress_PushLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/push-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Egress_PushLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Egress_PushLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/push-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Egress_PushLabelPathAny struct {
	*ygot.NodePath
}

// IncomingLabel (leaf): label value on the incoming packet
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/incoming-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/incoming-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_EgressPath) IncomingLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Egress_IncomingLabelPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Egress_IncomingLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "incoming-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncomingLabel (leaf): label value on the incoming packet
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/incoming-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/incoming-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_EgressPathAny) IncomingLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Egress_IncomingLabelPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Egress_IncomingLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "incoming-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): next hop IP address for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/next-hop"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_EgressPath) NextHop() *NetworkInstance_Mpls_Lsps_StaticLsp_Egress_NextHopPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Egress_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): next hop IP address for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/next-hop"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_EgressPathAny) NextHop() *NetworkInstance_Mpls_Lsps_StaticLsp_Egress_NextHopPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Egress_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushLabel (leaf): label value to push at the current hop for the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/push-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/push-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_EgressPath) PushLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Egress_PushLabelPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Egress_PushLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "push-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushLabel (leaf): label value to push at the current hop for the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/push-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/egress/config/push-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_EgressPathAny) PushLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Egress_PushLabelPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Egress_PushLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "push-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_StaticLsp_IngressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_IngressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_IngressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_IngressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_IncomingLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/incoming-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_IncomingLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_IncomingLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/incoming-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_IncomingLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/next-hop YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/next-hop YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_PushLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/push-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_PushLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_PushLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/push-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_PushLabelPathAny struct {
	*ygot.NodePath
}

// IncomingLabel (leaf): label value on the incoming packet
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/incoming-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/incoming-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_IngressPath) IncomingLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_IncomingLabelPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_IncomingLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "incoming-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncomingLabel (leaf): label value on the incoming packet
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/incoming-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/incoming-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_IngressPathAny) IncomingLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_IncomingLabelPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_IncomingLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "incoming-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): next hop IP address for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/next-hop"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_IngressPath) NextHop() *NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_NextHopPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): next hop IP address for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/next-hop"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_IngressPathAny) NextHop() *NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_NextHopPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushLabel (leaf): label value to push at the current hop for the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/push-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/push-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_IngressPath) PushLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_PushLabelPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_PushLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "push-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushLabel (leaf): label value to push at the current hop for the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/push-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/ingress/config/push-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_IngressPathAny) PushLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_PushLabelPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Ingress_PushLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "push-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_StaticLsp_TransitPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_TransitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_TransitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_TransitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Transit_IncomingLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/incoming-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Transit_IncomingLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Transit_IncomingLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/incoming-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Transit_IncomingLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Transit_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/next-hop YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Transit_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Transit_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/next-hop YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Transit_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Transit_PushLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/push-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Transit_PushLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_StaticLsp_Transit_PushLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/push-label YANG schema element.
type NetworkInstance_Mpls_Lsps_StaticLsp_Transit_PushLabelPathAny struct {
	*ygot.NodePath
}

// IncomingLabel (leaf): label value on the incoming packet
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/incoming-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/incoming-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_TransitPath) IncomingLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Transit_IncomingLabelPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Transit_IncomingLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "incoming-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// IncomingLabel (leaf): label value on the incoming packet
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/incoming-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/incoming-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_TransitPathAny) IncomingLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Transit_IncomingLabelPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Transit_IncomingLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "incoming-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): next hop IP address for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/next-hop"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_TransitPath) NextHop() *NetworkInstance_Mpls_Lsps_StaticLsp_Transit_NextHopPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Transit_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): next hop IP address for the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/next-hop"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_TransitPathAny) NextHop() *NetworkInstance_Mpls_Lsps_StaticLsp_Transit_NextHopPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Transit_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushLabel (leaf): label value to push at the current hop for the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/push-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/push-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_TransitPath) PushLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Transit_PushLabelPath {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Transit_PushLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "push-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushLabel (leaf): label value to push at the current hop for the
// LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-static"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/push-label"
// Path from root: "/network-instances/network-instance/mpls/lsps/static-lsps/static-lsp/transit/config/push-label"
func (n *NetworkInstance_Mpls_Lsps_StaticLsp_TransitPathAny) PushLabel() *NetworkInstance_Mpls_Lsps_StaticLsp_Transit_PushLabelPathAny {
	return &NetworkInstance_Mpls_Lsps_StaticLsp_Transit_PushLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "push-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_UnconstrainedPathPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/unconstrained-path YANG schema element.
type NetworkInstance_Mpls_Lsps_UnconstrainedPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_UnconstrainedPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/unconstrained-path YANG schema element.
type NetworkInstance_Mpls_Lsps_UnconstrainedPathPathAny struct {
	*ygot.NodePath
}

// PathSetupProtocol (container): select and configure the signaling method for
//  the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-igp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-setup-protocol"
// Path from root: "/network-instances/network-instance/mpls/lsps/unconstrained-path/path-setup-protocol"
func (n *NetworkInstance_Mpls_Lsps_UnconstrainedPathPath) PathSetupProtocol() *NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPath {
	return &NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"path-setup-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathSetupProtocol (container): select and configure the signaling method for
//  the LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-igp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-setup-protocol"
// Path from root: "/network-instances/network-instance/mpls/lsps/unconstrained-path/path-setup-protocol"
func (n *NetworkInstance_Mpls_Lsps_UnconstrainedPathPathAny) PathSetupProtocol() *NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPathAny {
	return &NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-setup-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/unconstrained-path/path-setup-protocol YANG schema element.
type NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/unconstrained-path/path-setup-protocol YANG schema element.
type NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPathAny struct {
	*ygot.NodePath
}

// Ldp (container): LDP signaling setup for IGP-congruent LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ldp"
// Path from root: "/network-instances/network-instance/mpls/lsps/unconstrained-path/path-setup-protocol/ldp"
func (n *NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPath) Ldp() *NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocol_LdpPath {
	return &NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocol_LdpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ldp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ldp (container): LDP signaling setup for IGP-congruent LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ldp"
// Path from root: "/network-instances/network-instance/mpls/lsps/unconstrained-path/path-setup-protocol/ldp"
func (n *NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocolPathAny) Ldp() *NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocol_LdpPathAny {
	return &NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocol_LdpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ldp"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocol_LdpPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/unconstrained-path/path-setup-protocol/ldp YANG schema element.
type NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocol_LdpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocol_LdpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/lsps/unconstrained-path/path-setup-protocol/ldp YANG schema element.
type NetworkInstance_Mpls_Lsps_UnconstrainedPath_PathSetupProtocol_LdpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocolsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols YANG schema element.
type NetworkInstance_Mpls_SignalingProtocolsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocolsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols YANG schema element.
type NetworkInstance_Mpls_SignalingProtocolsPathAny struct {
	*ygot.NodePath
}

// Ldp (container): LDP global signaling configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ldp"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp"
func (n *NetworkInstance_Mpls_SignalingProtocolsPath) Ldp() *NetworkInstance_Mpls_SignalingProtocols_LdpPath {
	return &NetworkInstance_Mpls_SignalingProtocols_LdpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ldp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ldp (container): LDP global signaling configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ldp"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp"
func (n *NetworkInstance_Mpls_SignalingProtocolsPathAny) Ldp() *NetworkInstance_Mpls_SignalingProtocols_LdpPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_LdpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ldp"},
			map[string]interface{}{},
			n,
		),
	}
}

// RsvpTe (container): RSVP-TE global signaling protocol configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rsvp-te"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te"
func (n *NetworkInstance_Mpls_SignalingProtocolsPath) RsvpTe() *NetworkInstance_Mpls_SignalingProtocols_RsvpTePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTePath{
		NodePath: ygot.NewNodePath(
			[]string{"rsvp-te"},
			map[string]interface{}{},
			n,
		),
	}
}

// RsvpTe (container): RSVP-TE global signaling protocol configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rsvp-te"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te"
func (n *NetworkInstance_Mpls_SignalingProtocolsPathAny) RsvpTe() *NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rsvp-te"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRouting (container): MPLS-specific Segment Routing configuration and operational state
// parameters
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing"
func (n *NetworkInstance_Mpls_SignalingProtocolsPath) SegmentRouting() *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRouting (container): MPLS-specific Segment Routing configuration and operational state
// parameters
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing"
func (n *NetworkInstance_Mpls_SignalingProtocolsPathAny) SegmentRouting() *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_LdpPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_LdpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_LdpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_LdpPathAny struct {
	*ygot.NodePath
}

// Global (container): Platform wide LDP configuration and state
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global"
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPath) Global() *NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPath{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// Global (container): Platform wide LDP configuration and state
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global"
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPathAny) Global() *NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAttributes (container): Container including attributes for LDP-enabled
// interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes"
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPath) InterfaceAttributes() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAttributes (container): Container including attributes for LDP-enabled
// interfaces
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes"
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPathAny) InterfaceAttributes() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): List of LDP neighbors and their attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor"
// LsrId (wildcarded): string
// LabelSpaceId (wildcarded): uint16
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPath) NeighborAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"lsr-id": "*", "label-space-id": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of LDP neighbors and their attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor"
// LsrId (wildcarded): string
// LabelSpaceId (wildcarded): uint16
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPathAny) NeighborAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"lsr-id": "*", "label-space-id": "*"},
			n,
		),
	}
}

// NeighborAnyLabelSpaceId (list): List of LDP neighbors and their attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor"
// LsrId: string
// LabelSpaceId (wildcarded): uint16
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPath) NeighborAnyLabelSpaceId(LsrId string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"lsr-id": LsrId, "label-space-id": "*"},
			n,
		),
	}
}

// NeighborAnyLabelSpaceId (list): List of LDP neighbors and their attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor"
// LsrId: string
// LabelSpaceId (wildcarded): uint16
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPathAny) NeighborAnyLabelSpaceId(LsrId string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"lsr-id": LsrId, "label-space-id": "*"},
			n,
		),
	}
}

// NeighborAnyLsrId (list): List of LDP neighbors and their attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor"
// LsrId (wildcarded): string
// LabelSpaceId: uint16
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPath) NeighborAnyLsrId(LabelSpaceId uint16) *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"lsr-id": "*", "label-space-id": LabelSpaceId},
			n,
		),
	}
}

// NeighborAnyLsrId (list): List of LDP neighbors and their attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor"
// LsrId (wildcarded): string
// LabelSpaceId: uint16
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPathAny) NeighborAnyLsrId(LabelSpaceId uint16) *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"lsr-id": "*", "label-space-id": LabelSpaceId},
			n,
		),
	}
}

// Neighbor (list): List of LDP neighbors and their attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor"
// LsrId: string
// LabelSpaceId: uint16
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPath) Neighbor(LsrId string, LabelSpaceId uint16) *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"lsr-id": LsrId, "label-space-id": LabelSpaceId},
			n,
		),
	}
}

// Neighbor (list): List of LDP neighbors and their attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor"
// LsrId: string
// LabelSpaceId: uint16
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPathAny) Neighbor(LsrId string, LabelSpaceId uint16) *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"lsr-id": LsrId, "label-space-id": LabelSpaceId},
			n,
		),
	}
}

// Targeted (container): Top container for targeted LDP state and configuration
// attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targeted"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted"
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPath) Targeted() *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPath{
		NodePath: ygot.NewNodePath(
			[]string{"targeted"},
			map[string]interface{}{},
			n,
		),
	}
}

// Targeted (container): Top container for targeted LDP state and configuration
// attributes.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targeted"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted"
func (n *NetworkInstance_Mpls_SignalingProtocols_LdpPathAny) Targeted() *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"targeted"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_LsrIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/config/lsr-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_LsrIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_LsrIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/config/lsr-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_LsrIdPathAny struct {
	*ygot.NodePath
}

// Authentication (container): Global LDP authentication
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPath) Authentication() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPath{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authentication (container): Global LDP authentication
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPathAny) Authentication() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Top container for LDP graceful-restart attributes
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPath) GracefulRestart() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Top container for LDP graceful-restart attributes
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPathAny) GracefulRestart() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// LsrId (leaf): Global label switch router identifier
// configuration.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsr-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/config/lsr-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPath) LsrId() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_LsrIdPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_LsrIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsr-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LsrId (leaf): Global label switch router identifier
// configuration.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsr-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/config/lsr-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_GlobalPathAny) LsrId() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_LsrIdPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_LsrIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsr-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_AuthenticationKeyPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication/config/authentication-key YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_AuthenticationKeyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_AuthenticationKeyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication/config/authentication-key YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_AuthenticationKeyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_EnablePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_EnablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_EnablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_EnablePathAny struct {
	*ygot.NodePath
}

// AuthenticationKey (leaf): authenticate LDP signaling
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-key"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication/config/authentication-key"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPath) AuthenticationKey() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_AuthenticationKeyPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_AuthenticationKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationKey (leaf): authenticate LDP signaling
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-key"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication/config/authentication-key"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPathAny) AuthenticationKey() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_AuthenticationKeyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_AuthenticationKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables LDP authentication on the node.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPath) Enable() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_EnablePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables LDP authentication on the node.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/authentication/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_AuthenticationPathAny) Enable() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_EnablePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_Authentication_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ForwardingHoldtimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/forwarding-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ForwardingHoldtimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ForwardingHoldtimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/forwarding-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ForwardingHoldtimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_HelperEnablePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/helper-enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_HelperEnablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_HelperEnablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/helper-enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_HelperEnablePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ReconnectTimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/reconnect-time YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ReconnectTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ReconnectTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/reconnect-time YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ReconnectTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_RecoveryTimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/recovery-time YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_RecoveryTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_RecoveryTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/recovery-time YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_RecoveryTimePathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/enabled"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPath) Enabled() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_EnabledPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/enabled"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPathAny) Enabled() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_EnabledPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingHoldtime (leaf): Time that defines the interval for keeping the
// node in recovery mode.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/forwarding-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/forwarding-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPath) ForwardingHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ForwardingHoldtimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ForwardingHoldtimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingHoldtime (leaf): Time that defines the interval for keeping the
// node in recovery mode.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/forwarding-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/forwarding-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPathAny) ForwardingHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ForwardingHoldtimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ForwardingHoldtimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperEnable (leaf): Enables the graceful restart helper for LDP.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/helper-enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPath) HelperEnable() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_HelperEnablePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_HelperEnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperEnable (leaf): Enables the graceful restart helper for LDP.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/helper-enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPathAny) HelperEnable() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_HelperEnablePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_HelperEnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReconnectTime (leaf): Interval for which the remote LDP peers
// will wait for the local node to reconnect after a
// failure
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reconnect-time"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/reconnect-time"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPath) ReconnectTime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ReconnectTimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ReconnectTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reconnect-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReconnectTime (leaf): Interval for which the remote LDP peers
// will wait for the local node to reconnect after a
// failure
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reconnect-time"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/reconnect-time"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPathAny) ReconnectTime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ReconnectTimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_ReconnectTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reconnect-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RecoveryTime (leaf): Interval used to specify the time for the remote
// peer to maintain the MPLS forwarding state after
// the local node has succesfully reconnected
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/recovery-time"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/recovery-time"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPath) RecoveryTime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_RecoveryTimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_RecoveryTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "recovery-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RecoveryTime (leaf): Interval used to specify the time for the remote
// peer to maintain the MPLS forwarding state after
// the local node has succesfully reconnected
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/recovery-time"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/global/graceful-restart/config/recovery-time"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestartPathAny) RecoveryTime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_RecoveryTimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Global_GracefulRestart_RecoveryTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "recovery-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloHoldtimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/config/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloHoldtimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloHoldtimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/config/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloHoldtimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloIntervalPathAny struct {
	*ygot.NodePath
}

// HelloHoldtime (leaf): Defines the time for which a neighbor adjacency will
// be kept by the router while it waits for a new link
// Hello message.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/config/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPath) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloHoldtimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloHoldtimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloHoldtime (leaf): Defines the time for which a neighbor adjacency will
// be kept by the router while it waits for a new link
// Hello message.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/config/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPathAny) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloHoldtimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloHoldtimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Defines the interval for sending Hello messages on
// each link LDP adjacency.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPath) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloIntervalPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Defines the interval for sending Hello messages on
// each link LDP adjacency.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPathAny) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloIntervalPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_HelloIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): list of per-interface LDP configurations
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPath) InterfaceAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): list of per-interface LDP configurations
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPathAny) InterfaceAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// Interface (list): list of per-interface LDP configurations
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPath) Interface(InterfaceId string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Interface (list): list of per-interface LDP configurations
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributesPathAny) Interface(InterfaceId string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloHoldtimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloHoldtimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloHoldtimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloHoldtimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// AddressFamilyAny (list): List for attributes related to address-families for LDP.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "address-families/address-family"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family"
// AfiName (wildcarded): E_MplsLdp_MplsLdpAfi
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath) AddressFamilyAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"address-families", "address-family"},
			map[string]interface{}{"afi-name": "*"},
			n,
		),
	}
}

// AddressFamilyAny (list): List for attributes related to address-families for LDP.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "address-families/address-family"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family"
// AfiName (wildcarded): E_MplsLdp_MplsLdpAfi
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny) AddressFamilyAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"address-families", "address-family"},
			map[string]interface{}{"afi-name": "*"},
			n,
		),
	}
}

// AddressFamily (list): List for attributes related to address-families for LDP.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "address-families/address-family"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family"
// AfiName: E_MplsLdp_MplsLdpAfi
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath) AddressFamily(AfiName E_MplsLdp_MplsLdpAfi) *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"address-families", "address-family"},
			map[string]interface{}{"afi-name": AfiName},
			n,
		),
	}
}

// AddressFamily (list): List for attributes related to address-families for LDP.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "address-families/address-family"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family"
// AfiName: E_MplsLdp_MplsLdpAfi
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny) AddressFamily(AfiName E_MplsLdp_MplsLdpAfi) *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"address-families", "address-family"},
			map[string]interface{}{"afi-name": AfiName},
			n,
		),
	}
}

// Counters (container): Interface specific LDP statistics and counters
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/state/counters"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath) Counters() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_CountersPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Interface specific LDP statistics and counters
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/state/counters"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny) Counters() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_CountersPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloHoldtime (leaf): Defines the time for which a neighbor adjacency will
// be kept by the router while it waits for a new link
// Hello message.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloHoldtimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloHoldtimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloHoldtime (leaf): Defines the time for which a neighbor adjacency will
// be kept by the router while it waits for a new link
// Hello message.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloHoldtimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloHoldtimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Defines the interval for sending Hello messages on
// each link LDP adjacency.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloIntervalPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Defines the interval for sending Hello messages on
// each link LDP adjacency.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloIntervalPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_HelloIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Identifier for the interface
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath) InterfaceId() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceIdPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Identifier for the interface
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny) InterfaceId() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceIdPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePath) InterfaceRef() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_InterfacePathAny) InterfaceRef() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_AfiNamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family/config/afi-name YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_AfiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_AfiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family/config/afi-name YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_AfiNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family/config/enabled YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family/config/enabled YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_EnabledPathAny struct {
	*ygot.NodePath
}

// AfiName (leaf): Adress-family name atttibute (IPv4, IPv6).
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family/config/afi-name"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPath) AfiName() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_AfiNamePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_AfiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiName (leaf): Adress-family name atttibute (IPv4, IPv6).
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family/config/afi-name"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny) AfiName() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_AfiNamePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_AfiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family/config/enabled"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPath) Enabled() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_EnabledPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/address-families/address-family/config/enabled"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamilyPathAny) Enabled() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_EnabledPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_AddressFamily_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/state/counters YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/state/counters YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPath) Interface() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/interface-attributes/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_InterfaceAttributes_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LabelSpaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/config/label-space-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LabelSpaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LabelSpaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/config/label-space-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LabelSpaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LsrIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/config/lsr-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LsrIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LsrIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/config/lsr-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LsrIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_SessionStatePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/state/session-state YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_SessionStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_SessionStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/state/session-state YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_SessionStatePathAny struct {
	*ygot.NodePath
}

// Authentication (container): Global LDP authentication
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath) Authentication() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPath{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authentication (container): Global LDP authentication
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny) Authentication() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloAdjacencyAny (list): List of hello adjacencies for a given LDP
// neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-adjacencies/hello-adjacency"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency"
// RemoteAddress (wildcarded): string
// LocalAddress (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath) HelloAdjacencyAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-adjacencies", "hello-adjacency"},
			map[string]interface{}{"remote-address": "*", "local-address": "*"},
			n,
		),
	}
}

// HelloAdjacencyAny (list): List of hello adjacencies for a given LDP
// neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-adjacencies/hello-adjacency"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency"
// RemoteAddress (wildcarded): string
// LocalAddress (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny) HelloAdjacencyAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-adjacencies", "hello-adjacency"},
			map[string]interface{}{"remote-address": "*", "local-address": "*"},
			n,
		),
	}
}

// HelloAdjacencyAnyLocalAddress (list): List of hello adjacencies for a given LDP
// neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-adjacencies/hello-adjacency"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency"
// RemoteAddress: string
// LocalAddress (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath) HelloAdjacencyAnyLocalAddress(RemoteAddress string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-adjacencies", "hello-adjacency"},
			map[string]interface{}{"remote-address": RemoteAddress, "local-address": "*"},
			n,
		),
	}
}

// HelloAdjacencyAnyLocalAddress (list): List of hello adjacencies for a given LDP
// neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-adjacencies/hello-adjacency"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency"
// RemoteAddress: string
// LocalAddress (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny) HelloAdjacencyAnyLocalAddress(RemoteAddress string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-adjacencies", "hello-adjacency"},
			map[string]interface{}{"remote-address": RemoteAddress, "local-address": "*"},
			n,
		),
	}
}

// HelloAdjacencyAnyRemoteAddress (list): List of hello adjacencies for a given LDP
// neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-adjacencies/hello-adjacency"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency"
// RemoteAddress (wildcarded): string
// LocalAddress: string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath) HelloAdjacencyAnyRemoteAddress(LocalAddress string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-adjacencies", "hello-adjacency"},
			map[string]interface{}{"remote-address": "*", "local-address": LocalAddress},
			n,
		),
	}
}

// HelloAdjacencyAnyRemoteAddress (list): List of hello adjacencies for a given LDP
// neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-adjacencies/hello-adjacency"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency"
// RemoteAddress (wildcarded): string
// LocalAddress: string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny) HelloAdjacencyAnyRemoteAddress(LocalAddress string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-adjacencies", "hello-adjacency"},
			map[string]interface{}{"remote-address": "*", "local-address": LocalAddress},
			n,
		),
	}
}

// HelloAdjacency (list): List of hello adjacencies for a given LDP
// neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-adjacencies/hello-adjacency"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency"
// RemoteAddress: string
// LocalAddress: string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath) HelloAdjacency(RemoteAddress string, LocalAddress string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath{
		NodePath: ygot.NewNodePath(
			[]string{"hello-adjacencies", "hello-adjacency"},
			map[string]interface{}{"remote-address": RemoteAddress, "local-address": LocalAddress},
			n,
		),
	}
}

// HelloAdjacency (list): List of hello adjacencies for a given LDP
// neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-adjacencies/hello-adjacency"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency"
// RemoteAddress: string
// LocalAddress: string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny) HelloAdjacency(RemoteAddress string, LocalAddress string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-adjacencies", "hello-adjacency"},
			map[string]interface{}{"remote-address": RemoteAddress, "local-address": LocalAddress},
			n,
		),
	}
}

// LabelSpaceId (leaf): Label space ID of the neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/label-space-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/config/label-space-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath) LabelSpaceId() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LabelSpaceIdPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LabelSpaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "label-space-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LabelSpaceId (leaf): Label space ID of the neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/label-space-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/config/label-space-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny) LabelSpaceId() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LabelSpaceIdPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LabelSpaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "label-space-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LsrId (leaf): Neighbor label switch router identifier.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsr-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/config/lsr-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath) LsrId() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LsrIdPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LsrIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsr-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LsrId (leaf): Neighbor label switch router identifier.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsr-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/config/lsr-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny) LsrId() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LsrIdPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_LsrIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsr-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionState (leaf): Operational status of the LDP session,
// based on the state machine for session
// negotiation behavior.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/session-state"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/state/session-state"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPath) SessionState() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_SessionStatePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_SessionStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionState (leaf): Operational status of the LDP session,
// based on the state machine for session
// negotiation behavior.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/session-state"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/state/session-state"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_NeighborPathAny) SessionState() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_SessionStatePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_SessionStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_AuthenticationKeyPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication/config/authentication-key YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_AuthenticationKeyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_AuthenticationKeyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication/config/authentication-key YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_AuthenticationKeyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_EnablePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_EnablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_EnablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_EnablePathAny struct {
	*ygot.NodePath
}

// AuthenticationKey (leaf): authenticate LDP signaling
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-key"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication/config/authentication-key"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPath) AuthenticationKey() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_AuthenticationKeyPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_AuthenticationKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationKey (leaf): authenticate LDP signaling
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-key"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication/config/authentication-key"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPathAny) AuthenticationKey() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_AuthenticationKeyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_AuthenticationKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables LDP authentication on the node.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPath) Enable() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_EnablePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables LDP authentication on the node.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/authentication/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_AuthenticationPathAny) Enable() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_EnablePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_Authentication_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_AdjacencyTypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/adjacency-type YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_AdjacencyTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_AdjacencyTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/adjacency-type YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_AdjacencyTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloDroppedPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/hello-dropped YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloDroppedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloDroppedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/hello-dropped YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloDroppedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/hello-received YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/hello-received YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LastClearPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/last-clear YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LastClearPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LastClearPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/last-clear YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LastClearPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LocalAddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/local-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LocalAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LocalAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/local-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LocalAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_RemoteAddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/remote-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_RemoteAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_RemoteAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/remote-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_RemoteAddressPathAny struct {
	*ygot.NodePath
}

// AdjacencyType (leaf): This attributes defines if the LDP
// adjacency is from a direct link or from
// targeted discovery.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-type"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/adjacency-type"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath) AdjacencyType() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_AdjacencyTypePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_AdjacencyTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjacencyType (leaf): This attributes defines if the LDP
// adjacency is from a direct link or from
// targeted discovery.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-type"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/adjacency-type"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny) AdjacencyType() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_AdjacencyTypePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_AdjacencyTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloDropped (leaf): Number of Hello messaged dropped by the device
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/hello-dropped"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/hello-dropped"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath) HelloDropped() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloDroppedPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloDroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hello-dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloDropped (leaf): Number of Hello messaged dropped by the device
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/hello-dropped"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/hello-dropped"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny) HelloDropped() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloDroppedPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloDroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hello-dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloHoldtime (container): Specifies the time the sending LSR will
// maintain its record of Hellos from the
// receiving LSR
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePath{
		NodePath: ygot.NewNodePath(
			[]string{"hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloHoldtime (container): Specifies the time the sending LSR will
// maintain its record of Hellos from the
// receiving LSR
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloReceived (leaf): Number of Hello messaged received by the device
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/hello-received"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/hello-received"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath) HelloReceived() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloReceivedPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hello-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloReceived (leaf): Number of Hello messaged received by the device
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/hello-received"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/hello-received"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny) HelloReceived() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloReceivedPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hello-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath) InterfaceRef() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny) InterfaceRef() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Timestamp of the last time the interface counters
// were cleared expressed relative to the Unix Epoch
// (January 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-clear"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/last-clear"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath) LastClear() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LastClearPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LastClearPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Timestamp of the last time the interface counters
// were cleared expressed relative to the Unix Epoch
// (January 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-clear"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/last-clear"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny) LastClear() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LastClearPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LastClearPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): Within the LDP adjacency, this attribute
// shows the local address.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/local-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath) LocalAddress() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LocalAddressPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LocalAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): Within the LDP adjacency, this attribute
// shows the local address.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/local-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny) LocalAddress() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LocalAddressPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_LocalAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): Within the LDP adjacency, this attribute
// shows the neighbor address.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/remote-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPath) RemoteAddress() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_RemoteAddressPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_RemoteAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): Within the LDP adjacency, this attribute
// shows the neighbor address.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/state/remote-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacencyPathAny) RemoteAddress() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_RemoteAddressPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_RemoteAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_AdjacentPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/adjacent YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_AdjacentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_AdjacentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/adjacent YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_AdjacentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_HelloExpirationPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/hello-expiration YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_HelloExpirationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_HelloExpirationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/hello-expiration YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_HelloExpirationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NegotiatedPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/negotiated YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NegotiatedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NegotiatedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/negotiated YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NegotiatedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NextHelloPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/next-hello YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NextHelloPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NextHelloPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/next-hello YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NextHelloPathAny struct {
	*ygot.NodePath
}

// Adjacent (leaf): Hello holdtime attribute learned from the
// LDP neighbor
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacent"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/adjacent"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePath) Adjacent() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_AdjacentPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_AdjacentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Adjacent (leaf): Hello holdtime attribute learned from the
// LDP neighbor
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacent"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/adjacent"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePathAny) Adjacent() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_AdjacentPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_AdjacentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacent"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloExpiration (leaf): Expiration time for the hello holdtime.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/hello-expiration"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/hello-expiration"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePath) HelloExpiration() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_HelloExpirationPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_HelloExpirationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hello-expiration"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloExpiration (leaf): Expiration time for the hello holdtime.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/hello-expiration"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/hello-expiration"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePathAny) HelloExpiration() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_HelloExpirationPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_HelloExpirationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hello-expiration"},
			map[string]interface{}{},
			n,
		),
	}
}

// Negotiated (leaf): Hello holdtime attribute negotiated between
// the LDP neighbor and the local router.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/negotiated"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/negotiated"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePath) Negotiated() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NegotiatedPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NegotiatedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "negotiated"},
			map[string]interface{}{},
			n,
		),
	}
}

// Negotiated (leaf): Hello holdtime attribute negotiated between
// the LDP neighbor and the local router.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/negotiated"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/negotiated"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePathAny) Negotiated() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NegotiatedPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NegotiatedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "negotiated"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHello (leaf): Time when the next LDP hello will be sent to
// the adjacent neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hello"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/next-hello"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePath) NextHello() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NextHelloPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NextHelloPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hello"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHello (leaf): Time when the next LDP hello will be sent to
// the adjacent neighbor.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hello"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/hello-holdtime/state/next-hello"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtimePathAny) NextHello() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NextHelloPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_HelloHoldtime_NextHelloPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hello"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref/state/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref/state/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref/state/subinterface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref/state/subinterface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref/state/interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPath) Interface() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_InterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref/state/interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPathAny) Interface() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref/state/subinterface"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPath) Subinterface() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/neighbors/neighbor/hello-adjacencies/hello-adjacency/interface-ref/state/subinterface"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRefPathAny) Subinterface() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Neighbor_HelloAdjacency_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloAcceptPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-accept YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloAcceptPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloAcceptPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-accept YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloAcceptPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloHoldtimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloHoldtimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloHoldtimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloHoldtimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloIntervalPathAny struct {
	*ygot.NodePath
}

// AddressFamilyAny (list): List of address families for targeted LDP
// configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "address-families/address-family"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family"
// AfiName (wildcarded): E_MplsLdp_MplsLdpAfi
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPath) AddressFamilyAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"address-families", "address-family"},
			map[string]interface{}{"afi-name": "*"},
			n,
		),
	}
}

// AddressFamilyAny (list): List of address families for targeted LDP
// configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "address-families/address-family"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family"
// AfiName (wildcarded): E_MplsLdp_MplsLdpAfi
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPathAny) AddressFamilyAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"address-families", "address-family"},
			map[string]interface{}{"afi-name": "*"},
			n,
		),
	}
}

// AddressFamily (list): List of address families for targeted LDP
// configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "address-families/address-family"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family"
// AfiName: E_MplsLdp_MplsLdpAfi
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPath) AddressFamily(AfiName E_MplsLdp_MplsLdpAfi) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"address-families", "address-family"},
			map[string]interface{}{"afi-name": AfiName},
			n,
		),
	}
}

// AddressFamily (list): List of address families for targeted LDP
// configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "address-families/address-family"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family"
// AfiName: E_MplsLdp_MplsLdpAfi
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPathAny) AddressFamily(AfiName E_MplsLdp_MplsLdpAfi) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"address-families", "address-family"},
			map[string]interface{}{"afi-name": AfiName},
			n,
		),
	}
}

// HelloAccept (leaf): Enables or disables the acceptance of targeted LDP
// hello messages.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-accept"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-accept"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPath) HelloAccept() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloAcceptPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloAcceptPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-accept"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloAccept (leaf): Enables or disables the acceptance of targeted LDP
// hello messages.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-accept"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-accept"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPathAny) HelloAccept() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloAcceptPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloAcceptPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-accept"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloHoldtime (leaf): Defines the time for which a neighbor adjacency will
// be kept by the router while it waits for a new link
// Hello message.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPath) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloHoldtimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloHoldtimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloHoldtime (leaf): Defines the time for which a neighbor adjacency will
// be kept by the router while it waits for a new link
// Hello message.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPathAny) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloHoldtimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloHoldtimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Defines the interval for sending Hello messages on
// each link LDP adjacency.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPath) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloIntervalPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Defines the interval for sending Hello messages on
// each link LDP adjacency.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_TargetedPathAny) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloIntervalPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_HelloIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_AfiNamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/config/afi-name YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_AfiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_AfiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/config/afi-name YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_AfiNamePathAny struct {
	*ygot.NodePath
}

// AfiName (leaf): Adress-family name atttibute (IPv4, IPv6).
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/config/afi-name"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPath) AfiName() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_AfiNamePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_AfiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiName (leaf): Adress-family name atttibute (IPv4, IPv6).
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/config/afi-name"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny) AfiName() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_AfiNamePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_AfiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAny (list): List of LDP targets configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targets/target"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target"
// RemoteAddress (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPath) TargetAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"targets", "target"},
			map[string]interface{}{"remote-address": "*"},
			n,
		),
	}
}

// TargetAny (list): List of LDP targets configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targets/target"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target"
// RemoteAddress (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny) TargetAny() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"targets", "target"},
			map[string]interface{}{"remote-address": "*"},
			n,
		),
	}
}

// Target (list): List of LDP targets configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targets/target"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target"
// RemoteAddress: string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPath) Target(RemoteAddress string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPath{
		NodePath: ygot.NewNodePath(
			[]string{"targets", "target"},
			map[string]interface{}{"remote-address": RemoteAddress},
			n,
		),
	}
}

// Target (list): List of LDP targets configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targets/target"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target"
// RemoteAddress: string
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamilyPathAny) Target(RemoteAddress string) *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"targets", "target"},
			map[string]interface{}{"remote-address": RemoteAddress},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/enabled YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/enabled YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloHoldtimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloHoldtimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloHoldtimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/hello-holdtime YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloHoldtimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_LocalAddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/local-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_LocalAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_LocalAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/local-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_LocalAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_RemoteAddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/remote-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_RemoteAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_RemoteAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/remote-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_RemoteAddressPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/enabled"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPath) Enabled() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_EnabledPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/enabled"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny) Enabled() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_EnabledPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloHoldtime (leaf): Defines the time for which a neighbor adjacency will
// be kept by the router while it waits for a new link
// Hello message.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPath) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloHoldtimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloHoldtimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloHoldtime (leaf): Defines the time for which a neighbor adjacency will
// be kept by the router while it waits for a new link
// Hello message.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-holdtime"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/hello-holdtime"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny) HelloHoldtime() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloHoldtimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloHoldtimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-holdtime"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Defines the interval for sending Hello messages on
// each link LDP adjacency.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPath) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloIntervalPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Defines the interval for sending Hello messages on
// each link LDP adjacency.
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloIntervalPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_HelloIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): Local IP address of the LDP adjacency
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/local-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPath) LocalAddress() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_LocalAddressPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_LocalAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): Local IP address of the LDP adjacency
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/local-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny) LocalAddress() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_LocalAddressPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_LocalAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): Configuration of neighbor address of the
// targeted LDP adjacency
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remote-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/remote-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPath) RemoteAddress() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_RemoteAddressPath {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_RemoteAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): Configuration of neighbor address of the
// targeted LDP adjacency
// ----------------------------------------
// Defining module: "openconfig-mpls-ldp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remote-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/ldp/targeted/address-families/address-family/targets/target/config/remote-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_TargetPathAny) RemoteAddress() *NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_RemoteAddressPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_Ldp_Targeted_AddressFamily_Target_RemoteAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny struct {
	*ygot.NodePath
}

// Global (container): Platform wide RSVP configuration and state
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePath) Global() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPath{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// Global (container): Platform wide RSVP configuration and state
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny) Global() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): list of per-interface RSVP configurations
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePath) InterfaceAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): list of per-interface RSVP configurations
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny) InterfaceAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// Interface (list): list of per-interface RSVP configurations
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface"
// InterfaceId: string
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePath) Interface(InterfaceId string) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Interface (list): list of per-interface RSVP configurations
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-attributes/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface"
// InterfaceId: string
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny) Interface(InterfaceId string) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-attributes", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// NeighborAny (list): List of RSVP neighbors of the local system
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor"
// Address (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePath) NeighborAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of RSVP neighbors of the local system
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor"
// Address (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny) NeighborAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// Neighbor (list): List of RSVP neighbors of the local system
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor"
// Address: string
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePath) Neighbor(Address string) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// Neighbor (list): List of RSVP neighbors of the local system
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor"
// Address: string
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny) Neighbor(Address string) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// SessionAny (list): List of RSVP sessions
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sessions/session"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session"
// LocalIndex (wildcarded): uint64
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePath) SessionAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sessions", "session"},
			map[string]interface{}{"local-index": "*"},
			n,
		),
	}
}

// SessionAny (list): List of RSVP sessions
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sessions/session"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session"
// LocalIndex (wildcarded): uint64
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny) SessionAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sessions", "session"},
			map[string]interface{}{"local-index": "*"},
			n,
		),
	}
}

// Session (list): List of RSVP sessions
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sessions/session"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session"
// LocalIndex: uint64
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePath) Session(LocalIndex uint64) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath{
		NodePath: ygot.NewNodePath(
			[]string{"sessions", "session"},
			map[string]interface{}{"local-index": LocalIndex},
			n,
		),
	}
}

// Session (list): List of RSVP sessions
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sessions/session"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session"
// LocalIndex: uint64
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTePathAny) Session(LocalIndex uint64) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sessions", "session"},
			map[string]interface{}{"local-index": LocalIndex},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPathAny struct {
	*ygot.NodePath
}

// Counters (container): Platform wide RSVP statistics and counters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPath) Counters() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Platform wide RSVP statistics and counters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPathAny) Counters() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Operational state and configuration parameters relating to
// graceful-restart for RSVP
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPath) GracefulRestart() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Operational state and configuration parameters relating to
// graceful-restart for RSVP
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPathAny) GracefulRestart() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hellos (container): Top level container for RSVP hello parameters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hellos"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPath) Hellos() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPath{
		NodePath: ygot.NewNodePath(
			[]string{"hellos"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hellos (container): Top level container for RSVP hello parameters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hellos"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPathAny) Hellos() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hellos"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftPreemption (container): Protocol options relating to RSVP
// soft preemption
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "soft-preemption"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPath) SoftPreemption() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"soft-preemption"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftPreemption (container): Protocol options relating to RSVP
// soft preemption
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "soft-preemption"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_GlobalPathAny) SoftPreemption() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"soft-preemption"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InAckMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-ack-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InAckMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InAckMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-ack-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InAckMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InHelloMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-hello-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InHelloMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InHelloMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-hello-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InHelloMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathErrorMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathErrorMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathErrorMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathErrorMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathTearMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathTearMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathTearMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathTearMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationErrorMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationErrorMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationErrorMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationErrorMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationTearMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationTearMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationTearMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationTearMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InSrefreshMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-srefresh-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InSrefreshMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InSrefreshMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-srefresh-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InSrefreshMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutAckMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-ack-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutAckMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutAckMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-ack-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutAckMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutHelloMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-hello-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutHelloMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutHelloMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-hello-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutHelloMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathErrorMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathErrorMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathErrorMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathErrorMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathTearMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathTearMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathTearMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathTearMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationErrorMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationErrorMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationErrorMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationErrorMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationTearMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationTearMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationTearMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationTearMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutSrefreshMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-srefresh-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutSrefreshMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutSrefreshMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-srefresh-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutSrefreshMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_PathTimeoutsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/path-timeouts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_PathTimeoutsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_PathTimeoutsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/path-timeouts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_PathTimeoutsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_RateLimitedMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/rate-limited-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_RateLimitedMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_RateLimitedMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/rate-limited-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_RateLimitedMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ReservationTimeoutsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/reservation-timeouts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ReservationTimeoutsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ReservationTimeoutsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/reservation-timeouts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ReservationTimeoutsPathAny struct {
	*ygot.NodePath
}

// Errors (container): Error counters associated with the global RSVP-TE
// instance.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "errors"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) Errors() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// Errors (container): Error counters associated with the global RSVP-TE
// instance.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "errors"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) Errors() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InAckMessages (leaf): Number of received RSVP refresh reduction ack
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-ack-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-ack-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) InAckMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InAckMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InAckMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-ack-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InAckMessages (leaf): Number of received RSVP refresh reduction ack
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-ack-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-ack-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) InAckMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InAckMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InAckMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-ack-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InHelloMessages (leaf): Number of received RSVP hello messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-hello-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-hello-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) InHelloMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InHelloMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InHelloMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InHelloMessages (leaf): Number of received RSVP hello messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-hello-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-hello-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) InHelloMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InHelloMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InHelloMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathErrorMessages (leaf): Number of received RSVP Path Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) InPathErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathErrorMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathErrorMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathErrorMessages (leaf): Number of received RSVP Path Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) InPathErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathErrorMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathErrorMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathMessages (leaf): Number of received RSVP Path messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) InPathMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathMessages (leaf): Number of received RSVP Path messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) InPathMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathTearMessages (leaf): Number of received RSVP Path Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) InPathTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathTearMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathTearMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathTearMessages (leaf): Number of received RSVP Path Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-path-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) InPathTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathTearMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InPathTearMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationErrorMessages (leaf): Number of received RSVP Resv Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) InReservationErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationErrorMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationErrorMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationErrorMessages (leaf): Number of received RSVP Resv Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) InReservationErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationErrorMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationErrorMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationMessages (leaf): Number of received RSVP Resv messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) InReservationMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationMessages (leaf): Number of received RSVP Resv messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) InReservationMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationTearMessages (leaf): Number of received RSVP Resv Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) InReservationTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationTearMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationTearMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationTearMessages (leaf): Number of received RSVP Resv Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-reservation-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) InReservationTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationTearMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InReservationTearMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSrefreshMessages (leaf): Number of received RSVP summary refresh messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-srefresh-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-srefresh-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) InSrefreshMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InSrefreshMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InSrefreshMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-srefresh-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSrefreshMessages (leaf): Number of received RSVP summary refresh messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-srefresh-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/in-srefresh-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) InSrefreshMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InSrefreshMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_InSrefreshMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-srefresh-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutAckMessages (leaf): Number of sent RSVP refresh reduction ack messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-ack-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-ack-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) OutAckMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutAckMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutAckMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-ack-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutAckMessages (leaf): Number of sent RSVP refresh reduction ack messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-ack-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-ack-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) OutAckMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutAckMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutAckMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-ack-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutHelloMessages (leaf): Number of sent RSVP hello messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-hello-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-hello-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) OutHelloMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutHelloMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutHelloMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutHelloMessages (leaf): Number of sent RSVP hello messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-hello-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-hello-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) OutHelloMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutHelloMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutHelloMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathErrorMessages (leaf): Number of sent RSVP Path Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) OutPathErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathErrorMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathErrorMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathErrorMessages (leaf): Number of sent RSVP Path Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) OutPathErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathErrorMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathErrorMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathMessages (leaf): Number of sent RSVP PATH messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) OutPathMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathMessages (leaf): Number of sent RSVP PATH messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) OutPathMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathTearMessages (leaf): Number of sent RSVP Path Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) OutPathTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathTearMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathTearMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathTearMessages (leaf): Number of sent RSVP Path Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-path-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) OutPathTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathTearMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutPathTearMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationErrorMessages (leaf): Number of sent RSVP Resv Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) OutReservationErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationErrorMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationErrorMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationErrorMessages (leaf): Number of sent RSVP Resv Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) OutReservationErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationErrorMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationErrorMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationMessages (leaf): Number of sent RSVP Resv messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) OutReservationMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationMessages (leaf): Number of sent RSVP Resv messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) OutReservationMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationTearMessages (leaf): Number of sent RSVP Resv Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) OutReservationTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationTearMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationTearMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationTearMessages (leaf): Number of sent RSVP Resv Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-reservation-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) OutReservationTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationTearMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutReservationTearMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutSrefreshMessages (leaf): Number of sent RSVP summary refresh messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-srefresh-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-srefresh-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) OutSrefreshMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutSrefreshMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutSrefreshMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-srefresh-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutSrefreshMessages (leaf): Number of sent RSVP summary refresh messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-srefresh-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/out-srefresh-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) OutSrefreshMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutSrefreshMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_OutSrefreshMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-srefresh-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathTimeouts (leaf): The number of Path State Blocks (PSBs) that
// have been timed out by the local system.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-timeouts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/path-timeouts"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) PathTimeouts() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_PathTimeoutsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_PathTimeoutsPath{
		NodePath: ygot.NewNodePath(
			[]string{"path-timeouts"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathTimeouts (leaf): The number of Path State Blocks (PSBs) that
// have been timed out by the local system.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-timeouts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/path-timeouts"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) PathTimeouts() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_PathTimeoutsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_PathTimeoutsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-timeouts"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateLimitedMessages (leaf): RSVP messages dropped due to rate limiting
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rate-limited-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/rate-limited-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) RateLimitedMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_RateLimitedMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_RateLimitedMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"rate-limited-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateLimitedMessages (leaf): RSVP messages dropped due to rate limiting
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rate-limited-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/rate-limited-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) RateLimitedMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_RateLimitedMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_RateLimitedMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rate-limited-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReservationTimeouts (leaf): The number of Reservation State Blocks (RSBs) that
// have been timed out by the local system.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reservation-timeouts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/reservation-timeouts"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPath) ReservationTimeouts() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ReservationTimeoutsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ReservationTimeoutsPath{
		NodePath: ygot.NewNodePath(
			[]string{"reservation-timeouts"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReservationTimeouts (leaf): The number of Reservation State Blocks (RSBs) that
// have been timed out by the local system.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reservation-timeouts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/reservation-timeouts"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_CountersPathAny) ReservationTimeouts() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ReservationTimeoutsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ReservationTimeoutsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reservation-timeouts"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_AuthenticationFailPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/authentication-fail YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_AuthenticationFailPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_AuthenticationFailPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/authentication-fail YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_AuthenticationFailPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadChecksumPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-checksum YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadChecksumPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadChecksumPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-checksum YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadChecksumPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketFormatPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-packet-format YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketFormatPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketFormatPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-packet-format YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketFormatPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketLengthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-packet-length YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-packet-length YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_OutOfOrderPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/out-of-order YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_OutOfOrderPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_OutOfOrderPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/out-of-order YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_OutOfOrderPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_ReceivedNackPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/received-nack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_ReceivedNackPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_ReceivedNackPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/received-nack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_ReceivedNackPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitFailurePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/transmit-failure YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitFailurePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitFailurePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/transmit-failure YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitFailurePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitQueueFullPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/transmit-queue-full YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitQueueFullPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitQueueFullPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/transmit-queue-full YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitQueueFullPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownAckPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/unknown-ack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownAckPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownAckPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/unknown-ack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownAckPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownNackPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/unknown-nack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownNackPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownNackPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/unknown-nack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownNackPathAny struct {
	*ygot.NodePath
}

// AuthenticationFail (leaf): The number of packets received that have failed RSVP-TE
// authentication checks in the specified context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication-fail"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/authentication-fail"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) AuthenticationFail() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_AuthenticationFailPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_AuthenticationFailPath{
		NodePath: ygot.NewNodePath(
			[]string{"authentication-fail"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationFail (leaf): The number of packets received that have failed RSVP-TE
// authentication checks in the specified context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication-fail"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/authentication-fail"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) AuthenticationFail() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_AuthenticationFailPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_AuthenticationFailPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authentication-fail"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadChecksum (leaf): The number of packets received that have an incorrect RSVP-TE
// checksum in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-checksum"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-checksum"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) BadChecksum() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadChecksumPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadChecksumPath{
		NodePath: ygot.NewNodePath(
			[]string{"bad-checksum"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadChecksum (leaf): The number of packets received that have an incorrect RSVP-TE
// checksum in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-checksum"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-checksum"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) BadChecksum() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadChecksumPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadChecksumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bad-checksum"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadPacketFormat (leaf): The number of packets received that were dropped due to being
// badly formed in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-packet-format"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-packet-format"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) BadPacketFormat() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketFormatPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketFormatPath{
		NodePath: ygot.NewNodePath(
			[]string{"bad-packet-format"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadPacketFormat (leaf): The number of packets received that were dropped due to being
// badly formed in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-packet-format"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-packet-format"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) BadPacketFormat() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketFormatPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketFormatPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bad-packet-format"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadPacketLength (leaf): The number of packets received that were dropped due to having
// an invalid length specified in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-packet-length"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-packet-length"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) BadPacketLength() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketLengthPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"bad-packet-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadPacketLength (leaf): The number of packets received that were dropped due to having
// an invalid length specified in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-packet-length"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/bad-packet-length"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) BadPacketLength() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketLengthPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_BadPacketLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bad-packet-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOfOrder (leaf): The number of messages received out of order in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-of-order"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/out-of-order"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) OutOfOrder() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_OutOfOrderPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_OutOfOrderPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-of-order"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOfOrder (leaf): The number of messages received out of order in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-of-order"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/out-of-order"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) OutOfOrder() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_OutOfOrderPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_OutOfOrderPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-of-order"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedNack (leaf): The number of NACK RESV messages received in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received-nack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/received-nack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) ReceivedNack() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_ReceivedNackPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_ReceivedNackPath{
		NodePath: ygot.NewNodePath(
			[]string{"received-nack"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedNack (leaf): The number of NACK RESV messages received in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received-nack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/received-nack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) ReceivedNack() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_ReceivedNackPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_ReceivedNackPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"received-nack"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmitFailure (leaf): The total number of packets dropped on transmit in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transmit-failure"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/transmit-failure"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) TransmitFailure() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitFailurePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitFailurePath{
		NodePath: ygot.NewNodePath(
			[]string{"transmit-failure"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmitFailure (leaf): The total number of packets dropped on transmit in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transmit-failure"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/transmit-failure"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) TransmitFailure() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitFailurePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitFailurePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transmit-failure"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmitQueueFull (leaf): The number of packets dropped due to the transmit queue being
// full in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transmit-queue-full"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/transmit-queue-full"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) TransmitQueueFull() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitQueueFullPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitQueueFullPath{
		NodePath: ygot.NewNodePath(
			[]string{"transmit-queue-full"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmitQueueFull (leaf): The number of packets dropped due to the transmit queue being
// full in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transmit-queue-full"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/transmit-queue-full"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) TransmitQueueFull() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitQueueFullPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_TransmitQueueFullPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transmit-queue-full"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAck (leaf): The number of packets received containing an ACK for an unknown
// message ID in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-ack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/unknown-ack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) UnknownAck() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownAckPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownAckPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-ack"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAck (leaf): The number of packets received containing an ACK for an unknown
// message ID in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-ack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/unknown-ack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) UnknownAck() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownAckPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownAckPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-ack"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownNack (leaf): The number of packets received containing a NACK for an unknown
// message ID in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-nack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/unknown-nack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPath) UnknownNack() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownNackPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownNackPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-nack"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownNack (leaf): The number of packets received containing a NACK for an unknown
// message ID in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-nack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/state/counters/errors/unknown-nack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_ErrorsPathAny) UnknownNack() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownNackPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Counters_Errors_UnknownNackPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-nack"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_EnablePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_EnablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_EnablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_EnablePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RecoveryTimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/recovery-time YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RecoveryTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RecoveryTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/recovery-time YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RecoveryTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RestartTimePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/restart-time YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RestartTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RestartTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/restart-time YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RestartTimePathAny struct {
	*ygot.NodePath
}

// Enable (leaf): Enables graceful restart on the node.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPath) Enable() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_EnablePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables graceful restart on the node.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPathAny) Enable() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_EnablePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// RecoveryTime (leaf): RSVP state recovery time
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/recovery-time"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/recovery-time"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPath) RecoveryTime() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RecoveryTimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RecoveryTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "recovery-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RecoveryTime (leaf): RSVP state recovery time
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/recovery-time"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/recovery-time"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPathAny) RecoveryTime() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RecoveryTimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RecoveryTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "recovery-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Graceful restart time (seconds).
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/restart-time"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPath) RestartTime() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RestartTimePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RestartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Graceful restart time (seconds).
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/graceful-restart/config/restart-time"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestartPathAny) RestartTime() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RestartTimePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_GracefulRestart_RestartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_HelloIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_HelloIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_HelloIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_HelloIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_RefreshReductionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos/config/refresh-reduction YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_RefreshReductionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_RefreshReductionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos/config/refresh-reduction YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_RefreshReductionPathAny struct {
	*ygot.NodePath
}

// HelloInterval (leaf): set the interval in ms between RSVP hello
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPath) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_HelloIntervalPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_HelloIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): set the interval in ms between RSVP hello
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPathAny) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_HelloIntervalPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_HelloIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// RefreshReduction (leaf): enables all RSVP refresh reduction message
// bundling, RSVP message ID, reliable message delivery
// and summary refresh
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/refresh-reduction"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos/config/refresh-reduction"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPath) RefreshReduction() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_RefreshReductionPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_RefreshReductionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "refresh-reduction"},
			map[string]interface{}{},
			n,
		),
	}
}

// RefreshReduction (leaf): enables all RSVP refresh reduction message
// bundling, RSVP message ID, reliable message delivery
// and summary refresh
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/refresh-reduction"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/hellos/config/refresh-reduction"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_HellosPathAny) RefreshReduction() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_RefreshReductionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_Hellos_RefreshReductionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "refresh-reduction"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_EnablePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_EnablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_EnablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_EnablePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_SoftPreemptionTimeoutPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption/config/soft-preemption-timeout YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_SoftPreemptionTimeoutPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_SoftPreemptionTimeoutPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption/config/soft-preemption-timeout YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_SoftPreemptionTimeoutPathAny struct {
	*ygot.NodePath
}

// Enable (leaf): Enables soft preemption on a node.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPath) Enable() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_EnablePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables soft preemption on a node.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPathAny) Enable() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_EnablePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftPreemptionTimeout (leaf): Timeout value for soft preemption to revert
// to hard preemption. The default timeout for
// soft-preemption is 30 seconds - after which
// the local system reverts to hard pre-emption.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/soft-preemption-timeout"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption/config/soft-preemption-timeout"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPath) SoftPreemptionTimeout() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_SoftPreemptionTimeoutPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_SoftPreemptionTimeoutPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "soft-preemption-timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftPreemptionTimeout (leaf): Timeout value for soft preemption to revert
// to hard preemption. The default timeout for
// soft-preemption is 30 seconds - after which
// the local system reverts to hard pre-emption.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/soft-preemption-timeout"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/global/soft-preemption/config/soft-preemption-timeout"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemptionPathAny) SoftPreemptionTimeout() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_SoftPreemptionTimeoutPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Global_SoftPreemption_SoftPreemptionTimeoutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "soft-preemption-timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_MaxLinkBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/max-link-bandwidth YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_MaxLinkBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_MaxLinkBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/max-link-bandwidth YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_MaxLinkBandwidthPathAny struct {
	*ygot.NodePath
}

// Authentication (container): Configuration and state parameters relating to RSVP
// authentication as per RFC2747
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) Authentication() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPath{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authentication (container): Configuration and state parameters relating to RSVP
// authentication as per RFC2747
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) Authentication() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// BandwidthReservationAny (list): Available and reserved bandwidth by priority on
// the interface.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-reservations/bandwidth-reservation"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation"
// Priority (wildcarded): [UnionUint8, E_BandwidthReservation_Priority_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) BandwidthReservationAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-reservations", "bandwidth-reservation"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// BandwidthReservationAny (list): Available and reserved bandwidth by priority on
// the interface.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-reservations/bandwidth-reservation"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation"
// Priority (wildcarded): [UnionUint8, E_BandwidthReservation_Priority_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) BandwidthReservationAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-reservations", "bandwidth-reservation"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// BandwidthReservation (list): Available and reserved bandwidth by priority on
// the interface.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-reservations/bandwidth-reservation"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation"
// Priority: [UnionUint8, E_BandwidthReservation_Priority_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) BandwidthReservation(Priority NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_Priority_Union) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPath{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-reservations", "bandwidth-reservation"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// BandwidthReservation (list): Available and reserved bandwidth by priority on
// the interface.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-reservations/bandwidth-reservation"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation"
// Priority: [UnionUint8, E_BandwidthReservation_Priority_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) BandwidthReservation(Priority NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_Priority_Union) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-reservations", "bandwidth-reservation"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// Counters (container): Interface specific RSVP statistics and counters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) Counters() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Interface specific RSVP statistics and counters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) Counters() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hellos (container): Top level container for RSVP hello parameters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hellos"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) Hellos() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPath{
		NodePath: ygot.NewNodePath(
			[]string{"hellos"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hellos (container): Top level container for RSVP hello parameters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hellos"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) Hellos() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hellos"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Identifier for the interface
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/config/interface-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) InterfaceId() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceIdPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Identifier for the interface
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/config/interface-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) InterfaceId() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceIdPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) InterfaceRef() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) InterfaceRef() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (leaf): The maximum link bandwidth expressed in kilobits
// per second. This value should be the same (other than
// the units) as the value that is advertised into the
// IGP traffic engineering database.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-link-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/max-link-bandwidth"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) MaxLinkBandwidth() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_MaxLinkBandwidthPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_MaxLinkBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (leaf): The maximum link bandwidth expressed in kilobits
// per second. This value should be the same (other than
// the units) as the value that is advertised into the
// IGP traffic engineering database.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-link-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/max-link-bandwidth"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) MaxLinkBandwidth() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_MaxLinkBandwidthPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_MaxLinkBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protection (container): link-protection (NHOP) related configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protection"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) Protection() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPath{
		NodePath: ygot.NewNodePath(
			[]string{"protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protection (container): link-protection (NHOP) related configuration
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "protection"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) Protection() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subscription (container): Bandwidth percentage reservable by RSVP
// on an interface
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subscription"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePath) Subscription() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"subscription"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subscription (container): Bandwidth percentage reservable by RSVP
// on an interface
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subscription"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_InterfacePathAny) Subscription() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subscription"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationKeyPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/authentication-key YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationKeyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationKeyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/authentication-key YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationKeyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationTypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/authentication-type YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/authentication-type YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_EnablePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_EnablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_EnablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/enable YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_EnablePathAny struct {
	*ygot.NodePath
}

// AuthenticationKey (leaf): Authenticate RSVP signaling messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-key"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/authentication-key"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPath) AuthenticationKey() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationKeyPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationKey (leaf): Authenticate RSVP signaling messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-key"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/authentication-key"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPathAny) AuthenticationKey() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationKeyPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationType (leaf): RSVP message authentication algorithm type
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-type"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/authentication-type"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPath) AuthenticationType() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationTypePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationType (leaf): RSVP message authentication algorithm type
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-type"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/authentication-type"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPathAny) AuthenticationType() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationTypePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_AuthenticationTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables RSVP authentication on the node.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPath) Enable() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_EnablePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables RSVP authentication on the node.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/authentication/config/enable"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_AuthenticationPathAny) Enable() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_EnablePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Authentication_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ActiveReservationsCountPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/active-reservations-count YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ActiveReservationsCountPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ActiveReservationsCountPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/active-reservations-count YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ActiveReservationsCountPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_AvailableBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/available-bandwidth YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_AvailableBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_AvailableBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/available-bandwidth YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_AvailableBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_HighwaterMarkPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/highwater-mark YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_HighwaterMarkPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_HighwaterMarkPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/highwater-mark YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_HighwaterMarkPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/priority YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/priority YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_PriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ReservedBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/reserved-bandwidth YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ReservedBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ReservedBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/reserved-bandwidth YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ReservedBandwidthPathAny struct {
	*ygot.NodePath
}

// ActiveReservationsCount (leaf): Number of active RSVP reservations in the associated
// priority, or the sum of all reservations when the priority
// level is set to ALL
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-reservations-count"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/active-reservations-count"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPath) ActiveReservationsCount() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ActiveReservationsCountPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ActiveReservationsCountPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-reservations-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActiveReservationsCount (leaf): Number of active RSVP reservations in the associated
// priority, or the sum of all reservations when the priority
// level is set to ALL
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-reservations-count"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/active-reservations-count"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny) ActiveReservationsCount() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ActiveReservationsCountPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ActiveReservationsCountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-reservations-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (leaf): Bandwidth currently available with the priority level,
// or for the entire interface when the priority is set to
// ALL
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/available-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/available-bandwidth"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPath) AvailableBandwidth() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_AvailableBandwidthPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_AvailableBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (leaf): Bandwidth currently available with the priority level,
// or for the entire interface when the priority is set to
// ALL
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/available-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/available-bandwidth"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny) AvailableBandwidth() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_AvailableBandwidthPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_AvailableBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// HighwaterMark (leaf): Maximum bandwidth reserved on the interface within the
// priority, or across all priorities in the case that the
// priority level is set to ALL
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/highwater-mark"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/highwater-mark"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPath) HighwaterMark() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_HighwaterMarkPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_HighwaterMarkPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "highwater-mark"},
			map[string]interface{}{},
			n,
		),
	}
}

// HighwaterMark (leaf): Maximum bandwidth reserved on the interface within the
// priority, or across all priorities in the case that the
// priority level is set to ALL
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/highwater-mark"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/highwater-mark"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny) HighwaterMark() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_HighwaterMarkPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_HighwaterMarkPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "highwater-mark"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): RSVP priority level for LSPs traversing the interface
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/priority"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPath) Priority() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_PriorityPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): RSVP priority level for LSPs traversing the interface
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/priority"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny) Priority() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_PriorityPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReservedBandwidth (leaf): Bandwidth currently reserved within the priority level,
// or the sum of all priority levels when the keyword is set
// to ALL
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reserved-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/reserved-bandwidth"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPath) ReservedBandwidth() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ReservedBandwidthPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ReservedBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reserved-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReservedBandwidth (leaf): Bandwidth currently reserved within the priority level,
// or the sum of all priority levels when the keyword is set
// to ALL
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reserved-bandwidth"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/bandwidth-reservations/bandwidth-reservation/state/reserved-bandwidth"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservationPathAny) ReservedBandwidth() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ReservedBandwidthPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_BandwidthReservation_ReservedBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reserved-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InAckMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-ack-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InAckMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InAckMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-ack-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InAckMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InHelloMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-hello-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InHelloMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InHelloMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-hello-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InHelloMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathErrorMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathErrorMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathErrorMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathErrorMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathTearMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathTearMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathTearMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathTearMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationErrorMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationErrorMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationErrorMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationErrorMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationTearMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationTearMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationTearMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationTearMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InSrefreshMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-srefresh-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InSrefreshMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InSrefreshMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-srefresh-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InSrefreshMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutAckMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-ack-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutAckMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutAckMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-ack-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutAckMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutHelloMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-hello-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutHelloMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutHelloMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-hello-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutHelloMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathErrorMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathErrorMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathErrorMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathErrorMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathTearMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathTearMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathTearMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathTearMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationErrorMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationErrorMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationErrorMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-error-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationErrorMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationTearMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationTearMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationTearMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-tear-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationTearMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutSrefreshMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-srefresh-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutSrefreshMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutSrefreshMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-srefresh-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutSrefreshMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_RateLimitedMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/rate-limited-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_RateLimitedMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_RateLimitedMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/rate-limited-messages YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_RateLimitedMessagesPathAny struct {
	*ygot.NodePath
}

// Errors (container): Interface specific RSVP error counters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "errors"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) Errors() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// Errors (container): Interface specific RSVP error counters
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "errors"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) Errors() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InAckMessages (leaf): Number of received RSVP refresh reduction ack
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-ack-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-ack-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) InAckMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InAckMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InAckMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-ack-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InAckMessages (leaf): Number of received RSVP refresh reduction ack
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-ack-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-ack-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) InAckMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InAckMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InAckMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-ack-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InHelloMessages (leaf): Number of received RSVP hello messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-hello-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-hello-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) InHelloMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InHelloMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InHelloMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InHelloMessages (leaf): Number of received RSVP hello messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-hello-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-hello-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) InHelloMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InHelloMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InHelloMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathErrorMessages (leaf): Number of received RSVP Path Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) InPathErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathErrorMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathErrorMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathErrorMessages (leaf): Number of received RSVP Path Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) InPathErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathErrorMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathErrorMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathMessages (leaf): Number of received RSVP Path messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) InPathMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathMessages (leaf): Number of received RSVP Path messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) InPathMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathTearMessages (leaf): Number of received RSVP Path Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) InPathTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathTearMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathTearMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPathTearMessages (leaf): Number of received RSVP Path Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-path-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-path-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) InPathTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathTearMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InPathTearMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-path-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationErrorMessages (leaf): Number of received RSVP Resv Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) InReservationErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationErrorMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationErrorMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationErrorMessages (leaf): Number of received RSVP Resv Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) InReservationErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationErrorMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationErrorMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationMessages (leaf): Number of received RSVP Resv messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) InReservationMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationMessages (leaf): Number of received RSVP Resv messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) InReservationMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationTearMessages (leaf): Number of received RSVP Resv Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) InReservationTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationTearMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationTearMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InReservationTearMessages (leaf): Number of received RSVP Resv Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-reservation-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-reservation-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) InReservationTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationTearMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InReservationTearMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-reservation-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSrefreshMessages (leaf): Number of received RSVP summary refresh messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-srefresh-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-srefresh-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) InSrefreshMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InSrefreshMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InSrefreshMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-srefresh-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSrefreshMessages (leaf): Number of received RSVP summary refresh messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-srefresh-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/in-srefresh-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) InSrefreshMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InSrefreshMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_InSrefreshMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-srefresh-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutAckMessages (leaf): Number of sent RSVP refresh reduction ack messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-ack-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-ack-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) OutAckMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutAckMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutAckMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-ack-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutAckMessages (leaf): Number of sent RSVP refresh reduction ack messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-ack-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-ack-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) OutAckMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutAckMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutAckMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-ack-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutHelloMessages (leaf): Number of sent RSVP hello messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-hello-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-hello-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) OutHelloMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutHelloMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutHelloMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutHelloMessages (leaf): Number of sent RSVP hello messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-hello-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-hello-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) OutHelloMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutHelloMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutHelloMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathErrorMessages (leaf): Number of sent RSVP Path Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) OutPathErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathErrorMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathErrorMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathErrorMessages (leaf): Number of sent RSVP Path Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) OutPathErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathErrorMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathErrorMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathMessages (leaf): Number of sent RSVP PATH messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) OutPathMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathMessages (leaf): Number of sent RSVP PATH messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) OutPathMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathTearMessages (leaf): Number of sent RSVP Path Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) OutPathTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathTearMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathTearMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPathTearMessages (leaf): Number of sent RSVP Path Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-path-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-path-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) OutPathTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathTearMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutPathTearMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-path-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationErrorMessages (leaf): Number of sent RSVP Resv Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) OutReservationErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationErrorMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationErrorMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationErrorMessages (leaf): Number of sent RSVP Resv Error messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-error-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-error-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) OutReservationErrorMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationErrorMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationErrorMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-error-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationMessages (leaf): Number of sent RSVP Resv messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) OutReservationMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationMessages (leaf): Number of sent RSVP Resv messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) OutReservationMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationTearMessages (leaf): Number of sent RSVP Resv Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) OutReservationTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationTearMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationTearMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutReservationTearMessages (leaf): Number of sent RSVP Resv Tear messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-reservation-tear-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-reservation-tear-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) OutReservationTearMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationTearMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutReservationTearMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-reservation-tear-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutSrefreshMessages (leaf): Number of sent RSVP summary refresh messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-srefresh-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-srefresh-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) OutSrefreshMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutSrefreshMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutSrefreshMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-srefresh-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutSrefreshMessages (leaf): Number of sent RSVP summary refresh messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-srefresh-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/out-srefresh-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) OutSrefreshMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutSrefreshMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_OutSrefreshMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-srefresh-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateLimitedMessages (leaf): RSVP messages dropped due to rate limiting
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rate-limited-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/rate-limited-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPath) RateLimitedMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_RateLimitedMessagesPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_RateLimitedMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"rate-limited-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateLimitedMessages (leaf): RSVP messages dropped due to rate limiting
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rate-limited-messages"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/rate-limited-messages"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_CountersPathAny) RateLimitedMessages() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_RateLimitedMessagesPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_RateLimitedMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rate-limited-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_AuthenticationFailPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/authentication-fail YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_AuthenticationFailPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_AuthenticationFailPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/authentication-fail YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_AuthenticationFailPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadChecksumPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-checksum YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadChecksumPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadChecksumPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-checksum YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadChecksumPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketFormatPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-packet-format YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketFormatPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketFormatPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-packet-format YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketFormatPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketLengthPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-packet-length YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-packet-length YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_OutOfOrderPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/out-of-order YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_OutOfOrderPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_OutOfOrderPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/out-of-order YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_OutOfOrderPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_ReceivedNackPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/received-nack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_ReceivedNackPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_ReceivedNackPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/received-nack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_ReceivedNackPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitFailurePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/transmit-failure YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitFailurePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitFailurePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/transmit-failure YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitFailurePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitQueueFullPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/transmit-queue-full YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitQueueFullPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitQueueFullPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/transmit-queue-full YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitQueueFullPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownAckPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/unknown-ack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownAckPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownAckPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/unknown-ack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownAckPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownNackPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/unknown-nack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownNackPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownNackPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/unknown-nack YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownNackPathAny struct {
	*ygot.NodePath
}

// AuthenticationFail (leaf): The number of packets received that have failed RSVP-TE
// authentication checks in the specified context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication-fail"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/authentication-fail"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) AuthenticationFail() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_AuthenticationFailPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_AuthenticationFailPath{
		NodePath: ygot.NewNodePath(
			[]string{"authentication-fail"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationFail (leaf): The number of packets received that have failed RSVP-TE
// authentication checks in the specified context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication-fail"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/authentication-fail"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) AuthenticationFail() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_AuthenticationFailPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_AuthenticationFailPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authentication-fail"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadChecksum (leaf): The number of packets received that have an incorrect RSVP-TE
// checksum in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-checksum"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-checksum"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) BadChecksum() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadChecksumPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadChecksumPath{
		NodePath: ygot.NewNodePath(
			[]string{"bad-checksum"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadChecksum (leaf): The number of packets received that have an incorrect RSVP-TE
// checksum in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-checksum"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-checksum"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) BadChecksum() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadChecksumPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadChecksumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bad-checksum"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadPacketFormat (leaf): The number of packets received that were dropped due to being
// badly formed in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-packet-format"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-packet-format"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) BadPacketFormat() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketFormatPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketFormatPath{
		NodePath: ygot.NewNodePath(
			[]string{"bad-packet-format"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadPacketFormat (leaf): The number of packets received that were dropped due to being
// badly formed in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-packet-format"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-packet-format"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) BadPacketFormat() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketFormatPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketFormatPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bad-packet-format"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadPacketLength (leaf): The number of packets received that were dropped due to having
// an invalid length specified in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-packet-length"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-packet-length"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) BadPacketLength() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketLengthPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"bad-packet-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// BadPacketLength (leaf): The number of packets received that were dropped due to having
// an invalid length specified in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bad-packet-length"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/bad-packet-length"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) BadPacketLength() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketLengthPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_BadPacketLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bad-packet-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOfOrder (leaf): The number of messages received out of order in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-of-order"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/out-of-order"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) OutOfOrder() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_OutOfOrderPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_OutOfOrderPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-of-order"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOfOrder (leaf): The number of messages received out of order in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-of-order"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/out-of-order"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) OutOfOrder() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_OutOfOrderPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_OutOfOrderPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-of-order"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedNack (leaf): The number of NACK RESV messages received in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received-nack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/received-nack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) ReceivedNack() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_ReceivedNackPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_ReceivedNackPath{
		NodePath: ygot.NewNodePath(
			[]string{"received-nack"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedNack (leaf): The number of NACK RESV messages received in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received-nack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/received-nack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) ReceivedNack() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_ReceivedNackPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_ReceivedNackPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"received-nack"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmitFailure (leaf): The total number of packets dropped on transmit in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transmit-failure"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/transmit-failure"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) TransmitFailure() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitFailurePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitFailurePath{
		NodePath: ygot.NewNodePath(
			[]string{"transmit-failure"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmitFailure (leaf): The total number of packets dropped on transmit in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transmit-failure"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/transmit-failure"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) TransmitFailure() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitFailurePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitFailurePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transmit-failure"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmitQueueFull (leaf): The number of packets dropped due to the transmit queue being
// full in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transmit-queue-full"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/transmit-queue-full"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) TransmitQueueFull() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitQueueFullPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitQueueFullPath{
		NodePath: ygot.NewNodePath(
			[]string{"transmit-queue-full"},
			map[string]interface{}{},
			n,
		),
	}
}

// TransmitQueueFull (leaf): The number of packets dropped due to the transmit queue being
// full in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transmit-queue-full"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/transmit-queue-full"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) TransmitQueueFull() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitQueueFullPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_TransmitQueueFullPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transmit-queue-full"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAck (leaf): The number of packets received containing an ACK for an unknown
// message ID in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-ack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/unknown-ack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) UnknownAck() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownAckPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownAckPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-ack"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAck (leaf): The number of packets received containing an ACK for an unknown
// message ID in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-ack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/unknown-ack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) UnknownAck() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownAckPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownAckPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-ack"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownNack (leaf): The number of packets received containing a NACK for an unknown
// message ID in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-nack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/unknown-nack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPath) UnknownNack() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownNackPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownNackPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-nack"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownNack (leaf): The number of packets received containing a NACK for an unknown
// message ID in the context.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-nack"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/state/counters/errors/unknown-nack"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_ErrorsPathAny) UnknownNack() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownNackPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Counters_Errors_UnknownNackPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-nack"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_HelloIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_HelloIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_HelloIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos/config/hello-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_HelloIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_RefreshReductionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos/config/refresh-reduction YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_RefreshReductionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_RefreshReductionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos/config/refresh-reduction YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_RefreshReductionPathAny struct {
	*ygot.NodePath
}

// HelloInterval (leaf): set the interval in ms between RSVP hello
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPath) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_HelloIntervalPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_HelloIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): set the interval in ms between RSVP hello
// messages
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos/config/hello-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPathAny) HelloInterval() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_HelloIntervalPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_HelloIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// RefreshReduction (leaf): enables all RSVP refresh reduction message
// bundling, RSVP message ID, reliable message delivery
// and summary refresh
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/refresh-reduction"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos/config/refresh-reduction"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPath) RefreshReduction() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_RefreshReductionPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_RefreshReductionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "refresh-reduction"},
			map[string]interface{}{},
			n,
		),
	}
}

// RefreshReduction (leaf): enables all RSVP refresh reduction message
// bundling, RSVP message ID, reliable message delivery
// and summary refresh
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/refresh-reduction"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/hellos/config/refresh-reduction"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_HellosPathAny) RefreshReduction() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_RefreshReductionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Hellos_RefreshReductionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "refresh-reduction"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPath) Interface() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_BypassOptimizeIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection/config/bypass-optimize-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_BypassOptimizeIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_BypassOptimizeIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection/config/bypass-optimize-interval YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_BypassOptimizeIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_LinkProtectionStyleRequestedPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection/config/link-protection-style-requested YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_LinkProtectionStyleRequestedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_LinkProtectionStyleRequestedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection/config/link-protection-style-requested YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_LinkProtectionStyleRequestedPathAny struct {
	*ygot.NodePath
}

// BypassOptimizeInterval (leaf): interval between periodic optimization
// of the bypass LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/bypass-optimize-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection/config/bypass-optimize-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPath) BypassOptimizeInterval() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_BypassOptimizeIntervalPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_BypassOptimizeIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bypass-optimize-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// BypassOptimizeInterval (leaf): interval between periodic optimization
// of the bypass LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/bypass-optimize-interval"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection/config/bypass-optimize-interval"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPathAny) BypassOptimizeInterval() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_BypassOptimizeIntervalPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_BypassOptimizeIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bypass-optimize-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionStyleRequested (leaf): Style of mpls frr protection desired:
// link, link-node, or unprotected
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/link-protection-style-requested"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection/config/link-protection-style-requested"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPath) LinkProtectionStyleRequested() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_LinkProtectionStyleRequestedPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_LinkProtectionStyleRequestedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-protection-style-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionStyleRequested (leaf): Style of mpls frr protection desired:
// link, link-node, or unprotected
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/link-protection-style-requested"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/protection/config/link-protection-style-requested"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_ProtectionPathAny) LinkProtectionStyleRequested() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_LinkProtectionStyleRequestedPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Protection_LinkProtectionStyleRequestedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-protection-style-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_CalculatedAbsoluteSubscriptionBwPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription/state/calculated-absolute-subscription-bw YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_CalculatedAbsoluteSubscriptionBwPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_CalculatedAbsoluteSubscriptionBwPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription/state/calculated-absolute-subscription-bw YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_CalculatedAbsoluteSubscriptionBwPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_SubscriptionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription/config/subscription YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_SubscriptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_SubscriptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription/config/subscription YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_SubscriptionPathAny struct {
	*ygot.NodePath
}

// CalculatedAbsoluteSubscriptionBw (leaf): The calculated absolute value of the bandwidth
// which is reservable to RSVP-TE on the interface
// prior to any adjustments that may be made from
// external sources.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/calculated-absolute-subscription-bw"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription/state/calculated-absolute-subscription-bw"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPath) CalculatedAbsoluteSubscriptionBw() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_CalculatedAbsoluteSubscriptionBwPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_CalculatedAbsoluteSubscriptionBwPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "calculated-absolute-subscription-bw"},
			map[string]interface{}{},
			n,
		),
	}
}

// CalculatedAbsoluteSubscriptionBw (leaf): The calculated absolute value of the bandwidth
// which is reservable to RSVP-TE on the interface
// prior to any adjustments that may be made from
// external sources.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/calculated-absolute-subscription-bw"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription/state/calculated-absolute-subscription-bw"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPathAny) CalculatedAbsoluteSubscriptionBw() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_CalculatedAbsoluteSubscriptionBwPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_CalculatedAbsoluteSubscriptionBwPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "calculated-absolute-subscription-bw"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subscription (leaf): percentage of the interface bandwidth that
// RSVP can reserve
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subscription"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription/config/subscription"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPath) Subscription() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_SubscriptionPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_SubscriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subscription"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subscription (leaf): percentage of the interface bandwidth that
// RSVP can reserve
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subscription"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/interface-attributes/interface/subscription/config/subscription"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_SubscriptionPathAny) Subscription() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_SubscriptionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Interface_Subscription_SubscriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subscription"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_DetectedInterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/detected-interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_DetectedInterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_DetectedInterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/detected-interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_DetectedInterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_NeighborStatusPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/neighbor-status YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_NeighborStatusPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_NeighborStatusPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/neighbor-status YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_NeighborStatusPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_RefreshReductionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/refresh-reduction YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_RefreshReductionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_RefreshReductionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/refresh-reduction YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_RefreshReductionPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Address of RSVP neighbor
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/address"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPath) Address() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_AddressPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Address of RSVP neighbor
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/address"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny) Address() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_AddressPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DetectedInterface (leaf): Interface where RSVP neighbor was detected
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/detected-interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/detected-interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPath) DetectedInterface() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_DetectedInterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_DetectedInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "detected-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// DetectedInterface (leaf): Interface where RSVP neighbor was detected
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/detected-interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/detected-interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny) DetectedInterface() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_DetectedInterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_DetectedInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "detected-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborStatus (leaf): Enumuration of possible RSVP neighbor states
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-status"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/neighbor-status"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPath) NeighborStatus() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_NeighborStatusPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_NeighborStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborStatus (leaf): Enumuration of possible RSVP neighbor states
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-status"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/neighbor-status"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny) NeighborStatus() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_NeighborStatusPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_NeighborStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// RefreshReduction (leaf): Suppport of neighbor for RSVP refresh reduction
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/refresh-reduction"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/refresh-reduction"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPath) RefreshReduction() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_RefreshReductionPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_RefreshReductionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "refresh-reduction"},
			map[string]interface{}{},
			n,
		),
	}
}

// RefreshReduction (leaf): Suppport of neighbor for RSVP refresh reduction
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/refresh-reduction"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/neighbors/neighbor/state/refresh-reduction"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_NeighborPathAny) RefreshReduction() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_RefreshReductionPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Neighbor_RefreshReductionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "refresh-reduction"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_DestinationAddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/destination-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_DestinationAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_DestinationAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/destination-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_DestinationAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelInPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/label-in YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelInPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelInPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/label-in YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelInPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelOutPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/label-out YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelOutPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelOutPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/label-out YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelOutPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LocalIndexPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/local-index YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LocalIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LocalIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/local-index YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LocalIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LspIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/lsp-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LspIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LspIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/lsp-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LspIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ProtectionRequestedPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/protection-requested YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ProtectionRequestedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ProtectionRequestedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/protection-requested YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ProtectionRequestedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SessionNamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/session-name YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SessionNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SessionNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/session-name YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SessionNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SourceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/source-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SourceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SourceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/source-address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SourceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_StatusPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/status YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_StatusPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_StatusPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/status YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_StatusPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TunnelIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/tunnel-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TunnelIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TunnelIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/tunnel-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TunnelIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/type YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/type YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TypePathAny struct {
	*ygot.NodePath
}

// DestinationAddress (leaf): Destination address of RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/destination-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/destination-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) DestinationAddress() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_DestinationAddressPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_DestinationAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationAddress (leaf): Destination address of RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/destination-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/destination-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) DestinationAddress() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_DestinationAddressPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_DestinationAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExplicitRouteObjectAny (list): Read-only list of explicit route objects associated with the
// traffic-engineered tunnel. Each entry in the list contains
// a hop IP address, and the MPLS label allocated at the hop.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "explicit-route-objects/explicit-route-object"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object"
// Index (wildcarded): uint64
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) ExplicitRouteObjectAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"explicit-route-objects", "explicit-route-object"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// ExplicitRouteObjectAny (list): Read-only list of explicit route objects associated with the
// traffic-engineered tunnel. Each entry in the list contains
// a hop IP address, and the MPLS label allocated at the hop.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "explicit-route-objects/explicit-route-object"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object"
// Index (wildcarded): uint64
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) ExplicitRouteObjectAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"explicit-route-objects", "explicit-route-object"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// ExplicitRouteObject (list): Read-only list of explicit route objects associated with the
// traffic-engineered tunnel. Each entry in the list contains
// a hop IP address, and the MPLS label allocated at the hop.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "explicit-route-objects/explicit-route-object"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object"
// Index: uint64
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) ExplicitRouteObject(Index uint64) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath{
		NodePath: ygot.NewNodePath(
			[]string{"explicit-route-objects", "explicit-route-object"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// ExplicitRouteObject (list): Read-only list of explicit route objects associated with the
// traffic-engineered tunnel. Each entry in the list contains
// a hop IP address, and the MPLS label allocated at the hop.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "explicit-route-objects/explicit-route-object"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object"
// Index: uint64
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) ExplicitRouteObject(Index uint64) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"explicit-route-objects", "explicit-route-object"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// LabelIn (leaf): Incoming MPLS label associated with this RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label-in"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/label-in"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) LabelIn() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelInPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelInPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// LabelIn (leaf): Incoming MPLS label associated with this RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label-in"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/label-in"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) LabelIn() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelInPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// LabelOut (leaf): Outgoing MPLS label associated with this RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label-out"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/label-out"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) LabelOut() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelOutPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelOutPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// LabelOut (leaf): Outgoing MPLS label associated with this RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label-out"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/label-out"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) LabelOut() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelOutPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LabelOutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIndex (leaf): The index used to identify the RSVP session
// on the local network element. This index is
// generated by the device and is unique only
// to the local network element.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-index"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/local-index"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) LocalIndex() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LocalIndexPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LocalIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIndex (leaf): The index used to identify the RSVP session
// on the local network element. This index is
// generated by the device and is unique only
// to the local network element.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-index"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/local-index"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) LocalIndex() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LocalIndexPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LocalIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspId (leaf): The LSP ID distinguishes between two LSPs
// originated from the same headend, and is
// commonly used to distinguish RSVP sessions
// during make before break operations.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lsp-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/lsp-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) LspId() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LspIdPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LspIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lsp-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspId (leaf): The LSP ID distinguishes between two LSPs
// originated from the same headend, and is
// commonly used to distinguish RSVP sessions
// during make before break operations.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lsp-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/lsp-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) LspId() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LspIdPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_LspIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lsp-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtectionRequested (leaf): The type of protection requested for the RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/protection-requested"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/protection-requested"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) ProtectionRequested() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ProtectionRequestedPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ProtectionRequestedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "protection-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtectionRequested (leaf): The type of protection requested for the RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/protection-requested"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/protection-requested"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) ProtectionRequested() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ProtectionRequestedPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ProtectionRequestedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "protection-requested"},
			map[string]interface{}{},
			n,
		),
	}
}

// RecordRouteObjectAny (list): Read-only list of record route objects associated with the
// traffic engineered tunnel. Each entry in the list
// may contain a hop IP address, MPLS label allocated
// at the hop, and the flags associated with the entry.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "record-route-objects/record-route-object"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object"
// Index (wildcarded): uint8
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) RecordRouteObjectAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"record-route-objects", "record-route-object"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// RecordRouteObjectAny (list): Read-only list of record route objects associated with the
// traffic engineered tunnel. Each entry in the list
// may contain a hop IP address, MPLS label allocated
// at the hop, and the flags associated with the entry.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "record-route-objects/record-route-object"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object"
// Index (wildcarded): uint8
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) RecordRouteObjectAny() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"record-route-objects", "record-route-object"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// RecordRouteObject (list): Read-only list of record route objects associated with the
// traffic engineered tunnel. Each entry in the list
// may contain a hop IP address, MPLS label allocated
// at the hop, and the flags associated with the entry.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "record-route-objects/record-route-object"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object"
// Index: uint8
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) RecordRouteObject(Index uint8) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPath{
		NodePath: ygot.NewNodePath(
			[]string{"record-route-objects", "record-route-object"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// RecordRouteObject (list): Read-only list of record route objects associated with the
// traffic engineered tunnel. Each entry in the list
// may contain a hop IP address, MPLS label allocated
// at the hop, and the flags associated with the entry.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "record-route-objects/record-route-object"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object"
// Index: uint8
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) RecordRouteObject(Index uint8) *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"record-route-objects", "record-route-object"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// SenderTspec (container): Operational state statistics relating to the SENDER_TSPEC
// received for the RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sender-tspec"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) SenderTspec() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sender-tspec"},
			map[string]interface{}{},
			n,
		),
	}
}

// SenderTspec (container): Operational state statistics relating to the SENDER_TSPEC
// received for the RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sender-tspec"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) SenderTspec() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sender-tspec"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionName (leaf): The signaled name of this RSVP session.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/session-name"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/session-name"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) SessionName() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SessionNamePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SessionNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionName (leaf): The signaled name of this RSVP session.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/session-name"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/session-name"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) SessionName() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SessionNamePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SessionNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Origin address of RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/source-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) SourceAddress() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SourceAddressPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SourceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Origin address of RSVP session
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/source-address"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) SourceAddress() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SourceAddressPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SourceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Status (leaf): Enumeration of RSVP session states
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/status"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/status"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) Status() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_StatusPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_StatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "status"},
			map[string]interface{}{},
			n,
		),
	}
}

// Status (leaf): Enumeration of RSVP session states
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/status"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/status"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) Status() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_StatusPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_StatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "status"},
			map[string]interface{}{},
			n,
		),
	}
}

// TunnelId (leaf): The tunnel ID is an identifier used in the
// RSVP session, which remains constant over
// the life of the tunnel.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tunnel-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/tunnel-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) TunnelId() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TunnelIdPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TunnelIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tunnel-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// TunnelId (leaf): The tunnel ID is an identifier used in the
// RSVP session, which remains constant over
// the life of the tunnel.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tunnel-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/tunnel-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) TunnelId() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TunnelIdPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TunnelIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tunnel-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type/role of the RSVP session, signifing
// the session's role on the current device, such as
// a transit session vs. an ingress session.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/type"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPath) Type() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TypePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type/role of the RSVP session, signifing
// the session's role on the current device, such as
// a transit session vs. an ingress session.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/type"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_SessionPathAny) Type() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TypePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_AsnPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/asn YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_AsnPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_AsnPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/asn YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_AsnPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/index YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/index YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/interface-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/interface-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IpPrefixPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/ip-prefix YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IpPrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IpPrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/ip-prefix YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IpPrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/label YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/label YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LoosePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/loose YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LoosePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LoosePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/loose YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LoosePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_TypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/type YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/type YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_TypePathAny struct {
	*ygot.NodePath
}

// Asn (leaf): The autonomous system number indicated by the ERO. Specified
// only when the ERO hop is an 2 or 4-byte AS number.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/asn"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/asn"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath) Asn() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_AsnPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_AsnPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "asn"},
			map[string]interface{}{},
			n,
		),
	}
}

// Asn (leaf): The autonomous system number indicated by the ERO. Specified
// only when the ERO hop is an 2 or 4-byte AS number.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/asn"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/asn"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny) Asn() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_AsnPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_AsnPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "asn"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of the entry in the ERO. Entries are ordered in
// ascending order from the source to destination of the
// LSP.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/index"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath) Index() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IndexPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of the entry in the ERO. Entries are ordered in
// ascending order from the source to destination of the
// LSP.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/index"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny) Index() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IndexPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): The interface ID for an unnumbered interface. Specified only
// when the ERO hop is a unnumbered interface.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/interface-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath) InterfaceId() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_InterfaceIdPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): The interface ID for an unnumbered interface. Specified only
// when the ERO hop is a unnumbered interface.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/interface-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny) InterfaceId() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_InterfaceIdPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefix (leaf): The IPv4 or IPv6 prefix indicated by the ERO. Specified
// only when the ERO hop is an IPv4 or IPv6 prefix.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/ip-prefix"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath) IpPrefix() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IpPrefixPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IpPrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefix (leaf): The IPv4 or IPv6 prefix indicated by the ERO. Specified
// only when the ERO hop is an IPv4 or IPv6 prefix.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/ip-prefix"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny) IpPrefix() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IpPrefixPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_IpPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): The MPLS label specified in the ERO hop. Specified only when
// the hop is an MPLS label.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/label"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath) Label() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LabelPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): The MPLS label specified in the ERO hop. Specified only when
// the hop is an MPLS label.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/label"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny) Label() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LabelPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Loose (leaf): When set to true, indicates that the hop of the ERO is
// a loose hop within the explicit route. If unset, indicates
// that the hop must explicitly traverse the entity specified
// in the ERO hop as the next-entity.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/loose"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/loose"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath) Loose() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LoosePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LoosePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "loose"},
			map[string]interface{}{},
			n,
		),
	}
}

// Loose (leaf): When set to true, indicates that the hop of the ERO is
// a loose hop within the explicit route. If unset, indicates
// that the hop must explicitly traverse the entity specified
// in the ERO hop as the next-entity.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/loose"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/loose"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny) Loose() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LoosePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_LoosePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "loose"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of hop indicated by the ERO entry.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/type"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPath) Type() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_TypePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of hop indicated by the ERO entry.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/explicit-route-objects/explicit-route-object/state/type"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObjectPathAny) Type() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_TypePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_ExplicitRouteObject_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/address YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/index YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/index YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedFlagsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/reported-flags YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedFlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedFlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/reported-flags YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedFlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/reported-label YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/reported-label YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedLabelPathAny struct {
	*ygot.NodePath
}

// Address (leaf): IP router hop for RRO entry
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/address"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPath) Address() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_AddressPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): IP router hop for RRO entry
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/address"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny) Address() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_AddressPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of object in the list. Used for ordering.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/index"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPath) Index() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_IndexPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of object in the list. Used for ordering.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/index"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny) Index() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_IndexPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReportedFlags (leaf): Subobject flags for MPLS label
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reported-flags"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/reported-flags"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPath) ReportedFlags() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedFlagsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedFlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reported-flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReportedFlags (leaf): Subobject flags for MPLS label
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reported-flags"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/reported-flags"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny) ReportedFlags() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedFlagsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedFlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reported-flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReportedLabel (leaf): Label reported for RRO hop
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reported-label"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/reported-label"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPath) ReportedLabel() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedLabelPath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reported-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReportedLabel (leaf): Label reported for RRO hop
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reported-label"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/record-route-objects/record-route-object/state/reported-label"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObjectPathAny) ReportedLabel() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedLabelPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_RecordRouteObject_ReportedLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reported-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_PeakDataRatePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/peak-data-rate YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_PeakDataRatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_PeakDataRatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/peak-data-rate YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_PeakDataRatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_RatePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/rate YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_RatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_RatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/rate YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_RatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_SizePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/size YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_SizePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_SizePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/size YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_SizePathAny struct {
	*ygot.NodePath
}

// PeakDataRate (leaf): The maximum traffic generation rate that the head-end
// device sends traffic at.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "peak-data-rate"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/peak-data-rate"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPath) PeakDataRate() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_PeakDataRatePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_PeakDataRatePath{
		NodePath: ygot.NewNodePath(
			[]string{"peak-data-rate"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeakDataRate (leaf): The maximum traffic generation rate that the head-end
// device sends traffic at.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "peak-data-rate"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/peak-data-rate"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPathAny) PeakDataRate() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_PeakDataRatePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_PeakDataRatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"peak-data-rate"},
			map[string]interface{}{},
			n,
		),
	}
}

// Rate (leaf): The rate at which the head-end device generates traffic,
// expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rate"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/rate"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPath) Rate() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_RatePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_RatePath{
		NodePath: ygot.NewNodePath(
			[]string{"rate"},
			map[string]interface{}{},
			n,
		),
	}
}

// Rate (leaf): The rate at which the head-end device generates traffic,
// expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rate"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/rate"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPathAny) Rate() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_RatePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_RatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rate"},
			map[string]interface{}{},
			n,
		),
	}
}

// Size (leaf): The size of the token bucket that is used to determine
// the rate at which the head-end device generates traffic,
// expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "size"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/size"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPath) Size() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_SizePath {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_SizePath{
		NodePath: ygot.NewNodePath(
			[]string{"size"},
			map[string]interface{}{},
			n,
		),
	}
}

// Size (leaf): The size of the token bucket that is used to determine
// the rate at which the head-end device generates traffic,
// expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-mpls-rsvp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "size"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/rsvp-te/sessions/session/state/sender-tspec/size"
func (n *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspecPathAny) Size() *NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_SizePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_RsvpTe_Session_SenderTspec_SizePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"size"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPathAny struct {
	*ygot.NodePath
}

// AggregateSidCounterAny (list): Counters aggregated across all of the interfaces of the local
// system corresponding to traffic received or forwarded with a
// particular SID
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "aggregate-sid-counters/aggregate-sid-counter"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter"
// MplsLabel (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPath) AggregateSidCounterAny() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"aggregate-sid-counters", "aggregate-sid-counter"},
			map[string]interface{}{"mpls-label": "*"},
			n,
		),
	}
}

// AggregateSidCounterAny (list): Counters aggregated across all of the interfaces of the local
// system corresponding to traffic received or forwarded with a
// particular SID
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "aggregate-sid-counters/aggregate-sid-counter"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter"
// MplsLabel (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPathAny) AggregateSidCounterAny() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"aggregate-sid-counters", "aggregate-sid-counter"},
			map[string]interface{}{"mpls-label": "*"},
			n,
		),
	}
}

// AggregateSidCounter (list): Counters aggregated across all of the interfaces of the local
// system corresponding to traffic received or forwarded with a
// particular SID
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "aggregate-sid-counters/aggregate-sid-counter"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter"
// MplsLabel: [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPath) AggregateSidCounter(MplsLabel NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabel_Union) *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPath{
		NodePath: ygot.NewNodePath(
			[]string{"aggregate-sid-counters", "aggregate-sid-counter"},
			map[string]interface{}{"mpls-label": MplsLabel},
			n,
		),
	}
}

// AggregateSidCounter (list): Counters aggregated across all of the interfaces of the local
// system corresponding to traffic received or forwarded with a
// particular SID
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "aggregate-sid-counters/aggregate-sid-counter"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter"
// MplsLabel: [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPathAny) AggregateSidCounter(MplsLabel NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabel_Union) *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"aggregate-sid-counters", "aggregate-sid-counter"},
			map[string]interface{}{"mpls-label": MplsLabel},
			n,
		),
	}
}

// InterfaceAny (list): Parameters and MPLS-specific configuration relating to Segment
// Routing on an interface.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPath) InterfaceAny() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): Parameters and MPLS-specific configuration relating to Segment
// Routing on an interface.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPathAny) InterfaceAny() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// Interface (list): Parameters and MPLS-specific configuration relating to Segment
// Routing on an interface.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPath) Interface(InterfaceId string) *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Interface (list): Parameters and MPLS-specific configuration relating to Segment
// Routing on an interface.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRoutingPathAny) Interface(InterfaceId string) *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/in-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/in-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InPktsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/in-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/in-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/mpls-label YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/mpls-label YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/out-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/out-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutPktsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/out-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/out-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutPktsPathAny struct {
	*ygot.NodePath
}

// InOctets (leaf): The cumulative counter of the total bytes received within the context
// which have matched a label corresponding to an SR Segment Identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/in-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPath) InOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InOctetsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The cumulative counter of the total bytes received within the context
// which have matched a label corresponding to an SR Segment Identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/in-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny) InOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InOctetsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the packets received within the context
// which have matched a label corresponding to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/in-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPath) InPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InPktsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the packets received within the context
// which have matched a label corresponding to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/in-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny) InPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InPktsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabel (leaf): The MPLS label used for the segment identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-label"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/mpls-label"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPath) MplsLabel() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabelPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabel (leaf): The MPLS label used for the segment identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-label"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/mpls-label"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny) MplsLabel() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabelPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_MplsLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): A cumulative counter of the total bytes transmitted by the local
// system within the context which have a label imported that
// corresponds to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/out-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPath) OutOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutOctetsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): A cumulative counter of the total bytes transmitted by the local
// system within the context which have a label imported that
// corresponds to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/out-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny) OutOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutOctetsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the total number of packets transmitted by
// the local system within the context which have a label imposed that
// corresponds to an Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/out-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPath) OutPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutPktsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the total number of packets transmitted by
// the local system within the context which have a label imposed that
// corresponds to an Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/aggregate-sid-counters/aggregate-sid-counter/state/out-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounterPathAny) OutPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutPktsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_AggregateSidCounter_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/in-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/in-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InPktsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/in-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/in-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/out-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/out-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutPktsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/out-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/out-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutPktsPathAny struct {
	*ygot.NodePath
}

// InOctets (leaf): The cumulative counter of the total bytes received within the context
// which have matched a label corresponding to an SR Segment Identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/in-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath) InOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InOctetsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The cumulative counter of the total bytes received within the context
// which have matched a label corresponding to an SR Segment Identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/in-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny) InOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InOctetsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the packets received within the context
// which have matched a label corresponding to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/in-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath) InPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InPktsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the packets received within the context
// which have matched a label corresponding to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/in-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny) InPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InPktsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): A unique identifier for the interface.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath) InterfaceId() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceIdPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): A unique identifier for the interface.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny) InterfaceId() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceIdPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath) InterfaceRef() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny) InterfaceRef() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): A cumulative counter of the total bytes transmitted by the local
// system within the context which have a label imported that
// corresponds to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/out-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath) OutOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutOctetsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): A cumulative counter of the total bytes transmitted by the local
// system within the context which have a label imported that
// corresponds to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/out-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny) OutOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutOctetsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the total number of packets transmitted by
// the local system within the context which have a label imposed that
// corresponds to an Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/out-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath) OutPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutPktsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the total number of packets transmitted by
// the local system within the context which have a label imposed that
// corresponds to an Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/state/out-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny) OutPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutPktsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidCounterAny (list): Per segment identifier counters for the MPLS dataplane.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-counters/sid-counter"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter"
// MplsLabel (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath) SidCounterAny() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sid-counters", "sid-counter"},
			map[string]interface{}{"mpls-label": "*"},
			n,
		),
	}
}

// SidCounterAny (list): Per segment identifier counters for the MPLS dataplane.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-counters/sid-counter"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter"
// MplsLabel (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny) SidCounterAny() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sid-counters", "sid-counter"},
			map[string]interface{}{"mpls-label": "*"},
			n,
		),
	}
}

// SidCounter (list): Per segment identifier counters for the MPLS dataplane.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-counters/sid-counter"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter"
// MplsLabel: [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePath) SidCounter(MplsLabel NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabel_Union) *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath{
		NodePath: ygot.NewNodePath(
			[]string{"sid-counters", "sid-counter"},
			map[string]interface{}{"mpls-label": MplsLabel},
			n,
		),
	}
}

// SidCounter (list): Per segment identifier counters for the MPLS dataplane.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-counters/sid-counter"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter"
// MplsLabel: [UnionUint32, E_MplsTypes_MplsLabel_Enum]
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_InterfacePathAny) SidCounter(MplsLabel NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabel_Union) *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sid-counters", "sid-counter"},
			map[string]interface{}{"mpls-label": MplsLabel},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPath) Interface() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/in-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/in-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InPktsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/in-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/in-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabelPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/mpls-label YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/mpls-label YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/out-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/out-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutPktsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/out-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/out-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutPktsPathAny struct {
	*ygot.NodePath
}

// ForwardingClassAny (list): SID entries for the forwarding class associated with the
// referenced MPLS EXP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "forwarding-classes/forwarding-class"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class"
// Exp (wildcarded): uint8
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath) ForwardingClassAny() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"forwarding-classes", "forwarding-class"},
			map[string]interface{}{"exp": "*"},
			n,
		),
	}
}

// ForwardingClassAny (list): SID entries for the forwarding class associated with the
// referenced MPLS EXP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "forwarding-classes/forwarding-class"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class"
// Exp (wildcarded): uint8
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny) ForwardingClassAny() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"forwarding-classes", "forwarding-class"},
			map[string]interface{}{"exp": "*"},
			n,
		),
	}
}

// ForwardingClass (list): SID entries for the forwarding class associated with the
// referenced MPLS EXP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "forwarding-classes/forwarding-class"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class"
// Exp: uint8
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath) ForwardingClass(Exp uint8) *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPath{
		NodePath: ygot.NewNodePath(
			[]string{"forwarding-classes", "forwarding-class"},
			map[string]interface{}{"exp": Exp},
			n,
		),
	}
}

// ForwardingClass (list): SID entries for the forwarding class associated with the
// referenced MPLS EXP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "forwarding-classes/forwarding-class"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class"
// Exp: uint8
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny) ForwardingClass(Exp uint8) *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"forwarding-classes", "forwarding-class"},
			map[string]interface{}{"exp": Exp},
			n,
		),
	}
}

// InOctets (leaf): The cumulative counter of the total bytes received within the context
// which have matched a label corresponding to an SR Segment Identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/in-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath) InOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InOctetsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The cumulative counter of the total bytes received within the context
// which have matched a label corresponding to an SR Segment Identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/in-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny) InOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InOctetsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the packets received within the context
// which have matched a label corresponding to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/in-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath) InPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InPktsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the packets received within the context
// which have matched a label corresponding to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/in-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny) InPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InPktsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabel (leaf): The MPLS label used for the segment identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-label"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/mpls-label"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath) MplsLabel() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabelPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabel (leaf): The MPLS label used for the segment identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-label"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/mpls-label"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny) MplsLabel() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabelPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_MplsLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): A cumulative counter of the total bytes transmitted by the local
// system within the context which have a label imported that
// corresponds to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/out-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath) OutOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutOctetsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): A cumulative counter of the total bytes transmitted by the local
// system within the context which have a label imported that
// corresponds to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/out-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny) OutOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutOctetsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the total number of packets transmitted by
// the local system within the context which have a label imposed that
// corresponds to an Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/out-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPath) OutPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutPktsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the total number of packets transmitted by
// the local system within the context which have a label imposed that
// corresponds to an Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/state/out-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounterPathAny) OutPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutPktsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_ExpPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/exp YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_ExpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_ExpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/exp YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_ExpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/in-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/in-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InPktsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/in-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/in-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/out-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/out-octets YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutPktsPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/out-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/out-pkts YANG schema element.
type NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutPktsPathAny struct {
	*ygot.NodePath
}

// Exp (leaf): The value of the MPLS EXP (experimental) or Traffic Class bits that the
// SID statistics relate to. Packets received with a MPLS label value
// equal to the SID's MPLS label and EXP bits equal to the this value
// should be counted towards the associated ingress statistics. Packets
// that are forwarded to the destination MPLS label corresponding to the
// SID should be counted towards this value. In the egress direction, where
// forwarding follows a SID value that requires PHP at the local node,
// packets should still be counted towards the egress counters.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/exp"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/exp"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPath) Exp() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_ExpPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_ExpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "exp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Exp (leaf): The value of the MPLS EXP (experimental) or Traffic Class bits that the
// SID statistics relate to. Packets received with a MPLS label value
// equal to the SID's MPLS label and EXP bits equal to the this value
// should be counted towards the associated ingress statistics. Packets
// that are forwarded to the destination MPLS label corresponding to the
// SID should be counted towards this value. In the egress direction, where
// forwarding follows a SID value that requires PHP at the local node,
// packets should still be counted towards the egress counters.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/exp"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/exp"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny) Exp() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_ExpPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_ExpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "exp"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The cumulative counter of the total bytes received within the context
// which have matched a label corresponding to an SR Segment Identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/in-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPath) InOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InOctetsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The cumulative counter of the total bytes received within the context
// which have matched a label corresponding to an SR Segment Identifier
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/in-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny) InOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InOctetsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the packets received within the context
// which have matched a label corresponding to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/in-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPath) InPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InPktsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the packets received within the context
// which have matched a label corresponding to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/in-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/in-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny) InPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InPktsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): A cumulative counter of the total bytes transmitted by the local
// system within the context which have a label imported that
// corresponds to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/out-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPath) OutOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutOctetsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): A cumulative counter of the total bytes transmitted by the local
// system within the context which have a label imported that
// corresponds to an SR Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-octets"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/out-octets"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny) OutOctets() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutOctetsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the total number of packets transmitted by
// the local system within the context which have a label imposed that
// corresponds to an Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/out-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPath) OutPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutPktsPath {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the total number of packets transmitted by
// the local system within the context which have a label imposed that
// corresponds to an Segment Identifier.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/out-pkts"
// Path from root: "/network-instances/network-instance/mpls/signaling-protocols/segment-routing/interfaces/interface/sid-counters/sid-counter/forwarding-classes/forwarding-class/state/out-pkts"
func (n *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClassPathAny) OutPkts() *NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutPktsPathAny {
	return &NetworkInstance_Mpls_SignalingProtocols_SegmentRouting_Interface_SidCounter_ForwardingClass_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_TeGlobalAttributesPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributesPathAny struct {
	*ygot.NodePath
}

// AdminGroupAny (list): configuration of value to name mapping
// for mpls affinities/admin-groups
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls-admin-groups/admin-group"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group"
// AdminGroupName (wildcarded): string
func (n *NetworkInstance_Mpls_TeGlobalAttributesPath) AdminGroupAny() *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls-admin-groups", "admin-group"},
			map[string]interface{}{"admin-group-name": "*"},
			n,
		),
	}
}

// AdminGroupAny (list): configuration of value to name mapping
// for mpls affinities/admin-groups
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls-admin-groups/admin-group"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group"
// AdminGroupName (wildcarded): string
func (n *NetworkInstance_Mpls_TeGlobalAttributesPathAny) AdminGroupAny() *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls-admin-groups", "admin-group"},
			map[string]interface{}{"admin-group-name": "*"},
			n,
		),
	}
}

// AdminGroup (list): configuration of value to name mapping
// for mpls affinities/admin-groups
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls-admin-groups/admin-group"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group"
// AdminGroupName: string
func (n *NetworkInstance_Mpls_TeGlobalAttributesPath) AdminGroup(AdminGroupName string) *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"mpls-admin-groups", "admin-group"},
			map[string]interface{}{"admin-group-name": AdminGroupName},
			n,
		),
	}
}

// AdminGroup (list): configuration of value to name mapping
// for mpls affinities/admin-groups
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls-admin-groups/admin-group"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group"
// AdminGroupName: string
func (n *NetworkInstance_Mpls_TeGlobalAttributesPathAny) AdminGroup(AdminGroupName string) *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls-admin-groups", "admin-group"},
			map[string]interface{}{"admin-group-name": AdminGroupName},
			n,
		),
	}
}

// SrlgAny (list): List of shared risk link groups
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srlgs/srlg"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_TeGlobalAttributesPath) SrlgAny() *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srlgs", "srlg"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// SrlgAny (list): List of shared risk link groups
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srlgs/srlg"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg"
// Name (wildcarded): string
func (n *NetworkInstance_Mpls_TeGlobalAttributesPathAny) SrlgAny() *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srlgs", "srlg"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Srlg (list): List of shared risk link groups
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srlgs/srlg"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg"
// Name: string
func (n *NetworkInstance_Mpls_TeGlobalAttributesPath) Srlg(Name string) *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath{
		NodePath: ygot.NewNodePath(
			[]string{"srlgs", "srlg"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Srlg (list): List of shared risk link groups
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srlgs/srlg"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg"
// Name: string
func (n *NetworkInstance_Mpls_TeGlobalAttributesPathAny) Srlg(Name string) *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srlgs", "srlg"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// TeLspTimers (container): Definition for delays associated with setup
// and cleanup of TE LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-lsp-timers"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers"
func (n *NetworkInstance_Mpls_TeGlobalAttributesPath) TeLspTimers() *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPath{
		NodePath: ygot.NewNodePath(
			[]string{"te-lsp-timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// TeLspTimers (container): Definition for delays associated with setup
// and cleanup of TE LSPs
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-lsp-timers"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers"
func (n *NetworkInstance_Mpls_TeGlobalAttributesPathAny) TeLspTimers() *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-lsp-timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_AdminGroupNamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group/config/admin-group-name YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_AdminGroupNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_AdminGroupNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group/config/admin-group-name YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_AdminGroupNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_BitPositionPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group/config/bit-position YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_BitPositionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_BitPositionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group/config/bit-position YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_BitPositionPathAny struct {
	*ygot.NodePath
}

// AdminGroupName (leaf): name for mpls admin-group
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/admin-group-name"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group/config/admin-group-name"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPath) AdminGroupName() *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_AdminGroupNamePath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_AdminGroupNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-group-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroupName (leaf): name for mpls admin-group
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/admin-group-name"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group/config/admin-group-name"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny) AdminGroupName() *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_AdminGroupNamePathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_AdminGroupNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-group-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// BitPosition (leaf): bit-position value for mpls admin-group. The value
// for the admin group is an integer that represents one
// of the bit positions in the admin-group bitmask. Values
// between 0 and 31 are interpreted as the original limit
// of 32 admin groups. Values >=32 are interpreted as
// extended admin group values as per RFC7308.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/bit-position"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group/config/bit-position"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPath) BitPosition() *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_BitPositionPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_BitPositionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bit-position"},
			map[string]interface{}{},
			n,
		),
	}
}

// BitPosition (leaf): bit-position value for mpls admin-group. The value
// for the admin group is an integer that represents one
// of the bit positions in the admin-group bitmask. Values
// between 0 and 31 are interpreted as the original limit
// of 32 admin groups. Values >=32 are interpreted as
// extended admin group values as per RFC7308.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/bit-position"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/mpls-admin-groups/admin-group/config/bit-position"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroupPathAny) BitPosition() *NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_BitPositionPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_AdminGroup_BitPositionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bit-position"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_CostPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/cost YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_CostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_CostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/cost YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_CostPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_FloodingTypePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/flooding-type YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_FloodingTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_FloodingTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/flooding-type YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_FloodingTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_NamePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/name YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/name YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_NamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/value YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/value YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_ValuePathAny struct {
	*ygot.NodePath
}

// Cost (leaf): The cost of the SRLG to the computation
// algorithm
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/cost"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/cost"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath) Cost() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_CostPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_CostPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cost (leaf): The cost of the SRLG to the computation
// algorithm
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/cost"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/cost"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny) Cost() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_CostPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_CostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// FloodingType (leaf): The type of SRLG, either flooded in the IGP or
// statically configured
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/flooding-type"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/flooding-type"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath) FloodingType() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_FloodingTypePath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_FloodingTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "flooding-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// FloodingType (leaf): The type of SRLG, either flooded in the IGP or
// statically configured
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/flooding-type"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/flooding-type"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny) FloodingType() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_FloodingTypePathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_FloodingTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "flooding-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// MembersListAny (list): List of SRLG members, which are expressed
// as IP address endpoints of links contained in the
// SRLG
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-srlg-members/members-list"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list"
// FromAddress (wildcarded): string
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath) MembersListAny() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-srlg-members", "members-list"},
			map[string]interface{}{"from-address": "*"},
			n,
		),
	}
}

// MembersListAny (list): List of SRLG members, which are expressed
// as IP address endpoints of links contained in the
// SRLG
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-srlg-members/members-list"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list"
// FromAddress (wildcarded): string
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny) MembersListAny() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-srlg-members", "members-list"},
			map[string]interface{}{"from-address": "*"},
			n,
		),
	}
}

// MembersList (list): List of SRLG members, which are expressed
// as IP address endpoints of links contained in the
// SRLG
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-srlg-members/members-list"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list"
// FromAddress: string
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath) MembersList(FromAddress string) *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPath{
		NodePath: ygot.NewNodePath(
			[]string{"static-srlg-members", "members-list"},
			map[string]interface{}{"from-address": FromAddress},
			n,
		),
	}
}

// MembersList (list): List of SRLG members, which are expressed
// as IP address endpoints of links contained in the
// SRLG
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-srlg-members/members-list"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list"
// FromAddress: string
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny) MembersList(FromAddress string) *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-srlg-members", "members-list"},
			map[string]interface{}{"from-address": FromAddress},
			n,
		),
	}
}

// Name (leaf): SRLG group identifier
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/name"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath) Name() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_NamePath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): SRLG group identifier
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/name"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny) Name() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_NamePathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): group ID for the SRLG
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/value"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/value"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPath) Value() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_ValuePath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): group ID for the SRLG
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/value"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/config/value"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_SrlgPathAny) Value() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_ValuePathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_FromAddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list/config/from-address YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_FromAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_FromAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list/config/from-address YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_FromAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_ToAddressPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list/config/to-address YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_ToAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_ToAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list/config/to-address YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_ToAddressPathAny struct {
	*ygot.NodePath
}

// FromAddress (leaf): IP address of the a-side of the SRLG link
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/from-address"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list/config/from-address"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPath) FromAddress() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_FromAddressPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_FromAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "from-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// FromAddress (leaf): IP address of the a-side of the SRLG link
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/from-address"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list/config/from-address"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny) FromAddress() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_FromAddressPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_FromAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "from-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ToAddress (leaf): IP address of the z-side of the SRLG link
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/to-address"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list/config/to-address"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPath) ToAddress() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_ToAddressPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_ToAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "to-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ToAddress (leaf): IP address of the z-side of the SRLG link
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/to-address"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/srlgs/srlg/static-srlg-members/members-list/config/to-address"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersListPathAny) ToAddress() *NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_ToAddressPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_Srlg_MembersList_ToAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "to-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_CleanupDelayPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/cleanup-delay YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_CleanupDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_CleanupDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/cleanup-delay YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_CleanupDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_InstallDelayPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/install-delay YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_InstallDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_InstallDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/install-delay YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_InstallDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_ReoptimizeTimerPath represents the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/reoptimize-timer YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_ReoptimizeTimerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_ReoptimizeTimerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/reoptimize-timer YANG schema element.
type NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_ReoptimizeTimerPathAny struct {
	*ygot.NodePath
}

// CleanupDelay (leaf): delay the removal of old te lsp for a specified
// amount of time
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/cleanup-delay"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/cleanup-delay"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPath) CleanupDelay() *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_CleanupDelayPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_CleanupDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cleanup-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// CleanupDelay (leaf): delay the removal of old te lsp for a specified
// amount of time
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/cleanup-delay"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/cleanup-delay"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPathAny) CleanupDelay() *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_CleanupDelayPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_CleanupDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cleanup-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstallDelay (leaf): delay the use of newly installed te lsp for a
// specified amount of time.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/install-delay"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/install-delay"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPath) InstallDelay() *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_InstallDelayPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_InstallDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "install-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstallDelay (leaf): delay the use of newly installed te lsp for a
// specified amount of time.
// ----------------------------------------
// Defining module: "openconfig-mpls"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/install-delay"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/install-delay"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPathAny) InstallDelay() *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_InstallDelayPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_InstallDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "install-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReoptimizeTimer (leaf): frequency of reoptimization of
// a traffic engineered LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reoptimize-timer"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/reoptimize-timer"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPath) ReoptimizeTimer() *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_ReoptimizeTimerPath {
	return &NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_ReoptimizeTimerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reoptimize-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReoptimizeTimer (leaf): frequency of reoptimization of
// a traffic engineered LSP
// ----------------------------------------
// Defining module: "openconfig-mpls-te"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reoptimize-timer"
// Path from root: "/network-instances/network-instance/mpls/te-global-attributes/te-lsp-timers/config/reoptimize-timer"
func (n *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimersPathAny) ReoptimizeTimer() *NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_ReoptimizeTimerPathAny {
	return &NetworkInstance_Mpls_TeGlobalAttributes_TeLspTimers_ReoptimizeTimerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reoptimize-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwardingPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding YANG schema element.
type NetworkInstance_PolicyForwardingPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwardingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding YANG schema element.
type NetworkInstance_PolicyForwardingPathAny struct {
	*ygot.NodePath
}

// InterfaceAny (list): Configuration and operationals state relating to the
// relationship between interfaces and policy-based forwarding
// rules.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_PolicyForwardingPath) InterfaceAny() *NetworkInstance_PolicyForwarding_InterfacePathAny {
	return &NetworkInstance_PolicyForwarding_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): Configuration and operationals state relating to the
// relationship between interfaces and policy-based forwarding
// rules.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_PolicyForwardingPathAny) InterfaceAny() *NetworkInstance_PolicyForwarding_InterfacePathAny {
	return &NetworkInstance_PolicyForwarding_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// Interface (list): Configuration and operationals state relating to the
// relationship between interfaces and policy-based forwarding
// rules.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_PolicyForwardingPath) Interface(InterfaceId string) *NetworkInstance_PolicyForwarding_InterfacePath {
	return &NetworkInstance_PolicyForwarding_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Interface (list): Configuration and operationals state relating to the
// relationship between interfaces and policy-based forwarding
// rules.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_PolicyForwardingPathAny) Interface(InterfaceId string) *NetworkInstance_PolicyForwarding_InterfacePathAny {
	return &NetworkInstance_PolicyForwarding_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// PathSelectionGroupAny (list): A path selection group is a set of forwarding resources,
// which are grouped as eligible paths for a particular
// policy-based forwarding rule. A policy rule may select a
// path-selection-group as the egress for a particular type of
// traffic (e.g., DSCP value). The system then utilises its
// standard forwarding lookup mechanism to select from the
// paths that are specified within the group - for IP packets,
// the destination IP address is used such that the packet is
// routed to the entity within the path-selection-group that
// corresponds to the next-hop for the destination IP address
// of the packet; for L2 packets, the selection is based on the
// destination MAC address. If multiple paths within the
// selection group are eligible to be used for forwarding,
// the packets are load-balanced between them according to
// the system's usual load balancing logic.
// ----------------------------------------
// Defining module: "openconfig-pf-path-groups"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-selection-groups/path-selection-group"
// Path from root: "/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group"
// GroupId (wildcarded): string
func (n *NetworkInstance_PolicyForwardingPath) PathSelectionGroupAny() *NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny {
	return &NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-selection-groups", "path-selection-group"},
			map[string]interface{}{"group-id": "*"},
			n,
		),
	}
}

// PathSelectionGroupAny (list): A path selection group is a set of forwarding resources,
// which are grouped as eligible paths for a particular
// policy-based forwarding rule. A policy rule may select a
// path-selection-group as the egress for a particular type of
// traffic (e.g., DSCP value). The system then utilises its
// standard forwarding lookup mechanism to select from the
// paths that are specified within the group - for IP packets,
// the destination IP address is used such that the packet is
// routed to the entity within the path-selection-group that
// corresponds to the next-hop for the destination IP address
// of the packet; for L2 packets, the selection is based on the
// destination MAC address. If multiple paths within the
// selection group are eligible to be used for forwarding,
// the packets are load-balanced between them according to
// the system's usual load balancing logic.
// ----------------------------------------
// Defining module: "openconfig-pf-path-groups"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-selection-groups/path-selection-group"
// Path from root: "/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group"
// GroupId (wildcarded): string
func (n *NetworkInstance_PolicyForwardingPathAny) PathSelectionGroupAny() *NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny {
	return &NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-selection-groups", "path-selection-group"},
			map[string]interface{}{"group-id": "*"},
			n,
		),
	}
}

// PathSelectionGroup (list): A path selection group is a set of forwarding resources,
// which are grouped as eligible paths for a particular
// policy-based forwarding rule. A policy rule may select a
// path-selection-group as the egress for a particular type of
// traffic (e.g., DSCP value). The system then utilises its
// standard forwarding lookup mechanism to select from the
// paths that are specified within the group - for IP packets,
// the destination IP address is used such that the packet is
// routed to the entity within the path-selection-group that
// corresponds to the next-hop for the destination IP address
// of the packet; for L2 packets, the selection is based on the
// destination MAC address. If multiple paths within the
// selection group are eligible to be used for forwarding,
// the packets are load-balanced between them according to
// the system's usual load balancing logic.
// ----------------------------------------
// Defining module: "openconfig-pf-path-groups"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-selection-groups/path-selection-group"
// Path from root: "/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group"
// GroupId: string
func (n *NetworkInstance_PolicyForwardingPath) PathSelectionGroup(GroupId string) *NetworkInstance_PolicyForwarding_PathSelectionGroupPath {
	return &NetworkInstance_PolicyForwarding_PathSelectionGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"path-selection-groups", "path-selection-group"},
			map[string]interface{}{"group-id": GroupId},
			n,
		),
	}
}

// PathSelectionGroup (list): A path selection group is a set of forwarding resources,
// which are grouped as eligible paths for a particular
// policy-based forwarding rule. A policy rule may select a
// path-selection-group as the egress for a particular type of
// traffic (e.g., DSCP value). The system then utilises its
// standard forwarding lookup mechanism to select from the
// paths that are specified within the group - for IP packets,
// the destination IP address is used such that the packet is
// routed to the entity within the path-selection-group that
// corresponds to the next-hop for the destination IP address
// of the packet; for L2 packets, the selection is based on the
// destination MAC address. If multiple paths within the
// selection group are eligible to be used for forwarding,
// the packets are load-balanced between them according to
// the system's usual load balancing logic.
// ----------------------------------------
// Defining module: "openconfig-pf-path-groups"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "path-selection-groups/path-selection-group"
// Path from root: "/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group"
// GroupId: string
func (n *NetworkInstance_PolicyForwardingPathAny) PathSelectionGroup(GroupId string) *NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny {
	return &NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"path-selection-groups", "path-selection-group"},
			map[string]interface{}{"group-id": GroupId},
			n,
		),
	}
}

// PolicyAny (list): A forwarding policy is defined to have a set of match
// criteria, allowing particular fields of a packet's header to
// be matched, and a set of forwarding actions which determines
// how the local system should forward the packet.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policies/policy"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy"
// PolicyId (wildcarded): string
func (n *NetworkInstance_PolicyForwardingPath) PolicyAny() *NetworkInstance_PolicyForwarding_PolicyPathAny {
	return &NetworkInstance_PolicyForwarding_PolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policies", "policy"},
			map[string]interface{}{"policy-id": "*"},
			n,
		),
	}
}

// PolicyAny (list): A forwarding policy is defined to have a set of match
// criteria, allowing particular fields of a packet's header to
// be matched, and a set of forwarding actions which determines
// how the local system should forward the packet.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policies/policy"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy"
// PolicyId (wildcarded): string
func (n *NetworkInstance_PolicyForwardingPathAny) PolicyAny() *NetworkInstance_PolicyForwarding_PolicyPathAny {
	return &NetworkInstance_PolicyForwarding_PolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policies", "policy"},
			map[string]interface{}{"policy-id": "*"},
			n,
		),
	}
}

// Policy (list): A forwarding policy is defined to have a set of match
// criteria, allowing particular fields of a packet's header to
// be matched, and a set of forwarding actions which determines
// how the local system should forward the packet.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policies/policy"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy"
// PolicyId: string
func (n *NetworkInstance_PolicyForwardingPath) Policy(PolicyId string) *NetworkInstance_PolicyForwarding_PolicyPath {
	return &NetworkInstance_PolicyForwarding_PolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"policies", "policy"},
			map[string]interface{}{"policy-id": PolicyId},
			n,
		),
	}
}

// Policy (list): A forwarding policy is defined to have a set of match
// criteria, allowing particular fields of a packet's header to
// be matched, and a set of forwarding actions which determines
// how the local system should forward the packet.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "policies/policy"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy"
// PolicyId: string
func (n *NetworkInstance_PolicyForwardingPathAny) Policy(PolicyId string) *NetworkInstance_PolicyForwarding_PolicyPathAny {
	return &NetworkInstance_PolicyForwarding_PolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policies", "policy"},
			map[string]interface{}{"policy-id": PolicyId},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface YANG schema element.
type NetworkInstance_PolicyForwarding_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface YANG schema element.
type NetworkInstance_PolicyForwarding_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_ApplyForwardingPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/config/apply-forwarding-policy YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_ApplyForwardingPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_ApplyForwardingPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/config/apply-forwarding-policy YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_ApplyForwardingPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_ApplyVrfSelectionPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/config/apply-vrf-selection-policy YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_ApplyVrfSelectionPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_ApplyVrfSelectionPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/config/apply-vrf-selection-policy YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_ApplyVrfSelectionPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// ApplyForwardingPolicy (leaf): The policy to be applied on the interface. Packets ingress on
// the referenced interface should be compared to the match
// criteria within the specified policy, and in the case that
// these criteria are met, the forwarding actions specified
// applied. These policies should be applied following quality of
// service classification, and ACL actions if such entities are
// referenced by the corresponding interface.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/apply-forwarding-policy"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/config/apply-forwarding-policy"
func (n *NetworkInstance_PolicyForwarding_InterfacePath) ApplyForwardingPolicy() *NetworkInstance_PolicyForwarding_Interface_ApplyForwardingPolicyPath {
	return &NetworkInstance_PolicyForwarding_Interface_ApplyForwardingPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "apply-forwarding-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyForwardingPolicy (leaf): The policy to be applied on the interface. Packets ingress on
// the referenced interface should be compared to the match
// criteria within the specified policy, and in the case that
// these criteria are met, the forwarding actions specified
// applied. These policies should be applied following quality of
// service classification, and ACL actions if such entities are
// referenced by the corresponding interface.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/apply-forwarding-policy"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/config/apply-forwarding-policy"
func (n *NetworkInstance_PolicyForwarding_InterfacePathAny) ApplyForwardingPolicy() *NetworkInstance_PolicyForwarding_Interface_ApplyForwardingPolicyPathAny {
	return &NetworkInstance_PolicyForwarding_Interface_ApplyForwardingPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "apply-forwarding-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyVrfSelectionPolicy (leaf): Apply the specific VRF selection policy on the interface. The referenced policy
// MUST be of type VRF_SELECTION_POLICY. The VRF selection policy may coexist with
// a policy-forwarding policy.
//
// The policy specified in this leaf is used to specifically choose the L3VRF network
// instance that is used for specific input criteria of packets.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/apply-vrf-selection-policy"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/config/apply-vrf-selection-policy"
func (n *NetworkInstance_PolicyForwarding_InterfacePath) ApplyVrfSelectionPolicy() *NetworkInstance_PolicyForwarding_Interface_ApplyVrfSelectionPolicyPath {
	return &NetworkInstance_PolicyForwarding_Interface_ApplyVrfSelectionPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "apply-vrf-selection-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyVrfSelectionPolicy (leaf): Apply the specific VRF selection policy on the interface. The referenced policy
// MUST be of type VRF_SELECTION_POLICY. The VRF selection policy may coexist with
// a policy-forwarding policy.
//
// The policy specified in this leaf is used to specifically choose the L3VRF network
// instance that is used for specific input criteria of packets.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/apply-vrf-selection-policy"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/config/apply-vrf-selection-policy"
func (n *NetworkInstance_PolicyForwarding_InterfacePathAny) ApplyVrfSelectionPolicy() *NetworkInstance_PolicyForwarding_Interface_ApplyVrfSelectionPolicyPathAny {
	return &NetworkInstance_PolicyForwarding_Interface_ApplyVrfSelectionPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "apply-vrf-selection-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): A unique identifier for the interface.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/config/interface-id"
func (n *NetworkInstance_PolicyForwarding_InterfacePath) InterfaceId() *NetworkInstance_PolicyForwarding_Interface_InterfaceIdPath {
	return &NetworkInstance_PolicyForwarding_Interface_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): A unique identifier for the interface.
// ----------------------------------------
// Defining module: "openconfig-pf-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/config/interface-id"
func (n *NetworkInstance_PolicyForwarding_InterfacePathAny) InterfaceId() *NetworkInstance_PolicyForwarding_Interface_InterfaceIdPathAny {
	return &NetworkInstance_PolicyForwarding_Interface_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref"
func (n *NetworkInstance_PolicyForwarding_InterfacePath) InterfaceRef() *NetworkInstance_PolicyForwarding_Interface_InterfaceRefPath {
	return &NetworkInstance_PolicyForwarding_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref"
func (n *NetworkInstance_PolicyForwarding_InterfacePathAny) InterfaceRef() *NetworkInstance_PolicyForwarding_Interface_InterfaceRefPathAny {
	return &NetworkInstance_PolicyForwarding_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_PolicyForwarding_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_PolicyForwarding_Interface_InterfaceRefPath) Interface() *NetworkInstance_PolicyForwarding_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_PolicyForwarding_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_PolicyForwarding_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_PolicyForwarding_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_PolicyForwarding_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_PolicyForwarding_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_PolicyForwarding_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_PolicyForwarding_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/policy-forwarding/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_PolicyForwarding_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_PolicyForwarding_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_PolicyForwarding_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_PathSelectionGroupPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group YANG schema element.
type NetworkInstance_PolicyForwarding_PathSelectionGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group YANG schema element.
type NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_PathSelectionGroup_GroupIdPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group/config/group-id YANG schema element.
type NetworkInstance_PolicyForwarding_PathSelectionGroup_GroupIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_PathSelectionGroup_GroupIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group/config/group-id YANG schema element.
type NetworkInstance_PolicyForwarding_PathSelectionGroup_GroupIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_PathSelectionGroup_MplsLspPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group/config/mpls-lsp YANG schema element.
type NetworkInstance_PolicyForwarding_PathSelectionGroup_MplsLspPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_PathSelectionGroup_MplsLspPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group/config/mpls-lsp YANG schema element.
type NetworkInstance_PolicyForwarding_PathSelectionGroup_MplsLspPathAny struct {
	*ygot.NodePath
}

// GroupId (leaf): A unique name for the path-selection-group
// ----------------------------------------
// Defining module: "openconfig-pf-path-groups"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/group-id"
// Path from root: "/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group/config/group-id"
func (n *NetworkInstance_PolicyForwarding_PathSelectionGroupPath) GroupId() *NetworkInstance_PolicyForwarding_PathSelectionGroup_GroupIdPath {
	return &NetworkInstance_PolicyForwarding_PathSelectionGroup_GroupIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "group-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// GroupId (leaf): A unique name for the path-selection-group
// ----------------------------------------
// Defining module: "openconfig-pf-path-groups"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/group-id"
// Path from root: "/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group/config/group-id"
func (n *NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny) GroupId() *NetworkInstance_PolicyForwarding_PathSelectionGroup_GroupIdPathAny {
	return &NetworkInstance_PolicyForwarding_PathSelectionGroup_GroupIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "group-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLsp (leaf): A set of MPLS constrained-path LSPs which should be
// considered for the policy forwarding next-hop. In order to
// select between the LSPs within the path-selection-group, the
// system should determine which LSP provides the best path to
// the next-hop for the routed packet.
// ----------------------------------------
// Defining module: "openconfig-pf-path-groups"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mpls-lsp"
// Path from root: "/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group/config/mpls-lsp"
func (n *NetworkInstance_PolicyForwarding_PathSelectionGroupPath) MplsLsp() *NetworkInstance_PolicyForwarding_PathSelectionGroup_MplsLspPath {
	return &NetworkInstance_PolicyForwarding_PathSelectionGroup_MplsLspPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mpls-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLsp (leaf): A set of MPLS constrained-path LSPs which should be
// considered for the policy forwarding next-hop. In order to
// select between the LSPs within the path-selection-group, the
// system should determine which LSP provides the best path to
// the next-hop for the routed packet.
// ----------------------------------------
// Defining module: "openconfig-pf-path-groups"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mpls-lsp"
// Path from root: "/network-instances/network-instance/policy-forwarding/path-selection-groups/path-selection-group/config/mpls-lsp"
func (n *NetworkInstance_PolicyForwarding_PathSelectionGroupPathAny) MplsLsp() *NetworkInstance_PolicyForwarding_PathSelectionGroup_MplsLspPathAny {
	return &NetworkInstance_PolicyForwarding_PathSelectionGroup_MplsLspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mpls-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_PolicyPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy YANG schema element.
type NetworkInstance_PolicyForwarding_PolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_PolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy YANG schema element.
type NetworkInstance_PolicyForwarding_PolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_PolicyIdPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/config/policy-id YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_PolicyIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_PolicyIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/config/policy-id YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_PolicyIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_TypePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/config/type YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/config/type YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_TypePathAny struct {
	*ygot.NodePath
}

// PolicyId (leaf): A unique name identifying the forwarding policy. This name is
// used when applying the policy to a particular interface.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/policy-id"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/config/policy-id"
func (n *NetworkInstance_PolicyForwarding_PolicyPath) PolicyId() *NetworkInstance_PolicyForwarding_Policy_PolicyIdPath {
	return &NetworkInstance_PolicyForwarding_Policy_PolicyIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "policy-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PolicyId (leaf): A unique name identifying the forwarding policy. This name is
// used when applying the policy to a particular interface.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/policy-id"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/config/policy-id"
func (n *NetworkInstance_PolicyForwarding_PolicyPathAny) PolicyId() *NetworkInstance_PolicyForwarding_Policy_PolicyIdPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_PolicyIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "policy-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RuleAny (list): A match rule for the policy. In the case that multiple
// criteria are specified within a single rule, all criteria
// must be met for the rule to be applied to a packet.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rules/rule"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule"
// SequenceId (wildcarded): uint32
func (n *NetworkInstance_PolicyForwarding_PolicyPath) RuleAny() *NetworkInstance_PolicyForwarding_Policy_RulePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_RulePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rules", "rule"},
			map[string]interface{}{"sequence-id": "*"},
			n,
		),
	}
}

// RuleAny (list): A match rule for the policy. In the case that multiple
// criteria are specified within a single rule, all criteria
// must be met for the rule to be applied to a packet.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rules/rule"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule"
// SequenceId (wildcarded): uint32
func (n *NetworkInstance_PolicyForwarding_PolicyPathAny) RuleAny() *NetworkInstance_PolicyForwarding_Policy_RulePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_RulePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rules", "rule"},
			map[string]interface{}{"sequence-id": "*"},
			n,
		),
	}
}

// Rule (list): A match rule for the policy. In the case that multiple
// criteria are specified within a single rule, all criteria
// must be met for the rule to be applied to a packet.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rules/rule"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule"
// SequenceId: uint32
func (n *NetworkInstance_PolicyForwarding_PolicyPath) Rule(SequenceId uint32) *NetworkInstance_PolicyForwarding_Policy_RulePath {
	return &NetworkInstance_PolicyForwarding_Policy_RulePath{
		NodePath: ygot.NewNodePath(
			[]string{"rules", "rule"},
			map[string]interface{}{"sequence-id": SequenceId},
			n,
		),
	}
}

// Rule (list): A match rule for the policy. In the case that multiple
// criteria are specified within a single rule, all criteria
// must be met for the rule to be applied to a packet.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rules/rule"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule"
// SequenceId: uint32
func (n *NetworkInstance_PolicyForwarding_PolicyPathAny) Rule(SequenceId uint32) *NetworkInstance_PolicyForwarding_Policy_RulePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_RulePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rules", "rule"},
			map[string]interface{}{"sequence-id": SequenceId},
			n,
		),
	}
}

// Type (leaf): The type of the policy. By default policies are generally usable for policy-based
// routing, and have no restrictions on their implementation. Where there are alternate
// policy types, this leaf specifies that a policy is expected to conform with a subset
// of the functionality as described in the specified type.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/config/type"
func (n *NetworkInstance_PolicyForwarding_PolicyPath) Type() *NetworkInstance_PolicyForwarding_Policy_TypePath {
	return &NetworkInstance_PolicyForwarding_Policy_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the policy. By default policies are generally usable for policy-based
// routing, and have no restrictions on their implementation. Where there are alternate
// policy types, this leaf specifies that a policy is expected to conform with a subset
// of the functionality as described in the specified type.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/type"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/config/type"
func (n *NetworkInstance_PolicyForwarding_PolicyPathAny) Type() *NetworkInstance_PolicyForwarding_Policy_TypePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_Policy_RulePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_RulePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_RulePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_RulePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_MatchedOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/state/matched-octets YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_MatchedOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_MatchedOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/state/matched-octets YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_MatchedOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_MatchedPktsPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/state/matched-pkts YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_MatchedPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_MatchedPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/state/matched-pkts YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_MatchedPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_SequenceIdPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/config/sequence-id YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_SequenceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_SequenceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/config/sequence-id YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_SequenceIdPathAny struct {
	*ygot.NodePath
}

// Action (container): The forwarding policy action to be applied for
// packets matching the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "action"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePath) Action() *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath{
		NodePath: ygot.NewNodePath(
			[]string{"action"},
			map[string]interface{}{},
			n,
		),
	}
}

// Action (container): The forwarding policy action to be applied for
// packets matching the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "action"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePathAny) Action() *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"action"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4 (container): Top level container for IPv4 match field data
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePath) Ipv4() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4 (container): Top level container for IPv4 match field data
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePathAny) Ipv4() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6 (container): Top-level container for IPv6 match field data
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePath) Ipv6() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6 (container): Top-level container for IPv6 match field data
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePathAny) Ipv6() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2 (container): Ethernet header fields
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePath) L2() *NetworkInstance_PolicyForwarding_Policy_Rule_L2Path {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2Path{
		NodePath: ygot.NewNodePath(
			[]string{"l2"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2 (container): Ethernet header fields
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePathAny) L2() *NetworkInstance_PolicyForwarding_Policy_Rule_L2PathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedOctets (leaf): Bytes matched by the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/matched-octets"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/state/matched-octets"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePath) MatchedOctets() *NetworkInstance_PolicyForwarding_Policy_Rule_MatchedOctetsPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_MatchedOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedOctets (leaf): Bytes matched by the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/matched-octets"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/state/matched-octets"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePathAny) MatchedOctets() *NetworkInstance_PolicyForwarding_Policy_Rule_MatchedOctetsPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_MatchedOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedPkts (leaf): Number of packets matched by the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/matched-pkts"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/state/matched-pkts"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePath) MatchedPkts() *NetworkInstance_PolicyForwarding_Policy_Rule_MatchedPktsPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_MatchedPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchedPkts (leaf): Number of packets matched by the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/matched-pkts"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/state/matched-pkts"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePathAny) MatchedPkts() *NetworkInstance_PolicyForwarding_Policy_Rule_MatchedPktsPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_MatchedPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "matched-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceId (leaf): Unique sequence number for the policy rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sequence-id"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/config/sequence-id"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePath) SequenceId() *NetworkInstance_PolicyForwarding_Policy_Rule_SequenceIdPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_SequenceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sequence-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceId (leaf): Unique sequence number for the policy rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sequence-id"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/config/sequence-id"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePathAny) SequenceId() *NetworkInstance_PolicyForwarding_Policy_Rule_SequenceIdPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_SequenceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sequence-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): Transport fields container
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transport"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePath) Transport() *NetworkInstance_PolicyForwarding_Policy_Rule_TransportPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_TransportPath{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): Transport fields container
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transport"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport"
func (n *NetworkInstance_PolicyForwarding_Policy_RulePathAny) Transport() *NetworkInstance_PolicyForwarding_Policy_Rule_TransportPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_TransportPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGrePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-gre YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGrePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-gre YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGrePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGuePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-gue YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGuePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-gue YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateMplsInUdpPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-mpls-in-udp YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateMplsInUdpPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateMplsInUdpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-mpls-in-udp YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateMplsInUdpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_DiscardPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/discard YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_DiscardPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_DiscardPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/discard YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_DiscardPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_NetworkInstancePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/network-instance YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_NetworkInstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_NetworkInstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/network-instance YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_NetworkInstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/next-hop YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/next-hop YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_PathSelectionGroupPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/path-selection-group YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_PathSelectionGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_PathSelectionGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/path-selection-group YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_PathSelectionGroupPathAny struct {
	*ygot.NodePath
}

// DecapsulateGre (leaf): When this leaf is set to true, the local system should remove
// the GRE header from the packet matching the rule. Following
// the decapsulation it should subsequently forward the
// encapsulated packet according to the relevant lookup (e.g., if
// the encapsulated packet is IP, the packet should be routed
// according to the IP destination).
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/decapsulate-gre"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-gre"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath) DecapsulateGre() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGrePath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGrePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "decapsulate-gre"},
			map[string]interface{}{},
			n,
		),
	}
}

// DecapsulateGre (leaf): When this leaf is set to true, the local system should remove
// the GRE header from the packet matching the rule. Following
// the decapsulation it should subsequently forward the
// encapsulated packet according to the relevant lookup (e.g., if
// the encapsulated packet is IP, the packet should be routed
// according to the IP destination).
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/decapsulate-gre"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-gre"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny) DecapsulateGre() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGrePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "decapsulate-gre"},
			map[string]interface{}{},
			n,
		),
	}
}

// DecapsulateGue (leaf): When this leaf is set to true, the local system should remove
// the Generic UDP Encapsulation (GUE) header from the packet matching
// the rule. Following the decapsulation it should subsequently forward the
// encapsulated packet according to the underlying IPv4 or IPv6 header.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/decapsulate-gue"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-gue"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath) DecapsulateGue() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGuePath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGuePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "decapsulate-gue"},
			map[string]interface{}{},
			n,
		),
	}
}

// DecapsulateGue (leaf): When this leaf is set to true, the local system should remove
// the Generic UDP Encapsulation (GUE) header from the packet matching
// the rule. Following the decapsulation it should subsequently forward the
// encapsulated packet according to the underlying IPv4 or IPv6 header.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/decapsulate-gue"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-gue"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny) DecapsulateGue() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGuePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateGuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "decapsulate-gue"},
			map[string]interface{}{},
			n,
		),
	}
}

// DecapsulateMplsInUdp (leaf): When this leaf is set to true, the local system should remove
// the UDP header from the packet matching the rule.
// Following the decapsulation it should subsequently forward the
// encapsulated packet according to the underlying MPLS label.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/decapsulate-mpls-in-udp"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-mpls-in-udp"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath) DecapsulateMplsInUdp() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateMplsInUdpPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateMplsInUdpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "decapsulate-mpls-in-udp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DecapsulateMplsInUdp (leaf): When this leaf is set to true, the local system should remove
// the UDP header from the packet matching the rule.
// Following the decapsulation it should subsequently forward the
// encapsulated packet according to the underlying MPLS label.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/decapsulate-mpls-in-udp"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/decapsulate-mpls-in-udp"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny) DecapsulateMplsInUdp() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateMplsInUdpPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_DecapsulateMplsInUdpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "decapsulate-mpls-in-udp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Discard (leaf): When this leaf is set to true, the local system should drop
// packets that match the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/discard"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/discard"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath) Discard() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_DiscardPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_DiscardPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// Discard (leaf): When this leaf is set to true, the local system should drop
// packets that match the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/discard"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/discard"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny) Discard() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_DiscardPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_DiscardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// EncapsulateGre (container): Packets matching the policy rule should be GRE encapsulated
// towards the set of targets defined within the target list. Where
// more than one target is specified, or the target subnet expands
// to more than one endpoint, packets should be load-balanced across
// the destination addresses within the subnets.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "encapsulate-gre"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath) EncapsulateGre() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePath{
		NodePath: ygot.NewNodePath(
			[]string{"encapsulate-gre"},
			map[string]interface{}{},
			n,
		),
	}
}

// EncapsulateGre (container): Packets matching the policy rule should be GRE encapsulated
// towards the set of targets defined within the target list. Where
// more than one target is specified, or the target subnet expands
// to more than one endpoint, packets should be load-balanced across
// the destination addresses within the subnets.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "encapsulate-gre"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny) EncapsulateGre() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"encapsulate-gre"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance (leaf): When this leaf is set, packets matching the match criteria
// for the forwarding rule should be looked up in the
// network-instance that is referenced rather than the
// network-instance with which the interface is associated.
// Such configuration allows policy-routing into multiple
// sub-topologies from a single ingress access interface, or
// different send and receive contexts for a particular
// interface (sometimes referred to as half-duplex VRF).
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/network-instance"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/network-instance"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath) NetworkInstance() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_NetworkInstancePath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_NetworkInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance (leaf): When this leaf is set, packets matching the match criteria
// for the forwarding rule should be looked up in the
// network-instance that is referenced rather than the
// network-instance with which the interface is associated.
// Such configuration allows policy-routing into multiple
// sub-topologies from a single ingress access interface, or
// different send and receive contexts for a particular
// interface (sometimes referred to as half-duplex VRF).
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/network-instance"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/network-instance"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny) NetworkInstance() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_NetworkInstancePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_NetworkInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "network-instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): When an IP next-hop is specified in the next-hop field,
// packets matching the match criteria for the forwarding rule
// should be forwarded to the next-hop IP address, bypassing any
// lookup on the local system.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/next-hop"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath) NextHop() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_NextHopPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): When an IP next-hop is specified in the next-hop field,
// packets matching the match criteria for the forwarding rule
// should be forwarded to the next-hop IP address, bypassing any
// lookup on the local system.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/next-hop"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny) NextHop() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_NextHopPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathSelectionGroup (leaf): When path-selection-group is set, packets matching the
// match criteria for the forwarding rule should be forwarded
// only via one of the paths that is specified within the
// referenced path-selection-group. The next-hop of the packet
// within the routing context should be used to determine between
// multiple paths that are specified within the group.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-selection-group"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/path-selection-group"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPath) PathSelectionGroup() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_PathSelectionGroupPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_PathSelectionGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-selection-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathSelectionGroup (leaf): When path-selection-group is set, packets matching the
// match criteria for the forwarding rule should be forwarded
// only via one of the paths that is specified within the
// referenced path-selection-group. The next-hop of the packet
// within the routing context should be used to determine between
// multiple paths that are specified within the group.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/path-selection-group"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/config/path-selection-group"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_ActionPathAny) PathSelectionGroup() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_PathSelectionGroupPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_PathSelectionGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "path-selection-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_IdentifyingPrefixPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/config/identifying-prefix YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_IdentifyingPrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_IdentifyingPrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/config/identifying-prefix YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_IdentifyingPrefixPathAny struct {
	*ygot.NodePath
}

// IdentifyingPrefix (leaf): An IP prefix that can be used to identify the group of
// GRE endpoints that are being encapsulated towards. Systems
// that require an IP identifier for the tunnel set
// should use this prefix as the next-hop identifier.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/identifying-prefix"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/config/identifying-prefix"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePath) IdentifyingPrefix() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_IdentifyingPrefixPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_IdentifyingPrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "identifying-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// IdentifyingPrefix (leaf): An IP prefix that can be used to identify the group of
// GRE endpoints that are being encapsulated towards. Systems
// that require an IP identifier for the tunnel set
// should use this prefix as the next-hop identifier.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/identifying-prefix"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/config/identifying-prefix"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePathAny) IdentifyingPrefix() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_IdentifyingPrefixPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_IdentifyingPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "identifying-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetAny (list): Each target specified within this list should be treated as a
// endpoint to which packets should be GRE encapsulated. Where the
// set of destinations described within a single entry expands to
// more than one destination IP address, packets should be load
// shared across the destination using the local system's ECMP hashing
// mechanisms.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targets/target"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target"
// Id (wildcarded): string
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePath) TargetAny() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"targets", "target"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// TargetAny (list): Each target specified within this list should be treated as a
// endpoint to which packets should be GRE encapsulated. Where the
// set of destinations described within a single entry expands to
// more than one destination IP address, packets should be load
// shared across the destination using the local system's ECMP hashing
// mechanisms.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targets/target"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target"
// Id (wildcarded): string
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePathAny) TargetAny() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"targets", "target"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Target (list): Each target specified within this list should be treated as a
// endpoint to which packets should be GRE encapsulated. Where the
// set of destinations described within a single entry expands to
// more than one destination IP address, packets should be load
// shared across the destination using the local system's ECMP hashing
// mechanisms.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targets/target"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target"
// Id: string
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePath) Target(Id string) *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPath{
		NodePath: ygot.NewNodePath(
			[]string{"targets", "target"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Target (list): Each target specified within this list should be treated as a
// endpoint to which packets should be GRE encapsulated. Where the
// set of destinations described within a single entry expands to
// more than one destination IP address, packets should be load
// shared across the destination using the local system's ECMP hashing
// mechanisms.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "targets/target"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target"
// Id: string
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGrePathAny) Target(Id string) *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"targets", "target"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_DestinationPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/destination YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_DestinationPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_DestinationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/destination YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_DestinationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IdPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/id YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/id YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IpTtlPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/ip-ttl YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IpTtlPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IpTtlPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/ip-ttl YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IpTtlPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_SourcePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/source YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_SourcePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_SourcePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/source YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_SourcePathAny struct {
	*ygot.NodePath
}

// Destination (leaf): The set of destination addresses that should be encapsulated towards.
// Where a subnet is specified, each address within the subnet should be
// treated as an independent destination for encapsulated traffic. Packets
// should be distributed with ECMP across the set of tunnel destination
// addresses.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/destination"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPath) Destination() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_DestinationPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_DestinationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination"},
			map[string]interface{}{},
			n,
		),
	}
}

// Destination (leaf): The set of destination addresses that should be encapsulated towards.
// Where a subnet is specified, each address within the subnet should be
// treated as an independent destination for encapsulated traffic. Packets
// should be distributed with ECMP across the set of tunnel destination
// addresses.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/destination"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny) Destination() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_DestinationPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_DestinationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique identifier for the target.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/id"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/id"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPath) Id() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IdPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique identifier for the target.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/id"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/id"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny) Id() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IdPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpTtl (leaf): The TTL that should be specified in the IP header of the GRE packet
// encapsulating the packet matching the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ip-ttl"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/ip-ttl"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPath) IpTtl() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IpTtlPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IpTtlPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpTtl (leaf): The TTL that should be specified in the IP header of the GRE packet
// encapsulating the packet matching the rule.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ip-ttl"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/ip-ttl"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny) IpTtl() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IpTtlPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_IpTtlPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// Source (leaf): The source IP address that should be used when encapsulating
// packets from the local system.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/source"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPath) Source() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_SourcePath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_SourcePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// Source (leaf): The source IP address that should be used when encapsulating
// packets from the local system.
// ----------------------------------------
// Defining module: "openconfig-pf-forwarding-policies"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/action/encapsulate-gre/targets/target/config/source"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_TargetPathAny) Source() *NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_SourcePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Action_EncapsulateGre_Target_SourcePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4 YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4 YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DestinationAddressPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/destination-address YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DestinationAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DestinationAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/destination-address YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DestinationAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/dscp YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/dscp YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpSetPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/dscp-set YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpSetPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpSetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/dscp-set YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpSetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_HopLimitPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/hop-limit YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_HopLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_HopLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/hop-limit YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_HopLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_ProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/protocol YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_ProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_ProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/protocol YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_ProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_SourceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/source-address YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_SourceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_SourceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/source-address YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_SourceAddressPathAny struct {
	*ygot.NodePath
}

// DestinationAddress (leaf): Destination IPv4 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-address"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/destination-address"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path) DestinationAddress() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DestinationAddressPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DestinationAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationAddress (leaf): Destination IPv4 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-address"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/destination-address"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny) DestinationAddress() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DestinationAddressPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DestinationAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dscp (leaf): Value of diffserv codepoint.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dscp"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/dscp"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path) Dscp() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dscp (leaf): Value of diffserv codepoint.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dscp"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/dscp"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny) Dscp() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DscpSet (leaf): A list of DSCP values to be matched for incoming packets. AN OR match should
// be performed, such that a packet must match one of the values defined in this
// list. If the field is left empty then any DSCP value matches unless the 'dscp'
// leaf is specified. It is not valid to specify both 'dscp' and 'dscp-set together.'
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dscp-set"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/dscp-set"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path) DscpSet() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpSetPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// DscpSet (leaf): A list of DSCP values to be matched for incoming packets. AN OR match should
// be performed, such that a packet must match one of the values defined in this
// list. If the field is left empty then any DSCP value matches unless the 'dscp'
// leaf is specified. It is not valid to specify both 'dscp' and 'dscp-set together.'
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dscp-set"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/dscp-set"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny) DscpSet() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpSetPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_DscpSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopLimit (leaf): The IP packet's hop limit -- known as TTL (in hops) in
// IPv4 packets, and hop limit in IPv6
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hop-limit"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/hop-limit"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path) HopLimit() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_HopLimitPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_HopLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopLimit (leaf): The IP packet's hop limit -- known as TTL (in hops) in
// IPv4 packets, and hop limit in IPv6
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hop-limit"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/hop-limit"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny) HopLimit() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_HopLimitPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_HopLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): The protocol carried in the IP packet, expressed either
// as its IP protocol number, or by a defined identity.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protocol"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/protocol"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path) Protocol() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_ProtocolPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_ProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): The protocol carried in the IP packet, expressed either
// as its IP protocol number, or by a defined identity.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protocol"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/protocol"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny) Protocol() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_ProtocolPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IPv4 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-address"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/source-address"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4Path) SourceAddress() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_SourceAddressPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_SourceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IPv4 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-address"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv4/config/source-address"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4PathAny) SourceAddress() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_SourceAddressPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv4_SourceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6 YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6 YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationAddressPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/destination-address YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/destination-address YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationFlowLabelPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/destination-flow-label YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationFlowLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationFlowLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/destination-flow-label YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationFlowLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/dscp YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/dscp YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpSetPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/dscp-set YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpSetPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpSetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/dscp-set YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpSetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_HopLimitPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/hop-limit YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_HopLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_HopLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/hop-limit YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_HopLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_ProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/protocol YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_ProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_ProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/protocol YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_ProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/source-address YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/source-address YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceFlowLabelPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/source-flow-label YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceFlowLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceFlowLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/source-flow-label YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceFlowLabelPathAny struct {
	*ygot.NodePath
}

// DestinationAddress (leaf): Destination IPv6 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-address"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/destination-address"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path) DestinationAddress() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationAddressPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationAddress (leaf): Destination IPv6 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-address"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/destination-address"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny) DestinationAddress() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationAddressPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationFlowLabel (leaf): Destination IPv6 Flow label.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-flow-label"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/destination-flow-label"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path) DestinationFlowLabel() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationFlowLabelPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationFlowLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-flow-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationFlowLabel (leaf): Destination IPv6 Flow label.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-flow-label"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/destination-flow-label"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny) DestinationFlowLabel() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationFlowLabelPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DestinationFlowLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-flow-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dscp (leaf): Value of diffserv codepoint.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dscp"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/dscp"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path) Dscp() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dscp (leaf): Value of diffserv codepoint.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dscp"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/dscp"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny) Dscp() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DscpSet (leaf): A list of DSCP values to be matched for incoming packets. AN OR match should
// be performed, such that a packet must match one of the values defined in this
// list. If the field is left empty then any DSCP value matches unless the 'dscp'
// leaf is specified. It is not valid to specify both 'dscp' and 'dscp-set together.'
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dscp-set"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/dscp-set"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path) DscpSet() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpSetPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// DscpSet (leaf): A list of DSCP values to be matched for incoming packets. AN OR match should
// be performed, such that a packet must match one of the values defined in this
// list. If the field is left empty then any DSCP value matches unless the 'dscp'
// leaf is specified. It is not valid to specify both 'dscp' and 'dscp-set together.'
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dscp-set"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/dscp-set"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny) DscpSet() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpSetPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_DscpSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dscp-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopLimit (leaf): The IP packet's hop limit -- known as TTL (in hops) in
// IPv4 packets, and hop limit in IPv6
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hop-limit"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/hop-limit"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path) HopLimit() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_HopLimitPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_HopLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// HopLimit (leaf): The IP packet's hop limit -- known as TTL (in hops) in
// IPv4 packets, and hop limit in IPv6
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hop-limit"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/hop-limit"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny) HopLimit() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_HopLimitPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_HopLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hop-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): The protocol carried in the IP packet, expressed either
// as its IP protocol number, or by a defined identity.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protocol"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/protocol"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path) Protocol() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_ProtocolPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_ProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): The protocol carried in the IP packet, expressed either
// as its IP protocol number, or by a defined identity.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protocol"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/protocol"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny) Protocol() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_ProtocolPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IPv6 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-address"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/source-address"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path) SourceAddress() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceAddressPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IPv6 address prefix.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-address"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/source-address"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny) SourceAddress() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceAddressPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceFlowLabel (leaf): Source IPv6 Flow label.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-flow-label"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/source-flow-label"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6Path) SourceFlowLabel() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceFlowLabelPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceFlowLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-flow-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceFlowLabel (leaf): Source IPv6 Flow label.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-flow-label"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/ipv6/config/source-flow-label"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6PathAny) SourceFlowLabel() *NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceFlowLabelPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Ipv6_SourceFlowLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-flow-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2Path represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2 YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2Path struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2 YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/destination-mac YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/destination-mac YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacMaskPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/destination-mac-mask YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacMaskPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacMaskPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/destination-mac-mask YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacMaskPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_EthertypePath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/ethertype YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_EthertypePath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_EthertypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/ethertype YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_EthertypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/source-mac YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/source-mac YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacMaskPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/source-mac-mask YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacMaskPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacMaskPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/source-mac-mask YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacMaskPathAny struct {
	*ygot.NodePath
}

// DestinationMac (leaf): Destination IEEE 802 MAC address.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-mac"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/destination-mac"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2Path) DestinationMac() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationMac (leaf): Destination IEEE 802 MAC address.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-mac"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/destination-mac"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2PathAny) DestinationMac() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationMacMask (leaf): Destination IEEE 802 MAC address mask.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-mac-mask"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/destination-mac-mask"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2Path) DestinationMacMask() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacMaskPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacMaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-mac-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationMacMask (leaf): Destination IEEE 802 MAC address mask.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-mac-mask"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/destination-mac-mask"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2PathAny) DestinationMacMask() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacMaskPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_DestinationMacMaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-mac-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ethertype (leaf): Ethertype field to match in Ethernet packets
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ethertype"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/ethertype"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2Path) Ethertype() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_EthertypePath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_EthertypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ethertype"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ethertype (leaf): Ethertype field to match in Ethernet packets
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ethertype"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/ethertype"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2PathAny) Ethertype() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_EthertypePathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_EthertypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ethertype"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceMac (leaf): Source IEEE 802 MAC address.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-mac"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/source-mac"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2Path) SourceMac() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceMac (leaf): Source IEEE 802 MAC address.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-mac"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/source-mac"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2PathAny) SourceMac() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-mac"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceMacMask (leaf): Source IEEE 802 MAC address mask.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-mac-mask"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/source-mac-mask"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2Path) SourceMacMask() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacMaskPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacMaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-mac-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceMacMask (leaf): Source IEEE 802 MAC address mask.
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-mac-mask"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/l2/config/source-mac-mask"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_L2PathAny) SourceMacMask() *NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacMaskPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_L2_SourceMacMaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-mac-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_PolicyForwarding_Policy_Rule_TransportPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_TransportPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_TransportPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_TransportPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Transport_DestinationPortPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/destination-port YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Transport_DestinationPortPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Transport_DestinationPortPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/destination-port YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Transport_DestinationPortPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Transport_SourcePortPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/source-port YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Transport_SourcePortPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Transport_SourcePortPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/source-port YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Transport_SourcePortPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Transport_TcpFlagsPath represents the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/tcp-flags YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Transport_TcpFlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_PolicyForwarding_Policy_Rule_Transport_TcpFlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/tcp-flags YANG schema element.
type NetworkInstance_PolicyForwarding_Policy_Rule_Transport_TcpFlagsPathAny struct {
	*ygot.NodePath
}

// DestinationPort (leaf): Destination port or range
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-port"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/destination-port"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_TransportPath) DestinationPort() *NetworkInstance_PolicyForwarding_Policy_Rule_Transport_DestinationPortPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Transport_DestinationPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// DestinationPort (leaf): Destination port or range
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/destination-port"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/destination-port"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_TransportPathAny) DestinationPort() *NetworkInstance_PolicyForwarding_Policy_Rule_Transport_DestinationPortPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Transport_DestinationPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "destination-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourcePort (leaf): Source port or range
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-port"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/source-port"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_TransportPath) SourcePort() *NetworkInstance_PolicyForwarding_Policy_Rule_Transport_SourcePortPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Transport_SourcePortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourcePort (leaf): Source port or range
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source-port"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/source-port"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_TransportPathAny) SourcePort() *NetworkInstance_PolicyForwarding_Policy_Rule_Transport_SourcePortPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Transport_SourcePortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// TcpFlags (leaf): List of TCP flags to match
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/tcp-flags"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/tcp-flags"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_TransportPath) TcpFlags() *NetworkInstance_PolicyForwarding_Policy_Rule_Transport_TcpFlagsPath {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Transport_TcpFlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tcp-flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// TcpFlags (leaf): List of TCP flags to match
// ----------------------------------------
// Defining module: "openconfig-packet-match"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/tcp-flags"
// Path from root: "/network-instances/network-instance/policy-forwarding/policies/policy/rules/rule/transport/config/tcp-flags"
func (n *NetworkInstance_PolicyForwarding_Policy_Rule_TransportPathAny) TcpFlags() *NetworkInstance_PolicyForwarding_Policy_Rule_Transport_TcpFlagsPathAny {
	return &NetworkInstance_PolicyForwarding_Policy_Rule_Transport_TcpFlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tcp-flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_ProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol YANG schema element.
type NetworkInstance_ProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_ProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol YANG schema element.
type NetworkInstance_ProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_DefaultMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/config/default-metric YANG schema element.
type NetworkInstance_Protocol_DefaultMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_DefaultMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/config/default-metric YANG schema element.
type NetworkInstance_Protocol_DefaultMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/config/enabled YANG schema element.
type NetworkInstance_Protocol_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/config/enabled YANG schema element.
type NetworkInstance_Protocol_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_IdentifierPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/config/identifier YANG schema element.
type NetworkInstance_Protocol_IdentifierPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_IdentifierPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/config/identifier YANG schema element.
type NetworkInstance_Protocol_IdentifierPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_NamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/config/name YANG schema element.
type NetworkInstance_Protocol_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/config/name YANG schema element.
type NetworkInstance_Protocol_NamePathAny struct {
	*ygot.NodePath
}

// AggregateAny (list): List of aggregates
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "local-aggregates/aggregate"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate"
// Prefix (wildcarded): string
func (n *NetworkInstance_ProtocolPath) AggregateAny() *NetworkInstance_Protocol_AggregatePathAny {
	return &NetworkInstance_Protocol_AggregatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"local-aggregates", "aggregate"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// AggregateAny (list): List of aggregates
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "local-aggregates/aggregate"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate"
// Prefix (wildcarded): string
func (n *NetworkInstance_ProtocolPathAny) AggregateAny() *NetworkInstance_Protocol_AggregatePathAny {
	return &NetworkInstance_Protocol_AggregatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"local-aggregates", "aggregate"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Aggregate (list): List of aggregates
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "local-aggregates/aggregate"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate"
// Prefix: string
func (n *NetworkInstance_ProtocolPath) Aggregate(Prefix string) *NetworkInstance_Protocol_AggregatePath {
	return &NetworkInstance_Protocol_AggregatePath{
		NodePath: ygot.NewNodePath(
			[]string{"local-aggregates", "aggregate"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Aggregate (list): List of aggregates
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "local-aggregates/aggregate"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate"
// Prefix: string
func (n *NetworkInstance_ProtocolPathAny) Aggregate(Prefix string) *NetworkInstance_Protocol_AggregatePathAny {
	return &NetworkInstance_Protocol_AggregatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"local-aggregates", "aggregate"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Bgp (container): Top-level configuration and state for the BGP router
// ----------------------------------------
// Defining module: "openconfig-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp"
func (n *NetworkInstance_ProtocolPath) Bgp() *NetworkInstance_Protocol_BgpPath {
	return &NetworkInstance_Protocol_BgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"bgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bgp (container): Top-level configuration and state for the BGP router
// ----------------------------------------
// Defining module: "openconfig-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp"
func (n *NetworkInstance_ProtocolPathAny) Bgp() *NetworkInstance_Protocol_BgpPathAny {
	return &NetworkInstance_Protocol_BgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultMetric (leaf): The default metric within the RIB for entries that are
// installed by this protocol instance. This value may
// be overridden by protocol specific configuration options.
// The lower the metric specified the more preferable the RIB
// entry is to be selected for use within the network instance.
// Where multiple entries have the same metric value then these
// equal cost paths should be treated according to the specified
// ECMP path selection behaviour for the instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/config/default-metric"
func (n *NetworkInstance_ProtocolPath) DefaultMetric() *NetworkInstance_Protocol_DefaultMetricPath {
	return &NetworkInstance_Protocol_DefaultMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultMetric (leaf): The default metric within the RIB for entries that are
// installed by this protocol instance. This value may
// be overridden by protocol specific configuration options.
// The lower the metric specified the more preferable the RIB
// entry is to be selected for use within the network instance.
// Where multiple entries have the same metric value then these
// equal cost paths should be treated according to the specified
// ECMP path selection behaviour for the instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/config/default-metric"
func (n *NetworkInstance_ProtocolPathAny) DefaultMetric() *NetworkInstance_Protocol_DefaultMetricPathAny {
	return &NetworkInstance_Protocol_DefaultMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): A boolean value indicating whether the local protocol
// instance is enabled.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/config/enabled"
func (n *NetworkInstance_ProtocolPath) Enabled() *NetworkInstance_Protocol_EnabledPath {
	return &NetworkInstance_Protocol_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): A boolean value indicating whether the local protocol
// instance is enabled.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/config/enabled"
func (n *NetworkInstance_ProtocolPathAny) Enabled() *NetworkInstance_Protocol_EnabledPathAny {
	return &NetworkInstance_Protocol_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Identifier (leaf): The protocol identifier for the instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/config/identifier"
func (n *NetworkInstance_ProtocolPath) Identifier() *NetworkInstance_Protocol_IdentifierPath {
	return &NetworkInstance_Protocol_IdentifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// Identifier (leaf): The protocol identifier for the instance
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/config/identifier"
func (n *NetworkInstance_ProtocolPathAny) Identifier() *NetworkInstance_Protocol_IdentifierPathAny {
	return &NetworkInstance_Protocol_IdentifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// Igmp (container): Top-level IGMP configuration and operational state.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igmp"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp"
func (n *NetworkInstance_ProtocolPath) Igmp() *NetworkInstance_Protocol_IgmpPath {
	return &NetworkInstance_Protocol_IgmpPath{
		NodePath: ygot.NewNodePath(
			[]string{"igmp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Igmp (container): Top-level IGMP configuration and operational state.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igmp"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp"
func (n *NetworkInstance_ProtocolPathAny) Igmp() *NetworkInstance_Protocol_IgmpPathAny {
	return &NetworkInstance_Protocol_IgmpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"igmp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Isis (container): This container defines top-level ISIS configuration and state
// information.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "isis"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis"
func (n *NetworkInstance_ProtocolPath) Isis() *NetworkInstance_Protocol_IsisPath {
	return &NetworkInstance_Protocol_IsisPath{
		NodePath: ygot.NewNodePath(
			[]string{"isis"},
			map[string]interface{}{},
			n,
		),
	}
}

// Isis (container): This container defines top-level ISIS configuration and state
// information.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "isis"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis"
func (n *NetworkInstance_ProtocolPathAny) Isis() *NetworkInstance_Protocol_IsisPathAny {
	return &NetworkInstance_Protocol_IsisPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"isis"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): A unique name for the protocol instance.
//
// If the operator does not designate a name for the protocol
// instance (e.g. config), the implementation should use the
// name of 'DEFAULT' (e.g. state).  In addition, for
// implementations that support single protocol instances, the
// default value is recommended for consistency and uniqueness
// per protocol instance.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/protocols/protocol/config/name"
func (n *NetworkInstance_ProtocolPath) Name() *NetworkInstance_Protocol_NamePath {
	return &NetworkInstance_Protocol_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): A unique name for the protocol instance.
//
// If the operator does not designate a name for the protocol
// instance (e.g. config), the implementation should use the
// name of 'DEFAULT' (e.g. state).  In addition, for
// implementations that support single protocol instances, the
// default value is recommended for consistency and uniqueness
// per protocol instance.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/protocols/protocol/config/name"
func (n *NetworkInstance_ProtocolPathAny) Name() *NetworkInstance_Protocol_NamePathAny {
	return &NetworkInstance_Protocol_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ospfv2 (container): Top-level configuration and operational state for
// Open Shortest Path First (OSPF) v2
// ----------------------------------------
// Defining module: "openconfig-ospfv2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ospfv2"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2"
func (n *NetworkInstance_ProtocolPath) Ospfv2() *NetworkInstance_Protocol_Ospfv2Path {
	return &NetworkInstance_Protocol_Ospfv2Path{
		NodePath: ygot.NewNodePath(
			[]string{"ospfv2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ospfv2 (container): Top-level configuration and operational state for
// Open Shortest Path First (OSPF) v2
// ----------------------------------------
// Defining module: "openconfig-ospfv2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ospfv2"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2"
func (n *NetworkInstance_ProtocolPathAny) Ospfv2() *NetworkInstance_Protocol_Ospfv2PathAny {
	return &NetworkInstance_Protocol_Ospfv2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ospfv2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Pim (container): Top-level PIM configuration and operational state.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "pim"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim"
func (n *NetworkInstance_ProtocolPath) Pim() *NetworkInstance_Protocol_PimPath {
	return &NetworkInstance_Protocol_PimPath{
		NodePath: ygot.NewNodePath(
			[]string{"pim"},
			map[string]interface{}{},
			n,
		),
	}
}

// Pim (container): Top-level PIM configuration and operational state.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "pim"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim"
func (n *NetworkInstance_ProtocolPathAny) Pim() *NetworkInstance_Protocol_PimPathAny {
	return &NetworkInstance_Protocol_PimPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"pim"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaticAny (list): List of locally configured static routes
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-routes/static"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static"
// Prefix (wildcarded): string
func (n *NetworkInstance_ProtocolPath) StaticAny() *NetworkInstance_Protocol_StaticPathAny {
	return &NetworkInstance_Protocol_StaticPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-routes", "static"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// StaticAny (list): List of locally configured static routes
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-routes/static"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static"
// Prefix (wildcarded): string
func (n *NetworkInstance_ProtocolPathAny) StaticAny() *NetworkInstance_Protocol_StaticPathAny {
	return &NetworkInstance_Protocol_StaticPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-routes", "static"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Static (list): List of locally configured static routes
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-routes/static"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static"
// Prefix: string
func (n *NetworkInstance_ProtocolPath) Static(Prefix string) *NetworkInstance_Protocol_StaticPath {
	return &NetworkInstance_Protocol_StaticPath{
		NodePath: ygot.NewNodePath(
			[]string{"static-routes", "static"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Static (list): List of locally configured static routes
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-routes/static"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static"
// Prefix: string
func (n *NetworkInstance_ProtocolPathAny) Static(Prefix string) *NetworkInstance_Protocol_StaticPathAny {
	return &NetworkInstance_Protocol_StaticPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-routes", "static"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// NetworkInstance_Protocol_AggregatePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate YANG schema element.
type NetworkInstance_Protocol_AggregatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_AggregatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate YANG schema element.
type NetworkInstance_Protocol_AggregatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Aggregate_DescriptionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/description YANG schema element.
type NetworkInstance_Protocol_Aggregate_DescriptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Aggregate_DescriptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/description YANG schema element.
type NetworkInstance_Protocol_Aggregate_DescriptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Aggregate_DiscardPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/discard YANG schema element.
type NetworkInstance_Protocol_Aggregate_DiscardPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Aggregate_DiscardPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/discard YANG schema element.
type NetworkInstance_Protocol_Aggregate_DiscardPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Aggregate_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/prefix YANG schema element.
type NetworkInstance_Protocol_Aggregate_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Aggregate_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/prefix YANG schema element.
type NetworkInstance_Protocol_Aggregate_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Aggregate_SetTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/set-tag YANG schema element.
type NetworkInstance_Protocol_Aggregate_SetTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Aggregate_SetTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/set-tag YANG schema element.
type NetworkInstance_Protocol_Aggregate_SetTagPathAny struct {
	*ygot.NodePath
}

// Description (leaf): An optional textual description for the route.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/description"
func (n *NetworkInstance_Protocol_AggregatePath) Description() *NetworkInstance_Protocol_Aggregate_DescriptionPath {
	return &NetworkInstance_Protocol_Aggregate_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): An optional textual description for the route.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/description"
func (n *NetworkInstance_Protocol_AggregatePathAny) Description() *NetworkInstance_Protocol_Aggregate_DescriptionPathAny {
	return &NetworkInstance_Protocol_Aggregate_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Discard (leaf): When true, install the aggregate route with a discard
// next-hop -- traffic destined to the aggregate will be
// discarded with no ICMP message generated.  When false,
// traffic destined to an aggregate address when no
// constituent routes are present will generate an ICMP
// unreachable message.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/discard"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/discard"
func (n *NetworkInstance_Protocol_AggregatePath) Discard() *NetworkInstance_Protocol_Aggregate_DiscardPath {
	return &NetworkInstance_Protocol_Aggregate_DiscardPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// Discard (leaf): When true, install the aggregate route with a discard
// next-hop -- traffic destined to the aggregate will be
// discarded with no ICMP message generated.  When false,
// traffic destined to an aggregate address when no
// constituent routes are present will generate an ICMP
// unreachable message.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/discard"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/discard"
func (n *NetworkInstance_Protocol_AggregatePathAny) Discard() *NetworkInstance_Protocol_Aggregate_DiscardPathAny {
	return &NetworkInstance_Protocol_Aggregate_DiscardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Aggregate prefix to be advertised
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/prefix"
func (n *NetworkInstance_Protocol_AggregatePath) Prefix() *NetworkInstance_Protocol_Aggregate_PrefixPath {
	return &NetworkInstance_Protocol_Aggregate_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Aggregate prefix to be advertised
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/prefix"
func (n *NetworkInstance_Protocol_AggregatePathAny) Prefix() *NetworkInstance_Protocol_Aggregate_PrefixPathAny {
	return &NetworkInstance_Protocol_Aggregate_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (leaf): Set a generic tag value on the route. This tag can be
// used for filtering routes that are distributed to other
// routing protocols.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/set-tag"
func (n *NetworkInstance_Protocol_AggregatePath) SetTag() *NetworkInstance_Protocol_Aggregate_SetTagPath {
	return &NetworkInstance_Protocol_Aggregate_SetTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (leaf): Set a generic tag value on the route. This tag can be
// used for filtering routes that are distributed to other
// routing protocols.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/local-aggregates/aggregate/config/set-tag"
func (n *NetworkInstance_Protocol_AggregatePathAny) SetTag() *NetworkInstance_Protocol_Aggregate_SetTagPathAny {
	return &NetworkInstance_Protocol_Aggregate_SetTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_BgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp YANG schema element.
type NetworkInstance_Protocol_BgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_BgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp YANG schema element.
type NetworkInstance_Protocol_BgpPathAny struct {
	*ygot.NodePath
}

// Global (container): Global configuration for the BGP router
// ----------------------------------------
// Defining module: "openconfig-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global"
func (n *NetworkInstance_Protocol_BgpPath) Global() *NetworkInstance_Protocol_Bgp_GlobalPath {
	return &NetworkInstance_Protocol_Bgp_GlobalPath{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// Global (container): Global configuration for the BGP router
// ----------------------------------------
// Defining module: "openconfig-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global"
func (n *NetworkInstance_Protocol_BgpPathAny) Global() *NetworkInstance_Protocol_Bgp_GlobalPathAny {
	return &NetworkInstance_Protocol_Bgp_GlobalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): List of BGP neighbors configured on the local system,
// uniquely identified by peer IPv[46] address
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_BgpPath) NeighborAny() *NetworkInstance_Protocol_Bgp_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of BGP neighbors configured on the local system,
// uniquely identified by peer IPv[46] address
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_BgpPathAny) NeighborAny() *NetworkInstance_Protocol_Bgp_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// Neighbor (list): List of BGP neighbors configured on the local system,
// uniquely identified by peer IPv[46] address
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_BgpPath) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_NeighborPath {
	return &NetworkInstance_Protocol_Bgp_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// Neighbor (list): List of BGP neighbors configured on the local system,
// uniquely identified by peer IPv[46] address
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_BgpPathAny) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// PeerGroupAny (list): List of BGP peer-groups configured on the local system -
// uniquely identified by peer-group name
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "peer-groups/peer-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group"
// PeerGroupName (wildcarded): string
func (n *NetworkInstance_Protocol_BgpPath) PeerGroupAny() *NetworkInstance_Protocol_Bgp_PeerGroupPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"peer-groups", "peer-group"},
			map[string]interface{}{"peer-group-name": "*"},
			n,
		),
	}
}

// PeerGroupAny (list): List of BGP peer-groups configured on the local system -
// uniquely identified by peer-group name
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "peer-groups/peer-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group"
// PeerGroupName (wildcarded): string
func (n *NetworkInstance_Protocol_BgpPathAny) PeerGroupAny() *NetworkInstance_Protocol_Bgp_PeerGroupPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"peer-groups", "peer-group"},
			map[string]interface{}{"peer-group-name": "*"},
			n,
		),
	}
}

// PeerGroup (list): List of BGP peer-groups configured on the local system -
// uniquely identified by peer-group name
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "peer-groups/peer-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group"
// PeerGroupName: string
func (n *NetworkInstance_Protocol_BgpPath) PeerGroup(PeerGroupName string) *NetworkInstance_Protocol_Bgp_PeerGroupPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"peer-groups", "peer-group"},
			map[string]interface{}{"peer-group-name": PeerGroupName},
			n,
		),
	}
}

// PeerGroup (list): List of BGP peer-groups configured on the local system -
// uniquely identified by peer-group name
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "peer-groups/peer-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group"
// PeerGroupName: string
func (n *NetworkInstance_Protocol_BgpPathAny) PeerGroup(PeerGroupName string) *NetworkInstance_Protocol_Bgp_PeerGroupPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"peer-groups", "peer-group"},
			map[string]interface{}{"peer-group-name": PeerGroupName},
			n,
		),
	}
}

// Rib (container): Top level container for BGP RIBs
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib"
func (n *NetworkInstance_Protocol_BgpPath) Rib() *NetworkInstance_Protocol_Bgp_RibPath {
	return &NetworkInstance_Protocol_Bgp_RibPath{
		NodePath: ygot.NewNodePath(
			[]string{"rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// Rib (container): Top level container for BGP RIBs
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib"
func (n *NetworkInstance_Protocol_BgpPathAny) Rib() *NetworkInstance_Protocol_Bgp_RibPathAny {
	return &NetworkInstance_Protocol_Bgp_RibPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_GlobalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global YANG schema element.
type NetworkInstance_Protocol_Bgp_GlobalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_GlobalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global YANG schema element.
type NetworkInstance_Protocol_Bgp_GlobalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/config/as YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/config/as YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/config/router-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/config/router-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_TotalPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/state/total-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_TotalPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_TotalPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/state/total-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_TotalPathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_TotalPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/state/total-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_TotalPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_TotalPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/state/total-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_TotalPrefixesPathAny struct {
	*ygot.NodePath
}

// AfiSafiAny (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi"
// AfiSafiName (wildcarded): E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) AfiSafiAny() *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": "*"},
			n,
		),
	}
}

// AfiSafiAny (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi"
// AfiSafiName (wildcarded): E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) AfiSafiAny() *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": "*"},
			n,
		),
	}
}

// AfiSafi (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi"
// AfiSafiName: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) AfiSafi(AfiSafiName E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafiPath{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": AfiSafiName},
			n,
		),
	}
}

// AfiSafi (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi"
// AfiSafiName: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) AfiSafi(AfiSafiName E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": AfiSafiName},
			n,
		),
	}
}

// As (leaf): Local autonomous system number of the router.  Uses
// the 32-bit as-number type from the model in RFC 6991.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/config/as"
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) As() *NetworkInstance_Protocol_Bgp_Global_AsPath {
	return &NetworkInstance_Protocol_Bgp_Global_AsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "as"},
			map[string]interface{}{},
			n,
		),
	}
}

// As (leaf): Local autonomous system number of the router.  Uses
// the 32-bit as-number type from the model in RFC 6991.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/config/as"
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) As() *NetworkInstance_Protocol_Bgp_Global_AsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "as"},
			map[string]interface{}{},
			n,
		),
	}
}

// Confederation (container): Parameters indicating whether the local system acts as part
// of a BGP confederation
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "confederation"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/confederation"
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) Confederation() *NetworkInstance_Protocol_Bgp_Global_ConfederationPath {
	return &NetworkInstance_Protocol_Bgp_Global_ConfederationPath{
		NodePath: ygot.NewNodePath(
			[]string{"confederation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Confederation (container): Parameters indicating whether the local system acts as part
// of a BGP confederation
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "confederation"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/confederation"
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) Confederation() *NetworkInstance_Protocol_Bgp_Global_ConfederationPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_ConfederationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"confederation"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultRouteDistance (container): Administrative distance (or preference) assigned to
// routes received from different sources
// (external, internal, and local).
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "default-route-distance"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance"
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) DefaultRouteDistance() *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePath {
	return &NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePath{
		NodePath: ygot.NewNodePath(
			[]string{"default-route-distance"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultRouteDistance (container): Administrative distance (or preference) assigned to
// routes received from different sources
// (external, internal, and local).
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "default-route-distance"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance"
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) DefaultRouteDistance() *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePathAny {
	return &NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"default-route-distance"},
			map[string]interface{}{},
			n,
		),
	}
}

// DynamicNeighborPrefixAny (list): An individual prefix from which dynamic neighbor
// connections are allowed.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "dynamic-neighbor-prefixes/dynamic-neighbor-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) DynamicNeighborPrefixAny() *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dynamic-neighbor-prefixes", "dynamic-neighbor-prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// DynamicNeighborPrefixAny (list): An individual prefix from which dynamic neighbor
// connections are allowed.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "dynamic-neighbor-prefixes/dynamic-neighbor-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) DynamicNeighborPrefixAny() *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dynamic-neighbor-prefixes", "dynamic-neighbor-prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// DynamicNeighborPrefix (list): An individual prefix from which dynamic neighbor
// connections are allowed.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "dynamic-neighbor-prefixes/dynamic-neighbor-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) DynamicNeighborPrefix(Prefix string) *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPath {
	return &NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"dynamic-neighbor-prefixes", "dynamic-neighbor-prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// DynamicNeighborPrefix (list): An individual prefix from which dynamic neighbor
// connections are allowed.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "dynamic-neighbor-prefixes/dynamic-neighbor-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) DynamicNeighborPrefix(Prefix string) *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dynamic-neighbor-prefixes", "dynamic-neighbor-prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating the graceful restart mechanism for BGP
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) GracefulRestart() *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPath {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating the graceful restart mechanism for BGP
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) GracefulRestart() *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteSelectionOptions (container): Parameters relating to options for route selection
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-selection-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options"
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) RouteSelectionOptions() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"route-selection-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteSelectionOptions (container): Parameters relating to options for route selection
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-selection-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options"
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) RouteSelectionOptions() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"route-selection-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): Router id of the router - an unsigned 32-bit integer
// expressed in dotted quad notation.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/config/router-id"
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) RouterId() *NetworkInstance_Protocol_Bgp_Global_RouterIdPath {
	return &NetworkInstance_Protocol_Bgp_Global_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): Router id of the router - an unsigned 32-bit integer
// expressed in dotted quad notation.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/config/router-id"
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) RouterId() *NetworkInstance_Protocol_Bgp_Global_RouterIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPaths (leaf): Total number of BGP paths within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/state/total-paths"
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) TotalPaths() *NetworkInstance_Protocol_Bgp_Global_TotalPathsPath {
	return &NetworkInstance_Protocol_Bgp_Global_TotalPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPaths (leaf): Total number of BGP paths within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/state/total-paths"
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) TotalPaths() *NetworkInstance_Protocol_Bgp_Global_TotalPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_TotalPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPrefixes (leaf): Total number of BGP prefixes received within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/state/total-prefixes"
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) TotalPrefixes() *NetworkInstance_Protocol_Bgp_Global_TotalPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_TotalPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPrefixes (leaf): Total number of BGP prefixes received within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/state/total-prefixes"
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) TotalPrefixes() *NetworkInstance_Protocol_Bgp_Global_TotalPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_TotalPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple paths for the
// same NLRI
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_GlobalPath) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPath {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple paths for the
// same NLRI
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_GlobalPathAny) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AfiSafiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/config/afi-safi-name YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AfiSafiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AfiSafiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/config/afi-safi-name YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AfiSafiNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/state/total-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/state/total-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/state/total-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/state/total-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPrefixesPathAny struct {
	*ygot.NodePath
}

// AddPaths (container): Parameters relating to the advertisement and receipt of
// multiple paths for a single NLRI (add-paths)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "add-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) AddPaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"add-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// AddPaths (container): Parameters relating to the advertisement and receipt of
// multiple paths for a single NLRI (add-paths)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "add-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) AddPaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"add-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiSafiName (leaf): AFI,SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/config/afi-safi-name"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) AfiSafiName() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AfiSafiNamePath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AfiSafiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiSafiName (leaf): AFI,SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/config/afi-safi-name"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) AfiSafiName() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AfiSafiNamePathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AfiSafiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether the AFI-SAFI is
// enabled for the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) Enabled() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether the AFI-SAFI is
// enabled for the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating to BGP graceful-restart
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) GracefulRestart() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating to BGP graceful-restart
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) GracefulRestart() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4LabeledUnicast (container): IPv4 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) Ipv4LabeledUnicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4LabeledUnicast (container): IPv4 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) Ipv4LabeledUnicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Unicast (container): IPv4 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) Ipv4Unicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Unicast (container): IPv4 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) Ipv4Unicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6LabeledUnicast (container): IPv6 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) Ipv6LabeledUnicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6LabeledUnicast (container): IPv6 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) Ipv6LabeledUnicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Unicast (container): IPv6 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) Ipv6Unicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Unicast (container): IPv6 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) Ipv6Unicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnEvpn (container): BGP EVPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-evpn"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) L2VpnEvpn() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPath{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnEvpn (container): BGP EVPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-evpn"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) L2VpnEvpn() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnVpls (container): BGP-signalled VPLS configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-vpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) L2VpnVpls() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-vpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnVpls (container): BGP-signalled VPLS configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-vpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) L2VpnVpls() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-vpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Multicast (container): Multicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) L3VpnIpv4Multicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Multicast (container): Multicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) L3VpnIpv4Multicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Unicast (container): Unicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) L3VpnIpv4Unicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Unicast (container): Unicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) L3VpnIpv4Unicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Multicast (container): Multicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) L3VpnIpv6Multicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Multicast (container): Multicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) L3VpnIpv6Multicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Unicast (container): Unicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) L3VpnIpv6Unicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Unicast (container): Unicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) L3VpnIpv6Unicast() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteSelectionOptions (container): Parameters relating to options for route selection
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-selection-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) RouteSelectionOptions() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"route-selection-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteSelectionOptions (container): Parameters relating to options for route selection
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-selection-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) RouteSelectionOptions() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"route-selection-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv4 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv4 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv4"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) SrtePolicyIpv4() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4Path {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4Path{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv4 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv4 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv4"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) SrtePolicyIpv4() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4PathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv6 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv6 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv6"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) SrtePolicyIpv6() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6Path {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6Path{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv6 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv6 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv6"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) SrtePolicyIpv6() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6PathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPaths (leaf): Total number of BGP paths within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/state/total-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) TotalPaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPathsPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPaths (leaf): Total number of BGP paths within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/state/total-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) TotalPaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPrefixes (leaf): Total number of BGP prefixes received within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/state/total-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) TotalPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPrefixes (leaf): Total number of BGP prefixes received within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/state/total-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) TotalPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_TotalPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple paths for the
// same NLRI
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPath) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple paths for the
// same NLRI
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafiPathAny) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_EligiblePrefixPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_EligiblePrefixPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_ReceivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/receive YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_ReceivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_ReceivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/receive YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_ReceivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/send YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/send YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendMaxPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/send-max YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendMaxPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendMaxPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/send-max YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendMaxPathAny struct {
	*ygot.NodePath
}

// EligiblePrefixPolicy (leaf): A reference to a routing policy which can be used to
// restrict the prefixes for which add-paths is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/eligible-prefix-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPath) EligiblePrefixPolicy() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_EligiblePrefixPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_EligiblePrefixPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "eligible-prefix-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// EligiblePrefixPolicy (leaf): A reference to a routing policy which can be used to
// restrict the prefixes for which add-paths is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/eligible-prefix-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPathAny) EligiblePrefixPolicy() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "eligible-prefix-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Receive (leaf): Enable capability negotiation to receive multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/receive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/receive"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPath) Receive() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_ReceivePath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_ReceivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Receive (leaf): Enable capability negotiation to receive multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/receive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/receive"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPathAny) Receive() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_ReceivePathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_ReceivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Send (leaf): Enable capability negotiation to send multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/send"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPath) Send() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send"},
			map[string]interface{}{},
			n,
		),
	}
}

// Send (leaf): Enable capability negotiation to send multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/send"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPathAny) Send() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendMax (leaf): The maximum total number of paths to advertise to neighbors
// for a single NLRI.  This includes the single best path as
// well as additional paths advertised when add-paths is
// enabled.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-max"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/send-max"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPath) SendMax() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendMaxPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendMaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-max"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendMax (leaf): The maximum total number of paths to advertise to neighbors
// for a single NLRI.  This includes the single best path as
// well as additional paths advertised when add-paths is
// enabled.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-max"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/add-paths/config/send-max"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPathsPathAny) SendMax() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendMaxPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_AddPaths_SendMaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-max"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestart_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestart_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestart_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestart_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): This leaf indicates whether graceful-restart is enabled for
// this AFI-SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPath) Enabled() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestart_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestart_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether graceful-restart is enabled for
// this AFI-SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestartPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestart_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_GracefulRestart_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_SendDefaultRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_SendDefaultRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPath) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_SendDefaultRoutePath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_SendDefaultRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4UnicastPathAny) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_SendDefaultRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_SendDefaultRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPath) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_SendDefaultRoutePath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_SendDefaultRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6UnicastPathAny) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpnPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVplsPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4MulticastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6MulticastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AdvertiseInactiveRoutesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/advertise-inactive-routes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AdvertiseInactiveRoutesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AdvertiseInactiveRoutesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/advertise-inactive-routes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AdvertiseInactiveRoutesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AlwaysCompareMedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/always-compare-med YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AlwaysCompareMedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AlwaysCompareMedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/always-compare-med YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AlwaysCompareMedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_EnableAigpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/enable-aigp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_EnableAigpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_EnableAigpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/enable-aigp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_EnableAigpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_ExternalCompareRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/external-compare-router-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_ExternalCompareRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_ExternalCompareRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/external-compare-router-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_ExternalCompareRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreAsPathLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/ignore-as-path-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreAsPathLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreAsPathLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/ignore-as-path-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreAsPathLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreNextHopIgpMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/ignore-next-hop-igp-metric YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreNextHopIgpMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreNextHopIgpMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/ignore-next-hop-igp-metric YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreNextHopIgpMetricPathAny struct {
	*ygot.NodePath
}

// AdvertiseInactiveRoutes (leaf): Advertise inactive routes to external peers.  The
// default is to only advertise active routes.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/advertise-inactive-routes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/advertise-inactive-routes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath) AdvertiseInactiveRoutes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AdvertiseInactiveRoutesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AdvertiseInactiveRoutesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertise-inactive-routes"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertiseInactiveRoutes (leaf): Advertise inactive routes to external peers.  The
// default is to only advertise active routes.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/advertise-inactive-routes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/advertise-inactive-routes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny) AdvertiseInactiveRoutes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AdvertiseInactiveRoutesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AdvertiseInactiveRoutesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertise-inactive-routes"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlwaysCompareMed (leaf): Compare multi-exit discriminator (MED) value from
// different ASes when selecting the best route.  The
// default behavior is to only compare MEDs for paths
// received from the same AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/always-compare-med"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/always-compare-med"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath) AlwaysCompareMed() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AlwaysCompareMedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AlwaysCompareMedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "always-compare-med"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlwaysCompareMed (leaf): Compare multi-exit discriminator (MED) value from
// different ASes when selecting the best route.  The
// default behavior is to only compare MEDs for paths
// received from the same AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/always-compare-med"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/always-compare-med"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny) AlwaysCompareMed() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AlwaysCompareMedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_AlwaysCompareMedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "always-compare-med"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableAigp (leaf): Flag to enable sending / receiving accumulated IGP
// attribute in routing updates
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable-aigp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/enable-aigp"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath) EnableAigp() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_EnableAigpPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_EnableAigpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-aigp"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableAigp (leaf): Flag to enable sending / receiving accumulated IGP
// attribute in routing updates
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable-aigp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/enable-aigp"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny) EnableAigp() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_EnableAigpPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_EnableAigpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-aigp"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalCompareRouterId (leaf): When comparing similar routes received from external
// BGP peers, use the router-id as a criterion to select
// the active path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/external-compare-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/external-compare-router-id"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath) ExternalCompareRouterId() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_ExternalCompareRouterIdPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_ExternalCompareRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "external-compare-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalCompareRouterId (leaf): When comparing similar routes received from external
// BGP peers, use the router-id as a criterion to select
// the active path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/external-compare-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/external-compare-router-id"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny) ExternalCompareRouterId() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_ExternalCompareRouterIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_ExternalCompareRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "external-compare-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgnoreAsPathLength (leaf): Ignore the AS path length when selecting the best path.
// The default is to use the AS path length and prefer paths
// with shorter length.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-as-path-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/ignore-as-path-length"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath) IgnoreAsPathLength() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreAsPathLengthPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreAsPathLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-as-path-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgnoreAsPathLength (leaf): Ignore the AS path length when selecting the best path.
// The default is to use the AS path length and prefer paths
// with shorter length.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-as-path-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/ignore-as-path-length"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny) IgnoreAsPathLength() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreAsPathLengthPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreAsPathLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-as-path-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgnoreNextHopIgpMetric (leaf): Ignore the IGP metric to the next-hop when calculating
// BGP best-path. The default is to select the route for
// which the metric to the next-hop is lowest
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-next-hop-igp-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/ignore-next-hop-igp-metric"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPath) IgnoreNextHopIgpMetric() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreNextHopIgpMetricPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreNextHopIgpMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-next-hop-igp-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgnoreNextHopIgpMetric (leaf): Ignore the IGP metric to the next-hop when calculating
// BGP best-path. The default is to select the route for
// which the metric to the next-hop is lowest
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-next-hop-igp-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/route-selection-options/config/ignore-next-hop-igp-metric"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptionsPathAny) IgnoreNextHopIgpMetric() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreNextHopIgpMetricPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_RouteSelectionOptions_IgnoreNextHopIgpMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-next-hop-igp-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4 YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4 YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4PathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4Path) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4PathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4Path) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4PathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6 YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6 YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6PathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6Path) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6PathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6Path) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6PathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EnabledPathAny struct {
	*ygot.NodePath
}

// Ebgp (container): Multipath parameters for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPath) Ebgp() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ebgp (container): Multipath parameters for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPathAny) Ebgp() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPath) Enabled() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ibgp (container): Multipath parameters for iBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ibgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ibgp"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPath) Ibgp() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ibgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ibgp (container): Multipath parameters for iBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ibgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ibgp"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePathsPathAny) Ibgp() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ibgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPathAny struct {
	*ygot.NodePath
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPath) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPathAny) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// BGP multipath. The default is use a single path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPath) MaximumPaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// BGP multipath. The default is use a single path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ebgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_EbgpPathAny) MaximumPaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ibgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ibgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ibgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ibgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPathAny struct {
	*ygot.NodePath
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// iBGP multipath. The default is to use a single path
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ibgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPath) MaximumPaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPath {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// iBGP multipath. The default is to use a single path
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/afi-safis/afi-safi/use-multiple-paths/ibgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_IbgpPathAny) MaximumPaths() *NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_ConfederationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/confederation YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_ConfederationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_ConfederationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/confederation YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_ConfederationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_Confederation_IdentifierPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/confederation/config/identifier YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_Confederation_IdentifierPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_Confederation_IdentifierPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/confederation/config/identifier YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_Confederation_IdentifierPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_Confederation_MemberAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/confederation/config/member-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_Confederation_MemberAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_Confederation_MemberAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/confederation/config/member-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_Confederation_MemberAsPathAny struct {
	*ygot.NodePath
}

// Identifier (leaf): Confederation identifier for the autonomous system.
// Setting the identifier indicates that the local-AS is part
// of a BGP confederation.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/confederation/config/identifier"
func (n *NetworkInstance_Protocol_Bgp_Global_ConfederationPath) Identifier() *NetworkInstance_Protocol_Bgp_Global_Confederation_IdentifierPath {
	return &NetworkInstance_Protocol_Bgp_Global_Confederation_IdentifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// Identifier (leaf): Confederation identifier for the autonomous system.
// Setting the identifier indicates that the local-AS is part
// of a BGP confederation.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/confederation/config/identifier"
func (n *NetworkInstance_Protocol_Bgp_Global_ConfederationPathAny) Identifier() *NetworkInstance_Protocol_Bgp_Global_Confederation_IdentifierPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_Confederation_IdentifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// MemberAs (leaf): Remote autonomous systems that are to be treated
// as part of the local confederation.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/member-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/confederation/config/member-as"
func (n *NetworkInstance_Protocol_Bgp_Global_ConfederationPath) MemberAs() *NetworkInstance_Protocol_Bgp_Global_Confederation_MemberAsPath {
	return &NetworkInstance_Protocol_Bgp_Global_Confederation_MemberAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "member-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// MemberAs (leaf): Remote autonomous systems that are to be treated
// as part of the local confederation.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/member-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/confederation/config/member-as"
func (n *NetworkInstance_Protocol_Bgp_Global_ConfederationPathAny) MemberAs() *NetworkInstance_Protocol_Bgp_Global_Confederation_MemberAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_Confederation_MemberAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "member-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_ExternalRouteDistancePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance/config/external-route-distance YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_ExternalRouteDistancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_ExternalRouteDistancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance/config/external-route-distance YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_ExternalRouteDistancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_InternalRouteDistancePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance/config/internal-route-distance YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_InternalRouteDistancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_InternalRouteDistancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance/config/internal-route-distance YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_InternalRouteDistancePathAny struct {
	*ygot.NodePath
}

// ExternalRouteDistance (leaf): Administrative distance for routes learned from external
// BGP (eBGP).
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/external-route-distance"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance/config/external-route-distance"
func (n *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePath) ExternalRouteDistance() *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_ExternalRouteDistancePath {
	return &NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_ExternalRouteDistancePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "external-route-distance"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalRouteDistance (leaf): Administrative distance for routes learned from external
// BGP (eBGP).
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/external-route-distance"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance/config/external-route-distance"
func (n *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePathAny) ExternalRouteDistance() *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_ExternalRouteDistancePathAny {
	return &NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_ExternalRouteDistancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "external-route-distance"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalRouteDistance (leaf): Administrative distance for routes learned from internal
// BGP (iBGP).
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/internal-route-distance"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance/config/internal-route-distance"
func (n *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePath) InternalRouteDistance() *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_InternalRouteDistancePath {
	return &NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_InternalRouteDistancePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "internal-route-distance"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalRouteDistance (leaf): Administrative distance for routes learned from internal
// BGP (iBGP).
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/internal-route-distance"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/default-route-distance/config/internal-route-distance"
func (n *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistancePathAny) InternalRouteDistance() *NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_InternalRouteDistancePathAny {
	return &NetworkInstance_Protocol_Bgp_Global_DefaultRouteDistance_InternalRouteDistancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "internal-route-distance"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PeerGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix/config/peer-group YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PeerGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PeerGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix/config/peer-group YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PeerGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix/config/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix/config/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PrefixPathAny struct {
	*ygot.NodePath
}

// PeerGroup (leaf): The peer-group within which the dynamic neighbor will be
// configured.  The configuration parameters used for the dynamic
// neighbor are those specified within the referenced peer
// group.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix/config/peer-group"
func (n *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPath) PeerGroup() *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PeerGroupPath {
	return &NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PeerGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerGroup (leaf): The peer-group within which the dynamic neighbor will be
// configured.  The configuration parameters used for the dynamic
// neighbor are those specified within the referenced peer
// group.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix/config/peer-group"
func (n *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny) PeerGroup() *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PeerGroupPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PeerGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IP prefix within which the source address of the remote
// BGP speaker must fall to be considered eligible to the
// dynamically configured.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix/config/prefix"
func (n *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPath) Prefix() *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IP prefix within which the source address of the remote
// BGP speaker must fall to be considered eligible to the
// dynamically configured.
// ----------------------------------------
// Defining module: "openconfig-bgp-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/dynamic-neighbor-prefixes/dynamic-neighbor-prefix/config/prefix"
func (n *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefixPathAny) Prefix() *NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_DynamicNeighborPrefix_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestart_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestart_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestart_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestart_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestart_HelperOnlyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestart_HelperOnlyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestart_HelperOnlyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestart_HelperOnlyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestart_RestartTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestart_RestartTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestart_RestartTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestart_RestartTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestart_StaleRoutesTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/stale-routes-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestart_StaleRoutesTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_GracefulRestart_StaleRoutesTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/stale-routes-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_GracefulRestart_StaleRoutesTimePathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Enable or disable the graceful-restart capability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPath) Enabled() *NetworkInstance_Protocol_Bgp_Global_GracefulRestart_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestart_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enable or disable the graceful-restart capability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Global_GracefulRestart_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestart_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Enable graceful-restart in helper mode only. When this
// leaf is set, the local system does not retain forwarding
// its own state during a restart, but supports procedures
// for the receiving speaker, as defined in RFC4724.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPath) HelperOnly() *NetworkInstance_Protocol_Bgp_Global_GracefulRestart_HelperOnlyPath {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestart_HelperOnlyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Enable graceful-restart in helper mode only. When this
// leaf is set, the local system does not retain forwarding
// its own state during a restart, but supports procedures
// for the receiving speaker, as defined in RFC4724.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPathAny) HelperOnly() *NetworkInstance_Protocol_Bgp_Global_GracefulRestart_HelperOnlyPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestart_HelperOnlyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Estimated time (in seconds) for the local BGP speaker to
// restart a session. This value is advertise in the graceful
// restart BGP capability.  This is a 12-bit value, referred to
// as Restart Time in RFC4724.  Per RFC4724, the suggested
// default value is <= the hold-time value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPath) RestartTime() *NetworkInstance_Protocol_Bgp_Global_GracefulRestart_RestartTimePath {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestart_RestartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Estimated time (in seconds) for the local BGP speaker to
// restart a session. This value is advertise in the graceful
// restart BGP capability.  This is a 12-bit value, referred to
// as Restart Time in RFC4724.  Per RFC4724, the suggested
// default value is <= the hold-time value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPathAny) RestartTime() *NetworkInstance_Protocol_Bgp_Global_GracefulRestart_RestartTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestart_RestartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaleRoutesTime (leaf): An upper-bound on the time thate stale routes will be
// retained by a router after a session is restarted. If an
// End-of-RIB (EOR) marker is received prior to this timer
// expiring stale-routes will be flushed upon its receipt - if
// no EOR is received, then when this timer expires stale paths
// will be purged. This timer is referred to as the
// Selection_Deferral_Timer in RFC4724
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/stale-routes-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/stale-routes-time"
func (n *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPath) StaleRoutesTime() *NetworkInstance_Protocol_Bgp_Global_GracefulRestart_StaleRoutesTimePath {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestart_StaleRoutesTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "stale-routes-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaleRoutesTime (leaf): An upper-bound on the time thate stale routes will be
// retained by a router after a session is restarted. If an
// End-of-RIB (EOR) marker is received prior to this timer
// expiring stale-routes will be flushed upon its receipt - if
// no EOR is received, then when this timer expires stale paths
// will be purged. This timer is referred to as the
// Selection_Deferral_Timer in RFC4724
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/stale-routes-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/graceful-restart/config/stale-routes-time"
func (n *NetworkInstance_Protocol_Bgp_Global_GracefulRestartPathAny) StaleRoutesTime() *NetworkInstance_Protocol_Bgp_Global_GracefulRestart_StaleRoutesTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Global_GracefulRestart_StaleRoutesTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "stale-routes-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AdvertiseInactiveRoutesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/advertise-inactive-routes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AdvertiseInactiveRoutesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AdvertiseInactiveRoutesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/advertise-inactive-routes YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AdvertiseInactiveRoutesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AlwaysCompareMedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/always-compare-med YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AlwaysCompareMedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AlwaysCompareMedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/always-compare-med YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AlwaysCompareMedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_EnableAigpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/enable-aigp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_EnableAigpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_EnableAigpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/enable-aigp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_EnableAigpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_ExternalCompareRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/external-compare-router-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_ExternalCompareRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_ExternalCompareRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/external-compare-router-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_ExternalCompareRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreAsPathLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/ignore-as-path-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreAsPathLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreAsPathLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/ignore-as-path-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreAsPathLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreNextHopIgpMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/ignore-next-hop-igp-metric YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreNextHopIgpMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreNextHopIgpMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/ignore-next-hop-igp-metric YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreNextHopIgpMetricPathAny struct {
	*ygot.NodePath
}

// AdvertiseInactiveRoutes (leaf): Advertise inactive routes to external peers.  The
// default is to only advertise active routes.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/advertise-inactive-routes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/advertise-inactive-routes"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath) AdvertiseInactiveRoutes() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AdvertiseInactiveRoutesPath {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AdvertiseInactiveRoutesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertise-inactive-routes"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertiseInactiveRoutes (leaf): Advertise inactive routes to external peers.  The
// default is to only advertise active routes.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/advertise-inactive-routes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/advertise-inactive-routes"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny) AdvertiseInactiveRoutes() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AdvertiseInactiveRoutesPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AdvertiseInactiveRoutesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertise-inactive-routes"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlwaysCompareMed (leaf): Compare multi-exit discriminator (MED) value from
// different ASes when selecting the best route.  The
// default behavior is to only compare MEDs for paths
// received from the same AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/always-compare-med"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/always-compare-med"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath) AlwaysCompareMed() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AlwaysCompareMedPath {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AlwaysCompareMedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "always-compare-med"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlwaysCompareMed (leaf): Compare multi-exit discriminator (MED) value from
// different ASes when selecting the best route.  The
// default behavior is to only compare MEDs for paths
// received from the same AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/always-compare-med"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/always-compare-med"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny) AlwaysCompareMed() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AlwaysCompareMedPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_AlwaysCompareMedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "always-compare-med"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableAigp (leaf): Flag to enable sending / receiving accumulated IGP
// attribute in routing updates
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable-aigp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/enable-aigp"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath) EnableAigp() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_EnableAigpPath {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_EnableAigpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-aigp"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableAigp (leaf): Flag to enable sending / receiving accumulated IGP
// attribute in routing updates
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enable-aigp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/enable-aigp"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny) EnableAigp() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_EnableAigpPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_EnableAigpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-aigp"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalCompareRouterId (leaf): When comparing similar routes received from external
// BGP peers, use the router-id as a criterion to select
// the active path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/external-compare-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/external-compare-router-id"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath) ExternalCompareRouterId() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_ExternalCompareRouterIdPath {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_ExternalCompareRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "external-compare-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalCompareRouterId (leaf): When comparing similar routes received from external
// BGP peers, use the router-id as a criterion to select
// the active path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/external-compare-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/external-compare-router-id"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny) ExternalCompareRouterId() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_ExternalCompareRouterIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_ExternalCompareRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "external-compare-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgnoreAsPathLength (leaf): Ignore the AS path length when selecting the best path.
// The default is to use the AS path length and prefer paths
// with shorter length.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-as-path-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/ignore-as-path-length"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath) IgnoreAsPathLength() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreAsPathLengthPath {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreAsPathLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-as-path-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgnoreAsPathLength (leaf): Ignore the AS path length when selecting the best path.
// The default is to use the AS path length and prefer paths
// with shorter length.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-as-path-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/ignore-as-path-length"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny) IgnoreAsPathLength() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreAsPathLengthPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreAsPathLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-as-path-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgnoreNextHopIgpMetric (leaf): Ignore the IGP metric to the next-hop when calculating
// BGP best-path. The default is to select the route for
// which the metric to the next-hop is lowest
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-next-hop-igp-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/ignore-next-hop-igp-metric"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPath) IgnoreNextHopIgpMetric() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreNextHopIgpMetricPath {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreNextHopIgpMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-next-hop-igp-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgnoreNextHopIgpMetric (leaf): Ignore the IGP metric to the next-hop when calculating
// BGP best-path. The default is to select the route for
// which the metric to the next-hop is lowest
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-next-hop-igp-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/route-selection-options/config/ignore-next-hop-igp-metric"
func (n *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptionsPathAny) IgnoreNextHopIgpMetric() *NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreNextHopIgpMetricPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_RouteSelectionOptions_IgnoreNextHopIgpMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-next-hop-igp-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EnabledPathAny struct {
	*ygot.NodePath
}

// Ebgp (container): Multipath parameters for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPath) Ebgp() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPath {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ebgp (container): Multipath parameters for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPathAny) Ebgp() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPath) Enabled() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ibgp (container): Multipath parameters for iBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ibgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ibgp"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPath) Ibgp() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPath {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ibgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ibgp (container): Multipath parameters for iBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ibgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ibgp"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePathsPathAny) Ibgp() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ibgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_AllowMultipleAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_AllowMultipleAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_MaximumPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_MaximumPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_MaximumPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_MaximumPathsPathAny struct {
	*ygot.NodePath
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPath) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_AllowMultipleAsPath {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_AllowMultipleAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPathAny) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// BGP multipath. The default is use a single path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPath) MaximumPaths() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_MaximumPathsPath {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_MaximumPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// BGP multipath. The default is use a single path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ebgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_EbgpPathAny) MaximumPaths() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_MaximumPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ebgp_MaximumPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ibgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ibgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ibgp_MaximumPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ibgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ibgp_MaximumPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ibgp_MaximumPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ibgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ibgp_MaximumPathsPathAny struct {
	*ygot.NodePath
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// iBGP multipath. The default is to use a single path
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ibgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPath) MaximumPaths() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ibgp_MaximumPathsPath {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ibgp_MaximumPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// iBGP multipath. The default is to use a single path
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/global/use-multiple-paths/ibgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_IbgpPathAny) MaximumPaths() *NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ibgp_MaximumPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Global_UseMultiplePaths_Ibgp_MaximumPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AuthPasswordPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AuthPasswordPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AuthPasswordPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AuthPasswordPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_DescriptionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/description YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_DescriptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_DescriptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/description YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_DescriptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_DynamicallyConfiguredPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/dynamically-configured YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_DynamicallyConfiguredPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_DynamicallyConfiguredPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/dynamically-configured YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_DynamicallyConfiguredPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EstablishedTransitionsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/established-transitions YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EstablishedTransitionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EstablishedTransitionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/established-transitions YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EstablishedTransitionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_LastEstablishedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/last-established YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LastEstablishedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_LastEstablishedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/last-established YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LastEstablishedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_LastPrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/last-prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LastPrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_LastPrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/last-prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LastPrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_LocalAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/local-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LocalAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_LocalAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/local-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LocalAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_NeighborPortPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/neighbor-port YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_NeighborPortPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_NeighborPortPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/neighbor-port YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_NeighborPortPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_PeerAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_PeerAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_PeerAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_PeerAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_PeerGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-group YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_PeerGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_PeerGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-group YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_PeerGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_PeerTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_PeerTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_PeerTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_PeerTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_RemovePrivateAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/remove-private-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RemovePrivateAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_RemovePrivateAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/remove-private-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RemovePrivateAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_RouteFlapDampingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/route-flap-damping YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RouteFlapDampingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_RouteFlapDampingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/route-flap-damping YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RouteFlapDampingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_SendCommunityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/send-community YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_SendCommunityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_SendCommunityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/send-community YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_SendCommunityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_SessionStatePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/session-state YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_SessionStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_SessionStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/session-state YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_SessionStatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_SupportedCapabilitiesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/supported-capabilities YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_SupportedCapabilitiesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_SupportedCapabilitiesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/supported-capabilities YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_SupportedCapabilitiesPathAny struct {
	*ygot.NodePath
}

// AfiSafiAny (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi"
// AfiSafiName (wildcarded): E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) AfiSafiAny() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": "*"},
			n,
		),
	}
}

// AfiSafiAny (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi"
// AfiSafiName (wildcarded): E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) AfiSafiAny() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": "*"},
			n,
		),
	}
}

// AfiSafi (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi"
// AfiSafiName: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) AfiSafi(AfiSafiName E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": AfiSafiName},
			n,
		),
	}
}

// AfiSafi (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi"
// AfiSafiName: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) AfiSafi(AfiSafiName E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": AfiSafiName},
			n,
		),
	}
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) ApplyPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) ApplyPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// AsPathOptions (container): AS_PATH manipulation parameters for the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "as-path-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) AsPathOptions() *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"as-path-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// AsPathOptions (container): AS_PATH manipulation parameters for the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "as-path-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) AsPathOptions() *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"as-path-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): Configures an MD5 authentication password for use with
// neighboring devices.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/auth-password"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) AuthPassword() *NetworkInstance_Protocol_Bgp_Neighbor_AuthPasswordPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AuthPasswordPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): Configures an MD5 authentication password for use with
// neighboring devices.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/auth-password"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) AuthPassword() *NetworkInstance_Protocol_Bgp_Neighbor_AuthPasswordPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AuthPasswordPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): An optional textual description (intended primarily for use
// with a peer or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/description"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) Description() *NetworkInstance_Protocol_Bgp_Neighbor_DescriptionPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): An optional textual description (intended primarily for use
// with a peer or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/description"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) Description() *NetworkInstance_Protocol_Bgp_Neighbor_DescriptionPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// DynamicallyConfigured (leaf): When this leaf is set to true, the peer was configured dynamically
// due to an inbound connection request from a specified source prefix
// within a dynamic-neighbor-prefix.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dynamically-configured"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/dynamically-configured"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) DynamicallyConfigured() *NetworkInstance_Protocol_Bgp_Neighbor_DynamicallyConfiguredPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_DynamicallyConfiguredPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dynamically-configured"},
			map[string]interface{}{},
			n,
		),
	}
}

// DynamicallyConfigured (leaf): When this leaf is set to true, the peer was configured dynamically
// due to an inbound connection request from a specified source prefix
// within a dynamic-neighbor-prefix.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dynamically-configured"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/dynamically-configured"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) DynamicallyConfigured() *NetworkInstance_Protocol_Bgp_Neighbor_DynamicallyConfiguredPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_DynamicallyConfiguredPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dynamically-configured"},
			map[string]interface{}{},
			n,
		),
	}
}

// EbgpMultihop (container): eBGP multi-hop parameters for the BGPgroup
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp-multihop"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) EbgpMultihop() *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPath{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp-multihop"},
			map[string]interface{}{},
			n,
		),
	}
}

// EbgpMultihop (container): eBGP multi-hop parameters for the BGPgroup
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp-multihop"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) EbgpMultihop() *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp-multihop"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/enable-bfd"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) EnableBfd() *NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPath{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/enable-bfd"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) EnableBfd() *NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the BGP peer is enabled. In cases where the
// enabled leaf is set to false, the local system should not
// initiate connections to the neighbor, and should not
// respond to TCP connections attempts from the neighbor. If
// the state of the BGP session is ESTABLISHED at the time
// that this leaf is set to false, the BGP session should be
// ceased.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the BGP peer is enabled. In cases where the
// enabled leaf is set to false, the local system should not
// initiate connections to the neighbor, and should not
// respond to TCP connections attempts from the neighbor. If
// the state of the BGP session is ESTABLISHED at the time
// that this leaf is set to false, the BGP session should be
// ceased.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorHandling (container): Error handling parameters used for the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-handling"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) ErrorHandling() *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPath{
		NodePath: ygot.NewNodePath(
			[]string{"error-handling"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorHandling (container): Error handling parameters used for the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-handling"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) ErrorHandling() *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"error-handling"},
			map[string]interface{}{},
			n,
		),
	}
}

// EstablishedTransitions (leaf): Number of transitions to the Established state for
// the neighbor session.  This value is analogous to the
// bgpPeerFsmEstablishedTransitions object from the standard
// BGP-4 MIB
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/established-transitions"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/established-transitions"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) EstablishedTransitions() *NetworkInstance_Protocol_Bgp_Neighbor_EstablishedTransitionsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EstablishedTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "established-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// EstablishedTransitions (leaf): Number of transitions to the Established state for
// the neighbor session.  This value is analogous to the
// bgpPeerFsmEstablishedTransitions object from the standard
// BGP-4 MIB
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/established-transitions"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/established-transitions"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) EstablishedTransitions() *NetworkInstance_Protocol_Bgp_Neighbor_EstablishedTransitionsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EstablishedTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "established-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating the graceful restart mechanism for BGP
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) GracefulRestart() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating the graceful restart mechanism for BGP
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) GracefulRestart() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastEstablished (leaf): This timestamp indicates the time that the
// BGP session last transitioned in or out of the Established
// state.  The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// The BGP session uptime can be computed by clients as the
// difference between this value and the current time in UTC
// (assuming the session is in the ESTABLISHED state, per the
// session-state leaf).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-established"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/last-established"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) LastEstablished() *NetworkInstance_Protocol_Bgp_Neighbor_LastEstablishedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LastEstablishedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-established"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastEstablished (leaf): This timestamp indicates the time that the
// BGP session last transitioned in or out of the Established
// state.  The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// The BGP session uptime can be computed by clients as the
// difference between this value and the current time in UTC
// (assuming the session is in the ESTABLISHED state, per the
// session-state leaf).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-established"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/last-established"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) LastEstablished() *NetworkInstance_Protocol_Bgp_Neighbor_LastEstablishedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LastEstablishedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-established"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPrefixLimitExceeded (leaf): This timestamp indicates the time that the BGP session last
// violated a configured max prefix-limit for any AFI/SAFI combination
// on the session.  The value is the timestamp in nanoseconds relative
// to the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// If the 'prefix-limit-exceeded' node is set to true for any AFI/SAFI
// on the session, then the next restart time for the session can be
// calculated as this value plus the configured 'restart-time' under
// the neighbor timers.
//
// This value should be retained across established sessions and is only
// set/updated when prefix-limit-exceeded transitions from false/unset to
// true.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/last-prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) LastPrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_LastPrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LastPrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastPrefixLimitExceeded (leaf): This timestamp indicates the time that the BGP session last
// violated a configured max prefix-limit for any AFI/SAFI combination
// on the session.  The value is the timestamp in nanoseconds relative
// to the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// If the 'prefix-limit-exceeded' node is set to true for any AFI/SAFI
// on the session, then the next restart time for the session can be
// calculated as this value plus the configured 'restart-time' under
// the neighbor timers.
//
// This value should be retained across established sessions and is only
// set/updated when prefix-limit-exceeded transitions from false/unset to
// true.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/last-prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) LastPrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_LastPrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LastPrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAs (leaf): The local autonomous system number that is to be used
// when establishing sessions with the remote peer or peer
// group, if this differs from the global BGP router
// autonomous system number.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/local-as"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) LocalAs() *NetworkInstance_Protocol_Bgp_Neighbor_LocalAsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LocalAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAs (leaf): The local autonomous system number that is to be used
// when establishing sessions with the remote peer or peer
// group, if this differs from the global BGP router
// autonomous system number.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/local-as"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) LocalAs() *NetworkInstance_Protocol_Bgp_Neighbor_LocalAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LocalAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoggingOptions (container): Logging options for events related to the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "logging-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/logging-options"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) LoggingOptions() *NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"logging-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoggingOptions (container): Logging options for events related to the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "logging-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/logging-options"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) LoggingOptions() *NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"logging-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// Messages (container): Counters for BGP messages sent and received from the
// neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) Messages() *NetworkInstance_Protocol_Bgp_Neighbor_MessagesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_MessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// Messages (container): Counters for BGP messages sent and received from the
// neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) Messages() *NetworkInstance_Protocol_Bgp_Neighbor_MessagesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_MessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): Address of the BGP peer, either in IPv4 or IPv6
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) NeighborAddress() *NetworkInstance_Protocol_Bgp_Neighbor_NeighborAddressPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): Address of the BGP peer, either in IPv4 or IPv6
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) NeighborAddress() *NetworkInstance_Protocol_Bgp_Neighbor_NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborPort (leaf): Port number of the BGP peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/neighbor-port"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/neighbor-port"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) NeighborPort() *NetworkInstance_Protocol_Bgp_Neighbor_NeighborPortPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_NeighborPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "neighbor-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborPort (leaf): Port number of the BGP peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/neighbor-port"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/neighbor-port"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) NeighborPort() *NetworkInstance_Protocol_Bgp_Neighbor_NeighborPortPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_NeighborPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "neighbor-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerAs (leaf): AS number of the peer.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-as"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) PeerAs() *NetworkInstance_Protocol_Bgp_Neighbor_PeerAsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_PeerAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerAs (leaf): AS number of the peer.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-as"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) PeerAs() *NetworkInstance_Protocol_Bgp_Neighbor_PeerAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_PeerAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerGroup (leaf): The peer-group with which this neighbor is associated
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-group"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) PeerGroup() *NetworkInstance_Protocol_Bgp_Neighbor_PeerGroupPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_PeerGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerGroup (leaf): The peer-group with which this neighbor is associated
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-group"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) PeerGroup() *NetworkInstance_Protocol_Bgp_Neighbor_PeerGroupPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_PeerGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerType (leaf): Explicitly designate the peer or peer group as internal
// (iBGP) or external (eBGP).
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-type"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) PeerType() *NetworkInstance_Protocol_Bgp_Neighbor_PeerTypePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_PeerTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerType (leaf): Explicitly designate the peer or peer group as internal
// (iBGP) or external (eBGP).
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/peer-type"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) PeerType() *NetworkInstance_Protocol_Bgp_Neighbor_PeerTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_PeerTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Queues (container): Counters related to queued messages associated with the
// BGP neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/queues"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) Queues() *NetworkInstance_Protocol_Bgp_Neighbor_QueuesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_QueuesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "queues"},
			map[string]interface{}{},
			n,
		),
	}
}

// Queues (container): Counters related to queued messages associated with the
// BGP neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/queues"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) Queues() *NetworkInstance_Protocol_Bgp_Neighbor_QueuesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_QueuesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "queues"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemovePrivateAs (leaf): Remove private AS numbers from updates sent to peers - when
// this leaf is not specified, the AS_PATH attribute should be
// sent to the peer unchanged
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remove-private-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/remove-private-as"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) RemovePrivateAs() *NetworkInstance_Protocol_Bgp_Neighbor_RemovePrivateAsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RemovePrivateAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remove-private-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemovePrivateAs (leaf): Remove private AS numbers from updates sent to peers - when
// this leaf is not specified, the AS_PATH attribute should be
// sent to the peer unchanged
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remove-private-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/remove-private-as"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) RemovePrivateAs() *NetworkInstance_Protocol_Bgp_Neighbor_RemovePrivateAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RemovePrivateAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remove-private-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteFlapDamping (leaf): Enable route flap damping.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-flap-damping"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/route-flap-damping"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) RouteFlapDamping() *NetworkInstance_Protocol_Bgp_Neighbor_RouteFlapDampingPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RouteFlapDampingPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-flap-damping"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteFlapDamping (leaf): Enable route flap damping.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-flap-damping"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/route-flap-damping"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) RouteFlapDamping() *NetworkInstance_Protocol_Bgp_Neighbor_RouteFlapDampingPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RouteFlapDampingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-flap-damping"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflector (container): Route reflector parameters for the BGPgroup
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-reflector"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) RouteReflector() *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPath{
		NodePath: ygot.NewNodePath(
			[]string{"route-reflector"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflector (container): Route reflector parameters for the BGPgroup
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-reflector"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) RouteReflector() *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"route-reflector"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendCommunity (leaf): Specify which types of community should be sent to the
// neighbor or group. The default is to not send the
// community attribute
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/send-community"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) SendCommunity() *NetworkInstance_Protocol_Bgp_Neighbor_SendCommunityPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_SendCommunityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-community"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendCommunity (leaf): Specify which types of community should be sent to the
// neighbor or group. The default is to not send the
// community attribute
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/config/send-community"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) SendCommunity() *NetworkInstance_Protocol_Bgp_Neighbor_SendCommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_SendCommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-community"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionState (leaf): Operational state of the BGP peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/session-state"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/session-state"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) SessionState() *NetworkInstance_Protocol_Bgp_Neighbor_SessionStatePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_SessionStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionState (leaf): Operational state of the BGP peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/session-state"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/session-state"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) SessionState() *NetworkInstance_Protocol_Bgp_Neighbor_SessionStatePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_SessionStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "session-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// SupportedCapabilities (leaf): BGP capabilities negotiated as supported with the peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/supported-capabilities"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/supported-capabilities"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) SupportedCapabilities() *NetworkInstance_Protocol_Bgp_Neighbor_SupportedCapabilitiesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_SupportedCapabilitiesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "supported-capabilities"},
			map[string]interface{}{},
			n,
		),
	}
}

// SupportedCapabilities (leaf): BGP capabilities negotiated as supported with the peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/supported-capabilities"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/supported-capabilities"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) SupportedCapabilities() *NetworkInstance_Protocol_Bgp_Neighbor_SupportedCapabilitiesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_SupportedCapabilitiesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "supported-capabilities"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): Timers related to a BGP neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) Timers() *NetworkInstance_Protocol_Bgp_Neighbor_TimersPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_TimersPath{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): Timers related to a BGP neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) Timers() *NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): Transport session parameters for the BGP neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transport"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) Transport() *NetworkInstance_Protocol_Bgp_Neighbor_TransportPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_TransportPath{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): Transport session parameters for the BGP neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transport"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) Transport() *NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple-paths for the same
// NLRI when they are received only from this neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_NeighborPath) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple-paths for the same
// NLRI when they are received only from this neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_NeighborPathAny) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ActivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/active YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ActivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ActivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/active YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ActivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AfiSafiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/config/afi-safi-name YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AfiSafiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AfiSafiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/config/afi-safi-name YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AfiSafiNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_EnabledPathAny struct {
	*ygot.NodePath
}

// Active (leaf): This value indicates whether a particular AFI-SAFI has
// been succesfully negotiated with the peer. An AFI-SAFI
// may be enabled in the current running configuration, but a
// session restart may be required in order to negotiate the new
// capability.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/active"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) Active() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ActivePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ActivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// Active (leaf): This value indicates whether a particular AFI-SAFI has
// been succesfully negotiated with the peer. An AFI-SAFI
// may be enabled in the current running configuration, but a
// session restart may be required in order to negotiate the new
// capability.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/active"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) Active() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ActivePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ActivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// AddPaths (container): Parameters relating to the advertisement and receipt of
// multiple paths for a single NLRI (add-paths)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "add-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) AddPaths() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"add-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// AddPaths (container): Parameters relating to the advertisement and receipt of
// multiple paths for a single NLRI (add-paths)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "add-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) AddPaths() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"add-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiSafiName (leaf): AFI,SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/config/afi-safi-name"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) AfiSafiName() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AfiSafiNamePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AfiSafiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiSafiName (leaf): AFI,SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/config/afi-safi-name"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) AfiSafiName() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AfiSafiNamePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AfiSafiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) ApplyPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) ApplyPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether the AFI-SAFI is
// enabled for the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether the AFI-SAFI is
// enabled for the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating to BGP graceful-restart
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) GracefulRestart() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating to BGP graceful-restart
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) GracefulRestart() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4LabeledUnicast (container): IPv4 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) Ipv4LabeledUnicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4LabeledUnicast (container): IPv4 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) Ipv4LabeledUnicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Unicast (container): IPv4 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) Ipv4Unicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Unicast (container): IPv4 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) Ipv4Unicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6LabeledUnicast (container): IPv6 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) Ipv6LabeledUnicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6LabeledUnicast (container): IPv6 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) Ipv6LabeledUnicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Unicast (container): IPv6 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) Ipv6Unicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Unicast (container): IPv6 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) Ipv6Unicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnEvpn (container): BGP EVPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-evpn"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) L2VpnEvpn() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPath{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnEvpn (container): BGP EVPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-evpn"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) L2VpnEvpn() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnVpls (container): BGP-signalled VPLS configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-vpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) L2VpnVpls() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-vpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnVpls (container): BGP-signalled VPLS configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-vpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) L2VpnVpls() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-vpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Multicast (container): Multicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) L3VpnIpv4Multicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Multicast (container): Multicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) L3VpnIpv4Multicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Unicast (container): Unicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) L3VpnIpv4Unicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Unicast (container): Unicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) L3VpnIpv4Unicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Multicast (container): Multicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) L3VpnIpv6Multicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Multicast (container): Multicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) L3VpnIpv6Multicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Unicast (container): Unicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) L3VpnIpv6Unicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Unicast (container): Unicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) L3VpnIpv6Unicast() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefixes (container): Prefix counters for the BGP session
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) Prefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefixes (container): Prefix counters for the BGP session
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) Prefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv4 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv4 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv4"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) SrtePolicyIpv4() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4Path {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4Path{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv4 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv4 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv4"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) SrtePolicyIpv4() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4PathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv6 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv6 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv6"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) SrtePolicyIpv6() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6Path {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6Path{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv6 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv6 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv6"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) SrtePolicyIpv6() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6PathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple-paths for the same
// NLRI when they are received only from this neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPath) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple-paths for the same
// NLRI when they are received only from this neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafiPathAny) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_EligiblePrefixPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_EligiblePrefixPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_ReceivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/receive YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_ReceivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_ReceivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/receive YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_ReceivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/send YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/send YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendMaxPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/send-max YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendMaxPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendMaxPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/send-max YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendMaxPathAny struct {
	*ygot.NodePath
}

// EligiblePrefixPolicy (leaf): A reference to a routing policy which can be used to
// restrict the prefixes for which add-paths is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/eligible-prefix-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPath) EligiblePrefixPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_EligiblePrefixPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_EligiblePrefixPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "eligible-prefix-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// EligiblePrefixPolicy (leaf): A reference to a routing policy which can be used to
// restrict the prefixes for which add-paths is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/eligible-prefix-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPathAny) EligiblePrefixPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "eligible-prefix-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Receive (leaf): Enable capability negotiation to receive multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/receive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/receive"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPath) Receive() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_ReceivePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_ReceivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Receive (leaf): Enable capability negotiation to receive multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/receive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/receive"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPathAny) Receive() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_ReceivePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_ReceivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Send (leaf): Enable capability negotiation to send multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/send"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPath) Send() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send"},
			map[string]interface{}{},
			n,
		),
	}
}

// Send (leaf): Enable capability negotiation to send multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/send"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPathAny) Send() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendMax (leaf): The maximum total number of paths to advertise to neighbors
// for a single NLRI.  This includes the single best path as
// well as additional paths advertised when add-paths is
// enabled.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-max"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/send-max"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPath) SendMax() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendMaxPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendMaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-max"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendMax (leaf): The maximum total number of paths to advertise to neighbors
// for a single NLRI.  This includes the single best path as
// well as additional paths advertised when add-paths is
// enabled.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-max"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/add-paths/config/send-max"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPathsPathAny) SendMax() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendMaxPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_AddPaths_SendMaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-max"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ImportPolicyPathAny struct {
	*ygot.NodePath
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/default-export-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPath) DefaultExportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultExportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/default-export-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPathAny) DefaultExportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultExportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPath) DefaultImportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultImportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPathAny) DefaultImportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultImportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_DefaultImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/export-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPath) ExportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ExportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/export-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPathAny) ExportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ExportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPath) ImportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ImportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/apply-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicyPathAny) ImportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ImportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_ApplyPolicy_ImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_AdvertisedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/state/advertised YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_AdvertisedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_AdvertisedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/state/advertised YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_AdvertisedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/state/received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/state/received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_ReceivedPathAny struct {
	*ygot.NodePath
}

// Advertised (leaf): This leaf indicates whether the ability to support
// graceful-restart has been advertised to the peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/state/advertised"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPath) Advertised() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_AdvertisedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_AdvertisedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised"},
			map[string]interface{}{},
			n,
		),
	}
}

// Advertised (leaf): This leaf indicates whether the ability to support
// graceful-restart has been advertised to the peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/state/advertised"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPathAny) Advertised() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_AdvertisedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_AdvertisedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether graceful-restart is enabled for
// this AFI-SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPath) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether graceful-restart is enabled for
// this AFI-SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): This leaf indicates whether the neighbor advertised the
// ability to support graceful-restart for this AFI-SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/state/received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPath) Received() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_ReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): This leaf indicates whether the neighbor advertised the
// ability to support graceful-restart for this AFI-SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/graceful-restart/state/received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestartPathAny) Received() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_ReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_GracefulRestart_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_SendDefaultRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_SendDefaultRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPath) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_SendDefaultRoutePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_SendDefaultRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4UnicastPathAny) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_SendDefaultRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_SendDefaultRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPath) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_SendDefaultRoutePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_SendDefaultRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6UnicastPathAny) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpnPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVplsPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4MulticastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6MulticastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_InstalledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/installed YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_InstalledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_InstalledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/installed YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_InstalledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPrePolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/received-pre-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPrePolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPrePolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/received-pre-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPrePolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/sent YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/sent YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_SentPathAny struct {
	*ygot.NodePath
}

// Installed (leaf): The number of prefices received from the neighbor that
// are installed in the network instance RIB and actively used
// for forwarding.
//
// Routes that are actively used for forwarding are
// defined to be those that:
// - are selected, after the application of policies, to be
//   included in the Adj-RIB-In-Post, AND
// - are selected by best path selection and hence installed
//   in the Loc-RIB (either as the only route, or as part of
//   a multipath set, AND
// - are selected, after the application of protocol
//   preferences (e.g., administrative distance) as the
//   route to be used by the system's RIB
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "installed"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/installed"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPath) Installed() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_InstalledPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_InstalledPath{
		NodePath: ygot.NewNodePath(
			[]string{"installed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Installed (leaf): The number of prefices received from the neighbor that
// are installed in the network instance RIB and actively used
// for forwarding.
//
// Routes that are actively used for forwarding are
// defined to be those that:
// - are selected, after the application of policies, to be
//   included in the Adj-RIB-In-Post, AND
// - are selected by best path selection and hence installed
//   in the Loc-RIB (either as the only route, or as part of
//   a multipath set, AND
// - are selected, after the application of protocol
//   preferences (e.g., administrative distance) as the
//   route to be used by the system's RIB
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "installed"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/installed"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPathAny) Installed() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_InstalledPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_InstalledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"installed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of prefixes that are received from the
// neighbor after applying any policies. This count is the
// number of prefixes present in the post-policy Adj-RIB-In
// for the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPath) Received() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of prefixes that are received from the
// neighbor after applying any policies. This count is the
// number of prefixes present in the post-policy Adj-RIB-In
// for the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPathAny) Received() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"received"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedPrePolicy (leaf): The number of prefixes that are received from the
// neighbor before applying any policies. This count is
// the number of prefixes present in the pre-policy
// Adj-RIB-In for the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received-pre-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/received-pre-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPath) ReceivedPrePolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPrePolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPrePolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"received-pre-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedPrePolicy (leaf): The number of prefixes that are received from the
// neighbor before applying any policies. This count is
// the number of prefixes present in the pre-policy
// Adj-RIB-In for the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received-pre-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/received-pre-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPathAny) ReceivedPrePolicy() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPrePolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_ReceivedPrePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"received-pre-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of prefixes that are advertised to the
// neighbor after applying any policies. This count is
// the number of prefixes present in the post-policy
// Adj-RIB-Out for the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/sent"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPath) Sent() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_SentPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of prefixes that are advertised to the
// neighbor after applying any policies. This count is
// the number of prefixes present in the post-policy
// Adj-RIB-Out for the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/state/prefixes/sent"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_PrefixesPathAny) Sent() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_SentPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_Prefixes_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4 YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4 YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4PathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4Path) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4PathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4Path) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4PathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6 YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6 YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6PathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6Path) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6PathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6Path) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6PathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EnabledPathAny struct {
	*ygot.NodePath
}

// Ebgp (container): Multipath configuration for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPath) Ebgp() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ebgp (container): Multipath configuration for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPathAny) Ebgp() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPath) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePathsPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny struct {
	*ygot.NodePath
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPath) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_EbgpPathAny) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ImportPolicyPathAny struct {
	*ygot.NodePath
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/default-export-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPath) DefaultExportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultExportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/default-export-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPathAny) DefaultExportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultExportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPath) DefaultImportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultImportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPathAny) DefaultImportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultImportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_DefaultImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/export-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPath) ExportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ExportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/export-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPathAny) ExportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ExportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPath) ImportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ImportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/apply-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicyPathAny) ImportPolicy() *NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ImportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ApplyPolicy_ImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_AllowOwnAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/allow-own-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_AllowOwnAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_AllowOwnAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/allow-own-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_AllowOwnAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_DisablePeerAsFilterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/disable-peer-as-filter YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_DisablePeerAsFilterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_DisablePeerAsFilterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/disable-peer-as-filter YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_DisablePeerAsFilterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_ReplacePeerAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/replace-peer-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_ReplacePeerAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_ReplacePeerAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/replace-peer-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_ReplacePeerAsPathAny struct {
	*ygot.NodePath
}

// AllowOwnAs (leaf): Specify the number of occurrences of the local BGP speaker's
// AS that can occur within the AS_PATH before it is rejected.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-own-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/allow-own-as"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPath) AllowOwnAs() *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_AllowOwnAsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_AllowOwnAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-own-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllowOwnAs (leaf): Specify the number of occurrences of the local BGP speaker's
// AS that can occur within the AS_PATH before it is rejected.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-own-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/allow-own-as"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPathAny) AllowOwnAs() *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_AllowOwnAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_AllowOwnAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-own-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisablePeerAsFilter (leaf): When set to true, the system advertises routes to a peer
// even if the peer's AS was in the AS path.  The default
// behavior (false) suppresses advertisements to peers if
// their AS number is in the AS path of the route.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-peer-as-filter"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/disable-peer-as-filter"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPath) DisablePeerAsFilter() *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_DisablePeerAsFilterPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_DisablePeerAsFilterPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-peer-as-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisablePeerAsFilter (leaf): When set to true, the system advertises routes to a peer
// even if the peer's AS was in the AS path.  The default
// behavior (false) suppresses advertisements to peers if
// their AS number is in the AS path of the route.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-peer-as-filter"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/disable-peer-as-filter"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPathAny) DisablePeerAsFilter() *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_DisablePeerAsFilterPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_DisablePeerAsFilterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-peer-as-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReplacePeerAs (leaf): Replace occurrences of the peer's AS in the AS_PATH
// with the local autonomous system number
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/replace-peer-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/replace-peer-as"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPath) ReplacePeerAs() *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_ReplacePeerAsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_ReplacePeerAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "replace-peer-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReplacePeerAs (leaf): Replace occurrences of the peer's AS in the AS_PATH
// with the local autonomous system number
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/replace-peer-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/as-path-options/config/replace-peer-as"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptionsPathAny) ReplacePeerAs() *NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_ReplacePeerAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_AsPathOptions_ReplacePeerAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "replace-peer-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_MultihopTtlPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop/config/multihop-ttl YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_MultihopTtlPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_MultihopTtlPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop/config/multihop-ttl YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_MultihopTtlPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When enabled the referenced group or neighbors are permitted
// to be indirectly connected - including cases where the TTL
// can be decremented between the BGP peers
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPath) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When enabled the referenced group or neighbors are permitted
// to be indirectly connected - including cases where the TTL
// can be decremented between the BGP peers
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultihopTtl (leaf): Time-to-live value to use when packets are sent to the
// referenced group or neighbors and ebgp-multihop is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multihop-ttl"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop/config/multihop-ttl"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPath) MultihopTtl() *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_MultihopTtlPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_MultihopTtlPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multihop-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultihopTtl (leaf): Time-to-live value to use when packets are sent to the
// referenced group or neighbors and ebgp-multihop is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multihop-ttl"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/ebgp-multihop/config/multihop-ttl"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihopPathAny) MultihopTtl() *NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_MultihopTtlPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EbgpMultihop_MultihopTtlPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multihop-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EnableBfd_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EnableBfd_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_EnableBfd_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_EnableBfd_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPath) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_EnableBfd_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EnableBfd_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_EnableBfdPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_EnableBfd_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_EnableBfd_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_ErroneousUpdateMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling/state/erroneous-update-messages YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_ErroneousUpdateMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_ErroneousUpdateMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling/state/erroneous-update-messages YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_ErroneousUpdateMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_TreatAsWithdrawPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling/config/treat-as-withdraw YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_TreatAsWithdrawPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_TreatAsWithdrawPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling/config/treat-as-withdraw YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_TreatAsWithdrawPathAny struct {
	*ygot.NodePath
}

// ErroneousUpdateMessages (leaf): The number of BGP UPDATE messages for which the
// treat-as-withdraw mechanism has been applied based
// on erroneous message contents
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/erroneous-update-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling/state/erroneous-update-messages"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPath) ErroneousUpdateMessages() *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_ErroneousUpdateMessagesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_ErroneousUpdateMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "erroneous-update-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErroneousUpdateMessages (leaf): The number of BGP UPDATE messages for which the
// treat-as-withdraw mechanism has been applied based
// on erroneous message contents
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/erroneous-update-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling/state/erroneous-update-messages"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPathAny) ErroneousUpdateMessages() *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_ErroneousUpdateMessagesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_ErroneousUpdateMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "erroneous-update-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// TreatAsWithdraw (leaf): Specify whether erroneous UPDATE messages for which the
// NLRI can be extracted are reated as though the NLRI is
// withdrawn - avoiding session reset
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/treat-as-withdraw"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling/config/treat-as-withdraw"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPath) TreatAsWithdraw() *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_TreatAsWithdrawPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_TreatAsWithdrawPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "treat-as-withdraw"},
			map[string]interface{}{},
			n,
		),
	}
}

// TreatAsWithdraw (leaf): Specify whether erroneous UPDATE messages for which the
// NLRI can be extracted are reated as though the NLRI is
// withdrawn - avoiding session reset
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/treat-as-withdraw"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/error-handling/config/treat-as-withdraw"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandlingPathAny) TreatAsWithdraw() *NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_TreatAsWithdrawPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_ErrorHandling_TreatAsWithdrawPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "treat-as-withdraw"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_HelperOnlyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_HelperOnlyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_HelperOnlyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_HelperOnlyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_LocalRestartingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/local-restarting YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_LocalRestartingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_LocalRestartingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/local-restarting YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_LocalRestartingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_ModePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/mode YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_ModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_ModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/mode YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_ModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/peer-restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/peer-restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/peer-restarting YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/peer-restarting YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_RestartTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_RestartTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_RestartTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_RestartTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_StaleRoutesTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/stale-routes-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_StaleRoutesTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_StaleRoutesTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/stale-routes-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_StaleRoutesTimePathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Enable or disable the graceful-restart capability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enable or disable the graceful-restart capability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Enable graceful-restart in helper mode only. When this
// leaf is set, the local system does not retain forwarding
// its own state during a restart, but supports procedures
// for the receiving speaker, as defined in RFC4724.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath) HelperOnly() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_HelperOnlyPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_HelperOnlyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Enable graceful-restart in helper mode only. When this
// leaf is set, the local system does not retain forwarding
// its own state during a restart, but supports procedures
// for the receiving speaker, as defined in RFC4724.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny) HelperOnly() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_HelperOnlyPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_HelperOnlyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalRestarting (leaf): This flag indicates whether the local neighbor is currently
// restarting. The flag is unset after all NLRI have been
// advertised to the peer, and the End-of-RIB (EOR) marker has
// been unset
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-restarting"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/local-restarting"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath) LocalRestarting() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_LocalRestartingPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_LocalRestartingPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-restarting"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalRestarting (leaf): This flag indicates whether the local neighbor is currently
// restarting. The flag is unset after all NLRI have been
// advertised to the peer, and the End-of-RIB (EOR) marker has
// been unset
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-restarting"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/local-restarting"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny) LocalRestarting() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_LocalRestartingPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_LocalRestartingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-restarting"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): Ths leaf indicates the mode of operation of BGP graceful
// restart with the peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/mode"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath) Mode() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_ModePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_ModePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): Ths leaf indicates the mode of operation of BGP graceful
// restart with the peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/mode"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny) Mode() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_ModePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerRestartTime (leaf): The period of time (advertised by the peer) that
// the peer expects a restart of a BGP session to
// take
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/peer-restart-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath) PeerRestartTime() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartTimePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerRestartTime (leaf): The period of time (advertised by the peer) that
// the peer expects a restart of a BGP session to
// take
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/peer-restart-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny) PeerRestartTime() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerRestarting (leaf): This flag indicates whether the remote neighbor is currently
// in the process of restarting, and hence received routes are
// currently stale
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-restarting"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/peer-restarting"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath) PeerRestarting() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartingPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartingPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-restarting"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerRestarting (leaf): This flag indicates whether the remote neighbor is currently
// in the process of restarting, and hence received routes are
// currently stale
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-restarting"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/state/peer-restarting"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny) PeerRestarting() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartingPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_PeerRestartingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-restarting"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Estimated time (in seconds) for the local BGP speaker to
// restart a session. This value is advertise in the graceful
// restart BGP capability.  This is a 12-bit value, referred to
// as Restart Time in RFC4724.  Per RFC4724, the suggested
// default value is <= the hold-time value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath) RestartTime() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_RestartTimePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_RestartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Estimated time (in seconds) for the local BGP speaker to
// restart a session. This value is advertise in the graceful
// restart BGP capability.  This is a 12-bit value, referred to
// as Restart Time in RFC4724.  Per RFC4724, the suggested
// default value is <= the hold-time value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny) RestartTime() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_RestartTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_RestartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaleRoutesTime (leaf): An upper-bound on the time thate stale routes will be
// retained by a router after a session is restarted. If an
// End-of-RIB (EOR) marker is received prior to this timer
// expiring stale-routes will be flushed upon its receipt - if
// no EOR is received, then when this timer expires stale paths
// will be purged. This timer is referred to as the
// Selection_Deferral_Timer in RFC4724
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/stale-routes-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/stale-routes-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPath) StaleRoutesTime() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_StaleRoutesTimePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_StaleRoutesTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "stale-routes-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaleRoutesTime (leaf): An upper-bound on the time thate stale routes will be
// retained by a router after a session is restarted. If an
// End-of-RIB (EOR) marker is received prior to this timer
// expiring stale-routes will be flushed upon its receipt - if
// no EOR is received, then when this timer expires stale paths
// will be purged. This timer is referred to as the
// Selection_Deferral_Timer in RFC4724
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/stale-routes-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/graceful-restart/config/stale-routes-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestartPathAny) StaleRoutesTime() *NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_StaleRoutesTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_GracefulRestart_StaleRoutesTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "stale-routes-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/logging-options YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/logging-options YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptions_LogNeighborStateChangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/logging-options/config/log-neighbor-state-changes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptions_LogNeighborStateChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptions_LogNeighborStateChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/logging-options/config/log-neighbor-state-changes YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptions_LogNeighborStateChangesPathAny struct {
	*ygot.NodePath
}

// LogNeighborStateChanges (leaf): Configure logging of peer state changes.  Default is
// to enable logging of peer state changes.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/log-neighbor-state-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/logging-options/config/log-neighbor-state-changes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPath) LogNeighborStateChanges() *NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptions_LogNeighborStateChangesPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptions_LogNeighborStateChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "log-neighbor-state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LogNeighborStateChanges (leaf): Configure logging of peer state changes.  Default is
// to enable logging of peer state changes.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/log-neighbor-state-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/logging-options/config/log-neighbor-state-changes"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptionsPathAny) LogNeighborStateChanges() *NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptions_LogNeighborStateChangesPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_LoggingOptions_LogNeighborStateChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "log-neighbor-state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_MessagesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_MessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_MessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_MessagesPathAny struct {
	*ygot.NodePath
}

// Received (container): Counters for BGP messages received from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_MessagesPath) Received() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (container): Counters for BGP messages received from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_MessagesPathAny) Received() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (container): Counters relating to BGP messages sent to the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_MessagesPath) Sent() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (container): Counters relating to BGP messages sent to the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_MessagesPathAny) Sent() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_NOTIFICATIONPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/NOTIFICATION YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_NOTIFICATIONPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_NOTIFICATIONPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/NOTIFICATION YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_NOTIFICATIONPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_UPDATEPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/UPDATE YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_UPDATEPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_UPDATEPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/UPDATE YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_UPDATEPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorCodePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-error-code YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorCodePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorCodePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-error-code YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorCodePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorSubcodePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-error-subcode YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorSubcodePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorSubcodePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-error-subcode YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorSubcodePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationTimePathAny struct {
	*ygot.NodePath
}

// NOTIFICATION (leaf): Number of BGP NOTIFICATION messages indicating an
// error condition has occurred exchanged.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "NOTIFICATION"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/NOTIFICATION"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPath) NOTIFICATION() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_NOTIFICATIONPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_NOTIFICATIONPath{
		NodePath: ygot.NewNodePath(
			[]string{"NOTIFICATION"},
			map[string]interface{}{},
			n,
		),
	}
}

// NOTIFICATION (leaf): Number of BGP NOTIFICATION messages indicating an
// error condition has occurred exchanged.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "NOTIFICATION"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/NOTIFICATION"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPathAny) NOTIFICATION() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_NOTIFICATIONPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_NOTIFICATIONPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"NOTIFICATION"},
			map[string]interface{}{},
			n,
		),
	}
}

// UPDATE (leaf): Number of BGP UPDATE messages announcing, withdrawing
// or modifying paths exchanged.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "UPDATE"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/UPDATE"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPath) UPDATE() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_UPDATEPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_UPDATEPath{
		NodePath: ygot.NewNodePath(
			[]string{"UPDATE"},
			map[string]interface{}{},
			n,
		),
	}
}

// UPDATE (leaf): Number of BGP UPDATE messages announcing, withdrawing
// or modifying paths exchanged.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "UPDATE"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/UPDATE"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPathAny) UPDATE() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_UPDATEPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_UPDATEPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"UPDATE"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationErrorCode (leaf): Indicates the last BGP error sent or received on the peering
// session (based on whether this leaf is associated with
// sent or received messages).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-error-code"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-error-code"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPath) LastNotificationErrorCode() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorCodePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorCodePath{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-error-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationErrorCode (leaf): Indicates the last BGP error sent or received on the peering
// session (based on whether this leaf is associated with
// sent or received messages).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-error-code"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-error-code"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPathAny) LastNotificationErrorCode() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorCodePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorCodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-error-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationErrorSubcode (leaf): Indicates the last BGP error subcode sent or received on
// the peering session (based on whether this leaf is associated
// with sent or received messages)
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-error-subcode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-error-subcode"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPath) LastNotificationErrorSubcode() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorSubcodePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorSubcodePath{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-error-subcode"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationErrorSubcode (leaf): Indicates the last BGP error subcode sent or received on
// the peering session (based on whether this leaf is associated
// with sent or received messages)
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-error-subcode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-error-subcode"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPathAny) LastNotificationErrorSubcode() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorSubcodePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationErrorSubcodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-error-subcode"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationTime (leaf): This timestamp indicates the time that a NOTIFICATION
// message was sent or received on the peering session
// (based on whether this leaf is associated with
// sent or received messages).
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPath) LastNotificationTime() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationTimePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationTime (leaf): This timestamp indicates the time that a NOTIFICATION
// message was sent or received on the peering session
// (based on whether this leaf is associated with
// sent or received messages).
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/received/last-notification-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_ReceivedPathAny) LastNotificationTime() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Received_LastNotificationTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_NOTIFICATIONPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/NOTIFICATION YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_NOTIFICATIONPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_NOTIFICATIONPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/NOTIFICATION YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_NOTIFICATIONPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_UPDATEPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/UPDATE YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_UPDATEPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_UPDATEPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/UPDATE YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_UPDATEPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorCodePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-error-code YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorCodePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorCodePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-error-code YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorCodePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorSubcodePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-error-subcode YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorSubcodePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorSubcodePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-error-subcode YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorSubcodePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationTimePathAny struct {
	*ygot.NodePath
}

// NOTIFICATION (leaf): Number of BGP NOTIFICATION messages indicating an
// error condition has occurred exchanged.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "NOTIFICATION"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/NOTIFICATION"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPath) NOTIFICATION() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_NOTIFICATIONPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_NOTIFICATIONPath{
		NodePath: ygot.NewNodePath(
			[]string{"NOTIFICATION"},
			map[string]interface{}{},
			n,
		),
	}
}

// NOTIFICATION (leaf): Number of BGP NOTIFICATION messages indicating an
// error condition has occurred exchanged.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "NOTIFICATION"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/NOTIFICATION"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPathAny) NOTIFICATION() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_NOTIFICATIONPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_NOTIFICATIONPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"NOTIFICATION"},
			map[string]interface{}{},
			n,
		),
	}
}

// UPDATE (leaf): Number of BGP UPDATE messages announcing, withdrawing
// or modifying paths exchanged.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "UPDATE"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/UPDATE"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPath) UPDATE() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_UPDATEPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_UPDATEPath{
		NodePath: ygot.NewNodePath(
			[]string{"UPDATE"},
			map[string]interface{}{},
			n,
		),
	}
}

// UPDATE (leaf): Number of BGP UPDATE messages announcing, withdrawing
// or modifying paths exchanged.
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "UPDATE"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/UPDATE"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPathAny) UPDATE() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_UPDATEPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_UPDATEPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"UPDATE"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationErrorCode (leaf): Indicates the last BGP error sent or received on the peering
// session (based on whether this leaf is associated with
// sent or received messages).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-error-code"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-error-code"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPath) LastNotificationErrorCode() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorCodePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorCodePath{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-error-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationErrorCode (leaf): Indicates the last BGP error sent or received on the peering
// session (based on whether this leaf is associated with
// sent or received messages).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-error-code"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-error-code"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPathAny) LastNotificationErrorCode() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorCodePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorCodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-error-code"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationErrorSubcode (leaf): Indicates the last BGP error subcode sent or received on
// the peering session (based on whether this leaf is associated
// with sent or received messages)
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-error-subcode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-error-subcode"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPath) LastNotificationErrorSubcode() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorSubcodePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorSubcodePath{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-error-subcode"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationErrorSubcode (leaf): Indicates the last BGP error subcode sent or received on
// the peering session (based on whether this leaf is associated
// with sent or received messages)
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-error-subcode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-error-subcode"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPathAny) LastNotificationErrorSubcode() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorSubcodePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationErrorSubcodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-error-subcode"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationTime (leaf): This timestamp indicates the time that a NOTIFICATION
// message was sent or received on the peering session
// (based on whether this leaf is associated with
// sent or received messages).
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPath) LastNotificationTime() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationTimePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastNotificationTime (leaf): This timestamp indicates the time that a NOTIFICATION
// message was sent or received on the peering session
// (based on whether this leaf is associated with
// sent or received messages).
//
// The value is the timestamp in nanoseconds relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "last-notification-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/messages/sent/last-notification-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_Messages_SentPathAny) LastNotificationTime() *NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Messages_Sent_LastNotificationTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-notification-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_QueuesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_QueuesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_QueuesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_QueuesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Queues_InputPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues/input YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Queues_InputPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Queues_InputPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues/input YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Queues_InputPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Queues_OutputPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues/output YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Queues_OutputPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Queues_OutputPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues/output YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Queues_OutputPathAny struct {
	*ygot.NodePath
}

// Input (leaf): The number of messages received from the peer currently
// queued
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "input"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues/input"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_QueuesPath) Input() *NetworkInstance_Protocol_Bgp_Neighbor_Queues_InputPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Queues_InputPath{
		NodePath: ygot.NewNodePath(
			[]string{"input"},
			map[string]interface{}{},
			n,
		),
	}
}

// Input (leaf): The number of messages received from the peer currently
// queued
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "input"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues/input"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_QueuesPathAny) Input() *NetworkInstance_Protocol_Bgp_Neighbor_Queues_InputPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Queues_InputPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"input"},
			map[string]interface{}{},
			n,
		),
	}
}

// Output (leaf): The number of messages queued to be sent to the peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "output"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues/output"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_QueuesPath) Output() *NetworkInstance_Protocol_Bgp_Neighbor_Queues_OutputPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Queues_OutputPath{
		NodePath: ygot.NewNodePath(
			[]string{"output"},
			map[string]interface{}{},
			n,
		),
	}
}

// Output (leaf): The number of messages queued to be sent to the peer
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "output"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/state/queues/output"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_QueuesPathAny) Output() *NetworkInstance_Protocol_Bgp_Neighbor_Queues_OutputPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Queues_OutputPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"output"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClientPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector/config/route-reflector-client YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClientPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClientPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector/config/route-reflector-client YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClientPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClusterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector/config/route-reflector-cluster-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClusterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClusterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector/config/route-reflector-cluster-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClusterIdPathAny struct {
	*ygot.NodePath
}

// RouteReflectorClient (leaf): Configure the neighbor as a route reflector client.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-reflector-client"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector/config/route-reflector-client"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPath) RouteReflectorClient() *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClientPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClientPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-reflector-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflectorClient (leaf): Configure the neighbor as a route reflector client.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-reflector-client"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector/config/route-reflector-client"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPathAny) RouteReflectorClient() *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClientPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClientPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-reflector-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflectorClusterId (leaf): route-reflector cluster id to use when local router is
// configured as a route reflector.  Commonly set at the group
// level, but allows a different cluster
// id to be set for each neighbor.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-reflector-cluster-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector/config/route-reflector-cluster-id"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPath) RouteReflectorClusterId() *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClusterIdPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClusterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-reflector-cluster-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflectorClusterId (leaf): route-reflector cluster id to use when local router is
// configured as a route reflector.  Commonly set at the group
// level, but allows a different cluster
// id to be set for each neighbor.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-reflector-cluster-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/route-reflector/config/route-reflector-cluster-id"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflectorPathAny) RouteReflectorClusterId() *NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClusterIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_RouteReflector_RouteReflectorClusterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-reflector-cluster-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_TimersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_TimersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_ConnectRetryPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/connect-retry YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_ConnectRetryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_ConnectRetryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/connect-retry YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_ConnectRetryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_HoldTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/hold-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_HoldTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_HoldTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/hold-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_HoldTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_KeepaliveIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/keepalive-interval YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_KeepaliveIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_KeepaliveIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/keepalive-interval YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_KeepaliveIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_MinimumAdvertisementIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/minimum-advertisement-interval YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_MinimumAdvertisementIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_MinimumAdvertisementIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/minimum-advertisement-interval YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_MinimumAdvertisementIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_NegotiatedHoldTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/state/negotiated-hold-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_NegotiatedHoldTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_NegotiatedHoldTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/state/negotiated-hold-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_NegotiatedHoldTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_RestartTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_RestartTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Timers_RestartTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Timers_RestartTimePathAny struct {
	*ygot.NodePath
}

// ConnectRetry (leaf): Time interval in seconds between attempts to establish a
// session with the peer.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/connect-retry"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/connect-retry"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPath) ConnectRetry() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_ConnectRetryPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_ConnectRetryPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "connect-retry"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectRetry (leaf): Time interval in seconds between attempts to establish a
// session with the peer.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/connect-retry"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/connect-retry"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny) ConnectRetry() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_ConnectRetryPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_ConnectRetryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "connect-retry"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): Time interval in seconds that a BGP session will be
// considered active in the absence of keepalive or other
// messages from the peer.  The hold-time is typically
// set to 3x the keepalive-interval.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/hold-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPath) HoldTime() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_HoldTimePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_HoldTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): Time interval in seconds that a BGP session will be
// considered active in the absence of keepalive or other
// messages from the peer.  The hold-time is typically
// set to 3x the keepalive-interval.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/hold-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny) HoldTime() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_HoldTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_HoldTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeepaliveInterval (leaf): Time interval in seconds between transmission of keepalive
// messages to the neighbor.  Typically set to 1/3 the
// hold-time.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keepalive-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/keepalive-interval"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPath) KeepaliveInterval() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_KeepaliveIntervalPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_KeepaliveIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keepalive-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeepaliveInterval (leaf): Time interval in seconds between transmission of keepalive
// messages to the neighbor.  Typically set to 1/3 the
// hold-time.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keepalive-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/keepalive-interval"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny) KeepaliveInterval() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_KeepaliveIntervalPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_KeepaliveIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keepalive-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinimumAdvertisementInterval (leaf): Minimum time which must elapse between subsequent UPDATE
// messages relating to a common set of NLRI being transmitted
// to a peer. This timer is referred to as
// MinRouteAdvertisementIntervalTimer by RFC 4721 and serves to
// reduce the number of UPDATE messages transmitted when a
// particular set of NLRI exhibit instability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/minimum-advertisement-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/minimum-advertisement-interval"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPath) MinimumAdvertisementInterval() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_MinimumAdvertisementIntervalPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_MinimumAdvertisementIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "minimum-advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinimumAdvertisementInterval (leaf): Minimum time which must elapse between subsequent UPDATE
// messages relating to a common set of NLRI being transmitted
// to a peer. This timer is referred to as
// MinRouteAdvertisementIntervalTimer by RFC 4721 and serves to
// reduce the number of UPDATE messages transmitted when a
// particular set of NLRI exhibit instability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/minimum-advertisement-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/minimum-advertisement-interval"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny) MinimumAdvertisementInterval() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_MinimumAdvertisementIntervalPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_MinimumAdvertisementIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "minimum-advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// NegotiatedHoldTime (leaf): The negotiated hold-time for the BGP session
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/negotiated-hold-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/state/negotiated-hold-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPath) NegotiatedHoldTime() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_NegotiatedHoldTimePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_NegotiatedHoldTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "negotiated-hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NegotiatedHoldTime (leaf): The negotiated hold-time for the BGP session
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/negotiated-hold-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/state/negotiated-hold-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny) NegotiatedHoldTime() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_NegotiatedHoldTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_NegotiatedHoldTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "negotiated-hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Time interval in seconds after which the BGP session is
// re-established after being torn down due to exceeding any
// configured max prefix-limit.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPath) RestartTime() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_RestartTimePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_RestartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Time interval in seconds after which the BGP session is
// re-established after being torn down due to exceeding any
// configured max prefix-limit.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/timers/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TimersPathAny) RestartTime() *NetworkInstance_Protocol_Bgp_Neighbor_Timers_RestartTimePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Timers_RestartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_TransportPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_TransportPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/local-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/local-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalPortPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/local-port YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalPortPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalPortPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/local-port YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalPortPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_MtuDiscoveryPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/mtu-discovery YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_MtuDiscoveryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_MtuDiscoveryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/mtu-discovery YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_MtuDiscoveryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_PassiveModePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/passive-mode YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_PassiveModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_PassiveModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/passive-mode YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_PassiveModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemoteAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/remote-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemoteAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemoteAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/remote-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemoteAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemotePortPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/remote-port YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemotePortPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemotePortPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/remote-port YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemotePortPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_TcpMssPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/tcp-mss YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_TcpMssPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_Transport_TcpMssPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/tcp-mss YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_Transport_TcpMssPathAny struct {
	*ygot.NodePath
}

// LocalAddress (leaf): Set the local IP (either IPv4 or IPv6) address to use
// for the session when sending BGP update messages.  This
// may be expressed as either an IP address or reference
// to the name of an interface.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/local-address"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPath) LocalAddress() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalAddressPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): Set the local IP (either IPv4 or IPv6) address to use
// for the session when sending BGP update messages.  This
// may be expressed as either an IP address or reference
// to the name of an interface.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/local-address"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny) LocalAddress() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalPort (leaf): Local TCP port being used for the TCP session supporting
// the BGP session
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-port"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/local-port"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPath) LocalPort() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalPortPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalPort (leaf): Local TCP port being used for the TCP session supporting
// the BGP session
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-port"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/local-port"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny) LocalPort() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalPortPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_LocalPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtuDiscovery (leaf): Turns path mtu discovery for BGP TCP sessions on (true)
// or off (false)
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mtu-discovery"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/mtu-discovery"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPath) MtuDiscovery() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_MtuDiscoveryPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_MtuDiscoveryPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu-discovery"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtuDiscovery (leaf): Turns path mtu discovery for BGP TCP sessions on (true)
// or off (false)
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mtu-discovery"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/mtu-discovery"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny) MtuDiscovery() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_MtuDiscoveryPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_MtuDiscoveryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu-discovery"},
			map[string]interface{}{},
			n,
		),
	}
}

// PassiveMode (leaf): Wait for peers to issue requests to open a BGP session,
// rather than initiating sessions from the local router.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/passive-mode"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPath) PassiveMode() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_PassiveModePath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_PassiveModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// PassiveMode (leaf): Wait for peers to issue requests to open a BGP session,
// rather than initiating sessions from the local router.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/passive-mode"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny) PassiveMode() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_PassiveModePathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_PassiveModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): Remote address to which the BGP session has been
// established
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/remote-address"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPath) RemoteAddress() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemoteAddressPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemoteAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteAddress (leaf): Remote address to which the BGP session has been
// established
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/remote-address"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny) RemoteAddress() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemoteAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemoteAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemotePort (leaf): Remote port being used by the peer for the TCP session
// supporting the BGP session
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-port"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/remote-port"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPath) RemotePort() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemotePortPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemotePortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemotePort (leaf): Remote port being used by the peer for the TCP session
// supporting the BGP session
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-port"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/state/remote-port"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny) RemotePort() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemotePortPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_RemotePortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// TcpMss (leaf): Sets the max segment size for BGP TCP sessions.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/tcp-mss"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/tcp-mss"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPath) TcpMss() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_TcpMssPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_TcpMssPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tcp-mss"},
			map[string]interface{}{},
			n,
		),
	}
}

// TcpMss (leaf): Sets the max segment size for BGP TCP sessions.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/tcp-mss"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/transport/config/tcp-mss"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_TransportPathAny) TcpMss() *NetworkInstance_Protocol_Bgp_Neighbor_Transport_TcpMssPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_Transport_TcpMssPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tcp-mss"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EnabledPathAny struct {
	*ygot.NodePath
}

// Ebgp (container): Multipath configuration for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPath) Ebgp() *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ebgp (container): Multipath configuration for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-neighbor"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPathAny) Ebgp() *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPath) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePathsPathAny) Enabled() *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_Ebgp_AllowMultipleAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_Ebgp_AllowMultipleAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny struct {
	*ygot.NodePath
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPath) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_Ebgp_AllowMultipleAsPath {
	return &NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_Ebgp_AllowMultipleAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/neighbors/neighbor/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_EbgpPathAny) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny {
	return &NetworkInstance_Protocol_Bgp_Neighbor_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AuthPasswordPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AuthPasswordPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AuthPasswordPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AuthPasswordPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_DescriptionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/description YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_DescriptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_DescriptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/description YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_DescriptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_LocalAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/local-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_LocalAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_LocalAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/local-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_LocalAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_PeerAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_PeerAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_PeerAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_PeerAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_PeerGroupNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-group-name YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_PeerGroupNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_PeerGroupNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-group-name YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_PeerGroupNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_PeerTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-type YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_PeerTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_PeerTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-type YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_PeerTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RemovePrivateAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/remove-private-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RemovePrivateAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RemovePrivateAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/remove-private-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RemovePrivateAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RouteFlapDampingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/route-flap-damping YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RouteFlapDampingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RouteFlapDampingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/route-flap-damping YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RouteFlapDampingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_SendCommunityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/send-community YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_SendCommunityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_SendCommunityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/send-community YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_SendCommunityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_TotalPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/state/total-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_TotalPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_TotalPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/state/total-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_TotalPathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_TotalPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/state/total-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_TotalPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_TotalPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/state/total-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_TotalPrefixesPathAny struct {
	*ygot.NodePath
}

// AfiSafiAny (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi"
// AfiSafiName (wildcarded): E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) AfiSafiAny() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": "*"},
			n,
		),
	}
}

// AfiSafiAny (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi"
// AfiSafiName (wildcarded): E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) AfiSafiAny() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": "*"},
			n,
		),
	}
}

// AfiSafi (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi"
// AfiSafiName: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) AfiSafi(AfiSafiName E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": AfiSafiName},
			n,
		),
	}
}

// AfiSafi (list): AFI,SAFI configuration available for the
// neighbour or group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi"
// AfiSafiName: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) AfiSafi(AfiSafiName E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": AfiSafiName},
			n,
		),
	}
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) ApplyPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) ApplyPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// AsPathOptions (container): AS_PATH manipulation parameters for the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "as-path-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) AsPathOptions() *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"as-path-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// AsPathOptions (container): AS_PATH manipulation parameters for the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "as-path-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) AsPathOptions() *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"as-path-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): Configures an MD5 authentication password for use with
// neighboring devices.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/auth-password"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) AuthPassword() *NetworkInstance_Protocol_Bgp_PeerGroup_AuthPasswordPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AuthPasswordPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): Configures an MD5 authentication password for use with
// neighboring devices.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/auth-password"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) AuthPassword() *NetworkInstance_Protocol_Bgp_PeerGroup_AuthPasswordPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AuthPasswordPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): An optional textual description (intended primarily for use
// with a peer or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/description"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) Description() *NetworkInstance_Protocol_Bgp_PeerGroup_DescriptionPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): An optional textual description (intended primarily for use
// with a peer or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/description"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) Description() *NetworkInstance_Protocol_Bgp_PeerGroup_DescriptionPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// EbgpMultihop (container): eBGP multi-hop parameters for the BGPgroup
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp-multihop"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) EbgpMultihop() *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPath{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp-multihop"},
			map[string]interface{}{},
			n,
		),
	}
}

// EbgpMultihop (container): eBGP multi-hop parameters for the BGPgroup
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp-multihop"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) EbgpMultihop() *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp-multihop"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/enable-bfd"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) EnableBfd() *NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPath{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/enable-bfd"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) EnableBfd() *NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorHandling (container): Error handling parameters used for the BGP peer-group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-handling"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/error-handling"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) ErrorHandling() *NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPath{
		NodePath: ygot.NewNodePath(
			[]string{"error-handling"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorHandling (container): Error handling parameters used for the BGP peer-group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-handling"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/error-handling"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) ErrorHandling() *NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"error-handling"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating the graceful restart mechanism for BGP
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) GracefulRestart() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating the graceful restart mechanism for BGP
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) GracefulRestart() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAs (leaf): The local autonomous system number that is to be used
// when establishing sessions with the remote peer or peer
// group, if this differs from the global BGP router
// autonomous system number.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/local-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) LocalAs() *NetworkInstance_Protocol_Bgp_PeerGroup_LocalAsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_LocalAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAs (leaf): The local autonomous system number that is to be used
// when establishing sessions with the remote peer or peer
// group, if this differs from the global BGP router
// autonomous system number.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/local-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) LocalAs() *NetworkInstance_Protocol_Bgp_PeerGroup_LocalAsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_LocalAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoggingOptions (container): Logging options for events related to the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "logging-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/logging-options"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) LoggingOptions() *NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"logging-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoggingOptions (container): Logging options for events related to the BGP neighbor or
// group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "logging-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/logging-options"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) LoggingOptions() *NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"logging-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerAs (leaf): AS number of the peer.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) PeerAs() *NetworkInstance_Protocol_Bgp_PeerGroup_PeerAsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_PeerAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerAs (leaf): AS number of the peer.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) PeerAs() *NetworkInstance_Protocol_Bgp_PeerGroup_PeerAsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_PeerAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerGroupName (leaf): Name of the BGP peer-group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-group-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-group-name"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) PeerGroupName() *NetworkInstance_Protocol_Bgp_PeerGroup_PeerGroupNamePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_PeerGroupNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-group-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerGroupName (leaf): Name of the BGP peer-group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-group-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-group-name"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) PeerGroupName() *NetworkInstance_Protocol_Bgp_PeerGroup_PeerGroupNamePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_PeerGroupNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-group-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerType (leaf): Explicitly designate the peer or peer group as internal
// (iBGP) or external (eBGP).
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-type"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) PeerType() *NetworkInstance_Protocol_Bgp_PeerGroup_PeerTypePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_PeerTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerType (leaf): Explicitly designate the peer or peer group as internal
// (iBGP) or external (eBGP).
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/peer-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/peer-type"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) PeerType() *NetworkInstance_Protocol_Bgp_PeerGroup_PeerTypePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_PeerTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "peer-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemovePrivateAs (leaf): Remove private AS numbers from updates sent to peers - when
// this leaf is not specified, the AS_PATH attribute should be
// sent to the peer unchanged
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remove-private-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/remove-private-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) RemovePrivateAs() *NetworkInstance_Protocol_Bgp_PeerGroup_RemovePrivateAsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RemovePrivateAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remove-private-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemovePrivateAs (leaf): Remove private AS numbers from updates sent to peers - when
// this leaf is not specified, the AS_PATH attribute should be
// sent to the peer unchanged
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remove-private-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/remove-private-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) RemovePrivateAs() *NetworkInstance_Protocol_Bgp_PeerGroup_RemovePrivateAsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RemovePrivateAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remove-private-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteFlapDamping (leaf): Enable route flap damping.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-flap-damping"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/route-flap-damping"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) RouteFlapDamping() *NetworkInstance_Protocol_Bgp_PeerGroup_RouteFlapDampingPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RouteFlapDampingPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-flap-damping"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteFlapDamping (leaf): Enable route flap damping.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-flap-damping"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/route-flap-damping"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) RouteFlapDamping() *NetworkInstance_Protocol_Bgp_PeerGroup_RouteFlapDampingPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RouteFlapDampingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-flap-damping"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflector (container): Route reflector parameters for the BGPgroup
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-reflector"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) RouteReflector() *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPath{
		NodePath: ygot.NewNodePath(
			[]string{"route-reflector"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflector (container): Route reflector parameters for the BGPgroup
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-reflector"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) RouteReflector() *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"route-reflector"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendCommunity (leaf): Specify which types of community should be sent to the
// neighbor or group. The default is to not send the
// community attribute
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/send-community"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) SendCommunity() *NetworkInstance_Protocol_Bgp_PeerGroup_SendCommunityPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_SendCommunityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-community"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendCommunity (leaf): Specify which types of community should be sent to the
// neighbor or group. The default is to not send the
// community attribute
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/config/send-community"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) SendCommunity() *NetworkInstance_Protocol_Bgp_PeerGroup_SendCommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_SendCommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-community"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): Timers related to a BGP peer-group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) Timers() *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_TimersPath{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): Timers related to a BGP peer-group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) Timers() *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_TimersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPaths (leaf): Total number of BGP paths within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/state/total-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) TotalPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_TotalPathsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_TotalPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPaths (leaf): Total number of BGP paths within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/state/total-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) TotalPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_TotalPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_TotalPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPrefixes (leaf): Total number of BGP prefixes received within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/state/total-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) TotalPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_TotalPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_TotalPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalPrefixes (leaf): Total number of BGP prefixes received within the context
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/total-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/state/total-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) TotalPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_TotalPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_TotalPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): Transport session parameters for the BGP peer-group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transport"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) Transport() *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_TransportPath{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): Transport session parameters for the BGP peer-group
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transport"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) Transport() *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_TransportPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple paths for the
// same NLRI
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPath) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple paths for the
// same NLRI
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroupPathAny) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AfiSafiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/config/afi-safi-name YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AfiSafiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AfiSafiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/config/afi-safi-name YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AfiSafiNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_EnabledPathAny struct {
	*ygot.NodePath
}

// AddPaths (container): Parameters relating to the advertisement and receipt of
// multiple paths for a single NLRI (add-paths)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "add-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) AddPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"add-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// AddPaths (container): Parameters relating to the advertisement and receipt of
// multiple paths for a single NLRI (add-paths)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-structure"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "add-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) AddPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"add-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiSafiName (leaf): AFI,SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/config/afi-safi-name"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) AfiSafiName() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AfiSafiNamePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AfiSafiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiSafiName (leaf): AFI,SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/config/afi-safi-name"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) AfiSafiName() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AfiSafiNamePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AfiSafiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) ApplyPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ApplyPolicy (container): Anchor point for routing policies in the model.
// Import and export policies are with respect to the local
// routing table, i.e., export (send) and import (receive),
// depending on the context.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "apply-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) ApplyPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"apply-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether the AFI-SAFI is
// enabled for the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether the AFI-SAFI is
// enabled for the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating to BGP graceful-restart
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) GracefulRestart() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Parameters relating to BGP graceful-restart
// ----------------------------------------
// Defining module: "openconfig-bgp-peer-group"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/graceful-restart"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) GracefulRestart() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4LabeledUnicast (container): IPv4 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) Ipv4LabeledUnicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4LabeledUnicast (container): IPv4 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) Ipv4LabeledUnicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Unicast (container): IPv4 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) Ipv4Unicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Unicast (container): IPv4 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) Ipv4Unicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6LabeledUnicast (container): IPv6 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) Ipv6LabeledUnicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6LabeledUnicast (container): IPv6 Labeled Unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-labeled-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) Ipv6LabeledUnicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-labeled-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Unicast (container): IPv6 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) Ipv6Unicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Unicast (container): IPv6 unicast configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) Ipv6Unicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnEvpn (container): BGP EVPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-evpn"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) L2VpnEvpn() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPath{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnEvpn (container): BGP EVPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-evpn"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) L2VpnEvpn() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnVpls (container): BGP-signalled VPLS configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-vpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) L2VpnVpls() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-vpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnVpls (container): BGP-signalled VPLS configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-vpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) L2VpnVpls() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-vpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Multicast (container): Multicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) L3VpnIpv4Multicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Multicast (container): Multicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) L3VpnIpv4Multicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Unicast (container): Unicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) L3VpnIpv4Unicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv4Unicast (container): Unicast IPv4 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) L3VpnIpv4Unicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Multicast (container): Multicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) L3VpnIpv6Multicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Multicast (container): Multicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-multicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) L3VpnIpv6Multicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-multicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Unicast (container): Unicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) L3VpnIpv6Unicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L3VpnIpv6Unicast (container): Unicast IPv6 L3VPN configuration options
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l3vpn-ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) L3VpnIpv6Unicast() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l3vpn-ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv4 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv4 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv4"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) SrtePolicyIpv4() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4Path {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4Path{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv4 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv4 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv4"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) SrtePolicyIpv4() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4PathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv4"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv6 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv6 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv6"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) SrtePolicyIpv6() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6Path {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6Path{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrtePolicyIpv6 (container): Configuration and operational state parameters relating to
// the SR-TE Policy SAFI for IPv6 Unicast.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srte-policy-ipv6"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) SrtePolicyIpv6() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6PathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srte-policy-ipv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple paths for the
// same NLRI
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPath) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// UseMultiplePaths (container): Parameters related to the use of multiple paths for the
// same NLRI
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "use-multiple-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafiPathAny) UseMultiplePaths() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"use-multiple-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_EligiblePrefixPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_EligiblePrefixPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_ReceivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/receive YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_ReceivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_ReceivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/receive YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_ReceivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/send YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/send YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendMaxPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/send-max YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendMaxPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendMaxPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/send-max YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendMaxPathAny struct {
	*ygot.NodePath
}

// EligiblePrefixPolicy (leaf): A reference to a routing policy which can be used to
// restrict the prefixes for which add-paths is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/eligible-prefix-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPath) EligiblePrefixPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_EligiblePrefixPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_EligiblePrefixPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "eligible-prefix-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// EligiblePrefixPolicy (leaf): A reference to a routing policy which can be used to
// restrict the prefixes for which add-paths is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/eligible-prefix-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/eligible-prefix-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPathAny) EligiblePrefixPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_EligiblePrefixPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "eligible-prefix-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Receive (leaf): Enable capability negotiation to receive multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/receive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/receive"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPath) Receive() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_ReceivePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_ReceivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Receive (leaf): Enable capability negotiation to receive multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/receive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/receive"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPathAny) Receive() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_ReceivePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_ReceivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "receive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Send (leaf): Enable capability negotiation to send multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/send"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPath) Send() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send"},
			map[string]interface{}{},
			n,
		),
	}
}

// Send (leaf): Enable capability negotiation to send multiple path
// advertisements for an NLRI from the neighbor or group
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/send"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPathAny) Send() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendMax (leaf): The maximum total number of paths to advertise to neighbors
// for a single NLRI.  This includes the single best path as
// well as additional paths advertised when add-paths is
// enabled.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-max"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/send-max"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPath) SendMax() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendMaxPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendMaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-max"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendMax (leaf): The maximum total number of paths to advertise to neighbors
// for a single NLRI.  This includes the single best path as
// well as additional paths advertised when add-paths is
// enabled.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-max"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/add-paths/config/send-max"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPathsPathAny) SendMax() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendMaxPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_AddPaths_SendMaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-max"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ImportPolicyPathAny struct {
	*ygot.NodePath
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/default-export-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPath) DefaultExportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultExportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/default-export-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPathAny) DefaultExportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultExportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPath) DefaultImportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultImportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPathAny) DefaultImportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultImportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_DefaultImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/export-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPath) ExportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ExportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/export-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPathAny) ExportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ExportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPath) ImportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ImportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/apply-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicyPathAny) ImportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ImportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_ApplyPolicy_ImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestart_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestart_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestart_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestart_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): This leaf indicates whether graceful-restart is enabled for
// this AFI-SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPath) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestart_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestart_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): This leaf indicates whether graceful-restart is enabled for
// this AFI-SAFI
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestartPathAny) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestart_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_GracefulRestart_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_SendDefaultRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_SendDefaultRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPath) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_SendDefaultRoutePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_SendDefaultRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4UnicastPathAny) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_SendDefaultRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-labeled-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6LabeledUnicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_SendDefaultRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_SendDefaultRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/config/send-default-route YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPath) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_SendDefaultRoutePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_SendDefaultRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// SendDefaultRoute (leaf): If set to true, send the default-route to the neighbor(s)
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/send-default-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/config/send-default-route"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6UnicastPathAny) SendDefaultRoute() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_SendDefaultRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "send-default-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_Ipv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpnPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-evpn/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnEvpn_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVplsPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l2vpn-vpls/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L2VpnVpls_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4MulticastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Multicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv4-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv4Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6MulticastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-multicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Multicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPath) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPath) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6UnicastPathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/l3vpn-ipv6-unicast/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_L3VpnIpv6Unicast_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4 YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4 YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4PathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4Path) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4PathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4Path) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4PathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv4/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv4_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6 YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6 YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6PathAny struct {
	*ygot.NodePath
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6Path) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimit (container): Configure the maximum number of prefixes that will be
// accepted from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6PathAny) PrefixLimit() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6Path) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitReceived (container): Configure the maximum number of prefixes that will be
// received from a peer
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-limit-received"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6PathAny) PrefixLimitReceived() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-limit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimit_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny struct {
	*ygot.NodePath
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxPrefixes (leaf): Maximum number of prefixes that will be accepted
// from the neighbor
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/max-prefixes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) MaxPrefixes() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_MaxPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLimitExceeded (leaf): If set to true, the prefix-limit has been exceeded.  When the
// prefix-limit has been exceeded, the value of true must be retained
// until the restart-time has expired.  Prior to session re-establishment,
// the value must be reset to false
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-limit-exceeded"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/state/prefix-limit-exceeded"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) PrefixLimitExceeded() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PrefixLimitExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-limit-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreventTeardown (leaf): Do not tear down the BGP session when the maximum
// prefix limit is exceeded, but rather only log a
// warning. The default of this leaf is false, such
// that when it is not specified, the session is torn
// down.
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prevent-teardown"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/prevent-teardown"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) PreventTeardown() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_PreventTeardownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prevent-teardown"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPath) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningThresholdPct (leaf): Threshold on number of prefixes that can be received
// from a neighbor before generation of warning messages
// or log entries. Expressed as a percentage of
// max-prefixes
// ----------------------------------------
// Defining module: "openconfig-bgp-common-multiprotocol"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-threshold-pct"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/srte-policy-ipv6/prefix-limit-received/config/warning-threshold-pct"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceivedPathAny) WarningThresholdPct() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_SrtePolicyIpv6_PrefixLimitReceived_WarningThresholdPctPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-threshold-pct"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EnabledPathAny struct {
	*ygot.NodePath
}

// Ebgp (container): Multipath parameters for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPath) Ebgp() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ebgp (container): Multipath parameters for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPathAny) Ebgp() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPath) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPathAny) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ibgp (container): Multipath parameters for iBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ibgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ibgp"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPath) Ibgp() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ibgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ibgp (container): Multipath parameters for iBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ibgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ibgp"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePathsPathAny) Ibgp() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ibgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPathAny struct {
	*ygot.NodePath
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPath) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPathAny) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// BGP multipath. The default is use a single path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPath) MaximumPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// BGP multipath. The default is use a single path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ebgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_EbgpPathAny) MaximumPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ebgp_MaximumPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ibgp YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ibgp YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ibgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ibgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPathAny struct {
	*ygot.NodePath
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// iBGP multipath. The default is to use a single path
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ibgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPath) MaximumPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// iBGP multipath. The default is to use a single path
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/afi-safis/afi-safi/use-multiple-paths/ibgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_IbgpPathAny) MaximumPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AfiSafi_UseMultiplePaths_Ibgp_MaximumPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/default-export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ExportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ExportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ExportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/export-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ExportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ImportPolicyPathAny struct {
	*ygot.NodePath
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/default-export-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPath) DefaultExportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultExportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultExportPolicy (leaf): explicitly set a default policy if no policy definition
// in the export policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/default-export-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPathAny) DefaultExportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultExportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPath) DefaultImportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultImportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPathAny) DefaultImportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultImportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_DefaultImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/export-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPath) ExportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ExportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ExportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExportPolicy (leaf): list of policy names in sequence to be applied on
// sending a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/export-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/export-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPathAny) ExportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ExportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ExportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "export-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPath) ImportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ImportPolicyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/apply-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicyPathAny) ImportPolicy() *NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ImportPolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ApplyPolicy_ImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_AllowOwnAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/allow-own-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_AllowOwnAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_AllowOwnAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/allow-own-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_AllowOwnAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_DisablePeerAsFilterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/disable-peer-as-filter YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_DisablePeerAsFilterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_DisablePeerAsFilterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/disable-peer-as-filter YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_DisablePeerAsFilterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_ReplacePeerAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/replace-peer-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_ReplacePeerAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_ReplacePeerAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/replace-peer-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_ReplacePeerAsPathAny struct {
	*ygot.NodePath
}

// AllowOwnAs (leaf): Specify the number of occurrences of the local BGP speaker's
// AS that can occur within the AS_PATH before it is rejected.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-own-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/allow-own-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPath) AllowOwnAs() *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_AllowOwnAsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_AllowOwnAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-own-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllowOwnAs (leaf): Specify the number of occurrences of the local BGP speaker's
// AS that can occur within the AS_PATH before it is rejected.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-own-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/allow-own-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPathAny) AllowOwnAs() *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_AllowOwnAsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_AllowOwnAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-own-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisablePeerAsFilter (leaf): When set to true, the system advertises routes to a peer
// even if the peer's AS was in the AS path.  The default
// behavior (false) suppresses advertisements to peers if
// their AS number is in the AS path of the route.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-peer-as-filter"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/disable-peer-as-filter"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPath) DisablePeerAsFilter() *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_DisablePeerAsFilterPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_DisablePeerAsFilterPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-peer-as-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisablePeerAsFilter (leaf): When set to true, the system advertises routes to a peer
// even if the peer's AS was in the AS path.  The default
// behavior (false) suppresses advertisements to peers if
// their AS number is in the AS path of the route.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-peer-as-filter"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/disable-peer-as-filter"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPathAny) DisablePeerAsFilter() *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_DisablePeerAsFilterPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_DisablePeerAsFilterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-peer-as-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReplacePeerAs (leaf): Replace occurrences of the peer's AS in the AS_PATH
// with the local autonomous system number
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/replace-peer-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/replace-peer-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPath) ReplacePeerAs() *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_ReplacePeerAsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_ReplacePeerAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "replace-peer-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReplacePeerAs (leaf): Replace occurrences of the peer's AS in the AS_PATH
// with the local autonomous system number
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/replace-peer-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/as-path-options/config/replace-peer-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptionsPathAny) ReplacePeerAs() *NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_ReplacePeerAsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_AsPathOptions_ReplacePeerAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "replace-peer-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_MultihopTtlPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop/config/multihop-ttl YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_MultihopTtlPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_MultihopTtlPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop/config/multihop-ttl YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_MultihopTtlPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When enabled the referenced group or neighbors are permitted
// to be indirectly connected - including cases where the TTL
// can be decremented between the BGP peers
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPath) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When enabled the referenced group or neighbors are permitted
// to be indirectly connected - including cases where the TTL
// can be decremented between the BGP peers
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPathAny) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultihopTtl (leaf): Time-to-live value to use when packets are sent to the
// referenced group or neighbors and ebgp-multihop is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multihop-ttl"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop/config/multihop-ttl"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPath) MultihopTtl() *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_MultihopTtlPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_MultihopTtlPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multihop-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultihopTtl (leaf): Time-to-live value to use when packets are sent to the
// referenced group or neighbors and ebgp-multihop is enabled
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multihop-ttl"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/ebgp-multihop/config/multihop-ttl"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihopPathAny) MultihopTtl() *NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_MultihopTtlPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EbgpMultihop_MultihopTtlPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multihop-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfd_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfd_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfd_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfd_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPath) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfd_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfd_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfdPathAny) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfd_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_EnableBfd_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/error-handling YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/error-handling YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandling_TreatAsWithdrawPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/error-handling/config/treat-as-withdraw YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandling_TreatAsWithdrawPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandling_TreatAsWithdrawPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/error-handling/config/treat-as-withdraw YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandling_TreatAsWithdrawPathAny struct {
	*ygot.NodePath
}

// TreatAsWithdraw (leaf): Specify whether erroneous UPDATE messages for which the
// NLRI can be extracted are reated as though the NLRI is
// withdrawn - avoiding session reset
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/treat-as-withdraw"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/error-handling/config/treat-as-withdraw"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPath) TreatAsWithdraw() *NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandling_TreatAsWithdrawPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandling_TreatAsWithdrawPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "treat-as-withdraw"},
			map[string]interface{}{},
			n,
		),
	}
}

// TreatAsWithdraw (leaf): Specify whether erroneous UPDATE messages for which the
// NLRI can be extracted are reated as though the NLRI is
// withdrawn - avoiding session reset
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/treat-as-withdraw"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/error-handling/config/treat-as-withdraw"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandlingPathAny) TreatAsWithdraw() *NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandling_TreatAsWithdrawPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_ErrorHandling_TreatAsWithdrawPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "treat-as-withdraw"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_HelperOnlyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_HelperOnlyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_HelperOnlyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_HelperOnlyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_RestartTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_RestartTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_RestartTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_RestartTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_StaleRoutesTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/stale-routes-time YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_StaleRoutesTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_StaleRoutesTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/stale-routes-time YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_StaleRoutesTimePathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Enable or disable the graceful-restart capability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPath) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enable or disable the graceful-restart capability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPathAny) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Enable graceful-restart in helper mode only. When this
// leaf is set, the local system does not retain forwarding
// its own state during a restart, but supports procedures
// for the receiving speaker, as defined in RFC4724.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPath) HelperOnly() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_HelperOnlyPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_HelperOnlyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Enable graceful-restart in helper mode only. When this
// leaf is set, the local system does not retain forwarding
// its own state during a restart, but supports procedures
// for the receiving speaker, as defined in RFC4724.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPathAny) HelperOnly() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_HelperOnlyPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_HelperOnlyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Estimated time (in seconds) for the local BGP speaker to
// restart a session. This value is advertise in the graceful
// restart BGP capability.  This is a 12-bit value, referred to
// as Restart Time in RFC4724.  Per RFC4724, the suggested
// default value is <= the hold-time value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPath) RestartTime() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_RestartTimePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_RestartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Estimated time (in seconds) for the local BGP speaker to
// restart a session. This value is advertise in the graceful
// restart BGP capability.  This is a 12-bit value, referred to
// as Restart Time in RFC4724.  Per RFC4724, the suggested
// default value is <= the hold-time value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPathAny) RestartTime() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_RestartTimePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_RestartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaleRoutesTime (leaf): An upper-bound on the time thate stale routes will be
// retained by a router after a session is restarted. If an
// End-of-RIB (EOR) marker is received prior to this timer
// expiring stale-routes will be flushed upon its receipt - if
// no EOR is received, then when this timer expires stale paths
// will be purged. This timer is referred to as the
// Selection_Deferral_Timer in RFC4724
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/stale-routes-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/stale-routes-time"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPath) StaleRoutesTime() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_StaleRoutesTimePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_StaleRoutesTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "stale-routes-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaleRoutesTime (leaf): An upper-bound on the time thate stale routes will be
// retained by a router after a session is restarted. If an
// End-of-RIB (EOR) marker is received prior to this timer
// expiring stale-routes will be flushed upon its receipt - if
// no EOR is received, then when this timer expires stale paths
// will be purged. This timer is referred to as the
// Selection_Deferral_Timer in RFC4724
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/stale-routes-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/graceful-restart/config/stale-routes-time"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestartPathAny) StaleRoutesTime() *NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_StaleRoutesTimePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_GracefulRestart_StaleRoutesTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "stale-routes-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/logging-options YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/logging-options YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptions_LogNeighborStateChangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/logging-options/config/log-neighbor-state-changes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptions_LogNeighborStateChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptions_LogNeighborStateChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/logging-options/config/log-neighbor-state-changes YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptions_LogNeighborStateChangesPathAny struct {
	*ygot.NodePath
}

// LogNeighborStateChanges (leaf): Configure logging of peer state changes.  Default is
// to enable logging of peer state changes.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/log-neighbor-state-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/logging-options/config/log-neighbor-state-changes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPath) LogNeighborStateChanges() *NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptions_LogNeighborStateChangesPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptions_LogNeighborStateChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "log-neighbor-state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LogNeighborStateChanges (leaf): Configure logging of peer state changes.  Default is
// to enable logging of peer state changes.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/log-neighbor-state-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/logging-options/config/log-neighbor-state-changes"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptionsPathAny) LogNeighborStateChanges() *NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptions_LogNeighborStateChangesPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_LoggingOptions_LogNeighborStateChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "log-neighbor-state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClientPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector/config/route-reflector-client YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClientPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClientPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector/config/route-reflector-client YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClientPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClusterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector/config/route-reflector-cluster-id YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClusterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClusterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector/config/route-reflector-cluster-id YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClusterIdPathAny struct {
	*ygot.NodePath
}

// RouteReflectorClient (leaf): Configure the neighbor as a route reflector client.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-reflector-client"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector/config/route-reflector-client"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPath) RouteReflectorClient() *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClientPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClientPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-reflector-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflectorClient (leaf): Configure the neighbor as a route reflector client.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-reflector-client"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector/config/route-reflector-client"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPathAny) RouteReflectorClient() *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClientPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClientPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-reflector-client"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflectorClusterId (leaf): route-reflector cluster id to use when local router is
// configured as a route reflector.  Commonly set at the group
// level, but allows a different cluster
// id to be set for each neighbor.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-reflector-cluster-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector/config/route-reflector-cluster-id"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPath) RouteReflectorClusterId() *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClusterIdPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClusterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-reflector-cluster-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteReflectorClusterId (leaf): route-reflector cluster id to use when local router is
// configured as a route reflector.  Commonly set at the group
// level, but allows a different cluster
// id to be set for each neighbor.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/route-reflector-cluster-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/route-reflector/config/route-reflector-cluster-id"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflectorPathAny) RouteReflectorClusterId() *NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClusterIdPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_RouteReflector_RouteReflectorClusterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "route-reflector-cluster-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_TimersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_TimersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_TimersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_TimersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_ConnectRetryPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/connect-retry YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_ConnectRetryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_ConnectRetryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/connect-retry YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_ConnectRetryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_HoldTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/hold-time YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_HoldTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_HoldTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/hold-time YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_HoldTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_KeepaliveIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/keepalive-interval YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_KeepaliveIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_KeepaliveIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/keepalive-interval YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_KeepaliveIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_MinimumAdvertisementIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/minimum-advertisement-interval YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_MinimumAdvertisementIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_MinimumAdvertisementIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/minimum-advertisement-interval YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_MinimumAdvertisementIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_RestartTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_RestartTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Timers_RestartTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/restart-time YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Timers_RestartTimePathAny struct {
	*ygot.NodePath
}

// ConnectRetry (leaf): Time interval in seconds between attempts to establish a
// session with the peer.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/connect-retry"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/connect-retry"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPath) ConnectRetry() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_ConnectRetryPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_ConnectRetryPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "connect-retry"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectRetry (leaf): Time interval in seconds between attempts to establish a
// session with the peer.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/connect-retry"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/connect-retry"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPathAny) ConnectRetry() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_ConnectRetryPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_ConnectRetryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "connect-retry"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): Time interval in seconds that a BGP session will be
// considered active in the absence of keepalive or other
// messages from the peer.  The hold-time is typically
// set to 3x the keepalive-interval.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/hold-time"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPath) HoldTime() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_HoldTimePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_HoldTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): Time interval in seconds that a BGP session will be
// considered active in the absence of keepalive or other
// messages from the peer.  The hold-time is typically
// set to 3x the keepalive-interval.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hold-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/hold-time"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPathAny) HoldTime() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_HoldTimePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_HoldTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeepaliveInterval (leaf): Time interval in seconds between transmission of keepalive
// messages to the neighbor.  Typically set to 1/3 the
// hold-time.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keepalive-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/keepalive-interval"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPath) KeepaliveInterval() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_KeepaliveIntervalPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_KeepaliveIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keepalive-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeepaliveInterval (leaf): Time interval in seconds between transmission of keepalive
// messages to the neighbor.  Typically set to 1/3 the
// hold-time.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keepalive-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/keepalive-interval"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPathAny) KeepaliveInterval() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_KeepaliveIntervalPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_KeepaliveIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keepalive-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinimumAdvertisementInterval (leaf): Minimum time which must elapse between subsequent UPDATE
// messages relating to a common set of NLRI being transmitted
// to a peer. This timer is referred to as
// MinRouteAdvertisementIntervalTimer by RFC 4721 and serves to
// reduce the number of UPDATE messages transmitted when a
// particular set of NLRI exhibit instability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/minimum-advertisement-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/minimum-advertisement-interval"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPath) MinimumAdvertisementInterval() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_MinimumAdvertisementIntervalPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_MinimumAdvertisementIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "minimum-advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinimumAdvertisementInterval (leaf): Minimum time which must elapse between subsequent UPDATE
// messages relating to a common set of NLRI being transmitted
// to a peer. This timer is referred to as
// MinRouteAdvertisementIntervalTimer by RFC 4721 and serves to
// reduce the number of UPDATE messages transmitted when a
// particular set of NLRI exhibit instability.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/minimum-advertisement-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/minimum-advertisement-interval"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPathAny) MinimumAdvertisementInterval() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_MinimumAdvertisementIntervalPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_MinimumAdvertisementIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "minimum-advertisement-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Time interval in seconds after which the BGP session is
// re-established after being torn down due to exceeding any
// configured max prefix-limit.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPath) RestartTime() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_RestartTimePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_RestartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartTime (leaf): Time interval in seconds after which the BGP session is
// re-established after being torn down due to exceeding any
// configured max prefix-limit.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/restart-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/timers/config/restart-time"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TimersPathAny) RestartTime() *NetworkInstance_Protocol_Bgp_PeerGroup_Timers_RestartTimePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Timers_RestartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "restart-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_TransportPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_TransportPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_TransportPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_TransportPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Transport_LocalAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/local-address YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Transport_LocalAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Transport_LocalAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/local-address YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Transport_LocalAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Transport_MtuDiscoveryPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/mtu-discovery YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Transport_MtuDiscoveryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Transport_MtuDiscoveryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/mtu-discovery YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Transport_MtuDiscoveryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Transport_PassiveModePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/passive-mode YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Transport_PassiveModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Transport_PassiveModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/passive-mode YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Transport_PassiveModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Transport_TcpMssPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/tcp-mss YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Transport_TcpMssPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_Transport_TcpMssPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/tcp-mss YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_Transport_TcpMssPathAny struct {
	*ygot.NodePath
}

// LocalAddress (leaf): Set the local IP (either IPv4 or IPv6) address to use
// for the session when sending BGP update messages.  This
// may be expressed as either an IP address or reference
// to the name of an interface.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/local-address"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPath) LocalAddress() *NetworkInstance_Protocol_Bgp_PeerGroup_Transport_LocalAddressPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Transport_LocalAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalAddress (leaf): Set the local IP (either IPv4 or IPv6) address to use
// for the session when sending BGP update messages.  This
// may be expressed as either an IP address or reference
// to the name of an interface.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/local-address"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPathAny) LocalAddress() *NetworkInstance_Protocol_Bgp_PeerGroup_Transport_LocalAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Transport_LocalAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtuDiscovery (leaf): Turns path mtu discovery for BGP TCP sessions on (true)
// or off (false)
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mtu-discovery"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/mtu-discovery"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPath) MtuDiscovery() *NetworkInstance_Protocol_Bgp_PeerGroup_Transport_MtuDiscoveryPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Transport_MtuDiscoveryPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu-discovery"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtuDiscovery (leaf): Turns path mtu discovery for BGP TCP sessions on (true)
// or off (false)
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mtu-discovery"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/mtu-discovery"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPathAny) MtuDiscovery() *NetworkInstance_Protocol_Bgp_PeerGroup_Transport_MtuDiscoveryPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Transport_MtuDiscoveryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mtu-discovery"},
			map[string]interface{}{},
			n,
		),
	}
}

// PassiveMode (leaf): Wait for peers to issue requests to open a BGP session,
// rather than initiating sessions from the local router.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/passive-mode"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPath) PassiveMode() *NetworkInstance_Protocol_Bgp_PeerGroup_Transport_PassiveModePath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Transport_PassiveModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// PassiveMode (leaf): Wait for peers to issue requests to open a BGP session,
// rather than initiating sessions from the local router.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/passive-mode"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPathAny) PassiveMode() *NetworkInstance_Protocol_Bgp_PeerGroup_Transport_PassiveModePathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Transport_PassiveModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// TcpMss (leaf): Sets the max segment size for BGP TCP sessions.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/tcp-mss"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/tcp-mss"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPath) TcpMss() *NetworkInstance_Protocol_Bgp_PeerGroup_Transport_TcpMssPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Transport_TcpMssPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tcp-mss"},
			map[string]interface{}{},
			n,
		),
	}
}

// TcpMss (leaf): Sets the max segment size for BGP TCP sessions.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/tcp-mss"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/transport/config/tcp-mss"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_TransportPathAny) TcpMss() *NetworkInstance_Protocol_Bgp_PeerGroup_Transport_TcpMssPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_Transport_TcpMssPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tcp-mss"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/config/enabled YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EnabledPathAny struct {
	*ygot.NodePath
}

// Ebgp (container): Multipath parameters for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPath) Ebgp() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ebgp (container): Multipath parameters for eBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ebgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPathAny) Ebgp() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ebgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPath) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EnabledPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Whether the use of multiple paths for the same NLRI is
// enabled for the neighbor. This value is overridden by
// any more specific configuration value.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/config/enabled"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPathAny) Enabled() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EnabledPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ibgp (container): Multipath parameters for iBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ibgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ibgp"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPath) Ibgp() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ibgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ibgp (container): Multipath parameters for iBGP
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ibgp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ibgp"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePathsPathAny) Ibgp() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ibgp"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_AllowMultipleAsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_AllowMultipleAsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp/config/allow-multiple-as YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_MaximumPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_MaximumPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_MaximumPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_MaximumPathsPathAny struct {
	*ygot.NodePath
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPath) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_AllowMultipleAsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_AllowMultipleAsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllowMultipleAs (leaf): Allow multipath to use paths from different neighbouring
// ASes.  The default is to only consider multiple paths from
// the same neighbouring AS.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/allow-multiple-as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp/config/allow-multiple-as"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPathAny) AllowMultipleAs() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_AllowMultipleAsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allow-multiple-as"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// BGP multipath. The default is use a single path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPath) MaximumPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_MaximumPathsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_MaximumPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// BGP multipath. The default is use a single path.
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ebgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_EbgpPathAny) MaximumPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_MaximumPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ebgp_MaximumPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ibgp YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ibgp YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ibgp_MaximumPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ibgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ibgp_MaximumPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ibgp_MaximumPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ibgp/config/maximum-paths YANG schema element.
type NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ibgp_MaximumPathsPathAny struct {
	*ygot.NodePath
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// iBGP multipath. The default is to use a single path
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ibgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPath) MaximumPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ibgp_MaximumPathsPath {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ibgp_MaximumPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumPaths (leaf): Maximum number of parallel paths to consider when using
// iBGP multipath. The default is to use a single path
// ----------------------------------------
// Defining module: "openconfig-bgp-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/peer-groups/peer-group/use-multiple-paths/ibgp/config/maximum-paths"
func (n *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_IbgpPathAny) MaximumPaths() *NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ibgp_MaximumPathsPathAny {
	return &NetworkInstance_Protocol_Bgp_PeerGroup_UseMultiplePaths_Ibgp_MaximumPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_RibPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib YANG schema element.
type NetworkInstance_Protocol_Bgp_RibPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_RibPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib YANG schema element.
type NetworkInstance_Protocol_Bgp_RibPathAny struct {
	*ygot.NodePath
}

// AfiSafiAny (list): list of afi-safi types
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi"
// AfiSafiName (wildcarded): E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_RibPath) AfiSafiAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": "*"},
			n,
		),
	}
}

// AfiSafiAny (list): list of afi-safi types
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi"
// AfiSafiName (wildcarded): E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_RibPathAny) AfiSafiAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": "*"},
			n,
		),
	}
}

// AfiSafi (list): list of afi-safi types
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi"
// AfiSafiName: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_RibPath) AfiSafi(AfiSafiName E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": AfiSafiName},
			n,
		),
	}
}

// AfiSafi (list): list of afi-safi types
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safis/afi-safi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi"
// AfiSafiName: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_RibPathAny) AfiSafi(AfiSafiName E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safis", "afi-safi"},
			map[string]interface{}{"afi-safi-name": AfiSafiName},
			n,
		),
	}
}

// AttrSetAny (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "attr-sets/attr-set"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set"
// Index (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_RibPath) AttrSetAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"attr-sets", "attr-set"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// AttrSetAny (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "attr-sets/attr-set"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set"
// Index (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_RibPathAny) AttrSetAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"attr-sets", "attr-set"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// AttrSet (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "attr-sets/attr-set"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set"
// Index: uint64
func (n *NetworkInstance_Protocol_Bgp_RibPath) AttrSet(Index uint64) *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"attr-sets", "attr-set"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// AttrSet (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "attr-sets/attr-set"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set"
// Index: uint64
func (n *NetworkInstance_Protocol_Bgp_RibPathAny) AttrSet(Index uint64) *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"attr-sets", "attr-set"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// CommunityAny (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "communities/community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community"
// Index (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_RibPath) CommunityAny() *NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"communities", "community"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// CommunityAny (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "communities/community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community"
// Index (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_RibPathAny) CommunityAny() *NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"communities", "community"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// Community (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "communities/community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community"
// Index: uint64
func (n *NetworkInstance_Protocol_Bgp_RibPath) Community(Index uint64) *NetworkInstance_Protocol_Bgp_Rib_CommunityPath {
	return &NetworkInstance_Protocol_Bgp_Rib_CommunityPath{
		NodePath: ygot.NewNodePath(
			[]string{"communities", "community"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Community (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "communities/community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community"
// Index: uint64
func (n *NetworkInstance_Protocol_Bgp_RibPathAny) Community(Index uint64) *NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"communities", "community"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// ExtCommunityAny (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ext-communities/ext-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community"
// Index (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_RibPath) ExtCommunityAny() *NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ext-communities", "ext-community"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// ExtCommunityAny (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ext-communities/ext-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community"
// Index (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_RibPathAny) ExtCommunityAny() *NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ext-communities", "ext-community"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// ExtCommunity (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ext-communities/ext-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community"
// Index: uint64
func (n *NetworkInstance_Protocol_Bgp_RibPath) ExtCommunity(Index uint64) *NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPath {
	return &NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPath{
		NodePath: ygot.NewNodePath(
			[]string{"ext-communities", "ext-community"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// ExtCommunity (list): List of path attributes that may be in use by multiple
// routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ext-communities/ext-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community"
// Index: uint64
func (n *NetworkInstance_Protocol_Bgp_RibPathAny) ExtCommunity(Index uint64) *NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ext-communities", "ext-community"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_AfiSafiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/state/afi-safi-name YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_AfiSafiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_AfiSafiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/state/afi-safi-name YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_AfiSafiNamePathAny struct {
	*ygot.NodePath
}

// AfiSafiName (leaf): AFI,SAFI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/afi-safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/state/afi-safi-name"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath) AfiSafiName() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_AfiSafiNamePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_AfiSafiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "afi-safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiSafiName (leaf): AFI,SAFI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/afi-safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/state/afi-safi-name"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny) AfiSafiName() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_AfiSafiNamePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_AfiSafiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "afi-safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SrtePolicy (container): Routing tables for the IPv4 Unicast, SR-TE Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-srte-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath) Ipv4SrtePolicy() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-srte-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SrtePolicy (container): Routing tables for the IPv4 Unicast, SR-TE Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-srte-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny) Ipv4SrtePolicy() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-srte-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Unicast (container): Routing tables for IPv4 unicast -- active when the
// afi-safi name is ipv4-unicast
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath) Ipv4Unicast() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Unicast (container): Routing tables for IPv4 unicast -- active when the
// afi-safi name is ipv4-unicast
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny) Ipv4Unicast() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SrtePolicy (container): Routing tables for the IPv6 Unicast, SR-TE Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-srte-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath) Ipv6SrtePolicy() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-srte-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SrtePolicy (container): Routing tables for the IPv6 Unicast, SR-TE Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-srte-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny) Ipv6SrtePolicy() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-srte-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Unicast (container): Routing tables for IPv6 unicast -- active when the
// afi-safi name is ipv6-unicast
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath) Ipv6Unicast() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Unicast (container): Routing tables for IPv6 unicast -- active when the
// afi-safi name is ipv6-unicast
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-unicast"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny) Ipv6Unicast() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-unicast"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnEvpn (container): Routing tables for l2vpn evpn -- active when the
// afi-safi name is l2vpn-evpn
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-evpn"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPath) L2VpnEvpn() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPath{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// L2VpnEvpn (container): Routing tables for l2vpn evpn -- active when the
// afi-safi name is l2vpn-evpn
// ----------------------------------------
// Defining module: "openconfig-rib-bgp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "l2vpn-evpn"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafiPathAny) L2VpnEvpn() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"l2vpn-evpn"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPathAny struct {
	*ygot.NodePath
}

// LocRib (container): The Loc-RIB for the SR-TE Policy SAFI for IPv4 or IPv6 Unicast
// AFIs.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPath) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPath{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocRib (container): The Loc-RIB for the SR-TE Policy SAFI for IPv4 or IPv6 Unicast
// AFIs.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPathAny) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): An individual neighbour that is enabled for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPath) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// NeighborAny (list): An individual neighbour that is enabled for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPathAny) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// Neighbor (list): An individual neighbour that is enabled for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPath) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// Neighbor (list): An individual neighbour that is enabled for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicyPathAny) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): Route within the specified address family for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): Route within the specified address family for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRibPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_NeighborAddressPathAny struct {
	*ygot.NodePath
}

// AdjRibInPost (container): The Adj-RIB-In for the SR-TE Policy SAFI for the neighbour,
// following any inbound policy constraints or modifications
// being made.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPath) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPost (container): The Adj-RIB-In for the SR-TE Policy SAFI for the neighbour,
// following any inbound policy constraints or modifications
// being made.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): The Adj-RIB-In for the SR-TE Policy SAFI for the neighbour,
// prior to any inbound policy constraints or modifications
// having been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPath) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): The Adj-RIB-In for the SR-TE Policy SAFI for the neighbour,
// prior to any inbound policy constraints or modifications
// having been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): The Adj-RIB-Out for the SR-TE Policy SAFI for the neighbour,
// follow any outbound policy constraints or modifications being
// made.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPath) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): The Adj-RIB-Out for the SR-TE Policy SAFI for the neighbour,
// follow any outbound policy constraints or modifications being
// made.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): The Adj-RIB-Out for the SR-TE Policy SAFI for the neighbour,
// prior to any outgoing policy modifications or constraints
// having been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPath) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): The Adj-RIB-Out for the SR-TE Policy SAFI for the neighbour,
// prior to any outgoing policy modifications or constraints
// having been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): The address of the neighbour for which the SR-TE policy
// SAFI has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPath) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_NeighborAddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): The address of the neighbour for which the SR-TE policy
// SAFI has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_NeighborPathAny) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): The routes that are in the Adj-RIB-In-Post for the specified
// BGP neighbour within the SR-TE Policy SAFI for the specified
// address family.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): The routes that are in the Adj-RIB-In-Post for the specified
// BGP neighbour within the SR-TE Policy SAFI for the specified
// address family.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPostPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// BestPath (leaf): Current path was selected as the best path.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/best-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) BestPath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "best-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// BestPath (leaf): Current path was selected as the best path.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/best-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) BestPath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "best-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePathAny struct {
	*ygot.NodePath
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPrePathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPostPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePathAny struct {
	*ygot.NodePath
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPrePathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPathAny struct {
	*ygot.NodePath
}

// LocRib (container): Container for the IPv4 BGP LOC-RIB data
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPath) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPath{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocRib (container): Container for the IPv4 BGP LOC-RIB data
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPathAny) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPath) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPathAny) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// Neighbor (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPath) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// Neighbor (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4UnicastPathAny) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table, keyed by the route
// prefix, the route origin, and path-id.  The route
// origin can be either the neighbor address from which
// the route was learned, or the source protocol that
// injected the route.  The path-id distinguishes routes
// for the same prefix received from a neighbor (e.g.,
// if add-paths is eanbled).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "origin": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table, keyed by the route
// prefix, the route origin, and path-id.  The route
// origin can be either the neighbor address from which
// the route was learned, or the source protocol that
// injected the route.  The path-id distinguishes routes
// for the same prefix received from a neighbor (e.g.,
// if add-paths is eanbled).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRibPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "origin": "*", "path-id": "*"},
			n,
		),
	}
}

// WithPrefix sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny's key "prefix" to the specified value.
// Prefix: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) WithPrefix(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "prefix", Prefix)
	return n
}

// WithOrigin sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny's key "origin" to the specified value.
// Origin: [UnionString, E_PolicyTypes_INSTALL_PROTOCOL_TYPE]
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) WithOrigin(Origin NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_Origin_Union) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "origin", Origin)
	return n
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_OriginPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/origin YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_OriginPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_OriginPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/origin YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_OriginPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): Indicates the origin of the route.  If the route is learned
// from a neighbor, this value is the neighbor address.  If
// the route was injected or redistributed from another
// protocol, the origin indicates the source protocol for the
// route.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/origin"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) Origin() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_OriginPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): Indicates the origin of the route.  If the route is learned
// from a neighbor, this value is the neighbor address.  If
// the route was injected or redistributed from another
// protocol, the origin indicates the source protocol for the
// route.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/origin"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) Origin() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_OriginPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): If the route is learned from a neighbor, the path-id
// corresponds to the path-id for the route in the
// corresponding adj-rib-in-post table.  If the route is
// injected from another protocol, or the neighbor does not
// support BGP add-paths, the path-id should be set
// to zero, also the default value.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): If the route is learned from a neighbor, the path-id
// corresponds to the path-id for the route in the
// corresponding adj-rib-in-post table.  If the route is
// injected from another protocol, or the neighbor does not
// support BGP add-paths, the path-id should be set
// to zero, also the default value.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv4 prefix corresponding to the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv4 prefix corresponding to the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_LocRib_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_NeighborAddressPathAny struct {
	*ygot.NodePath
}

// AdjRibInPost (container): Per-neighbor table containing the paths received from
// the neighbor that are eligible for best-path selection
// after local input policy rules have been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPath) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPost (container): Per-neighbor table containing the paths received from
// the neighbor that are eligible for best-path selection
// after local input policy rules have been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): Per-neighbor table containing the NLRI updates
// received from the neighbor before any local input
// policy rules or filters have been applied.  This can
// be considered the 'raw' updates from the neighbor.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPath) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): Per-neighbor table containing the NLRI updates
// received from the neighbor before any local input
// policy rules or filters have been applied.  This can
// be considered the 'raw' updates from the neighbor.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor after output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPath) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor after output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor before output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPath) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor before output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): IP address of the BGP neighbor or peer
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPath) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_NeighborAddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): IP address of the BGP neighbor or peer
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_NeighborPathAny) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPath) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPathAny) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPath) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPathAny) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPath) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPostPathAny) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_BestPathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_BestPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_BestPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_BestPathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// BestPath (leaf): Current path was selected as the best path.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/best-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) BestPath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_BestPathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_BestPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "best-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// BestPath (leaf): Current path was selected as the best path.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/best-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) BestPath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_BestPathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_BestPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "best-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePath) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePathAny) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePath) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePathAny) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePath) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPrePathAny) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPath) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPathAny) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPath) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPathAny) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPath) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPostPathAny) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePath) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePathAny) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePath) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePathAny) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePath) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table, keyed by a combination of
// the route prefix and path-id to distinguish multiple
// routes received from a neighbor for the same prefix,
// e.g., when BGP add-paths is enabled.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPrePathAny) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv4-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv4Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPathAny struct {
	*ygot.NodePath
}

// LocRib (container): The Loc-RIB for the SR-TE Policy SAFI for IPv4 or IPv6 Unicast
// AFIs.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPath) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPath{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocRib (container): The Loc-RIB for the SR-TE Policy SAFI for IPv4 or IPv6 Unicast
// AFIs.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPathAny) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): An individual neighbour that is enabled for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPath) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// NeighborAny (list): An individual neighbour that is enabled for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPathAny) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// Neighbor (list): An individual neighbour that is enabled for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPath) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// Neighbor (list): An individual neighbour that is enabled for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicyPathAny) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): Route within the specified address family for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): Route within the specified address family for the SR-TE
// Policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRibPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_LocRib_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_NeighborAddressPathAny struct {
	*ygot.NodePath
}

// AdjRibInPost (container): The Adj-RIB-In for the SR-TE Policy SAFI for the neighbour,
// following any inbound policy constraints or modifications
// being made.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPath) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPost (container): The Adj-RIB-In for the SR-TE Policy SAFI for the neighbour,
// following any inbound policy constraints or modifications
// being made.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): The Adj-RIB-In for the SR-TE Policy SAFI for the neighbour,
// prior to any inbound policy constraints or modifications
// having been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPath) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): The Adj-RIB-In for the SR-TE Policy SAFI for the neighbour,
// prior to any inbound policy constraints or modifications
// having been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): The Adj-RIB-Out for the SR-TE Policy SAFI for the neighbour,
// follow any outbound policy constraints or modifications being
// made.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPath) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): The Adj-RIB-Out for the SR-TE Policy SAFI for the neighbour,
// follow any outbound policy constraints or modifications being
// made.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): The Adj-RIB-Out for the SR-TE Policy SAFI for the neighbour,
// prior to any outgoing policy modifications or constraints
// having been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPath) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): The Adj-RIB-Out for the SR-TE Policy SAFI for the neighbour,
// prior to any outgoing policy modifications or constraints
// having been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): The address of the neighbour for which the SR-TE policy
// SAFI has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPath) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_NeighborAddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): The address of the neighbour for which the SR-TE policy
// SAFI has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_NeighborPathAny) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): The routes that are in the Adj-RIB-In-Post for the specified
// BGP neighbour within the SR-TE Policy SAFI for the specified
// address family.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): The routes that are in the Adj-RIB-In-Post for the specified
// BGP neighbour within the SR-TE Policy SAFI for the specified
// address family.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPostPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// BestPath (leaf): Current path was selected as the best path.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/best-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) BestPath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "best-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// BestPath (leaf): Current path was selected as the best path.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/best-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) BestPath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_BestPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "best-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePathAny struct {
	*ygot.NodePath
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPrePathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPostPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePathAny struct {
	*ygot.NodePath
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// RouteAny (list): The routes within the SR-TE Policy SAFI Adj-RIB. The
// routes are keyed on the path-id - set to a non-zero
// value only if ADD-PATHS is being used; the color; and
// the endpoint. The colour and endpoint are extracted from
// the NLRI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPrePathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"path-id": "*", "endpoint": "*", "color": "*"},
			n,
		),
	}
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// WithEndpoint sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny's key "endpoint" to the specified value.
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) WithEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "endpoint", Endpoint)
	return n
}

// WithColor sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny's key "color" to the specified value.
// Color: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) WithColor(Color uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "color", Color)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/color YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): A 4-octet value identifying the policy. Combined with the endpoint
// the endpoint and colour represent the unique policy.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/color"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) Color() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): A unique identifier for the remote set of nodes. When the address
// family is IPv4, the value is a 4-octet IPv4 address. When the
// address family is IPv6, the value is a 16-octet IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): Identifier for the path when using BGP ADD-PATHS for the SR-TE
// policy SAFI.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-srte-policy/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6SrtePolicy_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPathAny struct {
	*ygot.NodePath
}

// LocRib (container): Container for the IPv6 BGP LOC-RIB data
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPath) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPath{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocRib (container): Container for the IPv6 BGP LOC-RIB data
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPathAny) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPath) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPathAny) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// Neighbor (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPath) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// Neighbor (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6UnicastPathAny) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table, keyed by the route
// prefix, the route origin, and path-id.  The route
// origin can be either the neighbor address from which
// the route was learned, or the source protocol that
// injected the route.  The path-id distinguishes routes
// for the same prefix received from a neighbor (e.g.,
// if add-paths is eanbled).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "origin": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table, keyed by the route
// prefix, the route origin, and path-id.  The route
// origin can be either the neighbor address from which
// the route was learned, or the source protocol that
// injected the route.  The path-id distinguishes routes
// for the same prefix received from a neighbor (e.g.,
// if add-paths is eanbled).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRibPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "origin": "*", "path-id": "*"},
			n,
		),
	}
}

// WithPrefix sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny's key "prefix" to the specified value.
// Prefix: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) WithPrefix(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "prefix", Prefix)
	return n
}

// WithOrigin sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny's key "origin" to the specified value.
// Origin: [UnionString, E_PolicyTypes_INSTALL_PROTOCOL_TYPE]
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) WithOrigin(Origin NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_Origin_Union) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "origin", Origin)
	return n
}

// WithPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny's key "path-id" to the specified value.
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) WithPathId(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny {
	ygot.ModifyKey(n.NodePath, "path-id", PathId)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_OriginPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/origin YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_OriginPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_OriginPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/origin YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_OriginPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): Indicates the origin of the route.  If the route is learned
// from a neighbor, this value is the neighbor address.  If
// the route was injected or redistributed from another
// protocol, the origin indicates the source protocol for the
// route.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/origin"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) Origin() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_OriginPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): Indicates the origin of the route.  If the route is learned
// from a neighbor, this value is the neighbor address.  If
// the route was injected or redistributed from another
// protocol, the origin indicates the source protocol for the
// route.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/origin"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) Origin() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_OriginPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): If the route is learned from a neighbor, the path-id
// corresponds to the path-id for the route in the
// corresponding adj-rib-in-post table.  If the route is
// injected from another protocol, or the neighbor does not
// support BGP add-paths, the path-id should be set
// to zero, also the default value.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): If the route is learned from a neighbor, the path-id
// corresponds to the path-id for the route in the
// corresponding adj-rib-in-post table.  If the route is
// injected from another protocol, or the neighbor does not
// support BGP add-paths, the path-id should be set
// to zero, also the default value.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv6 prefix corresponding to the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv6 prefix corresponding to the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/loc-rib/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_LocRib_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_NeighborAddressPathAny struct {
	*ygot.NodePath
}

// AdjRibInPost (container): Per-neighbor table containing the paths received from
// the neighbor that are eligible for best-path selection
// after local input policy rules have been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPath) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPost (container): Per-neighbor table containing the paths received from
// the neighbor that are eligible for best-path selection
// after local input policy rules have been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): Per-neighbor table containing the NLRI updates
// received from the neighbor before any local input
// policy rules or filters have been applied.  This can
// be considered the 'raw' updates from the neighbor.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPath) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): Per-neighbor table containing the NLRI updates
// received from the neighbor before any local input
// policy rules or filters have been applied.  This can
// be considered the 'raw' updates from the neighbor.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor after output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPath) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor after output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor before output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPath) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor before output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): IP address of the BGP neighbor or peer
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPath) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_NeighborAddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): IP address of the BGP neighbor or peer
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_NeighborPathAny) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPath) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPathAny) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPath) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPathAny) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPath) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPostPathAny) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_BestPathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_BestPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_BestPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_BestPathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// BestPath (leaf): Current path was selected as the best path.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/best-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) BestPath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_BestPathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_BestPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "best-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// BestPath (leaf): Current path was selected as the best path.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/best-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/best-path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) BestPath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_BestPathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_BestPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "best-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPost_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePath) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePathAny) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePath) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePathAny) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePath) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPrePathAny) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-in-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibInPre_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPath) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPathAny) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPath) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPathAny) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPath) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPostPathAny) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-post/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPost_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePathAny struct {
	*ygot.NodePath
}

// RouteAny (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePath) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAny (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix (wildcarded): string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePathAny) RouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePath) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPathId (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix: string
// PathId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePathAny) RouteAnyPathId(Prefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": "*"},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePath) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// RouteAnyPrefix (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix (wildcarded): string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePathAny) RouteAnyPrefix(PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": "*", "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePath) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// Route (list): List of routes in the table
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route"
// Prefix: string
// PathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPrePathAny) Route(Prefix string, PathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route"},
			map[string]interface{}{"prefix": Prefix, "path-id": PathId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathId (leaf): When the BGP speaker supports advertisement of multiple
// paths for a prefix, the path identifier is used to
// uniquely identify a route based on the combination of the
// prefix and path id.  In the Adj-RIB-In, the path-id value is
// the value received in the update message.   In the Loc-RIB,
// if used, it should represent a locally generated path-id
// value for the corresponding route.  In Adj-RIB-Out, it
// should be the value sent to a neighbor when add-paths is
// used, i.e., the capability has been negotiated.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) PathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) Prefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_RoutePathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/ipv6-unicast/neighbors/neighbor/adj-rib-out-pre/routes/route/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_Ipv6Unicast_Neighbor_AdjRibOutPre_Route_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPathAny struct {
	*ygot.NodePath
}

// LocRib (container): Container for the L2VPN EVPN BGP LOC-RIB data
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPath) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPath{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocRib (container): Container for the L2VPN EVPN BGP LOC-RIB data
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "loc-rib"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPathAny) LocRib() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"loc-rib"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPath) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPathAny) NeighborAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// Neighbor (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPath) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// Neighbor (list): List of neighbors (peers) of the local BGP speaker
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpnPathAny) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPathAny struct {
	*ygot.NodePath
}

// RouteDistinguisherAny (list): List of route distinguishers
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher"
// RouteDistinguisher (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPath) RouteDistinguisherAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route-distinguisher"},
			map[string]interface{}{"route-distinguisher": "*"},
			n,
		),
	}
}

// RouteDistinguisherAny (list): List of route distinguishers
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher"
// RouteDistinguisher (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPathAny) RouteDistinguisherAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route-distinguisher"},
			map[string]interface{}{"route-distinguisher": "*"},
			n,
		),
	}
}

// RouteDistinguisher (list): List of route distinguishers
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher"
// RouteDistinguisher: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPath) RouteDistinguisher(RouteDistinguisher string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route-distinguisher"},
			map[string]interface{}{"route-distinguisher": RouteDistinguisher},
			n,
		),
	}
}

// RouteDistinguisher (list): List of route distinguishers
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "routes/route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher"
// RouteDistinguisher: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRibPathAny) RouteDistinguisher(RouteDistinguisher string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"routes", "route-distinguisher"},
			map[string]interface{}{"route-distinguisher": RouteDistinguisher},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_RouteDistinguisherPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/state/route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_RouteDistinguisherPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_RouteDistinguisherPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/state/route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_RouteDistinguisherPathAny struct {
	*ygot.NodePath
}

// RouteDistinguisher (leaf): Route Distinguisher for all supported EVPN route types
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/state/route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath) RouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_RouteDistinguisherPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_RouteDistinguisherPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteDistinguisher (leaf): Route Distinguisher for all supported EVPN route types
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/state/route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny) RouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_RouteDistinguisherPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_RouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// TypeFiveRouteAny (list): List of IP Prefix Advertisement L2VPN EVPN routes
//
// For the purpose of BGP route key processing, only The RD, Ethernet Tag ID,
// IP prefix length, and IP prefix are part of the route key used by BGP to
// compare routes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-five-ip-prefix/type-five-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath) TypeFiveRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-five-ip-prefix", "type-five-route"},
			map[string]interface{}{"ethernet-tag": "*", "ip-prefix-length": "*", "ip-prefix": "*"},
			n,
		),
	}
}

// TypeFiveRouteAny (list): List of IP Prefix Advertisement L2VPN EVPN routes
//
// For the purpose of BGP route key processing, only The RD, Ethernet Tag ID,
// IP prefix length, and IP prefix are part of the route key used by BGP to
// compare routes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-five-ip-prefix/type-five-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny) TypeFiveRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-five-ip-prefix", "type-five-route"},
			map[string]interface{}{"ethernet-tag": "*", "ip-prefix-length": "*", "ip-prefix": "*"},
			n,
		),
	}
}

// WithEthernetTag sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny's key "ethernet-tag" to the specified value.
// EthernetTag: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny) WithEthernetTag(EthernetTag uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny {
	ygot.ModifyKey(n.NodePath, "ethernet-tag", EthernetTag)
	return n
}

// WithIpPrefixLength sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny's key "ip-prefix-length" to the specified value.
// IpPrefixLength: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny) WithIpPrefixLength(IpPrefixLength string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny {
	ygot.ModifyKey(n.NodePath, "ip-prefix-length", IpPrefixLength)
	return n
}

// WithIpPrefix sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny's key "ip-prefix" to the specified value.
// IpPrefix: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny) WithIpPrefix(IpPrefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny {
	ygot.ModifyKey(n.NodePath, "ip-prefix", IpPrefix)
	return n
}

// TypeFourRouteAny (list): List of Ethernet Segment L2VPN EVPN routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment ID,
// IP Address Length, and Originating Router's IP Address fields are
// considered to be part of the prefix in the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-four-ethernet-segment/type-four-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath) TypeFourRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-four-ethernet-segment", "type-four-route"},
			map[string]interface{}{"esi": "*", "originating-router-ip": "*", "originator-ip-length": "*"},
			n,
		),
	}
}

// TypeFourRouteAny (list): List of Ethernet Segment L2VPN EVPN routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment ID,
// IP Address Length, and Originating Router's IP Address fields are
// considered to be part of the prefix in the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-four-ethernet-segment/type-four-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny) TypeFourRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-four-ethernet-segment", "type-four-route"},
			map[string]interface{}{"esi": "*", "originating-router-ip": "*", "originator-ip-length": "*"},
			n,
		),
	}
}

// WithEsi sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny's key "esi" to the specified value.
// Esi: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny) WithEsi(Esi string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny {
	ygot.ModifyKey(n.NodePath, "esi", Esi)
	return n
}

// WithOriginatingRouterIp sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny's key "originating-router-ip" to the specified value.
// OriginatingRouterIp: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny) WithOriginatingRouterIp(OriginatingRouterIp string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny {
	ygot.ModifyKey(n.NodePath, "originating-router-ip", OriginatingRouterIp)
	return n
}

// WithOriginatorIpLength sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny's key "originator-ip-length" to the specified value.
// OriginatorIpLength: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny) WithOriginatorIpLength(OriginatorIpLength uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny {
	ygot.ModifyKey(n.NodePath, "originator-ip-length", OriginatorIpLength)
	return n
}

// TypeOneRouteAny (list): List of BGP EVPN Ethernet Auto-discovery routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment
// Identifier and Ethernet Tag ID are considered to be part of the prefix in
// the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-one-ethernet-auto-discovery/type-one-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route"
// Esi (wildcarded): string
// EthernetTag (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath) TypeOneRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-one-ethernet-auto-discovery", "type-one-route"},
			map[string]interface{}{"esi": "*", "ethernet-tag": "*"},
			n,
		),
	}
}

// TypeOneRouteAny (list): List of BGP EVPN Ethernet Auto-discovery routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment
// Identifier and Ethernet Tag ID are considered to be part of the prefix in
// the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-one-ethernet-auto-discovery/type-one-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route"
// Esi (wildcarded): string
// EthernetTag (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny) TypeOneRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-one-ethernet-auto-discovery", "type-one-route"},
			map[string]interface{}{"esi": "*", "ethernet-tag": "*"},
			n,
		),
	}
}

// TypeOneRouteAnyEthernetTag (list): List of BGP EVPN Ethernet Auto-discovery routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment
// Identifier and Ethernet Tag ID are considered to be part of the prefix in
// the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-one-ethernet-auto-discovery/type-one-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route"
// Esi: string
// EthernetTag (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath) TypeOneRouteAnyEthernetTag(Esi string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-one-ethernet-auto-discovery", "type-one-route"},
			map[string]interface{}{"esi": Esi, "ethernet-tag": "*"},
			n,
		),
	}
}

// TypeOneRouteAnyEthernetTag (list): List of BGP EVPN Ethernet Auto-discovery routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment
// Identifier and Ethernet Tag ID are considered to be part of the prefix in
// the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-one-ethernet-auto-discovery/type-one-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route"
// Esi: string
// EthernetTag (wildcarded): uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny) TypeOneRouteAnyEthernetTag(Esi string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-one-ethernet-auto-discovery", "type-one-route"},
			map[string]interface{}{"esi": Esi, "ethernet-tag": "*"},
			n,
		),
	}
}

// TypeOneRouteAnyEsi (list): List of BGP EVPN Ethernet Auto-discovery routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment
// Identifier and Ethernet Tag ID are considered to be part of the prefix in
// the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-one-ethernet-auto-discovery/type-one-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route"
// Esi (wildcarded): string
// EthernetTag: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath) TypeOneRouteAnyEsi(EthernetTag uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-one-ethernet-auto-discovery", "type-one-route"},
			map[string]interface{}{"esi": "*", "ethernet-tag": EthernetTag},
			n,
		),
	}
}

// TypeOneRouteAnyEsi (list): List of BGP EVPN Ethernet Auto-discovery routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment
// Identifier and Ethernet Tag ID are considered to be part of the prefix in
// the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-one-ethernet-auto-discovery/type-one-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route"
// Esi (wildcarded): string
// EthernetTag: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny) TypeOneRouteAnyEsi(EthernetTag uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-one-ethernet-auto-discovery", "type-one-route"},
			map[string]interface{}{"esi": "*", "ethernet-tag": EthernetTag},
			n,
		),
	}
}

// TypeOneRoute (list): List of BGP EVPN Ethernet Auto-discovery routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment
// Identifier and Ethernet Tag ID are considered to be part of the prefix in
// the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-one-ethernet-auto-discovery/type-one-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route"
// Esi: string
// EthernetTag: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath) TypeOneRoute(Esi string, EthernetTag uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"type-one-ethernet-auto-discovery", "type-one-route"},
			map[string]interface{}{"esi": Esi, "ethernet-tag": EthernetTag},
			n,
		),
	}
}

// TypeOneRoute (list): List of BGP EVPN Ethernet Auto-discovery routes
//
// For the purpose of BGP route key processing, only the Ethernet Segment
// Identifier and Ethernet Tag ID are considered to be part of the prefix in
// the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-one-ethernet-auto-discovery/type-one-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route"
// Esi: string
// EthernetTag: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny) TypeOneRoute(Esi string, EthernetTag uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-one-ethernet-auto-discovery", "type-one-route"},
			map[string]interface{}{"esi": Esi, "ethernet-tag": EthernetTag},
			n,
		),
	}
}

// TypeThreeRouteAny (list): List of Inclusive Multicast Ethernet Tag L2VPN EVPN routes
//
// For the purpose of BGP route key processing, only the Ethernet Tag ID,
// IP Address Length, and Originating Router's IP Address fields are
// considered to be part of the prefix in the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-three-inclusive-multicast-ethernet-tag/type-three-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath) TypeThreeRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-three-inclusive-multicast-ethernet-tag", "type-three-route"},
			map[string]interface{}{"ethernet-tag": "*", "originating-router-ip": "*", "originator-ip-length": "*"},
			n,
		),
	}
}

// TypeThreeRouteAny (list): List of Inclusive Multicast Ethernet Tag L2VPN EVPN routes
//
// For the purpose of BGP route key processing, only the Ethernet Tag ID,
// IP Address Length, and Originating Router's IP Address fields are
// considered to be part of the prefix in the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-three-inclusive-multicast-ethernet-tag/type-three-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny) TypeThreeRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-three-inclusive-multicast-ethernet-tag", "type-three-route"},
			map[string]interface{}{"ethernet-tag": "*", "originating-router-ip": "*", "originator-ip-length": "*"},
			n,
		),
	}
}

// WithEthernetTag sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny's key "ethernet-tag" to the specified value.
// EthernetTag: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny) WithEthernetTag(EthernetTag uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny {
	ygot.ModifyKey(n.NodePath, "ethernet-tag", EthernetTag)
	return n
}

// WithOriginatingRouterIp sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny's key "originating-router-ip" to the specified value.
// OriginatingRouterIp: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny) WithOriginatingRouterIp(OriginatingRouterIp string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny {
	ygot.ModifyKey(n.NodePath, "originating-router-ip", OriginatingRouterIp)
	return n
}

// WithOriginatorIpLength sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny's key "originator-ip-length" to the specified value.
// OriginatorIpLength: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny) WithOriginatorIpLength(OriginatorIpLength uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny {
	ygot.ModifyKey(n.NodePath, "originator-ip-length", OriginatorIpLength)
	return n
}

// TypeTwoRouteAny (list): List of MAC_IP Advertisement L2VPN EVPN routes
//
// For the purpose of BGP route key processing, only the Ethernet Tag ID,
// MAC Address Length, MAC Address, IP Address Length, and IP Address fields
// are considered to be part of the prefix in the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-two-mac-ip-advertisement/type-two-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPath) TypeTwoRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-two-mac-ip-advertisement", "type-two-route"},
			map[string]interface{}{"ethernet-tag": "*", "mac-address": "*", "mac-length": "*", "ip-prefix": "*", "ip-length": "*"},
			n,
		),
	}
}

// TypeTwoRouteAny (list): List of MAC_IP Advertisement L2VPN EVPN routes
//
// For the purpose of BGP route key processing, only the Ethernet Tag ID,
// MAC Address Length, MAC Address, IP Address Length, and IP Address fields
// are considered to be part of the prefix in the NLRI
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "type-two-mac-ip-advertisement/type-two-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisherPathAny) TypeTwoRouteAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"type-two-mac-ip-advertisement", "type-two-route"},
			map[string]interface{}{"ethernet-tag": "*", "mac-address": "*", "mac-length": "*", "ip-prefix": "*", "ip-length": "*"},
			n,
		),
	}
}

// WithEthernetTag sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny's key "ethernet-tag" to the specified value.
// EthernetTag: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) WithEthernetTag(EthernetTag uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny {
	ygot.ModifyKey(n.NodePath, "ethernet-tag", EthernetTag)
	return n
}

// WithMacAddress sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny's key "mac-address" to the specified value.
// MacAddress: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) WithMacAddress(MacAddress string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny {
	ygot.ModifyKey(n.NodePath, "mac-address", MacAddress)
	return n
}

// WithMacLength sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny's key "mac-length" to the specified value.
// MacLength: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) WithMacLength(MacLength uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny {
	ygot.ModifyKey(n.NodePath, "mac-length", MacLength)
	return n
}

// WithIpPrefix sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny's key "ip-prefix" to the specified value.
// IpPrefix: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) WithIpPrefix(IpPrefix string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny {
	ygot.ModifyKey(n.NodePath, "ip-prefix", IpPrefix)
	return n
}

// WithIpLength sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny's key "ip-length" to the specified value.
// IpLength: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) WithIpLength(IpLength uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny {
	ygot.ModifyKey(n.NodePath, "ip-length", IpLength)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_EthernetTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ethernet-tag YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_EthernetTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_EthernetTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ethernet-tag YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_EthernetTagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ip-prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ip-prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ip-prefix-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ip-prefix-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixLengthPathAny struct {
	*ygot.NodePath
}

// EthernetTag (leaf): The Ethernet tag identifying the broadcast domain for this
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ethernet-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ethernet-tag"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePath) EthernetTag() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_EthernetTagPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_EthernetTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// EthernetTag (leaf): The Ethernet tag identifying the broadcast domain for this
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ethernet-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ethernet-tag"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny) EthernetTag() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_EthernetTagPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_EthernetTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefix (leaf): The ip-prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ip-prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePath) IpPrefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefix (leaf): The ip-prefix for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ip-prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny) IpPrefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefixLength (leaf): The ip-prefix length for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ip-prefix-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePath) IpPrefixLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixLengthPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefixLength (leaf): The ip-prefix length for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/state/ip-prefix-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny) IpPrefixLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixLengthPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_IpPrefixLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePath) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoutePathAny) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// WithPeerIp sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny's key "peer-ip" to the specified value.
// PeerIp: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) WithPeerIp(PeerIp string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-ip", PeerIp)
	return n
}

// WithPeerPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny's key "peer-path-id" to the specified value.
// PeerPathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) WithPeerPathId(PeerPathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-path-id", PeerPathId)
	return n
}

// WithSourceRouteDistinguisher sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny's key "source-route-distinguisher" to the specified value.
// SourceRouteDistinguisher: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) WithSourceRouteDistinguisher(SourceRouteDistinguisher string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-route-distinguisher", SourceRouteDistinguisher)
	return n
}

// WithSourceAddressFamily sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny's key "source-address-family" to the specified value.
// SourceAddressFamily: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) WithSourceAddressFamily(SourceAddressFamily E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-address-family", SourceAddressFamily)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AdvertisedToPeerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AdvertisedToPeerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AdvertisedToPeerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AdvertisedToPeerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BackupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BackupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BackupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BackupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BestpathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BestpathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BestpathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BestpathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_EsiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/esi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_EsiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_EsiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/esi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_EsiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_GatewayIpAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/gateway-ip-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_GatewayIpAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_GatewayIpAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/gateway-ip-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_GatewayIpAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_Label2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_Label2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_Label2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_Label2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_MultipathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_MultipathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_MultipathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_MultipathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerIpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerPathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerPathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerPathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerPathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceAddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceAddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceAddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceAddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceRouteDistinguisherPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceRouteDistinguisherPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceRouteDistinguisherPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceRouteDistinguisherPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AdvertisedToPeerPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AdvertisedToPeerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AdvertisedToPeerPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AdvertisedToPeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BackupPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BackupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BackupPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BackupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BestpathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BestpathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BestpathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_BestpathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): The Ethernet Segment Identifier (ESI) identifying the ethernet
// segment for this route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/esi"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) Esi() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_EsiPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_EsiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): The Ethernet Segment Identifier (ESI) identifying the ethernet
// segment for this route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/esi"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) Esi() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_EsiPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_EsiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// GatewayIpAddress (leaf): The gateway-ip-address for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/gateway-ip-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/gateway-ip-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) GatewayIpAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_GatewayIpAddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_GatewayIpAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "gateway-ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// GatewayIpAddress (leaf): The gateway-ip-address for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/gateway-ip-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/gateway-ip-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) GatewayIpAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_GatewayIpAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_GatewayIpAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "gateway-ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LabelPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LabelPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_Label2Path {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_Label2Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_Label2PathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_Label2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_MultipathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_MultipathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_MultipathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_MultipathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerIpPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerIpPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerPathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerPathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerPathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_PeerPathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceAddressFamilyPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceAddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceAddressFamilyPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceAddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceRouteDistinguisherPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceRouteDistinguisherPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceRouteDistinguisherPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_SourceRouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_PathPathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-five-ip-prefix/type-five-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFiveRoute_Path_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_EsiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/esi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_EsiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_EsiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/esi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_EsiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatingRouterIpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/originating-router-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatingRouterIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatingRouterIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/originating-router-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatingRouterIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatorIpLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/originator-ip-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatorIpLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatorIpLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/originator-ip-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatorIpLengthPathAny struct {
	*ygot.NodePath
}

// Esi (leaf): The Ethernet Segment Identifier (ESI) identifying the ethernet
// segment for this route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/esi"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePath) Esi() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_EsiPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_EsiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): The Ethernet Segment Identifier (ESI) identifying the ethernet
// segment for this route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/esi"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny) Esi() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_EsiPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_EsiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatingRouterIp (leaf): The originating router ip
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originating-router-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/originating-router-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePath) OriginatingRouterIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatingRouterIpPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatingRouterIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originating-router-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatingRouterIp (leaf): The originating router ip
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originating-router-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/originating-router-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny) OriginatingRouterIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatingRouterIpPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatingRouterIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originating-router-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorIpLength (leaf): The originating router ip length
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-ip-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/originator-ip-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePath) OriginatorIpLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatorIpLengthPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatorIpLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-ip-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorIpLength (leaf): The originating router ip length
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-ip-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/state/originator-ip-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny) OriginatorIpLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatorIpLengthPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_OriginatorIpLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-ip-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePath) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoutePathAny) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// WithPeerIp sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny's key "peer-ip" to the specified value.
// PeerIp: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) WithPeerIp(PeerIp string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-ip", PeerIp)
	return n
}

// WithPeerPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny's key "peer-path-id" to the specified value.
// PeerPathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) WithPeerPathId(PeerPathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-path-id", PeerPathId)
	return n
}

// WithSourceRouteDistinguisher sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny's key "source-route-distinguisher" to the specified value.
// SourceRouteDistinguisher: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) WithSourceRouteDistinguisher(SourceRouteDistinguisher string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-route-distinguisher", SourceRouteDistinguisher)
	return n
}

// WithSourceAddressFamily sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny's key "source-address-family" to the specified value.
// SourceAddressFamily: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) WithSourceAddressFamily(SourceAddressFamily E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-address-family", SourceAddressFamily)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AdvertisedToPeerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AdvertisedToPeerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AdvertisedToPeerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AdvertisedToPeerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BackupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BackupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BackupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BackupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BestpathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BestpathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BestpathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BestpathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_Label2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_Label2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_Label2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_Label2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_MultipathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_MultipathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_MultipathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_MultipathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerIpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerPathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerPathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerPathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerPathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceAddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceAddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceAddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceAddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceRouteDistinguisherPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceRouteDistinguisherPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceRouteDistinguisherPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceRouteDistinguisherPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AdvertisedToPeerPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AdvertisedToPeerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AdvertisedToPeerPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AdvertisedToPeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BackupPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BackupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BackupPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BackupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BestpathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BestpathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BestpathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_BestpathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LabelPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LabelPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_Label2Path {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_Label2Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_Label2PathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_Label2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_MultipathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_MultipathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_MultipathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_MultipathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerIpPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerIpPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerPathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerPathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerPathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_PeerPathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceAddressFamilyPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceAddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceAddressFamilyPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceAddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceRouteDistinguisherPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceRouteDistinguisherPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceRouteDistinguisherPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_SourceRouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_PathPathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-four-ethernet-segment/type-four-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeFourRoute_Path_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EsiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/state/esi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EsiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EsiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/state/esi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EsiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EthernetTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/state/ethernet-tag YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EthernetTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EthernetTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/state/ethernet-tag YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EthernetTagPathAny struct {
	*ygot.NodePath
}

// Esi (leaf): The Ethernet Segment Identifier (ESI) identifying the ethernet
// segment for this route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/state/esi"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePath) Esi() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EsiPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EsiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): The Ethernet Segment Identifier (ESI) identifying the ethernet
// segment for this route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/state/esi"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny) Esi() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EsiPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EsiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// EthernetTag (leaf): The Ethernet tag identifying the broadcast domain for this
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ethernet-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/state/ethernet-tag"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePath) EthernetTag() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EthernetTagPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EthernetTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// EthernetTag (leaf): The Ethernet tag identifying the broadcast domain for this
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ethernet-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/state/ethernet-tag"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny) EthernetTag() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EthernetTagPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_EthernetTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePath) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoutePathAny) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// WithPeerIp sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny's key "peer-ip" to the specified value.
// PeerIp: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) WithPeerIp(PeerIp string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-ip", PeerIp)
	return n
}

// WithPeerPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny's key "peer-path-id" to the specified value.
// PeerPathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) WithPeerPathId(PeerPathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-path-id", PeerPathId)
	return n
}

// WithSourceRouteDistinguisher sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny's key "source-route-distinguisher" to the specified value.
// SourceRouteDistinguisher: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) WithSourceRouteDistinguisher(SourceRouteDistinguisher string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-route-distinguisher", SourceRouteDistinguisher)
	return n
}

// WithSourceAddressFamily sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny's key "source-address-family" to the specified value.
// SourceAddressFamily: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) WithSourceAddressFamily(SourceAddressFamily E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-address-family", SourceAddressFamily)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AdvertisedToPeerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AdvertisedToPeerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AdvertisedToPeerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AdvertisedToPeerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BackupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BackupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BackupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BackupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BestpathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BestpathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BestpathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BestpathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_Label2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_Label2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_Label2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_Label2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_MultipathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_MultipathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_MultipathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_MultipathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerIpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerPathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerPathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerPathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerPathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceAddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceAddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceAddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceAddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceRouteDistinguisherPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceRouteDistinguisherPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceRouteDistinguisherPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceRouteDistinguisherPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AdvertisedToPeerPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AdvertisedToPeerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AdvertisedToPeerPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AdvertisedToPeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BackupPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BackupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BackupPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BackupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BestpathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BestpathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BestpathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_BestpathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LabelPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LabelPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_Label2Path {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_Label2Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_Label2PathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_Label2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_MultipathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_MultipathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_MultipathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_MultipathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerIpPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerIpPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerPathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerPathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerPathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_PeerPathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceAddressFamilyPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceAddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceAddressFamilyPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceAddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceRouteDistinguisherPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceRouteDistinguisherPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceRouteDistinguisherPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_SourceRouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_PathPathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-one-ethernet-auto-discovery/type-one-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeOneRoute_Path_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_EthernetTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/ethernet-tag YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_EthernetTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_EthernetTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/ethernet-tag YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_EthernetTagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatingRouterIpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/originating-router-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatingRouterIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatingRouterIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/originating-router-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatingRouterIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatorIpLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/originator-ip-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatorIpLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatorIpLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/originator-ip-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatorIpLengthPathAny struct {
	*ygot.NodePath
}

// EthernetTag (leaf): The Ethernet tag identifying the broadcast domain for this
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ethernet-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/ethernet-tag"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePath) EthernetTag() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_EthernetTagPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_EthernetTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// EthernetTag (leaf): The Ethernet tag identifying the broadcast domain for this
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ethernet-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/ethernet-tag"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny) EthernetTag() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_EthernetTagPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_EthernetTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatingRouterIp (leaf): The Originating Router's IP Address
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originating-router-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/originating-router-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePath) OriginatingRouterIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatingRouterIpPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatingRouterIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originating-router-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatingRouterIp (leaf): The Originating Router's IP Address
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originating-router-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/originating-router-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny) OriginatingRouterIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatingRouterIpPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatingRouterIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originating-router-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorIpLength (leaf): The ip-prefix length for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-ip-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/originator-ip-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePath) OriginatorIpLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatorIpLengthPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatorIpLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-ip-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorIpLength (leaf): The ip-prefix length for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-ip-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/state/originator-ip-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny) OriginatorIpLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatorIpLengthPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_OriginatorIpLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-ip-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePath) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoutePathAny) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// WithPeerIp sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny's key "peer-ip" to the specified value.
// PeerIp: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) WithPeerIp(PeerIp string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-ip", PeerIp)
	return n
}

// WithPeerPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny's key "peer-path-id" to the specified value.
// PeerPathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) WithPeerPathId(PeerPathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-path-id", PeerPathId)
	return n
}

// WithSourceRouteDistinguisher sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny's key "source-route-distinguisher" to the specified value.
// SourceRouteDistinguisher: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) WithSourceRouteDistinguisher(SourceRouteDistinguisher string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-route-distinguisher", SourceRouteDistinguisher)
	return n
}

// WithSourceAddressFamily sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny's key "source-address-family" to the specified value.
// SourceAddressFamily: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) WithSourceAddressFamily(SourceAddressFamily E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-address-family", SourceAddressFamily)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AdvertisedToPeerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AdvertisedToPeerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AdvertisedToPeerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AdvertisedToPeerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BackupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BackupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BackupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BackupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BestpathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BestpathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BestpathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BestpathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_Label2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_Label2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_Label2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_Label2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_MultipathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_MultipathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_MultipathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_MultipathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerIpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerPathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerPathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerPathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerPathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceAddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceAddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceAddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceAddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceRouteDistinguisherPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceRouteDistinguisherPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceRouteDistinguisherPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceRouteDistinguisherPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AdvertisedToPeerPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AdvertisedToPeerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AdvertisedToPeerPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AdvertisedToPeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BackupPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BackupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BackupPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BackupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BestpathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BestpathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BestpathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_BestpathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LabelPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LabelPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_Label2Path {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_Label2Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_Label2PathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_Label2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_MultipathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_MultipathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_MultipathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_MultipathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerIpPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerIpPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerPathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerPathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerPathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_PeerPathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceAddressFamilyPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceAddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceAddressFamilyPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceAddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceRouteDistinguisherPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceRouteDistinguisherPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceRouteDistinguisherPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_SourceRouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_PathPathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-three-inclusive-multicast-ethernet-tag/type-three-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeThreeRoute_Path_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_EthernetTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ethernet-tag YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_EthernetTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_EthernetTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ethernet-tag YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_EthernetTagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ip-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ip-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpPrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ip-prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpPrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpPrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ip-prefix YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpPrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/mac-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/mac-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/mac-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/mac-length YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacLengthPathAny struct {
	*ygot.NodePath
}

// EthernetTag (leaf): The Ethernet tag identifying the broadcast domain for this
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ethernet-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ethernet-tag"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePath) EthernetTag() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_EthernetTagPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_EthernetTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// EthernetTag (leaf): The Ethernet tag identifying the broadcast domain for this
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ethernet-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ethernet-tag"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) EthernetTag() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_EthernetTagPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_EthernetTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ethernet-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpLength (leaf): The ip-prefix length for the IP address specified by ip-prefix
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ip-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePath) IpLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpLengthPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpLength (leaf): The ip-prefix length for the IP address specified by ip-prefix
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ip-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) IpLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpLengthPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefix (leaf): The IP address for end-host reachability information
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ip-prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePath) IpPrefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpPrefixPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpPrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefix (leaf): The IP address for end-host reachability information
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/ip-prefix"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) IpPrefix() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpPrefixPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_IpPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The MAC address that is learned on a PE from a CE that is
// connected to it or learned from other PEs
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/mac-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePath) MacAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacAddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The MAC address that is learned on a PE from a CE that is
// connected to it or learned from other PEs
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/mac-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) MacAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacLength (leaf): The MAC address length for the mac-address
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/mac-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePath) MacLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacLengthPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacLength (leaf): The MAC address length for the mac-address
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/state/mac-length"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) MacLength() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacLengthPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_MacLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePath) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// PathAny (list): List of paths
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "paths/path"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoutePathAny) PathAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"paths", "path"},
			map[string]interface{}{"peer-ip": "*", "peer-path-id": "*", "source-route-distinguisher": "*", "source-address-family": "*"},
			n,
		),
	}
}

// WithPeerIp sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny's key "peer-ip" to the specified value.
// PeerIp: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) WithPeerIp(PeerIp string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-ip", PeerIp)
	return n
}

// WithPeerPathId sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny's key "peer-path-id" to the specified value.
// PeerPathId: uint32
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) WithPeerPathId(PeerPathId uint32) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "peer-path-id", PeerPathId)
	return n
}

// WithSourceRouteDistinguisher sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny's key "source-route-distinguisher" to the specified value.
// SourceRouteDistinguisher: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) WithSourceRouteDistinguisher(SourceRouteDistinguisher string) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-route-distinguisher", SourceRouteDistinguisher)
	return n
}

// WithSourceAddressFamily sets NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny's key "source-address-family" to the specified value.
// SourceAddressFamily: E_BgpTypes_AFI_SAFI_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) WithSourceAddressFamily(SourceAddressFamily E_BgpTypes_AFI_SAFI_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny {
	ygot.ModifyKey(n.NodePath, "source-address-family", SourceAddressFamily)
	return n
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AdvertisedToPeerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AdvertisedToPeerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AdvertisedToPeerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/advertised-to-peer YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AdvertisedToPeerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AttrIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AttrIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AttrIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/attr-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AttrIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BackupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BackupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BackupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/backup YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BackupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BestpathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BestpathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BestpathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/bestpath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BestpathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_CommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_CommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_CommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_CommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_EsiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/esi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_EsiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_EsiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/esi YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_EsiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ExtCommunityIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ExtCommunityIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ExtCommunityIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/ext-community-index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ExtCommunityIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/invalid-reason YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/label YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_Label2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_Label2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_Label2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/label2 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_Label2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LastModifiedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LastModifiedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LastModifiedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/last-modified YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LastModifiedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_MultipathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_MultipathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_MultipathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/multipath YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_MultipathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerIpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerIpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerIpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/peer-ip YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerIpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerPathIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerPathIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerPathIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/peer-path-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerPathIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceAddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceAddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceAddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/source-address-family YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceAddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceRouteDistinguisherPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceRouteDistinguisherPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceRouteDistinguisherPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/source-route-distinguisher YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceRouteDistinguisherPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ValidRoutePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ValidRoutePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ValidRoutePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/valid-route YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ValidRoutePathAny struct {
	*ygot.NodePath
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AdvertisedToPeerPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AdvertisedToPeerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisedToPeer (leaf): List of peers to which this path is advertised
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertised-to-peer"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/advertised-to-peer"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) AdvertisedToPeer() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AdvertisedToPeerPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AdvertisedToPeerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertised-to-peer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AttrIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AttrIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrIndex (leaf): Reference to the common attribute group for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/attr-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) AttrIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AttrIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_AttrIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BackupPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BackupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): BGP path marked as a backup path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/backup"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) Backup() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BackupPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BackupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BestpathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BestpathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bestpath (leaf): BGP can receive multiple paths to the same destination. This
// parameter indicates that this path is the bestpath to install
// in the IP routing table and use for traffic forwarding
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bestpath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/bestpath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) Bestpath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BestpathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_BestpathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bestpath"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_CommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_CommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// CommunityIndex (leaf): Reference to the community attribute for the route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) CommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_CommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_CommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): The Ethernet Segment Identifier (ESI) identifying the ethernet
// segment for this route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/esi"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) Esi() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_EsiPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_EsiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esi (leaf): The Ethernet Segment Identifier (ESI) identifying the ethernet
// segment for this route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/esi"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/esi"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) Esi() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_EsiPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_EsiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esi"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ExtCommunityIndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ExtCommunityIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunityIndex (leaf): Reference to the extended community attribute for the
// route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/ext-community-index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) ExtCommunityIndex() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ExtCommunityIndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ExtCommunityIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_InvalidReasonPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If the route is rejected as invalid, this indicates the
// reason.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/invalid-reason"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) InvalidReason() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_InvalidReasonPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LabelPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): MPLS Label field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/label"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) Label() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LabelPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_Label2Path {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_Label2Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label2 (leaf): MPLS Label2 field used for route attributes
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label2"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/label2"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) Label2() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_Label2PathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_Label2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label2"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LastModifiedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LastModifiedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastModified (leaf): Timestamp when this path was last modified.
//
// The value is the timestamp relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-modified"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/last-modified"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) LastModified() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LastModifiedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_LastModifiedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-modified"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_MultipathPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_MultipathPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// Multipath (leaf): BGP can use multiple paths to reach a destination allowing
// BGP to load-balance traffic. This parameter indicates that this
// path is marked as multipath
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multipath"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/multipath"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) Multipath() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_MultipathPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_MultipathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multipath"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerIpPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerIpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerIp (leaf): The source peer ip address of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-ip"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/peer-ip"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) PeerIp() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerIpPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerIpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-ip"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerPathIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerPathIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PeerPathId (leaf): The source peer path id of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/peer-path-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/peer-path-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) PeerPathId() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerPathIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_PeerPathIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "peer-path-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceAddressFamilyPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceAddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddressFamily (leaf): The source address-family of the imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/source-address-family"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) SourceAddressFamily() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceAddressFamilyPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceAddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceRouteDistinguisherPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceRouteDistinguisherPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceRouteDistinguisher (leaf): The source route distinguisher is the remote RD source of the
// imported route
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-route-distinguisher"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/source-route-distinguisher"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) SourceRouteDistinguisher() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceRouteDistinguisherPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_SourceRouteDistinguisherPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-route-distinguisher"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttributeAny (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType (wildcarded): uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) UnknownAttributeAny() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": "*"},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// UnknownAttribute (list): This list contains received attributes that are unrecognized
// or unsupported by the local router.  The list may be empty.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-attributes/unknown-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute"
// AttrType: uint8
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) UnknownAttribute(AttrType uint8) *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-attributes", "unknown-attribute"},
			map[string]interface{}{"attr-type": AttrType},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPath) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ValidRoutePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ValidRoutePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// ValidRoute (leaf): Indicates that the route is considered valid by the
// local router
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-table-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid-route"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/state/valid-route"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_PathPathAny) ValidRoute() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ValidRoutePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_ValidRoutePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid-route"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrLenPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrLenPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrLenPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrLenPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_ExtendedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_ExtendedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_ExtendedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/extended YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_ExtendedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_OptionalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_OptionalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_OptionalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/optional YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_OptionalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_PartialPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_PartialPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_PartialPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/partial YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_PartialPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_TransitivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_TransitivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_TransitivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/transitive YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_TransitivePathAny struct {
	*ygot.NodePath
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrLenPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrLenPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrLen (leaf): One or two octet attribute length field indicating the
// length of the attribute data in octets.  If the Extended
// Length attribute flag is set, the length field is 2 octets,
// otherwise it is 1 octet
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-len"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-len"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny) AttrLen() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrLenPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrLenPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-len"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrTypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrType (leaf): 1-octet value encoding the attribute type code
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny) AttrType() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrTypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrValuePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttrValue (leaf): Raw attribute value, not including the attribute
// flags, type, or length.  The maximum length
// of the attribute value data is 2^16-1 per the max value
// of the attr-len field (2 octets).
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attr-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/attr-value"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny) AttrValue() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrValuePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_AttrValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attr-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_ExtendedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_ExtendedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Extended (leaf): Defines whether the attribute length is one octet
// (if set to false) or two octets (if set to true).  Set in
// the fourth high-order bit of the BGP attribute flags
// octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/extended"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny) Extended() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_ExtendedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_ExtendedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_OptionalPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_OptionalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Optional (leaf): Defines whether the attribute is optional (if
// set to true) or well-known (if set to false).
// Set in the high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/optional"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny) Optional() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_OptionalPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_OptionalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_PartialPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_PartialPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Partial (leaf): Defines whether the information contained in the optional
// transitive attribute is partial (if set to true) or complete
// (if set to false).  For well-known attributes and for
// optional non-transitive attributes, the partial flag
// must be set to false.  Set in the third high-order bit of
// the BGP attribute flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/partial"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/partial"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny) Partial() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_PartialPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_PartialPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "partial"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePath) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_TransitivePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_TransitivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transitive (leaf): Defines whether an optional attribute is transitive
// (if set to true) or non-transitive (if set to false).  For
// well-known attributes, the transitive flag MUST be set to
// true.  Set in the second high-order bit of the BGP attribute
// flags octet.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/transitive"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/loc-rib/routes/route-distinguisher/type-two-mac-ip-advertisement/type-two-route/paths/path/unknown-attributes/unknown-attribute/state/transitive"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttributePathAny) Transitive() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_TransitivePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_LocRib_RouteDistinguisher_TypeTwoRoute_Path_UnknownAttribute_TransitivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "transitive"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_NeighborAddressPathAny struct {
	*ygot.NodePath
}

// AdjRibInPost (container): Per-neighbor table containing the paths received from
// the neighbor that are eligible for best-path selection
// after local input policy rules have been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPath) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPost (container): Per-neighbor table containing the paths received from
// the neighbor that are eligible for best-path selection
// after local input policy rules have been applied.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-in-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny) AdjRibInPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): Per-neighbor table containing the NLRI updates
// received from the neighbor before any local input
// policy rules or filters have been applied.  This can
// be considered the 'raw' updates from the neighbor.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPath) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibInPre (container): Per-neighbor table containing the NLRI updates
// received from the neighbor before any local input
// policy rules or filters have been applied.  This can
// be considered the 'raw' updates from the neighbor.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-in-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-in-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny) AdjRibInPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-in-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor after output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPath) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPostPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPostPath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPost (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor after output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-post"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-out-post"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny) AdjRibOutPost() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPostPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-post"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor before output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPath) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPrePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPrePath{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjRibOutPre (container): Per-neighbor table containing paths eligble for
// sending (advertising) to the neighbor before output
// policy rules have been applied
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adj-rib-out-pre"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-out-pre"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny) AdjRibOutPre() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPrePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPrePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adj-rib-out-pre"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): IP address of the BGP neighbor or peer
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPath) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_NeighborAddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): IP address of the BGP neighbor or peer
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-tables"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_NeighborPathAny) NeighborAddress() *NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-in-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPostPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-in-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibInPrePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPostPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPostPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPostPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-out-post YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPostPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPrePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPrePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPrePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/afi-safis/afi-safi/l2vpn-evpn/neighbors/neighbor/adj-rib-out-pre YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AfiSafi_L2VpnEvpn_Neighbor_AdjRibOutPrePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSetPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSetPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AigpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/aigp YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AigpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AigpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/aigp YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AigpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AtomicAggregatePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/atomic-aggregate YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AtomicAggregatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AtomicAggregatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/atomic-aggregate YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AtomicAggregatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_ClusterListPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/cluster-list YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_ClusterListPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_ClusterListPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/cluster-list YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_ClusterListPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_LocalPrefPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/local-pref YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_LocalPrefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_LocalPrefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/local-pref YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_LocalPrefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_MedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/med YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_MedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_MedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/med YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_MedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/next-hop YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/next-hop YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/origin YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/origin YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginatorIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/originator-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginatorIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginatorIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/originator-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginatorIdPathAny struct {
	*ygot.NodePath
}

// Aggregator (container): BGP attribute indicating the prefix has been aggregated by
// the specified AS and router.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "aggregator"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) Aggregator() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPath{
		NodePath: ygot.NewNodePath(
			[]string{"aggregator"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aggregator (container): BGP attribute indicating the prefix has been aggregated by
// the specified AS and router.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "aggregator"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) Aggregator() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"aggregator"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aigp (leaf): BGP path attribute representing the accumulated IGP metric
// for the path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/aigp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/aigp"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) Aigp() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AigpPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AigpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "aigp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aigp (leaf): BGP path attribute representing the accumulated IGP metric
// for the path
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/aigp"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/aigp"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) Aigp() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AigpPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AigpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "aigp"},
			map[string]interface{}{},
			n,
		),
	}
}

// AtomicAggregate (leaf): BGP attribute indicating that the prefix is an atomic
// aggregate, i.e., the peer selected a less specific
// route without selecting a more specific route that is
// included in it.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/atomic-aggregate"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/atomic-aggregate"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) AtomicAggregate() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AtomicAggregatePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AtomicAggregatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "atomic-aggregate"},
			map[string]interface{}{},
			n,
		),
	}
}

// AtomicAggregate (leaf): BGP attribute indicating that the prefix is an atomic
// aggregate, i.e., the peer selected a less specific
// route without selecting a more specific route that is
// included in it.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/atomic-aggregate"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/atomic-aggregate"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) AtomicAggregate() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AtomicAggregatePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AtomicAggregatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "atomic-aggregate"},
			map[string]interface{}{},
			n,
		),
	}
}

// ClusterList (leaf): Represents the reflection path that the route has passed.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/cluster-list"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/cluster-list"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) ClusterList() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_ClusterListPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_ClusterListPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cluster-list"},
			map[string]interface{}{},
			n,
		),
	}
}

// ClusterList (leaf): Represents the reflection path that the route has passed.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/cluster-list"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/cluster-list"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) ClusterList() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_ClusterListPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_ClusterListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cluster-list"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): System generated index for each attribute set.  The
// index is used to reference an attribute set from a
// specific path.  Multiple paths may reference the same
// attribute set.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) Index() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_IndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): System generated index for each attribute set.  The
// index is used to reference an attribute set from a
// specific path.  Multiple paths may reference the same
// attribute set.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) Index() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_IndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalPref (leaf): BGP local preference attribute sent to internal peers to
// indicate the degree of preference for externally learned
// routes.  The route with the highest local preference value
// is preferred.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-pref"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/local-pref"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) LocalPref() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_LocalPrefPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_LocalPrefPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-pref"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalPref (leaf): BGP local preference attribute sent to internal peers to
// indicate the degree of preference for externally learned
// routes.  The route with the highest local preference value
// is preferred.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-pref"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/local-pref"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) LocalPref() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_LocalPrefPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_LocalPrefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-pref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Med (leaf): BGP multi-exit discriminator attribute used in BGP route
// selection process
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/med"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/med"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) Med() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_MedPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_MedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "med"},
			map[string]interface{}{},
			n,
		),
	}
}

// Med (leaf): BGP multi-exit discriminator attribute used in BGP route
// selection process
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/med"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/med"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) Med() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_MedPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_MedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "med"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): BGP next hop attribute defining the IP address of the router
// that should be used as the next hop to the destination
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/next-hop"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) NextHop() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_NextHopPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): BGP next hop attribute defining the IP address of the router
// that should be used as the next hop to the destination
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/next-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/next-hop"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) NextHop() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_NextHopPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): BGP attribute defining the origin of the path information.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/origin"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) Origin() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// Origin (leaf): BGP attribute defining the origin of the path information.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/origin"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) Origin() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorId (leaf): BGP attribute that provides the id as an IPv4 address
// of the originator of the announcement.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/originator-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) OriginatorId() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginatorIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginatorIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorId (leaf): BGP attribute that provides the id as an IPv4 address
// of the originator of the announcement.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/state/originator-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) OriginatorId() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginatorIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_OriginatorIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// TunnelEncapsulation (container): The Tunnel Encapsulation attribute specifies a set of
// tunnels to a remote destination. The attribute is TLV
// based and allows description of a tunnel type, and the
// relevant information to create the tunnel to the remote
// destination.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnel-encapsulation"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPath) TunnelEncapsulation() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPath{
		NodePath: ygot.NewNodePath(
			[]string{"tunnel-encapsulation"},
			map[string]interface{}{},
			n,
		),
	}
}

// TunnelEncapsulation (container): The Tunnel Encapsulation attribute specifies a set of
// tunnels to a remote destination. The attribute is TLV
// based and allows description of a tunnel type, and the
// relevant information to create the tunnel to the remote
// destination.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnel-encapsulation"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSetPathAny) TunnelEncapsulation() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tunnel-encapsulation"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/as YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/as YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_As4Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/as4 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_As4Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_As4PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/as4 YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_As4PathAny struct {
	*ygot.NodePath
}

// Address (leaf): IP address of the router that performed the
// aggregation.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPath) Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): IP address of the router that performed the
// aggregation.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPathAny) Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// As (leaf): AS number of the autnonomous system that performed the
// aggregation.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/as"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPath) As() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AsPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "as"},
			map[string]interface{}{},
			n,
		),
	}
}

// As (leaf): AS number of the autnonomous system that performed the
// aggregation.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/as"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPathAny) As() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AsPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_AsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "as"},
			map[string]interface{}{},
			n,
		),
	}
}

// As4 (leaf): AS number of the autnonomous system that performed the
// aggregation (4-octet representation).  This value is
// populated if an upstream router is not 4-octet capable.
// Its semantics are similar to the AS4_PATH optional
// transitive attribute
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/as4"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/as4"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPath) As4() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_As4Path {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_As4Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "as4"},
			map[string]interface{}{},
			n,
		),
	}
}

// As4 (leaf): AS number of the autnonomous system that performed the
// aggregation (4-octet representation).  This value is
// populated if an upstream router is not 4-octet capable.
// Its semantics are similar to the AS4_PATH optional
// transitive attribute
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/as4"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/aggregator/state/as4"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AggregatorPathAny) As4() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_As4PathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_Aggregator_As4PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "as4"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4SegmentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4SegmentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4SegmentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4SegmentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_MemberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment/state/member YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_MemberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_MemberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment/state/member YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_MemberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_TypePathAny struct {
	*ygot.NodePath
}

// Member (leaf): List of the AS numbers in the AS-PATH segment
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/member"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment/state/member"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4SegmentPath) Member() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_MemberPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_MemberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "member"},
			map[string]interface{}{},
			n,
		),
	}
}

// Member (leaf): List of the AS numbers in the AS-PATH segment
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/member"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment/state/member"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4SegmentPathAny) Member() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_MemberPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_MemberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "member"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of AS-PATH segment
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4SegmentPath) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_TypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of AS-PATH segment
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as4-path/as4-segment/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4SegmentPathAny) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_TypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_As4Segment_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegmentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegmentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegmentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegmentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_MemberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment/state/member YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_MemberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_MemberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment/state/member YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_MemberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_TypePathAny struct {
	*ygot.NodePath
}

// Member (leaf): List of the AS numbers in the AS-PATH segment
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/member"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment/state/member"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegmentPath) Member() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_MemberPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_MemberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "member"},
			map[string]interface{}{},
			n,
		),
	}
}

// Member (leaf): List of the AS numbers in the AS-PATH segment
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/member"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment/state/member"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegmentPathAny) Member() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_MemberPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_MemberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "member"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of AS-PATH segment
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegmentPath) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_TypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of AS-PATH segment
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/as-path/as-segment/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegmentPathAny) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_TypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_AsSegment_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPathAny struct {
	*ygot.NodePath
}

// TunnelAny (list): List of the tunnels that are specified within the
// attribute. Keyed on the type of tunnel that the
// TLV describes.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnels/tunnel"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel"
// Type (wildcarded): E_RibBgpTypes_TUNNEL_ENCAPSULATION_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPath) TunnelAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tunnels", "tunnel"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// TunnelAny (list): List of the tunnels that are specified within the
// attribute. Keyed on the type of tunnel that the
// TLV describes.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnels/tunnel"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel"
// Type (wildcarded): E_RibBgpTypes_TUNNEL_ENCAPSULATION_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPathAny) TunnelAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tunnels", "tunnel"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Tunnel (list): List of the tunnels that are specified within the
// attribute. Keyed on the type of tunnel that the
// TLV describes.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnels/tunnel"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel"
// Type: E_RibBgpTypes_TUNNEL_ENCAPSULATION_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPath) Tunnel(Type E_RibBgpTypes_TUNNEL_ENCAPSULATION_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPath{
		NodePath: ygot.NewNodePath(
			[]string{"tunnels", "tunnel"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Tunnel (list): List of the tunnels that are specified within the
// attribute. Keyed on the type of tunnel that the
// TLV describes.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tunnels/tunnel"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel"
// Type: E_RibBgpTypes_TUNNEL_ENCAPSULATION_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulationPathAny) Tunnel(Type E_RibBgpTypes_TUNNEL_ENCAPSULATION_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tunnels", "tunnel"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_TypePathAny struct {
	*ygot.NodePath
}

// SubtlvAny (list): List of the subTLVs that are specified within the
// TLV instance inside the tunnel encapsulation attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv"
// Type (wildcarded): E_RibBgpTypes_TUNNEL_ENCAPSULATION_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPath) SubtlvAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of the subTLVs that are specified within the
// TLV instance inside the tunnel encapsulation attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv"
// Type (wildcarded): E_RibBgpTypes_TUNNEL_ENCAPSULATION_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny) SubtlvAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of the subTLVs that are specified within the
// TLV instance inside the tunnel encapsulation attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv"
// Type: E_RibBgpTypes_TUNNEL_ENCAPSULATION_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPath) Subtlv(Type E_RibBgpTypes_TUNNEL_ENCAPSULATION_SUBTLV_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of the subTLVs that are specified within the
// TLV instance inside the tunnel encapsulation attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv"
// Type: E_RibBgpTypes_TUNNEL_ENCAPSULATION_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny) Subtlv(Type E_RibBgpTypes_TUNNEL_ENCAPSULATION_SUBTLV_TYPE) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Type (leaf): Type of the tunnel described within the tunnel encapsulation
// attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPath) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_TypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Type of the tunnel described within the tunnel encapsulation
// attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_TunnelPathAny) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_TypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_BindingSidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/binding-sid YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_BindingSidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_BindingSidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/binding-sid YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_BindingSidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_ColorsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/colors YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_ColorsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_ColorsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/colors YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_ColorsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_PreferencePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/preference YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_PreferencePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_PreferencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/preference YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_PreferencePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// BindingSid (leaf): Binding SID associated with the SR-TE policy
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/binding-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/binding-sid"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath) BindingSid() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_BindingSidPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_BindingSidPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "binding-sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// BindingSid (leaf): Binding SID associated with the SR-TE policy
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/binding-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/binding-sid"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny) BindingSid() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_BindingSidPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_BindingSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "binding-sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Colors (leaf): The colours associated with the tunnel encapsulation attribute,
// as described by RFC5512.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/colors"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/colors"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath) Colors() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_ColorsPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_ColorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "colors"},
			map[string]interface{}{},
			n,
		),
	}
}

// Colors (leaf): The colours associated with the tunnel encapsulation attribute,
// as described by RFC5512.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/colors"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/colors"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny) Colors() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_ColorsPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_ColorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "colors"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): The preference of the SR-TE policy described by the tunnel
// encapsulation attribute. If unspecified, the preference
// defaults to 100.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/preference"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/preference"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath) Preference() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_PreferencePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_PreferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): The preference of the SR-TE policy described by the tunnel
// encapsulation attribute. If unspecified, the preference
// defaults to 100.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/preference"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/preference"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny) Preference() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_PreferencePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_PreferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteEndpointAny (list): List of the remote endpoints described within the TLV.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "remote-endpoints/remote-endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint"
// Endpoint (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath) RemoteEndpointAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"remote-endpoints", "remote-endpoint"},
			map[string]interface{}{"endpoint": "*"},
			n,
		),
	}
}

// RemoteEndpointAny (list): List of the remote endpoints described within the TLV.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "remote-endpoints/remote-endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint"
// Endpoint (wildcarded): string
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny) RemoteEndpointAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"remote-endpoints", "remote-endpoint"},
			map[string]interface{}{"endpoint": "*"},
			n,
		),
	}
}

// RemoteEndpoint (list): List of the remote endpoints described within the TLV.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "remote-endpoints/remote-endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint"
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath) RemoteEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"remote-endpoints", "remote-endpoint"},
			map[string]interface{}{"endpoint": Endpoint},
			n,
		),
	}
}

// RemoteEndpoint (list): List of the remote endpoints described within the TLV.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "remote-endpoints/remote-endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint"
// Endpoint: string
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny) RemoteEndpoint(Endpoint string) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"remote-endpoints", "remote-endpoint"},
			map[string]interface{}{"endpoint": Endpoint},
			n,
		),
	}
}

// SegmentListAny (list): List of segment lists that are specified within the
// tunnel encapsulation attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-lists/segment-list"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list"
// InstanceId (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath) SegmentListAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-lists", "segment-list"},
			map[string]interface{}{"instance-id": "*"},
			n,
		),
	}
}

// SegmentListAny (list): List of segment lists that are specified within the
// tunnel encapsulation attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-lists/segment-list"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list"
// InstanceId (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny) SegmentListAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-lists", "segment-list"},
			map[string]interface{}{"instance-id": "*"},
			n,
		),
	}
}

// SegmentList (list): List of segment lists that are specified within the
// tunnel encapsulation attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-lists/segment-list"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list"
// InstanceId: uint64
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath) SegmentList(InstanceId uint64) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-lists", "segment-list"},
			map[string]interface{}{"instance-id": InstanceId},
			n,
		),
	}
}

// SegmentList (list): List of segment lists that are specified within the
// tunnel encapsulation attribute.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-lists/segment-list"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list"
// InstanceId: uint64
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny) SegmentList(InstanceId uint64) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-lists", "segment-list"},
			map[string]interface{}{"instance-id": InstanceId},
			n,
		),
	}
}

// Type (leaf): Type of the sub-TLV within the tunnel encapsulation attribute
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPath) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Type of the sub-TLV within the tunnel encapsulation attribute
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_SubtlvPathAny) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_AsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint/state/as YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_AsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_AsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint/state/as YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_AsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint/state/endpoint YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_EndpointPathAny struct {
	*ygot.NodePath
}

// As (leaf): The remote AS to which the IP address of the remote endpoint
// belongs.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint/state/as"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPath) As() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_AsPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_AsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "as"},
			map[string]interface{}{},
			n,
		),
	}
}

// As (leaf): The remote AS to which the IP address of the remote endpoint
// belongs.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/as"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint/state/as"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny) As() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_AsPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_AsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "as"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): IP address of the remote endpoint.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPath) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_EndpointPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): IP address of the remote endpoint.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/remote-endpoints/remote-endpoint/state/endpoint"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpointPathAny) Endpoint() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_EndpointPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_RemoteEndpoint_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_InstanceIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/state/instance-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_InstanceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_InstanceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/state/instance-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_InstanceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/state/weight YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/state/weight YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_WeightPathAny struct {
	*ygot.NodePath
}

// InstanceId (leaf): Instance of the segment list within the sub-TLV
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/state/instance-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPath) InstanceId() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_InstanceIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_InstanceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstanceId (leaf): Instance of the segment list within the sub-TLV
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/state/instance-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny) InstanceId() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_InstanceIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_InstanceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentAny (list): List of segments within the SR-TE segment list.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segments/segment"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment"
// Index (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPath) SegmentAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segments", "segment"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// SegmentAny (list): List of segments within the SR-TE segment list.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segments/segment"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment"
// Index (wildcarded): uint64
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny) SegmentAny() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segments", "segment"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// Segment (list): List of segments within the SR-TE segment list.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segments/segment"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment"
// Index: uint64
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPath) Segment(Index uint64) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath{
		NodePath: ygot.NewNodePath(
			[]string{"segments", "segment"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Segment (list): List of segments within the SR-TE segment list.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segments/segment"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment"
// Index: uint64
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny) Segment(Index uint64) *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segments", "segment"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Weight (leaf): The weight given to the path within the set of segment
// lists that are included in the tunnel attribute sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/state/weight"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPath) Weight() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_WeightPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): The weight given to the path within the set of segment
// lists that are included in the tunnel attribute sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/state/weight"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentListPathAny) Weight() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_WeightPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalInterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-interface-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalInterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalInterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-interface-id YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalInterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv4AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-ipv4-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv4AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv4AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-ipv4-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv4AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv6AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-ipv6-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv6AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv6AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-ipv6-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv6AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsBosPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-bos YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsBosPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsBosPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-bos YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsBosPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTcPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-tc YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTcPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTcPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-tc YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTcPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTtlPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-ttl YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTtlPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTtlPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-ttl YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTtlPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv4AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/remote-ipv4-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv4AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv4AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/remote-ipv4-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv4AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv6AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/remote-ipv6-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv6AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv6AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/remote-ipv6-address YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv6AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_SidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/sid YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_SidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_SidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/sid YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_SidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/type YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_TypePathAny struct {
	*ygot.NodePath
}

// Index (leaf): Index of the segment within the segment list. The segments are
// ordered in ascending order, beginning at 0.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) Index() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_IndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of the segment within the segment list. The segments are
// ordered in ascending order, beginning at 0.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/index"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) Index() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_IndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalInterfaceId (leaf): The local interface identifier to be utilised for the segment.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-interface-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) LocalInterfaceId() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalInterfaceIdPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalInterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalInterfaceId (leaf): The local interface identifier to be utilised for the segment.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-interface-id"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) LocalInterfaceId() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalInterfaceIdPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalInterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIpv4Address (leaf): An IPv4 address of a local adjacency that is used to identify
// the segment.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ipv4-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-ipv4-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) LocalIpv4Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv4AddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv4AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ipv4-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIpv4Address (leaf): An IPv4 address of a local adjacency that is used to identify
// the segment.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ipv4-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-ipv4-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) LocalIpv4Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv4AddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv4AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ipv4-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIpv6Address (leaf): An IPv6 address of a local adjacency that is used to identify the
// segment.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ipv6-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-ipv6-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) LocalIpv6Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv6AddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv6AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ipv6-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIpv6Address (leaf): An IPv6 address of a local adjacency that is used to identify the
// segment.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ipv6-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/local-ipv6-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) LocalIpv6Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv6AddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_LocalIpv6AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ipv6-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsBos (leaf): When this leaf is set to true the MPLS bottom-of-stack
// (BoS) bit is set in the MPLS segment. The BoS bit should
// always be set to zero by the sender.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-bos"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-bos"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) MplsBos() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsBosPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsBosPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-bos"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsBos (leaf): When this leaf is set to true the MPLS bottom-of-stack
// (BoS) bit is set in the MPLS segment. The BoS bit should
// always be set to zero by the sender.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-bos"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-bos"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) MplsBos() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsBosPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsBosPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-bos"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTc (leaf): The MPLS TC bits used when the SID is specified as an MPLS
// label. If set to zero, the receiving system specifies the
// value of the TC bits.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-tc"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-tc"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) MplsTc() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTcPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTcPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-tc"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTc (leaf): The MPLS TC bits used when the SID is specified as an MPLS
// label. If set to zero, the receiving system specifies the
// value of the TC bits.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-tc"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-tc"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) MplsTc() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTcPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTcPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-tc"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTtl (leaf): The MPLS time to live (TTL) to be set for the MPLS
// segment. If set to 255, the receiver specifies the
// TTL value that is used for packets sent with this
// segment in the stack.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-ttl"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-ttl"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) MplsTtl() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTtlPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTtlPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTtl (leaf): The MPLS time to live (TTL) to be set for the MPLS
// segment. If set to 255, the receiver specifies the
// TTL value that is used for packets sent with this
// segment in the stack.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-ttl"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/mpls-ttl"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) MplsTtl() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTtlPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_MplsTtlPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteIpv4Address (leaf): An IPv4 address specified as the remote node address. When the type
// of the segment specifies only the remote address, no other addresses
// are specified. When the type of the segment requires a local address,
// this leaf specifies the remote IPv4 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-ipv4-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/remote-ipv4-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) RemoteIpv4Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv4AddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv4AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-ipv4-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteIpv4Address (leaf): An IPv4 address specified as the remote node address. When the type
// of the segment specifies only the remote address, no other addresses
// are specified. When the type of the segment requires a local address,
// this leaf specifies the remote IPv4 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-ipv4-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/remote-ipv4-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) RemoteIpv4Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv4AddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv4AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-ipv4-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteIpv6Address (leaf): An IPv6 address specified as the remote node address. When the type
// of the segment specifies only the remote address, no other addresses
// are specified. When the type of the segment requires a local address,
// this leaf specifies the remote IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-ipv6-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/remote-ipv6-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) RemoteIpv6Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv6AddressPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv6AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-ipv6-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteIpv6Address (leaf): An IPv6 address specified as the remote node address. When the type
// of the segment specifies only the remote address, no other addresses
// are specified. When the type of the segment requires a local address,
// this leaf specifies the remote IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-ipv6-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/remote-ipv6-address"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) RemoteIpv6Address() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv6AddressPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_RemoteIpv6AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-ipv6-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sid (leaf): SID value for the segment entry, specified as an MPLS label
// or IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/sid"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) Sid() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_SidPath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_SidPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sid (leaf): SID value for the segment entry, specified as an MPLS label
// or IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/sid"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) Sid() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_SidPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_SidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of segment specified within the segment entry.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPath) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_TypePath {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of segment specified within the segment entry.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/attr-sets/attr-set/tunnel-encapsulation/tunnels/tunnel/subtlvs/subtlv/segment-lists/segment-list/segments/segment/state/type"
func (n *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_SegmentPathAny) Type() *NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_TypePathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_AttrSet_TunnelEncapsulation_Tunnel_Subtlv_SegmentList_Segment_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_CommunityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_CommunityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_Community_CommunityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community/state/community YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_Community_CommunityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_Community_CommunityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community/state/community YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_Community_CommunityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_Community_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community/state/index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_Community_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_Community_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community/state/index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_Community_IndexPathAny struct {
	*ygot.NodePath
}

// Community (leaf): List of standard or well-known BGP community
// attributes.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community/state/community"
func (n *NetworkInstance_Protocol_Bgp_Rib_CommunityPath) Community() *NetworkInstance_Protocol_Bgp_Rib_Community_CommunityPath {
	return &NetworkInstance_Protocol_Bgp_Rib_Community_CommunityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community"},
			map[string]interface{}{},
			n,
		),
	}
}

// Community (leaf): List of standard or well-known BGP community
// attributes.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community/state/community"
func (n *NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny) Community() *NetworkInstance_Protocol_Bgp_Rib_Community_CommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_Community_CommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "community"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): System generated index for each attribute set.  The
// index is used to reference an attribute set from a
// specific path.  Multiple paths may reference the same
// attribute set.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community/state/index"
func (n *NetworkInstance_Protocol_Bgp_Rib_CommunityPath) Index() *NetworkInstance_Protocol_Bgp_Rib_Community_IndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_Community_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): System generated index for each attribute set.  The
// index is used to reference an attribute set from a
// specific path.  Multiple paths may reference the same
// attribute set.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/communities/community/state/index"
func (n *NetworkInstance_Protocol_Bgp_Rib_CommunityPathAny) Index() *NetworkInstance_Protocol_Bgp_Rib_Community_IndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_Community_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_ExtCommunityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community/state/ext-community YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_ExtCommunityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_ExtCommunityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community/state/ext-community YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_ExtCommunityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community/state/index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community/state/index YANG schema element.
type NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_IndexPathAny struct {
	*ygot.NodePath
}

// ExtCommunity (leaf): List of BGP extended community attributes.  The received
// extended community may be an explicitly modeled
// type or unknown, represented by an 8-octet value
// formatted according to RFC 4360.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community/state/ext-community"
func (n *NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPath) ExtCommunity() *NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_ExtCommunityPath {
	return &NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_ExtCommunityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtCommunity (leaf): List of BGP extended community attributes.  The received
// extended community may be an explicitly modeled
// type or unknown, represented by an 8-octet value
// formatted according to RFC 4360.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ext-community"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community/state/ext-community"
func (n *NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny) ExtCommunity() *NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_ExtCommunityPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_ExtCommunityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ext-community"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): System generated index for each attribute set.  The
// index is used to reference an attribute set from a
// specific path.  Multiple paths may reference the same
// attribute set.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community/state/index"
func (n *NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPath) Index() *NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_IndexPath {
	return &NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): System generated index for each attribute set.  The
// index is used to reference an attribute set from a
// specific path.  Multiple paths may reference the same
// attribute set.
// ----------------------------------------
// Defining module: "openconfig-rib-bgp-shared-attributes"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/bgp/rib/ext-communities/ext-community/state/index"
func (n *NetworkInstance_Protocol_Bgp_Rib_ExtCommunityPathAny) Index() *NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_IndexPathAny {
	return &NetworkInstance_Protocol_Bgp_Rib_ExtCommunity_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_IgmpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp YANG schema element.
type NetworkInstance_Protocol_IgmpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_IgmpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp YANG schema element.
type NetworkInstance_Protocol_IgmpPathAny struct {
	*ygot.NodePath
}

// Global (container): Global IGMP configuration and operational state.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global"
func (n *NetworkInstance_Protocol_IgmpPath) Global() *NetworkInstance_Protocol_Igmp_GlobalPath {
	return &NetworkInstance_Protocol_Igmp_GlobalPath{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// Global (container): Global IGMP configuration and operational state.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global"
func (n *NetworkInstance_Protocol_IgmpPathAny) Global() *NetworkInstance_Protocol_Igmp_GlobalPathAny {
	return &NetworkInstance_Protocol_Igmp_GlobalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): This container defines interface IGMP configuration and
// state information.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Protocol_IgmpPath) InterfaceAny() *NetworkInstance_Protocol_Igmp_InterfacePathAny {
	return &NetworkInstance_Protocol_Igmp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): This container defines interface IGMP configuration and
// state information.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Protocol_IgmpPathAny) InterfaceAny() *NetworkInstance_Protocol_Igmp_InterfacePathAny {
	return &NetworkInstance_Protocol_Igmp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// Interface (list): This container defines interface IGMP configuration and
// state information.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Protocol_IgmpPath) Interface(InterfaceId string) *NetworkInstance_Protocol_Igmp_InterfacePath {
	return &NetworkInstance_Protocol_Igmp_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Interface (list): This container defines interface IGMP configuration and
// state information.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Protocol_IgmpPathAny) Interface(InterfaceId string) *NetworkInstance_Protocol_Igmp_InterfacePathAny {
	return &NetworkInstance_Protocol_Igmp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_GlobalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global YANG schema element.
type NetworkInstance_Protocol_Igmp_GlobalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_GlobalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global YANG schema element.
type NetworkInstance_Protocol_Igmp_GlobalPathAny struct {
	*ygot.NodePath
}

// Ssm (container): Source specific multicast (SSM).
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ssm"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm"
func (n *NetworkInstance_Protocol_Igmp_GlobalPath) Ssm() *NetworkInstance_Protocol_Igmp_Global_SsmPath {
	return &NetworkInstance_Protocol_Igmp_Global_SsmPath{
		NodePath: ygot.NewNodePath(
			[]string{"ssm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ssm (container): Source specific multicast (SSM).
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ssm"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm"
func (n *NetworkInstance_Protocol_Igmp_GlobalPathAny) Ssm() *NetworkInstance_Protocol_Igmp_Global_SsmPathAny {
	return &NetworkInstance_Protocol_Igmp_Global_SsmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ssm"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Global_SsmPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global/ssm YANG schema element.
type NetworkInstance_Protocol_Igmp_Global_SsmPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Global_SsmPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global/ssm YANG schema element.
type NetworkInstance_Protocol_Igmp_Global_SsmPathAny struct {
	*ygot.NodePath
}

// MappingAny (list): A Source Specific Multicast (SSM) mapping. This allows
// IGMP v2 hosts to be able to join in SSM environments
// by translating IGMP v2 reports into IGMP v3 reports.
// The request in an IGMP v2 join is sent toward the source
// address found by matching the multicast address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mappings/mapping"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping"
// Source (wildcarded): string
func (n *NetworkInstance_Protocol_Igmp_Global_SsmPath) MappingAny() *NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny {
	return &NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mappings", "mapping"},
			map[string]interface{}{"source": "*"},
			n,
		),
	}
}

// MappingAny (list): A Source Specific Multicast (SSM) mapping. This allows
// IGMP v2 hosts to be able to join in SSM environments
// by translating IGMP v2 reports into IGMP v3 reports.
// The request in an IGMP v2 join is sent toward the source
// address found by matching the multicast address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mappings/mapping"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping"
// Source (wildcarded): string
func (n *NetworkInstance_Protocol_Igmp_Global_SsmPathAny) MappingAny() *NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny {
	return &NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mappings", "mapping"},
			map[string]interface{}{"source": "*"},
			n,
		),
	}
}

// Mapping (list): A Source Specific Multicast (SSM) mapping. This allows
// IGMP v2 hosts to be able to join in SSM environments
// by translating IGMP v2 reports into IGMP v3 reports.
// The request in an IGMP v2 join is sent toward the source
// address found by matching the multicast address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mappings/mapping"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping"
// Source: string
func (n *NetworkInstance_Protocol_Igmp_Global_SsmPath) Mapping(Source string) *NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPath {
	return &NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPath{
		NodePath: ygot.NewNodePath(
			[]string{"mappings", "mapping"},
			map[string]interface{}{"source": Source},
			n,
		),
	}
}

// Mapping (list): A Source Specific Multicast (SSM) mapping. This allows
// IGMP v2 hosts to be able to join in SSM environments
// by translating IGMP v2 reports into IGMP v3 reports.
// The request in an IGMP v2 join is sent toward the source
// address found by matching the multicast address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mappings/mapping"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping"
// Source: string
func (n *NetworkInstance_Protocol_Igmp_Global_SsmPathAny) Mapping(Source string) *NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny {
	return &NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mappings", "mapping"},
			map[string]interface{}{"source": Source},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping YANG schema element.
type NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping YANG schema element.
type NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SourcePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping/config/source YANG schema element.
type NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SourcePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SourcePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping/config/source YANG schema element.
type NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SourcePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SsmRangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping/config/ssm-ranges YANG schema element.
type NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SsmRangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SsmRangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping/config/ssm-ranges YANG schema element.
type NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SsmRangesPathAny struct {
	*ygot.NodePath
}

// Source (leaf): Multicast source address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping/config/source"
func (n *NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPath) Source() *NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SourcePath {
	return &NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SourcePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// Source (leaf): Multicast source address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping/config/source"
func (n *NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny) Source() *NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SourcePathAny {
	return &NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SourcePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// SsmRanges (leaf): List of accepted source specific multicast (SSM) address
// ranges.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ssm-ranges"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping/config/ssm-ranges"
func (n *NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPath) SsmRanges() *NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SsmRangesPath {
	return &NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SsmRangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ssm-ranges"},
			map[string]interface{}{},
			n,
		),
	}
}

// SsmRanges (leaf): List of accepted source specific multicast (SSM) address
// ranges.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ssm-ranges"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/global/ssm/mappings/mapping/config/ssm-ranges"
func (n *NetworkInstance_Protocol_Igmp_Global_Ssm_MappingPathAny) SsmRanges() *NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SsmRangesPathAny {
	return &NetworkInstance_Protocol_Igmp_Global_Ssm_Mapping_SsmRangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ssm-ranges"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface YANG schema element.
type NetworkInstance_Protocol_Igmp_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface YANG schema element.
type NetworkInstance_Protocol_Igmp_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/enabled YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/enabled YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_FilterPrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/filter-prefixes YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_FilterPrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_FilterPrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/filter-prefixes YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_FilterPrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_QueryExpiresPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/state/query-expires YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_QueryExpiresPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_QueryExpiresPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/state/query-expires YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_QueryExpiresPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_QueryIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/query-interval YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_QueryIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_QueryIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/query-interval YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_QueryIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_VersionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/version YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_VersionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_VersionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/version YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_VersionPathAny struct {
	*ygot.NodePath
}

// Counters (container): Counters avaiable on a per interface bases for IGMP.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters"
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) Counters() *NetworkInstance_Protocol_Igmp_Interface_CountersPath {
	return &NetworkInstance_Protocol_Igmp_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Counters avaiable on a per interface bases for IGMP.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters"
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) Counters() *NetworkInstance_Protocol_Igmp_Interface_CountersPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this
// leaf is defined is enabled, when set to false it is
// explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/enabled"
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) Enabled() *NetworkInstance_Protocol_Igmp_Interface_EnabledPath {
	return &NetworkInstance_Protocol_Igmp_Interface_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this
// leaf is defined is enabled, when set to false it is
// explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/enabled"
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) Enabled() *NetworkInstance_Protocol_Igmp_Interface_EnabledPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// FilterPrefixes (leaf): List used to filter joins.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/filter-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/filter-prefixes"
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) FilterPrefixes() *NetworkInstance_Protocol_Igmp_Interface_FilterPrefixesPath {
	return &NetworkInstance_Protocol_Igmp_Interface_FilterPrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "filter-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// FilterPrefixes (leaf): List used to filter joins.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/filter-prefixes"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/filter-prefixes"
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) FilterPrefixes() *NetworkInstance_Protocol_Igmp_Interface_FilterPrefixesPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_FilterPrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "filter-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// GroupAny (list): Multicast group membership.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "membership-groups/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group"
// Group (wildcarded): string
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) GroupAny() *NetworkInstance_Protocol_Igmp_Interface_GroupPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"membership-groups", "group"},
			map[string]interface{}{"group": "*"},
			n,
		),
	}
}

// GroupAny (list): Multicast group membership.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "membership-groups/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group"
// Group (wildcarded): string
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) GroupAny() *NetworkInstance_Protocol_Igmp_Interface_GroupPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"membership-groups", "group"},
			map[string]interface{}{"group": "*"},
			n,
		),
	}
}

// Group (list): Multicast group membership.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "membership-groups/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group"
// Group: string
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) Group(Group string) *NetworkInstance_Protocol_Igmp_Interface_GroupPath {
	return &NetworkInstance_Protocol_Igmp_Interface_GroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"membership-groups", "group"},
			map[string]interface{}{"group": Group},
			n,
		),
	}
}

// Group (list): Multicast group membership.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "membership-groups/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group"
// Group: string
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) Group(Group string) *NetworkInstance_Protocol_Igmp_Interface_GroupPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"membership-groups", "group"},
			map[string]interface{}{"group": Group},
			n,
		),
	}
}

// InterfaceId (leaf): Reference to an interface on which IGMP is enabled.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) InterfaceId() *NetworkInstance_Protocol_Igmp_Interface_InterfaceIdPath {
	return &NetworkInstance_Protocol_Igmp_Interface_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Reference to an interface on which IGMP is enabled.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) InterfaceId() *NetworkInstance_Protocol_Igmp_Interface_InterfaceIdPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref"
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) InterfaceRef() *NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPath {
	return &NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref"
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) InterfaceRef() *NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// QueryExpires (leaf): This timestamp indicates the time that the next query is sent
// expressed relative to the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/query-expires"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/state/query-expires"
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) QueryExpires() *NetworkInstance_Protocol_Igmp_Interface_QueryExpiresPath {
	return &NetworkInstance_Protocol_Igmp_Interface_QueryExpiresPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "query-expires"},
			map[string]interface{}{},
			n,
		),
	}
}

// QueryExpires (leaf): This timestamp indicates the time that the next query is sent
// expressed relative to the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/query-expires"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/state/query-expires"
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) QueryExpires() *NetworkInstance_Protocol_Igmp_Interface_QueryExpiresPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_QueryExpiresPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "query-expires"},
			map[string]interface{}{},
			n,
		),
	}
}

// QueryInterval (leaf): Interval at which the router sends the IGMP membership
// queries.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/query-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/query-interval"
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) QueryInterval() *NetworkInstance_Protocol_Igmp_Interface_QueryIntervalPath {
	return &NetworkInstance_Protocol_Igmp_Interface_QueryIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "query-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// QueryInterval (leaf): Interval at which the router sends the IGMP membership
// queries.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/query-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/query-interval"
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) QueryInterval() *NetworkInstance_Protocol_Igmp_Interface_QueryIntervalPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_QueryIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "query-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaticGroupsAny (list): Multicast group membership.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-membership-groups/static-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups"
// StaticGroup (wildcarded): string
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) StaticGroupsAny() *NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-membership-groups", "static-groups"},
			map[string]interface{}{"static-group": "*"},
			n,
		),
	}
}

// StaticGroupsAny (list): Multicast group membership.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-membership-groups/static-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups"
// StaticGroup (wildcarded): string
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) StaticGroupsAny() *NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-membership-groups", "static-groups"},
			map[string]interface{}{"static-group": "*"},
			n,
		),
	}
}

// StaticGroups (list): Multicast group membership.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-membership-groups/static-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups"
// StaticGroup: string
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) StaticGroups(StaticGroup string) *NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPath {
	return &NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPath{
		NodePath: ygot.NewNodePath(
			[]string{"static-membership-groups", "static-groups"},
			map[string]interface{}{"static-group": StaticGroup},
			n,
		),
	}
}

// StaticGroups (list): Multicast group membership.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "static-membership-groups/static-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups"
// StaticGroup: string
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) StaticGroups(StaticGroup string) *NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"static-membership-groups", "static-groups"},
			map[string]interface{}{"static-group": StaticGroup},
			n,
		),
	}
}

// Version (leaf): IGMP Version.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/version"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/version"
func (n *NetworkInstance_Protocol_Igmp_InterfacePath) Version() *NetworkInstance_Protocol_Igmp_Interface_VersionPath {
	return &NetworkInstance_Protocol_Igmp_Interface_VersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "version"},
			map[string]interface{}{},
			n,
		),
	}
}

// Version (leaf): IGMP Version.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/version"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/config/version"
func (n *NetworkInstance_Protocol_Igmp_InterfacePathAny) Version() *NetworkInstance_Protocol_Igmp_Interface_VersionPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_VersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "version"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Interface_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// Queries (container): IGMP membership queries.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "queries"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries"
func (n *NetworkInstance_Protocol_Igmp_Interface_CountersPath) Queries() *NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPath {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPath{
		NodePath: ygot.NewNodePath(
			[]string{"queries"},
			map[string]interface{}{},
			n,
		),
	}
}

// Queries (container): IGMP membership queries.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "queries"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries"
func (n *NetworkInstance_Protocol_Igmp_Interface_CountersPathAny) Queries() *NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"queries"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reports (container): Number of IGMP membership reports received.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reports"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports"
func (n *NetworkInstance_Protocol_Igmp_Interface_CountersPath) Reports() *NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPath {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPath{
		NodePath: ygot.NewNodePath(
			[]string{"reports"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reports (container): Number of IGMP membership reports received.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reports"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports"
func (n *NetworkInstance_Protocol_Igmp_Interface_CountersPathAny) Reports() *NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reports"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPathAny struct {
	*ygot.NodePath
}

// Received (container): Number of IGMP membership queries received.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPath) Received() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPath {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (container): Number of IGMP membership queries received.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "received"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPathAny) Received() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (container): Number of IGMP membership queries sent.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPath) Sent() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPath {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (container): Number of IGMP membership queries sent.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_QueriesPathAny) Sent() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V1Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v1 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V1Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V1PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v1 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V1PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v2 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v2 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V3Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v3 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V3Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V3PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v3 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V3PathAny struct {
	*ygot.NodePath
}

// V1 (leaf): IGMP v1.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v1"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v1"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPath) V1() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V1Path {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V1Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v1"},
			map[string]interface{}{},
			n,
		),
	}
}

// V1 (leaf): IGMP v1.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v1"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v1"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPathAny) V1() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V1PathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V1PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v1"},
			map[string]interface{}{},
			n,
		),
	}
}

// V2 (leaf): IGMP v2.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v2"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v2"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPath) V2() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V2Path {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V2Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v2"},
			map[string]interface{}{},
			n,
		),
	}
}

// V2 (leaf): IGMP v2.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v2"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v2"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPathAny) V2() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V2PathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v2"},
			map[string]interface{}{},
			n,
		),
	}
}

// V3 (leaf): IGMP v3.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v3"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v3"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPath) V3() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V3Path {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V3Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v3"},
			map[string]interface{}{},
			n,
		),
	}
}

// V3 (leaf): IGMP v3.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v3"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/received/state/v3"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_ReceivedPathAny) V3() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V3PathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Received_V3PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v3"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V1Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v1 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V1Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V1PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v1 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V1PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v2 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v2 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V3Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v3 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V3Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V3PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v3 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V3PathAny struct {
	*ygot.NodePath
}

// V1 (leaf): IGMP v1.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v1"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v1"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPath) V1() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V1Path {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V1Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v1"},
			map[string]interface{}{},
			n,
		),
	}
}

// V1 (leaf): IGMP v1.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v1"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v1"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPathAny) V1() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V1PathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V1PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v1"},
			map[string]interface{}{},
			n,
		),
	}
}

// V2 (leaf): IGMP v2.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v2"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v2"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPath) V2() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V2Path {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V2Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v2"},
			map[string]interface{}{},
			n,
		),
	}
}

// V2 (leaf): IGMP v2.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v2"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v2"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPathAny) V2() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V2PathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v2"},
			map[string]interface{}{},
			n,
		),
	}
}

// V3 (leaf): IGMP v3.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v3"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v3"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPath) V3() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V3Path {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V3Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v3"},
			map[string]interface{}{},
			n,
		),
	}
}

// V3 (leaf): IGMP v3.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v3"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/queries/sent/state/v3"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_SentPathAny) V3() *NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V3PathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Queries_Sent_V3PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v3"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V1Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v1 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V1Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V1PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v1 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V1PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v2 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v2 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V3Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v3 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V3Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V3PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v3 YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V3PathAny struct {
	*ygot.NodePath
}

// V1 (leaf): IGMP v1.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v1"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v1"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPath) V1() *NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V1Path {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V1Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v1"},
			map[string]interface{}{},
			n,
		),
	}
}

// V1 (leaf): IGMP v1.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v1"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v1"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPathAny) V1() *NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V1PathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V1PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v1"},
			map[string]interface{}{},
			n,
		),
	}
}

// V2 (leaf): IGMP v2.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v2"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v2"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPath) V2() *NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V2Path {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V2Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v2"},
			map[string]interface{}{},
			n,
		),
	}
}

// V2 (leaf): IGMP v2.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v2"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v2"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPathAny) V2() *NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V2PathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v2"},
			map[string]interface{}{},
			n,
		),
	}
}

// V3 (leaf): IGMP v3.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v3"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v3"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPath) V3() *NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V3Path {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V3Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v3"},
			map[string]interface{}{},
			n,
		),
	}
}

// V3 (leaf): IGMP v3.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/v3"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/counters/reports/state/v3"
func (n *NetworkInstance_Protocol_Igmp_Interface_Counters_ReportsPathAny) V3() *NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V3PathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Counters_Reports_V3PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "v3"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Interface_GroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_GroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_GroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_GroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Group_GroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/group YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Group_GroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Group_GroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/group YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Group_GroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Group_ReporterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/reporter YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Group_ReporterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Group_ReporterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/reporter YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Group_ReporterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Group_SourcePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/source YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Group_SourcePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_Group_SourcePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/source YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_Group_SourcePathAny struct {
	*ygot.NodePath
}

// Group (leaf): Multicast address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/group"
func (n *NetworkInstance_Protocol_Igmp_Interface_GroupPath) Group() *NetworkInstance_Protocol_Igmp_Interface_Group_GroupPath {
	return &NetworkInstance_Protocol_Igmp_Interface_Group_GroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Group (leaf): Multicast address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/group"
func (n *NetworkInstance_Protocol_Igmp_Interface_GroupPathAny) Group() *NetworkInstance_Protocol_Igmp_Interface_Group_GroupPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Group_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reporter (leaf): Address of the last reporter.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reporter"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/reporter"
func (n *NetworkInstance_Protocol_Igmp_Interface_GroupPath) Reporter() *NetworkInstance_Protocol_Igmp_Interface_Group_ReporterPath {
	return &NetworkInstance_Protocol_Igmp_Interface_Group_ReporterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reporter"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reporter (leaf): Address of the last reporter.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reporter"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/reporter"
func (n *NetworkInstance_Protocol_Igmp_Interface_GroupPathAny) Reporter() *NetworkInstance_Protocol_Igmp_Interface_Group_ReporterPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Group_ReporterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reporter"},
			map[string]interface{}{},
			n,
		),
	}
}

// Source (leaf): Source address of multicast.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/source"
func (n *NetworkInstance_Protocol_Igmp_Interface_GroupPath) Source() *NetworkInstance_Protocol_Igmp_Interface_Group_SourcePath {
	return &NetworkInstance_Protocol_Igmp_Interface_Group_SourcePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// Source (leaf): Source address of multicast.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/membership-groups/group/state/source"
func (n *NetworkInstance_Protocol_Igmp_Interface_GroupPathAny) Source() *NetworkInstance_Protocol_Igmp_Interface_Group_SourcePathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_Group_SourcePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPath) Interface() *NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Igmp_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_StaticGroups_SourcePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups/config/source YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_StaticGroups_SourcePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_StaticGroups_SourcePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups/config/source YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_StaticGroups_SourcePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_StaticGroups_StaticGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups/config/static-group YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_StaticGroups_StaticGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Igmp_Interface_StaticGroups_StaticGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups/config/static-group YANG schema element.
type NetworkInstance_Protocol_Igmp_Interface_StaticGroups_StaticGroupPathAny struct {
	*ygot.NodePath
}

// Source (leaf): Source address of multicast.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups/config/source"
func (n *NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPath) Source() *NetworkInstance_Protocol_Igmp_Interface_StaticGroups_SourcePath {
	return &NetworkInstance_Protocol_Igmp_Interface_StaticGroups_SourcePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// Source (leaf): Source address of multicast.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups/config/source"
func (n *NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny) Source() *NetworkInstance_Protocol_Igmp_Interface_StaticGroups_SourcePathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_StaticGroups_SourcePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaticGroup (leaf): Multicast address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/static-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups/config/static-group"
func (n *NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPath) StaticGroup() *NetworkInstance_Protocol_Igmp_Interface_StaticGroups_StaticGroupPath {
	return &NetworkInstance_Protocol_Igmp_Interface_StaticGroups_StaticGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "static-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// StaticGroup (leaf): Multicast address.
// ----------------------------------------
// Defining module: "openconfig-igmp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/static-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/igmp/interfaces/interface/static-membership-groups/static-groups/config/static-group"
func (n *NetworkInstance_Protocol_Igmp_Interface_StaticGroupsPathAny) StaticGroup() *NetworkInstance_Protocol_Igmp_Interface_StaticGroups_StaticGroupPathAny {
	return &NetworkInstance_Protocol_Igmp_Interface_StaticGroups_StaticGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "static-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_IsisPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis YANG schema element.
type NetworkInstance_Protocol_IsisPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_IsisPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis YANG schema element.
type NetworkInstance_Protocol_IsisPathAny struct {
	*ygot.NodePath
}

// Global (container): This container defines global ISIS configuration and state
// information.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global"
func (n *NetworkInstance_Protocol_IsisPath) Global() *NetworkInstance_Protocol_Isis_GlobalPath {
	return &NetworkInstance_Protocol_Isis_GlobalPath{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// Global (container): This container defines global ISIS configuration and state
// information.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global"
func (n *NetworkInstance_Protocol_IsisPathAny) Global() *NetworkInstance_Protocol_Isis_GlobalPathAny {
	return &NetworkInstance_Protocol_Isis_GlobalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): This list contains ISIS interfaces.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Protocol_IsisPath) InterfaceAny() *NetworkInstance_Protocol_Isis_InterfacePathAny {
	return &NetworkInstance_Protocol_Isis_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): This list contains ISIS interfaces.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Protocol_IsisPathAny) InterfaceAny() *NetworkInstance_Protocol_Isis_InterfacePathAny {
	return &NetworkInstance_Protocol_Isis_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// Interface (list): This list contains ISIS interfaces.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Protocol_IsisPath) Interface(InterfaceId string) *NetworkInstance_Protocol_Isis_InterfacePath {
	return &NetworkInstance_Protocol_Isis_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Interface (list): This list contains ISIS interfaces.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Protocol_IsisPathAny) Interface(InterfaceId string) *NetworkInstance_Protocol_Isis_InterfacePathAny {
	return &NetworkInstance_Protocol_Isis_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// LevelAny (list): Configuration and operational state parameters related to a
// particular level within the IS-IS protocol instance
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "levels/level"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level"
// LevelNumber (wildcarded): uint8
func (n *NetworkInstance_Protocol_IsisPath) LevelAny() *NetworkInstance_Protocol_Isis_LevelPathAny {
	return &NetworkInstance_Protocol_Isis_LevelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"levels", "level"},
			map[string]interface{}{"level-number": "*"},
			n,
		),
	}
}

// LevelAny (list): Configuration and operational state parameters related to a
// particular level within the IS-IS protocol instance
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "levels/level"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level"
// LevelNumber (wildcarded): uint8
func (n *NetworkInstance_Protocol_IsisPathAny) LevelAny() *NetworkInstance_Protocol_Isis_LevelPathAny {
	return &NetworkInstance_Protocol_Isis_LevelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"levels", "level"},
			map[string]interface{}{"level-number": "*"},
			n,
		),
	}
}

// Level (list): Configuration and operational state parameters related to a
// particular level within the IS-IS protocol instance
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "levels/level"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level"
// LevelNumber: uint8
func (n *NetworkInstance_Protocol_IsisPath) Level(LevelNumber uint8) *NetworkInstance_Protocol_Isis_LevelPath {
	return &NetworkInstance_Protocol_Isis_LevelPath{
		NodePath: ygot.NewNodePath(
			[]string{"levels", "level"},
			map[string]interface{}{"level-number": LevelNumber},
			n,
		),
	}
}

// Level (list): Configuration and operational state parameters related to a
// particular level within the IS-IS protocol instance
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "levels/level"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level"
// LevelNumber: uint8
func (n *NetworkInstance_Protocol_IsisPathAny) Level(LevelNumber uint8) *NetworkInstance_Protocol_Isis_LevelPathAny {
	return &NetworkInstance_Protocol_Isis_LevelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"levels", "level"},
			map[string]interface{}{"level-number": LevelNumber},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_GlobalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global YANG schema element.
type NetworkInstance_Protocol_Isis_GlobalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_GlobalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global YANG schema element.
type NetworkInstance_Protocol_Isis_GlobalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_AuthenticationCheckPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/authentication-check YANG schema element.
type NetworkInstance_Protocol_Isis_Global_AuthenticationCheckPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_AuthenticationCheckPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/authentication-check YANG schema element.
type NetworkInstance_Protocol_Isis_Global_AuthenticationCheckPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_FastFloodingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/fast-flooding YANG schema element.
type NetworkInstance_Protocol_Isis_Global_FastFloodingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_FastFloodingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/fast-flooding YANG schema element.
type NetworkInstance_Protocol_Isis_Global_FastFloodingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_HelloPaddingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/hello-padding YANG schema element.
type NetworkInstance_Protocol_Isis_Global_HelloPaddingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_HelloPaddingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/hello-padding YANG schema element.
type NetworkInstance_Protocol_Isis_Global_HelloPaddingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_IidTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/iid-tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Global_IidTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_IidTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/iid-tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Global_IidTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InstancePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LevelCapabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/level-capability YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LevelCapabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LevelCapabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/level-capability YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LevelCapabilityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_MaxEcmpPathsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/max-ecmp-paths YANG schema element.
type NetworkInstance_Protocol_Isis_Global_MaxEcmpPathsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_MaxEcmpPathsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/max-ecmp-paths YANG schema element.
type NetworkInstance_Protocol_Isis_Global_MaxEcmpPathsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_MaximumAreaAddressesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/maximum-area-addresses YANG schema element.
type NetworkInstance_Protocol_Isis_Global_MaximumAreaAddressesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_MaximumAreaAddressesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/maximum-area-addresses YANG schema element.
type NetworkInstance_Protocol_Isis_Global_MaximumAreaAddressesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_NetPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/net YANG schema element.
type NetworkInstance_Protocol_Isis_Global_NetPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_NetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/net YANG schema element.
type NetworkInstance_Protocol_Isis_Global_NetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_PoiTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/poi-tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Global_PoiTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_PoiTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/config/poi-tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Global_PoiTlvPathAny struct {
	*ygot.NodePath
}

// AfAny (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPath) AfAny() *NetworkInstance_Protocol_Isis_Global_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": "*"},
			n,
		),
	}
}

// AfAny (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) AfAny() *NetworkInstance_Protocol_Isis_Global_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": "*"},
			n,
		),
	}
}

// AfAnySafiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPath) AfAnySafiName(AfiName E_IsisTypes_AFI_TYPE) *NetworkInstance_Protocol_Isis_Global_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": "*"},
			n,
		),
	}
}

// AfAnySafiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) AfAnySafiName(AfiName E_IsisTypes_AFI_TYPE) *NetworkInstance_Protocol_Isis_Global_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": "*"},
			n,
		),
	}
}

// AfAnyAfiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPath) AfAnyAfiName(SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Global_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": SafiName},
			n,
		),
	}
}

// AfAnyAfiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) AfAnyAfiName(SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Global_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": SafiName},
			n,
		),
	}
}

// Af (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPath) Af(AfiName E_IsisTypes_AFI_TYPE, SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Global_AfPath {
	return &NetworkInstance_Protocol_Isis_Global_AfPath{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": SafiName},
			n,
		),
	}
}

// Af (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) Af(AfiName E_IsisTypes_AFI_TYPE, SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Global_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": SafiName},
			n,
		),
	}
}

// AfiAny (list): Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-shortcuts/afi"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPath) AfiAny() *NetworkInstance_Protocol_Isis_Global_AfiPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"igp-shortcuts", "afi"},
			map[string]interface{}{"afi-name": "*"},
			n,
		),
	}
}

// AfiAny (list): Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-shortcuts/afi"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) AfiAny() *NetworkInstance_Protocol_Isis_Global_AfiPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"igp-shortcuts", "afi"},
			map[string]interface{}{"afi-name": "*"},
			n,
		),
	}
}

// Afi (list): Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-shortcuts/afi"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi"
// AfiName: E_IsisTypes_AFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPath) Afi(AfiName E_IsisTypes_AFI_TYPE) *NetworkInstance_Protocol_Isis_Global_AfiPath {
	return &NetworkInstance_Protocol_Isis_Global_AfiPath{
		NodePath: ygot.NewNodePath(
			[]string{"igp-shortcuts", "afi"},
			map[string]interface{}{"afi-name": AfiName},
			n,
		),
	}
}

// Afi (list): Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-shortcuts/afi"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi"
// AfiName: E_IsisTypes_AFI_TYPE
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) Afi(AfiName E_IsisTypes_AFI_TYPE) *NetworkInstance_Protocol_Isis_Global_AfiPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AfiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"igp-shortcuts", "afi"},
			map[string]interface{}{"afi-name": AfiName},
			n,
		),
	}
}

// AuthenticationCheck (leaf): When set to true, reject all ISIS protocol PDUs that either have a mismatch
// in authentication-type or authentication-key.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-check"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/authentication-check"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) AuthenticationCheck() *NetworkInstance_Protocol_Isis_Global_AuthenticationCheckPath {
	return &NetworkInstance_Protocol_Isis_Global_AuthenticationCheckPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-check"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationCheck (leaf): When set to true, reject all ISIS protocol PDUs that either have a mismatch
// in authentication-type or authentication-key.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-check"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/authentication-check"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) AuthenticationCheck() *NetworkInstance_Protocol_Isis_Global_AuthenticationCheckPathAny {
	return &NetworkInstance_Protocol_Isis_Global_AuthenticationCheckPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-check"},
			map[string]interface{}{},
			n,
		),
	}
}

// FastFlooding (leaf): When set to true, IS will always flood the LSP that triggered an SPF
// before the router actually runs the SPF computation.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/fast-flooding"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/fast-flooding"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) FastFlooding() *NetworkInstance_Protocol_Isis_Global_FastFloodingPath {
	return &NetworkInstance_Protocol_Isis_Global_FastFloodingPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "fast-flooding"},
			map[string]interface{}{},
			n,
		),
	}
}

// FastFlooding (leaf): When set to true, IS will always flood the LSP that triggered an SPF
// before the router actually runs the SPF computation.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/fast-flooding"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/fast-flooding"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) FastFlooding() *NetworkInstance_Protocol_Isis_Global_FastFloodingPathAny {
	return &NetworkInstance_Protocol_Isis_Global_FastFloodingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "fast-flooding"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): This container defines ISIS Graceful Restart.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) GracefulRestart() *NetworkInstance_Protocol_Isis_Global_GracefulRestartPath {
	return &NetworkInstance_Protocol_Isis_Global_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): This container defines ISIS Graceful Restart.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) GracefulRestart() *NetworkInstance_Protocol_Isis_Global_GracefulRestartPathAny {
	return &NetworkInstance_Protocol_Isis_Global_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloPadding (leaf): Controls the padding type for IS-IS Hello PDUs on a global level.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-padding"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/hello-padding"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) HelloPadding() *NetworkInstance_Protocol_Isis_Global_HelloPaddingPath {
	return &NetworkInstance_Protocol_Isis_Global_HelloPaddingPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-padding"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloPadding (leaf): Controls the padding type for IS-IS Hello PDUs on a global level.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-padding"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/hello-padding"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) HelloPadding() *NetworkInstance_Protocol_Isis_Global_HelloPaddingPathAny {
	return &NetworkInstance_Protocol_Isis_Global_HelloPaddingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-padding"},
			map[string]interface{}{},
			n,
		),
	}
}

// IidTlv (leaf): ISIS Instance Identifier TLV. When set to trues, the IID-TLV identifies
// the unique instance as well as the topology/topologies to which the
// PDU applies.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/iid-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/iid-tlv"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) IidTlv() *NetworkInstance_Protocol_Isis_Global_IidTlvPath {
	return &NetworkInstance_Protocol_Isis_Global_IidTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "iid-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// IidTlv (leaf): ISIS Instance Identifier TLV. When set to trues, the IID-TLV identifies
// the unique instance as well as the topology/topologies to which the
// PDU applies.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/iid-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/iid-tlv"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) IidTlv() *NetworkInstance_Protocol_Isis_Global_IidTlvPathAny {
	return &NetworkInstance_Protocol_Isis_Global_IidTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "iid-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instance (leaf): ISIS Instance.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/instance"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) Instance() *NetworkInstance_Protocol_Isis_Global_InstancePath {
	return &NetworkInstance_Protocol_Isis_Global_InstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instance (leaf): ISIS Instance.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/instance"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) Instance() *NetworkInstance_Protocol_Isis_Global_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Global_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "instance"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterLevelPropagationPolicies (container): Policies to propagate prefixes between IS-IS levels.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-level-propagation-policies"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) InterLevelPropagationPolicies() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPath {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPath{
		NodePath: ygot.NewNodePath(
			[]string{"inter-level-propagation-policies"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterLevelPropagationPolicies (container): Policies to propagate prefixes between IS-IS levels.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-level-propagation-policies"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) InterLevelPropagationPolicies() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPathAny {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inter-level-propagation-policies"},
			map[string]interface{}{},
			n,
		),
	}
}

// LevelCapability (leaf): ISIS level capability(level-1, level-2, level-1-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/level-capability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/level-capability"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) LevelCapability() *NetworkInstance_Protocol_Isis_Global_LevelCapabilityPath {
	return &NetworkInstance_Protocol_Isis_Global_LevelCapabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "level-capability"},
			map[string]interface{}{},
			n,
		),
	}
}

// LevelCapability (leaf): ISIS level capability(level-1, level-2, level-1-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/level-capability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/level-capability"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) LevelCapability() *NetworkInstance_Protocol_Isis_Global_LevelCapabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LevelCapabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "level-capability"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspBit (container): This container defines ISIS LSP Operational Bits.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsp-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) LspBit() *NetworkInstance_Protocol_Isis_Global_LspBitPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"lsp-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspBit (container): This container defines ISIS LSP Operational Bits.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsp-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) LspBit() *NetworkInstance_Protocol_Isis_Global_LspBitPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsp-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxEcmpPaths (leaf): ISIS max-paths count.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-ecmp-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/max-ecmp-paths"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) MaxEcmpPaths() *NetworkInstance_Protocol_Isis_Global_MaxEcmpPathsPath {
	return &NetworkInstance_Protocol_Isis_Global_MaxEcmpPathsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-ecmp-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxEcmpPaths (leaf): ISIS max-paths count.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/max-ecmp-paths"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/max-ecmp-paths"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) MaxEcmpPaths() *NetworkInstance_Protocol_Isis_Global_MaxEcmpPathsPathAny {
	return &NetworkInstance_Protocol_Isis_Global_MaxEcmpPathsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-ecmp-paths"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumAreaAddresses (leaf): Maximum areas supported.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-area-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/maximum-area-addresses"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) MaximumAreaAddresses() *NetworkInstance_Protocol_Isis_Global_MaximumAreaAddressesPath {
	return &NetworkInstance_Protocol_Isis_Global_MaximumAreaAddressesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-area-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumAreaAddresses (leaf): Maximum areas supported.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-area-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/maximum-area-addresses"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) MaximumAreaAddresses() *NetworkInstance_Protocol_Isis_Global_MaximumAreaAddressesPathAny {
	return &NetworkInstance_Protocol_Isis_Global_MaximumAreaAddressesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-area-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): Configuration and operational state relating to MPLS-related
// features in IS-IS
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/mpls"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) Mpls() *NetworkInstance_Protocol_Isis_Global_MplsPath {
	return &NetworkInstance_Protocol_Isis_Global_MplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): Configuration and operational state relating to MPLS-related
// features in IS-IS
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/mpls"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) Mpls() *NetworkInstance_Protocol_Isis_Global_MplsPathAny {
	return &NetworkInstance_Protocol_Isis_Global_MplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Net (leaf): ISIS network entity title (NET). The first 8 bits are usually
// 49 (private AFI), next 16 bits represent area, next 48 bits represent
// system id and final 8 bits are set to 0.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/net"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/net"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) Net() *NetworkInstance_Protocol_Isis_Global_NetPath {
	return &NetworkInstance_Protocol_Isis_Global_NetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "net"},
			map[string]interface{}{},
			n,
		),
	}
}

// Net (leaf): ISIS network entity title (NET). The first 8 bits are usually
// 49 (private AFI), next 16 bits represent area, next 48 bits represent
// system id and final 8 bits are set to 0.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/net"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/net"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) Net() *NetworkInstance_Protocol_Isis_Global_NetPathAny {
	return &NetworkInstance_Protocol_Isis_Global_NetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "net"},
			map[string]interface{}{},
			n,
		),
	}
}

// Nsr (container): This container defines ISIS Non-Stop Routing.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "nsr"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/nsr"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) Nsr() *NetworkInstance_Protocol_Isis_Global_NsrPath {
	return &NetworkInstance_Protocol_Isis_Global_NsrPath{
		NodePath: ygot.NewNodePath(
			[]string{"nsr"},
			map[string]interface{}{},
			n,
		),
	}
}

// Nsr (container): This container defines ISIS Non-Stop Routing.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "nsr"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/nsr"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) Nsr() *NetworkInstance_Protocol_Isis_Global_NsrPathAny {
	return &NetworkInstance_Protocol_Isis_Global_NsrPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"nsr"},
			map[string]interface{}{},
			n,
		),
	}
}

// PoiTlv (leaf): ISIS purge TLV. When set to true, a TLV is added to purges to record
// the system ID  of the IS generating the purge.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/poi-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/poi-tlv"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) PoiTlv() *NetworkInstance_Protocol_Isis_Global_PoiTlvPath {
	return &NetworkInstance_Protocol_Isis_Global_PoiTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "poi-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// PoiTlv (leaf): ISIS purge TLV. When set to true, a TLV is added to purges to record
// the system ID  of the IS generating the purge.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/poi-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/config/poi-tlv"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) PoiTlv() *NetworkInstance_Protocol_Isis_Global_PoiTlvPathAny {
	return &NetworkInstance_Protocol_Isis_Global_PoiTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "poi-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReferenceBandwidth (container): This container defines ISIS Reference Bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reference-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/reference-bandwidth"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) ReferenceBandwidth() *NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"reference-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReferenceBandwidth (container): This container defines ISIS Reference Bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reference-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/reference-bandwidth"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) ReferenceBandwidth() *NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reference-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRouting (container): Configuration and operational state relating to segment routing.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/segment-routing"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) SegmentRouting() *NetworkInstance_Protocol_Isis_Global_SegmentRoutingPath {
	return &NetworkInstance_Protocol_Isis_Global_SegmentRoutingPath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRouting (container): Configuration and operational state relating to segment routing.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/segment-routing"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) SegmentRouting() *NetworkInstance_Protocol_Isis_Global_SegmentRoutingPathAny {
	return &NetworkInstance_Protocol_Isis_Global_SegmentRoutingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): This container defines ISIS timers.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) Timers() *NetworkInstance_Protocol_Isis_Global_TimersPath {
	return &NetworkInstance_Protocol_Isis_Global_TimersPath{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): This container defines ISIS timers.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) Timers() *NetworkInstance_Protocol_Isis_Global_TimersPathAny {
	return &NetworkInstance_Protocol_Isis_Global_TimersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): This container defines ISIS transport.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transport"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/transport"
func (n *NetworkInstance_Protocol_Isis_GlobalPath) Transport() *NetworkInstance_Protocol_Isis_Global_TransportPath {
	return &NetworkInstance_Protocol_Isis_Global_TransportPath{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transport (container): This container defines ISIS transport.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "transport"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/transport"
func (n *NetworkInstance_Protocol_Isis_GlobalPathAny) Transport() *NetworkInstance_Protocol_Isis_Global_TransportPathAny {
	return &NetworkInstance_Protocol_Isis_Global_TransportPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"transport"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_AfPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af YANG schema element.
type NetworkInstance_Protocol_Isis_Global_AfPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_AfPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af YANG schema element.
type NetworkInstance_Protocol_Isis_Global_AfPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_AfiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_AfiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_AfiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_AfiNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_SafiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/safi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_SafiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_SafiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/safi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_SafiNamePathAny struct {
	*ygot.NodePath
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Global_AfPath) AfiName() *NetworkInstance_Protocol_Isis_Global_Af_AfiNamePath {
	return &NetworkInstance_Protocol_Isis_Global_Af_AfiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Global_AfPathAny) AfiName() *NetworkInstance_Protocol_Isis_Global_Af_AfiNamePathAny {
	return &NetworkInstance_Protocol_Isis_Global_Af_AfiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_AfPath) Enabled() *NetworkInstance_Protocol_Isis_Global_Af_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Global_Af_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_AfPathAny) Enabled() *NetworkInstance_Protocol_Isis_Global_Af_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Af_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value(default=10).
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/metric"
func (n *NetworkInstance_Protocol_Isis_Global_AfPath) Metric() *NetworkInstance_Protocol_Isis_Global_Af_MetricPath {
	return &NetworkInstance_Protocol_Isis_Global_Af_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value(default=10).
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/metric"
func (n *NetworkInstance_Protocol_Isis_Global_AfPathAny) Metric() *NetworkInstance_Protocol_Isis_Global_Af_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Af_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopology (container): This container defines multi-topology address-family configuration
// and state information. ISIS TLV 235, 237.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "multi-topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology"
func (n *NetworkInstance_Protocol_Isis_Global_AfPath) MultiTopology() *NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPath {
	return &NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPath{
		NodePath: ygot.NewNodePath(
			[]string{"multi-topology"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopology (container): This container defines multi-topology address-family configuration
// and state information. ISIS TLV 235, 237.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "multi-topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology"
func (n *NetworkInstance_Protocol_Isis_Global_AfPathAny) MultiTopology() *NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"multi-topology"},
			map[string]interface{}{},
			n,
		),
	}
}

// SafiName (leaf): Subsequent address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/safi-name"
func (n *NetworkInstance_Protocol_Isis_Global_AfPath) SafiName() *NetworkInstance_Protocol_Isis_Global_Af_SafiNamePath {
	return &NetworkInstance_Protocol_Isis_Global_Af_SafiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SafiName (leaf): Subsequent address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/config/safi-name"
func (n *NetworkInstance_Protocol_Isis_Global_AfPathAny) SafiName() *NetworkInstance_Protocol_Isis_Global_Af_SafiNamePathAny {
	return &NetworkInstance_Protocol_Isis_Global_Af_SafiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_AfiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_AfiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_AfiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_AfiNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/state/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/state/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_SafiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/config/safi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_SafiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_SafiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/config/safi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_SafiNamePathAny struct {
	*ygot.NodePath
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPath) AfiName() *NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_AfiNamePath {
	return &NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_AfiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPathAny) AfiName() *NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_AfiNamePathAny {
	return &NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_AfiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/state/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPath) Enabled() *NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/state/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPathAny) Enabled() *NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// SafiName (leaf): Subsequent address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/config/safi-name"
func (n *NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPath) SafiName() *NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_SafiNamePath {
	return &NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_SafiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SafiName (leaf): Subsequent address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/afi-safi/af/multi-topology/config/safi-name"
func (n *NetworkInstance_Protocol_Isis_Global_Af_MultiTopologyPathAny) SafiName() *NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_SafiNamePathAny {
	return &NetworkInstance_Protocol_Isis_Global_Af_MultiTopology_SafiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_AfiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi YANG schema element.
type NetworkInstance_Protocol_Isis_Global_AfiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_AfiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi YANG schema element.
type NetworkInstance_Protocol_Isis_Global_AfiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Afi_AfiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Afi_AfiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Afi_AfiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Afi_AfiNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Afi_NhTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi/config/nh-type YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Afi_NhTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Afi_NhTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi/config/nh-type YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Afi_NhTypePathAny struct {
	*ygot.NodePath
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Global_AfiPath) AfiName() *NetworkInstance_Protocol_Isis_Global_Afi_AfiNamePath {
	return &NetworkInstance_Protocol_Isis_Global_Afi_AfiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Global_AfiPathAny) AfiName() *NetworkInstance_Protocol_Isis_Global_Afi_AfiNamePathAny {
	return &NetworkInstance_Protocol_Isis_Global_Afi_AfiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// NhType (leaf): Tunnel NH Type(RSVP,SR). When present it implies
// that nh-type shortcut is enabled for a specified AFI.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/nh-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi/config/nh-type"
func (n *NetworkInstance_Protocol_Isis_Global_AfiPath) NhType() *NetworkInstance_Protocol_Isis_Global_Afi_NhTypePath {
	return &NetworkInstance_Protocol_Isis_Global_Afi_NhTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "nh-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NhType (leaf): Tunnel NH Type(RSVP,SR). When present it implies
// that nh-type shortcut is enabled for a specified AFI.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/nh-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/igp-shortcuts/afi/config/nh-type"
func (n *NetworkInstance_Protocol_Isis_Global_AfiPathAny) NhType() *NetworkInstance_Protocol_Isis_Global_Afi_NhTypePathAny {
	return &NetworkInstance_Protocol_Isis_Global_Afi_NhTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "nh-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Isis_Global_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Isis_Global_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_GracefulRestart_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_GracefulRestart_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_GracefulRestart_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_GracefulRestart_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_GracefulRestart_HelperOnlyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Isis_Global_GracefulRestart_HelperOnlyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_GracefulRestart_HelperOnlyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Isis_Global_GracefulRestart_HelperOnlyPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_GracefulRestartPath) Enabled() *NetworkInstance_Protocol_Isis_Global_GracefulRestart_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Global_GracefulRestart_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_GracefulRestartPathAny) Enabled() *NetworkInstance_Protocol_Isis_Global_GracefulRestart_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Global_GracefulRestart_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Enable or disable the IS-IS graceful restart helper function. When
// this leaf is set, the local system does not utilise the IS-IS
// graceful restart procedures during its own restart, but supports
// retaining forwarding information during a remote speaker's restart.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Isis_Global_GracefulRestartPath) HelperOnly() *NetworkInstance_Protocol_Isis_Global_GracefulRestart_HelperOnlyPath {
	return &NetworkInstance_Protocol_Isis_Global_GracefulRestart_HelperOnlyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Enable or disable the IS-IS graceful restart helper function. When
// this leaf is set, the local system does not utilise the IS-IS
// graceful restart procedures during its own restart, but supports
// retaining forwarding information during a remote speaker's restart.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Isis_Global_GracefulRestartPathAny) HelperOnly() *NetworkInstance_Protocol_Isis_Global_GracefulRestart_HelperOnlyPathAny {
	return &NetworkInstance_Protocol_Isis_Global_GracefulRestart_HelperOnlyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPathAny struct {
	*ygot.NodePath
}

// Level1ToLevel2 (container): Policies relating to prefixes to be propagated from
// Level 1 to Level 2.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "level1-to-level2"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPath) Level1ToLevel2() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2Path {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2Path{
		NodePath: ygot.NewNodePath(
			[]string{"level1-to-level2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Level1ToLevel2 (container): Policies relating to prefixes to be propagated from
// Level 1 to Level 2.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "level1-to-level2"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPathAny) Level1ToLevel2() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2PathAny {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"level1-to-level2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Level2ToLevel1 (container): Policies relating to prefixes to be propagated from
// Level2 to Level 1.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "level2-to-level1"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPath) Level2ToLevel1() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1Path {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1Path{
		NodePath: ygot.NewNodePath(
			[]string{"level2-to-level1"},
			map[string]interface{}{},
			n,
		),
	}
}

// Level2ToLevel1 (container): Policies relating to prefixes to be propagated from
// Level2 to Level 1.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "level2-to-level1"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPoliciesPathAny) Level2ToLevel1() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1PathAny {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"level2-to-level1"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2 YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2 YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_DefaultImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_DefaultImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_DefaultImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_DefaultImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_ImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_ImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_ImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_ImportPolicyPathAny struct {
	*ygot.NodePath
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2/config/default-import-policy"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2Path) DefaultImportPolicy() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_DefaultImportPolicyPath {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_DefaultImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2/config/default-import-policy"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2PathAny) DefaultImportPolicy() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_DefaultImportPolicyPathAny {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_DefaultImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2/config/import-policy"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2Path) ImportPolicy() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_ImportPolicyPath {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_ImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level1-to-level2/config/import-policy"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2PathAny) ImportPolicy() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_ImportPolicyPathAny {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level1ToLevel2_ImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1 YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1 YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_DefaultImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_DefaultImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_DefaultImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_DefaultImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_ImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_ImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_ImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_ImportPolicyPathAny struct {
	*ygot.NodePath
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1/config/default-import-policy"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1Path) DefaultImportPolicy() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_DefaultImportPolicyPath {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_DefaultImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1/config/default-import-policy"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1PathAny) DefaultImportPolicy() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_DefaultImportPolicyPathAny {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_DefaultImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1/config/import-policy"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1Path) ImportPolicy() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_ImportPolicyPath {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_ImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/inter-level-propagation-policies/level2-to-level1/config/import-policy"
func (n *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1PathAny) ImportPolicy() *NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_ImportPolicyPathAny {
	return &NetworkInstance_Protocol_Isis_Global_InterLevelPropagationPolicies_Level2ToLevel1_ImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_LspBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBitPathAny struct {
	*ygot.NodePath
}

// AttachedBit (container): This container defines Attached Bit.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "attached-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBitPath) AttachedBit() *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"attached-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttachedBit (container): This container defines Attached Bit.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "attached-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBitPathAny) AttachedBit() *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"attached-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// OverloadBit (container): This container defines Overload Bit configuration.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "overload-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBitPath) OverloadBit() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"overload-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// OverloadBit (container): This container defines Overload Bit configuration.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "overload-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBitPathAny) OverloadBit() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"overload-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_IgnoreBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit/config/ignore-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_IgnoreBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_IgnoreBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit/config/ignore-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_IgnoreBitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_SuppressBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit/config/suppress-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_SuppressBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_SuppressBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit/config/suppress-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_SuppressBitPathAny struct {
	*ygot.NodePath
}

// IgnoreBit (leaf): When set to true, if the attached bit is set on an incoming Level 1
// IS-IS, the local system ignores it. In this case the local system
// does not set a default route to the L1L2 router advertising the PDU
// with the attached bit set.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit/config/ignore-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPath) IgnoreBit() *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_IgnoreBitPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_IgnoreBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgnoreBit (leaf): When set to true, if the attached bit is set on an incoming Level 1
// IS-IS, the local system ignores it. In this case the local system
// does not set a default route to the L1L2 router advertising the PDU
// with the attached bit set.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ignore-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit/config/ignore-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPathAny) IgnoreBit() *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_IgnoreBitPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_IgnoreBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ignore-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SuppressBit (leaf): When set to true, if the local IS acts as a L1L2 router, then the
// attached bit is not advertised in locally generated PDUs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/suppress-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit/config/suppress-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPath) SuppressBit() *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_SuppressBitPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_SuppressBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "suppress-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SuppressBit (leaf): When set to true, if the local IS acts as a L1L2 router, then the
// attached bit is not advertised in locally generated PDUs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/suppress-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/attached-bit/config/suppress-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBitPathAny) SuppressBit() *NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_SuppressBitPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_AttachedBit_SuppressBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "suppress-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_AdvertiseHighMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/advertise-high-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_AdvertiseHighMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_AdvertiseHighMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/advertise-high-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_AdvertiseHighMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/set-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/set-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitOnBootPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/set-bit-on-boot YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitOnBootPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitOnBootPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/set-bit-on-boot YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitOnBootPathAny struct {
	*ygot.NodePath
}

// AdvertiseHighMetric (leaf): When set to true, the local IS advertises links with the highest
// available metric regardless of their configured metric. The metric
// value is based on the metric style - if wide metrics are utilised
// the metric is advertised as 16777214, otherwise they are advertised
// with a value of 63.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/advertise-high-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/advertise-high-metric"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPath) AdvertiseHighMetric() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_AdvertiseHighMetricPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_AdvertiseHighMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertise-high-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertiseHighMetric (leaf): When set to true, the local IS advertises links with the highest
// available metric regardless of their configured metric. The metric
// value is based on the metric style - if wide metrics are utilised
// the metric is advertised as 16777214, otherwise they are advertised
// with a value of 63.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/advertise-high-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/advertise-high-metric"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPathAny) AdvertiseHighMetric() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_AdvertiseHighMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_AdvertiseHighMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "advertise-high-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResetTriggerAny (list): This list describes ISIS Overload reset trigger reasons.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reset-triggers/reset-trigger"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger"
// ResetTrigger (wildcarded): E_IsisTypes_OVERLOAD_RESET_TRIGGER_TYPE
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPath) ResetTriggerAny() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reset-triggers", "reset-trigger"},
			map[string]interface{}{"reset-trigger": "*"},
			n,
		),
	}
}

// ResetTriggerAny (list): This list describes ISIS Overload reset trigger reasons.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reset-triggers/reset-trigger"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger"
// ResetTrigger (wildcarded): E_IsisTypes_OVERLOAD_RESET_TRIGGER_TYPE
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPathAny) ResetTriggerAny() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reset-triggers", "reset-trigger"},
			map[string]interface{}{"reset-trigger": "*"},
			n,
		),
	}
}

// ResetTrigger (list): This list describes ISIS Overload reset trigger reasons.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reset-triggers/reset-trigger"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger"
// ResetTrigger: E_IsisTypes_OVERLOAD_RESET_TRIGGER_TYPE
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPath) ResetTrigger(ResetTrigger E_IsisTypes_OVERLOAD_RESET_TRIGGER_TYPE) *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPath{
		NodePath: ygot.NewNodePath(
			[]string{"reset-triggers", "reset-trigger"},
			map[string]interface{}{"reset-trigger": ResetTrigger},
			n,
		),
	}
}

// ResetTrigger (list): This list describes ISIS Overload reset trigger reasons.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "reset-triggers/reset-trigger"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger"
// ResetTrigger: E_IsisTypes_OVERLOAD_RESET_TRIGGER_TYPE
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPathAny) ResetTrigger(ResetTrigger E_IsisTypes_OVERLOAD_RESET_TRIGGER_TYPE) *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reset-triggers", "reset-trigger"},
			map[string]interface{}{"reset-trigger": ResetTrigger},
			n,
		),
	}
}

// SetBit (leaf): When set to true, IS-IS overload bit is set.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/set-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPath) SetBit() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetBit (leaf): When set to true, IS-IS overload bit is set.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/set-bit"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPathAny) SetBit() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetBitOnBoot (leaf): When set to true, the IS-IS overload bit is set on system boot.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-bit-on-boot"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/set-bit-on-boot"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPath) SetBitOnBoot() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitOnBootPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitOnBootPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-bit-on-boot"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetBitOnBoot (leaf): When set to true, the IS-IS overload bit is set on system boot.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-bit-on-boot"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/config/set-bit-on-boot"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBitPathAny) SetBitOnBoot() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitOnBootPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_SetBitOnBootPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-bit-on-boot"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_DelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger/config/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_DelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_DelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger/config/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_DelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_ResetTriggerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger/config/reset-trigger YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_ResetTriggerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_ResetTriggerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger/config/reset-trigger YANG schema element.
type NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_ResetTriggerPathAny struct {
	*ygot.NodePath
}

// Delay (leaf): If a reset trigger is specified, the system should delay resetting
// the overload bit for the specified number of seconds after the
// trigger occurs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger/config/delay"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPath) Delay() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_DelayPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_DelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): If a reset trigger is specified, the system should delay resetting
// the overload bit for the specified number of seconds after the
// trigger occurs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger/config/delay"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny) Delay() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_DelayPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_DelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResetTrigger (leaf): In the case that the system sets the overload bit on start, the
// system should reset the bit (i.e., clear the overload bit) upon
// the specified trigger.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reset-trigger"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger/config/reset-trigger"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPath) ResetTrigger() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_ResetTriggerPath {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_ResetTriggerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reset-trigger"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResetTrigger (leaf): In the case that the system sets the overload bit on start, the
// system should reset the bit (i.e., clear the overload bit) upon
// the specified trigger.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reset-trigger"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/lsp-bit/overload-bit/reset-triggers/reset-trigger/config/reset-trigger"
func (n *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTriggerPathAny) ResetTrigger() *NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_ResetTriggerPathAny {
	return &NetworkInstance_Protocol_Isis_Global_LspBit_OverloadBit_ResetTrigger_ResetTriggerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reset-trigger"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_MplsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/mpls YANG schema element.
type NetworkInstance_Protocol_Isis_Global_MplsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_MplsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/mpls YANG schema element.
type NetworkInstance_Protocol_Isis_Global_MplsPathAny struct {
	*ygot.NodePath
}

// IgpLdpSync (container): Configuration and operational state relating to synchronisation
// between the LDP and IS-IS
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-ldp-sync"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync"
func (n *NetworkInstance_Protocol_Isis_Global_MplsPath) IgpLdpSync() *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPath {
	return &NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPath{
		NodePath: ygot.NewNodePath(
			[]string{"igp-ldp-sync"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgpLdpSync (container): Configuration and operational state relating to synchronisation
// between the LDP and IS-IS
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-ldp-sync"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync"
func (n *NetworkInstance_Protocol_Isis_Global_MplsPathAny) IgpLdpSync() *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"igp-ldp-sync"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_PostSessionUpDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync/config/post-session-up-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_PostSessionUpDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_PostSessionUpDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync/config/post-session-up-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_PostSessionUpDelayPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When set to true, rely on IGP/LDP synchronization. IGP cost for
// link is maintained at max until LDP adjacencies are established
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPath) Enabled() *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, rely on IGP/LDP synchronization. IGP cost for
// link is maintained at max until LDP adjacencies are established
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPathAny) Enabled() *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostSessionUpDelay (leaf): Specifies a delay, expressed in units of seconds,
// between the LDP session to the IGP neighbor being established, and
// it being considered synchronized by the IGP.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/post-session-up-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync/config/post-session-up-delay"
func (n *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPath) PostSessionUpDelay() *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_PostSessionUpDelayPath {
	return &NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_PostSessionUpDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "post-session-up-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostSessionUpDelay (leaf): Specifies a delay, expressed in units of seconds,
// between the LDP session to the IGP neighbor being established, and
// it being considered synchronized by the IGP.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/post-session-up-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/mpls/igp-ldp-sync/config/post-session-up-delay"
func (n *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSyncPathAny) PostSessionUpDelay() *NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_PostSessionUpDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Mpls_IgpLdpSync_PostSessionUpDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "post-session-up-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_NsrPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/nsr YANG schema element.
type NetworkInstance_Protocol_Isis_Global_NsrPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_NsrPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/nsr YANG schema element.
type NetworkInstance_Protocol_Isis_Global_NsrPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Nsr_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/nsr/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Nsr_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Nsr_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/nsr/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Nsr_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/nsr/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_NsrPath) Enabled() *NetworkInstance_Protocol_Isis_Global_Nsr_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Global_Nsr_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/nsr/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_NsrPathAny) Enabled() *NetworkInstance_Protocol_Isis_Global_Nsr_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Nsr_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/reference-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/reference-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_ReferenceBandwidth_ReferenceBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/reference-bandwidth/config/reference-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Global_ReferenceBandwidth_ReferenceBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_ReferenceBandwidth_ReferenceBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/reference-bandwidth/config/reference-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Global_ReferenceBandwidth_ReferenceBandwidthPathAny struct {
	*ygot.NodePath
}

// ReferenceBandwidth (leaf): ISIS Reference Bandwidth value
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reference-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/reference-bandwidth/config/reference-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPath) ReferenceBandwidth() *NetworkInstance_Protocol_Isis_Global_ReferenceBandwidth_ReferenceBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Global_ReferenceBandwidth_ReferenceBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reference-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReferenceBandwidth (leaf): ISIS Reference Bandwidth value
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/reference-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/reference-bandwidth/config/reference-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Global_ReferenceBandwidthPathAny) ReferenceBandwidth() *NetworkInstance_Protocol_Isis_Global_ReferenceBandwidth_ReferenceBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Global_ReferenceBandwidth_ReferenceBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "reference-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_SegmentRoutingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/segment-routing YANG schema element.
type NetworkInstance_Protocol_Isis_Global_SegmentRoutingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_SegmentRoutingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/segment-routing YANG schema element.
type NetworkInstance_Protocol_Isis_Global_SegmentRoutingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_SegmentRouting_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_SegmentRouting_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_SegmentRouting_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Global_SegmentRouting_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrgbPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/srgb YANG schema element.
type NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrgbPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrgbPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/srgb YANG schema element.
type NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrgbPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrlbPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/srlb YANG schema element.
type NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrlbPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrlbPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/srlb YANG schema element.
type NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrlbPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, the segment routing extensions are
// utilised within the IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_SegmentRoutingPath) Enabled() *NetworkInstance_Protocol_Isis_Global_SegmentRouting_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Global_SegmentRouting_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, the segment routing extensions are
// utilised within the IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Global_SegmentRoutingPathAny) Enabled() *NetworkInstance_Protocol_Isis_Global_SegmentRouting_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Global_SegmentRouting_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Srgb (leaf): A reference to the Segment Routing Global Block (SRGB) that is
// to be used by this IGP instance.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/srgb"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/srgb"
func (n *NetworkInstance_Protocol_Isis_Global_SegmentRoutingPath) Srgb() *NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrgbPath {
	return &NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrgbPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "srgb"},
			map[string]interface{}{},
			n,
		),
	}
}

// Srgb (leaf): A reference to the Segment Routing Global Block (SRGB) that is
// to be used by this IGP instance.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/srgb"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/srgb"
func (n *NetworkInstance_Protocol_Isis_Global_SegmentRoutingPathAny) Srgb() *NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrgbPathAny {
	return &NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrgbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "srgb"},
			map[string]interface{}{},
			n,
		),
	}
}

// Srlb (leaf): A reference to the Segment Routing Local Block (SRLB) that is to
// be advertised by the IGP instance.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/srlb"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/srlb"
func (n *NetworkInstance_Protocol_Isis_Global_SegmentRoutingPath) Srlb() *NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrlbPath {
	return &NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrlbPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "srlb"},
			map[string]interface{}{},
			n,
		),
	}
}

// Srlb (leaf): A reference to the Segment Routing Local Block (SRLB) that is to
// be advertised by the IGP instance.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/srlb"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/segment-routing/config/srlb"
func (n *NetworkInstance_Protocol_Isis_Global_SegmentRoutingPathAny) Srlb() *NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrlbPathAny {
	return &NetworkInstance_Protocol_Isis_Global_SegmentRouting_SrlbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "srlb"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_TimersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers YANG schema element.
type NetworkInstance_Protocol_Isis_Global_TimersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_TimersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers YANG schema element.
type NetworkInstance_Protocol_Isis_Global_TimersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspLifetimeIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/config/lsp-lifetime-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspLifetimeIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspLifetimeIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/config/lsp-lifetime-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspLifetimeIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspRefreshIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/config/lsp-refresh-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspRefreshIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspRefreshIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/config/lsp-refresh-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspRefreshIntervalPathAny struct {
	*ygot.NodePath
}

// LspGeneration (container): This container defines ISIS LSP Generation.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsp-generation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation"
func (n *NetworkInstance_Protocol_Isis_Global_TimersPath) LspGeneration() *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPath{
		NodePath: ygot.NewNodePath(
			[]string{"lsp-generation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspGeneration (container): This container defines ISIS LSP Generation.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsp-generation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation"
func (n *NetworkInstance_Protocol_Isis_Global_TimersPathAny) LspGeneration() *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsp-generation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspLifetimeInterval (leaf): Time interval in seconds that specifies how long an LSP remains in
// LSDB without being refreshed.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-lifetime-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/config/lsp-lifetime-interval"
func (n *NetworkInstance_Protocol_Isis_Global_TimersPath) LspLifetimeInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspLifetimeIntervalPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspLifetimeIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-lifetime-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspLifetimeInterval (leaf): Time interval in seconds that specifies how long an LSP remains in
// LSDB without being refreshed.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-lifetime-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/config/lsp-lifetime-interval"
func (n *NetworkInstance_Protocol_Isis_Global_TimersPathAny) LspLifetimeInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspLifetimeIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspLifetimeIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-lifetime-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspRefreshInterval (leaf): Time interval in seconds that specifies how often route topology
// that a device originates is transmitted in LSPs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-refresh-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/config/lsp-refresh-interval"
func (n *NetworkInstance_Protocol_Isis_Global_TimersPath) LspRefreshInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspRefreshIntervalPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspRefreshIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-refresh-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspRefreshInterval (leaf): Time interval in seconds that specifies how often route topology
// that a device originates is transmitted in LSPs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-refresh-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/config/lsp-refresh-interval"
func (n *NetworkInstance_Protocol_Isis_Global_TimersPathAny) LspRefreshInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspRefreshIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspRefreshIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-refresh-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Spf (container): This container defines ISIS SPF timer settings.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "spf"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf"
func (n *NetworkInstance_Protocol_Isis_Global_TimersPath) Spf() *NetworkInstance_Protocol_Isis_Global_Timers_SpfPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_SpfPath{
		NodePath: ygot.NewNodePath(
			[]string{"spf"},
			map[string]interface{}{},
			n,
		),
	}
}

// Spf (container): This container defines ISIS SPF timer settings.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "spf"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf"
func (n *NetworkInstance_Protocol_Isis_Global_TimersPathAny) Spf() *NetworkInstance_Protocol_Isis_Global_Timers_SpfPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_SpfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"spf"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_AdaptiveTimerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/state/adaptive-timer YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_AdaptiveTimerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_AdaptiveTimerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/state/adaptive-timer YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_AdaptiveTimerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspFirstWaitIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-first-wait-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspFirstWaitIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspFirstWaitIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-first-wait-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspFirstWaitIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspMaxWaitIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-max-wait-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspMaxWaitIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspMaxWaitIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-max-wait-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspMaxWaitIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspSecondWaitIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-second-wait-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspSecondWaitIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspSecondWaitIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-second-wait-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspSecondWaitIntervalPathAny struct {
	*ygot.NodePath
}

// AdaptiveTimer (leaf): ISIS adaptive timer types (linear, exponential).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adaptive-timer"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/state/adaptive-timer"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPath) AdaptiveTimer() *NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_AdaptiveTimerPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_AdaptiveTimerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adaptive-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdaptiveTimer (leaf): ISIS adaptive timer types (linear, exponential).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adaptive-timer"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/state/adaptive-timer"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPathAny) AdaptiveTimer() *NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_AdaptiveTimerPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_AdaptiveTimerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adaptive-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspFirstWaitInterval (leaf): Time interval in milliseconds that specifies the first LSP generation
// delay.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-first-wait-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-first-wait-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPath) LspFirstWaitInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspFirstWaitIntervalPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspFirstWaitIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-first-wait-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspFirstWaitInterval (leaf): Time interval in milliseconds that specifies the first LSP generation
// delay.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-first-wait-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-first-wait-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPathAny) LspFirstWaitInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspFirstWaitIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspFirstWaitIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-first-wait-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspMaxWaitInterval (leaf): Time interval in milliseconds that specifies max interval between
// two consecutive occurrences of an LSP being generated.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-max-wait-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-max-wait-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPath) LspMaxWaitInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspMaxWaitIntervalPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspMaxWaitIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-max-wait-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspMaxWaitInterval (leaf): Time interval in milliseconds that specifies max interval between
// two consecutive occurrences of an LSP being generated.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-max-wait-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-max-wait-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPathAny) LspMaxWaitInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspMaxWaitIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspMaxWaitIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-max-wait-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspSecondWaitInterval (leaf): Time interval in milliseconds that specifies the millisecond LSP
// generation delay.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-second-wait-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-second-wait-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPath) LspSecondWaitInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspSecondWaitIntervalPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspSecondWaitIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-second-wait-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspSecondWaitInterval (leaf): Time interval in milliseconds that specifies the millisecond LSP
// generation delay.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-second-wait-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/lsp-generation/config/lsp-second-wait-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_LspGenerationPathAny) LspSecondWaitInterval() *NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspSecondWaitIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_LspGeneration_LspSecondWaitIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-second-wait-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_Timers_SpfPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_SpfPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_SpfPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_SpfPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_Spf_AdaptiveTimerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/state/adaptive-timer YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_Spf_AdaptiveTimerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_Spf_AdaptiveTimerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/state/adaptive-timer YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_Spf_AdaptiveTimerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfFirstIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-first-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfFirstIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfFirstIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-first-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfFirstIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfHoldIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-hold-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfHoldIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfHoldIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-hold-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfHoldIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfSecondIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-second-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfSecondIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfSecondIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-second-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfSecondIntervalPathAny struct {
	*ygot.NodePath
}

// AdaptiveTimer (leaf): ISIS adaptive timer types (linear, exponential).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adaptive-timer"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/state/adaptive-timer"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_SpfPath) AdaptiveTimer() *NetworkInstance_Protocol_Isis_Global_Timers_Spf_AdaptiveTimerPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_Spf_AdaptiveTimerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adaptive-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdaptiveTimer (leaf): ISIS adaptive timer types (linear, exponential).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adaptive-timer"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/state/adaptive-timer"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_SpfPathAny) AdaptiveTimer() *NetworkInstance_Protocol_Isis_Global_Timers_Spf_AdaptiveTimerPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_Spf_AdaptiveTimerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adaptive-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfFirstInterval (leaf): Time interval in milliseconds between the
// detection of topology change and when the SPF algorithm runs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/spf-first-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-first-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_SpfPath) SpfFirstInterval() *NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfFirstIntervalPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfFirstIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "spf-first-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfFirstInterval (leaf): Time interval in milliseconds between the
// detection of topology change and when the SPF algorithm runs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/spf-first-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-first-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_SpfPathAny) SpfFirstInterval() *NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfFirstIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfFirstIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "spf-first-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfHoldInterval (leaf): SPF Hold Down time interval in milliseconds.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/spf-hold-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-hold-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_SpfPath) SpfHoldInterval() *NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfHoldIntervalPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfHoldIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "spf-hold-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfHoldInterval (leaf): SPF Hold Down time interval in milliseconds.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/spf-hold-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-hold-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_SpfPathAny) SpfHoldInterval() *NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfHoldIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfHoldIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "spf-hold-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfSecondInterval (leaf): Time interval in milliseconds between the first and second
// SPF calculation.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/spf-second-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-second-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_SpfPath) SpfSecondInterval() *NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfSecondIntervalPath {
	return &NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfSecondIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "spf-second-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfSecondInterval (leaf): Time interval in milliseconds between the first and second
// SPF calculation.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/spf-second-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/timers/spf/config/spf-second-interval"
func (n *NetworkInstance_Protocol_Isis_Global_Timers_SpfPathAny) SpfSecondInterval() *NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfSecondIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Global_Timers_Spf_SpfSecondIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "spf-second-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Global_TransportPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/transport YANG schema element.
type NetworkInstance_Protocol_Isis_Global_TransportPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_TransportPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/transport YANG schema element.
type NetworkInstance_Protocol_Isis_Global_TransportPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Transport_LspMtuSizePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/transport/config/lsp-mtu-size YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Transport_LspMtuSizePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Global_Transport_LspMtuSizePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/global/transport/config/lsp-mtu-size YANG schema element.
type NetworkInstance_Protocol_Isis_Global_Transport_LspMtuSizePathAny struct {
	*ygot.NodePath
}

// LspMtuSize (leaf): The maximum size in bytes of an IS-IS Link state PDU.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-mtu-size"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/transport/config/lsp-mtu-size"
func (n *NetworkInstance_Protocol_Isis_Global_TransportPath) LspMtuSize() *NetworkInstance_Protocol_Isis_Global_Transport_LspMtuSizePath {
	return &NetworkInstance_Protocol_Isis_Global_Transport_LspMtuSizePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-mtu-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspMtuSize (leaf): The maximum size in bytes of an IS-IS Link state PDU.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-mtu-size"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/global/transport/config/lsp-mtu-size"
func (n *NetworkInstance_Protocol_Isis_Global_TransportPathAny) LspMtuSize() *NetworkInstance_Protocol_Isis_Global_Transport_LspMtuSizePathAny {
	return &NetworkInstance_Protocol_Isis_Global_Transport_LspMtuSizePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-mtu-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface YANG schema element.
type NetworkInstance_Protocol_Isis_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface YANG schema element.
type NetworkInstance_Protocol_Isis_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/circuit-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/circuit-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_HelloPaddingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/hello-padding YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_HelloPaddingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_HelloPaddingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/hello-padding YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_HelloPaddingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_PassivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/passive YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_PassivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_PassivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/passive YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_PassivePathAny struct {
	*ygot.NodePath
}

// AfAny (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_InterfacePath) AfAny() *NetworkInstance_Protocol_Isis_Interface_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": "*"},
			n,
		),
	}
}

// AfAny (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) AfAny() *NetworkInstance_Protocol_Isis_Interface_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": "*"},
			n,
		),
	}
}

// AfAnySafiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_InterfacePath) AfAnySafiName(AfiName E_IsisTypes_AFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": "*"},
			n,
		),
	}
}

// AfAnySafiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) AfAnySafiName(AfiName E_IsisTypes_AFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": "*"},
			n,
		),
	}
}

// AfAnyAfiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_InterfacePath) AfAnyAfiName(SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": SafiName},
			n,
		),
	}
}

// AfAnyAfiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) AfAnyAfiName(SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": SafiName},
			n,
		),
	}
}

// Af (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_InterfacePath) Af(AfiName E_IsisTypes_AFI_TYPE, SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_AfPath {
	return &NetworkInstance_Protocol_Isis_Interface_AfPath{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": SafiName},
			n,
		),
	}
}

// Af (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) Af(AfiName E_IsisTypes_AFI_TYPE, SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": SafiName},
			n,
		),
	}
}

// Authentication (container): This container defines ISIS authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) Authentication() *NetworkInstance_Protocol_Isis_Interface_AuthenticationPath {
	return &NetworkInstance_Protocol_Isis_Interface_AuthenticationPath{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authentication (container): This container defines ISIS authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) Authentication() *NetworkInstance_Protocol_Isis_Interface_AuthenticationPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_AuthenticationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bfd (container): This container defines BFD.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/bfd"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) Bfd() *NetworkInstance_Protocol_Isis_Interface_BfdPath {
	return &NetworkInstance_Protocol_Isis_Interface_BfdPath{
		NodePath: ygot.NewNodePath(
			[]string{"bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bfd (container): This container defines BFD.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/bfd"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) Bfd() *NetworkInstance_Protocol_Isis_Interface_BfdPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_BfdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// CircuitCounters (container): This container defines state information for ISIS circuit counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "circuit-counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) CircuitCounters() *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"circuit-counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// CircuitCounters (container): This container defines state information for ISIS circuit counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "circuit-counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) CircuitCounters() *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"circuit-counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// CircuitType (leaf): ISIS circuit type (p2p, broadcast).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/circuit-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/circuit-type"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) CircuitType() *NetworkInstance_Protocol_Isis_Interface_CircuitTypePath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "circuit-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// CircuitType (leaf): ISIS circuit type (p2p, broadcast).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/circuit-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/circuit-type"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) CircuitType() *NetworkInstance_Protocol_Isis_Interface_CircuitTypePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "circuit-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/enable-bfd"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) EnableBfd() *NetworkInstance_Protocol_Isis_Interface_EnableBfdPath {
	return &NetworkInstance_Protocol_Isis_Interface_EnableBfdPath{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/enable-bfd"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) EnableBfd() *NetworkInstance_Protocol_Isis_Interface_EnableBfdPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_EnableBfdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/enabled"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) Enabled() *NetworkInstance_Protocol_Isis_Interface_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Interface_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/enabled"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) Enabled() *NetworkInstance_Protocol_Isis_Interface_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloPadding (leaf): Controls the padding type for IS-IS Hello PDUs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-padding"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/hello-padding"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) HelloPadding() *NetworkInstance_Protocol_Isis_Interface_HelloPaddingPath {
	return &NetworkInstance_Protocol_Isis_Interface_HelloPaddingPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-padding"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloPadding (leaf): Controls the padding type for IS-IS Hello PDUs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-padding"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/hello-padding"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) HelloPadding() *NetworkInstance_Protocol_Isis_Interface_HelloPaddingPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_HelloPaddingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-padding"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Interface for which ISIS configuration is to be applied.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) InterfaceId() *NetworkInstance_Protocol_Isis_Interface_InterfaceIdPath {
	return &NetworkInstance_Protocol_Isis_Interface_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Interface for which ISIS configuration is to be applied.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) InterfaceId() *NetworkInstance_Protocol_Isis_Interface_InterfaceIdPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) InterfaceRef() *NetworkInstance_Protocol_Isis_Interface_InterfaceRefPath {
	return &NetworkInstance_Protocol_Isis_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) InterfaceRef() *NetworkInstance_Protocol_Isis_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// LevelAny (list): Configuration and operational state parameters related to a
// particular level on an IS-IS enabled interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "levels/level"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level"
// LevelNumber (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_InterfacePath) LevelAny() *NetworkInstance_Protocol_Isis_Interface_LevelPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_LevelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"levels", "level"},
			map[string]interface{}{"level-number": "*"},
			n,
		),
	}
}

// LevelAny (list): Configuration and operational state parameters related to a
// particular level on an IS-IS enabled interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "levels/level"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level"
// LevelNumber (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) LevelAny() *NetworkInstance_Protocol_Isis_Interface_LevelPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_LevelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"levels", "level"},
			map[string]interface{}{"level-number": "*"},
			n,
		),
	}
}

// Level (list): Configuration and operational state parameters related to a
// particular level on an IS-IS enabled interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "levels/level"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level"
// LevelNumber: uint8
func (n *NetworkInstance_Protocol_Isis_InterfacePath) Level(LevelNumber uint8) *NetworkInstance_Protocol_Isis_Interface_LevelPath {
	return &NetworkInstance_Protocol_Isis_Interface_LevelPath{
		NodePath: ygot.NewNodePath(
			[]string{"levels", "level"},
			map[string]interface{}{"level-number": LevelNumber},
			n,
		),
	}
}

// Level (list): Configuration and operational state parameters related to a
// particular level on an IS-IS enabled interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "levels/level"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level"
// LevelNumber: uint8
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) Level(LevelNumber uint8) *NetworkInstance_Protocol_Isis_Interface_LevelPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_LevelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"levels", "level"},
			map[string]interface{}{"level-number": LevelNumber},
			n,
		),
	}
}

// Mpls (container): Configuration and operational state relating to MPLS-related
// features in IS-IS
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) Mpls() *NetworkInstance_Protocol_Isis_Interface_MplsPath {
	return &NetworkInstance_Protocol_Isis_Interface_MplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): Configuration and operational state relating to MPLS-related
// features in IS-IS
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) Mpls() *NetworkInstance_Protocol_Isis_Interface_MplsPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_MplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Passive (leaf): When set to true, the referenced interface is a passive interface
// such that it is not eligible to establish adjacencies with other
// systems, but is advertised into the IS-IS topology.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/passive"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) Passive() *NetworkInstance_Protocol_Isis_Interface_PassivePath {
	return &NetworkInstance_Protocol_Isis_Interface_PassivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Passive (leaf): When set to true, the referenced interface is a passive interface
// such that it is not eligible to establish adjacencies with other
// systems, but is advertised into the IS-IS topology.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/config/passive"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) Passive() *NetworkInstance_Protocol_Isis_Interface_PassivePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_PassivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): This container describes ISIS interface timers configuration
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers"
func (n *NetworkInstance_Protocol_Isis_InterfacePath) Timers() *NetworkInstance_Protocol_Isis_Interface_TimersPath {
	return &NetworkInstance_Protocol_Isis_Interface_TimersPath{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): This container describes ISIS interface timers configuration
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers"
func (n *NetworkInstance_Protocol_Isis_InterfacePathAny) Timers() *NetworkInstance_Protocol_Isis_Interface_TimersPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_TimersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_AfPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_AfPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_AfPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_AfPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Af_AfiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Af_AfiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Af_AfiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Af_AfiNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Af_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Af_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Af_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Af_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Af_SafiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/safi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Af_SafiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Af_SafiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/safi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Af_SafiNamePathAny struct {
	*ygot.NodePath
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Interface_AfPath) AfiName() *NetworkInstance_Protocol_Isis_Interface_Af_AfiNamePath {
	return &NetworkInstance_Protocol_Isis_Interface_Af_AfiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Interface_AfPathAny) AfiName() *NetworkInstance_Protocol_Isis_Interface_Af_AfiNamePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Af_AfiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_AfPath) Enabled() *NetworkInstance_Protocol_Isis_Interface_Af_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Interface_Af_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_AfPathAny) Enabled() *NetworkInstance_Protocol_Isis_Interface_Af_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Af_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// SafiName (leaf): Subsequent address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/safi-name"
func (n *NetworkInstance_Protocol_Isis_Interface_AfPath) SafiName() *NetworkInstance_Protocol_Isis_Interface_Af_SafiNamePath {
	return &NetworkInstance_Protocol_Isis_Interface_Af_SafiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SafiName (leaf): Subsequent address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/afi-safi/af/config/safi-name"
func (n *NetworkInstance_Protocol_Isis_Interface_AfPathAny) SafiName() *NetworkInstance_Protocol_Isis_Interface_Af_SafiNamePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Af_SafiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_AuthenticationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_AuthenticationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_AuthenticationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_AuthenticationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_AuthModePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-mode YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_AuthModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_AuthModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-mode YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_AuthModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_AuthPasswordPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_AuthPasswordPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_AuthPasswordPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_AuthPasswordPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_AuthTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_AuthTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_AuthTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_AuthTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_KeychainPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/keychain YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_KeychainPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Authentication_KeychainPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/keychain YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Authentication_KeychainPathAny struct {
	*ygot.NodePath
}

// AuthMode (leaf): The type of authentication used in the applicable IS-IS PDUs.
//
// This leaf along with the sibling leaf 'auth-password' can be used
// to configure the simple key authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-mode"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPath) AuthMode() *NetworkInstance_Protocol_Isis_Interface_Authentication_AuthModePath {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_AuthModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthMode (leaf): The type of authentication used in the applicable IS-IS PDUs.
//
// This leaf along with the sibling leaf 'auth-password' can be used
// to configure the simple key authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-mode"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPathAny) AuthMode() *NetworkInstance_Protocol_Isis_Interface_Authentication_AuthModePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_AuthModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): The authentication key used in the applicable IS-IS PDUs. The key in the
// packet may be encrypted according to the configured authentication type.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-password"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPath) AuthPassword() *NetworkInstance_Protocol_Isis_Interface_Authentication_AuthPasswordPath {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_AuthPasswordPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): The authentication key used in the applicable IS-IS PDUs. The key in the
// packet may be encrypted according to the configured authentication type.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-password"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPathAny) AuthPassword() *NetworkInstance_Protocol_Isis_Interface_Authentication_AuthPasswordPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_AuthPasswordPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthType (leaf): The type of authentication used in the applicable IS-IS PDUs
// (simple_key, keychain).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-type"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPath) AuthType() *NetworkInstance_Protocol_Isis_Interface_Authentication_AuthTypePath {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_AuthTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthType (leaf): The type of authentication used in the applicable IS-IS PDUs
// (simple_key, keychain).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/auth-type"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPathAny) AuthType() *NetworkInstance_Protocol_Isis_Interface_Authentication_AuthTypePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_AuthTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enabled or disable ISIS Hello authentication. Hello authentication
// is used on a per-interface basis to authenticate adjacencies on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPath) Enabled() *NetworkInstance_Protocol_Isis_Interface_Authentication_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enabled or disable ISIS Hello authentication. Hello authentication
// is used on a per-interface basis to authenticate adjacencies on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPathAny) Enabled() *NetworkInstance_Protocol_Isis_Interface_Authentication_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Keychain (leaf): Reference to a keychain that should be used for hello authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keychain"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/keychain"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPath) Keychain() *NetworkInstance_Protocol_Isis_Interface_Authentication_KeychainPath {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_KeychainPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keychain"},
			map[string]interface{}{},
			n,
		),
	}
}

// Keychain (leaf): Reference to a keychain that should be used for hello authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keychain"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/authentication/config/keychain"
func (n *NetworkInstance_Protocol_Isis_Interface_AuthenticationPathAny) Keychain() *NetworkInstance_Protocol_Isis_Interface_Authentication_KeychainPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Authentication_KeychainPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keychain"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_BfdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/bfd YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_BfdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_BfdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/bfd YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_BfdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Bfd_BfdTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/bfd/config/bfd-tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Bfd_BfdTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Bfd_BfdTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/bfd/config/bfd-tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Bfd_BfdTlvPathAny struct {
	*ygot.NodePath
}

// BfdTlv (leaf): When set to true, BFD TLV is used. This enables support for the IS-IS
// BFD TLV options, which specify that a BFD session must be established
// before an IS-IS adjacency can transition to the established state.
// This option should be enabled on all IS-IS neighbors on a shared
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/bfd-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/bfd/config/bfd-tlv"
func (n *NetworkInstance_Protocol_Isis_Interface_BfdPath) BfdTlv() *NetworkInstance_Protocol_Isis_Interface_Bfd_BfdTlvPath {
	return &NetworkInstance_Protocol_Isis_Interface_Bfd_BfdTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bfd-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// BfdTlv (leaf): When set to true, BFD TLV is used. This enables support for the IS-IS
// BFD TLV options, which specify that a BFD session must be established
// before an IS-IS adjacency can transition to the established state.
// This option should be enabled on all IS-IS neighbors on a shared
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/bfd-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/bfd/config/bfd-tlv"
func (n *NetworkInstance_Protocol_Isis_Interface_BfdPathAny) BfdTlv() *NetworkInstance_Protocol_Isis_Interface_Bfd_BfdTlvPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Bfd_BfdTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bfd-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjChangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/adj-changes YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/adj-changes YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjChangesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/adj-number YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/adj-number YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthFailsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/auth-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthFailsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthFailsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/auth-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthFailsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthTypeFailsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/auth-type-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthTypeFailsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthTypeFailsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/auth-type-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthTypeFailsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_IdFieldLenMismatchesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/id-field-len-mismatches YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_IdFieldLenMismatchesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_IdFieldLenMismatchesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/id-field-len-mismatches YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_IdFieldLenMismatchesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_InitFailsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/init-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_InitFailsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_InitFailsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/init-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_InitFailsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_LanDisChangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/lan-dis-changes YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_LanDisChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_LanDisChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/lan-dis-changes YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_LanDisChangesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_MaxAreaAddressMismatchesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/max-area-address-mismatches YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_MaxAreaAddressMismatchesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_MaxAreaAddressMismatchesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/max-area-address-mismatches YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_MaxAreaAddressMismatchesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_RejectedAdjPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/rejected-adj YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_RejectedAdjPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_CircuitCounters_RejectedAdjPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/rejected-adj YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_CircuitCounters_RejectedAdjPathAny struct {
	*ygot.NodePath
}

// AdjChanges (leaf): Number of times an adjacency state change has occurred on this circuit.
// MIB Entry: CircAdjChanges.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adj-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/adj-changes"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath) AdjChanges() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjChangesPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adj-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjChanges (leaf): Number of times an adjacency state change has occurred on this circuit.
// MIB Entry: CircAdjChanges.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adj-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/adj-changes"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny) AdjChanges() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjChangesPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adj-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjNumber (leaf): Number of adjacencies on this circuit.
// MIB Entry: CircNumAdj.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adj-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/adj-number"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath) AdjNumber() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjNumberPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adj-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjNumber (leaf): Number of adjacencies on this circuit.
// MIB Entry: CircNumAdj.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adj-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/adj-number"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny) AdjNumber() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjNumberPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AdjNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adj-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthFails (leaf): Number of times an IS-IS control PDU with the correct auth type has
// failed to pass authentication validation. MIB Entry: CircAuthFails.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auth-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/auth-fails"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath) AuthFails() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthFailsPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthFailsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthFails (leaf): Number of times an IS-IS control PDU with the correct auth type has
// failed to pass authentication validation. MIB Entry: CircAuthFails.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auth-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/auth-fails"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny) AuthFails() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthFailsPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthFailsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthTypeFails (leaf): Number of times an IS-IS control PDU with an auth type field different
// from that for this system has been received. MIB Entry:
// CircAuthTypeFails.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auth-type-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/auth-type-fails"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath) AuthTypeFails() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthTypeFailsPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthTypeFailsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-type-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthTypeFails (leaf): Number of times an IS-IS control PDU with an auth type field different
// from that for this system has been received. MIB Entry:
// CircAuthTypeFails.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auth-type-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/auth-type-fails"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny) AuthTypeFails() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthTypeFailsPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_AuthTypeFailsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-type-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// IdFieldLenMismatches (leaf): Number of times an IS-IS control PDU with an ID field length different
// from that for this system has been received.
// MIB Entry: CircIDFieldLenMismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id-field-len-mismatches"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/id-field-len-mismatches"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath) IdFieldLenMismatches() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_IdFieldLenMismatchesPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_IdFieldLenMismatchesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id-field-len-mismatches"},
			map[string]interface{}{},
			n,
		),
	}
}

// IdFieldLenMismatches (leaf): Number of times an IS-IS control PDU with an ID field length different
// from that for this system has been received.
// MIB Entry: CircIDFieldLenMismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id-field-len-mismatches"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/id-field-len-mismatches"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny) IdFieldLenMismatches() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_IdFieldLenMismatchesPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_IdFieldLenMismatchesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id-field-len-mismatches"},
			map[string]interface{}{},
			n,
		),
	}
}

// InitFails (leaf): Number of times initialization of this circuit has failed. This counts
// events such as PPP NCP failures. MIB Entry: CircInitFails.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/init-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/init-fails"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath) InitFails() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_InitFailsPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_InitFailsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "init-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// InitFails (leaf): Number of times initialization of this circuit has failed. This counts
// events such as PPP NCP failures. MIB Entry: CircInitFails.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/init-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/init-fails"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny) InitFails() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_InitFailsPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_InitFailsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "init-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// LanDisChanges (leaf): Number of times the Designated IS has changed on this circuit at this
// level. If the circuit is point to point, this count is zero. MIB Entry:
// CircLANDesISChanges.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lan-dis-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/lan-dis-changes"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath) LanDisChanges() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_LanDisChangesPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_LanDisChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lan-dis-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LanDisChanges (leaf): Number of times the Designated IS has changed on this circuit at this
// level. If the circuit is point to point, this count is zero. MIB Entry:
// CircLANDesISChanges.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lan-dis-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/lan-dis-changes"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny) LanDisChanges() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_LanDisChangesPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_LanDisChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lan-dis-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAreaAddressMismatches (leaf): Number of times an IS-IS control PDU with a max area address field
// different from that for this system has been received. MIB Entry:
// CircMaxAreaAddrMismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-area-address-mismatches"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/max-area-address-mismatches"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath) MaxAreaAddressMismatches() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_MaxAreaAddressMismatchesPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_MaxAreaAddressMismatchesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-area-address-mismatches"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAreaAddressMismatches (leaf): Number of times an IS-IS control PDU with a max area address field
// different from that for this system has been received. MIB Entry:
// CircMaxAreaAddrMismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-area-address-mismatches"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/max-area-address-mismatches"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny) MaxAreaAddressMismatches() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_MaxAreaAddressMismatchesPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_MaxAreaAddressMismatchesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-area-address-mismatches"},
			map[string]interface{}{},
			n,
		),
	}
}

// RejectedAdj (leaf): Number of times an adjacency has been rejected on this circuit. MIB
// Entry: CircRejAdjs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/rejected-adj"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/rejected-adj"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPath) RejectedAdj() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_RejectedAdjPath {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_RejectedAdjPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "rejected-adj"},
			map[string]interface{}{},
			n,
		),
	}
}

// RejectedAdj (leaf): Number of times an adjacency has been rejected on this circuit. MIB
// Entry: CircRejAdjs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/rejected-adj"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/circuit-counters/state/rejected-adj"
func (n *NetworkInstance_Protocol_Isis_Interface_CircuitCountersPathAny) RejectedAdj() *NetworkInstance_Protocol_Isis_Interface_CircuitCounters_RejectedAdjPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_CircuitCounters_RejectedAdjPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "rejected-adj"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_EnableBfdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_EnableBfdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_EnableBfdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_EnableBfdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_EnableBfd_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_EnableBfd_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_EnableBfd_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_EnableBfd_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_EnableBfdPath) Enabled() *NetworkInstance_Protocol_Isis_Interface_EnableBfd_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Interface_EnableBfd_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_EnableBfdPathAny) Enabled() *NetworkInstance_Protocol_Isis_Interface_EnableBfd_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_EnableBfd_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Isis_Interface_InterfaceRefPath) Interface() *NetworkInstance_Protocol_Isis_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Protocol_Isis_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Isis_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Protocol_Isis_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Isis_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Protocol_Isis_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Protocol_Isis_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Isis_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Protocol_Isis_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_LevelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_LevelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_LevelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_LevelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_LevelNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/level-number YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_LevelNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_LevelNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/level-number YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_LevelNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PassivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/passive YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PassivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PassivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/passive YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PassivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PriorityPathAny struct {
	*ygot.NodePath
}

// AdjacencyAny (list): List of the local system's IS-IS adjacencies.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacencies/adjacency"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency"
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) AdjacencyAny() *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacencies", "adjacency"},
			map[string]interface{}{"system-id": "*"},
			n,
		),
	}
}

// AdjacencyAny (list): List of the local system's IS-IS adjacencies.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacencies/adjacency"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency"
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) AdjacencyAny() *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacencies", "adjacency"},
			map[string]interface{}{"system-id": "*"},
			n,
		),
	}
}

// Adjacency (list): List of the local system's IS-IS adjacencies.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacencies/adjacency"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency"
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) Adjacency(SystemId string) *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath{
		NodePath: ygot.NewNodePath(
			[]string{"adjacencies", "adjacency"},
			map[string]interface{}{"system-id": SystemId},
			n,
		),
	}
}

// Adjacency (list): List of the local system's IS-IS adjacencies.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacencies/adjacency"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency"
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) Adjacency(SystemId string) *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacencies", "adjacency"},
			map[string]interface{}{"system-id": SystemId},
			n,
		),
	}
}

// AfAny (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) AfAny() *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": "*"},
			n,
		),
	}
}

// AfAny (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) AfAny() *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": "*"},
			n,
		),
	}
}

// AfAnySafiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) AfAnySafiName(AfiName E_IsisTypes_AFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": "*"},
			n,
		),
	}
}

// AfAnySafiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName (wildcarded): E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) AfAnySafiName(AfiName E_IsisTypes_AFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": "*"},
			n,
		),
	}
}

// AfAnyAfiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) AfAnyAfiName(SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": SafiName},
			n,
		),
	}
}

// AfAnyAfiName (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af"
// AfiName (wildcarded): E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) AfAnyAfiName(SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": "*", "safi-name": SafiName},
			n,
		),
	}
}

// Af (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) Af(AfiName E_IsisTypes_AFI_TYPE, SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_Level_AfPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AfPath{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": SafiName},
			n,
		),
	}
}

// Af (list): Address-family/Subsequent Address-family list.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "afi-safi/af"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af"
// AfiName: E_IsisTypes_AFI_TYPE
// SafiName: E_IsisTypes_SAFI_TYPE
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) Af(AfiName E_IsisTypes_AFI_TYPE, SafiName E_IsisTypes_SAFI_TYPE) *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"afi-safi", "af"},
			map[string]interface{}{"afi-name": AfiName, "safi-name": SafiName},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) Enabled() *NetworkInstance_Protocol_Isis_Interface_Level_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) Enabled() *NetworkInstance_Protocol_Isis_Interface_Level_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloAuthentication (container): This container defines ISIS authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-authentication"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) HelloAuthentication() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPath{
		NodePath: ygot.NewNodePath(
			[]string{"hello-authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloAuthentication (container): This container defines ISIS authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-authentication"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) HelloAuthentication() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// LevelNumber (leaf): ISIS level number(level-1, level-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/level-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/level-number"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) LevelNumber() *NetworkInstance_Protocol_Isis_Interface_Level_LevelNumberPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_LevelNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "level-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// LevelNumber (leaf): ISIS level number(level-1, level-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/level-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/level-number"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) LevelNumber() *NetworkInstance_Protocol_Isis_Interface_Level_LevelNumberPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_LevelNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "level-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketCounters (container): This container defines ISIS interface packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "packet-counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) PacketCounters() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"packet-counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// PacketCounters (container): This container defines ISIS interface packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "packet-counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) PacketCounters() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"packet-counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Passive (leaf): ISIS passive interface admin enable/disable function.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/passive"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) Passive() *NetworkInstance_Protocol_Isis_Interface_Level_PassivePath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PassivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Passive (leaf): ISIS passive interface admin enable/disable function.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/passive"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) Passive() *NetworkInstance_Protocol_Isis_Interface_Level_PassivePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PassivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): ISIS neighbor priority(LAN hello PDU only).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/priority"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) Priority() *NetworkInstance_Protocol_Isis_Interface_Level_PriorityPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): ISIS neighbor priority(LAN hello PDU only).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/config/priority"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) Priority() *NetworkInstance_Protocol_Isis_Interface_Level_PriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): This container defines ISIS timers.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPath) Timers() *NetworkInstance_Protocol_Isis_Interface_Level_TimersPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_TimersPath{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): This container defines ISIS timers.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers"
func (n *NetworkInstance_Protocol_Isis_Interface_LevelPathAny) Timers() *NetworkInstance_Protocol_Isis_Interface_Level_TimersPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_TimersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyStatePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/adjacency-state YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/adjacency-state YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyStatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/adjacency-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/adjacency-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AreaAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/area-address YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AreaAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AreaAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/area-address YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AreaAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_DisSystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/dis-system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_DisSystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_DisSystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/dis-system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_DisSystemIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_LocalExtendedCircuitIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/local-extended-circuit-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_LocalExtendedCircuitIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_LocalExtendedCircuitIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/local-extended-circuit-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_LocalExtendedCircuitIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_MultiTopologyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/multi-topology YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_MultiTopologyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_MultiTopologyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/multi-topology YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_MultiTopologyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborCircuitTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-circuit-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborCircuitTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborCircuitTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-circuit-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborCircuitTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborExtendedCircuitIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-extended-circuit-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborExtendedCircuitIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborExtendedCircuitIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-extended-circuit-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborExtendedCircuitIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv4AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-ipv4-address YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv4AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv4AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-ipv4-address YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv4AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv6AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-ipv6-address YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv6AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv6AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-ipv6-address YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv6AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborSnpaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-snpa YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborSnpaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborSnpaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-snpa YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborSnpaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NlpidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/nlpid YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NlpidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NlpidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/nlpid YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NlpidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_PriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartStatusPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-status YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartStatusPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartStatusPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-status YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartStatusPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSupportPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-support YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSupportPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSupportPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-support YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSupportPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSuppressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-suppress YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSuppressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSuppressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-suppress YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSuppressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_SystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_SystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_SystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_SystemIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_TopologyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/topology YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_TopologyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_TopologyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/topology YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_TopologyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_UpTimestampPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/up-timestamp YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_UpTimestampPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_UpTimestampPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/up-timestamp YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_UpTimestampPathAny struct {
	*ygot.NodePath
}

// AdjacencyState (leaf): P2P 3-way ISIS adjacency state(up, down, init, failed).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-state"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/adjacency-state"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) AdjacencyState() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyStatePath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjacencyState (leaf): P2P 3-way ISIS adjacency state(up, down, init, failed).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-state"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/adjacency-state"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) AdjacencyState() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyStatePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjacencyType (leaf): Formed ISIS adjacency type(level-1, level-2, level-1-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/adjacency-type"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) AdjacencyType() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyTypePath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjacencyType (leaf): Formed ISIS adjacency type(level-1, level-2, level-1-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/adjacency-type"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) AdjacencyType() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyTypePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AdjacencyTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AreaAddress (leaf): List of ISIS area-address(es).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/area-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/area-address"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) AreaAddress() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AreaAddressPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AreaAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "area-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// AreaAddress (leaf): List of ISIS area-address(es).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/area-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/area-address"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) AreaAddress() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AreaAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_AreaAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "area-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisSystemId (leaf): DIS System ID(LAN hello only).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dis-system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/dis-system-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) DisSystemId() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_DisSystemIdPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_DisSystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dis-system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisSystemId (leaf): DIS System ID(LAN hello only).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dis-system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/dis-system-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) DisSystemId() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_DisSystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_DisSystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dis-system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalExtendedCircuitId (leaf): Local extended circuit ID.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-extended-circuit-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/local-extended-circuit-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) LocalExtendedCircuitId() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_LocalExtendedCircuitIdPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_LocalExtendedCircuitIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-extended-circuit-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalExtendedCircuitId (leaf): Local extended circuit ID.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-extended-circuit-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/local-extended-circuit-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) LocalExtendedCircuitId() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_LocalExtendedCircuitIdPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_LocalExtendedCircuitIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-extended-circuit-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopology (leaf): When set to true, ISIS multi-topology is supported.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multi-topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/multi-topology"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) MultiTopology() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_MultiTopologyPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_MultiTopologyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multi-topology"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopology (leaf): When set to true, ISIS multi-topology is supported.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multi-topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/multi-topology"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) MultiTopology() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_MultiTopologyPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_MultiTopologyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multi-topology"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborCircuitType (leaf): Received ISIS circuit type (level-1, level-2, level-1-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-circuit-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-circuit-type"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) NeighborCircuitType() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborCircuitTypePath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborCircuitTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-circuit-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborCircuitType (leaf): Received ISIS circuit type (level-1, level-2, level-1-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-circuit-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-circuit-type"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) NeighborCircuitType() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborCircuitTypePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborCircuitTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-circuit-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborExtendedCircuitId (leaf): ISIS neighbor extended circuit ID.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-extended-circuit-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-extended-circuit-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) NeighborExtendedCircuitId() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborExtendedCircuitIdPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborExtendedCircuitIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-extended-circuit-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborExtendedCircuitId (leaf): ISIS neighbor extended circuit ID.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-extended-circuit-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-extended-circuit-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) NeighborExtendedCircuitId() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborExtendedCircuitIdPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborExtendedCircuitIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-extended-circuit-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborIpv4Address (leaf): ISIS Neighbor IPv4 address.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-ipv4-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-ipv4-address"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) NeighborIpv4Address() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv4AddressPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv4AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-ipv4-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborIpv4Address (leaf): ISIS Neighbor IPv4 address.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-ipv4-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-ipv4-address"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) NeighborIpv4Address() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv4AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv4AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-ipv4-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborIpv6Address (leaf): ISIS Neighbor IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-ipv6-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-ipv6-address"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) NeighborIpv6Address() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv6AddressPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv6AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-ipv6-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborIpv6Address (leaf): ISIS Neighbor IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-ipv6-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-ipv6-address"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) NeighborIpv6Address() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv6AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborIpv6AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-ipv6-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborSnpa (leaf): ISIS neighbor SNPA.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-snpa"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-snpa"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) NeighborSnpa() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborSnpaPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborSnpaPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-snpa"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborSnpa (leaf): ISIS neighbor SNPA.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-snpa"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/neighbor-snpa"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) NeighborSnpa() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborSnpaPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NeighborSnpaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-snpa"},
			map[string]interface{}{},
			n,
		),
	}
}

// Nlpid (leaf): Supported Protocol. IPv4 is defined as (0xcc)
// and IPv6 - (0x8e). ISIS reference is TLV 129.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/nlpid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/nlpid"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) Nlpid() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NlpidPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NlpidPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "nlpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Nlpid (leaf): Supported Protocol. IPv4 is defined as (0xcc)
// and IPv6 - (0x8e). ISIS reference is TLV 129.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/nlpid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/nlpid"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) Nlpid() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NlpidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_NlpidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "nlpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Priority of the neighboring IS(LAN Hello only).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/priority"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) Priority() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_PriorityPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Priority of the neighboring IS(LAN Hello only).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/priority"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) Priority() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_PriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartStatus (leaf): When set to true, neighbor is being helped. The RR bit is used by a
// (re)starting router to signal to its neighbors that a (re)start is in
// progress.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/restart-status"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-status"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) RestartStatus() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartStatusPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartStatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "restart-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartStatus (leaf): When set to true, neighbor is being helped. The RR bit is used by a
// (re)starting router to signal to its neighbors that a (re)start is in
// progress.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/restart-status"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-status"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) RestartStatus() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartStatusPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartStatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "restart-status"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartSupport (leaf): When set to true, Graceful-restart signaling is supported.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/restart-support"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-support"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) RestartSupport() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSupportPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSupportPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "restart-support"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartSupport (leaf): When set to true, Graceful-restart signaling is supported.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/restart-support"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-support"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) RestartSupport() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSupportPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSupportPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "restart-support"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartSuppress (leaf): When set to true, adjacency is not advertised. The SA bit is used by a
// starting router to  request that its neighbor suppress advertisement of
// the adjacency  to the starting router in the neighbor's LSPs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/restart-suppress"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-suppress"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) RestartSuppress() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSuppressPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSuppressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "restart-suppress"},
			map[string]interface{}{},
			n,
		),
	}
}

// RestartSuppress (leaf): When set to true, adjacency is not advertised. The SA bit is used by a
// starting router to  request that its neighbor suppress advertisement of
// the adjacency  to the starting router in the neighbor's LSPs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/restart-suppress"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/restart-suppress"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) RestartSuppress() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSuppressPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_RestartSuppressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "restart-suppress"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): ISIS neighbor system-id.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) SystemId() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_SystemIdPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_SystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): ISIS neighbor system-id.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) SystemId() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_SystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_SystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Topology (leaf): ISIS topology type support(ipv4-unicast, ipv6-unicast,
// ipv4-multicast, ipv6-multicast).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/topology"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) Topology() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_TopologyPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_TopologyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology"},
			map[string]interface{}{},
			n,
		),
	}
}

// Topology (leaf): ISIS topology type support(ipv4-unicast, ipv6-unicast,
// ipv4-multicast, ipv6-multicast).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/topology"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) Topology() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_TopologyPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_TopologyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpTimestamp (leaf): Time at which the adjacency transitioned into the up state, expressed
// as number of nanoseconds since the Unix epoch (Jan 1, 1970 00:00:00
// UTC).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-timestamp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/up-timestamp"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPath) UpTimestamp() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_UpTimestampPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_UpTimestampPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-timestamp"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpTimestamp (leaf): Time at which the adjacency transitioned into the up state, expressed
// as number of nanoseconds since the Unix epoch (Jan 1, 1970 00:00:00
// UTC).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-timestamp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/adjacencies/adjacency/state/up-timestamp"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AdjacencyPathAny) UpTimestamp() *NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_UpTimestampPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Adjacency_UpTimestampPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-timestamp"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_AfPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_AfPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_AfiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_AfiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_AfiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/afi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_AfiNamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SafiNamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/safi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SafiNamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SafiNamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/safi-name YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SafiNamePathAny struct {
	*ygot.NodePath
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPath) AfiName() *NetworkInstance_Protocol_Isis_Interface_Level_Af_AfiNamePath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_AfiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AfiName (leaf): Address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/afi-name"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny) AfiName() *NetworkInstance_Protocol_Isis_Interface_Level_Af_AfiNamePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_AfiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPath) Enabled() *NetworkInstance_Protocol_Isis_Interface_Level_Af_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny) Enabled() *NetworkInstance_Protocol_Isis_Interface_Level_Af_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value(default=10).
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/metric"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPath) Metric() *NetworkInstance_Protocol_Isis_Interface_Level_Af_MetricPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value(default=10).
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/metric"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny) Metric() *NetworkInstance_Protocol_Isis_Interface_Level_Af_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// SafiName (leaf): Subsequent address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/safi-name"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPath) SafiName() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SafiNamePath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SafiNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SafiName (leaf): Subsequent address-family type.
// ----------------------------------------
// Defining module: "openconfig-isis-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/safi-name"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/config/safi-name"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny) SafiName() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SafiNamePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SafiNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "safi-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRouting (container): Configuration and operatioanl state parameters relating to segment
// routing for an interface within the IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPath) SegmentRouting() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRouting (container): Configuration and operatioanl state parameters relating to segment
// routing for an interface within the IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_AfPathAny) SegmentRouting() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny struct {
	*ygot.NodePath
}

// AdjacencySidAny (list): An Adjacency SID to be advertised for the specified interface.
// The Adj-SID's identifier (the SID ID) must be unique, with flags
// specified indicating the parameters that should be set for the SID.
// Where a SID value is specified that is allocated from the SRGB, the
// global flag must be set by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid"
// Neighbor (wildcarded): string
// SidId (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum, UnionString, E_AdjacencySid_SidId_Enum]
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"neighbor": "*", "sid-id": "*"},
			n,
		),
	}
}

// AdjacencySidAny (list): An Adjacency SID to be advertised for the specified interface.
// The Adj-SID's identifier (the SID ID) must be unique, with flags
// specified indicating the parameters that should be set for the SID.
// Where a SID value is specified that is allocated from the SRGB, the
// global flag must be set by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid"
// Neighbor (wildcarded): string
// SidId (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum, UnionString, E_AdjacencySid_SidId_Enum]
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"neighbor": "*", "sid-id": "*"},
			n,
		),
	}
}

// AdjacencySidAnySidId (list): An Adjacency SID to be advertised for the specified interface.
// The Adj-SID's identifier (the SID ID) must be unique, with flags
// specified indicating the parameters that should be set for the SID.
// Where a SID value is specified that is allocated from the SRGB, the
// global flag must be set by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid"
// Neighbor: string
// SidId (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum, UnionString, E_AdjacencySid_SidId_Enum]
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath) AdjacencySidAnySidId(Neighbor string) *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"neighbor": Neighbor, "sid-id": "*"},
			n,
		),
	}
}

// AdjacencySidAnySidId (list): An Adjacency SID to be advertised for the specified interface.
// The Adj-SID's identifier (the SID ID) must be unique, with flags
// specified indicating the parameters that should be set for the SID.
// Where a SID value is specified that is allocated from the SRGB, the
// global flag must be set by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid"
// Neighbor: string
// SidId (wildcarded): [UnionUint32, E_MplsTypes_MplsLabel_Enum, UnionString, E_AdjacencySid_SidId_Enum]
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny) AdjacencySidAnySidId(Neighbor string) *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"neighbor": Neighbor, "sid-id": "*"},
			n,
		),
	}
}

// AdjacencySidAnyNeighbor (list): An Adjacency SID to be advertised for the specified interface.
// The Adj-SID's identifier (the SID ID) must be unique, with flags
// specified indicating the parameters that should be set for the SID.
// Where a SID value is specified that is allocated from the SRGB, the
// global flag must be set by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid"
// Neighbor (wildcarded): string
// SidId: [UnionUint32, E_MplsTypes_MplsLabel_Enum, UnionString, E_AdjacencySid_SidId_Enum]
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath) AdjacencySidAnyNeighbor(SidId NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidId_Union) *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"neighbor": "*", "sid-id": SidId},
			n,
		),
	}
}

// AdjacencySidAnyNeighbor (list): An Adjacency SID to be advertised for the specified interface.
// The Adj-SID's identifier (the SID ID) must be unique, with flags
// specified indicating the parameters that should be set for the SID.
// Where a SID value is specified that is allocated from the SRGB, the
// global flag must be set by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid"
// Neighbor (wildcarded): string
// SidId: [UnionUint32, E_MplsTypes_MplsLabel_Enum, UnionString, E_AdjacencySid_SidId_Enum]
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny) AdjacencySidAnyNeighbor(SidId NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidId_Union) *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"neighbor": "*", "sid-id": SidId},
			n,
		),
	}
}

// AdjacencySid (list): An Adjacency SID to be advertised for the specified interface.
// The Adj-SID's identifier (the SID ID) must be unique, with flags
// specified indicating the parameters that should be set for the SID.
// Where a SID value is specified that is allocated from the SRGB, the
// global flag must be set by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid"
// Neighbor: string
// SidId: [UnionUint32, E_MplsTypes_MplsLabel_Enum, UnionString, E_AdjacencySid_SidId_Enum]
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath) AdjacencySid(Neighbor string, SidId NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidId_Union) *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"neighbor": Neighbor, "sid-id": SidId},
			n,
		),
	}
}

// AdjacencySid (list): An Adjacency SID to be advertised for the specified interface.
// The Adj-SID's identifier (the SID ID) must be unique, with flags
// specified indicating the parameters that should be set for the SID.
// Where a SID value is specified that is allocated from the SRGB, the
// global flag must be set by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid"
// Neighbor: string
// SidId: [UnionUint32, E_MplsTypes_MplsLabel_Enum, UnionString, E_AdjacencySid_SidId_Enum]
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny) AdjacencySid(Neighbor string, SidId NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidId_Union) *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"neighbor": Neighbor, "sid-id": SidId},
			n,
		),
	}
}

// PrefixSidAny (list): An IGP prefix that should have a segment routing IGP-Prefix SID
// allocated to it. The value of the SID is specified by the SID ID,
// as an absolute value. If the absolute value falls within the SRGB,
// the Global flag should be advertised by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath) PrefixSidAny() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// PrefixSidAny (list): An IGP prefix that should have a segment routing IGP-Prefix SID
// allocated to it. The value of the SID is specified by the SID ID,
// as an absolute value. If the absolute value falls within the SRGB,
// the Global flag should be advertised by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny) PrefixSidAny() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// PrefixSid (list): An IGP prefix that should have a segment routing IGP-Prefix SID
// allocated to it. The value of the SID is specified by the SID ID,
// as an absolute value. If the absolute value falls within the SRGB,
// the Global flag should be advertised by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPath) PrefixSid(Prefix string) *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// PrefixSid (list): An IGP prefix that should have a segment routing IGP-Prefix SID
// allocated to it. The value of the SID is specified by the SID ID,
// as an absolute value. If the absolute value falls within the SRGB,
// the Global flag should be advertised by the system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRoutingPathAny) PrefixSid(Prefix string) *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_AllocatedDynamicLocalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/state/allocated-dynamic-local YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_AllocatedDynamicLocalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_AllocatedDynamicLocalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/state/allocated-dynamic-local YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_AllocatedDynamicLocalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_GroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/group YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_GroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_GroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/group YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_GroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_ProtectionEligiblePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/protection-eligible YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_ProtectionEligiblePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_ProtectionEligiblePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/protection-eligible YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_ProtectionEligiblePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/sid-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/sid-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidIdPathAny struct {
	*ygot.NodePath
}

// AllocatedDynamicLocal (leaf): Where an Adjacency SID with a dynamic value is to be allocated by
// the system, this leaf reports to the value of the Adj-SID allocated
// to this interface.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/allocated-dynamic-local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/state/allocated-dynamic-local"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPath) AllocatedDynamicLocal() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_AllocatedDynamicLocalPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_AllocatedDynamicLocalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "allocated-dynamic-local"},
			map[string]interface{}{},
			n,
		),
	}
}

// AllocatedDynamicLocal (leaf): Where an Adjacency SID with a dynamic value is to be allocated by
// the system, this leaf reports to the value of the Adj-SID allocated
// to this interface.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/allocated-dynamic-local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/state/allocated-dynamic-local"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny) AllocatedDynamicLocal() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_AllocatedDynamicLocalPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_AllocatedDynamicLocalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "allocated-dynamic-local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Group (leaf): When set to true, the Adj-SID is indicated to be part of a group, and
// the G flag is set to 1 in the corresponding advertisement in the IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/group"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPath) Group() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_GroupPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_GroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Group (leaf): When set to true, the Adj-SID is indicated to be part of a group, and
// the G flag is set to 1 in the corresponding advertisement in the IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/group"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny) Group() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_GroupPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Neighbor (leaf): The remote system on the interface with which the Adj-SID is
// associated.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/neighbor"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPath) Neighbor() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_NeighborPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "neighbor"},
			map[string]interface{}{},
			n,
		),
	}
}

// Neighbor (leaf): The remote system on the interface with which the Adj-SID is
// associated.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/neighbor"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny) Neighbor() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "neighbor"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtectionEligible (leaf): Whether the Adj-SID should be considered to be eligible for protection
// using IP or MPLS FRR during a network failure. When this value is set to
// true, the B-flag of the Adj-SID is set to 1, and the local system should
// provide FRR paths for the associated label forwarding entry. When it is
// set to false, the local system must not provide FRR for the specified
// LFIB entry.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protection-eligible"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/protection-eligible"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPath) ProtectionEligible() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_ProtectionEligiblePath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_ProtectionEligiblePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protection-eligible"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtectionEligible (leaf): Whether the Adj-SID should be considered to be eligible for protection
// using IP or MPLS FRR during a network failure. When this value is set to
// true, the B-flag of the Adj-SID is set to 1, and the local system should
// provide FRR paths for the associated label forwarding entry. When it is
// set to false, the local system must not provide FRR for the specified
// LFIB entry.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protection-eligible"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/protection-eligible"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny) ProtectionEligible() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_ProtectionEligiblePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_ProtectionEligiblePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protection-eligible"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidId (leaf): The value of the Adj-SID to be advertised. Where a static SID
// identifier is specified, this should be advertised directly by the
// system. Where the DYNAMIC value is specified, this should be treated
// as a dynamically allocated value. When the MPLS data plane is in use
// the dynamic value should not fall within a reserved-label-block.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sid-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/sid-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPath) SidId() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidIdPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sid-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidId (leaf): The value of the Adj-SID to be advertised. Where a static SID
// identifier is specified, this should be advertised directly by the
// system. Where the DYNAMIC value is specified, this should be treated
// as a dynamically allocated value. When the MPLS data plane is in use
// the dynamic value should not fall within a reserved-label-block.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sid-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/adjacency-sids/adjacency-sid/config/sid-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySidPathAny) SidId() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidIdPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_AdjacencySid_SidIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sid-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_LabelOptionsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/label-options YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_LabelOptionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_LabelOptionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/label-options YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_LabelOptionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_SidIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/sid-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_SidIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_SidIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/sid-id YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_SidIdPathAny struct {
	*ygot.NodePath
}

// LabelOptions (leaf): The options associated with the IGP prefix SID for MPLS. The value
// of this leaf specifies the option that the SID should be advertised
// into the IGP with.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/label-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/label-options"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPath) LabelOptions() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_LabelOptionsPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_LabelOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "label-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// LabelOptions (leaf): The options associated with the IGP prefix SID for MPLS. The value
// of this leaf specifies the option that the SID should be advertised
// into the IGP with.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/label-options"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/label-options"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny) LabelOptions() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_LabelOptionsPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_LabelOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "label-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IP prefix for which the IGP prefix SID should be advertised. The
// value specified is a local prefix on the interface which is advertised
// into the IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/prefix"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPath) Prefix() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IP prefix for which the IGP prefix SID should be advertised. The
// value specified is a local prefix on the interface which is advertised
// into the IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/prefix"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny) Prefix() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidId (leaf): The Segment Identifier to be used when advertising the IGP Prefix SID.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sid-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/sid-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPath) SidId() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_SidIdPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_SidIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sid-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidId (leaf): The Segment Identifier to be used when advertising the IGP Prefix SID.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/sid-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/afi-safi/af/segment-routing/prefix-sids/prefix-sid/config/sid-id"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSidPathAny) SidId() *NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_SidIdPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Af_SegmentRouting_PrefixSid_SidIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "sid-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthModePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-mode YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-mode YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthPasswordPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthPasswordPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthPasswordPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthPasswordPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-type YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_KeychainPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/keychain YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_KeychainPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_KeychainPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/keychain YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_KeychainPathAny struct {
	*ygot.NodePath
}

// AuthMode (leaf): The type of authentication used in the applicable IS-IS PDUs.
//
// This leaf along with the sibling leaf 'auth-password' can be used
// to configure the simple key authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-mode"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPath) AuthMode() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthModePath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthMode (leaf): The type of authentication used in the applicable IS-IS PDUs.
//
// This leaf along with the sibling leaf 'auth-password' can be used
// to configure the simple key authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-mode"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPathAny) AuthMode() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthModePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): The authentication key used in the applicable IS-IS PDUs. The key in the
// packet may be encrypted according to the configured authentication type.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-password"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPath) AuthPassword() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthPasswordPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthPasswordPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): The authentication key used in the applicable IS-IS PDUs. The key in the
// packet may be encrypted according to the configured authentication type.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-password"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPathAny) AuthPassword() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthPasswordPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthPasswordPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthType (leaf): The type of authentication used in the applicable IS-IS PDUs
// (simple_key, keychain).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-type"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPath) AuthType() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthTypePath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthType (leaf): The type of authentication used in the applicable IS-IS PDUs
// (simple_key, keychain).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/auth-type"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPathAny) AuthType() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthTypePathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_AuthTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enabled or disable ISIS Hello authentication. Hello authentication
// is used on a per-interface basis to authenticate adjacencies on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPath) Enabled() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enabled or disable ISIS Hello authentication. Hello authentication
// is used on a per-interface basis to authenticate adjacencies on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPathAny) Enabled() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Keychain (leaf): Reference to a keychain that should be used for hello authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keychain"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/keychain"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPath) Keychain() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_KeychainPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_KeychainPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keychain"},
			map[string]interface{}{},
			n,
		),
	}
}

// Keychain (leaf): Reference to a keychain that should be used for hello authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keychain"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/hello-authentication/config/keychain"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthenticationPathAny) Keychain() *NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_KeychainPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_HelloAuthentication_KeychainPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keychain"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny struct {
	*ygot.NodePath
}

// Csnp (container): Operational state parameters relating to CSNPs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "csnp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath) Csnp() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPath{
		NodePath: ygot.NewNodePath(
			[]string{"csnp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Csnp (container): Operational state parameters relating to CSNPs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "csnp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny) Csnp() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"csnp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esh (container): This container defines ESH packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "esh"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath) Esh() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPath{
		NodePath: ygot.NewNodePath(
			[]string{"esh"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esh (container): This container defines ESH packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "esh"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny) Esh() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"esh"},
			map[string]interface{}{},
			n,
		),
	}
}

// Iih (container): This container defines IIH packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "iih"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath) Iih() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPath{
		NodePath: ygot.NewNodePath(
			[]string{"iih"},
			map[string]interface{}{},
			n,
		),
	}
}

// Iih (container): This container defines IIH packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "iih"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny) Iih() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"iih"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ish (container): This container defines ISH packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ish"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath) Ish() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPath{
		NodePath: ygot.NewNodePath(
			[]string{"ish"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ish (container): This container defines ISH packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ish"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny) Ish() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ish"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lsp (container): This container defines LSP packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath) Lsp() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPath{
		NodePath: ygot.NewNodePath(
			[]string{"lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lsp (container): This container defines LSP packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny) Lsp() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Psnp (container): This container defines PSNP packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "psnp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath) Psnp() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPath{
		NodePath: ygot.NewNodePath(
			[]string{"psnp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Psnp (container): This container defines PSNP packet counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "psnp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny) Psnp() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"psnp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unknown (container): Operational state parameters relating to IS-IS PDUs that are not
// otherwise classified - referred to as Unknown PDUs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPath) Unknown() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown"},
			map[string]interface{}{},
			n,
		),
	}
}

// Unknown (container): Operational state parameters relating to IS-IS PDUs that are not
// otherwise classified - referred to as Unknown PDUs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCountersPathAny) Unknown() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_DroppedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_DroppedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_DroppedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_DroppedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ProcessedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ProcessedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ProcessedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ProcessedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_RetransmitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_RetransmitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_RetransmitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_RetransmitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_SentPathAny struct {
	*ygot.NodePath
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPath) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_DroppedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_DroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPathAny) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_DroppedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_DroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPath) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ProcessedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ProcessedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPathAny) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ProcessedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ProcessedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPath) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ReceivedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPathAny) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ReceivedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPath) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_RetransmitPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_RetransmitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPathAny) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_RetransmitPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_RetransmitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPath) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_SentPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/csnp/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_CsnpPathAny) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_SentPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Csnp_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_DroppedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_DroppedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_DroppedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_DroppedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ProcessedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ProcessedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ProcessedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ProcessedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_RetransmitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_RetransmitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_RetransmitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_RetransmitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_SentPathAny struct {
	*ygot.NodePath
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPath) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_DroppedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_DroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPathAny) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_DroppedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_DroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPath) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ProcessedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ProcessedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPathAny) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ProcessedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ProcessedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPath) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ReceivedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPathAny) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ReceivedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPath) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_RetransmitPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_RetransmitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPathAny) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_RetransmitPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_RetransmitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPath) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_SentPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/esh/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_EshPathAny) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_SentPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Esh_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_DroppedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_DroppedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_DroppedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_DroppedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ProcessedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ProcessedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ProcessedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ProcessedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_RetransmitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_RetransmitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_RetransmitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_RetransmitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_SentPathAny struct {
	*ygot.NodePath
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPath) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_DroppedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_DroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPathAny) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_DroppedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_DroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPath) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ProcessedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ProcessedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPathAny) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ProcessedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ProcessedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPath) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ReceivedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPathAny) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ReceivedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPath) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_RetransmitPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_RetransmitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPathAny) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_RetransmitPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_RetransmitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPath) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_SentPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/iih/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IihPathAny) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_SentPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Iih_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_DroppedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_DroppedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_DroppedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_DroppedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ProcessedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ProcessedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ProcessedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ProcessedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_RetransmitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_RetransmitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_RetransmitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_RetransmitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_SentPathAny struct {
	*ygot.NodePath
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPath) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_DroppedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_DroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPathAny) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_DroppedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_DroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPath) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ProcessedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ProcessedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPathAny) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ProcessedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ProcessedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPath) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ReceivedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPathAny) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ReceivedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPath) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_RetransmitPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_RetransmitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPathAny) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_RetransmitPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_RetransmitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPath) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_SentPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/ish/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_IshPathAny) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_SentPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Ish_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_DroppedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_DroppedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_DroppedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_DroppedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ProcessedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ProcessedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ProcessedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ProcessedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_RetransmitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_RetransmitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_RetransmitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_RetransmitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_SentPathAny struct {
	*ygot.NodePath
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPath) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_DroppedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_DroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPathAny) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_DroppedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_DroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPath) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ProcessedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ProcessedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPathAny) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ProcessedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ProcessedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPath) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ReceivedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPathAny) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ReceivedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPath) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_RetransmitPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_RetransmitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPathAny) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_RetransmitPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_RetransmitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPath) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_SentPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/lsp/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_LspPathAny) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_SentPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Lsp_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_DroppedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_DroppedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_DroppedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_DroppedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ProcessedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ProcessedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ProcessedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ProcessedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_RetransmitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_RetransmitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_RetransmitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_RetransmitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_SentPathAny struct {
	*ygot.NodePath
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPath) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_DroppedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_DroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPathAny) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_DroppedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_DroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPath) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ProcessedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ProcessedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPathAny) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ProcessedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ProcessedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPath) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ReceivedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPathAny) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ReceivedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPath) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_RetransmitPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_RetransmitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPathAny) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_RetransmitPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_RetransmitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPath) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_SentPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/psnp/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_PsnpPathAny) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_SentPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Psnp_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_DroppedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_DroppedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_DroppedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/dropped YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_DroppedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ProcessedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ProcessedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ProcessedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/processed YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ProcessedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ReceivedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ReceivedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ReceivedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/received YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ReceivedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_RetransmitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_RetransmitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_RetransmitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/retransmit YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_RetransmitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_SentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_SentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_SentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/sent YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_SentPathAny struct {
	*ygot.NodePath
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPath) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_DroppedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_DroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dropped (leaf): The number of the specified type of PDU received on the interface
// that have been dropped.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dropped"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/dropped"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPathAny) Dropped() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_DroppedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_DroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPath) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ProcessedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ProcessedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Processed (leaf): The number of the specified type of PDU received on the interface
// that have been processed by the local system.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/processed"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/processed"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPathAny) Processed() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ProcessedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ProcessedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "processed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPath) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ReceivedPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Received (leaf): The number of the specified type of PDU received on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/received"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPathAny) Received() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ReceivedPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_ReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPath) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_RetransmitPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_RetransmitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Retransmit (leaf): The number of the specified type of PDU that that have been
// retransmitted by the local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/retransmit"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPathAny) Retransmit() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_RetransmitPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_RetransmitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPath) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_SentPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_SentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Sent (leaf): The number of the specified type of PDU that have been sent by the
// local system on the interface.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sent"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/packet-counters/unknown/state/sent"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_UnknownPathAny) Sent() *NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_SentPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_PacketCounters_Unknown_SentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Level_TimersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_TimersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_TimersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_TimersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers/config/hello-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers/config/hello-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloMultiplierPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers/config/hello-multiplier YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloMultiplierPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloMultiplierPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers/config/hello-multiplier YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloMultiplierPathAny struct {
	*ygot.NodePath
}

// HelloInterval (leaf): ISIS hello-interval value.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers/config/hello-interval"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_TimersPath) HelloInterval() *NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloIntervalPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): ISIS hello-interval value.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers/config/hello-interval"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_TimersPathAny) HelloInterval() *NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloMultiplier (leaf): ISIS hello-multiplier value.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-multiplier"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers/config/hello-multiplier"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_TimersPath) HelloMultiplier() *NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloMultiplierPath {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloMultiplierPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-multiplier"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloMultiplier (leaf): ISIS hello-multiplier value.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-multiplier"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/levels/level/timers/config/hello-multiplier"
func (n *NetworkInstance_Protocol_Isis_Interface_Level_TimersPathAny) HelloMultiplier() *NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloMultiplierPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Level_Timers_HelloMultiplierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-multiplier"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_MplsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_MplsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_MplsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_MplsPathAny struct {
	*ygot.NodePath
}

// IgpLdpSync (container): Configuration and operational state relating to synchronisation
// between the LDP and IS-IS
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-ldp-sync"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync"
func (n *NetworkInstance_Protocol_Isis_Interface_MplsPath) IgpLdpSync() *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPath {
	return &NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPath{
		NodePath: ygot.NewNodePath(
			[]string{"igp-ldp-sync"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgpLdpSync (container): Configuration and operational state relating to synchronisation
// between the LDP and IS-IS
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-ldp-sync"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync"
func (n *NetworkInstance_Protocol_Isis_Interface_MplsPathAny) IgpLdpSync() *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"igp-ldp-sync"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync/config/post-session-up-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync/config/post-session-up-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When set to true, rely on IGP/LDP synchronization. IGP cost for
// link is maintained at max until LDP adjacencies are established
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPath) Enabled() *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, rely on IGP/LDP synchronization. IGP cost for
// link is maintained at max until LDP adjacencies are established
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPathAny) Enabled() *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostSessionUpDelay (leaf): Specifies a delay, expressed in units of seconds,
// between the LDP session to the IGP neighbor being established, and
// it being considered synchronized by the IGP.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/post-session-up-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync/config/post-session-up-delay"
func (n *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPath) PostSessionUpDelay() *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPath {
	return &NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "post-session-up-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostSessionUpDelay (leaf): Specifies a delay, expressed in units of seconds,
// between the LDP session to the IGP neighbor being established, and
// it being considered synchronized by the IGP.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/post-session-up-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/mpls/igp-ldp-sync/config/post-session-up-delay"
func (n *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSyncPathAny) PostSessionUpDelay() *NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "post-session-up-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Interface_TimersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_TimersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_TimersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_TimersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Timers_CsnpIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers/config/csnp-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Timers_CsnpIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Timers_CsnpIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers/config/csnp-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Timers_CsnpIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Timers_LspPacingIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers/config/lsp-pacing-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Timers_LspPacingIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Interface_Timers_LspPacingIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers/config/lsp-pacing-interval YANG schema element.
type NetworkInstance_Protocol_Isis_Interface_Timers_LspPacingIntervalPathAny struct {
	*ygot.NodePath
}

// CsnpInterval (leaf): The interval, specified in seconds, at which periodic CSNP packets
// should be transmitted by the local IS.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/csnp-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers/config/csnp-interval"
func (n *NetworkInstance_Protocol_Isis_Interface_TimersPath) CsnpInterval() *NetworkInstance_Protocol_Isis_Interface_Timers_CsnpIntervalPath {
	return &NetworkInstance_Protocol_Isis_Interface_Timers_CsnpIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "csnp-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// CsnpInterval (leaf): The interval, specified in seconds, at which periodic CSNP packets
// should be transmitted by the local IS.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/csnp-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers/config/csnp-interval"
func (n *NetworkInstance_Protocol_Isis_Interface_TimersPathAny) CsnpInterval() *NetworkInstance_Protocol_Isis_Interface_Timers_CsnpIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Timers_CsnpIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "csnp-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspPacingInterval (leaf): The interval interval in milliseconds between the
// detection of topology change and when the SPF algorithm runs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-pacing-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers/config/lsp-pacing-interval"
func (n *NetworkInstance_Protocol_Isis_Interface_TimersPath) LspPacingInterval() *NetworkInstance_Protocol_Isis_Interface_Timers_LspPacingIntervalPath {
	return &NetworkInstance_Protocol_Isis_Interface_Timers_LspPacingIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-pacing-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspPacingInterval (leaf): The interval interval in milliseconds between the
// detection of topology change and when the SPF algorithm runs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/lsp-pacing-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/interfaces/interface/timers/config/lsp-pacing-interval"
func (n *NetworkInstance_Protocol_Isis_Interface_TimersPathAny) LspPacingInterval() *NetworkInstance_Protocol_Isis_Interface_Timers_LspPacingIntervalPathAny {
	return &NetworkInstance_Protocol_Isis_Interface_Timers_LspPacingIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "lsp-pacing-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_LevelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level YANG schema element.
type NetworkInstance_Protocol_Isis_LevelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_LevelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level YANG schema element.
type NetworkInstance_Protocol_Isis_LevelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_AuthenticationCheckPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/config/authentication-check YANG schema element.
type NetworkInstance_Protocol_Isis_Level_AuthenticationCheckPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_AuthenticationCheckPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/config/authentication-check YANG schema element.
type NetworkInstance_Protocol_Isis_Level_AuthenticationCheckPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Level_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Level_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_LevelNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/config/level-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_LevelNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_LevelNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/config/level-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_LevelNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_MetricStylePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/config/metric-style YANG schema element.
type NetworkInstance_Protocol_Isis_Level_MetricStylePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_MetricStylePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/config/metric-style YANG schema element.
type NetworkInstance_Protocol_Isis_Level_MetricStylePathAny struct {
	*ygot.NodePath
}

// Authentication (container): This container defines ISIS authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication"
func (n *NetworkInstance_Protocol_Isis_LevelPath) Authentication() *NetworkInstance_Protocol_Isis_Level_AuthenticationPath {
	return &NetworkInstance_Protocol_Isis_Level_AuthenticationPath{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authentication (container): This container defines ISIS authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication"
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) Authentication() *NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny {
	return &NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationCheck (leaf): When set to true, reject all ISIS protocol PDUs that either have a mismatch
// in authentication-type or authentication-key.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-check"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/config/authentication-check"
func (n *NetworkInstance_Protocol_Isis_LevelPath) AuthenticationCheck() *NetworkInstance_Protocol_Isis_Level_AuthenticationCheckPath {
	return &NetworkInstance_Protocol_Isis_Level_AuthenticationCheckPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-check"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationCheck (leaf): When set to true, reject all ISIS protocol PDUs that either have a mismatch
// in authentication-type or authentication-key.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-check"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/config/authentication-check"
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) AuthenticationCheck() *NetworkInstance_Protocol_Isis_Level_AuthenticationCheckPathAny {
	return &NetworkInstance_Protocol_Isis_Level_AuthenticationCheckPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-check"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/config/enabled"
func (n *NetworkInstance_Protocol_Isis_LevelPath) Enabled() *NetworkInstance_Protocol_Isis_Level_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Level_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/config/enabled"
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) Enabled() *NetworkInstance_Protocol_Isis_Level_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Level_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// LevelNumber (leaf): ISIS level number (level-1, level-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/level-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/config/level-number"
func (n *NetworkInstance_Protocol_Isis_LevelPath) LevelNumber() *NetworkInstance_Protocol_Isis_Level_LevelNumberPath {
	return &NetworkInstance_Protocol_Isis_Level_LevelNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "level-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// LevelNumber (leaf): ISIS level number (level-1, level-2).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/level-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/config/level-number"
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) LevelNumber() *NetworkInstance_Protocol_Isis_Level_LevelNumberPathAny {
	return &NetworkInstance_Protocol_Isis_Level_LevelNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "level-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspAny (list): This list describes LSPs in the LSDB.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-state-database/lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp"
// LspId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_LevelPath) LspAny() *NetworkInstance_Protocol_Isis_Level_LspPathAny {
	return &NetworkInstance_Protocol_Isis_Level_LspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-state-database", "lsp"},
			map[string]interface{}{"lsp-id": "*"},
			n,
		),
	}
}

// LspAny (list): This list describes LSPs in the LSDB.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-state-database/lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp"
// LspId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) LspAny() *NetworkInstance_Protocol_Isis_Level_LspPathAny {
	return &NetworkInstance_Protocol_Isis_Level_LspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-state-database", "lsp"},
			map[string]interface{}{"lsp-id": "*"},
			n,
		),
	}
}

// Lsp (list): This list describes LSPs in the LSDB.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-state-database/lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp"
// LspId: string
func (n *NetworkInstance_Protocol_Isis_LevelPath) Lsp(LspId string) *NetworkInstance_Protocol_Isis_Level_LspPath {
	return &NetworkInstance_Protocol_Isis_Level_LspPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-state-database", "lsp"},
			map[string]interface{}{"lsp-id": LspId},
			n,
		),
	}
}

// Lsp (list): This list describes LSPs in the LSDB.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-state-database/lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp"
// LspId: string
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) Lsp(LspId string) *NetworkInstance_Protocol_Isis_Level_LspPathAny {
	return &NetworkInstance_Protocol_Isis_Level_LspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-state-database", "lsp"},
			map[string]interface{}{"lsp-id": LspId},
			n,
		),
	}
}

// MetricStyle (leaf): ISIS metric style types(narrow, wide).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric-style"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/config/metric-style"
func (n *NetworkInstance_Protocol_Isis_LevelPath) MetricStyle() *NetworkInstance_Protocol_Isis_Level_MetricStylePath {
	return &NetworkInstance_Protocol_Isis_Level_MetricStylePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric-style"},
			map[string]interface{}{},
			n,
		),
	}
}

// MetricStyle (leaf): ISIS metric style types(narrow, wide).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric-style"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/config/metric-style"
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) MetricStyle() *NetworkInstance_Protocol_Isis_Level_MetricStylePathAny {
	return &NetworkInstance_Protocol_Isis_Level_MetricStylePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric-style"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutePreference (container): This container defines Administrative Distance (or preference)
// assigned to ISIS routes (level1 internal, level2 internal, level1
// external, level2 external).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-preference"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference"
func (n *NetworkInstance_Protocol_Isis_LevelPath) RoutePreference() *NetworkInstance_Protocol_Isis_Level_RoutePreferencePath {
	return &NetworkInstance_Protocol_Isis_Level_RoutePreferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"route-preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutePreference (container): This container defines Administrative Distance (or preference)
// assigned to ISIS routes (level1 internal, level2 internal, level1
// external, level2 external).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "route-preference"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference"
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) RoutePreference() *NetworkInstance_Protocol_Isis_Level_RoutePreferencePathAny {
	return &NetworkInstance_Protocol_Isis_Level_RoutePreferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"route-preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemLevelCounters (container): This container defines ISIS system level counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "system-level-counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters"
func (n *NetworkInstance_Protocol_Isis_LevelPath) SystemLevelCounters() *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"system-level-counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemLevelCounters (container): This container defines ISIS system level counters.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "system-level-counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters"
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) SystemLevelCounters() *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"system-level-counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineering (container): This container defines ISIS TE.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "traffic-engineering"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering"
func (n *NetworkInstance_Protocol_Isis_LevelPath) TrafficEngineering() *NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPath {
	return &NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPath{
		NodePath: ygot.NewNodePath(
			[]string{"traffic-engineering"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineering (container): This container defines ISIS TE.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "traffic-engineering"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering"
func (n *NetworkInstance_Protocol_Isis_LevelPathAny) TrafficEngineering() *NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPathAny {
	return &NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"traffic-engineering"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_AuthenticationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication YANG schema element.
type NetworkInstance_Protocol_Isis_Level_AuthenticationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication YANG schema element.
type NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_AuthModePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-mode YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_AuthModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_AuthModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-mode YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_AuthModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_AuthPasswordPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_AuthPasswordPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_AuthPasswordPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-password YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_AuthPasswordPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_AuthTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_AuthTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_AuthTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_AuthTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_DisableCsnpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-csnp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_DisableCsnpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_DisableCsnpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-csnp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_DisableCsnpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_DisableLspPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_DisableLspPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_DisableLspPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_DisableLspPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_DisablePsnpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-psnp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_DisablePsnpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_DisablePsnpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-psnp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_DisablePsnpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_KeychainPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/keychain YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_KeychainPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Authentication_KeychainPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/keychain YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Authentication_KeychainPathAny struct {
	*ygot.NodePath
}

// AuthMode (leaf): The type of authentication used in the applicable IS-IS PDUs.
//
// This leaf along with the sibling leaf 'auth-password' can be used
// to configure the simple key authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-mode"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPath) AuthMode() *NetworkInstance_Protocol_Isis_Level_Authentication_AuthModePath {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_AuthModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthMode (leaf): The type of authentication used in the applicable IS-IS PDUs.
//
// This leaf along with the sibling leaf 'auth-password' can be used
// to configure the simple key authentication.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-mode"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny) AuthMode() *NetworkInstance_Protocol_Isis_Level_Authentication_AuthModePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_AuthModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): The authentication key used in the applicable IS-IS PDUs. The key in the
// packet may be encrypted according to the configured authentication type.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-password"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPath) AuthPassword() *NetworkInstance_Protocol_Isis_Level_Authentication_AuthPasswordPath {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_AuthPasswordPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPassword (leaf): The authentication key used in the applicable IS-IS PDUs. The key in the
// packet may be encrypted according to the configured authentication type.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-password"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-password"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny) AuthPassword() *NetworkInstance_Protocol_Isis_Level_Authentication_AuthPasswordPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_AuthPasswordPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthType (leaf): The type of authentication used in the applicable IS-IS PDUs
// (simple_key, keychain).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-type"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPath) AuthType() *NetworkInstance_Protocol_Isis_Level_Authentication_AuthTypePath {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_AuthTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthType (leaf): The type of authentication used in the applicable IS-IS PDUs
// (simple_key, keychain).
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/auth-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/auth-type"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny) AuthType() *NetworkInstance_Protocol_Isis_Level_Authentication_AuthTypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_AuthTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisableCsnp (leaf): When this leaf is set to true, authentication is disabled for CSNP
// packets, overriding the value of the enabled leaf in this context.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-csnp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-csnp"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPath) DisableCsnp() *NetworkInstance_Protocol_Isis_Level_Authentication_DisableCsnpPath {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_DisableCsnpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-csnp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisableCsnp (leaf): When this leaf is set to true, authentication is disabled for CSNP
// packets, overriding the value of the enabled leaf in this context.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-csnp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-csnp"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny) DisableCsnp() *NetworkInstance_Protocol_Isis_Level_Authentication_DisableCsnpPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_DisableCsnpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-csnp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisableLsp (leaf): When this leaf is set to true, authentication is disabled for LSP
// packets, overriding the value of the enabled leaf in this context.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPath) DisableLsp() *NetworkInstance_Protocol_Isis_Level_Authentication_DisableLspPath {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_DisableLspPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisableLsp (leaf): When this leaf is set to true, authentication is disabled for LSP
// packets, overriding the value of the enabled leaf in this context.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny) DisableLsp() *NetworkInstance_Protocol_Isis_Level_Authentication_DisableLspPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_DisableLspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisablePsnp (leaf): When this leaf is set to true, authentication is disabled for PSNP
// packets, overriding the value of the enabled leaf in this context.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-psnp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-psnp"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPath) DisablePsnp() *NetworkInstance_Protocol_Isis_Level_Authentication_DisablePsnpPath {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_DisablePsnpPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-psnp"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisablePsnp (leaf): When this leaf is set to true, authentication is disabled for PSNP
// packets, overriding the value of the enabled leaf in this context.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-psnp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/disable-psnp"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny) DisablePsnp() *NetworkInstance_Protocol_Isis_Level_Authentication_DisablePsnpPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_DisablePsnpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-psnp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, authentication of IS-IS PSNP, CSNP and
// LSP packets is enabled using the specified authentication details in
// the sibling leaves.
//
// The sibling 'disable-<type>' leaves can be used to override the value
// of this leaf and disable authentication for a specific packet type.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPath) Enabled() *NetworkInstance_Protocol_Isis_Level_Authentication_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, authentication of IS-IS PSNP, CSNP and
// LSP packets is enabled using the specified authentication details in
// the sibling leaves.
//
// The sibling 'disable-<type>' leaves can be used to override the value
// of this leaf and disable authentication for a specific packet type.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny) Enabled() *NetworkInstance_Protocol_Isis_Level_Authentication_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Keychain (leaf): Reference to the keychain that should be used for authenticating IS-IS
// packets - the keychain may contain either a simple password, or
// HMAC-MD5 key that is used for authenticating CSNP, PSNP and LSP packets
// within the specified IS-IS level.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keychain"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/keychain"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPath) Keychain() *NetworkInstance_Protocol_Isis_Level_Authentication_KeychainPath {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_KeychainPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keychain"},
			map[string]interface{}{},
			n,
		),
	}
}

// Keychain (leaf): Reference to the keychain that should be used for authenticating IS-IS
// packets - the keychain may contain either a simple password, or
// HMAC-MD5 key that is used for authenticating CSNP, PSNP and LSP packets
// within the specified IS-IS level.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/keychain"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/authentication/config/keychain"
func (n *NetworkInstance_Protocol_Isis_Level_AuthenticationPathAny) Keychain() *NetworkInstance_Protocol_Isis_Level_Authentication_KeychainPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Authentication_KeychainPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "keychain"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_LspPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_LspPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_LspPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_LspPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_ChecksumPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/checksum YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_ChecksumPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_ChecksumPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/checksum YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_ChecksumPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_IdLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/id-length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_IdLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_IdLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/id-length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_IdLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_IsTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/is-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_IsTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_IsTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/is-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_IsTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_LspIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/lsp-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_LspIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_LspIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/lsp-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_LspIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_MaximumAreaAddressesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/maximum-area-addresses YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_MaximumAreaAddressesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_MaximumAreaAddressesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/maximum-area-addresses YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_MaximumAreaAddressesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_PduLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/pdu-length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_PduLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_PduLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/pdu-length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_PduLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_PduTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/pdu-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_PduTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_PduTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/pdu-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_PduTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_RemainingLifetimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/remaining-lifetime YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_RemainingLifetimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_RemainingLifetimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/remaining-lifetime YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_RemainingLifetimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_SequenceNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/sequence-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_SequenceNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_SequenceNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/sequence-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_SequenceNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_VersionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/version YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_VersionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_VersionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/version YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_VersionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Version2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/version2 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Version2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Version2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/version2 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Version2PathAny struct {
	*ygot.NodePath
}

// Checksum (leaf): Checksum of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/checksum"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/checksum"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) Checksum() *NetworkInstance_Protocol_Isis_Level_Lsp_ChecksumPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_ChecksumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "checksum"},
			map[string]interface{}{},
			n,
		),
	}
}

// Checksum (leaf): Checksum of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/checksum"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/checksum"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) Checksum() *NetworkInstance_Protocol_Isis_Level_Lsp_ChecksumPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_ChecksumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "checksum"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): LSP Type-Block flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): LSP Type-Block flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// IdLength (leaf): Length of the ID field of NSAP addresses and NETs used in
// this routing domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/id-length"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) IdLength() *NetworkInstance_Protocol_Isis_Level_Lsp_IdLengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_IdLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// IdLength (leaf): Length of the ID field of NSAP addresses and NETs used in
// this routing domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/id-length"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) IdLength() *NetworkInstance_Protocol_Isis_Level_Lsp_IdLengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_IdLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsType (leaf): Type of neighboring system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/is-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/is-type"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) IsType() *NetworkInstance_Protocol_Isis_Level_Lsp_IsTypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_IsTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "is-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsType (leaf): Type of neighboring system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/is-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/is-type"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) IsType() *NetworkInstance_Protocol_Isis_Level_Lsp_IsTypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_IsTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "is-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspId (leaf): LSP ID of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lsp-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/lsp-id"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) LspId() *NetworkInstance_Protocol_Isis_Level_Lsp_LspIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_LspIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lsp-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspId (leaf): LSP ID of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lsp-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/lsp-id"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) LspId() *NetworkInstance_Protocol_Isis_Level_Lsp_LspIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_LspIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lsp-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumAreaAddresses (leaf): Number of area addresses permitted for this ISs area. 0
// indicates the IS only supports three area addresses (by
// default). Any number inclusive of 1 and 254 indicates the
// number of areas allowed.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/maximum-area-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/maximum-area-addresses"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) MaximumAreaAddresses() *NetworkInstance_Protocol_Isis_Level_Lsp_MaximumAreaAddressesPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_MaximumAreaAddressesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "maximum-area-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumAreaAddresses (leaf): Number of area addresses permitted for this ISs area. 0
// indicates the IS only supports three area addresses (by
// default). Any number inclusive of 1 and 254 indicates the
// number of areas allowed.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/maximum-area-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/maximum-area-addresses"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) MaximumAreaAddresses() *NetworkInstance_Protocol_Isis_Level_Lsp_MaximumAreaAddressesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_MaximumAreaAddressesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "maximum-area-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// PduLength (leaf): Total length of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pdu-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/pdu-length"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) PduLength() *NetworkInstance_Protocol_Isis_Level_Lsp_PduLengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_PduLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pdu-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PduLength (leaf): Total length of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pdu-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/pdu-length"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) PduLength() *NetworkInstance_Protocol_Isis_Level_Lsp_PduLengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_PduLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pdu-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PduType (leaf): Link State PDU type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pdu-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/pdu-type"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) PduType() *NetworkInstance_Protocol_Isis_Level_Lsp_PduTypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_PduTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pdu-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// PduType (leaf): Link State PDU type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pdu-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/pdu-type"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) PduType() *NetworkInstance_Protocol_Isis_Level_Lsp_PduTypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_PduTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pdu-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemainingLifetime (leaf): Remaining lifetime in seconds before the LSP expiration.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remaining-lifetime"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/remaining-lifetime"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) RemainingLifetime() *NetworkInstance_Protocol_Isis_Level_Lsp_RemainingLifetimePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_RemainingLifetimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remaining-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemainingLifetime (leaf): Remaining lifetime in seconds before the LSP expiration.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remaining-lifetime"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/remaining-lifetime"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) RemainingLifetime() *NetworkInstance_Protocol_Isis_Level_Lsp_RemainingLifetimePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_RemainingLifetimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remaining-lifetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceNumber (leaf): Sequence number of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sequence-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/sequence-number"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) SequenceNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_SequenceNumberPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_SequenceNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sequence-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceNumber (leaf): Sequence number of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sequence-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/sequence-number"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) SequenceNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_SequenceNumberPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_SequenceNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sequence-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvAny (list): List of TLV types in the LSDB for the specified LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tlvs/tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_TLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) TlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlvs", "tlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// TlvAny (list): List of TLV types in the LSDB for the specified LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tlvs/tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_TLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) TlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlvs", "tlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Tlv (list): List of TLV types in the LSDB for the specified LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tlvs/tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv"
// Type: E_IsisLsdbTypes_ISIS_TLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) Tlv(Type E_IsisLsdbTypes_ISIS_TLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlvs", "tlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Tlv (list): List of TLV types in the LSDB for the specified LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tlvs/tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv"
// Type: E_IsisLsdbTypes_ISIS_TLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) Tlv(Type E_IsisLsdbTypes_ISIS_TLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlvs", "tlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedTlvAny (list): List of TLVs that are not defined within the model, or are
// not recognised by the system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-tlvs/undefined-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) UndefinedTlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-tlvs", "undefined-tlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedTlvAny (list): List of TLVs that are not defined within the model, or are
// not recognised by the system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-tlvs/undefined-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) UndefinedTlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-tlvs", "undefined-tlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedTlv (list): List of TLVs that are not defined within the model, or are
// not recognised by the system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-tlvs/undefined-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) UndefinedTlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-tlvs", "undefined-tlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedTlv (list): List of TLVs that are not defined within the model, or are
// not recognised by the system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-tlvs/undefined-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) UndefinedTlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-tlvs", "undefined-tlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Version (leaf): PDU version. This is set to 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/version"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/version"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) Version() *NetworkInstance_Protocol_Isis_Level_Lsp_VersionPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_VersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "version"},
			map[string]interface{}{},
			n,
		),
	}
}

// Version (leaf): PDU version. This is set to 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/version"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/version"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) Version() *NetworkInstance_Protocol_Isis_Level_Lsp_VersionPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_VersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "version"},
			map[string]interface{}{},
			n,
		),
	}
}

// Version2 (leaf): PDU version2. This is set to 1
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/version2"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/version2"
func (n *NetworkInstance_Protocol_Isis_Level_LspPath) Version2() *NetworkInstance_Protocol_Isis_Level_Lsp_Version2Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Version2Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "version2"},
			map[string]interface{}{},
			n,
		),
	}
}

// Version2 (leaf): PDU version2. This is set to 1
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/version2"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/state/version2"
func (n *NetworkInstance_Protocol_Isis_Level_LspPathAny) Version2() *NetworkInstance_Protocol_Isis_Level_Lsp_Version2PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Version2PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "version2"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// AreaAddress (container): This container defines TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "area-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/area-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) AreaAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"area-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// AreaAddress (container): This container defines TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "area-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/area-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) AreaAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"area-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authentication (container): This container defines authentication information of the
// node.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Authentication() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPath{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authentication (container): This container defines authentication information of the
// node.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "authentication"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Authentication() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// CapabilityAny (list): This list describes IS Router capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-capabilities/capability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability"
// InstanceNumber (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) CapabilityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"router-capabilities", "capability"},
			map[string]interface{}{"instance-number": "*"},
			n,
		),
	}
}

// CapabilityAny (list): This list describes IS Router capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-capabilities/capability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability"
// InstanceNumber (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) CapabilityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"router-capabilities", "capability"},
			map[string]interface{}{"instance-number": "*"},
			n,
		),
	}
}

// Capability (list): This list describes IS Router capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-capabilities/capability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability"
// InstanceNumber: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Capability(InstanceNumber uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"router-capabilities", "capability"},
			map[string]interface{}{"instance-number": InstanceNumber},
			n,
		),
	}
}

// Capability (list): This list describes IS Router capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-capabilities/capability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability"
// InstanceNumber: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Capability(InstanceNumber uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"router-capabilities", "capability"},
			map[string]interface{}{"instance-number": InstanceNumber},
			n,
		),
	}
}

// ExtendedIpv4Reachability (container): This container defines list of IPv4 extended reachability
// information.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-ipv4-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) ExtendedIpv4Reachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"extended-ipv4-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedIpv4Reachability (container): This container defines list of IPv4 extended reachability
// information.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-ipv4-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) ExtendedIpv4Reachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"extended-ipv4-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedIsReachability (container): This container defines list of ISIS extended reachability
// neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-is-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) ExtendedIsReachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"extended-is-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedIsReachability (container): This container defines list of ISIS extended reachability
// neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-is-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) ExtendedIsReachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"extended-is-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hostname (container): This container defines TLV 137.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hostname"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/hostname"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Hostname() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePath{
		NodePath: ygot.NewNodePath(
			[]string{"hostname"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hostname (container): This container defines TLV 137.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hostname"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/hostname"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Hostname() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hostname"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstanceIdAny (list): A list of instance IDs received within TLV 7 within an
// IS-IS LSP. In the case that more than one instance of
// TLV 7 is included in the LSP, the instance IDs specified
// within the instances are concatenated within this
// list.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instance-ids/instance-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id"
// InstanceId (wildcarded): uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) InstanceIdAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instance-ids", "instance-id"},
			map[string]interface{}{"instance-id": "*"},
			n,
		),
	}
}

// InstanceIdAny (list): A list of instance IDs received within TLV 7 within an
// IS-IS LSP. In the case that more than one instance of
// TLV 7 is included in the LSP, the instance IDs specified
// within the instances are concatenated within this
// list.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instance-ids/instance-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id"
// InstanceId (wildcarded): uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) InstanceIdAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instance-ids", "instance-id"},
			map[string]interface{}{"instance-id": "*"},
			n,
		),
	}
}

// InstanceId (list): A list of instance IDs received within TLV 7 within an
// IS-IS LSP. In the case that more than one instance of
// TLV 7 is included in the LSP, the instance IDs specified
// within the instances are concatenated within this
// list.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instance-ids/instance-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id"
// InstanceId: uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) InstanceId(InstanceId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"instance-ids", "instance-id"},
			map[string]interface{}{"instance-id": InstanceId},
			n,
		),
	}
}

// InstanceId (list): A list of instance IDs received within TLV 7 within an
// IS-IS LSP. In the case that more than one instance of
// TLV 7 is included in the LSP, the instance IDs specified
// within the instances are concatenated within this
// list.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instance-ids/instance-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id"
// InstanceId: uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) InstanceId(InstanceId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instance-ids", "instance-id"},
			map[string]interface{}{"instance-id": InstanceId},
			n,
		),
	}
}

// Ipv4ExternalReachability (container): This container defines list of IPv4 external reachability
// information.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-external-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv4ExternalReachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-external-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4ExternalReachability (container): This container defines list of IPv4 external reachability
// information.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-external-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv4ExternalReachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-external-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddresses (container): This container defines TLV 132.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-interface-addresses"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv4InterfaceAddresses() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddresses (container): This container defines TLV 132.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-interface-addresses"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv4InterfaceAddresses() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InternalReachability (container): This container defines list of IPv4 internal reachability
// information.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-internal-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv4InternalReachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-internal-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InternalReachability (container): This container defines list of IPv4 internal reachability
// information.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-internal-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv4InternalReachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-internal-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SrlgAny (list): Instance of the IPv4 SRLG TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-srlgs/ipv4-srlg"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg"
// InstanceNumber (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv4SrlgAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-srlgs", "ipv4-srlg"},
			map[string]interface{}{"instance-number": "*"},
			n,
		),
	}
}

// Ipv4SrlgAny (list): Instance of the IPv4 SRLG TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-srlgs/ipv4-srlg"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg"
// InstanceNumber (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv4SrlgAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-srlgs", "ipv4-srlg"},
			map[string]interface{}{"instance-number": "*"},
			n,
		),
	}
}

// Ipv4Srlg (list): Instance of the IPv4 SRLG TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-srlgs/ipv4-srlg"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg"
// InstanceNumber: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv4Srlg(InstanceNumber uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-srlgs", "ipv4-srlg"},
			map[string]interface{}{"instance-number": InstanceNumber},
			n,
		),
	}
}

// Ipv4Srlg (list): Instance of the IPv4 SRLG TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-srlgs/ipv4-srlg"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg"
// InstanceNumber: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv4Srlg(InstanceNumber uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-srlgs", "ipv4-srlg"},
			map[string]interface{}{"instance-number": InstanceNumber},
			n,
		),
	}
}

// Ipv4TeRouterId (container): This container defines TLV 134.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-te-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-te-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv4TeRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-te-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4TeRouterId (container): This container defines TLV 134.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-te-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-te-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv4TeRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-te-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddresses (container): This container defines TLV 232.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-interface-addresses"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv6InterfaceAddresses() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddresses (container): This container defines TLV 232.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-interface-addresses"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv6InterfaceAddresses() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Reachability (container): This container defines list of IPv6 reachability
// information.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv6Reachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Reachability (container): This container defines list of IPv6 reachability
// information.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv6Reachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SrlgAny (list): Instance of the IPv6 SRLG TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-srlgs/ipv6-srlg"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg"
// InstanceNumber (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv6SrlgAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-srlgs", "ipv6-srlg"},
			map[string]interface{}{"instance-number": "*"},
			n,
		),
	}
}

// Ipv6SrlgAny (list): Instance of the IPv6 SRLG TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-srlgs/ipv6-srlg"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg"
// InstanceNumber (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv6SrlgAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-srlgs", "ipv6-srlg"},
			map[string]interface{}{"instance-number": "*"},
			n,
		),
	}
}

// Ipv6Srlg (list): Instance of the IPv6 SRLG TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-srlgs/ipv6-srlg"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg"
// InstanceNumber: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv6Srlg(InstanceNumber uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-srlgs", "ipv6-srlg"},
			map[string]interface{}{"instance-number": InstanceNumber},
			n,
		),
	}
}

// Ipv6Srlg (list): Instance of the IPv6 SRLG TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-srlgs/ipv6-srlg"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg"
// InstanceNumber: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv6Srlg(InstanceNumber uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-srlgs", "ipv6-srlg"},
			map[string]interface{}{"instance-number": InstanceNumber},
			n,
		),
	}
}

// Ipv6TeRouterId (container): This container defines TLV 140.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-te-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-te-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Ipv6TeRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-te-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6TeRouterId (container): This container defines TLV 140.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-te-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-te-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Ipv6TeRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-te-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsAliasId (container): This container defines the IS-Alias TLV which allows
// extension-capable ISs to recognize the Originating System
// of an Extended LSP set. It identifies the Normal system-
// id of the Originating System.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "is-alias-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-alias-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) IsAliasId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"is-alias-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsAliasId (container): This container defines the IS-Alias TLV which allows
// extension-capable ISs to recognize the Originating System
// of an Extended LSP set. It identifies the Normal system-
// id of the Originating System.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "is-alias-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-alias-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) IsAliasId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"is-alias-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsReachability (container): This container describes list of ISIS neighbors and
// attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "is-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) IsReachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"is-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsReachability (container): This container describes list of ISIS neighbors and
// attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "is-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) IsReachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"is-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsisNeighborAttribute (container): This container defines list of ISIS topology neighbors
// for extended ISIS LSP (multiple system IDs).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "isis-neighbor-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) IsisNeighborAttribute() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"isis-neighbor-attribute"},
			map[string]interface{}{},
			n,
		),
	}
}

// IsisNeighborAttribute (container): This container defines list of ISIS topology neighbors
// for extended ISIS LSP (multiple system IDs).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "isis-neighbor-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) IsisNeighborAttribute() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"isis-neighbor-attribute"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspBufferSize (container): This container defines TLV 14 - the LSP Buffer Size
// TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsp-buffer-size"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/lsp-buffer-size"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) LspBufferSize() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePath{
		NodePath: ygot.NewNodePath(
			[]string{"lsp-buffer-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspBufferSize (container): This container defines TLV 14 - the LSP Buffer Size
// TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsp-buffer-size"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/lsp-buffer-size"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) LspBufferSize() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsp-buffer-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtIpv4Reachability (container): This container defines list of IPv4 reachability
// Information in multi-topology environment.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mt-ipv4-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) MtIpv4Reachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"mt-ipv4-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtIpv4Reachability (container): This container defines list of IPv4 reachability
// Information in multi-topology environment.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mt-ipv4-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) MtIpv4Reachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mt-ipv4-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtIpv6Reachability (container): This container defines list of IPv6 reachability
// information in multi - topology environment.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mt-ipv6-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) MtIpv6Reachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"mt-ipv6-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtIpv6Reachability (container): This container defines list of IPv6 reachability
// information in multi - topology environment.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mt-ipv6-reachability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) MtIpv6Reachability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mt-ipv6-reachability"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtIsisNeighborAttribute (container): This container defines list of ISIS multi-topology
// neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mt-isis-neighbor-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) MtIsisNeighborAttribute() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"mt-isis-neighbor-attribute"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtIsisNeighborAttribute (container): This container defines list of ISIS multi-topology
// neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mt-isis-neighbor-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) MtIsisNeighborAttribute() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mt-isis-neighbor-attribute"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtIsn (container): This container defines list of ISIS multi-topology
// neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mt-isn"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) MtIsn() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPath{
		NodePath: ygot.NewNodePath(
			[]string{"mt-isn"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtIsn (container): This container defines list of ISIS multi-topology
// neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mt-isn"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) MtIsn() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mt-isn"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopology (container): This container defines the topology supported.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "multi-topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) MultiTopology() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPath{
		NodePath: ygot.NewNodePath(
			[]string{"multi-topology"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopology (container): This container defines the topology supported.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "multi-topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) MultiTopology() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"multi-topology"},
			map[string]interface{}{},
			n,
		),
	}
}

// Nlpid (container): This container defines TLV 129.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "nlpid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/nlpid"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Nlpid() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPath{
		NodePath: ygot.NewNodePath(
			[]string{"nlpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Nlpid (container): This container defines TLV 129.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "nlpid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/nlpid"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Nlpid() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"nlpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// PurgeOi (container): This container defines ISIS purge TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "purge-oi"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) PurgeOi() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPath{
		NodePath: ygot.NewNodePath(
			[]string{"purge-oi"},
			map[string]interface{}{},
			n,
		),
	}
}

// PurgeOi (container): This container defines ISIS purge TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "purge-oi"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) PurgeOi() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"purge-oi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of TLV being described. The type of TLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of TLV being described. The type of TLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_TlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/area-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/area-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/area-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/area-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Area adress(es) of the IS. Set of manual area
// addresses of this IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/area-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Area adress(es) of the IS. Set of manual area
// addresses of this IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/area-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AreaAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_AuthenticationKeyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication/state/authentication-key YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_AuthenticationKeyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_AuthenticationKeyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication/state/authentication-key YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_AuthenticationKeyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_CryptoTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication/state/crypto-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_CryptoTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_CryptoTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication/state/crypto-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_CryptoTypePathAny struct {
	*ygot.NodePath
}

// AuthenticationKey (leaf): Authentication key to be used.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/authentication-key"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication/state/authentication-key"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPath) AuthenticationKey() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_AuthenticationKeyPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_AuthenticationKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "authentication-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationKey (leaf): Authentication key to be used.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/authentication-key"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication/state/authentication-key"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPathAny) AuthenticationKey() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_AuthenticationKeyPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_AuthenticationKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "authentication-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// CryptoType (leaf): Authentication type to be used.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/crypto-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication/state/crypto-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPath) CryptoType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_CryptoTypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_CryptoTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "crypto-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// CryptoType (leaf): Authentication type to be used.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/crypto-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/authentication/state/crypto-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_AuthenticationPathAny) CryptoType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_CryptoTypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Authentication_CryptoTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "crypto-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_InstanceNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/instance-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_InstanceNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_InstanceNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/instance-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_InstanceNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_RouterIdPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Router capability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Router capability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstanceNumber (leaf): A unique instance number for the instance of the
// router capabilities TLV. The instance number should
// be autogenerated by the producer of the data and may
// be renumbered if the entire LSP contents are
// replaced in subsequent advertisements.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/instance-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath) InstanceNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_InstanceNumberPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_InstanceNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstanceNumber (leaf): A unique instance number for the instance of the
// router capabilities TLV. The instance number should
// be autogenerated by the producer of the data and may
// be renumbered if the entire LSP contents are
// replaced in subsequent advertisements.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/instance-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny) InstanceNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_InstanceNumberPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_InstanceNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv4 router-id.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv4 router-id.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified
// TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified
// TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified
// TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified
// TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPath) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_CapabilityPathAny) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// SegmentRoutingAlgorithms (container): This container defines SR algorithm sub-TLV 19.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing-algorithms"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-algorithms"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPath) SegmentRoutingAlgorithms() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing-algorithms"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRoutingAlgorithms (container): This container defines SR algorithm sub-TLV 19.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing-algorithms"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-algorithms"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny) SegmentRoutingAlgorithms() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing-algorithms"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRoutingCapability (container): This container defines SR Capability sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing-capability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPath) SegmentRoutingCapability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing-capability"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRoutingCapability (container): This container defines SR Capability sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing-capability"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny) SegmentRoutingCapability() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing-capability"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_SubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-algorithms YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-algorithms YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithms_AlgorithmPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-algorithms/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithms_AlgorithmPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithms_AlgorithmPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-algorithms/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithms_AlgorithmPathAny struct {
	*ygot.NodePath
}

// Algorithm (leaf): The Segment Routing algorithm that is
// described by the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-algorithms/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPath) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithms_AlgorithmPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithms_AlgorithmPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Algorithm (leaf): The Segment Routing algorithm that is
// described by the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-algorithms/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithmsPathAny) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithms_AlgorithmPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingAlgorithms_AlgorithmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_FlagsPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Segment Routing Capability Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Segment Routing Capability Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrgbDescriptorAny (list): Descriptor entry within the SR capabilty
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srgb-descriptors/srgb-descriptor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor"
// Range (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPath) SrgbDescriptorAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srgb-descriptors", "srgb-descriptor"},
			map[string]interface{}{"range": "*"},
			n,
		),
	}
}

// SrgbDescriptorAny (list): Descriptor entry within the SR capabilty
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srgb-descriptors/srgb-descriptor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor"
// Range (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPathAny) SrgbDescriptorAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srgb-descriptors", "srgb-descriptor"},
			map[string]interface{}{"range": "*"},
			n,
		),
	}
}

// SrgbDescriptor (list): Descriptor entry within the SR capabilty
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srgb-descriptors/srgb-descriptor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor"
// Range: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPath) SrgbDescriptor(Range uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPath{
		NodePath: ygot.NewNodePath(
			[]string{"srgb-descriptors", "srgb-descriptor"},
			map[string]interface{}{"range": Range},
			n,
		),
	}
}

// SrgbDescriptor (list): Descriptor entry within the SR capabilty
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srgb-descriptors/srgb-descriptor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor"
// Range: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapabilityPathAny) SrgbDescriptor(Range uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srgb-descriptors", "srgb-descriptor"},
			map[string]interface{}{"range": Range},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_LabelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor/state/label YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_LabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_LabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor/state/label YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_LabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_RangePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor/state/range YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_RangePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_RangePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor/state/range YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_RangePathAny struct {
	*ygot.NodePath
}

// Label (leaf): The first value of the SRGB when
// expressed as an MPLS label.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor/state/label"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPath) Label() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_LabelPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_LabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Label (leaf): The first value of the SRGB when
// expressed as an MPLS label.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/label"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor/state/label"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny) Label() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_LabelPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_LabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Range (leaf): Number of SRGB elements. The range
// value MUST be greater than 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/range"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor/state/range"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPath) Range() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_RangePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_RangePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "range"},
			map[string]interface{}{},
			n,
		),
	}
}

// Range (leaf): Number of SRGB elements. The range
// value MUST be greater than 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/range"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/subtlvs/subtlv/segment-routing-capability/srgb-descriptors/srgb-descriptor/state/range"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptorPathAny) Range() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_RangePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_Subtlv_SegmentRoutingCapability_SrgbDescriptor_RangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "range"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/router-capabilities/capability/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Capability_UndefinedSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPathAny struct {
	*ygot.NodePath
}

// PrefixAny (list): This list describes IPv4 extended prefixes and
// attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPath) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// PrefixAny (list): This list describes IPv4 extended prefixes and
// attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPathAny) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Prefix (list): This list describes IPv4 extended prefixes and
// attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPath) Prefix(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Prefix (list): This list describes IPv4 extended prefixes and
// attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4ReachabilityPathAny) Prefix(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/s-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/s-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SBitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UpDownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UpDownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UpDownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UpDownPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv4 prefix contained within extended reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv4 prefix contained within extended reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// SBit (leaf): The Sub-TLV present bit. If UNSET, the octets of Sub-TLVs
// are not present. Otherwise, the bit is set and the octet
// following the prefix will contain the length of the Sub-TLV
// portion of the structure.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/s-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/s-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath) SBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SBitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "s-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SBit (leaf): The Sub-TLV present bit. If UNSET, the octets of Sub-TLVs
// are not present. Otherwise, the bit is set and the octet
// following the prefix will contain the length of the Sub-TLV
// portion of the structure.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/s-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/s-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny) SBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SBitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "s-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPath) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UpDownPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UpDownPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_PrefixPathAny) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UpDownPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UpDownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// Flags (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SourceRouterId (container): This container defines sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath) Ipv4SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SourceRouterId (container): This container defines sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny) Ipv4SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SourceRouterId (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath) Ipv6SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SourceRouterId (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny) Ipv6SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixSidAny (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath) PrefixSidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// PrefixSidAny (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny) PrefixSidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// PrefixSid (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath) PrefixSid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// PrefixSid (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny) PrefixSid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// Tag (container): This container defines sub-TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath) Tag() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPath{
		NodePath: ygot.NewNodePath(
			[]string{"tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag (container): This container defines sub-TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny) Tag() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (container): This container defines sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64Path{
		NodePath: ygot.NewNodePath(
			[]string{"tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (container): This container defines sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_SubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_TypePathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Additional prefix reachability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Additional prefix reachability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_FlagsPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Flags_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv4 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv4 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv6 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv6 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny struct {
	*ygot.NodePath
}

// Algorithm (leaf): Prefix-SID algorithm to be used for path computation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPath) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Algorithm (leaf): Prefix-SID algorithm to be used for path computation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Prefix Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Prefix Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): IGP Prefix-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): IGP Prefix-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag_Tag32Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag_Tag32Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag_Tag32PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag_Tag32PathAny struct {
	*ygot.NodePath
}

// Tag32 (leaf): List of 32-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag32"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPath) Tag32() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag_Tag32Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag_Tag32Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag32"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag32 (leaf): List of 32-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag32"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_TagPathAny) Tag32() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag_Tag32PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag_Tag32PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag32"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64_Tag64Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64_Tag64Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64_Tag64PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64_Tag64PathAny struct {
	*ygot.NodePath
}

// Tag64 (leaf): List of 64-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64Path) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64_Tag64Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64_Tag64Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (leaf): List of 64-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64PathAny) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64_Tag64PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_Subtlv_Tag64_Tag64PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIpv4Reachability_Prefix_UndefinedSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPathAny struct {
	*ygot.NodePath
}

// NeighborAny (list): This list describes ISIS extended neighbors and
// reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor"
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPath) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": "*"},
			n,
		),
	}
}

// NeighborAny (list): This list describes ISIS extended neighbors and
// reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor"
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPathAny) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": "*"},
			n,
		),
	}
}

// Neighbor (list): This list describes ISIS extended neighbors and
// reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor"
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPath) Neighbor(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": SystemId},
			n,
		),
	}
}

// Neighbor (list): This list describes ISIS extended neighbors and
// reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor"
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachabilityPathAny) Neighbor(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": SystemId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_SystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_SystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_SystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_SystemIdPathAny struct {
	*ygot.NodePath
}

// InstanceAny (list): Instance of the TLV to the remote IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance"
// Id (wildcarded): uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPath) InstanceAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InstanceAny (list): Instance of the TLV to the remote IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance"
// Id (wildcarded): uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny) InstanceAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Instance (list): Instance of the TLV to the remote IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance"
// Id: uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPath) Instance(Id uint64) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Instance (list): Instance of the TLV to the remote IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance"
// Id: uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny) Instance(Id uint64) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// SystemId (leaf): System-id of the neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPath) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_SystemIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_SystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): System-id of the neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_NeighborPathAny) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_SystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_SystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_IdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/state/id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/state/id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_MetricPathAny struct {
	*ygot.NodePath
}

// Id (leaf): Unique identifier for the instance of the
// TLV for the IS neighbor. The instance
// ID is not required to be consistent across
// across readvertisements of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/state/id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath) Id() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_IdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Unique identifier for the instance of the
// TLV for the IS neighbor. The instance
// ID is not required to be consistent across
// across readvertisements of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/state/id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny) Id() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_IdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): Metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): Metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePath) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_InstancePathAny) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// AdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// AdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// AdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) AdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// AdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) AdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// AdminGroup (container): This container defines sub-TLV 3.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroup (container): This container defines sub-TLV 3.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (container): This container defines unidirectional lavailable
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "available-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) AvailableBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (container): This container defines unidirectional lavailable
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "available-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) AvailableBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// BandwidthConstraintAny (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) BandwidthConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": "*"},
			n,
		),
	}
}

// BandwidthConstraintAny (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) BandwidthConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": "*"},
			n,
		),
	}
}

// BandwidthConstraint (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) BandwidthConstraint(ModelId uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": ModelId},
			n,
		),
	}
}

// BandwidthConstraint (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) BandwidthConstraint(ModelId uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": ModelId},
			n,
		),
	}
}

// ExtendedAdminGroup (container): This container defines sub-TLV 14.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedAdminGroup (container): This container defines sub-TLV 14.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (container): This container defines sub-TLV 6.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (container): This container defines sub-TLV 6.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (container): This container defines sub-TLV 8.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (container): This container defines sub-TLV 8.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (container): This container defines sub-TLV 13.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (container): This container defines sub-TLV 13.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LanAdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) LanAdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// LanAdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) LanAdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// LanAdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) LanAdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// LanAdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) LanAdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// LinkAttributes (container): This container defines link-attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) LinkAttributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkAttributes (container): This container defines link-attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) LinkAttributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelay (container): This container defines unidirectional link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) LinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelay (container): This container defines unidirectional link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) LinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelayVariation (container): This container defines unidirectional link delay
// variation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay-variation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) LinkDelayVariation() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay-variation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelayVariation (container): This container defines unidirectional link delay
// variation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay-variation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) LinkDelayVariation() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay-variation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) LinkId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) LinkId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (container): This container defines unidirectional link loss delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (container): This container defines unidirectional link loss delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionType (container): ISIS LSDB parameters relating to the type of link
// protection offered.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-protection-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) LinkProtectionType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"link-protection-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionType (container): ISIS LSDB parameters relating to the type of link
// protection offered.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-protection-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) LinkProtectionType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-protection-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (container): This container defines sub-TLV 9.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) MaxLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (container): This container defines sub-TLV 9.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) MaxLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxReservableLinkBandwidth (container): This container defines sub-TLV 10.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-reservable-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) MaxReservableLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"max-reservable-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxReservableLinkBandwidth (container): This container defines sub-TLV 10.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-reservable-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) MaxReservableLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-reservable-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinMaxLinkDelay (container): This container defines min/max link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "min-max-link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) MinMaxLinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"min-max-link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinMaxLinkDelay (container): This container defines min/max link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "min-max-link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) MinMaxLinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-max-link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResidualBandwidth (container): This container defines unidirectional residual
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "residual-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) ResidualBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"residual-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResidualBandwidth (container): This container defines unidirectional residual
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "residual-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) ResidualBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"residual-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriorityAny (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) SetupPriorityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// SetupPriorityAny (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) SetupPriorityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// SetupPriority (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) SetupPriority(Priority uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// SetupPriority (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) SetupPriority(Priority uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// TeDefaultMetric (container): This container defines sub-TLV 18.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) TeDefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"te-default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// TeDefaultMetric (container): This container defines sub-TLV 18.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) TeDefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnconstrainedLsp (container): This container defines sub-TLV 23.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) UnconstrainedLsp() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPath{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnconstrainedLsp (container): This container defines sub-TLV 23.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) UnconstrainedLsp() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// UtilizedBandwidth (container): This container defines unidirectional utilized
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "utilized-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPath) UtilizedBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"utilized-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// UtilizedBandwidth (container): This container defines unidirectional utilized
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "utilized-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_SubtlvPathAny) UtilizedBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"utilized-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Flags associated with Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID for
// the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPath) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID for
// the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny struct {
	*ygot.NodePath
}

// AdminGroup (leaf): The administrative group sub-TLV contains a 4-octet
// bit mask assigned by the network administrator.  Each
// set bit corresponds to one administrative group
// assigned to the interface. By convention, the least
// significant bit is referred to as group 0, and the
// most significant bit is referred to as group 31.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPath) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroup (leaf): The administrative group sub-TLV contains a 4-octet
// bit mask assigned by the network administrator.  Each
// set bit corresponds to one administrative group
// assigned to the interface. By convention, the least
// significant bit is referred to as group 0, and the
// most significant bit is referred to as group 31.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroupPathAny) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The available bandwidth on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, available bandwidth is defined
// to be residual bandwidth minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The available bandwidth on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, available bandwidth is defined
// to be residual bandwidth minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny struct {
	*ygot.NodePath
}

// ConstraintAny (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPath) ConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": "*"},
			n,
		),
	}
}

// ConstraintAny (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) ConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": "*"},
			n,
		),
	}
}

// Constraint (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPath) Constraint(ConstraintId uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": ConstraintId},
			n,
		),
	}
}

// Constraint (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) Constraint(ConstraintId uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": ConstraintId},
			n,
		),
	}
}

// ModelId (leaf): Identifier for the Bandwidth Constraints  Model
// currently in use by the LSR initiating the IGP
// advertisement.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/model-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPath) ModelId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "model-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModelId (leaf): Identifier for the Bandwidth Constraints  Model
// currently in use by the LSR initiating the IGP
// advertisement.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/model-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) ModelId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "model-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The bandwidth constraint, expressed as a 32-bit IEEE
// floating point number expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The bandwidth constraint, expressed as a 32-bit IEEE
// floating point number expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConstraintId (leaf): Unique reference for the bandwidth constraint level. BC0
// is indicated by this leaf being set to zero, with BCN
// represented by this leaf being set to N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/constraint-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath) ConstraintId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "constraint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConstraintId (leaf): Unique reference for the bandwidth constraint level. BC0
// is indicated by this leaf being set to zero, with BCN
// represented by this leaf being set to N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/constraint-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny) ConstraintId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "constraint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny struct {
	*ygot.NodePath
}

// ExtendedAdminGroup (leaf): The extended-admin-group sub-TLV is used in addition
// to the Administrative Groups when it is desirable to
// make more than 32 colors available for advertisement
// in a network.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedAdminGroup (leaf): The extended-admin-group sub-TLV is used in addition
// to the Administrative Groups when it is desirable to
// make more than 32 colors available for advertisement
// in a network.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): A 4-octet IPv4 address for the interface described by
// the (main) TLV. This sub-TLV can occur multiple
// times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): A 4-octet IPv4 address for the interface described by
// the (main) TLV. This sub-TLV can occur multiple
// times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): A single IPv4 address for a neighboring router on
// this link. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): A single IPv4 address for a neighboring router on
// this link. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Contains a 16-octet IPv6 address for the interface
// described by the containing  Extended IS Reachability
// TLV. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Contains a 16-octet IPv6 address for the interface
// described by the containing  Extended IS Reachability
// TLV. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Contains a 16-octet IPv6 address for a neighboring
// router on the link described by the (main) TLV. This
// sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Contains a 16-octet IPv6 address for a neighboring
// router on the link described by the (main) TLV. This
// sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Flags associated with LAN-Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with LAN-Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborId (leaf): System ID of the neighbor associated with the LAN-
// Adj-Segment-ID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPath) NeighborId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborId (leaf): System ID of the neighbor associated with the LAN-
// Adj-Segment-ID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) NeighborId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): LAN Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): LAN Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID
// for the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID
// for the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny struct {
	*ygot.NodePath
}

// LocalProtection (leaf): Link local-protection attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-protection"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPath) LocalProtection() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalProtection (leaf): Link local-protection attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-protection"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributesPathAny) LocalProtection() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_DelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_DelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay value (in microseconds) between
// two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPath) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_DelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_DelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay value (in microseconds) between
// two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayPathAny) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny struct {
	*ygot.NodePath
}

// Delay (leaf): Average link delay between two directly connected IS-
// IS neighbors over a configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPath) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay between two directly connected IS-
// IS neighbors over a configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_LocalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_LocalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_LocalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_LocalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_RemotePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_RemotePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_RemotePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_RemotePathAny struct {
	*ygot.NodePath
}

// Local (leaf): The value field of this sub-TLV contains 4 octets of
// Link Local Identifier followed by 4 octets of Link
// Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPath) Local() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_LocalPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_LocalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Local (leaf): The value field of this sub-TLV contains 4 octets of
// Link Local Identifier followed by 4 octets of Link
// Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPathAny) Local() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_LocalPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_LocalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (leaf): If the Link Remote Identifier is unknown, it is set
// to 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPath) Remote() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_RemotePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_RemotePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (leaf): If the Link Remote Identifier is unknown, it is set
// to 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkIdPathAny) Remote() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_RemotePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkId_RemotePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (leaf): Link packet loss as a percentage of the total traffic
// sent over a configurable interval. The basic unit is
// 0.000003%, where (2^24 - 2) is 50.331642%. This value
// is the highest packet-loss percentage that can be
// expressed (the assumption being that precision is more
// important on high-speed links than the ability to
// advertise loss rates greater than this, and that high-
// speed links with over 50% loss are unusable).
// Therefore, measured values that are larger than the
// field maximum SHOULD be encoded as the maximum
// value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPath) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (leaf): Link packet loss as a percentage of the total traffic
// sent over a configurable interval. The basic unit is
// 0.000003%, where (2^24 - 2) is 50.331642%. This value
// is the highest packet-loss percentage that can be
// expressed (the assumption being that precision is more
// important on high-speed links than the ability to
// advertise loss rates greater than this, and that high-
// speed links with over 50% loss are unusable).
// Therefore, measured values that are larger than the
// field maximum SHOULD be encoded as the maximum
// value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLossPathAny) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny struct {
	*ygot.NodePath
}

// Type (leaf): Link protection capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Link protection capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The maximum bandwidth that can be used on this link
// in this direction (from the system originating the LSP
// to its neighbors).  It is encoded in 32 bits in IEEE
// floating point format.  The units are bytes (not
// bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The maximum bandwidth that can be used on this link
// in this direction (from the system originating the LSP
// to its neighbors).  It is encoded in 32 bits in IEEE
// floating point format.  The units are bytes (not
// bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The maximum amount of bandwidth that can be reserved
// in this direction on this link.  Note that for
// oversubscription purposes,  this can be greater than
// the bandwidth of the link. It is encoded  in 32 bits
// in IEEE floating point format.  The units are bytes
// (not bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The maximum amount of bandwidth that can be reserved
// in this direction on this link.  Note that for
// oversubscription purposes,  this can be greater than
// the bandwidth of the link. It is encoded  in 32 bits
// in IEEE floating point format.  The units are bytes
// (not bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxDelay (leaf): Maximum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) MaxDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxDelay (leaf): Maximum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) MaxDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinDelay (leaf): Minimum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/min-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) MinDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "min-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinDelay (leaf): Minimum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/min-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) MinDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "min-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): Residual bandwidth on a link,forwarding adjacency
// [RFC4206], or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, residual bandwidth is defined to
// be the Maximum Bandwidth [RFC5305] minus the bandwidth
// currently allocated to RSVP-TE label switched paths.
// For a bundled link, residual bandwidth is defined to
// be the sum of the component link residual
// bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): Residual bandwidth on a link,forwarding adjacency
// [RFC4206], or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, residual bandwidth is defined to
// be the Maximum Bandwidth [RFC5305] minus the bandwidth
// currently allocated to RSVP-TE label switched paths.
// For a bundled link, residual bandwidth is defined to
// be the sum of the component link residual
// bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The amount of bandwidth reservable in this
// direction on this link. Note that for
// oversubscription purposes, this can be greater than
// the bandwidth of the link. It contains eight 32-bit
// IEEE floating point numbers(one for each priority).
// The units are bytes (not bits!) per second. The
// values correspond to the bandwidth that can be
// reserved with a setup priority of 0 through 7,
// arranged in increasing order with priority 0
// occurring at the start of the sub-TLV, and priority
// 7 at the end of the sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The amount of bandwidth reservable in this
// direction on this link. Note that for
// oversubscription purposes, this can be greater than
// the bandwidth of the link. It contains eight 32-bit
// IEEE floating point numbers(one for each priority).
// The units are bytes (not bits!) per second. The
// values correspond to the bandwidth that can be
// reserved with a setup priority of 0 through 7,
// arranged in increasing order with priority 0
// occurring at the start of the sub-TLV, and priority
// 7 at the end of the sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Setup priority level of 0 through 7 to be used by
// Unreserved Bandwidth sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPath) Priority() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Setup priority level of 0 through 7 to be used by
// Unreserved Bandwidth sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriorityPathAny) Priority() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): This metric is administratively assigned and can be
// used to present a differently weighted topology to
// traffic engineering SPF calculations. To preclude
// overflow within a traffic engineering SPF
// implementation, all metrics greater than or equal to
// MAX_PATH_METRIC SHALL be considered to have a metric
// of MAX_PATH_METRIC.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): This metric is administratively assigned and can be
// used to present a differently weighted topology to
// traffic engineering SPF calculations. To preclude
// overflow within a traffic engineering SPF
// implementation, all metrics greater than or equal to
// MAX_PATH_METRIC SHALL be considered to have a metric
// of MAX_PATH_METRIC.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny struct {
	*ygot.NodePath
}

// Count (leaf): Unconstrained TE LSP count(TE Label Switched Paths
// (LSPs) signalled with zero bandwidth).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPath) Count() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "count"},
			map[string]interface{}{},
			n,
		),
	}
}

// Count (leaf): Unconstrained TE LSP count(TE Label Switched Paths
// (LSPs) signalled with zero bandwidth).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny) Count() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "count"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The bandwidth utilization on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second.  For a link or
// forwarding adjacency, bandwidth utilization represents
// the actual utilization of the link (i.e., as measured
// by the advertising node).  For a bundled link,
// bandwidth utilization is defined to be the sum of the
// component link bandwidth utilizations.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The bandwidth utilization on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second.  For a link or
// forwarding adjacency, bandwidth utilization represents
// the actual utilization of the link (i.e., as measured
// by the advertising node).  For a bundled link,
// bandwidth utilization is defined to be the sum of the
// component link bandwidth utilizations.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/extended-is-reachability/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_ExtendedIsReachability_Neighbor_Instance_UndefinedSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/hostname YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/hostname YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Hostname_HostnamePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/hostname/state/hostname YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Hostname_HostnamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Hostname_HostnamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/hostname/state/hostname YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Hostname_HostnamePathAny struct {
	*ygot.NodePath
}

// Hostname (leaf): Name of the node.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/hostname"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/hostname/state/hostname"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePath) Hostname() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Hostname_HostnamePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Hostname_HostnamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hostname"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hostname (leaf): Name of the node.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/hostname"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/hostname/state/hostname"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_HostnamePathAny) Hostname() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Hostname_HostnamePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Hostname_HostnamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hostname"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_InstanceIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id/state/instance-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_InstanceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_InstanceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id/state/instance-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_InstanceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_TopologyIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id/state/topology-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_TopologyIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_TopologyIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id/state/topology-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_TopologyIdPathAny struct {
	*ygot.NodePath
}

// InstanceId (leaf): An Instance Identifier (IID) to uniquely identify
// an IS-IS instance. When the IID = 0, the list of
// supported ITIDs MUST NOT be present. An IID-TLV with
// IID = 0 MUST NOT appear in an SNP or LSP. When the
// TLV appears (with a non-zero IID) in an SNP or LSP,
// exactly one ITID. MUST be present indicating the
// topology with which the PDU is associated. If no
// ITIDs or multiple ITIDs are present or the IID is
// zero, then the PDU MUST be ignored.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id/state/instance-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPath) InstanceId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_InstanceIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_InstanceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstanceId (leaf): An Instance Identifier (IID) to uniquely identify
// an IS-IS instance. When the IID = 0, the list of
// supported ITIDs MUST NOT be present. An IID-TLV with
// IID = 0 MUST NOT appear in an SNP or LSP. When the
// TLV appears (with a non-zero IID) in an SNP or LSP,
// exactly one ITID. MUST be present indicating the
// topology with which the PDU is associated. If no
// ITIDs or multiple ITIDs are present or the IID is
// zero, then the PDU MUST be ignored.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id/state/instance-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny) InstanceId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_InstanceIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_InstanceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// TopologyId (leaf): Instance-Specific Topology Identifiers (ITIDs).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/topology-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id/state/topology-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPath) TopologyId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_TopologyIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_TopologyIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// TopologyId (leaf): Instance-Specific Topology Identifiers (ITIDs).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/topology-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/instance-ids/instance-id/state/topology-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceIdPathAny) TopologyId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_TopologyIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_InstanceId_TopologyIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPathAny struct {
	*ygot.NodePath
}

// PrefixAny (list): IPv4 external prefixes and reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPath) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// PrefixAny (list): IPv4 external prefixes and reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPathAny) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Prefix (list): IPv4 external prefixes and reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPath) Prefix(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Prefix (list): IPv4 external prefixes and reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachabilityPathAny) Prefix(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_UpDownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_UpDownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_UpDownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_UpDownPathAny struct {
	*ygot.NodePath
}

// DefaultMetric (container): This container defines ISIS Default Metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath) DefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultMetric (container): This container defines ISIS Default Metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny) DefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DelayMetric (container): This container defines the ISIS delay metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "delay-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath) DelayMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"delay-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DelayMetric (container): This container defines the ISIS delay metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "delay-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny) DelayMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"delay-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorMetric (container): This container defines the ISIS error metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath) ErrorMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"error-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorMetric (container): This container defines the ISIS error metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny) ErrorMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"error-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExpenseMetric (container): This container defines the ISIS expense metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "expense-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath) ExpenseMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"expense-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExpenseMetric (container): This container defines the ISIS expense metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "expense-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny) ExpenseMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"expense-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv4 prefix contained within reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv4 prefix contained within reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPath) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_UpDownPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_UpDownPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_PrefixPathAny) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_UpDownPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_UpDownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): ISIS Default-Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): ISIS Default-Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS default metric value. This is a metric understood by
// every Intermediate system in the domain. Each circuit
// shall have a positive  integral value assigned for this
// metric. The value may be associated with any  objective
// function of the circuit, but by convention is intended to
// measure the capacity of the circuit for handling traffic,
// for example, its throughput in  bits-per-second. Higher
// values indicate a lower capacity.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS default metric value. This is a metric understood by
// every Intermediate system in the domain. Each circuit
// shall have a positive  integral value assigned for this
// metric. The value may be associated with any  objective
// function of the circuit, but by convention is intended to
// measure the capacity of the circuit for handling traffic,
// for example, its throughput in  bits-per-second. Higher
// values indicate a lower capacity.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DefaultMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): ISIS Delay Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): ISIS Delay Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS delay metric value. This metric measures the transit
// delay of the associated circuit. It is an optional metric,
// which if assigned to a circuit shall have a positive
// integral value. Higher values indicate a longer transit
// delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS delay metric value. This metric measures the transit
// delay of the associated circuit. It is an optional metric,
// which if assigned to a circuit shall have a positive
// integral value. Higher values indicate a longer transit
// delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/delay-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_DelayMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): IS-IS error metric flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): IS-IS error metric flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS error metric value. This metric measures the
// residual error probability of the associated circuit. It
// is an optional metric, which if assigned to a circuit
// shall have a non-zero value. Higher values indicate a
// larger probability of undetected errors on the circuit.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS error metric value. This metric measures the
// residual error probability of the associated circuit. It
// is an optional metric, which if assigned to a circuit
// shall have a non-zero value. Higher values indicate a
// larger probability of undetected errors on the circuit.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/error-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ErrorMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): ISIS Expense Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): ISIS Expense Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS expense metric value. This metric measures the
// monetary cost of utilising the associated circuit. It is
// an optional metric, which if assigned to a circuit shall
// have a positive integral value1). Higher values indicate a
// larger monetary expense.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS expense metric value. This metric measures the
// monetary cost of utilising the associated circuit. It is
// an optional metric, which if assigned to a circuit shall
// have a positive integral value1). Higher values indicate a
// larger monetary expense.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-external-reachability/prefixes/prefix/expense-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4ExternalReachability_Prefix_ExpenseMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-interface-addresses YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-interface-addresses YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddresses_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-interface-addresses/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddresses_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddresses_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-interface-addresses/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddresses_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): IPv4 address(es) of the interface corresponding to
// the SNPA over which this PDU is to be transmitted.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-interface-addresses/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddresses_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddresses_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): IPv4 address(es) of the interface corresponding to
// the SNPA over which this PDU is to be transmitted.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-interface-addresses/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddressesPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddresses_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InterfaceAddresses_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPathAny struct {
	*ygot.NodePath
}

// PrefixAny (list): IPv4 prefixes and internal reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPath) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// PrefixAny (list): IPv4 prefixes and internal reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPathAny) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Prefix (list): IPv4 prefixes and internal reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPath) Prefix(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Prefix (list): IPv4 prefixes and internal reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachabilityPathAny) Prefix(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_UpDownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_UpDownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_UpDownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_UpDownPathAny struct {
	*ygot.NodePath
}

// DefaultMetric (container): This container defines ISIS Default Metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath) DefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultMetric (container): This container defines ISIS Default Metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny) DefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DelayMetric (container): This container defines the ISIS delay metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "delay-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath) DelayMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"delay-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DelayMetric (container): This container defines the ISIS delay metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "delay-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny) DelayMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"delay-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorMetric (container): This container defines the ISIS error metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath) ErrorMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"error-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorMetric (container): This container defines the ISIS error metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny) ErrorMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"error-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExpenseMetric (container): This container defines the ISIS expense metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "expense-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath) ExpenseMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"expense-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExpenseMetric (container): This container defines the ISIS expense metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "expense-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny) ExpenseMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"expense-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv4 prefix contained within reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv4 prefix contained within reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPath) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_UpDownPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_UpDownPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_PrefixPathAny) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_UpDownPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_UpDownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): ISIS Default-Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): ISIS Default-Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS default metric value. This is a metric understood by
// every Intermediate system in the domain. Each circuit
// shall have a positive  integral value assigned for this
// metric. The value may be associated with any  objective
// function of the circuit, but by convention is intended to
// measure the capacity of the circuit for handling traffic,
// for example, its throughput in  bits-per-second. Higher
// values indicate a lower capacity.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS default metric value. This is a metric understood by
// every Intermediate system in the domain. Each circuit
// shall have a positive  integral value assigned for this
// metric. The value may be associated with any  objective
// function of the circuit, but by convention is intended to
// measure the capacity of the circuit for handling traffic,
// for example, its throughput in  bits-per-second. Higher
// values indicate a lower capacity.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DefaultMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): ISIS Delay Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): ISIS Delay Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS delay metric value. This metric measures the transit
// delay of the associated circuit. It is an optional metric,
// which if assigned to a circuit shall have a positive
// integral value. Higher values indicate a longer transit
// delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS delay metric value. This metric measures the transit
// delay of the associated circuit. It is an optional metric,
// which if assigned to a circuit shall have a positive
// integral value. Higher values indicate a longer transit
// delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/delay-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_DelayMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): IS-IS error metric flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): IS-IS error metric flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS error metric value. This metric measures the
// residual error probability of the associated circuit. It
// is an optional metric, which if assigned to a circuit
// shall have a non-zero value. Higher values indicate a
// larger probability of undetected errors on the circuit.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS error metric value. This metric measures the
// residual error probability of the associated circuit. It
// is an optional metric, which if assigned to a circuit
// shall have a non-zero value. Higher values indicate a
// larger probability of undetected errors on the circuit.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/error-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ErrorMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): ISIS Expense Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): ISIS Expense Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS expense metric value. This metric measures the
// monetary cost of utilising the associated circuit. It is
// an optional metric, which if assigned to a circuit shall
// have a positive integral value1). Higher values indicate a
// larger monetary expense.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS expense metric value. This metric measures the
// monetary cost of utilising the associated circuit. It is
// an optional metric, which if assigned to a circuit shall
// have a positive integral value1). Higher values indicate a
// larger monetary expense.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-internal-reachability/prefixes/prefix/expense-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4InternalReachability_Prefix_ExpenseMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_InstanceNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/instance-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_InstanceNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_InstanceNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/instance-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_InstanceNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_PsnNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/psn-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_PsnNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_PsnNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/psn-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_PsnNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SrlgValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/srlg-value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SrlgValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SrlgValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/srlg-value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SrlgValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SystemIdPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): SRLG flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): SRLG flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstanceNumber (leaf): An arbitrary unsigned 32-bit integer used to
// disambiguate the instance of TLV 138. The instance
// identifier is synthesised by the system
// and may be renumbered for the same SRLG definition
// in subsequent advertised LSPs if (and only if) the
// entire list of SRLGs is replaced.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/instance-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath) InstanceNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_InstanceNumberPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_InstanceNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstanceNumber (leaf): An arbitrary unsigned 32-bit integer used to
// disambiguate the instance of TLV 138. The instance
// identifier is synthesised by the system
// and may be renumbered for the same SRLG definition
// in subsequent advertised LSPs if (and only if) the
// entire list of SRLGs is replaced.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/instance-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny) InstanceNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_InstanceNumberPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_InstanceNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (leaf): IPv4 interface address.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (leaf): IPv4 interface address.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (leaf): IPv4 neighbor address.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (leaf): IPv4 neighbor address.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_Ipv4NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// PsnNumber (leaf): Pseudonode number if the neighbor is on a LAN
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/psn-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/psn-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath) PsnNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_PsnNumberPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_PsnNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "psn-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// PsnNumber (leaf): Pseudonode number if the neighbor is on a LAN
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/psn-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/psn-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny) PsnNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_PsnNumberPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_PsnNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "psn-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrlgValue (leaf): List of SRLG values.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/srlg-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/srlg-value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath) SrlgValue() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SrlgValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SrlgValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "srlg-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrlgValue (leaf): List of SRLG values.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/srlg-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/srlg-value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny) SrlgValue() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SrlgValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SrlgValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "srlg-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): Neighbor system ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPath) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SystemIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): Neighbor system ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-srlgs/ipv4-srlg/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4SrlgPathAny) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4Srlg_SystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-te-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-te-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-te-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-te-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv4 Traffic Engineering router ID of the node. For
// traffic engineering, it guarantees that we have a
// single stable address that can always be referenced in
// a path that will be reachable from multiple hops away,
// regardless of the state of the node's interfaces.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-te-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv4 Traffic Engineering router ID of the node. For
// traffic engineering, it guarantees that we have a
// single stable address that can always be referenced in
// a path that will be reachable from multiple hops away,
// regardless of the state of the node's interfaces.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv4-te-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv4TeRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-interface-addresses YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-interface-addresses YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddresses_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-interface-addresses/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddresses_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddresses_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-interface-addresses/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddresses_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): IPv6 interface addresses of the node.  MUST contain
// only the non-link-local IPv6 addresses assigned to the
// IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-interface-addresses/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddresses_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddresses_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): IPv6 interface addresses of the node.  MUST contain
// only the non-link-local IPv6 addresses assigned to the
// IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-interface-addresses/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddressesPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddresses_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6InterfaceAddresses_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPathAny struct {
	*ygot.NodePath
}

// PrefixAny (list): This list defines IPv6 extended prefix attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPath) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// PrefixAny (list): This list defines IPv6 extended prefix attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix"
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPathAny) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*"},
			n,
		),
	}
}

// Prefix (list): This list defines IPv6 extended prefix attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPath) Prefix(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// Prefix (list): This list defines IPv6 extended prefix attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix"
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6ReachabilityPathAny) Prefix(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/s-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/s-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SBitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UpDownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UpDownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UpDownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UpDownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_XBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/x-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_XBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_XBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/x-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_XBitPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv6 prefix contained within extended reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv6 prefix contained within extended reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// SBit (leaf): The sub-tlv present bit. If UNSET, the octets of Sub-TLVs
// are not present. Otherwise, the bit is set and the octet
// following the prefix will contain the length of the Sub-TLV
// portion of the structure.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/s-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/s-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath) SBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SBitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "s-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SBit (leaf): The sub-tlv present bit. If UNSET, the octets of Sub-TLVs
// are not present. Otherwise, the bit is set and the octet
// following the prefix will contain the length of the Sub-TLV
// portion of the structure.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/s-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/s-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny) SBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SBitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "s-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UpDownPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UpDownPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UpDownPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UpDownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// XBit (leaf): The external bit. Set when the prefix was distributed into
// IS-IS from another routing protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/x-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/x-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPath) XBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_XBitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_XBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "x-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// XBit (leaf): The external bit. Set when the prefix was distributed into
// IS-IS from another routing protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/x-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/state/x-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_PrefixPathAny) XBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_XBitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_XBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "x-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// Flags (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SourceRouterId (container): This container defines sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath) Ipv4SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SourceRouterId (container): This container defines sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny) Ipv4SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SourceRouterId (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath) Ipv6SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SourceRouterId (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny) Ipv6SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixSidAny (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath) PrefixSidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// PrefixSidAny (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny) PrefixSidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// PrefixSid (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath) PrefixSid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// PrefixSid (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny) PrefixSid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// Tag (container): This container defines sub-TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath) Tag() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPath{
		NodePath: ygot.NewNodePath(
			[]string{"tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag (container): This container defines sub-TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny) Tag() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (container): This container defines sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64Path{
		NodePath: ygot.NewNodePath(
			[]string{"tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (container): This container defines sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_SubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_TypePathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Additional prefix reachability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Additional prefix reachability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_FlagsPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Flags_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv4 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv4 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv6 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv6 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny struct {
	*ygot.NodePath
}

// Algorithm (leaf): Prefix-SID algorithm to be used for path computation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPath) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Algorithm (leaf): Prefix-SID algorithm to be used for path computation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Prefix Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Prefix Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): IGP Prefix-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): IGP Prefix-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag_Tag32Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag_Tag32Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag_Tag32PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag_Tag32PathAny struct {
	*ygot.NodePath
}

// Tag32 (leaf): List of 32-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag32"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPath) Tag32() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag_Tag32Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag_Tag32Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag32"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag32 (leaf): List of 32-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag32"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_TagPathAny) Tag32() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag_Tag32PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag_Tag32PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag32"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64_Tag64Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64_Tag64Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64_Tag64PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64_Tag64PathAny struct {
	*ygot.NodePath
}

// Tag64 (leaf): List of 64-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64Path) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64_Tag64Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64_Tag64Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (leaf): List of 64-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64PathAny) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64_Tag64PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_Subtlv_Tag64_Tag64PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Reachability_Prefix_UndefinedSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_InstanceNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/instance-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_InstanceNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_InstanceNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/instance-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_InstanceNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_PsnNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/psn-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_PsnNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_PsnNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/psn-number YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_PsnNumberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SrlgValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/srlg-value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SrlgValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SrlgValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/srlg-value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SrlgValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SystemIdPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): IPv6 SRLG flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): IPv6 SRLG flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstanceNumber (leaf): An arbitrary unsigned 32-bit integer used to
// disambiguate the instance of TLV 138. The instance
// identifier is synthesised by the system
// and may be renumbered for the same SRLG definition
// in subsequent advertised LSPs if (and only if) the
// entire list of SRLGs is replaced.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/instance-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath) InstanceNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_InstanceNumberPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_InstanceNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstanceNumber (leaf): An arbitrary unsigned 32-bit integer used to
// disambiguate the instance of TLV 138. The instance
// identifier is synthesised by the system
// and may be renumbered for the same SRLG definition
// in subsequent advertised LSPs if (and only if) the
// entire list of SRLGs is replaced.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/instance-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/instance-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny) InstanceNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_InstanceNumberPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_InstanceNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "instance-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (leaf): IPv6 interface address or Link Local Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (leaf): IPv6 interface address or Link Local Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (leaf): IPv6 neighbor address or Link Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (leaf): IPv6 neighbor address or Link Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_Ipv6NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// PsnNumber (leaf): Pseudonode number if the neighbor is on a LAN
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/psn-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/psn-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath) PsnNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_PsnNumberPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_PsnNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "psn-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// PsnNumber (leaf): Pseudonode number if the neighbor is on a LAN
// interface.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/psn-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/psn-number"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny) PsnNumber() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_PsnNumberPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_PsnNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "psn-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrlgValue (leaf): SRLG values.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/srlg-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/srlg-value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath) SrlgValue() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SrlgValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SrlgValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "srlg-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrlgValue (leaf): SRLG values.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/srlg-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/srlg-value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny) SrlgValue() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SrlgValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SrlgValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "srlg-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): Neighbor system ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPath) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SystemIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): Neighbor system ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-srlgs/ipv6-srlg/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6SrlgPathAny) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6Srlg_SystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-te-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-te-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-te-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-te-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv6 Traffic Engineering router ID of the node. For
// traffic engineering, it guarantees that we have a
// single stable address that can always be referenced in
// a path that will be reachable from multiple hops away,
// regardless of the state of the node's interfaces.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-te-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv6 Traffic Engineering router ID of the node. For
// traffic engineering, it guarantees that we have a
// single stable address that can always be referenced in
// a path that will be reachable from multiple hops away,
// regardless of the state of the node's interfaces.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/ipv6-te-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Ipv6TeRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-alias-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-alias-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasId_AliasIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-alias-id/state/alias-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasId_AliasIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasId_AliasIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-alias-id/state/alias-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasId_AliasIdPathAny struct {
	*ygot.NodePath
}

// AliasId (leaf): List of alias ID(s).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/alias-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-alias-id/state/alias-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPath) AliasId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasId_AliasIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasId_AliasIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "alias-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// AliasId (leaf): List of alias ID(s).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/alias-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-alias-id/state/alias-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasIdPathAny) AliasId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasId_AliasIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsAliasId_AliasIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "alias-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPathAny struct {
	*ygot.NodePath
}

// NeighborAny (list): IS reachability neighbor attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor"
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPath) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": "*"},
			n,
		),
	}
}

// NeighborAny (list): IS reachability neighbor attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor"
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPathAny) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": "*"},
			n,
		),
	}
}

// Neighbor (list): IS reachability neighbor attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor"
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPath) Neighbor(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": SystemId},
			n,
		),
	}
}

// Neighbor (list): IS reachability neighbor attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor"
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachabilityPathAny) Neighbor(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": SystemId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_SystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_SystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_SystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_SystemIdPathAny struct {
	*ygot.NodePath
}

// DefaultMetric (container): This container defines ISIS Default Metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPath) DefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultMetric (container): This container defines ISIS Default Metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny) DefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DelayMetric (container): This container defines the ISIS delay metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "delay-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPath) DelayMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"delay-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// DelayMetric (container): This container defines the ISIS delay metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "delay-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny) DelayMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"delay-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorMetric (container): This container defines the ISIS error metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPath) ErrorMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"error-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorMetric (container): This container defines the ISIS error metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "error-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny) ErrorMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"error-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExpenseMetric (container): This container defines the ISIS expense metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "expense-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPath) ExpenseMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"expense-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExpenseMetric (container): This container defines the ISIS expense metric.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "expense-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny) ExpenseMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"expense-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): System-ID of IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPath) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_SystemIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_SystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): System-ID of IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_NeighborPathAny) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_SystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_SystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): ISIS Default-Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): ISIS Default-Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS default metric value. This is a metric understood by
// every Intermediate system in the domain. Each circuit
// shall have a positive  integral value assigned for this
// metric. The value may be associated with any  objective
// function of the circuit, but by convention is intended to
// measure the capacity of the circuit for handling traffic,
// for example, its throughput in  bits-per-second. Higher
// values indicate a lower capacity.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS default metric value. This is a metric understood by
// every Intermediate system in the domain. Each circuit
// shall have a positive  integral value assigned for this
// metric. The value may be associated with any  objective
// function of the circuit, but by convention is intended to
// measure the capacity of the circuit for handling traffic,
// for example, its throughput in  bits-per-second. Higher
// values indicate a lower capacity.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DefaultMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): ISIS Delay Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): ISIS Delay Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS delay metric value. This metric measures the transit
// delay of the associated circuit. It is an optional metric,
// which if assigned to a circuit shall have a positive
// integral value. Higher values indicate a longer transit
// delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS delay metric value. This metric measures the transit
// delay of the associated circuit. It is an optional metric,
// which if assigned to a circuit shall have a positive
// integral value. Higher values indicate a longer transit
// delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/delay-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_DelayMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): IS-IS error metric flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): IS-IS error metric flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS error metric value. This metric measures the
// residual error probability of the associated circuit. It
// is an optional metric, which if assigned to a circuit
// shall have a non-zero value. Higher values indicate a
// larger probability of undetected errors on the circuit.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS error metric value. This metric measures the
// residual error probability of the associated circuit. It
// is an optional metric, which if assigned to a circuit
// shall have a non-zero value. Higher values indicate a
// larger probability of undetected errors on the circuit.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/error-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ErrorMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): ISIS Expense Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): ISIS Expense Metric Flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS expense metric value. This metric measures the
// monetary cost of utilising the associated circuit. It is
// an optional metric, which if assigned to a circuit shall
// have a positive integral value1). Higher values indicate a
// larger monetary expense.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS expense metric value. This metric measures the
// monetary cost of utilising the associated circuit. It is
// an optional metric, which if assigned to a circuit shall
// have a positive integral value1). Higher values indicate a
// larger monetary expense.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/is-reachability/neighbors/neighbor/expense-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsReachability_Neighbor_ExpenseMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePathAny struct {
	*ygot.NodePath
}

// NeighborAny (list): This list describes ISIS extended neighbors and
// reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor"
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePath) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": "*"},
			n,
		),
	}
}

// NeighborAny (list): This list describes ISIS extended neighbors and
// reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor"
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePathAny) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": "*"},
			n,
		),
	}
}

// Neighbor (list): This list describes ISIS extended neighbors and
// reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor"
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePath) Neighbor(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": SystemId},
			n,
		),
	}
}

// Neighbor (list): This list describes ISIS extended neighbors and
// reachability attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor"
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttributePathAny) Neighbor(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"system-id": SystemId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_SystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_SystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_SystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_SystemIdPathAny struct {
	*ygot.NodePath
}

// InstanceAny (list): Instance of the TLV to the remote IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance"
// Id (wildcarded): uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPath) InstanceAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InstanceAny (list): Instance of the TLV to the remote IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance"
// Id (wildcarded): uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny) InstanceAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Instance (list): Instance of the TLV to the remote IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance"
// Id: uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPath) Instance(Id uint64) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Instance (list): Instance of the TLV to the remote IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance"
// Id: uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny) Instance(Id uint64) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// SystemId (leaf): System-id of the neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPath) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_SystemIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_SystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): System-id of the neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_NeighborPathAny) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_SystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_SystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_IdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_MetricPathAny struct {
	*ygot.NodePath
}

// Id (leaf): Unique identifier for the instance of the
// TLV for the IS neighbor. The instance
// ID is not required to be consistent across
// across readvertisements of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath) Id() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_IdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Unique identifier for the instance of the
// TLV for the IS neighbor. The instance
// ID is not required to be consistent across
// across readvertisements of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny) Id() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_IdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): Metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): Metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePath) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_InstancePathAny) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// AdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// AdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// AdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) AdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// AdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) AdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// AdminGroup (container): This container defines sub-TLV 3.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroup (container): This container defines sub-TLV 3.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (container): This container defines unidirectional lavailable
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "available-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) AvailableBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (container): This container defines unidirectional lavailable
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "available-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) AvailableBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// BandwidthConstraintAny (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) BandwidthConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": "*"},
			n,
		),
	}
}

// BandwidthConstraintAny (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) BandwidthConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": "*"},
			n,
		),
	}
}

// BandwidthConstraint (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) BandwidthConstraint(ModelId uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": ModelId},
			n,
		),
	}
}

// BandwidthConstraint (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) BandwidthConstraint(ModelId uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": ModelId},
			n,
		),
	}
}

// ExtendedAdminGroup (container): This container defines sub-TLV 14.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedAdminGroup (container): This container defines sub-TLV 14.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (container): This container defines sub-TLV 6.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (container): This container defines sub-TLV 6.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (container): This container defines sub-TLV 8.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (container): This container defines sub-TLV 8.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (container): This container defines sub-TLV 13.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (container): This container defines sub-TLV 13.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LanAdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LanAdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// LanAdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LanAdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// LanAdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LanAdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// LanAdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LanAdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// LinkAttributes (container): This container defines link-attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkAttributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkAttributes (container): This container defines link-attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkAttributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelay (container): This container defines unidirectional link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelay (container): This container defines unidirectional link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelayVariation (container): This container defines unidirectional link delay
// variation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay-variation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkDelayVariation() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay-variation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelayVariation (container): This container defines unidirectional link delay
// variation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay-variation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkDelayVariation() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay-variation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (container): This container defines unidirectional link loss delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (container): This container defines unidirectional link loss delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionType (container): ISIS LSDB parameters relating to the type of link
// protection offered.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-protection-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkProtectionType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"link-protection-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionType (container): ISIS LSDB parameters relating to the type of link
// protection offered.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-protection-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkProtectionType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-protection-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (container): This container defines sub-TLV 9.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) MaxLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (container): This container defines sub-TLV 9.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) MaxLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxReservableLinkBandwidth (container): This container defines sub-TLV 10.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-reservable-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) MaxReservableLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"max-reservable-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxReservableLinkBandwidth (container): This container defines sub-TLV 10.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-reservable-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) MaxReservableLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-reservable-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinMaxLinkDelay (container): This container defines min/max link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "min-max-link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) MinMaxLinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"min-max-link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinMaxLinkDelay (container): This container defines min/max link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "min-max-link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) MinMaxLinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-max-link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResidualBandwidth (container): This container defines unidirectional residual
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "residual-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) ResidualBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"residual-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResidualBandwidth (container): This container defines unidirectional residual
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "residual-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) ResidualBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"residual-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriorityAny (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) SetupPriorityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// SetupPriorityAny (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) SetupPriorityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// SetupPriority (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) SetupPriority(Priority uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// SetupPriority (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) SetupPriority(Priority uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// TeDefaultMetric (container): This container defines sub-TLV 18.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) TeDefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"te-default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// TeDefaultMetric (container): This container defines sub-TLV 18.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) TeDefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnconstrainedLsp (container): This container defines sub-TLV 23.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) UnconstrainedLsp() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnconstrainedLsp (container): This container defines sub-TLV 23.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) UnconstrainedLsp() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// UtilizedBandwidth (container): This container defines unidirectional utilized
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "utilized-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPath) UtilizedBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"utilized-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// UtilizedBandwidth (container): This container defines unidirectional utilized
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "utilized-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) UtilizedBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"utilized-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Flags associated with Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID for
// the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID for
// the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny struct {
	*ygot.NodePath
}

// AdminGroup (leaf): The administrative group sub-TLV contains a 4-octet
// bit mask assigned by the network administrator.  Each
// set bit corresponds to one administrative group
// assigned to the interface. By convention, the least
// significant bit is referred to as group 0, and the
// most significant bit is referred to as group 31.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroup (leaf): The administrative group sub-TLV contains a 4-octet
// bit mask assigned by the network administrator.  Each
// set bit corresponds to one administrative group
// assigned to the interface. By convention, the least
// significant bit is referred to as group 0, and the
// most significant bit is referred to as group 31.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The available bandwidth on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, available bandwidth is defined
// to be residual bandwidth minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The available bandwidth on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, available bandwidth is defined
// to be residual bandwidth minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny struct {
	*ygot.NodePath
}

// ConstraintAny (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath) ConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": "*"},
			n,
		),
	}
}

// ConstraintAny (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) ConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": "*"},
			n,
		),
	}
}

// Constraint (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath) Constraint(ConstraintId uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": ConstraintId},
			n,
		),
	}
}

// Constraint (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) Constraint(ConstraintId uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": ConstraintId},
			n,
		),
	}
}

// ModelId (leaf): Identifier for the Bandwidth Constraints  Model
// currently in use by the LSR initiating the IGP
// advertisement.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/model-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath) ModelId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "model-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModelId (leaf): Identifier for the Bandwidth Constraints  Model
// currently in use by the LSR initiating the IGP
// advertisement.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/model-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) ModelId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "model-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The bandwidth constraint, expressed as a 32-bit IEEE
// floating point number expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The bandwidth constraint, expressed as a 32-bit IEEE
// floating point number expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConstraintId (leaf): Unique reference for the bandwidth constraint level. BC0
// is indicated by this leaf being set to zero, with BCN
// represented by this leaf being set to N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/constraint-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath) ConstraintId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "constraint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConstraintId (leaf): Unique reference for the bandwidth constraint level. BC0
// is indicated by this leaf being set to zero, with BCN
// represented by this leaf being set to N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/constraint-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny) ConstraintId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "constraint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny struct {
	*ygot.NodePath
}

// ExtendedAdminGroup (leaf): The extended-admin-group sub-TLV is used in addition
// to the Administrative Groups when it is desirable to
// make more than 32 colors available for advertisement
// in a network.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedAdminGroup (leaf): The extended-admin-group sub-TLV is used in addition
// to the Administrative Groups when it is desirable to
// make more than 32 colors available for advertisement
// in a network.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): A 4-octet IPv4 address for the interface described by
// the (main) TLV. This sub-TLV can occur multiple
// times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): A 4-octet IPv4 address for the interface described by
// the (main) TLV. This sub-TLV can occur multiple
// times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): A single IPv4 address for a neighboring router on
// this link. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): A single IPv4 address for a neighboring router on
// this link. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Contains a 16-octet IPv6 address for the interface
// described by the containing  Extended IS Reachability
// TLV. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Contains a 16-octet IPv6 address for the interface
// described by the containing  Extended IS Reachability
// TLV. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Contains a 16-octet IPv6 address for a neighboring
// router on the link described by the (main) TLV. This
// sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Contains a 16-octet IPv6 address for a neighboring
// router on the link described by the (main) TLV. This
// sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Flags associated with LAN-Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with LAN-Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborId (leaf): System ID of the neighbor associated with the LAN-
// Adj-Segment-ID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath) NeighborId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborId (leaf): System ID of the neighbor associated with the LAN-
// Adj-Segment-ID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) NeighborId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): LAN Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): LAN Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID
// for the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID
// for the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny struct {
	*ygot.NodePath
}

// LocalProtection (leaf): Link local-protection attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-protection"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath) LocalProtection() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalProtection (leaf): Link local-protection attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-protection"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny) LocalProtection() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay value (in microseconds) between
// two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay value (in microseconds) between
// two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny struct {
	*ygot.NodePath
}

// Delay (leaf): Average link delay between two directly connected IS-
// IS neighbors over a configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay between two directly connected IS-
// IS neighbors over a configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePathAny struct {
	*ygot.NodePath
}

// Local (leaf): The value field of this sub-TLV contains 4 octets of
// Link Local Identifier followed by 4 octets of Link
// Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath) Local() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Local (leaf): The value field of this sub-TLV contains 4 octets of
// Link Local Identifier followed by 4 octets of Link
// Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny) Local() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (leaf): If the Link Remote Identifier is unknown, it is set
// to 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath) Remote() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (leaf): If the Link Remote Identifier is unknown, it is set
// to 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny) Remote() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (leaf): Link packet loss as a percentage of the total traffic
// sent over a configurable interval. The basic unit is
// 0.000003%, where (2^24 - 2) is 50.331642%. This value
// is the highest packet-loss percentage that can be
// expressed (the assumption being that precision is more
// important on high-speed links than the ability to
// advertise loss rates greater than this, and that high-
// speed links with over 50% loss are unusable).
// Therefore, measured values that are larger than the
// field maximum SHOULD be encoded as the maximum
// value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (leaf): Link packet loss as a percentage of the total traffic
// sent over a configurable interval. The basic unit is
// 0.000003%, where (2^24 - 2) is 50.331642%. This value
// is the highest packet-loss percentage that can be
// expressed (the assumption being that precision is more
// important on high-speed links than the ability to
// advertise loss rates greater than this, and that high-
// speed links with over 50% loss are unusable).
// Therefore, measured values that are larger than the
// field maximum SHOULD be encoded as the maximum
// value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny struct {
	*ygot.NodePath
}

// Type (leaf): Link protection capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Link protection capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The maximum bandwidth that can be used on this link
// in this direction (from the system originating the LSP
// to its neighbors).  It is encoded in 32 bits in IEEE
// floating point format.  The units are bytes (not
// bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The maximum bandwidth that can be used on this link
// in this direction (from the system originating the LSP
// to its neighbors).  It is encoded in 32 bits in IEEE
// floating point format.  The units are bytes (not
// bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The maximum amount of bandwidth that can be reserved
// in this direction on this link.  Note that for
// oversubscription purposes,  this can be greater than
// the bandwidth of the link. It is encoded  in 32 bits
// in IEEE floating point format.  The units are bytes
// (not bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The maximum amount of bandwidth that can be reserved
// in this direction on this link.  Note that for
// oversubscription purposes,  this can be greater than
// the bandwidth of the link. It is encoded  in 32 bits
// in IEEE floating point format.  The units are bytes
// (not bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxDelay (leaf): Maximum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) MaxDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxDelay (leaf): Maximum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) MaxDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinDelay (leaf): Minimum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/min-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) MinDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "min-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinDelay (leaf): Minimum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/min-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) MinDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "min-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): Residual bandwidth on a link,forwarding adjacency
// [RFC4206], or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, residual bandwidth is defined to
// be the Maximum Bandwidth [RFC5305] minus the bandwidth
// currently allocated to RSVP-TE label switched paths.
// For a bundled link, residual bandwidth is defined to
// be the sum of the component link residual
// bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): Residual bandwidth on a link,forwarding adjacency
// [RFC4206], or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, residual bandwidth is defined to
// be the Maximum Bandwidth [RFC5305] minus the bandwidth
// currently allocated to RSVP-TE label switched paths.
// For a bundled link, residual bandwidth is defined to
// be the sum of the component link residual
// bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The amount of bandwidth reservable in this
// direction on this link. Note that for
// oversubscription purposes, this can be greater than
// the bandwidth of the link. It contains eight 32-bit
// IEEE floating point numbers(one for each priority).
// The units are bytes (not bits!) per second. The
// values correspond to the bandwidth that can be
// reserved with a setup priority of 0 through 7,
// arranged in increasing order with priority 0
// occurring at the start of the sub-TLV, and priority
// 7 at the end of the sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The amount of bandwidth reservable in this
// direction on this link. Note that for
// oversubscription purposes, this can be greater than
// the bandwidth of the link. It contains eight 32-bit
// IEEE floating point numbers(one for each priority).
// The units are bytes (not bits!) per second. The
// values correspond to the bandwidth that can be
// reserved with a setup priority of 0 through 7,
// arranged in increasing order with priority 0
// occurring at the start of the sub-TLV, and priority
// 7 at the end of the sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Setup priority level of 0 through 7 to be used by
// Unreserved Bandwidth sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath) Priority() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Setup priority level of 0 through 7 to be used by
// Unreserved Bandwidth sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny) Priority() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): This metric is administratively assigned and can be
// used to present a differently weighted topology to
// traffic engineering SPF calculations. To preclude
// overflow within a traffic engineering SPF
// implementation, all metrics greater than or equal to
// MAX_PATH_METRIC SHALL be considered to have a metric
// of MAX_PATH_METRIC.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): This metric is administratively assigned and can be
// used to present a differently weighted topology to
// traffic engineering SPF calculations. To preclude
// overflow within a traffic engineering SPF
// implementation, all metrics greater than or equal to
// MAX_PATH_METRIC SHALL be considered to have a metric
// of MAX_PATH_METRIC.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny struct {
	*ygot.NodePath
}

// Count (leaf): Unconstrained TE LSP count(TE Label Switched Paths
// (LSPs) signalled with zero bandwidth).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath) Count() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "count"},
			map[string]interface{}{},
			n,
		),
	}
}

// Count (leaf): Unconstrained TE LSP count(TE Label Switched Paths
// (LSPs) signalled with zero bandwidth).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny) Count() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "count"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The bandwidth utilization on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second.  For a link or
// forwarding adjacency, bandwidth utilization represents
// the actual utilization of the link (i.e., as measured
// by the advertising node).  For a bundled link,
// bandwidth utilization is defined to be the sum of the
// component link bandwidth utilizations.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The bandwidth utilization on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second.  For a link or
// forwarding adjacency, bandwidth utilization represents
// the actual utilization of the link (i.e., as measured
// by the advertising node).  For a bundled link,
// bandwidth utilization is defined to be the sum of the
// component link bandwidth utilizations.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_IsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/lsp-buffer-size YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/lsp-buffer-size YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSize_SizePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/lsp-buffer-size/state/size YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSize_SizePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSize_SizePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/lsp-buffer-size/state/size YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSize_SizePathAny struct {
	*ygot.NodePath
}

// Size (leaf): The maximum MTU that the advertising system can
// receive, expressed in bytes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/size"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/lsp-buffer-size/state/size"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePath) Size() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSize_SizePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSize_SizePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "size"},
			map[string]interface{}{},
			n,
		),
	}
}

// Size (leaf): The maximum MTU that the advertising system can
// receive, expressed in bytes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/size"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/lsp-buffer-size/state/size"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSizePathAny) Size() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSize_SizePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_LspBufferSize_SizePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "size"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPathAny struct {
	*ygot.NodePath
}

// PrefixAny (list): IPv4 prefixes that are contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix"
// MtId (wildcarded): uint16
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPath) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"mt-id": "*", "prefix": "*"},
			n,
		),
	}
}

// PrefixAny (list): IPv4 prefixes that are contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix"
// MtId (wildcarded): uint16
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPathAny) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"mt-id": "*", "prefix": "*"},
			n,
		),
	}
}

// PrefixAnyPrefix (list): IPv4 prefixes that are contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix"
// MtId: uint16
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPath) PrefixAnyPrefix(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"mt-id": MtId, "prefix": "*"},
			n,
		),
	}
}

// PrefixAnyPrefix (list): IPv4 prefixes that are contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix"
// MtId: uint16
// Prefix (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPathAny) PrefixAnyPrefix(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"mt-id": MtId, "prefix": "*"},
			n,
		),
	}
}

// PrefixAnyMtId (list): IPv4 prefixes that are contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix"
// MtId (wildcarded): uint16
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPath) PrefixAnyMtId(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"mt-id": "*", "prefix": Prefix},
			n,
		),
	}
}

// PrefixAnyMtId (list): IPv4 prefixes that are contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix"
// MtId (wildcarded): uint16
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPathAny) PrefixAnyMtId(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"mt-id": "*", "prefix": Prefix},
			n,
		),
	}
}

// Prefix (list): IPv4 prefixes that are contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix"
// MtId: uint16
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPath) Prefix(MtId uint16, Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"mt-id": MtId, "prefix": Prefix},
			n,
		),
	}
}

// Prefix (list): IPv4 prefixes that are contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix"
// MtId: uint16
// Prefix: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4ReachabilityPathAny) Prefix(MtId uint16, Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"mt-id": MtId, "prefix": Prefix},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MtIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MtIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MtIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MtIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/s-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/s-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SBitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UpDownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UpDownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UpDownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UpDownPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtId (leaf): Multi-topology ID
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MtIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MtIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtId (leaf): Multi-topology ID
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MtIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_MtIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv4 prefix contained within extended reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv4 prefix contained within extended reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// SBit (leaf): The Sub-TLV present bit. If UNSET, the octets of Sub-TLVs
// are not present. Otherwise, the bit is set and the octet
// following the prefix will contain the length of the Sub-TLV
// portion of the structure.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/s-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/s-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath) SBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SBitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "s-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SBit (leaf): The Sub-TLV present bit. If UNSET, the octets of Sub-TLVs
// are not present. Otherwise, the bit is set and the octet
// following the prefix will contain the length of the Sub-TLV
// portion of the structure.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/s-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/s-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny) SBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SBitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "s-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPath) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UpDownPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UpDownPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_PrefixPathAny) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UpDownPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UpDownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// Flags (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SourceRouterId (container): This container defines sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath) Ipv4SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SourceRouterId (container): This container defines sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny) Ipv4SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SourceRouterId (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath) Ipv6SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SourceRouterId (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny) Ipv6SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixSidAny (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath) PrefixSidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// PrefixSidAny (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny) PrefixSidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// PrefixSid (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath) PrefixSid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// PrefixSid (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny) PrefixSid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// Tag (container): This container defines sub-TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath) Tag() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPath{
		NodePath: ygot.NewNodePath(
			[]string{"tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag (container): This container defines sub-TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny) Tag() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (container): This container defines sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64Path{
		NodePath: ygot.NewNodePath(
			[]string{"tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (container): This container defines sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_SubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_TypePathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Additional prefix reachability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Additional prefix reachability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_FlagsPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Flags_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv4 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv4 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv6 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv6 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny struct {
	*ygot.NodePath
}

// Algorithm (leaf): Prefix-SID algorithm to be used for path computation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPath) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Algorithm (leaf): Prefix-SID algorithm to be used for path computation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Prefix Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Prefix Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): IGP Prefix-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): IGP Prefix-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag_Tag32Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag_Tag32Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag_Tag32PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag_Tag32PathAny struct {
	*ygot.NodePath
}

// Tag32 (leaf): List of 32-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag32"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPath) Tag32() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag_Tag32Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag_Tag32Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag32"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag32 (leaf): List of 32-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag32"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_TagPathAny) Tag32() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag_Tag32PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag_Tag32PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag32"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64_Tag64Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64_Tag64Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64_Tag64PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64_Tag64PathAny struct {
	*ygot.NodePath
}

// Tag64 (leaf): List of 64-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64Path) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64_Tag64Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64_Tag64Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (leaf): List of 64-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64PathAny) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64_Tag64PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_Subtlv_Tag64_Tag64PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv4-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv4Reachability_Prefix_UndefinedSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPathAny struct {
	*ygot.NodePath
}

// PrefixAny (list): List of IPv6 prefixes contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix"
// Prefix (wildcarded): string
// MtId (wildcarded): uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPath) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*", "mt-id": "*"},
			n,
		),
	}
}

// PrefixAny (list): List of IPv6 prefixes contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix"
// Prefix (wildcarded): string
// MtId (wildcarded): uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPathAny) PrefixAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*", "mt-id": "*"},
			n,
		),
	}
}

// PrefixAnyMtId (list): List of IPv6 prefixes contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix"
// Prefix: string
// MtId (wildcarded): uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPath) PrefixAnyMtId(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix, "mt-id": "*"},
			n,
		),
	}
}

// PrefixAnyMtId (list): List of IPv6 prefixes contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix"
// Prefix: string
// MtId (wildcarded): uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPathAny) PrefixAnyMtId(Prefix string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix, "mt-id": "*"},
			n,
		),
	}
}

// PrefixAnyPrefix (list): List of IPv6 prefixes contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix"
// Prefix (wildcarded): string
// MtId: uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPath) PrefixAnyPrefix(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*", "mt-id": MtId},
			n,
		),
	}
}

// PrefixAnyPrefix (list): List of IPv6 prefixes contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix"
// Prefix (wildcarded): string
// MtId: uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPathAny) PrefixAnyPrefix(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": "*", "mt-id": MtId},
			n,
		),
	}
}

// Prefix (list): List of IPv6 prefixes contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix"
// Prefix: string
// MtId: uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPath) Prefix(Prefix string, MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix, "mt-id": MtId},
			n,
		),
	}
}

// Prefix (list): List of IPv6 prefixes contained within MT
// reachability TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefixes/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix"
// Prefix: string
// MtId: uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6ReachabilityPathAny) Prefix(Prefix string, MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"prefix": Prefix, "mt-id": MtId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MtIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MtIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MtIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MtIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/s-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/s-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SBitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UpDownPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UpDownPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UpDownPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/up-down YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UpDownPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_XBitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/x-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_XBitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_XBitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/x-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_XBitPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtId (leaf): Multi-topology ID
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MtIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MtIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtId (leaf): Multi-topology ID
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MtIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_MtIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv6 prefix contained within extended reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_PrefixPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): IPv6 prefix contained within extended reachability TLVs.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/prefix"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) Prefix() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_PrefixPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// SBit (leaf): The sub-tlv present bit. If UNSET, the octets of Sub-TLVs
// are not present. Otherwise, the bit is set and the octet
// following the prefix will contain the length of the Sub-TLV
// portion of the structure.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/s-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/s-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) SBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SBitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "s-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SBit (leaf): The sub-tlv present bit. If UNSET, the octets of Sub-TLVs
// are not present. Otherwise, the bit is set and the octet
// following the prefix will contain the length of the Sub-TLV
// portion of the structure.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/s-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/s-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) SBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SBitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "s-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UpDownPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UpDownPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpDown (leaf): The up/down bit. Set if a prefix is advertised from a
// higher level to a lower level (e.g., level 2 to level 1),
// indicating that the prefix has traveled down the hierarchy.
// Prefixes that have the up/down bit set may only be
// advertised down the hierarchy, i.e., to lower levels. When a
// prefix is first injected into IS-IS, the bit is UNSET.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/up-down"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/up-down"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) UpDown() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UpDownPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UpDownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "up-down"},
			map[string]interface{}{},
			n,
		),
	}
}

// XBit (leaf): The external bit. Set when the prefix was distributed into
// IS-IS from another routing protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/x-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/x-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPath) XBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_XBitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_XBitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "x-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// XBit (leaf): The external bit. Set when the prefix was distributed into
// IS-IS from another routing protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/x-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/state/x-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_PrefixPathAny) XBit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_XBitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_XBitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "x-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// Flags (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SourceRouterId (container): This container defines sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath) Ipv4SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4SourceRouterId (container): This container defines sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny) Ipv4SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SourceRouterId (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath) Ipv6SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6SourceRouterId (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-source-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny) Ipv6SourceRouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-source-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixSidAny (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath) PrefixSidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// PrefixSidAny (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny) PrefixSidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// PrefixSid (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath) PrefixSid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// PrefixSid (list): Prefix Segment-ID list. IGP-Prefix Segment is an IGP segment
// attached to an IGP prefix. An IGP-Prefix Segment is global
// (unless explicitly advertised otherwise) within the SR/IGP
// domain.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sids/prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny) PrefixSid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sids", "prefix-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// Tag (container): This container defines sub-TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath) Tag() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPath{
		NodePath: ygot.NewNodePath(
			[]string{"tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag (container): This container defines sub-TLV 1.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny) Tag() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (container): This container defines sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64Path{
		NodePath: ygot.NewNodePath(
			[]string{"tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (container): This container defines sub-TLV 2.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_SubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_TypePathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Additional prefix reachability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Additional prefix reachability flags.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/flags/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_FlagsPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Flags_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv4 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv4 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv4-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterIdPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv4SourceRouterId_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny struct {
	*ygot.NodePath
}

// RouterId (leaf): IPv6 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): IPv6 Source router ID address. In cases where the
// advertisement is an identifier for the advertising
// router (e.g., with the N-flag set in the Prefix
// Attribute Flags sub-TLV), it may be useful for other
// routers to know the source of the advertisement. When
// reachability advertisement is leaked from one level to
// another, Router ID advertised is always the Router ID
// of the IS-IS instance that originated the
// advertisement. This would be true even if the prefix
// had been learned from another protocol.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/router-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny) RouterId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/ipv6-source-router-id/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterIdPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Ipv6SourceRouterId_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny struct {
	*ygot.NodePath
}

// Algorithm (leaf): Prefix-SID algorithm to be used for path computation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPath) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Algorithm (leaf): Prefix-SID algorithm to be used for path computation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny) Algorithm() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_AlgorithmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Prefix Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Prefix Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): IGP Prefix-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): IGP Prefix-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/prefix-sids/prefix-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_PrefixSid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag_Tag32Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag_Tag32Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag_Tag32PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag_Tag32PathAny struct {
	*ygot.NodePath
}

// Tag32 (leaf): List of 32-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag32"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPath) Tag32() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag_Tag32Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag_Tag32Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag32"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag32 (leaf): List of 32-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag32"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag/state/tag32"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_TagPathAny) Tag32() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag_Tag32PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag_Tag32PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag32"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64PathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64_Tag64Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64_Tag64Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64_Tag64PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64 YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64_Tag64PathAny struct {
	*ygot.NodePath
}

// Tag64 (leaf): List of 64-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64Path) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64_Tag64Path {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64_Tag64Path{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag64 (leaf): List of 64-bit tags associated with the prefix. Example
// uses of these tags include carrying BGP standard (or
// extended) communities and controlling redistribution
// between levels and areas, different routing protocols,
// or multiple instances of IS-IS running on the same
// router.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tag64"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/subtlvs/subtlv/tag64/state/tag64"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64PathAny) Tag64() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64_Tag64PathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_Subtlv_Tag64_Tag64PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tag64"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-ipv6-reachability/prefixes/prefix/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIpv6Reachability_Prefix_UndefinedSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePathAny struct {
	*ygot.NodePath
}

// NeighborAny (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor"
// MtId (wildcarded): uint16
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePath) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": "*", "system-id": "*"},
			n,
		),
	}
}

// NeighborAny (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor"
// MtId (wildcarded): uint16
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePathAny) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": "*", "system-id": "*"},
			n,
		),
	}
}

// NeighborAnySystemId (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor"
// MtId: uint16
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePath) NeighborAnySystemId(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": MtId, "system-id": "*"},
			n,
		),
	}
}

// NeighborAnySystemId (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor"
// MtId: uint16
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePathAny) NeighborAnySystemId(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": MtId, "system-id": "*"},
			n,
		),
	}
}

// NeighborAnyMtId (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor"
// MtId (wildcarded): uint16
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePath) NeighborAnyMtId(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": "*", "system-id": SystemId},
			n,
		),
	}
}

// NeighborAnyMtId (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor"
// MtId (wildcarded): uint16
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePathAny) NeighborAnyMtId(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": "*", "system-id": SystemId},
			n,
		),
	}
}

// Neighbor (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor"
// MtId: uint16
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePath) Neighbor(MtId uint16, SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": MtId, "system-id": SystemId},
			n,
		),
	}
}

// Neighbor (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor"
// MtId: uint16
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttributePathAny) Neighbor(MtId uint16, SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": MtId, "system-id": SystemId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_MtIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_MtIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_MtIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_MtIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_SystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_SystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_SystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_SystemIdPathAny struct {
	*ygot.NodePath
}

// InstanceAny (list): Instance of TLV-222 between the originating
// and remote IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance"
// Id (wildcarded): uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPath) InstanceAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InstanceAny (list): Instance of TLV-222 between the originating
// and remote IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance"
// Id (wildcarded): uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny) InstanceAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Instance (list): Instance of TLV-222 between the originating
// and remote IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance"
// Id: uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPath) Instance(Id uint64) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Instance (list): Instance of TLV-222 between the originating
// and remote IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance"
// Id: uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny) Instance(Id uint64) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// MtId (leaf): Identifier of a topology being announced.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPath) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_MtIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_MtIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtId (leaf): Identifier of a topology being announced.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_MtIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_MtIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): System-id of the IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPath) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_SystemIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_SystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): System-id of the IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_NeighborPathAny) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_SystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_SystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_IdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_MetricPathAny struct {
	*ygot.NodePath
}

// Id (leaf): Unique identifier for the TLV instance for the
// neighbor. The ID is not required to be consistent
// across readvertisements of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath) Id() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_IdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Unique identifier for the TLV instance for the
// neighbor. The ID is not required to be consistent
// across readvertisements of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny) Id() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_IdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePath) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_InstancePathAny) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// AdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// AdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// AdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) AdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// AdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) AdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// AdminGroup (container): This container defines sub-TLV 3.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroup (container): This container defines sub-TLV 3.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (container): This container defines unidirectional lavailable
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "available-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) AvailableBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (container): This container defines unidirectional lavailable
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "available-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) AvailableBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// BandwidthConstraintAny (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) BandwidthConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": "*"},
			n,
		),
	}
}

// BandwidthConstraintAny (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) BandwidthConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": "*"},
			n,
		),
	}
}

// BandwidthConstraint (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) BandwidthConstraint(ModelId uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": ModelId},
			n,
		),
	}
}

// BandwidthConstraint (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) BandwidthConstraint(ModelId uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": ModelId},
			n,
		),
	}
}

// ExtendedAdminGroup (container): This container defines sub-TLV 14.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedAdminGroup (container): This container defines sub-TLV 14.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (container): This container defines sub-TLV 6.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (container): This container defines sub-TLV 6.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (container): This container defines sub-TLV 8.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (container): This container defines sub-TLV 8.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (container): This container defines sub-TLV 13.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (container): This container defines sub-TLV 13.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LanAdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LanAdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// LanAdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LanAdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// LanAdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LanAdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// LanAdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LanAdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// LinkAttributes (container): This container defines link-attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkAttributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkAttributes (container): This container defines link-attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkAttributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelay (container): This container defines unidirectional link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelay (container): This container defines unidirectional link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelayVariation (container): This container defines unidirectional link delay
// variation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay-variation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkDelayVariation() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay-variation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelayVariation (container): This container defines unidirectional link delay
// variation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay-variation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkDelayVariation() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay-variation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (container): This container defines unidirectional link loss delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (container): This container defines unidirectional link loss delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionType (container): ISIS LSDB parameters relating to the type of link
// protection offered.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-protection-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) LinkProtectionType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"link-protection-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionType (container): ISIS LSDB parameters relating to the type of link
// protection offered.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-protection-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) LinkProtectionType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-protection-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (container): This container defines sub-TLV 9.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) MaxLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (container): This container defines sub-TLV 9.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) MaxLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxReservableLinkBandwidth (container): This container defines sub-TLV 10.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-reservable-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) MaxReservableLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"max-reservable-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxReservableLinkBandwidth (container): This container defines sub-TLV 10.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-reservable-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) MaxReservableLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-reservable-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinMaxLinkDelay (container): This container defines min/max link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "min-max-link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) MinMaxLinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"min-max-link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinMaxLinkDelay (container): This container defines min/max link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "min-max-link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) MinMaxLinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-max-link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResidualBandwidth (container): This container defines unidirectional residual
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "residual-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) ResidualBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"residual-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResidualBandwidth (container): This container defines unidirectional residual
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "residual-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) ResidualBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"residual-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriorityAny (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) SetupPriorityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// SetupPriorityAny (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) SetupPriorityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// SetupPriority (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) SetupPriority(Priority uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// SetupPriority (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) SetupPriority(Priority uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// TeDefaultMetric (container): This container defines sub-TLV 18.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) TeDefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"te-default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// TeDefaultMetric (container): This container defines sub-TLV 18.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) TeDefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnconstrainedLsp (container): This container defines sub-TLV 23.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) UnconstrainedLsp() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnconstrainedLsp (container): This container defines sub-TLV 23.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) UnconstrainedLsp() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// UtilizedBandwidth (container): This container defines unidirectional utilized
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "utilized-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPath) UtilizedBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"utilized-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// UtilizedBandwidth (container): This container defines unidirectional utilized
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "utilized-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_SubtlvPathAny) UtilizedBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"utilized-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Flags associated with Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID for
// the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPath) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID for
// the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny struct {
	*ygot.NodePath
}

// AdminGroup (leaf): The administrative group sub-TLV contains a 4-octet
// bit mask assigned by the network administrator.  Each
// set bit corresponds to one administrative group
// assigned to the interface. By convention, the least
// significant bit is referred to as group 0, and the
// most significant bit is referred to as group 31.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPath) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroup (leaf): The administrative group sub-TLV contains a 4-octet
// bit mask assigned by the network administrator.  Each
// set bit corresponds to one administrative group
// assigned to the interface. By convention, the least
// significant bit is referred to as group 0, and the
// most significant bit is referred to as group 31.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroupPathAny) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The available bandwidth on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, available bandwidth is defined
// to be residual bandwidth minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The available bandwidth on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, available bandwidth is defined
// to be residual bandwidth minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny struct {
	*ygot.NodePath
}

// ConstraintAny (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath) ConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": "*"},
			n,
		),
	}
}

// ConstraintAny (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) ConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": "*"},
			n,
		),
	}
}

// Constraint (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath) Constraint(ConstraintId uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": ConstraintId},
			n,
		),
	}
}

// Constraint (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) Constraint(ConstraintId uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": ConstraintId},
			n,
		),
	}
}

// ModelId (leaf): Identifier for the Bandwidth Constraints  Model
// currently in use by the LSR initiating the IGP
// advertisement.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/model-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPath) ModelId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "model-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModelId (leaf): Identifier for the Bandwidth Constraints  Model
// currently in use by the LSR initiating the IGP
// advertisement.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/model-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) ModelId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "model-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The bandwidth constraint, expressed as a 32-bit IEEE
// floating point number expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The bandwidth constraint, expressed as a 32-bit IEEE
// floating point number expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConstraintId (leaf): Unique reference for the bandwidth constraint level. BC0
// is indicated by this leaf being set to zero, with BCN
// represented by this leaf being set to N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/constraint-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath) ConstraintId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "constraint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConstraintId (leaf): Unique reference for the bandwidth constraint level. BC0
// is indicated by this leaf being set to zero, with BCN
// represented by this leaf being set to N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/constraint-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny) ConstraintId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "constraint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny struct {
	*ygot.NodePath
}

// ExtendedAdminGroup (leaf): The extended-admin-group sub-TLV is used in addition
// to the Administrative Groups when it is desirable to
// make more than 32 colors available for advertisement
// in a network.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedAdminGroup (leaf): The extended-admin-group sub-TLV is used in addition
// to the Administrative Groups when it is desirable to
// make more than 32 colors available for advertisement
// in a network.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): A 4-octet IPv4 address for the interface described by
// the (main) TLV. This sub-TLV can occur multiple
// times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): A 4-octet IPv4 address for the interface described by
// the (main) TLV. This sub-TLV can occur multiple
// times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): A single IPv4 address for a neighboring router on
// this link. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): A single IPv4 address for a neighboring router on
// this link. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Contains a 16-octet IPv6 address for the interface
// described by the containing  Extended IS Reachability
// TLV. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Contains a 16-octet IPv6 address for the interface
// described by the containing  Extended IS Reachability
// TLV. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Contains a 16-octet IPv6 address for a neighboring
// router on the link described by the (main) TLV. This
// sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Contains a 16-octet IPv6 address for a neighboring
// router on the link described by the (main) TLV. This
// sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Flags associated with LAN-Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with LAN-Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborId (leaf): System ID of the neighbor associated with the LAN-
// Adj-Segment-ID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath) NeighborId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborId (leaf): System ID of the neighbor associated with the LAN-
// Adj-Segment-ID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) NeighborId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): LAN Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): LAN Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID
// for the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID
// for the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny struct {
	*ygot.NodePath
}

// LocalProtection (leaf): Link local-protection attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-protection"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPath) LocalProtection() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalProtection (leaf): Link local-protection attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-protection"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributesPathAny) LocalProtection() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay value (in microseconds) between
// two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPath) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay value (in microseconds) between
// two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayPathAny) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny struct {
	*ygot.NodePath
}

// Delay (leaf): Average link delay between two directly connected IS-
// IS neighbors over a configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPath) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay between two directly connected IS-
// IS neighbors over a configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePathAny struct {
	*ygot.NodePath
}

// Local (leaf): The value field of this sub-TLV contains 4 octets of
// Link Local Identifier followed by 4 octets of Link
// Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath) Local() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Local (leaf): The value field of this sub-TLV contains 4 octets of
// Link Local Identifier followed by 4 octets of Link
// Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny) Local() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_LocalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (leaf): If the Link Remote Identifier is unknown, it is set
// to 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPath) Remote() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (leaf): If the Link Remote Identifier is unknown, it is set
// to 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkIdPathAny) Remote() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkId_RemotePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (leaf): Link packet loss as a percentage of the total traffic
// sent over a configurable interval. The basic unit is
// 0.000003%, where (2^24 - 2) is 50.331642%. This value
// is the highest packet-loss percentage that can be
// expressed (the assumption being that precision is more
// important on high-speed links than the ability to
// advertise loss rates greater than this, and that high-
// speed links with over 50% loss are unusable).
// Therefore, measured values that are larger than the
// field maximum SHOULD be encoded as the maximum
// value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPath) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (leaf): Link packet loss as a percentage of the total traffic
// sent over a configurable interval. The basic unit is
// 0.000003%, where (2^24 - 2) is 50.331642%. This value
// is the highest packet-loss percentage that can be
// expressed (the assumption being that precision is more
// important on high-speed links than the ability to
// advertise loss rates greater than this, and that high-
// speed links with over 50% loss are unusable).
// Therefore, measured values that are larger than the
// field maximum SHOULD be encoded as the maximum
// value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLossPathAny) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny struct {
	*ygot.NodePath
}

// Type (leaf): Link protection capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Link protection capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The maximum bandwidth that can be used on this link
// in this direction (from the system originating the LSP
// to its neighbors).  It is encoded in 32 bits in IEEE
// floating point format.  The units are bytes (not
// bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The maximum bandwidth that can be used on this link
// in this direction (from the system originating the LSP
// to its neighbors).  It is encoded in 32 bits in IEEE
// floating point format.  The units are bytes (not
// bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The maximum amount of bandwidth that can be reserved
// in this direction on this link.  Note that for
// oversubscription purposes,  this can be greater than
// the bandwidth of the link. It is encoded  in 32 bits
// in IEEE floating point format.  The units are bytes
// (not bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The maximum amount of bandwidth that can be reserved
// in this direction on this link.  Note that for
// oversubscription purposes,  this can be greater than
// the bandwidth of the link. It is encoded  in 32 bits
// in IEEE floating point format.  The units are bytes
// (not bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxDelay (leaf): Maximum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) MaxDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxDelay (leaf): Maximum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) MaxDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinDelay (leaf): Minimum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/min-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) MinDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "min-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinDelay (leaf): Minimum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/min-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) MinDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "min-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): Residual bandwidth on a link,forwarding adjacency
// [RFC4206], or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, residual bandwidth is defined to
// be the Maximum Bandwidth [RFC5305] minus the bandwidth
// currently allocated to RSVP-TE label switched paths.
// For a bundled link, residual bandwidth is defined to
// be the sum of the component link residual
// bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): Residual bandwidth on a link,forwarding adjacency
// [RFC4206], or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, residual bandwidth is defined to
// be the Maximum Bandwidth [RFC5305] minus the bandwidth
// currently allocated to RSVP-TE label switched paths.
// For a bundled link, residual bandwidth is defined to
// be the sum of the component link residual
// bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The amount of bandwidth reservable in this
// direction on this link. Note that for
// oversubscription purposes, this can be greater than
// the bandwidth of the link. It contains eight 32-bit
// IEEE floating point numbers(one for each priority).
// The units are bytes (not bits!) per second. The
// values correspond to the bandwidth that can be
// reserved with a setup priority of 0 through 7,
// arranged in increasing order with priority 0
// occurring at the start of the sub-TLV, and priority
// 7 at the end of the sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The amount of bandwidth reservable in this
// direction on this link. Note that for
// oversubscription purposes, this can be greater than
// the bandwidth of the link. It contains eight 32-bit
// IEEE floating point numbers(one for each priority).
// The units are bytes (not bits!) per second. The
// values correspond to the bandwidth that can be
// reserved with a setup priority of 0 through 7,
// arranged in increasing order with priority 0
// occurring at the start of the sub-TLV, and priority
// 7 at the end of the sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Setup priority level of 0 through 7 to be used by
// Unreserved Bandwidth sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPath) Priority() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Setup priority level of 0 through 7 to be used by
// Unreserved Bandwidth sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriorityPathAny) Priority() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): This metric is administratively assigned and can be
// used to present a differently weighted topology to
// traffic engineering SPF calculations. To preclude
// overflow within a traffic engineering SPF
// implementation, all metrics greater than or equal to
// MAX_PATH_METRIC SHALL be considered to have a metric
// of MAX_PATH_METRIC.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): This metric is administratively assigned and can be
// used to present a differently weighted topology to
// traffic engineering SPF calculations. To preclude
// overflow within a traffic engineering SPF
// implementation, all metrics greater than or equal to
// MAX_PATH_METRIC SHALL be considered to have a metric
// of MAX_PATH_METRIC.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny struct {
	*ygot.NodePath
}

// Count (leaf): Unconstrained TE LSP count(TE Label Switched Paths
// (LSPs) signalled with zero bandwidth).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath) Count() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "count"},
			map[string]interface{}{},
			n,
		),
	}
}

// Count (leaf): Unconstrained TE LSP count(TE Label Switched Paths
// (LSPs) signalled with zero bandwidth).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny) Count() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "count"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The bandwidth utilization on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second.  For a link or
// forwarding adjacency, bandwidth utilization represents
// the actual utilization of the link (i.e., as measured
// by the advertising node).  For a bundled link,
// bandwidth utilization is defined to be the sum of the
// component link bandwidth utilizations.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The bandwidth utilization on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second.  For a link or
// forwarding adjacency, bandwidth utilization represents
// the actual utilization of the link (i.e., as measured
// by the advertising node).  For a bundled link,
// bandwidth utilization is defined to be the sum of the
// component link bandwidth utilizations.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isis-neighbor-attribute/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsisNeighborAttribute_Neighbor_Instance_UndefinedSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPathAny struct {
	*ygot.NodePath
}

// NeighborAny (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor"
// MtId (wildcarded): uint16
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPath) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": "*", "system-id": "*"},
			n,
		),
	}
}

// NeighborAny (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor"
// MtId (wildcarded): uint16
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPathAny) NeighborAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": "*", "system-id": "*"},
			n,
		),
	}
}

// NeighborAnySystemId (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor"
// MtId: uint16
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPath) NeighborAnySystemId(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": MtId, "system-id": "*"},
			n,
		),
	}
}

// NeighborAnySystemId (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor"
// MtId: uint16
// SystemId (wildcarded): string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPathAny) NeighborAnySystemId(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": MtId, "system-id": "*"},
			n,
		),
	}
}

// NeighborAnyMtId (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor"
// MtId (wildcarded): uint16
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPath) NeighborAnyMtId(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": "*", "system-id": SystemId},
			n,
		),
	}
}

// NeighborAnyMtId (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor"
// MtId (wildcarded): uint16
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPathAny) NeighborAnyMtId(SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": "*", "system-id": SystemId},
			n,
		),
	}
}

// Neighbor (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor"
// MtId: uint16
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPath) Neighbor(MtId uint16, SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": MtId, "system-id": SystemId},
			n,
		),
	}
}

// Neighbor (list): This container describes IS neighbors.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor"
// MtId: uint16
// SystemId: string
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsnPathAny) Neighbor(MtId uint16, SystemId string) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"mt-id": MtId, "system-id": SystemId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_MtIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_MtIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_MtIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_MtIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_SystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_SystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_SystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/state/system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_SystemIdPathAny struct {
	*ygot.NodePath
}

// InstanceAny (list): Instance of TLV-222 between the originating
// and remote IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance"
// Id (wildcarded): uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPath) InstanceAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InstanceAny (list): Instance of TLV-222 between the originating
// and remote IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance"
// Id (wildcarded): uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny) InstanceAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Instance (list): Instance of TLV-222 between the originating
// and remote IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance"
// Id: uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPath) Instance(Id uint64) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Instance (list): Instance of TLV-222 between the originating
// and remote IS.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "instances/instance"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance"
// Id: uint64
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny) Instance(Id uint64) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instances", "instance"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// MtId (leaf): Identifier of a topology being announced.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPath) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_MtIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_MtIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtId (leaf): Identifier of a topology being announced.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_MtIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_MtIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): System-id of the IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPath) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_SystemIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_SystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemId (leaf): System-id of the IS neighbor.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/state/system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_NeighborPathAny) SystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_SystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_SystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_IdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/state/id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/state/id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_MetricPathAny struct {
	*ygot.NodePath
}

// Id (leaf): Unique identifier for the TLV instance for the
// neighbor. The ID is not required to be consistent
// across readvertisements of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/state/id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath) Id() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_IdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Unique identifier for the TLV instance for the
// neighbor. The ID is not required to be consistent
// across readvertisements of the LSP.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/state/id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny) Id() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_IdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): ISIS metric value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// SubtlvAny (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type (wildcarded): E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny) SubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// Subtlv (list): List of subTLV types in the LSDB for the specified TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "subtlvs/subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv"
// Type: E_IsisLsdbTypes_ISIS_SUBTLV_TYPE
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny) Subtlv(Type E_IsisLsdbTypes_ISIS_SUBTLV_TYPE) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"subtlvs", "subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlvAny (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny) UndefinedSubtlvAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePath) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// UndefinedSubtlv (list): Sub-TLVs that are not defined in the model or not
// recognised by system.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "undefined-subtlvs/undefined-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv"
// Type: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_InstancePathAny) UndefinedSubtlv(Type uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"undefined-subtlvs", "undefined-subtlv"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TypePathAny struct {
	*ygot.NodePath
}

// AdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// AdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) AdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// AdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) AdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// AdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sids/adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) AdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sids", "adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// AdminGroup (container): This container defines sub-TLV 3.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroup (container): This container defines sub-TLV 3.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (container): This container defines unidirectional lavailable
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "available-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) AvailableBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// AvailableBandwidth (container): This container defines unidirectional lavailable
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "available-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) AvailableBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"available-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// BandwidthConstraintAny (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) BandwidthConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": "*"},
			n,
		),
	}
}

// BandwidthConstraintAny (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) BandwidthConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": "*"},
			n,
		),
	}
}

// BandwidthConstraint (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) BandwidthConstraint(ModelId uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": ModelId},
			n,
		),
	}
}

// BandwidthConstraint (list): List of the Bandwidth Constraints sub-TLV instances
// present in the TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bandwidth-constraints/bandwidth-constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint"
// ModelId: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) BandwidthConstraint(ModelId uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bandwidth-constraints", "bandwidth-constraint"},
			map[string]interface{}{"model-id": ModelId},
			n,
		),
	}
}

// ExtendedAdminGroup (container): This container defines sub-TLV 14.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedAdminGroup (container): This container defines sub-TLV 14.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (container): This container defines sub-TLV 6.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4InterfaceAddress (container): This container defines sub-TLV 6.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) Ipv4InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (container): This container defines sub-TLV 8.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4NeighborAddress (container): This container defines sub-TLV 8.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) Ipv4NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6InterfaceAddress (container): This container defines sub-TLV 12.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) Ipv6InterfaceAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (container): This container defines sub-TLV 13.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6NeighborAddress (container): This container defines sub-TLV 13.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv6-neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) Ipv6NeighborAddress() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv6-neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LanAdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) LanAdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// LanAdjacencySidAny (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) LanAdjacencySidAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": "*"},
			n,
		),
	}
}

// LanAdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) LanAdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// LanAdjacencySid (list): Adjacency Segment-IDs List. An IGP-Adjacency Segment is
// an IGP segment attached to a unidirectional adjacency or
// a set of unidirectional adjacencies. By default, an IGP-
// Adjacency Segment is local to the node which advertises
// it.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lan-adjacency-sids/lan-adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid"
// Value: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) LanAdjacencySid(Value uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lan-adjacency-sids", "lan-adjacency-sid"},
			map[string]interface{}{"value": Value},
			n,
		),
	}
}

// LinkAttributes (container): This container defines link-attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) LinkAttributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkAttributes (container): This container defines link-attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) LinkAttributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelay (container): This container defines unidirectional link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) LinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelay (container): This container defines unidirectional link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) LinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelayVariation (container): This container defines unidirectional link delay
// variation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay-variation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) LinkDelayVariation() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay-variation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkDelayVariation (container): This container defines unidirectional link delay
// variation.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-delay-variation"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) LinkDelayVariation() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-delay-variation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) LinkId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (container): This container defines sub-TLV 4.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) LinkId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (container): This container defines unidirectional link loss delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (container): This container defines unidirectional link loss delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionType (container): ISIS LSDB parameters relating to the type of link
// protection offered.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-protection-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) LinkProtectionType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"link-protection-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkProtectionType (container): ISIS LSDB parameters relating to the type of link
// protection offered.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link-protection-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) LinkProtectionType() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link-protection-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (container): This container defines sub-TLV 9.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) MaxLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxLinkBandwidth (container): This container defines sub-TLV 9.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) MaxLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxReservableLinkBandwidth (container): This container defines sub-TLV 10.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-reservable-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) MaxReservableLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"max-reservable-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxReservableLinkBandwidth (container): This container defines sub-TLV 10.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-reservable-link-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) MaxReservableLinkBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-reservable-link-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinMaxLinkDelay (container): This container defines min/max link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "min-max-link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) MinMaxLinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"min-max-link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinMaxLinkDelay (container): This container defines min/max link delay.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "min-max-link-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) MinMaxLinkDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-max-link-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResidualBandwidth (container): This container defines unidirectional residual
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "residual-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) ResidualBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"residual-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ResidualBandwidth (container): This container defines unidirectional residual
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "residual-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) ResidualBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"residual-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetupPriorityAny (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) SetupPriorityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// SetupPriorityAny (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) SetupPriorityAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// SetupPriority (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) SetupPriority(Priority uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// SetupPriority (list): Setup priority (0 through 7) for unreserved
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidth/setup-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority"
// Priority: uint8
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) SetupPriority(Priority uint8) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidth", "setup-priority"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// TeDefaultMetric (container): This container defines sub-TLV 18.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) TeDefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"te-default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// TeDefaultMetric (container): This container defines sub-TLV 18.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-default-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) TeDefaultMetric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-default-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnconstrainedLsp (container): This container defines sub-TLV 23.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) UnconstrainedLsp() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPath{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnconstrainedLsp (container): This container defines sub-TLV 23.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unconstrained-lsp"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) UnconstrainedLsp() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unconstrained-lsp"},
			map[string]interface{}{},
			n,
		),
	}
}

// UtilizedBandwidth (container): This container defines unidirectional utilized
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "utilized-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPath) UtilizedBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"utilized-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// UtilizedBandwidth (container): This container defines unidirectional utilized
// bandwidth.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "utilized-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_SubtlvPathAny) UtilizedBandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"utilized-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Flags associated with Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID for
// the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPath) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID for
// the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/adjacency-sids/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySidPathAny) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdjacencySid_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny struct {
	*ygot.NodePath
}

// AdminGroup (leaf): The administrative group sub-TLV contains a 4-octet
// bit mask assigned by the network administrator.  Each
// set bit corresponds to one administrative group
// assigned to the interface. By convention, the least
// significant bit is referred to as group 0, and the
// most significant bit is referred to as group 31.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPath) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminGroup (leaf): The administrative group sub-TLV contains a 4-octet
// bit mask assigned by the network administrator.  Each
// set bit corresponds to one administrative group
// assigned to the interface. By convention, the least
// significant bit is referred to as group 0, and the
// most significant bit is referred to as group 31.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/admin-group/state/admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroupPathAny) AdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AdminGroup_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The available bandwidth on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, available bandwidth is defined
// to be residual bandwidth minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The available bandwidth on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, available bandwidth is defined
// to be residual bandwidth minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths minus the measured bandwidth
// used for the actual forwarding of non-RSVP-TE label
// switched path packets.  For a bundled link, available
// bandwidth is defined to be the sum of the component
// link available bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/available-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidthPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_AvailableBandwidth_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny struct {
	*ygot.NodePath
}

// ConstraintAny (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPath) ConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": "*"},
			n,
		),
	}
}

// ConstraintAny (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId (wildcarded): uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) ConstraintAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": "*"},
			n,
		),
	}
}

// Constraint (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPath) Constraint(ConstraintId uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": ConstraintId},
			n,
		),
	}
}

// Constraint (list): List of the constraints within the Bandwidth
// Constraints sub-TLV. The BC0 level is indicated by
// the constraint-id leaf being set to 0, with BCN
// being indicated by constraint-id N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "constraints/constraint"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint"
// ConstraintId: uint32
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) Constraint(ConstraintId uint32) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"constraints", "constraint"},
			map[string]interface{}{"constraint-id": ConstraintId},
			n,
		),
	}
}

// ModelId (leaf): Identifier for the Bandwidth Constraints  Model
// currently in use by the LSR initiating the IGP
// advertisement.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/model-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPath) ModelId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "model-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModelId (leaf): Identifier for the Bandwidth Constraints  Model
// currently in use by the LSR initiating the IGP
// advertisement.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/model-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/state/model-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraintPathAny) ModelId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ModelIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "model-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The bandwidth constraint, expressed as a 32-bit IEEE
// floating point number expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The bandwidth constraint, expressed as a 32-bit IEEE
// floating point number expressed in bytes per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConstraintId (leaf): Unique reference for the bandwidth constraint level. BC0
// is indicated by this leaf being set to zero, with BCN
// represented by this leaf being set to N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/constraint-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPath) ConstraintId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "constraint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConstraintId (leaf): Unique reference for the bandwidth constraint level. BC0
// is indicated by this leaf being set to zero, with BCN
// represented by this leaf being set to N.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/constraint-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/bandwidth-constraints/bandwidth-constraint/constraints/constraint/state/constraint-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_ConstraintPathAny) ConstraintId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_BandwidthConstraint_Constraint_ConstraintIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "constraint-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny struct {
	*ygot.NodePath
}

// ExtendedAdminGroup (leaf): The extended-admin-group sub-TLV is used in addition
// to the Administrative Groups when it is desirable to
// make more than 32 colors available for advertisement
// in a network.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPath) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedAdminGroup (leaf): The extended-admin-group sub-TLV is used in addition
// to the Administrative Groups when it is desirable to
// make more than 32 colors available for advertisement
// in a network.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/extended-admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/extended-admin-group/state/extended-admin-group"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroupPathAny) ExtendedAdminGroup() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ExtendedAdminGroup_ExtendedAdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "extended-admin-group"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): A 4-octet IPv4 address for the interface described by
// the (main) TLV. This sub-TLV can occur multiple
// times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): A 4-octet IPv4 address for the interface described by
// the (main) TLV. This sub-TLV can occur multiple
// times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4InterfaceAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): A single IPv4 address for a neighboring router on
// this link. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): A single IPv4 address for a neighboring router on
// this link. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv4-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv4NeighborAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Contains a 16-octet IPv6 address for the interface
// described by the containing  Extended IS Reachability
// TLV. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Contains a 16-octet IPv6 address for the interface
// described by the containing  Extended IS Reachability
// TLV. This sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-interface-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6InterfaceAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Contains a 16-octet IPv6 address for a neighboring
// router on the link described by the (main) TLV. This
// sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPath) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Contains a 16-octet IPv6 address for a neighboring
// router on the link described by the (main) TLV. This
// sub-TLV can occur multiple times.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/ipv6-neighbor-address/state/address"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddressPathAny) Address() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_Ipv6NeighborAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny struct {
	*ygot.NodePath
}

// Flags (leaf): Flags associated with LAN-Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// Flags (leaf): Flags associated with LAN-Adj-Segment-ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/flags"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/flags"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Flags() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_FlagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "flags"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborId (leaf): System ID of the neighbor associated with the LAN-
// Adj-Segment-ID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPath) NeighborId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborId (leaf): System ID of the neighbor associated with the LAN-
// Adj-Segment-ID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/neighbor-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) NeighborId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_NeighborIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): LAN Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): LAN Adjacency-SID value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID
// for the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPath) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): Value that represents the weight of the Adj-SID
// for the purpose of load balancing.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/lan-adjacency-sids/lan-adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySidPathAny) Weight() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LanAdjacencySid_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny struct {
	*ygot.NodePath
}

// LocalProtection (leaf): Link local-protection attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-protection"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPath) LocalProtection() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalProtection (leaf): Link local-protection attributes.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-protection"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-attributes/state/local-protection"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributesPathAny) LocalProtection() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkAttributes_LocalProtectionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-protection"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_DelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_DelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay value (in microseconds) between
// two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPath) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_DelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_DelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay value (in microseconds) between
// two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayPathAny) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelay_DelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny struct {
	*ygot.NodePath
}

// Delay (leaf): Average link delay between two directly connected IS-
// IS neighbors over a configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPath) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Delay (leaf): Average link delay between two directly connected IS-
// IS neighbors over a configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-delay-variation/state/delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariationPathAny) Delay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkDelayVariation_DelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_LocalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_LocalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_LocalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_LocalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_RemotePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_RemotePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_RemotePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_RemotePathAny struct {
	*ygot.NodePath
}

// Local (leaf): The value field of this sub-TLV contains 4 octets of
// Link Local Identifier followed by 4 octets of Link
// Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPath) Local() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_LocalPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_LocalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Local (leaf): The value field of this sub-TLV contains 4 octets of
// Link Local Identifier followed by 4 octets of Link
// Remote Identifier.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/local"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPathAny) Local() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_LocalPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_LocalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (leaf): If the Link Remote Identifier is unknown, it is set
// to 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPath) Remote() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_RemotePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_RemotePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// Remote (leaf): If the Link Remote Identifier is unknown, it is set
// to 0.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-id/state/remote"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkIdPathAny) Remote() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_RemotePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkId_RemotePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (leaf): Link packet loss as a percentage of the total traffic
// sent over a configurable interval. The basic unit is
// 0.000003%, where (2^24 - 2) is 50.331642%. This value
// is the highest packet-loss percentage that can be
// expressed (the assumption being that precision is more
// important on high-speed links than the ability to
// advertise loss rates greater than this, and that high-
// speed links with over 50% loss are unusable).
// Therefore, measured values that are larger than the
// field maximum SHOULD be encoded as the maximum
// value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPath) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkLoss (leaf): Link packet loss as a percentage of the total traffic
// sent over a configurable interval. The basic unit is
// 0.000003%, where (2^24 - 2) is 50.331642%. This value
// is the highest packet-loss percentage that can be
// expressed (the assumption being that precision is more
// important on high-speed links than the ability to
// advertise loss rates greater than this, and that high-
// speed links with over 50% loss are unusable).
// Therefore, measured values that are larger than the
// field maximum SHOULD be encoded as the maximum
// value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-loss"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-loss/state/link-loss"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLossPathAny) LinkLoss() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkLoss_LinkLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny struct {
	*ygot.NodePath
}

// Type (leaf): Link protection capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionType_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Link protection capabilities.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/link-protection-type/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionTypePathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_LinkProtectionType_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The maximum bandwidth that can be used on this link
// in this direction (from the system originating the LSP
// to its neighbors).  It is encoded in 32 bits in IEEE
// floating point format.  The units are bytes (not
// bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The maximum bandwidth that can be used on this link
// in this direction (from the system originating the LSP
// to its neighbors).  It is encoded in 32 bits in IEEE
// floating point format.  The units are bytes (not
// bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxLinkBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The maximum amount of bandwidth that can be reserved
// in this direction on this link.  Note that for
// oversubscription purposes,  this can be greater than
// the bandwidth of the link. It is encoded  in 32 bits
// in IEEE floating point format.  The units are bytes
// (not bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The maximum amount of bandwidth that can be reserved
// in this direction on this link.  Note that for
// oversubscription purposes,  this can be greater than
// the bandwidth of the link. It is encoded  in 32 bits
// in IEEE floating point format.  The units are bytes
// (not bits!) per second.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/max-reservable-link-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MaxReservableLinkBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny struct {
	*ygot.NodePath
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// ABit (leaf): The A bit is set when the measured value of this parameter
// exceeds its configured maximum threshold. The A bit is cleared
// when the measured value falls below its configured reuse
// threshold.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/a-bit"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/a-bit"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) ABit() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_ABitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "a-bit"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxDelay (leaf): Maximum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) MaxDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxDelay (leaf): Maximum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/max-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) MaxDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MaxDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinDelay (leaf): Minimum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/min-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPath) MinDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "min-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinDelay (leaf): Minimum measured link delay value(in microseconds)
// between two directly connected IS-IS neighbors over a
// configurable interval.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/min-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/min-max-link-delay/state/min-delay"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelayPathAny) MinDelay() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_MinMaxLinkDelay_MinDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "min-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): Residual bandwidth on a link,forwarding adjacency
// [RFC4206], or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, residual bandwidth is defined to
// be the Maximum Bandwidth [RFC5305] minus the bandwidth
// currently allocated to RSVP-TE label switched paths.
// For a bundled link, residual bandwidth is defined to
// be the sum of the component link residual
// bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): Residual bandwidth on a link,forwarding adjacency
// [RFC4206], or bundled link in IEEE floating-point
// format with units of bytes per second. For a link or
// forwarding adjacency, residual bandwidth is defined to
// be the Maximum Bandwidth [RFC5305] minus the bandwidth
// currently allocated to RSVP-TE label switched paths.
// For a bundled link, residual bandwidth is defined to
// be the sum of the component link residual
// bandwidths.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/residual-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_ResidualBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The amount of bandwidth reservable in this
// direction on this link. Note that for
// oversubscription purposes, this can be greater than
// the bandwidth of the link. It contains eight 32-bit
// IEEE floating point numbers(one for each priority).
// The units are bytes (not bits!) per second. The
// values correspond to the bandwidth that can be
// reserved with a setup priority of 0 through 7,
// arranged in increasing order with priority 0
// occurring at the start of the sub-TLV, and priority
// 7 at the end of the sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The amount of bandwidth reservable in this
// direction on this link. Note that for
// oversubscription purposes, this can be greater than
// the bandwidth of the link. It contains eight 32-bit
// IEEE floating point numbers(one for each priority).
// The units are bytes (not bits!) per second. The
// values correspond to the bandwidth that can be
// reserved with a setup priority of 0 through 7,
// arranged in increasing order with priority 0
// occurring at the start of the sub-TLV, and priority
// 7 at the end of the sub-TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Setup priority level of 0 through 7 to be used by
// Unreserved Bandwidth sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPath) Priority() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): Setup priority level of 0 through 7 to be used by
// Unreserved Bandwidth sub-TLV 11.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unreserved-bandwidth/setup-priority/state/priority"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriorityPathAny) Priority() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_SetupPriority_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): This metric is administratively assigned and can be
// used to present a differently weighted topology to
// traffic engineering SPF calculations. To preclude
// overflow within a traffic engineering SPF
// implementation, all metrics greater than or equal to
// MAX_PATH_METRIC SHALL be considered to have a metric
// of MAX_PATH_METRIC.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPath) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): This metric is administratively assigned and can be
// used to present a differently weighted topology to
// traffic engineering SPF calculations. To preclude
// overflow within a traffic engineering SPF
// implementation, all metrics greater than or equal to
// MAX_PATH_METRIC SHALL be considered to have a metric
// of MAX_PATH_METRIC.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/te-default-metric/state/metric"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetricPathAny) Metric() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_TeDefaultMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny struct {
	*ygot.NodePath
}

// Count (leaf): Unconstrained TE LSP count(TE Label Switched Paths
// (LSPs) signalled with zero bandwidth).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPath) Count() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "count"},
			map[string]interface{}{},
			n,
		),
	}
}

// Count (leaf): Unconstrained TE LSP count(TE Label Switched Paths
// (LSPs) signalled with zero bandwidth).
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny) Count() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_CountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "count"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/unconstrained-lsp/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLspPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UnconstrainedLsp_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny struct {
	*ygot.NodePath
}

// Bandwidth (leaf): The bandwidth utilization on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second.  For a link or
// forwarding adjacency, bandwidth utilization represents
// the actual utilization of the link (i.e., as measured
// by the advertising node).  For a bundled link,
// bandwidth utilization is defined to be the sum of the
// component link bandwidth utilizations.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPath) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bandwidth (leaf): The bandwidth utilization on a link, forwarding
// adjacency, or bundled link in IEEE floating-point
// format with units of bytes per second.  For a link or
// forwarding adjacency, bandwidth utilization represents
// the actual utilization of the link (i.e., as measured
// by the advertising node).  For a bundled link,
// bandwidth utilization is defined to be the sum of the
// component link bandwidth utilizations.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/bandwidth"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny) Bandwidth() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_BandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of subTLV being described. The type of subTLV is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/subtlvs/subtlv/utilized-bandwidth/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidthPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_Subtlv_UtilizedBandwidth_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/mt-isn/neighbors/neighbor/instances/instance/undefined-subtlvs/undefined-subtlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MtIsn_Neighbor_Instance_UndefinedSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPathAny struct {
	*ygot.NodePath
}

// TopologyAny (list): This list describes a topology.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "topologies/topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology"
// MtId (wildcarded): uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPath) TopologyAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"topologies", "topology"},
			map[string]interface{}{"mt-id": "*"},
			n,
		),
	}
}

// TopologyAny (list): This list describes a topology.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "topologies/topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology"
// MtId (wildcarded): uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPathAny) TopologyAny() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"topologies", "topology"},
			map[string]interface{}{"mt-id": "*"},
			n,
		),
	}
}

// Topology (list): This list describes a topology.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "topologies/topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology"
// MtId: uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPath) Topology(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPath{
		NodePath: ygot.NewNodePath(
			[]string{"topologies", "topology"},
			map[string]interface{}{"mt-id": MtId},
			n,
		),
	}
}

// Topology (list): This list describes a topology.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "topologies/topology"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology"
// MtId: uint16
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopologyPathAny) Topology(MtId uint16) *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"topologies", "topology"},
			map[string]interface{}{"mt-id": MtId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_AttributesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology/state/attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_AttributesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_AttributesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology/state/attributes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_AttributesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_MtIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_MtIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_MtIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology/state/mt-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_MtIdPathAny struct {
	*ygot.NodePath
}

// Attributes (leaf): Attributes of the LSP for the associated
// topology.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology/state/attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPath) Attributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_AttributesPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_AttributesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Attributes (leaf): Attributes of the LSP for the associated
// topology.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attributes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology/state/attributes"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny) Attributes() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_AttributesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_AttributesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attributes"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtId (leaf): Multi-topology ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPath) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_MtIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_MtIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MtId (leaf): Multi-topology ID.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mt-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/multi-topology/topologies/topology/state/mt-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_TopologyPathAny) MtId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_MtIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_MultiTopology_Topology_MtIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mt-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/nlpid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/nlpid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Nlpid_NlpidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/nlpid/state/nlpid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Nlpid_NlpidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Nlpid_NlpidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/nlpid/state/nlpid YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Nlpid_NlpidPathAny struct {
	*ygot.NodePath
}

// Nlpid (leaf): Protocol supported. IPv4 is defined as (0xcc) and IPv6 -
// (0x8e)
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/nlpid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/nlpid/state/nlpid"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPath) Nlpid() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Nlpid_NlpidPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Nlpid_NlpidPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "nlpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Nlpid (leaf): Protocol supported. IPv4 is defined as (0xcc) and IPv6 -
// (0x8e)
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/nlpid"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/nlpid/state/nlpid"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_NlpidPathAny) Nlpid() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Nlpid_NlpidPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_Nlpid_NlpidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "nlpid"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_ReceivedSystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/received-system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_ReceivedSystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_ReceivedSystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/received-system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_ReceivedSystemIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SourceSystemIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/source-system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SourceSystemIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SourceSystemIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/source-system-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SourceSystemIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SystemIdCountPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/system-id-count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SystemIdCountPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SystemIdCountPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/system-id-count YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SystemIdCountPathAny struct {
	*ygot.NodePath
}

// ReceivedSystemId (leaf): System ID of the Intermediate System from which the
// purge was received.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received-system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/received-system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPath) ReceivedSystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_ReceivedSystemIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_ReceivedSystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received-system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ReceivedSystemId (leaf): System ID of the Intermediate System from which the
// purge was received.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/received-system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/received-system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPathAny) ReceivedSystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_ReceivedSystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_ReceivedSystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "received-system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceSystemId (leaf): System ID of the Intermediate System that inserted
// this TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/source-system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPath) SourceSystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SourceSystemIdPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SourceSystemIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceSystemId (leaf): System ID of the Intermediate System that inserted
// this TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/source-system-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/source-system-id"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPathAny) SourceSystemId() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SourceSystemIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SourceSystemIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "source-system-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemIdCount (leaf): Number of system IDs carried in this TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id-count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/system-id-count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPath) SystemIdCount() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SystemIdCountPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SystemIdCountPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemIdCount (leaf): Number of system IDs carried in this TLV.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/system-id-count"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/tlvs/tlv/purge-oi/state/system-id-count"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOiPathAny) SystemIdCount() *NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SystemIdCountPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_Tlv_PurgeOi_SystemIdCountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-id-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPath) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_LengthPath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): TLV length.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/length"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny) Length() *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_LengthPathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPath) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_TypePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): TLV Type.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/type"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny) Type() *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_TypePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPath) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_ValuePath {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): TLV value.
// ----------------------------------------
// Defining module: "openconfig-isis-lsp"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/link-state-database/lsp/undefined-tlvs/undefined-tlv/state/value"
func (n *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlvPathAny) Value() *NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_ValuePathAny {
	return &NetworkInstance_Protocol_Isis_Level_Lsp_UndefinedTlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_RoutePreferencePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference YANG schema element.
type NetworkInstance_Protocol_Isis_Level_RoutePreferencePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_RoutePreferencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference YANG schema element.
type NetworkInstance_Protocol_Isis_Level_RoutePreferencePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_RoutePreference_ExternalRoutePreferencePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference/config/external-route-preference YANG schema element.
type NetworkInstance_Protocol_Isis_Level_RoutePreference_ExternalRoutePreferencePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_RoutePreference_ExternalRoutePreferencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference/config/external-route-preference YANG schema element.
type NetworkInstance_Protocol_Isis_Level_RoutePreference_ExternalRoutePreferencePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_RoutePreference_InternalRoutePreferencePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference/config/internal-route-preference YANG schema element.
type NetworkInstance_Protocol_Isis_Level_RoutePreference_InternalRoutePreferencePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_RoutePreference_InternalRoutePreferencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference/config/internal-route-preference YANG schema element.
type NetworkInstance_Protocol_Isis_Level_RoutePreference_InternalRoutePreferencePathAny struct {
	*ygot.NodePath
}

// ExternalRoutePreference (leaf): Administrative Distance(preference) for external ISIS routes.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/external-route-preference"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference/config/external-route-preference"
func (n *NetworkInstance_Protocol_Isis_Level_RoutePreferencePath) ExternalRoutePreference() *NetworkInstance_Protocol_Isis_Level_RoutePreference_ExternalRoutePreferencePath {
	return &NetworkInstance_Protocol_Isis_Level_RoutePreference_ExternalRoutePreferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "external-route-preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalRoutePreference (leaf): Administrative Distance(preference) for external ISIS routes.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/external-route-preference"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference/config/external-route-preference"
func (n *NetworkInstance_Protocol_Isis_Level_RoutePreferencePathAny) ExternalRoutePreference() *NetworkInstance_Protocol_Isis_Level_RoutePreference_ExternalRoutePreferencePathAny {
	return &NetworkInstance_Protocol_Isis_Level_RoutePreference_ExternalRoutePreferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "external-route-preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalRoutePreference (leaf): Administrative Distance(preference) for internal ISIS routes.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/internal-route-preference"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference/config/internal-route-preference"
func (n *NetworkInstance_Protocol_Isis_Level_RoutePreferencePath) InternalRoutePreference() *NetworkInstance_Protocol_Isis_Level_RoutePreference_InternalRoutePreferencePath {
	return &NetworkInstance_Protocol_Isis_Level_RoutePreference_InternalRoutePreferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "internal-route-preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// InternalRoutePreference (leaf): Administrative Distance(preference) for internal ISIS routes.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/internal-route-preference"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/route-preference/config/internal-route-preference"
func (n *NetworkInstance_Protocol_Isis_Level_RoutePreferencePathAny) InternalRoutePreference() *NetworkInstance_Protocol_Isis_Level_RoutePreference_InternalRoutePreferencePathAny {
	return &NetworkInstance_Protocol_Isis_Level_RoutePreference_InternalRoutePreferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "internal-route-preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthFailsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/auth-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthFailsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthFailsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/auth-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthFailsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthTypeFailsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/auth-type-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthTypeFailsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthTypeFailsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/auth-type-fails YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthTypeFailsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_CorruptedLspsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/corrupted-lsps YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_CorruptedLspsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_CorruptedLspsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/corrupted-lsps YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_CorruptedLspsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_DatabaseOverloadsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/database-overloads YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_DatabaseOverloadsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_DatabaseOverloadsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/database-overloads YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_DatabaseOverloadsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ExceedMaxSeqNumsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/exceed-max-seq-nums YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ExceedMaxSeqNumsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ExceedMaxSeqNumsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/exceed-max-seq-nums YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ExceedMaxSeqNumsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_IdLenMismatchPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/id-len-mismatch YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_IdLenMismatchPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_IdLenMismatchPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/id-len-mismatch YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_IdLenMismatchPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_LspErrorsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/lsp-errors YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_LspErrorsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_LspErrorsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/lsp-errors YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_LspErrorsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ManualAddressDropFromAreasPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/manual-address-drop-from-areas YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ManualAddressDropFromAreasPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ManualAddressDropFromAreasPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/manual-address-drop-from-areas YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ManualAddressDropFromAreasPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_MaxAreaAddressMismatchesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/max-area-address-mismatches YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_MaxAreaAddressMismatchesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_MaxAreaAddressMismatchesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/max-area-address-mismatches YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_MaxAreaAddressMismatchesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_OwnLspPurgesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/own-lsp-purges YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_OwnLspPurgesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_OwnLspPurgesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/own-lsp-purges YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_OwnLspPurgesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_PartChangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/part-changes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_PartChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_PartChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/part-changes YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_PartChangesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SeqNumSkipsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/seq-num-skips YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SeqNumSkipsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SeqNumSkipsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/seq-num-skips YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SeqNumSkipsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SpfRunsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/spf-runs YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SpfRunsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SpfRunsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/spf-runs YANG schema element.
type NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SpfRunsPathAny struct {
	*ygot.NodePath
}

// AuthFails (leaf): The number of authentication key failures.
// MIB Entry: SysAuthFails.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auth-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/auth-fails"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) AuthFails() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthFailsPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthFailsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthFails (leaf): The number of authentication key failures.
// MIB Entry: SysAuthFails.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auth-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/auth-fails"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) AuthFails() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthFailsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthFailsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthTypeFails (leaf): The number of authentication type mismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auth-type-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/auth-type-fails"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) AuthTypeFails() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthTypeFailsPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthTypeFailsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-type-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthTypeFails (leaf): The number of authentication type mismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/auth-type-fails"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/auth-type-fails"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) AuthTypeFails() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthTypeFailsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_AuthTypeFailsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-type-fails"},
			map[string]interface{}{},
			n,
		),
	}
}

// CorruptedLsps (leaf): Number of corrupted in-memory LSPs detected. LSPs received from the
// wire with a bad checksum are silently dropped and not counted. LSPs
// received from the wire with parse errors are counted by lsp-errors. MIB
// Entry: SysCorrLSPs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/corrupted-lsps"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/corrupted-lsps"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) CorruptedLsps() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_CorruptedLspsPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_CorruptedLspsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "corrupted-lsps"},
			map[string]interface{}{},
			n,
		),
	}
}

// CorruptedLsps (leaf): Number of corrupted in-memory LSPs detected. LSPs received from the
// wire with a bad checksum are silently dropped and not counted. LSPs
// received from the wire with parse errors are counted by lsp-errors. MIB
// Entry: SysCorrLSPs.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/corrupted-lsps"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/corrupted-lsps"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) CorruptedLsps() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_CorruptedLspsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_CorruptedLspsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "corrupted-lsps"},
			map[string]interface{}{},
			n,
		),
	}
}

// DatabaseOverloads (leaf): Number of times the database has become
// overloaded.
// MIB entry: SysLSPL(Level)DbaseOloads.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/database-overloads"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/database-overloads"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) DatabaseOverloads() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_DatabaseOverloadsPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_DatabaseOverloadsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "database-overloads"},
			map[string]interface{}{},
			n,
		),
	}
}

// DatabaseOverloads (leaf): Number of times the database has become
// overloaded.
// MIB entry: SysLSPL(Level)DbaseOloads.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/database-overloads"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/database-overloads"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) DatabaseOverloads() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_DatabaseOverloadsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_DatabaseOverloadsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "database-overloads"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExceedMaxSeqNums (leaf): The number of times the system has attempted to exceed the maximum
// sequence number. MIB Entry: SysAttmptToExMaxSeqNums.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/exceed-max-seq-nums"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/exceed-max-seq-nums"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) ExceedMaxSeqNums() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ExceedMaxSeqNumsPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ExceedMaxSeqNumsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "exceed-max-seq-nums"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExceedMaxSeqNums (leaf): The number of times the system has attempted to exceed the maximum
// sequence number. MIB Entry: SysAttmptToExMaxSeqNums.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/exceed-max-seq-nums"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/exceed-max-seq-nums"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) ExceedMaxSeqNums() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ExceedMaxSeqNumsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ExceedMaxSeqNumsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "exceed-max-seq-nums"},
			map[string]interface{}{},
			n,
		),
	}
}

// IdLenMismatch (leaf): Number of times a PDU is received with a different value for ID field
// length from that of the receiving system. MIB Entry:
// isisSysIDFieldLenMismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id-len-mismatch"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/id-len-mismatch"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) IdLenMismatch() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_IdLenMismatchPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_IdLenMismatchPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id-len-mismatch"},
			map[string]interface{}{},
			n,
		),
	}
}

// IdLenMismatch (leaf): Number of times a PDU is received with a different value for ID field
// length from that of the receiving system. MIB Entry:
// isisSysIDFieldLenMismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id-len-mismatch"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/id-len-mismatch"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) IdLenMismatch() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_IdLenMismatchPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_IdLenMismatchPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id-len-mismatch"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspErrors (leaf): The number of received LSPs with errors.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lsp-errors"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/lsp-errors"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) LspErrors() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_LspErrorsPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_LspErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lsp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// LspErrors (leaf): The number of received LSPs with errors.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/lsp-errors"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/lsp-errors"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) LspErrors() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_LspErrorsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_LspErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "lsp-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManualAddressDropFromAreas (leaf): Number of times a manual address has been dropped from area.
// MIB Entry: SysManAddrDropFromAreas.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/manual-address-drop-from-areas"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/manual-address-drop-from-areas"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) ManualAddressDropFromAreas() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ManualAddressDropFromAreasPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ManualAddressDropFromAreasPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "manual-address-drop-from-areas"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManualAddressDropFromAreas (leaf): Number of times a manual address has been dropped from area.
// MIB Entry: SysManAddrDropFromAreas.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/manual-address-drop-from-areas"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/manual-address-drop-from-areas"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) ManualAddressDropFromAreas() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ManualAddressDropFromAreasPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_ManualAddressDropFromAreasPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "manual-address-drop-from-areas"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAreaAddressMismatches (leaf): Number of times a PDU is received with a different value for
// MaximumAreaAddresses from that of the receiving system. MIB Entry:
// SysMaxAreaAddrMismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-area-address-mismatches"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/max-area-address-mismatches"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) MaxAreaAddressMismatches() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_MaxAreaAddressMismatchesPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_MaxAreaAddressMismatchesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-area-address-mismatches"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAreaAddressMismatches (leaf): Number of times a PDU is received with a different value for
// MaximumAreaAddresses from that of the receiving system. MIB Entry:
// SysMaxAreaAddrMismatches.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/max-area-address-mismatches"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/max-area-address-mismatches"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) MaxAreaAddressMismatches() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_MaxAreaAddressMismatchesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_MaxAreaAddressMismatchesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "max-area-address-mismatches"},
			map[string]interface{}{},
			n,
		),
	}
}

// OwnLspPurges (leaf): Number of times a zero-aged copy of the system's
// own LSP is received from some other node.
// MIB Entry: isisSysOwnLSPPurges.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/own-lsp-purges"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/own-lsp-purges"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) OwnLspPurges() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_OwnLspPurgesPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_OwnLspPurgesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "own-lsp-purges"},
			map[string]interface{}{},
			n,
		),
	}
}

// OwnLspPurges (leaf): Number of times a zero-aged copy of the system's
// own LSP is received from some other node.
// MIB Entry: isisSysOwnLSPPurges.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/own-lsp-purges"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/own-lsp-purges"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) OwnLspPurges() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_OwnLspPurgesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_OwnLspPurgesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "own-lsp-purges"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartChanges (leaf): The number of partition changes detected. MIB Entry: SysPartChanges.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/part-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/part-changes"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) PartChanges() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_PartChangesPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_PartChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "part-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// PartChanges (leaf): The number of partition changes detected. MIB Entry: SysPartChanges.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/part-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/part-changes"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) PartChanges() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_PartChangesPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_PartChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "part-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// SeqNumSkips (leaf): Number of times a sequence number skip has occurred. MIB Entry:
// SysSeqNumSkips.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/seq-num-skips"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/seq-num-skips"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) SeqNumSkips() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SeqNumSkipsPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SeqNumSkipsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "seq-num-skips"},
			map[string]interface{}{},
			n,
		),
	}
}

// SeqNumSkips (leaf): Number of times a sequence number skip has occurred. MIB Entry:
// SysSeqNumSkips.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/seq-num-skips"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/seq-num-skips"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) SeqNumSkips() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SeqNumSkipsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SeqNumSkipsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "seq-num-skips"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfRuns (leaf): The number of times SPF was ran at this level.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/spf-runs"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/spf-runs"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPath) SpfRuns() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SpfRunsPath {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SpfRunsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "spf-runs"},
			map[string]interface{}{},
			n,
		),
	}
}

// SpfRuns (leaf): The number of times SPF was ran at this level.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/spf-runs"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/system-level-counters/state/spf-runs"
func (n *NetworkInstance_Protocol_Isis_Level_SystemLevelCountersPathAny) SpfRuns() *NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SpfRunsPathAny {
	return &NetworkInstance_Protocol_Isis_Level_SystemLevelCounters_SpfRunsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "spf-runs"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering YANG schema element.
type NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering YANG schema element.
type NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_TrafficEngineering_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Level_TrafficEngineering_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_TrafficEngineering_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/enabled YANG schema element.
type NetworkInstance_Protocol_Isis_Level_TrafficEngineering_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv4RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/ipv4-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv4RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv4RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/ipv4-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv4RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv6RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/ipv6-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv6RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv6RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/ipv6-router-id YANG schema element.
type NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv6RouterIdPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPath) Enabled() *NetworkInstance_Protocol_Isis_Level_TrafficEngineering_EnabledPath {
	return &NetworkInstance_Protocol_Isis_Level_TrafficEngineering_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this leaf is
// defined is enabled, when set to false it is explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/enabled"
func (n *NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPathAny) Enabled() *NetworkInstance_Protocol_Isis_Level_TrafficEngineering_EnabledPathAny {
	return &NetworkInstance_Protocol_Isis_Level_TrafficEngineering_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4RouterId (leaf): IPv4 MPLS Traffic Engineering Router-ID.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ipv4-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/ipv4-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPath) Ipv4RouterId() *NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv4RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv4RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv4-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4RouterId (leaf): IPv4 MPLS Traffic Engineering Router-ID.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ipv4-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/ipv4-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPathAny) Ipv4RouterId() *NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv4RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv4RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv4-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6RouterId (leaf): IPv6 MPLS Traffic Engineering Router-ID.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ipv6-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/ipv6-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPath) Ipv6RouterId() *NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv6RouterIdPath {
	return &NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv6RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv6-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6RouterId (leaf): IPv6 MPLS Traffic Engineering Router-ID.
// ----------------------------------------
// Defining module: "openconfig-isis"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ipv6-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/isis/levels/level/traffic-engineering/config/ipv6-router-id"
func (n *NetworkInstance_Protocol_Isis_Level_TrafficEngineeringPathAny) Ipv6RouterId() *NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv6RouterIdPathAny {
	return &NetworkInstance_Protocol_Isis_Level_TrafficEngineering_Ipv6RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv6-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2Path represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2 YANG schema element.
type NetworkInstance_Protocol_Ospfv2Path struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2PathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2 YANG schema element.
type NetworkInstance_Protocol_Ospfv2PathAny struct {
	*ygot.NodePath
}

// AreaAny (list): The OSPFv2 areas within which the local system exists
// ----------------------------------------
// Defining module: "openconfig-ospfv2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "areas/area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area"
// Identifier (wildcarded): [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2Path) AreaAny() *NetworkInstance_Protocol_Ospfv2_AreaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_AreaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"areas", "area"},
			map[string]interface{}{"identifier": "*"},
			n,
		),
	}
}

// AreaAny (list): The OSPFv2 areas within which the local system exists
// ----------------------------------------
// Defining module: "openconfig-ospfv2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "areas/area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area"
// Identifier (wildcarded): [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2PathAny) AreaAny() *NetworkInstance_Protocol_Ospfv2_AreaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_AreaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"areas", "area"},
			map[string]interface{}{"identifier": "*"},
			n,
		),
	}
}

// Area (list): The OSPFv2 areas within which the local system exists
// ----------------------------------------
// Defining module: "openconfig-ospfv2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "areas/area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area"
// Identifier: [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2Path) Area(Identifier NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union) *NetworkInstance_Protocol_Ospfv2_AreaPath {
	return &NetworkInstance_Protocol_Ospfv2_AreaPath{
		NodePath: ygot.NewNodePath(
			[]string{"areas", "area"},
			map[string]interface{}{"identifier": Identifier},
			n,
		),
	}
}

// Area (list): The OSPFv2 areas within which the local system exists
// ----------------------------------------
// Defining module: "openconfig-ospfv2"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "areas/area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area"
// Identifier: [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2PathAny) Area(Identifier NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union) *NetworkInstance_Protocol_Ospfv2_AreaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_AreaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"areas", "area"},
			map[string]interface{}{"identifier": Identifier},
			n,
		),
	}
}

// Global (container): Configuration and operational state parameters for settings
// that are global to the OSPFv2 instance
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global"
func (n *NetworkInstance_Protocol_Ospfv2Path) Global() *NetworkInstance_Protocol_Ospfv2_GlobalPath {
	return &NetworkInstance_Protocol_Ospfv2_GlobalPath{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// Global (container): Configuration and operational state parameters for settings
// that are global to the OSPFv2 instance
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global"
func (n *NetworkInstance_Protocol_Ospfv2PathAny) Global() *NetworkInstance_Protocol_Ospfv2_GlobalPathAny {
	return &NetworkInstance_Protocol_Ospfv2_GlobalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_AreaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area YANG schema element.
type NetworkInstance_Protocol_Ospfv2_AreaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_AreaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area YANG schema element.
type NetworkInstance_Protocol_Ospfv2_AreaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_IdentifierPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/config/identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_IdentifierPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_IdentifierPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/config/identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_IdentifierPathAny struct {
	*ygot.NodePath
}

// Identifier (leaf): An identifier for the OSPFv2 area - described as either a
// 32-bit unsigned integer, or a dotted-quad
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/config/identifier"
func (n *NetworkInstance_Protocol_Ospfv2_AreaPath) Identifier() *NetworkInstance_Protocol_Ospfv2_Area_IdentifierPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_IdentifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// Identifier (leaf): An identifier for the OSPFv2 area - described as either a
// 32-bit unsigned integer, or a dotted-quad
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/config/identifier"
func (n *NetworkInstance_Protocol_Ospfv2_AreaPathAny) Identifier() *NetworkInstance_Protocol_Ospfv2_Area_IdentifierPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_IdentifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces which are enabled within this area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface"
// Id (wildcarded): string
func (n *NetworkInstance_Protocol_Ospfv2_AreaPath) InterfaceAny() *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces which are enabled within this area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface"
// Id (wildcarded): string
func (n *NetworkInstance_Protocol_Ospfv2_AreaPathAny) InterfaceAny() *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Interface (list): List of interfaces which are enabled within this area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface"
// Id: string
func (n *NetworkInstance_Protocol_Ospfv2_AreaPath) Interface(Id string) *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Interface (list): List of interfaces which are enabled within this area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface"
// Id: string
func (n *NetworkInstance_Protocol_Ospfv2_AreaPathAny) Interface(Id string) *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Lsdb (container): The link-state database for the OSPFv2 area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsdb"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb"
func (n *NetworkInstance_Protocol_Ospfv2_AreaPath) Lsdb() *NetworkInstance_Protocol_Ospfv2_Area_LsdbPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_LsdbPath{
		NodePath: ygot.NewNodePath(
			[]string{"lsdb"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lsdb (container): The link-state database for the OSPFv2 area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsdb"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb"
func (n *NetworkInstance_Protocol_Ospfv2_AreaPathAny) Lsdb() *NetworkInstance_Protocol_Ospfv2_Area_LsdbPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_LsdbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsdb"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): Configuration and operational state parameters for OSPFv2
// extensions relating to MPLS
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/mpls"
func (n *NetworkInstance_Protocol_Ospfv2_AreaPath) Mpls() *NetworkInstance_Protocol_Ospfv2_Area_MplsPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_MplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): Configuration and operational state parameters for OSPFv2
// extensions relating to MPLS
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/mpls"
func (n *NetworkInstance_Protocol_Ospfv2_AreaPathAny) Mpls() *NetworkInstance_Protocol_Ospfv2_Area_MplsPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_MplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// VirtualLinkAny (list): Configuration and state parameters relating to a
// virtual link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "virtual-links/virtual-link"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link"
// RemoteRouterId (wildcarded): string
func (n *NetworkInstance_Protocol_Ospfv2_AreaPath) VirtualLinkAny() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"virtual-links", "virtual-link"},
			map[string]interface{}{"remote-router-id": "*"},
			n,
		),
	}
}

// VirtualLinkAny (list): Configuration and state parameters relating to a
// virtual link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "virtual-links/virtual-link"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link"
// RemoteRouterId (wildcarded): string
func (n *NetworkInstance_Protocol_Ospfv2_AreaPathAny) VirtualLinkAny() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"virtual-links", "virtual-link"},
			map[string]interface{}{"remote-router-id": "*"},
			n,
		),
	}
}

// VirtualLink (list): Configuration and state parameters relating to a
// virtual link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "virtual-links/virtual-link"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link"
// RemoteRouterId: string
func (n *NetworkInstance_Protocol_Ospfv2_AreaPath) VirtualLink(RemoteRouterId string) *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath{
		NodePath: ygot.NewNodePath(
			[]string{"virtual-links", "virtual-link"},
			map[string]interface{}{"remote-router-id": RemoteRouterId},
			n,
		),
	}
}

// VirtualLink (list): Configuration and state parameters relating to a
// virtual link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "virtual-links/virtual-link"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link"
// RemoteRouterId: string
func (n *NetworkInstance_Protocol_Ospfv2_AreaPathAny) VirtualLink(RemoteRouterId string) *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"virtual-links", "virtual-link"},
			map[string]interface{}{"remote-router-id": RemoteRouterId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_AuthenticationTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/authentication-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_AuthenticationTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_AuthenticationTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/authentication-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_AuthenticationTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_HideNetworkPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/hide-network YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_HideNetworkPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_HideNetworkPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/hide-network YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_HideNetworkPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_IdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_MultiAreaAdjacencyPrimaryPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/multi-area-adjacency-primary YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_MultiAreaAdjacencyPrimaryPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_MultiAreaAdjacencyPrimaryPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/multi-area-adjacency-primary YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_MultiAreaAdjacencyPrimaryPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_NetworkTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/network-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_NetworkTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_NetworkTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/network-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_NetworkTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_PassivePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/passive YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_PassivePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_PassivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/passive YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_PassivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/priority YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/priority YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_PriorityPathAny struct {
	*ygot.NodePath
}

// AuthenticationType (leaf): The type of authentication that should be used on this
// interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/authentication-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) AuthenticationType() *NetworkInstance_Protocol_Ospfv2_Area_Interface_AuthenticationTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_AuthenticationTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationType (leaf): The type of authentication that should be used on this
// interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/authentication-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/authentication-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) AuthenticationType() *NetworkInstance_Protocol_Ospfv2_Area_Interface_AuthenticationTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_AuthenticationTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/enable-bfd"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) EnableBfd() *NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPath{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/enable-bfd"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) EnableBfd() *NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// HideNetwork (leaf): When this leaf is set to true, the network connected to
// the interface should be hidden from OSPFv2 advertisements
// per the procedure described in RFC6860.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hide-network"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/hide-network"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) HideNetwork() *NetworkInstance_Protocol_Ospfv2_Area_Interface_HideNetworkPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_HideNetworkPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hide-network"},
			map[string]interface{}{},
			n,
		),
	}
}

// HideNetwork (leaf): When this leaf is set to true, the network connected to
// the interface should be hidden from OSPFv2 advertisements
// per the procedure described in RFC6860.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hide-network"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/hide-network"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) HideNetwork() *NetworkInstance_Protocol_Ospfv2_Area_Interface_HideNetworkPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_HideNetworkPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hide-network"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): An operator-specified string utilised to uniquely
// reference this interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) Id() *NetworkInstance_Protocol_Ospfv2_Area_Interface_IdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): An operator-specified string utilised to uniquely
// reference this interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) Id() *NetworkInstance_Protocol_Ospfv2_Area_Interface_IdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) InterfaceRef() *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) InterfaceRef() *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// LsaFilter (container): OSPFv2 parameters relating to filtering of LSAs to
// neighbors the specified interface.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsa-filter"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/lsa-filter"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) LsaFilter() *NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPath{
		NodePath: ygot.NewNodePath(
			[]string{"lsa-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// LsaFilter (container): OSPFv2 parameters relating to filtering of LSAs to
// neighbors the specified interface.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsa-filter"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/lsa-filter"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) LsaFilter() *NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsa-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric for the interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Interface_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric for the interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Interface_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): Configuration and operational state parameters for
// OSPFv2 extensions related to MPLS on the interface.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) Mpls() *NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): Configuration and operational state parameters for
// OSPFv2 extensions related to MPLS on the interface.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) Mpls() *NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiAreaAdjacencyPrimary (leaf): When the specified interface is included in more than one
// area's configuration, this leaf marks whether the area should
// be considered the primary (when the value is true). In the
// case that this value is false, the area is considered a
// secondary area.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multi-area-adjacency-primary"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/multi-area-adjacency-primary"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) MultiAreaAdjacencyPrimary() *NetworkInstance_Protocol_Ospfv2_Area_Interface_MultiAreaAdjacencyPrimaryPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_MultiAreaAdjacencyPrimaryPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multi-area-adjacency-primary"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiAreaAdjacencyPrimary (leaf): When the specified interface is included in more than one
// area's configuration, this leaf marks whether the area should
// be considered the primary (when the value is true). In the
// case that this value is false, the area is considered a
// secondary area.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multi-area-adjacency-primary"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/multi-area-adjacency-primary"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) MultiAreaAdjacencyPrimary() *NetworkInstance_Protocol_Ospfv2_Area_Interface_MultiAreaAdjacencyPrimaryPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_MultiAreaAdjacencyPrimaryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multi-area-adjacency-primary"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): A neighbor with which an OSPFv2 adjacency has been
// established within this area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor"
// RouterId (wildcarded): string
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) NeighborAny() *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"router-id": "*"},
			n,
		),
	}
}

// NeighborAny (list): A neighbor with which an OSPFv2 adjacency has been
// established within this area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor"
// RouterId (wildcarded): string
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) NeighborAny() *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"router-id": "*"},
			n,
		),
	}
}

// Neighbor (list): A neighbor with which an OSPFv2 adjacency has been
// established within this area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor"
// RouterId: string
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) Neighbor(RouterId string) *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"router-id": RouterId},
			n,
		),
	}
}

// Neighbor (list): A neighbor with which an OSPFv2 adjacency has been
// established within this area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor"
// RouterId: string
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) Neighbor(RouterId string) *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"router-id": RouterId},
			n,
		),
	}
}

// NetworkType (leaf): The type of network that OSPFv2 should use for the specified
// interface.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/network-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/network-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) NetworkType() *NetworkInstance_Protocol_Ospfv2_Area_Interface_NetworkTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_NetworkTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "network-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkType (leaf): The type of network that OSPFv2 should use for the specified
// interface.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/network-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/network-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) NetworkType() *NetworkInstance_Protocol_Ospfv2_Area_Interface_NetworkTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_NetworkTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "network-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Passive (leaf): When this leaf is set to true, the interface should be
// advertised within the OSPF area but OSPF adjacencies should
// not be established over the interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/passive"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) Passive() *NetworkInstance_Protocol_Ospfv2_Area_Interface_PassivePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_PassivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Passive (leaf): When this leaf is set to true, the interface should be
// advertised within the OSPF area but OSPF adjacencies should
// not be established over the interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/passive"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/passive"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) Passive() *NetworkInstance_Protocol_Ospfv2_Area_Interface_PassivePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_PassivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "passive"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The local system's priority to become the designated
// router
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/priority"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) Priority() *NetworkInstance_Protocol_Ospfv2_Area_Interface_PriorityPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The local system's priority to become the designated
// router
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/config/priority"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) Priority() *NetworkInstance_Protocol_Ospfv2_Area_Interface_PriorityPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): Timers relating to OSPFv2 on the interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePath) Timers() *NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPath{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): Timers relating to OSPFv2 on the interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers"
func (n *NetworkInstance_Protocol_Ospfv2_Area_InterfacePathAny) Timers() *NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfd_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfd_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfd_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfd_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPath) Enabled() *NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfd_EnabledPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfd_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfdPathAny) Enabled() *NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfd_EnabledPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_EnableBfd_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPath) Interface() *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/lsa-filter YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/lsa-filter YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilter_AllPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/lsa-filter/config/all YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilter_AllPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilter_AllPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/lsa-filter/config/all YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilter_AllPathAny struct {
	*ygot.NodePath
}

// All (leaf): When this leaf is set to true, all LSAs should be
// filtered to the neighbours with whom adjacencies are
// formed on the interface.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/all"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/lsa-filter/config/all"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPath) All() *NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilter_AllPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilter_AllPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "all"},
			map[string]interface{}{},
			n,
		),
	}
}

// All (leaf): When this leaf is set to true, all LSAs should be
// filtered to the neighbours with whom adjacencies are
// formed on the interface.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/all"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/lsa-filter/config/all"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilterPathAny) All() *NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilter_AllPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_LsaFilter_AllPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "all"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_TrafficEngineeringMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/config/traffic-engineering-metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_TrafficEngineeringMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_TrafficEngineeringMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/config/traffic-engineering-metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_TrafficEngineeringMetricPathAny struct {
	*ygot.NodePath
}

// IgpLdpSync (container): OSPFv2 parameters relating to LDP/IGP synchronization
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-ldp-sync"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPath) IgpLdpSync() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPath{
		NodePath: ygot.NewNodePath(
			[]string{"igp-ldp-sync"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgpLdpSync (container): OSPFv2 parameters relating to LDP/IGP synchronization
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-ldp-sync"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPathAny) IgpLdpSync() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"igp-ldp-sync"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineeringMetric (leaf): A link metric that should only be considered for traffic
// engineering purposes.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/traffic-engineering-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/config/traffic-engineering-metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPath) TrafficEngineeringMetric() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_TrafficEngineeringMetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_TrafficEngineeringMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "traffic-engineering-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineeringMetric (leaf): A link metric that should only be considered for traffic
// engineering purposes.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/traffic-engineering-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/config/traffic-engineering-metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_MplsPathAny) TrafficEngineeringMetric() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_TrafficEngineeringMetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_TrafficEngineeringMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "traffic-engineering-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/config/enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/config/enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/config/post-session-up-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/config/post-session-up-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_SynchronizedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/state/synchronized YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_SynchronizedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_SynchronizedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/state/synchronized YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_SynchronizedPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, do not utilise this link for
// forwarding via the IGP until such time as LDP adjacencies to
// the neighbor(s) over the link are established.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/config/enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPath) Enabled() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_EnabledPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, do not utilise this link for
// forwarding via the IGP until such time as LDP adjacencies to
// the neighbor(s) over the link are established.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/config/enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPathAny) Enabled() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_EnabledPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostSessionUpDelay (leaf): This leaf specifies a delay, expressed in units of milliseconds,
// between the LDP session to the IGP neighbor being established, and
// it being considered synchronized by the IGP.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/post-session-up-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/config/post-session-up-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPath) PostSessionUpDelay() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "post-session-up-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostSessionUpDelay (leaf): This leaf specifies a delay, expressed in units of milliseconds,
// between the LDP session to the IGP neighbor being established, and
// it being considered synchronized by the IGP.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/post-session-up-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/config/post-session-up-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPathAny) PostSessionUpDelay() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_PostSessionUpDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "post-session-up-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// Synchronized (leaf): When the value of this leaf is set to true, the
// LDP neighbors reachable via this interface are considered
// to be synchronized, and hence the link is considered
// usable by the IGP.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/synchronized"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/state/synchronized"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPath) Synchronized() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_SynchronizedPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_SynchronizedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "synchronized"},
			map[string]interface{}{},
			n,
		),
	}
}

// Synchronized (leaf): When the value of this leaf is set to true, the
// LDP neighbors reachable via this interface are considered
// to be synchronized, and hence the link is considered
// usable by the IGP.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/synchronized"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/mpls/igp-ldp-sync/state/synchronized"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSyncPathAny) Synchronized() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_SynchronizedPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Mpls_IgpLdpSync_SynchronizedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "synchronized"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_AdjacencyStatePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/adjacency-state YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_AdjacencyStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_AdjacencyStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/adjacency-state YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_AdjacencyStatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_BackupDesignatedRouterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/backup-designated-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_BackupDesignatedRouterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_BackupDesignatedRouterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/backup-designated-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_BackupDesignatedRouterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DeadTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/dead-time YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DeadTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DeadTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/dead-time YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DeadTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DesignatedRouterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/designated-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DesignatedRouterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DesignatedRouterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/designated-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DesignatedRouterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_LastEstablishedTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/last-established-time YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_LastEstablishedTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_LastEstablishedTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/last-established-time YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_LastEstablishedTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/config/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/config/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_OptionalCapabilitiesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/optional-capabilities YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_OptionalCapabilitiesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_OptionalCapabilitiesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/optional-capabilities YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_OptionalCapabilitiesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/priority YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/priority YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_PriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RetransmissionQueueLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/retransmission-queue-length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RetransmissionQueueLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RetransmissionQueueLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/retransmission-queue-length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RetransmissionQueueLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/config/router-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/config/router-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_StateChangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/state-changes YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_StateChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_StateChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/state-changes YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_StateChangesPathAny struct {
	*ygot.NodePath
}

// AdjacencyState (leaf): The state of the adjacency with the neighbor.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-state"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/adjacency-state"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) AdjacencyState() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_AdjacencyStatePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_AdjacencyStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjacencyState (leaf): The state of the adjacency with the neighbor.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-state"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/adjacency-state"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) AdjacencyState() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_AdjacencyStatePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_AdjacencyStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// BackupDesignatedRouter (leaf): The backup designated router for the adjacency.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup-designated-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/backup-designated-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) BackupDesignatedRouter() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_BackupDesignatedRouterPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_BackupDesignatedRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup-designated-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// BackupDesignatedRouter (leaf): The backup designated router for the adjacency.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup-designated-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/backup-designated-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) BackupDesignatedRouter() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_BackupDesignatedRouterPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_BackupDesignatedRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup-designated-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// DeadTime (leaf): The time at which this neighbor's adjacency will be
// considered dead. The value is expressed relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dead-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/dead-time"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) DeadTime() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DeadTimePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DeadTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dead-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// DeadTime (leaf): The time at which this neighbor's adjacency will be
// considered dead. The value is expressed relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dead-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/dead-time"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) DeadTime() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DeadTimePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DeadTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dead-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRouter (leaf): The designated router for the adjacency. This device
// advertises the Network LSA for broadcast and NBMA networks.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/designated-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/designated-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) DesignatedRouter() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DesignatedRouterPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DesignatedRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRouter (leaf): The designated router for the adjacency. This device
// advertises the Network LSA for broadcast and NBMA networks.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/designated-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/designated-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) DesignatedRouter() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DesignatedRouterPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_DesignatedRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastEstablishedTime (leaf): The time at which the adjacency was last established with
// the neighbor. That is to say the time at which the
// adjacency last transitioned into the FULL state. The
// value is expressed relative to the Unix Epoch (Jan 1 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-established-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/last-established-time"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) LastEstablishedTime() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_LastEstablishedTimePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_LastEstablishedTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-established-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastEstablishedTime (leaf): The time at which the adjacency was last established with
// the neighbor. That is to say the time at which the
// adjacency last transitioned into the FULL state. The
// value is expressed relative to the Unix Epoch (Jan 1 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-established-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/last-established-time"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) LastEstablishedTime() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_LastEstablishedTimePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_LastEstablishedTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-established-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric that should be considered to the remote neighbor
// over this interface. This configuration is only applicable
// for multiple-access networks
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/config/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric that should be considered to the remote neighbor
// over this interface. This configuration is only applicable
// for multiple-access networks
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/config/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// OptionalCapabilities (leaf): The optional capabilities field received in the Hello
// message from the neighbor
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional-capabilities"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/optional-capabilities"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) OptionalCapabilities() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_OptionalCapabilitiesPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_OptionalCapabilitiesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional-capabilities"},
			map[string]interface{}{},
			n,
		),
	}
}

// OptionalCapabilities (leaf): The optional capabilities field received in the Hello
// message from the neighbor
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional-capabilities"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/optional-capabilities"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) OptionalCapabilities() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_OptionalCapabilitiesPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_OptionalCapabilitiesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional-capabilities"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The remote system's priority to become the designated
// router
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/priority"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) Priority() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_PriorityPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The remote system's priority to become the designated
// router
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/priority"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) Priority() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_PriorityPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetransmissionQueueLength (leaf): The number of LSAs that are currently in the queue to be
// retransmitted to the neighbor
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmission-queue-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/retransmission-queue-length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) RetransmissionQueueLength() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RetransmissionQueueLengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RetransmissionQueueLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmission-queue-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetransmissionQueueLength (leaf): The number of LSAs that are currently in the queue to be
// retransmitted to the neighbor
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmission-queue-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/retransmission-queue-length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) RetransmissionQueueLength() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RetransmissionQueueLengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RetransmissionQueueLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmission-queue-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): The router ID of the remote system.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/config/router-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) RouterId() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RouterIdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): The router ID of the remote system.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/config/router-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) RouterId() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RouterIdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// StateChanges (leaf): The number of transitions out of the FULL state that this
// neighbor has been through
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/state-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/state-changes"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPath) StateChanges() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_StateChangesPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_StateChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// StateChanges (leaf): The number of transitions out of the FULL state that this
// neighbor has been through
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/state-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/neighbors/neighbor/state/state-changes"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_NeighborPathAny) StateChanges() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_StateChangesPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Neighbor_StateChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_DeadIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/dead-interval YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_DeadIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_DeadIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/dead-interval YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_DeadIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_HelloIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/hello-interval YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_HelloIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_HelloIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/hello-interval YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_HelloIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_RetransmissionIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/retransmission-interval YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_RetransmissionIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_RetransmissionIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/retransmission-interval YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_RetransmissionIntervalPathAny struct {
	*ygot.NodePath
}

// DeadInterval (leaf): The number of seconds that the local system should let
// elapse before declaring a silent router down
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dead-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/dead-interval"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPath) DeadInterval() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_DeadIntervalPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_DeadIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dead-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// DeadInterval (leaf): The number of seconds that the local system should let
// elapse before declaring a silent router down
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dead-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/dead-interval"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPathAny) DeadInterval() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_DeadIntervalPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_DeadIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dead-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): The number of seconds the local system waits between the
// transmission of subsequent Hello packets
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/hello-interval"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPath) HelloInterval() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_HelloIntervalPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_HelloIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): The number of seconds the local system waits between the
// transmission of subsequent Hello packets
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/hello-interval"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPathAny) HelloInterval() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_HelloIntervalPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_HelloIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetransmissionInterval (leaf): The number of seconds that the local system waits before
// retransmitting an unacknowledged LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/retransmission-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/retransmission-interval"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPath) RetransmissionInterval() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_RetransmissionIntervalPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_RetransmissionIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "retransmission-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetransmissionInterval (leaf): The number of seconds that the local system waits before
// retransmitting an unacknowledged LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/retransmission-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/interfaces/interface/timers/config/retransmission-interval"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Interface_TimersPathAny) RetransmissionInterval() *NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_RetransmissionIntervalPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Interface_Timers_RetransmissionIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "retransmission-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_LsdbPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_LsdbPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_LsdbPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_LsdbPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_IdentifierPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/state/identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_IdentifierPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_IdentifierPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/state/identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_IdentifierPathAny struct {
	*ygot.NodePath
}

// Identifier (leaf): An identifier for the area, expressed as a dotted quad or
// an unsigned 32-bit integer
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/state/identifier"
func (n *NetworkInstance_Protocol_Ospfv2_Area_LsdbPath) Identifier() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_IdentifierPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_IdentifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// Identifier (leaf): An identifier for the area, expressed as a dotted quad or
// an unsigned 32-bit integer
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/state/identifier"
func (n *NetworkInstance_Protocol_Ospfv2_Area_LsdbPathAny) Identifier() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_IdentifierPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_IdentifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// LsaTypeAny (list): List of LSA types in the LSDB for the specified
// area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsa-types/lsa-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type"
// Type (wildcarded): E_OspfTypes_OSPF_LSA_TYPE
func (n *NetworkInstance_Protocol_Ospfv2_Area_LsdbPath) LsaTypeAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsa-types", "lsa-type"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// LsaTypeAny (list): List of LSA types in the LSDB for the specified
// area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsa-types/lsa-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type"
// Type (wildcarded): E_OspfTypes_OSPF_LSA_TYPE
func (n *NetworkInstance_Protocol_Ospfv2_Area_LsdbPathAny) LsaTypeAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsa-types", "lsa-type"},
			map[string]interface{}{"type": "*"},
			n,
		),
	}
}

// LsaType (list): List of LSA types in the LSDB for the specified
// area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsa-types/lsa-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type"
// Type: E_OspfTypes_OSPF_LSA_TYPE
func (n *NetworkInstance_Protocol_Ospfv2_Area_LsdbPath) LsaType(Type E_OspfTypes_OSPF_LSA_TYPE) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"lsa-types", "lsa-type"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// LsaType (list): List of LSA types in the LSDB for the specified
// area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsa-types/lsa-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type"
// Type: E_OspfTypes_OSPF_LSA_TYPE
func (n *NetworkInstance_Protocol_Ospfv2_Area_LsdbPathAny) LsaType(Type E_OspfTypes_OSPF_LSA_TYPE) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsa-types", "lsa-type"},
			map[string]interface{}{"type": Type},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_TypePathAny struct {
	*ygot.NodePath
}

// LsaAny (list): List of the LSAs of a specified type in the
// LSDB for the specified area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsas/lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa"
// LinkStateId (wildcarded): string
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePath) LsaAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsas", "lsa"},
			map[string]interface{}{"link-state-id": "*"},
			n,
		),
	}
}

// LsaAny (list): List of the LSAs of a specified type in the
// LSDB for the specified area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsas/lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa"
// LinkStateId (wildcarded): string
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny) LsaAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsas", "lsa"},
			map[string]interface{}{"link-state-id": "*"},
			n,
		),
	}
}

// Lsa (list): List of the LSAs of a specified type in the
// LSDB for the specified area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsas/lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa"
// LinkStateId: string
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePath) Lsa(LinkStateId string) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath{
		NodePath: ygot.NewNodePath(
			[]string{"lsas", "lsa"},
			map[string]interface{}{"link-state-id": LinkStateId},
			n,
		),
	}
}

// Lsa (list): List of the LSAs of a specified type in the
// LSDB for the specified area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsas/lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa"
// LinkStateId: string
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny) Lsa(LinkStateId string) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsas", "lsa"},
			map[string]interface{}{"link-state-id": LinkStateId},
			n,
		),
	}
}

// Type (leaf): The type of LSA being described. The type of the LSA is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of LSA being described. The type of the LSA is
// expressed as a canonical name.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaTypePathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AdvertisingRouterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/advertising-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AdvertisingRouterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AdvertisingRouterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/advertising-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AdvertisingRouterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AgePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/age YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AgePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AgePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/age YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AgePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_ChecksumPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/checksum YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_ChecksumPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_ChecksumPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/checksum YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_ChecksumPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_LinkStateIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/link-state-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_LinkStateIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_LinkStateIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/link-state-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_LinkStateIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SequenceNumberPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/sequence-number YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SequenceNumberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SequenceNumberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/sequence-number YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SequenceNumberPathAny struct {
	*ygot.NodePath
}

// AdvertisingRouter (leaf): The router ID of the router that originated the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertising-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/advertising-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) AdvertisingRouter() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AdvertisingRouterPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AdvertisingRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertising-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdvertisingRouter (leaf): The router ID of the router that originated the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/advertising-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/advertising-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) AdvertisingRouter() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AdvertisingRouterPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AdvertisingRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "advertising-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// Age (leaf): The time since the LSA's generation in seconds
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/age"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/age"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) Age() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AgePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AgePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "age"},
			map[string]interface{}{},
			n,
		),
	}
}

// Age (leaf): The time since the LSA's generation in seconds
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/age"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/age"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) Age() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AgePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AgePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "age"},
			map[string]interface{}{},
			n,
		),
	}
}

// AsExternalLsa (container): Contents of the AS External LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "as-external-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) AsExternalLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath{
		NodePath: ygot.NewNodePath(
			[]string{"as-external-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// AsExternalLsa (container): Contents of the AS External LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "as-external-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) AsExternalLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"as-external-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// Checksum (leaf): The checksum of the complete contents of the LSA excluding
// the age field.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/checksum"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/checksum"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) Checksum() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_ChecksumPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_ChecksumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "checksum"},
			map[string]interface{}{},
			n,
		),
	}
}

// Checksum (leaf): The checksum of the complete contents of the LSA excluding
// the age field.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/checksum"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/checksum"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) Checksum() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_ChecksumPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_ChecksumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "checksum"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkStateId (leaf): The Link State ID for the specified LSA type. The exact
// defined value of the Link State ID is dependent on the LSA
// type.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-state-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/link-state-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) LinkStateId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_LinkStateIdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_LinkStateIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-state-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkStateId (leaf): The Link State ID for the specified LSA type. The exact
// defined value of the Link State ID is dependent on the LSA
// type.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-state-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/link-state-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) LinkStateId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_LinkStateIdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_LinkStateIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-state-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkLsa (container): Contents of the network LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "network-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) NetworkLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPath{
		NodePath: ygot.NewNodePath(
			[]string{"network-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkLsa (container): Contents of the network LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "network-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) NetworkLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"network-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// NssaExternalLsa (container): Contents of the NSSA External LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "nssa-external-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) NssaExternalLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath{
		NodePath: ygot.NewNodePath(
			[]string{"nssa-external-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// NssaExternalLsa (container): Contents of the NSSA External LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "nssa-external-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) NssaExternalLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"nssa-external-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpaqueLsa (container): Contents of the opaque LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "opaque-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) OpaqueLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath{
		NodePath: ygot.NewNodePath(
			[]string{"opaque-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpaqueLsa (container): Contents of the opaque LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "opaque-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) OpaqueLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"opaque-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterLsa (container): Contents of the router LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) RouterLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath{
		NodePath: ygot.NewNodePath(
			[]string{"router-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterLsa (container): Contents of the router LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) RouterLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"router-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceNumber (leaf): A signed 32-bit integer used to detect old and duplicate
// LSAs. The greater the sequence number the more recent the
// LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sequence-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/sequence-number"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) SequenceNumber() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SequenceNumberPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SequenceNumberPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sequence-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// SequenceNumber (leaf): A signed 32-bit integer used to detect old and duplicate
// LSAs. The greater the sequence number the more recent the
// LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sequence-number"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/state/sequence-number"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) SequenceNumber() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SequenceNumberPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SequenceNumberPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sequence-number"},
			map[string]interface{}{},
			n,
		),
	}
}

// SummaryLsa (container): Contents of the summary LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "summary-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPath) SummaryLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPath{
		NodePath: ygot.NewNodePath(
			[]string{"summary-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// SummaryLsa (container): Contents of the summary LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "summary-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_LsaPathAny) SummaryLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"summary-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ExternalRouteTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/external-route-tag YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ExternalRouteTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ExternalRouteTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/external-route-tag YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ExternalRouteTagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ForwardingAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/forwarding-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ForwardingAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ForwardingAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/forwarding-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ForwardingAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MaskPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/mask YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MaskPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MaskPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/mask YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MaskPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/metric-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/metric-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricTypePathAny struct {
	*ygot.NodePath
}

// ExternalRouteTag (leaf): An opaque tag that set by the LSA originator to carry
// information relating to the external route
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/external-route-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/external-route-tag"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath) ExternalRouteTag() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ExternalRouteTagPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ExternalRouteTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "external-route-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalRouteTag (leaf): An opaque tag that set by the LSA originator to carry
// information relating to the external route
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/external-route-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/external-route-tag"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny) ExternalRouteTag() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ExternalRouteTagPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ExternalRouteTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "external-route-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingAddress (leaf): The destination to which traffic for the external prefix
// should be advertised. When this value is set to 0.0.0.0 then
// traffic should be forwarded to the LSA's originator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/forwarding-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/forwarding-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath) ForwardingAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ForwardingAddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ForwardingAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forwarding-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingAddress (leaf): The destination to which traffic for the external prefix
// should be advertised. When this value is set to 0.0.0.0 then
// traffic should be forwarded to the LSA's originator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/forwarding-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/forwarding-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny) ForwardingAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ForwardingAddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_ForwardingAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forwarding-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mask (leaf): The subnet mask for the advertised destination
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mask"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/mask"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath) Mask() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MaskPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mask (leaf): The subnet mask for the advertised destination
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mask"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/mask"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny) Mask() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MaskPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The cost to reach the external network specified. The exact
// interpretation of this cost is dependent on the type of
// metric specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The cost to reach the external network specified. The exact
// interpretation of this cost is dependent on the type of
// metric specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// MetricType (leaf): The type of metric included within the AS External LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/metric-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath) MetricType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// MetricType (leaf): The type of metric included within the AS External LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/state/metric-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny) MetricType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_MetricTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// TypeOfServiceAny (list): Per-type of service parameters for the AS External LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service"
// Tos (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath) TypeOfServiceAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": "*"},
			n,
		),
	}
}

// TypeOfServiceAny (list): Per-type of service parameters for the AS External LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service"
// Tos (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny) TypeOfServiceAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": "*"},
			n,
		),
	}
}

// TypeOfService (list): Per-type of service parameters for the AS External LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service"
// Tos: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPath) TypeOfService(Tos uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePath{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": Tos},
			n,
		),
	}
}

// TypeOfService (list): Per-type of service parameters for the AS External LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service"
// Tos: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsaPathAny) TypeOfService(Tos uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": Tos},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ExternalRouteTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/external-route-tag YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ExternalRouteTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ExternalRouteTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/external-route-tag YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ExternalRouteTagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ForwardingAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/forwarding-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ForwardingAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ForwardingAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/forwarding-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ForwardingAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_TosPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/tos YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_TosPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_TosPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/tos YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_TosPathAny struct {
	*ygot.NodePath
}

// ExternalRouteTag (leaf): An opaque tag that set by the LSA originator to carry
// information relating to the external route
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/external-route-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/external-route-tag"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePath) ExternalRouteTag() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ExternalRouteTagPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ExternalRouteTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "external-route-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalRouteTag (leaf): An opaque tag that set by the LSA originator to carry
// information relating to the external route
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/external-route-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/external-route-tag"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny) ExternalRouteTag() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ExternalRouteTagPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ExternalRouteTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "external-route-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingAddress (leaf): The destination to which traffic for the external prefix
// should be advertised. When this value is set to 0.0.0.0 then
// traffic should be forwarded to the LSA's originator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/forwarding-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/forwarding-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePath) ForwardingAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ForwardingAddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ForwardingAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forwarding-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingAddress (leaf): The destination to which traffic for the external prefix
// should be advertised. When this value is set to 0.0.0.0 then
// traffic should be forwarded to the LSA's originator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/forwarding-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/forwarding-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny) ForwardingAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ForwardingAddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_ForwardingAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forwarding-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric value to be used for the TOS specified. This value
// represents the cost of use of the link for the specific type
// of service.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric value to be used for the TOS specified. This value
// represents the cost of use of the link for the specific type
// of service.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tos (leaf): OSPF encoding of the type of service referred to by this
// LSA. Encoding for OSPF TOS are described in RFC2328.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tos"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/tos"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePath) Tos() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_TosPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_TosPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tos"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tos (leaf): OSPF encoding of the type of service referred to by this
// LSA. Encoding for OSPF TOS are described in RFC2328.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tos"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/as-external-lsa/types-of-service/type-of-service/state/tos"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfServicePathAny) Tos() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_TosPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_AsExternalLsa_TypeOfService_TosPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tos"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_AttachedRouterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa/state/attached-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_AttachedRouterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_AttachedRouterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa/state/attached-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_AttachedRouterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_NetworkMaskPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa/state/network-mask YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_NetworkMaskPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_NetworkMaskPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa/state/network-mask YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_NetworkMaskPathAny struct {
	*ygot.NodePath
}

// AttachedRouter (leaf): A list of the router ID of the routers that are attached to
// the network described by the Network LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attached-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa/state/attached-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPath) AttachedRouter() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_AttachedRouterPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_AttachedRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attached-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// AttachedRouter (leaf): A list of the router ID of the routers that are attached to
// the network described by the Network LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attached-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa/state/attached-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPathAny) AttachedRouter() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_AttachedRouterPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_AttachedRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attached-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkMask (leaf): The mask of the network described by the Network LSA
// represented as a CIDR mask.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/network-mask"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa/state/network-mask"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPath) NetworkMask() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_NetworkMaskPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_NetworkMaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "network-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkMask (leaf): The mask of the network described by the Network LSA
// represented as a CIDR mask.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/network-mask"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/network-lsa/state/network-mask"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsaPathAny) NetworkMask() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_NetworkMaskPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NetworkLsa_NetworkMaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "network-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ExternalRouteTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/external-route-tag YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ExternalRouteTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ExternalRouteTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/external-route-tag YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ExternalRouteTagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ForwardingAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/forwarding-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ForwardingAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ForwardingAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/forwarding-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ForwardingAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MaskPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/mask YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MaskPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MaskPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/mask YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MaskPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/metric-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/metric-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_PropagatePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/propagate YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_PropagatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_PropagatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/propagate YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_PropagatePathAny struct {
	*ygot.NodePath
}

// ExternalRouteTag (leaf): An opaque tag that set by the LSA originator to carry
// information relating to the external route
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/external-route-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/external-route-tag"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath) ExternalRouteTag() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ExternalRouteTagPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ExternalRouteTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "external-route-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalRouteTag (leaf): An opaque tag that set by the LSA originator to carry
// information relating to the external route
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/external-route-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/external-route-tag"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny) ExternalRouteTag() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ExternalRouteTagPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ExternalRouteTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "external-route-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingAddress (leaf): The destination to which traffic for the external prefix
// should be advertised. When this value is set to 0.0.0.0 then
// traffic should be forwarded to the LSA's originator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/forwarding-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/forwarding-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath) ForwardingAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ForwardingAddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ForwardingAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forwarding-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingAddress (leaf): The destination to which traffic for the external prefix
// should be advertised. When this value is set to 0.0.0.0 then
// traffic should be forwarded to the LSA's originator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/forwarding-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/forwarding-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny) ForwardingAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ForwardingAddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_ForwardingAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forwarding-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mask (leaf): The subnet mask for the advertised destination
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mask"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/mask"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath) Mask() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MaskPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mask (leaf): The subnet mask for the advertised destination
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mask"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/mask"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny) Mask() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MaskPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The cost to reach the external network specified. The exact
// interpretation of this cost is dependent on the type of
// metric specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The cost to reach the external network specified. The exact
// interpretation of this cost is dependent on the type of
// metric specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// MetricType (leaf): The type of metric included within the AS External LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/metric-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath) MetricType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// MetricType (leaf): The type of metric included within the AS External LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/metric-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny) MetricType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_MetricTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Propagate (leaf): When this bit is set to true, an NSSA border router will
// translate a Type 7 LSA (NSSA External) to a Type 5 LSA
// (AS External).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/propagate"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/propagate"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath) Propagate() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_PropagatePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_PropagatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "propagate"},
			map[string]interface{}{},
			n,
		),
	}
}

// Propagate (leaf): When this bit is set to true, an NSSA border router will
// translate a Type 7 LSA (NSSA External) to a Type 5 LSA
// (AS External).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/propagate"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/state/propagate"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny) Propagate() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_PropagatePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_PropagatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "propagate"},
			map[string]interface{}{},
			n,
		),
	}
}

// TypeOfServiceAny (list): Per-type of service parameters for the NSSA external LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service"
// Tos (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath) TypeOfServiceAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": "*"},
			n,
		),
	}
}

// TypeOfServiceAny (list): Per-type of service parameters for the NSSA external LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service"
// Tos (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny) TypeOfServiceAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": "*"},
			n,
		),
	}
}

// TypeOfService (list): Per-type of service parameters for the NSSA external LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service"
// Tos: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPath) TypeOfService(Tos uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePath{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": Tos},
			n,
		),
	}
}

// TypeOfService (list): Per-type of service parameters for the NSSA external LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service"
// Tos: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsaPathAny) TypeOfService(Tos uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": Tos},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ExternalRouteTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/external-route-tag YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ExternalRouteTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ExternalRouteTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/external-route-tag YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ExternalRouteTagPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ForwardingAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/forwarding-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ForwardingAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ForwardingAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/forwarding-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ForwardingAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_TosPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/tos YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_TosPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_TosPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/tos YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_TosPathAny struct {
	*ygot.NodePath
}

// ExternalRouteTag (leaf): An opaque tag that set by the LSA originator to carry
// information relating to the external route
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/external-route-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/external-route-tag"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePath) ExternalRouteTag() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ExternalRouteTagPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ExternalRouteTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "external-route-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExternalRouteTag (leaf): An opaque tag that set by the LSA originator to carry
// information relating to the external route
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/external-route-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/external-route-tag"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny) ExternalRouteTag() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ExternalRouteTagPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ExternalRouteTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "external-route-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingAddress (leaf): The destination to which traffic for the external prefix
// should be advertised. When this value is set to 0.0.0.0 then
// traffic should be forwarded to the LSA's originator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/forwarding-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/forwarding-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePath) ForwardingAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ForwardingAddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ForwardingAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forwarding-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingAddress (leaf): The destination to which traffic for the external prefix
// should be advertised. When this value is set to 0.0.0.0 then
// traffic should be forwarded to the LSA's originator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/forwarding-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/forwarding-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny) ForwardingAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ForwardingAddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_ForwardingAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forwarding-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric value to be used for the TOS specified. This value
// represents the cost of use of the link for the specific type
// of service.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric value to be used for the TOS specified. This value
// represents the cost of use of the link for the specific type
// of service.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tos (leaf): OSPF encoding of the type of service referred to by this
// LSA. Encoding for OSPF TOS are described in RFC2328.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tos"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/tos"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePath) Tos() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_TosPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_TosPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tos"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tos (leaf): OSPF encoding of the type of service referred to by this
// LSA. Encoding for OSPF TOS are described in RFC2328.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tos"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/nssa-external-lsa/types-of-service/type-of-service/state/tos"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfServicePathAny) Tos() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_TosPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_NssaExternalLsa_TypeOfService_TosPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tos"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ScopePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/state/scope YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ScopePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ScopePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/state/scope YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ScopePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TypePathAny struct {
	*ygot.NodePath
}

// ExtendedLink (container): The OSPFv2 Extended Link Opaque LSA, used to encapsulate TLV
// attributes associated with a link advertised in OSPF.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-link"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath) ExtendedLink() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPath{
		NodePath: ygot.NewNodePath(
			[]string{"extended-link"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedLink (container): The OSPFv2 Extended Link Opaque LSA, used to encapsulate TLV
// attributes associated with a link advertised in OSPF.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-link"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny) ExtendedLink() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"extended-link"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedPrefix (container): An OSPFv2 Extended Prefix Opaque LSA, used to encapsulate
// TLV attributes associated with a prefix advertised in OSPF.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath) ExtendedPrefix() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"extended-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedPrefix (container): An OSPFv2 Extended Prefix Opaque LSA, used to encapsulate
// TLV attributes associated with a prefix advertised in OSPF.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny) ExtendedPrefix() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"extended-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// GraceLsa (container): The Grace LSA is utilised when a remote system is undergoing
// graceful restart
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "grace-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath) GraceLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsaPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsaPath{
		NodePath: ygot.NewNodePath(
			[]string{"grace-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// GraceLsa (container): The Grace LSA is utilised when a remote system is undergoing
// graceful restart
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "grace-lsa"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny) GraceLsa() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"grace-lsa"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterInformation (container): The router information LSA is utilised to advertise capabilities
// of a system to other systems who receive the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-information"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath) RouterInformation() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformationPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformationPath{
		NodePath: ygot.NewNodePath(
			[]string{"router-information"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterInformation (container): The router information LSA is utilised to advertise capabilities
// of a system to other systems who receive the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-information"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny) RouterInformation() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformationPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"router-information"},
			map[string]interface{}{},
			n,
		),
	}
}

// Scope (leaf): The scope of the opaque LSA. The type of the LSA
// indicates its scope - the value of this leaf
// determines both the flooding domain, and the type
// of the LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/scope"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/state/scope"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath) Scope() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ScopePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ScopePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "scope"},
			map[string]interface{}{},
			n,
		),
	}
}

// Scope (leaf): The scope of the opaque LSA. The type of the LSA
// indicates its scope - the value of this leaf
// determines both the flooding domain, and the type
// of the LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/scope"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/state/scope"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny) Scope() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ScopePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ScopePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "scope"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineering (container): Contents of the Traffic Engineering Opaque LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "traffic-engineering"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath) TrafficEngineering() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineeringPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineeringPath{
		NodePath: ygot.NewNodePath(
			[]string{"traffic-engineering"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineering (container): Contents of the Traffic Engineering Opaque LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "traffic-engineering"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny) TrafficEngineering() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineeringPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineeringPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"traffic-engineering"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The Opaque Type of the LSA. This value is used to
// indicate the type of data carried by the opaque LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The Opaque Type of the LSA. This value is used to
// indicate the type of data carried by the opaque LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPath) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsaPathAny) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkDataPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-data YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkDataPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkDataPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-data YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkDataPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkTypePathAny struct {
	*ygot.NodePath
}

// LinkData (leaf): The data associated with the link type. The value is
// dependent upon the subtype of the LSA. When the connection is
// to a stub network it represents the mask; for p2p connections
// that are unnumbered it represents the ifIndex value of the
// router's interface; for all other connections it represents
// the local system's IP address
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-data"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-data"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPath) LinkData() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkDataPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkDataPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-data"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkData (leaf): The data associated with the link type. The value is
// dependent upon the subtype of the LSA. When the connection is
// to a stub network it represents the mask; for p2p connections
// that are unnumbered it represents the ifIndex value of the
// router's interface; for all other connections it represents
// the local system's IP address
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-data"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-data"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPathAny) LinkData() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkDataPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkDataPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-data"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (leaf): The identifier for the link specified. The value of the link
// identifier is dependent upon the type of the LSA. The value is
// specified to be, per sub-type:
//  1) Neighbouring router's router ID.
//  2) IP address of DR.
//  3) IP network address.
//  4) Neighbouring router router's ID.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPath) LinkId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkIdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (leaf): The identifier for the link specified. The value of the link
// identifier is dependent upon the type of the LSA. The value is
// specified to be, per sub-type:
//  1) Neighbouring router's router ID.
//  2) IP address of DR.
//  3) IP network address.
//  4) Neighbouring router router's ID.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPathAny) LinkId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkIdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkType (leaf): The type of link with which extended attributes are associated
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPath) LinkType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkType (leaf): The type of link with which extended attributes are associated
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/state/link-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLinkPathAny) LinkType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_LinkTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// AdjacencySid (container): Parameters relating to an Adjacency SID sub-TLV of the
// extended link LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPath) AdjacencySid() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjacencySid (container): Parameters relating to an Adjacency SID sub-TLV of the
// extended link LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "adjacency-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPathAny) AdjacencySid() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"adjacency-sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the sub-TLV contained within the extended link TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the sub-TLV contained within the extended link TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPath) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_TlvPathAny) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_BackupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/backup YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_BackupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_BackupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/backup YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_BackupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_GroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/group YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_GroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_GroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/group YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_GroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_MultiTopologyIdentifierPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/multi-topology-identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_MultiTopologyIdentifierPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_MultiTopologyIdentifierPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/multi-topology-identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_MultiTopologyIdentifierPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/sid-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/sid-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/sid-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/sid-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/weight YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_WeightPathAny struct {
	*ygot.NodePath
}

// Backup (leaf): When this flag is set, it indicates that the adjacency SID refers to
// an adjacency which is eligible for protection
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/backup"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath) Backup() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_BackupPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_BackupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Backup (leaf): When this flag is set, it indicates that the adjacency SID refers to
// an adjacency which is eligible for protection
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/backup"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny) Backup() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_BackupPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_BackupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup"},
			map[string]interface{}{},
			n,
		),
	}
}

// Group (leaf): When this flag is set it indicates that the adjacency SID refers to
// a group of adjacencies that have a common value
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/group"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath) Group() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_GroupPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_GroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Group (leaf): When this flag is set it indicates that the adjacency SID refers to
// a group of adjacencies that have a common value
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/group"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny) Group() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_GroupPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "group"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopologyIdentifier (leaf): The multi-topology identifier with which the adjacency SID is
// associated
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multi-topology-identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/multi-topology-identifier"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath) MultiTopologyIdentifier() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_MultiTopologyIdentifierPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_MultiTopologyIdentifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multi-topology-identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopologyIdentifier (leaf): The multi-topology identifier with which the adjacency SID is
// associated
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multi-topology-identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/multi-topology-identifier"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny) MultiTopologyIdentifier() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_MultiTopologyIdentifierPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_MultiTopologyIdentifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multi-topology-identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidType (leaf): The type of the value contained within the sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/sid-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath) SidType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidType (leaf): The type of the value contained within the sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/sid-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny) SidType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidValue (leaf): The value of the binding included within the sub-TLV. The type of
// this binding is indicated by the type leaf.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/sid-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath) SidValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidValue (leaf): The value of the binding included within the sub-TLV. The type of
// this binding is indicated by the type leaf.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/sid-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny) SidValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_SidValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): The weight of the Adjacency SID when used for load-balancing
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPath) Weight() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_WeightPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): The weight of the Adjacency SID when used for load-balancing
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/adjacency-sid/state/weight"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySidPathAny) Weight() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_WeightPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_AdjacencySid_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPath) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_LengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPathAny) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_LengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPath) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_ValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-link/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlvPathAny) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_ValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedLink_Tlv_UnknownTlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/address-family YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/address-family YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AttachedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/attached YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AttachedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AttachedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/attached YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AttachedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_NodePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/node YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_NodePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_NodePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/node YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_NodePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/prefix YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/prefix-length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/prefix-length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_RouteTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/route-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_RouteTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_RouteTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/route-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_RouteTypePathAny struct {
	*ygot.NodePath
}

// AddressFamily (leaf): The address family of the prefix contained in the Extended Prefix
// LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/address-family"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath) AddressFamily() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AddressFamilyPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// AddressFamily (leaf): The address family of the prefix contained in the Extended Prefix
// LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/address-family"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny) AddressFamily() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AddressFamilyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// Attached (leaf): If this value is set to true, the prefix being advertised was
// generated by an ABR for an inter-area prefix. The value corresponds
// to the A-flag of the flags field of the Extended Prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attached"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/attached"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath) Attached() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AttachedPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AttachedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attached"},
			map[string]interface{}{},
			n,
		),
	}
}

// Attached (leaf): If this value is set to true, the prefix being advertised was
// generated by an ABR for an inter-area prefix. The value corresponds
// to the A-flag of the flags field of the Extended Prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/attached"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/attached"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny) Attached() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AttachedPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_AttachedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "attached"},
			map[string]interface{}{},
			n,
		),
	}
}

// Node (leaf): If this value is set to true, the prefix being advertised represents
// the advertising router. Typically, the prefix within the LSA is
// expected to be globally-reachable prefix associated with a loopback
// interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/node"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/node"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath) Node() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_NodePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_NodePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "node"},
			map[string]interface{}{},
			n,
		),
	}
}

// Node (leaf): If this value is set to true, the prefix being advertised represents
// the advertising router. Typically, the prefix within the LSA is
// expected to be globally-reachable prefix associated with a loopback
// interface
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/node"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/node"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny) Node() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_NodePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_NodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "node"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv4 prefix contained within the extended prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/prefix"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath) Prefix() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The IPv4 prefix contained within the extended prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/prefix"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny) Prefix() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the IPv4 prefix contained in the Extended Prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/prefix-length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath) PrefixLength() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixLengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the IPv4 prefix contained in the Extended Prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/prefix-length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny) PrefixLength() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixLengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_PrefixLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteType (leaf): The type of prefix that is contained within the Extended Prefix LSA.
// The information contained in sub-TLVs of the attribute is applicable
// regardless of this value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/route-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/route-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPath) RouteType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_RouteTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_RouteTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "route-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouteType (leaf): The type of prefix that is contained within the Extended Prefix LSA.
// The information contained in sub-TLVs of the attribute is applicable
// regardless of this value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/route-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/state/route-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefixPathAny) RouteType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_RouteTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_RouteTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "route-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// ExtendedPrefixRange (container): State parameters relating to the extended prefix range
// sub-TLV of the extended prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-prefix-range"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPath) ExtendedPrefixRange() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePath{
		NodePath: ygot.NewNodePath(
			[]string{"extended-prefix-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExtendedPrefixRange (container): State parameters relating to the extended prefix range
// sub-TLV of the extended prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "extended-prefix-range"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPathAny) ExtendedPrefixRange() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"extended-prefix-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixSid (container): State parameters relating to the Prefix SID sub-TLV of the
// extended prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPath) PrefixSid() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixSid (container): State parameters relating to the Prefix SID sub-TLV of the
// extended prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "prefix-sid"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPathAny) PrefixSid() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sid"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidLabelBinding (container): State parameters relating to the SID/Label binding sub-TLV
// of the extended prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-label-binding"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPath) SidLabelBinding() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPath{
		NodePath: ygot.NewNodePath(
			[]string{"sid-label-binding"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidLabelBinding (container): State parameters relating to the SID/Label binding sub-TLV
// of the extended prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-label-binding"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPathAny) SidLabelBinding() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sid-label-binding"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of sub-TLV as indicated by the Extended Prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of sub-TLV as indicated by the Extended Prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPath) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_TlvPathAny) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_AddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/address-family YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_AddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_AddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/address-family YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_AddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_InterAreaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/inter-area YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_InterAreaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_InterAreaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/inter-area YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_InterAreaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/prefix YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/prefix YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/prefix-length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/prefix-length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_RangeSizePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/range-size YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_RangeSizePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_RangeSizePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/range-size YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_RangeSizePathAny struct {
	*ygot.NodePath
}

// AddressFamily (leaf): The address family of the prefix contained in the Extended Prefix
// LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/address-family"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePath) AddressFamily() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_AddressFamilyPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_AddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// AddressFamily (leaf): The address family of the prefix contained in the Extended Prefix
// LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address-family"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/address-family"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePathAny) AddressFamily() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_AddressFamilyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterArea (leaf): When this leaf is set to true, then the prefix range is inter-area -
// the flag is set by the ABR that advertises the Extended Prefix Range
// TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/inter-area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/inter-area"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePath) InterArea() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_InterAreaPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_InterAreaPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "inter-area"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterArea (leaf): When this leaf is set to true, then the prefix range is inter-area -
// the flag is set by the ABR that advertises the Extended Prefix Range
// TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/inter-area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/inter-area"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePathAny) InterArea() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_InterAreaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_InterAreaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "inter-area"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The first prefix in the range of prefixes being described by the
// extended prefix range sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/prefix"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePath) Prefix() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): The first prefix in the range of prefixes being described by the
// extended prefix range sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/prefix"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePathAny) Prefix() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the IPv4 prefix contained in the Extended Prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/prefix-length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePath) PrefixLength() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixLengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixLength (leaf): The length of the IPv4 prefix contained in the Extended Prefix LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/prefix-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/prefix-length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePathAny) PrefixLength() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixLengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_PrefixLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "prefix-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// RangeSize (leaf): The number of prefixes that are covered by the advertisement.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/range-size"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/range-size"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePath) RangeSize() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_RangeSizePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_RangeSizePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "range-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// RangeSize (leaf): The number of prefixes that are covered by the advertisement.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/range-size"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/extended-prefix-range/state/range-size"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRangePathAny) RangeSize() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_RangeSizePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_ExtendedPrefixRange_RangeSizePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "range-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_AlgorithmPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_AlgorithmPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_AlgorithmPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/algorithm YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_AlgorithmPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_ExplicitNullPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/explicit-null YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_ExplicitNullPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_ExplicitNullPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/explicit-null YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_ExplicitNullPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MappingServerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/mapping-server YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MappingServerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MappingServerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/mapping-server YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MappingServerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MultiTopologyIdentifierPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/multi-topology-identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MultiTopologyIdentifierPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MultiTopologyIdentifierPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/multi-topology-identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MultiTopologyIdentifierPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_NoPhpPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/no-php YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_NoPhpPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_NoPhpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/no-php YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_NoPhpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidScopePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-scope YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidScopePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidScopePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-scope YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidScopePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValuePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValueTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-value-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValueTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValueTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-value-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValueTypePathAny struct {
	*ygot.NodePath
}

// Algorithm (leaf): The algorithm that computes the path associated with the Prefix SID
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath) Algorithm() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_AlgorithmPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_AlgorithmPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Algorithm (leaf): The algorithm that computes the path associated with the Prefix SID
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/algorithm"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny) Algorithm() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_AlgorithmPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_AlgorithmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExplicitNull (leaf): If this leaf is set, the advertising system has requested that the
// prefix SID value should be replaced with the explicit null label
// value
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/explicit-null"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/explicit-null"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath) ExplicitNull() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_ExplicitNullPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_ExplicitNullPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "explicit-null"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExplicitNull (leaf): If this leaf is set, the advertising system has requested that the
// prefix SID value should be replaced with the explicit null label
// value
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/explicit-null"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/explicit-null"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny) ExplicitNull() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_ExplicitNullPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_ExplicitNullPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "explicit-null"},
			map[string]interface{}{},
			n,
		),
	}
}

// MappingServer (leaf): If this leaf is set the SID was advertised by a Segment Routing
// mapping server
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mapping-server"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/mapping-server"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath) MappingServer() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MappingServerPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MappingServerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mapping-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// MappingServer (leaf): If this leaf is set the SID was advertised by a Segment Routing
// mapping server
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mapping-server"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/mapping-server"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny) MappingServer() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MappingServerPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MappingServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mapping-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopologyIdentifier (leaf): The identifier for the topology to which the Prefix SID relates. The
// value of this leaf is a MT-ID as defined in RFC4915
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multi-topology-identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/multi-topology-identifier"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath) MultiTopologyIdentifier() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MultiTopologyIdentifierPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MultiTopologyIdentifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multi-topology-identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopologyIdentifier (leaf): The identifier for the topology to which the Prefix SID relates. The
// value of this leaf is a MT-ID as defined in RFC4915
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multi-topology-identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/multi-topology-identifier"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny) MultiTopologyIdentifier() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MultiTopologyIdentifierPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_MultiTopologyIdentifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multi-topology-identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// NoPhp (leaf): If this leaf is set the advertising system has indicated that the
// prefix SID must not be popped before delivering packets to it
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/no-php"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/no-php"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath) NoPhp() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_NoPhpPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_NoPhpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "no-php"},
			map[string]interface{}{},
			n,
		),
	}
}

// NoPhp (leaf): If this leaf is set the advertising system has indicated that the
// prefix SID must not be popped before delivering packets to it
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/no-php"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/no-php"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny) NoPhp() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_NoPhpPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_NoPhpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "no-php"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidScope (leaf): Specifies the scope of the SID advertisement within the Prefix SID
// sub-TLV. The scope of the SID is independent of whether the SID
// contained is an index, or an absolute value
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-scope"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-scope"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath) SidScope() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidScopePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidScopePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-scope"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidScope (leaf): Specifies the scope of the SID advertisement within the Prefix SID
// sub-TLV. The scope of the SID is independent of whether the SID
// contained is an index, or an absolute value
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-scope"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-scope"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny) SidScope() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidScopePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidScopePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-scope"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidValue (leaf): The value of the Prefix SID. The meaning of this value is dependent
// upon the type of SID, and its scope. The value contained is either a
// 32-bit value indicating the index of the SID, or a 24-bit label where
// the 20 right-most bits are used for encoding the label value
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath) SidValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidValue (leaf): The value of the Prefix SID. The meaning of this value is dependent
// upon the type of SID, and its scope. The value contained is either a
// 32-bit value indicating the index of the SID, or a 24-bit label where
// the 20 right-most bits are used for encoding the label value
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny) SidValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidValueType (leaf): Specifies the type of the value specified within the Prefix SID
// sub-TLV - in particular, whether the value is an index or an
// absolute value. This value corresponds with the V-flag of the Prefix
// SID sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-value-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-value-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPath) SidValueType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValueTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValueTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-value-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidValueType (leaf): Specifies the type of the value specified within the Prefix SID
// sub-TLV - in particular, whether the value is an index or an
// absolute value. This value corresponds with the V-flag of the Prefix
// SID sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-value-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/prefix-sid/state/sid-value-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSidPathAny) SidValueType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValueTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_PrefixSid_SidValueTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-value-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MirroringPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/mirroring YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MirroringPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MirroringPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/mirroring YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MirroringPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MultiTopologyIdentifierPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/multi-topology-identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MultiTopologyIdentifierPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MultiTopologyIdentifierPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/multi-topology-identifier YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MultiTopologyIdentifierPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/weight YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/weight YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_WeightPathAny struct {
	*ygot.NodePath
}

// Mirroring (leaf): When set to true, this indicates that the SID/Label Binding sub-TLV
// entries contained within this TLV are indicative of a mirroring
// context
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mirroring"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/mirroring"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPath) Mirroring() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MirroringPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MirroringPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mirroring"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mirroring (leaf): When set to true, this indicates that the SID/Label Binding sub-TLV
// entries contained within this TLV are indicative of a mirroring
// context
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mirroring"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/mirroring"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPathAny) Mirroring() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MirroringPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MirroringPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mirroring"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopologyIdentifier (leaf): The identifier for the topology to which the SID/Label Binding
// sub-TLV is associated. The value of this leaf is a MT-ID as defined
// in RFC4915
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multi-topology-identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/multi-topology-identifier"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPath) MultiTopologyIdentifier() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MultiTopologyIdentifierPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MultiTopologyIdentifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multi-topology-identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// MultiTopologyIdentifier (leaf): The identifier for the topology to which the SID/Label Binding
// sub-TLV is associated. The value of this leaf is a MT-ID as defined
// in RFC4915
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/multi-topology-identifier"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/multi-topology-identifier"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPathAny) MultiTopologyIdentifier() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MultiTopologyIdentifierPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_MultiTopologyIdentifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "multi-topology-identifier"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): The weight of the advertised binding when used for load-balancing
// purposes
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/weight"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPath) Weight() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_WeightPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): The weight of the advertised binding when used for load-balancing
// purposes
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/state/weight"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBindingPathAny) Weight() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_WeightPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// EroMetric (container): Parameters for the ERO Metric Sub-TLV of the SID/Label
// binding TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ero-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPath) EroMetric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"ero-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// EroMetric (container): Parameters for the ERO Metric Sub-TLV of the SID/Label
// binding TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ero-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPathAny) EroMetric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ero-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// EroPath (container): Parameters for the ERO Path Sub-TLV of the SID/Label
// binding TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ero-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPath) EroPath() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPathPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPathPath{
		NodePath: ygot.NewNodePath(
			[]string{"ero-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// EroPath (container): Parameters for the ERO Path Sub-TLV of the SID/Label
// binding TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ero-path"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPathAny) EroPath() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPathPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ero-path"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidLabelBinding (container): Parameters for the SID/Label Binding sub-TLV of the
// SID/Label binding TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-label-binding"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPath) SidLabelBinding() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPath{
		NodePath: ygot.NewNodePath(
			[]string{"sid-label-binding"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidLabelBinding (container): Parameters for the SID/Label Binding sub-TLV of the
// SID/Label binding TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-label-binding"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPathAny) SidLabelBinding() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sid-label-binding"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of sub-TLV that is being contained within the SID/Label
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of sub-TLV that is being contained within the SID/Label
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_TlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetric_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetric_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetric_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-metric/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetric_MetricPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): The metric representing the aggregate IGP or TE path cost for the
// binding included within the SID/Label Binding TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-metric/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetric_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetric_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric representing the aggregate IGP or TE path cost for the
// binding included within the SID/Label Binding TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-metric/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetricPathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetric_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroMetric_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPathPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPathPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_LoosePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/state/loose YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_LoosePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_LoosePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/state/loose YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_LoosePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_TypePathAny struct {
	*ygot.NodePath
}

// Ipv4Segment (container): Details of the IPv4 segment interface of the ERO
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-segment"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/ipv4-segment"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPath) Ipv4Segment() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPath{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-segment"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Segment (container): Details of the IPv4 segment interface of the ERO
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ipv4-segment"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/ipv4-segment"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPathAny) Ipv4Segment() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ipv4-segment"},
			map[string]interface{}{},
			n,
		),
	}
}

// Loose (leaf): If this leaf is set the segment is identifier as a loose path
// segment, otherwise the path strictly follows the path specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/loose"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/state/loose"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPath) Loose() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_LoosePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_LoosePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "loose"},
			map[string]interface{}{},
			n,
		),
	}
}

// Loose (leaf): If this leaf is set the segment is identifier as a loose path
// segment, otherwise the path strictly follows the path specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/loose"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/state/loose"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPathAny) Loose() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_LoosePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_LoosePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "loose"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the segment being specified as part of the ERO
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the segment being specified as part of the ERO
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnnumberedHop (container): Details of the unnumbered interface segment of the
// ERO
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unnumbered-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPath) UnnumberedHop() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnnumberedHop (container): Details of the unnumbered interface segment of the
// ERO
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unnumbered-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_SegmentPathAny) UnnumberedHop() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unnumbered-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/ipv4-segment YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/ipv4-segment YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4Segment_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/ipv4-segment/state/address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4Segment_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4Segment_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/ipv4-segment/state/address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4Segment_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): The IPv4 address of the hop within the ERO
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/ipv4-segment/state/address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPath) Address() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4Segment_AddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4Segment_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): The IPv4 address of the hop within the ERO
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/ipv4-segment/state/address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4SegmentPathAny) Address() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4Segment_AddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_Ipv4Segment_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop/state/interface-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop/state/interface-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop/state/router-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop/state/router-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_RouterIdPathAny struct {
	*ygot.NodePath
}

// InterfaceId (leaf): The identifier assigned to the link by the remote system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop/state/interface-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPath) InterfaceId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_InterfaceIdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): The identifier assigned to the link by the remote system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop/state/interface-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPathAny) InterfaceId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_InterfaceIdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): The IPv4 router identtifier of the remote system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop/state/router-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPath) RouterId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_RouterIdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): The IPv4 router identtifier of the remote system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/ero-path/segments/segment/unnumbered-hop/state/router-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHopPathAny) RouterId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_RouterIdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_EroPath_Segment_UnnumberedHop_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding/state/sid-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding/state/sid-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding/state/sid-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding/state/sid-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidValuePathAny struct {
	*ygot.NodePath
}

// SidType (leaf): The type of the value contained within the sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding/state/sid-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPath) SidType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidType (leaf): The type of the value contained within the sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding/state/sid-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPathAny) SidType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidValue (leaf): The value of the binding included within the sub-TLV. The type of
// this binding is indicated by the type leaf.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding/state/sid-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPath) SidValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidValue (leaf): The value of the binding included within the sub-TLV. The type of
// this binding is indicated by the type leaf.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/sid-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/sid-label-binding/tlvs/tlv/sid-label-binding/state/sid-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBindingPathAny) SidValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_SidLabelBinding_Tlv_SidLabelBinding_SidValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sid-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPath) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_LengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPathAny) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_LengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPath) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_ValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/extended-prefix/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlvPathAny) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_ValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_ExtendedPrefix_Tlv_UnknownTlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_IpInterfaceAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/ip-interface-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_IpInterfaceAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_IpInterfaceAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/ip-interface-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_IpInterfaceAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_PeriodPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/period YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_PeriodPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_PeriodPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/period YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_PeriodPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_ReasonPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/reason YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_ReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_ReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/reason YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_ReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// IpInterfaceAddress (leaf): The restarting system's IP address on the interface via which the
// Grace LSA is being advertised.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/ip-interface-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPath) IpInterfaceAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_IpInterfaceAddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_IpInterfaceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpInterfaceAddress (leaf): The restarting system's IP address on the interface via which the
// Grace LSA is being advertised.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-interface-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/ip-interface-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPathAny) IpInterfaceAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_IpInterfaceAddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_IpInterfaceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-interface-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Period (leaf): The number of seconds that the router's neighbors should advertise
// the local system as fully adjacent regardless of database
// synchronization state
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/period"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/period"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPath) Period() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_PeriodPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_PeriodPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "period"},
			map[string]interface{}{},
			n,
		),
	}
}

// Period (leaf): The number of seconds that the router's neighbors should advertise
// the local system as fully adjacent regardless of database
// synchronization state
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/period"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/period"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPathAny) Period() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_PeriodPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_PeriodPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "period"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reason (leaf): The reason for the graceful restart event occurring, as advertised
// by the restarting system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/reason"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPath) Reason() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_ReasonPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_ReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reason (leaf): The reason for the graceful restart event occurring, as advertised
// by the restarting system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/reason"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/reason"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPathAny) Reason() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_ReasonPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_ReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the sub-TLV received within the Grace LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the sub-TLV received within the Grace LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPath) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_TlvPathAny) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPath) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_LengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPathAny) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_LengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPath) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_ValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/grace-lsa/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlvPathAny) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_ValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_GraceLsa_Tlv_UnknownTlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// InformationalCapabilities (container): Information related to the capabilities of the advertising
// router within the scope that the opaque RI LSA is being
// advertised
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "informational-capabilities"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPath) InformationalCapabilities() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath{
		NodePath: ygot.NewNodePath(
			[]string{"informational-capabilities"},
			map[string]interface{}{},
			n,
		),
	}
}

// InformationalCapabilities (container): Information related to the capabilities of the advertising
// router within the scope that the opaque RI LSA is being
// advertised
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "informational-capabilities"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPathAny) InformationalCapabilities() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"informational-capabilities"},
			map[string]interface{}{},
			n,
		),
	}
}

// NodeAdministrativeTags (container): Per-node administrative tags associated with the local system
// specified by the operator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "node-administrative-tags"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/node-administrative-tags"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPath) NodeAdministrativeTags() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"node-administrative-tags"},
			map[string]interface{}{},
			n,
		),
	}
}

// NodeAdministrativeTags (container): Per-node administrative tags associated with the local system
// specified by the operator
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "node-administrative-tags"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/node-administrative-tags"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPathAny) NodeAdministrativeTags() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"node-administrative-tags"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRoutingAlgorithm (container): The algorithms supported for Segment Routing by the local system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing-algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-algorithm"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPath) SegmentRoutingAlgorithm() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing-algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRoutingAlgorithm (container): The algorithms supported for Segment Routing by the local system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing-algorithm"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-algorithm"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPathAny) SegmentRoutingAlgorithm() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing-algorithm"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRoutingSidLabelRange (container): The Segment Identifier (SID) or label ranges that are supported by
// the local system for Segment Routing
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing-sid-label-range"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPath) SegmentRoutingSidLabelRange() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRangePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRangePath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing-sid-label-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentRoutingSidLabelRange (container): The Segment Identifier (SID) or label ranges that are supported by
// the local system for Segment Routing
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-routing-sid-label-range"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPathAny) SegmentRoutingSidLabelRange() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRangePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-routing-sid-label-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of sub-TLV of the Router Information opaque LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of sub-TLV of the Router Information opaque LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPath) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_TlvPathAny) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_ExperimentalTePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/experimental-te YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_ExperimentalTePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_ExperimentalTePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/experimental-te YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_ExperimentalTePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartCapablePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/graceful-restart-capable YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartCapablePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartCapablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/graceful-restart-capable YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartCapablePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartHelperPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/graceful-restart-helper YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartHelperPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartHelperPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/graceful-restart-helper YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartHelperPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_PointToPointOverLanPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/point-to-point-over-lan YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_PointToPointOverLanPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_PointToPointOverLanPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/point-to-point-over-lan YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_PointToPointOverLanPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_StubRouterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/stub-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_StubRouterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_StubRouterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/stub-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_StubRouterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_TrafficEngineeringPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/traffic-engineering YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_TrafficEngineeringPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_TrafficEngineeringPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/traffic-engineering YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_TrafficEngineeringPathAny struct {
	*ygot.NodePath
}

// ExperimentalTe (leaf): When this leaf is set to ture, the advertising system supports the
// experimental extensions to OSPF for TE described in RFC4973
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/experimental-te"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/experimental-te"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath) ExperimentalTe() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_ExperimentalTePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_ExperimentalTePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "experimental-te"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExperimentalTe (leaf): When this leaf is set to ture, the advertising system supports the
// experimental extensions to OSPF for TE described in RFC4973
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/experimental-te"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/experimental-te"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny) ExperimentalTe() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_ExperimentalTePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_ExperimentalTePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "experimental-te"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestartCapable (leaf): When this leaf is set to true, the advertising system is capable of
// OSPF graceful restart.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/graceful-restart-capable"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/graceful-restart-capable"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath) GracefulRestartCapable() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartCapablePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartCapablePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "graceful-restart-capable"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestartCapable (leaf): When this leaf is set to true, the advertising system is capable of
// OSPF graceful restart.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/graceful-restart-capable"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/graceful-restart-capable"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny) GracefulRestartCapable() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartCapablePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartCapablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "graceful-restart-capable"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestartHelper (leaf): When this leaf is set to true, the advertising system is capable of
// being a helper for OSPF graceful restart
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/graceful-restart-helper"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/graceful-restart-helper"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath) GracefulRestartHelper() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartHelperPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartHelperPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "graceful-restart-helper"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestartHelper (leaf): When this leaf is set to true, the advertising system is capable of
// being a helper for OSPF graceful restart
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/graceful-restart-helper"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/graceful-restart-helper"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny) GracefulRestartHelper() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartHelperPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_GracefulRestartHelperPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "graceful-restart-helper"},
			map[string]interface{}{},
			n,
		),
	}
}

// PointToPointOverLan (leaf): When this leaf is set to true, the advertising system supports treating
// LAN adjacencies as though they were point to point
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/point-to-point-over-lan"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/point-to-point-over-lan"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath) PointToPointOverLan() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_PointToPointOverLanPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_PointToPointOverLanPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "point-to-point-over-lan"},
			map[string]interface{}{},
			n,
		),
	}
}

// PointToPointOverLan (leaf): When this leaf is set to true, the advertising system supports treating
// LAN adjacencies as though they were point to point
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/point-to-point-over-lan"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/point-to-point-over-lan"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny) PointToPointOverLan() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_PointToPointOverLanPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_PointToPointOverLanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "point-to-point-over-lan"},
			map[string]interface{}{},
			n,
		),
	}
}

// StubRouter (leaf): When this leaf is set to true, the advertising system is able to
// advertise its status as a stub router
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/stub-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/stub-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath) StubRouter() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_StubRouterPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_StubRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "stub-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// StubRouter (leaf): When this leaf is set to true, the advertising system is able to
// advertise its status as a stub router
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/stub-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/stub-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny) StubRouter() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_StubRouterPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_StubRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "stub-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineering (leaf): When this leaf is set to true, the advertising system supports OSPFv2
// traffic engineering capabilities
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/traffic-engineering"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/traffic-engineering"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPath) TrafficEngineering() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_TrafficEngineeringPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_TrafficEngineeringPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "traffic-engineering"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineering (leaf): When this leaf is set to true, the advertising system supports OSPFv2
// traffic engineering capabilities
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/traffic-engineering"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/informational-capabilities/state/traffic-engineering"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilitiesPathAny) TrafficEngineering() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_TrafficEngineeringPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_InformationalCapabilities_TrafficEngineeringPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "traffic-engineering"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/node-administrative-tags YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/node-administrative-tags YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTags_AdministrativeTagsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/node-administrative-tags/state/administrative-tags YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTags_AdministrativeTagsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTags_AdministrativeTagsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/node-administrative-tags/state/administrative-tags YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTags_AdministrativeTagsPathAny struct {
	*ygot.NodePath
}

// AdministrativeTags (leaf): The set of administrative tags assigned to the local system by
// the network operator. The meaning of these tags is opaque to OSPF
// - and their interpretation is per-domain specific
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/administrative-tags"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/node-administrative-tags/state/administrative-tags"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPath) AdministrativeTags() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTags_AdministrativeTagsPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTags_AdministrativeTagsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "administrative-tags"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdministrativeTags (leaf): The set of administrative tags assigned to the local system by
// the network operator. The meaning of these tags is opaque to OSPF
// - and their interpretation is per-domain specific
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/administrative-tags"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/node-administrative-tags/state/administrative-tags"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTagsPathAny) AdministrativeTags() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTags_AdministrativeTagsPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_NodeAdministrativeTags_AdministrativeTagsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "administrative-tags"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-algorithm YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-algorithm YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithm_SupportedAlgorithmsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-algorithm/state/supported-algorithms YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithm_SupportedAlgorithmsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithm_SupportedAlgorithmsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-algorithm/state/supported-algorithms YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithm_SupportedAlgorithmsPathAny struct {
	*ygot.NodePath
}

// SupportedAlgorithms (leaf): A list of the algorithms that are supported for segment routing
// by the advertising system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/supported-algorithms"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-algorithm/state/supported-algorithms"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPath) SupportedAlgorithms() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithm_SupportedAlgorithmsPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithm_SupportedAlgorithmsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "supported-algorithms"},
			map[string]interface{}{},
			n,
		),
	}
}

// SupportedAlgorithms (leaf): A list of the algorithms that are supported for segment routing
// by the advertising system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/supported-algorithms"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-algorithm/state/supported-algorithms"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithmPathAny) SupportedAlgorithms() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithm_SupportedAlgorithmsPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingAlgorithm_SupportedAlgorithmsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "supported-algorithms"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRangePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRangePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRangePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRangePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_RangeSizePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/state/range-size YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_RangeSizePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_RangeSizePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/state/range-size YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_RangeSizePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// RangeSize (leaf): The number of entries within the range being described within the
// SID/Label range TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/range-size"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/state/range-size"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPath) RangeSize() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_RangeSizePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_RangeSizePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "range-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// RangeSize (leaf): The number of entries within the range being described within the
// SID/Label range TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/range-size"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/state/range-size"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPathAny) RangeSize() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_RangeSizePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_RangeSizePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "range-size"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidLabel (container): Sub-TLV used to advertise the SID or label associated with the
// subset of the SRGB being advertised
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-label"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPath) SidLabel() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"sid-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// SidLabel (container): Sub-TLV used to advertise the SID or label associated with the
// subset of the SRGB being advertised
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sid-label"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPathAny) SidLabel() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sid-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the sub-TLV received by the local system within the
// SR SID/Label Range TLV of the RI LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the sub-TLV received by the local system within the
// SR SID/Label Range TLV of the RI LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPath) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_TlvPathAny) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_EntryTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label/state/entry-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_EntryTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_EntryTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label/state/entry-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_EntryTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_FirstValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label/state/first-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_FirstValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_FirstValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label/state/first-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_FirstValuePathAny struct {
	*ygot.NodePath
}

// EntryType (leaf): The type of entry that is contained within the sub-TLV. The range may
// be represented as either a range of MPLS labels, or numeric segment
// identifiers
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label/state/entry-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPath) EntryType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_EntryTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_EntryTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// EntryType (leaf): The type of entry that is contained within the sub-TLV. The range may
// be represented as either a range of MPLS labels, or numeric segment
// identifiers
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/entry-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label/state/entry-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPathAny) EntryType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_EntryTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_EntryTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "entry-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// FirstValue (leaf): The first value within the SRGB range being specified. The type of the
// entry is determined based on the value of the entry type as this value
// may represent either a segment identifier or an MPLS label.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/first-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label/state/first-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPath) FirstValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_FirstValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_FirstValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "first-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// FirstValue (leaf): The first value within the SRGB range being specified. The type of the
// entry is determined based on the value of the entry type as this value
// may represent either a segment identifier or an MPLS label.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/first-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/sid-label/state/first-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabelPathAny) FirstValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_FirstValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_SidLabel_FirstValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "first-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPath) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_LengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPathAny) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_LengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPath) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_ValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/segment-routing-sid-label-range/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlvPathAny) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_ValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_SegmentRoutingSidLabelRange_Tlv_UnknownTlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPath) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_LengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPathAny) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_LengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPath) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_ValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/router-information/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlvPathAny) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_ValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_RouterInformation_Tlv_UnknownTlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineeringPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineeringPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineeringPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineeringPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// Link (container): Parameters included in the Link TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPath) Link() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_LinkPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_LinkPath{
		NodePath: ygot.NewNodePath(
			[]string{"link"},
			map[string]interface{}{},
			n,
		),
	}
}

// Link (container): Parameters included in the Link TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "link"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPathAny) Link() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_LinkPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_LinkPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"link"},
			map[string]interface{}{},
			n,
		),
	}
}

// NodeAttribute (container): Parameters included in the Node Attribute TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "node-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPath) NodeAttribute() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttributePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttributePath{
		NodePath: ygot.NewNodePath(
			[]string{"node-attribute"},
			map[string]interface{}{},
			n,
		),
	}
}

// NodeAttribute (container): Parameters included in the Node Attribute TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "node-attribute"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPathAny) NodeAttribute() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttributePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttributePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"node-attribute"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterAddress (container): Parameters included in the Router Address TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/router-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPath) RouterAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"router-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterAddress (container): Parameters included in the Router Address TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "router-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/router-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPathAny) RouterAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"router-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of TLV within the Traffic Engineering LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of TLV within the Traffic Engineering LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPath) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownTlv (container): An unknown TLV within the context. Unknown TLVs are
// defined to be the set of TLVs that are not modelled
// within the OpenConfig model, or are unknown to the
// local system such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-tlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_TlvPathAny) UnknownTlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-tlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_LinkPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_LinkPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_LinkPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_LinkPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/link-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/link-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/link-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/link-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LocalIpAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/local-ip-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LocalIpAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LocalIpAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/local-ip-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LocalIpAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/maximum-bandwidth YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/maximum-bandwidth YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumReservableBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/maximum-reservable-bandwidth YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumReservableBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumReservableBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/maximum-reservable-bandwidth YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumReservableBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_RemoteIpAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/remote-ip-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_RemoteIpAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_RemoteIpAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/remote-ip-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_RemoteIpAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/unknown-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/unknown-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/unknown-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/unknown-value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownValuePathAny struct {
	*ygot.NodePath
}

// AdminGroupAny (list): The administrative group described within the
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "administrative-groups/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group"
// BitIndex (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) AdminGroupAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"administrative-groups", "admin-group"},
			map[string]interface{}{"bit-index": "*"},
			n,
		),
	}
}

// AdminGroupAny (list): The administrative group described within the
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "administrative-groups/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group"
// BitIndex (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) AdminGroupAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"administrative-groups", "admin-group"},
			map[string]interface{}{"bit-index": "*"},
			n,
		),
	}
}

// AdminGroup (list): The administrative group described within the
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "administrative-groups/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group"
// BitIndex: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) AdminGroup(BitIndex uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"administrative-groups", "admin-group"},
			map[string]interface{}{"bit-index": BitIndex},
			n,
		),
	}
}

// AdminGroup (list): The administrative group described within the
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "administrative-groups/admin-group"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group"
// BitIndex: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) AdminGroup(BitIndex uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"administrative-groups", "admin-group"},
			map[string]interface{}{"bit-index": BitIndex},
			n,
		),
	}
}

// LinkId (leaf): The ID of the remote system. For point-to-point links, this is the
// router ID of the neighbor. For multi-access links it is the address
// of the designated router.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/link-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) LinkId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkIdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (leaf): The ID of the remote system. For point-to-point links, this is the
// router ID of the neighbor. For multi-access links it is the address
// of the designated router.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/link-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) LinkId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkIdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkType (leaf): The type of the link that is being described by the TE LSA Link
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/link-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) LinkType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkType (leaf): The type of the link that is being described by the TE LSA Link
// sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/link-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) LinkType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LinkTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIpAddress (leaf): The IP address(es) of the local system that correspond to the
// specified TE link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ip-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/local-ip-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) LocalIpAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LocalIpAddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LocalIpAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIpAddress (leaf): The IP address(es) of the local system that correspond to the
// specified TE link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ip-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/local-ip-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) LocalIpAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LocalIpAddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_LocalIpAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumBandwidth (leaf): The maximum bandwidth of the link. This value reflects the actual
// bandwidth of the link expressed asn IEEE 32-bit floating point
// number
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/maximum-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/maximum-bandwidth"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) MaximumBandwidth() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumBandwidthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "maximum-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumBandwidth (leaf): The maximum bandwidth of the link. This value reflects the actual
// bandwidth of the link expressed asn IEEE 32-bit floating point
// number
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/maximum-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/maximum-bandwidth"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) MaximumBandwidth() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumBandwidthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "maximum-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumReservableBandwidth (leaf): The maximum reservable bandwidth for the link. This value represents
// the total bandwidth which may be used for traffic engineering
// purposes. The value may exceed the maximum-bandwidth value
// in cases where the link is oversubscribed. The value is reflected as
// a 32-bit IEEE floating-point number
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/maximum-reservable-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/maximum-reservable-bandwidth"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) MaximumReservableBandwidth() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumReservableBandwidthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumReservableBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "maximum-reservable-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumReservableBandwidth (leaf): The maximum reservable bandwidth for the link. This value represents
// the total bandwidth which may be used for traffic engineering
// purposes. The value may exceed the maximum-bandwidth value
// in cases where the link is oversubscribed. The value is reflected as
// a 32-bit IEEE floating-point number
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/maximum-reservable-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/maximum-reservable-bandwidth"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) MaximumReservableBandwidth() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumReservableBandwidthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MaximumReservableBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "maximum-reservable-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric of the link that should be used for traffic engineering
// purposes. This link may be different than the standard OSPF link
// metric.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric of the link that should be used for traffic engineering
// purposes. This link may be different than the standard OSPF link
// metric.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteIpAddress (leaf): The IP address(es) of the remote systems that are attached to the
// specified TE link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-ip-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/remote-ip-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) RemoteIpAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_RemoteIpAddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_RemoteIpAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteIpAddress (leaf): The IP address(es) of the remote systems that are attached to the
// specified TE link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/remote-ip-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/remote-ip-address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) RemoteIpAddress() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_RemoteIpAddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_RemoteIpAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "remote-ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The sub-TLV type specified in the Link TLV. When the value is
// known by the local system, a canonical name of the sub-TLV is utilised
// - the special UNKNOWN value indicates that the system did not
// support the sub-TLV type received in the LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The sub-TLV type specified in the Link TLV. When the value is
// known by the local system, a canonical name of the sub-TLV is utilised
// - the special UNKNOWN value indicates that the system did not
// support the sub-TLV type received in the LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownSubtlv (container): An unknown SubTLV within the context. Unknown Sub-TLV
// are defined to be the set of SubTLVs that are not modelled
// by the OpenConfig schema, or are unknown to the local system
// such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) UnknownSubtlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-subtlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownSubtlv (container): An unknown SubTLV within the context. Unknown Sub-TLV
// are defined to be the set of SubTLVs that are not modelled
// by the OpenConfig schema, or are unknown to the local system
// such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) UnknownSubtlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-subtlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownType (leaf): The value of the type field of an unknown sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/unknown-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/unknown-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) UnknownType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "unknown-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownType (leaf): The value of the type field of an unknown sub-TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/unknown-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/unknown-type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) UnknownType() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "unknown-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownValue (leaf): The binary contents of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/unknown-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/unknown-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) UnknownValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "unknown-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownValue (leaf): The binary contents of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/unknown-value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/state/unknown-value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) UnknownValue() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "unknown-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnreservedBandwidthAny (list): The unreserved bandwidth at each priority level
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidths/unreserved-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) UnreservedBandwidthAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidths", "unreserved-bandwidth"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// UnreservedBandwidthAny (list): The unreserved bandwidth at each priority level
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidths/unreserved-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth"
// Priority (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) UnreservedBandwidthAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidths", "unreserved-bandwidth"},
			map[string]interface{}{"priority": "*"},
			n,
		),
	}
}

// UnreservedBandwidth (list): The unreserved bandwidth at each priority level
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidths/unreserved-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth"
// Priority: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPath) UnreservedBandwidth(Priority uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidths", "unreserved-bandwidth"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// UnreservedBandwidth (list): The unreserved bandwidth at each priority level
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unreserved-bandwidths/unreserved-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth"
// Priority: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlvPathAny) UnreservedBandwidth(Priority uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unreserved-bandwidths", "unreserved-bandwidth"},
			map[string]interface{}{"priority": Priority},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_BitIndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group/state/bit-index YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_BitIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_BitIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group/state/bit-index YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_BitIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_SetPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group/state/set YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_SetPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_SetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group/state/set YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_SetPathAny struct {
	*ygot.NodePath
}

// BitIndex (leaf): The index of the bit within the 32-bit administrative group field
// of the Administrative Group sub-TLV of the Traffic Engineering LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bit-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group/state/bit-index"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPath) BitIndex() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_BitIndexPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_BitIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bit-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// BitIndex (leaf): The index of the bit within the 32-bit administrative group field
// of the Administrative Group sub-TLV of the Traffic Engineering LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bit-index"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group/state/bit-index"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny) BitIndex() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_BitIndexPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_BitIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bit-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Set (leaf): Whether the bit is set within the administrative group field
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/set"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group/state/set"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPath) Set() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_SetPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_SetPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "set"},
			map[string]interface{}{},
			n,
		),
	}
}

// Set (leaf): Whether the bit is set within the administrative group field
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/set"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/administrative-groups/admin-group/state/set"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroupPathAny) Set() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_SetPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_AdminGroup_SetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "set"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPath) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPathAny) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPath) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unknown-subtlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlvPathAny) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnknownSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth/state/priority YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth/state/priority YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_PriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_UnreservedBandwidthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth/state/unreserved-bandwidth YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_UnreservedBandwidthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_UnreservedBandwidthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth/state/unreserved-bandwidth YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_UnreservedBandwidthPathAny struct {
	*ygot.NodePath
}

// Priority (leaf): The priority level being described
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth/state/priority"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPath) Priority() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_PriorityPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The priority level being described
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth/state/priority"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny) Priority() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_PriorityPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnreservedBandwidth (leaf): The unreserved bandwidth for at priority level P, where P is
// equal to the priority of the current list entry. The reservable
// bandwidth at priority P is equal to the sum of the reservable
// bandwidth at all levels 0..P.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/unreserved-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth/state/unreserved-bandwidth"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPath) UnreservedBandwidth() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_UnreservedBandwidthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_UnreservedBandwidthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "unreserved-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnreservedBandwidth (leaf): The unreserved bandwidth for at priority level P, where P is
// equal to the priority of the current list entry. The reservable
// bandwidth at priority P is equal to the sum of the reservable
// bandwidth at all levels 0..P.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/unreserved-bandwidth"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/link/sub-tlvs/sub-tlv/unreserved-bandwidths/unreserved-bandwidth/state/unreserved-bandwidth"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidthPathAny) UnreservedBandwidth() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_UnreservedBandwidthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_Link_SubTlv_UnreservedBandwidth_UnreservedBandwidthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "unreserved-bandwidth"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttributePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttributePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttributePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttributePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv4AddressesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/local-ipv4-addresses YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv4AddressesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv4AddressesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/local-ipv4-addresses YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv4AddressesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv6AddressesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/local-ipv6-addresses YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv6AddressesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv6AddressesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/local-ipv6-addresses YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv6AddressesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_TypePathAny struct {
	*ygot.NodePath
}

// LocalIpv4Addresses (leaf): The local IPv4 addresses of the node expressed in CIDR notation
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ipv4-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/local-ipv4-addresses"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPath) LocalIpv4Addresses() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv4AddressesPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv4AddressesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ipv4-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIpv4Addresses (leaf): The local IPv4 addresses of the node expressed in CIDR notation
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ipv4-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/local-ipv4-addresses"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPathAny) LocalIpv4Addresses() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv4AddressesPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv4AddressesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ipv4-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIpv6Addresses (leaf): The local IPv6 addreses of the node
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ipv6-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/local-ipv6-addresses"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPath) LocalIpv6Addresses() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv6AddressesPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv6AddressesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ipv6-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalIpv6Addresses (leaf): The local IPv6 addreses of the node
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/local-ipv6-addresses"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/local-ipv6-addresses"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPathAny) LocalIpv6Addresses() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv6AddressesPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_LocalIpv6AddressesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "local-ipv6-addresses"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the sub-TLV of the Node Attribute TLV contained within
// the TE LSA. If the local system can interpret the value received the
// canonical name of the type is utilised, otherwise the special UNKNOWN
// value is used
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type of the sub-TLV of the Node Attribute TLV contained within
// the TE LSA. If the local system can interpret the value received the
// canonical name of the type is utilised, otherwise the special UNKNOWN
// value is used
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownSubtlv (container): An unknown SubTLV within the context. Unknown Sub-TLV
// are defined to be the set of SubTLVs that are not modelled
// by the OpenConfig schema, or are unknown to the local system
// such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPath) UnknownSubtlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPath{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-subtlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnknownSubtlv (container): An unknown SubTLV within the context. Unknown Sub-TLV
// are defined to be the set of SubTLVs that are not modelled
// by the OpenConfig schema, or are unknown to the local system
// such that it cannot decode their value.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "unknown-subtlv"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlvPathAny) UnknownSubtlv() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"unknown-subtlv"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPath) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_LengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPathAny) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_LengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPath) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_ValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/node-attribute/sub-tlvs/sub-tlv/unknown-subtlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlvPathAny) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_ValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_NodeAttribute_SubTlv_UnknownSubtlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/router-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/router-address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddress_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/router-address/state/address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddress_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddress_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/router-address/state/address YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddress_AddressPathAny struct {
	*ygot.NodePath
}

// Address (leaf): A stable IP address of the advertising router, that is always
// reachable when the router is connected to the network. Typically this
// is a loopback address.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/router-address/state/address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPath) Address() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddress_AddressPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddress_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): A stable IP address of the advertising router, that is always
// reachable when the router is connected to the network. Typically this
// is a loopback address.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/router-address/state/address"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddressPathAny) Address() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddress_AddressPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_RouterAddress_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPath) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_LengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPathAny) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_LengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPath) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_ValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/traffic-engineering/tlvs/tlv/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlvPathAny) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_ValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_TrafficEngineering_Tlv_UnknownTlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_LengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_LengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_LengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_LengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_TypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/value YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_ValuePathAny struct {
	*ygot.NodePath
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPath) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_LengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_LengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Length (leaf): The length value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPathAny) Length() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_LengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_LengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "length"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The type value of the unknown TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPath) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_ValuePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value portion of the unknwon TLV
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/opaque-lsa/unknown-tlv/state/value"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlvPathAny) Value() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_ValuePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_OpaqueLsa_UnknownTlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkDataPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/link-data YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkDataPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkDataPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/link-data YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkDataPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/link-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/link-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberLinksPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/number-links YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberLinksPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberLinksPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/number-links YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberLinksPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberTosMetricsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/number-tos-metrics YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberTosMetricsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberTosMetricsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/number-tos-metrics YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberTosMetricsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypePathAny struct {
	*ygot.NodePath
}

// LinkData (leaf): The data associated with the link type. The value is
// dependent upon the subtype of the LSA. When the connection is
// to a stub network it represents the mask; for p2p connections
// that are unnumbered it represents the ifIndex value of the
// router's interface; for all other connections it represents
// the local system's IP address
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-data"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/link-data"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath) LinkData() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkDataPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkDataPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-data"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkData (leaf): The data associated with the link type. The value is
// dependent upon the subtype of the LSA. When the connection is
// to a stub network it represents the mask; for p2p connections
// that are unnumbered it represents the ifIndex value of the
// router's interface; for all other connections it represents
// the local system's IP address
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-data"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/link-data"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny) LinkData() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkDataPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkDataPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-data"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (leaf): The identifier for the link specified. The value of the link
// identifier is dependent upon the type of the LSA. The value is
// specified to be, per sub-type:
//  1) Neighbouring router's router ID.
//  2) IP address of DR.
//  3) IP network address.
//  4) Neighbouring router router's ID.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/link-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath) LinkId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkIdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkId (leaf): The identifier for the link specified. The value of the link
// identifier is dependent upon the type of the LSA. The value is
// specified to be, per sub-type:
//  1) Neighbouring router's router ID.
//  2) IP address of DR.
//  3) IP network address.
//  4) Neighbouring router router's ID.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/link-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/link-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny) LinkId() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkIdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_LinkIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The cost of utilising the link specified independent of TOS
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The cost of utilising the link specified independent of TOS
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NumberLinks (leaf): The number of links that are described within the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/number-links"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/number-links"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath) NumberLinks() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberLinksPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberLinksPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "number-links"},
			map[string]interface{}{},
			n,
		),
	}
}

// NumberLinks (leaf): The number of links that are described within the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/number-links"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/number-links"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny) NumberLinks() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberLinksPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberLinksPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "number-links"},
			map[string]interface{}{},
			n,
		),
	}
}

// NumberTosMetrics (leaf): The number of different TOS metrics given for this link, not
// including the link metric (which is referred to as TOS 0).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/number-tos-metrics"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/number-tos-metrics"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath) NumberTosMetrics() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberTosMetricsPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberTosMetricsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "number-tos-metrics"},
			map[string]interface{}{},
			n,
		),
	}
}

// NumberTosMetrics (leaf): The number of different TOS metrics given for this link, not
// including the link metric (which is referred to as TOS 0).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/number-tos-metrics"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/number-tos-metrics"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny) NumberTosMetrics() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberTosMetricsPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_NumberTosMetricsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "number-tos-metrics"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The sub-type of the Router LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The sub-type of the Router LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/state/type"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny) Type() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// TypeOfServiceAny (list): Per-type of service parameters for the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service"
// Tos (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath) TypeOfServiceAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": "*"},
			n,
		),
	}
}

// TypeOfServiceAny (list): Per-type of service parameters for the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service"
// Tos (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny) TypeOfServiceAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": "*"},
			n,
		),
	}
}

// TypeOfService (list): Per-type of service parameters for the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service"
// Tos: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPath) TypeOfService(Tos uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePath{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": Tos},
			n,
		),
	}
}

// TypeOfService (list): Per-type of service parameters for the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service"
// Tos: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsaPathAny) TypeOfService(Tos uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": Tos},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_TosPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service/state/tos YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_TosPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_TosPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service/state/tos YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_TosPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): The metric value to be used for the TOS specified. This value
// represents the cost of use of the link for the specific type
// of service.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric value to be used for the TOS specified. This value
// represents the cost of use of the link for the specific type
// of service.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tos (leaf): OSPF encoding of the type of service referred to by this
// LSA. Encoding for OSPF TOS are described in RFC2328.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tos"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service/state/tos"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePath) Tos() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_TosPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_TosPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tos"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tos (leaf): OSPF encoding of the type of service referred to by this
// LSA. Encoding for OSPF TOS are described in RFC2328.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tos"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/router-lsa/types-of-service/type-of-service/state/tos"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfServicePathAny) Tos() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_TosPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_RouterLsa_TypeOfService_TosPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tos"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_NetworkMaskPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/state/network-mask YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_NetworkMaskPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_NetworkMaskPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/state/network-mask YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_NetworkMaskPathAny struct {
	*ygot.NodePath
}

// NetworkMask (leaf): The mask of the network described by the Summary LSA
// represented as a CIDR mask.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/network-mask"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/state/network-mask"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPath) NetworkMask() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_NetworkMaskPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_NetworkMaskPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "network-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkMask (leaf): The mask of the network described by the Summary LSA
// represented as a CIDR mask.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/network-mask"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/state/network-mask"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPathAny) NetworkMask() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_NetworkMaskPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_NetworkMaskPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "network-mask"},
			map[string]interface{}{},
			n,
		),
	}
}

// TypeOfServiceAny (list): Per-type of service parameters for the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service"
// Tos (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPath) TypeOfServiceAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": "*"},
			n,
		),
	}
}

// TypeOfServiceAny (list): Per-type of service parameters for the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service"
// Tos (wildcarded): uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPathAny) TypeOfServiceAny() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": "*"},
			n,
		),
	}
}

// TypeOfService (list): Per-type of service parameters for the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service"
// Tos: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPath) TypeOfService(Tos uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePath{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": Tos},
			n,
		),
	}
}

// TypeOfService (list): Per-type of service parameters for the LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "types-of-service/type-of-service"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service"
// Tos: uint8
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsaPathAny) TypeOfService(Tos uint8) *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"types-of-service", "type-of-service"},
			map[string]interface{}{"tos": Tos},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service/state/metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_TosPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service/state/tos YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_TosPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_TosPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service/state/tos YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_TosPathAny struct {
	*ygot.NodePath
}

// Metric (leaf): The metric value to be used for the TOS specified. This value
// represents the cost of use of the link for the specific type
// of service.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePath) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_MetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): The metric value to be used for the TOS specified. This value
// represents the cost of use of the link for the specific type
// of service.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service/state/metric"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny) Metric() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_MetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tos (leaf): OSPF encoding of the type of service referred to by this
// LSA. Encoding for OSPF TOS are described in RFC2328.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tos"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service/state/tos"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePath) Tos() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_TosPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_TosPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tos"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tos (leaf): OSPF encoding of the type of service referred to by this
// LSA. Encoding for OSPF TOS are described in RFC2328.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-lsdb"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/tos"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/lsdb/lsa-types/lsa-type/lsas/lsa/summary-lsa/types-of-service/type-of-service/state/tos"
func (n *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfServicePathAny) Tos() *NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_TosPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Lsdb_LsaType_Lsa_SummaryLsa_TypeOfService_TosPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tos"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_MplsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/mpls YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_MplsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_MplsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/mpls YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_MplsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Mpls_TrafficEngineeringEnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/mpls/config/traffic-engineering-enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Mpls_TrafficEngineeringEnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_Mpls_TrafficEngineeringEnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/mpls/config/traffic-engineering-enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_Mpls_TrafficEngineeringEnabledPathAny struct {
	*ygot.NodePath
}

// TrafficEngineeringEnabled (leaf): Specifies whether traffic engineering extensions should be
// advertised within the area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/traffic-engineering-enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/mpls/config/traffic-engineering-enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Area_MplsPath) TrafficEngineeringEnabled() *NetworkInstance_Protocol_Ospfv2_Area_Mpls_TrafficEngineeringEnabledPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_Mpls_TrafficEngineeringEnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "traffic-engineering-enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineeringEnabled (leaf): Specifies whether traffic engineering extensions should be
// advertised within the area
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/traffic-engineering-enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/mpls/config/traffic-engineering-enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Area_MplsPathAny) TrafficEngineeringEnabled() *NetworkInstance_Protocol_Ospfv2_Area_Mpls_TrafficEngineeringEnabledPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_Mpls_TrafficEngineeringEnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "traffic-engineering-enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_AdjacencyStatePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/adjacency-state YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_AdjacencyStatePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_AdjacencyStatePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/adjacency-state YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_AdjacencyStatePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_BackupDesignatedRouterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/backup-designated-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_BackupDesignatedRouterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_BackupDesignatedRouterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/backup-designated-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_BackupDesignatedRouterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DeadTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/dead-time YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DeadTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DeadTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/dead-time YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DeadTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DesignatedRouterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/designated-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DesignatedRouterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DesignatedRouterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/designated-router YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DesignatedRouterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_LastEstablishedTimePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/last-established-time YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_LastEstablishedTimePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_LastEstablishedTimePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/last-established-time YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_LastEstablishedTimePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_OptionalCapabilitiesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/optional-capabilities YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_OptionalCapabilitiesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_OptionalCapabilitiesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/optional-capabilities YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_OptionalCapabilitiesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_PriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/priority YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_PriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_PriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/priority YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_PriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RemoteRouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/config/remote-router-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RemoteRouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RemoteRouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/config/remote-router-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RemoteRouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RetransmissionQueueLengthPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/retransmission-queue-length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RetransmissionQueueLengthPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RetransmissionQueueLengthPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/retransmission-queue-length YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RetransmissionQueueLengthPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_StateChangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/state-changes YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_StateChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_StateChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/state-changes YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_StateChangesPathAny struct {
	*ygot.NodePath
}

// AdjacencyState (leaf): The state of the adjacency with the neighbor.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-state"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/adjacency-state"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) AdjacencyState() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_AdjacencyStatePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_AdjacencyStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdjacencyState (leaf): The state of the adjacency with the neighbor.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/adjacency-state"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/adjacency-state"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) AdjacencyState() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_AdjacencyStatePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_AdjacencyStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "adjacency-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// BackupDesignatedRouter (leaf): The backup designated router for the adjacency.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup-designated-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/backup-designated-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) BackupDesignatedRouter() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_BackupDesignatedRouterPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_BackupDesignatedRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup-designated-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// BackupDesignatedRouter (leaf): The backup designated router for the adjacency.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/backup-designated-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/backup-designated-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) BackupDesignatedRouter() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_BackupDesignatedRouterPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_BackupDesignatedRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "backup-designated-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// DeadTime (leaf): The time at which this neighbor's adjacency will be
// considered dead. The value is expressed relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dead-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/dead-time"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) DeadTime() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DeadTimePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DeadTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dead-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// DeadTime (leaf): The time at which this neighbor's adjacency will be
// considered dead. The value is expressed relative to
// the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dead-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/dead-time"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) DeadTime() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DeadTimePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DeadTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dead-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRouter (leaf): The designated router for the adjacency. This device
// advertises the Network LSA for broadcast and NBMA networks.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/designated-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/designated-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) DesignatedRouter() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DesignatedRouterPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DesignatedRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRouter (leaf): The designated router for the adjacency. This device
// advertises the Network LSA for broadcast and NBMA networks.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/designated-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/designated-router"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) DesignatedRouter() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DesignatedRouterPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_DesignatedRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastEstablishedTime (leaf): The time at which the adjacency was last established with
// the neighbor. That is to say the time at which the
// adjacency last transitioned into the FULL state. The
// value is expressed relative to the Unix Epoch (Jan 1 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-established-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/last-established-time"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) LastEstablishedTime() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_LastEstablishedTimePath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_LastEstablishedTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-established-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastEstablishedTime (leaf): The time at which the adjacency was last established with
// the neighbor. That is to say the time at which the
// adjacency last transitioned into the FULL state. The
// value is expressed relative to the Unix Epoch (Jan 1 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/last-established-time"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/last-established-time"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) LastEstablishedTime() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_LastEstablishedTimePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_LastEstablishedTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-established-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OptionalCapabilities (leaf): The optional capabilities field received in the Hello
// message from the neighbor
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional-capabilities"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/optional-capabilities"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) OptionalCapabilities() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_OptionalCapabilitiesPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_OptionalCapabilitiesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional-capabilities"},
			map[string]interface{}{},
			n,
		),
	}
}

// OptionalCapabilities (leaf): The optional capabilities field received in the Hello
// message from the neighbor
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/optional-capabilities"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/optional-capabilities"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) OptionalCapabilities() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_OptionalCapabilitiesPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_OptionalCapabilitiesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optional-capabilities"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The remote system's priority to become the designated
// router
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/priority"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) Priority() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_PriorityPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The remote system's priority to become the designated
// router
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/priority"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) Priority() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_PriorityPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteRouterId (leaf): The router ID of the device which terminates the remote end
// of the virtual link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remote-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/config/remote-router-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) RemoteRouterId() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RemoteRouterIdPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RemoteRouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteRouterId (leaf): The router ID of the device which terminates the remote end
// of the virtual link
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/remote-router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/config/remote-router-id"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) RemoteRouterId() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RemoteRouterIdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RemoteRouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetransmissionQueueLength (leaf): The number of LSAs that are currently in the queue to be
// retransmitted to the neighbor
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmission-queue-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/retransmission-queue-length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) RetransmissionQueueLength() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RetransmissionQueueLengthPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RetransmissionQueueLengthPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmission-queue-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetransmissionQueueLength (leaf): The number of LSAs that are currently in the queue to be
// retransmitted to the neighbor
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/retransmission-queue-length"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/retransmission-queue-length"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) RetransmissionQueueLength() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RetransmissionQueueLengthPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_RetransmissionQueueLengthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "retransmission-queue-length"},
			map[string]interface{}{},
			n,
		),
	}
}

// StateChanges (leaf): The number of transitions out of the FULL state that this
// neighbor has been through
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/state-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/state-changes"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPath) StateChanges() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_StateChangesPath {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_StateChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// StateChanges (leaf): The number of transitions out of the FULL state that this
// neighbor has been through
// ----------------------------------------
// Defining module: "openconfig-ospfv2-area-interface"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/state-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/areas/area/virtual-links/virtual-link/state/state-changes"
func (n *NetworkInstance_Protocol_Ospfv2_Area_VirtualLinkPathAny) StateChanges() *NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_StateChangesPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Area_VirtualLink_StateChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "state-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_GlobalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global YANG schema element.
type NetworkInstance_Protocol_Ospfv2_GlobalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_GlobalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global YANG schema element.
type NetworkInstance_Protocol_Ospfv2_GlobalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_HideTransitOnlyNetworksPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/hide-transit-only-networks YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_HideTransitOnlyNetworksPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_HideTransitOnlyNetworksPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/hide-transit-only-networks YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_HideTransitOnlyNetworksPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_IgpShortcutsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/igp-shortcuts YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_IgpShortcutsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_IgpShortcutsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/igp-shortcuts YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_IgpShortcutsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_LogAdjacencyChangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/log-adjacency-changes YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_LogAdjacencyChangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_LogAdjacencyChangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/log-adjacency-changes YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_LogAdjacencyChangesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_RouterIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/router-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_RouterIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_RouterIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/router-id YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_RouterIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_SummaryRouteCostModePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/summary-route-cost-mode YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_SummaryRouteCostModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_SummaryRouteCostModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/config/summary-route-cost-mode YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_SummaryRouteCostModePathAny struct {
	*ygot.NodePath
}

// GracefulRestart (container): Configuration and operational state parameters for OSPFv2
// graceful restart
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) GracefulRestart() *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPath{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// GracefulRestart (container): Configuration and operational state parameters for OSPFv2
// graceful restart
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "graceful-restart"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) GracefulRestart() *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"graceful-restart"},
			map[string]interface{}{},
			n,
		),
	}
}

// HideTransitOnlyNetworks (leaf): When this leaf is set to true, do not advertise prefixes
// into OSPFv2 that correspond to transit interfaces, as per
// the behaviour discussed in RFC6860.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hide-transit-only-networks"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/hide-transit-only-networks"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) HideTransitOnlyNetworks() *NetworkInstance_Protocol_Ospfv2_Global_HideTransitOnlyNetworksPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_HideTransitOnlyNetworksPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hide-transit-only-networks"},
			map[string]interface{}{},
			n,
		),
	}
}

// HideTransitOnlyNetworks (leaf): When this leaf is set to true, do not advertise prefixes
// into OSPFv2 that correspond to transit interfaces, as per
// the behaviour discussed in RFC6860.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hide-transit-only-networks"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/hide-transit-only-networks"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) HideTransitOnlyNetworks() *NetworkInstance_Protocol_Ospfv2_Global_HideTransitOnlyNetworksPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_HideTransitOnlyNetworksPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hide-transit-only-networks"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgpShortcuts (leaf): When this leaf is set to true, OSPFv2 will route traffic to
// a remote system via any LSP to the system that is marked as
// shortcut eligible.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/igp-shortcuts"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/igp-shortcuts"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) IgpShortcuts() *NetworkInstance_Protocol_Ospfv2_Global_IgpShortcutsPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_IgpShortcutsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "igp-shortcuts"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgpShortcuts (leaf): When this leaf is set to true, OSPFv2 will route traffic to
// a remote system via any LSP to the system that is marked as
// shortcut eligible.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/igp-shortcuts"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/igp-shortcuts"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) IgpShortcuts() *NetworkInstance_Protocol_Ospfv2_Global_IgpShortcutsPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_IgpShortcutsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "igp-shortcuts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterAreaPropagationPolicyAny (list): A list of connections between pairs of areas - routes are
// propagated from the source (src) area to the destination (dst)
// area according to the policy specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-area-propagation-policies/inter-area-propagation-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy"
// SrcArea (wildcarded): [UnionUint32, UnionString]
// DstArea (wildcarded): [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) InterAreaPropagationPolicyAny() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inter-area-propagation-policies", "inter-area-propagation-policy"},
			map[string]interface{}{"src-area": "*", "dst-area": "*"},
			n,
		),
	}
}

// InterAreaPropagationPolicyAny (list): A list of connections between pairs of areas - routes are
// propagated from the source (src) area to the destination (dst)
// area according to the policy specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-area-propagation-policies/inter-area-propagation-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy"
// SrcArea (wildcarded): [UnionUint32, UnionString]
// DstArea (wildcarded): [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) InterAreaPropagationPolicyAny() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inter-area-propagation-policies", "inter-area-propagation-policy"},
			map[string]interface{}{"src-area": "*", "dst-area": "*"},
			n,
		),
	}
}

// InterAreaPropagationPolicyAnyDstArea (list): A list of connections between pairs of areas - routes are
// propagated from the source (src) area to the destination (dst)
// area according to the policy specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-area-propagation-policies/inter-area-propagation-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy"
// SrcArea: [UnionUint32, UnionString]
// DstArea (wildcarded): [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) InterAreaPropagationPolicyAnyDstArea(SrcArea NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union) *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inter-area-propagation-policies", "inter-area-propagation-policy"},
			map[string]interface{}{"src-area": SrcArea, "dst-area": "*"},
			n,
		),
	}
}

// InterAreaPropagationPolicyAnyDstArea (list): A list of connections between pairs of areas - routes are
// propagated from the source (src) area to the destination (dst)
// area according to the policy specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-area-propagation-policies/inter-area-propagation-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy"
// SrcArea: [UnionUint32, UnionString]
// DstArea (wildcarded): [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) InterAreaPropagationPolicyAnyDstArea(SrcArea NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union) *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inter-area-propagation-policies", "inter-area-propagation-policy"},
			map[string]interface{}{"src-area": SrcArea, "dst-area": "*"},
			n,
		),
	}
}

// InterAreaPropagationPolicyAnySrcArea (list): A list of connections between pairs of areas - routes are
// propagated from the source (src) area to the destination (dst)
// area according to the policy specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-area-propagation-policies/inter-area-propagation-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy"
// SrcArea (wildcarded): [UnionUint32, UnionString]
// DstArea: [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) InterAreaPropagationPolicyAnySrcArea(DstArea NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union) *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inter-area-propagation-policies", "inter-area-propagation-policy"},
			map[string]interface{}{"src-area": "*", "dst-area": DstArea},
			n,
		),
	}
}

// InterAreaPropagationPolicyAnySrcArea (list): A list of connections between pairs of areas - routes are
// propagated from the source (src) area to the destination (dst)
// area according to the policy specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-area-propagation-policies/inter-area-propagation-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy"
// SrcArea (wildcarded): [UnionUint32, UnionString]
// DstArea: [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) InterAreaPropagationPolicyAnySrcArea(DstArea NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union) *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inter-area-propagation-policies", "inter-area-propagation-policy"},
			map[string]interface{}{"src-area": "*", "dst-area": DstArea},
			n,
		),
	}
}

// InterAreaPropagationPolicy (list): A list of connections between pairs of areas - routes are
// propagated from the source (src) area to the destination (dst)
// area according to the policy specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-area-propagation-policies/inter-area-propagation-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy"
// SrcArea: [UnionUint32, UnionString]
// DstArea: [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) InterAreaPropagationPolicy(SrcArea NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union, DstArea NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union) *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"inter-area-propagation-policies", "inter-area-propagation-policy"},
			map[string]interface{}{"src-area": SrcArea, "dst-area": DstArea},
			n,
		),
	}
}

// InterAreaPropagationPolicy (list): A list of connections between pairs of areas - routes are
// propagated from the source (src) area to the destination (dst)
// area according to the policy specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "inter-area-propagation-policies/inter-area-propagation-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy"
// SrcArea: [UnionUint32, UnionString]
// DstArea: [UnionUint32, UnionString]
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) InterAreaPropagationPolicy(SrcArea NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union, DstArea NetworkInstance_Protocol_Ospfv2_Area_Identifier_Union) *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inter-area-propagation-policies", "inter-area-propagation-policy"},
			map[string]interface{}{"src-area": SrcArea, "dst-area": DstArea},
			n,
		),
	}
}

// LogAdjacencyChanges (leaf): When this leaf is set to true, a log message will be
// generated when the state of an OSPFv2 neighbour changes.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/log-adjacency-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/log-adjacency-changes"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) LogAdjacencyChanges() *NetworkInstance_Protocol_Ospfv2_Global_LogAdjacencyChangesPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_LogAdjacencyChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "log-adjacency-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LogAdjacencyChanges (leaf): When this leaf is set to true, a log message will be
// generated when the state of an OSPFv2 neighbour changes.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/log-adjacency-changes"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/log-adjacency-changes"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) LogAdjacencyChanges() *NetworkInstance_Protocol_Ospfv2_Global_LogAdjacencyChangesPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_LogAdjacencyChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "log-adjacency-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): OSPFv2 parameters relating to MPLS
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) Mpls() *NetworkInstance_Protocol_Ospfv2_Global_MplsPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_MplsPath{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mpls (container): OSPFv2 parameters relating to MPLS
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "mpls"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) Mpls() *NetworkInstance_Protocol_Ospfv2_Global_MplsPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_MplsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mpls"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): A 32-bit number represented as a dotted quad assigned to
// each router running the OSPFv2 protocol. This number should
// be unique within the autonomous system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/router-id"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) RouterId() *NetworkInstance_Protocol_Ospfv2_Global_RouterIdPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_RouterIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RouterId (leaf): A 32-bit number represented as a dotted quad assigned to
// each router running the OSPFv2 protocol. This number should
// be unique within the autonomous system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/router-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/router-id"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) RouterId() *NetworkInstance_Protocol_Ospfv2_Global_RouterIdPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_RouterIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "router-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SummaryRouteCostMode (leaf): Specify how costs for the summary routes should be specified
// as per the behaviour in the original OSPF specification
// RFC1583, or alternatively whether the revised behaviour
// described in RFC2328 should be utilised
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/summary-route-cost-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/summary-route-cost-mode"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) SummaryRouteCostMode() *NetworkInstance_Protocol_Ospfv2_Global_SummaryRouteCostModePath {
	return &NetworkInstance_Protocol_Ospfv2_Global_SummaryRouteCostModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "summary-route-cost-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// SummaryRouteCostMode (leaf): Specify how costs for the summary routes should be specified
// as per the behaviour in the original OSPF specification
// RFC1583, or alternatively whether the revised behaviour
// described in RFC2328 should be utilised
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/summary-route-cost-mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/config/summary-route-cost-mode"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) SummaryRouteCostMode() *NetworkInstance_Protocol_Ospfv2_Global_SummaryRouteCostModePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_SummaryRouteCostModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "summary-route-cost-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): Configuration and operational state parameters for OSPFv2
// timers
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPath) Timers() *NetworkInstance_Protocol_Ospfv2_Global_TimersPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_TimersPath{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timers (container): Configuration and operational state parameters for OSPFv2
// timers
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "timers"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers"
func (n *NetworkInstance_Protocol_Ospfv2_GlobalPathAny) Timers() *NetworkInstance_Protocol_Ospfv2_Global_TimersPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_TimersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"timers"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart/config/enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_HelperOnlyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_HelperOnlyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_HelperOnlyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart/config/helper-only YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_HelperOnlyPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When the value of this leaf is set to true, graceful restart
// is enabled on the local system. In this case, the system will
// use Grace-LSAs to signal that it is restarting to its
// neighbors.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPath) Enabled() *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_EnabledPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When the value of this leaf is set to true, graceful restart
// is enabled on the local system. In this case, the system will
// use Grace-LSAs to signal that it is restarting to its
// neighbors.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart/config/enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPathAny) Enabled() *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_EnabledPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Operate graceful-restart only in helper mode. When this leaf
// is set to true, the local system does not use Grace-LSAs to
// indicate that it is restarting, but will accept Grace-LSAs
// from remote systems, and suppress withdrawl of adjacencies
// of the system for the grace period specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPath) HelperOnly() *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_HelperOnlyPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_HelperOnlyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperOnly (leaf): Operate graceful-restart only in helper mode. When this leaf
// is set to true, the local system does not use Grace-LSAs to
// indicate that it is restarting, but will accept Grace-LSAs
// from remote systems, and suppress withdrawl of adjacencies
// of the system for the grace period specified
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/helper-only"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/graceful-restart/config/helper-only"
func (n *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestartPathAny) HelperOnly() *NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_HelperOnlyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_GracefulRestart_HelperOnlyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DefaultImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DefaultImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DefaultImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/default-import-policy YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DefaultImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DstAreaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/dst-area YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DstAreaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DstAreaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/dst-area YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DstAreaPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_ImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_ImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_ImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/import-policy YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_ImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_SrcAreaPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/src-area YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_SrcAreaPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_SrcAreaPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/src-area YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_SrcAreaPathAny struct {
	*ygot.NodePath
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPath) DefaultImportPolicy() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DefaultImportPolicyPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DefaultImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/default-import-policy"
func (n *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny) DefaultImportPolicy() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DefaultImportPolicyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DefaultImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DstArea (leaf): The destination area to which prefixes are to be imported
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dst-area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/dst-area"
func (n *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPath) DstArea() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DstAreaPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DstAreaPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dst-area"},
			map[string]interface{}{},
			n,
		),
	}
}

// DstArea (leaf): The destination area to which prefixes are to be imported
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dst-area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/dst-area"
func (n *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny) DstArea() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DstAreaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_DstAreaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dst-area"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPath) ImportPolicy() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_ImportPolicyPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_ImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/import-policy"
func (n *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny) ImportPolicy() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_ImportPolicyPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_ImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrcArea (leaf): The area from which prefixes are to be exported.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/src-area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/src-area"
func (n *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPath) SrcArea() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_SrcAreaPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_SrcAreaPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "src-area"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrcArea (leaf): The area from which prefixes are to be exported.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/src-area"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/inter-area-propagation-policies/inter-area-propagation-policy/config/src-area"
func (n *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicyPathAny) SrcArea() *NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_SrcAreaPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_InterAreaPropagationPolicy_SrcAreaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "src-area"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Global_MplsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_MplsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_MplsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_MplsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Mpls_TrafficEngineeringExtensionsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/config/traffic-engineering-extensions YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Mpls_TrafficEngineeringExtensionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Mpls_TrafficEngineeringExtensionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/config/traffic-engineering-extensions YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Mpls_TrafficEngineeringExtensionsPathAny struct {
	*ygot.NodePath
}

// IgpLdpSync (container): OSPFv2 parameters relating to LDP/IGP synchronization
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-ldp-sync"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync"
func (n *NetworkInstance_Protocol_Ospfv2_Global_MplsPath) IgpLdpSync() *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPath{
		NodePath: ygot.NewNodePath(
			[]string{"igp-ldp-sync"},
			map[string]interface{}{},
			n,
		),
	}
}

// IgpLdpSync (container): OSPFv2 parameters relating to LDP/IGP synchronization
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "igp-ldp-sync"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync"
func (n *NetworkInstance_Protocol_Ospfv2_Global_MplsPathAny) IgpLdpSync() *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"igp-ldp-sync"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineeringExtensions (leaf): When this leaf is set to true, use traffic engineering
// extensions for OSPF to advertise TE parameters via type 10
// Opaque LSAs
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/traffic-engineering-extensions"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/config/traffic-engineering-extensions"
func (n *NetworkInstance_Protocol_Ospfv2_Global_MplsPath) TrafficEngineeringExtensions() *NetworkInstance_Protocol_Ospfv2_Global_Mpls_TrafficEngineeringExtensionsPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Mpls_TrafficEngineeringExtensionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "traffic-engineering-extensions"},
			map[string]interface{}{},
			n,
		),
	}
}

// TrafficEngineeringExtensions (leaf): When this leaf is set to true, use traffic engineering
// extensions for OSPF to advertise TE parameters via type 10
// Opaque LSAs
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/traffic-engineering-extensions"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/config/traffic-engineering-extensions"
func (n *NetworkInstance_Protocol_Ospfv2_Global_MplsPathAny) TrafficEngineeringExtensions() *NetworkInstance_Protocol_Ospfv2_Global_Mpls_TrafficEngineeringExtensionsPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Mpls_TrafficEngineeringExtensionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "traffic-engineering-extensions"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync/config/enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync/config/enabled YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_PostSessionUpDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync/config/post-session-up-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_PostSessionUpDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_PostSessionUpDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync/config/post-session-up-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_PostSessionUpDelayPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, do not utilise this link for
// forwarding via the IGP until such time as LDP adjacencies to
// the neighbor(s) over the link are established.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync/config/enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPath) Enabled() *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_EnabledPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, do not utilise this link for
// forwarding via the IGP until such time as LDP adjacencies to
// the neighbor(s) over the link are established.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync/config/enabled"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPathAny) Enabled() *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_EnabledPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostSessionUpDelay (leaf): This leaf specifies a delay, expressed in units of milliseconds,
// between the LDP session to the IGP neighbor being established, and
// it being considered synchronized by the IGP.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/post-session-up-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync/config/post-session-up-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPath) PostSessionUpDelay() *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_PostSessionUpDelayPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_PostSessionUpDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "post-session-up-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostSessionUpDelay (leaf): This leaf specifies a delay, expressed in units of milliseconds,
// between the LDP session to the IGP neighbor being established, and
// it being considered synchronized by the IGP.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/post-session-up-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/mpls/igp-ldp-sync/config/post-session-up-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSyncPathAny) PostSessionUpDelay() *NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_PostSessionUpDelayPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Mpls_IgpLdpSync_PostSessionUpDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "post-session-up-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Global_TimersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_TimersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_TimersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_TimersPathAny struct {
	*ygot.NodePath
}

// LsaGeneration (container): Configuration and operational state parameters relating
// to timers governing the generation of LSAs by the local
// system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsa-generation"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation"
func (n *NetworkInstance_Protocol_Ospfv2_Global_TimersPath) LsaGeneration() *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPath{
		NodePath: ygot.NewNodePath(
			[]string{"lsa-generation"},
			map[string]interface{}{},
			n,
		),
	}
}

// LsaGeneration (container): Configuration and operational state parameters relating
// to timers governing the generation of LSAs by the local
// system
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "lsa-generation"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation"
func (n *NetworkInstance_Protocol_Ospfv2_Global_TimersPathAny) LsaGeneration() *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lsa-generation"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxMetric (container): Configuration and operational state parameters relating
// to setting the OSPFv2 maximum metric.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric"
func (n *NetworkInstance_Protocol_Ospfv2_Global_TimersPath) MaxMetric() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"max-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxMetric (container): Configuration and operational state parameters relating
// to setting the OSPFv2 maximum metric.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "max-metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric"
func (n *NetworkInstance_Protocol_Ospfv2_Global_TimersPathAny) MaxMetric() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Spf (container): Configuration and operational state parameters relating
// to timers governing the operation of SPF runs
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "spf"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf"
func (n *NetworkInstance_Protocol_Ospfv2_Global_TimersPath) Spf() *NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPath{
		NodePath: ygot.NewNodePath(
			[]string{"spf"},
			map[string]interface{}{},
			n,
		),
	}
}

// Spf (container): Configuration and operational state parameters relating
// to timers governing the operation of SPF runs
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "spf"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf"
func (n *NetworkInstance_Protocol_Ospfv2_Global_TimersPathAny) Spf() *NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"spf"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_InitialDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/config/initial-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_InitialDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_InitialDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/config/initial-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_InitialDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_MaximumDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/config/maximum-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_MaximumDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_MaximumDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/config/maximum-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_MaximumDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_TimerTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/state/timer-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_TimerTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_TimerTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/state/timer-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_TimerTypePathAny struct {
	*ygot.NodePath
}

// InitialDelay (leaf): The value of this leaf specifies the time between the first
// time an LSA is generated and advertised and the subsequent
// generation of that LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/initial-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/config/initial-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPath) InitialDelay() *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_InitialDelayPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_InitialDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "initial-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// InitialDelay (leaf): The value of this leaf specifies the time between the first
// time an LSA is generated and advertised and the subsequent
// generation of that LSA.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/initial-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/config/initial-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPathAny) InitialDelay() *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_InitialDelayPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_InitialDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "initial-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumDelay (leaf): The value of this leaf specifies the maximum time between the
// generation of an LSA and the subsequent re-generation of that
// LSA. This value is used in implementations that support
// increasing delay between generation of an LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/config/maximum-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPath) MaximumDelay() *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_MaximumDelayPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_MaximumDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumDelay (leaf): The value of this leaf specifies the maximum time between the
// generation of an LSA and the subsequent re-generation of that
// LSA. This value is used in implementations that support
// increasing delay between generation of an LSA
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/config/maximum-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPathAny) MaximumDelay() *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_MaximumDelayPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_MaximumDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// TimerType (leaf): The timer mode that is utilised by the implementation.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/timer-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/state/timer-type"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPath) TimerType() *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_TimerTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_TimerTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "timer-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// TimerType (leaf): The timer mode that is utilised by the implementation.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/timer-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/lsa-generation/state/timer-type"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGenerationPathAny) TimerType() *NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_TimerTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_LsaGeneration_TimerTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "timer-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_IncludePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/include YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_IncludePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_IncludePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/include YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_IncludePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_SetPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/set YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_SetPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_SetPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/set YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_SetPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TimeoutPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/timeout YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TimeoutPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TimeoutPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/timeout YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TimeoutPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TriggerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/trigger YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TriggerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TriggerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/trigger YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TriggerPathAny struct {
	*ygot.NodePath
}

// Include (leaf): By default, the maximum metric is advertised for all
// non-stub interfaces of a device. When identities are
// specified within this leaf-list, additional entities
// are also advertised with the maximum metric according
// to the values within the list.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/include"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPath) Include() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_IncludePath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_IncludePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include"},
			map[string]interface{}{},
			n,
		),
	}
}

// Include (leaf): By default, the maximum metric is advertised for all
// non-stub interfaces of a device. When identities are
// specified within this leaf-list, additional entities
// are also advertised with the maximum metric according
// to the values within the list.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/include"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/include"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPathAny) Include() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_IncludePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_IncludePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "include"},
			map[string]interface{}{},
			n,
		),
	}
}

// Set (leaf): When this leaf is set to true, all non-stub interfaces of
// the local system are advertised with the maximum metric,
// such that the router does not act as a transit system,
// (similarly to the IS-IS overload functionality).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/set"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPath) Set() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_SetPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_SetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set"},
			map[string]interface{}{},
			n,
		),
	}
}

// Set (leaf): When this leaf is set to true, all non-stub interfaces of
// the local system are advertised with the maximum metric,
// such that the router does not act as a transit system,
// (similarly to the IS-IS overload functionality).
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/set"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPathAny) Set() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_SetPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_SetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): The delay, in seconds, after which the advertisement of
// entities with the maximum metric should be cleared, and
// the system reverts to the default, or configured, metrics.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/timeout"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/timeout"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPath) Timeout() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TimeoutPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TimeoutPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): The delay, in seconds, after which the advertisement of
// entities with the maximum metric should be cleared, and
// the system reverts to the default, or configured, metrics.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/timeout"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/timeout"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPathAny) Timeout() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TimeoutPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TimeoutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// Trigger (leaf): By default, the maximum metric is only advertised
// when the max-metric/set leaf is specified as true.
// In the case that identities are specified within this
// list, they provide additional triggers (e.g., system
// boot) that may cause the max-metric to be set. In this
// case, the system should still honour the timeout specified
// by the max-metric/timeout leaf, and clear the max-metric
// advertisements after the expiration of this timer.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/trigger"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/trigger"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPath) Trigger() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TriggerPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TriggerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trigger"},
			map[string]interface{}{},
			n,
		),
	}
}

// Trigger (leaf): By default, the maximum metric is only advertised
// when the max-metric/set leaf is specified as true.
// In the case that identities are specified within this
// list, they provide additional triggers (e.g., system
// boot) that may cause the max-metric to be set. In this
// case, the system should still honour the timeout specified
// by the max-metric/timeout leaf, and clear the max-metric
// advertisements after the expiration of this timer.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/trigger"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/max-metric/config/trigger"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetricPathAny) Trigger() *NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TriggerPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_MaxMetric_TriggerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trigger"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_InitialDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/config/initial-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_InitialDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_InitialDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/config/initial-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_InitialDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_MaximumDelayPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/config/maximum-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_MaximumDelayPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_MaximumDelayPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/config/maximum-delay YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_MaximumDelayPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_TimerTypePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/state/timer-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_TimerTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_TimerTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/state/timer-type YANG schema element.
type NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_TimerTypePathAny struct {
	*ygot.NodePath
}

// InitialDelay (leaf): The value of this leaf specifies the time between a change
// in topology being detected and the first run of the SPF
// algorithm.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/initial-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/config/initial-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPath) InitialDelay() *NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_InitialDelayPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_InitialDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "initial-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// InitialDelay (leaf): The value of this leaf specifies the time between a change
// in topology being detected and the first run of the SPF
// algorithm.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/initial-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/config/initial-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPathAny) InitialDelay() *NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_InitialDelayPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_InitialDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "initial-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumDelay (leaf): The value of this leaf specifies the maximum delay between
// a topology change being detected and the SPF algorithm
// running. This value is used for implementations that support
// increasing the wait time between SPF runs.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/config/maximum-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPath) MaximumDelay() *NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_MaximumDelayPath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_MaximumDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumDelay (leaf): The value of this leaf specifies the maximum delay between
// a topology change being detected and the SPF algorithm
// running. This value is used for implementations that support
// increasing the wait time between SPF runs.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-global"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-delay"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/config/maximum-delay"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPathAny) MaximumDelay() *NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_MaximumDelayPathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_MaximumDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// TimerType (leaf): The timer mode that is utilised by the implementation.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/timer-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/state/timer-type"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPath) TimerType() *NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_TimerTypePath {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_TimerTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "timer-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// TimerType (leaf): The timer mode that is utilised by the implementation.
// ----------------------------------------
// Defining module: "openconfig-ospfv2-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/timer-type"
// Path from root: "/network-instances/network-instance/protocols/protocol/ospfv2/global/timers/spf/state/timer-type"
func (n *NetworkInstance_Protocol_Ospfv2_Global_Timers_SpfPathAny) TimerType() *NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_TimerTypePathAny {
	return &NetworkInstance_Protocol_Ospfv2_Global_Timers_Spf_TimerTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "timer-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_PimPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim YANG schema element.
type NetworkInstance_Protocol_PimPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_PimPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim YANG schema element.
type NetworkInstance_Protocol_PimPathAny struct {
	*ygot.NodePath
}

// Global (container): This container defines global PIM configuration and state
// information.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global"
func (n *NetworkInstance_Protocol_PimPath) Global() *NetworkInstance_Protocol_Pim_GlobalPath {
	return &NetworkInstance_Protocol_Pim_GlobalPath{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// Global (container): This container defines global PIM configuration and state
// information.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "global"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global"
func (n *NetworkInstance_Protocol_PimPathAny) Global() *NetworkInstance_Protocol_Pim_GlobalPathAny {
	return &NetworkInstance_Protocol_Pim_GlobalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): This container defines interface PIM configuration and
// state information.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Protocol_PimPath) InterfaceAny() *NetworkInstance_Protocol_Pim_InterfacePathAny {
	return &NetworkInstance_Protocol_Pim_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): This container defines interface PIM configuration and
// state information.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface"
// InterfaceId (wildcarded): string
func (n *NetworkInstance_Protocol_PimPathAny) InterfaceAny() *NetworkInstance_Protocol_Pim_InterfacePathAny {
	return &NetworkInstance_Protocol_Pim_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": "*"},
			n,
		),
	}
}

// Interface (list): This container defines interface PIM configuration and
// state information.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Protocol_PimPath) Interface(InterfaceId string) *NetworkInstance_Protocol_Pim_InterfacePath {
	return &NetworkInstance_Protocol_Pim_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// Interface (list): This container defines interface PIM configuration and
// state information.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interfaces/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface"
// InterfaceId: string
func (n *NetworkInstance_Protocol_PimPathAny) Interface(InterfaceId string) *NetworkInstance_Protocol_Pim_InterfacePathAny {
	return &NetworkInstance_Protocol_Pim_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"interface-id": InterfaceId},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_GlobalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global YANG schema element.
type NetworkInstance_Protocol_Pim_GlobalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_GlobalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global YANG schema element.
type NetworkInstance_Protocol_Pim_GlobalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_MaximumGroupsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/config/maximum-groups YANG schema element.
type NetworkInstance_Protocol_Pim_Global_MaximumGroupsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_MaximumGroupsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/config/maximum-groups YANG schema element.
type NetworkInstance_Protocol_Pim_Global_MaximumGroupsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_NeighborCountPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/neighbor-count YANG schema element.
type NetworkInstance_Protocol_Pim_Global_NeighborCountPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_NeighborCountPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/neighbor-count YANG schema element.
type NetworkInstance_Protocol_Pim_Global_NeighborCountPathAny struct {
	*ygot.NodePath
}

// Counters (container): Global PIM counters.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/counters"
func (n *NetworkInstance_Protocol_Pim_GlobalPath) Counters() *NetworkInstance_Protocol_Pim_Global_CountersPath {
	return &NetworkInstance_Protocol_Pim_Global_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Global PIM counters.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/counters"
func (n *NetworkInstance_Protocol_Pim_GlobalPathAny) Counters() *NetworkInstance_Protocol_Pim_Global_CountersPathAny {
	return &NetworkInstance_Protocol_Pim_Global_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumGroups (leaf): Limit the number of accepted (S, G) and (*, G)
// PIM join states on the network-instance.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/config/maximum-groups"
func (n *NetworkInstance_Protocol_Pim_GlobalPath) MaximumGroups() *NetworkInstance_Protocol_Pim_Global_MaximumGroupsPath {
	return &NetworkInstance_Protocol_Pim_Global_MaximumGroupsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumGroups (leaf): Limit the number of accepted (S, G) and (*, G)
// PIM join states on the network-instance.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/config/maximum-groups"
func (n *NetworkInstance_Protocol_Pim_GlobalPathAny) MaximumGroups() *NetworkInstance_Protocol_Pim_Global_MaximumGroupsPathAny {
	return &NetworkInstance_Protocol_Pim_Global_MaximumGroupsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborCount (leaf): Number of adjacent PIM neighbors.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-count"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/neighbor-count"
func (n *NetworkInstance_Protocol_Pim_GlobalPath) NeighborCount() *NetworkInstance_Protocol_Pim_Global_NeighborCountPath {
	return &NetworkInstance_Protocol_Pim_Global_NeighborCountPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborCount (leaf): Number of adjacent PIM neighbors.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-count"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/neighbor-count"
func (n *NetworkInstance_Protocol_Pim_GlobalPathAny) NeighborCount() *NetworkInstance_Protocol_Pim_Global_NeighborCountPathAny {
	return &NetworkInstance_Protocol_Pim_Global_NeighborCountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// RendezvousPointAny (list): Defines a rendezvous point (RP) for sparse mode multicast.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rendezvous-points/rendezvous-point"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point"
// Address (wildcarded): string
func (n *NetworkInstance_Protocol_Pim_GlobalPath) RendezvousPointAny() *NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny {
	return &NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rendezvous-points", "rendezvous-point"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// RendezvousPointAny (list): Defines a rendezvous point (RP) for sparse mode multicast.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rendezvous-points/rendezvous-point"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point"
// Address (wildcarded): string
func (n *NetworkInstance_Protocol_Pim_GlobalPathAny) RendezvousPointAny() *NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny {
	return &NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rendezvous-points", "rendezvous-point"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// RendezvousPoint (list): Defines a rendezvous point (RP) for sparse mode multicast.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rendezvous-points/rendezvous-point"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point"
// Address: string
func (n *NetworkInstance_Protocol_Pim_GlobalPath) RendezvousPoint(Address string) *NetworkInstance_Protocol_Pim_Global_RendezvousPointPath {
	return &NetworkInstance_Protocol_Pim_Global_RendezvousPointPath{
		NodePath: ygot.NewNodePath(
			[]string{"rendezvous-points", "rendezvous-point"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// RendezvousPoint (list): Defines a rendezvous point (RP) for sparse mode multicast.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "rendezvous-points/rendezvous-point"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point"
// Address: string
func (n *NetworkInstance_Protocol_Pim_GlobalPathAny) RendezvousPoint(Address string) *NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny {
	return &NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rendezvous-points", "rendezvous-point"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// SourceAny (list): A multicast source that has been joined.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sources-joined/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source"
// Address (wildcarded): string
func (n *NetworkInstance_Protocol_Pim_GlobalPath) SourceAny() *NetworkInstance_Protocol_Pim_Global_SourcePathAny {
	return &NetworkInstance_Protocol_Pim_Global_SourcePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sources-joined", "source"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// SourceAny (list): A multicast source that has been joined.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sources-joined/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source"
// Address (wildcarded): string
func (n *NetworkInstance_Protocol_Pim_GlobalPathAny) SourceAny() *NetworkInstance_Protocol_Pim_Global_SourcePathAny {
	return &NetworkInstance_Protocol_Pim_Global_SourcePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sources-joined", "source"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// Source (list): A multicast source that has been joined.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sources-joined/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source"
// Address: string
func (n *NetworkInstance_Protocol_Pim_GlobalPath) Source(Address string) *NetworkInstance_Protocol_Pim_Global_SourcePath {
	return &NetworkInstance_Protocol_Pim_Global_SourcePath{
		NodePath: ygot.NewNodePath(
			[]string{"sources-joined", "source"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// Source (list): A multicast source that has been joined.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sources-joined/source"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source"
// Address: string
func (n *NetworkInstance_Protocol_Pim_GlobalPathAny) Source(Address string) *NetworkInstance_Protocol_Pim_Global_SourcePathAny {
	return &NetworkInstance_Protocol_Pim_Global_SourcePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sources-joined", "source"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// Ssm (container): Source specific multicast (SSM).
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ssm"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/ssm"
func (n *NetworkInstance_Protocol_Pim_GlobalPath) Ssm() *NetworkInstance_Protocol_Pim_Global_SsmPath {
	return &NetworkInstance_Protocol_Pim_Global_SsmPath{
		NodePath: ygot.NewNodePath(
			[]string{"ssm"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ssm (container): Source specific multicast (SSM).
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "ssm"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/ssm"
func (n *NetworkInstance_Protocol_Pim_GlobalPathAny) Ssm() *NetworkInstance_Protocol_Pim_Global_SsmPathAny {
	return &NetworkInstance_Protocol_Pim_Global_SsmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ssm"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_Global_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/counters YANG schema element.
type NetworkInstance_Protocol_Pim_Global_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/counters YANG schema element.
type NetworkInstance_Protocol_Pim_Global_CountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Counters_BootstrapMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/counters/bootstrap-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Counters_BootstrapMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Counters_BootstrapMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/counters/bootstrap-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Counters_BootstrapMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Counters_HelloMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/counters/hello-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Counters_HelloMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Counters_HelloMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/counters/hello-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Counters_HelloMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Counters_JoinPruneMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/counters/join-prune-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Counters_JoinPruneMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Counters_JoinPruneMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/state/counters/join-prune-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Counters_JoinPruneMessagesPathAny struct {
	*ygot.NodePath
}

// BootstrapMessages (leaf): Number of bootstrap router messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bootstrap-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/counters/bootstrap-messages"
func (n *NetworkInstance_Protocol_Pim_Global_CountersPath) BootstrapMessages() *NetworkInstance_Protocol_Pim_Global_Counters_BootstrapMessagesPath {
	return &NetworkInstance_Protocol_Pim_Global_Counters_BootstrapMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"bootstrap-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// BootstrapMessages (leaf): Number of bootstrap router messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bootstrap-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/counters/bootstrap-messages"
func (n *NetworkInstance_Protocol_Pim_Global_CountersPathAny) BootstrapMessages() *NetworkInstance_Protocol_Pim_Global_Counters_BootstrapMessagesPathAny {
	return &NetworkInstance_Protocol_Pim_Global_Counters_BootstrapMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bootstrap-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloMessages (leaf): Number of hello messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/counters/hello-messages"
func (n *NetworkInstance_Protocol_Pim_Global_CountersPath) HelloMessages() *NetworkInstance_Protocol_Pim_Global_Counters_HelloMessagesPath {
	return &NetworkInstance_Protocol_Pim_Global_Counters_HelloMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloMessages (leaf): Number of hello messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/counters/hello-messages"
func (n *NetworkInstance_Protocol_Pim_Global_CountersPathAny) HelloMessages() *NetworkInstance_Protocol_Pim_Global_Counters_HelloMessagesPathAny {
	return &NetworkInstance_Protocol_Pim_Global_Counters_HelloMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// JoinPruneMessages (leaf): Number of join/prune messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "join-prune-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/counters/join-prune-messages"
func (n *NetworkInstance_Protocol_Pim_Global_CountersPath) JoinPruneMessages() *NetworkInstance_Protocol_Pim_Global_Counters_JoinPruneMessagesPath {
	return &NetworkInstance_Protocol_Pim_Global_Counters_JoinPruneMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"join-prune-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// JoinPruneMessages (leaf): Number of join/prune messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "join-prune-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/state/counters/join-prune-messages"
func (n *NetworkInstance_Protocol_Pim_Global_CountersPathAny) JoinPruneMessages() *NetworkInstance_Protocol_Pim_Global_Counters_JoinPruneMessagesPathAny {
	return &NetworkInstance_Protocol_Pim_Global_Counters_JoinPruneMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"join-prune-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_Global_RendezvousPointPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point YANG schema element.
type NetworkInstance_Protocol_Pim_Global_RendezvousPointPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point YANG schema element.
type NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_RendezvousPoint_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point/config/address YANG schema element.
type NetworkInstance_Protocol_Pim_Global_RendezvousPoint_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_RendezvousPoint_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point/config/address YANG schema element.
type NetworkInstance_Protocol_Pim_Global_RendezvousPoint_AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_RendezvousPoint_MulticastGroupsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point/config/multicast-groups YANG schema element.
type NetworkInstance_Protocol_Pim_Global_RendezvousPoint_MulticastGroupsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_RendezvousPoint_MulticastGroupsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point/config/multicast-groups YANG schema element.
type NetworkInstance_Protocol_Pim_Global_RendezvousPoint_MulticastGroupsPathAny struct {
	*ygot.NodePath
}

// Address (leaf): IPv4 address of rendezvous point.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point/config/address"
func (n *NetworkInstance_Protocol_Pim_Global_RendezvousPointPath) Address() *NetworkInstance_Protocol_Pim_Global_RendezvousPoint_AddressPath {
	return &NetworkInstance_Protocol_Pim_Global_RendezvousPoint_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): IPv4 address of rendezvous point.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point/config/address"
func (n *NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny) Address() *NetworkInstance_Protocol_Pim_Global_RendezvousPoint_AddressPathAny {
	return &NetworkInstance_Protocol_Pim_Global_RendezvousPoint_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastGroups (leaf): List of multicast groups (multicast IP address ranges) for which
// this entry will be used as a rendezvous point. When not
// present the default is equivalent to all valid IP multicast
// addresses.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point/config/multicast-groups"
func (n *NetworkInstance_Protocol_Pim_Global_RendezvousPointPath) MulticastGroups() *NetworkInstance_Protocol_Pim_Global_RendezvousPoint_MulticastGroupsPath {
	return &NetworkInstance_Protocol_Pim_Global_RendezvousPoint_MulticastGroupsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// MulticastGroups (leaf): List of multicast groups (multicast IP address ranges) for which
// this entry will be used as a rendezvous point. When not
// present the default is equivalent to all valid IP multicast
// addresses.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/multicast-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/rendezvous-points/rendezvous-point/config/multicast-groups"
func (n *NetworkInstance_Protocol_Pim_Global_RendezvousPointPathAny) MulticastGroups() *NetworkInstance_Protocol_Pim_Global_RendezvousPoint_MulticastGroupsPathAny {
	return &NetworkInstance_Protocol_Pim_Global_RendezvousPoint_MulticastGroupsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "multicast-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_Global_SourcePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source YANG schema element.
type NetworkInstance_Protocol_Pim_Global_SourcePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_SourcePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source YANG schema element.
type NetworkInstance_Protocol_Pim_Global_SourcePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Source_AddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/address YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Source_AddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Source_AddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/address YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Source_AddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Source_GroupPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/group YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Source_GroupPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Source_GroupPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/group YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Source_GroupPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Source_UpstreamInterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/upstream-interface-id YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Source_UpstreamInterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Source_UpstreamInterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/upstream-interface-id YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Source_UpstreamInterfaceIdPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Source address of multicast.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/address"
func (n *NetworkInstance_Protocol_Pim_Global_SourcePath) Address() *NetworkInstance_Protocol_Pim_Global_Source_AddressPath {
	return &NetworkInstance_Protocol_Pim_Global_Source_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Source address of multicast.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/address"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/address"
func (n *NetworkInstance_Protocol_Pim_Global_SourcePathAny) Address() *NetworkInstance_Protocol_Pim_Global_Source_AddressPathAny {
	return &NetworkInstance_Protocol_Pim_Global_Source_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Group (leaf): Multicast address.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/group"
func (n *NetworkInstance_Protocol_Pim_Global_SourcePath) Group() *NetworkInstance_Protocol_Pim_Global_Source_GroupPath {
	return &NetworkInstance_Protocol_Pim_Global_Source_GroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "group"},
			map[string]interface{}{},
			n,
		),
	}
}

// Group (leaf): Multicast address.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/group"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/group"
func (n *NetworkInstance_Protocol_Pim_Global_SourcePathAny) Group() *NetworkInstance_Protocol_Pim_Global_Source_GroupPathAny {
	return &NetworkInstance_Protocol_Pim_Global_Source_GroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "group"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpstreamInterfaceId (leaf): The upstream interface for this multicast source.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/upstream-interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/upstream-interface-id"
func (n *NetworkInstance_Protocol_Pim_Global_SourcePath) UpstreamInterfaceId() *NetworkInstance_Protocol_Pim_Global_Source_UpstreamInterfaceIdPath {
	return &NetworkInstance_Protocol_Pim_Global_Source_UpstreamInterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "upstream-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// UpstreamInterfaceId (leaf): The upstream interface for this multicast source.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/upstream-interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/sources-joined/source/state/upstream-interface-id"
func (n *NetworkInstance_Protocol_Pim_Global_SourcePathAny) UpstreamInterfaceId() *NetworkInstance_Protocol_Pim_Global_Source_UpstreamInterfaceIdPathAny {
	return &NetworkInstance_Protocol_Pim_Global_Source_UpstreamInterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "upstream-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_Global_SsmPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/ssm YANG schema element.
type NetworkInstance_Protocol_Pim_Global_SsmPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_SsmPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/ssm YANG schema element.
type NetworkInstance_Protocol_Pim_Global_SsmPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Ssm_SsmRangesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/ssm/config/ssm-ranges YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Ssm_SsmRangesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Global_Ssm_SsmRangesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/global/ssm/config/ssm-ranges YANG schema element.
type NetworkInstance_Protocol_Pim_Global_Ssm_SsmRangesPathAny struct {
	*ygot.NodePath
}

// SsmRanges (leaf): List of accepted source specific multicast (SSM) address
// ranges.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ssm-ranges"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/ssm/config/ssm-ranges"
func (n *NetworkInstance_Protocol_Pim_Global_SsmPath) SsmRanges() *NetworkInstance_Protocol_Pim_Global_Ssm_SsmRangesPath {
	return &NetworkInstance_Protocol_Pim_Global_Ssm_SsmRangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ssm-ranges"},
			map[string]interface{}{},
			n,
		),
	}
}

// SsmRanges (leaf): List of accepted source specific multicast (SSM) address
// ranges.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ssm-ranges"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/global/ssm/config/ssm-ranges"
func (n *NetworkInstance_Protocol_Pim_Global_SsmPathAny) SsmRanges() *NetworkInstance_Protocol_Pim_Global_Ssm_SsmRangesPathAny {
	return &NetworkInstance_Protocol_Pim_Global_Ssm_SsmRangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ssm-ranges"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface YANG schema element.
type NetworkInstance_Protocol_Pim_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface YANG schema element.
type NetworkInstance_Protocol_Pim_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_BorderRouterPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/border-router YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_BorderRouterPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_BorderRouterPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/border-router YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_BorderRouterPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_BsrBorderPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/bsr-border YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_BsrBorderPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_BsrBorderPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/bsr-border YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_BsrBorderPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_DeadTimerPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/dead-timer YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_DeadTimerPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_DeadTimerPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/dead-timer YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_DeadTimerPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_DrPriorityPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/dr-priority YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_DrPriorityPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_DrPriorityPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/dr-priority YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_DrPriorityPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/enabled YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/enabled YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_EnabledPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_HelloIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/hello-interval YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_HelloIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_HelloIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/hello-interval YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_HelloIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_InterfaceIdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_InterfaceIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_InterfaceIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/interface-id YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_JoinPruneIntervalPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/join-prune-interval YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_JoinPruneIntervalPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_JoinPruneIntervalPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/join-prune-interval YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_JoinPruneIntervalPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_MaximumGroupsPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/maximum-groups YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_MaximumGroupsPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_MaximumGroupsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/maximum-groups YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_MaximumGroupsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_ModePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/mode YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_ModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_ModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/mode YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_ModePathAny struct {
	*ygot.NodePath
}

// BorderRouter (leaf): When set to true the interface is set as MBR (multicast border
// router) and allows multicast traffic from sources that are
// outside of the PIM domain.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/border-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/border-router"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) BorderRouter() *NetworkInstance_Protocol_Pim_Interface_BorderRouterPath {
	return &NetworkInstance_Protocol_Pim_Interface_BorderRouterPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "border-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// BorderRouter (leaf): When set to true the interface is set as MBR (multicast border
// router) and allows multicast traffic from sources that are
// outside of the PIM domain.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/border-router"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/border-router"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) BorderRouter() *NetworkInstance_Protocol_Pim_Interface_BorderRouterPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_BorderRouterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "border-router"},
			map[string]interface{}{},
			n,
		),
	}
}

// BsrBorder (leaf): When set to true the device will not send bootstrap router
// messages over this interface. By default these are transmitted
// over all PIM sparse mode (PIM-SM) enabled interfaces.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/bsr-border"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/bsr-border"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) BsrBorder() *NetworkInstance_Protocol_Pim_Interface_BsrBorderPath {
	return &NetworkInstance_Protocol_Pim_Interface_BsrBorderPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bsr-border"},
			map[string]interface{}{},
			n,
		),
	}
}

// BsrBorder (leaf): When set to true the device will not send bootstrap router
// messages over this interface. By default these are transmitted
// over all PIM sparse mode (PIM-SM) enabled interfaces.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/bsr-border"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/bsr-border"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) BsrBorder() *NetworkInstance_Protocol_Pim_Interface_BsrBorderPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_BsrBorderPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bsr-border"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): PIM counters for each interface.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) Counters() *NetworkInstance_Protocol_Pim_Interface_CountersPath {
	return &NetworkInstance_Protocol_Pim_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): PIM counters for each interface.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) Counters() *NetworkInstance_Protocol_Pim_Interface_CountersPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// DeadTimer (leaf): Number of missed hello messages after which a neighbor is
// expired.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dead-timer"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/dead-timer"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) DeadTimer() *NetworkInstance_Protocol_Pim_Interface_DeadTimerPath {
	return &NetworkInstance_Protocol_Pim_Interface_DeadTimerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dead-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// DeadTimer (leaf): Number of missed hello messages after which a neighbor is
// expired.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dead-timer"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/dead-timer"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) DeadTimer() *NetworkInstance_Protocol_Pim_Interface_DeadTimerPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_DeadTimerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dead-timer"},
			map[string]interface{}{},
			n,
		),
	}
}

// DrPriority (leaf): The designated router priority of this interface. Larger always
// preferred.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dr-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/dr-priority"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) DrPriority() *NetworkInstance_Protocol_Pim_Interface_DrPriorityPath {
	return &NetworkInstance_Protocol_Pim_Interface_DrPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dr-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DrPriority (leaf): The designated router priority of this interface. Larger always
// preferred.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dr-priority"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/dr-priority"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) DrPriority() *NetworkInstance_Protocol_Pim_Interface_DrPriorityPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_DrPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dr-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/enable-bfd"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) EnableBfd() *NetworkInstance_Protocol_Pim_Interface_EnableBfdPath {
	return &NetworkInstance_Protocol_Pim_Interface_EnableBfdPath{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/enable-bfd"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) EnableBfd() *NetworkInstance_Protocol_Pim_Interface_EnableBfdPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_EnableBfdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this
// leaf is defined is enabled, when set to false it is
// explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/enabled"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) Enabled() *NetworkInstance_Protocol_Pim_Interface_EnabledPath {
	return &NetworkInstance_Protocol_Pim_Interface_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When set to true, the functionality within which this
// leaf is defined is enabled, when set to false it is
// explicitly disabled.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/enabled"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) Enabled() *NetworkInstance_Protocol_Pim_Interface_EnabledPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Interval at which the router sends the PIM hello messages.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/hello-interval"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) HelloInterval() *NetworkInstance_Protocol_Pim_Interface_HelloIntervalPath {
	return &NetworkInstance_Protocol_Pim_Interface_HelloIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloInterval (leaf): Interval at which the router sends the PIM hello messages.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/hello-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/hello-interval"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) HelloInterval() *NetworkInstance_Protocol_Pim_Interface_HelloIntervalPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_HelloIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Reference to an interface on which PIM is enabled.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) InterfaceId() *NetworkInstance_Protocol_Pim_Interface_InterfaceIdPath {
	return &NetworkInstance_Protocol_Pim_Interface_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Reference to an interface on which PIM is enabled.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface-id"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/interface-id"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) InterfaceId() *NetworkInstance_Protocol_Pim_Interface_InterfaceIdPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) InterfaceRef() *NetworkInstance_Protocol_Pim_Interface_InterfaceRefPath {
	return &NetworkInstance_Protocol_Pim_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) InterfaceRef() *NetworkInstance_Protocol_Pim_Interface_InterfaceRefPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// JoinPruneInterval (leaf): Interval at which the router sends the PIM join/prune messages
// toward the upstream RPF neighbor.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/join-prune-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/join-prune-interval"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) JoinPruneInterval() *NetworkInstance_Protocol_Pim_Interface_JoinPruneIntervalPath {
	return &NetworkInstance_Protocol_Pim_Interface_JoinPruneIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "join-prune-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// JoinPruneInterval (leaf): Interval at which the router sends the PIM join/prune messages
// toward the upstream RPF neighbor.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/join-prune-interval"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/join-prune-interval"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) JoinPruneInterval() *NetworkInstance_Protocol_Pim_Interface_JoinPruneIntervalPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_JoinPruneIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "join-prune-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumGroups (leaf): Limit the number of (S, G) and (*, G) PIM
// entries accepted on the interface.
// This feature depends on hardware implementation.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/maximum-groups"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) MaximumGroups() *NetworkInstance_Protocol_Pim_Interface_MaximumGroupsPath {
	return &NetworkInstance_Protocol_Pim_Interface_MaximumGroupsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaximumGroups (leaf): Limit the number of (S, G) and (*, G) PIM
// entries accepted on the interface.
// This feature depends on hardware implementation.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum-groups"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/maximum-groups"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) MaximumGroups() *NetworkInstance_Protocol_Pim_Interface_MaximumGroupsPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_MaximumGroupsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum-groups"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): PIM mode to use when delivering multicast traffic via this
// interface.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/mode"
func (n *NetworkInstance_Protocol_Pim_InterfacePath) Mode() *NetworkInstance_Protocol_Pim_Interface_ModePath {
	return &NetworkInstance_Protocol_Pim_Interface_ModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): PIM mode to use when delivering multicast traffic via this
// interface.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/config/mode"
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) Mode() *NetworkInstance_Protocol_Pim_Interface_ModePathAny {
	return &NetworkInstance_Protocol_Pim_Interface_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): Details about a specific PIM neighbor.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Pim_InterfacePath) NeighborAny() *NetworkInstance_Protocol_Pim_Interface_NeighborPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// NeighborAny (list): Details about a specific PIM neighbor.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor"
// NeighborAddress (wildcarded): string
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) NeighborAny() *NetworkInstance_Protocol_Pim_Interface_NeighborPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": "*"},
			n,
		),
	}
}

// Neighbor (list): Details about a specific PIM neighbor.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Pim_InterfacePath) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Pim_Interface_NeighborPath {
	return &NetworkInstance_Protocol_Pim_Interface_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// Neighbor (list): Details about a specific PIM neighbor.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "neighbors/neighbor"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor"
// NeighborAddress: string
func (n *NetworkInstance_Protocol_Pim_InterfacePathAny) Neighbor(NeighborAddress string) *NetworkInstance_Protocol_Pim_Interface_NeighborPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"neighbor-address": NeighborAddress},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_Interface_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Counters_BootstrapMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/bootstrap-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Counters_BootstrapMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Counters_BootstrapMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/bootstrap-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Counters_BootstrapMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Counters_HelloMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/hello-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Counters_HelloMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Counters_HelloMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/hello-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Counters_HelloMessagesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Counters_JoinPruneMessagesPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/join-prune-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Counters_JoinPruneMessagesPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Counters_JoinPruneMessagesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/join-prune-messages YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Counters_JoinPruneMessagesPathAny struct {
	*ygot.NodePath
}

// BootstrapMessages (leaf): Number of bootstrap router messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bootstrap-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/bootstrap-messages"
func (n *NetworkInstance_Protocol_Pim_Interface_CountersPath) BootstrapMessages() *NetworkInstance_Protocol_Pim_Interface_Counters_BootstrapMessagesPath {
	return &NetworkInstance_Protocol_Pim_Interface_Counters_BootstrapMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"bootstrap-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// BootstrapMessages (leaf): Number of bootstrap router messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "bootstrap-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/bootstrap-messages"
func (n *NetworkInstance_Protocol_Pim_Interface_CountersPathAny) BootstrapMessages() *NetworkInstance_Protocol_Pim_Interface_Counters_BootstrapMessagesPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_Counters_BootstrapMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bootstrap-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloMessages (leaf): Number of hello messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/hello-messages"
func (n *NetworkInstance_Protocol_Pim_Interface_CountersPath) HelloMessages() *NetworkInstance_Protocol_Pim_Interface_Counters_HelloMessagesPath {
	return &NetworkInstance_Protocol_Pim_Interface_Counters_HelloMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloMessages (leaf): Number of hello messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "hello-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/hello-messages"
func (n *NetworkInstance_Protocol_Pim_Interface_CountersPathAny) HelloMessages() *NetworkInstance_Protocol_Pim_Interface_Counters_HelloMessagesPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_Counters_HelloMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"hello-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// JoinPruneMessages (leaf): Number of join/prune messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "join-prune-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/join-prune-messages"
func (n *NetworkInstance_Protocol_Pim_Interface_CountersPath) JoinPruneMessages() *NetworkInstance_Protocol_Pim_Interface_Counters_JoinPruneMessagesPath {
	return &NetworkInstance_Protocol_Pim_Interface_Counters_JoinPruneMessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"join-prune-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// JoinPruneMessages (leaf): Number of join/prune messages received.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "join-prune-messages"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/state/counters/join-prune-messages"
func (n *NetworkInstance_Protocol_Pim_Interface_CountersPathAny) JoinPruneMessages() *NetworkInstance_Protocol_Pim_Interface_Counters_JoinPruneMessagesPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_Counters_JoinPruneMessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"join-prune-messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_Interface_EnableBfdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_EnableBfdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_EnableBfdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_EnableBfdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_EnableBfd_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_EnableBfd_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_EnableBfd_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_EnableBfd_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Pim_Interface_EnableBfdPath) Enabled() *NetworkInstance_Protocol_Pim_Interface_EnableBfd_EnabledPath {
	return &NetworkInstance_Protocol_Pim_Interface_EnableBfd_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Pim_Interface_EnableBfdPathAny) Enabled() *NetworkInstance_Protocol_Pim_Interface_EnableBfd_EnabledPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_EnableBfd_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_Interface_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Pim_Interface_InterfaceRefPath) Interface() *NetworkInstance_Protocol_Pim_Interface_InterfaceRef_InterfacePath {
	return &NetworkInstance_Protocol_Pim_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Pim_Interface_InterfaceRefPathAny) Interface() *NetworkInstance_Protocol_Pim_Interface_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Protocol_Pim_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Pim_Interface_InterfaceRefPath) Subinterface() *NetworkInstance_Protocol_Pim_Interface_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Protocol_Pim_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Pim_Interface_InterfaceRefPathAny) Subinterface() *NetworkInstance_Protocol_Pim_Interface_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Protocol_Pim_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Pim_Interface_NeighborPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_NeighborPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_NeighborPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_NeighborPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_DrAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/dr-address YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_DrAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_DrAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/dr-address YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_DrAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_ModePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/mode YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_ModePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_ModePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/mode YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_ModePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborAddressPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-address YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborEstablishedPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-established YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborEstablishedPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborEstablishedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-established YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborEstablishedPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborExpiresPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-expires YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborExpiresPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborExpiresPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-expires YANG schema element.
type NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborExpiresPathAny struct {
	*ygot.NodePath
}

// DrAddress (leaf): IPv4 address of designated router.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dr-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/dr-address"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPath) DrAddress() *NetworkInstance_Protocol_Pim_Interface_Neighbor_DrAddressPath {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_DrAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dr-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DrAddress (leaf): IPv4 address of designated router.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/dr-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/dr-address"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPathAny) DrAddress() *NetworkInstance_Protocol_Pim_Interface_Neighbor_DrAddressPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_DrAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "dr-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): PIM mode in use when delivering multicast traffic
// via this neighbor.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/mode"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPath) Mode() *NetworkInstance_Protocol_Pim_Interface_Neighbor_ModePath {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_ModePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): PIM mode in use when delivering multicast traffic
// via this neighbor.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mode"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/mode"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPathAny) Mode() *NetworkInstance_Protocol_Pim_Interface_Neighbor_ModePathAny {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): IPv4 address of neighbor router.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPath) NeighborAddress() *NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborAddressPath {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAddress (leaf): IPv4 address of neighbor router.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-address"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-address"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPathAny) NeighborAddress() *NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborAddressPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborEstablished (leaf): This timestamp indicates the time that the
// PIM neighbor adjacency established. It is expressed
// relative to the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// The PIM session uptime can be computed by clients
// as the difference between this value and the
// current time in UTC.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-established"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-established"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPath) NeighborEstablished() *NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborEstablishedPath {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborEstablishedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-established"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborEstablished (leaf): This timestamp indicates the time that the
// PIM neighbor adjacency established. It is expressed
// relative to the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
//
// The PIM session uptime can be computed by clients
// as the difference between this value and the
// current time in UTC.
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-established"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-established"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPathAny) NeighborEstablished() *NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborEstablishedPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborEstablishedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-established"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborExpires (leaf): This timestamp indicates the time that the
// PIM neighbor adjacency will expire should hello
// messages fail to arrive from the neighbor. The value
// is expressed relative to the Unix Epoch (Jan 1, 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-expires"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-expires"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPath) NeighborExpires() *NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborExpiresPath {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborExpiresPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-expires"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborExpires (leaf): This timestamp indicates the time that the
// PIM neighbor adjacency will expire should hello
// messages fail to arrive from the neighbor. The value
// is expressed relative to the Unix Epoch (Jan 1, 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-pim"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/neighbor-expires"
// Path from root: "/network-instances/network-instance/protocols/protocol/pim/interfaces/interface/neighbors/neighbor/state/neighbor-expires"
func (n *NetworkInstance_Protocol_Pim_Interface_NeighborPathAny) NeighborExpires() *NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborExpiresPathAny {
	return &NetworkInstance_Protocol_Pim_Interface_Neighbor_NeighborExpiresPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "neighbor-expires"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_StaticPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static YANG schema element.
type NetworkInstance_Protocol_StaticPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_StaticPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static YANG schema element.
type NetworkInstance_Protocol_StaticPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_DescriptionPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/config/description YANG schema element.
type NetworkInstance_Protocol_Static_DescriptionPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_DescriptionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/config/description YANG schema element.
type NetworkInstance_Protocol_Static_DescriptionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/config/prefix YANG schema element.
type NetworkInstance_Protocol_Static_PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/config/prefix YANG schema element.
type NetworkInstance_Protocol_Static_PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_SetTagPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/config/set-tag YANG schema element.
type NetworkInstance_Protocol_Static_SetTagPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_SetTagPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/config/set-tag YANG schema element.
type NetworkInstance_Protocol_Static_SetTagPathAny struct {
	*ygot.NodePath
}

// Description (leaf): An optional textual description for the route.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/config/description"
func (n *NetworkInstance_Protocol_StaticPath) Description() *NetworkInstance_Protocol_Static_DescriptionPath {
	return &NetworkInstance_Protocol_Static_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): An optional textual description for the route.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/description"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/config/description"
func (n *NetworkInstance_Protocol_StaticPathAny) Description() *NetworkInstance_Protocol_Static_DescriptionPathAny {
	return &NetworkInstance_Protocol_Static_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopAny (list): A list of next-hops to be utilised for the static
// route being specified.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop"
// Index (wildcarded): string
func (n *NetworkInstance_Protocol_StaticPath) NextHopAny() *NetworkInstance_Protocol_Static_NextHopPathAny {
	return &NetworkInstance_Protocol_Static_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHopAny (list): A list of next-hops to be utilised for the static
// route being specified.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop"
// Index (wildcarded): string
func (n *NetworkInstance_Protocol_StaticPathAny) NextHopAny() *NetworkInstance_Protocol_Static_NextHopPathAny {
	return &NetworkInstance_Protocol_Static_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHop (list): A list of next-hops to be utilised for the static
// route being specified.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop"
// Index: string
func (n *NetworkInstance_Protocol_StaticPath) NextHop(Index string) *NetworkInstance_Protocol_Static_NextHopPath {
	return &NetworkInstance_Protocol_Static_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NextHop (list): A list of next-hops to be utilised for the static
// route being specified.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop"
// Index: string
func (n *NetworkInstance_Protocol_StaticPathAny) NextHop(Index string) *NetworkInstance_Protocol_Static_NextHopPathAny {
	return &NetworkInstance_Protocol_Static_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Prefix (leaf): Destination prefix for the static route, either IPv4 or
// IPv6.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/config/prefix"
func (n *NetworkInstance_Protocol_StaticPath) Prefix() *NetworkInstance_Protocol_Static_PrefixPath {
	return &NetworkInstance_Protocol_Static_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefix (leaf): Destination prefix for the static route, either IPv4 or
// IPv6.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/prefix"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/config/prefix"
func (n *NetworkInstance_Protocol_StaticPathAny) Prefix() *NetworkInstance_Protocol_Static_PrefixPathAny {
	return &NetworkInstance_Protocol_Static_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (leaf): Set a generic tag value on the route. This tag can be
// used for filtering routes that are distributed to other
// routing protocols.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/config/set-tag"
func (n *NetworkInstance_Protocol_StaticPath) SetTag() *NetworkInstance_Protocol_Static_SetTagPath {
	return &NetworkInstance_Protocol_Static_SetTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (leaf): Set a generic tag value on the route. This tag can be
// used for filtering routes that are distributed to other
// routing protocols.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/set-tag"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/config/set-tag"
func (n *NetworkInstance_Protocol_StaticPathAny) SetTag() *NetworkInstance_Protocol_Static_SetTagPathAny {
	return &NetworkInstance_Protocol_Static_SetTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Static_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop YANG schema element.
type NetworkInstance_Protocol_Static_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop YANG schema element.
type NetworkInstance_Protocol_Static_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/index YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/index YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_MetricPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/metric YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_MetricPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_MetricPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/metric YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_MetricPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/next-hop YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/next-hop YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_RecursePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/recurse YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_RecursePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_RecursePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/recurse YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_RecursePathAny struct {
	*ygot.NodePath
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/enable-bfd"
func (n *NetworkInstance_Protocol_Static_NextHopPath) EnableBfd() *NetworkInstance_Protocol_Static_NextHop_EnableBfdPath {
	return &NetworkInstance_Protocol_Static_NextHop_EnableBfdPath{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableBfd (container): Enable BFD for liveliness detection to the next-hop or
// neighbour.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "enable-bfd"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/enable-bfd"
func (n *NetworkInstance_Protocol_Static_NextHopPathAny) EnableBfd() *NetworkInstance_Protocol_Static_NextHop_EnableBfdPathAny {
	return &NetworkInstance_Protocol_Static_NextHop_EnableBfdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"enable-bfd"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): An user-specified identifier utilised to uniquely reference
// the next-hop entry in the next-hop list. The value of this
// index has no semantic meaning other than for referencing
// the entry.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/index"
func (n *NetworkInstance_Protocol_Static_NextHopPath) Index() *NetworkInstance_Protocol_Static_NextHop_IndexPath {
	return &NetworkInstance_Protocol_Static_NextHop_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): An user-specified identifier utilised to uniquely reference
// the next-hop entry in the next-hop list. The value of this
// index has no semantic meaning other than for referencing
// the entry.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/index"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/index"
func (n *NetworkInstance_Protocol_Static_NextHopPathAny) Index() *NetworkInstance_Protocol_Static_NextHop_IndexPathAny {
	return &NetworkInstance_Protocol_Static_NextHop_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref"
func (n *NetworkInstance_Protocol_Static_NextHopPath) InterfaceRef() *NetworkInstance_Protocol_Static_NextHop_InterfaceRefPath {
	return &NetworkInstance_Protocol_Static_NextHop_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref"
func (n *NetworkInstance_Protocol_Static_NextHopPathAny) InterfaceRef() *NetworkInstance_Protocol_Static_NextHop_InterfaceRefPathAny {
	return &NetworkInstance_Protocol_Static_NextHop_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): A metric which is utilised to specify the preference of
// the next-hop entry when it is injected into the RIB. The
// lower the metric, the more preferable the prefix is. When
// this value is not specified the metric is inherited from
// the default metric utilised for static routes within the
// network instance that the static routes are being
// instantiated. When multiple next-hops are specified for a
// static route, the metric is utilised to determine which of
// the next-hops is to be installed in the RIB. When multiple
// next-hops have the same metric (be it specified, or simply
// the default) then these next-hops should all be installed
// in the RIB
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/metric"
func (n *NetworkInstance_Protocol_Static_NextHopPath) Metric() *NetworkInstance_Protocol_Static_NextHop_MetricPath {
	return &NetworkInstance_Protocol_Static_NextHop_MetricPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// Metric (leaf): A metric which is utilised to specify the preference of
// the next-hop entry when it is injected into the RIB. The
// lower the metric, the more preferable the prefix is. When
// this value is not specified the metric is inherited from
// the default metric utilised for static routes within the
// network instance that the static routes are being
// instantiated. When multiple next-hops are specified for a
// static route, the metric is utilised to determine which of
// the next-hops is to be installed in the RIB. When multiple
// next-hops have the same metric (be it specified, or simply
// the default) then these next-hops should all be installed
// in the RIB
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/metric"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/metric"
func (n *NetworkInstance_Protocol_Static_NextHopPathAny) Metric() *NetworkInstance_Protocol_Static_NextHop_MetricPathAny {
	return &NetworkInstance_Protocol_Static_NextHop_MetricPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "metric"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): The next-hop that is to be used for the static route
// - this may be specified as an IP address, an interface
// or a pre-defined next-hop type - for instance, DROP or
// LOCAL_LINK. When this leaf is not set, and the interface-ref
// value is specified for the next-hop, then the system should
// treat the prefix as though it is directly connected to the
// interface.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/next-hop"
func (n *NetworkInstance_Protocol_Static_NextHopPath) NextHop() *NetworkInstance_Protocol_Static_NextHop_NextHopPath {
	return &NetworkInstance_Protocol_Static_NextHop_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHop (leaf): The next-hop that is to be used for the static route
// - this may be specified as an IP address, an interface
// or a pre-defined next-hop type - for instance, DROP or
// LOCAL_LINK. When this leaf is not set, and the interface-ref
// value is specified for the next-hop, then the system should
// treat the prefix as though it is directly connected to the
// interface.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/next-hop"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/next-hop"
func (n *NetworkInstance_Protocol_Static_NextHopPathAny) NextHop() *NetworkInstance_Protocol_Static_NextHop_NextHopPathAny {
	return &NetworkInstance_Protocol_Static_NextHop_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "next-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// Recurse (leaf): Determines whether the next-hop should be allowed to
// be looked up recursively - i.e., via a RIB entry which has
// been installed by a routing protocol, or another static route
// - rather than needing to be connected directly to an
// interface of the local system within the current network
// instance. When the interface reference specified within the
// next-hop entry is set (i.e., is not null) then forwarding is
// restricted to being via the interface specified - and
// recursion is hence disabled.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/recurse"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/recurse"
func (n *NetworkInstance_Protocol_Static_NextHopPath) Recurse() *NetworkInstance_Protocol_Static_NextHop_RecursePath {
	return &NetworkInstance_Protocol_Static_NextHop_RecursePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "recurse"},
			map[string]interface{}{},
			n,
		),
	}
}

// Recurse (leaf): Determines whether the next-hop should be allowed to
// be looked up recursively - i.e., via a RIB entry which has
// been installed by a routing protocol, or another static route
// - rather than needing to be connected directly to an
// interface of the local system within the current network
// instance. When the interface reference specified within the
// next-hop entry is set (i.e., is not null) then forwarding is
// restricted to being via the interface specified - and
// recursion is hence disabled.
// ----------------------------------------
// Defining module: "openconfig-local-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/recurse"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/config/recurse"
func (n *NetworkInstance_Protocol_Static_NextHopPathAny) Recurse() *NetworkInstance_Protocol_Static_NextHop_RecursePathAny {
	return &NetworkInstance_Protocol_Static_NextHop_RecursePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "recurse"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Static_NextHop_EnableBfdPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_EnableBfdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_EnableBfdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/enable-bfd YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_EnableBfdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_EnableBfd_EnabledPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_EnableBfd_EnabledPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_EnableBfd_EnabledPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/enable-bfd/config/enabled YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_EnableBfd_EnabledPathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Static_NextHop_EnableBfdPath) Enabled() *NetworkInstance_Protocol_Static_NextHop_EnableBfd_EnabledPath {
	return &NetworkInstance_Protocol_Static_NextHop_EnableBfd_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): When this leaf is set to true, BFD is used to detect the
// liveliness of the remote peer or next-hop.
// ----------------------------------------
// Defining module: "openconfig-bfd"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/enabled"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/enable-bfd/config/enabled"
func (n *NetworkInstance_Protocol_Static_NextHop_EnableBfdPathAny) Enabled() *NetworkInstance_Protocol_Static_NextHop_EnableBfd_EnabledPathAny {
	return &NetworkInstance_Protocol_Static_NextHop_EnableBfd_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Protocol_Static_NextHop_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref/config/interface YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Protocol_Static_NextHop_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref/config/subinterface YANG schema element.
type NetworkInstance_Protocol_Static_NextHop_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Static_NextHop_InterfaceRefPath) Interface() *NetworkInstance_Protocol_Static_NextHop_InterfaceRef_InterfacePath {
	return &NetworkInstance_Protocol_Static_NextHop_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/interface"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref/config/interface"
func (n *NetworkInstance_Protocol_Static_NextHop_InterfaceRefPathAny) Interface() *NetworkInstance_Protocol_Static_NextHop_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_Protocol_Static_NextHop_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Static_NextHop_InterfaceRefPath) Subinterface() *NetworkInstance_Protocol_Static_NextHop_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_Protocol_Static_NextHop_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/subinterface"
// Path from root: "/network-instances/network-instance/protocols/protocol/static-routes/static/next-hops/next-hop/interface-ref/config/subinterface"
func (n *NetworkInstance_Protocol_Static_NextHop_InterfaceRefPathAny) Subinterface() *NetworkInstance_Protocol_Static_NextHop_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_Protocol_Static_NextHop_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_RouteLimitPath represents the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit YANG schema element.
type NetworkInstance_RouteLimitPath struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimitPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit YANG schema element.
type NetworkInstance_RouteLimitPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_AfiPath represents the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/config/afi YANG schema element.
type NetworkInstance_RouteLimit_AfiPath struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_AfiPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/config/afi YANG schema element.
type NetworkInstance_RouteLimit_AfiPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_AlarmThresholdPath represents the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/config/alarm-threshold YANG schema element.
type NetworkInstance_RouteLimit_AlarmThresholdPath struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_AlarmThresholdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/config/alarm-threshold YANG schema element.
type NetworkInstance_RouteLimit_AlarmThresholdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_InstalledRoutesPath represents the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/state/installed-routes YANG schema element.
type NetworkInstance_RouteLimit_InstalledRoutesPath struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_InstalledRoutesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/state/installed-routes YANG schema element.
type NetworkInstance_RouteLimit_InstalledRoutesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_MaximumPath represents the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/config/maximum YANG schema element.
type NetworkInstance_RouteLimit_MaximumPath struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_MaximumPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/config/maximum YANG schema element.
type NetworkInstance_RouteLimit_MaximumPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_ThresholdExceededPath represents the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/state/threshold-exceeded YANG schema element.
type NetworkInstance_RouteLimit_ThresholdExceededPath struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_ThresholdExceededPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/state/threshold-exceeded YANG schema element.
type NetworkInstance_RouteLimit_ThresholdExceededPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_WarningOnlyPath represents the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/config/warning-only YANG schema element.
type NetworkInstance_RouteLimit_WarningOnlyPath struct {
	*ygot.NodePath
}

// NetworkInstance_RouteLimit_WarningOnlyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/route-limits/route-limit/config/warning-only YANG schema element.
type NetworkInstance_RouteLimit_WarningOnlyPathAny struct {
	*ygot.NodePath
}

// Afi (leaf): The address family for which the route limit applies.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/config/afi"
func (n *NetworkInstance_RouteLimitPath) Afi() *NetworkInstance_RouteLimit_AfiPath {
	return &NetworkInstance_RouteLimit_AfiPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi"},
			map[string]interface{}{},
			n,
		),
	}
}

// Afi (leaf): The address family for which the route limit applies.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/afi"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/config/afi"
func (n *NetworkInstance_RouteLimitPathAny) Afi() *NetworkInstance_RouteLimit_AfiPathAny {
	return &NetworkInstance_RouteLimit_AfiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "afi"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlarmThreshold (leaf): When specified, an alarm should be generated when the threshold
// number of installed routes is reached.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/alarm-threshold"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/config/alarm-threshold"
func (n *NetworkInstance_RouteLimitPath) AlarmThreshold() *NetworkInstance_RouteLimit_AlarmThresholdPath {
	return &NetworkInstance_RouteLimit_AlarmThresholdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "alarm-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlarmThreshold (leaf): When specified, an alarm should be generated when the threshold
// number of installed routes is reached.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/alarm-threshold"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/config/alarm-threshold"
func (n *NetworkInstance_RouteLimitPathAny) AlarmThreshold() *NetworkInstance_RouteLimit_AlarmThresholdPathAny {
	return &NetworkInstance_RouteLimit_AlarmThresholdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "alarm-threshold"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstalledRoutes (leaf): The current number of routes installed for the address family.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/installed-routes"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/state/installed-routes"
func (n *NetworkInstance_RouteLimitPath) InstalledRoutes() *NetworkInstance_RouteLimit_InstalledRoutesPath {
	return &NetworkInstance_RouteLimit_InstalledRoutesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "installed-routes"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstalledRoutes (leaf): The current number of routes installed for the address family.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/installed-routes"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/state/installed-routes"
func (n *NetworkInstance_RouteLimitPathAny) InstalledRoutes() *NetworkInstance_RouteLimit_InstalledRoutesPathAny {
	return &NetworkInstance_RouteLimit_InstalledRoutesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "installed-routes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Maximum (leaf): The maximum number of routes for the address family. The
// system should not install more than maximum number of
// prefixes into the RIB unless the warning-only leaf is specified.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/config/maximum"
func (n *NetworkInstance_RouteLimitPath) Maximum() *NetworkInstance_RouteLimit_MaximumPath {
	return &NetworkInstance_RouteLimit_MaximumPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum"},
			map[string]interface{}{},
			n,
		),
	}
}

// Maximum (leaf): The maximum number of routes for the address family. The
// system should not install more than maximum number of
// prefixes into the RIB unless the warning-only leaf is specified.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/maximum"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/config/maximum"
func (n *NetworkInstance_RouteLimitPathAny) Maximum() *NetworkInstance_RouteLimit_MaximumPathAny {
	return &NetworkInstance_RouteLimit_MaximumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "maximum"},
			map[string]interface{}{},
			n,
		),
	}
}

// ThresholdExceeded (leaf): This leaf should be set to true in the case that the threshold
// number of routes has been exceeded.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/threshold-exceeded"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/state/threshold-exceeded"
func (n *NetworkInstance_RouteLimitPath) ThresholdExceeded() *NetworkInstance_RouteLimit_ThresholdExceededPath {
	return &NetworkInstance_RouteLimit_ThresholdExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "threshold-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// ThresholdExceeded (leaf): This leaf should be set to true in the case that the threshold
// number of routes has been exceeded.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/threshold-exceeded"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/state/threshold-exceeded"
func (n *NetworkInstance_RouteLimitPathAny) ThresholdExceeded() *NetworkInstance_RouteLimit_ThresholdExceededPathAny {
	return &NetworkInstance_RouteLimit_ThresholdExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "threshold-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningOnly (leaf): When specified, the route limit specified is considered only as
// a warning - and routes should continue to be installed into the
// RIB over the limit specified in the maximum leaf.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-only"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/config/warning-only"
func (n *NetworkInstance_RouteLimitPath) WarningOnly() *NetworkInstance_RouteLimit_WarningOnlyPath {
	return &NetworkInstance_RouteLimit_WarningOnlyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// WarningOnly (leaf): When specified, the route limit specified is considered only as
// a warning - and routes should continue to be installed into the
// RIB over the limit specified in the maximum leaf.
// ----------------------------------------
// Defining module: "openconfig-network-instance-l3"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/warning-only"
// Path from root: "/network-instances/network-instance/route-limits/route-limit/config/warning-only"
func (n *NetworkInstance_RouteLimitPathAny) WarningOnly() *NetworkInstance_RouteLimit_WarningOnlyPathAny {
	return &NetworkInstance_RouteLimit_WarningOnlyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "warning-only"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRoutingPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing YANG schema element.
type NetworkInstance_SegmentRoutingPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRoutingPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing YANG schema element.
type NetworkInstance_SegmentRoutingPathAny struct {
	*ygot.NodePath
}

// SrgbAny (list): A single definition of an SRGB which may comprise of multiple
// sets of dataplane addresses (IPv6 addresses, or MPLS labels).
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srgbs/srgb"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb"
// LocalId (wildcarded): string
func (n *NetworkInstance_SegmentRoutingPath) SrgbAny() *NetworkInstance_SegmentRouting_SrgbPathAny {
	return &NetworkInstance_SegmentRouting_SrgbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srgbs", "srgb"},
			map[string]interface{}{"local-id": "*"},
			n,
		),
	}
}

// SrgbAny (list): A single definition of an SRGB which may comprise of multiple
// sets of dataplane addresses (IPv6 addresses, or MPLS labels).
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srgbs/srgb"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb"
// LocalId (wildcarded): string
func (n *NetworkInstance_SegmentRoutingPathAny) SrgbAny() *NetworkInstance_SegmentRouting_SrgbPathAny {
	return &NetworkInstance_SegmentRouting_SrgbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srgbs", "srgb"},
			map[string]interface{}{"local-id": "*"},
			n,
		),
	}
}

// Srgb (list): A single definition of an SRGB which may comprise of multiple
// sets of dataplane addresses (IPv6 addresses, or MPLS labels).
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srgbs/srgb"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb"
// LocalId: string
func (n *NetworkInstance_SegmentRoutingPath) Srgb(LocalId string) *NetworkInstance_SegmentRouting_SrgbPath {
	return &NetworkInstance_SegmentRouting_SrgbPath{
		NodePath: ygot.NewNodePath(
			[]string{"srgbs", "srgb"},
			map[string]interface{}{"local-id": LocalId},
			n,
		),
	}
}

// Srgb (list): A single definition of an SRGB which may comprise of multiple
// sets of dataplane addresses (IPv6 addresses, or MPLS labels).
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srgbs/srgb"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb"
// LocalId: string
func (n *NetworkInstance_SegmentRoutingPathAny) Srgb(LocalId string) *NetworkInstance_SegmentRouting_SrgbPathAny {
	return &NetworkInstance_SegmentRouting_SrgbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srgbs", "srgb"},
			map[string]interface{}{"local-id": LocalId},
			n,
		),
	}
}

// SrlbAny (list): A definition of a Segment Routing Local Block, defined to be
// a set of Segment Identifiers (specified as MPLS labels or
// IPv6 addreses) that are defined for local allocation by the
// system. A block may optionally be advertised into an IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srlbs/srlb"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb"
// LocalId (wildcarded): string
func (n *NetworkInstance_SegmentRoutingPath) SrlbAny() *NetworkInstance_SegmentRouting_SrlbPathAny {
	return &NetworkInstance_SegmentRouting_SrlbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srlbs", "srlb"},
			map[string]interface{}{"local-id": "*"},
			n,
		),
	}
}

// SrlbAny (list): A definition of a Segment Routing Local Block, defined to be
// a set of Segment Identifiers (specified as MPLS labels or
// IPv6 addreses) that are defined for local allocation by the
// system. A block may optionally be advertised into an IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srlbs/srlb"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb"
// LocalId (wildcarded): string
func (n *NetworkInstance_SegmentRoutingPathAny) SrlbAny() *NetworkInstance_SegmentRouting_SrlbPathAny {
	return &NetworkInstance_SegmentRouting_SrlbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srlbs", "srlb"},
			map[string]interface{}{"local-id": "*"},
			n,
		),
	}
}

// Srlb (list): A definition of a Segment Routing Local Block, defined to be
// a set of Segment Identifiers (specified as MPLS labels or
// IPv6 addreses) that are defined for local allocation by the
// system. A block may optionally be advertised into an IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srlbs/srlb"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb"
// LocalId: string
func (n *NetworkInstance_SegmentRoutingPath) Srlb(LocalId string) *NetworkInstance_SegmentRouting_SrlbPath {
	return &NetworkInstance_SegmentRouting_SrlbPath{
		NodePath: ygot.NewNodePath(
			[]string{"srlbs", "srlb"},
			map[string]interface{}{"local-id": LocalId},
			n,
		),
	}
}

// Srlb (list): A definition of a Segment Routing Local Block, defined to be
// a set of Segment Identifiers (specified as MPLS labels or
// IPv6 addreses) that are defined for local allocation by the
// system. A block may optionally be advertised into an IGP.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "srlbs/srlb"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb"
// LocalId: string
func (n *NetworkInstance_SegmentRoutingPathAny) Srlb(LocalId string) *NetworkInstance_SegmentRouting_SrlbPathAny {
	return &NetworkInstance_SegmentRouting_SrlbPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"srlbs", "srlb"},
			map[string]interface{}{"local-id": LocalId},
			n,
		),
	}
}

// TePolicyAny (list): An individual SR-TE policy is identified by a combination
// of color and endpoint.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-policies/te-policy"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy"
// Color (wildcarded): uint32
// Endpoint (wildcarded): string
func (n *NetworkInstance_SegmentRoutingPath) TePolicyAny() *NetworkInstance_SegmentRouting_TePolicyPathAny {
	return &NetworkInstance_SegmentRouting_TePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-policies", "te-policy"},
			map[string]interface{}{"color": "*", "endpoint": "*"},
			n,
		),
	}
}

// TePolicyAny (list): An individual SR-TE policy is identified by a combination
// of color and endpoint.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-policies/te-policy"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy"
// Color (wildcarded): uint32
// Endpoint (wildcarded): string
func (n *NetworkInstance_SegmentRoutingPathAny) TePolicyAny() *NetworkInstance_SegmentRouting_TePolicyPathAny {
	return &NetworkInstance_SegmentRouting_TePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-policies", "te-policy"},
			map[string]interface{}{"color": "*", "endpoint": "*"},
			n,
		),
	}
}

// TePolicyAnyEndpoint (list): An individual SR-TE policy is identified by a combination
// of color and endpoint.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-policies/te-policy"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy"
// Color: uint32
// Endpoint (wildcarded): string
func (n *NetworkInstance_SegmentRoutingPath) TePolicyAnyEndpoint(Color uint32) *NetworkInstance_SegmentRouting_TePolicyPathAny {
	return &NetworkInstance_SegmentRouting_TePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-policies", "te-policy"},
			map[string]interface{}{"color": Color, "endpoint": "*"},
			n,
		),
	}
}

// TePolicyAnyEndpoint (list): An individual SR-TE policy is identified by a combination
// of color and endpoint.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-policies/te-policy"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy"
// Color: uint32
// Endpoint (wildcarded): string
func (n *NetworkInstance_SegmentRoutingPathAny) TePolicyAnyEndpoint(Color uint32) *NetworkInstance_SegmentRouting_TePolicyPathAny {
	return &NetworkInstance_SegmentRouting_TePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-policies", "te-policy"},
			map[string]interface{}{"color": Color, "endpoint": "*"},
			n,
		),
	}
}

// TePolicyAnyColor (list): An individual SR-TE policy is identified by a combination
// of color and endpoint.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-policies/te-policy"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy"
// Color (wildcarded): uint32
// Endpoint: string
func (n *NetworkInstance_SegmentRoutingPath) TePolicyAnyColor(Endpoint string) *NetworkInstance_SegmentRouting_TePolicyPathAny {
	return &NetworkInstance_SegmentRouting_TePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-policies", "te-policy"},
			map[string]interface{}{"color": "*", "endpoint": Endpoint},
			n,
		),
	}
}

// TePolicyAnyColor (list): An individual SR-TE policy is identified by a combination
// of color and endpoint.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-policies/te-policy"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy"
// Color (wildcarded): uint32
// Endpoint: string
func (n *NetworkInstance_SegmentRoutingPathAny) TePolicyAnyColor(Endpoint string) *NetworkInstance_SegmentRouting_TePolicyPathAny {
	return &NetworkInstance_SegmentRouting_TePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-policies", "te-policy"},
			map[string]interface{}{"color": "*", "endpoint": Endpoint},
			n,
		),
	}
}

// TePolicy (list): An individual SR-TE policy is identified by a combination
// of color and endpoint.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-policies/te-policy"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy"
// Color: uint32
// Endpoint: string
func (n *NetworkInstance_SegmentRoutingPath) TePolicy(Color uint32, Endpoint string) *NetworkInstance_SegmentRouting_TePolicyPath {
	return &NetworkInstance_SegmentRouting_TePolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"te-policies", "te-policy"},
			map[string]interface{}{"color": Color, "endpoint": Endpoint},
			n,
		),
	}
}

// TePolicy (list): An individual SR-TE policy is identified by a combination
// of color and endpoint.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "te-policies/te-policy"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy"
// Color: uint32
// Endpoint: string
func (n *NetworkInstance_SegmentRoutingPathAny) TePolicy(Color uint32, Endpoint string) *NetworkInstance_SegmentRouting_TePolicyPathAny {
	return &NetworkInstance_SegmentRouting_TePolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"te-policies", "te-policy"},
			map[string]interface{}{"color": Color, "endpoint": Endpoint},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_SrgbPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb YANG schema element.
type NetworkInstance_SegmentRouting_SrgbPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_SrgbPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb YANG schema element.
type NetworkInstance_SegmentRouting_SrgbPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_DataplaneTypePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/config/dataplane-type YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_DataplaneTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_DataplaneTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/config/dataplane-type YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_DataplaneTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_Ipv6PrefixesPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/config/ipv6-prefixes YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_Ipv6PrefixesPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_Ipv6PrefixesPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/config/ipv6-prefixes YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_Ipv6PrefixesPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_LocalIdPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/config/local-id YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_LocalIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_LocalIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/config/local-id YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_LocalIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_MplsLabelBlocksPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/config/mpls-label-blocks YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_MplsLabelBlocksPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_MplsLabelBlocksPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/config/mpls-label-blocks YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_MplsLabelBlocksPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_SizePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/state/size YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_SizePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_SizePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/state/size YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_SizePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_UsedPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/state/used YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_UsedPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srgb_UsedPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srgbs/srgb/state/used YANG schema element.
type NetworkInstance_SegmentRouting_Srgb_UsedPathAny struct {
	*ygot.NodePath
}

// DataplaneType (leaf): The dataplane being used to instantiate the SRGB. When MPLS is specified
// the set of MPLS label blocks that are defined in the mpls-label-blocks
// list are used to make up the SRGB. When IPv6 is specified, the set of IPv6
// prefixes specified in the ipv6-prefixes list are used.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dataplane-type"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/config/dataplane-type"
func (n *NetworkInstance_SegmentRouting_SrgbPath) DataplaneType() *NetworkInstance_SegmentRouting_Srgb_DataplaneTypePath {
	return &NetworkInstance_SegmentRouting_Srgb_DataplaneTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dataplane-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// DataplaneType (leaf): The dataplane being used to instantiate the SRGB. When MPLS is specified
// the set of MPLS label blocks that are defined in the mpls-label-blocks
// list are used to make up the SRGB. When IPv6 is specified, the set of IPv6
// prefixes specified in the ipv6-prefixes list are used.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dataplane-type"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/config/dataplane-type"
func (n *NetworkInstance_SegmentRouting_SrgbPathAny) DataplaneType() *NetworkInstance_SegmentRouting_Srgb_DataplaneTypePathAny {
	return &NetworkInstance_SegmentRouting_Srgb_DataplaneTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dataplane-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Prefixes (leaf): A list of IPv6 prefixes which are to be used for segment routing using
// the IPv6 dataplane.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ipv6-prefixes"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/config/ipv6-prefixes"
func (n *NetworkInstance_SegmentRouting_SrgbPath) Ipv6Prefixes() *NetworkInstance_SegmentRouting_Srgb_Ipv6PrefixesPath {
	return &NetworkInstance_SegmentRouting_Srgb_Ipv6PrefixesPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv6-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Prefixes (leaf): A list of IPv6 prefixes which are to be used for segment routing using
// the IPv6 dataplane.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ipv6-prefixes"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/config/ipv6-prefixes"
func (n *NetworkInstance_SegmentRouting_SrgbPathAny) Ipv6Prefixes() *NetworkInstance_SegmentRouting_Srgb_Ipv6PrefixesPathAny {
	return &NetworkInstance_SegmentRouting_Srgb_Ipv6PrefixesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv6-prefixes"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalId (leaf): Unique identifier for the segment routing global block on
// the local system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-id"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/config/local-id"
func (n *NetworkInstance_SegmentRouting_SrgbPath) LocalId() *NetworkInstance_SegmentRouting_Srgb_LocalIdPath {
	return &NetworkInstance_SegmentRouting_Srgb_LocalIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalId (leaf): Unique identifier for the segment routing global block on
// the local system.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-id"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/config/local-id"
func (n *NetworkInstance_SegmentRouting_SrgbPathAny) LocalId() *NetworkInstance_SegmentRouting_Srgb_LocalIdPathAny {
	return &NetworkInstance_SegmentRouting_Srgb_LocalIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabelBlocks (leaf): A list of refences to the label blocks that are used to make
// up the SRGB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mpls-label-blocks"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/config/mpls-label-blocks"
func (n *NetworkInstance_SegmentRouting_SrgbPath) MplsLabelBlocks() *NetworkInstance_SegmentRouting_Srgb_MplsLabelBlocksPath {
	return &NetworkInstance_SegmentRouting_Srgb_MplsLabelBlocksPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mpls-label-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabelBlocks (leaf): A list of refences to the label blocks that are used to make
// up the SRGB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mpls-label-blocks"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/config/mpls-label-blocks"
func (n *NetworkInstance_SegmentRouting_SrgbPathAny) MplsLabelBlocks() *NetworkInstance_SegmentRouting_Srgb_MplsLabelBlocksPathAny {
	return &NetworkInstance_SegmentRouting_Srgb_MplsLabelBlocksPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mpls-label-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// Size (leaf): The total number of SRGB entries that are available within the SRGB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/size"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/state/size"
func (n *NetworkInstance_SegmentRouting_SrgbPath) Size() *NetworkInstance_SegmentRouting_Srgb_SizePath {
	return &NetworkInstance_SegmentRouting_Srgb_SizePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "size"},
			map[string]interface{}{},
			n,
		),
	}
}

// Size (leaf): The total number of SRGB entries that are available within the SRGB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/size"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/state/size"
func (n *NetworkInstance_SegmentRouting_SrgbPathAny) Size() *NetworkInstance_SegmentRouting_Srgb_SizePathAny {
	return &NetworkInstance_SegmentRouting_Srgb_SizePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "size"},
			map[string]interface{}{},
			n,
		),
	}
}

// Used (leaf): The total number of SRGB entries that have already been alocated by
// protocols referencing the SRGB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/used"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/state/used"
func (n *NetworkInstance_SegmentRouting_SrgbPath) Used() *NetworkInstance_SegmentRouting_Srgb_UsedPath {
	return &NetworkInstance_SegmentRouting_Srgb_UsedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "used"},
			map[string]interface{}{},
			n,
		),
	}
}

// Used (leaf): The total number of SRGB entries that have already been alocated by
// protocols referencing the SRGB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/used"
// Path from root: "/network-instances/network-instance/segment-routing/srgbs/srgb/state/used"
func (n *NetworkInstance_SegmentRouting_SrgbPathAny) Used() *NetworkInstance_SegmentRouting_Srgb_UsedPathAny {
	return &NetworkInstance_SegmentRouting_Srgb_UsedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "used"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_SrlbPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb YANG schema element.
type NetworkInstance_SegmentRouting_SrlbPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_SrlbPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb YANG schema element.
type NetworkInstance_SegmentRouting_SrlbPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srlb_DataplaneTypePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb/config/dataplane-type YANG schema element.
type NetworkInstance_SegmentRouting_Srlb_DataplaneTypePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srlb_DataplaneTypePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb/config/dataplane-type YANG schema element.
type NetworkInstance_SegmentRouting_Srlb_DataplaneTypePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srlb_Ipv6PrefixPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb/config/ipv6-prefix YANG schema element.
type NetworkInstance_SegmentRouting_Srlb_Ipv6PrefixPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srlb_Ipv6PrefixPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb/config/ipv6-prefix YANG schema element.
type NetworkInstance_SegmentRouting_Srlb_Ipv6PrefixPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srlb_LocalIdPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb/config/local-id YANG schema element.
type NetworkInstance_SegmentRouting_Srlb_LocalIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srlb_LocalIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb/config/local-id YANG schema element.
type NetworkInstance_SegmentRouting_Srlb_LocalIdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srlb_MplsLabelBlockPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb/config/mpls-label-block YANG schema element.
type NetworkInstance_SegmentRouting_Srlb_MplsLabelBlockPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_Srlb_MplsLabelBlockPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/srlbs/srlb/config/mpls-label-block YANG schema element.
type NetworkInstance_SegmentRouting_Srlb_MplsLabelBlockPathAny struct {
	*ygot.NodePath
}

// DataplaneType (leaf): The dataplane that is to be used for the Segment Routing Local Block.
// When MPLS is specified, the local block corresponds to a block of MPLS
// labels; when IPv6 is specified it corresponds to an IPv6 prefix.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dataplane-type"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb/config/dataplane-type"
func (n *NetworkInstance_SegmentRouting_SrlbPath) DataplaneType() *NetworkInstance_SegmentRouting_Srlb_DataplaneTypePath {
	return &NetworkInstance_SegmentRouting_Srlb_DataplaneTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dataplane-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// DataplaneType (leaf): The dataplane that is to be used for the Segment Routing Local Block.
// When MPLS is specified, the local block corresponds to a block of MPLS
// labels; when IPv6 is specified it corresponds to an IPv6 prefix.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dataplane-type"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb/config/dataplane-type"
func (n *NetworkInstance_SegmentRouting_SrlbPathAny) DataplaneType() *NetworkInstance_SegmentRouting_Srlb_DataplaneTypePathAny {
	return &NetworkInstance_SegmentRouting_Srlb_DataplaneTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dataplane-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Prefix (leaf): The IPv6 prefix that is used for the SRLB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ipv6-prefix"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb/config/ipv6-prefix"
func (n *NetworkInstance_SegmentRouting_SrlbPath) Ipv6Prefix() *NetworkInstance_SegmentRouting_Srlb_Ipv6PrefixPath {
	return &NetworkInstance_SegmentRouting_Srlb_Ipv6PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv6-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Prefix (leaf): The IPv6 prefix that is used for the SRLB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/ipv6-prefix"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb/config/ipv6-prefix"
func (n *NetworkInstance_SegmentRouting_SrlbPathAny) Ipv6Prefix() *NetworkInstance_SegmentRouting_Srlb_Ipv6PrefixPathAny {
	return &NetworkInstance_SegmentRouting_Srlb_Ipv6PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv6-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalId (leaf): A unique local identifier used for the Segment Routing Local Block.
// The identifier is used when referencing the SRLB within other
// contexts.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-id"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb/config/local-id"
func (n *NetworkInstance_SegmentRouting_SrlbPath) LocalId() *NetworkInstance_SegmentRouting_Srlb_LocalIdPath {
	return &NetworkInstance_SegmentRouting_Srlb_LocalIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LocalId (leaf): A unique local identifier used for the Segment Routing Local Block.
// The identifier is used when referencing the SRLB within other
// contexts.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/local-id"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb/config/local-id"
func (n *NetworkInstance_SegmentRouting_SrlbPathAny) LocalId() *NetworkInstance_SegmentRouting_Srlb_LocalIdPathAny {
	return &NetworkInstance_SegmentRouting_Srlb_LocalIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "local-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabelBlock (leaf): A reference to the MPLS label block that is used to contain the
// SIDs of the SRLB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mpls-label-block"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb/config/mpls-label-block"
func (n *NetworkInstance_SegmentRouting_SrlbPath) MplsLabelBlock() *NetworkInstance_SegmentRouting_Srlb_MplsLabelBlockPath {
	return &NetworkInstance_SegmentRouting_Srlb_MplsLabelBlockPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mpls-label-block"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsLabelBlock (leaf): A reference to the MPLS label block that is used to contain the
// SIDs of the SRLB.
// ----------------------------------------
// Defining module: "openconfig-segment-routing"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/mpls-label-block"
// Path from root: "/network-instances/network-instance/segment-routing/srlbs/srlb/config/mpls-label-block"
func (n *NetworkInstance_SegmentRouting_SrlbPathAny) MplsLabelBlock() *NetworkInstance_SegmentRouting_Srlb_MplsLabelBlockPathAny {
	return &NetworkInstance_SegmentRouting_Srlb_MplsLabelBlockPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mpls-label-block"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_TePolicyPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy YANG schema element.
type NetworkInstance_SegmentRouting_TePolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy YANG schema element.
type NetworkInstance_SegmentRouting_TePolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_ActivePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_ActivePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_ActivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_ActivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_ActiveSincePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active-since YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_ActiveSincePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_ActiveSincePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active-since YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_ActiveSincePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_ActiveTransitionsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active-transitions YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_ActiveTransitionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_ActiveTransitionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active-transitions YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_ActiveTransitionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_BsidPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/bsid YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_BsidPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_BsidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/bsid YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_BsidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_ColorPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/color YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_ColorPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_ColorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/color YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_ColorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_EndpointPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/endpoint YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_EndpointPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_EndpointPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/endpoint YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_EndpointPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_NamePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/name YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/name YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_NamePathAny struct {
	*ygot.NodePath
}

// Active (leaf): A SR-TE policy is marked as active when at least one of its
// candidate paths is valid/active and the policy has been
// instantiated in the forwarding plane.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active"
func (n *NetworkInstance_SegmentRouting_TePolicyPath) Active() *NetworkInstance_SegmentRouting_TePolicy_ActivePath {
	return &NetworkInstance_SegmentRouting_TePolicy_ActivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// Active (leaf): A SR-TE policy is marked as active when at least one of its
// candidate paths is valid/active and the policy has been
// instantiated in the forwarding plane.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active"
func (n *NetworkInstance_SegmentRouting_TePolicyPathAny) Active() *NetworkInstance_SegmentRouting_TePolicy_ActivePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_ActivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActiveSince (leaf): Indication of the time the policy transitioned to the active
// state.
//
// The value is the timestamp in nanoseconds relative to the Unix
// Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-since"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active-since"
func (n *NetworkInstance_SegmentRouting_TePolicyPath) ActiveSince() *NetworkInstance_SegmentRouting_TePolicy_ActiveSincePath {
	return &NetworkInstance_SegmentRouting_TePolicy_ActiveSincePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-since"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActiveSince (leaf): Indication of the time the policy transitioned to the active
// state.
//
// The value is the timestamp in nanoseconds relative to the Unix
// Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-since"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active-since"
func (n *NetworkInstance_SegmentRouting_TePolicyPathAny) ActiveSince() *NetworkInstance_SegmentRouting_TePolicy_ActiveSincePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_ActiveSincePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-since"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActiveTransitions (leaf): The number of transitions to active state for the policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-transitions"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active-transitions"
func (n *NetworkInstance_SegmentRouting_TePolicyPath) ActiveTransitions() *NetworkInstance_SegmentRouting_TePolicy_ActiveTransitionsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_ActiveTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActiveTransitions (leaf): The number of transitions to active state for the policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-transitions"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/active-transitions"
func (n *NetworkInstance_SegmentRouting_TePolicyPathAny) ActiveTransitions() *NetworkInstance_SegmentRouting_TePolicy_ActiveTransitionsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_ActiveTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bsid (leaf): The Binding SID (BSID) assigned to the SR-TE policy,
// expressed as an MPLS label or IPv6 address. Packets that are
// ingress to the system with active segment matching the SID
// value specified in this leaf should be forwarded according
// to the policy. The specified Binding SID must be removed
// from the segment list by the system.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bsid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/bsid"
func (n *NetworkInstance_SegmentRouting_TePolicyPath) Bsid() *NetworkInstance_SegmentRouting_TePolicy_BsidPath {
	return &NetworkInstance_SegmentRouting_TePolicy_BsidPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bsid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Bsid (leaf): The Binding SID (BSID) assigned to the SR-TE policy,
// expressed as an MPLS label or IPv6 address. Packets that are
// ingress to the system with active segment matching the SID
// value specified in this leaf should be forwarded according
// to the policy. The specified Binding SID must be removed
// from the segment list by the system.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/bsid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/bsid"
func (n *NetworkInstance_SegmentRouting_TePolicyPathAny) Bsid() *NetworkInstance_SegmentRouting_TePolicy_BsidPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_BsidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bsid"},
			map[string]interface{}{},
			n,
		),
	}
}

// CandidatePathAny (list): An individual candidate path within the list of candidate
// paths associated with this SR-TE policy. It is uniquely
// identified by the combination of protocol-origin,
// originator and discriminator
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "candidate-paths/candidate-path"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path"
func (n *NetworkInstance_SegmentRouting_TePolicyPath) CandidatePathAny() *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"candidate-paths", "candidate-path"},
			map[string]interface{}{"protocol-origin": "*", "originator-asn": "*", "originator-addr": "*", "discriminator": "*"},
			n,
		),
	}
}

// CandidatePathAny (list): An individual candidate path within the list of candidate
// paths associated with this SR-TE policy. It is uniquely
// identified by the combination of protocol-origin,
// originator and discriminator
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "candidate-paths/candidate-path"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path"
func (n *NetworkInstance_SegmentRouting_TePolicyPathAny) CandidatePathAny() *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"candidate-paths", "candidate-path"},
			map[string]interface{}{"protocol-origin": "*", "originator-asn": "*", "originator-addr": "*", "discriminator": "*"},
			n,
		),
	}
}

// WithProtocolOrigin sets NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny's key "protocol-origin" to the specified value.
// ProtocolOrigin: E_SegmentRoutingTypes_SrteProtocolType
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) WithProtocolOrigin(ProtocolOrigin E_SegmentRoutingTypes_SrteProtocolType) *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny {
	ygot.ModifyKey(n.NodePath, "protocol-origin", ProtocolOrigin)
	return n
}

// WithOriginatorAsn sets NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny's key "originator-asn" to the specified value.
// OriginatorAsn: uint32
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) WithOriginatorAsn(OriginatorAsn uint32) *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny {
	ygot.ModifyKey(n.NodePath, "originator-asn", OriginatorAsn)
	return n
}

// WithOriginatorAddr sets NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny's key "originator-addr" to the specified value.
// OriginatorAddr: string
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) WithOriginatorAddr(OriginatorAddr string) *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny {
	ygot.ModifyKey(n.NodePath, "originator-addr", OriginatorAddr)
	return n
}

// WithDiscriminator sets NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny's key "discriminator" to the specified value.
// Discriminator: uint32
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) WithDiscriminator(Discriminator uint32) *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny {
	ygot.ModifyKey(n.NodePath, "discriminator", Discriminator)
	return n
}

// Color (leaf): When the policy is used for RIB resolution to a specific
// Segment Routing Traffic Engineering path, the policy is used
// when the color required in the policy (which may be specified
// based on the value of a BGP extended colour community) matches
// the value of this leaf. The color being set to 0 indicates
// that the colour is a wildcard in the policy resolution.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/color"
func (n *NetworkInstance_SegmentRouting_TePolicyPath) Color() *NetworkInstance_SegmentRouting_TePolicy_ColorPath {
	return &NetworkInstance_SegmentRouting_TePolicy_ColorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Color (leaf): When the policy is used for RIB resolution to a specific
// Segment Routing Traffic Engineering path, the policy is used
// when the color required in the policy (which may be specified
// based on the value of a BGP extended colour community) matches
// the value of this leaf. The color being set to 0 indicates
// that the colour is a wildcard in the policy resolution.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/color"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/color"
func (n *NetworkInstance_SegmentRouting_TePolicyPathAny) Color() *NetworkInstance_SegmentRouting_TePolicy_ColorPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_ColorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "color"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): A collection of counters on the policy level. They
// count the total traffic forwarded by the policy,
// regardless of its installation source. The counters
// should be persistent across policy state changes and
// switches between active protocols.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters"
func (n *NetworkInstance_SegmentRouting_TePolicyPath) Counters() *NetworkInstance_SegmentRouting_TePolicy_CountersPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): A collection of counters on the policy level. They
// count the total traffic forwarded by the policy,
// regardless of its installation source. The counters
// should be persistent across policy state changes and
// switches between active protocols.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters"
func (n *NetworkInstance_SegmentRouting_TePolicyPathAny) Counters() *NetworkInstance_SegmentRouting_TePolicy_CountersPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): When the policy is used for RIB resolution to a Segment
// Routing Traffic Engineering path, the policy is used when the
// required endpoint (which may be the protocol next-hop) matches
// the endpoint address specified in this leaf. When the leaf is
// set to all zeros (0.0.0.0 or ::), the endpoint acts as a
// wildcard in the policy resolution.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/endpoint"
func (n *NetworkInstance_SegmentRouting_TePolicyPath) Endpoint() *NetworkInstance_SegmentRouting_TePolicy_EndpointPath {
	return &NetworkInstance_SegmentRouting_TePolicy_EndpointPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Endpoint (leaf): When the policy is used for RIB resolution to a Segment
// Routing Traffic Engineering path, the policy is used when the
// required endpoint (which may be the protocol next-hop) matches
// the endpoint address specified in this leaf. When the leaf is
// set to all zeros (0.0.0.0 or ::), the endpoint acts as a
// wildcard in the policy resolution.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/endpoint"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/endpoint"
func (n *NetworkInstance_SegmentRouting_TePolicyPathAny) Endpoint() *NetworkInstance_SegmentRouting_TePolicy_EndpointPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_EndpointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "endpoint"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The user friendly SR-TE policy name.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/name"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/name"
func (n *NetworkInstance_SegmentRouting_TePolicyPath) Name() *NetworkInstance_SegmentRouting_TePolicy_NamePath {
	return &NetworkInstance_SegmentRouting_TePolicy_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The user friendly SR-TE policy name.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/name"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/name"
func (n *NetworkInstance_SegmentRouting_TePolicyPathAny) Name() *NetworkInstance_SegmentRouting_TePolicy_NamePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActivePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActivePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActivePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActivePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveSincePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active-since YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveSincePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveSincePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active-since YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveSincePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveTransitionsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active-transitions YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveTransitionsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveTransitionsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active-transitions YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveTransitionsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_DiscriminatorPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/discriminator YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_DiscriminatorPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_DiscriminatorPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/discriminator YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_DiscriminatorPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_EnlpPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/enlp YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_EnlpPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_EnlpPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/enlp YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_EnlpPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_NamePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/name YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/name YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_NamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAddrPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/originator-addr YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAddrPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAddrPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/originator-addr YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAddrPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAsnPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/originator-asn YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAsnPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAsnPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/originator-asn YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAsnPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_PreferencePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/preference YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_PreferencePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_PreferencePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/preference YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_PreferencePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ProtocolOriginPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/protocol-origin YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ProtocolOriginPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ProtocolOriginPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/protocol-origin YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ProtocolOriginPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ValidPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/valid YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ValidPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ValidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/valid YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ValidPathAny struct {
	*ygot.NodePath
}

// Active (leaf): A candidate path is active when it is valid and it is
// determined to be the best path of the SR-TE Policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) Active() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActivePath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActivePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// Active (leaf): A candidate path is active when it is valid and it is
// determined to be the best path of the SR-TE Policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) Active() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActivePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActiveSince (leaf): Indication of the time the path transitioned to the active
// state.
//
// The value is the timestamp in nanoseconds relative to the
// Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-since"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active-since"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) ActiveSince() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveSincePath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveSincePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-since"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActiveSince (leaf): Indication of the time the path transitioned to the active
// state.
//
// The value is the timestamp in nanoseconds relative to the
// Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-since"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active-since"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) ActiveSince() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveSincePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveSincePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-since"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActiveTransitions (leaf): The number of transitions to active state for the candidate
// path.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-transitions"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active-transitions"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) ActiveTransitions() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveTransitionsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveTransitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActiveTransitions (leaf): The number of transitions to active state for the candidate
// path.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/active-transitions"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/active-transitions"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) ActiveTransitions() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveTransitionsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ActiveTransitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "active-transitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Discriminator (leaf): A 32 bit value uniquely identifying the path within the
// context of a policy learnt from a protocol.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/discriminator"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/discriminator"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) Discriminator() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_DiscriminatorPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_DiscriminatorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// Discriminator (leaf): A 32 bit value uniquely identifying the path within the
// context of a policy learnt from a protocol.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/discriminator"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/discriminator"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) Discriminator() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_DiscriminatorPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_DiscriminatorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "discriminator"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enlp (leaf): ENLP (Explicit NULL Label Policy) indicates whether Explicit
// NULL labels are to be pushed on unlabeled IP packets that are
// being steered into a given SR policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/enlp"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/enlp"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) Enlp() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_EnlpPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_EnlpPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "enlp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enlp (leaf): ENLP (Explicit NULL Label Policy) indicates whether Explicit
// NULL labels are to be pushed on unlabeled IP packets that are
// being steered into a given SR policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/enlp"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/enlp"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) Enlp() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_EnlpPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_EnlpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "enlp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The user friendly SR-TE candidate path name.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/name"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/name"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) Name() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_NamePath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The user friendly SR-TE candidate path name.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/name"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/name"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) Name() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_NamePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorAddr (leaf): The address of the node originating the candidate path.
// Address in IPv4 can be represented as IPv6-encoded-IPv4 e.g.
// ::FFFF:192.168.1.2 or a normal IPv6 address with the lowest
// 32 bits carrying the actual IPv4 address.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-addr"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/originator-addr"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) OriginatorAddr() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAddrPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAddrPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-addr"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorAddr (leaf): The address of the node originating the candidate path.
// Address in IPv4 can be represented as IPv6-encoded-IPv4 e.g.
// ::FFFF:192.168.1.2 or a normal IPv6 address with the lowest
// 32 bits carrying the actual IPv4 address.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-addr"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/originator-addr"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) OriginatorAddr() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAddrPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAddrPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-addr"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorAsn (leaf): The autonomous system that node originating the candidate
// path locates.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-asn"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/originator-asn"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) OriginatorAsn() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAsnPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAsnPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-asn"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginatorAsn (leaf): The autonomous system that node originating the candidate
// path locates.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/originator-asn"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/originator-asn"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) OriginatorAsn() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAsnPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_OriginatorAsnPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "originator-asn"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): When there are multiple candidate paths specified a
// particular SR-TE policy. The preference is used to resolve
// between them. And the one with higher preference is
// preferred.
// These paths may be learnt from a dynamic routing protocol,
// or interface to the device, or from other static entries
// configured on the system.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/preference"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/preference"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) Preference() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_PreferencePath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_PreferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// Preference (leaf): When there are multiple candidate paths specified a
// particular SR-TE policy. The preference is used to resolve
// between them. And the one with higher preference is
// preferred.
// These paths may be learnt from a dynamic routing protocol,
// or interface to the device, or from other static entries
// configured on the system.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/preference"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/preference"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) Preference() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_PreferencePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_PreferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "preference"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtocolOrigin (leaf): The component or protocol that originates or signals the
// candidate path.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/protocol-origin"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/protocol-origin"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) ProtocolOrigin() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ProtocolOriginPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ProtocolOriginPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "protocol-origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtocolOrigin (leaf): The component or protocol that originates or signals the
// candidate path.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/protocol-origin"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/protocol-origin"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) ProtocolOrigin() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ProtocolOriginPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ProtocolOriginPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "protocol-origin"},
			map[string]interface{}{},
			n,
		),
	}
}

// SegmentListAny (list): An individual segment list within the list of segment
// lists associated with this candidate path.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-lists/segment-list"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list"
// Id (wildcarded): uint32
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) SegmentListAny() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-lists", "segment-list"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// SegmentListAny (list): An individual segment list within the list of segment
// lists associated with this candidate path.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-lists/segment-list"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list"
// Id (wildcarded): uint32
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) SegmentListAny() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-lists", "segment-list"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// SegmentList (list): An individual segment list within the list of segment
// lists associated with this candidate path.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-lists/segment-list"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list"
// Id: uint32
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) SegmentList(Id uint32) *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath{
		NodePath: ygot.NewNodePath(
			[]string{"segment-lists", "segment-list"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// SegmentList (list): An individual segment list within the list of segment
// lists associated with this candidate path.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "segment-lists/segment-list"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list"
// Id: uint32
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) SegmentList(Id uint32) *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"segment-lists", "segment-list"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Valid (leaf): A path should be marked as valid when it is usable e.g. the
// at least one segment-list is valid even though the path may
// not be the best.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/valid"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPath) Valid() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ValidPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ValidPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Valid (leaf): A path should be marked as valid when it is usable e.g. the
// at least one segment-list is valid even though the path may
// not be the best.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/state/valid"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePathPathAny) Valid() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ValidPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_ValidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_IdPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/id YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_IdPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_IdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/id YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_IdPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_InvalidReasonPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/invalid-reason YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_InvalidReasonPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_InvalidReasonPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/invalid-reason YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_InvalidReasonPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_ValidPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/valid YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_ValidPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_ValidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/valid YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_ValidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_WeightPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/weight YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_WeightPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_WeightPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/weight YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_WeightPathAny struct {
	*ygot.NodePath
}

// Counters (container): The counters of traffic steered to the segment-list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath) Counters() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): The counters of traffic steered to the segment-list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny) Counters() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique id identifying the segment-list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/id"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath) Id() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_IdPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): A unique id identifying the segment-list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/id"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/id"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny) Id() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_IdPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If a segment-list is marked as invalid, this leaf should
// indicate the reason.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/invalid-reason"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath) InvalidReason() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_InvalidReasonPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_InvalidReasonPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidReason (leaf): If a segment-list is marked as invalid, this leaf should
// indicate the reason.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/invalid-reason"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/invalid-reason"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny) InvalidReason() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_InvalidReasonPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_InvalidReasonPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "invalid-reason"},
			map[string]interface{}{},
			n,
		),
	}
}

// NextHopAny (list): A next-hop the segment list is resolved to.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath) NextHopAny() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHopAny (list): A next-hop the segment list is resolved to.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop"
// Index (wildcarded): uint64
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny) NextHopAny() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// NextHop (list): A next-hop the segment list is resolved to.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath) NextHop(Index uint64) *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// NextHop (list): A next-hop the segment list is resolved to.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "next-hops/next-hop"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop"
// Index: uint64
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny) NextHop(Index uint64) *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"next-hops", "next-hop"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// SidAny (list): List of SIDs that make up the segment list. The segment
// list is formed by ordering the set of SIDs that are
// specified by their index in ascending numerical order.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sids/sid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid"
// Index (wildcarded): uint64
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath) SidAny() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sids", "sid"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// SidAny (list): List of SIDs that make up the segment list. The segment
// list is formed by ordering the set of SIDs that are
// specified by their index in ascending numerical order.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sids/sid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid"
// Index (wildcarded): uint64
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny) SidAny() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sids", "sid"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// Sid (list): List of SIDs that make up the segment list. The segment
// list is formed by ordering the set of SIDs that are
// specified by their index in ascending numerical order.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sids/sid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid"
// Index: uint64
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath) Sid(Index uint64) *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPath{
		NodePath: ygot.NewNodePath(
			[]string{"sids", "sid"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Sid (list): List of SIDs that make up the segment list. The segment
// list is formed by ordering the set of SIDs that are
// specified by their index in ascending numerical order.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "sids/sid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid"
// Index: uint64
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny) Sid(Index uint64) *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"sids", "sid"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Valid (leaf): The validity of a segment-list should marked as true
// when it is usable.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/valid"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath) Valid() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_ValidPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_ValidPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Valid (leaf): The validity of a segment-list should marked as true
// when it is usable.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/valid"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/valid"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny) Valid() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_ValidPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_ValidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): The weight of the segment list within the set of
// segment lists specified for the candidate path. The
// traffic that is forwarded according to the policy is
// distributed across the set of segment-lists such that
// each list receives weight/(sum of all weights) traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/weight"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPath) Weight() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_WeightPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_WeightPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// Weight (leaf): The weight of the segment list within the set of
// segment lists specified for the candidate path. The
// traffic that is forwarded according to the policy is
// distributed across the set of segment-lists such that
// each list receives weight/(sum of all weights) traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/weight"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/weight"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentListPathAny) Weight() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_WeightPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_WeightPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "weight"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-labeled-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-labeled-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledPktsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-labeled-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-labeled-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutPktsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutPktsPathAny struct {
	*ygot.NodePath
}

// OutLabeledOctets (leaf): A cumulative counter of the total bytes of incoming labeled
// traffic steered to the segment list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-labeled-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPath) OutLabeledOctets() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledOctetsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledOctets (leaf): A cumulative counter of the total bytes of incoming labeled
// traffic steered to the segment list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-labeled-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPathAny) OutLabeledOctets() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledOctetsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledPkts (leaf): A cumulative counter of the incoming labeled packets steered
// to the segment list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-labeled-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPath) OutLabeledPkts() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledPktsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledPkts (leaf): A cumulative counter of the incoming labeled packets steered
// to the segment list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-labeled-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPathAny) OutLabeledPkts() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledPktsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutLabeledPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The cumulative counter of the total outgoing bytes steered
// to the segment list. The counter includes both labeled and
// unlabeled steerted traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPath) OutOctets() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutOctetsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The cumulative counter of the total outgoing bytes steered
// to the segment list. The counter includes both labeled and
// unlabeled steerted traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPathAny) OutOctets() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutOctetsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the outgoing packets steered to the
// segment list. The counter includes both labeled and unlabeled
// steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPath) OutPkts() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutPktsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the outgoing packets steered to the
// segment list. The counter includes both labeled and unlabeled
// steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/state/counters/out-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_CountersPathAny) OutPkts() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutPktsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Counters_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_EncapsulateHeaderPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/encapsulate-header YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_EncapsulateHeaderPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_EncapsulateHeaderPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/encapsulate-header YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_EncapsulateHeaderPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/index YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IpAddressPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/ip-address YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IpAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IpAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/ip-address YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IpAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_MacAddressPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/mac-address YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_MacAddressPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_MacAddressPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/mac-address YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_MacAddressPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_OriginProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/origin-protocol YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_OriginProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_OriginProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/origin-protocol YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_OriginProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PopTopLabelPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/pop-top-label YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PopTopLabelPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PopTopLabelPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/pop-top-label YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PopTopLabelPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_ProgrammedIndexPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/programmed-index YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_ProgrammedIndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_ProgrammedIndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/programmed-index YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_ProgrammedIndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PushedMplsLabelStackPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/pushed-mpls-label-stack YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PushedMplsLabelStackPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PushedMplsLabelStackPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/pushed-mpls-label-stack YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PushedMplsLabelStackPathAny struct {
	*ygot.NodePath
}

// Counters (container): The counters of traffic steered to the segment-list on
// per next-hop basis.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) Counters() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): The counters of traffic steered to the segment-list on
// per next-hop basis.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/counters"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) Counters() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// EncapsulateHeader (leaf): When forwarding a packet to the specified next-hop the local
// system performs an encapsulation of the packet - adding the
// specified header type.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/encapsulate-header"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/encapsulate-header"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) EncapsulateHeader() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_EncapsulateHeaderPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_EncapsulateHeaderPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "encapsulate-header"},
			map[string]interface{}{},
			n,
		),
	}
}

// EncapsulateHeader (leaf): When forwarding a packet to the specified next-hop the local
// system performs an encapsulation of the packet - adding the
// specified header type.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/encapsulate-header"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/encapsulate-header"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) EncapsulateHeader() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_EncapsulateHeaderPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_EncapsulateHeaderPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "encapsulate-header"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): A unique entry for the next-hop.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/index"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) Index() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IndexPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): A unique entry for the next-hop.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/index"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) Index() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IndexPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) InterfaceRef() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "interface-ref"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) InterfaceRef() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpAddress (leaf): The IP address of the next-hop system.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-address"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/ip-address"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) IpAddress() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IpAddressPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IpAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpAddress (leaf): The IP address of the next-hop system.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/ip-address"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/ip-address"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) IpAddress() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IpAddressPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_IpAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ip-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The MAC address of the next-hop if resolved by the local
// network instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/mac-address"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) MacAddress() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_MacAddressPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_MacAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// MacAddress (leaf): The MAC address of the next-hop if resolved by the local
// network instance.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mac-address"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/mac-address"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) MacAddress() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_MacAddressPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_MacAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mac-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginProtocol (leaf): The protocol from which the AFT entry was learned.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin-protocol"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/origin-protocol"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) OriginProtocol() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_OriginProtocolPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_OriginProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// OriginProtocol (leaf): The protocol from which the AFT entry was learned.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/origin-protocol"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/origin-protocol"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) OriginProtocol() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_OriginProtocolPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_OriginProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "origin-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// PopTopLabel (leaf): Flag that controls pop action, i.e., the top-most MPLS label
// should be popped from the packet when switched by the system.
//
// The top-most MPLS label associated with pop action is equal to
// the label key used in 'mpls' AFT 'label-entry' list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pop-top-label"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/pop-top-label"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) PopTopLabel() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PopTopLabelPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PopTopLabelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pop-top-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// PopTopLabel (leaf): Flag that controls pop action, i.e., the top-most MPLS label
// should be popped from the packet when switched by the system.
//
// The top-most MPLS label associated with pop action is equal to
// the label key used in 'mpls' AFT 'label-entry' list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pop-top-label"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/pop-top-label"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) PopTopLabel() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PopTopLabelPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PopTopLabelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pop-top-label"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProgrammedIndex (leaf): In some routing protocols, or route injection mechanisms it
// is possible to set the index of the next-hop via configuration
// or the protocol itself. In some systems it may not be possible
// to maintain the index provided by an external client when
// advertising the same entry via telemetry.
//
// This leaf reflects the configured or client-supplied index of
// the next-hop. This allows a client to create an assocation or
// mapping back to the original index pushed by the client, and
// the ID used as a key in the next-hop AFT list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/programmed-index"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/programmed-index"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) ProgrammedIndex() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_ProgrammedIndexPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_ProgrammedIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "programmed-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProgrammedIndex (leaf): In some routing protocols, or route injection mechanisms it
// is possible to set the index of the next-hop via configuration
// or the protocol itself. In some systems it may not be possible
// to maintain the index provided by an external client when
// advertising the same entry via telemetry.
//
// This leaf reflects the configured or client-supplied index of
// the next-hop. This allows a client to create an assocation or
// mapping back to the original index pushed by the client, and
// the ID used as a key in the next-hop AFT list.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/programmed-index"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/programmed-index"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) ProgrammedIndex() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_ProgrammedIndexPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_ProgrammedIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "programmed-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushedMplsLabelStack (leaf): The MPLS label stack imposed when forwarding packets to the
// next-hop
// - the stack is encoded as a leaf list whereby the order of the
//  entries is such that the first entry in the list is the
//  label at the bottom of the stack to be pushed.
//
// To this end, a packet which is to forwarded to a device using
// a service label of 42, and a transport label of 8072 will be
// represented with a label stack list of [42, 8072].
//
// The MPLS label stack list is ordered by the user, such that no
// system re-ordering of leaves is permitted by the system.
//
// A swap operation is reflected by entries in the
// popped-mpls-label-stack and pushed-mpls-label-stack nodes.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pushed-mpls-label-stack"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/pushed-mpls-label-stack"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPath) PushedMplsLabelStack() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PushedMplsLabelStackPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PushedMplsLabelStackPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pushed-mpls-label-stack"},
			map[string]interface{}{},
			n,
		),
	}
}

// PushedMplsLabelStack (leaf): The MPLS label stack imposed when forwarding packets to the
// next-hop
// - the stack is encoded as a leaf list whereby the order of the
//  entries is such that the first entry in the list is the
//  label at the bottom of the stack to be pushed.
//
// To this end, a packet which is to forwarded to a device using
// a service label of 42, and a transport label of 8072 will be
// represented with a label stack list of [42, 8072].
//
// The MPLS label stack list is ordered by the user, such that no
// system re-ordering of leaves is permitted by the system.
//
// A swap operation is reflected by entries in the
// popped-mpls-label-stack and pushed-mpls-label-stack nodes.
// ----------------------------------------
// Defining module: "openconfig-aft-common"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/pushed-mpls-label-stack"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/pushed-mpls-label-stack"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHopPathAny) PushedMplsLabelStack() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PushedMplsLabelStackPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_PushedMplsLabelStackPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pushed-mpls-label-stack"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-labeled-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-labeled-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledPktsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-labeled-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-labeled-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutPktsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutPktsPathAny struct {
	*ygot.NodePath
}

// OutLabeledOctets (leaf): A cumulative counter of the total bytes of incoming labeled
// traffic steered to the segment list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-labeled-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPath) OutLabeledOctets() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledOctetsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledOctets (leaf): A cumulative counter of the total bytes of incoming labeled
// traffic steered to the segment list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-labeled-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPathAny) OutLabeledOctets() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledOctetsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledPkts (leaf): A cumulative counter of the incoming labeled packets steered
// to the segment list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-labeled-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPath) OutLabeledPkts() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledPktsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledPkts (leaf): A cumulative counter of the incoming labeled packets steered
// to the segment list.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-labeled-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPathAny) OutLabeledPkts() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledPktsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutLabeledPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The cumulative counter of the total outgoing bytes steered
// to the segment list. The counter includes both labeled and
// unlabeled steerted traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPath) OutOctets() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutOctetsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The cumulative counter of the total outgoing bytes steered
// to the segment list. The counter includes both labeled and
// unlabeled steerted traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPathAny) OutOctets() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutOctetsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the outgoing packets steered to the
// segment list. The counter includes both labeled and unlabeled
// steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPath) OutPkts() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutPktsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the outgoing packets steered to the
// segment list. The counter includes both labeled and unlabeled
// steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/state/counters/out-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_CountersPathAny) OutPkts() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutPktsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_Counters_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref/state/interface YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref/state/interface YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_SubinterfacePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref/state/subinterface YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref/state/subinterface YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref/state/interface"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPath) Interface() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_InterfacePath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref/state/interface"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPathAny) Interface() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_InterfacePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref/state/subinterface"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPath) Subinterface() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_SubinterfacePath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/subinterface"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/next-hops/next-hop/interface-ref/state/subinterface"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRefPathAny) Subinterface() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_SubinterfacePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_NextHop_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_IndexPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/index YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_IndexPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_IndexPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/index YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_IndexPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTcPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/mpls-tc YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTcPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTcPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/mpls-tc YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTcPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTtlPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/mpls-ttl YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTtlPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTtlPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/mpls-ttl YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTtlPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_ValuePath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/value YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_ValuePath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_ValuePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/value YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_ValuePathAny struct {
	*ygot.NodePath
}

// Index (leaf): The index of the SID within the segment list. The segment list is
// applied by ordering the SID entries in ascending numerical order
// beginning at 0.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/index"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPath) Index() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_IndexPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): The index of the SID within the segment list. The segment list is
// applied by ordering the SID entries in ascending numerical order
// beginning at 0.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/index"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/index"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny) Index() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_IndexPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTc (leaf): The value of the MPLS Traffic Class (TC) bits to be used if the
// value of the SID is an MPLS label. In the case that the value is
// set to 0, then the local implementation should choose the value.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-tc"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/mpls-tc"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPath) MplsTc() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTcPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTcPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-tc"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTc (leaf): The value of the MPLS Traffic Class (TC) bits to be used if the
// value of the SID is an MPLS label. In the case that the value is
// set to 0, then the local implementation should choose the value.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-tc"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/mpls-tc"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny) MplsTc() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTcPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTcPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-tc"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTtl (leaf): The TTL to be set if the type of the SID is an MPLS label. If the
// value of the TTL is set to be 0, the value is picked by the local
// implementation.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-ttl"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/mpls-ttl"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPath) MplsTtl() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTtlPath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTtlPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// MplsTtl (leaf): The TTL to be set if the type of the SID is an MPLS label. If the
// value of the TTL is set to be 0, the value is picked by the local
// implementation.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/mpls-ttl"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/mpls-ttl"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny) MplsTtl() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTtlPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_MplsTtlPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mpls-ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value of the SID that is to be used. Specified as an MPLS
// label or IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/value"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPath) Value() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_ValuePath {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): The value of the SID that is to be used. Specified as an MPLS
// label or IPv6 address.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/value"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/candidate-paths/candidate-path/segment-lists/segment-list/sids/sid/state/value"
func (n *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_SidPathAny) Value() *NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_ValuePathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_CandidatePath_SegmentList_Sid_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_SegmentRouting_TePolicy_CountersPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CountersPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_CountersPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_CountersPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-labeled-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-labeled-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledPktsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-labeled-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-labeled-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_InOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_InOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_InOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_InOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_InPktsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_InPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_InPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_InPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-labeled-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-labeled-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledPktsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-labeled-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-labeled-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledPktsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_OutOctetsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_OutOctetsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_OutOctetsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-octets YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_OutOctetsPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_OutPktsPath represents the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_OutPktsPath struct {
	*ygot.NodePath
}

// NetworkInstance_SegmentRouting_TePolicy_Counters_OutPktsPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-pkts YANG schema element.
type NetworkInstance_SegmentRouting_TePolicy_Counters_OutPktsPathAny struct {
	*ygot.NodePath
}

// InLabeledOctets (leaf): A cumulative counter of the total bytes of incoming labeled
// traffic steered to the SR-TE policy. Labeled traffic carries
// an active SID (top-most SID in the stack) that matches the
// BSID associated to this policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-labeled-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-labeled-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPath) InLabeledOctets() *NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledOctetsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-labeled-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InLabeledOctets (leaf): A cumulative counter of the total bytes of incoming labeled
// traffic steered to the SR-TE policy. Labeled traffic carries
// an active SID (top-most SID in the stack) that matches the
// BSID associated to this policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-labeled-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-labeled-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPathAny) InLabeledOctets() *NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledOctetsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-labeled-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InLabeledPkts (leaf): A cumulative counter of the incoming labeled packets steered
// to the SR-TE policy. Labeled packets carries an active SID
// (top-most SID in the stack) that matches the BSID associated
// to this policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-labeled-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-labeled-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPath) InLabeledPkts() *NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledPktsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-labeled-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InLabeledPkts (leaf): A cumulative counter of the incoming labeled packets steered
// to the SR-TE policy. Labeled packets carries an active SID
// (top-most SID in the stack) that matches the BSID associated
// to this policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-labeled-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-labeled-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPathAny) InLabeledPkts() *NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledPktsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_InLabeledPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-labeled-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The cumulative counter of the total incoming bytes steered
// to the SR-TE policy. It includes both labeled and unlabeled
// steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPath) InOctets() *NetworkInstance_SegmentRouting_TePolicy_Counters_InOctetsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_InOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOctets (leaf): The cumulative counter of the total incoming bytes steered
// to the SR-TE policy. It includes both labeled and unlabeled
// steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPathAny) InOctets() *NetworkInstance_SegmentRouting_TePolicy_Counters_InOctetsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_InOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the incoming packets steered to
// the SR-TE policy. It includes both labeled and unlabeled
// steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPath) InPkts() *NetworkInstance_SegmentRouting_TePolicy_Counters_InPktsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_InPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPkts (leaf): A cumulative counter of the incoming packets steered to
// the SR-TE policy. It includes both labeled and unlabeled
// steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "in-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/in-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPathAny) InPkts() *NetworkInstance_SegmentRouting_TePolicy_Counters_InPktsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_InPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"in-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledOctets (leaf): A cumulative counter of the total bytes of outgoing labeled
// traffic after being steered to the SR-TE policy. Labeled
// traffic carries an active SID (top-most SID in the stack) that
// matches the BSID associated to this policy. The counter should
// include the segments pushed to packets.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-labeled-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPath) OutLabeledOctets() *NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledOctetsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledOctets (leaf): A cumulative counter of the total bytes of outgoing labeled
// traffic after being steered to the SR-TE policy. Labeled
// traffic carries an active SID (top-most SID in the stack) that
// matches the BSID associated to this policy. The counter should
// include the segments pushed to packets.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-labeled-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPathAny) OutLabeledOctets() *NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledOctetsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledPkts (leaf): A cumulative counter of the outgoing labeled packets after
// being steered to the SR-TE policy. Labeled packets carries
// an active SID (top-most SID in the stack) that matches the
// BSID associated to this policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-labeled-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPath) OutLabeledPkts() *NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledPktsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutLabeledPkts (leaf): A cumulative counter of the outgoing labeled packets after
// being steered to the SR-TE policy. Labeled packets carries
// an active SID (top-most SID in the stack) that matches the
// BSID associated to this policy.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-labeled-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-labeled-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPathAny) OutLabeledPkts() *NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledPktsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_OutLabeledPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-labeled-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The cumulative counter of the total outgoing bytes after
// being steered to the SR-TE policy. It includes both labeled
// and unlabeled steered traffic. The counter should include the
// segments pushed to packets.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPath) OutOctets() *NetworkInstance_SegmentRouting_TePolicy_Counters_OutOctetsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_OutOctetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutOctets (leaf): The cumulative counter of the total outgoing bytes after
// being steered to the SR-TE policy. It includes both labeled
// and unlabeled steered traffic. The counter should include the
// segments pushed to packets.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-octets"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-octets"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPathAny) OutOctets() *NetworkInstance_SegmentRouting_TePolicy_Counters_OutOctetsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_OutOctetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-octets"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the outgoing packets after being
// steered to the SR-TE policy. It includes both labeled and
// unlabeled steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPath) OutPkts() *NetworkInstance_SegmentRouting_TePolicy_Counters_OutPktsPath {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_OutPktsPath{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPkts (leaf): A cumulative counter of the outgoing packets after being
// steered to the SR-TE policy. It includes both labeled and
// unlabeled steered traffic.
// ----------------------------------------
// Defining module: "openconfig-srte-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "out-pkts"
// Path from root: "/network-instances/network-instance/segment-routing/te-policies/te-policy/state/counters/out-pkts"
func (n *NetworkInstance_SegmentRouting_TePolicy_CountersPathAny) OutPkts() *NetworkInstance_SegmentRouting_TePolicy_Counters_OutPktsPathAny {
	return &NetworkInstance_SegmentRouting_TePolicy_Counters_OutPktsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"out-pkts"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_TablePath represents the /openconfig-network-instance/network-instances/network-instance/tables/table YANG schema element.
type NetworkInstance_TablePath struct {
	*ygot.NodePath
}

// NetworkInstance_TablePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/tables/table YANG schema element.
type NetworkInstance_TablePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Table_AddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/tables/table/config/address-family YANG schema element.
type NetworkInstance_Table_AddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_Table_AddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/tables/table/config/address-family YANG schema element.
type NetworkInstance_Table_AddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Table_ProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/tables/table/config/protocol YANG schema element.
type NetworkInstance_Table_ProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_Table_ProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/tables/table/config/protocol YANG schema element.
type NetworkInstance_Table_ProtocolPathAny struct {
	*ygot.NodePath
}

// AddressFamily (leaf): The address family (IPv4, IPv6) of the table's entries
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/address-family"
// Path from root: "/network-instances/network-instance/tables/table/config/address-family"
func (n *NetworkInstance_TablePath) AddressFamily() *NetworkInstance_Table_AddressFamilyPath {
	return &NetworkInstance_Table_AddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// AddressFamily (leaf): The address family (IPv4, IPv6) of the table's entries
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/address-family"
// Path from root: "/network-instances/network-instance/tables/table/config/address-family"
func (n *NetworkInstance_TablePathAny) AddressFamily() *NetworkInstance_Table_AddressFamilyPathAny {
	return &NetworkInstance_Table_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): Reference to the protocol that the table is associated with.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protocol"
// Path from root: "/network-instances/network-instance/tables/table/config/protocol"
func (n *NetworkInstance_TablePath) Protocol() *NetworkInstance_Table_ProtocolPath {
	return &NetworkInstance_Table_ProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// Protocol (leaf): Reference to the protocol that the table is associated with.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/protocol"
// Path from root: "/network-instances/network-instance/tables/table/config/protocol"
func (n *NetworkInstance_TablePathAny) Protocol() *NetworkInstance_Table_ProtocolPathAny {
	return &NetworkInstance_Table_ProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_TableConnectionPath represents the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection YANG schema element.
type NetworkInstance_TableConnectionPath struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnectionPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection YANG schema element.
type NetworkInstance_TableConnectionPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_AddressFamilyPath represents the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/address-family YANG schema element.
type NetworkInstance_TableConnection_AddressFamilyPath struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_AddressFamilyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/address-family YANG schema element.
type NetworkInstance_TableConnection_AddressFamilyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_DefaultImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/default-import-policy YANG schema element.
type NetworkInstance_TableConnection_DefaultImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_DefaultImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/default-import-policy YANG schema element.
type NetworkInstance_TableConnection_DefaultImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_DisableMetricPropagationPath represents the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/disable-metric-propagation YANG schema element.
type NetworkInstance_TableConnection_DisableMetricPropagationPath struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_DisableMetricPropagationPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/disable-metric-propagation YANG schema element.
type NetworkInstance_TableConnection_DisableMetricPropagationPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_DstProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/dst-protocol YANG schema element.
type NetworkInstance_TableConnection_DstProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_DstProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/dst-protocol YANG schema element.
type NetworkInstance_TableConnection_DstProtocolPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_ImportPolicyPath represents the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/import-policy YANG schema element.
type NetworkInstance_TableConnection_ImportPolicyPath struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_ImportPolicyPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/import-policy YANG schema element.
type NetworkInstance_TableConnection_ImportPolicyPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_SrcProtocolPath represents the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/src-protocol YANG schema element.
type NetworkInstance_TableConnection_SrcProtocolPath struct {
	*ygot.NodePath
}

// NetworkInstance_TableConnection_SrcProtocolPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/table-connections/table-connection/config/src-protocol YANG schema element.
type NetworkInstance_TableConnection_SrcProtocolPathAny struct {
	*ygot.NodePath
}

// AddressFamily (leaf): The address family associated with the connection. This
// must be defined for the source protocol. The target
// address family is implicitly defined by the address family
// specified for the source protocol.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/address-family"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/address-family"
func (n *NetworkInstance_TableConnectionPath) AddressFamily() *NetworkInstance_TableConnection_AddressFamilyPath {
	return &NetworkInstance_TableConnection_AddressFamilyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// AddressFamily (leaf): The address family associated with the connection. This
// must be defined for the source protocol. The target
// address family is implicitly defined by the address family
// specified for the source protocol.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/address-family"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/address-family"
func (n *NetworkInstance_TableConnectionPathAny) AddressFamily() *NetworkInstance_TableConnection_AddressFamilyPathAny {
	return &NetworkInstance_TableConnection_AddressFamilyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address-family"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/default-import-policy"
func (n *NetworkInstance_TableConnectionPath) DefaultImportPolicy() *NetworkInstance_TableConnection_DefaultImportPolicyPath {
	return &NetworkInstance_TableConnection_DefaultImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefaultImportPolicy (leaf): explicitly set a default policy if no policy definition
// in the import policy chain is satisfied.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/default-import-policy"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/default-import-policy"
func (n *NetworkInstance_TableConnectionPathAny) DefaultImportPolicy() *NetworkInstance_TableConnection_DefaultImportPolicyPathAny {
	return &NetworkInstance_TableConnection_DefaultImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "default-import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisableMetricPropagation (leaf): By default a system may reflect the metric specified in
// the destination protocol according to that which is set in
// the source protocol. For example:
// - IS-IS metric may be reflected in BGP MED (and vice versa)
// - OSPF metric may be reflected in the BGP MED (and vice versa)
// When this leaf is set to true, this reflection behaviour MUST be
// disabled, and rather the metric must be set to the default value,
// or explicitly set by policy.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-metric-propagation"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/disable-metric-propagation"
func (n *NetworkInstance_TableConnectionPath) DisableMetricPropagation() *NetworkInstance_TableConnection_DisableMetricPropagationPath {
	return &NetworkInstance_TableConnection_DisableMetricPropagationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-metric-propagation"},
			map[string]interface{}{},
			n,
		),
	}
}

// DisableMetricPropagation (leaf): By default a system may reflect the metric specified in
// the destination protocol according to that which is set in
// the source protocol. For example:
// - IS-IS metric may be reflected in BGP MED (and vice versa)
// - OSPF metric may be reflected in the BGP MED (and vice versa)
// When this leaf is set to true, this reflection behaviour MUST be
// disabled, and rather the metric must be set to the default value,
// or explicitly set by policy.
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/disable-metric-propagation"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/disable-metric-propagation"
func (n *NetworkInstance_TableConnectionPathAny) DisableMetricPropagation() *NetworkInstance_TableConnection_DisableMetricPropagationPathAny {
	return &NetworkInstance_TableConnection_DisableMetricPropagationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "disable-metric-propagation"},
			map[string]interface{}{},
			n,
		),
	}
}

// DstProtocol (leaf): The destination protocol for the table connection
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dst-protocol"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/dst-protocol"
func (n *NetworkInstance_TableConnectionPath) DstProtocol() *NetworkInstance_TableConnection_DstProtocolPath {
	return &NetworkInstance_TableConnection_DstProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dst-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// DstProtocol (leaf): The destination protocol for the table connection
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/dst-protocol"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/dst-protocol"
func (n *NetworkInstance_TableConnectionPathAny) DstProtocol() *NetworkInstance_TableConnection_DstProtocolPathAny {
	return &NetworkInstance_TableConnection_DstProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "dst-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/import-policy"
func (n *NetworkInstance_TableConnectionPath) ImportPolicy() *NetworkInstance_TableConnection_ImportPolicyPath {
	return &NetworkInstance_TableConnection_ImportPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// ImportPolicy (leaf): list of policy names in sequence to be applied on
// receiving a routing update in the current context, e.g.,
// for the current peer group, neighbor, address family,
// etc.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/import-policy"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/import-policy"
func (n *NetworkInstance_TableConnectionPathAny) ImportPolicy() *NetworkInstance_TableConnection_ImportPolicyPathAny {
	return &NetworkInstance_TableConnection_ImportPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "import-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrcProtocol (leaf): The source protocol for the table connection
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/src-protocol"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/src-protocol"
func (n *NetworkInstance_TableConnectionPath) SrcProtocol() *NetworkInstance_TableConnection_SrcProtocolPath {
	return &NetworkInstance_TableConnection_SrcProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "src-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// SrcProtocol (leaf): The source protocol for the table connection
// ----------------------------------------
// Defining module: "openconfig-network-instance"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/src-protocol"
// Path from root: "/network-instances/network-instance/table-connections/table-connection/config/src-protocol"
func (n *NetworkInstance_TableConnectionPathAny) SrcProtocol() *NetworkInstance_TableConnection_SrcProtocolPathAny {
	return &NetworkInstance_TableConnection_SrcProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "src-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_VlanPath represents the /openconfig-network-instance/network-instances/network-instance/vlans/vlan YANG schema element.
type NetworkInstance_VlanPath struct {
	*ygot.NodePath
}

// NetworkInstance_VlanPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/vlans/vlan YANG schema element.
type NetworkInstance_VlanPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Vlan_NamePath represents the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/config/name YANG schema element.
type NetworkInstance_Vlan_NamePath struct {
	*ygot.NodePath
}

// NetworkInstance_Vlan_NamePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/config/name YANG schema element.
type NetworkInstance_Vlan_NamePathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Vlan_StatusPath represents the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/config/status YANG schema element.
type NetworkInstance_Vlan_StatusPath struct {
	*ygot.NodePath
}

// NetworkInstance_Vlan_StatusPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/config/status YANG schema element.
type NetworkInstance_Vlan_StatusPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Vlan_VlanIdPath represents the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/config/vlan-id YANG schema element.
type NetworkInstance_Vlan_VlanIdPath struct {
	*ygot.NodePath
}

// NetworkInstance_Vlan_VlanIdPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/config/vlan-id YANG schema element.
type NetworkInstance_Vlan_VlanIdPathAny struct {
	*ygot.NodePath
}

// Name (leaf): Interface VLAN name.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/vlans/vlan/config/name"
func (n *NetworkInstance_VlanPath) Name() *NetworkInstance_Vlan_NamePath {
	return &NetworkInstance_Vlan_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Interface VLAN name.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/name"
// Path from root: "/network-instances/network-instance/vlans/vlan/config/name"
func (n *NetworkInstance_VlanPathAny) Name() *NetworkInstance_Vlan_NamePathAny {
	return &NetworkInstance_Vlan_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Status (leaf): Admin state of the VLAN
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/status"
// Path from root: "/network-instances/network-instance/vlans/vlan/config/status"
func (n *NetworkInstance_VlanPath) Status() *NetworkInstance_Vlan_StatusPath {
	return &NetworkInstance_Vlan_StatusPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "status"},
			map[string]interface{}{},
			n,
		),
	}
}

// Status (leaf): Admin state of the VLAN
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/status"
// Path from root: "/network-instances/network-instance/vlans/vlan/config/status"
func (n *NetworkInstance_VlanPathAny) Status() *NetworkInstance_Vlan_StatusPathAny {
	return &NetworkInstance_Vlan_StatusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "status"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): Interface VLAN id.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/vlan-id"
// Path from root: "/network-instances/network-instance/vlans/vlan/config/vlan-id"
func (n *NetworkInstance_VlanPath) VlanId() *NetworkInstance_Vlan_VlanIdPath {
	return &NetworkInstance_Vlan_VlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): Interface VLAN id.
// ----------------------------------------
// Defining module: "openconfig-vlan"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "config/vlan-id"
// Path from root: "/network-instances/network-instance/vlans/vlan/config/vlan-id"
func (n *NetworkInstance_VlanPathAny) VlanId() *NetworkInstance_Vlan_VlanIdPathAny {
	return &NetworkInstance_Vlan_VlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// NetworkInstance_Vlan_MemberPath represents the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/members/member YANG schema element.
type NetworkInstance_Vlan_MemberPath struct {
	*ygot.NodePath
}

// NetworkInstance_Vlan_MemberPathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/members/member YANG schema element.
type NetworkInstance_Vlan_MemberPathAny struct {
	*ygot.NodePath
}

// NetworkInstance_Vlan_Member_InterfacePath represents the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/members/member/state/interface YANG schema element.
type NetworkInstance_Vlan_Member_InterfacePath struct {
	*ygot.NodePath
}

// NetworkInstance_Vlan_Member_InterfacePathAny represents the wildcard version of the /openconfig-network-instance/network-instances/network-instance/vlans/vlan/members/member/state/interface YANG schema element.
type NetworkInstance_Vlan_Member_InterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/vlans/vlan/members/member/state/interface"
func (n *NetworkInstance_Vlan_MemberPath) Interface() *NetworkInstance_Vlan_Member_InterfacePath {
	return &NetworkInstance_Vlan_Member_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-network-instance"
// Path from parent: "state/interface"
// Path from root: "/network-instances/network-instance/vlans/vlan/members/member/state/interface"
func (n *NetworkInstance_Vlan_MemberPathAny) Interface() *NetworkInstance_Vlan_Member_InterfacePathAny {
	return &NetworkInstance_Vlan_Member_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifierPath represents the /openconfig-optical-amplifier/optical-amplifier YANG schema element.
type OpticalAmplifierPath struct {
	*ygot.NodePath
}

// OpticalAmplifierPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier YANG schema element.
type OpticalAmplifierPathAny struct {
	*ygot.NodePath
}

// AmplifierAny (list): List of optical amplifiers present in the device
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "amplifiers/amplifier"
// Path from root: "/optical-amplifier/amplifiers/amplifier"
// Name (wildcarded): string
func (n *OpticalAmplifierPath) AmplifierAny() *OpticalAmplifier_AmplifierPathAny {
	return &OpticalAmplifier_AmplifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"amplifiers", "amplifier"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// AmplifierAny (list): List of optical amplifiers present in the device
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "amplifiers/amplifier"
// Path from root: "/optical-amplifier/amplifiers/amplifier"
// Name (wildcarded): string
func (n *OpticalAmplifierPathAny) AmplifierAny() *OpticalAmplifier_AmplifierPathAny {
	return &OpticalAmplifier_AmplifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"amplifiers", "amplifier"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Amplifier (list): List of optical amplifiers present in the device
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "amplifiers/amplifier"
// Path from root: "/optical-amplifier/amplifiers/amplifier"
// Name: string
func (n *OpticalAmplifierPath) Amplifier(Name string) *OpticalAmplifier_AmplifierPath {
	return &OpticalAmplifier_AmplifierPath{
		NodePath: ygot.NewNodePath(
			[]string{"amplifiers", "amplifier"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Amplifier (list): List of optical amplifiers present in the device
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "amplifiers/amplifier"
// Path from root: "/optical-amplifier/amplifiers/amplifier"
// Name: string
func (n *OpticalAmplifierPathAny) Amplifier(Name string) *OpticalAmplifier_AmplifierPathAny {
	return &OpticalAmplifier_AmplifierPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"amplifiers", "amplifier"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// SupervisoryChannelAny (list): List of supervisory channels
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "supervisory-channels/supervisory-channel"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel"
// Interface (wildcarded): string
func (n *OpticalAmplifierPath) SupervisoryChannelAny() *OpticalAmplifier_SupervisoryChannelPathAny {
	return &OpticalAmplifier_SupervisoryChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"supervisory-channels", "supervisory-channel"},
			map[string]interface{}{"interface": "*"},
			n,
		),
	}
}

// SupervisoryChannelAny (list): List of supervisory channels
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "supervisory-channels/supervisory-channel"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel"
// Interface (wildcarded): string
func (n *OpticalAmplifierPathAny) SupervisoryChannelAny() *OpticalAmplifier_SupervisoryChannelPathAny {
	return &OpticalAmplifier_SupervisoryChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"supervisory-channels", "supervisory-channel"},
			map[string]interface{}{"interface": "*"},
			n,
		),
	}
}

// SupervisoryChannel (list): List of supervisory channels
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "supervisory-channels/supervisory-channel"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel"
// Interface: string
func (n *OpticalAmplifierPath) SupervisoryChannel(Interface string) *OpticalAmplifier_SupervisoryChannelPath {
	return &OpticalAmplifier_SupervisoryChannelPath{
		NodePath: ygot.NewNodePath(
			[]string{"supervisory-channels", "supervisory-channel"},
			map[string]interface{}{"interface": Interface},
			n,
		),
	}
}

// SupervisoryChannel (list): List of supervisory channels
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "supervisory-channels/supervisory-channel"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel"
// Interface: string
func (n *OpticalAmplifierPathAny) SupervisoryChannel(Interface string) *OpticalAmplifier_SupervisoryChannelPathAny {
	return &OpticalAmplifier_SupervisoryChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"supervisory-channels", "supervisory-channel"},
			map[string]interface{}{"interface": Interface},
			n,
		),
	}
}

// OpticalAmplifier_AmplifierPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier YANG schema element.
type OpticalAmplifier_AmplifierPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_AmplifierPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier YANG schema element.
type OpticalAmplifier_AmplifierPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_AmpModePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/amp-mode YANG schema element.
type OpticalAmplifier_Amplifier_AmpModePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_AmpModePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/amp-mode YANG schema element.
type OpticalAmplifier_Amplifier_AmpModePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ComponentPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/component YANG schema element.
type OpticalAmplifier_Amplifier_ComponentPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ComponentPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/component YANG schema element.
type OpticalAmplifier_Amplifier_ComponentPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_EgressPortPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/egress-port YANG schema element.
type OpticalAmplifier_Amplifier_EgressPortPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_EgressPortPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/egress-port YANG schema element.
type OpticalAmplifier_Amplifier_EgressPortPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_EnabledPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/enabled YANG schema element.
type OpticalAmplifier_Amplifier_EnabledPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_EnabledPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/enabled YANG schema element.
type OpticalAmplifier_Amplifier_EnabledPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_FiberTypeProfilePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/fiber-type-profile YANG schema element.
type OpticalAmplifier_Amplifier_FiberTypeProfilePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_FiberTypeProfilePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/fiber-type-profile YANG schema element.
type OpticalAmplifier_Amplifier_FiberTypeProfilePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_GainRangePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/gain-range YANG schema element.
type OpticalAmplifier_Amplifier_GainRangePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_GainRangePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/gain-range YANG schema element.
type OpticalAmplifier_Amplifier_GainRangePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_IngressPortPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/ingress-port YANG schema element.
type OpticalAmplifier_Amplifier_IngressPortPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_IngressPortPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/ingress-port YANG schema element.
type OpticalAmplifier_Amplifier_IngressPortPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_MaxGainPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/max-gain YANG schema element.
type OpticalAmplifier_Amplifier_MaxGainPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_MaxGainPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/max-gain YANG schema element.
type OpticalAmplifier_Amplifier_MaxGainPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_MaxOutputPowerPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/max-output-power YANG schema element.
type OpticalAmplifier_Amplifier_MaxOutputPowerPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_MaxOutputPowerPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/max-output-power YANG schema element.
type OpticalAmplifier_Amplifier_MaxOutputPowerPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_MinGainPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/min-gain YANG schema element.
type OpticalAmplifier_Amplifier_MinGainPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_MinGainPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/min-gain YANG schema element.
type OpticalAmplifier_Amplifier_MinGainPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_NamePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/name YANG schema element.
type OpticalAmplifier_Amplifier_NamePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_NamePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/name YANG schema element.
type OpticalAmplifier_Amplifier_NamePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_TargetGainPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/target-gain YANG schema element.
type OpticalAmplifier_Amplifier_TargetGainPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_TargetGainPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/target-gain YANG schema element.
type OpticalAmplifier_Amplifier_TargetGainPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_TargetGainTiltPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/target-gain-tilt YANG schema element.
type OpticalAmplifier_Amplifier_TargetGainTiltPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_TargetGainTiltPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/target-gain-tilt YANG schema element.
type OpticalAmplifier_Amplifier_TargetGainTiltPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_TargetOutputPowerPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/target-output-power YANG schema element.
type OpticalAmplifier_Amplifier_TargetOutputPowerPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_TargetOutputPowerPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/target-output-power YANG schema element.
type OpticalAmplifier_Amplifier_TargetOutputPowerPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_TypePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/type YANG schema element.
type OpticalAmplifier_Amplifier_TypePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_TypePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/config/type YANG schema element.
type OpticalAmplifier_Amplifier_TypePathAny struct {
	*ygot.NodePath
}

// ActualGain (container): The actual gain applied by the amplifier in units of
// 0.01dB. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/actual-gain"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain"
func (n *OpticalAmplifier_AmplifierPath) ActualGain() *OpticalAmplifier_Amplifier_ActualGainPath {
	return &OpticalAmplifier_Amplifier_ActualGainPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "actual-gain"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActualGain (container): The actual gain applied by the amplifier in units of
// 0.01dB. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/actual-gain"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain"
func (n *OpticalAmplifier_AmplifierPathAny) ActualGain() *OpticalAmplifier_Amplifier_ActualGainPathAny {
	return &OpticalAmplifier_Amplifier_ActualGainPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "actual-gain"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActualGainTilt (container): The actual tilt applied by the amplifier in units of
// 0.01dB. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/actual-gain-tilt"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt"
func (n *OpticalAmplifier_AmplifierPath) ActualGainTilt() *OpticalAmplifier_Amplifier_ActualGainTiltPath {
	return &OpticalAmplifier_Amplifier_ActualGainTiltPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "actual-gain-tilt"},
			map[string]interface{}{},
			n,
		),
	}
}

// ActualGainTilt (container): The actual tilt applied by the amplifier in units of
// 0.01dB. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/actual-gain-tilt"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt"
func (n *OpticalAmplifier_AmplifierPathAny) ActualGainTilt() *OpticalAmplifier_Amplifier_ActualGainTiltPathAny {
	return &OpticalAmplifier_Amplifier_ActualGainTiltPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "actual-gain-tilt"},
			map[string]interface{}{},
			n,
		),
	}
}

// AmpMode (leaf): The operating mode of the amplifier
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/amp-mode"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/amp-mode"
func (n *OpticalAmplifier_AmplifierPath) AmpMode() *OpticalAmplifier_Amplifier_AmpModePath {
	return &OpticalAmplifier_Amplifier_AmpModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "amp-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// AmpMode (leaf): The operating mode of the amplifier
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/amp-mode"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/amp-mode"
func (n *OpticalAmplifier_AmplifierPathAny) AmpMode() *OpticalAmplifier_Amplifier_AmpModePathAny {
	return &OpticalAmplifier_Amplifier_AmpModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "amp-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component (leaf): Reference to the system-supplied physical component that
// the amplifier gain block is contained within. Multiple
// amplifier gain blocks may be contained within the same
// physical component.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/component"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/component"
func (n *OpticalAmplifier_AmplifierPath) Component() *OpticalAmplifier_Amplifier_ComponentPath {
	return &OpticalAmplifier_Amplifier_ComponentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "component"},
			map[string]interface{}{},
			n,
		),
	}
}

// Component (leaf): Reference to the system-supplied physical component that
// the amplifier gain block is contained within. Multiple
// amplifier gain blocks may be contained within the same
// physical component.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/component"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/component"
func (n *OpticalAmplifier_AmplifierPathAny) Component() *OpticalAmplifier_Amplifier_ComponentPathAny {
	return &OpticalAmplifier_Amplifier_ComponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "component"},
			map[string]interface{}{},
			n,
		),
	}
}

// EgressPort (leaf): Reference to system-supplied name of the amplifier egress
// port. This leaf is only valid for ports of type EGRESS.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/egress-port"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/egress-port"
func (n *OpticalAmplifier_AmplifierPath) EgressPort() *OpticalAmplifier_Amplifier_EgressPortPath {
	return &OpticalAmplifier_Amplifier_EgressPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "egress-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// EgressPort (leaf): Reference to system-supplied name of the amplifier egress
// port. This leaf is only valid for ports of type EGRESS.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/egress-port"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/egress-port"
func (n *OpticalAmplifier_AmplifierPathAny) EgressPort() *OpticalAmplifier_Amplifier_EgressPortPathAny {
	return &OpticalAmplifier_Amplifier_EgressPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "egress-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Turns power on / off to the amplifiers gain module.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/enabled"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/enabled"
func (n *OpticalAmplifier_AmplifierPath) Enabled() *OpticalAmplifier_Amplifier_EnabledPath {
	return &OpticalAmplifier_Amplifier_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Turns power on / off to the amplifiers gain module.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/enabled"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/enabled"
func (n *OpticalAmplifier_AmplifierPathAny) Enabled() *OpticalAmplifier_Amplifier_EnabledPathAny {
	return &OpticalAmplifier_Amplifier_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// FiberTypeProfile (leaf): The fiber type profile specifies details about the
// fiber type which are needed to accurately determine
// the gain and perform efficient amplification. This is
// only needed for Raman type amplifiers.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/fiber-type-profile"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/fiber-type-profile"
func (n *OpticalAmplifier_AmplifierPath) FiberTypeProfile() *OpticalAmplifier_Amplifier_FiberTypeProfilePath {
	return &OpticalAmplifier_Amplifier_FiberTypeProfilePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "fiber-type-profile"},
			map[string]interface{}{},
			n,
		),
	}
}

// FiberTypeProfile (leaf): The fiber type profile specifies details about the
// fiber type which are needed to accurately determine
// the gain and perform efficient amplification. This is
// only needed for Raman type amplifiers.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/fiber-type-profile"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/fiber-type-profile"
func (n *OpticalAmplifier_AmplifierPathAny) FiberTypeProfile() *OpticalAmplifier_Amplifier_FiberTypeProfilePathAny {
	return &OpticalAmplifier_Amplifier_FiberTypeProfilePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "fiber-type-profile"},
			map[string]interface{}{},
			n,
		),
	}
}

// GainRange (leaf): Selected gain range.  The gain range is a platform-defined
// value indicating the switched gain amplifier setting
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/gain-range"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/gain-range"
func (n *OpticalAmplifier_AmplifierPath) GainRange() *OpticalAmplifier_Amplifier_GainRangePath {
	return &OpticalAmplifier_Amplifier_GainRangePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "gain-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// GainRange (leaf): Selected gain range.  The gain range is a platform-defined
// value indicating the switched gain amplifier setting
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/gain-range"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/gain-range"
func (n *OpticalAmplifier_AmplifierPathAny) GainRange() *OpticalAmplifier_Amplifier_GainRangePathAny {
	return &OpticalAmplifier_Amplifier_GainRangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "gain-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// IngressPort (leaf): Reference to system-supplied name of the amplifier ingress
// port. This leaf is only valid for ports of type INGRESS.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/ingress-port"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/ingress-port"
func (n *OpticalAmplifier_AmplifierPath) IngressPort() *OpticalAmplifier_Amplifier_IngressPortPath {
	return &OpticalAmplifier_Amplifier_IngressPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ingress-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// IngressPort (leaf): Reference to system-supplied name of the amplifier ingress
// port. This leaf is only valid for ports of type INGRESS.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/ingress-port"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/ingress-port"
func (n *OpticalAmplifier_AmplifierPathAny) IngressPort() *OpticalAmplifier_Amplifier_IngressPortPathAny {
	return &OpticalAmplifier_Amplifier_IngressPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ingress-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPowerCBand (container): The C band (consisting of approximately 191 to 195 THz or
// 1530nm to 1565 nm) input optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/input-power-c-band"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band"
func (n *OpticalAmplifier_AmplifierPath) InputPowerCBand() *OpticalAmplifier_Amplifier_InputPowerCBandPath {
	return &OpticalAmplifier_Amplifier_InputPowerCBandPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power-c-band"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPowerCBand (container): The C band (consisting of approximately 191 to 195 THz or
// 1530nm to 1565 nm) input optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/input-power-c-band"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band"
func (n *OpticalAmplifier_AmplifierPathAny) InputPowerCBand() *OpticalAmplifier_Amplifier_InputPowerCBandPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerCBandPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power-c-band"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPowerLBand (container): The L band (consisting of approximately 184 to 191 THz or
// 1565 to 1625 nm) input optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/input-power-l-band"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band"
func (n *OpticalAmplifier_AmplifierPath) InputPowerLBand() *OpticalAmplifier_Amplifier_InputPowerLBandPath {
	return &OpticalAmplifier_Amplifier_InputPowerLBandPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power-l-band"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPowerLBand (container): The L band (consisting of approximately 184 to 191 THz or
// 1565 to 1625 nm) input optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/input-power-l-band"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band"
func (n *OpticalAmplifier_AmplifierPathAny) InputPowerLBand() *OpticalAmplifier_Amplifier_InputPowerLBandPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerLBandPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power-l-band"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPowerTotal (container): The total input optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/input-power-total"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total"
func (n *OpticalAmplifier_AmplifierPath) InputPowerTotal() *OpticalAmplifier_Amplifier_InputPowerTotalPath {
	return &OpticalAmplifier_Amplifier_InputPowerTotalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power-total"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPowerTotal (container): The total input optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/input-power-total"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total"
func (n *OpticalAmplifier_AmplifierPathAny) InputPowerTotal() *OpticalAmplifier_Amplifier_InputPowerTotalPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerTotalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power-total"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to two decimal precision. If avg/min/max statistics
// are not supported, just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/laser-bias-current"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current"
func (n *OpticalAmplifier_AmplifierPath) LaserBiasCurrent() *OpticalAmplifier_Amplifier_LaserBiasCurrentPath {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to two decimal precision. If avg/min/max statistics
// are not supported, just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/laser-bias-current"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current"
func (n *OpticalAmplifier_AmplifierPathAny) LaserBiasCurrent() *OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxGain (leaf): The maximum allowed gain of the amplifier. This is used
// when the amp-mode is in CONSTANT_POWER or DYNAMIC_GAIN mode
// to prevent the gain from exceeding a desired threshold. If
// left empty, the platform will apply a maximum gain based on
// hardware specifications.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/max-gain"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/max-gain"
func (n *OpticalAmplifier_AmplifierPath) MaxGain() *OpticalAmplifier_Amplifier_MaxGainPath {
	return &OpticalAmplifier_Amplifier_MaxGainPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-gain"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxGain (leaf): The maximum allowed gain of the amplifier. This is used
// when the amp-mode is in CONSTANT_POWER or DYNAMIC_GAIN mode
// to prevent the gain from exceeding a desired threshold. If
// left empty, the platform will apply a maximum gain based on
// hardware specifications.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/max-gain"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/max-gain"
func (n *OpticalAmplifier_AmplifierPathAny) MaxGain() *OpticalAmplifier_Amplifier_MaxGainPathAny {
	return &OpticalAmplifier_Amplifier_MaxGainPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-gain"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxOutputPower (leaf): The maximum optical output power of the amplifier. This
// may be used to prevent the output power from exceeding a
// desired threshold.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/max-output-power"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/max-output-power"
func (n *OpticalAmplifier_AmplifierPath) MaxOutputPower() *OpticalAmplifier_Amplifier_MaxOutputPowerPath {
	return &OpticalAmplifier_Amplifier_MaxOutputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxOutputPower (leaf): The maximum optical output power of the amplifier. This
// may be used to prevent the output power from exceeding a
// desired threshold.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/max-output-power"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/max-output-power"
func (n *OpticalAmplifier_AmplifierPathAny) MaxOutputPower() *OpticalAmplifier_Amplifier_MaxOutputPowerPathAny {
	return &OpticalAmplifier_Amplifier_MaxOutputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinGain (leaf): The minimum allowed gain of the amplifier. This is used
// when the amp-mode is in CONSTANT_POWER or DYNAMIC_GAIN mode
// to prevent the gain from dropping below a desired threshold.
// If left empty, the platform will apply a minimum gain based
// on hardware specifications.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/min-gain"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/min-gain"
func (n *OpticalAmplifier_AmplifierPath) MinGain() *OpticalAmplifier_Amplifier_MinGainPath {
	return &OpticalAmplifier_Amplifier_MinGainPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "min-gain"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinGain (leaf): The minimum allowed gain of the amplifier. This is used
// when the amp-mode is in CONSTANT_POWER or DYNAMIC_GAIN mode
// to prevent the gain from dropping below a desired threshold.
// If left empty, the platform will apply a minimum gain based
// on hardware specifications.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/min-gain"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/min-gain"
func (n *OpticalAmplifier_AmplifierPathAny) MinGain() *OpticalAmplifier_Amplifier_MinGainPathAny {
	return &OpticalAmplifier_Amplifier_MinGainPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "min-gain"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): User-defined name assigned to identify a specific amplifier
// in the device
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/name"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/name"
func (n *OpticalAmplifier_AmplifierPath) Name() *OpticalAmplifier_Amplifier_NamePath {
	return &OpticalAmplifier_Amplifier_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): User-defined name assigned to identify a specific amplifier
// in the device
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/name"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/name"
func (n *OpticalAmplifier_AmplifierPathAny) Name() *OpticalAmplifier_Amplifier_NamePathAny {
	return &OpticalAmplifier_Amplifier_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalReturnLoss (container): The optical return loss (ORL) is the ratio of the light
// reflected back into the port to the light launched out of
// the port. ORL is in units of 0.01dBm. If avg/min/max
// statistics are not supported, just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/optical-return-loss"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss"
func (n *OpticalAmplifier_AmplifierPath) OpticalReturnLoss() *OpticalAmplifier_Amplifier_OpticalReturnLossPath {
	return &OpticalAmplifier_Amplifier_OpticalReturnLossPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-return-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalReturnLoss (container): The optical return loss (ORL) is the ratio of the light
// reflected back into the port to the light launched out of
// the port. ORL is in units of 0.01dBm. If avg/min/max
// statistics are not supported, just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/optical-return-loss"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss"
func (n *OpticalAmplifier_AmplifierPathAny) OpticalReturnLoss() *OpticalAmplifier_Amplifier_OpticalReturnLossPathAny {
	return &OpticalAmplifier_Amplifier_OpticalReturnLossPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "optical-return-loss"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPowerCBand (container): The C band (consisting of approximately 191 to 195 THz or
// 1530nm to 1565 nm)output optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-power-c-band"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band"
func (n *OpticalAmplifier_AmplifierPath) OutputPowerCBand() *OpticalAmplifier_Amplifier_OutputPowerCBandPath {
	return &OpticalAmplifier_Amplifier_OutputPowerCBandPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power-c-band"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPowerCBand (container): The C band (consisting of approximately 191 to 195 THz or
// 1530nm to 1565 nm)output optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-power-c-band"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band"
func (n *OpticalAmplifier_AmplifierPathAny) OutputPowerCBand() *OpticalAmplifier_Amplifier_OutputPowerCBandPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerCBandPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power-c-band"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPowerLBand (container): The L band (consisting of approximately 184 to 191 THz or
// 1565 to 1625 nm)output optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-power-l-band"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band"
func (n *OpticalAmplifier_AmplifierPath) OutputPowerLBand() *OpticalAmplifier_Amplifier_OutputPowerLBandPath {
	return &OpticalAmplifier_Amplifier_OutputPowerLBandPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power-l-band"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPowerLBand (container): The L band (consisting of approximately 184 to 191 THz or
// 1565 to 1625 nm)output optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-power-l-band"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band"
func (n *OpticalAmplifier_AmplifierPathAny) OutputPowerLBand() *OpticalAmplifier_Amplifier_OutputPowerLBandPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerLBandPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power-l-band"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPowerTotal (container): The total output optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-power-total"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total"
func (n *OpticalAmplifier_AmplifierPath) OutputPowerTotal() *OpticalAmplifier_Amplifier_OutputPowerTotalPath {
	return &OpticalAmplifier_Amplifier_OutputPowerTotalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power-total"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPowerTotal (container): The total output optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-power-total"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total"
func (n *OpticalAmplifier_AmplifierPathAny) OutputPowerTotal() *OpticalAmplifier_Amplifier_OutputPowerTotalPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerTotalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power-total"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetGain (leaf): Positive gain applied by the amplifier. This is used
// when the amp-mode is in CONSTANT_GAIN or DYNAMIC_GAIN
// mode to set the target gain that the amplifier should
// achieve.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/target-gain"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/target-gain"
func (n *OpticalAmplifier_AmplifierPath) TargetGain() *OpticalAmplifier_Amplifier_TargetGainPath {
	return &OpticalAmplifier_Amplifier_TargetGainPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-gain"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetGain (leaf): Positive gain applied by the amplifier. This is used
// when the amp-mode is in CONSTANT_GAIN or DYNAMIC_GAIN
// mode to set the target gain that the amplifier should
// achieve.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/target-gain"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/target-gain"
func (n *OpticalAmplifier_AmplifierPathAny) TargetGain() *OpticalAmplifier_Amplifier_TargetGainPathAny {
	return &OpticalAmplifier_Amplifier_TargetGainPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-gain"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetGainTilt (leaf): Gain tilt control
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/target-gain-tilt"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/target-gain-tilt"
func (n *OpticalAmplifier_AmplifierPath) TargetGainTilt() *OpticalAmplifier_Amplifier_TargetGainTiltPath {
	return &OpticalAmplifier_Amplifier_TargetGainTiltPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-gain-tilt"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetGainTilt (leaf): Gain tilt control
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/target-gain-tilt"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/target-gain-tilt"
func (n *OpticalAmplifier_AmplifierPathAny) TargetGainTilt() *OpticalAmplifier_Amplifier_TargetGainTiltPathAny {
	return &OpticalAmplifier_Amplifier_TargetGainTiltPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-gain-tilt"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetOutputPower (leaf): Output optical power of the amplifier.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/target-output-power"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/target-output-power"
func (n *OpticalAmplifier_AmplifierPath) TargetOutputPower() *OpticalAmplifier_Amplifier_TargetOutputPowerPath {
	return &OpticalAmplifier_Amplifier_TargetOutputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// TargetOutputPower (leaf): Output optical power of the amplifier.
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/target-output-power"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/target-output-power"
func (n *OpticalAmplifier_AmplifierPathAny) TargetOutputPower() *OpticalAmplifier_Amplifier_TargetOutputPowerPathAny {
	return &OpticalAmplifier_Amplifier_TargetOutputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "target-output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Type of the amplifier
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/type"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/type"
func (n *OpticalAmplifier_AmplifierPath) Type() *OpticalAmplifier_Amplifier_TypePath {
	return &OpticalAmplifier_Amplifier_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): Type of the amplifier
// ----------------------------------------
// Defining module: "openconfig-optical-amplifier"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/type"
// Path from root: "/optical-amplifier/amplifiers/amplifier/config/type"
func (n *OpticalAmplifier_AmplifierPathAny) Type() *OpticalAmplifier_Amplifier_TypePathAny {
	return &OpticalAmplifier_Amplifier_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_ActualGainPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/avg YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/avg YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/instant YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/instant YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/interval YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/interval YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/max YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/max YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/max-time YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/max-time YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/min YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/min YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/min-time YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGain_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain/min-time YANG schema element.
type OpticalAmplifier_Amplifier_ActualGain_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/avg"
func (n *OpticalAmplifier_Amplifier_ActualGainPath) Avg() *OpticalAmplifier_Amplifier_ActualGain_AvgPath {
	return &OpticalAmplifier_Amplifier_ActualGain_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/avg"
func (n *OpticalAmplifier_Amplifier_ActualGainPathAny) Avg() *OpticalAmplifier_Amplifier_ActualGain_AvgPathAny {
	return &OpticalAmplifier_Amplifier_ActualGain_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/instant"
func (n *OpticalAmplifier_Amplifier_ActualGainPath) Instant() *OpticalAmplifier_Amplifier_ActualGain_InstantPath {
	return &OpticalAmplifier_Amplifier_ActualGain_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/instant"
func (n *OpticalAmplifier_Amplifier_ActualGainPathAny) Instant() *OpticalAmplifier_Amplifier_ActualGain_InstantPathAny {
	return &OpticalAmplifier_Amplifier_ActualGain_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/interval"
func (n *OpticalAmplifier_Amplifier_ActualGainPath) Interval() *OpticalAmplifier_Amplifier_ActualGain_IntervalPath {
	return &OpticalAmplifier_Amplifier_ActualGain_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/interval"
func (n *OpticalAmplifier_Amplifier_ActualGainPathAny) Interval() *OpticalAmplifier_Amplifier_ActualGain_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_ActualGain_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/max"
func (n *OpticalAmplifier_Amplifier_ActualGainPath) Max() *OpticalAmplifier_Amplifier_ActualGain_MaxPath {
	return &OpticalAmplifier_Amplifier_ActualGain_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/max"
func (n *OpticalAmplifier_Amplifier_ActualGainPathAny) Max() *OpticalAmplifier_Amplifier_ActualGain_MaxPathAny {
	return &OpticalAmplifier_Amplifier_ActualGain_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/max-time"
func (n *OpticalAmplifier_Amplifier_ActualGainPath) MaxTime() *OpticalAmplifier_Amplifier_ActualGain_MaxTimePath {
	return &OpticalAmplifier_Amplifier_ActualGain_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/max-time"
func (n *OpticalAmplifier_Amplifier_ActualGainPathAny) MaxTime() *OpticalAmplifier_Amplifier_ActualGain_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_ActualGain_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/min"
func (n *OpticalAmplifier_Amplifier_ActualGainPath) Min() *OpticalAmplifier_Amplifier_ActualGain_MinPath {
	return &OpticalAmplifier_Amplifier_ActualGain_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/min"
func (n *OpticalAmplifier_Amplifier_ActualGainPathAny) Min() *OpticalAmplifier_Amplifier_ActualGain_MinPathAny {
	return &OpticalAmplifier_Amplifier_ActualGain_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/min-time"
func (n *OpticalAmplifier_Amplifier_ActualGainPath) MinTime() *OpticalAmplifier_Amplifier_ActualGain_MinTimePath {
	return &OpticalAmplifier_Amplifier_ActualGain_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain/min-time"
func (n *OpticalAmplifier_Amplifier_ActualGainPathAny) MinTime() *OpticalAmplifier_Amplifier_ActualGain_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_ActualGain_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_ActualGainTiltPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTiltPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTiltPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTiltPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/avg YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/avg YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/instant YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/instant YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/interval YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/interval YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/max YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/max YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/max-time YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/max-time YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/min YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/min YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/min-time YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_ActualGainTilt_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/min-time YANG schema element.
type OpticalAmplifier_Amplifier_ActualGainTilt_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/avg"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPath) Avg() *OpticalAmplifier_Amplifier_ActualGainTilt_AvgPath {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/avg"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPathAny) Avg() *OpticalAmplifier_Amplifier_ActualGainTilt_AvgPathAny {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/instant"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPath) Instant() *OpticalAmplifier_Amplifier_ActualGainTilt_InstantPath {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/instant"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPathAny) Instant() *OpticalAmplifier_Amplifier_ActualGainTilt_InstantPathAny {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/interval"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPath) Interval() *OpticalAmplifier_Amplifier_ActualGainTilt_IntervalPath {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/interval"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPathAny) Interval() *OpticalAmplifier_Amplifier_ActualGainTilt_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/max"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPath) Max() *OpticalAmplifier_Amplifier_ActualGainTilt_MaxPath {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/max"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPathAny) Max() *OpticalAmplifier_Amplifier_ActualGainTilt_MaxPathAny {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/max-time"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPath) MaxTime() *OpticalAmplifier_Amplifier_ActualGainTilt_MaxTimePath {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/max-time"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPathAny) MaxTime() *OpticalAmplifier_Amplifier_ActualGainTilt_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/min"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPath) Min() *OpticalAmplifier_Amplifier_ActualGainTilt_MinPath {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/min"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPathAny) Min() *OpticalAmplifier_Amplifier_ActualGainTilt_MinPathAny {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/min-time"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPath) MinTime() *OpticalAmplifier_Amplifier_ActualGainTilt_MinTimePath {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/actual-gain-tilt/min-time"
func (n *OpticalAmplifier_Amplifier_ActualGainTiltPathAny) MinTime() *OpticalAmplifier_Amplifier_ActualGainTilt_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_ActualGainTilt_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_InputPowerCBandPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBandPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBandPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBandPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/avg YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/avg YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/instant YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/instant YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/interval YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/interval YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/max YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/max YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/max-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/max-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/min YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/min YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/min-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerCBand_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/min-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerCBand_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/avg"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPath) Avg() *OpticalAmplifier_Amplifier_InputPowerCBand_AvgPath {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/avg"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPathAny) Avg() *OpticalAmplifier_Amplifier_InputPowerCBand_AvgPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/instant"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPath) Instant() *OpticalAmplifier_Amplifier_InputPowerCBand_InstantPath {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/instant"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPathAny) Instant() *OpticalAmplifier_Amplifier_InputPowerCBand_InstantPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/interval"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPath) Interval() *OpticalAmplifier_Amplifier_InputPowerCBand_IntervalPath {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/interval"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPathAny) Interval() *OpticalAmplifier_Amplifier_InputPowerCBand_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/max"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPath) Max() *OpticalAmplifier_Amplifier_InputPowerCBand_MaxPath {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/max"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPathAny) Max() *OpticalAmplifier_Amplifier_InputPowerCBand_MaxPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/max-time"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPath) MaxTime() *OpticalAmplifier_Amplifier_InputPowerCBand_MaxTimePath {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/max-time"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPathAny) MaxTime() *OpticalAmplifier_Amplifier_InputPowerCBand_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/min"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPath) Min() *OpticalAmplifier_Amplifier_InputPowerCBand_MinPath {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/min"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPathAny) Min() *OpticalAmplifier_Amplifier_InputPowerCBand_MinPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/min-time"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPath) MinTime() *OpticalAmplifier_Amplifier_InputPowerCBand_MinTimePath {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-c-band/min-time"
func (n *OpticalAmplifier_Amplifier_InputPowerCBandPathAny) MinTime() *OpticalAmplifier_Amplifier_InputPowerCBand_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_InputPowerCBand_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_InputPowerLBandPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBandPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBandPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBandPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/avg YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/avg YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/instant YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/instant YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/interval YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/interval YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/max YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/max YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/max-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/max-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/min YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/min YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/min-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerLBand_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/min-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerLBand_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/avg"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPath) Avg() *OpticalAmplifier_Amplifier_InputPowerLBand_AvgPath {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/avg"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPathAny) Avg() *OpticalAmplifier_Amplifier_InputPowerLBand_AvgPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/instant"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPath) Instant() *OpticalAmplifier_Amplifier_InputPowerLBand_InstantPath {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/instant"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPathAny) Instant() *OpticalAmplifier_Amplifier_InputPowerLBand_InstantPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/interval"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPath) Interval() *OpticalAmplifier_Amplifier_InputPowerLBand_IntervalPath {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/interval"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPathAny) Interval() *OpticalAmplifier_Amplifier_InputPowerLBand_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/max"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPath) Max() *OpticalAmplifier_Amplifier_InputPowerLBand_MaxPath {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/max"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPathAny) Max() *OpticalAmplifier_Amplifier_InputPowerLBand_MaxPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/max-time"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPath) MaxTime() *OpticalAmplifier_Amplifier_InputPowerLBand_MaxTimePath {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/max-time"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPathAny) MaxTime() *OpticalAmplifier_Amplifier_InputPowerLBand_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/min"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPath) Min() *OpticalAmplifier_Amplifier_InputPowerLBand_MinPath {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/min"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPathAny) Min() *OpticalAmplifier_Amplifier_InputPowerLBand_MinPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/min-time"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPath) MinTime() *OpticalAmplifier_Amplifier_InputPowerLBand_MinTimePath {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-l-band/min-time"
func (n *OpticalAmplifier_Amplifier_InputPowerLBandPathAny) MinTime() *OpticalAmplifier_Amplifier_InputPowerLBand_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_InputPowerLBand_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_InputPowerTotalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/avg YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/avg YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/instant YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/instant YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/interval YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/interval YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/max YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/max YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/max-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/max-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/min YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/min YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/min-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_InputPowerTotal_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/input-power-total/min-time YANG schema element.
type OpticalAmplifier_Amplifier_InputPowerTotal_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/avg"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPath) Avg() *OpticalAmplifier_Amplifier_InputPowerTotal_AvgPath {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/avg"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPathAny) Avg() *OpticalAmplifier_Amplifier_InputPowerTotal_AvgPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/instant"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPath) Instant() *OpticalAmplifier_Amplifier_InputPowerTotal_InstantPath {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/instant"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPathAny) Instant() *OpticalAmplifier_Amplifier_InputPowerTotal_InstantPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/interval"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPath) Interval() *OpticalAmplifier_Amplifier_InputPowerTotal_IntervalPath {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/interval"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPathAny) Interval() *OpticalAmplifier_Amplifier_InputPowerTotal_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/max"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPath) Max() *OpticalAmplifier_Amplifier_InputPowerTotal_MaxPath {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/max"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPathAny) Max() *OpticalAmplifier_Amplifier_InputPowerTotal_MaxPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/max-time"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPath) MaxTime() *OpticalAmplifier_Amplifier_InputPowerTotal_MaxTimePath {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/max-time"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPathAny) MaxTime() *OpticalAmplifier_Amplifier_InputPowerTotal_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/min"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPath) Min() *OpticalAmplifier_Amplifier_InputPowerTotal_MinPath {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/min"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPathAny) Min() *OpticalAmplifier_Amplifier_InputPowerTotal_MinPathAny {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/min-time"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPath) MinTime() *OpticalAmplifier_Amplifier_InputPowerTotal_MinTimePath {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/input-power-total/min-time"
func (n *OpticalAmplifier_Amplifier_InputPowerTotalPathAny) MinTime() *OpticalAmplifier_Amplifier_InputPowerTotal_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_InputPowerTotal_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_LaserBiasCurrentPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrentPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/avg YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/avg YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/instant YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/instant YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/interval YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/interval YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/max YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/max YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/max-time YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/max-time YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/min YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/min YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/min-time YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_LaserBiasCurrent_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/min-time YANG schema element.
type OpticalAmplifier_Amplifier_LaserBiasCurrent_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/avg"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPath) Avg() *OpticalAmplifier_Amplifier_LaserBiasCurrent_AvgPath {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/avg"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny) Avg() *OpticalAmplifier_Amplifier_LaserBiasCurrent_AvgPathAny {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/instant"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPath) Instant() *OpticalAmplifier_Amplifier_LaserBiasCurrent_InstantPath {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/instant"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny) Instant() *OpticalAmplifier_Amplifier_LaserBiasCurrent_InstantPathAny {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/interval"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPath) Interval() *OpticalAmplifier_Amplifier_LaserBiasCurrent_IntervalPath {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/interval"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny) Interval() *OpticalAmplifier_Amplifier_LaserBiasCurrent_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/max"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPath) Max() *OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxPath {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/max"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny) Max() *OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxPathAny {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/max-time"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPath) MaxTime() *OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxTimePath {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/max-time"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny) MaxTime() *OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/min"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPath) Min() *OpticalAmplifier_Amplifier_LaserBiasCurrent_MinPath {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/min"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny) Min() *OpticalAmplifier_Amplifier_LaserBiasCurrent_MinPathAny {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/min-time"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPath) MinTime() *OpticalAmplifier_Amplifier_LaserBiasCurrent_MinTimePath {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/laser-bias-current/min-time"
func (n *OpticalAmplifier_Amplifier_LaserBiasCurrentPathAny) MinTime() *OpticalAmplifier_Amplifier_LaserBiasCurrent_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_LaserBiasCurrent_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_OpticalReturnLossPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLossPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLossPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLossPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/avg YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/avg YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/instant YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/instant YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/interval YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/interval YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/max YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/max YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/max-time YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/max-time YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/min YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/min YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/min-time YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OpticalReturnLoss_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/min-time YANG schema element.
type OpticalAmplifier_Amplifier_OpticalReturnLoss_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/avg"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPath) Avg() *OpticalAmplifier_Amplifier_OpticalReturnLoss_AvgPath {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/avg"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPathAny) Avg() *OpticalAmplifier_Amplifier_OpticalReturnLoss_AvgPathAny {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/instant"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPath) Instant() *OpticalAmplifier_Amplifier_OpticalReturnLoss_InstantPath {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/instant"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPathAny) Instant() *OpticalAmplifier_Amplifier_OpticalReturnLoss_InstantPathAny {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/interval"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPath) Interval() *OpticalAmplifier_Amplifier_OpticalReturnLoss_IntervalPath {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/interval"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPathAny) Interval() *OpticalAmplifier_Amplifier_OpticalReturnLoss_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/max"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPath) Max() *OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxPath {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/max"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPathAny) Max() *OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxPathAny {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/max-time"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPath) MaxTime() *OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxTimePath {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/max-time"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPathAny) MaxTime() *OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/min"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPath) Min() *OpticalAmplifier_Amplifier_OpticalReturnLoss_MinPath {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/min"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPathAny) Min() *OpticalAmplifier_Amplifier_OpticalReturnLoss_MinPathAny {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/min-time"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPath) MinTime() *OpticalAmplifier_Amplifier_OpticalReturnLoss_MinTimePath {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/optical-return-loss/min-time"
func (n *OpticalAmplifier_Amplifier_OpticalReturnLossPathAny) MinTime() *OpticalAmplifier_Amplifier_OpticalReturnLoss_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_OpticalReturnLoss_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_OutputPowerCBandPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBandPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBandPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBandPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/avg YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/avg YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/instant YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/instant YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/interval YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/interval YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/max YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/max YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/max-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/max-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/min YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/min YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/min-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerCBand_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/min-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerCBand_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/avg"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPath) Avg() *OpticalAmplifier_Amplifier_OutputPowerCBand_AvgPath {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/avg"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPathAny) Avg() *OpticalAmplifier_Amplifier_OutputPowerCBand_AvgPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/instant"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPath) Instant() *OpticalAmplifier_Amplifier_OutputPowerCBand_InstantPath {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/instant"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPathAny) Instant() *OpticalAmplifier_Amplifier_OutputPowerCBand_InstantPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/interval"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPath) Interval() *OpticalAmplifier_Amplifier_OutputPowerCBand_IntervalPath {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/interval"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPathAny) Interval() *OpticalAmplifier_Amplifier_OutputPowerCBand_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/max"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPath) Max() *OpticalAmplifier_Amplifier_OutputPowerCBand_MaxPath {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/max"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPathAny) Max() *OpticalAmplifier_Amplifier_OutputPowerCBand_MaxPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/max-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPath) MaxTime() *OpticalAmplifier_Amplifier_OutputPowerCBand_MaxTimePath {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/max-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPathAny) MaxTime() *OpticalAmplifier_Amplifier_OutputPowerCBand_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/min"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPath) Min() *OpticalAmplifier_Amplifier_OutputPowerCBand_MinPath {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/min"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPathAny) Min() *OpticalAmplifier_Amplifier_OutputPowerCBand_MinPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/min-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPath) MinTime() *OpticalAmplifier_Amplifier_OutputPowerCBand_MinTimePath {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-c-band/min-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerCBandPathAny) MinTime() *OpticalAmplifier_Amplifier_OutputPowerCBand_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerCBand_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_OutputPowerLBandPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBandPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBandPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBandPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/avg YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/avg YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/instant YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/instant YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/interval YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/interval YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/max YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/max YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/max-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/max-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/min YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/min YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/min-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerLBand_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/min-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerLBand_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/avg"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPath) Avg() *OpticalAmplifier_Amplifier_OutputPowerLBand_AvgPath {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/avg"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPathAny) Avg() *OpticalAmplifier_Amplifier_OutputPowerLBand_AvgPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/instant"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPath) Instant() *OpticalAmplifier_Amplifier_OutputPowerLBand_InstantPath {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/instant"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPathAny) Instant() *OpticalAmplifier_Amplifier_OutputPowerLBand_InstantPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/interval"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPath) Interval() *OpticalAmplifier_Amplifier_OutputPowerLBand_IntervalPath {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/interval"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPathAny) Interval() *OpticalAmplifier_Amplifier_OutputPowerLBand_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/max"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPath) Max() *OpticalAmplifier_Amplifier_OutputPowerLBand_MaxPath {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/max"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPathAny) Max() *OpticalAmplifier_Amplifier_OutputPowerLBand_MaxPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/max-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPath) MaxTime() *OpticalAmplifier_Amplifier_OutputPowerLBand_MaxTimePath {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/max-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPathAny) MaxTime() *OpticalAmplifier_Amplifier_OutputPowerLBand_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/min"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPath) Min() *OpticalAmplifier_Amplifier_OutputPowerLBand_MinPath {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/min"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPathAny) Min() *OpticalAmplifier_Amplifier_OutputPowerLBand_MinPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/min-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPath) MinTime() *OpticalAmplifier_Amplifier_OutputPowerLBand_MinTimePath {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-l-band/min-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerLBandPathAny) MinTime() *OpticalAmplifier_Amplifier_OutputPowerLBand_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerLBand_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_Amplifier_OutputPowerTotalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/avg YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/avg YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/instant YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/instant YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/interval YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/interval YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/max YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/max YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/max-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/max-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/min YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/min YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/min-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_Amplifier_OutputPowerTotal_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/amplifiers/amplifier/state/output-power-total/min-time YANG schema element.
type OpticalAmplifier_Amplifier_OutputPowerTotal_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/avg"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPath) Avg() *OpticalAmplifier_Amplifier_OutputPowerTotal_AvgPath {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/avg"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPathAny) Avg() *OpticalAmplifier_Amplifier_OutputPowerTotal_AvgPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/instant"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPath) Instant() *OpticalAmplifier_Amplifier_OutputPowerTotal_InstantPath {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/instant"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPathAny) Instant() *OpticalAmplifier_Amplifier_OutputPowerTotal_InstantPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/interval"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPath) Interval() *OpticalAmplifier_Amplifier_OutputPowerTotal_IntervalPath {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/interval"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPathAny) Interval() *OpticalAmplifier_Amplifier_OutputPowerTotal_IntervalPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/max"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPath) Max() *OpticalAmplifier_Amplifier_OutputPowerTotal_MaxPath {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/max"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPathAny) Max() *OpticalAmplifier_Amplifier_OutputPowerTotal_MaxPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/max-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPath) MaxTime() *OpticalAmplifier_Amplifier_OutputPowerTotal_MaxTimePath {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/max-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPathAny) MaxTime() *OpticalAmplifier_Amplifier_OutputPowerTotal_MaxTimePathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/min"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPath) Min() *OpticalAmplifier_Amplifier_OutputPowerTotal_MinPath {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/min"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPathAny) Min() *OpticalAmplifier_Amplifier_OutputPowerTotal_MinPathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/min-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPath) MinTime() *OpticalAmplifier_Amplifier_OutputPowerTotal_MinTimePath {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/amplifiers/amplifier/state/output-power-total/min-time"
func (n *OpticalAmplifier_Amplifier_OutputPowerTotalPathAny) MinTime() *OpticalAmplifier_Amplifier_OutputPowerTotal_MinTimePathAny {
	return &OpticalAmplifier_Amplifier_OutputPowerTotal_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_SupervisoryChannelPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel YANG schema element.
type OpticalAmplifier_SupervisoryChannelPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannelPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel YANG schema element.
type OpticalAmplifier_SupervisoryChannelPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InterfacePath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/config/interface YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InterfacePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InterfacePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/config/interface YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InterfacePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputFrequencyPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-frequency YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputFrequencyPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputFrequencyPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-frequency YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputFrequencyPathAny struct {
	*ygot.NodePath
}

// InputPower (container): The input optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// the target is expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/input-power"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power"
func (n *OpticalAmplifier_SupervisoryChannelPath) InputPower() *OpticalAmplifier_SupervisoryChannel_InputPowerPath {
	return &OpticalAmplifier_SupervisoryChannel_InputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// InputPower (container): The input optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// the target is expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/input-power"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power"
func (n *OpticalAmplifier_SupervisoryChannelPathAny) InputPower() *OpticalAmplifier_SupervisoryChannel_InputPowerPathAny {
	return &OpticalAmplifier_SupervisoryChannel_InputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "input-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to an OSC interface
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/interface"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/config/interface"
func (n *OpticalAmplifier_SupervisoryChannelPath) Interface() *OpticalAmplifier_SupervisoryChannel_InterfacePath {
	return &OpticalAmplifier_SupervisoryChannel_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to an OSC interface
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "config/interface"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/config/interface"
func (n *OpticalAmplifier_SupervisoryChannelPathAny) Interface() *OpticalAmplifier_SupervisoryChannel_InterfacePathAny {
	return &OpticalAmplifier_SupervisoryChannel_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to one decimal precision. If avg/min/max statistics
// are not supported, the target is expected to just supply
// the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/laser-bias-current"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current"
func (n *OpticalAmplifier_SupervisoryChannelPath) LaserBiasCurrent() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// LaserBiasCurrent (container): The current applied by the system to the transmit laser to
// achieve the output power. The current is expressed in mA
// with up to one decimal precision. If avg/min/max statistics
// are not supported, the target is expected to just supply
// the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/laser-bias-current"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current"
func (n *OpticalAmplifier_SupervisoryChannelPathAny) LaserBiasCurrent() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "laser-bias-current"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputFrequency (leaf): The frequency in MHz of the individual physical channel
// (e.g. ITU C50 - 195.0THz and would be reported as
// 195,000,000 MHz in this model). This attribute is not
// configurable on most client ports.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-frequency"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-frequency"
func (n *OpticalAmplifier_SupervisoryChannelPath) OutputFrequency() *OpticalAmplifier_SupervisoryChannel_OutputFrequencyPath {
	return &OpticalAmplifier_SupervisoryChannel_OutputFrequencyPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-frequency"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputFrequency (leaf): The frequency in MHz of the individual physical channel
// (e.g. ITU C50 - 195.0THz and would be reported as
// 195,000,000 MHz in this model). This attribute is not
// configurable on most client ports.
// ----------------------------------------
// Defining module: "openconfig-platform-transceiver"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-frequency"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-frequency"
func (n *OpticalAmplifier_SupervisoryChannelPathAny) OutputFrequency() *OpticalAmplifier_SupervisoryChannel_OutputFrequencyPathAny {
	return &OpticalAmplifier_SupervisoryChannel_OutputFrequencyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-frequency"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): The output optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// the target is expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-power"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power"
func (n *OpticalAmplifier_SupervisoryChannelPath) OutputPower() *OpticalAmplifier_SupervisoryChannel_OutputPowerPath {
	return &OpticalAmplifier_SupervisoryChannel_OutputPowerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutputPower (container): The output optical power of this port in units
// of 0.01dBm. If avg/min/max statistics are not supported,
// the target is expected to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-transport-line-common"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "state/output-power"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power"
func (n *OpticalAmplifier_SupervisoryChannelPathAny) OutputPower() *OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny {
	return &OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "output-power"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_SupervisoryChannel_InputPowerPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPowerPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPowerPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPowerPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/avg YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/avg YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/instant YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/instant YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/interval YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/interval YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/max YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/max YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/max-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/max-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/min YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/min YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/min-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_InputPower_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/min-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_InputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/avg"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPath) Avg() *OpticalAmplifier_SupervisoryChannel_InputPower_AvgPath {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/avg"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPathAny) Avg() *OpticalAmplifier_SupervisoryChannel_InputPower_AvgPathAny {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/instant"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPath) Instant() *OpticalAmplifier_SupervisoryChannel_InputPower_InstantPath {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/instant"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPathAny) Instant() *OpticalAmplifier_SupervisoryChannel_InputPower_InstantPathAny {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/interval"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPath) Interval() *OpticalAmplifier_SupervisoryChannel_InputPower_IntervalPath {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/interval"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPathAny) Interval() *OpticalAmplifier_SupervisoryChannel_InputPower_IntervalPathAny {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/max"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPath) Max() *OpticalAmplifier_SupervisoryChannel_InputPower_MaxPath {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/max"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPathAny) Max() *OpticalAmplifier_SupervisoryChannel_InputPower_MaxPathAny {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/max-time"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPath) MaxTime() *OpticalAmplifier_SupervisoryChannel_InputPower_MaxTimePath {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/max-time"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPathAny) MaxTime() *OpticalAmplifier_SupervisoryChannel_InputPower_MaxTimePathAny {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/min"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPath) Min() *OpticalAmplifier_SupervisoryChannel_InputPower_MinPath {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/min"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPathAny) Min() *OpticalAmplifier_SupervisoryChannel_InputPower_MinPathAny {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/min-time"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPath) MinTime() *OpticalAmplifier_SupervisoryChannel_InputPower_MinTimePath {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/input-power/min-time"
func (n *OpticalAmplifier_SupervisoryChannel_InputPowerPathAny) MinTime() *OpticalAmplifier_SupervisoryChannel_InputPower_MinTimePathAny {
	return &OpticalAmplifier_SupervisoryChannel_InputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/avg YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/avg YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/instant YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/instant YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/interval YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/interval YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/max YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/max YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/max-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/max-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/min YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/min YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/min-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/min-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/avg"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath) Avg() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_AvgPath {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/avg"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny) Avg() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_AvgPathAny {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/instant"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath) Instant() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_InstantPath {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/instant"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny) Instant() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_InstantPathAny {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/interval"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath) Interval() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_IntervalPath {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/interval"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny) Interval() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_IntervalPathAny {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/max"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath) Max() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxPath {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/max"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny) Max() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxPathAny {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/max-time"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath) MaxTime() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxTimePath {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/max-time"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny) MaxTime() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxTimePathAny {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/min"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath) Min() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinPath {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/min"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny) Min() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinPathAny {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/min-time"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPath) MinTime() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinTimePath {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/laser-bias-current/min-time"
func (n *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrentPathAny) MinTime() *OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinTimePathAny {
	return &OpticalAmplifier_SupervisoryChannel_LaserBiasCurrent_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalAmplifier_SupervisoryChannel_OutputPowerPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPowerPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_AvgPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/avg YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_AvgPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_AvgPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/avg YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_AvgPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_InstantPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/instant YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_InstantPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_InstantPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/instant YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_InstantPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_IntervalPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/interval YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_IntervalPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_IntervalPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/interval YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_IntervalPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_MaxPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/max YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_MaxPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_MaxPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/max YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_MaxPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_MaxTimePath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/max-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_MaxTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_MaxTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/max-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_MaxTimePathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_MinPath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/min YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_MinPath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_MinPathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/min YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_MinPathAny struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_MinTimePath represents the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/min-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_MinTimePath struct {
	*ygot.NodePath
}

// OpticalAmplifier_SupervisoryChannel_OutputPower_MinTimePathAny represents the wildcard version of the /openconfig-optical-amplifier/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/min-time YANG schema element.
type OpticalAmplifier_SupervisoryChannel_OutputPower_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/avg"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPath) Avg() *OpticalAmplifier_SupervisoryChannel_OutputPower_AvgPath {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "avg"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/avg"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny) Avg() *OpticalAmplifier_SupervisoryChannel_OutputPower_AvgPathAny {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/instant"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPath) Instant() *OpticalAmplifier_SupervisoryChannel_OutputPower_InstantPath {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "instant"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/instant"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny) Instant() *OpticalAmplifier_SupervisoryChannel_OutputPower_InstantPathAny {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/interval"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPath) Interval() *OpticalAmplifier_SupervisoryChannel_OutputPower_IntervalPath {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "interval"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/interval"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny) Interval() *OpticalAmplifier_SupervisoryChannel_OutputPower_IntervalPathAny {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/max"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPath) Max() *OpticalAmplifier_SupervisoryChannel_OutputPower_MaxPath {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/max"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny) Max() *OpticalAmplifier_SupervisoryChannel_OutputPower_MaxPathAny {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/max-time"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPath) MaxTime() *OpticalAmplifier_SupervisoryChannel_OutputPower_MaxTimePath {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "max-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/max-time"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny) MaxTime() *OpticalAmplifier_SupervisoryChannel_OutputPower_MaxTimePathAny {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/min"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPath) Min() *OpticalAmplifier_SupervisoryChannel_OutputPower_MinPath {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/min"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny) Min() *OpticalAmplifier_SupervisoryChannel_OutputPower_MinPathAny {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/min-time"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPath) MinTime() *OpticalAmplifier_SupervisoryChannel_OutputPower_MinTimePath {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-optical-amplifier"
// Path from parent: "min-time"
// Path from root: "/optical-amplifier/supervisory-channels/supervisory-channel/state/output-power/min-time"
func (n *OpticalAmplifier_SupervisoryChannel_OutputPowerPathAny) MinTime() *OpticalAmplifier_SupervisoryChannel_OutputPower_MinTimePathAny {
	return &OpticalAmplifier_SupervisoryChannel_OutputPower_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgentPath represents the /openconfig-relay-agent/relay-agent YANG schema element.
type RelayAgentPath struct {
	*ygot.NodePath
}

// RelayAgentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent YANG schema element.
type RelayAgentPathAny struct {
	*ygot.NodePath
}

// Dhcp (container): Top-level container for global relay agent data
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp"
// Path from root: "/relay-agent/dhcp"
func (n *RelayAgentPath) Dhcp() *RelayAgent_DhcpPath {
	return &RelayAgent_DhcpPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcp (container): Top-level container for global relay agent data
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp"
// Path from root: "/relay-agent/dhcp"
func (n *RelayAgentPathAny) Dhcp() *RelayAgent_DhcpPathAny {
	return &RelayAgent_DhcpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6 (container): Top-level container for global relay agent data
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6"
// Path from root: "/relay-agent/dhcpv6"
func (n *RelayAgentPath) Dhcpv6() *RelayAgent_Dhcpv6Path {
	return &RelayAgent_Dhcpv6Path{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6 (container): Top-level container for global relay agent data
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6"
// Path from root: "/relay-agent/dhcpv6"
func (n *RelayAgentPathAny) Dhcpv6() *RelayAgent_Dhcpv6PathAny {
	return &RelayAgent_Dhcpv6PathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_DhcpPath represents the /openconfig-relay-agent/relay-agent/dhcp YANG schema element.
type RelayAgent_DhcpPath struct {
	*ygot.NodePath
}

// RelayAgent_DhcpPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp YANG schema element.
type RelayAgent_DhcpPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_EnableRelayAgentPath represents the /openconfig-relay-agent/relay-agent/dhcp/config/enable-relay-agent YANG schema element.
type RelayAgent_Dhcp_EnableRelayAgentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_EnableRelayAgentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/config/enable-relay-agent YANG schema element.
type RelayAgent_Dhcp_EnableRelayAgentPathAny struct {
	*ygot.NodePath
}

// AgentInformationOption (container): Top-level container for relay agent information option
// data
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "agent-information-option"
// Path from root: "/relay-agent/dhcp/agent-information-option"
func (n *RelayAgent_DhcpPath) AgentInformationOption() *RelayAgent_Dhcp_AgentInformationOptionPath {
	return &RelayAgent_Dhcp_AgentInformationOptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"agent-information-option"},
			map[string]interface{}{},
			n,
		),
	}
}

// AgentInformationOption (container): Top-level container for relay agent information option
// data
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "agent-information-option"
// Path from root: "/relay-agent/dhcp/agent-information-option"
func (n *RelayAgent_DhcpPathAny) AgentInformationOption() *RelayAgent_Dhcp_AgentInformationOptionPathAny {
	return &RelayAgent_Dhcp_AgentInformationOptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"agent-information-option"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableRelayAgent (leaf): Enables DHCP/BOOTP relay agent on all interfaces
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-relay-agent"
// Path from root: "/relay-agent/dhcp/config/enable-relay-agent"
func (n *RelayAgent_DhcpPath) EnableRelayAgent() *RelayAgent_Dhcp_EnableRelayAgentPath {
	return &RelayAgent_Dhcp_EnableRelayAgentPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-relay-agent"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableRelayAgent (leaf): Enables DHCP/BOOTP relay agent on all interfaces
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-relay-agent"
// Path from root: "/relay-agent/dhcp/config/enable-relay-agent"
func (n *RelayAgent_DhcpPathAny) EnableRelayAgent() *RelayAgent_Dhcp_EnableRelayAgentPathAny {
	return &RelayAgent_Dhcp_EnableRelayAgentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-relay-agent"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which the relay agent is
// configured.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interfaces/interface"
// Path from root: "/relay-agent/dhcp/interfaces/interface"
// Id (wildcarded): string
func (n *RelayAgent_DhcpPath) InterfaceAny() *RelayAgent_Dhcp_InterfacePathAny {
	return &RelayAgent_Dhcp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which the relay agent is
// configured.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interfaces/interface"
// Path from root: "/relay-agent/dhcp/interfaces/interface"
// Id (wildcarded): string
func (n *RelayAgent_DhcpPathAny) InterfaceAny() *RelayAgent_Dhcp_InterfacePathAny {
	return &RelayAgent_Dhcp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Interface (list): List of interfaces on which the relay agent is
// configured.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interfaces/interface"
// Path from root: "/relay-agent/dhcp/interfaces/interface"
// Id: string
func (n *RelayAgent_DhcpPath) Interface(Id string) *RelayAgent_Dhcp_InterfacePath {
	return &RelayAgent_Dhcp_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Interface (list): List of interfaces on which the relay agent is
// configured.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interfaces/interface"
// Path from root: "/relay-agent/dhcp/interfaces/interface"
// Id: string
func (n *RelayAgent_DhcpPathAny) Interface(Id string) *RelayAgent_Dhcp_InterfacePathAny {
	return &RelayAgent_Dhcp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// RelayAgent_Dhcp_AgentInformationOptionPath represents the /openconfig-relay-agent/relay-agent/dhcp/agent-information-option YANG schema element.
type RelayAgent_Dhcp_AgentInformationOptionPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_AgentInformationOptionPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/agent-information-option YANG schema element.
type RelayAgent_Dhcp_AgentInformationOptionPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_AgentInformationOption_EnablePath represents the /openconfig-relay-agent/relay-agent/dhcp/agent-information-option/config/enable YANG schema element.
type RelayAgent_Dhcp_AgentInformationOption_EnablePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_AgentInformationOption_EnablePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/agent-information-option/config/enable YANG schema element.
type RelayAgent_Dhcp_AgentInformationOption_EnablePathAny struct {
	*ygot.NodePath
}

// Enable (leaf): Enable sending the DHCP option for Relay Agent information
// -- option 82.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable"
// Path from root: "/relay-agent/dhcp/agent-information-option/config/enable"
func (n *RelayAgent_Dhcp_AgentInformationOptionPath) Enable() *RelayAgent_Dhcp_AgentInformationOption_EnablePath {
	return &RelayAgent_Dhcp_AgentInformationOption_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enable sending the DHCP option for Relay Agent information
// -- option 82.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable"
// Path from root: "/relay-agent/dhcp/agent-information-option/config/enable"
func (n *RelayAgent_Dhcp_AgentInformationOptionPathAny) Enable() *RelayAgent_Dhcp_AgentInformationOption_EnablePathAny {
	return &RelayAgent_Dhcp_AgentInformationOption_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcp_InterfacePath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface YANG schema element.
type RelayAgent_Dhcp_InterfacePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_InterfacePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface YANG schema element.
type RelayAgent_Dhcp_InterfacePathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_EnablePath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/config/enable YANG schema element.
type RelayAgent_Dhcp_Interface_EnablePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_EnablePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/config/enable YANG schema element.
type RelayAgent_Dhcp_Interface_EnablePathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_HelperAddressPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/config/helper-address YANG schema element.
type RelayAgent_Dhcp_Interface_HelperAddressPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_HelperAddressPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/config/helper-address YANG schema element.
type RelayAgent_Dhcp_Interface_HelperAddressPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_IdPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/config/id YANG schema element.
type RelayAgent_Dhcp_Interface_IdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_IdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/config/id YANG schema element.
type RelayAgent_Dhcp_Interface_IdPathAny struct {
	*ygot.NodePath
}

// AgentInformationOption (container): Top-level container for relay agent information option
// data
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "agent-information-option"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option"
func (n *RelayAgent_Dhcp_InterfacePath) AgentInformationOption() *RelayAgent_Dhcp_Interface_AgentInformationOptionPath {
	return &RelayAgent_Dhcp_Interface_AgentInformationOptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"agent-information-option"},
			map[string]interface{}{},
			n,
		),
	}
}

// AgentInformationOption (container): Top-level container for relay agent information option
// data
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "agent-information-option"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option"
func (n *RelayAgent_Dhcp_InterfacePathAny) AgentInformationOption() *RelayAgent_Dhcp_Interface_AgentInformationOptionPathAny {
	return &RelayAgent_Dhcp_Interface_AgentInformationOptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"agent-information-option"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Counters and statistics for relay agent operation.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/counters"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters"
func (n *RelayAgent_Dhcp_InterfacePath) Counters() *RelayAgent_Dhcp_Interface_CountersPath {
	return &RelayAgent_Dhcp_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Counters and statistics for relay agent operation.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/counters"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters"
func (n *RelayAgent_Dhcp_InterfacePathAny) Counters() *RelayAgent_Dhcp_Interface_CountersPathAny {
	return &RelayAgent_Dhcp_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables the relay agent on the referenced interface.
// At least one helper address should also be configured
// for forwarding requested.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable"
// Path from root: "/relay-agent/dhcp/interfaces/interface/config/enable"
func (n *RelayAgent_Dhcp_InterfacePath) Enable() *RelayAgent_Dhcp_Interface_EnablePath {
	return &RelayAgent_Dhcp_Interface_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables the relay agent on the referenced interface.
// At least one helper address should also be configured
// for forwarding requested.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable"
// Path from root: "/relay-agent/dhcp/interfaces/interface/config/enable"
func (n *RelayAgent_Dhcp_InterfacePathAny) Enable() *RelayAgent_Dhcp_Interface_EnablePathAny {
	return &RelayAgent_Dhcp_Interface_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperAddress (leaf): List of IPv4 or IPv6 addresses of DHCP servers to which the
// relay agent should forward DHCPv4 requests.  The relay agent is
// expected to forward DHCPv4/BOOTP requests to all listed
// server addresses when DHCPv4 relaying is enabled globally, or
// on the interface.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/helper-address"
// Path from root: "/relay-agent/dhcp/interfaces/interface/config/helper-address"
func (n *RelayAgent_Dhcp_InterfacePath) HelperAddress() *RelayAgent_Dhcp_Interface_HelperAddressPath {
	return &RelayAgent_Dhcp_Interface_HelperAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperAddress (leaf): List of IPv4 or IPv6 addresses of DHCP servers to which the
// relay agent should forward DHCPv4 requests.  The relay agent is
// expected to forward DHCPv4/BOOTP requests to all listed
// server addresses when DHCPv4 relaying is enabled globally, or
// on the interface.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/helper-address"
// Path from root: "/relay-agent/dhcp/interfaces/interface/config/helper-address"
func (n *RelayAgent_Dhcp_InterfacePathAny) HelperAddress() *RelayAgent_Dhcp_Interface_HelperAddressPathAny {
	return &RelayAgent_Dhcp_Interface_HelperAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Name of the interface on which relay agent is active
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/config/id"
func (n *RelayAgent_Dhcp_InterfacePath) Id() *RelayAgent_Dhcp_Interface_IdPath {
	return &RelayAgent_Dhcp_Interface_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Name of the interface on which relay agent is active
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/config/id"
func (n *RelayAgent_Dhcp_InterfacePathAny) Id() *RelayAgent_Dhcp_Interface_IdPathAny {
	return &RelayAgent_Dhcp_Interface_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interface-ref"
// Path from root: "/relay-agent/dhcp/interfaces/interface/interface-ref"
func (n *RelayAgent_Dhcp_InterfacePath) InterfaceRef() *RelayAgent_Dhcp_Interface_InterfaceRefPath {
	return &RelayAgent_Dhcp_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interface-ref"
// Path from root: "/relay-agent/dhcp/interfaces/interface/interface-ref"
func (n *RelayAgent_Dhcp_InterfacePathAny) InterfaceRef() *RelayAgent_Dhcp_Interface_InterfaceRefPathAny {
	return &RelayAgent_Dhcp_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcp_Interface_AgentInformationOptionPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOptionPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOptionPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOptionPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_CircuitIdPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/config/circuit-id YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_CircuitIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_CircuitIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/config/circuit-id YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_CircuitIdPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_EnablePath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/config/enable YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_EnablePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_EnablePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/config/enable YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_EnablePathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_RemoteIdPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/config/remote-id YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_RemoteIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_RemoteIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/config/remote-id YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_RemoteIdPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_SentCircuitIdPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/state/sent-circuit-id YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_SentCircuitIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_SentCircuitIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/state/sent-circuit-id YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_SentCircuitIdPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_SentRemoteIdPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/state/sent-remote-id YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_SentRemoteIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_AgentInformationOption_SentRemoteIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/agent-information-option/state/sent-remote-id YANG schema element.
type RelayAgent_Dhcp_Interface_AgentInformationOption_SentRemoteIdPathAny struct {
	*ygot.NodePath
}

// CircuitId (leaf): Encodes an agent-local identifier of the circuit from which
// a DHCP client-to-server packet was received.  It is intended
// for use by agents in relaying DHCP responses back to the
// proper circuit.  The circuit id is an opaque value
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/circuit-id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/config/circuit-id"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPath) CircuitId() *RelayAgent_Dhcp_Interface_AgentInformationOption_CircuitIdPath {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_CircuitIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "circuit-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// CircuitId (leaf): Encodes an agent-local identifier of the circuit from which
// a DHCP client-to-server packet was received.  It is intended
// for use by agents in relaying DHCP responses back to the
// proper circuit.  The circuit id is an opaque value
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/circuit-id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/config/circuit-id"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPathAny) CircuitId() *RelayAgent_Dhcp_Interface_AgentInformationOption_CircuitIdPathAny {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_CircuitIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "circuit-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enable sending the DHCP option for Relay Agent information
// -- option 82.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/config/enable"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPath) Enable() *RelayAgent_Dhcp_Interface_AgentInformationOption_EnablePath {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enable sending the DHCP option for Relay Agent information
// -- option 82.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/config/enable"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPathAny) Enable() *RelayAgent_Dhcp_Interface_AgentInformationOption_EnablePathAny {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteId (leaf): Provides a mechanism to identify the remote host end of
// the circuit.  The remote-id should be thought of as an
// opaque value, but must be globally unique.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/remote-id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/config/remote-id"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPath) RemoteId() *RelayAgent_Dhcp_Interface_AgentInformationOption_RemoteIdPath {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_RemoteIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteId (leaf): Provides a mechanism to identify the remote host end of
// the circuit.  The remote-id should be thought of as an
// opaque value, but must be globally unique.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/remote-id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/config/remote-id"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPathAny) RemoteId() *RelayAgent_Dhcp_Interface_AgentInformationOption_RemoteIdPathAny {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_RemoteIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SentCircuitId (leaf): Reports the circuit-id sent by the system to the DHCP
// server.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/sent-circuit-id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/state/sent-circuit-id"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPath) SentCircuitId() *RelayAgent_Dhcp_Interface_AgentInformationOption_SentCircuitIdPath {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_SentCircuitIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent-circuit-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SentCircuitId (leaf): Reports the circuit-id sent by the system to the DHCP
// server.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/sent-circuit-id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/state/sent-circuit-id"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPathAny) SentCircuitId() *RelayAgent_Dhcp_Interface_AgentInformationOption_SentCircuitIdPathAny {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_SentCircuitIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent-circuit-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SentRemoteId (leaf): Reports the remote-id value sent by the system to the DHCP
// server
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/sent-remote-id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/state/sent-remote-id"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPath) SentRemoteId() *RelayAgent_Dhcp_Interface_AgentInformationOption_SentRemoteIdPath {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_SentRemoteIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent-remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SentRemoteId (leaf): Reports the remote-id value sent by the system to the DHCP
// server
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/sent-remote-id"
// Path from root: "/relay-agent/dhcp/interfaces/interface/agent-information-option/state/sent-remote-id"
func (n *RelayAgent_Dhcp_Interface_AgentInformationOptionPathAny) SentRemoteId() *RelayAgent_Dhcp_Interface_AgentInformationOption_SentRemoteIdPathAny {
	return &RelayAgent_Dhcp_Interface_AgentInformationOption_SentRemoteIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent-remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcp_Interface_CountersPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters YANG schema element.
type RelayAgent_Dhcp_Interface_CountersPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_CountersPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters YANG schema element.
type RelayAgent_Dhcp_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_BootreplySentPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/bootreply-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_BootreplySentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_BootreplySentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/bootreply-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_BootreplySentPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_BootrequestReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/bootrequest-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_BootrequestReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_BootrequestReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/bootrequest-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_BootrequestReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_BootrequestSentPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/bootrequest-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_BootrequestSentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_BootrequestSentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/bootrequest-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_BootrequestSentPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpAckSentPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-ack-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpAckSentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpAckSentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-ack-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpAckSentPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpDeclineReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-decline-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpDeclineReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpDeclineReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-decline-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpDeclineReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpDiscoverReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-discover-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpDiscoverReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpDiscoverReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-discover-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpDiscoverReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpInformReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-inform-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpInformReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpInformReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-inform-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpInformReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpNackSentPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-nack-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpNackSentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpNackSentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-nack-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpNackSentPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpOfferSentPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-offer-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpOfferSentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpOfferSentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-offer-sent YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpOfferSentPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpReleaseReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-release-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpReleaseReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpReleaseReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-release-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpReleaseReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpRequestReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-request-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpRequestReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_DhcpRequestReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-request-received YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_DhcpRequestReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_InvalidOpcodePath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/invalid-opcode YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_InvalidOpcodePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_InvalidOpcodePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/invalid-opcode YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_InvalidOpcodePathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_InvalidOptionsPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/invalid-options YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_InvalidOptionsPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_InvalidOptionsPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/invalid-options YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_InvalidOptionsPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_TotalDroppedPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/total-dropped YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_TotalDroppedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_Counters_TotalDroppedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/state/counters/total-dropped YANG schema element.
type RelayAgent_Dhcp_Interface_Counters_TotalDroppedPathAny struct {
	*ygot.NodePath
}

// BootreplySent (leaf): BOOTREPLY messages forwarded by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "bootreply-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/bootreply-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPath) BootreplySent() *RelayAgent_Dhcp_Interface_Counters_BootreplySentPath {
	return &RelayAgent_Dhcp_Interface_Counters_BootreplySentPath{
		NodePath: ygot.NewNodePath(
			[]string{"bootreply-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// BootreplySent (leaf): BOOTREPLY messages forwarded by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "bootreply-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/bootreply-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) BootreplySent() *RelayAgent_Dhcp_Interface_Counters_BootreplySentPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_BootreplySentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bootreply-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// BootrequestReceived (leaf): BOOTREQUEST messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "bootrequest-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/bootrequest-received"
func (n *RelayAgent_Dhcp_Interface_CountersPath) BootrequestReceived() *RelayAgent_Dhcp_Interface_Counters_BootrequestReceivedPath {
	return &RelayAgent_Dhcp_Interface_Counters_BootrequestReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"bootrequest-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// BootrequestReceived (leaf): BOOTREQUEST messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "bootrequest-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/bootrequest-received"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) BootrequestReceived() *RelayAgent_Dhcp_Interface_Counters_BootrequestReceivedPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_BootrequestReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bootrequest-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// BootrequestSent (leaf): BOOTREQUEST messages forwarded by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "bootrequest-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/bootrequest-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPath) BootrequestSent() *RelayAgent_Dhcp_Interface_Counters_BootrequestSentPath {
	return &RelayAgent_Dhcp_Interface_Counters_BootrequestSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"bootrequest-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// BootrequestSent (leaf): BOOTREQUEST messages forwarded by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "bootrequest-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/bootrequest-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) BootrequestSent() *RelayAgent_Dhcp_Interface_Counters_BootrequestSentPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_BootrequestSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bootrequest-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpAckSent (leaf): DHCP ACK messages sent by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-ack-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-ack-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPath) DhcpAckSent() *RelayAgent_Dhcp_Interface_Counters_DhcpAckSentPath {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpAckSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-ack-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpAckSent (leaf): DHCP ACK messages sent by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-ack-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-ack-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) DhcpAckSent() *RelayAgent_Dhcp_Interface_Counters_DhcpAckSentPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpAckSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-ack-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpDeclineReceived (leaf): DHCP DECLINE messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-decline-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-decline-received"
func (n *RelayAgent_Dhcp_Interface_CountersPath) DhcpDeclineReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpDeclineReceivedPath {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpDeclineReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-decline-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpDeclineReceived (leaf): DHCP DECLINE messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-decline-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-decline-received"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) DhcpDeclineReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpDeclineReceivedPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpDeclineReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-decline-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpDiscoverReceived (leaf): DHCP DISCOVER messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-discover-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-discover-received"
func (n *RelayAgent_Dhcp_Interface_CountersPath) DhcpDiscoverReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpDiscoverReceivedPath {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpDiscoverReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-discover-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpDiscoverReceived (leaf): DHCP DISCOVER messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-discover-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-discover-received"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) DhcpDiscoverReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpDiscoverReceivedPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpDiscoverReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-discover-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpInformReceived (leaf): DHCP INFORM messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-inform-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-inform-received"
func (n *RelayAgent_Dhcp_Interface_CountersPath) DhcpInformReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpInformReceivedPath {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpInformReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-inform-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpInformReceived (leaf): DHCP INFORM messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-inform-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-inform-received"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) DhcpInformReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpInformReceivedPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpInformReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-inform-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpNackSent (leaf): DHCP NACK messages sent by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-nack-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-nack-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPath) DhcpNackSent() *RelayAgent_Dhcp_Interface_Counters_DhcpNackSentPath {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpNackSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-nack-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpNackSent (leaf): DHCP NACK messages sent by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-nack-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-nack-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) DhcpNackSent() *RelayAgent_Dhcp_Interface_Counters_DhcpNackSentPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpNackSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-nack-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpOfferSent (leaf): DHCP OFFER messages sent by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-offer-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-offer-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPath) DhcpOfferSent() *RelayAgent_Dhcp_Interface_Counters_DhcpOfferSentPath {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpOfferSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-offer-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpOfferSent (leaf): DHCP OFFER messages sent by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-offer-sent"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-offer-sent"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) DhcpOfferSent() *RelayAgent_Dhcp_Interface_Counters_DhcpOfferSentPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpOfferSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-offer-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpReleaseReceived (leaf): DHCP RELEASE messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-release-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-release-received"
func (n *RelayAgent_Dhcp_Interface_CountersPath) DhcpReleaseReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpReleaseReceivedPath {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpReleaseReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-release-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpReleaseReceived (leaf): DHCP RELEASE messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-release-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-release-received"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) DhcpReleaseReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpReleaseReceivedPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpReleaseReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-release-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpRequestReceived (leaf): DHCP REQUEST messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-request-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-request-received"
func (n *RelayAgent_Dhcp_Interface_CountersPath) DhcpRequestReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpRequestReceivedPath {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpRequestReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-request-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// DhcpRequestReceived (leaf): DHCP REQUEST messages received by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcp-request-received"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/dhcp-request-received"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) DhcpRequestReceived() *RelayAgent_Dhcp_Interface_Counters_DhcpRequestReceivedPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_DhcpRequestReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcp-request-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidOpcode (leaf): Number of DHCP packets dropped due to an invalid opcode
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "invalid-opcode"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/invalid-opcode"
func (n *RelayAgent_Dhcp_Interface_CountersPath) InvalidOpcode() *RelayAgent_Dhcp_Interface_Counters_InvalidOpcodePath {
	return &RelayAgent_Dhcp_Interface_Counters_InvalidOpcodePath{
		NodePath: ygot.NewNodePath(
			[]string{"invalid-opcode"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidOpcode (leaf): Number of DHCP packets dropped due to an invalid opcode
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "invalid-opcode"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/invalid-opcode"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) InvalidOpcode() *RelayAgent_Dhcp_Interface_Counters_InvalidOpcodePathAny {
	return &RelayAgent_Dhcp_Interface_Counters_InvalidOpcodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"invalid-opcode"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidOptions (leaf): Number of DHCP packets dropped due to an invalid option
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "invalid-options"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/invalid-options"
func (n *RelayAgent_Dhcp_Interface_CountersPath) InvalidOptions() *RelayAgent_Dhcp_Interface_Counters_InvalidOptionsPath {
	return &RelayAgent_Dhcp_Interface_Counters_InvalidOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"invalid-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidOptions (leaf): Number of DHCP packets dropped due to an invalid option
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "invalid-options"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/invalid-options"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) InvalidOptions() *RelayAgent_Dhcp_Interface_Counters_InvalidOptionsPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_InvalidOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"invalid-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalDropped (leaf): Total number of DHCP packets dropped by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "total-dropped"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/total-dropped"
func (n *RelayAgent_Dhcp_Interface_CountersPath) TotalDropped() *RelayAgent_Dhcp_Interface_Counters_TotalDroppedPath {
	return &RelayAgent_Dhcp_Interface_Counters_TotalDroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"total-dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalDropped (leaf): Total number of DHCP packets dropped by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "total-dropped"
// Path from root: "/relay-agent/dhcp/interfaces/interface/state/counters/total-dropped"
func (n *RelayAgent_Dhcp_Interface_CountersPathAny) TotalDropped() *RelayAgent_Dhcp_Interface_Counters_TotalDroppedPathAny {
	return &RelayAgent_Dhcp_Interface_Counters_TotalDroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"total-dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcp_Interface_InterfaceRefPath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/interface-ref YANG schema element.
type RelayAgent_Dhcp_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/interface-ref YANG schema element.
type RelayAgent_Dhcp_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_InterfaceRef_InterfacePath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/interface-ref/config/interface YANG schema element.
type RelayAgent_Dhcp_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/interface-ref/config/interface YANG schema element.
type RelayAgent_Dhcp_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type RelayAgent_Dhcp_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcp_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcp/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type RelayAgent_Dhcp_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/interface"
// Path from root: "/relay-agent/dhcp/interfaces/interface/interface-ref/config/interface"
func (n *RelayAgent_Dhcp_Interface_InterfaceRefPath) Interface() *RelayAgent_Dhcp_Interface_InterfaceRef_InterfacePath {
	return &RelayAgent_Dhcp_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/interface"
// Path from root: "/relay-agent/dhcp/interfaces/interface/interface-ref/config/interface"
func (n *RelayAgent_Dhcp_Interface_InterfaceRefPathAny) Interface() *RelayAgent_Dhcp_Interface_InterfaceRef_InterfacePathAny {
	return &RelayAgent_Dhcp_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/subinterface"
// Path from root: "/relay-agent/dhcp/interfaces/interface/interface-ref/config/subinterface"
func (n *RelayAgent_Dhcp_Interface_InterfaceRefPath) Subinterface() *RelayAgent_Dhcp_Interface_InterfaceRef_SubinterfacePath {
	return &RelayAgent_Dhcp_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/subinterface"
// Path from root: "/relay-agent/dhcp/interfaces/interface/interface-ref/config/subinterface"
func (n *RelayAgent_Dhcp_Interface_InterfaceRefPathAny) Subinterface() *RelayAgent_Dhcp_Interface_InterfaceRef_SubinterfacePathAny {
	return &RelayAgent_Dhcp_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcpv6Path represents the /openconfig-relay-agent/relay-agent/dhcpv6 YANG schema element.
type RelayAgent_Dhcpv6Path struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6PathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6 YANG schema element.
type RelayAgent_Dhcpv6PathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_EnableRelayAgentPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/config/enable-relay-agent YANG schema element.
type RelayAgent_Dhcpv6_EnableRelayAgentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_EnableRelayAgentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/config/enable-relay-agent YANG schema element.
type RelayAgent_Dhcpv6_EnableRelayAgentPathAny struct {
	*ygot.NodePath
}

// EnableRelayAgent (leaf): Enables DHCP/BOOTP relay agent on all interfaces
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-relay-agent"
// Path from root: "/relay-agent/dhcpv6/config/enable-relay-agent"
func (n *RelayAgent_Dhcpv6Path) EnableRelayAgent() *RelayAgent_Dhcpv6_EnableRelayAgentPath {
	return &RelayAgent_Dhcpv6_EnableRelayAgentPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-relay-agent"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableRelayAgent (leaf): Enables DHCP/BOOTP relay agent on all interfaces
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-relay-agent"
// Path from root: "/relay-agent/dhcpv6/config/enable-relay-agent"
func (n *RelayAgent_Dhcpv6PathAny) EnableRelayAgent() *RelayAgent_Dhcpv6_EnableRelayAgentPathAny {
	return &RelayAgent_Dhcpv6_EnableRelayAgentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-relay-agent"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which the relay agent is
// configured.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interfaces/interface"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface"
// Id (wildcarded): string
func (n *RelayAgent_Dhcpv6Path) InterfaceAny() *RelayAgent_Dhcpv6_InterfacePathAny {
	return &RelayAgent_Dhcpv6_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which the relay agent is
// configured.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interfaces/interface"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface"
// Id (wildcarded): string
func (n *RelayAgent_Dhcpv6PathAny) InterfaceAny() *RelayAgent_Dhcpv6_InterfacePathAny {
	return &RelayAgent_Dhcpv6_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Interface (list): List of interfaces on which the relay agent is
// configured.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interfaces/interface"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface"
// Id: string
func (n *RelayAgent_Dhcpv6Path) Interface(Id string) *RelayAgent_Dhcpv6_InterfacePath {
	return &RelayAgent_Dhcpv6_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Interface (list): List of interfaces on which the relay agent is
// configured.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interfaces/interface"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface"
// Id: string
func (n *RelayAgent_Dhcpv6PathAny) Interface(Id string) *RelayAgent_Dhcpv6_InterfacePathAny {
	return &RelayAgent_Dhcpv6_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Options (container): Top-level container for DHCPv6 agent options on interfaces
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "options"
// Path from root: "/relay-agent/dhcpv6/options"
func (n *RelayAgent_Dhcpv6Path) Options() *RelayAgent_Dhcpv6_OptionsPath {
	return &RelayAgent_Dhcpv6_OptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"options"},
			map[string]interface{}{},
			n,
		),
	}
}

// Options (container): Top-level container for DHCPv6 agent options on interfaces
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "options"
// Path from root: "/relay-agent/dhcpv6/options"
func (n *RelayAgent_Dhcpv6PathAny) Options() *RelayAgent_Dhcpv6_OptionsPathAny {
	return &RelayAgent_Dhcpv6_OptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"options"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcpv6_InterfacePath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface YANG schema element.
type RelayAgent_Dhcpv6_InterfacePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_InterfacePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface YANG schema element.
type RelayAgent_Dhcpv6_InterfacePathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_EnablePath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/config/enable YANG schema element.
type RelayAgent_Dhcpv6_Interface_EnablePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_EnablePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/config/enable YANG schema element.
type RelayAgent_Dhcpv6_Interface_EnablePathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_HelperAddressPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/config/helper-address YANG schema element.
type RelayAgent_Dhcpv6_Interface_HelperAddressPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_HelperAddressPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/config/helper-address YANG schema element.
type RelayAgent_Dhcpv6_Interface_HelperAddressPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_IdPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/config/id YANG schema element.
type RelayAgent_Dhcpv6_Interface_IdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_IdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/config/id YANG schema element.
type RelayAgent_Dhcpv6_Interface_IdPathAny struct {
	*ygot.NodePath
}

// Counters (container): Counters and statistics for relay agent operation.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/counters"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters"
func (n *RelayAgent_Dhcpv6_InterfacePath) Counters() *RelayAgent_Dhcpv6_Interface_CountersPath {
	return &RelayAgent_Dhcpv6_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Counters and statistics for relay agent operation.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/counters"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters"
func (n *RelayAgent_Dhcpv6_InterfacePathAny) Counters() *RelayAgent_Dhcpv6_Interface_CountersPathAny {
	return &RelayAgent_Dhcpv6_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables the relay agent on the referenced interface.
// At least one helper address should also be configured
// for forwarding requested.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/config/enable"
func (n *RelayAgent_Dhcpv6_InterfacePath) Enable() *RelayAgent_Dhcpv6_Interface_EnablePath {
	return &RelayAgent_Dhcpv6_Interface_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables the relay agent on the referenced interface.
// At least one helper address should also be configured
// for forwarding requested.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/config/enable"
func (n *RelayAgent_Dhcpv6_InterfacePathAny) Enable() *RelayAgent_Dhcpv6_Interface_EnablePathAny {
	return &RelayAgent_Dhcpv6_Interface_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperAddress (leaf): List of IPv6 addresses of DHCP servers to which the
// relay agent should forward DHCPv6 requests.  The relay agent
// is expected to forward DHCPv4/BOOTP requests to all listed
// server addresses when DHCPv6 relaying is enabled globally, or
// on the interface.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/helper-address"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/config/helper-address"
func (n *RelayAgent_Dhcpv6_InterfacePath) HelperAddress() *RelayAgent_Dhcpv6_Interface_HelperAddressPath {
	return &RelayAgent_Dhcpv6_Interface_HelperAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelperAddress (leaf): List of IPv6 addresses of DHCP servers to which the
// relay agent should forward DHCPv6 requests.  The relay agent
// is expected to forward DHCPv4/BOOTP requests to all listed
// server addresses when DHCPv6 relaying is enabled globally, or
// on the interface.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/helper-address"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/config/helper-address"
func (n *RelayAgent_Dhcpv6_InterfacePathAny) HelperAddress() *RelayAgent_Dhcpv6_Interface_HelperAddressPathAny {
	return &RelayAgent_Dhcpv6_Interface_HelperAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "helper-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Name of the interface on which relay agent is active
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/config/id"
func (n *RelayAgent_Dhcpv6_InterfacePath) Id() *RelayAgent_Dhcpv6_Interface_IdPath {
	return &RelayAgent_Dhcpv6_Interface_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Name of the interface on which relay agent is active
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/config/id"
func (n *RelayAgent_Dhcpv6_InterfacePathAny) Id() *RelayAgent_Dhcpv6_Interface_IdPathAny {
	return &RelayAgent_Dhcpv6_Interface_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interface-ref"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/interface-ref"
func (n *RelayAgent_Dhcpv6_InterfacePath) InterfaceRef() *RelayAgent_Dhcpv6_Interface_InterfaceRefPath {
	return &RelayAgent_Dhcpv6_Interface_InterfaceRefPath{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceRef (container): Reference to an interface or subinterface
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "interface-ref"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/interface-ref"
func (n *RelayAgent_Dhcpv6_InterfacePathAny) InterfaceRef() *RelayAgent_Dhcpv6_Interface_InterfaceRefPathAny {
	return &RelayAgent_Dhcpv6_Interface_InterfaceRefPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interface-ref"},
			map[string]interface{}{},
			n,
		),
	}
}

// Options (container): Top-level container for DHCPv6 agent options on interfaces
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "options"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options"
func (n *RelayAgent_Dhcpv6_InterfacePath) Options() *RelayAgent_Dhcpv6_Interface_OptionsPath {
	return &RelayAgent_Dhcpv6_Interface_OptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"options"},
			map[string]interface{}{},
			n,
		),
	}
}

// Options (container): Top-level container for DHCPv6 agent options on interfaces
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "options"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options"
func (n *RelayAgent_Dhcpv6_InterfacePathAny) Options() *RelayAgent_Dhcpv6_Interface_OptionsPathAny {
	return &RelayAgent_Dhcpv6_Interface_OptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"options"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcpv6_Interface_CountersPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters YANG schema element.
type RelayAgent_Dhcpv6_Interface_CountersPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_CountersPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters YANG schema element.
type RelayAgent_Dhcpv6_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6AdverstiseSentPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-adverstise-sent YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6AdverstiseSentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6AdverstiseSentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-adverstise-sent YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6AdverstiseSentPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ConfirmReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-confirm-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ConfirmReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ConfirmReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-confirm-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ConfirmReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6DeclineReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-decline-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6DeclineReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6DeclineReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-decline-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6DeclineReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6InfoRequestReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-info-request-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6InfoRequestReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6InfoRequestReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-info-request-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6InfoRequestReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RebindReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-rebind-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RebindReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RebindReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-rebind-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RebindReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReconfigureSentPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-reconfigure-sent YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReconfigureSentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReconfigureSentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-reconfigure-sent YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReconfigureSentPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayForwSentPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-relay-forw-sent YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayForwSentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayForwSentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-relay-forw-sent YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayForwSentPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayReplyReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-relay-reply-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayReplyReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayReplyReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-relay-reply-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayReplyReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReleaseReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-release-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReleaseReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReleaseReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-release-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReleaseReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReplySentPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-reply-sent YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReplySentPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReplySentPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-reply-sent YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReplySentPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RequestReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-request-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RequestReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RequestReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-request-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RequestReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6SolicitReceivedPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-solicit-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6SolicitReceivedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6SolicitReceivedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-solicit-received YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6SolicitReceivedPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_InvalidOpcodePath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/invalid-opcode YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_InvalidOpcodePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_InvalidOpcodePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/invalid-opcode YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_InvalidOpcodePathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_InvalidOptionsPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/invalid-options YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_InvalidOptionsPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_InvalidOptionsPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/invalid-options YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_InvalidOptionsPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_TotalDroppedPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/total-dropped YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_TotalDroppedPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Counters_TotalDroppedPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/state/counters/total-dropped YANG schema element.
type RelayAgent_Dhcpv6_Interface_Counters_TotalDroppedPathAny struct {
	*ygot.NodePath
}

// Dhcpv6AdverstiseSent (leaf): Number of DHCPv6 adverstise messages sent to clients by
// the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-adverstise-sent"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-adverstise-sent"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6AdverstiseSent() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6AdverstiseSentPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6AdverstiseSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-adverstise-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6AdverstiseSent (leaf): Number of DHCPv6 adverstise messages sent to clients by
// the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-adverstise-sent"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-adverstise-sent"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6AdverstiseSent() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6AdverstiseSentPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6AdverstiseSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-adverstise-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6ConfirmReceived (leaf): Number of DHCPv6 confirm messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-confirm-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-confirm-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6ConfirmReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ConfirmReceivedPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ConfirmReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-confirm-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6ConfirmReceived (leaf): Number of DHCPv6 confirm messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-confirm-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-confirm-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6ConfirmReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ConfirmReceivedPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ConfirmReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-confirm-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6DeclineReceived (leaf): Number of DHCPv6 DECLINE messages received from
// clients by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-decline-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-decline-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6DeclineReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6DeclineReceivedPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6DeclineReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-decline-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6DeclineReceived (leaf): Number of DHCPv6 DECLINE messages received from
// clients by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-decline-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-decline-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6DeclineReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6DeclineReceivedPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6DeclineReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-decline-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6InfoRequestReceived (leaf): Number of DHCPv6 information requests messages received from
// clients by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-info-request-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-info-request-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6InfoRequestReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6InfoRequestReceivedPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6InfoRequestReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-info-request-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6InfoRequestReceived (leaf): Number of DHCPv6 information requests messages received from
// clients by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-info-request-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-info-request-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6InfoRequestReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6InfoRequestReceivedPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6InfoRequestReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-info-request-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6RebindReceived (leaf): Number of DHCPv6 rebind messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-rebind-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-rebind-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6RebindReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RebindReceivedPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RebindReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-rebind-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6RebindReceived (leaf): Number of DHCPv6 rebind messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-rebind-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-rebind-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6RebindReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RebindReceivedPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RebindReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-rebind-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6ReconfigureSent (leaf): Number of DHCPv6 reconfigure messages sent to clients by
// the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-reconfigure-sent"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-reconfigure-sent"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6ReconfigureSent() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReconfigureSentPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReconfigureSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-reconfigure-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6ReconfigureSent (leaf): Number of DHCPv6 reconfigure messages sent to clients by
// the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-reconfigure-sent"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-reconfigure-sent"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6ReconfigureSent() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReconfigureSentPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReconfigureSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-reconfigure-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6RelayForwSent (leaf): Number of DHCPv6 relay-forward messages sent to servers
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-relay-forw-sent"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-relay-forw-sent"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6RelayForwSent() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayForwSentPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayForwSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-relay-forw-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6RelayForwSent (leaf): Number of DHCPv6 relay-forward messages sent to servers
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-relay-forw-sent"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-relay-forw-sent"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6RelayForwSent() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayForwSentPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayForwSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-relay-forw-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6RelayReplyReceived (leaf): Number of DHCPv6 relay reply messages received from servers
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-relay-reply-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-relay-reply-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6RelayReplyReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayReplyReceivedPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayReplyReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-relay-reply-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6RelayReplyReceived (leaf): Number of DHCPv6 relay reply messages received from servers
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-relay-reply-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-relay-reply-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6RelayReplyReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayReplyReceivedPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RelayReplyReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-relay-reply-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6ReleaseReceived (leaf): Number of DHCPv6 release messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-release-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-release-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6ReleaseReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReleaseReceivedPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReleaseReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-release-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6ReleaseReceived (leaf): Number of DHCPv6 release messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-release-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-release-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6ReleaseReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReleaseReceivedPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReleaseReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-release-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6ReplySent (leaf): Number of DHCPv6 reply messages sent to clients by
// the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-reply-sent"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-reply-sent"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6ReplySent() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReplySentPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReplySentPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-reply-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6ReplySent (leaf): Number of DHCPv6 reply messages sent to clients by
// the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-reply-sent"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-reply-sent"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6ReplySent() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReplySentPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6ReplySentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-reply-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6RequestReceived (leaf): Number of DHCPv6 request messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-request-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-request-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6RequestReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RequestReceivedPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RequestReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-request-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6RequestReceived (leaf): Number of DHCPv6 request messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-request-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-request-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6RequestReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RequestReceivedPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6RequestReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-request-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6SolicitReceived (leaf): Number of DHCPv6 SOLICIT messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-solicit-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-solicit-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) Dhcpv6SolicitReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6SolicitReceivedPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6SolicitReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-solicit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dhcpv6SolicitReceived (leaf): Number of DHCPv6 SOLICIT messages received from clients
// by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "dhcpv6-solicit-received"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/dhcpv6-solicit-received"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) Dhcpv6SolicitReceived() *RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6SolicitReceivedPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_Dhcpv6SolicitReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dhcpv6-solicit-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidOpcode (leaf): Number of DHCP packets dropped due to an invalid opcode
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "invalid-opcode"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/invalid-opcode"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) InvalidOpcode() *RelayAgent_Dhcpv6_Interface_Counters_InvalidOpcodePath {
	return &RelayAgent_Dhcpv6_Interface_Counters_InvalidOpcodePath{
		NodePath: ygot.NewNodePath(
			[]string{"invalid-opcode"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidOpcode (leaf): Number of DHCP packets dropped due to an invalid opcode
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "invalid-opcode"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/invalid-opcode"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) InvalidOpcode() *RelayAgent_Dhcpv6_Interface_Counters_InvalidOpcodePathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_InvalidOpcodePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"invalid-opcode"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidOptions (leaf): Number of DHCP packets dropped due to an invalid option
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "invalid-options"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/invalid-options"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) InvalidOptions() *RelayAgent_Dhcpv6_Interface_Counters_InvalidOptionsPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_InvalidOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"invalid-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// InvalidOptions (leaf): Number of DHCP packets dropped due to an invalid option
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "invalid-options"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/invalid-options"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) InvalidOptions() *RelayAgent_Dhcpv6_Interface_Counters_InvalidOptionsPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_InvalidOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"invalid-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalDropped (leaf): Total number of DHCP packets dropped by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "total-dropped"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/total-dropped"
func (n *RelayAgent_Dhcpv6_Interface_CountersPath) TotalDropped() *RelayAgent_Dhcpv6_Interface_Counters_TotalDroppedPath {
	return &RelayAgent_Dhcpv6_Interface_Counters_TotalDroppedPath{
		NodePath: ygot.NewNodePath(
			[]string{"total-dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalDropped (leaf): Total number of DHCP packets dropped by the relay agent
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "total-dropped"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/state/counters/total-dropped"
func (n *RelayAgent_Dhcpv6_Interface_CountersPathAny) TotalDropped() *RelayAgent_Dhcpv6_Interface_Counters_TotalDroppedPathAny {
	return &RelayAgent_Dhcpv6_Interface_Counters_TotalDroppedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"total-dropped"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcpv6_Interface_InterfaceRefPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/interface-ref YANG schema element.
type RelayAgent_Dhcpv6_Interface_InterfaceRefPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_InterfaceRefPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/interface-ref YANG schema element.
type RelayAgent_Dhcpv6_Interface_InterfaceRefPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_InterfaceRef_InterfacePath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/interface-ref/config/interface YANG schema element.
type RelayAgent_Dhcpv6_Interface_InterfaceRef_InterfacePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_InterfaceRef_InterfacePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/interface-ref/config/interface YANG schema element.
type RelayAgent_Dhcpv6_Interface_InterfaceRef_InterfacePathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_InterfaceRef_SubinterfacePath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type RelayAgent_Dhcpv6_Interface_InterfaceRef_SubinterfacePath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_InterfaceRef_SubinterfacePathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/interface-ref/config/subinterface YANG schema element.
type RelayAgent_Dhcpv6_Interface_InterfaceRef_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/interface"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/interface-ref/config/interface"
func (n *RelayAgent_Dhcpv6_Interface_InterfaceRefPath) Interface() *RelayAgent_Dhcpv6_Interface_InterfaceRef_InterfacePath {
	return &RelayAgent_Dhcpv6_Interface_InterfaceRef_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/interface"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/interface-ref/config/interface"
func (n *RelayAgent_Dhcpv6_Interface_InterfaceRefPathAny) Interface() *RelayAgent_Dhcpv6_Interface_InterfaceRef_InterfacePathAny {
	return &RelayAgent_Dhcpv6_Interface_InterfaceRef_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/subinterface"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/interface-ref/config/subinterface"
func (n *RelayAgent_Dhcpv6_Interface_InterfaceRefPath) Subinterface() *RelayAgent_Dhcpv6_Interface_InterfaceRef_SubinterfacePath {
	return &RelayAgent_Dhcpv6_Interface_InterfaceRef_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/subinterface"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/interface-ref/config/subinterface"
func (n *RelayAgent_Dhcpv6_Interface_InterfaceRefPathAny) Subinterface() *RelayAgent_Dhcpv6_Interface_InterfaceRef_SubinterfacePathAny {
	return &RelayAgent_Dhcpv6_Interface_InterfaceRef_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcpv6_Interface_OptionsPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options YANG schema element.
type RelayAgent_Dhcpv6_Interface_OptionsPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_OptionsPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options YANG schema element.
type RelayAgent_Dhcpv6_Interface_OptionsPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_EnableInterfaceIdPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/config/enable-interface-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_EnableInterfaceIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_EnableInterfaceIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/config/enable-interface-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_EnableInterfaceIdPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_EnableRemoteIdPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/config/enable-remote-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_EnableRemoteIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_EnableRemoteIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/config/enable-remote-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_EnableRemoteIdPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_InterfaceIdPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/config/interface-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_InterfaceIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_InterfaceIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/config/interface-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_InterfaceIdPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_RemoteIdPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/config/remote-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_RemoteIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_RemoteIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/config/remote-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_RemoteIdPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_SentInterfaceIdPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/state/sent-interface-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_SentInterfaceIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_SentInterfaceIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/state/sent-interface-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_SentInterfaceIdPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_SentRemoteIdPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/state/sent-remote-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_SentRemoteIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Interface_Options_SentRemoteIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/interfaces/interface/options/state/sent-remote-id YANG schema element.
type RelayAgent_Dhcpv6_Interface_Options_SentRemoteIdPathAny struct {
	*ygot.NodePath
}

// EnableInterfaceId (leaf): Enables DHCPv6 OPTION_INTERFACE_ID (18) to identify the
// interface on which the client message was received.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-interface-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/config/enable-interface-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPath) EnableInterfaceId() *RelayAgent_Dhcpv6_Interface_Options_EnableInterfaceIdPath {
	return &RelayAgent_Dhcpv6_Interface_Options_EnableInterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableInterfaceId (leaf): Enables DHCPv6 OPTION_INTERFACE_ID (18) to identify the
// interface on which the client message was received.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-interface-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/config/enable-interface-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPathAny) EnableInterfaceId() *RelayAgent_Dhcpv6_Interface_Options_EnableInterfaceIdPathAny {
	return &RelayAgent_Dhcpv6_Interface_Options_EnableInterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableRemoteId (leaf): Sets DHCPv6 OPTION_REMOTE_ID (37).  This option is the
// DHCPv6 equivalent for the IPv4 (DHCPv4) Relay Agent Option's
// Remote-ID suboption as specified in RFC 3046. The remote-id
// field may be used to encode a user name, remote IP address,
// interface/port identifier, etc.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-remote-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/config/enable-remote-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPath) EnableRemoteId() *RelayAgent_Dhcpv6_Interface_Options_EnableRemoteIdPath {
	return &RelayAgent_Dhcpv6_Interface_Options_EnableRemoteIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableRemoteId (leaf): Sets DHCPv6 OPTION_REMOTE_ID (37).  This option is the
// DHCPv6 equivalent for the IPv4 (DHCPv4) Relay Agent Option's
// Remote-ID suboption as specified in RFC 3046. The remote-id
// field may be used to encode a user name, remote IP address,
// interface/port identifier, etc.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-remote-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/config/enable-remote-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPathAny) EnableRemoteId() *RelayAgent_Dhcpv6_Interface_Options_EnableRemoteIdPathAny {
	return &RelayAgent_Dhcpv6_Interface_Options_EnableRemoteIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Sets DHCPv6 OPTION_INTERFACE_ID (18) to identify the
// interface on which the client message was received.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/interface-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/config/interface-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPath) InterfaceId() *RelayAgent_Dhcpv6_Interface_Options_InterfaceIdPath {
	return &RelayAgent_Dhcpv6_Interface_Options_InterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceId (leaf): Sets DHCPv6 OPTION_INTERFACE_ID (18) to identify the
// interface on which the client message was received.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/interface-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/config/interface-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPathAny) InterfaceId() *RelayAgent_Dhcpv6_Interface_Options_InterfaceIdPathAny {
	return &RelayAgent_Dhcpv6_Interface_Options_InterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteId (leaf): Sets DHCPv6 OPTION_REMOTE_ID (37).  This option is the
// DHCPv6 equivalent for the IPv4 (DHCPv4) Relay Agent Option's
// Remote-ID suboption as specified in RFC 3046. The remote-id
// field may be used to encode a user name, remote IP address,
// interface/port identifier, etc.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/remote-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/config/remote-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPath) RemoteId() *RelayAgent_Dhcpv6_Interface_Options_RemoteIdPath {
	return &RelayAgent_Dhcpv6_Interface_Options_RemoteIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteId (leaf): Sets DHCPv6 OPTION_REMOTE_ID (37).  This option is the
// DHCPv6 equivalent for the IPv4 (DHCPv4) Relay Agent Option's
// Remote-ID suboption as specified in RFC 3046. The remote-id
// field may be used to encode a user name, remote IP address,
// interface/port identifier, etc.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/remote-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/config/remote-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPathAny) RemoteId() *RelayAgent_Dhcpv6_Interface_Options_RemoteIdPathAny {
	return &RelayAgent_Dhcpv6_Interface_Options_RemoteIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SentInterfaceId (leaf): Reflects the DHCPv6 OPTION_INTERFACE_ID (18) sent to the
// server by the system.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/sent-interface-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/state/sent-interface-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPath) SentInterfaceId() *RelayAgent_Dhcpv6_Interface_Options_SentInterfaceIdPath {
	return &RelayAgent_Dhcpv6_Interface_Options_SentInterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SentInterfaceId (leaf): Reflects the DHCPv6 OPTION_INTERFACE_ID (18) sent to the
// server by the system.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/sent-interface-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/state/sent-interface-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPathAny) SentInterfaceId() *RelayAgent_Dhcpv6_Interface_Options_SentInterfaceIdPathAny {
	return &RelayAgent_Dhcpv6_Interface_Options_SentInterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SentRemoteId (leaf): Reflects the DHCPv6 OPTION_REMOTE_ID (37) sent to the
// server by the system.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/sent-remote-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/state/sent-remote-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPath) SentRemoteId() *RelayAgent_Dhcpv6_Interface_Options_SentRemoteIdPath {
	return &RelayAgent_Dhcpv6_Interface_Options_SentRemoteIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent-remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// SentRemoteId (leaf): Reflects the DHCPv6 OPTION_REMOTE_ID (37) sent to the
// server by the system.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "state/sent-remote-id"
// Path from root: "/relay-agent/dhcpv6/interfaces/interface/options/state/sent-remote-id"
func (n *RelayAgent_Dhcpv6_Interface_OptionsPathAny) SentRemoteId() *RelayAgent_Dhcpv6_Interface_Options_SentRemoteIdPathAny {
	return &RelayAgent_Dhcpv6_Interface_Options_SentRemoteIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "sent-remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RelayAgent_Dhcpv6_OptionsPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/options YANG schema element.
type RelayAgent_Dhcpv6_OptionsPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_OptionsPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/options YANG schema element.
type RelayAgent_Dhcpv6_OptionsPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Options_EnableInterfaceIdPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/options/config/enable-interface-id YANG schema element.
type RelayAgent_Dhcpv6_Options_EnableInterfaceIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Options_EnableInterfaceIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/options/config/enable-interface-id YANG schema element.
type RelayAgent_Dhcpv6_Options_EnableInterfaceIdPathAny struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Options_EnableRemoteIdPath represents the /openconfig-relay-agent/relay-agent/dhcpv6/options/config/enable-remote-id YANG schema element.
type RelayAgent_Dhcpv6_Options_EnableRemoteIdPath struct {
	*ygot.NodePath
}

// RelayAgent_Dhcpv6_Options_EnableRemoteIdPathAny represents the wildcard version of the /openconfig-relay-agent/relay-agent/dhcpv6/options/config/enable-remote-id YANG schema element.
type RelayAgent_Dhcpv6_Options_EnableRemoteIdPathAny struct {
	*ygot.NodePath
}

// EnableInterfaceId (leaf): Enables DHCPv6 OPTION_INTERFACE_ID (18) to identify the
// interface on which the client message was received.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-interface-id"
// Path from root: "/relay-agent/dhcpv6/options/config/enable-interface-id"
func (n *RelayAgent_Dhcpv6_OptionsPath) EnableInterfaceId() *RelayAgent_Dhcpv6_Options_EnableInterfaceIdPath {
	return &RelayAgent_Dhcpv6_Options_EnableInterfaceIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableInterfaceId (leaf): Enables DHCPv6 OPTION_INTERFACE_ID (18) to identify the
// interface on which the client message was received.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-interface-id"
// Path from root: "/relay-agent/dhcpv6/options/config/enable-interface-id"
func (n *RelayAgent_Dhcpv6_OptionsPathAny) EnableInterfaceId() *RelayAgent_Dhcpv6_Options_EnableInterfaceIdPathAny {
	return &RelayAgent_Dhcpv6_Options_EnableInterfaceIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-interface-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableRemoteId (leaf): Sets DHCPv6 OPTION_REMOTE_ID (37).  This option is the
// DHCPv6 equivalent for the IPv4 (DHCPv4) Relay Agent Option's
// Remote-ID suboption as specified in RFC 3046. The remote-id
// field may be used to encode a user name, remote IP address,
// interface/port identifier, etc.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-remote-id"
// Path from root: "/relay-agent/dhcpv6/options/config/enable-remote-id"
func (n *RelayAgent_Dhcpv6_OptionsPath) EnableRemoteId() *RelayAgent_Dhcpv6_Options_EnableRemoteIdPath {
	return &RelayAgent_Dhcpv6_Options_EnableRemoteIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableRemoteId (leaf): Sets DHCPv6 OPTION_REMOTE_ID (37).  This option is the
// DHCPv6 equivalent for the IPv4 (DHCPv4) Relay Agent Option's
// Remote-ID suboption as specified in RFC 3046. The remote-id
// field may be used to encode a user name, remote IP address,
// interface/port identifier, etc.
// ----------------------------------------
// Defining module: "openconfig-relay-agent"
// Instantiating module: "openconfig-relay-agent"
// Path from parent: "config/enable-remote-id"
// Path from root: "/relay-agent/dhcpv6/options/config/enable-remote-id"
func (n *RelayAgent_Dhcpv6_OptionsPathAny) EnableRemoteId() *RelayAgent_Dhcpv6_Options_EnableRemoteIdPathAny {
	return &RelayAgent_Dhcpv6_Options_EnableRemoteIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-remote-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicyPath represents the /openconfig-routing-policy/routing-policy YANG schema element.
type RoutingPolicyPath struct {
	*ygot.NodePath
}

// RoutingPolicyPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy YANG schema element.
type RoutingPolicyPathAny struct {
	*ygot.NodePath
}

// DefinedSets (container): Predefined sets of attributes used in policy match
// statements
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "defined-sets"
// Path from root: "/routing-policy/defined-sets"
func (n *RoutingPolicyPath) DefinedSets() *RoutingPolicy_DefinedSetsPath {
	return &RoutingPolicy_DefinedSetsPath{
		NodePath: ygot.NewNodePath(
			[]string{"defined-sets"},
			map[string]interface{}{},
			n,
		),
	}
}

// DefinedSets (container): Predefined sets of attributes used in policy match
// statements
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "defined-sets"
// Path from root: "/routing-policy/defined-sets"
func (n *RoutingPolicyPathAny) DefinedSets() *RoutingPolicy_DefinedSetsPathAny {
	return &RoutingPolicy_DefinedSetsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"defined-sets"},
			map[string]interface{}{},
			n,
		),
	}
}

// PolicyDefinitionAny (list): List of top-level policy definitions, keyed by unique
// name.  These policy definitions are expected to be
// referenced (by name) in policy chains specified in import
// or export configuration statements.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "policy-definitions/policy-definition"
// Path from root: "/routing-policy/policy-definitions/policy-definition"
// Name (wildcarded): string
func (n *RoutingPolicyPath) PolicyDefinitionAny() *RoutingPolicy_PolicyDefinitionPathAny {
	return &RoutingPolicy_PolicyDefinitionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policy-definitions", "policy-definition"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// PolicyDefinitionAny (list): List of top-level policy definitions, keyed by unique
// name.  These policy definitions are expected to be
// referenced (by name) in policy chains specified in import
// or export configuration statements.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "policy-definitions/policy-definition"
// Path from root: "/routing-policy/policy-definitions/policy-definition"
// Name (wildcarded): string
func (n *RoutingPolicyPathAny) PolicyDefinitionAny() *RoutingPolicy_PolicyDefinitionPathAny {
	return &RoutingPolicy_PolicyDefinitionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policy-definitions", "policy-definition"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// PolicyDefinition (list): List of top-level policy definitions, keyed by unique
// name.  These policy definitions are expected to be
// referenced (by name) in policy chains specified in import
// or export configuration statements.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "policy-definitions/policy-definition"
// Path from root: "/routing-policy/policy-definitions/policy-definition"
// Name: string
func (n *RoutingPolicyPath) PolicyDefinition(Name string) *RoutingPolicy_PolicyDefinitionPath {
	return &RoutingPolicy_PolicyDefinitionPath{
		NodePath: ygot.NewNodePath(
			[]string{"policy-definitions", "policy-definition"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// PolicyDefinition (list): List of top-level policy definitions, keyed by unique
// name.  These policy definitions are expected to be
// referenced (by name) in policy chains specified in import
// or export configuration statements.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "policy-definitions/policy-definition"
// Path from root: "/routing-policy/policy-definitions/policy-definition"
// Name: string
func (n *RoutingPolicyPathAny) PolicyDefinition(Name string) *RoutingPolicy_PolicyDefinitionPathAny {
	return &RoutingPolicy_PolicyDefinitionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"policy-definitions", "policy-definition"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// RoutingPolicy_DefinedSetsPath represents the /openconfig-routing-policy/routing-policy/defined-sets YANG schema element.
type RoutingPolicy_DefinedSetsPath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSetsPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets YANG schema element.
type RoutingPolicy_DefinedSetsPathAny struct {
	*ygot.NodePath
}

// NeighborSetAny (list): List of defined neighbor sets for use in policies.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "neighbor-sets/neighbor-set"
// Path from root: "/routing-policy/defined-sets/neighbor-sets/neighbor-set"
// Name (wildcarded): string
func (n *RoutingPolicy_DefinedSetsPath) NeighborSetAny() *RoutingPolicy_DefinedSets_NeighborSetPathAny {
	return &RoutingPolicy_DefinedSets_NeighborSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbor-sets", "neighbor-set"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// NeighborSetAny (list): List of defined neighbor sets for use in policies.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "neighbor-sets/neighbor-set"
// Path from root: "/routing-policy/defined-sets/neighbor-sets/neighbor-set"
// Name (wildcarded): string
func (n *RoutingPolicy_DefinedSetsPathAny) NeighborSetAny() *RoutingPolicy_DefinedSets_NeighborSetPathAny {
	return &RoutingPolicy_DefinedSets_NeighborSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbor-sets", "neighbor-set"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// NeighborSet (list): List of defined neighbor sets for use in policies.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "neighbor-sets/neighbor-set"
// Path from root: "/routing-policy/defined-sets/neighbor-sets/neighbor-set"
// Name: string
func (n *RoutingPolicy_DefinedSetsPath) NeighborSet(Name string) *RoutingPolicy_DefinedSets_NeighborSetPath {
	return &RoutingPolicy_DefinedSets_NeighborSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbor-sets", "neighbor-set"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// NeighborSet (list): List of defined neighbor sets for use in policies.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "neighbor-sets/neighbor-set"
// Path from root: "/routing-policy/defined-sets/neighbor-sets/neighbor-set"
// Name: string
func (n *RoutingPolicy_DefinedSetsPathAny) NeighborSet(Name string) *RoutingPolicy_DefinedSets_NeighborSetPathAny {
	return &RoutingPolicy_DefinedSets_NeighborSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbor-sets", "neighbor-set"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// PrefixSetAny (list): List of the defined prefix sets
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefix-sets/prefix-set"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set"
// Name (wildcarded): string
func (n *RoutingPolicy_DefinedSetsPath) PrefixSetAny() *RoutingPolicy_DefinedSets_PrefixSetPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sets", "prefix-set"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// PrefixSetAny (list): List of the defined prefix sets
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefix-sets/prefix-set"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set"
// Name (wildcarded): string
func (n *RoutingPolicy_DefinedSetsPathAny) PrefixSetAny() *RoutingPolicy_DefinedSets_PrefixSetPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sets", "prefix-set"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// PrefixSet (list): List of the defined prefix sets
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefix-sets/prefix-set"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set"
// Name: string
func (n *RoutingPolicy_DefinedSetsPath) PrefixSet(Name string) *RoutingPolicy_DefinedSets_PrefixSetPath {
	return &RoutingPolicy_DefinedSets_PrefixSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sets", "prefix-set"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// PrefixSet (list): List of the defined prefix sets
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefix-sets/prefix-set"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set"
// Name: string
func (n *RoutingPolicy_DefinedSetsPathAny) PrefixSet(Name string) *RoutingPolicy_DefinedSets_PrefixSetPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefix-sets", "prefix-set"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// TagSetAny (list): List of tag set definitions.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "tag-sets/tag-set"
// Path from root: "/routing-policy/defined-sets/tag-sets/tag-set"
// Name (wildcarded): string
func (n *RoutingPolicy_DefinedSetsPath) TagSetAny() *RoutingPolicy_DefinedSets_TagSetPathAny {
	return &RoutingPolicy_DefinedSets_TagSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag-sets", "tag-set"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// TagSetAny (list): List of tag set definitions.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "tag-sets/tag-set"
// Path from root: "/routing-policy/defined-sets/tag-sets/tag-set"
// Name (wildcarded): string
func (n *RoutingPolicy_DefinedSetsPathAny) TagSetAny() *RoutingPolicy_DefinedSets_TagSetPathAny {
	return &RoutingPolicy_DefinedSets_TagSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag-sets", "tag-set"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// TagSet (list): List of tag set definitions.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "tag-sets/tag-set"
// Path from root: "/routing-policy/defined-sets/tag-sets/tag-set"
// Name: string
func (n *RoutingPolicy_DefinedSetsPath) TagSet(Name string) *RoutingPolicy_DefinedSets_TagSetPath {
	return &RoutingPolicy_DefinedSets_TagSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"tag-sets", "tag-set"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// TagSet (list): List of tag set definitions.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "tag-sets/tag-set"
// Path from root: "/routing-policy/defined-sets/tag-sets/tag-set"
// Name: string
func (n *RoutingPolicy_DefinedSetsPathAny) TagSet(Name string) *RoutingPolicy_DefinedSets_TagSetPathAny {
	return &RoutingPolicy_DefinedSets_TagSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tag-sets", "tag-set"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// RoutingPolicy_DefinedSets_NeighborSetPath represents the /openconfig-routing-policy/routing-policy/defined-sets/neighbor-sets/neighbor-set YANG schema element.
type RoutingPolicy_DefinedSets_NeighborSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_NeighborSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/neighbor-sets/neighbor-set YANG schema element.
type RoutingPolicy_DefinedSets_NeighborSetPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_NeighborSet_AddressPath represents the /openconfig-routing-policy/routing-policy/defined-sets/neighbor-sets/neighbor-set/config/address YANG schema element.
type RoutingPolicy_DefinedSets_NeighborSet_AddressPath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_NeighborSet_AddressPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/neighbor-sets/neighbor-set/config/address YANG schema element.
type RoutingPolicy_DefinedSets_NeighborSet_AddressPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_NeighborSet_NamePath represents the /openconfig-routing-policy/routing-policy/defined-sets/neighbor-sets/neighbor-set/config/name YANG schema element.
type RoutingPolicy_DefinedSets_NeighborSet_NamePath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_NeighborSet_NamePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/neighbor-sets/neighbor-set/config/name YANG schema element.
type RoutingPolicy_DefinedSets_NeighborSet_NamePathAny struct {
	*ygot.NodePath
}

// Address (leaf): List of IP addresses in the neighbor set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/address"
// Path from root: "/routing-policy/defined-sets/neighbor-sets/neighbor-set/config/address"
func (n *RoutingPolicy_DefinedSets_NeighborSetPath) Address() *RoutingPolicy_DefinedSets_NeighborSet_AddressPath {
	return &RoutingPolicy_DefinedSets_NeighborSet_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): List of IP addresses in the neighbor set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/address"
// Path from root: "/routing-policy/defined-sets/neighbor-sets/neighbor-set/config/address"
func (n *RoutingPolicy_DefinedSets_NeighborSetPathAny) Address() *RoutingPolicy_DefinedSets_NeighborSet_AddressPathAny {
	return &RoutingPolicy_DefinedSets_NeighborSet_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): name / label of the neighbor set -- this is used to
// reference the set in match conditions
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/defined-sets/neighbor-sets/neighbor-set/config/name"
func (n *RoutingPolicy_DefinedSets_NeighborSetPath) Name() *RoutingPolicy_DefinedSets_NeighborSet_NamePath {
	return &RoutingPolicy_DefinedSets_NeighborSet_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): name / label of the neighbor set -- this is used to
// reference the set in match conditions
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/defined-sets/neighbor-sets/neighbor-set/config/name"
func (n *RoutingPolicy_DefinedSets_NeighborSetPathAny) Name() *RoutingPolicy_DefinedSets_NeighborSet_NamePathAny {
	return &RoutingPolicy_DefinedSets_NeighborSet_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_DefinedSets_PrefixSetPath represents the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSetPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSet_ModePath represents the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/config/mode YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_ModePath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSet_ModePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/config/mode YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_ModePathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSet_NamePath represents the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/config/name YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_NamePath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSet_NamePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/config/name YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_NamePathAny struct {
	*ygot.NodePath
}

// Mode (leaf): Indicates the mode of the prefix set, in terms of which
// address families (IPv4, IPv6, or both) are present.  The
// mode provides a hint, but the device must validate that all
// prefixes are of the indicated type, and is expected to
// reject the configuration if there is a discrepancy.  The
// MIXED mode may not be supported on devices that require
// prefix sets to be of only one address family.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/mode"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/config/mode"
func (n *RoutingPolicy_DefinedSets_PrefixSetPath) Mode() *RoutingPolicy_DefinedSets_PrefixSet_ModePath {
	return &RoutingPolicy_DefinedSets_PrefixSet_ModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): Indicates the mode of the prefix set, in terms of which
// address families (IPv4, IPv6, or both) are present.  The
// mode provides a hint, but the device must validate that all
// prefixes are of the indicated type, and is expected to
// reject the configuration if there is a discrepancy.  The
// MIXED mode may not be supported on devices that require
// prefix sets to be of only one address family.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/mode"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/config/mode"
func (n *RoutingPolicy_DefinedSets_PrefixSetPathAny) Mode() *RoutingPolicy_DefinedSets_PrefixSet_ModePathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): name / label of the prefix set -- this is used to
// reference the set in match conditions
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/config/name"
func (n *RoutingPolicy_DefinedSets_PrefixSetPath) Name() *RoutingPolicy_DefinedSets_PrefixSet_NamePath {
	return &RoutingPolicy_DefinedSets_PrefixSet_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): name / label of the prefix set -- this is used to
// reference the set in match conditions
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/config/name"
func (n *RoutingPolicy_DefinedSets_PrefixSetPathAny) Name() *RoutingPolicy_DefinedSets_PrefixSet_NamePathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixAny (list): List of prefixes in the prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefixes/prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix"
// IpPrefix (wildcarded): string
// MasklengthRange (wildcarded): string
func (n *RoutingPolicy_DefinedSets_PrefixSetPath) PrefixAny() *RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"ip-prefix": "*", "masklength-range": "*"},
			n,
		),
	}
}

// PrefixAny (list): List of prefixes in the prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefixes/prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix"
// IpPrefix (wildcarded): string
// MasklengthRange (wildcarded): string
func (n *RoutingPolicy_DefinedSets_PrefixSetPathAny) PrefixAny() *RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"ip-prefix": "*", "masklength-range": "*"},
			n,
		),
	}
}

// PrefixAnyMasklengthRange (list): List of prefixes in the prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefixes/prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix"
// IpPrefix: string
// MasklengthRange (wildcarded): string
func (n *RoutingPolicy_DefinedSets_PrefixSetPath) PrefixAnyMasklengthRange(IpPrefix string) *RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"ip-prefix": IpPrefix, "masklength-range": "*"},
			n,
		),
	}
}

// PrefixAnyMasklengthRange (list): List of prefixes in the prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefixes/prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix"
// IpPrefix: string
// MasklengthRange (wildcarded): string
func (n *RoutingPolicy_DefinedSets_PrefixSetPathAny) PrefixAnyMasklengthRange(IpPrefix string) *RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"ip-prefix": IpPrefix, "masklength-range": "*"},
			n,
		),
	}
}

// PrefixAnyIpPrefix (list): List of prefixes in the prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefixes/prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix"
// IpPrefix (wildcarded): string
// MasklengthRange: string
func (n *RoutingPolicy_DefinedSets_PrefixSetPath) PrefixAnyIpPrefix(MasklengthRange string) *RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"ip-prefix": "*", "masklength-range": MasklengthRange},
			n,
		),
	}
}

// PrefixAnyIpPrefix (list): List of prefixes in the prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefixes/prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix"
// IpPrefix (wildcarded): string
// MasklengthRange: string
func (n *RoutingPolicy_DefinedSets_PrefixSetPathAny) PrefixAnyIpPrefix(MasklengthRange string) *RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"ip-prefix": "*", "masklength-range": MasklengthRange},
			n,
		),
	}
}

// Prefix (list): List of prefixes in the prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefixes/prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix"
// IpPrefix: string
// MasklengthRange: string
func (n *RoutingPolicy_DefinedSets_PrefixSetPath) Prefix(IpPrefix string, MasklengthRange string) *RoutingPolicy_DefinedSets_PrefixSet_PrefixPath {
	return &RoutingPolicy_DefinedSets_PrefixSet_PrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"ip-prefix": IpPrefix, "masklength-range": MasklengthRange},
			n,
		),
	}
}

// Prefix (list): List of prefixes in the prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "prefixes/prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix"
// IpPrefix: string
// MasklengthRange: string
func (n *RoutingPolicy_DefinedSets_PrefixSetPathAny) Prefix(IpPrefix string, MasklengthRange string) *RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"prefixes", "prefix"},
			map[string]interface{}{"ip-prefix": IpPrefix, "masklength-range": MasklengthRange},
			n,
		),
	}
}

// RoutingPolicy_DefinedSets_PrefixSet_PrefixPath represents the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_PrefixPath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSet_Prefix_IpPrefixPath represents the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix/config/ip-prefix YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_Prefix_IpPrefixPath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSet_Prefix_IpPrefixPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix/config/ip-prefix YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_Prefix_IpPrefixPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSet_Prefix_MasklengthRangePath represents the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix/config/masklength-range YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_Prefix_MasklengthRangePath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_PrefixSet_Prefix_MasklengthRangePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix/config/masklength-range YANG schema element.
type RoutingPolicy_DefinedSets_PrefixSet_Prefix_MasklengthRangePathAny struct {
	*ygot.NodePath
}

// IpPrefix (leaf): The prefix member in CIDR notation -- while the
// prefix may be either IPv4 or IPv6, most
// implementations require all members of the prefix set
// to be the same address family.  Mixing address types in
// the same prefix set is likely to cause an error.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/ip-prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix/config/ip-prefix"
func (n *RoutingPolicy_DefinedSets_PrefixSet_PrefixPath) IpPrefix() *RoutingPolicy_DefinedSets_PrefixSet_Prefix_IpPrefixPath {
	return &RoutingPolicy_DefinedSets_PrefixSet_Prefix_IpPrefixPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// IpPrefix (leaf): The prefix member in CIDR notation -- while the
// prefix may be either IPv4 or IPv6, most
// implementations require all members of the prefix set
// to be the same address family.  Mixing address types in
// the same prefix set is likely to cause an error.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/ip-prefix"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix/config/ip-prefix"
func (n *RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny) IpPrefix() *RoutingPolicy_DefinedSets_PrefixSet_Prefix_IpPrefixPathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_Prefix_IpPrefixPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ip-prefix"},
			map[string]interface{}{},
			n,
		),
	}
}

// MasklengthRange (leaf): Defines a range for the masklength, or 'exact' if
// the prefix has an exact length.
//
// Example: 10.3.192.0/21 through 10.3.192.0/24 would be
// expressed as prefix: 10.3.192.0/21,
// masklength-range: 21..24.
//
// Example: 10.3.192.0/21 would be expressed as
// prefix: 10.3.192.0/21,
// masklength-range: exact
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/masklength-range"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix/config/masklength-range"
func (n *RoutingPolicy_DefinedSets_PrefixSet_PrefixPath) MasklengthRange() *RoutingPolicy_DefinedSets_PrefixSet_Prefix_MasklengthRangePath {
	return &RoutingPolicy_DefinedSets_PrefixSet_Prefix_MasklengthRangePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "masklength-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// MasklengthRange (leaf): Defines a range for the masklength, or 'exact' if
// the prefix has an exact length.
//
// Example: 10.3.192.0/21 through 10.3.192.0/24 would be
// expressed as prefix: 10.3.192.0/21,
// masklength-range: 21..24.
//
// Example: 10.3.192.0/21 would be expressed as
// prefix: 10.3.192.0/21,
// masklength-range: exact
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/masklength-range"
// Path from root: "/routing-policy/defined-sets/prefix-sets/prefix-set/prefixes/prefix/config/masklength-range"
func (n *RoutingPolicy_DefinedSets_PrefixSet_PrefixPathAny) MasklengthRange() *RoutingPolicy_DefinedSets_PrefixSet_Prefix_MasklengthRangePathAny {
	return &RoutingPolicy_DefinedSets_PrefixSet_Prefix_MasklengthRangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "masklength-range"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_DefinedSets_TagSetPath represents the /openconfig-routing-policy/routing-policy/defined-sets/tag-sets/tag-set YANG schema element.
type RoutingPolicy_DefinedSets_TagSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_TagSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/tag-sets/tag-set YANG schema element.
type RoutingPolicy_DefinedSets_TagSetPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_TagSet_NamePath represents the /openconfig-routing-policy/routing-policy/defined-sets/tag-sets/tag-set/config/name YANG schema element.
type RoutingPolicy_DefinedSets_TagSet_NamePath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_TagSet_NamePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/tag-sets/tag-set/config/name YANG schema element.
type RoutingPolicy_DefinedSets_TagSet_NamePathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_TagSet_TagValuePath represents the /openconfig-routing-policy/routing-policy/defined-sets/tag-sets/tag-set/config/tag-value YANG schema element.
type RoutingPolicy_DefinedSets_TagSet_TagValuePath struct {
	*ygot.NodePath
}

// RoutingPolicy_DefinedSets_TagSet_TagValuePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/defined-sets/tag-sets/tag-set/config/tag-value YANG schema element.
type RoutingPolicy_DefinedSets_TagSet_TagValuePathAny struct {
	*ygot.NodePath
}

// Name (leaf): name / label of the tag set -- this is used to reference
// the set in match conditions
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/defined-sets/tag-sets/tag-set/config/name"
func (n *RoutingPolicy_DefinedSets_TagSetPath) Name() *RoutingPolicy_DefinedSets_TagSet_NamePath {
	return &RoutingPolicy_DefinedSets_TagSet_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): name / label of the tag set -- this is used to reference
// the set in match conditions
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/defined-sets/tag-sets/tag-set/config/name"
func (n *RoutingPolicy_DefinedSets_TagSetPathAny) Name() *RoutingPolicy_DefinedSets_TagSet_NamePathAny {
	return &RoutingPolicy_DefinedSets_TagSet_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// TagValue (leaf): Value of the tag set member
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/tag-value"
// Path from root: "/routing-policy/defined-sets/tag-sets/tag-set/config/tag-value"
func (n *RoutingPolicy_DefinedSets_TagSetPath) TagValue() *RoutingPolicy_DefinedSets_TagSet_TagValuePath {
	return &RoutingPolicy_DefinedSets_TagSet_TagValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tag-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// TagValue (leaf): Value of the tag set member
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/tag-value"
// Path from root: "/routing-policy/defined-sets/tag-sets/tag-set/config/tag-value"
func (n *RoutingPolicy_DefinedSets_TagSetPathAny) TagValue() *RoutingPolicy_DefinedSets_TagSet_TagValuePathAny {
	return &RoutingPolicy_DefinedSets_TagSet_TagValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tag-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinitionPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition YANG schema element.
type RoutingPolicy_PolicyDefinitionPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinitionPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition YANG schema element.
type RoutingPolicy_PolicyDefinitionPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_NamePath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/config/name YANG schema element.
type RoutingPolicy_PolicyDefinition_NamePath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_NamePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/config/name YANG schema element.
type RoutingPolicy_PolicyDefinition_NamePathAny struct {
	*ygot.NodePath
}

// Name (leaf): Name of the top-level policy definition -- this name
// is used in references to the current policy
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/policy-definitions/policy-definition/config/name"
func (n *RoutingPolicy_PolicyDefinitionPath) Name() *RoutingPolicy_PolicyDefinition_NamePath {
	return &RoutingPolicy_PolicyDefinition_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Name of the top-level policy definition -- this name
// is used in references to the current policy
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/policy-definitions/policy-definition/config/name"
func (n *RoutingPolicy_PolicyDefinitionPathAny) Name() *RoutingPolicy_PolicyDefinition_NamePathAny {
	return &RoutingPolicy_PolicyDefinition_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// StatementAny (list): Policy statements group conditions and actions
// within a policy definition.  They are evaluated in
// the order specified (see the description of policy
// evaluation at the top of this module.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "statements/statement"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement"
// Name (wildcarded): string
func (n *RoutingPolicy_PolicyDefinitionPath) StatementAny() *RoutingPolicy_PolicyDefinition_StatementPathAny {
	return &RoutingPolicy_PolicyDefinition_StatementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"statements", "statement"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// StatementAny (list): Policy statements group conditions and actions
// within a policy definition.  They are evaluated in
// the order specified (see the description of policy
// evaluation at the top of this module.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "statements/statement"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement"
// Name (wildcarded): string
func (n *RoutingPolicy_PolicyDefinitionPathAny) StatementAny() *RoutingPolicy_PolicyDefinition_StatementPathAny {
	return &RoutingPolicy_PolicyDefinition_StatementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"statements", "statement"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Statement (list): Policy statements group conditions and actions
// within a policy definition.  They are evaluated in
// the order specified (see the description of policy
// evaluation at the top of this module.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "statements/statement"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement"
// Name: string
func (n *RoutingPolicy_PolicyDefinitionPath) Statement(Name string) *RoutingPolicy_PolicyDefinition_StatementPath {
	return &RoutingPolicy_PolicyDefinition_StatementPath{
		NodePath: ygot.NewNodePath(
			[]string{"statements", "statement"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Statement (list): Policy statements group conditions and actions
// within a policy definition.  They are evaluated in
// the order specified (see the description of policy
// evaluation at the top of this module.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "statements/statement"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement"
// Name: string
func (n *RoutingPolicy_PolicyDefinitionPathAny) Statement(Name string) *RoutingPolicy_PolicyDefinition_StatementPathAny {
	return &RoutingPolicy_PolicyDefinition_StatementPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"statements", "statement"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_StatementPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement YANG schema element.
type RoutingPolicy_PolicyDefinition_StatementPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_StatementPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement YANG schema element.
type RoutingPolicy_PolicyDefinition_StatementPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_NamePath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/config/name YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_NamePath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_NamePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/config/name YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_NamePathAny struct {
	*ygot.NodePath
}

// Actions (container): Top-level container for policy action statements
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "actions"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions"
func (n *RoutingPolicy_PolicyDefinition_StatementPath) Actions() *RoutingPolicy_PolicyDefinition_Statement_ActionsPath {
	return &RoutingPolicy_PolicyDefinition_Statement_ActionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"actions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Actions (container): Top-level container for policy action statements
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "actions"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions"
func (n *RoutingPolicy_PolicyDefinition_StatementPathAny) Actions() *RoutingPolicy_PolicyDefinition_Statement_ActionsPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_ActionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"actions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Conditions (container): Condition statements for the current policy statement
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "conditions"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions"
func (n *RoutingPolicy_PolicyDefinition_StatementPath) Conditions() *RoutingPolicy_PolicyDefinition_Statement_ConditionsPath {
	return &RoutingPolicy_PolicyDefinition_Statement_ConditionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"conditions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Conditions (container): Condition statements for the current policy statement
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "conditions"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions"
func (n *RoutingPolicy_PolicyDefinition_StatementPathAny) Conditions() *RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"conditions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): name of the policy statement
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/config/name"
func (n *RoutingPolicy_PolicyDefinition_StatementPath) Name() *RoutingPolicy_PolicyDefinition_Statement_NamePath {
	return &RoutingPolicy_PolicyDefinition_Statement_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): name of the policy statement
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/name"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/config/name"
func (n *RoutingPolicy_PolicyDefinition_StatementPathAny) Name() *RoutingPolicy_PolicyDefinition_Statement_NamePathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_Statement_ActionsPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_ActionsPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_ActionsPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_ActionsPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_PolicyResultPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/config/policy-result YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_PolicyResultPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_PolicyResultPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/config/policy-result YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_PolicyResultPathAny struct {
	*ygot.NodePath
}

// PolicyResult (leaf): Select the final disposition for the route, either
// accept or reject.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/policy-result"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/config/policy-result"
func (n *RoutingPolicy_PolicyDefinition_Statement_ActionsPath) PolicyResult() *RoutingPolicy_PolicyDefinition_Statement_Actions_PolicyResultPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_PolicyResultPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "policy-result"},
			map[string]interface{}{},
			n,
		),
	}
}

// PolicyResult (leaf): Select the final disposition for the route, either
// accept or reject.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/policy-result"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/config/policy-result"
func (n *RoutingPolicy_PolicyDefinition_Statement_ActionsPathAny) PolicyResult() *RoutingPolicy_PolicyDefinition_Statement_Actions_PolicyResultPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_PolicyResultPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "policy-result"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (container): Policy actions associated with setting tags for a particular
// route. A tag is an abstract entity which can be mapped to underlying
// protocol attributes where applicable.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "set-tag"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag"
func (n *RoutingPolicy_PolicyDefinition_Statement_ActionsPath) SetTag() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPath{
		NodePath: ygot.NewNodePath(
			[]string{"set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// SetTag (container): Policy actions associated with setting tags for a particular
// route. A tag is an abstract entity which can be mapped to underlying
// protocol attributes where applicable.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "set-tag"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag"
func (n *RoutingPolicy_PolicyDefinition_Statement_ActionsPathAny) SetTag() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"set-tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ModePath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/config/mode YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ModePath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ModePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/config/mode YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ModePathAny struct {
	*ygot.NodePath
}

// Inline (container): The tags specified in this container are set on a route using
// the values directly. It is applicable when the mode of application
// is explicitly specified as INLINE.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "inline"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/inline"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPath) Inline() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePath {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePath{
		NodePath: ygot.NewNodePath(
			[]string{"inline"},
			map[string]interface{}{},
			n,
		),
	}
}

// Inline (container): The tags specified in this container are set on a route using
// the values directly. It is applicable when the mode of application
// is explicitly specified as INLINE.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "inline"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/inline"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPathAny) Inline() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"inline"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): This leaf controls the source of the tags that are set as a result
// of the action. In the case that the INLINE value is specified, the
// list of tags specified within the action is applied to matching prefixes.
// In the case that the REFERENCE value is specified, a pre-defined set of
// tags is utilised.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/mode"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/config/mode"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPath) Mode() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ModePath {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mode (leaf): This leaf controls the source of the tags that are set as a result
// of the action. In the case that the INLINE value is specified, the
// list of tags specified within the action is applied to matching prefixes.
// In the case that the REFERENCE value is specified, a pre-defined set of
// tags is utilised.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/mode"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/config/mode"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPathAny) Mode() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ModePathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reference (container): This container is applicable when the mode of application is explicitly
// specified to as REFERENCE. The tags set on a route are those that are
// specified within the tag-set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "reference"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/reference"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPath) Reference() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePath {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePath{
		NodePath: ygot.NewNodePath(
			[]string{"reference"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reference (container): This container is applicable when the mode of application is explicitly
// specified to as REFERENCE. The tags set on a route are those that are
// specified within the tag-set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "reference"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/reference"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTagPathAny) Reference() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"reference"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/inline YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/inline YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Inline_TagPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/inline/config/tag YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Inline_TagPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Inline_TagPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/inline/config/tag YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Inline_TagPathAny struct {
	*ygot.NodePath
}

// Tag (leaf): Set one or more tags for prefixes that match the specified condition(s)
// using the specified tag values. When a tag is set it MUST be possible to
// match the value set in subsequent policies on the local device. Where the
// protocol that is carrying the prefix has a tag field (OSPF, and IS-IS in
// particular) the tag MUST be set in the corresponding protocol advertisements
// of the prefix.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/tag"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/inline/config/tag"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePath) Tag() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Inline_TagPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Inline_TagPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tag (leaf): Set one or more tags for prefixes that match the specified condition(s)
// using the specified tag values. When a tag is set it MUST be possible to
// match the value set in subsequent policies on the local device. Where the
// protocol that is carrying the prefix has a tag field (OSPF, and IS-IS in
// particular) the tag MUST be set in the corresponding protocol advertisements
// of the prefix.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/tag"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/inline/config/tag"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_InlinePathAny) Tag() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Inline_TagPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Inline_TagPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tag"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/reference YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/reference YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Reference_TagSetPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/reference/config/tag-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Reference_TagSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Reference_TagSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/reference/config/tag-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Reference_TagSetPathAny struct {
	*ygot.NodePath
}

// TagSet (leaf): Use the referenced tag-set to set tags on the prefixes that match the
// specified conditions. When a tag is set it MUST be possible to match the
// value set in subsequent policies on the local device. where the protocol that
// is carrying the prefix has a tag field (OSPF, and IS-IS for in particular)
// the tag MUST be set in the corresponding protocol advertisements of the
// prefix.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/tag-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/reference/config/tag-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePath) TagSet() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Reference_TagSetPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Reference_TagSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tag-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// TagSet (leaf): Use the referenced tag-set to set tags on the prefixes that match the
// specified conditions. When a tag is set it MUST be possible to match the
// value set in subsequent policies on the local device. where the protocol that
// is carrying the prefix has a tag field (OSPF, and IS-IS for in particular)
// the tag MUST be set in the corresponding protocol advertisements of the
// prefix.
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/tag-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/actions/set-tag/reference/config/tag-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_ReferencePathAny) TagSet() *RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Reference_TagSetPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Actions_SetTag_Reference_TagSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tag-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_Statement_ConditionsPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_ConditionsPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_CallPolicyPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/config/call-policy YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_CallPolicyPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_CallPolicyPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/config/call-policy YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_CallPolicyPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_InstallProtocolEqPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/config/install-protocol-eq YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_InstallProtocolEqPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_InstallProtocolEqPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/config/install-protocol-eq YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_InstallProtocolEqPathAny struct {
	*ygot.NodePath
}

// CallPolicy (leaf): Applies the statements from the specified policy
// definition and then returns control the current
// policy statement. Note that the called policy may
// itself call other policies (subject to
// implementation limitations). This is intended to
// provide a policy 'subroutine' capability.  The
// called policy should contain an explicit or a
// default route disposition that returns an
// effective true (accept-route) or false
// (reject-route), otherwise the behavior may be
// ambiguous and implementation dependent
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/call-policy"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/config/call-policy"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPath) CallPolicy() *RoutingPolicy_PolicyDefinition_Statement_Conditions_CallPolicyPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_CallPolicyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "call-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// CallPolicy (leaf): Applies the statements from the specified policy
// definition and then returns control the current
// policy statement. Note that the called policy may
// itself call other policies (subject to
// implementation limitations). This is intended to
// provide a policy 'subroutine' capability.  The
// called policy should contain an explicit or a
// default route disposition that returns an
// effective true (accept-route) or false
// (reject-route), otherwise the behavior may be
// ambiguous and implementation dependent
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/call-policy"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/config/call-policy"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny) CallPolicy() *RoutingPolicy_PolicyDefinition_Statement_Conditions_CallPolicyPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_CallPolicyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "call-policy"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstallProtocolEq (leaf): Condition to check the protocol / method used to install
// the route into the local routing table
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/install-protocol-eq"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/config/install-protocol-eq"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPath) InstallProtocolEq() *RoutingPolicy_PolicyDefinition_Statement_Conditions_InstallProtocolEqPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_InstallProtocolEqPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "install-protocol-eq"},
			map[string]interface{}{},
			n,
		),
	}
}

// InstallProtocolEq (leaf): Condition to check the protocol / method used to install
// the route into the local routing table
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/install-protocol-eq"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/config/install-protocol-eq"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny) InstallProtocolEq() *RoutingPolicy_PolicyDefinition_Statement_Conditions_InstallProtocolEqPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_InstallProtocolEqPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "install-protocol-eq"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchInterface (container): Top-level container for interface match conditions
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "match-interface"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPath) MatchInterface() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"match-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchInterface (container): Top-level container for interface match conditions
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "match-interface"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny) MatchInterface() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"match-interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchNeighborSet (container): Match a referenced neighbor set according to the logic
// defined in the match-set-options-leaf
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "match-neighbor-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPath) MatchNeighborSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"match-neighbor-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchNeighborSet (container): Match a referenced neighbor set according to the logic
// defined in the match-set-options-leaf
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "match-neighbor-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny) MatchNeighborSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"match-neighbor-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchPrefixSet (container): Match a referenced prefix-set according to the logic
// defined in the match-set-options leaf
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "match-prefix-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPath) MatchPrefixSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"match-prefix-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchPrefixSet (container): Match a referenced prefix-set according to the logic
// defined in the match-set-options leaf
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "match-prefix-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny) MatchPrefixSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"match-prefix-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchTagSet (container): Match a referenced tag set according to the logic defined
// in the match-options-set leaf
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "match-tag-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPath) MatchTagSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"match-tag-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchTagSet (container): Match a referenced tag set according to the logic defined
// in the match-options-set leaf
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "match-tag-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_ConditionsPathAny) MatchTagSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"match-tag-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_InterfacePath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface/config/interface YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_InterfacePath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_InterfacePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface/config/interface YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_InterfacePathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_SubinterfacePath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface/config/subinterface YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_SubinterfacePath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_SubinterfacePathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface/config/subinterface YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_SubinterfacePathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/interface"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface/config/interface"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePath) Interface() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_InterfacePath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to a base interface.  If a reference to a
// subinterface is required, this leaf must be specified
// to indicate the base interface.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/interface"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface/config/interface"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePathAny) Interface() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_InterfacePathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/subinterface"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface/config/subinterface"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePath) Subinterface() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_SubinterfacePath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_SubinterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Subinterface (leaf): Reference to a subinterface -- this requires the base
// interface to be specified using the interface leaf in
// this container.  If only a reference to a base interface
// is requuired, this leaf should not be set.
// ----------------------------------------
// Defining module: "openconfig-interfaces"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/subinterface"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-interface/config/subinterface"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterfacePathAny) Subinterface() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_SubinterfacePathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchInterface_SubinterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "subinterface"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_MatchSetOptionsPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set/config/match-set-options YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_MatchSetOptionsPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_MatchSetOptionsPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set/config/match-set-options YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_MatchSetOptionsPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_NeighborSetPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set/config/neighbor-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_NeighborSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_NeighborSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set/config/neighbor-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_NeighborSetPathAny struct {
	*ygot.NodePath
}

// MatchSetOptions (leaf): Optional parameter that governs the behaviour of the
// match operation.  This leaf only supports matching on ANY
// member of the set or inverting the match.  Matching on ALL is
// not supported
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/match-set-options"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set/config/match-set-options"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPath) MatchSetOptions() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_MatchSetOptionsPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_MatchSetOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "match-set-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchSetOptions (leaf): Optional parameter that governs the behaviour of the
// match operation.  This leaf only supports matching on ANY
// member of the set or inverting the match.  Matching on ALL is
// not supported
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/match-set-options"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set/config/match-set-options"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPathAny) MatchSetOptions() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_MatchSetOptionsPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_MatchSetOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "match-set-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborSet (leaf): References a defined neighbor set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/neighbor-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set/config/neighbor-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPath) NeighborSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_NeighborSetPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_NeighborSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "neighbor-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborSet (leaf): References a defined neighbor set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/neighbor-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-neighbor-set/config/neighbor-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSetPathAny) NeighborSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_NeighborSetPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchNeighborSet_NeighborSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "neighbor-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_MatchSetOptionsPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set/config/match-set-options YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_MatchSetOptionsPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_MatchSetOptionsPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set/config/match-set-options YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_MatchSetOptionsPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_PrefixSetPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set/config/prefix-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_PrefixSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_PrefixSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set/config/prefix-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_PrefixSetPathAny struct {
	*ygot.NodePath
}

// MatchSetOptions (leaf): Optional parameter that governs the behaviour of the
// match operation.  This leaf only supports matching on ANY
// member of the set or inverting the match.  Matching on ALL is
// not supported
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/match-set-options"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set/config/match-set-options"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPath) MatchSetOptions() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_MatchSetOptionsPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_MatchSetOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "match-set-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchSetOptions (leaf): Optional parameter that governs the behaviour of the
// match operation.  This leaf only supports matching on ANY
// member of the set or inverting the match.  Matching on ALL is
// not supported
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/match-set-options"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set/config/match-set-options"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPathAny) MatchSetOptions() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_MatchSetOptionsPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_MatchSetOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "match-set-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixSet (leaf): References a defined prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/prefix-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set/config/prefix-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPath) PrefixSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_PrefixSetPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_PrefixSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// PrefixSet (leaf): References a defined prefix set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/prefix-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-prefix-set/config/prefix-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSetPathAny) PrefixSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_PrefixSetPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchPrefixSet_PrefixSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefix-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_MatchSetOptionsPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set/config/match-set-options YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_MatchSetOptionsPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_MatchSetOptionsPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set/config/match-set-options YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_MatchSetOptionsPathAny struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_TagSetPath represents the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set/config/tag-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_TagSetPath struct {
	*ygot.NodePath
}

// RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_TagSetPathAny represents the wildcard version of the /openconfig-routing-policy/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set/config/tag-set YANG schema element.
type RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_TagSetPathAny struct {
	*ygot.NodePath
}

// MatchSetOptions (leaf): Optional parameter that governs the behaviour of the
// match operation.  This leaf only supports matching on ANY
// member of the set or inverting the match.  Matching on ALL is
// not supported
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/match-set-options"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set/config/match-set-options"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPath) MatchSetOptions() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_MatchSetOptionsPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_MatchSetOptionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "match-set-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// MatchSetOptions (leaf): Optional parameter that governs the behaviour of the
// match operation.  This leaf only supports matching on ANY
// member of the set or inverting the match.  Matching on ALL is
// not supported
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/match-set-options"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set/config/match-set-options"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPathAny) MatchSetOptions() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_MatchSetOptionsPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_MatchSetOptionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "match-set-options"},
			map[string]interface{}{},
			n,
		),
	}
}

// TagSet (leaf): References a defined tag set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/tag-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set/config/tag-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPath) TagSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_TagSetPath {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_TagSetPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tag-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// TagSet (leaf): References a defined tag set
// ----------------------------------------
// Defining module: "openconfig-routing-policy"
// Instantiating module: "openconfig-routing-policy"
// Path from parent: "config/tag-set"
// Path from root: "/routing-policy/policy-definitions/policy-definition/statements/statement/conditions/match-tag-set/config/tag-set"
func (n *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSetPathAny) TagSet() *RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_TagSetPathAny {
	return &RoutingPolicy_PolicyDefinition_Statement_Conditions_MatchTagSet_TagSetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tag-set"},
			map[string]interface{}{},
			n,
		),
	}
}

// StpPath represents the /openconfig-spanning-tree/stp YANG schema element.
type StpPath struct {
	*ygot.NodePath
}

// StpPathAny represents the wildcard version of the /openconfig-spanning-tree/stp YANG schema element.
type StpPathAny struct {
	*ygot.NodePath
}

// Global (container): Global configuration and state data
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "global"
// Path from root: "/stp/global"
func (n *StpPath) Global() *Stp_GlobalPath {
	return &Stp_GlobalPath{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// Global (container): Global configuration and state data
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "global"
// Path from root: "/stp/global"
func (n *StpPathAny) Global() *Stp_GlobalPathAny {
	return &Stp_GlobalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"global"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/interfaces/interface"
// Name (wildcarded): string
func (n *StpPath) InterfaceAny() *Stp_InterfacePathAny {
	return &Stp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/interfaces/interface"
// Name (wildcarded): string
func (n *StpPathAny) InterfaceAny() *Stp_InterfacePathAny {
	return &Stp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Interface (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/interfaces/interface"
// Name: string
func (n *StpPath) Interface(Name string) *Stp_InterfacePath {
	return &Stp_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Interface (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/interfaces/interface"
// Name: string
func (n *StpPathAny) Interface(Name string) *Stp_InterfacePathAny {
	return &Stp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Mstp (container): Multi Spanning-tree protocol configuration and operation
// data
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "mstp"
// Path from root: "/stp/mstp"
func (n *StpPath) Mstp() *Stp_MstpPath {
	return &Stp_MstpPath{
		NodePath: ygot.NewNodePath(
			[]string{"mstp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mstp (container): Multi Spanning-tree protocol configuration and operation
// data
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "mstp"
// Path from root: "/stp/mstp"
func (n *StpPathAny) Mstp() *Stp_MstpPathAny {
	return &Stp_MstpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mstp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Rstp (container): Rapid Spanning-tree protocol configuration and operation
// data
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "rstp"
// Path from root: "/stp/rstp"
func (n *StpPath) Rstp() *Stp_RstpPath {
	return &Stp_RstpPath{
		NodePath: ygot.NewNodePath(
			[]string{"rstp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Rstp (container): Rapid Spanning-tree protocol configuration and operation
// data
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "rstp"
// Path from root: "/stp/rstp"
func (n *StpPathAny) Rstp() *Stp_RstpPathAny {
	return &Stp_RstpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rstp"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanAny (list): List of the vlans
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "rapid-pvst/vlan"
// Path from root: "/stp/rapid-pvst/vlan"
// VlanId (wildcarded): uint16
func (n *StpPath) VlanAny() *Stp_VlanPathAny {
	return &Stp_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rapid-pvst", "vlan"},
			map[string]interface{}{"vlan-id": "*"},
			n,
		),
	}
}

// VlanAny (list): List of the vlans
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "rapid-pvst/vlan"
// Path from root: "/stp/rapid-pvst/vlan"
// VlanId (wildcarded): uint16
func (n *StpPathAny) VlanAny() *Stp_VlanPathAny {
	return &Stp_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rapid-pvst", "vlan"},
			map[string]interface{}{"vlan-id": "*"},
			n,
		),
	}
}

// Vlan (list): List of the vlans
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "rapid-pvst/vlan"
// Path from root: "/stp/rapid-pvst/vlan"
// VlanId: uint16
func (n *StpPath) Vlan(VlanId uint16) *Stp_VlanPath {
	return &Stp_VlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"rapid-pvst", "vlan"},
			map[string]interface{}{"vlan-id": VlanId},
			n,
		),
	}
}

// Vlan (list): List of the vlans
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "rapid-pvst/vlan"
// Path from root: "/stp/rapid-pvst/vlan"
// VlanId: uint16
func (n *StpPathAny) Vlan(VlanId uint16) *Stp_VlanPathAny {
	return &Stp_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"rapid-pvst", "vlan"},
			map[string]interface{}{"vlan-id": VlanId},
			n,
		),
	}
}

// Stp_GlobalPath represents the /openconfig-spanning-tree/stp/global YANG schema element.
type Stp_GlobalPath struct {
	*ygot.NodePath
}

// Stp_GlobalPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/global YANG schema element.
type Stp_GlobalPathAny struct {
	*ygot.NodePath
}

// Stp_Global_BpduFilterPath represents the /openconfig-spanning-tree/stp/global/config/bpdu-filter YANG schema element.
type Stp_Global_BpduFilterPath struct {
	*ygot.NodePath
}

// Stp_Global_BpduFilterPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/global/config/bpdu-filter YANG schema element.
type Stp_Global_BpduFilterPathAny struct {
	*ygot.NodePath
}

// Stp_Global_BpduGuardPath represents the /openconfig-spanning-tree/stp/global/config/bpdu-guard YANG schema element.
type Stp_Global_BpduGuardPath struct {
	*ygot.NodePath
}

// Stp_Global_BpduGuardPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/global/config/bpdu-guard YANG schema element.
type Stp_Global_BpduGuardPathAny struct {
	*ygot.NodePath
}

// Stp_Global_BpduguardTimeoutRecoveryPath represents the /openconfig-spanning-tree/stp/global/config/bpduguard-timeout-recovery YANG schema element.
type Stp_Global_BpduguardTimeoutRecoveryPath struct {
	*ygot.NodePath
}

// Stp_Global_BpduguardTimeoutRecoveryPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/global/config/bpduguard-timeout-recovery YANG schema element.
type Stp_Global_BpduguardTimeoutRecoveryPathAny struct {
	*ygot.NodePath
}

// Stp_Global_BridgeAssurancePath represents the /openconfig-spanning-tree/stp/global/config/bridge-assurance YANG schema element.
type Stp_Global_BridgeAssurancePath struct {
	*ygot.NodePath
}

// Stp_Global_BridgeAssurancePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/global/config/bridge-assurance YANG schema element.
type Stp_Global_BridgeAssurancePathAny struct {
	*ygot.NodePath
}

// Stp_Global_EnabledProtocolPath represents the /openconfig-spanning-tree/stp/global/config/enabled-protocol YANG schema element.
type Stp_Global_EnabledProtocolPath struct {
	*ygot.NodePath
}

// Stp_Global_EnabledProtocolPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/global/config/enabled-protocol YANG schema element.
type Stp_Global_EnabledProtocolPathAny struct {
	*ygot.NodePath
}

// Stp_Global_EtherchannelMisconfigGuardPath represents the /openconfig-spanning-tree/stp/global/config/etherchannel-misconfig-guard YANG schema element.
type Stp_Global_EtherchannelMisconfigGuardPath struct {
	*ygot.NodePath
}

// Stp_Global_EtherchannelMisconfigGuardPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/global/config/etherchannel-misconfig-guard YANG schema element.
type Stp_Global_EtherchannelMisconfigGuardPathAny struct {
	*ygot.NodePath
}

// Stp_Global_LoopGuardPath represents the /openconfig-spanning-tree/stp/global/config/loop-guard YANG schema element.
type Stp_Global_LoopGuardPath struct {
	*ygot.NodePath
}

// Stp_Global_LoopGuardPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/global/config/loop-guard YANG schema element.
type Stp_Global_LoopGuardPathAny struct {
	*ygot.NodePath
}

// BpduFilter (leaf): Enable edge port BPDU filter
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpdu-filter"
// Path from root: "/stp/global/config/bpdu-filter"
func (n *Stp_GlobalPath) BpduFilter() *Stp_Global_BpduFilterPath {
	return &Stp_Global_BpduFilterPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpdu-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduFilter (leaf): Enable edge port BPDU filter
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpdu-filter"
// Path from root: "/stp/global/config/bpdu-filter"
func (n *Stp_GlobalPathAny) BpduFilter() *Stp_Global_BpduFilterPathAny {
	return &Stp_Global_BpduFilterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpdu-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduGuard (leaf): Enable edge port BPDU guard
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpdu-guard"
// Path from root: "/stp/global/config/bpdu-guard"
func (n *Stp_GlobalPath) BpduGuard() *Stp_Global_BpduGuardPath {
	return &Stp_Global_BpduGuardPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpdu-guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduGuard (leaf): Enable edge port BPDU guard
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpdu-guard"
// Path from root: "/stp/global/config/bpdu-guard"
func (n *Stp_GlobalPathAny) BpduGuard() *Stp_Global_BpduGuardPathAny {
	return &Stp_Global_BpduGuardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpdu-guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduguardTimeoutRecovery (leaf): Amount of time, in seconds, the interface receiving BPDUs
// is disabled. Once the timeout expires, the interface is
// brought back into service.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpduguard-timeout-recovery"
// Path from root: "/stp/global/config/bpduguard-timeout-recovery"
func (n *Stp_GlobalPath) BpduguardTimeoutRecovery() *Stp_Global_BpduguardTimeoutRecoveryPath {
	return &Stp_Global_BpduguardTimeoutRecoveryPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpduguard-timeout-recovery"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduguardTimeoutRecovery (leaf): Amount of time, in seconds, the interface receiving BPDUs
// is disabled. Once the timeout expires, the interface is
// brought back into service.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpduguard-timeout-recovery"
// Path from root: "/stp/global/config/bpduguard-timeout-recovery"
func (n *Stp_GlobalPathAny) BpduguardTimeoutRecovery() *Stp_Global_BpduguardTimeoutRecoveryPathAny {
	return &Stp_Global_BpduguardTimeoutRecoveryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpduguard-timeout-recovery"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgeAssurance (leaf): Enable bridge assurance to protect against unidirectional
// link failure
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bridge-assurance"
// Path from root: "/stp/global/config/bridge-assurance"
func (n *Stp_GlobalPath) BridgeAssurance() *Stp_Global_BridgeAssurancePath {
	return &Stp_Global_BridgeAssurancePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bridge-assurance"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgeAssurance (leaf): Enable bridge assurance to protect against unidirectional
// link failure
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bridge-assurance"
// Path from root: "/stp/global/config/bridge-assurance"
func (n *Stp_GlobalPathAny) BridgeAssurance() *Stp_Global_BridgeAssurancePathAny {
	return &Stp_Global_BridgeAssurancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bridge-assurance"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnabledProtocol (leaf): List of the spanning tree protocols enabled on the
// device
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/enabled-protocol"
// Path from root: "/stp/global/config/enabled-protocol"
func (n *Stp_GlobalPath) EnabledProtocol() *Stp_Global_EnabledProtocolPath {
	return &Stp_Global_EnabledProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnabledProtocol (leaf): List of the spanning tree protocols enabled on the
// device
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/enabled-protocol"
// Path from root: "/stp/global/config/enabled-protocol"
func (n *Stp_GlobalPathAny) EnabledProtocol() *Stp_Global_EnabledProtocolPathAny {
	return &Stp_Global_EnabledProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// EtherchannelMisconfigGuard (leaf): EtherChannel guard detects a misconfigured EtherChannel
// when interfaces on the switch are configured as an
// EtherChannel while interfaces on the other device are not
// or when not all the interfaces on the other device are in
// the same EtherChannel.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/etherchannel-misconfig-guard"
// Path from root: "/stp/global/config/etherchannel-misconfig-guard"
func (n *Stp_GlobalPath) EtherchannelMisconfigGuard() *Stp_Global_EtherchannelMisconfigGuardPath {
	return &Stp_Global_EtherchannelMisconfigGuardPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "etherchannel-misconfig-guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// EtherchannelMisconfigGuard (leaf): EtherChannel guard detects a misconfigured EtherChannel
// when interfaces on the switch are configured as an
// EtherChannel while interfaces on the other device are not
// or when not all the interfaces on the other device are in
// the same EtherChannel.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/etherchannel-misconfig-guard"
// Path from root: "/stp/global/config/etherchannel-misconfig-guard"
func (n *Stp_GlobalPathAny) EtherchannelMisconfigGuard() *Stp_Global_EtherchannelMisconfigGuardPathAny {
	return &Stp_Global_EtherchannelMisconfigGuardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "etherchannel-misconfig-guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoopGuard (leaf): The loop guard default setting for the bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/loop-guard"
// Path from root: "/stp/global/config/loop-guard"
func (n *Stp_GlobalPath) LoopGuard() *Stp_Global_LoopGuardPath {
	return &Stp_Global_LoopGuardPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "loop-guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoopGuard (leaf): The loop guard default setting for the bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/loop-guard"
// Path from root: "/stp/global/config/loop-guard"
func (n *Stp_GlobalPathAny) LoopGuard() *Stp_Global_LoopGuardPathAny {
	return &Stp_Global_LoopGuardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "loop-guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_InterfacePath represents the /openconfig-spanning-tree/stp/interfaces/interface YANG schema element.
type Stp_InterfacePath struct {
	*ygot.NodePath
}

// Stp_InterfacePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/interfaces/interface YANG schema element.
type Stp_InterfacePathAny struct {
	*ygot.NodePath
}

// Stp_Interface_BpduFilterPath represents the /openconfig-spanning-tree/stp/interfaces/interface/config/bpdu-filter YANG schema element.
type Stp_Interface_BpduFilterPath struct {
	*ygot.NodePath
}

// Stp_Interface_BpduFilterPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/interfaces/interface/config/bpdu-filter YANG schema element.
type Stp_Interface_BpduFilterPathAny struct {
	*ygot.NodePath
}

// Stp_Interface_BpduGuardPath represents the /openconfig-spanning-tree/stp/interfaces/interface/config/bpdu-guard YANG schema element.
type Stp_Interface_BpduGuardPath struct {
	*ygot.NodePath
}

// Stp_Interface_BpduGuardPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/interfaces/interface/config/bpdu-guard YANG schema element.
type Stp_Interface_BpduGuardPathAny struct {
	*ygot.NodePath
}

// Stp_Interface_EdgePortPath represents the /openconfig-spanning-tree/stp/interfaces/interface/config/edge-port YANG schema element.
type Stp_Interface_EdgePortPath struct {
	*ygot.NodePath
}

// Stp_Interface_EdgePortPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/interfaces/interface/config/edge-port YANG schema element.
type Stp_Interface_EdgePortPathAny struct {
	*ygot.NodePath
}

// Stp_Interface_GuardPath represents the /openconfig-spanning-tree/stp/interfaces/interface/config/guard YANG schema element.
type Stp_Interface_GuardPath struct {
	*ygot.NodePath
}

// Stp_Interface_GuardPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/interfaces/interface/config/guard YANG schema element.
type Stp_Interface_GuardPathAny struct {
	*ygot.NodePath
}

// Stp_Interface_LinkTypePath represents the /openconfig-spanning-tree/stp/interfaces/interface/config/link-type YANG schema element.
type Stp_Interface_LinkTypePath struct {
	*ygot.NodePath
}

// Stp_Interface_LinkTypePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/interfaces/interface/config/link-type YANG schema element.
type Stp_Interface_LinkTypePathAny struct {
	*ygot.NodePath
}

// Stp_Interface_NamePath represents the /openconfig-spanning-tree/stp/interfaces/interface/config/name YANG schema element.
type Stp_Interface_NamePath struct {
	*ygot.NodePath
}

// Stp_Interface_NamePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/interfaces/interface/config/name YANG schema element.
type Stp_Interface_NamePathAny struct {
	*ygot.NodePath
}

// BpduFilter (leaf): Enable edge port BPDU filter
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpdu-filter"
// Path from root: "/stp/interfaces/interface/config/bpdu-filter"
func (n *Stp_InterfacePath) BpduFilter() *Stp_Interface_BpduFilterPath {
	return &Stp_Interface_BpduFilterPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpdu-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduFilter (leaf): Enable edge port BPDU filter
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpdu-filter"
// Path from root: "/stp/interfaces/interface/config/bpdu-filter"
func (n *Stp_InterfacePathAny) BpduFilter() *Stp_Interface_BpduFilterPathAny {
	return &Stp_Interface_BpduFilterPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpdu-filter"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduGuard (leaf): Enable edge port BPDU guard
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpdu-guard"
// Path from root: "/stp/interfaces/interface/config/bpdu-guard"
func (n *Stp_InterfacePath) BpduGuard() *Stp_Interface_BpduGuardPath {
	return &Stp_Interface_BpduGuardPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpdu-guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduGuard (leaf): Enable edge port BPDU guard
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bpdu-guard"
// Path from root: "/stp/interfaces/interface/config/bpdu-guard"
func (n *Stp_InterfacePathAny) BpduGuard() *Stp_Interface_BpduGuardPathAny {
	return &Stp_Interface_BpduGuardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bpdu-guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// EdgePort (leaf): Configure the edge port state
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/edge-port"
// Path from root: "/stp/interfaces/interface/config/edge-port"
func (n *Stp_InterfacePath) EdgePort() *Stp_Interface_EdgePortPath {
	return &Stp_Interface_EdgePortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "edge-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// EdgePort (leaf): Configure the edge port state
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/edge-port"
// Path from root: "/stp/interfaces/interface/config/edge-port"
func (n *Stp_InterfacePathAny) EdgePort() *Stp_Interface_EdgePortPathAny {
	return &Stp_Interface_EdgePortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "edge-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// Guard (leaf): Enable root guard or loop guard
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/guard"
// Path from root: "/stp/interfaces/interface/config/guard"
func (n *Stp_InterfacePath) Guard() *Stp_Interface_GuardPath {
	return &Stp_Interface_GuardPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// Guard (leaf): Enable root guard or loop guard
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/guard"
// Path from root: "/stp/interfaces/interface/config/guard"
func (n *Stp_InterfacePathAny) Guard() *Stp_Interface_GuardPathAny {
	return &Stp_Interface_GuardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "guard"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkType (leaf): specifies the interface's link type
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/link-type"
// Path from root: "/stp/interfaces/interface/config/link-type"
func (n *Stp_InterfacePath) LinkType() *Stp_Interface_LinkTypePath {
	return &Stp_Interface_LinkTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkType (leaf): specifies the interface's link type
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/link-type"
// Path from root: "/stp/interfaces/interface/config/link-type"
func (n *Stp_InterfacePathAny) LinkType() *Stp_Interface_LinkTypePathAny {
	return &Stp_Interface_LinkTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "link-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the STP Ethernet interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/interfaces/interface/config/name"
func (n *Stp_InterfacePath) Name() *Stp_Interface_NamePath {
	return &Stp_Interface_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the STP Ethernet interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/interfaces/interface/config/name"
func (n *Stp_InterfacePathAny) Name() *Stp_Interface_NamePathAny {
	return &Stp_Interface_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_MstpPath represents the /openconfig-spanning-tree/stp/mstp YANG schema element.
type Stp_MstpPath struct {
	*ygot.NodePath
}

// Stp_MstpPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp YANG schema element.
type Stp_MstpPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_ForwardingDelayPath represents the /openconfig-spanning-tree/stp/mstp/config/forwarding-delay YANG schema element.
type Stp_Mstp_ForwardingDelayPath struct {
	*ygot.NodePath
}

// Stp_Mstp_ForwardingDelayPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/config/forwarding-delay YANG schema element.
type Stp_Mstp_ForwardingDelayPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_HelloTimePath represents the /openconfig-spanning-tree/stp/mstp/config/hello-time YANG schema element.
type Stp_Mstp_HelloTimePath struct {
	*ygot.NodePath
}

// Stp_Mstp_HelloTimePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/config/hello-time YANG schema element.
type Stp_Mstp_HelloTimePathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_HoldCountPath represents the /openconfig-spanning-tree/stp/mstp/config/hold-count YANG schema element.
type Stp_Mstp_HoldCountPath struct {
	*ygot.NodePath
}

// Stp_Mstp_HoldCountPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/config/hold-count YANG schema element.
type Stp_Mstp_HoldCountPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MaxAgePath represents the /openconfig-spanning-tree/stp/mstp/config/max-age YANG schema element.
type Stp_Mstp_MaxAgePath struct {
	*ygot.NodePath
}

// Stp_Mstp_MaxAgePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/config/max-age YANG schema element.
type Stp_Mstp_MaxAgePathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MaxHopPath represents the /openconfig-spanning-tree/stp/mstp/config/max-hop YANG schema element.
type Stp_Mstp_MaxHopPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MaxHopPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/config/max-hop YANG schema element.
type Stp_Mstp_MaxHopPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_NamePath represents the /openconfig-spanning-tree/stp/mstp/config/name YANG schema element.
type Stp_Mstp_NamePath struct {
	*ygot.NodePath
}

// Stp_Mstp_NamePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/config/name YANG schema element.
type Stp_Mstp_NamePathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_RevisionPath represents the /openconfig-spanning-tree/stp/mstp/config/revision YANG schema element.
type Stp_Mstp_RevisionPath struct {
	*ygot.NodePath
}

// Stp_Mstp_RevisionPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/config/revision YANG schema element.
type Stp_Mstp_RevisionPathAny struct {
	*ygot.NodePath
}

// ForwardingDelay (leaf): The delay used by STP bridges to transition root and
// designated ports to forwarding
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/forwarding-delay"
// Path from root: "/stp/mstp/config/forwarding-delay"
func (n *Stp_MstpPath) ForwardingDelay() *Stp_Mstp_ForwardingDelayPath {
	return &Stp_Mstp_ForwardingDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingDelay (leaf): The delay used by STP bridges to transition root and
// designated ports to forwarding
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/forwarding-delay"
// Path from root: "/stp/mstp/config/forwarding-delay"
func (n *Stp_MstpPathAny) ForwardingDelay() *Stp_Mstp_ForwardingDelayPathAny {
	return &Stp_Mstp_ForwardingDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloTime (leaf): The interval between periodic transmissions of
// configuration messages by designated ports
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hello-time"
// Path from root: "/stp/mstp/config/hello-time"
func (n *Stp_MstpPath) HelloTime() *Stp_Mstp_HelloTimePath {
	return &Stp_Mstp_HelloTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloTime (leaf): The interval between periodic transmissions of
// configuration messages by designated ports
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hello-time"
// Path from root: "/stp/mstp/config/hello-time"
func (n *Stp_MstpPathAny) HelloTime() *Stp_Mstp_HelloTimePathAny {
	return &Stp_Mstp_HelloTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldCount (leaf): the maximum number of BPDUs per second that the
// switch can send from an interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hold-count"
// Path from root: "/stp/mstp/config/hold-count"
func (n *Stp_MstpPath) HoldCount() *Stp_Mstp_HoldCountPath {
	return &Stp_Mstp_HoldCountPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldCount (leaf): the maximum number of BPDUs per second that the
// switch can send from an interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hold-count"
// Path from root: "/stp/mstp/config/hold-count"
func (n *Stp_MstpPathAny) HoldCount() *Stp_Mstp_HoldCountPathAny {
	return &Stp_Mstp_HoldCountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAge (leaf): The maximum age of the information transmitted by the
// bridge when it is the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/max-age"
// Path from root: "/stp/mstp/config/max-age"
func (n *Stp_MstpPath) MaxAge() *Stp_Mstp_MaxAgePath {
	return &Stp_Mstp_MaxAgePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-age"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAge (leaf): The maximum age of the information transmitted by the
// bridge when it is the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/max-age"
// Path from root: "/stp/mstp/config/max-age"
func (n *Stp_MstpPathAny) MaxAge() *Stp_Mstp_MaxAgePathAny {
	return &Stp_Mstp_MaxAgePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-age"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxHop (leaf): The max hop determines the number of bridges in an MST
// region that a BPDU can traverse before it is discarded
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/max-hop"
// Path from root: "/stp/mstp/config/max-hop"
func (n *Stp_MstpPath) MaxHop() *Stp_Mstp_MaxHopPath {
	return &Stp_Mstp_MaxHopPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxHop (leaf): The max hop determines the number of bridges in an MST
// region that a BPDU can traverse before it is discarded
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/max-hop"
// Path from root: "/stp/mstp/config/max-hop"
func (n *Stp_MstpPathAny) MaxHop() *Stp_Mstp_MaxHopPathAny {
	return &Stp_Mstp_MaxHopPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-hop"},
			map[string]interface{}{},
			n,
		),
	}
}

// MstInstanceAny (list): List of the mstp instances
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "mst-instances/mst-instance"
// Path from root: "/stp/mstp/mst-instances/mst-instance"
// MstId (wildcarded): uint16
func (n *Stp_MstpPath) MstInstanceAny() *Stp_Mstp_MstInstancePathAny {
	return &Stp_Mstp_MstInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mst-instances", "mst-instance"},
			map[string]interface{}{"mst-id": "*"},
			n,
		),
	}
}

// MstInstanceAny (list): List of the mstp instances
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "mst-instances/mst-instance"
// Path from root: "/stp/mstp/mst-instances/mst-instance"
// MstId (wildcarded): uint16
func (n *Stp_MstpPathAny) MstInstanceAny() *Stp_Mstp_MstInstancePathAny {
	return &Stp_Mstp_MstInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mst-instances", "mst-instance"},
			map[string]interface{}{"mst-id": "*"},
			n,
		),
	}
}

// MstInstance (list): List of the mstp instances
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "mst-instances/mst-instance"
// Path from root: "/stp/mstp/mst-instances/mst-instance"
// MstId: uint16
func (n *Stp_MstpPath) MstInstance(MstId uint16) *Stp_Mstp_MstInstancePath {
	return &Stp_Mstp_MstInstancePath{
		NodePath: ygot.NewNodePath(
			[]string{"mst-instances", "mst-instance"},
			map[string]interface{}{"mst-id": MstId},
			n,
		),
	}
}

// MstInstance (list): List of the mstp instances
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "mst-instances/mst-instance"
// Path from root: "/stp/mstp/mst-instances/mst-instance"
// MstId: uint16
func (n *Stp_MstpPathAny) MstInstance(MstId uint16) *Stp_Mstp_MstInstancePathAny {
	return &Stp_Mstp_MstInstancePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mst-instances", "mst-instance"},
			map[string]interface{}{"mst-id": MstId},
			n,
		),
	}
}

// Name (leaf): The Configuration Name in the MST Configuration Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/mstp/config/name"
func (n *Stp_MstpPath) Name() *Stp_Mstp_NamePath {
	return &Stp_Mstp_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The Configuration Name in the MST Configuration Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/mstp/config/name"
func (n *Stp_MstpPathAny) Name() *Stp_Mstp_NamePathAny {
	return &Stp_Mstp_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Revision (leaf): The Revision Level in the MST Configuration Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/revision"
// Path from root: "/stp/mstp/config/revision"
func (n *Stp_MstpPath) Revision() *Stp_Mstp_RevisionPath {
	return &Stp_Mstp_RevisionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "revision"},
			map[string]interface{}{},
			n,
		),
	}
}

// Revision (leaf): The Revision Level in the MST Configuration Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/revision"
// Path from root: "/stp/mstp/config/revision"
func (n *Stp_MstpPathAny) Revision() *Stp_Mstp_RevisionPathAny {
	return &Stp_Mstp_RevisionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "revision"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_Mstp_MstInstancePath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance YANG schema element.
type Stp_Mstp_MstInstancePath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstancePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance YANG schema element.
type Stp_Mstp_MstInstancePathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_BridgeAddressPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/bridge-address YANG schema element.
type Stp_Mstp_MstInstance_BridgeAddressPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_BridgeAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/bridge-address YANG schema element.
type Stp_Mstp_MstInstance_BridgeAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_BridgePriorityPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/config/bridge-priority YANG schema element.
type Stp_Mstp_MstInstance_BridgePriorityPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_BridgePriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/config/bridge-priority YANG schema element.
type Stp_Mstp_MstInstance_BridgePriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_DesignatedRootAddressPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/designated-root-address YANG schema element.
type Stp_Mstp_MstInstance_DesignatedRootAddressPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_DesignatedRootAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/designated-root-address YANG schema element.
type Stp_Mstp_MstInstance_DesignatedRootAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_DesignatedRootPriorityPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/designated-root-priority YANG schema element.
type Stp_Mstp_MstInstance_DesignatedRootPriorityPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_DesignatedRootPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/designated-root-priority YANG schema element.
type Stp_Mstp_MstInstance_DesignatedRootPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_HoldTimePath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/hold-time YANG schema element.
type Stp_Mstp_MstInstance_HoldTimePath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_HoldTimePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/hold-time YANG schema element.
type Stp_Mstp_MstInstance_HoldTimePathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_LastTopologyChangePath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/last-topology-change YANG schema element.
type Stp_Mstp_MstInstance_LastTopologyChangePath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_LastTopologyChangePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/last-topology-change YANG schema element.
type Stp_Mstp_MstInstance_LastTopologyChangePathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_MstIdPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/config/mst-id YANG schema element.
type Stp_Mstp_MstInstance_MstIdPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_MstIdPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/config/mst-id YANG schema element.
type Stp_Mstp_MstInstance_MstIdPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_RootCostPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/root-cost YANG schema element.
type Stp_Mstp_MstInstance_RootCostPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_RootCostPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/root-cost YANG schema element.
type Stp_Mstp_MstInstance_RootCostPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_RootPortPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/root-port YANG schema element.
type Stp_Mstp_MstInstance_RootPortPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_RootPortPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/root-port YANG schema element.
type Stp_Mstp_MstInstance_RootPortPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_TopologyChangesPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/topology-changes YANG schema element.
type Stp_Mstp_MstInstance_TopologyChangesPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_TopologyChangesPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/state/topology-changes YANG schema element.
type Stp_Mstp_MstInstance_TopologyChangesPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_VlanPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/config/vlan YANG schema element.
type Stp_Mstp_MstInstance_VlanPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_VlanPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/config/vlan YANG schema element.
type Stp_Mstp_MstInstance_VlanPathAny struct {
	*ygot.NodePath
}

// BridgeAddress (leaf): A unique 48-bit Universally Administered MAC Address
// assigned to the bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/bridge-address"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/bridge-address"
func (n *Stp_Mstp_MstInstancePath) BridgeAddress() *Stp_Mstp_MstInstance_BridgeAddressPath {
	return &Stp_Mstp_MstInstance_BridgeAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgeAddress (leaf): A unique 48-bit Universally Administered MAC Address
// assigned to the bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/bridge-address"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/bridge-address"
func (n *Stp_Mstp_MstInstancePathAny) BridgeAddress() *Stp_Mstp_MstInstance_BridgeAddressPathAny {
	return &Stp_Mstp_MstInstance_BridgeAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgePriority (leaf): The manageable component of the Bridge Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bridge-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/config/bridge-priority"
func (n *Stp_Mstp_MstInstancePath) BridgePriority() *Stp_Mstp_MstInstance_BridgePriorityPath {
	return &Stp_Mstp_MstInstance_BridgePriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgePriority (leaf): The manageable component of the Bridge Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bridge-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/config/bridge-priority"
func (n *Stp_Mstp_MstInstancePathAny) BridgePriority() *Stp_Mstp_MstInstance_BridgePriorityPathAny {
	return &Stp_Mstp_MstInstance_BridgePriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/designated-root-address"
func (n *Stp_Mstp_MstInstancePath) DesignatedRootAddress() *Stp_Mstp_MstInstance_DesignatedRootAddressPath {
	return &Stp_Mstp_MstInstance_DesignatedRootAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/designated-root-address"
func (n *Stp_Mstp_MstInstancePathAny) DesignatedRootAddress() *Stp_Mstp_MstInstance_DesignatedRootAddressPathAny {
	return &Stp_Mstp_MstInstance_DesignatedRootAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/designated-root-priority"
func (n *Stp_Mstp_MstInstancePath) DesignatedRootPriority() *Stp_Mstp_MstInstance_DesignatedRootPriorityPath {
	return &Stp_Mstp_MstInstance_DesignatedRootPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/designated-root-priority"
func (n *Stp_Mstp_MstInstancePathAny) DesignatedRootPriority() *Stp_Mstp_MstInstance_DesignatedRootPriorityPathAny {
	return &Stp_Mstp_MstInstance_DesignatedRootPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): This time value determines the interval length
// during which no more than two Configuration bridge
// PDUs shall be transmitted by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/hold-time"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/hold-time"
func (n *Stp_Mstp_MstInstancePath) HoldTime() *Stp_Mstp_MstInstance_HoldTimePath {
	return &Stp_Mstp_MstInstance_HoldTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): This time value determines the interval length
// during which no more than two Configuration bridge
// PDUs shall be transmitted by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/hold-time"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/hold-time"
func (n *Stp_Mstp_MstInstancePathAny) HoldTime() *Stp_Mstp_MstInstance_HoldTimePathAny {
	return &Stp_Mstp_MstInstance_HoldTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface"
// Name (wildcarded): string
func (n *Stp_Mstp_MstInstancePath) InterfaceAny() *Stp_Mstp_MstInstance_InterfacePathAny {
	return &Stp_Mstp_MstInstance_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface"
// Name (wildcarded): string
func (n *Stp_Mstp_MstInstancePathAny) InterfaceAny() *Stp_Mstp_MstInstance_InterfacePathAny {
	return &Stp_Mstp_MstInstance_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Interface (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface"
// Name: string
func (n *Stp_Mstp_MstInstancePath) Interface(Name string) *Stp_Mstp_MstInstance_InterfacePath {
	return &Stp_Mstp_MstInstance_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Interface (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface"
// Name: string
func (n *Stp_Mstp_MstInstancePathAny) Interface(Name string) *Stp_Mstp_MstInstance_InterfacePathAny {
	return &Stp_Mstp_MstInstance_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// LastTopologyChange (leaf): The time at which the last topology change was
// detected by the bridge entity. The value is
// expressed relative to the Unix Epoch (Jan 1, 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/last-topology-change"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/last-topology-change"
func (n *Stp_Mstp_MstInstancePath) LastTopologyChange() *Stp_Mstp_MstInstance_LastTopologyChangePath {
	return &Stp_Mstp_MstInstance_LastTopologyChangePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-topology-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastTopologyChange (leaf): The time at which the last topology change was
// detected by the bridge entity. The value is
// expressed relative to the Unix Epoch (Jan 1, 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/last-topology-change"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/last-topology-change"
func (n *Stp_Mstp_MstInstancePathAny) LastTopologyChange() *Stp_Mstp_MstInstance_LastTopologyChangePathAny {
	return &Stp_Mstp_MstInstance_LastTopologyChangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-topology-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// MstId (leaf): In an MSTP Bridge, an MSTID, i.e., a value used to identify
// a spanning tree (or MST) instance.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/mst-id"
// Path from root: "/stp/mstp/mst-instances/mst-instance/config/mst-id"
func (n *Stp_Mstp_MstInstancePath) MstId() *Stp_Mstp_MstInstance_MstIdPath {
	return &Stp_Mstp_MstInstance_MstIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mst-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// MstId (leaf): In an MSTP Bridge, an MSTID, i.e., a value used to identify
// a spanning tree (or MST) instance.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/mst-id"
// Path from root: "/stp/mstp/mst-instances/mst-instance/config/mst-id"
func (n *Stp_Mstp_MstInstancePathAny) MstId() *Stp_Mstp_MstInstance_MstIdPathAny {
	return &Stp_Mstp_MstInstance_MstIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mst-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootCost (leaf): The cost of the path to the root as seen from this bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-cost"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/root-cost"
func (n *Stp_Mstp_MstInstancePath) RootCost() *Stp_Mstp_MstInstance_RootCostPath {
	return &Stp_Mstp_MstInstance_RootCostPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootCost (leaf): The cost of the path to the root as seen from this bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-cost"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/root-cost"
func (n *Stp_Mstp_MstInstancePathAny) RootCost() *Stp_Mstp_MstInstance_RootCostPathAny {
	return &Stp_Mstp_MstInstance_RootCostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootPort (leaf): The port number of the port which offers the lowest
// cost path from this bridge to the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-port"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/root-port"
func (n *Stp_Mstp_MstInstancePath) RootPort() *Stp_Mstp_MstInstance_RootPortPath {
	return &Stp_Mstp_MstInstance_RootPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootPort (leaf): The port number of the port which offers the lowest
// cost path from this bridge to the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-port"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/root-port"
func (n *Stp_Mstp_MstInstancePathAny) RootPort() *Stp_Mstp_MstInstance_RootPortPathAny {
	return &Stp_Mstp_MstInstance_RootPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// TopologyChanges (leaf): The total number of topology changes detected by
// this bridge since the management entity was last
// reset or initialized
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/topology-changes"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/topology-changes"
func (n *Stp_Mstp_MstInstancePath) TopologyChanges() *Stp_Mstp_MstInstance_TopologyChangesPath {
	return &Stp_Mstp_MstInstance_TopologyChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// TopologyChanges (leaf): The total number of topology changes detected by
// this bridge since the management entity was last
// reset or initialized
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/topology-changes"
// Path from root: "/stp/mstp/mst-instances/mst-instance/state/topology-changes"
func (n *Stp_Mstp_MstInstancePathAny) TopologyChanges() *Stp_Mstp_MstInstance_TopologyChangesPathAny {
	return &Stp_Mstp_MstInstance_TopologyChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (leaf): list of vlans mapped to the MST instance
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/vlan"
// Path from root: "/stp/mstp/mst-instances/mst-instance/config/vlan"
func (n *Stp_Mstp_MstInstancePath) Vlan() *Stp_Mstp_MstInstance_VlanPath {
	return &Stp_Mstp_MstInstance_VlanPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Vlan (leaf): list of vlans mapped to the MST instance
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/vlan"
// Path from root: "/stp/mstp/mst-instances/mst-instance/config/vlan"
func (n *Stp_Mstp_MstInstancePathAny) Vlan() *Stp_Mstp_MstInstance_VlanPathAny {
	return &Stp_Mstp_MstInstance_VlanPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_Mstp_MstInstance_InterfacePath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface YANG schema element.
type Stp_Mstp_MstInstance_InterfacePath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_InterfacePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface YANG schema element.
type Stp_Mstp_MstInstance_InterfacePathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_CostPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/cost YANG schema element.
type Stp_Mstp_MstInstance_Interface_CostPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_CostPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/cost YANG schema element.
type Stp_Mstp_MstInstance_Interface_CostPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedBridgeAddressPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-bridge-address YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedBridgeAddressPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedBridgeAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-bridge-address YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedBridgeAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedBridgePriorityPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-bridge-priority YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedBridgePriorityPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedBridgePriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-bridge-priority YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedBridgePriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedCostPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-cost YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedCostPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedCostPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-cost YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedCostPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedPortNumPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-port-num YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedPortNumPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedPortNumPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-port-num YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedPortNumPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedPortPriorityPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-port-priority YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedPortPriorityPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedPortPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-port-priority YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedPortPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedRootAddressPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-root-address YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedRootAddressPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedRootAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-root-address YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedRootAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedRootPriorityPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-root-priority YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedRootPriorityPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_DesignatedRootPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-root-priority YANG schema element.
type Stp_Mstp_MstInstance_Interface_DesignatedRootPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_ForwardTransisitionsPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/forward-transisitions YANG schema element.
type Stp_Mstp_MstInstance_Interface_ForwardTransisitionsPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_ForwardTransisitionsPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/forward-transisitions YANG schema element.
type Stp_Mstp_MstInstance_Interface_ForwardTransisitionsPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_NamePath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/name YANG schema element.
type Stp_Mstp_MstInstance_Interface_NamePath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_NamePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/name YANG schema element.
type Stp_Mstp_MstInstance_Interface_NamePathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_PortNumPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/port-num YANG schema element.
type Stp_Mstp_MstInstance_Interface_PortNumPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_PortNumPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/port-num YANG schema element.
type Stp_Mstp_MstInstance_Interface_PortNumPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_PortPriorityPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/port-priority YANG schema element.
type Stp_Mstp_MstInstance_Interface_PortPriorityPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_PortPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/port-priority YANG schema element.
type Stp_Mstp_MstInstance_Interface_PortPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_PortStatePath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/port-state YANG schema element.
type Stp_Mstp_MstInstance_Interface_PortStatePath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_PortStatePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/port-state YANG schema element.
type Stp_Mstp_MstInstance_Interface_PortStatePathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_RolePath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/role YANG schema element.
type Stp_Mstp_MstInstance_Interface_RolePath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_RolePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/role YANG schema element.
type Stp_Mstp_MstInstance_Interface_RolePathAny struct {
	*ygot.NodePath
}

// Cost (leaf): The port's contribution, when it is the Root Port,
// to the Root Path Cost for the Bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/cost"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/cost"
func (n *Stp_Mstp_MstInstance_InterfacePath) Cost() *Stp_Mstp_MstInstance_Interface_CostPath {
	return &Stp_Mstp_MstInstance_Interface_CostPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cost (leaf): The port's contribution, when it is the Root Port,
// to the Root Path Cost for the Bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/cost"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/cost"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) Cost() *Stp_Mstp_MstInstance_Interface_CostPathAny {
	return &Stp_Mstp_MstInstance_Interface_CostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): The BPDU packet transmition statistics
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/counters"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters"
func (n *Stp_Mstp_MstInstance_InterfacePath) Counters() *Stp_Mstp_MstInstance_Interface_CountersPath {
	return &Stp_Mstp_MstInstance_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): The BPDU packet transmition statistics
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/counters"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) Counters() *Stp_Mstp_MstInstance_Interface_CountersPathAny {
	return &Stp_Mstp_MstInstance_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgeAddress (leaf): The bridge address of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-address"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-bridge-address"
func (n *Stp_Mstp_MstInstance_InterfacePath) DesignatedBridgeAddress() *Stp_Mstp_MstInstance_Interface_DesignatedBridgeAddressPath {
	return &Stp_Mstp_MstInstance_Interface_DesignatedBridgeAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgeAddress (leaf): The bridge address of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-address"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-bridge-address"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) DesignatedBridgeAddress() *Stp_Mstp_MstInstance_Interface_DesignatedBridgeAddressPathAny {
	return &Stp_Mstp_MstInstance_Interface_DesignatedBridgeAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgePriority (leaf): The bridge priority of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-bridge-priority"
func (n *Stp_Mstp_MstInstance_InterfacePath) DesignatedBridgePriority() *Stp_Mstp_MstInstance_Interface_DesignatedBridgePriorityPath {
	return &Stp_Mstp_MstInstance_Interface_DesignatedBridgePriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgePriority (leaf): The bridge priority of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-bridge-priority"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) DesignatedBridgePriority() *Stp_Mstp_MstInstance_Interface_DesignatedBridgePriorityPathAny {
	return &Stp_Mstp_MstInstance_Interface_DesignatedBridgePriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedCost (leaf): The path cost of the Designated Port of the
// segment connected to this port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-cost"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-cost"
func (n *Stp_Mstp_MstInstance_InterfacePath) DesignatedCost() *Stp_Mstp_MstInstance_Interface_DesignatedCostPath {
	return &Stp_Mstp_MstInstance_Interface_DesignatedCostPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedCost (leaf): The path cost of the Designated Port of the
// segment connected to this port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-cost"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-cost"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) DesignatedCost() *Stp_Mstp_MstInstance_Interface_DesignatedCostPathAny {
	return &Stp_Mstp_MstInstance_Interface_DesignatedCostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortNum (leaf): The Port number of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-num"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-port-num"
func (n *Stp_Mstp_MstInstance_InterfacePath) DesignatedPortNum() *Stp_Mstp_MstInstance_Interface_DesignatedPortNumPath {
	return &Stp_Mstp_MstInstance_Interface_DesignatedPortNumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortNum (leaf): The Port number of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-num"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-port-num"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) DesignatedPortNum() *Stp_Mstp_MstInstance_Interface_DesignatedPortNumPathAny {
	return &Stp_Mstp_MstInstance_Interface_DesignatedPortNumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortPriority (leaf): The Port priority of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-port-priority"
func (n *Stp_Mstp_MstInstance_InterfacePath) DesignatedPortPriority() *Stp_Mstp_MstInstance_Interface_DesignatedPortPriorityPath {
	return &Stp_Mstp_MstInstance_Interface_DesignatedPortPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortPriority (leaf): The Port priority of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-port-priority"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) DesignatedPortPriority() *Stp_Mstp_MstInstance_Interface_DesignatedPortPriorityPathAny {
	return &Stp_Mstp_MstInstance_Interface_DesignatedPortPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-root-address"
func (n *Stp_Mstp_MstInstance_InterfacePath) DesignatedRootAddress() *Stp_Mstp_MstInstance_Interface_DesignatedRootAddressPath {
	return &Stp_Mstp_MstInstance_Interface_DesignatedRootAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-root-address"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) DesignatedRootAddress() *Stp_Mstp_MstInstance_Interface_DesignatedRootAddressPathAny {
	return &Stp_Mstp_MstInstance_Interface_DesignatedRootAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-root-priority"
func (n *Stp_Mstp_MstInstance_InterfacePath) DesignatedRootPriority() *Stp_Mstp_MstInstance_Interface_DesignatedRootPriorityPath {
	return &Stp_Mstp_MstInstance_Interface_DesignatedRootPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/designated-root-priority"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) DesignatedRootPriority() *Stp_Mstp_MstInstance_Interface_DesignatedRootPriorityPathAny {
	return &Stp_Mstp_MstInstance_Interface_DesignatedRootPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardTransisitions (leaf): The number of times this port has transitioned
// from the Learning state to the Forwarding state
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/forward-transisitions"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/forward-transisitions"
func (n *Stp_Mstp_MstInstance_InterfacePath) ForwardTransisitions() *Stp_Mstp_MstInstance_Interface_ForwardTransisitionsPath {
	return &Stp_Mstp_MstInstance_Interface_ForwardTransisitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forward-transisitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardTransisitions (leaf): The number of times this port has transitioned
// from the Learning state to the Forwarding state
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/forward-transisitions"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/forward-transisitions"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) ForwardTransisitions() *Stp_Mstp_MstInstance_Interface_ForwardTransisitionsPathAny {
	return &Stp_Mstp_MstInstance_Interface_ForwardTransisitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forward-transisitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the STP ethernet interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/name"
func (n *Stp_Mstp_MstInstance_InterfacePath) Name() *Stp_Mstp_MstInstance_Interface_NamePath {
	return &Stp_Mstp_MstInstance_Interface_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the STP ethernet interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/name"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) Name() *Stp_Mstp_MstInstance_Interface_NamePathAny {
	return &Stp_Mstp_MstInstance_Interface_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortNum (leaf): The port number of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-num"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/port-num"
func (n *Stp_Mstp_MstInstance_InterfacePath) PortNum() *Stp_Mstp_MstInstance_Interface_PortNumPath {
	return &Stp_Mstp_MstInstance_Interface_PortNumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortNum (leaf): The port number of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-num"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/port-num"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) PortNum() *Stp_Mstp_MstInstance_Interface_PortNumPathAny {
	return &Stp_Mstp_MstInstance_Interface_PortNumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortPriority (leaf): The manageable component of the Port Identifier,
// also known as the Port Priority
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/port-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/port-priority"
func (n *Stp_Mstp_MstInstance_InterfacePath) PortPriority() *Stp_Mstp_MstInstance_Interface_PortPriorityPath {
	return &Stp_Mstp_MstInstance_Interface_PortPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortPriority (leaf): The manageable component of the Port Identifier,
// also known as the Port Priority
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/port-priority"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/config/port-priority"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) PortPriority() *Stp_Mstp_MstInstance_Interface_PortPriorityPathAny {
	return &Stp_Mstp_MstInstance_Interface_PortPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortState (leaf): The current state of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-state"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/port-state"
func (n *Stp_Mstp_MstInstance_InterfacePath) PortState() *Stp_Mstp_MstInstance_Interface_PortStatePath {
	return &Stp_Mstp_MstInstance_Interface_PortStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortState (leaf): The current state of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-state"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/port-state"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) PortState() *Stp_Mstp_MstInstance_Interface_PortStatePathAny {
	return &Stp_Mstp_MstInstance_Interface_PortStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): The current role of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/role"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/role"
func (n *Stp_Mstp_MstInstance_InterfacePath) Role() *Stp_Mstp_MstInstance_Interface_RolePath {
	return &Stp_Mstp_MstInstance_Interface_RolePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): The current role of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/role"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/role"
func (n *Stp_Mstp_MstInstance_InterfacePathAny) Role() *Stp_Mstp_MstInstance_Interface_RolePathAny {
	return &Stp_Mstp_MstInstance_Interface_RolePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_Mstp_MstInstance_Interface_CountersPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters YANG schema element.
type Stp_Mstp_MstInstance_Interface_CountersPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_CountersPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters YANG schema element.
type Stp_Mstp_MstInstance_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_Counters_BpduReceivedPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters/bpdu-received YANG schema element.
type Stp_Mstp_MstInstance_Interface_Counters_BpduReceivedPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_Counters_BpduReceivedPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters/bpdu-received YANG schema element.
type Stp_Mstp_MstInstance_Interface_Counters_BpduReceivedPathAny struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_Counters_BpduSentPath represents the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters/bpdu-sent YANG schema element.
type Stp_Mstp_MstInstance_Interface_Counters_BpduSentPath struct {
	*ygot.NodePath
}

// Stp_Mstp_MstInstance_Interface_Counters_BpduSentPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters/bpdu-sent YANG schema element.
type Stp_Mstp_MstInstance_Interface_Counters_BpduSentPathAny struct {
	*ygot.NodePath
}

// BpduReceived (leaf): The number of BPDU packet received
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-received"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters/bpdu-received"
func (n *Stp_Mstp_MstInstance_Interface_CountersPath) BpduReceived() *Stp_Mstp_MstInstance_Interface_Counters_BpduReceivedPath {
	return &Stp_Mstp_MstInstance_Interface_Counters_BpduReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduReceived (leaf): The number of BPDU packet received
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-received"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters/bpdu-received"
func (n *Stp_Mstp_MstInstance_Interface_CountersPathAny) BpduReceived() *Stp_Mstp_MstInstance_Interface_Counters_BpduReceivedPathAny {
	return &Stp_Mstp_MstInstance_Interface_Counters_BpduReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduSent (leaf): The number of BPDU packet sent
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-sent"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters/bpdu-sent"
func (n *Stp_Mstp_MstInstance_Interface_CountersPath) BpduSent() *Stp_Mstp_MstInstance_Interface_Counters_BpduSentPath {
	return &Stp_Mstp_MstInstance_Interface_Counters_BpduSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduSent (leaf): The number of BPDU packet sent
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-sent"
// Path from root: "/stp/mstp/mst-instances/mst-instance/interfaces/interface/state/counters/bpdu-sent"
func (n *Stp_Mstp_MstInstance_Interface_CountersPathAny) BpduSent() *Stp_Mstp_MstInstance_Interface_Counters_BpduSentPathAny {
	return &Stp_Mstp_MstInstance_Interface_Counters_BpduSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_RstpPath represents the /openconfig-spanning-tree/stp/rstp YANG schema element.
type Stp_RstpPath struct {
	*ygot.NodePath
}

// Stp_RstpPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp YANG schema element.
type Stp_RstpPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_BridgeAddressPath represents the /openconfig-spanning-tree/stp/rstp/state/bridge-address YANG schema element.
type Stp_Rstp_BridgeAddressPath struct {
	*ygot.NodePath
}

// Stp_Rstp_BridgeAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/state/bridge-address YANG schema element.
type Stp_Rstp_BridgeAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_BridgePriorityPath represents the /openconfig-spanning-tree/stp/rstp/config/bridge-priority YANG schema element.
type Stp_Rstp_BridgePriorityPath struct {
	*ygot.NodePath
}

// Stp_Rstp_BridgePriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/config/bridge-priority YANG schema element.
type Stp_Rstp_BridgePriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_DesignatedRootAddressPath represents the /openconfig-spanning-tree/stp/rstp/state/designated-root-address YANG schema element.
type Stp_Rstp_DesignatedRootAddressPath struct {
	*ygot.NodePath
}

// Stp_Rstp_DesignatedRootAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/state/designated-root-address YANG schema element.
type Stp_Rstp_DesignatedRootAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_DesignatedRootPriorityPath represents the /openconfig-spanning-tree/stp/rstp/state/designated-root-priority YANG schema element.
type Stp_Rstp_DesignatedRootPriorityPath struct {
	*ygot.NodePath
}

// Stp_Rstp_DesignatedRootPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/state/designated-root-priority YANG schema element.
type Stp_Rstp_DesignatedRootPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_ForwardingDelayPath represents the /openconfig-spanning-tree/stp/rstp/config/forwarding-delay YANG schema element.
type Stp_Rstp_ForwardingDelayPath struct {
	*ygot.NodePath
}

// Stp_Rstp_ForwardingDelayPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/config/forwarding-delay YANG schema element.
type Stp_Rstp_ForwardingDelayPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_HelloTimePath represents the /openconfig-spanning-tree/stp/rstp/config/hello-time YANG schema element.
type Stp_Rstp_HelloTimePath struct {
	*ygot.NodePath
}

// Stp_Rstp_HelloTimePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/config/hello-time YANG schema element.
type Stp_Rstp_HelloTimePathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_HoldCountPath represents the /openconfig-spanning-tree/stp/rstp/config/hold-count YANG schema element.
type Stp_Rstp_HoldCountPath struct {
	*ygot.NodePath
}

// Stp_Rstp_HoldCountPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/config/hold-count YANG schema element.
type Stp_Rstp_HoldCountPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_HoldTimePath represents the /openconfig-spanning-tree/stp/rstp/state/hold-time YANG schema element.
type Stp_Rstp_HoldTimePath struct {
	*ygot.NodePath
}

// Stp_Rstp_HoldTimePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/state/hold-time YANG schema element.
type Stp_Rstp_HoldTimePathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_LastTopologyChangePath represents the /openconfig-spanning-tree/stp/rstp/state/last-topology-change YANG schema element.
type Stp_Rstp_LastTopologyChangePath struct {
	*ygot.NodePath
}

// Stp_Rstp_LastTopologyChangePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/state/last-topology-change YANG schema element.
type Stp_Rstp_LastTopologyChangePathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_MaxAgePath represents the /openconfig-spanning-tree/stp/rstp/config/max-age YANG schema element.
type Stp_Rstp_MaxAgePath struct {
	*ygot.NodePath
}

// Stp_Rstp_MaxAgePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/config/max-age YANG schema element.
type Stp_Rstp_MaxAgePathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_RootCostPath represents the /openconfig-spanning-tree/stp/rstp/state/root-cost YANG schema element.
type Stp_Rstp_RootCostPath struct {
	*ygot.NodePath
}

// Stp_Rstp_RootCostPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/state/root-cost YANG schema element.
type Stp_Rstp_RootCostPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_RootPortPath represents the /openconfig-spanning-tree/stp/rstp/state/root-port YANG schema element.
type Stp_Rstp_RootPortPath struct {
	*ygot.NodePath
}

// Stp_Rstp_RootPortPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/state/root-port YANG schema element.
type Stp_Rstp_RootPortPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_TopologyChangesPath represents the /openconfig-spanning-tree/stp/rstp/state/topology-changes YANG schema element.
type Stp_Rstp_TopologyChangesPath struct {
	*ygot.NodePath
}

// Stp_Rstp_TopologyChangesPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/state/topology-changes YANG schema element.
type Stp_Rstp_TopologyChangesPathAny struct {
	*ygot.NodePath
}

// BridgeAddress (leaf): A unique 48-bit Universally Administered MAC Address
// assigned to the bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/bridge-address"
// Path from root: "/stp/rstp/state/bridge-address"
func (n *Stp_RstpPath) BridgeAddress() *Stp_Rstp_BridgeAddressPath {
	return &Stp_Rstp_BridgeAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgeAddress (leaf): A unique 48-bit Universally Administered MAC Address
// assigned to the bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/bridge-address"
// Path from root: "/stp/rstp/state/bridge-address"
func (n *Stp_RstpPathAny) BridgeAddress() *Stp_Rstp_BridgeAddressPathAny {
	return &Stp_Rstp_BridgeAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgePriority (leaf): The manageable component of the Bridge Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bridge-priority"
// Path from root: "/stp/rstp/config/bridge-priority"
func (n *Stp_RstpPath) BridgePriority() *Stp_Rstp_BridgePriorityPath {
	return &Stp_Rstp_BridgePriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgePriority (leaf): The manageable component of the Bridge Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bridge-priority"
// Path from root: "/stp/rstp/config/bridge-priority"
func (n *Stp_RstpPathAny) BridgePriority() *Stp_Rstp_BridgePriorityPathAny {
	return &Stp_Rstp_BridgePriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/rstp/state/designated-root-address"
func (n *Stp_RstpPath) DesignatedRootAddress() *Stp_Rstp_DesignatedRootAddressPath {
	return &Stp_Rstp_DesignatedRootAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/rstp/state/designated-root-address"
func (n *Stp_RstpPathAny) DesignatedRootAddress() *Stp_Rstp_DesignatedRootAddressPathAny {
	return &Stp_Rstp_DesignatedRootAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/rstp/state/designated-root-priority"
func (n *Stp_RstpPath) DesignatedRootPriority() *Stp_Rstp_DesignatedRootPriorityPath {
	return &Stp_Rstp_DesignatedRootPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/rstp/state/designated-root-priority"
func (n *Stp_RstpPathAny) DesignatedRootPriority() *Stp_Rstp_DesignatedRootPriorityPathAny {
	return &Stp_Rstp_DesignatedRootPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingDelay (leaf): The delay used by STP bridges to transition root and
// designated ports to forwarding
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/forwarding-delay"
// Path from root: "/stp/rstp/config/forwarding-delay"
func (n *Stp_RstpPath) ForwardingDelay() *Stp_Rstp_ForwardingDelayPath {
	return &Stp_Rstp_ForwardingDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingDelay (leaf): The delay used by STP bridges to transition root and
// designated ports to forwarding
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/forwarding-delay"
// Path from root: "/stp/rstp/config/forwarding-delay"
func (n *Stp_RstpPathAny) ForwardingDelay() *Stp_Rstp_ForwardingDelayPathAny {
	return &Stp_Rstp_ForwardingDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloTime (leaf): The interval between periodic transmissions of
// configuration messages by designated ports
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hello-time"
// Path from root: "/stp/rstp/config/hello-time"
func (n *Stp_RstpPath) HelloTime() *Stp_Rstp_HelloTimePath {
	return &Stp_Rstp_HelloTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloTime (leaf): The interval between periodic transmissions of
// configuration messages by designated ports
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hello-time"
// Path from root: "/stp/rstp/config/hello-time"
func (n *Stp_RstpPathAny) HelloTime() *Stp_Rstp_HelloTimePathAny {
	return &Stp_Rstp_HelloTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldCount (leaf): the maximum number of BPDUs per second that the
// switch can send from an interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hold-count"
// Path from root: "/stp/rstp/config/hold-count"
func (n *Stp_RstpPath) HoldCount() *Stp_Rstp_HoldCountPath {
	return &Stp_Rstp_HoldCountPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldCount (leaf): the maximum number of BPDUs per second that the
// switch can send from an interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hold-count"
// Path from root: "/stp/rstp/config/hold-count"
func (n *Stp_RstpPathAny) HoldCount() *Stp_Rstp_HoldCountPathAny {
	return &Stp_Rstp_HoldCountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): This time value determines the interval length
// during which no more than two Configuration bridge
// PDUs shall be transmitted by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/hold-time"
// Path from root: "/stp/rstp/state/hold-time"
func (n *Stp_RstpPath) HoldTime() *Stp_Rstp_HoldTimePath {
	return &Stp_Rstp_HoldTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): This time value determines the interval length
// during which no more than two Configuration bridge
// PDUs shall be transmitted by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/hold-time"
// Path from root: "/stp/rstp/state/hold-time"
func (n *Stp_RstpPathAny) HoldTime() *Stp_Rstp_HoldTimePathAny {
	return &Stp_Rstp_HoldTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/rstp/interfaces/interface"
// Name (wildcarded): string
func (n *Stp_RstpPath) InterfaceAny() *Stp_Rstp_InterfacePathAny {
	return &Stp_Rstp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/rstp/interfaces/interface"
// Name (wildcarded): string
func (n *Stp_RstpPathAny) InterfaceAny() *Stp_Rstp_InterfacePathAny {
	return &Stp_Rstp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Interface (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/rstp/interfaces/interface"
// Name: string
func (n *Stp_RstpPath) Interface(Name string) *Stp_Rstp_InterfacePath {
	return &Stp_Rstp_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Interface (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/rstp/interfaces/interface"
// Name: string
func (n *Stp_RstpPathAny) Interface(Name string) *Stp_Rstp_InterfacePathAny {
	return &Stp_Rstp_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// LastTopologyChange (leaf): The time at which the last topology change was
// detected by the bridge entity. The value is
// expressed relative to the Unix Epoch (Jan 1, 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/last-topology-change"
// Path from root: "/stp/rstp/state/last-topology-change"
func (n *Stp_RstpPath) LastTopologyChange() *Stp_Rstp_LastTopologyChangePath {
	return &Stp_Rstp_LastTopologyChangePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-topology-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastTopologyChange (leaf): The time at which the last topology change was
// detected by the bridge entity. The value is
// expressed relative to the Unix Epoch (Jan 1, 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/last-topology-change"
// Path from root: "/stp/rstp/state/last-topology-change"
func (n *Stp_RstpPathAny) LastTopologyChange() *Stp_Rstp_LastTopologyChangePathAny {
	return &Stp_Rstp_LastTopologyChangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-topology-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAge (leaf): The maximum age of the information transmitted by the
// bridge when it is the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/max-age"
// Path from root: "/stp/rstp/config/max-age"
func (n *Stp_RstpPath) MaxAge() *Stp_Rstp_MaxAgePath {
	return &Stp_Rstp_MaxAgePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-age"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAge (leaf): The maximum age of the information transmitted by the
// bridge when it is the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/max-age"
// Path from root: "/stp/rstp/config/max-age"
func (n *Stp_RstpPathAny) MaxAge() *Stp_Rstp_MaxAgePathAny {
	return &Stp_Rstp_MaxAgePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-age"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootCost (leaf): The cost of the path to the root as seen from this bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-cost"
// Path from root: "/stp/rstp/state/root-cost"
func (n *Stp_RstpPath) RootCost() *Stp_Rstp_RootCostPath {
	return &Stp_Rstp_RootCostPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootCost (leaf): The cost of the path to the root as seen from this bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-cost"
// Path from root: "/stp/rstp/state/root-cost"
func (n *Stp_RstpPathAny) RootCost() *Stp_Rstp_RootCostPathAny {
	return &Stp_Rstp_RootCostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootPort (leaf): The port number of the port which offers the lowest
// cost path from this bridge to the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-port"
// Path from root: "/stp/rstp/state/root-port"
func (n *Stp_RstpPath) RootPort() *Stp_Rstp_RootPortPath {
	return &Stp_Rstp_RootPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootPort (leaf): The port number of the port which offers the lowest
// cost path from this bridge to the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-port"
// Path from root: "/stp/rstp/state/root-port"
func (n *Stp_RstpPathAny) RootPort() *Stp_Rstp_RootPortPathAny {
	return &Stp_Rstp_RootPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// TopologyChanges (leaf): The total number of topology changes detected by
// this bridge since the management entity was last
// reset or initialized
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/topology-changes"
// Path from root: "/stp/rstp/state/topology-changes"
func (n *Stp_RstpPath) TopologyChanges() *Stp_Rstp_TopologyChangesPath {
	return &Stp_Rstp_TopologyChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// TopologyChanges (leaf): The total number of topology changes detected by
// this bridge since the management entity was last
// reset or initialized
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/topology-changes"
// Path from root: "/stp/rstp/state/topology-changes"
func (n *Stp_RstpPathAny) TopologyChanges() *Stp_Rstp_TopologyChangesPathAny {
	return &Stp_Rstp_TopologyChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_Rstp_InterfacePath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface YANG schema element.
type Stp_Rstp_InterfacePath struct {
	*ygot.NodePath
}

// Stp_Rstp_InterfacePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface YANG schema element.
type Stp_Rstp_InterfacePathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_CostPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/config/cost YANG schema element.
type Stp_Rstp_Interface_CostPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_CostPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/config/cost YANG schema element.
type Stp_Rstp_Interface_CostPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedBridgeAddressPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-bridge-address YANG schema element.
type Stp_Rstp_Interface_DesignatedBridgeAddressPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedBridgeAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-bridge-address YANG schema element.
type Stp_Rstp_Interface_DesignatedBridgeAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedBridgePriorityPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-bridge-priority YANG schema element.
type Stp_Rstp_Interface_DesignatedBridgePriorityPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedBridgePriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-bridge-priority YANG schema element.
type Stp_Rstp_Interface_DesignatedBridgePriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedCostPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-cost YANG schema element.
type Stp_Rstp_Interface_DesignatedCostPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedCostPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-cost YANG schema element.
type Stp_Rstp_Interface_DesignatedCostPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedPortNumPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-port-num YANG schema element.
type Stp_Rstp_Interface_DesignatedPortNumPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedPortNumPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-port-num YANG schema element.
type Stp_Rstp_Interface_DesignatedPortNumPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedPortPriorityPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-port-priority YANG schema element.
type Stp_Rstp_Interface_DesignatedPortPriorityPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedPortPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-port-priority YANG schema element.
type Stp_Rstp_Interface_DesignatedPortPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedRootAddressPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-root-address YANG schema element.
type Stp_Rstp_Interface_DesignatedRootAddressPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedRootAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-root-address YANG schema element.
type Stp_Rstp_Interface_DesignatedRootAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedRootPriorityPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-root-priority YANG schema element.
type Stp_Rstp_Interface_DesignatedRootPriorityPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_DesignatedRootPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/designated-root-priority YANG schema element.
type Stp_Rstp_Interface_DesignatedRootPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_ForwardTransisitionsPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/forward-transisitions YANG schema element.
type Stp_Rstp_Interface_ForwardTransisitionsPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_ForwardTransisitionsPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/forward-transisitions YANG schema element.
type Stp_Rstp_Interface_ForwardTransisitionsPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_NamePath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/config/name YANG schema element.
type Stp_Rstp_Interface_NamePath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_NamePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/config/name YANG schema element.
type Stp_Rstp_Interface_NamePathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_PortNumPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/port-num YANG schema element.
type Stp_Rstp_Interface_PortNumPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_PortNumPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/port-num YANG schema element.
type Stp_Rstp_Interface_PortNumPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_PortPriorityPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/config/port-priority YANG schema element.
type Stp_Rstp_Interface_PortPriorityPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_PortPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/config/port-priority YANG schema element.
type Stp_Rstp_Interface_PortPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_PortStatePath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/port-state YANG schema element.
type Stp_Rstp_Interface_PortStatePath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_PortStatePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/port-state YANG schema element.
type Stp_Rstp_Interface_PortStatePathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_RolePath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/role YANG schema element.
type Stp_Rstp_Interface_RolePath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_RolePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/role YANG schema element.
type Stp_Rstp_Interface_RolePathAny struct {
	*ygot.NodePath
}

// Cost (leaf): The port's contribution, when it is the Root Port,
// to the Root Path Cost for the Bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/cost"
// Path from root: "/stp/rstp/interfaces/interface/config/cost"
func (n *Stp_Rstp_InterfacePath) Cost() *Stp_Rstp_Interface_CostPath {
	return &Stp_Rstp_Interface_CostPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cost (leaf): The port's contribution, when it is the Root Port,
// to the Root Path Cost for the Bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/cost"
// Path from root: "/stp/rstp/interfaces/interface/config/cost"
func (n *Stp_Rstp_InterfacePathAny) Cost() *Stp_Rstp_Interface_CostPathAny {
	return &Stp_Rstp_Interface_CostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): The BPDU packet transmition statistics
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/counters"
// Path from root: "/stp/rstp/interfaces/interface/state/counters"
func (n *Stp_Rstp_InterfacePath) Counters() *Stp_Rstp_Interface_CountersPath {
	return &Stp_Rstp_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): The BPDU packet transmition statistics
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/counters"
// Path from root: "/stp/rstp/interfaces/interface/state/counters"
func (n *Stp_Rstp_InterfacePathAny) Counters() *Stp_Rstp_Interface_CountersPathAny {
	return &Stp_Rstp_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgeAddress (leaf): The bridge address of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-address"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-bridge-address"
func (n *Stp_Rstp_InterfacePath) DesignatedBridgeAddress() *Stp_Rstp_Interface_DesignatedBridgeAddressPath {
	return &Stp_Rstp_Interface_DesignatedBridgeAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgeAddress (leaf): The bridge address of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-address"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-bridge-address"
func (n *Stp_Rstp_InterfacePathAny) DesignatedBridgeAddress() *Stp_Rstp_Interface_DesignatedBridgeAddressPathAny {
	return &Stp_Rstp_Interface_DesignatedBridgeAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgePriority (leaf): The bridge priority of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-priority"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-bridge-priority"
func (n *Stp_Rstp_InterfacePath) DesignatedBridgePriority() *Stp_Rstp_Interface_DesignatedBridgePriorityPath {
	return &Stp_Rstp_Interface_DesignatedBridgePriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgePriority (leaf): The bridge priority of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-priority"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-bridge-priority"
func (n *Stp_Rstp_InterfacePathAny) DesignatedBridgePriority() *Stp_Rstp_Interface_DesignatedBridgePriorityPathAny {
	return &Stp_Rstp_Interface_DesignatedBridgePriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedCost (leaf): The path cost of the Designated Port of the
// segment connected to this port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-cost"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-cost"
func (n *Stp_Rstp_InterfacePath) DesignatedCost() *Stp_Rstp_Interface_DesignatedCostPath {
	return &Stp_Rstp_Interface_DesignatedCostPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedCost (leaf): The path cost of the Designated Port of the
// segment connected to this port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-cost"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-cost"
func (n *Stp_Rstp_InterfacePathAny) DesignatedCost() *Stp_Rstp_Interface_DesignatedCostPathAny {
	return &Stp_Rstp_Interface_DesignatedCostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortNum (leaf): The Port number of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-num"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-port-num"
func (n *Stp_Rstp_InterfacePath) DesignatedPortNum() *Stp_Rstp_Interface_DesignatedPortNumPath {
	return &Stp_Rstp_Interface_DesignatedPortNumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortNum (leaf): The Port number of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-num"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-port-num"
func (n *Stp_Rstp_InterfacePathAny) DesignatedPortNum() *Stp_Rstp_Interface_DesignatedPortNumPathAny {
	return &Stp_Rstp_Interface_DesignatedPortNumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortPriority (leaf): The Port priority of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-priority"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-port-priority"
func (n *Stp_Rstp_InterfacePath) DesignatedPortPriority() *Stp_Rstp_Interface_DesignatedPortPriorityPath {
	return &Stp_Rstp_Interface_DesignatedPortPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortPriority (leaf): The Port priority of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-priority"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-port-priority"
func (n *Stp_Rstp_InterfacePathAny) DesignatedPortPriority() *Stp_Rstp_Interface_DesignatedPortPriorityPathAny {
	return &Stp_Rstp_Interface_DesignatedPortPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-root-address"
func (n *Stp_Rstp_InterfacePath) DesignatedRootAddress() *Stp_Rstp_Interface_DesignatedRootAddressPath {
	return &Stp_Rstp_Interface_DesignatedRootAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-root-address"
func (n *Stp_Rstp_InterfacePathAny) DesignatedRootAddress() *Stp_Rstp_Interface_DesignatedRootAddressPathAny {
	return &Stp_Rstp_Interface_DesignatedRootAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-root-priority"
func (n *Stp_Rstp_InterfacePath) DesignatedRootPriority() *Stp_Rstp_Interface_DesignatedRootPriorityPath {
	return &Stp_Rstp_Interface_DesignatedRootPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/rstp/interfaces/interface/state/designated-root-priority"
func (n *Stp_Rstp_InterfacePathAny) DesignatedRootPriority() *Stp_Rstp_Interface_DesignatedRootPriorityPathAny {
	return &Stp_Rstp_Interface_DesignatedRootPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardTransisitions (leaf): The number of times this port has transitioned
// from the Learning state to the Forwarding state
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/forward-transisitions"
// Path from root: "/stp/rstp/interfaces/interface/state/forward-transisitions"
func (n *Stp_Rstp_InterfacePath) ForwardTransisitions() *Stp_Rstp_Interface_ForwardTransisitionsPath {
	return &Stp_Rstp_Interface_ForwardTransisitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forward-transisitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardTransisitions (leaf): The number of times this port has transitioned
// from the Learning state to the Forwarding state
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/forward-transisitions"
// Path from root: "/stp/rstp/interfaces/interface/state/forward-transisitions"
func (n *Stp_Rstp_InterfacePathAny) ForwardTransisitions() *Stp_Rstp_Interface_ForwardTransisitionsPathAny {
	return &Stp_Rstp_Interface_ForwardTransisitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forward-transisitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the STP ethernet interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/rstp/interfaces/interface/config/name"
func (n *Stp_Rstp_InterfacePath) Name() *Stp_Rstp_Interface_NamePath {
	return &Stp_Rstp_Interface_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the STP ethernet interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/rstp/interfaces/interface/config/name"
func (n *Stp_Rstp_InterfacePathAny) Name() *Stp_Rstp_Interface_NamePathAny {
	return &Stp_Rstp_Interface_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortNum (leaf): The port number of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-num"
// Path from root: "/stp/rstp/interfaces/interface/state/port-num"
func (n *Stp_Rstp_InterfacePath) PortNum() *Stp_Rstp_Interface_PortNumPath {
	return &Stp_Rstp_Interface_PortNumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortNum (leaf): The port number of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-num"
// Path from root: "/stp/rstp/interfaces/interface/state/port-num"
func (n *Stp_Rstp_InterfacePathAny) PortNum() *Stp_Rstp_Interface_PortNumPathAny {
	return &Stp_Rstp_Interface_PortNumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortPriority (leaf): The manageable component of the Port Identifier,
// also known as the Port Priority
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/port-priority"
// Path from root: "/stp/rstp/interfaces/interface/config/port-priority"
func (n *Stp_Rstp_InterfacePath) PortPriority() *Stp_Rstp_Interface_PortPriorityPath {
	return &Stp_Rstp_Interface_PortPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortPriority (leaf): The manageable component of the Port Identifier,
// also known as the Port Priority
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/port-priority"
// Path from root: "/stp/rstp/interfaces/interface/config/port-priority"
func (n *Stp_Rstp_InterfacePathAny) PortPriority() *Stp_Rstp_Interface_PortPriorityPathAny {
	return &Stp_Rstp_Interface_PortPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortState (leaf): The current state of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-state"
// Path from root: "/stp/rstp/interfaces/interface/state/port-state"
func (n *Stp_Rstp_InterfacePath) PortState() *Stp_Rstp_Interface_PortStatePath {
	return &Stp_Rstp_Interface_PortStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortState (leaf): The current state of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-state"
// Path from root: "/stp/rstp/interfaces/interface/state/port-state"
func (n *Stp_Rstp_InterfacePathAny) PortState() *Stp_Rstp_Interface_PortStatePathAny {
	return &Stp_Rstp_Interface_PortStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): The current role of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/role"
// Path from root: "/stp/rstp/interfaces/interface/state/role"
func (n *Stp_Rstp_InterfacePath) Role() *Stp_Rstp_Interface_RolePath {
	return &Stp_Rstp_Interface_RolePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): The current role of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/role"
// Path from root: "/stp/rstp/interfaces/interface/state/role"
func (n *Stp_Rstp_InterfacePathAny) Role() *Stp_Rstp_Interface_RolePathAny {
	return &Stp_Rstp_Interface_RolePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_Rstp_Interface_CountersPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/counters YANG schema element.
type Stp_Rstp_Interface_CountersPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_CountersPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/counters YANG schema element.
type Stp_Rstp_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_Counters_BpduReceivedPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/counters/bpdu-received YANG schema element.
type Stp_Rstp_Interface_Counters_BpduReceivedPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_Counters_BpduReceivedPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/counters/bpdu-received YANG schema element.
type Stp_Rstp_Interface_Counters_BpduReceivedPathAny struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_Counters_BpduSentPath represents the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/counters/bpdu-sent YANG schema element.
type Stp_Rstp_Interface_Counters_BpduSentPath struct {
	*ygot.NodePath
}

// Stp_Rstp_Interface_Counters_BpduSentPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rstp/interfaces/interface/state/counters/bpdu-sent YANG schema element.
type Stp_Rstp_Interface_Counters_BpduSentPathAny struct {
	*ygot.NodePath
}

// BpduReceived (leaf): The number of BPDU packet received
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-received"
// Path from root: "/stp/rstp/interfaces/interface/state/counters/bpdu-received"
func (n *Stp_Rstp_Interface_CountersPath) BpduReceived() *Stp_Rstp_Interface_Counters_BpduReceivedPath {
	return &Stp_Rstp_Interface_Counters_BpduReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduReceived (leaf): The number of BPDU packet received
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-received"
// Path from root: "/stp/rstp/interfaces/interface/state/counters/bpdu-received"
func (n *Stp_Rstp_Interface_CountersPathAny) BpduReceived() *Stp_Rstp_Interface_Counters_BpduReceivedPathAny {
	return &Stp_Rstp_Interface_Counters_BpduReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduSent (leaf): The number of BPDU packet sent
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-sent"
// Path from root: "/stp/rstp/interfaces/interface/state/counters/bpdu-sent"
func (n *Stp_Rstp_Interface_CountersPath) BpduSent() *Stp_Rstp_Interface_Counters_BpduSentPath {
	return &Stp_Rstp_Interface_Counters_BpduSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduSent (leaf): The number of BPDU packet sent
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-sent"
// Path from root: "/stp/rstp/interfaces/interface/state/counters/bpdu-sent"
func (n *Stp_Rstp_Interface_CountersPathAny) BpduSent() *Stp_Rstp_Interface_Counters_BpduSentPathAny {
	return &Stp_Rstp_Interface_Counters_BpduSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_VlanPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan YANG schema element.
type Stp_VlanPath struct {
	*ygot.NodePath
}

// Stp_VlanPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan YANG schema element.
type Stp_VlanPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_BridgeAddressPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/bridge-address YANG schema element.
type Stp_Vlan_BridgeAddressPath struct {
	*ygot.NodePath
}

// Stp_Vlan_BridgeAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/bridge-address YANG schema element.
type Stp_Vlan_BridgeAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_BridgePriorityPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/bridge-priority YANG schema element.
type Stp_Vlan_BridgePriorityPath struct {
	*ygot.NodePath
}

// Stp_Vlan_BridgePriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/bridge-priority YANG schema element.
type Stp_Vlan_BridgePriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_DesignatedRootAddressPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/designated-root-address YANG schema element.
type Stp_Vlan_DesignatedRootAddressPath struct {
	*ygot.NodePath
}

// Stp_Vlan_DesignatedRootAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/designated-root-address YANG schema element.
type Stp_Vlan_DesignatedRootAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_DesignatedRootPriorityPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/designated-root-priority YANG schema element.
type Stp_Vlan_DesignatedRootPriorityPath struct {
	*ygot.NodePath
}

// Stp_Vlan_DesignatedRootPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/designated-root-priority YANG schema element.
type Stp_Vlan_DesignatedRootPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_ForwardingDelayPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/forwarding-delay YANG schema element.
type Stp_Vlan_ForwardingDelayPath struct {
	*ygot.NodePath
}

// Stp_Vlan_ForwardingDelayPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/forwarding-delay YANG schema element.
type Stp_Vlan_ForwardingDelayPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_HelloTimePath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/hello-time YANG schema element.
type Stp_Vlan_HelloTimePath struct {
	*ygot.NodePath
}

// Stp_Vlan_HelloTimePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/hello-time YANG schema element.
type Stp_Vlan_HelloTimePathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_HoldCountPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/hold-count YANG schema element.
type Stp_Vlan_HoldCountPath struct {
	*ygot.NodePath
}

// Stp_Vlan_HoldCountPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/hold-count YANG schema element.
type Stp_Vlan_HoldCountPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_HoldTimePath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/hold-time YANG schema element.
type Stp_Vlan_HoldTimePath struct {
	*ygot.NodePath
}

// Stp_Vlan_HoldTimePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/hold-time YANG schema element.
type Stp_Vlan_HoldTimePathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_LastTopologyChangePath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/last-topology-change YANG schema element.
type Stp_Vlan_LastTopologyChangePath struct {
	*ygot.NodePath
}

// Stp_Vlan_LastTopologyChangePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/last-topology-change YANG schema element.
type Stp_Vlan_LastTopologyChangePathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_MaxAgePath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/max-age YANG schema element.
type Stp_Vlan_MaxAgePath struct {
	*ygot.NodePath
}

// Stp_Vlan_MaxAgePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/max-age YANG schema element.
type Stp_Vlan_MaxAgePathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_RootCostPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/root-cost YANG schema element.
type Stp_Vlan_RootCostPath struct {
	*ygot.NodePath
}

// Stp_Vlan_RootCostPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/root-cost YANG schema element.
type Stp_Vlan_RootCostPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_RootPortPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/root-port YANG schema element.
type Stp_Vlan_RootPortPath struct {
	*ygot.NodePath
}

// Stp_Vlan_RootPortPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/root-port YANG schema element.
type Stp_Vlan_RootPortPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_TopologyChangesPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/topology-changes YANG schema element.
type Stp_Vlan_TopologyChangesPath struct {
	*ygot.NodePath
}

// Stp_Vlan_TopologyChangesPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/state/topology-changes YANG schema element.
type Stp_Vlan_TopologyChangesPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_VlanIdPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/vlan-id YANG schema element.
type Stp_Vlan_VlanIdPath struct {
	*ygot.NodePath
}

// Stp_Vlan_VlanIdPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/config/vlan-id YANG schema element.
type Stp_Vlan_VlanIdPathAny struct {
	*ygot.NodePath
}

// BridgeAddress (leaf): A unique 48-bit Universally Administered MAC Address
// assigned to the bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/bridge-address"
// Path from root: "/stp/rapid-pvst/vlan/state/bridge-address"
func (n *Stp_VlanPath) BridgeAddress() *Stp_Vlan_BridgeAddressPath {
	return &Stp_Vlan_BridgeAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgeAddress (leaf): A unique 48-bit Universally Administered MAC Address
// assigned to the bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/bridge-address"
// Path from root: "/stp/rapid-pvst/vlan/state/bridge-address"
func (n *Stp_VlanPathAny) BridgeAddress() *Stp_Vlan_BridgeAddressPathAny {
	return &Stp_Vlan_BridgeAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgePriority (leaf): The manageable component of the Bridge Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bridge-priority"
// Path from root: "/stp/rapid-pvst/vlan/config/bridge-priority"
func (n *Stp_VlanPath) BridgePriority() *Stp_Vlan_BridgePriorityPath {
	return &Stp_Vlan_BridgePriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// BridgePriority (leaf): The manageable component of the Bridge Identifier
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/bridge-priority"
// Path from root: "/stp/rapid-pvst/vlan/config/bridge-priority"
func (n *Stp_VlanPathAny) BridgePriority() *Stp_Vlan_BridgePriorityPathAny {
	return &Stp_Vlan_BridgePriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/rapid-pvst/vlan/state/designated-root-address"
func (n *Stp_VlanPath) DesignatedRootAddress() *Stp_Vlan_DesignatedRootAddressPath {
	return &Stp_Vlan_DesignatedRootAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/rapid-pvst/vlan/state/designated-root-address"
func (n *Stp_VlanPathAny) DesignatedRootAddress() *Stp_Vlan_DesignatedRootAddressPathAny {
	return &Stp_Vlan_DesignatedRootAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/rapid-pvst/vlan/state/designated-root-priority"
func (n *Stp_VlanPath) DesignatedRootPriority() *Stp_Vlan_DesignatedRootPriorityPath {
	return &Stp_Vlan_DesignatedRootPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the root of the spanning
// tree, as determined by the Spanning Tree Protocol,
// as executed by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/rapid-pvst/vlan/state/designated-root-priority"
func (n *Stp_VlanPathAny) DesignatedRootPriority() *Stp_Vlan_DesignatedRootPriorityPathAny {
	return &Stp_Vlan_DesignatedRootPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingDelay (leaf): The delay used by STP bridges to transition root and
// designated ports to forwarding
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/forwarding-delay"
// Path from root: "/stp/rapid-pvst/vlan/config/forwarding-delay"
func (n *Stp_VlanPath) ForwardingDelay() *Stp_Vlan_ForwardingDelayPath {
	return &Stp_Vlan_ForwardingDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardingDelay (leaf): The delay used by STP bridges to transition root and
// designated ports to forwarding
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/forwarding-delay"
// Path from root: "/stp/rapid-pvst/vlan/config/forwarding-delay"
func (n *Stp_VlanPathAny) ForwardingDelay() *Stp_Vlan_ForwardingDelayPathAny {
	return &Stp_Vlan_ForwardingDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "forwarding-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloTime (leaf): The interval between periodic transmissions of
// configuration messages by designated ports
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hello-time"
// Path from root: "/stp/rapid-pvst/vlan/config/hello-time"
func (n *Stp_VlanPath) HelloTime() *Stp_Vlan_HelloTimePath {
	return &Stp_Vlan_HelloTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HelloTime (leaf): The interval between periodic transmissions of
// configuration messages by designated ports
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hello-time"
// Path from root: "/stp/rapid-pvst/vlan/config/hello-time"
func (n *Stp_VlanPathAny) HelloTime() *Stp_Vlan_HelloTimePathAny {
	return &Stp_Vlan_HelloTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hello-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldCount (leaf): the maximum number of BPDUs per second that the
// switch can send from an interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hold-count"
// Path from root: "/stp/rapid-pvst/vlan/config/hold-count"
func (n *Stp_VlanPath) HoldCount() *Stp_Vlan_HoldCountPath {
	return &Stp_Vlan_HoldCountPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldCount (leaf): the maximum number of BPDUs per second that the
// switch can send from an interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/hold-count"
// Path from root: "/stp/rapid-pvst/vlan/config/hold-count"
func (n *Stp_VlanPathAny) HoldCount() *Stp_Vlan_HoldCountPathAny {
	return &Stp_Vlan_HoldCountPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hold-count"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): This time value determines the interval length
// during which no more than two Configuration bridge
// PDUs shall be transmitted by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/hold-time"
// Path from root: "/stp/rapid-pvst/vlan/state/hold-time"
func (n *Stp_VlanPath) HoldTime() *Stp_Vlan_HoldTimePath {
	return &Stp_Vlan_HoldTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// HoldTime (leaf): This time value determines the interval length
// during which no more than two Configuration bridge
// PDUs shall be transmitted by this node
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/hold-time"
// Path from root: "/stp/rapid-pvst/vlan/state/hold-time"
func (n *Stp_VlanPathAny) HoldTime() *Stp_Vlan_HoldTimePathAny {
	return &Stp_Vlan_HoldTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hold-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface"
// Name (wildcarded): string
func (n *Stp_VlanPath) InterfaceAny() *Stp_Vlan_InterfacePathAny {
	return &Stp_Vlan_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// InterfaceAny (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface"
// Name (wildcarded): string
func (n *Stp_VlanPathAny) InterfaceAny() *Stp_Vlan_InterfacePathAny {
	return &Stp_Vlan_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// Interface (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface"
// Name: string
func (n *Stp_VlanPath) Interface(Name string) *Stp_Vlan_InterfacePath {
	return &Stp_Vlan_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Interface (list): List of interfaces on which STP is enable
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "interfaces/interface"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface"
// Name: string
func (n *Stp_VlanPathAny) Interface(Name string) *Stp_Vlan_InterfacePathAny {
	return &Stp_Vlan_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interfaces", "interface"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// LastTopologyChange (leaf): The time at which the last topology change was
// detected by the bridge entity. The value is
// expressed relative to the Unix Epoch (Jan 1, 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/last-topology-change"
// Path from root: "/stp/rapid-pvst/vlan/state/last-topology-change"
func (n *Stp_VlanPath) LastTopologyChange() *Stp_Vlan_LastTopologyChangePath {
	return &Stp_Vlan_LastTopologyChangePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-topology-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastTopologyChange (leaf): The time at which the last topology change was
// detected by the bridge entity. The value is
// expressed relative to the Unix Epoch (Jan 1, 1970
// 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/last-topology-change"
// Path from root: "/stp/rapid-pvst/vlan/state/last-topology-change"
func (n *Stp_VlanPathAny) LastTopologyChange() *Stp_Vlan_LastTopologyChangePathAny {
	return &Stp_Vlan_LastTopologyChangePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-topology-change"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAge (leaf): The maximum age of the information transmitted by the
// bridge when it is the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/max-age"
// Path from root: "/stp/rapid-pvst/vlan/config/max-age"
func (n *Stp_VlanPath) MaxAge() *Stp_Vlan_MaxAgePath {
	return &Stp_Vlan_MaxAgePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-age"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxAge (leaf): The maximum age of the information transmitted by the
// bridge when it is the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/max-age"
// Path from root: "/stp/rapid-pvst/vlan/config/max-age"
func (n *Stp_VlanPathAny) MaxAge() *Stp_Vlan_MaxAgePathAny {
	return &Stp_Vlan_MaxAgePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "max-age"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootCost (leaf): The cost of the path to the root as seen from this bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-cost"
// Path from root: "/stp/rapid-pvst/vlan/state/root-cost"
func (n *Stp_VlanPath) RootCost() *Stp_Vlan_RootCostPath {
	return &Stp_Vlan_RootCostPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootCost (leaf): The cost of the path to the root as seen from this bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-cost"
// Path from root: "/stp/rapid-pvst/vlan/state/root-cost"
func (n *Stp_VlanPathAny) RootCost() *Stp_Vlan_RootCostPathAny {
	return &Stp_Vlan_RootCostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootPort (leaf): The port number of the port which offers the lowest
// cost path from this bridge to the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-port"
// Path from root: "/stp/rapid-pvst/vlan/state/root-port"
func (n *Stp_VlanPath) RootPort() *Stp_Vlan_RootPortPath {
	return &Stp_Vlan_RootPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootPort (leaf): The port number of the port which offers the lowest
// cost path from this bridge to the root bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/root-port"
// Path from root: "/stp/rapid-pvst/vlan/state/root-port"
func (n *Stp_VlanPathAny) RootPort() *Stp_Vlan_RootPortPathAny {
	return &Stp_Vlan_RootPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// TopologyChanges (leaf): The total number of topology changes detected by
// this bridge since the management entity was last
// reset or initialized
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/topology-changes"
// Path from root: "/stp/rapid-pvst/vlan/state/topology-changes"
func (n *Stp_VlanPath) TopologyChanges() *Stp_Vlan_TopologyChangesPath {
	return &Stp_Vlan_TopologyChangesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// TopologyChanges (leaf): The total number of topology changes detected by
// this bridge since the management entity was last
// reset or initialized
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/topology-changes"
// Path from root: "/stp/rapid-pvst/vlan/state/topology-changes"
func (n *Stp_VlanPathAny) TopologyChanges() *Stp_Vlan_TopologyChangesPathAny {
	return &Stp_Vlan_TopologyChangesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "topology-changes"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): Interface VLAN ID
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/vlan-id"
// Path from root: "/stp/rapid-pvst/vlan/config/vlan-id"
func (n *Stp_VlanPath) VlanId() *Stp_Vlan_VlanIdPath {
	return &Stp_Vlan_VlanIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VlanId (leaf): Interface VLAN ID
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/vlan-id"
// Path from root: "/stp/rapid-pvst/vlan/config/vlan-id"
func (n *Stp_VlanPathAny) VlanId() *Stp_Vlan_VlanIdPathAny {
	return &Stp_Vlan_VlanIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "vlan-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_Vlan_InterfacePath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface YANG schema element.
type Stp_Vlan_InterfacePath struct {
	*ygot.NodePath
}

// Stp_Vlan_InterfacePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface YANG schema element.
type Stp_Vlan_InterfacePathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_CostPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/config/cost YANG schema element.
type Stp_Vlan_Interface_CostPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_CostPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/config/cost YANG schema element.
type Stp_Vlan_Interface_CostPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedBridgeAddressPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-bridge-address YANG schema element.
type Stp_Vlan_Interface_DesignatedBridgeAddressPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedBridgeAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-bridge-address YANG schema element.
type Stp_Vlan_Interface_DesignatedBridgeAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedBridgePriorityPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-bridge-priority YANG schema element.
type Stp_Vlan_Interface_DesignatedBridgePriorityPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedBridgePriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-bridge-priority YANG schema element.
type Stp_Vlan_Interface_DesignatedBridgePriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedCostPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-cost YANG schema element.
type Stp_Vlan_Interface_DesignatedCostPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedCostPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-cost YANG schema element.
type Stp_Vlan_Interface_DesignatedCostPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedPortNumPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-port-num YANG schema element.
type Stp_Vlan_Interface_DesignatedPortNumPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedPortNumPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-port-num YANG schema element.
type Stp_Vlan_Interface_DesignatedPortNumPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedPortPriorityPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-port-priority YANG schema element.
type Stp_Vlan_Interface_DesignatedPortPriorityPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedPortPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-port-priority YANG schema element.
type Stp_Vlan_Interface_DesignatedPortPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedRootAddressPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-root-address YANG schema element.
type Stp_Vlan_Interface_DesignatedRootAddressPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedRootAddressPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-root-address YANG schema element.
type Stp_Vlan_Interface_DesignatedRootAddressPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedRootPriorityPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-root-priority YANG schema element.
type Stp_Vlan_Interface_DesignatedRootPriorityPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_DesignatedRootPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/designated-root-priority YANG schema element.
type Stp_Vlan_Interface_DesignatedRootPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_ForwardTransisitionsPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/forward-transisitions YANG schema element.
type Stp_Vlan_Interface_ForwardTransisitionsPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_ForwardTransisitionsPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/forward-transisitions YANG schema element.
type Stp_Vlan_Interface_ForwardTransisitionsPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_NamePath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/config/name YANG schema element.
type Stp_Vlan_Interface_NamePath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_NamePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/config/name YANG schema element.
type Stp_Vlan_Interface_NamePathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_PortNumPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/port-num YANG schema element.
type Stp_Vlan_Interface_PortNumPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_PortNumPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/port-num YANG schema element.
type Stp_Vlan_Interface_PortNumPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_PortPriorityPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/config/port-priority YANG schema element.
type Stp_Vlan_Interface_PortPriorityPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_PortPriorityPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/config/port-priority YANG schema element.
type Stp_Vlan_Interface_PortPriorityPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_PortStatePath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/port-state YANG schema element.
type Stp_Vlan_Interface_PortStatePath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_PortStatePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/port-state YANG schema element.
type Stp_Vlan_Interface_PortStatePathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_RolePath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/role YANG schema element.
type Stp_Vlan_Interface_RolePath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_RolePathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/role YANG schema element.
type Stp_Vlan_Interface_RolePathAny struct {
	*ygot.NodePath
}

// Cost (leaf): The port's contribution, when it is the Root Port,
// to the Root Path Cost for the Bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/cost"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/config/cost"
func (n *Stp_Vlan_InterfacePath) Cost() *Stp_Vlan_Interface_CostPath {
	return &Stp_Vlan_Interface_CostPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// Cost (leaf): The port's contribution, when it is the Root Port,
// to the Root Path Cost for the Bridge
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/cost"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/config/cost"
func (n *Stp_Vlan_InterfacePathAny) Cost() *Stp_Vlan_Interface_CostPathAny {
	return &Stp_Vlan_Interface_CostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): The BPDU packet transmition statistics
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/counters"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/counters"
func (n *Stp_Vlan_InterfacePath) Counters() *Stp_Vlan_Interface_CountersPath {
	return &Stp_Vlan_Interface_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): The BPDU packet transmition statistics
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/counters"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/counters"
func (n *Stp_Vlan_InterfacePathAny) Counters() *Stp_Vlan_Interface_CountersPathAny {
	return &Stp_Vlan_Interface_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgeAddress (leaf): The bridge address of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-address"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-bridge-address"
func (n *Stp_Vlan_InterfacePath) DesignatedBridgeAddress() *Stp_Vlan_Interface_DesignatedBridgeAddressPath {
	return &Stp_Vlan_Interface_DesignatedBridgeAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgeAddress (leaf): The bridge address of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-address"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-bridge-address"
func (n *Stp_Vlan_InterfacePathAny) DesignatedBridgeAddress() *Stp_Vlan_Interface_DesignatedBridgeAddressPathAny {
	return &Stp_Vlan_Interface_DesignatedBridgeAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgePriority (leaf): The bridge priority of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-priority"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-bridge-priority"
func (n *Stp_Vlan_InterfacePath) DesignatedBridgePriority() *Stp_Vlan_Interface_DesignatedBridgePriorityPath {
	return &Stp_Vlan_Interface_DesignatedBridgePriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedBridgePriority (leaf): The bridge priority of the bridge that this port considers
// to be the designated bridge for this port's segment.
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-bridge-priority"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-bridge-priority"
func (n *Stp_Vlan_InterfacePathAny) DesignatedBridgePriority() *Stp_Vlan_Interface_DesignatedBridgePriorityPathAny {
	return &Stp_Vlan_Interface_DesignatedBridgePriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-bridge-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedCost (leaf): The path cost of the Designated Port of the
// segment connected to this port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-cost"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-cost"
func (n *Stp_Vlan_InterfacePath) DesignatedCost() *Stp_Vlan_Interface_DesignatedCostPath {
	return &Stp_Vlan_Interface_DesignatedCostPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedCost (leaf): The path cost of the Designated Port of the
// segment connected to this port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-cost"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-cost"
func (n *Stp_Vlan_InterfacePathAny) DesignatedCost() *Stp_Vlan_Interface_DesignatedCostPathAny {
	return &Stp_Vlan_Interface_DesignatedCostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-cost"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortNum (leaf): The Port number of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-num"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-port-num"
func (n *Stp_Vlan_InterfacePath) DesignatedPortNum() *Stp_Vlan_Interface_DesignatedPortNumPath {
	return &Stp_Vlan_Interface_DesignatedPortNumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortNum (leaf): The Port number of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-num"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-port-num"
func (n *Stp_Vlan_InterfacePathAny) DesignatedPortNum() *Stp_Vlan_Interface_DesignatedPortNumPathAny {
	return &Stp_Vlan_Interface_DesignatedPortNumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortPriority (leaf): The Port priority of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-priority"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-port-priority"
func (n *Stp_Vlan_InterfacePath) DesignatedPortPriority() *Stp_Vlan_Interface_DesignatedPortPriorityPath {
	return &Stp_Vlan_Interface_DesignatedPortPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedPortPriority (leaf): The Port priority of the port on the Designated
// Bridge for this port's segment, two octet string
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-port-priority"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-port-priority"
func (n *Stp_Vlan_InterfacePathAny) DesignatedPortPriority() *Stp_Vlan_Interface_DesignatedPortPriorityPathAny {
	return &Stp_Vlan_Interface_DesignatedPortPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-root-address"
func (n *Stp_Vlan_InterfacePath) DesignatedRootAddress() *Stp_Vlan_Interface_DesignatedRootAddressPath {
	return &Stp_Vlan_Interface_DesignatedRootAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootAddress (leaf): The bridge address of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-address"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-root-address"
func (n *Stp_Vlan_InterfacePathAny) DesignatedRootAddress() *Stp_Vlan_Interface_DesignatedRootAddressPathAny {
	return &Stp_Vlan_Interface_DesignatedRootAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-root-priority"
func (n *Stp_Vlan_InterfacePath) DesignatedRootPriority() *Stp_Vlan_Interface_DesignatedRootPriorityPath {
	return &Stp_Vlan_Interface_DesignatedRootPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// DesignatedRootPriority (leaf): The bridge priority of the bridge recorded as the
// root in the configuration BPDUs transmitted by the designated
// bridge for the segment to which the port is attached
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/designated-root-priority"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/designated-root-priority"
func (n *Stp_Vlan_InterfacePathAny) DesignatedRootPriority() *Stp_Vlan_Interface_DesignatedRootPriorityPathAny {
	return &Stp_Vlan_Interface_DesignatedRootPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "designated-root-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardTransisitions (leaf): The number of times this port has transitioned
// from the Learning state to the Forwarding state
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/forward-transisitions"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/forward-transisitions"
func (n *Stp_Vlan_InterfacePath) ForwardTransisitions() *Stp_Vlan_Interface_ForwardTransisitionsPath {
	return &Stp_Vlan_Interface_ForwardTransisitionsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forward-transisitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// ForwardTransisitions (leaf): The number of times this port has transitioned
// from the Learning state to the Forwarding state
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/forward-transisitions"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/forward-transisitions"
func (n *Stp_Vlan_InterfacePathAny) ForwardTransisitions() *Stp_Vlan_Interface_ForwardTransisitionsPathAny {
	return &Stp_Vlan_Interface_ForwardTransisitionsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "forward-transisitions"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the STP ethernet interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/config/name"
func (n *Stp_Vlan_InterfacePath) Name() *Stp_Vlan_Interface_NamePath {
	return &Stp_Vlan_Interface_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Reference to the STP ethernet interface
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/name"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/config/name"
func (n *Stp_Vlan_InterfacePathAny) Name() *Stp_Vlan_Interface_NamePathAny {
	return &Stp_Vlan_Interface_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortNum (leaf): The port number of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-num"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/port-num"
func (n *Stp_Vlan_InterfacePath) PortNum() *Stp_Vlan_Interface_PortNumPath {
	return &Stp_Vlan_Interface_PortNumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortNum (leaf): The port number of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-num"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/port-num"
func (n *Stp_Vlan_InterfacePathAny) PortNum() *Stp_Vlan_Interface_PortNumPathAny {
	return &Stp_Vlan_Interface_PortNumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-num"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortPriority (leaf): The manageable component of the Port Identifier,
// also known as the Port Priority
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/port-priority"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/config/port-priority"
func (n *Stp_Vlan_InterfacePath) PortPriority() *Stp_Vlan_Interface_PortPriorityPath {
	return &Stp_Vlan_Interface_PortPriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortPriority (leaf): The manageable component of the Port Identifier,
// also known as the Port Priority
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "config/port-priority"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/config/port-priority"
func (n *Stp_Vlan_InterfacePathAny) PortPriority() *Stp_Vlan_Interface_PortPriorityPathAny {
	return &Stp_Vlan_Interface_PortPriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port-priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortState (leaf): The current state of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-state"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/port-state"
func (n *Stp_Vlan_InterfacePath) PortState() *Stp_Vlan_Interface_PortStatePath {
	return &Stp_Vlan_Interface_PortStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortState (leaf): The current state of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/port-state"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/port-state"
func (n *Stp_Vlan_InterfacePathAny) PortState() *Stp_Vlan_Interface_PortStatePathAny {
	return &Stp_Vlan_Interface_PortStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): The current role of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/role"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/role"
func (n *Stp_Vlan_InterfacePath) Role() *Stp_Vlan_Interface_RolePath {
	return &Stp_Vlan_Interface_RolePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): The current role of the bridge port
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "state/role"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/role"
func (n *Stp_Vlan_InterfacePathAny) Role() *Stp_Vlan_Interface_RolePathAny {
	return &Stp_Vlan_Interface_RolePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stp_Vlan_Interface_CountersPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/counters YANG schema element.
type Stp_Vlan_Interface_CountersPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_CountersPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/counters YANG schema element.
type Stp_Vlan_Interface_CountersPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_Counters_BpduReceivedPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/counters/bpdu-received YANG schema element.
type Stp_Vlan_Interface_Counters_BpduReceivedPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_Counters_BpduReceivedPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/counters/bpdu-received YANG schema element.
type Stp_Vlan_Interface_Counters_BpduReceivedPathAny struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_Counters_BpduSentPath represents the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/counters/bpdu-sent YANG schema element.
type Stp_Vlan_Interface_Counters_BpduSentPath struct {
	*ygot.NodePath
}

// Stp_Vlan_Interface_Counters_BpduSentPathAny represents the wildcard version of the /openconfig-spanning-tree/stp/rapid-pvst/vlan/interfaces/interface/state/counters/bpdu-sent YANG schema element.
type Stp_Vlan_Interface_Counters_BpduSentPathAny struct {
	*ygot.NodePath
}

// BpduReceived (leaf): The number of BPDU packet received
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-received"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/counters/bpdu-received"
func (n *Stp_Vlan_Interface_CountersPath) BpduReceived() *Stp_Vlan_Interface_Counters_BpduReceivedPath {
	return &Stp_Vlan_Interface_Counters_BpduReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduReceived (leaf): The number of BPDU packet received
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-received"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/counters/bpdu-received"
func (n *Stp_Vlan_Interface_CountersPathAny) BpduReceived() *Stp_Vlan_Interface_Counters_BpduReceivedPathAny {
	return &Stp_Vlan_Interface_Counters_BpduReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduSent (leaf): The number of BPDU packet sent
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-sent"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/counters/bpdu-sent"
func (n *Stp_Vlan_Interface_CountersPath) BpduSent() *Stp_Vlan_Interface_Counters_BpduSentPath {
	return &Stp_Vlan_Interface_Counters_BpduSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// BpduSent (leaf): The number of BPDU packet sent
// ----------------------------------------
// Defining module: "openconfig-spanning-tree"
// Instantiating module: "openconfig-spanning-tree"
// Path from parent: "bpdu-sent"
// Path from root: "/stp/rapid-pvst/vlan/interfaces/interface/state/counters/bpdu-sent"
func (n *Stp_Vlan_Interface_CountersPathAny) BpduSent() *Stp_Vlan_Interface_Counters_BpduSentPathAny {
	return &Stp_Vlan_Interface_Counters_BpduSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"bpdu-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemPath represents the /openconfig-system/system YANG schema element.
type SystemPath struct {
	*ygot.NodePath
}

// SystemPathAny represents the wildcard version of the /openconfig-system/system YANG schema element.
type SystemPathAny struct {
	*ygot.NodePath
}

// System_BootTimePath represents the /openconfig-system/system/state/boot-time YANG schema element.
type System_BootTimePath struct {
	*ygot.NodePath
}

// System_BootTimePathAny represents the wildcard version of the /openconfig-system/system/state/boot-time YANG schema element.
type System_BootTimePathAny struct {
	*ygot.NodePath
}

// System_CurrentDatetimePath represents the /openconfig-system/system/state/current-datetime YANG schema element.
type System_CurrentDatetimePath struct {
	*ygot.NodePath
}

// System_CurrentDatetimePathAny represents the wildcard version of the /openconfig-system/system/state/current-datetime YANG schema element.
type System_CurrentDatetimePathAny struct {
	*ygot.NodePath
}

// System_DomainNamePath represents the /openconfig-system/system/config/domain-name YANG schema element.
type System_DomainNamePath struct {
	*ygot.NodePath
}

// System_DomainNamePathAny represents the wildcard version of the /openconfig-system/system/config/domain-name YANG schema element.
type System_DomainNamePathAny struct {
	*ygot.NodePath
}

// System_HostnamePath represents the /openconfig-system/system/config/hostname YANG schema element.
type System_HostnamePath struct {
	*ygot.NodePath
}

// System_HostnamePathAny represents the wildcard version of the /openconfig-system/system/config/hostname YANG schema element.
type System_HostnamePathAny struct {
	*ygot.NodePath
}

// System_LoginBannerPath represents the /openconfig-system/system/config/login-banner YANG schema element.
type System_LoginBannerPath struct {
	*ygot.NodePath
}

// System_LoginBannerPathAny represents the wildcard version of the /openconfig-system/system/config/login-banner YANG schema element.
type System_LoginBannerPathAny struct {
	*ygot.NodePath
}

// System_MotdBannerPath represents the /openconfig-system/system/config/motd-banner YANG schema element.
type System_MotdBannerPath struct {
	*ygot.NodePath
}

// System_MotdBannerPathAny represents the wildcard version of the /openconfig-system/system/config/motd-banner YANG schema element.
type System_MotdBannerPathAny struct {
	*ygot.NodePath
}

// Aaa (container): Top-level container for AAA services
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "aaa"
// Path from root: "/system/aaa"
func (n *SystemPath) Aaa() *System_AaaPath {
	return &System_AaaPath{
		NodePath: ygot.NewNodePath(
			[]string{"aaa"},
			map[string]interface{}{},
			n,
		),
	}
}

// Aaa (container): Top-level container for AAA services
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "aaa"
// Path from root: "/system/aaa"
func (n *SystemPathAny) Aaa() *System_AaaPathAny {
	return &System_AaaPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"aaa"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlarmAny (list): List of alarms, keyed by a unique id
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "alarms/alarm"
// Path from root: "/system/alarms/alarm"
// Id (wildcarded): string
func (n *SystemPath) AlarmAny() *System_AlarmPathAny {
	return &System_AlarmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"alarms", "alarm"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// AlarmAny (list): List of alarms, keyed by a unique id
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "alarms/alarm"
// Path from root: "/system/alarms/alarm"
// Id (wildcarded): string
func (n *SystemPathAny) AlarmAny() *System_AlarmPathAny {
	return &System_AlarmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"alarms", "alarm"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Alarm (list): List of alarms, keyed by a unique id
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "alarms/alarm"
// Path from root: "/system/alarms/alarm"
// Id: string
func (n *SystemPath) Alarm(Id string) *System_AlarmPath {
	return &System_AlarmPath{
		NodePath: ygot.NewNodePath(
			[]string{"alarms", "alarm"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Alarm (list): List of alarms, keyed by a unique id
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "alarms/alarm"
// Path from root: "/system/alarms/alarm"
// Id: string
func (n *SystemPathAny) Alarm(Id string) *System_AlarmPathAny {
	return &System_AlarmPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"alarms", "alarm"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// BootTime (leaf): This timestamp indicates the time that the system was last
// restarted.  The value is the timestamp in nanoseconds relative
// to the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/boot-time"
// Path from root: "/system/state/boot-time"
func (n *SystemPath) BootTime() *System_BootTimePath {
	return &System_BootTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "boot-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// BootTime (leaf): This timestamp indicates the time that the system was last
// restarted.  The value is the timestamp in nanoseconds relative
// to the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/boot-time"
// Path from root: "/system/state/boot-time"
func (n *SystemPathAny) BootTime() *System_BootTimePathAny {
	return &System_BootTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "boot-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Clock (container): Top-level container for clock configuration data
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "clock"
// Path from root: "/system/clock"
func (n *SystemPath) Clock() *System_ClockPath {
	return &System_ClockPath{
		NodePath: ygot.NewNodePath(
			[]string{"clock"},
			map[string]interface{}{},
			n,
		),
	}
}

// Clock (container): Top-level container for clock configuration data
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "clock"
// Path from root: "/system/clock"
func (n *SystemPathAny) Clock() *System_ClockPathAny {
	return &System_ClockPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"clock"},
			map[string]interface{}{},
			n,
		),
	}
}

// CpuAny (list): List of CPU cores on the system (including logical CPUs
// on hyperthreaded systems), keyed by either a numerical
// index, or the ALL value for an entry representing the
// aggregation across all CPUs.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "cpus/cpu"
// Path from root: "/system/cpus/cpu"
// Index (wildcarded): [E_Cpu_Index_Enum, UnionUint32]
func (n *SystemPath) CpuAny() *System_CpuPathAny {
	return &System_CpuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"cpus", "cpu"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// CpuAny (list): List of CPU cores on the system (including logical CPUs
// on hyperthreaded systems), keyed by either a numerical
// index, or the ALL value for an entry representing the
// aggregation across all CPUs.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "cpus/cpu"
// Path from root: "/system/cpus/cpu"
// Index (wildcarded): [E_Cpu_Index_Enum, UnionUint32]
func (n *SystemPathAny) CpuAny() *System_CpuPathAny {
	return &System_CpuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"cpus", "cpu"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// Cpu (list): List of CPU cores on the system (including logical CPUs
// on hyperthreaded systems), keyed by either a numerical
// index, or the ALL value for an entry representing the
// aggregation across all CPUs.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "cpus/cpu"
// Path from root: "/system/cpus/cpu"
// Index: [E_Cpu_Index_Enum, UnionUint32]
func (n *SystemPath) Cpu(Index System_Cpu_Index_Union) *System_CpuPath {
	return &System_CpuPath{
		NodePath: ygot.NewNodePath(
			[]string{"cpus", "cpu"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Cpu (list): List of CPU cores on the system (including logical CPUs
// on hyperthreaded systems), keyed by either a numerical
// index, or the ALL value for an entry representing the
// aggregation across all CPUs.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "cpus/cpu"
// Path from root: "/system/cpus/cpu"
// Index: [E_Cpu_Index_Enum, UnionUint32]
func (n *SystemPathAny) Cpu(Index System_Cpu_Index_Union) *System_CpuPathAny {
	return &System_CpuPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"cpus", "cpu"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// CurrentDatetime (leaf): The current system date and time.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/current-datetime"
// Path from root: "/system/state/current-datetime"
func (n *SystemPath) CurrentDatetime() *System_CurrentDatetimePath {
	return &System_CurrentDatetimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-datetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// CurrentDatetime (leaf): The current system date and time.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/current-datetime"
// Path from root: "/system/state/current-datetime"
func (n *SystemPathAny) CurrentDatetime() *System_CurrentDatetimePathAny {
	return &System_CurrentDatetimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "current-datetime"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dns (container): Enclosing container for DNS resolver data
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "dns"
// Path from root: "/system/dns"
func (n *SystemPath) Dns() *System_DnsPath {
	return &System_DnsPath{
		NodePath: ygot.NewNodePath(
			[]string{"dns"},
			map[string]interface{}{},
			n,
		),
	}
}

// Dns (container): Enclosing container for DNS resolver data
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "dns"
// Path from root: "/system/dns"
func (n *SystemPathAny) Dns() *System_DnsPathAny {
	return &System_DnsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"dns"},
			map[string]interface{}{},
			n,
		),
	}
}

// DomainName (leaf): Specifies the domain name used to form fully qualified name
// for unqualified hostnames.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/domain-name"
// Path from root: "/system/config/domain-name"
func (n *SystemPath) DomainName() *System_DomainNamePath {
	return &System_DomainNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "domain-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// DomainName (leaf): Specifies the domain name used to form fully qualified name
// for unqualified hostnames.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/domain-name"
// Path from root: "/system/config/domain-name"
func (n *SystemPathAny) DomainName() *System_DomainNamePathAny {
	return &System_DomainNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "domain-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hostname (leaf): The hostname of the device -- should be a single domain
// label, without the domain.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/hostname"
// Path from root: "/system/config/hostname"
func (n *SystemPath) Hostname() *System_HostnamePath {
	return &System_HostnamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hostname"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hostname (leaf): The hostname of the device -- should be a single domain
// label, without the domain.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/hostname"
// Path from root: "/system/config/hostname"
func (n *SystemPathAny) Hostname() *System_HostnamePathAny {
	return &System_HostnamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hostname"},
			map[string]interface{}{},
			n,
		),
	}
}

// License (container): Container for license model
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "license"
// Path from root: "/system/license"
func (n *SystemPath) License() *System_LicensePath {
	return &System_LicensePath{
		NodePath: ygot.NewNodePath(
			[]string{"license"},
			map[string]interface{}{},
			n,
		),
	}
}

// License (container): Container for license model
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "license"
// Path from root: "/system/license"
func (n *SystemPathAny) License() *System_LicensePathAny {
	return &System_LicensePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"license"},
			map[string]interface{}{},
			n,
		),
	}
}

// Logging (container): Top-level container for data related to logging / syslog
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "logging"
// Path from root: "/system/logging"
func (n *SystemPath) Logging() *System_LoggingPath {
	return &System_LoggingPath{
		NodePath: ygot.NewNodePath(
			[]string{"logging"},
			map[string]interface{}{},
			n,
		),
	}
}

// Logging (container): Top-level container for data related to logging / syslog
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "logging"
// Path from root: "/system/logging"
func (n *SystemPathAny) Logging() *System_LoggingPathAny {
	return &System_LoggingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"logging"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoginBanner (leaf): The console login message displayed before the login prompt,
// i.e., before a user logs into the system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/login-banner"
// Path from root: "/system/config/login-banner"
func (n *SystemPath) LoginBanner() *System_LoginBannerPath {
	return &System_LoginBannerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "login-banner"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoginBanner (leaf): The console login message displayed before the login prompt,
// i.e., before a user logs into the system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/login-banner"
// Path from root: "/system/config/login-banner"
func (n *SystemPathAny) LoginBanner() *System_LoginBannerPathAny {
	return &System_LoginBannerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "login-banner"},
			map[string]interface{}{},
			n,
		),
	}
}

// Memory (container): Top-level container for system memory data
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "memory"
// Path from root: "/system/memory"
func (n *SystemPath) Memory() *System_MemoryPath {
	return &System_MemoryPath{
		NodePath: ygot.NewNodePath(
			[]string{"memory"},
			map[string]interface{}{},
			n,
		),
	}
}

// Memory (container): Top-level container for system memory data
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "memory"
// Path from root: "/system/memory"
func (n *SystemPathAny) Memory() *System_MemoryPathAny {
	return &System_MemoryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"memory"},
			map[string]interface{}{},
			n,
		),
	}
}

// Messages (container): Top-level container for Syslog messages.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "messages"
// Path from root: "/system/messages"
func (n *SystemPath) Messages() *System_MessagesPath {
	return &System_MessagesPath{
		NodePath: ygot.NewNodePath(
			[]string{"messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// Messages (container): Top-level container for Syslog messages.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "messages"
// Path from root: "/system/messages"
func (n *SystemPathAny) Messages() *System_MessagesPathAny {
	return &System_MessagesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"messages"},
			map[string]interface{}{},
			n,
		),
	}
}

// MotdBanner (leaf): The console message displayed after a user logs into the
// system.  They system may append additional standard
// information such as the current system date and time, uptime,
// last login timestamp, etc.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/motd-banner"
// Path from root: "/system/config/motd-banner"
func (n *SystemPath) MotdBanner() *System_MotdBannerPath {
	return &System_MotdBannerPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "motd-banner"},
			map[string]interface{}{},
			n,
		),
	}
}

// MotdBanner (leaf): The console message displayed after a user logs into the
// system.  They system may append additional standard
// information such as the current system date and time, uptime,
// last login timestamp, etc.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/motd-banner"
// Path from root: "/system/config/motd-banner"
func (n *SystemPathAny) MotdBanner() *System_MotdBannerPathAny {
	return &System_MotdBannerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "motd-banner"},
			map[string]interface{}{},
			n,
		),
	}
}

// MountPointAny (list): List of mount points in the system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "mount-points/mount-point"
// Path from root: "/system/mount-points/mount-point"
// Name (wildcarded): string
func (n *SystemPath) MountPointAny() *System_MountPointPathAny {
	return &System_MountPointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mount-points", "mount-point"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// MountPointAny (list): List of mount points in the system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "mount-points/mount-point"
// Path from root: "/system/mount-points/mount-point"
// Name (wildcarded): string
func (n *SystemPathAny) MountPointAny() *System_MountPointPathAny {
	return &System_MountPointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mount-points", "mount-point"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// MountPoint (list): List of mount points in the system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "mount-points/mount-point"
// Path from root: "/system/mount-points/mount-point"
// Name: string
func (n *SystemPath) MountPoint(Name string) *System_MountPointPath {
	return &System_MountPointPath{
		NodePath: ygot.NewNodePath(
			[]string{"mount-points", "mount-point"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// MountPoint (list): List of mount points in the system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "mount-points/mount-point"
// Path from root: "/system/mount-points/mount-point"
// Name: string
func (n *SystemPathAny) MountPoint(Name string) *System_MountPointPathAny {
	return &System_MountPointPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"mount-points", "mount-point"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// Ntp (container): Top-level container for NTP configuration and state
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "ntp"
// Path from root: "/system/ntp"
func (n *SystemPath) Ntp() *System_NtpPath {
	return &System_NtpPath{
		NodePath: ygot.NewNodePath(
			[]string{"ntp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ntp (container): Top-level container for NTP configuration and state
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "ntp"
// Path from root: "/system/ntp"
func (n *SystemPathAny) Ntp() *System_NtpPathAny {
	return &System_NtpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ntp"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProcessAny (list): List of monitored processes
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "processes/process"
// Path from root: "/system/processes/process"
// Pid (wildcarded): uint64
func (n *SystemPath) ProcessAny() *System_ProcessPathAny {
	return &System_ProcessPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"processes", "process"},
			map[string]interface{}{"pid": "*"},
			n,
		),
	}
}

// ProcessAny (list): List of monitored processes
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "processes/process"
// Path from root: "/system/processes/process"
// Pid (wildcarded): uint64
func (n *SystemPathAny) ProcessAny() *System_ProcessPathAny {
	return &System_ProcessPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"processes", "process"},
			map[string]interface{}{"pid": "*"},
			n,
		),
	}
}

// Process (list): List of monitored processes
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "processes/process"
// Path from root: "/system/processes/process"
// Pid: uint64
func (n *SystemPath) Process(Pid uint64) *System_ProcessPath {
	return &System_ProcessPath{
		NodePath: ygot.NewNodePath(
			[]string{"processes", "process"},
			map[string]interface{}{"pid": Pid},
			n,
		),
	}
}

// Process (list): List of monitored processes
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "processes/process"
// Path from root: "/system/processes/process"
// Pid: uint64
func (n *SystemPathAny) Process(Pid uint64) *System_ProcessPathAny {
	return &System_ProcessPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"processes", "process"},
			map[string]interface{}{"pid": Pid},
			n,
		),
	}
}

// SshServer (container): Top-level container for ssh server
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "ssh-server"
// Path from root: "/system/ssh-server"
func (n *SystemPath) SshServer() *System_SshServerPath {
	return &System_SshServerPath{
		NodePath: ygot.NewNodePath(
			[]string{"ssh-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// SshServer (container): Top-level container for ssh server
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "ssh-server"
// Path from root: "/system/ssh-server"
func (n *SystemPathAny) SshServer() *System_SshServerPathAny {
	return &System_SshServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ssh-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// TelnetServer (container): Top-level container for telnet terminal servers
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "telnet-server"
// Path from root: "/system/telnet-server"
func (n *SystemPath) TelnetServer() *System_TelnetServerPath {
	return &System_TelnetServerPath{
		NodePath: ygot.NewNodePath(
			[]string{"telnet-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// TelnetServer (container): Top-level container for telnet terminal servers
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "telnet-server"
// Path from root: "/system/telnet-server"
func (n *SystemPathAny) TelnetServer() *System_TelnetServerPathAny {
	return &System_TelnetServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"telnet-server"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_AaaPath represents the /openconfig-system/system/aaa YANG schema element.
type System_AaaPath struct {
	*ygot.NodePath
}

// System_AaaPathAny represents the wildcard version of the /openconfig-system/system/aaa YANG schema element.
type System_AaaPathAny struct {
	*ygot.NodePath
}

// Accounting (container): Top-level container for AAA accounting
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "accounting"
// Path from root: "/system/aaa/accounting"
func (n *System_AaaPath) Accounting() *System_Aaa_AccountingPath {
	return &System_Aaa_AccountingPath{
		NodePath: ygot.NewNodePath(
			[]string{"accounting"},
			map[string]interface{}{},
			n,
		),
	}
}

// Accounting (container): Top-level container for AAA accounting
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "accounting"
// Path from root: "/system/aaa/accounting"
func (n *System_AaaPathAny) Accounting() *System_Aaa_AccountingPathAny {
	return &System_Aaa_AccountingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"accounting"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authentication (container): Top-level container for global authentication data
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "authentication"
// Path from root: "/system/aaa/authentication"
func (n *System_AaaPath) Authentication() *System_Aaa_AuthenticationPath {
	return &System_Aaa_AuthenticationPath{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authentication (container): Top-level container for global authentication data
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "authentication"
// Path from root: "/system/aaa/authentication"
func (n *System_AaaPathAny) Authentication() *System_Aaa_AuthenticationPathAny {
	return &System_Aaa_AuthenticationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authentication"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authorization (container): Top-level container for AAA authorization configuration
// and operational state data
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "authorization"
// Path from root: "/system/aaa/authorization"
func (n *System_AaaPath) Authorization() *System_Aaa_AuthorizationPath {
	return &System_Aaa_AuthorizationPath{
		NodePath: ygot.NewNodePath(
			[]string{"authorization"},
			map[string]interface{}{},
			n,
		),
	}
}

// Authorization (container): Top-level container for AAA authorization configuration
// and operational state data
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "authorization"
// Path from root: "/system/aaa/authorization"
func (n *System_AaaPathAny) Authorization() *System_Aaa_AuthorizationPathAny {
	return &System_Aaa_AuthorizationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"authorization"},
			map[string]interface{}{},
			n,
		),
	}
}

// ServerGroupAny (list): List of AAA server groups.  All servers in a group
// must have the same type as indicated by the server
// type.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "server-groups/server-group"
// Path from root: "/system/aaa/server-groups/server-group"
// Name (wildcarded): string
func (n *System_AaaPath) ServerGroupAny() *System_Aaa_ServerGroupPathAny {
	return &System_Aaa_ServerGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"server-groups", "server-group"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// ServerGroupAny (list): List of AAA server groups.  All servers in a group
// must have the same type as indicated by the server
// type.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "server-groups/server-group"
// Path from root: "/system/aaa/server-groups/server-group"
// Name (wildcarded): string
func (n *System_AaaPathAny) ServerGroupAny() *System_Aaa_ServerGroupPathAny {
	return &System_Aaa_ServerGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"server-groups", "server-group"},
			map[string]interface{}{"name": "*"},
			n,
		),
	}
}

// ServerGroup (list): List of AAA server groups.  All servers in a group
// must have the same type as indicated by the server
// type.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "server-groups/server-group"
// Path from root: "/system/aaa/server-groups/server-group"
// Name: string
func (n *System_AaaPath) ServerGroup(Name string) *System_Aaa_ServerGroupPath {
	return &System_Aaa_ServerGroupPath{
		NodePath: ygot.NewNodePath(
			[]string{"server-groups", "server-group"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// ServerGroup (list): List of AAA server groups.  All servers in a group
// must have the same type as indicated by the server
// type.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "server-groups/server-group"
// Path from root: "/system/aaa/server-groups/server-group"
// Name: string
func (n *System_AaaPathAny) ServerGroup(Name string) *System_Aaa_ServerGroupPathAny {
	return &System_Aaa_ServerGroupPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"server-groups", "server-group"},
			map[string]interface{}{"name": Name},
			n,
		),
	}
}

// System_Aaa_AccountingPath represents the /openconfig-system/system/aaa/accounting YANG schema element.
type System_Aaa_AccountingPath struct {
	*ygot.NodePath
}

// System_Aaa_AccountingPathAny represents the wildcard version of the /openconfig-system/system/aaa/accounting YANG schema element.
type System_Aaa_AccountingPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Accounting_AccountingMethodPath represents the /openconfig-system/system/aaa/accounting/config/accounting-method YANG schema element.
type System_Aaa_Accounting_AccountingMethodPath struct {
	*ygot.NodePath
}

// System_Aaa_Accounting_AccountingMethodPathAny represents the wildcard version of the /openconfig-system/system/aaa/accounting/config/accounting-method YANG schema element.
type System_Aaa_Accounting_AccountingMethodPathAny struct {
	*ygot.NodePath
}

// AccountingMethod (leaf): An ordered list of methods used for AAA accounting for this
// event type.  The method is defined by the destination for
// accounting data, which may be specified as the group of
// all TACACS+/RADIUS servers, a defined server group, or
// the local system.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/accounting-method"
// Path from root: "/system/aaa/accounting/config/accounting-method"
func (n *System_Aaa_AccountingPath) AccountingMethod() *System_Aaa_Accounting_AccountingMethodPath {
	return &System_Aaa_Accounting_AccountingMethodPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accounting-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// AccountingMethod (leaf): An ordered list of methods used for AAA accounting for this
// event type.  The method is defined by the destination for
// accounting data, which may be specified as the group of
// all TACACS+/RADIUS servers, a defined server group, or
// the local system.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/accounting-method"
// Path from root: "/system/aaa/accounting/config/accounting-method"
func (n *System_Aaa_AccountingPathAny) AccountingMethod() *System_Aaa_Accounting_AccountingMethodPathAny {
	return &System_Aaa_Accounting_AccountingMethodPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "accounting-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// EventAny (list): List of events subject to accounting
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "events/event"
// Path from root: "/system/aaa/accounting/events/event"
// EventType (wildcarded): E_AaaTypes_AAA_ACCOUNTING_EVENT_TYPE
func (n *System_Aaa_AccountingPath) EventAny() *System_Aaa_Accounting_EventPathAny {
	return &System_Aaa_Accounting_EventPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"events", "event"},
			map[string]interface{}{"event-type": "*"},
			n,
		),
	}
}

// EventAny (list): List of events subject to accounting
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "events/event"
// Path from root: "/system/aaa/accounting/events/event"
// EventType (wildcarded): E_AaaTypes_AAA_ACCOUNTING_EVENT_TYPE
func (n *System_Aaa_AccountingPathAny) EventAny() *System_Aaa_Accounting_EventPathAny {
	return &System_Aaa_Accounting_EventPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"events", "event"},
			map[string]interface{}{"event-type": "*"},
			n,
		),
	}
}

// Event (list): List of events subject to accounting
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "events/event"
// Path from root: "/system/aaa/accounting/events/event"
// EventType: E_AaaTypes_AAA_ACCOUNTING_EVENT_TYPE
func (n *System_Aaa_AccountingPath) Event(EventType E_AaaTypes_AAA_ACCOUNTING_EVENT_TYPE) *System_Aaa_Accounting_EventPath {
	return &System_Aaa_Accounting_EventPath{
		NodePath: ygot.NewNodePath(
			[]string{"events", "event"},
			map[string]interface{}{"event-type": EventType},
			n,
		),
	}
}

// Event (list): List of events subject to accounting
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "events/event"
// Path from root: "/system/aaa/accounting/events/event"
// EventType: E_AaaTypes_AAA_ACCOUNTING_EVENT_TYPE
func (n *System_Aaa_AccountingPathAny) Event(EventType E_AaaTypes_AAA_ACCOUNTING_EVENT_TYPE) *System_Aaa_Accounting_EventPathAny {
	return &System_Aaa_Accounting_EventPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"events", "event"},
			map[string]interface{}{"event-type": EventType},
			n,
		),
	}
}

// System_Aaa_Accounting_EventPath represents the /openconfig-system/system/aaa/accounting/events/event YANG schema element.
type System_Aaa_Accounting_EventPath struct {
	*ygot.NodePath
}

// System_Aaa_Accounting_EventPathAny represents the wildcard version of the /openconfig-system/system/aaa/accounting/events/event YANG schema element.
type System_Aaa_Accounting_EventPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Accounting_Event_EventTypePath represents the /openconfig-system/system/aaa/accounting/events/event/config/event-type YANG schema element.
type System_Aaa_Accounting_Event_EventTypePath struct {
	*ygot.NodePath
}

// System_Aaa_Accounting_Event_EventTypePathAny represents the wildcard version of the /openconfig-system/system/aaa/accounting/events/event/config/event-type YANG schema element.
type System_Aaa_Accounting_Event_EventTypePathAny struct {
	*ygot.NodePath
}

// System_Aaa_Accounting_Event_RecordPath represents the /openconfig-system/system/aaa/accounting/events/event/config/record YANG schema element.
type System_Aaa_Accounting_Event_RecordPath struct {
	*ygot.NodePath
}

// System_Aaa_Accounting_Event_RecordPathAny represents the wildcard version of the /openconfig-system/system/aaa/accounting/events/event/config/record YANG schema element.
type System_Aaa_Accounting_Event_RecordPathAny struct {
	*ygot.NodePath
}

// EventType (leaf): The type of activity to record at the AAA accounting
// server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/event-type"
// Path from root: "/system/aaa/accounting/events/event/config/event-type"
func (n *System_Aaa_Accounting_EventPath) EventType() *System_Aaa_Accounting_Event_EventTypePath {
	return &System_Aaa_Accounting_Event_EventTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "event-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// EventType (leaf): The type of activity to record at the AAA accounting
// server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/event-type"
// Path from root: "/system/aaa/accounting/events/event/config/event-type"
func (n *System_Aaa_Accounting_EventPathAny) EventType() *System_Aaa_Accounting_Event_EventTypePathAny {
	return &System_Aaa_Accounting_Event_EventTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "event-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Record (leaf): Type of record to send to the accounting server for this
// activity type
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/record"
// Path from root: "/system/aaa/accounting/events/event/config/record"
func (n *System_Aaa_Accounting_EventPath) Record() *System_Aaa_Accounting_Event_RecordPath {
	return &System_Aaa_Accounting_Event_RecordPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "record"},
			map[string]interface{}{},
			n,
		),
	}
}

// Record (leaf): Type of record to send to the accounting server for this
// activity type
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/record"
// Path from root: "/system/aaa/accounting/events/event/config/record"
func (n *System_Aaa_Accounting_EventPathAny) Record() *System_Aaa_Accounting_Event_RecordPathAny {
	return &System_Aaa_Accounting_Event_RecordPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "record"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Aaa_AuthenticationPath represents the /openconfig-system/system/aaa/authentication YANG schema element.
type System_Aaa_AuthenticationPath struct {
	*ygot.NodePath
}

// System_Aaa_AuthenticationPathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication YANG schema element.
type System_Aaa_AuthenticationPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_AuthenticationMethodPath represents the /openconfig-system/system/aaa/authentication/config/authentication-method YANG schema element.
type System_Aaa_Authentication_AuthenticationMethodPath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_AuthenticationMethodPathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/config/authentication-method YANG schema element.
type System_Aaa_Authentication_AuthenticationMethodPathAny struct {
	*ygot.NodePath
}

// AdminUser (container): Top-level container for the system root or admin user
// configuration and operational state
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "admin-user"
// Path from root: "/system/aaa/authentication/admin-user"
func (n *System_Aaa_AuthenticationPath) AdminUser() *System_Aaa_Authentication_AdminUserPath {
	return &System_Aaa_Authentication_AdminUserPath{
		NodePath: ygot.NewNodePath(
			[]string{"admin-user"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminUser (container): Top-level container for the system root or admin user
// configuration and operational state
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "admin-user"
// Path from root: "/system/aaa/authentication/admin-user"
func (n *System_Aaa_AuthenticationPathAny) AdminUser() *System_Aaa_Authentication_AdminUserPathAny {
	return &System_Aaa_Authentication_AdminUserPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"admin-user"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationMethod (leaf): Ordered list of authentication methods for users.  This
// can be either a reference to a server group, or a well-
// defined designation in the AAA_METHOD_TYPE identity.  If
// authentication fails with one method, the next defined
// method is tried -- failure of all methods results in the
// user being denied access.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/authentication-method"
// Path from root: "/system/aaa/authentication/config/authentication-method"
func (n *System_Aaa_AuthenticationPath) AuthenticationMethod() *System_Aaa_Authentication_AuthenticationMethodPath {
	return &System_Aaa_Authentication_AuthenticationMethodPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthenticationMethod (leaf): Ordered list of authentication methods for users.  This
// can be either a reference to a server group, or a well-
// defined designation in the AAA_METHOD_TYPE identity.  If
// authentication fails with one method, the next defined
// method is tried -- failure of all methods results in the
// user being denied access.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/authentication-method"
// Path from root: "/system/aaa/authentication/config/authentication-method"
func (n *System_Aaa_AuthenticationPathAny) AuthenticationMethod() *System_Aaa_Authentication_AuthenticationMethodPathAny {
	return &System_Aaa_Authentication_AuthenticationMethodPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authentication-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// UserAny (list): List of local users on the system
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "users/user"
// Path from root: "/system/aaa/authentication/users/user"
// Username (wildcarded): string
func (n *System_Aaa_AuthenticationPath) UserAny() *System_Aaa_Authentication_UserPathAny {
	return &System_Aaa_Authentication_UserPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"users", "user"},
			map[string]interface{}{"username": "*"},
			n,
		),
	}
}

// UserAny (list): List of local users on the system
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "users/user"
// Path from root: "/system/aaa/authentication/users/user"
// Username (wildcarded): string
func (n *System_Aaa_AuthenticationPathAny) UserAny() *System_Aaa_Authentication_UserPathAny {
	return &System_Aaa_Authentication_UserPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"users", "user"},
			map[string]interface{}{"username": "*"},
			n,
		),
	}
}

// User (list): List of local users on the system
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "users/user"
// Path from root: "/system/aaa/authentication/users/user"
// Username: string
func (n *System_Aaa_AuthenticationPath) User(Username string) *System_Aaa_Authentication_UserPath {
	return &System_Aaa_Authentication_UserPath{
		NodePath: ygot.NewNodePath(
			[]string{"users", "user"},
			map[string]interface{}{"username": Username},
			n,
		),
	}
}

// User (list): List of local users on the system
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "users/user"
// Path from root: "/system/aaa/authentication/users/user"
// Username: string
func (n *System_Aaa_AuthenticationPathAny) User(Username string) *System_Aaa_Authentication_UserPathAny {
	return &System_Aaa_Authentication_UserPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"users", "user"},
			map[string]interface{}{"username": Username},
			n,
		),
	}
}

// System_Aaa_Authentication_AdminUserPath represents the /openconfig-system/system/aaa/authentication/admin-user YANG schema element.
type System_Aaa_Authentication_AdminUserPath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_AdminUserPathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/admin-user YANG schema element.
type System_Aaa_Authentication_AdminUserPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_AdminUser_AdminPasswordPath represents the /openconfig-system/system/aaa/authentication/admin-user/config/admin-password YANG schema element.
type System_Aaa_Authentication_AdminUser_AdminPasswordPath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_AdminUser_AdminPasswordPathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/admin-user/config/admin-password YANG schema element.
type System_Aaa_Authentication_AdminUser_AdminPasswordPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_AdminUser_AdminPasswordHashedPath represents the /openconfig-system/system/aaa/authentication/admin-user/config/admin-password-hashed YANG schema element.
type System_Aaa_Authentication_AdminUser_AdminPasswordHashedPath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_AdminUser_AdminPasswordHashedPathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/admin-user/config/admin-password-hashed YANG schema element.
type System_Aaa_Authentication_AdminUser_AdminPasswordHashedPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_AdminUser_AdminUsernamePath represents the /openconfig-system/system/aaa/authentication/admin-user/state/admin-username YANG schema element.
type System_Aaa_Authentication_AdminUser_AdminUsernamePath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_AdminUser_AdminUsernamePathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/admin-user/state/admin-username YANG schema element.
type System_Aaa_Authentication_AdminUser_AdminUsernamePathAny struct {
	*ygot.NodePath
}

// AdminPassword (leaf): The admin/root password, supplied as a cleartext string.
// The system should hash and only store the password as a
// hashed value.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/admin-password"
// Path from root: "/system/aaa/authentication/admin-user/config/admin-password"
func (n *System_Aaa_Authentication_AdminUserPath) AdminPassword() *System_Aaa_Authentication_AdminUser_AdminPasswordPath {
	return &System_Aaa_Authentication_AdminUser_AdminPasswordPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminPassword (leaf): The admin/root password, supplied as a cleartext string.
// The system should hash and only store the password as a
// hashed value.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/admin-password"
// Path from root: "/system/aaa/authentication/admin-user/config/admin-password"
func (n *System_Aaa_Authentication_AdminUserPathAny) AdminPassword() *System_Aaa_Authentication_AdminUser_AdminPasswordPathAny {
	return &System_Aaa_Authentication_AdminUser_AdminPasswordPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-password"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminPasswordHashed (leaf): The admin/root password, supplied as a hashed value
// using the notation described in the definition of the
// crypt-password-type.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/admin-password-hashed"
// Path from root: "/system/aaa/authentication/admin-user/config/admin-password-hashed"
func (n *System_Aaa_Authentication_AdminUserPath) AdminPasswordHashed() *System_Aaa_Authentication_AdminUser_AdminPasswordHashedPath {
	return &System_Aaa_Authentication_AdminUser_AdminPasswordHashedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-password-hashed"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminPasswordHashed (leaf): The admin/root password, supplied as a hashed value
// using the notation described in the definition of the
// crypt-password-type.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/admin-password-hashed"
// Path from root: "/system/aaa/authentication/admin-user/config/admin-password-hashed"
func (n *System_Aaa_Authentication_AdminUserPathAny) AdminPasswordHashed() *System_Aaa_Authentication_AdminUser_AdminPasswordHashedPathAny {
	return &System_Aaa_Authentication_AdminUser_AdminPasswordHashedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-password-hashed"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminUsername (leaf): Name of the administrator user account, e.g., admin, root,
// etc.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/admin-username"
// Path from root: "/system/aaa/authentication/admin-user/state/admin-username"
func (n *System_Aaa_Authentication_AdminUserPath) AdminUsername() *System_Aaa_Authentication_AdminUser_AdminUsernamePath {
	return &System_Aaa_Authentication_AdminUser_AdminUsernamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-username"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminUsername (leaf): Name of the administrator user account, e.g., admin, root,
// etc.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/admin-username"
// Path from root: "/system/aaa/authentication/admin-user/state/admin-username"
func (n *System_Aaa_Authentication_AdminUserPathAny) AdminUsername() *System_Aaa_Authentication_AdminUser_AdminUsernamePathAny {
	return &System_Aaa_Authentication_AdminUser_AdminUsernamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "admin-username"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Aaa_Authentication_UserPath represents the /openconfig-system/system/aaa/authentication/users/user YANG schema element.
type System_Aaa_Authentication_UserPath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_UserPathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/users/user YANG schema element.
type System_Aaa_Authentication_UserPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_PasswordPath represents the /openconfig-system/system/aaa/authentication/users/user/config/password YANG schema element.
type System_Aaa_Authentication_User_PasswordPath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_PasswordPathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/users/user/config/password YANG schema element.
type System_Aaa_Authentication_User_PasswordPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_PasswordHashedPath represents the /openconfig-system/system/aaa/authentication/users/user/config/password-hashed YANG schema element.
type System_Aaa_Authentication_User_PasswordHashedPath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_PasswordHashedPathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/users/user/config/password-hashed YANG schema element.
type System_Aaa_Authentication_User_PasswordHashedPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_RolePath represents the /openconfig-system/system/aaa/authentication/users/user/config/role YANG schema element.
type System_Aaa_Authentication_User_RolePath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_RolePathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/users/user/config/role YANG schema element.
type System_Aaa_Authentication_User_RolePathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_SshKeyPath represents the /openconfig-system/system/aaa/authentication/users/user/config/ssh-key YANG schema element.
type System_Aaa_Authentication_User_SshKeyPath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_SshKeyPathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/users/user/config/ssh-key YANG schema element.
type System_Aaa_Authentication_User_SshKeyPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_UsernamePath represents the /openconfig-system/system/aaa/authentication/users/user/config/username YANG schema element.
type System_Aaa_Authentication_User_UsernamePath struct {
	*ygot.NodePath
}

// System_Aaa_Authentication_User_UsernamePathAny represents the wildcard version of the /openconfig-system/system/aaa/authentication/users/user/config/username YANG schema element.
type System_Aaa_Authentication_User_UsernamePathAny struct {
	*ygot.NodePath
}

// Password (leaf): The user password, supplied as cleartext.  The system
// must hash the value and only store the hashed value.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/password"
// Path from root: "/system/aaa/authentication/users/user/config/password"
func (n *System_Aaa_Authentication_UserPath) Password() *System_Aaa_Authentication_User_PasswordPath {
	return &System_Aaa_Authentication_User_PasswordPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "password"},
			map[string]interface{}{},
			n,
		),
	}
}

// Password (leaf): The user password, supplied as cleartext.  The system
// must hash the value and only store the hashed value.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/password"
// Path from root: "/system/aaa/authentication/users/user/config/password"
func (n *System_Aaa_Authentication_UserPathAny) Password() *System_Aaa_Authentication_User_PasswordPathAny {
	return &System_Aaa_Authentication_User_PasswordPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "password"},
			map[string]interface{}{},
			n,
		),
	}
}

// PasswordHashed (leaf): The user password, supplied as a hashed value
// using the notation described in the definition of the
// crypt-password-type.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/password-hashed"
// Path from root: "/system/aaa/authentication/users/user/config/password-hashed"
func (n *System_Aaa_Authentication_UserPath) PasswordHashed() *System_Aaa_Authentication_User_PasswordHashedPath {
	return &System_Aaa_Authentication_User_PasswordHashedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "password-hashed"},
			map[string]interface{}{},
			n,
		),
	}
}

// PasswordHashed (leaf): The user password, supplied as a hashed value
// using the notation described in the definition of the
// crypt-password-type.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/password-hashed"
// Path from root: "/system/aaa/authentication/users/user/config/password-hashed"
func (n *System_Aaa_Authentication_UserPathAny) PasswordHashed() *System_Aaa_Authentication_User_PasswordHashedPathAny {
	return &System_Aaa_Authentication_User_PasswordHashedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "password-hashed"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): Role assigned to the user.  The role may be supplied
// as a string or a role defined by the SYSTEM_DEFINED_ROLES
// identity.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/role"
// Path from root: "/system/aaa/authentication/users/user/config/role"
func (n *System_Aaa_Authentication_UserPath) Role() *System_Aaa_Authentication_User_RolePath {
	return &System_Aaa_Authentication_User_RolePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// Role (leaf): Role assigned to the user.  The role may be supplied
// as a string or a role defined by the SYSTEM_DEFINED_ROLES
// identity.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/role"
// Path from root: "/system/aaa/authentication/users/user/config/role"
func (n *System_Aaa_Authentication_UserPathAny) Role() *System_Aaa_Authentication_User_RolePathAny {
	return &System_Aaa_Authentication_User_RolePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "role"},
			map[string]interface{}{},
			n,
		),
	}
}

// SshKey (leaf): SSH public key for the user (RSA or DSA)
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/ssh-key"
// Path from root: "/system/aaa/authentication/users/user/config/ssh-key"
func (n *System_Aaa_Authentication_UserPath) SshKey() *System_Aaa_Authentication_User_SshKeyPath {
	return &System_Aaa_Authentication_User_SshKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ssh-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// SshKey (leaf): SSH public key for the user (RSA or DSA)
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/ssh-key"
// Path from root: "/system/aaa/authentication/users/user/config/ssh-key"
func (n *System_Aaa_Authentication_UserPathAny) SshKey() *System_Aaa_Authentication_User_SshKeyPathAny {
	return &System_Aaa_Authentication_User_SshKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ssh-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// Username (leaf): Assigned username for this user
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/username"
// Path from root: "/system/aaa/authentication/users/user/config/username"
func (n *System_Aaa_Authentication_UserPath) Username() *System_Aaa_Authentication_User_UsernamePath {
	return &System_Aaa_Authentication_User_UsernamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "username"},
			map[string]interface{}{},
			n,
		),
	}
}

// Username (leaf): Assigned username for this user
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/username"
// Path from root: "/system/aaa/authentication/users/user/config/username"
func (n *System_Aaa_Authentication_UserPathAny) Username() *System_Aaa_Authentication_User_UsernamePathAny {
	return &System_Aaa_Authentication_User_UsernamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "username"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Aaa_AuthorizationPath represents the /openconfig-system/system/aaa/authorization YANG schema element.
type System_Aaa_AuthorizationPath struct {
	*ygot.NodePath
}

// System_Aaa_AuthorizationPathAny represents the wildcard version of the /openconfig-system/system/aaa/authorization YANG schema element.
type System_Aaa_AuthorizationPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authorization_AuthorizationMethodPath represents the /openconfig-system/system/aaa/authorization/config/authorization-method YANG schema element.
type System_Aaa_Authorization_AuthorizationMethodPath struct {
	*ygot.NodePath
}

// System_Aaa_Authorization_AuthorizationMethodPathAny represents the wildcard version of the /openconfig-system/system/aaa/authorization/config/authorization-method YANG schema element.
type System_Aaa_Authorization_AuthorizationMethodPathAny struct {
	*ygot.NodePath
}

// AuthorizationMethod (leaf): Ordered list of methods for authorizing commands.  The first
// method that provides a response (positive or negative) should
// be used.  The list may contain a well-defined method such
// as the set of all TACACS or RADIUS servers, or the name of
// a defined AAA server group.  The system must validate
// that the named server group exists.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/authorization-method"
// Path from root: "/system/aaa/authorization/config/authorization-method"
func (n *System_Aaa_AuthorizationPath) AuthorizationMethod() *System_Aaa_Authorization_AuthorizationMethodPath {
	return &System_Aaa_Authorization_AuthorizationMethodPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authorization-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthorizationMethod (leaf): Ordered list of methods for authorizing commands.  The first
// method that provides a response (positive or negative) should
// be used.  The list may contain a well-defined method such
// as the set of all TACACS or RADIUS servers, or the name of
// a defined AAA server group.  The system must validate
// that the named server group exists.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/authorization-method"
// Path from root: "/system/aaa/authorization/config/authorization-method"
func (n *System_Aaa_AuthorizationPathAny) AuthorizationMethod() *System_Aaa_Authorization_AuthorizationMethodPathAny {
	return &System_Aaa_Authorization_AuthorizationMethodPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "authorization-method"},
			map[string]interface{}{},
			n,
		),
	}
}

// EventAny (list): List of events subject to AAA authorization
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "events/event"
// Path from root: "/system/aaa/authorization/events/event"
// EventType (wildcarded): E_AaaTypes_AAA_AUTHORIZATION_EVENT_TYPE
func (n *System_Aaa_AuthorizationPath) EventAny() *System_Aaa_Authorization_EventPathAny {
	return &System_Aaa_Authorization_EventPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"events", "event"},
			map[string]interface{}{"event-type": "*"},
			n,
		),
	}
}

// EventAny (list): List of events subject to AAA authorization
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "events/event"
// Path from root: "/system/aaa/authorization/events/event"
// EventType (wildcarded): E_AaaTypes_AAA_AUTHORIZATION_EVENT_TYPE
func (n *System_Aaa_AuthorizationPathAny) EventAny() *System_Aaa_Authorization_EventPathAny {
	return &System_Aaa_Authorization_EventPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"events", "event"},
			map[string]interface{}{"event-type": "*"},
			n,
		),
	}
}

// Event (list): List of events subject to AAA authorization
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "events/event"
// Path from root: "/system/aaa/authorization/events/event"
// EventType: E_AaaTypes_AAA_AUTHORIZATION_EVENT_TYPE
func (n *System_Aaa_AuthorizationPath) Event(EventType E_AaaTypes_AAA_AUTHORIZATION_EVENT_TYPE) *System_Aaa_Authorization_EventPath {
	return &System_Aaa_Authorization_EventPath{
		NodePath: ygot.NewNodePath(
			[]string{"events", "event"},
			map[string]interface{}{"event-type": EventType},
			n,
		),
	}
}

// Event (list): List of events subject to AAA authorization
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "events/event"
// Path from root: "/system/aaa/authorization/events/event"
// EventType: E_AaaTypes_AAA_AUTHORIZATION_EVENT_TYPE
func (n *System_Aaa_AuthorizationPathAny) Event(EventType E_AaaTypes_AAA_AUTHORIZATION_EVENT_TYPE) *System_Aaa_Authorization_EventPathAny {
	return &System_Aaa_Authorization_EventPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"events", "event"},
			map[string]interface{}{"event-type": EventType},
			n,
		),
	}
}

// System_Aaa_Authorization_EventPath represents the /openconfig-system/system/aaa/authorization/events/event YANG schema element.
type System_Aaa_Authorization_EventPath struct {
	*ygot.NodePath
}

// System_Aaa_Authorization_EventPathAny represents the wildcard version of the /openconfig-system/system/aaa/authorization/events/event YANG schema element.
type System_Aaa_Authorization_EventPathAny struct {
	*ygot.NodePath
}

// System_Aaa_Authorization_Event_EventTypePath represents the /openconfig-system/system/aaa/authorization/events/event/config/event-type YANG schema element.
type System_Aaa_Authorization_Event_EventTypePath struct {
	*ygot.NodePath
}

// System_Aaa_Authorization_Event_EventTypePathAny represents the wildcard version of the /openconfig-system/system/aaa/authorization/events/event/config/event-type YANG schema element.
type System_Aaa_Authorization_Event_EventTypePathAny struct {
	*ygot.NodePath
}

// EventType (leaf): The type of event to record at the AAA authorization
// server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/event-type"
// Path from root: "/system/aaa/authorization/events/event/config/event-type"
func (n *System_Aaa_Authorization_EventPath) EventType() *System_Aaa_Authorization_Event_EventTypePath {
	return &System_Aaa_Authorization_Event_EventTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "event-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// EventType (leaf): The type of event to record at the AAA authorization
// server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/event-type"
// Path from root: "/system/aaa/authorization/events/event/config/event-type"
func (n *System_Aaa_Authorization_EventPathAny) EventType() *System_Aaa_Authorization_Event_EventTypePathAny {
	return &System_Aaa_Authorization_Event_EventTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "event-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Aaa_ServerGroupPath represents the /openconfig-system/system/aaa/server-groups/server-group YANG schema element.
type System_Aaa_ServerGroupPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroupPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group YANG schema element.
type System_Aaa_ServerGroupPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_NamePath represents the /openconfig-system/system/aaa/server-groups/server-group/config/name YANG schema element.
type System_Aaa_ServerGroup_NamePath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_NamePathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/config/name YANG schema element.
type System_Aaa_ServerGroup_NamePathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_TypePath represents the /openconfig-system/system/aaa/server-groups/server-group/config/type YANG schema element.
type System_Aaa_ServerGroup_TypePath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_TypePathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/config/type YANG schema element.
type System_Aaa_ServerGroup_TypePathAny struct {
	*ygot.NodePath
}

// Name (leaf): Name for the server group
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/name"
// Path from root: "/system/aaa/server-groups/server-group/config/name"
func (n *System_Aaa_ServerGroupPath) Name() *System_Aaa_ServerGroup_NamePath {
	return &System_Aaa_ServerGroup_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Name for the server group
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/name"
// Path from root: "/system/aaa/server-groups/server-group/config/name"
func (n *System_Aaa_ServerGroupPathAny) Name() *System_Aaa_ServerGroup_NamePathAny {
	return &System_Aaa_ServerGroup_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// ServerAny (list): List of AAA servers
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/aaa/server-groups/server-group/servers/server"
// Address (wildcarded): string
func (n *System_Aaa_ServerGroupPath) ServerAny() *System_Aaa_ServerGroup_ServerPathAny {
	return &System_Aaa_ServerGroup_ServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// ServerAny (list): List of AAA servers
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/aaa/server-groups/server-group/servers/server"
// Address (wildcarded): string
func (n *System_Aaa_ServerGroupPathAny) ServerAny() *System_Aaa_ServerGroup_ServerPathAny {
	return &System_Aaa_ServerGroup_ServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// Server (list): List of AAA servers
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/aaa/server-groups/server-group/servers/server"
// Address: string
func (n *System_Aaa_ServerGroupPath) Server(Address string) *System_Aaa_ServerGroup_ServerPath {
	return &System_Aaa_ServerGroup_ServerPath{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// Server (list): List of AAA servers
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/aaa/server-groups/server-group/servers/server"
// Address: string
func (n *System_Aaa_ServerGroupPathAny) Server(Address string) *System_Aaa_ServerGroup_ServerPathAny {
	return &System_Aaa_ServerGroup_ServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// Type (leaf): AAA server type -- all servers in the group must be of this
// type
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/type"
// Path from root: "/system/aaa/server-groups/server-group/config/type"
func (n *System_Aaa_ServerGroupPath) Type() *System_Aaa_ServerGroup_TypePath {
	return &System_Aaa_ServerGroup_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): AAA server type -- all servers in the group must be of this
// type
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/type"
// Path from root: "/system/aaa/server-groups/server-group/config/type"
func (n *System_Aaa_ServerGroupPathAny) Type() *System_Aaa_ServerGroup_TypePathAny {
	return &System_Aaa_ServerGroup_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Aaa_ServerGroup_ServerPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server YANG schema element.
type System_Aaa_ServerGroup_ServerPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_ServerPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server YANG schema element.
type System_Aaa_ServerGroup_ServerPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_AddressPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/config/address YANG schema element.
type System_Aaa_ServerGroup_Server_AddressPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_AddressPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/config/address YANG schema element.
type System_Aaa_ServerGroup_Server_AddressPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionAbortsPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-aborts YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionAbortsPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionAbortsPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-aborts YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionAbortsPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionClosesPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-closes YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionClosesPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionClosesPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-closes YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionClosesPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionFailuresPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-failures YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionFailuresPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionFailuresPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-failures YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionFailuresPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionOpensPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-opens YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionOpensPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionOpensPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-opens YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionOpensPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionTimeoutsPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-timeouts YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionTimeoutsPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ConnectionTimeoutsPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/connection-timeouts YANG schema element.
type System_Aaa_ServerGroup_Server_ConnectionTimeoutsPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ErrorsReceivedPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/errors-received YANG schema element.
type System_Aaa_ServerGroup_Server_ErrorsReceivedPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_ErrorsReceivedPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/errors-received YANG schema element.
type System_Aaa_ServerGroup_Server_ErrorsReceivedPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_MessagesReceivedPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/messages-received YANG schema element.
type System_Aaa_ServerGroup_Server_MessagesReceivedPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_MessagesReceivedPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/messages-received YANG schema element.
type System_Aaa_ServerGroup_Server_MessagesReceivedPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_MessagesSentPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/messages-sent YANG schema element.
type System_Aaa_ServerGroup_Server_MessagesSentPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_MessagesSentPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/state/messages-sent YANG schema element.
type System_Aaa_ServerGroup_Server_MessagesSentPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_NamePath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/config/name YANG schema element.
type System_Aaa_ServerGroup_Server_NamePath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_NamePathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/config/name YANG schema element.
type System_Aaa_ServerGroup_Server_NamePathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_TimeoutPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/config/timeout YANG schema element.
type System_Aaa_ServerGroup_Server_TimeoutPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_TimeoutPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/config/timeout YANG schema element.
type System_Aaa_ServerGroup_Server_TimeoutPathAny struct {
	*ygot.NodePath
}

// Address (leaf): Address of the authentication server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/address"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/config/address"
func (n *System_Aaa_ServerGroup_ServerPath) Address() *System_Aaa_ServerGroup_Server_AddressPath {
	return &System_Aaa_ServerGroup_Server_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): Address of the authentication server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/address"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/config/address"
func (n *System_Aaa_ServerGroup_ServerPathAny) Address() *System_Aaa_ServerGroup_Server_AddressPathAny {
	return &System_Aaa_ServerGroup_Server_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionAborts (leaf): Number of aborted connections to the server.  These do
// not include connections that are close gracefully.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-aborts"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-aborts"
func (n *System_Aaa_ServerGroup_ServerPath) ConnectionAborts() *System_Aaa_ServerGroup_Server_ConnectionAbortsPath {
	return &System_Aaa_ServerGroup_Server_ConnectionAbortsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-aborts"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionAborts (leaf): Number of aborted connections to the server.  These do
// not include connections that are close gracefully.
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-aborts"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-aborts"
func (n *System_Aaa_ServerGroup_ServerPathAny) ConnectionAborts() *System_Aaa_ServerGroup_Server_ConnectionAbortsPathAny {
	return &System_Aaa_ServerGroup_Server_ConnectionAbortsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-aborts"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionCloses (leaf): Number of connection close requests sent to the server, e.g.
// socket close
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-closes"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-closes"
func (n *System_Aaa_ServerGroup_ServerPath) ConnectionCloses() *System_Aaa_ServerGroup_Server_ConnectionClosesPath {
	return &System_Aaa_ServerGroup_Server_ConnectionClosesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-closes"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionCloses (leaf): Number of connection close requests sent to the server, e.g.
// socket close
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-closes"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-closes"
func (n *System_Aaa_ServerGroup_ServerPathAny) ConnectionCloses() *System_Aaa_ServerGroup_Server_ConnectionClosesPathAny {
	return &System_Aaa_ServerGroup_Server_ConnectionClosesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-closes"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionFailures (leaf): Number of connection failures to the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-failures"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-failures"
func (n *System_Aaa_ServerGroup_ServerPath) ConnectionFailures() *System_Aaa_ServerGroup_Server_ConnectionFailuresPath {
	return &System_Aaa_ServerGroup_Server_ConnectionFailuresPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-failures"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionFailures (leaf): Number of connection failures to the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-failures"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-failures"
func (n *System_Aaa_ServerGroup_ServerPathAny) ConnectionFailures() *System_Aaa_ServerGroup_Server_ConnectionFailuresPathAny {
	return &System_Aaa_ServerGroup_Server_ConnectionFailuresPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-failures"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionOpens (leaf): Number of new connection requests sent to the server, e.g.
// socket open
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-opens"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-opens"
func (n *System_Aaa_ServerGroup_ServerPath) ConnectionOpens() *System_Aaa_ServerGroup_Server_ConnectionOpensPath {
	return &System_Aaa_ServerGroup_Server_ConnectionOpensPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-opens"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionOpens (leaf): Number of new connection requests sent to the server, e.g.
// socket open
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-opens"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-opens"
func (n *System_Aaa_ServerGroup_ServerPathAny) ConnectionOpens() *System_Aaa_ServerGroup_Server_ConnectionOpensPathAny {
	return &System_Aaa_ServerGroup_Server_ConnectionOpensPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-opens"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionTimeouts (leaf): Number of connection timeouts to the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-timeouts"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-timeouts"
func (n *System_Aaa_ServerGroup_ServerPath) ConnectionTimeouts() *System_Aaa_ServerGroup_Server_ConnectionTimeoutsPath {
	return &System_Aaa_ServerGroup_Server_ConnectionTimeoutsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-timeouts"},
			map[string]interface{}{},
			n,
		),
	}
}

// ConnectionTimeouts (leaf): Number of connection timeouts to the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/connection-timeouts"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/connection-timeouts"
func (n *System_Aaa_ServerGroup_ServerPathAny) ConnectionTimeouts() *System_Aaa_ServerGroup_Server_ConnectionTimeoutsPathAny {
	return &System_Aaa_ServerGroup_Server_ConnectionTimeoutsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "connection-timeouts"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorsReceived (leaf): Number of error messages received from the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/errors-received"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/errors-received"
func (n *System_Aaa_ServerGroup_ServerPath) ErrorsReceived() *System_Aaa_ServerGroup_Server_ErrorsReceivedPath {
	return &System_Aaa_ServerGroup_Server_ErrorsReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "errors-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErrorsReceived (leaf): Number of error messages received from the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/errors-received"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/errors-received"
func (n *System_Aaa_ServerGroup_ServerPathAny) ErrorsReceived() *System_Aaa_ServerGroup_Server_ErrorsReceivedPathAny {
	return &System_Aaa_ServerGroup_Server_ErrorsReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "errors-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// MessagesReceived (leaf): Number of messages received by the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/messages-received"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/messages-received"
func (n *System_Aaa_ServerGroup_ServerPath) MessagesReceived() *System_Aaa_ServerGroup_Server_MessagesReceivedPath {
	return &System_Aaa_ServerGroup_Server_MessagesReceivedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "messages-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// MessagesReceived (leaf): Number of messages received by the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/messages-received"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/messages-received"
func (n *System_Aaa_ServerGroup_ServerPathAny) MessagesReceived() *System_Aaa_ServerGroup_Server_MessagesReceivedPathAny {
	return &System_Aaa_ServerGroup_Server_MessagesReceivedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "messages-received"},
			map[string]interface{}{},
			n,
		),
	}
}

// MessagesSent (leaf): Number of messages sent to the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/messages-sent"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/messages-sent"
func (n *System_Aaa_ServerGroup_ServerPath) MessagesSent() *System_Aaa_ServerGroup_Server_MessagesSentPath {
	return &System_Aaa_ServerGroup_Server_MessagesSentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "messages-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// MessagesSent (leaf): Number of messages sent to the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "state/messages-sent"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/state/messages-sent"
func (n *System_Aaa_ServerGroup_ServerPathAny) MessagesSent() *System_Aaa_ServerGroup_Server_MessagesSentPathAny {
	return &System_Aaa_ServerGroup_Server_MessagesSentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "messages-sent"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Name assigned to the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/name"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/config/name"
func (n *System_Aaa_ServerGroup_ServerPath) Name() *System_Aaa_ServerGroup_Server_NamePath {
	return &System_Aaa_ServerGroup_Server_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Name assigned to the server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/name"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/config/name"
func (n *System_Aaa_ServerGroup_ServerPathAny) Name() *System_Aaa_ServerGroup_Server_NamePathAny {
	return &System_Aaa_ServerGroup_Server_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Radius (container): Top-level container for RADIUS server data
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "radius"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius"
func (n *System_Aaa_ServerGroup_ServerPath) Radius() *System_Aaa_ServerGroup_Server_RadiusPath {
	return &System_Aaa_ServerGroup_Server_RadiusPath{
		NodePath: ygot.NewNodePath(
			[]string{"radius"},
			map[string]interface{}{},
			n,
		),
	}
}

// Radius (container): Top-level container for RADIUS server data
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "radius"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius"
func (n *System_Aaa_ServerGroup_ServerPathAny) Radius() *System_Aaa_ServerGroup_Server_RadiusPathAny {
	return &System_Aaa_ServerGroup_Server_RadiusPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"radius"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tacacs (container): Top-level container for TACACS+ server data
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "tacacs"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs"
func (n *System_Aaa_ServerGroup_ServerPath) Tacacs() *System_Aaa_ServerGroup_Server_TacacsPath {
	return &System_Aaa_ServerGroup_Server_TacacsPath{
		NodePath: ygot.NewNodePath(
			[]string{"tacacs"},
			map[string]interface{}{},
			n,
		),
	}
}

// Tacacs (container): Top-level container for TACACS+ server data
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "tacacs"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs"
func (n *System_Aaa_ServerGroup_ServerPathAny) Tacacs() *System_Aaa_ServerGroup_Server_TacacsPathAny {
	return &System_Aaa_ServerGroup_Server_TacacsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tacacs"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): Set the timeout in seconds on responses from the AAA
// server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/timeout"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/config/timeout"
func (n *System_Aaa_ServerGroup_ServerPath) Timeout() *System_Aaa_ServerGroup_Server_TimeoutPath {
	return &System_Aaa_ServerGroup_Server_TimeoutPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): Set the timeout in seconds on responses from the AAA
// server
// ----------------------------------------
// Defining module: "openconfig-aaa"
// Instantiating module: "openconfig-system"
// Path from parent: "config/timeout"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/config/timeout"
func (n *System_Aaa_ServerGroup_ServerPathAny) Timeout() *System_Aaa_ServerGroup_Server_TimeoutPathAny {
	return &System_Aaa_ServerGroup_Server_TimeoutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Aaa_ServerGroup_Server_RadiusPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius YANG schema element.
type System_Aaa_ServerGroup_Server_RadiusPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_RadiusPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius YANG schema element.
type System_Aaa_ServerGroup_Server_RadiusPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_AcctPortPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/acct-port YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_AcctPortPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_AcctPortPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/acct-port YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_AcctPortPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_AuthPortPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/auth-port YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_AuthPortPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_AuthPortPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/auth-port YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_AuthPortPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_RetransmitAttemptsPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/retransmit-attempts YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_RetransmitAttemptsPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_RetransmitAttemptsPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/retransmit-attempts YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_RetransmitAttemptsPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_SecretKeyPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/secret-key YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_SecretKeyPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_SecretKeyPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/secret-key YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_SecretKeyPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_SecretKeyHashedPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/secret-key-hashed YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_SecretKeyHashedPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_SecretKeyHashedPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/secret-key-hashed YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_SecretKeyHashedPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_SourceAddressPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/source-address YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_SourceAddressPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_SourceAddressPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/config/source-address YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_SourceAddressPathAny struct {
	*ygot.NodePath
}

// AcctPort (leaf): Port number for accounting requests
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/acct-port"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/acct-port"
func (n *System_Aaa_ServerGroup_Server_RadiusPath) AcctPort() *System_Aaa_ServerGroup_Server_Radius_AcctPortPath {
	return &System_Aaa_ServerGroup_Server_Radius_AcctPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "acct-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// AcctPort (leaf): Port number for accounting requests
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/acct-port"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/acct-port"
func (n *System_Aaa_ServerGroup_Server_RadiusPathAny) AcctPort() *System_Aaa_ServerGroup_Server_Radius_AcctPortPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_AcctPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "acct-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPort (leaf): Port number for authentication requests
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/auth-port"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/auth-port"
func (n *System_Aaa_ServerGroup_Server_RadiusPath) AuthPort() *System_Aaa_ServerGroup_Server_Radius_AuthPortPath {
	return &System_Aaa_ServerGroup_Server_Radius_AuthPortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthPort (leaf): Port number for authentication requests
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/auth-port"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/auth-port"
func (n *System_Aaa_ServerGroup_Server_RadiusPathAny) AuthPort() *System_Aaa_ServerGroup_Server_Radius_AuthPortPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_AuthPortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "auth-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): A collection of RADIUS related state objects.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "state/counters"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters"
func (n *System_Aaa_ServerGroup_Server_RadiusPath) Counters() *System_Aaa_ServerGroup_Server_Radius_CountersPath {
	return &System_Aaa_ServerGroup_Server_Radius_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): A collection of RADIUS related state objects.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "state/counters"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters"
func (n *System_Aaa_ServerGroup_Server_RadiusPathAny) Counters() *System_Aaa_ServerGroup_Server_Radius_CountersPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetransmitAttempts (leaf): Number of times the system may resend a request to the
// RADIUS server when it is unresponsive
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/retransmit-attempts"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/retransmit-attempts"
func (n *System_Aaa_ServerGroup_Server_RadiusPath) RetransmitAttempts() *System_Aaa_ServerGroup_Server_Radius_RetransmitAttemptsPath {
	return &System_Aaa_ServerGroup_Server_Radius_RetransmitAttemptsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "retransmit-attempts"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetransmitAttempts (leaf): Number of times the system may resend a request to the
// RADIUS server when it is unresponsive
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/retransmit-attempts"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/retransmit-attempts"
func (n *System_Aaa_ServerGroup_Server_RadiusPathAny) RetransmitAttempts() *System_Aaa_ServerGroup_Server_Radius_RetransmitAttemptsPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_RetransmitAttemptsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "retransmit-attempts"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKey (leaf): The unencrypted shared key used between the authentication
// server and the device.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/secret-key"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/secret-key"
func (n *System_Aaa_ServerGroup_Server_RadiusPath) SecretKey() *System_Aaa_ServerGroup_Server_Radius_SecretKeyPath {
	return &System_Aaa_ServerGroup_Server_Radius_SecretKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKey (leaf): The unencrypted shared key used between the authentication
// server and the device.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/secret-key"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/secret-key"
func (n *System_Aaa_ServerGroup_Server_RadiusPathAny) SecretKey() *System_Aaa_ServerGroup_Server_Radius_SecretKeyPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_SecretKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKeyHashed (leaf): The hashed shared key used between the authentication
// server and the device.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/secret-key-hashed"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/secret-key-hashed"
func (n *System_Aaa_ServerGroup_Server_RadiusPath) SecretKeyHashed() *System_Aaa_ServerGroup_Server_Radius_SecretKeyHashedPath {
	return &System_Aaa_ServerGroup_Server_Radius_SecretKeyHashedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key-hashed"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKeyHashed (leaf): The hashed shared key used between the authentication
// server and the device.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/secret-key-hashed"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/secret-key-hashed"
func (n *System_Aaa_ServerGroup_Server_RadiusPathAny) SecretKeyHashed() *System_Aaa_ServerGroup_Server_Radius_SecretKeyHashedPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_SecretKeyHashedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key-hashed"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IP address to use in messages to the RADIUS server
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/source-address"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/source-address"
func (n *System_Aaa_ServerGroup_Server_RadiusPath) SourceAddress() *System_Aaa_ServerGroup_Server_Radius_SourceAddressPath {
	return &System_Aaa_ServerGroup_Server_Radius_SourceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IP address to use in messages to the RADIUS server
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "config/source-address"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/config/source-address"
func (n *System_Aaa_ServerGroup_Server_RadiusPathAny) SourceAddress() *System_Aaa_ServerGroup_Server_Radius_SourceAddressPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_SourceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Aaa_ServerGroup_Server_Radius_CountersPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_CountersPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_CountersPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_CountersPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_Counters_AccessAcceptsPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters/access-accepts YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_Counters_AccessAcceptsPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_Counters_AccessAcceptsPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters/access-accepts YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_Counters_AccessAcceptsPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_Counters_AccessRejectsPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters/access-rejects YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_Counters_AccessRejectsPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_Counters_AccessRejectsPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters/access-rejects YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_Counters_AccessRejectsPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_Counters_RetriedAccessRequestsPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters/retried-access-requests YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_Counters_RetriedAccessRequestsPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_Counters_RetriedAccessRequestsPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters/retried-access-requests YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_Counters_RetriedAccessRequestsPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_Counters_TimeoutAccessRequestsPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters/timeout-access-requests YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_Counters_TimeoutAccessRequestsPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Radius_Counters_TimeoutAccessRequestsPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/radius/state/counters/timeout-access-requests YANG schema element.
type System_Aaa_ServerGroup_Server_Radius_Counters_TimeoutAccessRequestsPathAny struct {
	*ygot.NodePath
}

// AccessAccepts (leaf): Received Access-Accept messages.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "access-accepts"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters/access-accepts"
func (n *System_Aaa_ServerGroup_Server_Radius_CountersPath) AccessAccepts() *System_Aaa_ServerGroup_Server_Radius_Counters_AccessAcceptsPath {
	return &System_Aaa_ServerGroup_Server_Radius_Counters_AccessAcceptsPath{
		NodePath: ygot.NewNodePath(
			[]string{"access-accepts"},
			map[string]interface{}{},
			n,
		),
	}
}

// AccessAccepts (leaf): Received Access-Accept messages.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "access-accepts"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters/access-accepts"
func (n *System_Aaa_ServerGroup_Server_Radius_CountersPathAny) AccessAccepts() *System_Aaa_ServerGroup_Server_Radius_Counters_AccessAcceptsPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_Counters_AccessAcceptsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"access-accepts"},
			map[string]interface{}{},
			n,
		),
	}
}

// AccessRejects (leaf): Received Access-Reject messages.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "access-rejects"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters/access-rejects"
func (n *System_Aaa_ServerGroup_Server_Radius_CountersPath) AccessRejects() *System_Aaa_ServerGroup_Server_Radius_Counters_AccessRejectsPath {
	return &System_Aaa_ServerGroup_Server_Radius_Counters_AccessRejectsPath{
		NodePath: ygot.NewNodePath(
			[]string{"access-rejects"},
			map[string]interface{}{},
			n,
		),
	}
}

// AccessRejects (leaf): Received Access-Reject messages.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "access-rejects"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters/access-rejects"
func (n *System_Aaa_ServerGroup_Server_Radius_CountersPathAny) AccessRejects() *System_Aaa_ServerGroup_Server_Radius_Counters_AccessRejectsPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_Counters_AccessRejectsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"access-rejects"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetriedAccessRequests (leaf): Retransmitted Access-Request messages.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "retried-access-requests"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters/retried-access-requests"
func (n *System_Aaa_ServerGroup_Server_Radius_CountersPath) RetriedAccessRequests() *System_Aaa_ServerGroup_Server_Radius_Counters_RetriedAccessRequestsPath {
	return &System_Aaa_ServerGroup_Server_Radius_Counters_RetriedAccessRequestsPath{
		NodePath: ygot.NewNodePath(
			[]string{"retried-access-requests"},
			map[string]interface{}{},
			n,
		),
	}
}

// RetriedAccessRequests (leaf): Retransmitted Access-Request messages.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "retried-access-requests"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters/retried-access-requests"
func (n *System_Aaa_ServerGroup_Server_Radius_CountersPathAny) RetriedAccessRequests() *System_Aaa_ServerGroup_Server_Radius_Counters_RetriedAccessRequestsPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_Counters_RetriedAccessRequestsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"retried-access-requests"},
			map[string]interface{}{},
			n,
		),
	}
}

// TimeoutAccessRequests (leaf): Access-Request messages that have timed-out,
// requiring retransmission.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "timeout-access-requests"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters/timeout-access-requests"
func (n *System_Aaa_ServerGroup_Server_Radius_CountersPath) TimeoutAccessRequests() *System_Aaa_ServerGroup_Server_Radius_Counters_TimeoutAccessRequestsPath {
	return &System_Aaa_ServerGroup_Server_Radius_Counters_TimeoutAccessRequestsPath{
		NodePath: ygot.NewNodePath(
			[]string{"timeout-access-requests"},
			map[string]interface{}{},
			n,
		),
	}
}

// TimeoutAccessRequests (leaf): Access-Request messages that have timed-out,
// requiring retransmission.
// ----------------------------------------
// Defining module: "openconfig-aaa-radius"
// Instantiating module: "openconfig-system"
// Path from parent: "timeout-access-requests"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/radius/state/counters/timeout-access-requests"
func (n *System_Aaa_ServerGroup_Server_Radius_CountersPathAny) TimeoutAccessRequests() *System_Aaa_ServerGroup_Server_Radius_Counters_TimeoutAccessRequestsPathAny {
	return &System_Aaa_ServerGroup_Server_Radius_Counters_TimeoutAccessRequestsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"timeout-access-requests"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Aaa_ServerGroup_Server_TacacsPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs YANG schema element.
type System_Aaa_ServerGroup_Server_TacacsPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_TacacsPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs YANG schema element.
type System_Aaa_ServerGroup_Server_TacacsPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Tacacs_PortPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs/config/port YANG schema element.
type System_Aaa_ServerGroup_Server_Tacacs_PortPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Tacacs_PortPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs/config/port YANG schema element.
type System_Aaa_ServerGroup_Server_Tacacs_PortPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Tacacs_SecretKeyPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs/config/secret-key YANG schema element.
type System_Aaa_ServerGroup_Server_Tacacs_SecretKeyPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Tacacs_SecretKeyPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs/config/secret-key YANG schema element.
type System_Aaa_ServerGroup_Server_Tacacs_SecretKeyPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Tacacs_SecretKeyHashedPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs/config/secret-key-hashed YANG schema element.
type System_Aaa_ServerGroup_Server_Tacacs_SecretKeyHashedPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Tacacs_SecretKeyHashedPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs/config/secret-key-hashed YANG schema element.
type System_Aaa_ServerGroup_Server_Tacacs_SecretKeyHashedPathAny struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Tacacs_SourceAddressPath represents the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs/config/source-address YANG schema element.
type System_Aaa_ServerGroup_Server_Tacacs_SourceAddressPath struct {
	*ygot.NodePath
}

// System_Aaa_ServerGroup_Server_Tacacs_SourceAddressPathAny represents the wildcard version of the /openconfig-system/system/aaa/server-groups/server-group/servers/server/tacacs/config/source-address YANG schema element.
type System_Aaa_ServerGroup_Server_Tacacs_SourceAddressPathAny struct {
	*ygot.NodePath
}

// Port (leaf): The port number on which to contact the TACACS server
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "config/port"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs/config/port"
func (n *System_Aaa_ServerGroup_Server_TacacsPath) Port() *System_Aaa_ServerGroup_Server_Tacacs_PortPath {
	return &System_Aaa_ServerGroup_Server_Tacacs_PortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port"},
			map[string]interface{}{},
			n,
		),
	}
}

// Port (leaf): The port number on which to contact the TACACS server
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "config/port"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs/config/port"
func (n *System_Aaa_ServerGroup_Server_TacacsPathAny) Port() *System_Aaa_ServerGroup_Server_Tacacs_PortPathAny {
	return &System_Aaa_ServerGroup_Server_Tacacs_PortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKey (leaf): The unencrypted shared key used between the authentication
// server and the device.
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "config/secret-key"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs/config/secret-key"
func (n *System_Aaa_ServerGroup_Server_TacacsPath) SecretKey() *System_Aaa_ServerGroup_Server_Tacacs_SecretKeyPath {
	return &System_Aaa_ServerGroup_Server_Tacacs_SecretKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKey (leaf): The unencrypted shared key used between the authentication
// server and the device.
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "config/secret-key"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs/config/secret-key"
func (n *System_Aaa_ServerGroup_Server_TacacsPathAny) SecretKey() *System_Aaa_ServerGroup_Server_Tacacs_SecretKeyPathAny {
	return &System_Aaa_ServerGroup_Server_Tacacs_SecretKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKeyHashed (leaf): The hashed shared key used between the authentication
// server and the device.
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "config/secret-key-hashed"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs/config/secret-key-hashed"
func (n *System_Aaa_ServerGroup_Server_TacacsPath) SecretKeyHashed() *System_Aaa_ServerGroup_Server_Tacacs_SecretKeyHashedPath {
	return &System_Aaa_ServerGroup_Server_Tacacs_SecretKeyHashedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key-hashed"},
			map[string]interface{}{},
			n,
		),
	}
}

// SecretKeyHashed (leaf): The hashed shared key used between the authentication
// server and the device.
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "config/secret-key-hashed"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs/config/secret-key-hashed"
func (n *System_Aaa_ServerGroup_Server_TacacsPathAny) SecretKeyHashed() *System_Aaa_ServerGroup_Server_Tacacs_SecretKeyHashedPathAny {
	return &System_Aaa_ServerGroup_Server_Tacacs_SecretKeyHashedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "secret-key-hashed"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IP address to use in messages to the TACACS server
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "config/source-address"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs/config/source-address"
func (n *System_Aaa_ServerGroup_Server_TacacsPath) SourceAddress() *System_Aaa_ServerGroup_Server_Tacacs_SourceAddressPath {
	return &System_Aaa_ServerGroup_Server_Tacacs_SourceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IP address to use in messages to the TACACS server
// ----------------------------------------
// Defining module: "openconfig-aaa-tacacs"
// Instantiating module: "openconfig-system"
// Path from parent: "config/source-address"
// Path from root: "/system/aaa/server-groups/server-group/servers/server/tacacs/config/source-address"
func (n *System_Aaa_ServerGroup_Server_TacacsPathAny) SourceAddress() *System_Aaa_ServerGroup_Server_Tacacs_SourceAddressPathAny {
	return &System_Aaa_ServerGroup_Server_Tacacs_SourceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_AlarmPath represents the /openconfig-system/system/alarms/alarm YANG schema element.
type System_AlarmPath struct {
	*ygot.NodePath
}

// System_AlarmPathAny represents the wildcard version of the /openconfig-system/system/alarms/alarm YANG schema element.
type System_AlarmPathAny struct {
	*ygot.NodePath
}

// System_Alarm_IdPath represents the /openconfig-system/system/alarms/alarm/state/id YANG schema element.
type System_Alarm_IdPath struct {
	*ygot.NodePath
}

// System_Alarm_IdPathAny represents the wildcard version of the /openconfig-system/system/alarms/alarm/state/id YANG schema element.
type System_Alarm_IdPathAny struct {
	*ygot.NodePath
}

// System_Alarm_ResourcePath represents the /openconfig-system/system/alarms/alarm/state/resource YANG schema element.
type System_Alarm_ResourcePath struct {
	*ygot.NodePath
}

// System_Alarm_ResourcePathAny represents the wildcard version of the /openconfig-system/system/alarms/alarm/state/resource YANG schema element.
type System_Alarm_ResourcePathAny struct {
	*ygot.NodePath
}

// System_Alarm_SeverityPath represents the /openconfig-system/system/alarms/alarm/state/severity YANG schema element.
type System_Alarm_SeverityPath struct {
	*ygot.NodePath
}

// System_Alarm_SeverityPathAny represents the wildcard version of the /openconfig-system/system/alarms/alarm/state/severity YANG schema element.
type System_Alarm_SeverityPathAny struct {
	*ygot.NodePath
}

// System_Alarm_TextPath represents the /openconfig-system/system/alarms/alarm/state/text YANG schema element.
type System_Alarm_TextPath struct {
	*ygot.NodePath
}

// System_Alarm_TextPathAny represents the wildcard version of the /openconfig-system/system/alarms/alarm/state/text YANG schema element.
type System_Alarm_TextPathAny struct {
	*ygot.NodePath
}

// System_Alarm_TimeCreatedPath represents the /openconfig-system/system/alarms/alarm/state/time-created YANG schema element.
type System_Alarm_TimeCreatedPath struct {
	*ygot.NodePath
}

// System_Alarm_TimeCreatedPathAny represents the wildcard version of the /openconfig-system/system/alarms/alarm/state/time-created YANG schema element.
type System_Alarm_TimeCreatedPathAny struct {
	*ygot.NodePath
}

// System_Alarm_TypeIdPath represents the /openconfig-system/system/alarms/alarm/state/type-id YANG schema element.
type System_Alarm_TypeIdPath struct {
	*ygot.NodePath
}

// System_Alarm_TypeIdPathAny represents the wildcard version of the /openconfig-system/system/alarms/alarm/state/type-id YANG schema element.
type System_Alarm_TypeIdPathAny struct {
	*ygot.NodePath
}

// Id (leaf): Unique ID for the alarm -- this will not be a
// configurable parameter on many implementations
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/id"
// Path from root: "/system/alarms/alarm/state/id"
func (n *System_AlarmPath) Id() *System_Alarm_IdPath {
	return &System_Alarm_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): Unique ID for the alarm -- this will not be a
// configurable parameter on many implementations
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/id"
// Path from root: "/system/alarms/alarm/state/id"
func (n *System_AlarmPathAny) Id() *System_Alarm_IdPathAny {
	return &System_Alarm_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Resource (leaf): The item that is under alarm within the device. The
// resource may be a reference to an item which is
// defined elsewhere in the model. For example, it
// may be a platform/component, interfaces/interface,
// terminal-device/logical-channels/channel, etc. In this
// case the system should match the name of the referenced
// item exactly. The referenced item could alternatively be
// the path of the item within the model.
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/resource"
// Path from root: "/system/alarms/alarm/state/resource"
func (n *System_AlarmPath) Resource() *System_Alarm_ResourcePath {
	return &System_Alarm_ResourcePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "resource"},
			map[string]interface{}{},
			n,
		),
	}
}

// Resource (leaf): The item that is under alarm within the device. The
// resource may be a reference to an item which is
// defined elsewhere in the model. For example, it
// may be a platform/component, interfaces/interface,
// terminal-device/logical-channels/channel, etc. In this
// case the system should match the name of the referenced
// item exactly. The referenced item could alternatively be
// the path of the item within the model.
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/resource"
// Path from root: "/system/alarms/alarm/state/resource"
func (n *System_AlarmPathAny) Resource() *System_Alarm_ResourcePathAny {
	return &System_Alarm_ResourcePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "resource"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): The severity level indicating the criticality and impact
// of the alarm
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/severity"
// Path from root: "/system/alarms/alarm/state/severity"
func (n *System_AlarmPath) Severity() *System_Alarm_SeverityPath {
	return &System_Alarm_SeverityPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): The severity level indicating the criticality and impact
// of the alarm
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/severity"
// Path from root: "/system/alarms/alarm/state/severity"
func (n *System_AlarmPathAny) Severity() *System_Alarm_SeverityPathAny {
	return &System_Alarm_SeverityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// Text (leaf): The string used to inform operators about the alarm. This
// MUST contain enough information for an operator to be able
// to understand the problem. If this string contains structure,
// this format should be clearly documented for programs to be
// able to parse that information
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/text"
// Path from root: "/system/alarms/alarm/state/text"
func (n *System_AlarmPath) Text() *System_Alarm_TextPath {
	return &System_Alarm_TextPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "text"},
			map[string]interface{}{},
			n,
		),
	}
}

// Text (leaf): The string used to inform operators about the alarm. This
// MUST contain enough information for an operator to be able
// to understand the problem. If this string contains structure,
// this format should be clearly documented for programs to be
// able to parse that information
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/text"
// Path from root: "/system/alarms/alarm/state/text"
func (n *System_AlarmPathAny) Text() *System_Alarm_TextPathAny {
	return &System_Alarm_TextPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "text"},
			map[string]interface{}{},
			n,
		),
	}
}

// TimeCreated (leaf): The time at which the alarm was raised by the system.
// This value is expressed relative to the Unix Epoch.
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/time-created"
// Path from root: "/system/alarms/alarm/state/time-created"
func (n *System_AlarmPath) TimeCreated() *System_Alarm_TimeCreatedPath {
	return &System_Alarm_TimeCreatedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "time-created"},
			map[string]interface{}{},
			n,
		),
	}
}

// TimeCreated (leaf): The time at which the alarm was raised by the system.
// This value is expressed relative to the Unix Epoch.
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/time-created"
// Path from root: "/system/alarms/alarm/state/time-created"
func (n *System_AlarmPathAny) TimeCreated() *System_Alarm_TimeCreatedPathAny {
	return &System_Alarm_TimeCreatedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "time-created"},
			map[string]interface{}{},
			n,
		),
	}
}

// TypeId (leaf): The abbreviated name of the alarm, for example LOS,
// EQPT, or OTS. Also referred to in different systems as
// condition type, alarm identifier, or alarm mnemonic. It
// is recommended to use the OPENCONFIG_ALARM_TYPE_ID
// identities where possible and only use the string type
// when the desired identityref is not yet defined
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/type-id"
// Path from root: "/system/alarms/alarm/state/type-id"
func (n *System_AlarmPath) TypeId() *System_Alarm_TypeIdPath {
	return &System_Alarm_TypeIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// TypeId (leaf): The abbreviated name of the alarm, for example LOS,
// EQPT, or OTS. Also referred to in different systems as
// condition type, alarm identifier, or alarm mnemonic. It
// is recommended to use the OPENCONFIG_ALARM_TYPE_ID
// identities where possible and only use the string type
// when the desired identityref is not yet defined
// ----------------------------------------
// Defining module: "openconfig-alarms"
// Instantiating module: "openconfig-system"
// Path from parent: "state/type-id"
// Path from root: "/system/alarms/alarm/state/type-id"
func (n *System_AlarmPathAny) TypeId() *System_Alarm_TypeIdPathAny {
	return &System_Alarm_TypeIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_ClockPath represents the /openconfig-system/system/clock YANG schema element.
type System_ClockPath struct {
	*ygot.NodePath
}

// System_ClockPathAny represents the wildcard version of the /openconfig-system/system/clock YANG schema element.
type System_ClockPathAny struct {
	*ygot.NodePath
}

// System_Clock_TimezoneNamePath represents the /openconfig-system/system/clock/config/timezone-name YANG schema element.
type System_Clock_TimezoneNamePath struct {
	*ygot.NodePath
}

// System_Clock_TimezoneNamePathAny represents the wildcard version of the /openconfig-system/system/clock/config/timezone-name YANG schema element.
type System_Clock_TimezoneNamePathAny struct {
	*ygot.NodePath
}

// TimezoneName (leaf): The TZ database name to use for the system, such
// as 'Europe/Stockholm'.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/timezone-name"
// Path from root: "/system/clock/config/timezone-name"
func (n *System_ClockPath) TimezoneName() *System_Clock_TimezoneNamePath {
	return &System_Clock_TimezoneNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timezone-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// TimezoneName (leaf): The TZ database name to use for the system, such
// as 'Europe/Stockholm'.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/timezone-name"
// Path from root: "/system/clock/config/timezone-name"
func (n *System_ClockPathAny) TimezoneName() *System_Clock_TimezoneNamePathAny {
	return &System_Clock_TimezoneNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timezone-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_CpuPath represents the /openconfig-system/system/cpus/cpu YANG schema element.
type System_CpuPath struct {
	*ygot.NodePath
}

// System_CpuPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu YANG schema element.
type System_CpuPathAny struct {
	*ygot.NodePath
}

// System_Cpu_IndexPath represents the /openconfig-system/system/cpus/cpu/state/index YANG schema element.
type System_Cpu_IndexPath struct {
	*ygot.NodePath
}

// System_Cpu_IndexPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/index YANG schema element.
type System_Cpu_IndexPathAny struct {
	*ygot.NodePath
}

// HardwareInterrupt (container): Percentage of CPU time spent servicing hardware interrupts.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/hardware-interrupt"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt"
func (n *System_CpuPath) HardwareInterrupt() *System_Cpu_HardwareInterruptPath {
	return &System_Cpu_HardwareInterruptPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hardware-interrupt"},
			map[string]interface{}{},
			n,
		),
	}
}

// HardwareInterrupt (container): Percentage of CPU time spent servicing hardware interrupts.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/hardware-interrupt"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt"
func (n *System_CpuPathAny) HardwareInterrupt() *System_Cpu_HardwareInterruptPathAny {
	return &System_Cpu_HardwareInterruptPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "hardware-interrupt"},
			map[string]interface{}{},
			n,
		),
	}
}

// Idle (container): Percentage of CPU time spent idle.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/idle"
// Path from root: "/system/cpus/cpu/state/idle"
func (n *System_CpuPath) Idle() *System_Cpu_IdlePath {
	return &System_Cpu_IdlePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "idle"},
			map[string]interface{}{},
			n,
		),
	}
}

// Idle (container): Percentage of CPU time spent idle.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/idle"
// Path from root: "/system/cpus/cpu/state/idle"
func (n *System_CpuPathAny) Idle() *System_Cpu_IdlePathAny {
	return &System_Cpu_IdlePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "idle"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): The CPU index for each processor core on the system.  On a
// single-core system, the index should be zero.  The ALL
// index signifies an aggregation of the CPU utilization
// statistics over all cores in the system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/index"
// Path from root: "/system/cpus/cpu/state/index"
func (n *System_CpuPath) Index() *System_Cpu_IndexPath {
	return &System_Cpu_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): The CPU index for each processor core on the system.  On a
// single-core system, the index should be zero.  The ALL
// index signifies an aggregation of the CPU utilization
// statistics over all cores in the system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/index"
// Path from root: "/system/cpus/cpu/state/index"
func (n *System_CpuPathAny) Index() *System_Cpu_IndexPathAny {
	return &System_Cpu_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Kernel (container): Percentage of CPU time spent running in kernel space.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/kernel"
// Path from root: "/system/cpus/cpu/state/kernel"
func (n *System_CpuPath) Kernel() *System_Cpu_KernelPath {
	return &System_Cpu_KernelPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "kernel"},
			map[string]interface{}{},
			n,
		),
	}
}

// Kernel (container): Percentage of CPU time spent running in kernel space.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/kernel"
// Path from root: "/system/cpus/cpu/state/kernel"
func (n *System_CpuPathAny) Kernel() *System_Cpu_KernelPathAny {
	return &System_Cpu_KernelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "kernel"},
			map[string]interface{}{},
			n,
		),
	}
}

// Nice (container): Percentage of CPU time spent running low-priority (niced)
// user processes.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/nice"
// Path from root: "/system/cpus/cpu/state/nice"
func (n *System_CpuPath) Nice() *System_Cpu_NicePath {
	return &System_Cpu_NicePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "nice"},
			map[string]interface{}{},
			n,
		),
	}
}

// Nice (container): Percentage of CPU time spent running low-priority (niced)
// user processes.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/nice"
// Path from root: "/system/cpus/cpu/state/nice"
func (n *System_CpuPathAny) Nice() *System_Cpu_NicePathAny {
	return &System_Cpu_NicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "nice"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftwareInterrupt (container): Percentage of CPU time spent servicing software interrupts
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/software-interrupt"
// Path from root: "/system/cpus/cpu/state/software-interrupt"
func (n *System_CpuPath) SoftwareInterrupt() *System_Cpu_SoftwareInterruptPath {
	return &System_Cpu_SoftwareInterruptPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "software-interrupt"},
			map[string]interface{}{},
			n,
		),
	}
}

// SoftwareInterrupt (container): Percentage of CPU time spent servicing software interrupts
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/software-interrupt"
// Path from root: "/system/cpus/cpu/state/software-interrupt"
func (n *System_CpuPathAny) SoftwareInterrupt() *System_Cpu_SoftwareInterruptPathAny {
	return &System_Cpu_SoftwareInterruptPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "software-interrupt"},
			map[string]interface{}{},
			n,
		),
	}
}

// Total (container): Total CPU utilization.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/total"
// Path from root: "/system/cpus/cpu/state/total"
func (n *System_CpuPath) Total() *System_Cpu_TotalPath {
	return &System_Cpu_TotalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total"},
			map[string]interface{}{},
			n,
		),
	}
}

// Total (container): Total CPU utilization.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/total"
// Path from root: "/system/cpus/cpu/state/total"
func (n *System_CpuPathAny) Total() *System_Cpu_TotalPathAny {
	return &System_Cpu_TotalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "total"},
			map[string]interface{}{},
			n,
		),
	}
}

// User (container): Percentage of CPU time spent running in user space.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/user"
// Path from root: "/system/cpus/cpu/state/user"
func (n *System_CpuPath) User() *System_Cpu_UserPath {
	return &System_Cpu_UserPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "user"},
			map[string]interface{}{},
			n,
		),
	}
}

// User (container): Percentage of CPU time spent running in user space.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/user"
// Path from root: "/system/cpus/cpu/state/user"
func (n *System_CpuPathAny) User() *System_Cpu_UserPathAny {
	return &System_Cpu_UserPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "user"},
			map[string]interface{}{},
			n,
		),
	}
}

// Wait (container): Percentage of CPU time spent waiting for I/O.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/wait"
// Path from root: "/system/cpus/cpu/state/wait"
func (n *System_CpuPath) Wait() *System_Cpu_WaitPath {
	return &System_Cpu_WaitPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "wait"},
			map[string]interface{}{},
			n,
		),
	}
}

// Wait (container): Percentage of CPU time spent waiting for I/O.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/wait"
// Path from root: "/system/cpus/cpu/state/wait"
func (n *System_CpuPathAny) Wait() *System_Cpu_WaitPathAny {
	return &System_Cpu_WaitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "wait"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Cpu_HardwareInterruptPath represents the /openconfig-system/system/cpus/cpu/state/hardware-interrupt YANG schema element.
type System_Cpu_HardwareInterruptPath struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterruptPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/hardware-interrupt YANG schema element.
type System_Cpu_HardwareInterruptPathAny struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_AvgPath represents the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/avg YANG schema element.
type System_Cpu_HardwareInterrupt_AvgPath struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_AvgPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/avg YANG schema element.
type System_Cpu_HardwareInterrupt_AvgPathAny struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_InstantPath represents the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/instant YANG schema element.
type System_Cpu_HardwareInterrupt_InstantPath struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_InstantPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/instant YANG schema element.
type System_Cpu_HardwareInterrupt_InstantPathAny struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_IntervalPath represents the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/interval YANG schema element.
type System_Cpu_HardwareInterrupt_IntervalPath struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_IntervalPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/interval YANG schema element.
type System_Cpu_HardwareInterrupt_IntervalPathAny struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_MaxPath represents the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/max YANG schema element.
type System_Cpu_HardwareInterrupt_MaxPath struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_MaxPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/max YANG schema element.
type System_Cpu_HardwareInterrupt_MaxPathAny struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_MaxTimePath represents the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/max-time YANG schema element.
type System_Cpu_HardwareInterrupt_MaxTimePath struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_MaxTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/max-time YANG schema element.
type System_Cpu_HardwareInterrupt_MaxTimePathAny struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_MinPath represents the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/min YANG schema element.
type System_Cpu_HardwareInterrupt_MinPath struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_MinPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/min YANG schema element.
type System_Cpu_HardwareInterrupt_MinPathAny struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_MinTimePath represents the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/min-time YANG schema element.
type System_Cpu_HardwareInterrupt_MinTimePath struct {
	*ygot.NodePath
}

// System_Cpu_HardwareInterrupt_MinTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/hardware-interrupt/min-time YANG schema element.
type System_Cpu_HardwareInterrupt_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/avg"
func (n *System_Cpu_HardwareInterruptPath) Avg() *System_Cpu_HardwareInterrupt_AvgPath {
	return &System_Cpu_HardwareInterrupt_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/avg"
func (n *System_Cpu_HardwareInterruptPathAny) Avg() *System_Cpu_HardwareInterrupt_AvgPathAny {
	return &System_Cpu_HardwareInterrupt_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/instant"
func (n *System_Cpu_HardwareInterruptPath) Instant() *System_Cpu_HardwareInterrupt_InstantPath {
	return &System_Cpu_HardwareInterrupt_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/instant"
func (n *System_Cpu_HardwareInterruptPathAny) Instant() *System_Cpu_HardwareInterrupt_InstantPathAny {
	return &System_Cpu_HardwareInterrupt_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/interval"
func (n *System_Cpu_HardwareInterruptPath) Interval() *System_Cpu_HardwareInterrupt_IntervalPath {
	return &System_Cpu_HardwareInterrupt_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/interval"
func (n *System_Cpu_HardwareInterruptPathAny) Interval() *System_Cpu_HardwareInterrupt_IntervalPathAny {
	return &System_Cpu_HardwareInterrupt_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/max"
func (n *System_Cpu_HardwareInterruptPath) Max() *System_Cpu_HardwareInterrupt_MaxPath {
	return &System_Cpu_HardwareInterrupt_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/max"
func (n *System_Cpu_HardwareInterruptPathAny) Max() *System_Cpu_HardwareInterrupt_MaxPathAny {
	return &System_Cpu_HardwareInterrupt_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/max-time"
func (n *System_Cpu_HardwareInterruptPath) MaxTime() *System_Cpu_HardwareInterrupt_MaxTimePath {
	return &System_Cpu_HardwareInterrupt_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/max-time"
func (n *System_Cpu_HardwareInterruptPathAny) MaxTime() *System_Cpu_HardwareInterrupt_MaxTimePathAny {
	return &System_Cpu_HardwareInterrupt_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/min"
func (n *System_Cpu_HardwareInterruptPath) Min() *System_Cpu_HardwareInterrupt_MinPath {
	return &System_Cpu_HardwareInterrupt_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/min"
func (n *System_Cpu_HardwareInterruptPathAny) Min() *System_Cpu_HardwareInterrupt_MinPathAny {
	return &System_Cpu_HardwareInterrupt_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/min-time"
func (n *System_Cpu_HardwareInterruptPath) MinTime() *System_Cpu_HardwareInterrupt_MinTimePath {
	return &System_Cpu_HardwareInterrupt_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/hardware-interrupt/min-time"
func (n *System_Cpu_HardwareInterruptPathAny) MinTime() *System_Cpu_HardwareInterrupt_MinTimePathAny {
	return &System_Cpu_HardwareInterrupt_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Cpu_IdlePath represents the /openconfig-system/system/cpus/cpu/state/idle YANG schema element.
type System_Cpu_IdlePath struct {
	*ygot.NodePath
}

// System_Cpu_IdlePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/idle YANG schema element.
type System_Cpu_IdlePathAny struct {
	*ygot.NodePath
}

// System_Cpu_Idle_AvgPath represents the /openconfig-system/system/cpus/cpu/state/idle/avg YANG schema element.
type System_Cpu_Idle_AvgPath struct {
	*ygot.NodePath
}

// System_Cpu_Idle_AvgPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/idle/avg YANG schema element.
type System_Cpu_Idle_AvgPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Idle_InstantPath represents the /openconfig-system/system/cpus/cpu/state/idle/instant YANG schema element.
type System_Cpu_Idle_InstantPath struct {
	*ygot.NodePath
}

// System_Cpu_Idle_InstantPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/idle/instant YANG schema element.
type System_Cpu_Idle_InstantPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Idle_IntervalPath represents the /openconfig-system/system/cpus/cpu/state/idle/interval YANG schema element.
type System_Cpu_Idle_IntervalPath struct {
	*ygot.NodePath
}

// System_Cpu_Idle_IntervalPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/idle/interval YANG schema element.
type System_Cpu_Idle_IntervalPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Idle_MaxPath represents the /openconfig-system/system/cpus/cpu/state/idle/max YANG schema element.
type System_Cpu_Idle_MaxPath struct {
	*ygot.NodePath
}

// System_Cpu_Idle_MaxPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/idle/max YANG schema element.
type System_Cpu_Idle_MaxPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Idle_MaxTimePath represents the /openconfig-system/system/cpus/cpu/state/idle/max-time YANG schema element.
type System_Cpu_Idle_MaxTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Idle_MaxTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/idle/max-time YANG schema element.
type System_Cpu_Idle_MaxTimePathAny struct {
	*ygot.NodePath
}

// System_Cpu_Idle_MinPath represents the /openconfig-system/system/cpus/cpu/state/idle/min YANG schema element.
type System_Cpu_Idle_MinPath struct {
	*ygot.NodePath
}

// System_Cpu_Idle_MinPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/idle/min YANG schema element.
type System_Cpu_Idle_MinPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Idle_MinTimePath represents the /openconfig-system/system/cpus/cpu/state/idle/min-time YANG schema element.
type System_Cpu_Idle_MinTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Idle_MinTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/idle/min-time YANG schema element.
type System_Cpu_Idle_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/idle/avg"
func (n *System_Cpu_IdlePath) Avg() *System_Cpu_Idle_AvgPath {
	return &System_Cpu_Idle_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/idle/avg"
func (n *System_Cpu_IdlePathAny) Avg() *System_Cpu_Idle_AvgPathAny {
	return &System_Cpu_Idle_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/idle/instant"
func (n *System_Cpu_IdlePath) Instant() *System_Cpu_Idle_InstantPath {
	return &System_Cpu_Idle_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/idle/instant"
func (n *System_Cpu_IdlePathAny) Instant() *System_Cpu_Idle_InstantPathAny {
	return &System_Cpu_Idle_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/idle/interval"
func (n *System_Cpu_IdlePath) Interval() *System_Cpu_Idle_IntervalPath {
	return &System_Cpu_Idle_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/idle/interval"
func (n *System_Cpu_IdlePathAny) Interval() *System_Cpu_Idle_IntervalPathAny {
	return &System_Cpu_Idle_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/idle/max"
func (n *System_Cpu_IdlePath) Max() *System_Cpu_Idle_MaxPath {
	return &System_Cpu_Idle_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/idle/max"
func (n *System_Cpu_IdlePathAny) Max() *System_Cpu_Idle_MaxPathAny {
	return &System_Cpu_Idle_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/idle/max-time"
func (n *System_Cpu_IdlePath) MaxTime() *System_Cpu_Idle_MaxTimePath {
	return &System_Cpu_Idle_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/idle/max-time"
func (n *System_Cpu_IdlePathAny) MaxTime() *System_Cpu_Idle_MaxTimePathAny {
	return &System_Cpu_Idle_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/idle/min"
func (n *System_Cpu_IdlePath) Min() *System_Cpu_Idle_MinPath {
	return &System_Cpu_Idle_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/idle/min"
func (n *System_Cpu_IdlePathAny) Min() *System_Cpu_Idle_MinPathAny {
	return &System_Cpu_Idle_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/idle/min-time"
func (n *System_Cpu_IdlePath) MinTime() *System_Cpu_Idle_MinTimePath {
	return &System_Cpu_Idle_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/idle/min-time"
func (n *System_Cpu_IdlePathAny) MinTime() *System_Cpu_Idle_MinTimePathAny {
	return &System_Cpu_Idle_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Cpu_KernelPath represents the /openconfig-system/system/cpus/cpu/state/kernel YANG schema element.
type System_Cpu_KernelPath struct {
	*ygot.NodePath
}

// System_Cpu_KernelPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/kernel YANG schema element.
type System_Cpu_KernelPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_AvgPath represents the /openconfig-system/system/cpus/cpu/state/kernel/avg YANG schema element.
type System_Cpu_Kernel_AvgPath struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_AvgPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/kernel/avg YANG schema element.
type System_Cpu_Kernel_AvgPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_InstantPath represents the /openconfig-system/system/cpus/cpu/state/kernel/instant YANG schema element.
type System_Cpu_Kernel_InstantPath struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_InstantPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/kernel/instant YANG schema element.
type System_Cpu_Kernel_InstantPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_IntervalPath represents the /openconfig-system/system/cpus/cpu/state/kernel/interval YANG schema element.
type System_Cpu_Kernel_IntervalPath struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_IntervalPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/kernel/interval YANG schema element.
type System_Cpu_Kernel_IntervalPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_MaxPath represents the /openconfig-system/system/cpus/cpu/state/kernel/max YANG schema element.
type System_Cpu_Kernel_MaxPath struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_MaxPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/kernel/max YANG schema element.
type System_Cpu_Kernel_MaxPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_MaxTimePath represents the /openconfig-system/system/cpus/cpu/state/kernel/max-time YANG schema element.
type System_Cpu_Kernel_MaxTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_MaxTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/kernel/max-time YANG schema element.
type System_Cpu_Kernel_MaxTimePathAny struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_MinPath represents the /openconfig-system/system/cpus/cpu/state/kernel/min YANG schema element.
type System_Cpu_Kernel_MinPath struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_MinPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/kernel/min YANG schema element.
type System_Cpu_Kernel_MinPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_MinTimePath represents the /openconfig-system/system/cpus/cpu/state/kernel/min-time YANG schema element.
type System_Cpu_Kernel_MinTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Kernel_MinTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/kernel/min-time YANG schema element.
type System_Cpu_Kernel_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/kernel/avg"
func (n *System_Cpu_KernelPath) Avg() *System_Cpu_Kernel_AvgPath {
	return &System_Cpu_Kernel_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/kernel/avg"
func (n *System_Cpu_KernelPathAny) Avg() *System_Cpu_Kernel_AvgPathAny {
	return &System_Cpu_Kernel_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/kernel/instant"
func (n *System_Cpu_KernelPath) Instant() *System_Cpu_Kernel_InstantPath {
	return &System_Cpu_Kernel_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/kernel/instant"
func (n *System_Cpu_KernelPathAny) Instant() *System_Cpu_Kernel_InstantPathAny {
	return &System_Cpu_Kernel_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/kernel/interval"
func (n *System_Cpu_KernelPath) Interval() *System_Cpu_Kernel_IntervalPath {
	return &System_Cpu_Kernel_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/kernel/interval"
func (n *System_Cpu_KernelPathAny) Interval() *System_Cpu_Kernel_IntervalPathAny {
	return &System_Cpu_Kernel_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/kernel/max"
func (n *System_Cpu_KernelPath) Max() *System_Cpu_Kernel_MaxPath {
	return &System_Cpu_Kernel_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/kernel/max"
func (n *System_Cpu_KernelPathAny) Max() *System_Cpu_Kernel_MaxPathAny {
	return &System_Cpu_Kernel_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/kernel/max-time"
func (n *System_Cpu_KernelPath) MaxTime() *System_Cpu_Kernel_MaxTimePath {
	return &System_Cpu_Kernel_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/kernel/max-time"
func (n *System_Cpu_KernelPathAny) MaxTime() *System_Cpu_Kernel_MaxTimePathAny {
	return &System_Cpu_Kernel_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/kernel/min"
func (n *System_Cpu_KernelPath) Min() *System_Cpu_Kernel_MinPath {
	return &System_Cpu_Kernel_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/kernel/min"
func (n *System_Cpu_KernelPathAny) Min() *System_Cpu_Kernel_MinPathAny {
	return &System_Cpu_Kernel_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/kernel/min-time"
func (n *System_Cpu_KernelPath) MinTime() *System_Cpu_Kernel_MinTimePath {
	return &System_Cpu_Kernel_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/kernel/min-time"
func (n *System_Cpu_KernelPathAny) MinTime() *System_Cpu_Kernel_MinTimePathAny {
	return &System_Cpu_Kernel_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Cpu_NicePath represents the /openconfig-system/system/cpus/cpu/state/nice YANG schema element.
type System_Cpu_NicePath struct {
	*ygot.NodePath
}

// System_Cpu_NicePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/nice YANG schema element.
type System_Cpu_NicePathAny struct {
	*ygot.NodePath
}

// System_Cpu_Nice_AvgPath represents the /openconfig-system/system/cpus/cpu/state/nice/avg YANG schema element.
type System_Cpu_Nice_AvgPath struct {
	*ygot.NodePath
}

// System_Cpu_Nice_AvgPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/nice/avg YANG schema element.
type System_Cpu_Nice_AvgPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Nice_InstantPath represents the /openconfig-system/system/cpus/cpu/state/nice/instant YANG schema element.
type System_Cpu_Nice_InstantPath struct {
	*ygot.NodePath
}

// System_Cpu_Nice_InstantPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/nice/instant YANG schema element.
type System_Cpu_Nice_InstantPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Nice_IntervalPath represents the /openconfig-system/system/cpus/cpu/state/nice/interval YANG schema element.
type System_Cpu_Nice_IntervalPath struct {
	*ygot.NodePath
}

// System_Cpu_Nice_IntervalPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/nice/interval YANG schema element.
type System_Cpu_Nice_IntervalPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Nice_MaxPath represents the /openconfig-system/system/cpus/cpu/state/nice/max YANG schema element.
type System_Cpu_Nice_MaxPath struct {
	*ygot.NodePath
}

// System_Cpu_Nice_MaxPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/nice/max YANG schema element.
type System_Cpu_Nice_MaxPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Nice_MaxTimePath represents the /openconfig-system/system/cpus/cpu/state/nice/max-time YANG schema element.
type System_Cpu_Nice_MaxTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Nice_MaxTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/nice/max-time YANG schema element.
type System_Cpu_Nice_MaxTimePathAny struct {
	*ygot.NodePath
}

// System_Cpu_Nice_MinPath represents the /openconfig-system/system/cpus/cpu/state/nice/min YANG schema element.
type System_Cpu_Nice_MinPath struct {
	*ygot.NodePath
}

// System_Cpu_Nice_MinPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/nice/min YANG schema element.
type System_Cpu_Nice_MinPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Nice_MinTimePath represents the /openconfig-system/system/cpus/cpu/state/nice/min-time YANG schema element.
type System_Cpu_Nice_MinTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Nice_MinTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/nice/min-time YANG schema element.
type System_Cpu_Nice_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/nice/avg"
func (n *System_Cpu_NicePath) Avg() *System_Cpu_Nice_AvgPath {
	return &System_Cpu_Nice_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/nice/avg"
func (n *System_Cpu_NicePathAny) Avg() *System_Cpu_Nice_AvgPathAny {
	return &System_Cpu_Nice_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/nice/instant"
func (n *System_Cpu_NicePath) Instant() *System_Cpu_Nice_InstantPath {
	return &System_Cpu_Nice_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/nice/instant"
func (n *System_Cpu_NicePathAny) Instant() *System_Cpu_Nice_InstantPathAny {
	return &System_Cpu_Nice_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/nice/interval"
func (n *System_Cpu_NicePath) Interval() *System_Cpu_Nice_IntervalPath {
	return &System_Cpu_Nice_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/nice/interval"
func (n *System_Cpu_NicePathAny) Interval() *System_Cpu_Nice_IntervalPathAny {
	return &System_Cpu_Nice_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/nice/max"
func (n *System_Cpu_NicePath) Max() *System_Cpu_Nice_MaxPath {
	return &System_Cpu_Nice_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/nice/max"
func (n *System_Cpu_NicePathAny) Max() *System_Cpu_Nice_MaxPathAny {
	return &System_Cpu_Nice_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/nice/max-time"
func (n *System_Cpu_NicePath) MaxTime() *System_Cpu_Nice_MaxTimePath {
	return &System_Cpu_Nice_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/nice/max-time"
func (n *System_Cpu_NicePathAny) MaxTime() *System_Cpu_Nice_MaxTimePathAny {
	return &System_Cpu_Nice_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/nice/min"
func (n *System_Cpu_NicePath) Min() *System_Cpu_Nice_MinPath {
	return &System_Cpu_Nice_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/nice/min"
func (n *System_Cpu_NicePathAny) Min() *System_Cpu_Nice_MinPathAny {
	return &System_Cpu_Nice_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/nice/min-time"
func (n *System_Cpu_NicePath) MinTime() *System_Cpu_Nice_MinTimePath {
	return &System_Cpu_Nice_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/nice/min-time"
func (n *System_Cpu_NicePathAny) MinTime() *System_Cpu_Nice_MinTimePathAny {
	return &System_Cpu_Nice_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Cpu_SoftwareInterruptPath represents the /openconfig-system/system/cpus/cpu/state/software-interrupt YANG schema element.
type System_Cpu_SoftwareInterruptPath struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterruptPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/software-interrupt YANG schema element.
type System_Cpu_SoftwareInterruptPathAny struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_AvgPath represents the /openconfig-system/system/cpus/cpu/state/software-interrupt/avg YANG schema element.
type System_Cpu_SoftwareInterrupt_AvgPath struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_AvgPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/software-interrupt/avg YANG schema element.
type System_Cpu_SoftwareInterrupt_AvgPathAny struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_InstantPath represents the /openconfig-system/system/cpus/cpu/state/software-interrupt/instant YANG schema element.
type System_Cpu_SoftwareInterrupt_InstantPath struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_InstantPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/software-interrupt/instant YANG schema element.
type System_Cpu_SoftwareInterrupt_InstantPathAny struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_IntervalPath represents the /openconfig-system/system/cpus/cpu/state/software-interrupt/interval YANG schema element.
type System_Cpu_SoftwareInterrupt_IntervalPath struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_IntervalPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/software-interrupt/interval YANG schema element.
type System_Cpu_SoftwareInterrupt_IntervalPathAny struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_MaxPath represents the /openconfig-system/system/cpus/cpu/state/software-interrupt/max YANG schema element.
type System_Cpu_SoftwareInterrupt_MaxPath struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_MaxPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/software-interrupt/max YANG schema element.
type System_Cpu_SoftwareInterrupt_MaxPathAny struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_MaxTimePath represents the /openconfig-system/system/cpus/cpu/state/software-interrupt/max-time YANG schema element.
type System_Cpu_SoftwareInterrupt_MaxTimePath struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_MaxTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/software-interrupt/max-time YANG schema element.
type System_Cpu_SoftwareInterrupt_MaxTimePathAny struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_MinPath represents the /openconfig-system/system/cpus/cpu/state/software-interrupt/min YANG schema element.
type System_Cpu_SoftwareInterrupt_MinPath struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_MinPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/software-interrupt/min YANG schema element.
type System_Cpu_SoftwareInterrupt_MinPathAny struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_MinTimePath represents the /openconfig-system/system/cpus/cpu/state/software-interrupt/min-time YANG schema element.
type System_Cpu_SoftwareInterrupt_MinTimePath struct {
	*ygot.NodePath
}

// System_Cpu_SoftwareInterrupt_MinTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/software-interrupt/min-time YANG schema element.
type System_Cpu_SoftwareInterrupt_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/software-interrupt/avg"
func (n *System_Cpu_SoftwareInterruptPath) Avg() *System_Cpu_SoftwareInterrupt_AvgPath {
	return &System_Cpu_SoftwareInterrupt_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/software-interrupt/avg"
func (n *System_Cpu_SoftwareInterruptPathAny) Avg() *System_Cpu_SoftwareInterrupt_AvgPathAny {
	return &System_Cpu_SoftwareInterrupt_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/software-interrupt/instant"
func (n *System_Cpu_SoftwareInterruptPath) Instant() *System_Cpu_SoftwareInterrupt_InstantPath {
	return &System_Cpu_SoftwareInterrupt_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/software-interrupt/instant"
func (n *System_Cpu_SoftwareInterruptPathAny) Instant() *System_Cpu_SoftwareInterrupt_InstantPathAny {
	return &System_Cpu_SoftwareInterrupt_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/software-interrupt/interval"
func (n *System_Cpu_SoftwareInterruptPath) Interval() *System_Cpu_SoftwareInterrupt_IntervalPath {
	return &System_Cpu_SoftwareInterrupt_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/software-interrupt/interval"
func (n *System_Cpu_SoftwareInterruptPathAny) Interval() *System_Cpu_SoftwareInterrupt_IntervalPathAny {
	return &System_Cpu_SoftwareInterrupt_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/software-interrupt/max"
func (n *System_Cpu_SoftwareInterruptPath) Max() *System_Cpu_SoftwareInterrupt_MaxPath {
	return &System_Cpu_SoftwareInterrupt_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/software-interrupt/max"
func (n *System_Cpu_SoftwareInterruptPathAny) Max() *System_Cpu_SoftwareInterrupt_MaxPathAny {
	return &System_Cpu_SoftwareInterrupt_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/software-interrupt/max-time"
func (n *System_Cpu_SoftwareInterruptPath) MaxTime() *System_Cpu_SoftwareInterrupt_MaxTimePath {
	return &System_Cpu_SoftwareInterrupt_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/software-interrupt/max-time"
func (n *System_Cpu_SoftwareInterruptPathAny) MaxTime() *System_Cpu_SoftwareInterrupt_MaxTimePathAny {
	return &System_Cpu_SoftwareInterrupt_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/software-interrupt/min"
func (n *System_Cpu_SoftwareInterruptPath) Min() *System_Cpu_SoftwareInterrupt_MinPath {
	return &System_Cpu_SoftwareInterrupt_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/software-interrupt/min"
func (n *System_Cpu_SoftwareInterruptPathAny) Min() *System_Cpu_SoftwareInterrupt_MinPathAny {
	return &System_Cpu_SoftwareInterrupt_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/software-interrupt/min-time"
func (n *System_Cpu_SoftwareInterruptPath) MinTime() *System_Cpu_SoftwareInterrupt_MinTimePath {
	return &System_Cpu_SoftwareInterrupt_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/software-interrupt/min-time"
func (n *System_Cpu_SoftwareInterruptPathAny) MinTime() *System_Cpu_SoftwareInterrupt_MinTimePathAny {
	return &System_Cpu_SoftwareInterrupt_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Cpu_TotalPath represents the /openconfig-system/system/cpus/cpu/state/total YANG schema element.
type System_Cpu_TotalPath struct {
	*ygot.NodePath
}

// System_Cpu_TotalPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/total YANG schema element.
type System_Cpu_TotalPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Total_AvgPath represents the /openconfig-system/system/cpus/cpu/state/total/avg YANG schema element.
type System_Cpu_Total_AvgPath struct {
	*ygot.NodePath
}

// System_Cpu_Total_AvgPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/total/avg YANG schema element.
type System_Cpu_Total_AvgPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Total_InstantPath represents the /openconfig-system/system/cpus/cpu/state/total/instant YANG schema element.
type System_Cpu_Total_InstantPath struct {
	*ygot.NodePath
}

// System_Cpu_Total_InstantPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/total/instant YANG schema element.
type System_Cpu_Total_InstantPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Total_IntervalPath represents the /openconfig-system/system/cpus/cpu/state/total/interval YANG schema element.
type System_Cpu_Total_IntervalPath struct {
	*ygot.NodePath
}

// System_Cpu_Total_IntervalPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/total/interval YANG schema element.
type System_Cpu_Total_IntervalPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Total_MaxPath represents the /openconfig-system/system/cpus/cpu/state/total/max YANG schema element.
type System_Cpu_Total_MaxPath struct {
	*ygot.NodePath
}

// System_Cpu_Total_MaxPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/total/max YANG schema element.
type System_Cpu_Total_MaxPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Total_MaxTimePath represents the /openconfig-system/system/cpus/cpu/state/total/max-time YANG schema element.
type System_Cpu_Total_MaxTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Total_MaxTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/total/max-time YANG schema element.
type System_Cpu_Total_MaxTimePathAny struct {
	*ygot.NodePath
}

// System_Cpu_Total_MinPath represents the /openconfig-system/system/cpus/cpu/state/total/min YANG schema element.
type System_Cpu_Total_MinPath struct {
	*ygot.NodePath
}

// System_Cpu_Total_MinPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/total/min YANG schema element.
type System_Cpu_Total_MinPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Total_MinTimePath represents the /openconfig-system/system/cpus/cpu/state/total/min-time YANG schema element.
type System_Cpu_Total_MinTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Total_MinTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/total/min-time YANG schema element.
type System_Cpu_Total_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/total/avg"
func (n *System_Cpu_TotalPath) Avg() *System_Cpu_Total_AvgPath {
	return &System_Cpu_Total_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/total/avg"
func (n *System_Cpu_TotalPathAny) Avg() *System_Cpu_Total_AvgPathAny {
	return &System_Cpu_Total_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/total/instant"
func (n *System_Cpu_TotalPath) Instant() *System_Cpu_Total_InstantPath {
	return &System_Cpu_Total_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/total/instant"
func (n *System_Cpu_TotalPathAny) Instant() *System_Cpu_Total_InstantPathAny {
	return &System_Cpu_Total_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/total/interval"
func (n *System_Cpu_TotalPath) Interval() *System_Cpu_Total_IntervalPath {
	return &System_Cpu_Total_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/total/interval"
func (n *System_Cpu_TotalPathAny) Interval() *System_Cpu_Total_IntervalPathAny {
	return &System_Cpu_Total_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/total/max"
func (n *System_Cpu_TotalPath) Max() *System_Cpu_Total_MaxPath {
	return &System_Cpu_Total_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/total/max"
func (n *System_Cpu_TotalPathAny) Max() *System_Cpu_Total_MaxPathAny {
	return &System_Cpu_Total_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/total/max-time"
func (n *System_Cpu_TotalPath) MaxTime() *System_Cpu_Total_MaxTimePath {
	return &System_Cpu_Total_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/total/max-time"
func (n *System_Cpu_TotalPathAny) MaxTime() *System_Cpu_Total_MaxTimePathAny {
	return &System_Cpu_Total_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/total/min"
func (n *System_Cpu_TotalPath) Min() *System_Cpu_Total_MinPath {
	return &System_Cpu_Total_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/total/min"
func (n *System_Cpu_TotalPathAny) Min() *System_Cpu_Total_MinPathAny {
	return &System_Cpu_Total_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/total/min-time"
func (n *System_Cpu_TotalPath) MinTime() *System_Cpu_Total_MinTimePath {
	return &System_Cpu_Total_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/total/min-time"
func (n *System_Cpu_TotalPathAny) MinTime() *System_Cpu_Total_MinTimePathAny {
	return &System_Cpu_Total_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Cpu_UserPath represents the /openconfig-system/system/cpus/cpu/state/user YANG schema element.
type System_Cpu_UserPath struct {
	*ygot.NodePath
}

// System_Cpu_UserPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/user YANG schema element.
type System_Cpu_UserPathAny struct {
	*ygot.NodePath
}

// System_Cpu_User_AvgPath represents the /openconfig-system/system/cpus/cpu/state/user/avg YANG schema element.
type System_Cpu_User_AvgPath struct {
	*ygot.NodePath
}

// System_Cpu_User_AvgPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/user/avg YANG schema element.
type System_Cpu_User_AvgPathAny struct {
	*ygot.NodePath
}

// System_Cpu_User_InstantPath represents the /openconfig-system/system/cpus/cpu/state/user/instant YANG schema element.
type System_Cpu_User_InstantPath struct {
	*ygot.NodePath
}

// System_Cpu_User_InstantPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/user/instant YANG schema element.
type System_Cpu_User_InstantPathAny struct {
	*ygot.NodePath
}

// System_Cpu_User_IntervalPath represents the /openconfig-system/system/cpus/cpu/state/user/interval YANG schema element.
type System_Cpu_User_IntervalPath struct {
	*ygot.NodePath
}

// System_Cpu_User_IntervalPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/user/interval YANG schema element.
type System_Cpu_User_IntervalPathAny struct {
	*ygot.NodePath
}

// System_Cpu_User_MaxPath represents the /openconfig-system/system/cpus/cpu/state/user/max YANG schema element.
type System_Cpu_User_MaxPath struct {
	*ygot.NodePath
}

// System_Cpu_User_MaxPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/user/max YANG schema element.
type System_Cpu_User_MaxPathAny struct {
	*ygot.NodePath
}

// System_Cpu_User_MaxTimePath represents the /openconfig-system/system/cpus/cpu/state/user/max-time YANG schema element.
type System_Cpu_User_MaxTimePath struct {
	*ygot.NodePath
}

// System_Cpu_User_MaxTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/user/max-time YANG schema element.
type System_Cpu_User_MaxTimePathAny struct {
	*ygot.NodePath
}

// System_Cpu_User_MinPath represents the /openconfig-system/system/cpus/cpu/state/user/min YANG schema element.
type System_Cpu_User_MinPath struct {
	*ygot.NodePath
}

// System_Cpu_User_MinPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/user/min YANG schema element.
type System_Cpu_User_MinPathAny struct {
	*ygot.NodePath
}

// System_Cpu_User_MinTimePath represents the /openconfig-system/system/cpus/cpu/state/user/min-time YANG schema element.
type System_Cpu_User_MinTimePath struct {
	*ygot.NodePath
}

// System_Cpu_User_MinTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/user/min-time YANG schema element.
type System_Cpu_User_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/user/avg"
func (n *System_Cpu_UserPath) Avg() *System_Cpu_User_AvgPath {
	return &System_Cpu_User_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/user/avg"
func (n *System_Cpu_UserPathAny) Avg() *System_Cpu_User_AvgPathAny {
	return &System_Cpu_User_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/user/instant"
func (n *System_Cpu_UserPath) Instant() *System_Cpu_User_InstantPath {
	return &System_Cpu_User_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/user/instant"
func (n *System_Cpu_UserPathAny) Instant() *System_Cpu_User_InstantPathAny {
	return &System_Cpu_User_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/user/interval"
func (n *System_Cpu_UserPath) Interval() *System_Cpu_User_IntervalPath {
	return &System_Cpu_User_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/user/interval"
func (n *System_Cpu_UserPathAny) Interval() *System_Cpu_User_IntervalPathAny {
	return &System_Cpu_User_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/user/max"
func (n *System_Cpu_UserPath) Max() *System_Cpu_User_MaxPath {
	return &System_Cpu_User_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/user/max"
func (n *System_Cpu_UserPathAny) Max() *System_Cpu_User_MaxPathAny {
	return &System_Cpu_User_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/user/max-time"
func (n *System_Cpu_UserPath) MaxTime() *System_Cpu_User_MaxTimePath {
	return &System_Cpu_User_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/user/max-time"
func (n *System_Cpu_UserPathAny) MaxTime() *System_Cpu_User_MaxTimePathAny {
	return &System_Cpu_User_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/user/min"
func (n *System_Cpu_UserPath) Min() *System_Cpu_User_MinPath {
	return &System_Cpu_User_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/user/min"
func (n *System_Cpu_UserPathAny) Min() *System_Cpu_User_MinPathAny {
	return &System_Cpu_User_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/user/min-time"
func (n *System_Cpu_UserPath) MinTime() *System_Cpu_User_MinTimePath {
	return &System_Cpu_User_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/user/min-time"
func (n *System_Cpu_UserPathAny) MinTime() *System_Cpu_User_MinTimePathAny {
	return &System_Cpu_User_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Cpu_WaitPath represents the /openconfig-system/system/cpus/cpu/state/wait YANG schema element.
type System_Cpu_WaitPath struct {
	*ygot.NodePath
}

// System_Cpu_WaitPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/wait YANG schema element.
type System_Cpu_WaitPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Wait_AvgPath represents the /openconfig-system/system/cpus/cpu/state/wait/avg YANG schema element.
type System_Cpu_Wait_AvgPath struct {
	*ygot.NodePath
}

// System_Cpu_Wait_AvgPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/wait/avg YANG schema element.
type System_Cpu_Wait_AvgPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Wait_InstantPath represents the /openconfig-system/system/cpus/cpu/state/wait/instant YANG schema element.
type System_Cpu_Wait_InstantPath struct {
	*ygot.NodePath
}

// System_Cpu_Wait_InstantPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/wait/instant YANG schema element.
type System_Cpu_Wait_InstantPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Wait_IntervalPath represents the /openconfig-system/system/cpus/cpu/state/wait/interval YANG schema element.
type System_Cpu_Wait_IntervalPath struct {
	*ygot.NodePath
}

// System_Cpu_Wait_IntervalPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/wait/interval YANG schema element.
type System_Cpu_Wait_IntervalPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Wait_MaxPath represents the /openconfig-system/system/cpus/cpu/state/wait/max YANG schema element.
type System_Cpu_Wait_MaxPath struct {
	*ygot.NodePath
}

// System_Cpu_Wait_MaxPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/wait/max YANG schema element.
type System_Cpu_Wait_MaxPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Wait_MaxTimePath represents the /openconfig-system/system/cpus/cpu/state/wait/max-time YANG schema element.
type System_Cpu_Wait_MaxTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Wait_MaxTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/wait/max-time YANG schema element.
type System_Cpu_Wait_MaxTimePathAny struct {
	*ygot.NodePath
}

// System_Cpu_Wait_MinPath represents the /openconfig-system/system/cpus/cpu/state/wait/min YANG schema element.
type System_Cpu_Wait_MinPath struct {
	*ygot.NodePath
}

// System_Cpu_Wait_MinPathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/wait/min YANG schema element.
type System_Cpu_Wait_MinPathAny struct {
	*ygot.NodePath
}

// System_Cpu_Wait_MinTimePath represents the /openconfig-system/system/cpus/cpu/state/wait/min-time YANG schema element.
type System_Cpu_Wait_MinTimePath struct {
	*ygot.NodePath
}

// System_Cpu_Wait_MinTimePathAny represents the wildcard version of the /openconfig-system/system/cpus/cpu/state/wait/min-time YANG schema element.
type System_Cpu_Wait_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/wait/avg"
func (n *System_Cpu_WaitPath) Avg() *System_Cpu_Wait_AvgPath {
	return &System_Cpu_Wait_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "avg"
// Path from root: "/system/cpus/cpu/state/wait/avg"
func (n *System_Cpu_WaitPathAny) Avg() *System_Cpu_Wait_AvgPathAny {
	return &System_Cpu_Wait_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/wait/instant"
func (n *System_Cpu_WaitPath) Instant() *System_Cpu_Wait_InstantPath {
	return &System_Cpu_Wait_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous percentage value.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "instant"
// Path from root: "/system/cpus/cpu/state/wait/instant"
func (n *System_Cpu_WaitPathAny) Instant() *System_Cpu_Wait_InstantPathAny {
	return &System_Cpu_Wait_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/wait/interval"
func (n *System_Cpu_WaitPath) Interval() *System_Cpu_Wait_IntervalPath {
	return &System_Cpu_Wait_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "interval"
// Path from root: "/system/cpus/cpu/state/wait/interval"
func (n *System_Cpu_WaitPathAny) Interval() *System_Cpu_Wait_IntervalPathAny {
	return &System_Cpu_Wait_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/wait/max"
func (n *System_Cpu_WaitPath) Max() *System_Cpu_Wait_MaxPath {
	return &System_Cpu_Wait_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max"
// Path from root: "/system/cpus/cpu/state/wait/max"
func (n *System_Cpu_WaitPathAny) Max() *System_Cpu_Wait_MaxPathAny {
	return &System_Cpu_Wait_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/wait/max-time"
func (n *System_Cpu_WaitPath) MaxTime() *System_Cpu_Wait_MaxTimePath {
	return &System_Cpu_Wait_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "max-time"
// Path from root: "/system/cpus/cpu/state/wait/max-time"
func (n *System_Cpu_WaitPathAny) MaxTime() *System_Cpu_Wait_MaxTimePathAny {
	return &System_Cpu_Wait_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/wait/min"
func (n *System_Cpu_WaitPath) Min() *System_Cpu_Wait_MinPath {
	return &System_Cpu_Wait_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the percentage measure of the
// statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min"
// Path from root: "/system/cpus/cpu/state/wait/min"
func (n *System_Cpu_WaitPathAny) Min() *System_Cpu_Wait_MinPathAny {
	return &System_Cpu_Wait_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/wait/min-time"
func (n *System_Cpu_WaitPath) MinTime() *System_Cpu_Wait_MinTimePath {
	return &System_Cpu_Wait_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-system"
// Path from parent: "min-time"
// Path from root: "/system/cpus/cpu/state/wait/min-time"
func (n *System_Cpu_WaitPathAny) MinTime() *System_Cpu_Wait_MinTimePathAny {
	return &System_Cpu_Wait_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_DnsPath represents the /openconfig-system/system/dns YANG schema element.
type System_DnsPath struct {
	*ygot.NodePath
}

// System_DnsPathAny represents the wildcard version of the /openconfig-system/system/dns YANG schema element.
type System_DnsPathAny struct {
	*ygot.NodePath
}

// System_Dns_SearchPath represents the /openconfig-system/system/dns/config/search YANG schema element.
type System_Dns_SearchPath struct {
	*ygot.NodePath
}

// System_Dns_SearchPathAny represents the wildcard version of the /openconfig-system/system/dns/config/search YANG schema element.
type System_Dns_SearchPathAny struct {
	*ygot.NodePath
}

// HostEntryAny (list): List of static host entries
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "host-entries/host-entry"
// Path from root: "/system/dns/host-entries/host-entry"
// Hostname (wildcarded): string
func (n *System_DnsPath) HostEntryAny() *System_Dns_HostEntryPathAny {
	return &System_Dns_HostEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"host-entries", "host-entry"},
			map[string]interface{}{"hostname": "*"},
			n,
		),
	}
}

// HostEntryAny (list): List of static host entries
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "host-entries/host-entry"
// Path from root: "/system/dns/host-entries/host-entry"
// Hostname (wildcarded): string
func (n *System_DnsPathAny) HostEntryAny() *System_Dns_HostEntryPathAny {
	return &System_Dns_HostEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"host-entries", "host-entry"},
			map[string]interface{}{"hostname": "*"},
			n,
		),
	}
}

// HostEntry (list): List of static host entries
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "host-entries/host-entry"
// Path from root: "/system/dns/host-entries/host-entry"
// Hostname: string
func (n *System_DnsPath) HostEntry(Hostname string) *System_Dns_HostEntryPath {
	return &System_Dns_HostEntryPath{
		NodePath: ygot.NewNodePath(
			[]string{"host-entries", "host-entry"},
			map[string]interface{}{"hostname": Hostname},
			n,
		),
	}
}

// HostEntry (list): List of static host entries
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "host-entries/host-entry"
// Path from root: "/system/dns/host-entries/host-entry"
// Hostname: string
func (n *System_DnsPathAny) HostEntry(Hostname string) *System_Dns_HostEntryPathAny {
	return &System_Dns_HostEntryPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"host-entries", "host-entry"},
			map[string]interface{}{"hostname": Hostname},
			n,
		),
	}
}

// Search (leaf): An ordered list of domains to search when resolving
// a host name.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/search"
// Path from root: "/system/dns/config/search"
func (n *System_DnsPath) Search() *System_Dns_SearchPath {
	return &System_Dns_SearchPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "search"},
			map[string]interface{}{},
			n,
		),
	}
}

// Search (leaf): An ordered list of domains to search when resolving
// a host name.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/search"
// Path from root: "/system/dns/config/search"
func (n *System_DnsPathAny) Search() *System_Dns_SearchPathAny {
	return &System_Dns_SearchPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "search"},
			map[string]interface{}{},
			n,
		),
	}
}

// ServerAny (list): List of the DNS servers that the resolver should query.
//
// When the resolver is invoked by a calling application, it
// sends the query to the first name server in this list.  If
// no response has been received within 'timeout' seconds,
// the resolver continues with the next server in the list.
// If no response is received from any server, the resolver
// continues with the first server again.  When the resolver
// has traversed the list 'attempts' times without receiving
// any response, it gives up and returns an error to the
// calling application.
//
// Implementations MAY limit the number of entries in this
// list.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/dns/servers/server"
// Address (wildcarded): string
func (n *System_DnsPath) ServerAny() *System_Dns_ServerPathAny {
	return &System_Dns_ServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// ServerAny (list): List of the DNS servers that the resolver should query.
//
// When the resolver is invoked by a calling application, it
// sends the query to the first name server in this list.  If
// no response has been received within 'timeout' seconds,
// the resolver continues with the next server in the list.
// If no response is received from any server, the resolver
// continues with the first server again.  When the resolver
// has traversed the list 'attempts' times without receiving
// any response, it gives up and returns an error to the
// calling application.
//
// Implementations MAY limit the number of entries in this
// list.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/dns/servers/server"
// Address (wildcarded): string
func (n *System_DnsPathAny) ServerAny() *System_Dns_ServerPathAny {
	return &System_Dns_ServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// Server (list): List of the DNS servers that the resolver should query.
//
// When the resolver is invoked by a calling application, it
// sends the query to the first name server in this list.  If
// no response has been received within 'timeout' seconds,
// the resolver continues with the next server in the list.
// If no response is received from any server, the resolver
// continues with the first server again.  When the resolver
// has traversed the list 'attempts' times without receiving
// any response, it gives up and returns an error to the
// calling application.
//
// Implementations MAY limit the number of entries in this
// list.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/dns/servers/server"
// Address: string
func (n *System_DnsPath) Server(Address string) *System_Dns_ServerPath {
	return &System_Dns_ServerPath{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// Server (list): List of the DNS servers that the resolver should query.
//
// When the resolver is invoked by a calling application, it
// sends the query to the first name server in this list.  If
// no response has been received within 'timeout' seconds,
// the resolver continues with the next server in the list.
// If no response is received from any server, the resolver
// continues with the first server again.  When the resolver
// has traversed the list 'attempts' times without receiving
// any response, it gives up and returns an error to the
// calling application.
//
// Implementations MAY limit the number of entries in this
// list.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/dns/servers/server"
// Address: string
func (n *System_DnsPathAny) Server(Address string) *System_Dns_ServerPathAny {
	return &System_Dns_ServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// System_Dns_HostEntryPath represents the /openconfig-system/system/dns/host-entries/host-entry YANG schema element.
type System_Dns_HostEntryPath struct {
	*ygot.NodePath
}

// System_Dns_HostEntryPathAny represents the wildcard version of the /openconfig-system/system/dns/host-entries/host-entry YANG schema element.
type System_Dns_HostEntryPathAny struct {
	*ygot.NodePath
}

// System_Dns_HostEntry_AliasPath represents the /openconfig-system/system/dns/host-entries/host-entry/config/alias YANG schema element.
type System_Dns_HostEntry_AliasPath struct {
	*ygot.NodePath
}

// System_Dns_HostEntry_AliasPathAny represents the wildcard version of the /openconfig-system/system/dns/host-entries/host-entry/config/alias YANG schema element.
type System_Dns_HostEntry_AliasPathAny struct {
	*ygot.NodePath
}

// System_Dns_HostEntry_HostnamePath represents the /openconfig-system/system/dns/host-entries/host-entry/config/hostname YANG schema element.
type System_Dns_HostEntry_HostnamePath struct {
	*ygot.NodePath
}

// System_Dns_HostEntry_HostnamePathAny represents the wildcard version of the /openconfig-system/system/dns/host-entries/host-entry/config/hostname YANG schema element.
type System_Dns_HostEntry_HostnamePathAny struct {
	*ygot.NodePath
}

// System_Dns_HostEntry_Ipv4AddressPath represents the /openconfig-system/system/dns/host-entries/host-entry/config/ipv4-address YANG schema element.
type System_Dns_HostEntry_Ipv4AddressPath struct {
	*ygot.NodePath
}

// System_Dns_HostEntry_Ipv4AddressPathAny represents the wildcard version of the /openconfig-system/system/dns/host-entries/host-entry/config/ipv4-address YANG schema element.
type System_Dns_HostEntry_Ipv4AddressPathAny struct {
	*ygot.NodePath
}

// System_Dns_HostEntry_Ipv6AddressPath represents the /openconfig-system/system/dns/host-entries/host-entry/config/ipv6-address YANG schema element.
type System_Dns_HostEntry_Ipv6AddressPath struct {
	*ygot.NodePath
}

// System_Dns_HostEntry_Ipv6AddressPathAny represents the wildcard version of the /openconfig-system/system/dns/host-entries/host-entry/config/ipv6-address YANG schema element.
type System_Dns_HostEntry_Ipv6AddressPathAny struct {
	*ygot.NodePath
}

// Alias (leaf): Additional aliases for the hostname
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/alias"
// Path from root: "/system/dns/host-entries/host-entry/config/alias"
func (n *System_Dns_HostEntryPath) Alias() *System_Dns_HostEntry_AliasPath {
	return &System_Dns_HostEntry_AliasPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "alias"},
			map[string]interface{}{},
			n,
		),
	}
}

// Alias (leaf): Additional aliases for the hostname
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/alias"
// Path from root: "/system/dns/host-entries/host-entry/config/alias"
func (n *System_Dns_HostEntryPathAny) Alias() *System_Dns_HostEntry_AliasPathAny {
	return &System_Dns_HostEntry_AliasPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "alias"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hostname (leaf): Hostname for the static DNS entry
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/hostname"
// Path from root: "/system/dns/host-entries/host-entry/config/hostname"
func (n *System_Dns_HostEntryPath) Hostname() *System_Dns_HostEntry_HostnamePath {
	return &System_Dns_HostEntry_HostnamePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hostname"},
			map[string]interface{}{},
			n,
		),
	}
}

// Hostname (leaf): Hostname for the static DNS entry
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/hostname"
// Path from root: "/system/dns/host-entries/host-entry/config/hostname"
func (n *System_Dns_HostEntryPathAny) Hostname() *System_Dns_HostEntry_HostnamePathAny {
	return &System_Dns_HostEntry_HostnamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "hostname"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Address (leaf): List of IPv4 addresses for the host entry
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/ipv4-address"
// Path from root: "/system/dns/host-entries/host-entry/config/ipv4-address"
func (n *System_Dns_HostEntryPath) Ipv4Address() *System_Dns_HostEntry_Ipv4AddressPath {
	return &System_Dns_HostEntry_Ipv4AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv4-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv4Address (leaf): List of IPv4 addresses for the host entry
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/ipv4-address"
// Path from root: "/system/dns/host-entries/host-entry/config/ipv4-address"
func (n *System_Dns_HostEntryPathAny) Ipv4Address() *System_Dns_HostEntry_Ipv4AddressPathAny {
	return &System_Dns_HostEntry_Ipv4AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv4-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Address (leaf): List of IPv6 addresses for the host entry
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/ipv6-address"
// Path from root: "/system/dns/host-entries/host-entry/config/ipv6-address"
func (n *System_Dns_HostEntryPath) Ipv6Address() *System_Dns_HostEntry_Ipv6AddressPath {
	return &System_Dns_HostEntry_Ipv6AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv6-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ipv6Address (leaf): List of IPv6 addresses for the host entry
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/ipv6-address"
// Path from root: "/system/dns/host-entries/host-entry/config/ipv6-address"
func (n *System_Dns_HostEntryPathAny) Ipv6Address() *System_Dns_HostEntry_Ipv6AddressPathAny {
	return &System_Dns_HostEntry_Ipv6AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ipv6-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Dns_ServerPath represents the /openconfig-system/system/dns/servers/server YANG schema element.
type System_Dns_ServerPath struct {
	*ygot.NodePath
}

// System_Dns_ServerPathAny represents the wildcard version of the /openconfig-system/system/dns/servers/server YANG schema element.
type System_Dns_ServerPathAny struct {
	*ygot.NodePath
}

// System_Dns_Server_AddressPath represents the /openconfig-system/system/dns/servers/server/config/address YANG schema element.
type System_Dns_Server_AddressPath struct {
	*ygot.NodePath
}

// System_Dns_Server_AddressPathAny represents the wildcard version of the /openconfig-system/system/dns/servers/server/config/address YANG schema element.
type System_Dns_Server_AddressPathAny struct {
	*ygot.NodePath
}

// System_Dns_Server_PortPath represents the /openconfig-system/system/dns/servers/server/config/port YANG schema element.
type System_Dns_Server_PortPath struct {
	*ygot.NodePath
}

// System_Dns_Server_PortPathAny represents the wildcard version of the /openconfig-system/system/dns/servers/server/config/port YANG schema element.
type System_Dns_Server_PortPathAny struct {
	*ygot.NodePath
}

// Address (leaf): The address of the DNS server, can be either IPv4
// or IPv6.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/address"
// Path from root: "/system/dns/servers/server/config/address"
func (n *System_Dns_ServerPath) Address() *System_Dns_Server_AddressPath {
	return &System_Dns_Server_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): The address of the DNS server, can be either IPv4
// or IPv6.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/address"
// Path from root: "/system/dns/servers/server/config/address"
func (n *System_Dns_ServerPathAny) Address() *System_Dns_Server_AddressPathAny {
	return &System_Dns_Server_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Port (leaf): The port number of the DNS server.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/port"
// Path from root: "/system/dns/servers/server/config/port"
func (n *System_Dns_ServerPath) Port() *System_Dns_Server_PortPath {
	return &System_Dns_Server_PortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port"},
			map[string]interface{}{},
			n,
		),
	}
}

// Port (leaf): The port number of the DNS server.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/port"
// Path from root: "/system/dns/servers/server/config/port"
func (n *System_Dns_ServerPathAny) Port() *System_Dns_Server_PortPathAny {
	return &System_Dns_Server_PortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_LicensePath represents the /openconfig-system/system/license YANG schema element.
type System_LicensePath struct {
	*ygot.NodePath
}

// System_LicensePathAny represents the wildcard version of the /openconfig-system/system/license YANG schema element.
type System_LicensePathAny struct {
	*ygot.NodePath
}

// LicenseAny (list): List of licenses.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "licenses/license"
// Path from root: "/system/license/licenses/license"
// LicenseId (wildcarded): string
func (n *System_LicensePath) LicenseAny() *System_License_LicensePathAny {
	return &System_License_LicensePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"licenses", "license"},
			map[string]interface{}{"license-id": "*"},
			n,
		),
	}
}

// LicenseAny (list): List of licenses.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "licenses/license"
// Path from root: "/system/license/licenses/license"
// LicenseId (wildcarded): string
func (n *System_LicensePathAny) LicenseAny() *System_License_LicensePathAny {
	return &System_License_LicensePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"licenses", "license"},
			map[string]interface{}{"license-id": "*"},
			n,
		),
	}
}

// License (list): List of licenses.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "licenses/license"
// Path from root: "/system/license/licenses/license"
// LicenseId: string
func (n *System_LicensePath) License(LicenseId string) *System_License_LicensePath {
	return &System_License_LicensePath{
		NodePath: ygot.NewNodePath(
			[]string{"licenses", "license"},
			map[string]interface{}{"license-id": LicenseId},
			n,
		),
	}
}

// License (list): List of licenses.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "licenses/license"
// Path from root: "/system/license/licenses/license"
// LicenseId: string
func (n *System_LicensePathAny) License(LicenseId string) *System_License_LicensePathAny {
	return &System_License_LicensePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"licenses", "license"},
			map[string]interface{}{"license-id": LicenseId},
			n,
		),
	}
}

// System_License_LicensePath represents the /openconfig-system/system/license/licenses/license YANG schema element.
type System_License_LicensePath struct {
	*ygot.NodePath
}

// System_License_LicensePathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license YANG schema element.
type System_License_LicensePathAny struct {
	*ygot.NodePath
}

// System_License_License_ActivePath represents the /openconfig-system/system/license/licenses/license/config/active YANG schema element.
type System_License_License_ActivePath struct {
	*ygot.NodePath
}

// System_License_License_ActivePathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license/config/active YANG schema element.
type System_License_License_ActivePathAny struct {
	*ygot.NodePath
}

// System_License_License_DescriptionPath represents the /openconfig-system/system/license/licenses/license/state/description YANG schema element.
type System_License_License_DescriptionPath struct {
	*ygot.NodePath
}

// System_License_License_DescriptionPathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license/state/description YANG schema element.
type System_License_License_DescriptionPathAny struct {
	*ygot.NodePath
}

// System_License_License_ExpirationDatePath represents the /openconfig-system/system/license/licenses/license/state/expiration-date YANG schema element.
type System_License_License_ExpirationDatePath struct {
	*ygot.NodePath
}

// System_License_License_ExpirationDatePathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license/state/expiration-date YANG schema element.
type System_License_License_ExpirationDatePathAny struct {
	*ygot.NodePath
}

// System_License_License_ExpiredPath represents the /openconfig-system/system/license/licenses/license/state/expired YANG schema element.
type System_License_License_ExpiredPath struct {
	*ygot.NodePath
}

// System_License_License_ExpiredPathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license/state/expired YANG schema element.
type System_License_License_ExpiredPathAny struct {
	*ygot.NodePath
}

// System_License_License_InUsePath represents the /openconfig-system/system/license/licenses/license/state/in-use YANG schema element.
type System_License_License_InUsePath struct {
	*ygot.NodePath
}

// System_License_License_InUsePathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license/state/in-use YANG schema element.
type System_License_License_InUsePathAny struct {
	*ygot.NodePath
}

// System_License_License_IssueDatePath represents the /openconfig-system/system/license/licenses/license/state/issue-date YANG schema element.
type System_License_License_IssueDatePath struct {
	*ygot.NodePath
}

// System_License_License_IssueDatePathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license/state/issue-date YANG schema element.
type System_License_License_IssueDatePathAny struct {
	*ygot.NodePath
}

// System_License_License_LicenseDataPath represents the /openconfig-system/system/license/licenses/license/config/license-data YANG schema element.
type System_License_License_LicenseDataPath struct {
	*ygot.NodePath
}

// System_License_License_LicenseDataPathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license/config/license-data YANG schema element.
type System_License_License_LicenseDataPathAny struct {
	*ygot.NodePath
}

// System_License_License_LicenseIdPath represents the /openconfig-system/system/license/licenses/license/config/license-id YANG schema element.
type System_License_License_LicenseIdPath struct {
	*ygot.NodePath
}

// System_License_License_LicenseIdPathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license/config/license-id YANG schema element.
type System_License_License_LicenseIdPathAny struct {
	*ygot.NodePath
}

// System_License_License_ValidPath represents the /openconfig-system/system/license/licenses/license/state/valid YANG schema element.
type System_License_License_ValidPath struct {
	*ygot.NodePath
}

// System_License_License_ValidPathAny represents the wildcard version of the /openconfig-system/system/license/licenses/license/state/valid YANG schema element.
type System_License_License_ValidPathAny struct {
	*ygot.NodePath
}

// Active (leaf): The activation state of the license.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "config/active"
// Path from root: "/system/license/licenses/license/config/active"
func (n *System_License_LicensePath) Active() *System_License_License_ActivePath {
	return &System_License_License_ActivePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// Active (leaf): The activation state of the license.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "config/active"
// Path from root: "/system/license/licenses/license/config/active"
func (n *System_License_LicensePathAny) Active() *System_License_License_ActivePathAny {
	return &System_License_License_ActivePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "active"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): The license description.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/description"
// Path from root: "/system/license/licenses/license/state/description"
func (n *System_License_LicensePath) Description() *System_License_License_DescriptionPath {
	return &System_License_License_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): The license description.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/description"
// Path from root: "/system/license/licenses/license/state/description"
func (n *System_License_LicensePathAny) Description() *System_License_License_DescriptionPathAny {
	return &System_License_License_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExpirationDate (leaf): The date and time at which the license will expire, expressed as the
// number of nanoseconds since the Unix Epoch
// (January 1, 1970, 00:00 UTC). Zero if it does not expire.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/expiration-date"
// Path from root: "/system/license/licenses/license/state/expiration-date"
func (n *System_License_LicensePath) ExpirationDate() *System_License_License_ExpirationDatePath {
	return &System_License_License_ExpirationDatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "expiration-date"},
			map[string]interface{}{},
			n,
		),
	}
}

// ExpirationDate (leaf): The date and time at which the license will expire, expressed as the
// number of nanoseconds since the Unix Epoch
// (January 1, 1970, 00:00 UTC). Zero if it does not expire.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/expiration-date"
// Path from root: "/system/license/licenses/license/state/expiration-date"
func (n *System_License_LicensePathAny) ExpirationDate() *System_License_License_ExpirationDatePathAny {
	return &System_License_License_ExpirationDatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "expiration-date"},
			map[string]interface{}{},
			n,
		),
	}
}

// Expired (leaf): The license has expired.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/expired"
// Path from root: "/system/license/licenses/license/state/expired"
func (n *System_License_LicensePath) Expired() *System_License_License_ExpiredPath {
	return &System_License_License_ExpiredPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "expired"},
			map[string]interface{}{},
			n,
		),
	}
}

// Expired (leaf): The license has expired.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/expired"
// Path from root: "/system/license/licenses/license/state/expired"
func (n *System_License_LicensePathAny) Expired() *System_License_License_ExpiredPathAny {
	return &System_License_License_ExpiredPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "expired"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUse (leaf): The license is in use. Different from active. This states that the
// license is effectively being used in addition to being active. If
// license for feature X was activated but feature X is not being used,
// then this should be false.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/in-use"
// Path from root: "/system/license/licenses/license/state/in-use"
func (n *System_License_LicensePath) InUse() *System_License_License_InUsePath {
	return &System_License_License_InUsePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-use"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUse (leaf): The license is in use. Different from active. This states that the
// license is effectively being used in addition to being active. If
// license for feature X was activated but feature X is not being used,
// then this should be false.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/in-use"
// Path from root: "/system/license/licenses/license/state/in-use"
func (n *System_License_LicensePathAny) InUse() *System_License_License_InUsePathAny {
	return &System_License_License_InUsePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-use"},
			map[string]interface{}{},
			n,
		),
	}
}

// IssueDate (leaf): The date and time at which the license was issued, expressed as the
// number of nanoseconds since the Unix Epoch
// (January 1, 1970, 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/issue-date"
// Path from root: "/system/license/licenses/license/state/issue-date"
func (n *System_License_LicensePath) IssueDate() *System_License_License_IssueDatePath {
	return &System_License_License_IssueDatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "issue-date"},
			map[string]interface{}{},
			n,
		),
	}
}

// IssueDate (leaf): The date and time at which the license was issued, expressed as the
// number of nanoseconds since the Unix Epoch
// (January 1, 1970, 00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/issue-date"
// Path from root: "/system/license/licenses/license/state/issue-date"
func (n *System_License_LicensePathAny) IssueDate() *System_License_License_IssueDatePathAny {
	return &System_License_License_IssueDatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "issue-date"},
			map[string]interface{}{},
			n,
		),
	}
}

// LicenseData (leaf): The contents of the licence (if required) - which may be
// supplied as a binary blob, or a simple string value. If this
// value is considered sensitive, it may be read as an empty value.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "config/license-data"
// Path from root: "/system/license/licenses/license/config/license-data"
func (n *System_License_LicensePath) LicenseData() *System_License_License_LicenseDataPath {
	return &System_License_License_LicenseDataPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "license-data"},
			map[string]interface{}{},
			n,
		),
	}
}

// LicenseData (leaf): The contents of the licence (if required) - which may be
// supplied as a binary blob, or a simple string value. If this
// value is considered sensitive, it may be read as an empty value.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "config/license-data"
// Path from root: "/system/license/licenses/license/config/license-data"
func (n *System_License_LicensePathAny) LicenseData() *System_License_License_LicenseDataPathAny {
	return &System_License_License_LicenseDataPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "license-data"},
			map[string]interface{}{},
			n,
		),
	}
}

// LicenseId (leaf): License ID. A string that uniquelly identifies the license. The
// platform should list all the licenses it supports being activated.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "config/license-id"
// Path from root: "/system/license/licenses/license/config/license-id"
func (n *System_License_LicensePath) LicenseId() *System_License_License_LicenseIdPath {
	return &System_License_License_LicenseIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "license-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LicenseId (leaf): License ID. A string that uniquelly identifies the license. The
// platform should list all the licenses it supports being activated.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "config/license-id"
// Path from root: "/system/license/licenses/license/config/license-id"
func (n *System_License_LicensePathAny) LicenseId() *System_License_License_LicenseIdPathAny {
	return &System_License_License_LicenseIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "license-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Valid (leaf): The license is valid. Can be activated in the system or platform.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/valid"
// Path from root: "/system/license/licenses/license/state/valid"
func (n *System_License_LicensePath) Valid() *System_License_License_ValidPath {
	return &System_License_License_ValidPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Valid (leaf): The license is valid. Can be activated in the system or platform.
// ----------------------------------------
// Defining module: "openconfig-license"
// Instantiating module: "openconfig-system"
// Path from parent: "state/valid"
// Path from root: "/system/license/licenses/license/state/valid"
func (n *System_License_LicensePathAny) Valid() *System_License_License_ValidPathAny {
	return &System_License_License_ValidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "valid"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_LoggingPath represents the /openconfig-system/system/logging YANG schema element.
type System_LoggingPath struct {
	*ygot.NodePath
}

// System_LoggingPathAny represents the wildcard version of the /openconfig-system/system/logging YANG schema element.
type System_LoggingPathAny struct {
	*ygot.NodePath
}

// Console (container): Top-level container for data related to console-based
// logging
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "console"
// Path from root: "/system/logging/console"
func (n *System_LoggingPath) Console() *System_Logging_ConsolePath {
	return &System_Logging_ConsolePath{
		NodePath: ygot.NewNodePath(
			[]string{"console"},
			map[string]interface{}{},
			n,
		),
	}
}

// Console (container): Top-level container for data related to console-based
// logging
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "console"
// Path from root: "/system/logging/console"
func (n *System_LoggingPathAny) Console() *System_Logging_ConsolePathAny {
	return &System_Logging_ConsolePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"console"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemoteServerAny (list): List of remote log servers
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "remote-servers/remote-server"
// Path from root: "/system/logging/remote-servers/remote-server"
// Host (wildcarded): string
func (n *System_LoggingPath) RemoteServerAny() *System_Logging_RemoteServerPathAny {
	return &System_Logging_RemoteServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"remote-servers", "remote-server"},
			map[string]interface{}{"host": "*"},
			n,
		),
	}
}

// RemoteServerAny (list): List of remote log servers
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "remote-servers/remote-server"
// Path from root: "/system/logging/remote-servers/remote-server"
// Host (wildcarded): string
func (n *System_LoggingPathAny) RemoteServerAny() *System_Logging_RemoteServerPathAny {
	return &System_Logging_RemoteServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"remote-servers", "remote-server"},
			map[string]interface{}{"host": "*"},
			n,
		),
	}
}

// RemoteServer (list): List of remote log servers
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "remote-servers/remote-server"
// Path from root: "/system/logging/remote-servers/remote-server"
// Host: string
func (n *System_LoggingPath) RemoteServer(Host string) *System_Logging_RemoteServerPath {
	return &System_Logging_RemoteServerPath{
		NodePath: ygot.NewNodePath(
			[]string{"remote-servers", "remote-server"},
			map[string]interface{}{"host": Host},
			n,
		),
	}
}

// RemoteServer (list): List of remote log servers
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "remote-servers/remote-server"
// Path from root: "/system/logging/remote-servers/remote-server"
// Host: string
func (n *System_LoggingPathAny) RemoteServer(Host string) *System_Logging_RemoteServerPathAny {
	return &System_Logging_RemoteServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"remote-servers", "remote-server"},
			map[string]interface{}{"host": Host},
			n,
		),
	}
}

// System_Logging_ConsolePath represents the /openconfig-system/system/logging/console YANG schema element.
type System_Logging_ConsolePath struct {
	*ygot.NodePath
}

// System_Logging_ConsolePathAny represents the wildcard version of the /openconfig-system/system/logging/console YANG schema element.
type System_Logging_ConsolePathAny struct {
	*ygot.NodePath
}

// SelectorAny (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/console/selectors/selector"
// Facility (wildcarded): E_SystemLogging_SYSLOG_FACILITY
// Severity (wildcarded): E_SystemLogging_SyslogSeverity
func (n *System_Logging_ConsolePath) SelectorAny() *System_Logging_Console_SelectorPathAny {
	return &System_Logging_Console_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": "*", "severity": "*"},
			n,
		),
	}
}

// SelectorAny (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/console/selectors/selector"
// Facility (wildcarded): E_SystemLogging_SYSLOG_FACILITY
// Severity (wildcarded): E_SystemLogging_SyslogSeverity
func (n *System_Logging_ConsolePathAny) SelectorAny() *System_Logging_Console_SelectorPathAny {
	return &System_Logging_Console_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": "*", "severity": "*"},
			n,
		),
	}
}

// SelectorAnySeverity (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/console/selectors/selector"
// Facility: E_SystemLogging_SYSLOG_FACILITY
// Severity (wildcarded): E_SystemLogging_SyslogSeverity
func (n *System_Logging_ConsolePath) SelectorAnySeverity(Facility E_SystemLogging_SYSLOG_FACILITY) *System_Logging_Console_SelectorPathAny {
	return &System_Logging_Console_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": Facility, "severity": "*"},
			n,
		),
	}
}

// SelectorAnySeverity (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/console/selectors/selector"
// Facility: E_SystemLogging_SYSLOG_FACILITY
// Severity (wildcarded): E_SystemLogging_SyslogSeverity
func (n *System_Logging_ConsolePathAny) SelectorAnySeverity(Facility E_SystemLogging_SYSLOG_FACILITY) *System_Logging_Console_SelectorPathAny {
	return &System_Logging_Console_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": Facility, "severity": "*"},
			n,
		),
	}
}

// SelectorAnyFacility (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/console/selectors/selector"
// Facility (wildcarded): E_SystemLogging_SYSLOG_FACILITY
// Severity: E_SystemLogging_SyslogSeverity
func (n *System_Logging_ConsolePath) SelectorAnyFacility(Severity E_SystemLogging_SyslogSeverity) *System_Logging_Console_SelectorPathAny {
	return &System_Logging_Console_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": "*", "severity": Severity},
			n,
		),
	}
}

// SelectorAnyFacility (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/console/selectors/selector"
// Facility (wildcarded): E_SystemLogging_SYSLOG_FACILITY
// Severity: E_SystemLogging_SyslogSeverity
func (n *System_Logging_ConsolePathAny) SelectorAnyFacility(Severity E_SystemLogging_SyslogSeverity) *System_Logging_Console_SelectorPathAny {
	return &System_Logging_Console_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": "*", "severity": Severity},
			n,
		),
	}
}

// Selector (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/console/selectors/selector"
// Facility: E_SystemLogging_SYSLOG_FACILITY
// Severity: E_SystemLogging_SyslogSeverity
func (n *System_Logging_ConsolePath) Selector(Facility E_SystemLogging_SYSLOG_FACILITY, Severity E_SystemLogging_SyslogSeverity) *System_Logging_Console_SelectorPath {
	return &System_Logging_Console_SelectorPath{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": Facility, "severity": Severity},
			n,
		),
	}
}

// Selector (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/console/selectors/selector"
// Facility: E_SystemLogging_SYSLOG_FACILITY
// Severity: E_SystemLogging_SyslogSeverity
func (n *System_Logging_ConsolePathAny) Selector(Facility E_SystemLogging_SYSLOG_FACILITY, Severity E_SystemLogging_SyslogSeverity) *System_Logging_Console_SelectorPathAny {
	return &System_Logging_Console_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": Facility, "severity": Severity},
			n,
		),
	}
}

// System_Logging_Console_SelectorPath represents the /openconfig-system/system/logging/console/selectors/selector YANG schema element.
type System_Logging_Console_SelectorPath struct {
	*ygot.NodePath
}

// System_Logging_Console_SelectorPathAny represents the wildcard version of the /openconfig-system/system/logging/console/selectors/selector YANG schema element.
type System_Logging_Console_SelectorPathAny struct {
	*ygot.NodePath
}

// System_Logging_Console_Selector_FacilityPath represents the /openconfig-system/system/logging/console/selectors/selector/config/facility YANG schema element.
type System_Logging_Console_Selector_FacilityPath struct {
	*ygot.NodePath
}

// System_Logging_Console_Selector_FacilityPathAny represents the wildcard version of the /openconfig-system/system/logging/console/selectors/selector/config/facility YANG schema element.
type System_Logging_Console_Selector_FacilityPathAny struct {
	*ygot.NodePath
}

// System_Logging_Console_Selector_SeverityPath represents the /openconfig-system/system/logging/console/selectors/selector/config/severity YANG schema element.
type System_Logging_Console_Selector_SeverityPath struct {
	*ygot.NodePath
}

// System_Logging_Console_Selector_SeverityPathAny represents the wildcard version of the /openconfig-system/system/logging/console/selectors/selector/config/severity YANG schema element.
type System_Logging_Console_Selector_SeverityPathAny struct {
	*ygot.NodePath
}

// Facility (leaf): Specifies the facility, or class of messages to log
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/facility"
// Path from root: "/system/logging/console/selectors/selector/config/facility"
func (n *System_Logging_Console_SelectorPath) Facility() *System_Logging_Console_Selector_FacilityPath {
	return &System_Logging_Console_Selector_FacilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "facility"},
			map[string]interface{}{},
			n,
		),
	}
}

// Facility (leaf): Specifies the facility, or class of messages to log
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/facility"
// Path from root: "/system/logging/console/selectors/selector/config/facility"
func (n *System_Logging_Console_SelectorPathAny) Facility() *System_Logging_Console_Selector_FacilityPathAny {
	return &System_Logging_Console_Selector_FacilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "facility"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): Specifies that only messages of the given severity (or
// greater severity) for the corresonding facility are logged
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/severity"
// Path from root: "/system/logging/console/selectors/selector/config/severity"
func (n *System_Logging_Console_SelectorPath) Severity() *System_Logging_Console_Selector_SeverityPath {
	return &System_Logging_Console_Selector_SeverityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): Specifies that only messages of the given severity (or
// greater severity) for the corresonding facility are logged
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/severity"
// Path from root: "/system/logging/console/selectors/selector/config/severity"
func (n *System_Logging_Console_SelectorPathAny) Severity() *System_Logging_Console_Selector_SeverityPathAny {
	return &System_Logging_Console_Selector_SeverityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Logging_RemoteServerPath represents the /openconfig-system/system/logging/remote-servers/remote-server YANG schema element.
type System_Logging_RemoteServerPath struct {
	*ygot.NodePath
}

// System_Logging_RemoteServerPathAny represents the wildcard version of the /openconfig-system/system/logging/remote-servers/remote-server YANG schema element.
type System_Logging_RemoteServerPathAny struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_HostPath represents the /openconfig-system/system/logging/remote-servers/remote-server/config/host YANG schema element.
type System_Logging_RemoteServer_HostPath struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_HostPathAny represents the wildcard version of the /openconfig-system/system/logging/remote-servers/remote-server/config/host YANG schema element.
type System_Logging_RemoteServer_HostPathAny struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_RemotePortPath represents the /openconfig-system/system/logging/remote-servers/remote-server/config/remote-port YANG schema element.
type System_Logging_RemoteServer_RemotePortPath struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_RemotePortPathAny represents the wildcard version of the /openconfig-system/system/logging/remote-servers/remote-server/config/remote-port YANG schema element.
type System_Logging_RemoteServer_RemotePortPathAny struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_SourceAddressPath represents the /openconfig-system/system/logging/remote-servers/remote-server/config/source-address YANG schema element.
type System_Logging_RemoteServer_SourceAddressPath struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_SourceAddressPathAny represents the wildcard version of the /openconfig-system/system/logging/remote-servers/remote-server/config/source-address YANG schema element.
type System_Logging_RemoteServer_SourceAddressPathAny struct {
	*ygot.NodePath
}

// Host (leaf): IP address or hostname of the remote log server
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/host"
// Path from root: "/system/logging/remote-servers/remote-server/config/host"
func (n *System_Logging_RemoteServerPath) Host() *System_Logging_RemoteServer_HostPath {
	return &System_Logging_RemoteServer_HostPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "host"},
			map[string]interface{}{},
			n,
		),
	}
}

// Host (leaf): IP address or hostname of the remote log server
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/host"
// Path from root: "/system/logging/remote-servers/remote-server/config/host"
func (n *System_Logging_RemoteServerPathAny) Host() *System_Logging_RemoteServer_HostPathAny {
	return &System_Logging_RemoteServer_HostPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "host"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemotePort (leaf): Sets the destination port number for syslog UDP messages to
// the server.  The default for syslog is 514.
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/remote-port"
// Path from root: "/system/logging/remote-servers/remote-server/config/remote-port"
func (n *System_Logging_RemoteServerPath) RemotePort() *System_Logging_RemoteServer_RemotePortPath {
	return &System_Logging_RemoteServer_RemotePortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// RemotePort (leaf): Sets the destination port number for syslog UDP messages to
// the server.  The default for syslog is 514.
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/remote-port"
// Path from root: "/system/logging/remote-servers/remote-server/config/remote-port"
func (n *System_Logging_RemoteServerPathAny) RemotePort() *System_Logging_RemoteServer_RemotePortPathAny {
	return &System_Logging_RemoteServer_RemotePortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "remote-port"},
			map[string]interface{}{},
			n,
		),
	}
}

// SelectorAny (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector"
// Facility (wildcarded): E_SystemLogging_SYSLOG_FACILITY
// Severity (wildcarded): E_SystemLogging_SyslogSeverity
func (n *System_Logging_RemoteServerPath) SelectorAny() *System_Logging_RemoteServer_SelectorPathAny {
	return &System_Logging_RemoteServer_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": "*", "severity": "*"},
			n,
		),
	}
}

// SelectorAny (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector"
// Facility (wildcarded): E_SystemLogging_SYSLOG_FACILITY
// Severity (wildcarded): E_SystemLogging_SyslogSeverity
func (n *System_Logging_RemoteServerPathAny) SelectorAny() *System_Logging_RemoteServer_SelectorPathAny {
	return &System_Logging_RemoteServer_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": "*", "severity": "*"},
			n,
		),
	}
}

// SelectorAnySeverity (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector"
// Facility: E_SystemLogging_SYSLOG_FACILITY
// Severity (wildcarded): E_SystemLogging_SyslogSeverity
func (n *System_Logging_RemoteServerPath) SelectorAnySeverity(Facility E_SystemLogging_SYSLOG_FACILITY) *System_Logging_RemoteServer_SelectorPathAny {
	return &System_Logging_RemoteServer_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": Facility, "severity": "*"},
			n,
		),
	}
}

// SelectorAnySeverity (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector"
// Facility: E_SystemLogging_SYSLOG_FACILITY
// Severity (wildcarded): E_SystemLogging_SyslogSeverity
func (n *System_Logging_RemoteServerPathAny) SelectorAnySeverity(Facility E_SystemLogging_SYSLOG_FACILITY) *System_Logging_RemoteServer_SelectorPathAny {
	return &System_Logging_RemoteServer_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": Facility, "severity": "*"},
			n,
		),
	}
}

// SelectorAnyFacility (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector"
// Facility (wildcarded): E_SystemLogging_SYSLOG_FACILITY
// Severity: E_SystemLogging_SyslogSeverity
func (n *System_Logging_RemoteServerPath) SelectorAnyFacility(Severity E_SystemLogging_SyslogSeverity) *System_Logging_RemoteServer_SelectorPathAny {
	return &System_Logging_RemoteServer_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": "*", "severity": Severity},
			n,
		),
	}
}

// SelectorAnyFacility (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector"
// Facility (wildcarded): E_SystemLogging_SYSLOG_FACILITY
// Severity: E_SystemLogging_SyslogSeverity
func (n *System_Logging_RemoteServerPathAny) SelectorAnyFacility(Severity E_SystemLogging_SyslogSeverity) *System_Logging_RemoteServer_SelectorPathAny {
	return &System_Logging_RemoteServer_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": "*", "severity": Severity},
			n,
		),
	}
}

// Selector (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector"
// Facility: E_SystemLogging_SYSLOG_FACILITY
// Severity: E_SystemLogging_SyslogSeverity
func (n *System_Logging_RemoteServerPath) Selector(Facility E_SystemLogging_SYSLOG_FACILITY, Severity E_SystemLogging_SyslogSeverity) *System_Logging_RemoteServer_SelectorPath {
	return &System_Logging_RemoteServer_SelectorPath{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": Facility, "severity": Severity},
			n,
		),
	}
}

// Selector (list): List of selectors for log messages
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "selectors/selector"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector"
// Facility: E_SystemLogging_SYSLOG_FACILITY
// Severity: E_SystemLogging_SyslogSeverity
func (n *System_Logging_RemoteServerPathAny) Selector(Facility E_SystemLogging_SYSLOG_FACILITY, Severity E_SystemLogging_SyslogSeverity) *System_Logging_RemoteServer_SelectorPathAny {
	return &System_Logging_RemoteServer_SelectorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"selectors", "selector"},
			map[string]interface{}{"facility": Facility, "severity": Severity},
			n,
		),
	}
}

// SourceAddress (leaf): Source IP address for packets to the log server
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/source-address"
// Path from root: "/system/logging/remote-servers/remote-server/config/source-address"
func (n *System_Logging_RemoteServerPath) SourceAddress() *System_Logging_RemoteServer_SourceAddressPath {
	return &System_Logging_RemoteServer_SourceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// SourceAddress (leaf): Source IP address for packets to the log server
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/source-address"
// Path from root: "/system/logging/remote-servers/remote-server/config/source-address"
func (n *System_Logging_RemoteServerPathAny) SourceAddress() *System_Logging_RemoteServer_SourceAddressPathAny {
	return &System_Logging_RemoteServer_SourceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Logging_RemoteServer_SelectorPath represents the /openconfig-system/system/logging/remote-servers/remote-server/selectors/selector YANG schema element.
type System_Logging_RemoteServer_SelectorPath struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_SelectorPathAny represents the wildcard version of the /openconfig-system/system/logging/remote-servers/remote-server/selectors/selector YANG schema element.
type System_Logging_RemoteServer_SelectorPathAny struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_Selector_FacilityPath represents the /openconfig-system/system/logging/remote-servers/remote-server/selectors/selector/config/facility YANG schema element.
type System_Logging_RemoteServer_Selector_FacilityPath struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_Selector_FacilityPathAny represents the wildcard version of the /openconfig-system/system/logging/remote-servers/remote-server/selectors/selector/config/facility YANG schema element.
type System_Logging_RemoteServer_Selector_FacilityPathAny struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_Selector_SeverityPath represents the /openconfig-system/system/logging/remote-servers/remote-server/selectors/selector/config/severity YANG schema element.
type System_Logging_RemoteServer_Selector_SeverityPath struct {
	*ygot.NodePath
}

// System_Logging_RemoteServer_Selector_SeverityPathAny represents the wildcard version of the /openconfig-system/system/logging/remote-servers/remote-server/selectors/selector/config/severity YANG schema element.
type System_Logging_RemoteServer_Selector_SeverityPathAny struct {
	*ygot.NodePath
}

// Facility (leaf): Specifies the facility, or class of messages to log
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/facility"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector/config/facility"
func (n *System_Logging_RemoteServer_SelectorPath) Facility() *System_Logging_RemoteServer_Selector_FacilityPath {
	return &System_Logging_RemoteServer_Selector_FacilityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "facility"},
			map[string]interface{}{},
			n,
		),
	}
}

// Facility (leaf): Specifies the facility, or class of messages to log
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/facility"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector/config/facility"
func (n *System_Logging_RemoteServer_SelectorPathAny) Facility() *System_Logging_RemoteServer_Selector_FacilityPathAny {
	return &System_Logging_RemoteServer_Selector_FacilityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "facility"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): Specifies that only messages of the given severity (or
// greater severity) for the corresonding facility are logged
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/severity"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector/config/severity"
func (n *System_Logging_RemoteServer_SelectorPath) Severity() *System_Logging_RemoteServer_Selector_SeverityPath {
	return &System_Logging_RemoteServer_Selector_SeverityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): Specifies that only messages of the given severity (or
// greater severity) for the corresonding facility are logged
// ----------------------------------------
// Defining module: "openconfig-system-logging"
// Instantiating module: "openconfig-system"
// Path from parent: "config/severity"
// Path from root: "/system/logging/remote-servers/remote-server/selectors/selector/config/severity"
func (n *System_Logging_RemoteServer_SelectorPathAny) Severity() *System_Logging_RemoteServer_Selector_SeverityPathAny {
	return &System_Logging_RemoteServer_Selector_SeverityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_MemoryPath represents the /openconfig-system/system/memory YANG schema element.
type System_MemoryPath struct {
	*ygot.NodePath
}

// System_MemoryPathAny represents the wildcard version of the /openconfig-system/system/memory YANG schema element.
type System_MemoryPathAny struct {
	*ygot.NodePath
}

// System_Memory_FreePath represents the /openconfig-system/system/memory/state/free YANG schema element.
type System_Memory_FreePath struct {
	*ygot.NodePath
}

// System_Memory_FreePathAny represents the wildcard version of the /openconfig-system/system/memory/state/free YANG schema element.
type System_Memory_FreePathAny struct {
	*ygot.NodePath
}

// System_Memory_PhysicalPath represents the /openconfig-system/system/memory/state/physical YANG schema element.
type System_Memory_PhysicalPath struct {
	*ygot.NodePath
}

// System_Memory_PhysicalPathAny represents the wildcard version of the /openconfig-system/system/memory/state/physical YANG schema element.
type System_Memory_PhysicalPathAny struct {
	*ygot.NodePath
}

// System_Memory_ReservedPath represents the /openconfig-system/system/memory/state/reserved YANG schema element.
type System_Memory_ReservedPath struct {
	*ygot.NodePath
}

// System_Memory_ReservedPathAny represents the wildcard version of the /openconfig-system/system/memory/state/reserved YANG schema element.
type System_Memory_ReservedPathAny struct {
	*ygot.NodePath
}

// System_Memory_UsedPath represents the /openconfig-system/system/memory/state/used YANG schema element.
type System_Memory_UsedPath struct {
	*ygot.NodePath
}

// System_Memory_UsedPathAny represents the wildcard version of the /openconfig-system/system/memory/state/used YANG schema element.
type System_Memory_UsedPathAny struct {
	*ygot.NodePath
}

// Counters (container): Counters for tracking system memory errors
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/counters"
// Path from root: "/system/memory/state/counters"
func (n *System_MemoryPath) Counters() *System_Memory_CountersPath {
	return &System_Memory_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): Counters for tracking system memory errors
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/counters"
// Path from root: "/system/memory/state/counters"
func (n *System_MemoryPathAny) Counters() *System_Memory_CountersPathAny {
	return &System_Memory_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Free (leaf): Memory that is not used and is available for allocation.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/free"
// Path from root: "/system/memory/state/free"
func (n *System_MemoryPath) Free() *System_Memory_FreePath {
	return &System_Memory_FreePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "free"},
			map[string]interface{}{},
			n,
		),
	}
}

// Free (leaf): Memory that is not used and is available for allocation.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/free"
// Path from root: "/system/memory/state/free"
func (n *System_MemoryPathAny) Free() *System_Memory_FreePathAny {
	return &System_Memory_FreePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "free"},
			map[string]interface{}{},
			n,
		),
	}
}

// Physical (leaf): Reports the total physical memory available on the
// system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/physical"
// Path from root: "/system/memory/state/physical"
func (n *System_MemoryPath) Physical() *System_Memory_PhysicalPath {
	return &System_Memory_PhysicalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "physical"},
			map[string]interface{}{},
			n,
		),
	}
}

// Physical (leaf): Reports the total physical memory available on the
// system.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/physical"
// Path from root: "/system/memory/state/physical"
func (n *System_MemoryPathAny) Physical() *System_Memory_PhysicalPathAny {
	return &System_Memory_PhysicalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "physical"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reserved (leaf): Memory reserved for system use
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/reserved"
// Path from root: "/system/memory/state/reserved"
func (n *System_MemoryPath) Reserved() *System_Memory_ReservedPath {
	return &System_Memory_ReservedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reserved"},
			map[string]interface{}{},
			n,
		),
	}
}

// Reserved (leaf): Memory reserved for system use
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/reserved"
// Path from root: "/system/memory/state/reserved"
func (n *System_MemoryPathAny) Reserved() *System_Memory_ReservedPathAny {
	return &System_Memory_ReservedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "reserved"},
			map[string]interface{}{},
			n,
		),
	}
}

// Used (leaf): Memory that has been used and not available for allocation.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/used"
// Path from root: "/system/memory/state/used"
func (n *System_MemoryPath) Used() *System_Memory_UsedPath {
	return &System_Memory_UsedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "used"},
			map[string]interface{}{},
			n,
		),
	}
}

// Used (leaf): Memory that has been used and not available for allocation.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/used"
// Path from root: "/system/memory/state/used"
func (n *System_MemoryPathAny) Used() *System_Memory_UsedPathAny {
	return &System_Memory_UsedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "used"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Memory_CountersPath represents the /openconfig-system/system/memory/state/counters YANG schema element.
type System_Memory_CountersPath struct {
	*ygot.NodePath
}

// System_Memory_CountersPathAny represents the wildcard version of the /openconfig-system/system/memory/state/counters YANG schema element.
type System_Memory_CountersPathAny struct {
	*ygot.NodePath
}

// System_Memory_Counters_CorrectableEccErrorsPath represents the /openconfig-system/system/memory/state/counters/correctable-ecc-errors YANG schema element.
type System_Memory_Counters_CorrectableEccErrorsPath struct {
	*ygot.NodePath
}

// System_Memory_Counters_CorrectableEccErrorsPathAny represents the wildcard version of the /openconfig-system/system/memory/state/counters/correctable-ecc-errors YANG schema element.
type System_Memory_Counters_CorrectableEccErrorsPathAny struct {
	*ygot.NodePath
}

// System_Memory_Counters_TotalEccErrorsPath represents the /openconfig-system/system/memory/state/counters/total-ecc-errors YANG schema element.
type System_Memory_Counters_TotalEccErrorsPath struct {
	*ygot.NodePath
}

// System_Memory_Counters_TotalEccErrorsPathAny represents the wildcard version of the /openconfig-system/system/memory/state/counters/total-ecc-errors YANG schema element.
type System_Memory_Counters_TotalEccErrorsPathAny struct {
	*ygot.NodePath
}

// System_Memory_Counters_UncorrectableEccErrorsPath represents the /openconfig-system/system/memory/state/counters/uncorrectable-ecc-errors YANG schema element.
type System_Memory_Counters_UncorrectableEccErrorsPath struct {
	*ygot.NodePath
}

// System_Memory_Counters_UncorrectableEccErrorsPathAny represents the wildcard version of the /openconfig-system/system/memory/state/counters/uncorrectable-ecc-errors YANG schema element.
type System_Memory_Counters_UncorrectableEccErrorsPathAny struct {
	*ygot.NodePath
}

// CorrectableEccErrors (leaf): Count of correctable ECC errors. Systems with ECC memory
// are capable of correcting Single-bit ECC errors.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "correctable-ecc-errors"
// Path from root: "/system/memory/state/counters/correctable-ecc-errors"
func (n *System_Memory_CountersPath) CorrectableEccErrors() *System_Memory_Counters_CorrectableEccErrorsPath {
	return &System_Memory_Counters_CorrectableEccErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"correctable-ecc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CorrectableEccErrors (leaf): Count of correctable ECC errors. Systems with ECC memory
// are capable of correcting Single-bit ECC errors.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "correctable-ecc-errors"
// Path from root: "/system/memory/state/counters/correctable-ecc-errors"
func (n *System_Memory_CountersPathAny) CorrectableEccErrors() *System_Memory_Counters_CorrectableEccErrorsPathAny {
	return &System_Memory_Counters_CorrectableEccErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"correctable-ecc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalEccErrors (leaf): Count of total ECC errors, this includes both correctable
// and uncorrectable ECC errors.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "total-ecc-errors"
// Path from root: "/system/memory/state/counters/total-ecc-errors"
func (n *System_Memory_CountersPath) TotalEccErrors() *System_Memory_Counters_TotalEccErrorsPath {
	return &System_Memory_Counters_TotalEccErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"total-ecc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// TotalEccErrors (leaf): Count of total ECC errors, this includes both correctable
// and uncorrectable ECC errors.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "total-ecc-errors"
// Path from root: "/system/memory/state/counters/total-ecc-errors"
func (n *System_Memory_CountersPathAny) TotalEccErrors() *System_Memory_Counters_TotalEccErrorsPathAny {
	return &System_Memory_Counters_TotalEccErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"total-ecc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UncorrectableEccErrors (leaf): Count of uncorrectable ECC errors. Systems with ECC
// memory are capable of detecting multi-bit ECC errors,
// but cannot correct them.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "uncorrectable-ecc-errors"
// Path from root: "/system/memory/state/counters/uncorrectable-ecc-errors"
func (n *System_Memory_CountersPath) UncorrectableEccErrors() *System_Memory_Counters_UncorrectableEccErrorsPath {
	return &System_Memory_Counters_UncorrectableEccErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"uncorrectable-ecc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// UncorrectableEccErrors (leaf): Count of uncorrectable ECC errors. Systems with ECC
// memory are capable of detecting multi-bit ECC errors,
// but cannot correct them.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "uncorrectable-ecc-errors"
// Path from root: "/system/memory/state/counters/uncorrectable-ecc-errors"
func (n *System_Memory_CountersPathAny) UncorrectableEccErrors() *System_Memory_Counters_UncorrectableEccErrorsPathAny {
	return &System_Memory_Counters_UncorrectableEccErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"uncorrectable-ecc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_MessagesPath represents the /openconfig-system/system/messages YANG schema element.
type System_MessagesPath struct {
	*ygot.NodePath
}

// System_MessagesPathAny represents the wildcard version of the /openconfig-system/system/messages YANG schema element.
type System_MessagesPathAny struct {
	*ygot.NodePath
}

// System_Messages_SeverityPath represents the /openconfig-system/system/messages/config/severity YANG schema element.
type System_Messages_SeverityPath struct {
	*ygot.NodePath
}

// System_Messages_SeverityPathAny represents the wildcard version of the /openconfig-system/system/messages/config/severity YANG schema element.
type System_Messages_SeverityPathAny struct {
	*ygot.NodePath
}

// DebugServiceAny (list): List of debugging entries.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "debug-entries/debug-service"
// Path from root: "/system/messages/debug-entries/debug-service"
// Service (wildcarded): E_Messages_DEBUG_SERVICE
func (n *System_MessagesPath) DebugServiceAny() *System_Messages_DebugServicePathAny {
	return &System_Messages_DebugServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"debug-entries", "debug-service"},
			map[string]interface{}{"service": "*"},
			n,
		),
	}
}

// DebugServiceAny (list): List of debugging entries.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "debug-entries/debug-service"
// Path from root: "/system/messages/debug-entries/debug-service"
// Service (wildcarded): E_Messages_DEBUG_SERVICE
func (n *System_MessagesPathAny) DebugServiceAny() *System_Messages_DebugServicePathAny {
	return &System_Messages_DebugServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"debug-entries", "debug-service"},
			map[string]interface{}{"service": "*"},
			n,
		),
	}
}

// DebugService (list): List of debugging entries.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "debug-entries/debug-service"
// Path from root: "/system/messages/debug-entries/debug-service"
// Service: E_Messages_DEBUG_SERVICE
func (n *System_MessagesPath) DebugService(Service E_Messages_DEBUG_SERVICE) *System_Messages_DebugServicePath {
	return &System_Messages_DebugServicePath{
		NodePath: ygot.NewNodePath(
			[]string{"debug-entries", "debug-service"},
			map[string]interface{}{"service": Service},
			n,
		),
	}
}

// DebugService (list): List of debugging entries.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "debug-entries/debug-service"
// Path from root: "/system/messages/debug-entries/debug-service"
// Service: E_Messages_DEBUG_SERVICE
func (n *System_MessagesPathAny) DebugService(Service E_Messages_DEBUG_SERVICE) *System_Messages_DebugServicePathAny {
	return &System_Messages_DebugServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"debug-entries", "debug-service"},
			map[string]interface{}{"service": Service},
			n,
		),
	}
}

// Message (container): Syslog messages the client is Subscribing to. This is all
// messages currently configured to be sent according to
// syslog-severity.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "state/message"
// Path from root: "/system/messages/state/message"
func (n *System_MessagesPath) Message() *System_Messages_MessagePath {
	return &System_Messages_MessagePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "message"},
			map[string]interface{}{},
			n,
		),
	}
}

// Message (container): Syslog messages the client is Subscribing to. This is all
// messages currently configured to be sent according to
// syslog-severity.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "state/message"
// Path from root: "/system/messages/state/message"
func (n *System_MessagesPathAny) Message() *System_Messages_MessagePathAny {
	return &System_Messages_MessagePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "message"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): Specifies that only messages of the given severity (or
// greater severity) are sent over the RPC.
//
// This is analogous to differentiating which severity is to be
// sent to legacy Syslog servers, as opposed to local buffer or
// files.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "config/severity"
// Path from root: "/system/messages/config/severity"
func (n *System_MessagesPath) Severity() *System_Messages_SeverityPath {
	return &System_Messages_SeverityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// Severity (leaf): Specifies that only messages of the given severity (or
// greater severity) are sent over the RPC.
//
// This is analogous to differentiating which severity is to be
// sent to legacy Syslog servers, as opposed to local buffer or
// files.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "config/severity"
// Path from root: "/system/messages/config/severity"
func (n *System_MessagesPathAny) Severity() *System_Messages_SeverityPathAny {
	return &System_Messages_SeverityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "severity"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Messages_DebugServicePath represents the /openconfig-system/system/messages/debug-entries/debug-service YANG schema element.
type System_Messages_DebugServicePath struct {
	*ygot.NodePath
}

// System_Messages_DebugServicePathAny represents the wildcard version of the /openconfig-system/system/messages/debug-entries/debug-service YANG schema element.
type System_Messages_DebugServicePathAny struct {
	*ygot.NodePath
}

// System_Messages_DebugService_EnabledPath represents the /openconfig-system/system/messages/debug-entries/debug-service/config/enabled YANG schema element.
type System_Messages_DebugService_EnabledPath struct {
	*ygot.NodePath
}

// System_Messages_DebugService_EnabledPathAny represents the wildcard version of the /openconfig-system/system/messages/debug-entries/debug-service/config/enabled YANG schema element.
type System_Messages_DebugService_EnabledPathAny struct {
	*ygot.NodePath
}

// System_Messages_DebugService_ServicePath represents the /openconfig-system/system/messages/debug-entries/debug-service/config/service YANG schema element.
type System_Messages_DebugService_ServicePath struct {
	*ygot.NodePath
}

// System_Messages_DebugService_ServicePathAny represents the wildcard version of the /openconfig-system/system/messages/debug-entries/debug-service/config/service YANG schema element.
type System_Messages_DebugService_ServicePathAny struct {
	*ygot.NodePath
}

// Enabled (leaf): Enable and disable debugging.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enabled"
// Path from root: "/system/messages/debug-entries/debug-service/config/enabled"
func (n *System_Messages_DebugServicePath) Enabled() *System_Messages_DebugService_EnabledPath {
	return &System_Messages_DebugService_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enable and disable debugging.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enabled"
// Path from root: "/system/messages/debug-entries/debug-service/config/enabled"
func (n *System_Messages_DebugServicePathAny) Enabled() *System_Messages_DebugService_EnabledPathAny {
	return &System_Messages_DebugService_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Service (leaf): Enumeration of all services which can have debugging enabled.
// Vendors are to augment this base identity with their platform
// or OS specific debug options.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "config/service"
// Path from root: "/system/messages/debug-entries/debug-service/config/service"
func (n *System_Messages_DebugServicePath) Service() *System_Messages_DebugService_ServicePath {
	return &System_Messages_DebugService_ServicePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "service"},
			map[string]interface{}{},
			n,
		),
	}
}

// Service (leaf): Enumeration of all services which can have debugging enabled.
// Vendors are to augment this base identity with their platform
// or OS specific debug options.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "config/service"
// Path from root: "/system/messages/debug-entries/debug-service/config/service"
func (n *System_Messages_DebugServicePathAny) Service() *System_Messages_DebugService_ServicePathAny {
	return &System_Messages_DebugService_ServicePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "service"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Messages_MessagePath represents the /openconfig-system/system/messages/state/message YANG schema element.
type System_Messages_MessagePath struct {
	*ygot.NodePath
}

// System_Messages_MessagePathAny represents the wildcard version of the /openconfig-system/system/messages/state/message YANG schema element.
type System_Messages_MessagePathAny struct {
	*ygot.NodePath
}

// System_Messages_Message_AppNamePath represents the /openconfig-system/system/messages/state/message/app-name YANG schema element.
type System_Messages_Message_AppNamePath struct {
	*ygot.NodePath
}

// System_Messages_Message_AppNamePathAny represents the wildcard version of the /openconfig-system/system/messages/state/message/app-name YANG schema element.
type System_Messages_Message_AppNamePathAny struct {
	*ygot.NodePath
}

// System_Messages_Message_MsgPath represents the /openconfig-system/system/messages/state/message/msg YANG schema element.
type System_Messages_Message_MsgPath struct {
	*ygot.NodePath
}

// System_Messages_Message_MsgPathAny represents the wildcard version of the /openconfig-system/system/messages/state/message/msg YANG schema element.
type System_Messages_Message_MsgPathAny struct {
	*ygot.NodePath
}

// System_Messages_Message_MsgidPath represents the /openconfig-system/system/messages/state/message/msgid YANG schema element.
type System_Messages_Message_MsgidPath struct {
	*ygot.NodePath
}

// System_Messages_Message_MsgidPathAny represents the wildcard version of the /openconfig-system/system/messages/state/message/msgid YANG schema element.
type System_Messages_Message_MsgidPathAny struct {
	*ygot.NodePath
}

// System_Messages_Message_PriorityPath represents the /openconfig-system/system/messages/state/message/priority YANG schema element.
type System_Messages_Message_PriorityPath struct {
	*ygot.NodePath
}

// System_Messages_Message_PriorityPathAny represents the wildcard version of the /openconfig-system/system/messages/state/message/priority YANG schema element.
type System_Messages_Message_PriorityPathAny struct {
	*ygot.NodePath
}

// System_Messages_Message_ProcidPath represents the /openconfig-system/system/messages/state/message/procid YANG schema element.
type System_Messages_Message_ProcidPath struct {
	*ygot.NodePath
}

// System_Messages_Message_ProcidPathAny represents the wildcard version of the /openconfig-system/system/messages/state/message/procid YANG schema element.
type System_Messages_Message_ProcidPathAny struct {
	*ygot.NodePath
}

// AppName (leaf): The APP-NAME field SHOULD identify the device or
// application that originated the message.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "app-name"
// Path from root: "/system/messages/state/message/app-name"
func (n *System_Messages_MessagePath) AppName() *System_Messages_Message_AppNamePath {
	return &System_Messages_Message_AppNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"app-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// AppName (leaf): The APP-NAME field SHOULD identify the device or
// application that originated the message.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "app-name"
// Path from root: "/system/messages/state/message/app-name"
func (n *System_Messages_MessagePathAny) AppName() *System_Messages_Message_AppNamePathAny {
	return &System_Messages_Message_AppNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"app-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Msg (leaf): Message payload. If other leafs within this container not
// supported, this leaf MAY include the entire message,
// inclding pri, procid, app-name etc..
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "msg"
// Path from root: "/system/messages/state/message/msg"
func (n *System_Messages_MessagePath) Msg() *System_Messages_Message_MsgPath {
	return &System_Messages_Message_MsgPath{
		NodePath: ygot.NewNodePath(
			[]string{"msg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Msg (leaf): Message payload. If other leafs within this container not
// supported, this leaf MAY include the entire message,
// inclding pri, procid, app-name etc..
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "msg"
// Path from root: "/system/messages/state/message/msg"
func (n *System_Messages_MessagePathAny) Msg() *System_Messages_Message_MsgPathAny {
	return &System_Messages_Message_MsgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"msg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Msgid (leaf): The MSGID SHOULD identify the type of message. For
// example, a firewall might use the MSGID 'TCPIN' for
// incoming TCP traffic and the MSGID 'TCPOUT' for outgoing
// TCP traffic.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "msgid"
// Path from root: "/system/messages/state/message/msgid"
func (n *System_Messages_MessagePath) Msgid() *System_Messages_Message_MsgidPath {
	return &System_Messages_Message_MsgidPath{
		NodePath: ygot.NewNodePath(
			[]string{"msgid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Msgid (leaf): The MSGID SHOULD identify the type of message. For
// example, a firewall might use the MSGID 'TCPIN' for
// incoming TCP traffic and the MSGID 'TCPOUT' for outgoing
// TCP traffic.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "msgid"
// Path from root: "/system/messages/state/message/msgid"
func (n *System_Messages_MessagePathAny) Msgid() *System_Messages_Message_MsgidPathAny {
	return &System_Messages_Message_MsgidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"msgid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The Priority value (PRIVAL) represents both the
// Facility and Severity.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "priority"
// Path from root: "/system/messages/state/message/priority"
func (n *System_Messages_MessagePath) Priority() *System_Messages_Message_PriorityPath {
	return &System_Messages_Message_PriorityPath{
		NodePath: ygot.NewNodePath(
			[]string{"priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Priority (leaf): The Priority value (PRIVAL) represents both the
// Facility and Severity.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "priority"
// Path from root: "/system/messages/state/message/priority"
func (n *System_Messages_MessagePathAny) Priority() *System_Messages_Message_PriorityPathAny {
	return &System_Messages_Message_PriorityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"priority"},
			map[string]interface{}{},
			n,
		),
	}
}

// Procid (leaf): PROCID is a value that is included in the message, having
// no interoperable meaning, except that a change in the value
// indicates there has been a discontinuity in syslog
// reporting.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "procid"
// Path from root: "/system/messages/state/message/procid"
func (n *System_Messages_MessagePath) Procid() *System_Messages_Message_ProcidPath {
	return &System_Messages_Message_ProcidPath{
		NodePath: ygot.NewNodePath(
			[]string{"procid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Procid (leaf): PROCID is a value that is included in the message, having
// no interoperable meaning, except that a change in the value
// indicates there has been a discontinuity in syslog
// reporting.
// ----------------------------------------
// Defining module: "openconfig-messages"
// Instantiating module: "openconfig-system"
// Path from parent: "procid"
// Path from root: "/system/messages/state/message/procid"
func (n *System_Messages_MessagePathAny) Procid() *System_Messages_Message_ProcidPathAny {
	return &System_Messages_Message_ProcidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"procid"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_MountPointPath represents the /openconfig-system/system/mount-points/mount-point YANG schema element.
type System_MountPointPath struct {
	*ygot.NodePath
}

// System_MountPointPathAny represents the wildcard version of the /openconfig-system/system/mount-points/mount-point YANG schema element.
type System_MountPointPathAny struct {
	*ygot.NodePath
}

// System_MountPoint_AvailablePath represents the /openconfig-system/system/mount-points/mount-point/state/available YANG schema element.
type System_MountPoint_AvailablePath struct {
	*ygot.NodePath
}

// System_MountPoint_AvailablePathAny represents the wildcard version of the /openconfig-system/system/mount-points/mount-point/state/available YANG schema element.
type System_MountPoint_AvailablePathAny struct {
	*ygot.NodePath
}

// System_MountPoint_NamePath represents the /openconfig-system/system/mount-points/mount-point/state/name YANG schema element.
type System_MountPoint_NamePath struct {
	*ygot.NodePath
}

// System_MountPoint_NamePathAny represents the wildcard version of the /openconfig-system/system/mount-points/mount-point/state/name YANG schema element.
type System_MountPoint_NamePathAny struct {
	*ygot.NodePath
}

// System_MountPoint_SizePath represents the /openconfig-system/system/mount-points/mount-point/state/size YANG schema element.
type System_MountPoint_SizePath struct {
	*ygot.NodePath
}

// System_MountPoint_SizePathAny represents the wildcard version of the /openconfig-system/system/mount-points/mount-point/state/size YANG schema element.
type System_MountPoint_SizePathAny struct {
	*ygot.NodePath
}

// System_MountPoint_StorageComponentPath represents the /openconfig-system/system/mount-points/mount-point/state/storage-component YANG schema element.
type System_MountPoint_StorageComponentPath struct {
	*ygot.NodePath
}

// System_MountPoint_StorageComponentPathAny represents the wildcard version of the /openconfig-system/system/mount-points/mount-point/state/storage-component YANG schema element.
type System_MountPoint_StorageComponentPathAny struct {
	*ygot.NodePath
}

// System_MountPoint_UtilizedPath represents the /openconfig-system/system/mount-points/mount-point/state/utilized YANG schema element.
type System_MountPoint_UtilizedPath struct {
	*ygot.NodePath
}

// System_MountPoint_UtilizedPathAny represents the wildcard version of the /openconfig-system/system/mount-points/mount-point/state/utilized YANG schema element.
type System_MountPoint_UtilizedPathAny struct {
	*ygot.NodePath
}

// Available (leaf): The amount of unused space on the filesystem.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/available"
// Path from root: "/system/mount-points/mount-point/state/available"
func (n *System_MountPointPath) Available() *System_MountPoint_AvailablePath {
	return &System_MountPoint_AvailablePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "available"},
			map[string]interface{}{},
			n,
		),
	}
}

// Available (leaf): The amount of unused space on the filesystem.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/available"
// Path from root: "/system/mount-points/mount-point/state/available"
func (n *System_MountPointPathAny) Available() *System_MountPoint_AvailablePathAny {
	return &System_MountPoint_AvailablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "available"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Mount point name.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/name"
// Path from root: "/system/mount-points/mount-point/state/name"
func (n *System_MountPointPath) Name() *System_MountPoint_NamePath {
	return &System_MountPoint_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): Mount point name.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/name"
// Path from root: "/system/mount-points/mount-point/state/name"
func (n *System_MountPointPathAny) Name() *System_MountPoint_NamePathAny {
	return &System_MountPoint_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Size (leaf): The total size of the initialised filesystem.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/size"
// Path from root: "/system/mount-points/mount-point/state/size"
func (n *System_MountPointPath) Size() *System_MountPoint_SizePath {
	return &System_MountPoint_SizePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "size"},
			map[string]interface{}{},
			n,
		),
	}
}

// Size (leaf): The total size of the initialised filesystem.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/size"
// Path from root: "/system/mount-points/mount-point/state/size"
func (n *System_MountPointPathAny) Size() *System_MountPoint_SizePathAny {
	return &System_MountPoint_SizePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "size"},
			map[string]interface{}{},
			n,
		),
	}
}

// StorageComponent (leaf): In the case that the filesystem that is mounted corresponds to a
// physical or logical component within the system, this leaf provides
// a reference to the hosting component within the /components
// hierarchy.
//
// The reference should be to the most specific component (e.g., if an
// entry for /dev/sda1 exists, then this should be referred to,
// otherwise a reference to /dev/sda may be provided.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/storage-component"
// Path from root: "/system/mount-points/mount-point/state/storage-component"
func (n *System_MountPointPath) StorageComponent() *System_MountPoint_StorageComponentPath {
	return &System_MountPoint_StorageComponentPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "storage-component"},
			map[string]interface{}{},
			n,
		),
	}
}

// StorageComponent (leaf): In the case that the filesystem that is mounted corresponds to a
// physical or logical component within the system, this leaf provides
// a reference to the hosting component within the /components
// hierarchy.
//
// The reference should be to the most specific component (e.g., if an
// entry for /dev/sda1 exists, then this should be referred to,
// otherwise a reference to /dev/sda may be provided.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/storage-component"
// Path from root: "/system/mount-points/mount-point/state/storage-component"
func (n *System_MountPointPathAny) StorageComponent() *System_MountPoint_StorageComponentPathAny {
	return &System_MountPoint_StorageComponentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "storage-component"},
			map[string]interface{}{},
			n,
		),
	}
}

// Utilized (leaf): The amount of space currently in use on the filesystem.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/utilized"
// Path from root: "/system/mount-points/mount-point/state/utilized"
func (n *System_MountPointPath) Utilized() *System_MountPoint_UtilizedPath {
	return &System_MountPoint_UtilizedPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "utilized"},
			map[string]interface{}{},
			n,
		),
	}
}

// Utilized (leaf): The amount of space currently in use on the filesystem.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/utilized"
// Path from root: "/system/mount-points/mount-point/state/utilized"
func (n *System_MountPointPathAny) Utilized() *System_MountPoint_UtilizedPathAny {
	return &System_MountPoint_UtilizedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "utilized"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_NtpPath represents the /openconfig-system/system/ntp YANG schema element.
type System_NtpPath struct {
	*ygot.NodePath
}

// System_NtpPathAny represents the wildcard version of the /openconfig-system/system/ntp YANG schema element.
type System_NtpPathAny struct {
	*ygot.NodePath
}

// System_Ntp_AuthMismatchPath represents the /openconfig-system/system/ntp/state/auth-mismatch YANG schema element.
type System_Ntp_AuthMismatchPath struct {
	*ygot.NodePath
}

// System_Ntp_AuthMismatchPathAny represents the wildcard version of the /openconfig-system/system/ntp/state/auth-mismatch YANG schema element.
type System_Ntp_AuthMismatchPathAny struct {
	*ygot.NodePath
}

// System_Ntp_EnableNtpAuthPath represents the /openconfig-system/system/ntp/config/enable-ntp-auth YANG schema element.
type System_Ntp_EnableNtpAuthPath struct {
	*ygot.NodePath
}

// System_Ntp_EnableNtpAuthPathAny represents the wildcard version of the /openconfig-system/system/ntp/config/enable-ntp-auth YANG schema element.
type System_Ntp_EnableNtpAuthPathAny struct {
	*ygot.NodePath
}

// System_Ntp_EnabledPath represents the /openconfig-system/system/ntp/config/enabled YANG schema element.
type System_Ntp_EnabledPath struct {
	*ygot.NodePath
}

// System_Ntp_EnabledPathAny represents the wildcard version of the /openconfig-system/system/ntp/config/enabled YANG schema element.
type System_Ntp_EnabledPathAny struct {
	*ygot.NodePath
}

// System_Ntp_NtpSourceAddressPath represents the /openconfig-system/system/ntp/config/ntp-source-address YANG schema element.
type System_Ntp_NtpSourceAddressPath struct {
	*ygot.NodePath
}

// System_Ntp_NtpSourceAddressPathAny represents the wildcard version of the /openconfig-system/system/ntp/config/ntp-source-address YANG schema element.
type System_Ntp_NtpSourceAddressPathAny struct {
	*ygot.NodePath
}

// AuthMismatch (leaf): Count of the number of NTP packets received that were not
// processed due to authentication mismatch.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/auth-mismatch"
// Path from root: "/system/ntp/state/auth-mismatch"
func (n *System_NtpPath) AuthMismatch() *System_Ntp_AuthMismatchPath {
	return &System_Ntp_AuthMismatchPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-mismatch"},
			map[string]interface{}{},
			n,
		),
	}
}

// AuthMismatch (leaf): Count of the number of NTP packets received that were not
// processed due to authentication mismatch.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/auth-mismatch"
// Path from root: "/system/ntp/state/auth-mismatch"
func (n *System_NtpPathAny) AuthMismatch() *System_Ntp_AuthMismatchPathAny {
	return &System_Ntp_AuthMismatchPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "auth-mismatch"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableNtpAuth (leaf): Enable or disable NTP authentication -- when enabled, the
// system will only use packets containing a trusted
// authentication key to synchronize the time.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enable-ntp-auth"
// Path from root: "/system/ntp/config/enable-ntp-auth"
func (n *System_NtpPath) EnableNtpAuth() *System_Ntp_EnableNtpAuthPath {
	return &System_Ntp_EnableNtpAuthPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-ntp-auth"},
			map[string]interface{}{},
			n,
		),
	}
}

// EnableNtpAuth (leaf): Enable or disable NTP authentication -- when enabled, the
// system will only use packets containing a trusted
// authentication key to synchronize the time.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enable-ntp-auth"
// Path from root: "/system/ntp/config/enable-ntp-auth"
func (n *System_NtpPathAny) EnableNtpAuth() *System_Ntp_EnableNtpAuthPathAny {
	return &System_Ntp_EnableNtpAuthPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable-ntp-auth"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enables the NTP protocol and indicates that the system should
// attempt to synchronize the system clock with an NTP server
// from the servers defined in the 'ntp/server' list.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enabled"
// Path from root: "/system/ntp/config/enabled"
func (n *System_NtpPath) Enabled() *System_Ntp_EnabledPath {
	return &System_Ntp_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enables the NTP protocol and indicates that the system should
// attempt to synchronize the system clock with an NTP server
// from the servers defined in the 'ntp/server' list.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enabled"
// Path from root: "/system/ntp/config/enabled"
func (n *System_NtpPathAny) Enabled() *System_Ntp_EnabledPathAny {
	return &System_Ntp_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NtpKeyAny (list): List of NTP authentication keys
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "ntp-keys/ntp-key"
// Path from root: "/system/ntp/ntp-keys/ntp-key"
// KeyId (wildcarded): uint16
func (n *System_NtpPath) NtpKeyAny() *System_Ntp_NtpKeyPathAny {
	return &System_Ntp_NtpKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ntp-keys", "ntp-key"},
			map[string]interface{}{"key-id": "*"},
			n,
		),
	}
}

// NtpKeyAny (list): List of NTP authentication keys
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "ntp-keys/ntp-key"
// Path from root: "/system/ntp/ntp-keys/ntp-key"
// KeyId (wildcarded): uint16
func (n *System_NtpPathAny) NtpKeyAny() *System_Ntp_NtpKeyPathAny {
	return &System_Ntp_NtpKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ntp-keys", "ntp-key"},
			map[string]interface{}{"key-id": "*"},
			n,
		),
	}
}

// NtpKey (list): List of NTP authentication keys
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "ntp-keys/ntp-key"
// Path from root: "/system/ntp/ntp-keys/ntp-key"
// KeyId: uint16
func (n *System_NtpPath) NtpKey(KeyId uint16) *System_Ntp_NtpKeyPath {
	return &System_Ntp_NtpKeyPath{
		NodePath: ygot.NewNodePath(
			[]string{"ntp-keys", "ntp-key"},
			map[string]interface{}{"key-id": KeyId},
			n,
		),
	}
}

// NtpKey (list): List of NTP authentication keys
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "ntp-keys/ntp-key"
// Path from root: "/system/ntp/ntp-keys/ntp-key"
// KeyId: uint16
func (n *System_NtpPathAny) NtpKey(KeyId uint16) *System_Ntp_NtpKeyPathAny {
	return &System_Ntp_NtpKeyPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ntp-keys", "ntp-key"},
			map[string]interface{}{"key-id": KeyId},
			n,
		),
	}
}

// NtpSourceAddress (leaf): Source address to use on outgoing NTP packets
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/ntp-source-address"
// Path from root: "/system/ntp/config/ntp-source-address"
func (n *System_NtpPath) NtpSourceAddress() *System_Ntp_NtpSourceAddressPath {
	return &System_Ntp_NtpSourceAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ntp-source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// NtpSourceAddress (leaf): Source address to use on outgoing NTP packets
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/ntp-source-address"
// Path from root: "/system/ntp/config/ntp-source-address"
func (n *System_NtpPathAny) NtpSourceAddress() *System_Ntp_NtpSourceAddressPathAny {
	return &System_Ntp_NtpSourceAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "ntp-source-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ServerAny (list): List of NTP servers to use for system clock
// synchronization.  If '/system/ntp/enabled'
// is 'true', then the system will attempt to
// contact and utilize the specified NTP servers.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/ntp/servers/server"
// Address (wildcarded): string
func (n *System_NtpPath) ServerAny() *System_Ntp_ServerPathAny {
	return &System_Ntp_ServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// ServerAny (list): List of NTP servers to use for system clock
// synchronization.  If '/system/ntp/enabled'
// is 'true', then the system will attempt to
// contact and utilize the specified NTP servers.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/ntp/servers/server"
// Address (wildcarded): string
func (n *System_NtpPathAny) ServerAny() *System_Ntp_ServerPathAny {
	return &System_Ntp_ServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": "*"},
			n,
		),
	}
}

// Server (list): List of NTP servers to use for system clock
// synchronization.  If '/system/ntp/enabled'
// is 'true', then the system will attempt to
// contact and utilize the specified NTP servers.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/ntp/servers/server"
// Address: string
func (n *System_NtpPath) Server(Address string) *System_Ntp_ServerPath {
	return &System_Ntp_ServerPath{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// Server (list): List of NTP servers to use for system clock
// synchronization.  If '/system/ntp/enabled'
// is 'true', then the system will attempt to
// contact and utilize the specified NTP servers.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "servers/server"
// Path from root: "/system/ntp/servers/server"
// Address: string
func (n *System_NtpPathAny) Server(Address string) *System_Ntp_ServerPathAny {
	return &System_Ntp_ServerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"servers", "server"},
			map[string]interface{}{"address": Address},
			n,
		),
	}
}

// System_Ntp_NtpKeyPath represents the /openconfig-system/system/ntp/ntp-keys/ntp-key YANG schema element.
type System_Ntp_NtpKeyPath struct {
	*ygot.NodePath
}

// System_Ntp_NtpKeyPathAny represents the wildcard version of the /openconfig-system/system/ntp/ntp-keys/ntp-key YANG schema element.
type System_Ntp_NtpKeyPathAny struct {
	*ygot.NodePath
}

// System_Ntp_NtpKey_KeyIdPath represents the /openconfig-system/system/ntp/ntp-keys/ntp-key/config/key-id YANG schema element.
type System_Ntp_NtpKey_KeyIdPath struct {
	*ygot.NodePath
}

// System_Ntp_NtpKey_KeyIdPathAny represents the wildcard version of the /openconfig-system/system/ntp/ntp-keys/ntp-key/config/key-id YANG schema element.
type System_Ntp_NtpKey_KeyIdPathAny struct {
	*ygot.NodePath
}

// System_Ntp_NtpKey_KeyTypePath represents the /openconfig-system/system/ntp/ntp-keys/ntp-key/config/key-type YANG schema element.
type System_Ntp_NtpKey_KeyTypePath struct {
	*ygot.NodePath
}

// System_Ntp_NtpKey_KeyTypePathAny represents the wildcard version of the /openconfig-system/system/ntp/ntp-keys/ntp-key/config/key-type YANG schema element.
type System_Ntp_NtpKey_KeyTypePathAny struct {
	*ygot.NodePath
}

// System_Ntp_NtpKey_KeyValuePath represents the /openconfig-system/system/ntp/ntp-keys/ntp-key/config/key-value YANG schema element.
type System_Ntp_NtpKey_KeyValuePath struct {
	*ygot.NodePath
}

// System_Ntp_NtpKey_KeyValuePathAny represents the wildcard version of the /openconfig-system/system/ntp/ntp-keys/ntp-key/config/key-value YANG schema element.
type System_Ntp_NtpKey_KeyValuePathAny struct {
	*ygot.NodePath
}

// KeyId (leaf): Integer identifier used by the client and server to
// designate a secret key.  The client and server must use
// the same key id.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/key-id"
// Path from root: "/system/ntp/ntp-keys/ntp-key/config/key-id"
func (n *System_Ntp_NtpKeyPath) KeyId() *System_Ntp_NtpKey_KeyIdPath {
	return &System_Ntp_NtpKey_KeyIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "key-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeyId (leaf): Integer identifier used by the client and server to
// designate a secret key.  The client and server must use
// the same key id.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/key-id"
// Path from root: "/system/ntp/ntp-keys/ntp-key/config/key-id"
func (n *System_Ntp_NtpKeyPathAny) KeyId() *System_Ntp_NtpKey_KeyIdPathAny {
	return &System_Ntp_NtpKey_KeyIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "key-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeyType (leaf): Encryption type used for the NTP authentication key
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/key-type"
// Path from root: "/system/ntp/ntp-keys/ntp-key/config/key-type"
func (n *System_Ntp_NtpKeyPath) KeyType() *System_Ntp_NtpKey_KeyTypePath {
	return &System_Ntp_NtpKey_KeyTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "key-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeyType (leaf): Encryption type used for the NTP authentication key
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/key-type"
// Path from root: "/system/ntp/ntp-keys/ntp-key/config/key-type"
func (n *System_Ntp_NtpKeyPathAny) KeyType() *System_Ntp_NtpKey_KeyTypePathAny {
	return &System_Ntp_NtpKey_KeyTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "key-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeyValue (leaf): NTP authentication key value
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/key-value"
// Path from root: "/system/ntp/ntp-keys/ntp-key/config/key-value"
func (n *System_Ntp_NtpKeyPath) KeyValue() *System_Ntp_NtpKey_KeyValuePath {
	return &System_Ntp_NtpKey_KeyValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "key-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// KeyValue (leaf): NTP authentication key value
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/key-value"
// Path from root: "/system/ntp/ntp-keys/ntp-key/config/key-value"
func (n *System_Ntp_NtpKeyPathAny) KeyValue() *System_Ntp_NtpKey_KeyValuePathAny {
	return &System_Ntp_NtpKey_KeyValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "key-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_Ntp_ServerPath represents the /openconfig-system/system/ntp/servers/server YANG schema element.
type System_Ntp_ServerPath struct {
	*ygot.NodePath
}

// System_Ntp_ServerPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server YANG schema element.
type System_Ntp_ServerPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_AddressPath represents the /openconfig-system/system/ntp/servers/server/config/address YANG schema element.
type System_Ntp_Server_AddressPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_AddressPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/config/address YANG schema element.
type System_Ntp_Server_AddressPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_AssociationTypePath represents the /openconfig-system/system/ntp/servers/server/config/association-type YANG schema element.
type System_Ntp_Server_AssociationTypePath struct {
	*ygot.NodePath
}

// System_Ntp_Server_AssociationTypePathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/config/association-type YANG schema element.
type System_Ntp_Server_AssociationTypePathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_IburstPath represents the /openconfig-system/system/ntp/servers/server/config/iburst YANG schema element.
type System_Ntp_Server_IburstPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_IburstPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/config/iburst YANG schema element.
type System_Ntp_Server_IburstPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_OffsetPath represents the /openconfig-system/system/ntp/servers/server/state/offset YANG schema element.
type System_Ntp_Server_OffsetPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_OffsetPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/state/offset YANG schema element.
type System_Ntp_Server_OffsetPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_PollIntervalPath represents the /openconfig-system/system/ntp/servers/server/state/poll-interval YANG schema element.
type System_Ntp_Server_PollIntervalPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_PollIntervalPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/state/poll-interval YANG schema element.
type System_Ntp_Server_PollIntervalPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_PortPath represents the /openconfig-system/system/ntp/servers/server/config/port YANG schema element.
type System_Ntp_Server_PortPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_PortPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/config/port YANG schema element.
type System_Ntp_Server_PortPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_PreferPath represents the /openconfig-system/system/ntp/servers/server/config/prefer YANG schema element.
type System_Ntp_Server_PreferPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_PreferPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/config/prefer YANG schema element.
type System_Ntp_Server_PreferPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_RootDelayPath represents the /openconfig-system/system/ntp/servers/server/state/root-delay YANG schema element.
type System_Ntp_Server_RootDelayPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_RootDelayPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/state/root-delay YANG schema element.
type System_Ntp_Server_RootDelayPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_RootDispersionPath represents the /openconfig-system/system/ntp/servers/server/state/root-dispersion YANG schema element.
type System_Ntp_Server_RootDispersionPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_RootDispersionPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/state/root-dispersion YANG schema element.
type System_Ntp_Server_RootDispersionPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_StratumPath represents the /openconfig-system/system/ntp/servers/server/state/stratum YANG schema element.
type System_Ntp_Server_StratumPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_StratumPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/state/stratum YANG schema element.
type System_Ntp_Server_StratumPathAny struct {
	*ygot.NodePath
}

// System_Ntp_Server_VersionPath represents the /openconfig-system/system/ntp/servers/server/config/version YANG schema element.
type System_Ntp_Server_VersionPath struct {
	*ygot.NodePath
}

// System_Ntp_Server_VersionPathAny represents the wildcard version of the /openconfig-system/system/ntp/servers/server/config/version YANG schema element.
type System_Ntp_Server_VersionPathAny struct {
	*ygot.NodePath
}

// Address (leaf): The address or hostname of the NTP server.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/address"
// Path from root: "/system/ntp/servers/server/config/address"
func (n *System_Ntp_ServerPath) Address() *System_Ntp_Server_AddressPath {
	return &System_Ntp_Server_AddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// Address (leaf): The address or hostname of the NTP server.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/address"
// Path from root: "/system/ntp/servers/server/config/address"
func (n *System_Ntp_ServerPathAny) Address() *System_Ntp_Server_AddressPathAny {
	return &System_Ntp_Server_AddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "address"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssociationType (leaf): The desired association type for this NTP server.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/association-type"
// Path from root: "/system/ntp/servers/server/config/association-type"
func (n *System_Ntp_ServerPath) AssociationType() *System_Ntp_Server_AssociationTypePath {
	return &System_Ntp_Server_AssociationTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "association-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssociationType (leaf): The desired association type for this NTP server.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/association-type"
// Path from root: "/system/ntp/servers/server/config/association-type"
func (n *System_Ntp_ServerPathAny) AssociationType() *System_Ntp_Server_AssociationTypePathAny {
	return &System_Ntp_Server_AssociationTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "association-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Iburst (leaf): Indicates whether this server should enable burst
// synchronization or not.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/iburst"
// Path from root: "/system/ntp/servers/server/config/iburst"
func (n *System_Ntp_ServerPath) Iburst() *System_Ntp_Server_IburstPath {
	return &System_Ntp_Server_IburstPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "iburst"},
			map[string]interface{}{},
			n,
		),
	}
}

// Iburst (leaf): Indicates whether this server should enable burst
// synchronization or not.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/iburst"
// Path from root: "/system/ntp/servers/server/config/iburst"
func (n *System_Ntp_ServerPathAny) Iburst() *System_Ntp_Server_IburstPathAny {
	return &System_Ntp_Server_IburstPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "iburst"},
			map[string]interface{}{},
			n,
		),
	}
}

// Offset (leaf): Estimate of the current time offset from the peer.  This is
// the time difference between the local and reference clock.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/offset"
// Path from root: "/system/ntp/servers/server/state/offset"
func (n *System_Ntp_ServerPath) Offset() *System_Ntp_Server_OffsetPath {
	return &System_Ntp_Server_OffsetPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "offset"},
			map[string]interface{}{},
			n,
		),
	}
}

// Offset (leaf): Estimate of the current time offset from the peer.  This is
// the time difference between the local and reference clock.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/offset"
// Path from root: "/system/ntp/servers/server/state/offset"
func (n *System_Ntp_ServerPathAny) Offset() *System_Ntp_Server_OffsetPathAny {
	return &System_Ntp_Server_OffsetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "offset"},
			map[string]interface{}{},
			n,
		),
	}
}

// PollInterval (leaf): Polling interval of the peer
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/poll-interval"
// Path from root: "/system/ntp/servers/server/state/poll-interval"
func (n *System_Ntp_ServerPath) PollInterval() *System_Ntp_Server_PollIntervalPath {
	return &System_Ntp_Server_PollIntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "poll-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// PollInterval (leaf): Polling interval of the peer
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/poll-interval"
// Path from root: "/system/ntp/servers/server/state/poll-interval"
func (n *System_Ntp_ServerPathAny) PollInterval() *System_Ntp_Server_PollIntervalPathAny {
	return &System_Ntp_Server_PollIntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "poll-interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Port (leaf): The port number of the NTP server.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/port"
// Path from root: "/system/ntp/servers/server/config/port"
func (n *System_Ntp_ServerPath) Port() *System_Ntp_Server_PortPath {
	return &System_Ntp_Server_PortPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port"},
			map[string]interface{}{},
			n,
		),
	}
}

// Port (leaf): The port number of the NTP server.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/port"
// Path from root: "/system/ntp/servers/server/config/port"
func (n *System_Ntp_ServerPathAny) Port() *System_Ntp_Server_PortPathAny {
	return &System_Ntp_Server_PortPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "port"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefer (leaf): Indicates whether this server should be preferred
// or not.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/prefer"
// Path from root: "/system/ntp/servers/server/config/prefer"
func (n *System_Ntp_ServerPath) Prefer() *System_Ntp_Server_PreferPath {
	return &System_Ntp_Server_PreferPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefer"},
			map[string]interface{}{},
			n,
		),
	}
}

// Prefer (leaf): Indicates whether this server should be preferred
// or not.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/prefer"
// Path from root: "/system/ntp/servers/server/config/prefer"
func (n *System_Ntp_ServerPathAny) Prefer() *System_Ntp_Server_PreferPathAny {
	return &System_Ntp_Server_PreferPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "prefer"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootDelay (leaf): The round-trip delay to the server, in milliseconds.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/root-delay"
// Path from root: "/system/ntp/servers/server/state/root-delay"
func (n *System_Ntp_ServerPath) RootDelay() *System_Ntp_Server_RootDelayPath {
	return &System_Ntp_Server_RootDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootDelay (leaf): The round-trip delay to the server, in milliseconds.
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/root-delay"
// Path from root: "/system/ntp/servers/server/state/root-delay"
func (n *System_Ntp_ServerPathAny) RootDelay() *System_Ntp_Server_RootDelayPathAny {
	return &System_Ntp_Server_RootDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootDispersion (leaf): Dispersion (epsilon) represents the maximum error inherent
// in the measurement
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/root-dispersion"
// Path from root: "/system/ntp/servers/server/state/root-dispersion"
func (n *System_Ntp_ServerPath) RootDispersion() *System_Ntp_Server_RootDispersionPath {
	return &System_Ntp_Server_RootDispersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-dispersion"},
			map[string]interface{}{},
			n,
		),
	}
}

// RootDispersion (leaf): Dispersion (epsilon) represents the maximum error inherent
// in the measurement
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/root-dispersion"
// Path from root: "/system/ntp/servers/server/state/root-dispersion"
func (n *System_Ntp_ServerPathAny) RootDispersion() *System_Ntp_Server_RootDispersionPathAny {
	return &System_Ntp_Server_RootDispersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "root-dispersion"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stratum (leaf): Indicates the level of the server in the NTP hierarchy. As
// stratum number increases, the accuracy is degraded.  Primary
// servers are stratum while a maximum value of 16 indicates
// unsynchronized.  The values have the following specific
// semantics:
//
// | 0      | unspecified or invalid
// | 1      | primary server (e.g., equipped with a GPS receiver)
// | 2-15   | secondary server (via NTP)
// | 16     | unsynchronized
// | 17-255 | reserved
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/stratum"
// Path from root: "/system/ntp/servers/server/state/stratum"
func (n *System_Ntp_ServerPath) Stratum() *System_Ntp_Server_StratumPath {
	return &System_Ntp_Server_StratumPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "stratum"},
			map[string]interface{}{},
			n,
		),
	}
}

// Stratum (leaf): Indicates the level of the server in the NTP hierarchy. As
// stratum number increases, the accuracy is degraded.  Primary
// servers are stratum while a maximum value of 16 indicates
// unsynchronized.  The values have the following specific
// semantics:
//
// | 0      | unspecified or invalid
// | 1      | primary server (e.g., equipped with a GPS receiver)
// | 2-15   | secondary server (via NTP)
// | 16     | unsynchronized
// | 17-255 | reserved
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "state/stratum"
// Path from root: "/system/ntp/servers/server/state/stratum"
func (n *System_Ntp_ServerPathAny) Stratum() *System_Ntp_Server_StratumPathAny {
	return &System_Ntp_Server_StratumPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "stratum"},
			map[string]interface{}{},
			n,
		),
	}
}

// Version (leaf): Version number to put in outgoing NTP packets
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/version"
// Path from root: "/system/ntp/servers/server/config/version"
func (n *System_Ntp_ServerPath) Version() *System_Ntp_Server_VersionPath {
	return &System_Ntp_Server_VersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "version"},
			map[string]interface{}{},
			n,
		),
	}
}

// Version (leaf): Version number to put in outgoing NTP packets
// ----------------------------------------
// Defining module: "openconfig-system"
// Instantiating module: "openconfig-system"
// Path from parent: "config/version"
// Path from root: "/system/ntp/servers/server/config/version"
func (n *System_Ntp_ServerPathAny) Version() *System_Ntp_Server_VersionPathAny {
	return &System_Ntp_Server_VersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "version"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_ProcessPath represents the /openconfig-system/system/processes/process YANG schema element.
type System_ProcessPath struct {
	*ygot.NodePath
}

// System_ProcessPathAny represents the wildcard version of the /openconfig-system/system/processes/process YANG schema element.
type System_ProcessPathAny struct {
	*ygot.NodePath
}

// System_Process_ArgsPath represents the /openconfig-system/system/processes/process/state/args YANG schema element.
type System_Process_ArgsPath struct {
	*ygot.NodePath
}

// System_Process_ArgsPathAny represents the wildcard version of the /openconfig-system/system/processes/process/state/args YANG schema element.
type System_Process_ArgsPathAny struct {
	*ygot.NodePath
}

// System_Process_CpuUsageSystemPath represents the /openconfig-system/system/processes/process/state/cpu-usage-system YANG schema element.
type System_Process_CpuUsageSystemPath struct {
	*ygot.NodePath
}

// System_Process_CpuUsageSystemPathAny represents the wildcard version of the /openconfig-system/system/processes/process/state/cpu-usage-system YANG schema element.
type System_Process_CpuUsageSystemPathAny struct {
	*ygot.NodePath
}

// System_Process_CpuUsageUserPath represents the /openconfig-system/system/processes/process/state/cpu-usage-user YANG schema element.
type System_Process_CpuUsageUserPath struct {
	*ygot.NodePath
}

// System_Process_CpuUsageUserPathAny represents the wildcard version of the /openconfig-system/system/processes/process/state/cpu-usage-user YANG schema element.
type System_Process_CpuUsageUserPathAny struct {
	*ygot.NodePath
}

// System_Process_CpuUtilizationPath represents the /openconfig-system/system/processes/process/state/cpu-utilization YANG schema element.
type System_Process_CpuUtilizationPath struct {
	*ygot.NodePath
}

// System_Process_CpuUtilizationPathAny represents the wildcard version of the /openconfig-system/system/processes/process/state/cpu-utilization YANG schema element.
type System_Process_CpuUtilizationPathAny struct {
	*ygot.NodePath
}

// System_Process_MemoryUsagePath represents the /openconfig-system/system/processes/process/state/memory-usage YANG schema element.
type System_Process_MemoryUsagePath struct {
	*ygot.NodePath
}

// System_Process_MemoryUsagePathAny represents the wildcard version of the /openconfig-system/system/processes/process/state/memory-usage YANG schema element.
type System_Process_MemoryUsagePathAny struct {
	*ygot.NodePath
}

// System_Process_MemoryUtilizationPath represents the /openconfig-system/system/processes/process/state/memory-utilization YANG schema element.
type System_Process_MemoryUtilizationPath struct {
	*ygot.NodePath
}

// System_Process_MemoryUtilizationPathAny represents the wildcard version of the /openconfig-system/system/processes/process/state/memory-utilization YANG schema element.
type System_Process_MemoryUtilizationPathAny struct {
	*ygot.NodePath
}

// System_Process_NamePath represents the /openconfig-system/system/processes/process/state/name YANG schema element.
type System_Process_NamePath struct {
	*ygot.NodePath
}

// System_Process_NamePathAny represents the wildcard version of the /openconfig-system/system/processes/process/state/name YANG schema element.
type System_Process_NamePathAny struct {
	*ygot.NodePath
}

// System_Process_PidPath represents the /openconfig-system/system/processes/process/state/pid YANG schema element.
type System_Process_PidPath struct {
	*ygot.NodePath
}

// System_Process_PidPathAny represents the wildcard version of the /openconfig-system/system/processes/process/state/pid YANG schema element.
type System_Process_PidPathAny struct {
	*ygot.NodePath
}

// System_Process_StartTimePath represents the /openconfig-system/system/processes/process/state/start-time YANG schema element.
type System_Process_StartTimePath struct {
	*ygot.NodePath
}

// System_Process_StartTimePathAny represents the wildcard version of the /openconfig-system/system/processes/process/state/start-time YANG schema element.
type System_Process_StartTimePathAny struct {
	*ygot.NodePath
}

// Args (leaf): Current process command line arguments.  Arguments with
// a parameter (e.g., --option 10  or -option=10) should be
// represented as a single element of the list with the
// argument name and parameter together.  Flag arguments, i.e.,
// those without a parameter should also be in their own list
// element.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/args"
// Path from root: "/system/processes/process/state/args"
func (n *System_ProcessPath) Args() *System_Process_ArgsPath {
	return &System_Process_ArgsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "args"},
			map[string]interface{}{},
			n,
		),
	}
}

// Args (leaf): Current process command line arguments.  Arguments with
// a parameter (e.g., --option 10  or -option=10) should be
// represented as a single element of the list with the
// argument name and parameter together.  Flag arguments, i.e.,
// those without a parameter should also be in their own list
// element.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/args"
// Path from root: "/system/processes/process/state/args"
func (n *System_ProcessPathAny) Args() *System_Process_ArgsPathAny {
	return &System_Process_ArgsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "args"},
			map[string]interface{}{},
			n,
		),
	}
}

// CpuUsageSystem (leaf): CPU time consumed by this process in kernel mode.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/cpu-usage-system"
// Path from root: "/system/processes/process/state/cpu-usage-system"
func (n *System_ProcessPath) CpuUsageSystem() *System_Process_CpuUsageSystemPath {
	return &System_Process_CpuUsageSystemPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu-usage-system"},
			map[string]interface{}{},
			n,
		),
	}
}

// CpuUsageSystem (leaf): CPU time consumed by this process in kernel mode.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/cpu-usage-system"
// Path from root: "/system/processes/process/state/cpu-usage-system"
func (n *System_ProcessPathAny) CpuUsageSystem() *System_Process_CpuUsageSystemPathAny {
	return &System_Process_CpuUsageSystemPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu-usage-system"},
			map[string]interface{}{},
			n,
		),
	}
}

// CpuUsageUser (leaf): CPU time consumed by this process in user mode in
// nanoseconds.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/cpu-usage-user"
// Path from root: "/system/processes/process/state/cpu-usage-user"
func (n *System_ProcessPath) CpuUsageUser() *System_Process_CpuUsageUserPath {
	return &System_Process_CpuUsageUserPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu-usage-user"},
			map[string]interface{}{},
			n,
		),
	}
}

// CpuUsageUser (leaf): CPU time consumed by this process in user mode in
// nanoseconds.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/cpu-usage-user"
// Path from root: "/system/processes/process/state/cpu-usage-user"
func (n *System_ProcessPathAny) CpuUsageUser() *System_Process_CpuUsageUserPathAny {
	return &System_Process_CpuUsageUserPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu-usage-user"},
			map[string]interface{}{},
			n,
		),
	}
}

// CpuUtilization (leaf): The percentage of CPU that is being used by the process.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/cpu-utilization"
// Path from root: "/system/processes/process/state/cpu-utilization"
func (n *System_ProcessPath) CpuUtilization() *System_Process_CpuUtilizationPath {
	return &System_Process_CpuUtilizationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu-utilization"},
			map[string]interface{}{},
			n,
		),
	}
}

// CpuUtilization (leaf): The percentage of CPU that is being used by the process.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/cpu-utilization"
// Path from root: "/system/processes/process/state/cpu-utilization"
func (n *System_ProcessPathAny) CpuUtilization() *System_Process_CpuUtilizationPathAny {
	return &System_Process_CpuUtilizationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "cpu-utilization"},
			map[string]interface{}{},
			n,
		),
	}
}

// MemoryUsage (leaf): Bytes allocated and still in use by the process
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/memory-usage"
// Path from root: "/system/processes/process/state/memory-usage"
func (n *System_ProcessPath) MemoryUsage() *System_Process_MemoryUsagePath {
	return &System_Process_MemoryUsagePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "memory-usage"},
			map[string]interface{}{},
			n,
		),
	}
}

// MemoryUsage (leaf): Bytes allocated and still in use by the process
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/memory-usage"
// Path from root: "/system/processes/process/state/memory-usage"
func (n *System_ProcessPathAny) MemoryUsage() *System_Process_MemoryUsagePathAny {
	return &System_Process_MemoryUsagePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "memory-usage"},
			map[string]interface{}{},
			n,
		),
	}
}

// MemoryUtilization (leaf): The percentage of RAM that is being used by the process.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/memory-utilization"
// Path from root: "/system/processes/process/state/memory-utilization"
func (n *System_ProcessPath) MemoryUtilization() *System_Process_MemoryUtilizationPath {
	return &System_Process_MemoryUtilizationPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "memory-utilization"},
			map[string]interface{}{},
			n,
		),
	}
}

// MemoryUtilization (leaf): The percentage of RAM that is being used by the process.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/memory-utilization"
// Path from root: "/system/processes/process/state/memory-utilization"
func (n *System_ProcessPathAny) MemoryUtilization() *System_Process_MemoryUtilizationPathAny {
	return &System_Process_MemoryUtilizationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "memory-utilization"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The process name
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/name"
// Path from root: "/system/processes/process/state/name"
func (n *System_ProcessPath) Name() *System_Process_NamePath {
	return &System_Process_NamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Name (leaf): The process name
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/name"
// Path from root: "/system/processes/process/state/name"
func (n *System_ProcessPathAny) Name() *System_Process_NamePathAny {
	return &System_Process_NamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "name"},
			map[string]interface{}{},
			n,
		),
	}
}

// Pid (leaf): The process pid
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/pid"
// Path from root: "/system/processes/process/state/pid"
func (n *System_ProcessPath) Pid() *System_Process_PidPath {
	return &System_Process_PidPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pid"},
			map[string]interface{}{},
			n,
		),
	}
}

// Pid (leaf): The process pid
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/pid"
// Path from root: "/system/processes/process/state/pid"
func (n *System_ProcessPathAny) Pid() *System_Process_PidPathAny {
	return &System_Process_PidPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pid"},
			map[string]interface{}{},
			n,
		),
	}
}

// StartTime (leaf): The time at which this process started,
// relative to the UNIX epoch.  The system must be
// synchronized such that the start-time can be
// reported accurately, otherwise it should not be reported.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/start-time"
// Path from root: "/system/processes/process/state/start-time"
func (n *System_ProcessPath) StartTime() *System_Process_StartTimePath {
	return &System_Process_StartTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "start-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// StartTime (leaf): The time at which this process started,
// relative to the UNIX epoch.  The system must be
// synchronized such that the start-time can be
// reported accurately, otherwise it should not be reported.
// ----------------------------------------
// Defining module: "openconfig-procmon"
// Instantiating module: "openconfig-system"
// Path from parent: "state/start-time"
// Path from root: "/system/processes/process/state/start-time"
func (n *System_ProcessPathAny) StartTime() *System_Process_StartTimePathAny {
	return &System_Process_StartTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "start-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_SshServerPath represents the /openconfig-system/system/ssh-server YANG schema element.
type System_SshServerPath struct {
	*ygot.NodePath
}

// System_SshServerPathAny represents the wildcard version of the /openconfig-system/system/ssh-server YANG schema element.
type System_SshServerPathAny struct {
	*ygot.NodePath
}

// System_SshServer_EnablePath represents the /openconfig-system/system/ssh-server/config/enable YANG schema element.
type System_SshServer_EnablePath struct {
	*ygot.NodePath
}

// System_SshServer_EnablePathAny represents the wildcard version of the /openconfig-system/system/ssh-server/config/enable YANG schema element.
type System_SshServer_EnablePathAny struct {
	*ygot.NodePath
}

// System_SshServer_ProtocolVersionPath represents the /openconfig-system/system/ssh-server/config/protocol-version YANG schema element.
type System_SshServer_ProtocolVersionPath struct {
	*ygot.NodePath
}

// System_SshServer_ProtocolVersionPathAny represents the wildcard version of the /openconfig-system/system/ssh-server/config/protocol-version YANG schema element.
type System_SshServer_ProtocolVersionPathAny struct {
	*ygot.NodePath
}

// System_SshServer_RateLimitPath represents the /openconfig-system/system/ssh-server/config/rate-limit YANG schema element.
type System_SshServer_RateLimitPath struct {
	*ygot.NodePath
}

// System_SshServer_RateLimitPathAny represents the wildcard version of the /openconfig-system/system/ssh-server/config/rate-limit YANG schema element.
type System_SshServer_RateLimitPathAny struct {
	*ygot.NodePath
}

// System_SshServer_SessionLimitPath represents the /openconfig-system/system/ssh-server/config/session-limit YANG schema element.
type System_SshServer_SessionLimitPath struct {
	*ygot.NodePath
}

// System_SshServer_SessionLimitPathAny represents the wildcard version of the /openconfig-system/system/ssh-server/config/session-limit YANG schema element.
type System_SshServer_SessionLimitPathAny struct {
	*ygot.NodePath
}

// System_SshServer_TimeoutPath represents the /openconfig-system/system/ssh-server/config/timeout YANG schema element.
type System_SshServer_TimeoutPath struct {
	*ygot.NodePath
}

// System_SshServer_TimeoutPathAny represents the wildcard version of the /openconfig-system/system/ssh-server/config/timeout YANG schema element.
type System_SshServer_TimeoutPathAny struct {
	*ygot.NodePath
}

// Enable (leaf): Enables the ssh server.  The ssh server is enabled by
// default.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enable"
// Path from root: "/system/ssh-server/config/enable"
func (n *System_SshServerPath) Enable() *System_SshServer_EnablePath {
	return &System_SshServer_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables the ssh server.  The ssh server is enabled by
// default.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enable"
// Path from root: "/system/ssh-server/config/enable"
func (n *System_SshServerPathAny) Enable() *System_SshServer_EnablePathAny {
	return &System_SshServer_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtocolVersion (leaf): Set the protocol version for SSH connections to the system
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/protocol-version"
// Path from root: "/system/ssh-server/config/protocol-version"
func (n *System_SshServerPath) ProtocolVersion() *System_SshServer_ProtocolVersionPath {
	return &System_SshServer_ProtocolVersionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol-version"},
			map[string]interface{}{},
			n,
		),
	}
}

// ProtocolVersion (leaf): Set the protocol version for SSH connections to the system
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/protocol-version"
// Path from root: "/system/ssh-server/config/protocol-version"
func (n *System_SshServerPathAny) ProtocolVersion() *System_SshServer_ProtocolVersionPathAny {
	return &System_SshServer_ProtocolVersionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "protocol-version"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateLimit (leaf): Set a limit on the number of connection attempts per
// minute to the system for the protocol.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/rate-limit"
// Path from root: "/system/ssh-server/config/rate-limit"
func (n *System_SshServerPath) RateLimit() *System_SshServer_RateLimitPath {
	return &System_SshServer_RateLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "rate-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateLimit (leaf): Set a limit on the number of connection attempts per
// minute to the system for the protocol.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/rate-limit"
// Path from root: "/system/ssh-server/config/rate-limit"
func (n *System_SshServerPathAny) RateLimit() *System_SshServer_RateLimitPathAny {
	return &System_SshServer_RateLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "rate-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionLimit (leaf): Set a limit on the number of simultaneous active terminal
// sessions to the system for the protocol (e.g., ssh,
// telnet, ...)
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/session-limit"
// Path from root: "/system/ssh-server/config/session-limit"
func (n *System_SshServerPath) SessionLimit() *System_SshServer_SessionLimitPath {
	return &System_SshServer_SessionLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "session-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionLimit (leaf): Set a limit on the number of simultaneous active terminal
// sessions to the system for the protocol (e.g., ssh,
// telnet, ...)
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/session-limit"
// Path from root: "/system/ssh-server/config/session-limit"
func (n *System_SshServerPathAny) SessionLimit() *System_SshServer_SessionLimitPathAny {
	return &System_SshServer_SessionLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "session-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): Set the idle timeout in seconds on terminal connections to
// the system for the protocol.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/timeout"
// Path from root: "/system/ssh-server/config/timeout"
func (n *System_SshServerPath) Timeout() *System_SshServer_TimeoutPath {
	return &System_SshServer_TimeoutPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): Set the idle timeout in seconds on terminal connections to
// the system for the protocol.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/timeout"
// Path from root: "/system/ssh-server/config/timeout"
func (n *System_SshServerPathAny) Timeout() *System_SshServer_TimeoutPathAny {
	return &System_SshServer_TimeoutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// System_TelnetServerPath represents the /openconfig-system/system/telnet-server YANG schema element.
type System_TelnetServerPath struct {
	*ygot.NodePath
}

// System_TelnetServerPathAny represents the wildcard version of the /openconfig-system/system/telnet-server YANG schema element.
type System_TelnetServerPathAny struct {
	*ygot.NodePath
}

// System_TelnetServer_EnablePath represents the /openconfig-system/system/telnet-server/config/enable YANG schema element.
type System_TelnetServer_EnablePath struct {
	*ygot.NodePath
}

// System_TelnetServer_EnablePathAny represents the wildcard version of the /openconfig-system/system/telnet-server/config/enable YANG schema element.
type System_TelnetServer_EnablePathAny struct {
	*ygot.NodePath
}

// System_TelnetServer_RateLimitPath represents the /openconfig-system/system/telnet-server/config/rate-limit YANG schema element.
type System_TelnetServer_RateLimitPath struct {
	*ygot.NodePath
}

// System_TelnetServer_RateLimitPathAny represents the wildcard version of the /openconfig-system/system/telnet-server/config/rate-limit YANG schema element.
type System_TelnetServer_RateLimitPathAny struct {
	*ygot.NodePath
}

// System_TelnetServer_SessionLimitPath represents the /openconfig-system/system/telnet-server/config/session-limit YANG schema element.
type System_TelnetServer_SessionLimitPath struct {
	*ygot.NodePath
}

// System_TelnetServer_SessionLimitPathAny represents the wildcard version of the /openconfig-system/system/telnet-server/config/session-limit YANG schema element.
type System_TelnetServer_SessionLimitPathAny struct {
	*ygot.NodePath
}

// System_TelnetServer_TimeoutPath represents the /openconfig-system/system/telnet-server/config/timeout YANG schema element.
type System_TelnetServer_TimeoutPath struct {
	*ygot.NodePath
}

// System_TelnetServer_TimeoutPathAny represents the wildcard version of the /openconfig-system/system/telnet-server/config/timeout YANG schema element.
type System_TelnetServer_TimeoutPathAny struct {
	*ygot.NodePath
}

// Enable (leaf): Enables the telnet server.  Telnet is disabled by
// default
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enable"
// Path from root: "/system/telnet-server/config/enable"
func (n *System_TelnetServerPath) Enable() *System_TelnetServer_EnablePath {
	return &System_TelnetServer_EnablePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enable (leaf): Enables the telnet server.  Telnet is disabled by
// default
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/enable"
// Path from root: "/system/telnet-server/config/enable"
func (n *System_TelnetServerPathAny) Enable() *System_TelnetServer_EnablePathAny {
	return &System_TelnetServer_EnablePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enable"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateLimit (leaf): Set a limit on the number of connection attempts per
// minute to the system for the protocol.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/rate-limit"
// Path from root: "/system/telnet-server/config/rate-limit"
func (n *System_TelnetServerPath) RateLimit() *System_TelnetServer_RateLimitPath {
	return &System_TelnetServer_RateLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "rate-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateLimit (leaf): Set a limit on the number of connection attempts per
// minute to the system for the protocol.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/rate-limit"
// Path from root: "/system/telnet-server/config/rate-limit"
func (n *System_TelnetServerPathAny) RateLimit() *System_TelnetServer_RateLimitPathAny {
	return &System_TelnetServer_RateLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "rate-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionLimit (leaf): Set a limit on the number of simultaneous active terminal
// sessions to the system for the protocol (e.g., ssh,
// telnet, ...)
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/session-limit"
// Path from root: "/system/telnet-server/config/session-limit"
func (n *System_TelnetServerPath) SessionLimit() *System_TelnetServer_SessionLimitPath {
	return &System_TelnetServer_SessionLimitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "session-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// SessionLimit (leaf): Set a limit on the number of simultaneous active terminal
// sessions to the system for the protocol (e.g., ssh,
// telnet, ...)
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/session-limit"
// Path from root: "/system/telnet-server/config/session-limit"
func (n *System_TelnetServerPathAny) SessionLimit() *System_TelnetServer_SessionLimitPathAny {
	return &System_TelnetServer_SessionLimitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "session-limit"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): Set the idle timeout in seconds on terminal connections to
// the system for the protocol.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/timeout"
// Path from root: "/system/telnet-server/config/timeout"
func (n *System_TelnetServerPath) Timeout() *System_TelnetServer_TimeoutPath {
	return &System_TelnetServer_TimeoutPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// Timeout (leaf): Set the idle timeout in seconds on terminal connections to
// the system for the protocol.
// ----------------------------------------
// Defining module: "openconfig-system-terminal"
// Instantiating module: "openconfig-system"
// Path from parent: "config/timeout"
// Path from root: "/system/telnet-server/config/timeout"
func (n *System_TelnetServerPathAny) Timeout() *System_TelnetServer_TimeoutPathAny {
	return &System_TelnetServer_TimeoutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "timeout"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevicePath represents the /openconfig-terminal-device/terminal-device YANG schema element.
type TerminalDevicePath struct {
	*ygot.NodePath
}

// TerminalDevicePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device YANG schema element.
type TerminalDevicePathAny struct {
	*ygot.NodePath
}

// ChannelAny (list): List of logical channels
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "logical-channels/channel"
// Path from root: "/terminal-device/logical-channels/channel"
// Index (wildcarded): uint32
func (n *TerminalDevicePath) ChannelAny() *TerminalDevice_ChannelPathAny {
	return &TerminalDevice_ChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"logical-channels", "channel"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// ChannelAny (list): List of logical channels
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "logical-channels/channel"
// Path from root: "/terminal-device/logical-channels/channel"
// Index (wildcarded): uint32
func (n *TerminalDevicePathAny) ChannelAny() *TerminalDevice_ChannelPathAny {
	return &TerminalDevice_ChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"logical-channels", "channel"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// Channel (list): List of logical channels
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "logical-channels/channel"
// Path from root: "/terminal-device/logical-channels/channel"
// Index: uint32
func (n *TerminalDevicePath) Channel(Index uint32) *TerminalDevice_ChannelPath {
	return &TerminalDevice_ChannelPath{
		NodePath: ygot.NewNodePath(
			[]string{"logical-channels", "channel"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Channel (list): List of logical channels
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "logical-channels/channel"
// Path from root: "/terminal-device/logical-channels/channel"
// Index: uint32
func (n *TerminalDevicePathAny) Channel(Index uint32) *TerminalDevice_ChannelPathAny {
	return &TerminalDevice_ChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"logical-channels", "channel"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// ModeAny (list): List of operational modes supported by the platform.
// The operational mode provides a platform-defined summary
// of information such as symbol rate, modulation, pulse
// shaping, etc.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "operational-modes/mode"
// Path from root: "/terminal-device/operational-modes/mode"
// ModeId (wildcarded): uint16
func (n *TerminalDevicePath) ModeAny() *TerminalDevice_ModePathAny {
	return &TerminalDevice_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"operational-modes", "mode"},
			map[string]interface{}{"mode-id": "*"},
			n,
		),
	}
}

// ModeAny (list): List of operational modes supported by the platform.
// The operational mode provides a platform-defined summary
// of information such as symbol rate, modulation, pulse
// shaping, etc.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "operational-modes/mode"
// Path from root: "/terminal-device/operational-modes/mode"
// ModeId (wildcarded): uint16
func (n *TerminalDevicePathAny) ModeAny() *TerminalDevice_ModePathAny {
	return &TerminalDevice_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"operational-modes", "mode"},
			map[string]interface{}{"mode-id": "*"},
			n,
		),
	}
}

// Mode (list): List of operational modes supported by the platform.
// The operational mode provides a platform-defined summary
// of information such as symbol rate, modulation, pulse
// shaping, etc.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "operational-modes/mode"
// Path from root: "/terminal-device/operational-modes/mode"
// ModeId: uint16
func (n *TerminalDevicePath) Mode(ModeId uint16) *TerminalDevice_ModePath {
	return &TerminalDevice_ModePath{
		NodePath: ygot.NewNodePath(
			[]string{"operational-modes", "mode"},
			map[string]interface{}{"mode-id": ModeId},
			n,
		),
	}
}

// Mode (list): List of operational modes supported by the platform.
// The operational mode provides a platform-defined summary
// of information such as symbol rate, modulation, pulse
// shaping, etc.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "operational-modes/mode"
// Path from root: "/terminal-device/operational-modes/mode"
// ModeId: uint16
func (n *TerminalDevicePathAny) Mode(ModeId uint16) *TerminalDevice_ModePathAny {
	return &TerminalDevice_ModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"operational-modes", "mode"},
			map[string]interface{}{"mode-id": ModeId},
			n,
		),
	}
}

// TerminalDevice_ChannelPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel YANG schema element.
type TerminalDevice_ChannelPath struct {
	*ygot.NodePath
}

// TerminalDevice_ChannelPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel YANG schema element.
type TerminalDevice_ChannelPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_AdminStatePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/admin-state YANG schema element.
type TerminalDevice_Channel_AdminStatePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_AdminStatePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/admin-state YANG schema element.
type TerminalDevice_Channel_AdminStatePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_ClientMappingModePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/client-mapping-mode YANG schema element.
type TerminalDevice_Channel_ClientMappingModePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_ClientMappingModePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/client-mapping-mode YANG schema element.
type TerminalDevice_Channel_ClientMappingModePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_DescriptionPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/description YANG schema element.
type TerminalDevice_Channel_DescriptionPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_DescriptionPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/description YANG schema element.
type TerminalDevice_Channel_DescriptionPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_IndexPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/index YANG schema element.
type TerminalDevice_Channel_IndexPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_IndexPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/index YANG schema element.
type TerminalDevice_Channel_IndexPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_LinkStatePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/state/link-state YANG schema element.
type TerminalDevice_Channel_LinkStatePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_LinkStatePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/state/link-state YANG schema element.
type TerminalDevice_Channel_LinkStatePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_LogicalChannelTypePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/logical-channel-type YANG schema element.
type TerminalDevice_Channel_LogicalChannelTypePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_LogicalChannelTypePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/logical-channel-type YANG schema element.
type TerminalDevice_Channel_LogicalChannelTypePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_LoopbackModePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/loopback-mode YANG schema element.
type TerminalDevice_Channel_LoopbackModePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_LoopbackModePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/loopback-mode YANG schema element.
type TerminalDevice_Channel_LoopbackModePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_RateClassPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/rate-class YANG schema element.
type TerminalDevice_Channel_RateClassPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_RateClassPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/rate-class YANG schema element.
type TerminalDevice_Channel_RateClassPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_TestSignalPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/test-signal YANG schema element.
type TerminalDevice_Channel_TestSignalPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_TestSignalPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/test-signal YANG schema element.
type TerminalDevice_Channel_TestSignalPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_TribProtocolPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/trib-protocol YANG schema element.
type TerminalDevice_Channel_TribProtocolPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_TribProtocolPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/config/trib-protocol YANG schema element.
type TerminalDevice_Channel_TribProtocolPathAny struct {
	*ygot.NodePath
}

// AdminState (leaf): Sets the admin state of the logical channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/admin-state"
// Path from root: "/terminal-device/logical-channels/channel/config/admin-state"
func (n *TerminalDevice_ChannelPath) AdminState() *TerminalDevice_Channel_AdminStatePath {
	return &TerminalDevice_Channel_AdminStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// AdminState (leaf): Sets the admin state of the logical channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/admin-state"
// Path from root: "/terminal-device/logical-channels/channel/config/admin-state"
func (n *TerminalDevice_ChannelPathAny) AdminState() *TerminalDevice_Channel_AdminStatePathAny {
	return &TerminalDevice_Channel_AdminStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "admin-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssignmentAny (list): Logical channel elements may be assigned directly to
// optical channels for line-side transmission, or can be
// further groomed into additional stages of logical channel
// elements.  The grooming can multiplex (i.e., split the
// current element into multiple elements in the subsequent
// stage) or de-multiplex (i.e., combine the current element
// with other elements into the same element in the subsequent
// stage) logical elements in each stage.
//
// Note that to support the ability to groom the logical
// elements, the list of logical channel elements should be
// populated with an entry for the logical elements at
// each stage, starting with the initial assignment from the
// respective client physical port.
//
// Each logical element assignment consists of a pointer to
// an element in the next stage, or to an optical channel,
// along with a bandwidth allocation for the corresponding
// assignment (e.g., to split or combine signal).
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "logical-channel-assignments/assignment"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment"
// Index (wildcarded): uint32
func (n *TerminalDevice_ChannelPath) AssignmentAny() *TerminalDevice_Channel_AssignmentPathAny {
	return &TerminalDevice_Channel_AssignmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"logical-channel-assignments", "assignment"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// AssignmentAny (list): Logical channel elements may be assigned directly to
// optical channels for line-side transmission, or can be
// further groomed into additional stages of logical channel
// elements.  The grooming can multiplex (i.e., split the
// current element into multiple elements in the subsequent
// stage) or de-multiplex (i.e., combine the current element
// with other elements into the same element in the subsequent
// stage) logical elements in each stage.
//
// Note that to support the ability to groom the logical
// elements, the list of logical channel elements should be
// populated with an entry for the logical elements at
// each stage, starting with the initial assignment from the
// respective client physical port.
//
// Each logical element assignment consists of a pointer to
// an element in the next stage, or to an optical channel,
// along with a bandwidth allocation for the corresponding
// assignment (e.g., to split or combine signal).
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "logical-channel-assignments/assignment"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment"
// Index (wildcarded): uint32
func (n *TerminalDevice_ChannelPathAny) AssignmentAny() *TerminalDevice_Channel_AssignmentPathAny {
	return &TerminalDevice_Channel_AssignmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"logical-channel-assignments", "assignment"},
			map[string]interface{}{"index": "*"},
			n,
		),
	}
}

// Assignment (list): Logical channel elements may be assigned directly to
// optical channels for line-side transmission, or can be
// further groomed into additional stages of logical channel
// elements.  The grooming can multiplex (i.e., split the
// current element into multiple elements in the subsequent
// stage) or de-multiplex (i.e., combine the current element
// with other elements into the same element in the subsequent
// stage) logical elements in each stage.
//
// Note that to support the ability to groom the logical
// elements, the list of logical channel elements should be
// populated with an entry for the logical elements at
// each stage, starting with the initial assignment from the
// respective client physical port.
//
// Each logical element assignment consists of a pointer to
// an element in the next stage, or to an optical channel,
// along with a bandwidth allocation for the corresponding
// assignment (e.g., to split or combine signal).
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "logical-channel-assignments/assignment"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment"
// Index: uint32
func (n *TerminalDevice_ChannelPath) Assignment(Index uint32) *TerminalDevice_Channel_AssignmentPath {
	return &TerminalDevice_Channel_AssignmentPath{
		NodePath: ygot.NewNodePath(
			[]string{"logical-channel-assignments", "assignment"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// Assignment (list): Logical channel elements may be assigned directly to
// optical channels for line-side transmission, or can be
// further groomed into additional stages of logical channel
// elements.  The grooming can multiplex (i.e., split the
// current element into multiple elements in the subsequent
// stage) or de-multiplex (i.e., combine the current element
// with other elements into the same element in the subsequent
// stage) logical elements in each stage.
//
// Note that to support the ability to groom the logical
// elements, the list of logical channel elements should be
// populated with an entry for the logical elements at
// each stage, starting with the initial assignment from the
// respective client physical port.
//
// Each logical element assignment consists of a pointer to
// an element in the next stage, or to an optical channel,
// along with a bandwidth allocation for the corresponding
// assignment (e.g., to split or combine signal).
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "logical-channel-assignments/assignment"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment"
// Index: uint32
func (n *TerminalDevice_ChannelPathAny) Assignment(Index uint32) *TerminalDevice_Channel_AssignmentPathAny {
	return &TerminalDevice_Channel_AssignmentPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"logical-channel-assignments", "assignment"},
			map[string]interface{}{"index": Index},
			n,
		),
	}
}

// ClientMappingMode (leaf): The client side mapping mode internal to the device that
// specifies the number of client electrical interfaces and
// the data rate of each client electrical interface. For
// example, a ZR+ transceiver with an optical line rate of 400G
// could be configured to break out into four 100G client
// signals which might connect to an interface or a
// physical-channel. This would be configured on the aggregate
// logical channel as MODE_4X100G. This is only valid on the
// aggregate logical channel that is connected directly to the
// optical-channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/client-mapping-mode"
// Path from root: "/terminal-device/logical-channels/channel/config/client-mapping-mode"
func (n *TerminalDevice_ChannelPath) ClientMappingMode() *TerminalDevice_Channel_ClientMappingModePath {
	return &TerminalDevice_Channel_ClientMappingModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "client-mapping-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// ClientMappingMode (leaf): The client side mapping mode internal to the device that
// specifies the number of client electrical interfaces and
// the data rate of each client electrical interface. For
// example, a ZR+ transceiver with an optical line rate of 400G
// could be configured to break out into four 100G client
// signals which might connect to an interface or a
// physical-channel. This would be configured on the aggregate
// logical channel as MODE_4X100G. This is only valid on the
// aggregate logical channel that is connected directly to the
// optical-channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/client-mapping-mode"
// Path from root: "/terminal-device/logical-channels/channel/config/client-mapping-mode"
func (n *TerminalDevice_ChannelPathAny) ClientMappingMode() *TerminalDevice_Channel_ClientMappingModePathAny {
	return &TerminalDevice_Channel_ClientMappingModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "client-mapping-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): Description of the logical channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/description"
// Path from root: "/terminal-device/logical-channels/channel/config/description"
func (n *TerminalDevice_ChannelPath) Description() *TerminalDevice_Channel_DescriptionPath {
	return &TerminalDevice_Channel_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): Description of the logical channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/description"
// Path from root: "/terminal-device/logical-channels/channel/config/description"
func (n *TerminalDevice_ChannelPathAny) Description() *TerminalDevice_Channel_DescriptionPathAny {
	return &TerminalDevice_Channel_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ethernet (container): Top level container for data related to Ethernet framing
// for the logical channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "ethernet"
// Path from root: "/terminal-device/logical-channels/channel/ethernet"
func (n *TerminalDevice_ChannelPath) Ethernet() *TerminalDevice_Channel_EthernetPath {
	return &TerminalDevice_Channel_EthernetPath{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ethernet (container): Top level container for data related to Ethernet framing
// for the logical channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "ethernet"
// Path from root: "/terminal-device/logical-channels/channel/ethernet"
func (n *TerminalDevice_ChannelPathAny) Ethernet() *TerminalDevice_Channel_EthernetPathAny {
	return &TerminalDevice_Channel_EthernetPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ethernet"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of the current logical channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/index"
// Path from root: "/terminal-device/logical-channels/channel/config/index"
func (n *TerminalDevice_ChannelPath) Index() *TerminalDevice_Channel_IndexPath {
	return &TerminalDevice_Channel_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of the current logical channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/index"
// Path from root: "/terminal-device/logical-channels/channel/config/index"
func (n *TerminalDevice_ChannelPathAny) Index() *TerminalDevice_Channel_IndexPathAny {
	return &TerminalDevice_Channel_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ingress (container): Top-level container for specifying references to the
// source of signal for the logical channel, either a
// transceiver, individual physical channels, or an interface
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "ingress"
// Path from root: "/terminal-device/logical-channels/channel/ingress"
func (n *TerminalDevice_ChannelPath) Ingress() *TerminalDevice_Channel_IngressPath {
	return &TerminalDevice_Channel_IngressPath{
		NodePath: ygot.NewNodePath(
			[]string{"ingress"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ingress (container): Top-level container for specifying references to the
// source of signal for the logical channel, either a
// transceiver, individual physical channels, or an interface
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "ingress"
// Path from root: "/terminal-device/logical-channels/channel/ingress"
func (n *TerminalDevice_ChannelPathAny) Ingress() *TerminalDevice_Channel_IngressPathAny {
	return &TerminalDevice_Channel_IngressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"ingress"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkState (leaf): Link-state of the Ethernet protocol on the logical channel,
// SONET / SDH framed signal, etc.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/link-state"
// Path from root: "/terminal-device/logical-channels/channel/state/link-state"
func (n *TerminalDevice_ChannelPath) LinkState() *TerminalDevice_Channel_LinkStatePath {
	return &TerminalDevice_Channel_LinkStatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// LinkState (leaf): Link-state of the Ethernet protocol on the logical channel,
// SONET / SDH framed signal, etc.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/link-state"
// Path from root: "/terminal-device/logical-channels/channel/state/link-state"
func (n *TerminalDevice_ChannelPathAny) LinkState() *TerminalDevice_Channel_LinkStatePathAny {
	return &TerminalDevice_Channel_LinkStatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "link-state"},
			map[string]interface{}{},
			n,
		),
	}
}

// LogicalChannelType (leaf): The type / stage of the logical element determines the
// configuration and operational state parameters (PMs)
// available for the logical element
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/logical-channel-type"
// Path from root: "/terminal-device/logical-channels/channel/config/logical-channel-type"
func (n *TerminalDevice_ChannelPath) LogicalChannelType() *TerminalDevice_Channel_LogicalChannelTypePath {
	return &TerminalDevice_Channel_LogicalChannelTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "logical-channel-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LogicalChannelType (leaf): The type / stage of the logical element determines the
// configuration and operational state parameters (PMs)
// available for the logical element
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/logical-channel-type"
// Path from root: "/terminal-device/logical-channels/channel/config/logical-channel-type"
func (n *TerminalDevice_ChannelPathAny) LogicalChannelType() *TerminalDevice_Channel_LogicalChannelTypePathAny {
	return &TerminalDevice_Channel_LogicalChannelTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "logical-channel-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoopbackMode (leaf): Sets the loopback type on the logical channel. Setting the
// mode to something besides NONE activates the loopback in
// the specified mode.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/loopback-mode"
// Path from root: "/terminal-device/logical-channels/channel/config/loopback-mode"
func (n *TerminalDevice_ChannelPath) LoopbackMode() *TerminalDevice_Channel_LoopbackModePath {
	return &TerminalDevice_Channel_LoopbackModePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "loopback-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// LoopbackMode (leaf): Sets the loopback type on the logical channel. Setting the
// mode to something besides NONE activates the loopback in
// the specified mode.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/loopback-mode"
// Path from root: "/terminal-device/logical-channels/channel/config/loopback-mode"
func (n *TerminalDevice_ChannelPathAny) LoopbackMode() *TerminalDevice_Channel_LoopbackModePathAny {
	return &TerminalDevice_Channel_LoopbackModePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "loopback-mode"},
			map[string]interface{}{},
			n,
		),
	}
}

// Otn (container): Top level container for OTU configuration when logical
// channel framing is using an OTU protocol, e.g., OTU1, OTU3,
// etc.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "otn"
// Path from root: "/terminal-device/logical-channels/channel/otn"
func (n *TerminalDevice_ChannelPath) Otn() *TerminalDevice_Channel_OtnPath {
	return &TerminalDevice_Channel_OtnPath{
		NodePath: ygot.NewNodePath(
			[]string{"otn"},
			map[string]interface{}{},
			n,
		),
	}
}

// Otn (container): Top level container for OTU configuration when logical
// channel framing is using an OTU protocol, e.g., OTU1, OTU3,
// etc.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "otn"
// Path from root: "/terminal-device/logical-channels/channel/otn"
func (n *TerminalDevice_ChannelPathAny) Otn() *TerminalDevice_Channel_OtnPathAny {
	return &TerminalDevice_Channel_OtnPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"otn"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateClass (leaf): Rounded bit rate of the tributary signal. Exact bit rate
// will be refined by protocol selection.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/rate-class"
// Path from root: "/terminal-device/logical-channels/channel/config/rate-class"
func (n *TerminalDevice_ChannelPath) RateClass() *TerminalDevice_Channel_RateClassPath {
	return &TerminalDevice_Channel_RateClassPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "rate-class"},
			map[string]interface{}{},
			n,
		),
	}
}

// RateClass (leaf): Rounded bit rate of the tributary signal. Exact bit rate
// will be refined by protocol selection.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/rate-class"
// Path from root: "/terminal-device/logical-channels/channel/config/rate-class"
func (n *TerminalDevice_ChannelPathAny) RateClass() *TerminalDevice_Channel_RateClassPathAny {
	return &TerminalDevice_Channel_RateClassPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "rate-class"},
			map[string]interface{}{},
			n,
		),
	}
}

// TestSignal (leaf): When enabled the logical channel's DSP will generate a pseudo
// randmon bit stream (PRBS) which can be used during testing.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/test-signal"
// Path from root: "/terminal-device/logical-channels/channel/config/test-signal"
func (n *TerminalDevice_ChannelPath) TestSignal() *TerminalDevice_Channel_TestSignalPath {
	return &TerminalDevice_Channel_TestSignalPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "test-signal"},
			map[string]interface{}{},
			n,
		),
	}
}

// TestSignal (leaf): When enabled the logical channel's DSP will generate a pseudo
// randmon bit stream (PRBS) which can be used during testing.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/test-signal"
// Path from root: "/terminal-device/logical-channels/channel/config/test-signal"
func (n *TerminalDevice_ChannelPathAny) TestSignal() *TerminalDevice_Channel_TestSignalPathAny {
	return &TerminalDevice_Channel_TestSignalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "test-signal"},
			map[string]interface{}{},
			n,
		),
	}
}

// TribProtocol (leaf): Protocol framing of the tributary signal. If this
// LogicalChannel is directly connected to a Client-Port or
// Optical-Channel, this is the protocol of the associated port.
// If the LogicalChannel is connected to other LogicalChannels,
// the TributaryProtocol of the LogicalChannels will define a
// specific mapping/demapping or multiplexing/demultiplexing
// function.
//
// Not all protocols are valid, depending on the value
// of trib-rate-class.  The expectation is that the NMS
// will validate that a correct combination of rate class
// and protocol are specfied.  Basic combinations are:
//
// rate class: 1G
// protocols: 1GE
//
// rate class: 2.5G
// protocols: OC48, STM16
//
// rate class: 10G
// protocols:  10GE LAN, 10GE WAN, OC192, STM64, OTU2, OTU2e,
//            OTU1e, ODU2, ODU2e, ODU1e
//
// rate class: 40G
// protocols:  40GE, OC768, STM256, OTU3, ODU3
//
// rate class: 100G
// protocols:  100GE, 100G MLG, OTU4, OTUCn, ODU4
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/trib-protocol"
// Path from root: "/terminal-device/logical-channels/channel/config/trib-protocol"
func (n *TerminalDevice_ChannelPath) TribProtocol() *TerminalDevice_Channel_TribProtocolPath {
	return &TerminalDevice_Channel_TribProtocolPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trib-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// TribProtocol (leaf): Protocol framing of the tributary signal. If this
// LogicalChannel is directly connected to a Client-Port or
// Optical-Channel, this is the protocol of the associated port.
// If the LogicalChannel is connected to other LogicalChannels,
// the TributaryProtocol of the LogicalChannels will define a
// specific mapping/demapping or multiplexing/demultiplexing
// function.
//
// Not all protocols are valid, depending on the value
// of trib-rate-class.  The expectation is that the NMS
// will validate that a correct combination of rate class
// and protocol are specfied.  Basic combinations are:
//
// rate class: 1G
// protocols: 1GE
//
// rate class: 2.5G
// protocols: OC48, STM16
//
// rate class: 10G
// protocols:  10GE LAN, 10GE WAN, OC192, STM64, OTU2, OTU2e,
//            OTU1e, ODU2, ODU2e, ODU1e
//
// rate class: 40G
// protocols:  40GE, OC768, STM256, OTU3, ODU3
//
// rate class: 100G
// protocols:  100GE, 100G MLG, OTU4, OTUCn, ODU4
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/trib-protocol"
// Path from root: "/terminal-device/logical-channels/channel/config/trib-protocol"
func (n *TerminalDevice_ChannelPathAny) TribProtocol() *TerminalDevice_Channel_TribProtocolPathAny {
	return &TerminalDevice_Channel_TribProtocolPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "trib-protocol"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_AssignmentPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment YANG schema element.
type TerminalDevice_Channel_AssignmentPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_AssignmentPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment YANG schema element.
type TerminalDevice_Channel_AssignmentPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_AllocationPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/allocation YANG schema element.
type TerminalDevice_Channel_Assignment_AllocationPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_AllocationPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/allocation YANG schema element.
type TerminalDevice_Channel_Assignment_AllocationPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_AssignmentTypePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/assignment-type YANG schema element.
type TerminalDevice_Channel_Assignment_AssignmentTypePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_AssignmentTypePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/assignment-type YANG schema element.
type TerminalDevice_Channel_Assignment_AssignmentTypePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_DescriptionPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/description YANG schema element.
type TerminalDevice_Channel_Assignment_DescriptionPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_DescriptionPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/description YANG schema element.
type TerminalDevice_Channel_Assignment_DescriptionPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_IndexPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/index YANG schema element.
type TerminalDevice_Channel_Assignment_IndexPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_IndexPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/index YANG schema element.
type TerminalDevice_Channel_Assignment_IndexPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_LogicalChannelPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/logical-channel YANG schema element.
type TerminalDevice_Channel_Assignment_LogicalChannelPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_LogicalChannelPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/logical-channel YANG schema element.
type TerminalDevice_Channel_Assignment_LogicalChannelPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_MappingPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/mapping YANG schema element.
type TerminalDevice_Channel_Assignment_MappingPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_MappingPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/mapping YANG schema element.
type TerminalDevice_Channel_Assignment_MappingPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_OpticalChannelPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/optical-channel YANG schema element.
type TerminalDevice_Channel_Assignment_OpticalChannelPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_OpticalChannelPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/optical-channel YANG schema element.
type TerminalDevice_Channel_Assignment_OpticalChannelPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_TributarySlotIndexPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/tributary-slot-index YANG schema element.
type TerminalDevice_Channel_Assignment_TributarySlotIndexPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Assignment_TributarySlotIndexPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/tributary-slot-index YANG schema element.
type TerminalDevice_Channel_Assignment_TributarySlotIndexPathAny struct {
	*ygot.NodePath
}

// Allocation (leaf): Allocation of the logical client channel to the tributary
// or sub-channel, expressed in Gbps. Please note that if the
// assignment is to an OTN logical channel, the allocation must
// be an integer multiplication to tributary-slot-granularity
// of the OTN logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/allocation"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/allocation"
func (n *TerminalDevice_Channel_AssignmentPath) Allocation() *TerminalDevice_Channel_Assignment_AllocationPath {
	return &TerminalDevice_Channel_Assignment_AllocationPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allocation"},
			map[string]interface{}{},
			n,
		),
	}
}

// Allocation (leaf): Allocation of the logical client channel to the tributary
// or sub-channel, expressed in Gbps. Please note that if the
// assignment is to an OTN logical channel, the allocation must
// be an integer multiplication to tributary-slot-granularity
// of the OTN logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/allocation"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/allocation"
func (n *TerminalDevice_Channel_AssignmentPathAny) Allocation() *TerminalDevice_Channel_Assignment_AllocationPathAny {
	return &TerminalDevice_Channel_Assignment_AllocationPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "allocation"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssignmentType (leaf): Each logical channel element may be assigned to subsequent
// stages of logical elements to implement further grooming, or
// can be assigned to a line-side optical channel for
// transmission.  Each assignment also has an associated
// bandwidth allocation.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/assignment-type"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/assignment-type"
func (n *TerminalDevice_Channel_AssignmentPath) AssignmentType() *TerminalDevice_Channel_Assignment_AssignmentTypePath {
	return &TerminalDevice_Channel_Assignment_AssignmentTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "assignment-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// AssignmentType (leaf): Each logical channel element may be assigned to subsequent
// stages of logical elements to implement further grooming, or
// can be assigned to a line-side optical channel for
// transmission.  Each assignment also has an associated
// bandwidth allocation.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/assignment-type"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/assignment-type"
func (n *TerminalDevice_Channel_AssignmentPathAny) AssignmentType() *TerminalDevice_Channel_Assignment_AssignmentTypePathAny {
	return &TerminalDevice_Channel_Assignment_AssignmentTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "assignment-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): Name assigned to the logical client channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/description"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/description"
func (n *TerminalDevice_Channel_AssignmentPath) Description() *TerminalDevice_Channel_Assignment_DescriptionPath {
	return &TerminalDevice_Channel_Assignment_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): Name assigned to the logical client channel
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/description"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/description"
func (n *TerminalDevice_Channel_AssignmentPathAny) Description() *TerminalDevice_Channel_Assignment_DescriptionPathAny {
	return &TerminalDevice_Channel_Assignment_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of the current logical client channel to tributary
// mapping
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/index"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/index"
func (n *TerminalDevice_Channel_AssignmentPath) Index() *TerminalDevice_Channel_Assignment_IndexPath {
	return &TerminalDevice_Channel_Assignment_IndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// Index (leaf): Index of the current logical client channel to tributary
// mapping
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/index"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/index"
func (n *TerminalDevice_Channel_AssignmentPathAny) Index() *TerminalDevice_Channel_Assignment_IndexPathAny {
	return &TerminalDevice_Channel_Assignment_IndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "index"},
			map[string]interface{}{},
			n,
		),
	}
}

// LogicalChannel (leaf): Reference to another stage of logical channel elements.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/logical-channel"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/logical-channel"
func (n *TerminalDevice_Channel_AssignmentPath) LogicalChannel() *TerminalDevice_Channel_Assignment_LogicalChannelPath {
	return &TerminalDevice_Channel_Assignment_LogicalChannelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "logical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// LogicalChannel (leaf): Reference to another stage of logical channel elements.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/logical-channel"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/logical-channel"
func (n *TerminalDevice_Channel_AssignmentPathAny) LogicalChannel() *TerminalDevice_Channel_Assignment_LogicalChannelPathAny {
	return &TerminalDevice_Channel_Assignment_LogicalChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "logical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mapping (leaf): Logical channel mapping procedure. Valid only when the
// assignment is to an OTN logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/mapping"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/mapping"
func (n *TerminalDevice_Channel_AssignmentPath) Mapping() *TerminalDevice_Channel_Assignment_MappingPath {
	return &TerminalDevice_Channel_Assignment_MappingPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mapping"},
			map[string]interface{}{},
			n,
		),
	}
}

// Mapping (leaf): Logical channel mapping procedure. Valid only when the
// assignment is to an OTN logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/mapping"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/mapping"
func (n *TerminalDevice_Channel_AssignmentPathAny) Mapping() *TerminalDevice_Channel_Assignment_MappingPathAny {
	return &TerminalDevice_Channel_Assignment_MappingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "mapping"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalChannel (leaf): Reference to the line-side optical channel that should
// carry the current logical channel element.  Use this
// reference to exit the logical element stage.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/optical-channel"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/optical-channel"
func (n *TerminalDevice_Channel_AssignmentPath) OpticalChannel() *TerminalDevice_Channel_Assignment_OpticalChannelPath {
	return &TerminalDevice_Channel_Assignment_OpticalChannelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "optical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// OpticalChannel (leaf): Reference to the line-side optical channel that should
// carry the current logical channel element.  Use this
// reference to exit the logical element stage.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/optical-channel"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/optical-channel"
func (n *TerminalDevice_Channel_AssignmentPathAny) OpticalChannel() *TerminalDevice_Channel_Assignment_OpticalChannelPathAny {
	return &TerminalDevice_Channel_Assignment_OpticalChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "optical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// TributarySlotIndex (leaf): Indicates the first tributary slot index allocated to the
// client signal or logical channel in the assignment. Valid
// only when the assignment is to an OTN logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tributary-slot-index"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/tributary-slot-index"
func (n *TerminalDevice_Channel_AssignmentPath) TributarySlotIndex() *TerminalDevice_Channel_Assignment_TributarySlotIndexPath {
	return &TerminalDevice_Channel_Assignment_TributarySlotIndexPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tributary-slot-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// TributarySlotIndex (leaf): Indicates the first tributary slot index allocated to the
// client signal or logical channel in the assignment. Valid
// only when the assignment is to an OTN logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tributary-slot-index"
// Path from root: "/terminal-device/logical-channels/channel/logical-channel-assignments/assignment/config/tributary-slot-index"
func (n *TerminalDevice_Channel_AssignmentPathAny) TributarySlotIndex() *TerminalDevice_Channel_Assignment_TributarySlotIndexPathAny {
	return &TerminalDevice_Channel_Assignment_TributarySlotIndexPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tributary-slot-index"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_EthernetPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet YANG schema element.
type TerminalDevice_Channel_EthernetPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_EthernetPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet YANG schema element.
type TerminalDevice_Channel_EthernetPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_AlsDelayPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/config/als-delay YANG schema element.
type TerminalDevice_Channel_Ethernet_AlsDelayPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_AlsDelayPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/config/als-delay YANG schema element.
type TerminalDevice_Channel_Ethernet_AlsDelayPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_ClientAlsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/config/client-als YANG schema element.
type TerminalDevice_Channel_Ethernet_ClientAlsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_ClientAlsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/config/client-als YANG schema element.
type TerminalDevice_Channel_Ethernet_ClientAlsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_FecUncorrectableBlocksPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/fec-uncorrectable-blocks YANG schema element.
type TerminalDevice_Channel_Ethernet_FecUncorrectableBlocksPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_FecUncorrectableBlocksPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/fec-uncorrectable-blocks YANG schema element.
type TerminalDevice_Channel_Ethernet_FecUncorrectableBlocksPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_In_8021QFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-8021q-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_In_8021QFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_In_8021QFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-8021q-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_In_8021QFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InBlockErrorsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-block-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_InBlockErrorsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InBlockErrorsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-block-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_InBlockErrorsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InCarrierErrorsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-carrier-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_InCarrierErrorsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InCarrierErrorsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-carrier-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_InCarrierErrorsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InCrcErrorsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-crc-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_InCrcErrorsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InCrcErrorsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-crc-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_InCrcErrorsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InFragmentFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-fragment-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InFragmentFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InFragmentFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-fragment-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InFragmentFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InInterruptedTxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-interrupted-tx YANG schema element.
type TerminalDevice_Channel_Ethernet_InInterruptedTxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InInterruptedTxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-interrupted-tx YANG schema element.
type TerminalDevice_Channel_Ethernet_InInterruptedTxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InJabberFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-jabber-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InJabberFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InJabberFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-jabber-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InJabberFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InLateCollisionPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-late-collision YANG schema element.
type TerminalDevice_Channel_Ethernet_InLateCollisionPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InLateCollisionPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-late-collision YANG schema element.
type TerminalDevice_Channel_Ethernet_InLateCollisionPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InMacControlFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-mac-control-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InMacControlFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InMacControlFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-mac-control-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InMacControlFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InMacErrorsRxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-mac-errors-rx YANG schema element.
type TerminalDevice_Channel_Ethernet_InMacErrorsRxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InMacErrorsRxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-mac-errors-rx YANG schema element.
type TerminalDevice_Channel_Ethernet_InMacErrorsRxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InMacPauseFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-mac-pause-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InMacPauseFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InMacPauseFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-mac-pause-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InMacPauseFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InMaxsizeExceededPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-maxsize-exceeded YANG schema element.
type TerminalDevice_Channel_Ethernet_InMaxsizeExceededPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InMaxsizeExceededPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-maxsize-exceeded YANG schema element.
type TerminalDevice_Channel_Ethernet_InMaxsizeExceededPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InOversizeFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-oversize-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InOversizeFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InOversizeFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-oversize-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InOversizeFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InPcsBipErrorsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-pcs-bip-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_InPcsBipErrorsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InPcsBipErrorsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-pcs-bip-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_InPcsBipErrorsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InPcsErroredSecondsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-pcs-errored-seconds YANG schema element.
type TerminalDevice_Channel_Ethernet_InPcsErroredSecondsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InPcsErroredSecondsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-pcs-errored-seconds YANG schema element.
type TerminalDevice_Channel_Ethernet_InPcsErroredSecondsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InPcsSeverelyErroredSecondsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-pcs-severely-errored-seconds YANG schema element.
type TerminalDevice_Channel_Ethernet_InPcsSeverelyErroredSecondsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InPcsSeverelyErroredSecondsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-pcs-severely-errored-seconds YANG schema element.
type TerminalDevice_Channel_Ethernet_InPcsSeverelyErroredSecondsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InPcsUnavailableSecondsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-pcs-unavailable-seconds YANG schema element.
type TerminalDevice_Channel_Ethernet_InPcsUnavailableSecondsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InPcsUnavailableSecondsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-pcs-unavailable-seconds YANG schema element.
type TerminalDevice_Channel_Ethernet_InPcsUnavailableSecondsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InSingleCollisionPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-single-collision YANG schema element.
type TerminalDevice_Channel_Ethernet_InSingleCollisionPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InSingleCollisionPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-single-collision YANG schema element.
type TerminalDevice_Channel_Ethernet_InSingleCollisionPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InSymbolErrorPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-symbol-error YANG schema element.
type TerminalDevice_Channel_Ethernet_InSymbolErrorPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InSymbolErrorPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-symbol-error YANG schema element.
type TerminalDevice_Channel_Ethernet_InSymbolErrorPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InUndersizeFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-undersize-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InUndersizeFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_InUndersizeFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/in-undersize-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_InUndersizeFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Out_8021QFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-8021q-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_Out_8021QFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Out_8021QFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-8021q-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_Out_8021QFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutBlockErrorsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-block-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_OutBlockErrorsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutBlockErrorsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-block-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_OutBlockErrorsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutCrcErrorsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-crc-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_OutCrcErrorsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutCrcErrorsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-crc-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_OutCrcErrorsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutMacControlFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-mac-control-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_OutMacControlFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutMacControlFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-mac-control-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_OutMacControlFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutMacErrorsTxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-mac-errors-tx YANG schema element.
type TerminalDevice_Channel_Ethernet_OutMacErrorsTxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutMacErrorsTxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-mac-errors-tx YANG schema element.
type TerminalDevice_Channel_Ethernet_OutMacErrorsTxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutMacPauseFramesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-mac-pause-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_OutMacPauseFramesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutMacPauseFramesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-mac-pause-frames YANG schema element.
type TerminalDevice_Channel_Ethernet_OutMacPauseFramesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutPcsBipErrorsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-pcs-bip-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_OutPcsBipErrorsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_OutPcsBipErrorsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/out-pcs-bip-errors YANG schema element.
type TerminalDevice_Channel_Ethernet_OutPcsBipErrorsPathAny struct {
	*ygot.NodePath
}

// AlsDelay (leaf): The timer to delay the client-als actions on the client
// port when a local or remote fault is detected on the line
// port. The delay will only be valid when the client-als is
// set to LASER_SHUTDOWN
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/als-delay"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/config/als-delay"
func (n *TerminalDevice_Channel_EthernetPath) AlsDelay() *TerminalDevice_Channel_Ethernet_AlsDelayPath {
	return &TerminalDevice_Channel_Ethernet_AlsDelayPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "als-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// AlsDelay (leaf): The timer to delay the client-als actions on the client
// port when a local or remote fault is detected on the line
// port. The delay will only be valid when the client-als is
// set to LASER_SHUTDOWN
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/als-delay"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/config/als-delay"
func (n *TerminalDevice_Channel_EthernetPathAny) AlsDelay() *TerminalDevice_Channel_Ethernet_AlsDelayPathAny {
	return &TerminalDevice_Channel_Ethernet_AlsDelayPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "als-delay"},
			map[string]interface{}{},
			n,
		),
	}
}

// ClientAls (leaf): Sets the client port behavior that defines if the actions
// of automatic laser shutdown (als), ethernet fault
// propagation, or nothing will be done upon the detection
// of a failure on the line port or the upstream remote
// client port.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/client-als"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/config/client-als"
func (n *TerminalDevice_Channel_EthernetPath) ClientAls() *TerminalDevice_Channel_Ethernet_ClientAlsPath {
	return &TerminalDevice_Channel_Ethernet_ClientAlsPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "client-als"},
			map[string]interface{}{},
			n,
		),
	}
}

// ClientAls (leaf): Sets the client port behavior that defines if the actions
// of automatic laser shutdown (als), ethernet fault
// propagation, or nothing will be done upon the detection
// of a failure on the line port or the upstream remote
// client port.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/client-als"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/config/client-als"
func (n *TerminalDevice_Channel_EthernetPathAny) ClientAls() *TerminalDevice_Channel_Ethernet_ClientAlsPathAny {
	return &TerminalDevice_Channel_Ethernet_ClientAlsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "client-als"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esnr (container): Electrical signal to noise ratio. Baud rate
// normalized signal to noise ratio based on
// error vector magnitude in dB with two decimal
// precision. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/esnr"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr"
func (n *TerminalDevice_Channel_EthernetPath) Esnr() *TerminalDevice_Channel_Ethernet_EsnrPath {
	return &TerminalDevice_Channel_Ethernet_EsnrPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esnr"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esnr (container): Electrical signal to noise ratio. Baud rate
// normalized signal to noise ratio based on
// error vector magnitude in dB with two decimal
// precision. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/esnr"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr"
func (n *TerminalDevice_Channel_EthernetPathAny) Esnr() *TerminalDevice_Channel_Ethernet_EsnrPathAny {
	return &TerminalDevice_Channel_Ethernet_EsnrPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esnr"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableBlocks (leaf): The number of blocks or frames that were uncorrectable by
// the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-uncorrectable-blocks"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/fec-uncorrectable-blocks"
func (n *TerminalDevice_Channel_EthernetPath) FecUncorrectableBlocks() *TerminalDevice_Channel_Ethernet_FecUncorrectableBlocksPath {
	return &TerminalDevice_Channel_Ethernet_FecUncorrectableBlocksPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableBlocks (leaf): The number of blocks or frames that were uncorrectable by
// the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-uncorrectable-blocks"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/fec-uncorrectable-blocks"
func (n *TerminalDevice_Channel_EthernetPathAny) FecUncorrectableBlocks() *TerminalDevice_Channel_Ethernet_FecUncorrectableBlocksPathAny {
	return &TerminalDevice_Channel_Ethernet_FecUncorrectableBlocksPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// In_8021QFrames (leaf): Number of 802.1q tagged frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-8021q-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-8021q-frames"
func (n *TerminalDevice_Channel_EthernetPath) In_8021QFrames() *TerminalDevice_Channel_Ethernet_In_8021QFramesPath {
	return &TerminalDevice_Channel_Ethernet_In_8021QFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-8021q-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// In_8021QFrames (leaf): Number of 802.1q tagged frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-8021q-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-8021q-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) In_8021QFrames() *TerminalDevice_Channel_Ethernet_In_8021QFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_In_8021QFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-8021q-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InBlockErrors (leaf): The number of received errored blocks. Error detection codes
// are capable of detecting whether one or more errors have
// occurred in a given sequence of bits – the block. It is
// normally not possible to determine the exact number of errored
// bits within the block
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-block-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-block-errors"
func (n *TerminalDevice_Channel_EthernetPath) InBlockErrors() *TerminalDevice_Channel_Ethernet_InBlockErrorsPath {
	return &TerminalDevice_Channel_Ethernet_InBlockErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-block-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InBlockErrors (leaf): The number of received errored blocks. Error detection codes
// are capable of detecting whether one or more errors have
// occurred in a given sequence of bits – the block. It is
// normally not possible to determine the exact number of errored
// bits within the block
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-block-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-block-errors"
func (n *TerminalDevice_Channel_EthernetPathAny) InBlockErrors() *TerminalDevice_Channel_Ethernet_InBlockErrorsPathAny {
	return &TerminalDevice_Channel_Ethernet_InBlockErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-block-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InCarrierErrors (leaf): The number of received errored frames due to a carrier issue.
// The value refers to MIB counter for
// dot3StatsCarrierSenseErrors
// oid=1.3.6.1.2.1.10.7.2.1.11
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-carrier-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-carrier-errors"
func (n *TerminalDevice_Channel_EthernetPath) InCarrierErrors() *TerminalDevice_Channel_Ethernet_InCarrierErrorsPath {
	return &TerminalDevice_Channel_Ethernet_InCarrierErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-carrier-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InCarrierErrors (leaf): The number of received errored frames due to a carrier issue.
// The value refers to MIB counter for
// dot3StatsCarrierSenseErrors
// oid=1.3.6.1.2.1.10.7.2.1.11
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-carrier-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-carrier-errors"
func (n *TerminalDevice_Channel_EthernetPathAny) InCarrierErrors() *TerminalDevice_Channel_Ethernet_InCarrierErrorsPathAny {
	return &TerminalDevice_Channel_Ethernet_InCarrierErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-carrier-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InCrcErrors (leaf): The total number of frames received that
// had a length (excluding framing bits, but
// including FCS octets) of between 64 and 1518
// octets, inclusive, but had either a bad
// Frame Check Sequence (FCS) with an integral
// number of octets (FCS Error) or a bad FCS with
// a non-integral number of octets (Alignment Error)
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-crc-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-crc-errors"
func (n *TerminalDevice_Channel_EthernetPath) InCrcErrors() *TerminalDevice_Channel_Ethernet_InCrcErrorsPath {
	return &TerminalDevice_Channel_Ethernet_InCrcErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-crc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InCrcErrors (leaf): The total number of frames received that
// had a length (excluding framing bits, but
// including FCS octets) of between 64 and 1518
// octets, inclusive, but had either a bad
// Frame Check Sequence (FCS) with an integral
// number of octets (FCS Error) or a bad FCS with
// a non-integral number of octets (Alignment Error)
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-crc-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-crc-errors"
func (n *TerminalDevice_Channel_EthernetPathAny) InCrcErrors() *TerminalDevice_Channel_Ethernet_InCrcErrorsPathAny {
	return &TerminalDevice_Channel_Ethernet_InCrcErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-crc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InFragmentFrames (leaf): The total number of frames received that were less than
// 64 octets in length (excluding framing bits but including
// FCS octets) and had either a bad Frame Check Sequence
// (FCS) with an integral number of octets (FCS Error) or a
// bad FCS with a non-integral number of octets (Alignment
// Error).
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-fragment-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-fragment-frames"
func (n *TerminalDevice_Channel_EthernetPath) InFragmentFrames() *TerminalDevice_Channel_Ethernet_InFragmentFramesPath {
	return &TerminalDevice_Channel_Ethernet_InFragmentFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-fragment-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InFragmentFrames (leaf): The total number of frames received that were less than
// 64 octets in length (excluding framing bits but including
// FCS octets) and had either a bad Frame Check Sequence
// (FCS) with an integral number of octets (FCS Error) or a
// bad FCS with a non-integral number of octets (Alignment
// Error).
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-fragment-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-fragment-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) InFragmentFrames() *TerminalDevice_Channel_Ethernet_InFragmentFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_InFragmentFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-fragment-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InInterruptedTx (leaf): The number of received errored frames due to interrupted
// transmission issue. The value refers to MIB counter for
// dot3StatsDeferredTransmissions
// oid=1.3.6.1.2.1.10.7.2.1.7
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-interrupted-tx"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-interrupted-tx"
func (n *TerminalDevice_Channel_EthernetPath) InInterruptedTx() *TerminalDevice_Channel_Ethernet_InInterruptedTxPath {
	return &TerminalDevice_Channel_Ethernet_InInterruptedTxPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-interrupted-tx"},
			map[string]interface{}{},
			n,
		),
	}
}

// InInterruptedTx (leaf): The number of received errored frames due to interrupted
// transmission issue. The value refers to MIB counter for
// dot3StatsDeferredTransmissions
// oid=1.3.6.1.2.1.10.7.2.1.7
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-interrupted-tx"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-interrupted-tx"
func (n *TerminalDevice_Channel_EthernetPathAny) InInterruptedTx() *TerminalDevice_Channel_Ethernet_InInterruptedTxPathAny {
	return &TerminalDevice_Channel_Ethernet_InInterruptedTxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-interrupted-tx"},
			map[string]interface{}{},
			n,
		),
	}
}

// InJabberFrames (leaf): Number of jabber frames received on the
// interface.  Jabber frames are typically defined as oversize
// frames which also have a bad CRC.  Implementations may use
// slightly different definitions of what constitutes a jabber
// frame.  Often indicative of a NIC hardware problem.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-jabber-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-jabber-frames"
func (n *TerminalDevice_Channel_EthernetPath) InJabberFrames() *TerminalDevice_Channel_Ethernet_InJabberFramesPath {
	return &TerminalDevice_Channel_Ethernet_InJabberFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-jabber-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InJabberFrames (leaf): Number of jabber frames received on the
// interface.  Jabber frames are typically defined as oversize
// frames which also have a bad CRC.  Implementations may use
// slightly different definitions of what constitutes a jabber
// frame.  Often indicative of a NIC hardware problem.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-jabber-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-jabber-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) InJabberFrames() *TerminalDevice_Channel_Ethernet_InJabberFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_InJabberFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-jabber-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InLateCollision (leaf): The number of received errored frames due to late collision
// issue. The value refers to MIB counter for
// dot3StatsLateCollisions
// oid=1.3.6.1.2.1.10.7.2.1.8
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-late-collision"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-late-collision"
func (n *TerminalDevice_Channel_EthernetPath) InLateCollision() *TerminalDevice_Channel_Ethernet_InLateCollisionPath {
	return &TerminalDevice_Channel_Ethernet_InLateCollisionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-late-collision"},
			map[string]interface{}{},
			n,
		),
	}
}

// InLateCollision (leaf): The number of received errored frames due to late collision
// issue. The value refers to MIB counter for
// dot3StatsLateCollisions
// oid=1.3.6.1.2.1.10.7.2.1.8
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-late-collision"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-late-collision"
func (n *TerminalDevice_Channel_EthernetPathAny) InLateCollision() *TerminalDevice_Channel_Ethernet_InLateCollisionPathAny {
	return &TerminalDevice_Channel_Ethernet_InLateCollisionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-late-collision"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacControlFrames (leaf): MAC layer control frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-mac-control-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-mac-control-frames"
func (n *TerminalDevice_Channel_EthernetPath) InMacControlFrames() *TerminalDevice_Channel_Ethernet_InMacControlFramesPath {
	return &TerminalDevice_Channel_Ethernet_InMacControlFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-mac-control-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacControlFrames (leaf): MAC layer control frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-mac-control-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-mac-control-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) InMacControlFrames() *TerminalDevice_Channel_Ethernet_InMacControlFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_InMacControlFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-mac-control-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacErrorsRx (leaf): The number of received errored frames due to MAC errors
// received. The value refers to MIB counter for
// dot3StatsInternalMacReceiveErrors
// oid=1.3.6.1.2.1.10.7.2.1.16
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-mac-errors-rx"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-mac-errors-rx"
func (n *TerminalDevice_Channel_EthernetPath) InMacErrorsRx() *TerminalDevice_Channel_Ethernet_InMacErrorsRxPath {
	return &TerminalDevice_Channel_Ethernet_InMacErrorsRxPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-mac-errors-rx"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacErrorsRx (leaf): The number of received errored frames due to MAC errors
// received. The value refers to MIB counter for
// dot3StatsInternalMacReceiveErrors
// oid=1.3.6.1.2.1.10.7.2.1.16
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-mac-errors-rx"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-mac-errors-rx"
func (n *TerminalDevice_Channel_EthernetPathAny) InMacErrorsRx() *TerminalDevice_Channel_Ethernet_InMacErrorsRxPathAny {
	return &TerminalDevice_Channel_Ethernet_InMacErrorsRxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-mac-errors-rx"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacPauseFrames (leaf): MAC layer PAUSE frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-mac-pause-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-mac-pause-frames"
func (n *TerminalDevice_Channel_EthernetPath) InMacPauseFrames() *TerminalDevice_Channel_Ethernet_InMacPauseFramesPath {
	return &TerminalDevice_Channel_Ethernet_InMacPauseFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-mac-pause-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMacPauseFrames (leaf): MAC layer PAUSE frames received on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-mac-pause-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-mac-pause-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) InMacPauseFrames() *TerminalDevice_Channel_Ethernet_InMacPauseFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_InMacPauseFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-mac-pause-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMaxsizeExceeded (leaf): The total number frames received that are well-formed but
// dropped due to exceeding the maximum frame size on the interface
// (e.g., MTU or MRU)
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-maxsize-exceeded"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-maxsize-exceeded"
func (n *TerminalDevice_Channel_EthernetPath) InMaxsizeExceeded() *TerminalDevice_Channel_Ethernet_InMaxsizeExceededPath {
	return &TerminalDevice_Channel_Ethernet_InMaxsizeExceededPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-maxsize-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// InMaxsizeExceeded (leaf): The total number frames received that are well-formed but
// dropped due to exceeding the maximum frame size on the interface
// (e.g., MTU or MRU)
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-maxsize-exceeded"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-maxsize-exceeded"
func (n *TerminalDevice_Channel_EthernetPathAny) InMaxsizeExceeded() *TerminalDevice_Channel_Ethernet_InMaxsizeExceededPathAny {
	return &TerminalDevice_Channel_Ethernet_InMaxsizeExceededPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-maxsize-exceeded"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOversizeFrames (leaf): The total number of frames received that were
// longer than 1518 octets (excluding framing bits,
// but including FCS octets) and were otherwise
// well formed.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-oversize-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-oversize-frames"
func (n *TerminalDevice_Channel_EthernetPath) InOversizeFrames() *TerminalDevice_Channel_Ethernet_InOversizeFramesPath {
	return &TerminalDevice_Channel_Ethernet_InOversizeFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-oversize-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InOversizeFrames (leaf): The total number of frames received that were
// longer than 1518 octets (excluding framing bits,
// but including FCS octets) and were otherwise
// well formed.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-oversize-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-oversize-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) InOversizeFrames() *TerminalDevice_Channel_Ethernet_InOversizeFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_InOversizeFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-oversize-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPcsBipErrors (leaf): The number of received bit interleaved parity (BIP) errors
// at the physical coding sublayer (PCS). If the interface
// consists of multiple lanes, this will be the sum of all
// errors on the lane
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-pcs-bip-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-pcs-bip-errors"
func (n *TerminalDevice_Channel_EthernetPath) InPcsBipErrors() *TerminalDevice_Channel_Ethernet_InPcsBipErrorsPath {
	return &TerminalDevice_Channel_Ethernet_InPcsBipErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pcs-bip-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPcsBipErrors (leaf): The number of received bit interleaved parity (BIP) errors
// at the physical coding sublayer (PCS). If the interface
// consists of multiple lanes, this will be the sum of all
// errors on the lane
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-pcs-bip-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-pcs-bip-errors"
func (n *TerminalDevice_Channel_EthernetPathAny) InPcsBipErrors() *TerminalDevice_Channel_Ethernet_InPcsBipErrorsPathAny {
	return &TerminalDevice_Channel_Ethernet_InPcsBipErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pcs-bip-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPcsErroredSeconds (leaf): The number of seconds that physical coding sublayer (PCS)
// errors have crossed a sytem defined threshold indicating the
// link is erroring
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-pcs-errored-seconds"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-pcs-errored-seconds"
func (n *TerminalDevice_Channel_EthernetPath) InPcsErroredSeconds() *TerminalDevice_Channel_Ethernet_InPcsErroredSecondsPath {
	return &TerminalDevice_Channel_Ethernet_InPcsErroredSecondsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pcs-errored-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPcsErroredSeconds (leaf): The number of seconds that physical coding sublayer (PCS)
// errors have crossed a sytem defined threshold indicating the
// link is erroring
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-pcs-errored-seconds"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-pcs-errored-seconds"
func (n *TerminalDevice_Channel_EthernetPathAny) InPcsErroredSeconds() *TerminalDevice_Channel_Ethernet_InPcsErroredSecondsPathAny {
	return &TerminalDevice_Channel_Ethernet_InPcsErroredSecondsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pcs-errored-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPcsSeverelyErroredSeconds (leaf): The number of seconds that physical coding sublayer (PCS)
// errors have crossed a system defined threshold indicating the
// link is severely erroring
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-pcs-severely-errored-seconds"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-pcs-severely-errored-seconds"
func (n *TerminalDevice_Channel_EthernetPath) InPcsSeverelyErroredSeconds() *TerminalDevice_Channel_Ethernet_InPcsSeverelyErroredSecondsPath {
	return &TerminalDevice_Channel_Ethernet_InPcsSeverelyErroredSecondsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pcs-severely-errored-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPcsSeverelyErroredSeconds (leaf): The number of seconds that physical coding sublayer (PCS)
// errors have crossed a system defined threshold indicating the
// link is severely erroring
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-pcs-severely-errored-seconds"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-pcs-severely-errored-seconds"
func (n *TerminalDevice_Channel_EthernetPathAny) InPcsSeverelyErroredSeconds() *TerminalDevice_Channel_Ethernet_InPcsSeverelyErroredSecondsPathAny {
	return &TerminalDevice_Channel_Ethernet_InPcsSeverelyErroredSecondsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pcs-severely-errored-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPcsUnavailableSeconds (leaf): The number of seconds that physical coding sublayer (PCS)
// errors have crossed a system defined threshold indicating the
// link is unavailable
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-pcs-unavailable-seconds"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-pcs-unavailable-seconds"
func (n *TerminalDevice_Channel_EthernetPath) InPcsUnavailableSeconds() *TerminalDevice_Channel_Ethernet_InPcsUnavailableSecondsPath {
	return &TerminalDevice_Channel_Ethernet_InPcsUnavailableSecondsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pcs-unavailable-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// InPcsUnavailableSeconds (leaf): The number of seconds that physical coding sublayer (PCS)
// errors have crossed a system defined threshold indicating the
// link is unavailable
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-pcs-unavailable-seconds"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-pcs-unavailable-seconds"
func (n *TerminalDevice_Channel_EthernetPathAny) InPcsUnavailableSeconds() *TerminalDevice_Channel_Ethernet_InPcsUnavailableSecondsPathAny {
	return &TerminalDevice_Channel_Ethernet_InPcsUnavailableSecondsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-pcs-unavailable-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSingleCollision (leaf): The number of received errored frames due to single collision
// issue. The value refers to MIB counter for
// dot3StatsSingleCollisionFrames
// oid=1.3.6.1.2.1.10.7.2.1.4
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-single-collision"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-single-collision"
func (n *TerminalDevice_Channel_EthernetPath) InSingleCollision() *TerminalDevice_Channel_Ethernet_InSingleCollisionPath {
	return &TerminalDevice_Channel_Ethernet_InSingleCollisionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-single-collision"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSingleCollision (leaf): The number of received errored frames due to single collision
// issue. The value refers to MIB counter for
// dot3StatsSingleCollisionFrames
// oid=1.3.6.1.2.1.10.7.2.1.4
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-single-collision"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-single-collision"
func (n *TerminalDevice_Channel_EthernetPathAny) InSingleCollision() *TerminalDevice_Channel_Ethernet_InSingleCollisionPathAny {
	return &TerminalDevice_Channel_Ethernet_InSingleCollisionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-single-collision"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSymbolError (leaf): The number of received errored frames due to symbol error.
// The value refers to MIB counter for
// in-symbol-error
// oid=1.3.6.1.2.1.10.7.2.1.18
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-symbol-error"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-symbol-error"
func (n *TerminalDevice_Channel_EthernetPath) InSymbolError() *TerminalDevice_Channel_Ethernet_InSymbolErrorPath {
	return &TerminalDevice_Channel_Ethernet_InSymbolErrorPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-symbol-error"},
			map[string]interface{}{},
			n,
		),
	}
}

// InSymbolError (leaf): The number of received errored frames due to symbol error.
// The value refers to MIB counter for
// in-symbol-error
// oid=1.3.6.1.2.1.10.7.2.1.18
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-symbol-error"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-symbol-error"
func (n *TerminalDevice_Channel_EthernetPathAny) InSymbolError() *TerminalDevice_Channel_Ethernet_InSymbolErrorPathAny {
	return &TerminalDevice_Channel_Ethernet_InSymbolErrorPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-symbol-error"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUndersizeFrames (leaf): The total number of frames received that were
// less than 64 octets long (excluding framing bits,
// but including FCS octets) and were otherwise well
// formed.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-undersize-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-undersize-frames"
func (n *TerminalDevice_Channel_EthernetPath) InUndersizeFrames() *TerminalDevice_Channel_Ethernet_InUndersizeFramesPath {
	return &TerminalDevice_Channel_Ethernet_InUndersizeFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-undersize-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// InUndersizeFrames (leaf): The total number of frames received that were
// less than 64 octets long (excluding framing bits,
// but including FCS octets) and were otherwise well
// formed.
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/in-undersize-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/in-undersize-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) InUndersizeFrames() *TerminalDevice_Channel_Ethernet_InUndersizeFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_InUndersizeFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "in-undersize-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lldp (container): LLDP data for logical channels
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "lldp"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp"
func (n *TerminalDevice_Channel_EthernetPath) Lldp() *TerminalDevice_Channel_Ethernet_LldpPath {
	return &TerminalDevice_Channel_Ethernet_LldpPath{
		NodePath: ygot.NewNodePath(
			[]string{"lldp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Lldp (container): LLDP data for logical channels
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "lldp"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp"
func (n *TerminalDevice_Channel_EthernetPathAny) Lldp() *TerminalDevice_Channel_Ethernet_LldpPathAny {
	return &TerminalDevice_Channel_Ethernet_LldpPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"lldp"},
			map[string]interface{}{},
			n,
		),
	}
}

// Out_8021QFrames (leaf): Number of 802.1q tagged frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-8021q-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-8021q-frames"
func (n *TerminalDevice_Channel_EthernetPath) Out_8021QFrames() *TerminalDevice_Channel_Ethernet_Out_8021QFramesPath {
	return &TerminalDevice_Channel_Ethernet_Out_8021QFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-8021q-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// Out_8021QFrames (leaf): Number of 802.1q tagged frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-8021q-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-8021q-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) Out_8021QFrames() *TerminalDevice_Channel_Ethernet_Out_8021QFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_Out_8021QFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-8021q-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutBlockErrors (leaf): The number of transmitted errored blocks. Error detection
// codes are capable of detecting whether one or more errors have
// occurred in a given sequence of bits – the block. It is
// normally not possible to determine the exact number of errored
// bits within the block
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-block-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-block-errors"
func (n *TerminalDevice_Channel_EthernetPath) OutBlockErrors() *TerminalDevice_Channel_Ethernet_OutBlockErrorsPath {
	return &TerminalDevice_Channel_Ethernet_OutBlockErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-block-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutBlockErrors (leaf): The number of transmitted errored blocks. Error detection
// codes are capable of detecting whether one or more errors have
// occurred in a given sequence of bits – the block. It is
// normally not possible to determine the exact number of errored
// bits within the block
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-block-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-block-errors"
func (n *TerminalDevice_Channel_EthernetPathAny) OutBlockErrors() *TerminalDevice_Channel_Ethernet_OutBlockErrorsPathAny {
	return &TerminalDevice_Channel_Ethernet_OutBlockErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-block-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutCrcErrors (leaf): Number of FCS/CRC error check failures sent on the interface
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-crc-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-crc-errors"
func (n *TerminalDevice_Channel_EthernetPath) OutCrcErrors() *TerminalDevice_Channel_Ethernet_OutCrcErrorsPath {
	return &TerminalDevice_Channel_Ethernet_OutCrcErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-crc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutCrcErrors (leaf): Number of FCS/CRC error check failures sent on the interface
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-crc-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-crc-errors"
func (n *TerminalDevice_Channel_EthernetPathAny) OutCrcErrors() *TerminalDevice_Channel_Ethernet_OutCrcErrorsPathAny {
	return &TerminalDevice_Channel_Ethernet_OutCrcErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-crc-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacControlFrames (leaf): MAC layer control frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-mac-control-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-mac-control-frames"
func (n *TerminalDevice_Channel_EthernetPath) OutMacControlFrames() *TerminalDevice_Channel_Ethernet_OutMacControlFramesPath {
	return &TerminalDevice_Channel_Ethernet_OutMacControlFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-mac-control-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacControlFrames (leaf): MAC layer control frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-mac-control-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-mac-control-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) OutMacControlFrames() *TerminalDevice_Channel_Ethernet_OutMacControlFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_OutMacControlFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-mac-control-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacErrorsTx (leaf): The number of sent errored frames due to MAC errors
// transmitted. The value refers to MIB counter for
// dot3StatsInternalMacTransmitErrors
// oid=1.3.6.1.2.1.10.7.2.1.10
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-mac-errors-tx"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-mac-errors-tx"
func (n *TerminalDevice_Channel_EthernetPath) OutMacErrorsTx() *TerminalDevice_Channel_Ethernet_OutMacErrorsTxPath {
	return &TerminalDevice_Channel_Ethernet_OutMacErrorsTxPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-mac-errors-tx"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacErrorsTx (leaf): The number of sent errored frames due to MAC errors
// transmitted. The value refers to MIB counter for
// dot3StatsInternalMacTransmitErrors
// oid=1.3.6.1.2.1.10.7.2.1.10
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-mac-errors-tx"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-mac-errors-tx"
func (n *TerminalDevice_Channel_EthernetPathAny) OutMacErrorsTx() *TerminalDevice_Channel_Ethernet_OutMacErrorsTxPathAny {
	return &TerminalDevice_Channel_Ethernet_OutMacErrorsTxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-mac-errors-tx"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacPauseFrames (leaf): MAC layer PAUSE frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-mac-pause-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-mac-pause-frames"
func (n *TerminalDevice_Channel_EthernetPath) OutMacPauseFrames() *TerminalDevice_Channel_Ethernet_OutMacPauseFramesPath {
	return &TerminalDevice_Channel_Ethernet_OutMacPauseFramesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-mac-pause-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutMacPauseFrames (leaf): MAC layer PAUSE frames sent on the interface
// ----------------------------------------
// Defining module: "openconfig-if-ethernet"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-mac-pause-frames"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-mac-pause-frames"
func (n *TerminalDevice_Channel_EthernetPathAny) OutMacPauseFrames() *TerminalDevice_Channel_Ethernet_OutMacPauseFramesPathAny {
	return &TerminalDevice_Channel_Ethernet_OutMacPauseFramesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-mac-pause-frames"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPcsBipErrors (leaf): The number of transmitted bit interleaved parity (BIP) errors
// at the physical coding sublayer (PCS). If the interface
// consists of multiple lanes, this will be the sum of all
// errors on the lane
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-pcs-bip-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-pcs-bip-errors"
func (n *TerminalDevice_Channel_EthernetPath) OutPcsBipErrors() *TerminalDevice_Channel_Ethernet_OutPcsBipErrorsPath {
	return &TerminalDevice_Channel_Ethernet_OutPcsBipErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pcs-bip-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// OutPcsBipErrors (leaf): The number of transmitted bit interleaved parity (BIP) errors
// at the physical coding sublayer (PCS). If the interface
// consists of multiple lanes, this will be the sum of all
// errors on the lane
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/out-pcs-bip-errors"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/out-pcs-bip-errors"
func (n *TerminalDevice_Channel_EthernetPathAny) OutPcsBipErrors() *TerminalDevice_Channel_Ethernet_OutPcsBipErrorsPathAny {
	return &TerminalDevice_Channel_Ethernet_OutPcsBipErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "out-pcs-bip-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostFecBer (container): Bit error rate after forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/post-fec-ber"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber"
func (n *TerminalDevice_Channel_EthernetPath) PostFecBer() *TerminalDevice_Channel_Ethernet_PostFecBerPath {
	return &TerminalDevice_Channel_Ethernet_PostFecBerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "post-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostFecBer (container): Bit error rate after forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/post-fec-ber"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber"
func (n *TerminalDevice_Channel_EthernetPathAny) PostFecBer() *TerminalDevice_Channel_Ethernet_PostFecBerPathAny {
	return &TerminalDevice_Channel_Ethernet_PostFecBerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "post-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreFecBer (container): Bit error rate before forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/pre-fec-ber"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber"
func (n *TerminalDevice_Channel_EthernetPath) PreFecBer() *TerminalDevice_Channel_Ethernet_PreFecBerPath {
	return &TerminalDevice_Channel_Ethernet_PreFecBerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pre-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreFecBer (container): Bit error rate before forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/pre-fec-ber"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber"
func (n *TerminalDevice_Channel_EthernetPathAny) PreFecBer() *TerminalDevice_Channel_Ethernet_PreFecBerPathAny {
	return &TerminalDevice_Channel_Ethernet_PreFecBerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pre-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// QValue (container): Quality value (factor) in dB of a channel with two
// decimal precision. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/q-value"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value"
func (n *TerminalDevice_Channel_EthernetPath) QValue() *TerminalDevice_Channel_Ethernet_QValuePath {
	return &TerminalDevice_Channel_Ethernet_QValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "q-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// QValue (container): Quality value (factor) in dB of a channel with two
// decimal precision. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/q-value"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value"
func (n *TerminalDevice_Channel_EthernetPathAny) QValue() *TerminalDevice_Channel_Ethernet_QValuePathAny {
	return &TerminalDevice_Channel_Ethernet_QValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "q-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Ethernet_EsnrPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr YANG schema element.
type TerminalDevice_Channel_Ethernet_EsnrPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_EsnrPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr YANG schema element.
type TerminalDevice_Channel_Ethernet_EsnrPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_AvgPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/avg YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_AvgPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_AvgPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/avg YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_AvgPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_InstantPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/instant YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_InstantPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_InstantPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/instant YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_InstantPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_IntervalPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/interval YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_IntervalPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_IntervalPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/interval YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_IntervalPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_MaxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/max YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_MaxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_MaxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/max YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_MaxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_MaxTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/max-time YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_MaxTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_MaxTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/max-time YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_MaxTimePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_MinPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/min YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_MinPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_MinPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/min YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_MinPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_MinTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/min-time YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_MinTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Esnr_MinTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/esnr/min-time YANG schema element.
type TerminalDevice_Channel_Ethernet_Esnr_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/avg"
func (n *TerminalDevice_Channel_Ethernet_EsnrPath) Avg() *TerminalDevice_Channel_Ethernet_Esnr_AvgPath {
	return &TerminalDevice_Channel_Ethernet_Esnr_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/avg"
func (n *TerminalDevice_Channel_Ethernet_EsnrPathAny) Avg() *TerminalDevice_Channel_Ethernet_Esnr_AvgPathAny {
	return &TerminalDevice_Channel_Ethernet_Esnr_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/instant"
func (n *TerminalDevice_Channel_Ethernet_EsnrPath) Instant() *TerminalDevice_Channel_Ethernet_Esnr_InstantPath {
	return &TerminalDevice_Channel_Ethernet_Esnr_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/instant"
func (n *TerminalDevice_Channel_Ethernet_EsnrPathAny) Instant() *TerminalDevice_Channel_Ethernet_Esnr_InstantPathAny {
	return &TerminalDevice_Channel_Ethernet_Esnr_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/interval"
func (n *TerminalDevice_Channel_Ethernet_EsnrPath) Interval() *TerminalDevice_Channel_Ethernet_Esnr_IntervalPath {
	return &TerminalDevice_Channel_Ethernet_Esnr_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/interval"
func (n *TerminalDevice_Channel_Ethernet_EsnrPathAny) Interval() *TerminalDevice_Channel_Ethernet_Esnr_IntervalPathAny {
	return &TerminalDevice_Channel_Ethernet_Esnr_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/max"
func (n *TerminalDevice_Channel_Ethernet_EsnrPath) Max() *TerminalDevice_Channel_Ethernet_Esnr_MaxPath {
	return &TerminalDevice_Channel_Ethernet_Esnr_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/max"
func (n *TerminalDevice_Channel_Ethernet_EsnrPathAny) Max() *TerminalDevice_Channel_Ethernet_Esnr_MaxPathAny {
	return &TerminalDevice_Channel_Ethernet_Esnr_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/max-time"
func (n *TerminalDevice_Channel_Ethernet_EsnrPath) MaxTime() *TerminalDevice_Channel_Ethernet_Esnr_MaxTimePath {
	return &TerminalDevice_Channel_Ethernet_Esnr_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/max-time"
func (n *TerminalDevice_Channel_Ethernet_EsnrPathAny) MaxTime() *TerminalDevice_Channel_Ethernet_Esnr_MaxTimePathAny {
	return &TerminalDevice_Channel_Ethernet_Esnr_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/min"
func (n *TerminalDevice_Channel_Ethernet_EsnrPath) Min() *TerminalDevice_Channel_Ethernet_Esnr_MinPath {
	return &TerminalDevice_Channel_Ethernet_Esnr_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/min"
func (n *TerminalDevice_Channel_Ethernet_EsnrPathAny) Min() *TerminalDevice_Channel_Ethernet_Esnr_MinPathAny {
	return &TerminalDevice_Channel_Ethernet_Esnr_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/min-time"
func (n *TerminalDevice_Channel_Ethernet_EsnrPath) MinTime() *TerminalDevice_Channel_Ethernet_Esnr_MinTimePath {
	return &TerminalDevice_Channel_Ethernet_Esnr_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/esnr/min-time"
func (n *TerminalDevice_Channel_Ethernet_EsnrPathAny) MinTime() *TerminalDevice_Channel_Ethernet_Esnr_MinTimePathAny {
	return &TerminalDevice_Channel_Ethernet_Esnr_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Ethernet_LldpPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp YANG schema element.
type TerminalDevice_Channel_Ethernet_LldpPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_LldpPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp YANG schema element.
type TerminalDevice_Channel_Ethernet_LldpPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_EnabledPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/config/enabled YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_EnabledPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_EnabledPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/config/enabled YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_EnabledPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_SnoopingPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/config/snooping YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_SnoopingPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_SnoopingPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/config/snooping YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_SnoopingPathAny struct {
	*ygot.NodePath
}

// Counters (container): LLDP counters on each interface
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/counters"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters"
func (n *TerminalDevice_Channel_Ethernet_LldpPath) Counters() *TerminalDevice_Channel_Ethernet_Lldp_CountersPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_CountersPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Counters (container): LLDP counters on each interface
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/counters"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters"
func (n *TerminalDevice_Channel_Ethernet_LldpPathAny) Counters() *TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "counters"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enable or disable the LLDP protocol on the logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/enabled"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/config/enabled"
func (n *TerminalDevice_Channel_Ethernet_LldpPath) Enabled() *TerminalDevice_Channel_Ethernet_Lldp_EnabledPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_EnabledPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// Enabled (leaf): Enable or disable the LLDP protocol on the logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/enabled"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/config/enabled"
func (n *TerminalDevice_Channel_Ethernet_LldpPathAny) Enabled() *TerminalDevice_Channel_Ethernet_Lldp_EnabledPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_EnabledPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "enabled"},
			map[string]interface{}{},
			n,
		),
	}
}

// NeighborAny (list): List of LLDP neighbors. If the implementation only
// supports one neighbor, this would always be a list with
// one item. If the device and neighbor supported multiple
// neighbors, which can be achieved via LLDP forwarding, then
// this would be supported
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "neighbors/neighbor"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor"
// Id (wildcarded): string
func (n *TerminalDevice_Channel_Ethernet_LldpPath) NeighborAny() *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// NeighborAny (list): List of LLDP neighbors. If the implementation only
// supports one neighbor, this would always be a list with
// one item. If the device and neighbor supported multiple
// neighbors, which can be achieved via LLDP forwarding, then
// this would be supported
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "neighbors/neighbor"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor"
// Id (wildcarded): string
func (n *TerminalDevice_Channel_Ethernet_LldpPathAny) NeighborAny() *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"id": "*"},
			n,
		),
	}
}

// Neighbor (list): List of LLDP neighbors. If the implementation only
// supports one neighbor, this would always be a list with
// one item. If the device and neighbor supported multiple
// neighbors, which can be achieved via LLDP forwarding, then
// this would be supported
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "neighbors/neighbor"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor"
// Id: string
func (n *TerminalDevice_Channel_Ethernet_LldpPath) Neighbor(Id string) *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_NeighborPath{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Neighbor (list): List of LLDP neighbors. If the implementation only
// supports one neighbor, this would always be a list with
// one item. If the device and neighbor supported multiple
// neighbors, which can be achieved via LLDP forwarding, then
// this would be supported
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "neighbors/neighbor"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor"
// Id: string
func (n *TerminalDevice_Channel_Ethernet_LldpPathAny) Neighbor(Id string) *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"neighbors", "neighbor"},
			map[string]interface{}{"id": Id},
			n,
		),
	}
}

// Snooping (leaf): If true, LLDP PDUs are only received and processed on
// the logical-channel, but are not originated by the local
// agent. The PDUs are not dropped by the logical channel after
// processing, but relayed to the downstream link layer
// neighbors. The snooping mode is valid only when LLDP is
// enabled on the logical channel. The snooping mode is useful
// when a logical channel does not want its link layer neighbors
// to discover itself since, for example, it is a lower-layer
// logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/snooping"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/config/snooping"
func (n *TerminalDevice_Channel_Ethernet_LldpPath) Snooping() *TerminalDevice_Channel_Ethernet_Lldp_SnoopingPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_SnoopingPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "snooping"},
			map[string]interface{}{},
			n,
		),
	}
}

// Snooping (leaf): If true, LLDP PDUs are only received and processed on
// the logical-channel, but are not originated by the local
// agent. The PDUs are not dropped by the logical channel after
// processing, but relayed to the downstream link layer
// neighbors. The snooping mode is valid only when LLDP is
// enabled on the logical channel. The snooping mode is useful
// when a logical channel does not want its link layer neighbors
// to discover itself since, for example, it is a lower-layer
// logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/snooping"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/config/snooping"
func (n *TerminalDevice_Channel_Ethernet_LldpPathAny) Snooping() *TerminalDevice_Channel_Ethernet_Lldp_SnoopingPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_SnoopingPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "snooping"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Ethernet_Lldp_CountersPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_CountersPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameDiscardPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-discard YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameDiscardPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameDiscardPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-discard YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameDiscardPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorInPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-error-in YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorInPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorInPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-error-in YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorInPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorOutPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-error-out YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorOutPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorOutPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-error-out YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorOutPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameInPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-in YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameInPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameInPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-in YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameInPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameOutPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-out YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameOutPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameOutPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-out YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameOutPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_LastClearPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/last-clear YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_LastClearPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_LastClearPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/last-clear YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_LastClearPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvDiscardPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/tlv-discard YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvDiscardPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvDiscardPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/tlv-discard YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvDiscardPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvUnknownPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/tlv-unknown YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvUnknownPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvUnknownPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/tlv-unknown YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvUnknownPathAny struct {
	*ygot.NodePath
}

// FrameDiscard (leaf): The number of LLDP frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-discard"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-discard"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPath) FrameDiscard() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameDiscardPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameDiscardPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameDiscard (leaf): The number of LLDP frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-discard"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-discard"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny) FrameDiscard() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameDiscardPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameDiscardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorIn (leaf): The number of LLDP frames received with errors.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-error-in"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-error-in"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPath) FrameErrorIn() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorInPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorInPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorIn (leaf): The number of LLDP frames received with errors.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-error-in"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-error-in"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny) FrameErrorIn() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorInPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorOut (leaf): The number of frame transmit errors on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-error-out"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-error-out"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPath) FrameErrorOut() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorOutPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorOutPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameErrorOut (leaf): The number of frame transmit errors on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-error-out"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-error-out"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny) FrameErrorOut() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorOutPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameErrorOutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-error-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameIn (leaf): The number of lldp frames received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-in"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-in"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPath) FrameIn() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameInPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameInPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameIn (leaf): The number of lldp frames received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-in"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-in"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny) FrameIn() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameInPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameInPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-in"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameOut (leaf): The number of frames transmitted out.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-out"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-out"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPath) FrameOut() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameOutPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameOutPath{
		NodePath: ygot.NewNodePath(
			[]string{"frame-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// FrameOut (leaf): The number of frames transmitted out.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "frame-out"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/frame-out"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny) FrameOut() *TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameOutPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_FrameOutPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"frame-out"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Indicates the last time the counters were
// cleared.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "last-clear"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/last-clear"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPath) LastClear() *TerminalDevice_Channel_Ethernet_Lldp_Counters_LastClearPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_LastClearPath{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastClear (leaf): Indicates the last time the counters were
// cleared.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "last-clear"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/last-clear"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny) LastClear() *TerminalDevice_Channel_Ethernet_Lldp_Counters_LastClearPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_LastClearPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"last-clear"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvDiscard (leaf): The number of TLV frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "tlv-discard"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/tlv-discard"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPath) TlvDiscard() *TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvDiscardPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvDiscardPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvDiscard (leaf): The number of TLV frames received and discarded.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "tlv-discard"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/tlv-discard"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny) TlvDiscard() *TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvDiscardPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvDiscardPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-discard"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvUnknown (leaf): The number of frames received with unknown TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "tlv-unknown"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/tlv-unknown"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPath) TlvUnknown() *TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvUnknownPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvUnknownPath{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-unknown"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvUnknown (leaf): The number of frames received with unknown TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "tlv-unknown"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/state/counters/tlv-unknown"
func (n *TerminalDevice_Channel_Ethernet_Lldp_CountersPathAny) TlvUnknown() *TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvUnknownPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Counters_TlvUnknownPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"tlv-unknown"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Ethernet_Lldp_NeighborPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_NeighborPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_AgePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/age YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_AgePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_AgePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/age YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_AgePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/chassis-id YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/chassis-id YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdTypePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/chassis-id-type YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdTypePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdTypePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/chassis-id-type YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdTypePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_IdPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/id YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_IdPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_IdPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/id YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_IdPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_LastUpdatePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/last-update YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_LastUpdatePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_LastUpdatePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/last-update YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_LastUpdatePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/management-address YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/management-address YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressTypePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/management-address-type YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressTypePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressTypePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/management-address-type YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressTypePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortDescriptionPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-description YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortDescriptionPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortDescriptionPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-description YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortDescriptionPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-id YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-id YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdTypePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-id-type YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdTypePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdTypePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-id-type YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdTypePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemDescriptionPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/system-description YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemDescriptionPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemDescriptionPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/system-description YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemDescriptionPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemNamePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/system-name YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemNamePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemNamePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/system-name YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemNamePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TtlPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/ttl YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TtlPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TtlPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/ttl YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TtlPathAny struct {
	*ygot.NodePath
}

// Age (leaf): Age since discovery
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/age"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/age"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) Age() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_AgePath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_AgePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "age"},
			map[string]interface{}{},
			n,
		),
	}
}

// Age (leaf): Age since discovery
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/age"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/age"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) Age() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_AgePathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_AgePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "age"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisId (leaf): The Chassis ID is a mandatory TLV which identifies the
// chassis component of the endpoint identifier associated with
// the transmitting LLDP agent
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/chassis-id"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/chassis-id"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) ChassisId() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chassis-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisId (leaf): The Chassis ID is a mandatory TLV which identifies the
// chassis component of the endpoint identifier associated with
// the transmitting LLDP agent
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/chassis-id"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/chassis-id"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) ChassisId() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chassis-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisIdType (leaf): This field identifies the format and source of the chassis
// identifier string. It is an enumerator defined by the
// LldpChassisIdSubtype object from IEEE 802.1AB MIB.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/chassis-id-type"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/chassis-id-type"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) ChassisIdType() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdTypePath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chassis-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// ChassisIdType (leaf): This field identifies the format and source of the chassis
// identifier string. It is an enumerator defined by the
// LldpChassisIdSubtype object from IEEE 802.1AB MIB.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/chassis-id-type"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/chassis-id-type"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) ChassisIdType() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdTypePathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ChassisIdTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "chassis-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): System generated identifier for the neighbor on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/id"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/id"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) Id() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_IdPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_IdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// Id (leaf): System generated identifier for the neighbor on the
// interface.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/id"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/id"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) Id() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_IdPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_IdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "id"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastUpdate (leaf): Seconds since last update received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/last-update"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/last-update"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) LastUpdate() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_LastUpdatePath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_LastUpdatePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-update"},
			map[string]interface{}{},
			n,
		),
	}
}

// LastUpdate (leaf): Seconds since last update received.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/last-update"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/last-update"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) LastUpdate() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_LastUpdatePathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_LastUpdatePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "last-update"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManagementAddress (leaf): The Management Address is a mandatory TLV which identifies a
// network address associated with the local LLDP agent, which
// can be used to reach the agent on the port identified in the
// Port ID TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/management-address"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/management-address"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) ManagementAddress() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManagementAddress (leaf): The Management Address is a mandatory TLV which identifies a
// network address associated with the local LLDP agent, which
// can be used to reach the agent on the port identified in the
// Port ID TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/management-address"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/management-address"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) ManagementAddress() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management-address"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManagementAddressType (leaf): The enumerated value for the network address type
// identified in this TLV. This enumeration is defined in the
// 'Assigned Numbers' RFC [RFC3232] and the
// ianaAddressFamilyNumbers object.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/management-address-type"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/management-address-type"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) ManagementAddressType() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressTypePath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management-address-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// ManagementAddressType (leaf): The enumerated value for the network address type
// identified in this TLV. This enumeration is defined in the
// 'Assigned Numbers' RFC [RFC3232] and the
// ianaAddressFamilyNumbers object.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/management-address-type"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/management-address-type"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) ManagementAddressType() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressTypePathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_ManagementAddressTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "management-address-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortDescription (leaf): The binary string containing the actual port identifier for
// the port which this LLDP PDU was transmitted. The source and
// format of this field is defined by PtopoPortId from
// RFC2922.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/port-description"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-description"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) PortDescription() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortDescriptionPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortDescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortDescription (leaf): The binary string containing the actual port identifier for
// the port which this LLDP PDU was transmitted. The source and
// format of this field is defined by PtopoPortId from
// RFC2922.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/port-description"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-description"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) PortDescription() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortDescriptionPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortDescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortId (leaf): The Port ID is a mandatory TLV which identifies the port
// component of the endpoint identifier associated with the
// transmitting LLDP agent. If the specified port is an IEEE
// 802.3 Repeater port, then this TLV is optional.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/port-id"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-id"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) PortId() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortId (leaf): The Port ID is a mandatory TLV which identifies the port
// component of the endpoint identifier associated with the
// transmitting LLDP agent. If the specified port is an IEEE
// 802.3 Repeater port, then this TLV is optional.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/port-id"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-id"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) PortId() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortIdType (leaf): This field identifies the format and source of the port
// identifier string. It is an enumerator defined by the
// PtopoPortIdType object from RFC2922.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/port-id-type"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-id-type"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) PortIdType() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdTypePath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdTypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// PortIdType (leaf): This field identifies the format and source of the port
// identifier string. It is an enumerator defined by the
// PtopoPortIdType object from RFC2922.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/port-id-type"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/port-id-type"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) PortIdType() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdTypePathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_PortIdTypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "port-id-type"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemDescription (leaf): The system description field shall contain an alpha-numeric
// string that is the textual description of the network entity.
// The system description should include the full name and
// version identification of the system's hardware type,
// software operating system, and networking software. If
// implementations support IETF RFC 3418, the sysDescr object
// should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/system-description"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/system-description"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) SystemDescription() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemDescriptionPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemDescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemDescription (leaf): The system description field shall contain an alpha-numeric
// string that is the textual description of the network entity.
// The system description should include the full name and
// version identification of the system's hardware type,
// software operating system, and networking software. If
// implementations support IETF RFC 3418, the sysDescr object
// should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/system-description"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/system-description"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) SystemDescription() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemDescriptionPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemDescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-description"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemName (leaf): The system name field shall contain an alpha-numeric string
// that indicates the system's administratively assigned name.
// The system name should be the system's fully qualified domain
// name. If implementations support IETF RFC 3418, the sysName
// object should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/system-name"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/system-name"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) SystemName() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemNamePath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemNamePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// SystemName (leaf): The system name field shall contain an alpha-numeric string
// that indicates the system's administratively assigned name.
// The system name should be the system's fully qualified domain
// name. If implementations support IETF RFC 3418, the sysName
// object should be used for this field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/system-name"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/system-name"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) SystemName() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemNamePathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_SystemNamePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "system-name"},
			map[string]interface{}{},
			n,
		),
	}
}

// TlvAny (list): List of custom LLDP TLVs from a neighbor
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "custom-tlvs/tlv"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) TlvAny() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"custom-tlvs", "tlv"},
			map[string]interface{}{"type": "*", "oui": "*", "oui-subtype": "*"},
			n,
		),
	}
}

// TlvAny (list): List of custom LLDP TLVs from a neighbor
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "custom-tlvs/tlv"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) TlvAny() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"custom-tlvs", "tlv"},
			map[string]interface{}{"type": "*", "oui": "*", "oui-subtype": "*"},
			n,
		),
	}
}

// WithType sets TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny's key "type" to the specified value.
// Type: int32
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny) WithType(Type int32) *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny {
	ygot.ModifyKey(n.NodePath, "type", Type)
	return n
}

// WithOui sets TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny's key "oui" to the specified value.
// Oui: string
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny) WithOui(Oui string) *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny {
	ygot.ModifyKey(n.NodePath, "oui", Oui)
	return n
}

// WithOuiSubtype sets TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny's key "oui-subtype" to the specified value.
// OuiSubtype: string
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny) WithOuiSubtype(OuiSubtype string) *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny {
	ygot.ModifyKey(n.NodePath, "oui-subtype", OuiSubtype)
	return n
}

// Ttl (leaf): The time-to-live (TTL) is a mandatory TLV which indicates
// how long information from the neighbor should be considered
// valid.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/ttl"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/ttl"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPath) Ttl() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TtlPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TtlPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// Ttl (leaf): The time-to-live (TTL) is a mandatory TLV which indicates
// how long information from the neighbor should be considered
// valid.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/ttl"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/state/ttl"
func (n *TerminalDevice_Channel_Ethernet_Lldp_NeighborPathAny) Ttl() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TtlPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TtlPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "ttl"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/oui YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/oui YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiSubtypePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/oui-subtype YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiSubtypePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiSubtypePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/oui-subtype YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiSubtypePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_TypePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/type YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_TypePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_TypePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/type YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_TypePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_ValuePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/value YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_ValuePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_ValuePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/value YANG schema element.
type TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_ValuePathAny struct {
	*ygot.NodePath
}

// Oui (leaf): The organizationally unique identifier field shall contain
// the organization's OUI as defined in Clause 9 of IEEE Std
// 802. The high-order octet is 0 and the low-order 3 octets
// are the SMI Network Management Private Enterprise Code of
// the Vendor in network byte order, as defined in the
// 'Assigned Numbers' RFC [RFC3232].
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/oui"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/oui"
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPath) Oui() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiPath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oui"},
			map[string]interface{}{},
			n,
		),
	}
}

// Oui (leaf): The organizationally unique identifier field shall contain
// the organization's OUI as defined in Clause 9 of IEEE Std
// 802. The high-order octet is 0 and the low-order 3 octets
// are the SMI Network Management Private Enterprise Code of
// the Vendor in network byte order, as defined in the
// 'Assigned Numbers' RFC [RFC3232].
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/oui"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/oui"
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny) Oui() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiPathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oui"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuiSubtype (leaf): The organizationally defined subtype field shall contain a
// unique subtype value assigned by the defining organization.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/oui-subtype"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/oui-subtype"
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPath) OuiSubtype() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiSubtypePath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiSubtypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oui-subtype"},
			map[string]interface{}{},
			n,
		),
	}
}

// OuiSubtype (leaf): The organizationally defined subtype field shall contain a
// unique subtype value assigned by the defining organization.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/oui-subtype"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/oui-subtype"
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny) OuiSubtype() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiSubtypePathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_OuiSubtypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "oui-subtype"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The integer value identifying the type of information
// contained in the value field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/type"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/type"
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPath) Type() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_TypePath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_TypePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Type (leaf): The integer value identifying the type of information
// contained in the value field.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/type"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/type"
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny) Type() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_TypePathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_TypePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "type"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): A variable-length octet-string containing the
// instance-specific information for this TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/value"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/value"
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPath) Value() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_ValuePath {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_ValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// Value (leaf): A variable-length octet-string containing the
// instance-specific information for this TLV.
// ----------------------------------------
// Defining module: "openconfig-lldp"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/value"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/lldp/neighbors/neighbor/custom-tlvs/tlv/state/value"
func (n *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_TlvPathAny) Value() *TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_ValuePathAny {
	return &TerminalDevice_Channel_Ethernet_Lldp_Neighbor_Tlv_ValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "value"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Ethernet_PostFecBerPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBerPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBerPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBerPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_AvgPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/avg YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_AvgPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_AvgPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/avg YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_AvgPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_InstantPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/instant YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_InstantPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_InstantPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/instant YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_InstantPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_IntervalPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/interval YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_IntervalPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_IntervalPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/interval YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_IntervalPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_MaxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/max YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_MaxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_MaxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/max YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_MaxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_MaxTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/max-time YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_MaxTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_MaxTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/max-time YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_MaxTimePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_MinPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/min YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_MinPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_MinPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/min YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_MinPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_MinTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/min-time YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_MinTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PostFecBer_MinTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/min-time YANG schema element.
type TerminalDevice_Channel_Ethernet_PostFecBer_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/avg"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPath) Avg() *TerminalDevice_Channel_Ethernet_PostFecBer_AvgPath {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/avg"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPathAny) Avg() *TerminalDevice_Channel_Ethernet_PostFecBer_AvgPathAny {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/instant"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPath) Instant() *TerminalDevice_Channel_Ethernet_PostFecBer_InstantPath {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/instant"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPathAny) Instant() *TerminalDevice_Channel_Ethernet_PostFecBer_InstantPathAny {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/interval"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPath) Interval() *TerminalDevice_Channel_Ethernet_PostFecBer_IntervalPath {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/interval"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPathAny) Interval() *TerminalDevice_Channel_Ethernet_PostFecBer_IntervalPathAny {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/max"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPath) Max() *TerminalDevice_Channel_Ethernet_PostFecBer_MaxPath {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/max"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPathAny) Max() *TerminalDevice_Channel_Ethernet_PostFecBer_MaxPathAny {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/max-time"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPath) MaxTime() *TerminalDevice_Channel_Ethernet_PostFecBer_MaxTimePath {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/max-time"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPathAny) MaxTime() *TerminalDevice_Channel_Ethernet_PostFecBer_MaxTimePathAny {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/min"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPath) Min() *TerminalDevice_Channel_Ethernet_PostFecBer_MinPath {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/min"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPathAny) Min() *TerminalDevice_Channel_Ethernet_PostFecBer_MinPathAny {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/min-time"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPath) MinTime() *TerminalDevice_Channel_Ethernet_PostFecBer_MinTimePath {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/post-fec-ber/min-time"
func (n *TerminalDevice_Channel_Ethernet_PostFecBerPathAny) MinTime() *TerminalDevice_Channel_Ethernet_PostFecBer_MinTimePathAny {
	return &TerminalDevice_Channel_Ethernet_PostFecBer_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Ethernet_PreFecBerPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBerPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBerPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBerPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_AvgPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/avg YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_AvgPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_AvgPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/avg YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_AvgPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_InstantPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/instant YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_InstantPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_InstantPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/instant YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_InstantPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_IntervalPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/interval YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_IntervalPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_IntervalPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/interval YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_IntervalPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_MaxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/max YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_MaxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_MaxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/max YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_MaxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_MaxTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/max-time YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_MaxTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_MaxTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/max-time YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_MaxTimePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_MinPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/min YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_MinPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_MinPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/min YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_MinPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_MinTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/min-time YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_MinTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_PreFecBer_MinTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/min-time YANG schema element.
type TerminalDevice_Channel_Ethernet_PreFecBer_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/avg"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPath) Avg() *TerminalDevice_Channel_Ethernet_PreFecBer_AvgPath {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/avg"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPathAny) Avg() *TerminalDevice_Channel_Ethernet_PreFecBer_AvgPathAny {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/instant"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPath) Instant() *TerminalDevice_Channel_Ethernet_PreFecBer_InstantPath {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/instant"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPathAny) Instant() *TerminalDevice_Channel_Ethernet_PreFecBer_InstantPathAny {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/interval"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPath) Interval() *TerminalDevice_Channel_Ethernet_PreFecBer_IntervalPath {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/interval"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPathAny) Interval() *TerminalDevice_Channel_Ethernet_PreFecBer_IntervalPathAny {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/max"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPath) Max() *TerminalDevice_Channel_Ethernet_PreFecBer_MaxPath {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/max"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPathAny) Max() *TerminalDevice_Channel_Ethernet_PreFecBer_MaxPathAny {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/max-time"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPath) MaxTime() *TerminalDevice_Channel_Ethernet_PreFecBer_MaxTimePath {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/max-time"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPathAny) MaxTime() *TerminalDevice_Channel_Ethernet_PreFecBer_MaxTimePathAny {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/min"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPath) Min() *TerminalDevice_Channel_Ethernet_PreFecBer_MinPath {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/min"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPathAny) Min() *TerminalDevice_Channel_Ethernet_PreFecBer_MinPathAny {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/min-time"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPath) MinTime() *TerminalDevice_Channel_Ethernet_PreFecBer_MinTimePath {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/pre-fec-ber/min-time"
func (n *TerminalDevice_Channel_Ethernet_PreFecBerPathAny) MinTime() *TerminalDevice_Channel_Ethernet_PreFecBer_MinTimePathAny {
	return &TerminalDevice_Channel_Ethernet_PreFecBer_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Ethernet_QValuePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value YANG schema element.
type TerminalDevice_Channel_Ethernet_QValuePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValuePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value YANG schema element.
type TerminalDevice_Channel_Ethernet_QValuePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_AvgPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/avg YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_AvgPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_AvgPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/avg YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_AvgPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_InstantPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/instant YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_InstantPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_InstantPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/instant YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_InstantPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_IntervalPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/interval YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_IntervalPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_IntervalPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/interval YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_IntervalPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_MaxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/max YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_MaxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_MaxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/max YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_MaxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_MaxTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/max-time YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_MaxTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_MaxTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/max-time YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_MaxTimePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_MinPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/min YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_MinPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_MinPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/min YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_MinPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_MinTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/min-time YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_MinTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ethernet_QValue_MinTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ethernet/state/q-value/min-time YANG schema element.
type TerminalDevice_Channel_Ethernet_QValue_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/avg"
func (n *TerminalDevice_Channel_Ethernet_QValuePath) Avg() *TerminalDevice_Channel_Ethernet_QValue_AvgPath {
	return &TerminalDevice_Channel_Ethernet_QValue_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/avg"
func (n *TerminalDevice_Channel_Ethernet_QValuePathAny) Avg() *TerminalDevice_Channel_Ethernet_QValue_AvgPathAny {
	return &TerminalDevice_Channel_Ethernet_QValue_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/instant"
func (n *TerminalDevice_Channel_Ethernet_QValuePath) Instant() *TerminalDevice_Channel_Ethernet_QValue_InstantPath {
	return &TerminalDevice_Channel_Ethernet_QValue_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/instant"
func (n *TerminalDevice_Channel_Ethernet_QValuePathAny) Instant() *TerminalDevice_Channel_Ethernet_QValue_InstantPathAny {
	return &TerminalDevice_Channel_Ethernet_QValue_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/interval"
func (n *TerminalDevice_Channel_Ethernet_QValuePath) Interval() *TerminalDevice_Channel_Ethernet_QValue_IntervalPath {
	return &TerminalDevice_Channel_Ethernet_QValue_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/interval"
func (n *TerminalDevice_Channel_Ethernet_QValuePathAny) Interval() *TerminalDevice_Channel_Ethernet_QValue_IntervalPathAny {
	return &TerminalDevice_Channel_Ethernet_QValue_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/max"
func (n *TerminalDevice_Channel_Ethernet_QValuePath) Max() *TerminalDevice_Channel_Ethernet_QValue_MaxPath {
	return &TerminalDevice_Channel_Ethernet_QValue_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/max"
func (n *TerminalDevice_Channel_Ethernet_QValuePathAny) Max() *TerminalDevice_Channel_Ethernet_QValue_MaxPathAny {
	return &TerminalDevice_Channel_Ethernet_QValue_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/max-time"
func (n *TerminalDevice_Channel_Ethernet_QValuePath) MaxTime() *TerminalDevice_Channel_Ethernet_QValue_MaxTimePath {
	return &TerminalDevice_Channel_Ethernet_QValue_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/max-time"
func (n *TerminalDevice_Channel_Ethernet_QValuePathAny) MaxTime() *TerminalDevice_Channel_Ethernet_QValue_MaxTimePathAny {
	return &TerminalDevice_Channel_Ethernet_QValue_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/min"
func (n *TerminalDevice_Channel_Ethernet_QValuePath) Min() *TerminalDevice_Channel_Ethernet_QValue_MinPath {
	return &TerminalDevice_Channel_Ethernet_QValue_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/min"
func (n *TerminalDevice_Channel_Ethernet_QValuePathAny) Min() *TerminalDevice_Channel_Ethernet_QValue_MinPathAny {
	return &TerminalDevice_Channel_Ethernet_QValue_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/min-time"
func (n *TerminalDevice_Channel_Ethernet_QValuePath) MinTime() *TerminalDevice_Channel_Ethernet_QValue_MinTimePath {
	return &TerminalDevice_Channel_Ethernet_QValue_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/ethernet/state/q-value/min-time"
func (n *TerminalDevice_Channel_Ethernet_QValuePathAny) MinTime() *TerminalDevice_Channel_Ethernet_QValue_MinTimePathAny {
	return &TerminalDevice_Channel_Ethernet_QValue_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_IngressPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ingress YANG schema element.
type TerminalDevice_Channel_IngressPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_IngressPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ingress YANG schema element.
type TerminalDevice_Channel_IngressPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ingress_InterfacePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ingress/config/interface YANG schema element.
type TerminalDevice_Channel_Ingress_InterfacePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ingress_InterfacePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ingress/config/interface YANG schema element.
type TerminalDevice_Channel_Ingress_InterfacePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ingress_PhysicalChannelPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ingress/config/physical-channel YANG schema element.
type TerminalDevice_Channel_Ingress_PhysicalChannelPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ingress_PhysicalChannelPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ingress/config/physical-channel YANG schema element.
type TerminalDevice_Channel_Ingress_PhysicalChannelPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ingress_TransceiverPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/ingress/config/transceiver YANG schema element.
type TerminalDevice_Channel_Ingress_TransceiverPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Ingress_TransceiverPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/ingress/config/transceiver YANG schema element.
type TerminalDevice_Channel_Ingress_TransceiverPathAny struct {
	*ygot.NodePath
}

// Interface (leaf): Reference to the interface carrying the input signal
// for the logical channel. The ingress will specify an interface
// in the case of a transceiver being utilized directly in a
// router and bypassing a dedicated terminal device. When
// specified, the other leaves in the ingress config must be
// empty.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/interface"
// Path from root: "/terminal-device/logical-channels/channel/ingress/config/interface"
func (n *TerminalDevice_Channel_IngressPath) Interface() *TerminalDevice_Channel_Ingress_InterfacePath {
	return &TerminalDevice_Channel_Ingress_InterfacePath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interface (leaf): Reference to the interface carrying the input signal
// for the logical channel. The ingress will specify an interface
// in the case of a transceiver being utilized directly in a
// router and bypassing a dedicated terminal device. When
// specified, the other leaves in the ingress config must be
// empty.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/interface"
// Path from root: "/terminal-device/logical-channels/channel/ingress/config/interface"
func (n *TerminalDevice_Channel_IngressPathAny) Interface() *TerminalDevice_Channel_Ingress_InterfacePathAny {
	return &TerminalDevice_Channel_Ingress_InterfacePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "interface"},
			map[string]interface{}{},
			n,
		),
	}
}

// PhysicalChannel (leaf): This list should be populated with references
// to the client physical channels that feed this logical
// channel from the transceiver specified in the 'transceiver'
// leaf, which must be specified.  If this leaf-list is empty,
// all physical channels in the transceiver are assumed to be
// mapped to the logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/physical-channel"
// Path from root: "/terminal-device/logical-channels/channel/ingress/config/physical-channel"
func (n *TerminalDevice_Channel_IngressPath) PhysicalChannel() *TerminalDevice_Channel_Ingress_PhysicalChannelPath {
	return &TerminalDevice_Channel_Ingress_PhysicalChannelPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "physical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// PhysicalChannel (leaf): This list should be populated with references
// to the client physical channels that feed this logical
// channel from the transceiver specified in the 'transceiver'
// leaf, which must be specified.  If this leaf-list is empty,
// all physical channels in the transceiver are assumed to be
// mapped to the logical channel.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/physical-channel"
// Path from root: "/terminal-device/logical-channels/channel/ingress/config/physical-channel"
func (n *TerminalDevice_Channel_IngressPathAny) PhysicalChannel() *TerminalDevice_Channel_Ingress_PhysicalChannelPathAny {
	return &TerminalDevice_Channel_Ingress_PhysicalChannelPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "physical-channel"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transceiver (leaf): Reference to the transceiver carrying the input signal
// for the logical channel.  If specific physical channels
// are mapped to the logical channel (as opposed to all
// physical channels carried by the transceiver), they can be
// specified in the list of physical channel references.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/transceiver"
// Path from root: "/terminal-device/logical-channels/channel/ingress/config/transceiver"
func (n *TerminalDevice_Channel_IngressPath) Transceiver() *TerminalDevice_Channel_Ingress_TransceiverPath {
	return &TerminalDevice_Channel_Ingress_TransceiverPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "transceiver"},
			map[string]interface{}{},
			n,
		),
	}
}

// Transceiver (leaf): Reference to the transceiver carrying the input signal
// for the logical channel.  If specific physical channels
// are mapped to the logical channel (as opposed to all
// physical channels carried by the transceiver), they can be
// specified in the list of physical channel references.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/transceiver"
// Path from root: "/terminal-device/logical-channels/channel/ingress/config/transceiver"
func (n *TerminalDevice_Channel_IngressPathAny) Transceiver() *TerminalDevice_Channel_Ingress_TransceiverPathAny {
	return &TerminalDevice_Channel_Ingress_TransceiverPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "transceiver"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_OtnPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn YANG schema element.
type TerminalDevice_Channel_OtnPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_OtnPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn YANG schema element.
type TerminalDevice_Channel_OtnPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_BackgroundBlockErrorsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/background-block-errors YANG schema element.
type TerminalDevice_Channel_Otn_BackgroundBlockErrorsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_BackgroundBlockErrorsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/background-block-errors YANG schema element.
type TerminalDevice_Channel_Otn_BackgroundBlockErrorsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_CodeViolationsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/code-violations YANG schema element.
type TerminalDevice_Channel_Otn_CodeViolationsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_CodeViolationsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/code-violations YANG schema element.
type TerminalDevice_Channel_Otn_CodeViolationsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_ErroredBlocksPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/errored-blocks YANG schema element.
type TerminalDevice_Channel_Otn_ErroredBlocksPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_ErroredBlocksPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/errored-blocks YANG schema element.
type TerminalDevice_Channel_Otn_ErroredBlocksPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_ErroredSecondsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/errored-seconds YANG schema element.
type TerminalDevice_Channel_Otn_ErroredSecondsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_ErroredSecondsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/errored-seconds YANG schema element.
type TerminalDevice_Channel_Otn_ErroredSecondsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_FecCorrectedBitsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/fec-corrected-bits YANG schema element.
type TerminalDevice_Channel_Otn_FecCorrectedBitsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_FecCorrectedBitsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/fec-corrected-bits YANG schema element.
type TerminalDevice_Channel_Otn_FecCorrectedBitsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_FecCorrectedBytesPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/fec-corrected-bytes YANG schema element.
type TerminalDevice_Channel_Otn_FecCorrectedBytesPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_FecCorrectedBytesPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/fec-corrected-bytes YANG schema element.
type TerminalDevice_Channel_Otn_FecCorrectedBytesPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_FecUncorrectableBlocksPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/fec-uncorrectable-blocks YANG schema element.
type TerminalDevice_Channel_Otn_FecUncorrectableBlocksPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_FecUncorrectableBlocksPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/fec-uncorrectable-blocks YANG schema element.
type TerminalDevice_Channel_Otn_FecUncorrectableBlocksPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_FecUncorrectableWordsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/fec-uncorrectable-words YANG schema element.
type TerminalDevice_Channel_Otn_FecUncorrectableWordsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_FecUncorrectableWordsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/fec-uncorrectable-words YANG schema element.
type TerminalDevice_Channel_Otn_FecUncorrectableWordsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_RdiMsgPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/rdi-msg YANG schema element.
type TerminalDevice_Channel_Otn_RdiMsgPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_RdiMsgPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/rdi-msg YANG schema element.
type TerminalDevice_Channel_Otn_RdiMsgPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_SeverelyErroredSecondsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/severely-errored-seconds YANG schema element.
type TerminalDevice_Channel_Otn_SeverelyErroredSecondsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_SeverelyErroredSecondsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/severely-errored-seconds YANG schema element.
type TerminalDevice_Channel_Otn_SeverelyErroredSecondsPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TributarySlotGranularityPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/config/tributary-slot-granularity YANG schema element.
type TerminalDevice_Channel_Otn_TributarySlotGranularityPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TributarySlotGranularityPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/config/tributary-slot-granularity YANG schema element.
type TerminalDevice_Channel_Otn_TributarySlotGranularityPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TtiMsgAutoPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/config/tti-msg-auto YANG schema element.
type TerminalDevice_Channel_Otn_TtiMsgAutoPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TtiMsgAutoPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/config/tti-msg-auto YANG schema element.
type TerminalDevice_Channel_Otn_TtiMsgAutoPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TtiMsgExpectedPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/config/tti-msg-expected YANG schema element.
type TerminalDevice_Channel_Otn_TtiMsgExpectedPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TtiMsgExpectedPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/config/tti-msg-expected YANG schema element.
type TerminalDevice_Channel_Otn_TtiMsgExpectedPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TtiMsgRecvPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/tti-msg-recv YANG schema element.
type TerminalDevice_Channel_Otn_TtiMsgRecvPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TtiMsgRecvPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/tti-msg-recv YANG schema element.
type TerminalDevice_Channel_Otn_TtiMsgRecvPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TtiMsgTransmitPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/config/tti-msg-transmit YANG schema element.
type TerminalDevice_Channel_Otn_TtiMsgTransmitPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_TtiMsgTransmitPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/config/tti-msg-transmit YANG schema element.
type TerminalDevice_Channel_Otn_TtiMsgTransmitPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_UnavailableSecondsPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/unavailable-seconds YANG schema element.
type TerminalDevice_Channel_Otn_UnavailableSecondsPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_UnavailableSecondsPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/unavailable-seconds YANG schema element.
type TerminalDevice_Channel_Otn_UnavailableSecondsPathAny struct {
	*ygot.NodePath
}

// BackgroundBlockErrors (leaf): The number of background block errors
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/background-block-errors"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/background-block-errors"
func (n *TerminalDevice_Channel_OtnPath) BackgroundBlockErrors() *TerminalDevice_Channel_Otn_BackgroundBlockErrorsPath {
	return &TerminalDevice_Channel_Otn_BackgroundBlockErrorsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "background-block-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// BackgroundBlockErrors (leaf): The number of background block errors
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/background-block-errors"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/background-block-errors"
func (n *TerminalDevice_Channel_OtnPathAny) BackgroundBlockErrors() *TerminalDevice_Channel_Otn_BackgroundBlockErrorsPathAny {
	return &TerminalDevice_Channel_Otn_BackgroundBlockErrorsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "background-block-errors"},
			map[string]interface{}{},
			n,
		),
	}
}

// CodeViolations (leaf): For ethernet or fiberchannel links, the number of 8b/10b
// coding violations. For SONET/SDH, the number of BIP (bit
// interleaved parity) errors
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/code-violations"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/code-violations"
func (n *TerminalDevice_Channel_OtnPath) CodeViolations() *TerminalDevice_Channel_Otn_CodeViolationsPath {
	return &TerminalDevice_Channel_Otn_CodeViolationsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "code-violations"},
			map[string]interface{}{},
			n,
		),
	}
}

// CodeViolations (leaf): For ethernet or fiberchannel links, the number of 8b/10b
// coding violations. For SONET/SDH, the number of BIP (bit
// interleaved parity) errors
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/code-violations"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/code-violations"
func (n *TerminalDevice_Channel_OtnPathAny) CodeViolations() *TerminalDevice_Channel_Otn_CodeViolationsPathAny {
	return &TerminalDevice_Channel_Otn_CodeViolationsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "code-violations"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErroredBlocks (leaf): The number of errored blocks. Error detection codes are
// capable to detect whether one or more errors have occurred
// in a given sequence of bits – the block. It is normally not
// possible to determine the exact number of errored bits within
// the block.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/errored-blocks"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/errored-blocks"
func (n *TerminalDevice_Channel_OtnPath) ErroredBlocks() *TerminalDevice_Channel_Otn_ErroredBlocksPath {
	return &TerminalDevice_Channel_Otn_ErroredBlocksPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "errored-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErroredBlocks (leaf): The number of errored blocks. Error detection codes are
// capable to detect whether one or more errors have occurred
// in a given sequence of bits – the block. It is normally not
// possible to determine the exact number of errored bits within
// the block.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/errored-blocks"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/errored-blocks"
func (n *TerminalDevice_Channel_OtnPathAny) ErroredBlocks() *TerminalDevice_Channel_Otn_ErroredBlocksPathAny {
	return &TerminalDevice_Channel_Otn_ErroredBlocksPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "errored-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErroredSeconds (leaf): The number of seconds that at least one errored blocks
// occurs, at least one code violation occurs, loss of sync is
// detected or loss of signal is detected
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/errored-seconds"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/errored-seconds"
func (n *TerminalDevice_Channel_OtnPath) ErroredSeconds() *TerminalDevice_Channel_Otn_ErroredSecondsPath {
	return &TerminalDevice_Channel_Otn_ErroredSecondsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "errored-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// ErroredSeconds (leaf): The number of seconds that at least one errored blocks
// occurs, at least one code violation occurs, loss of sync is
// detected or loss of signal is detected
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/errored-seconds"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/errored-seconds"
func (n *TerminalDevice_Channel_OtnPathAny) ErroredSeconds() *TerminalDevice_Channel_Otn_ErroredSecondsPathAny {
	return &TerminalDevice_Channel_Otn_ErroredSecondsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "errored-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esnr (container): Electrical signal to noise ratio. Baud rate
// normalized signal to noise ratio based on
// error vector magnitude in dB with two decimal
// precision. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/esnr"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr"
func (n *TerminalDevice_Channel_OtnPath) Esnr() *TerminalDevice_Channel_Otn_EsnrPath {
	return &TerminalDevice_Channel_Otn_EsnrPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esnr"},
			map[string]interface{}{},
			n,
		),
	}
}

// Esnr (container): Electrical signal to noise ratio. Baud rate
// normalized signal to noise ratio based on
// error vector magnitude in dB with two decimal
// precision. Values include the instantaneous, average,
// minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/esnr"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr"
func (n *TerminalDevice_Channel_OtnPathAny) Esnr() *TerminalDevice_Channel_Otn_EsnrPathAny {
	return &TerminalDevice_Channel_Otn_EsnrPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "esnr"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecCorrectedBits (leaf): The number of bits that were corrected by the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-corrected-bits"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/fec-corrected-bits"
func (n *TerminalDevice_Channel_OtnPath) FecCorrectedBits() *TerminalDevice_Channel_Otn_FecCorrectedBitsPath {
	return &TerminalDevice_Channel_Otn_FecCorrectedBitsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-corrected-bits"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecCorrectedBits (leaf): The number of bits that were corrected by the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-corrected-bits"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/fec-corrected-bits"
func (n *TerminalDevice_Channel_OtnPathAny) FecCorrectedBits() *TerminalDevice_Channel_Otn_FecCorrectedBitsPathAny {
	return &TerminalDevice_Channel_Otn_FecCorrectedBitsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-corrected-bits"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecCorrectedBytes (leaf): The number of bytes that were corrected by the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-corrected-bytes"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/fec-corrected-bytes"
func (n *TerminalDevice_Channel_OtnPath) FecCorrectedBytes() *TerminalDevice_Channel_Otn_FecCorrectedBytesPath {
	return &TerminalDevice_Channel_Otn_FecCorrectedBytesPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-corrected-bytes"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecCorrectedBytes (leaf): The number of bytes that were corrected by the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-corrected-bytes"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/fec-corrected-bytes"
func (n *TerminalDevice_Channel_OtnPathAny) FecCorrectedBytes() *TerminalDevice_Channel_Otn_FecCorrectedBytesPathAny {
	return &TerminalDevice_Channel_Otn_FecCorrectedBytesPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-corrected-bytes"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableBlocks (leaf): The number of blocks or frames that were uncorrectable by
// the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-uncorrectable-blocks"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/fec-uncorrectable-blocks"
func (n *TerminalDevice_Channel_OtnPath) FecUncorrectableBlocks() *TerminalDevice_Channel_Otn_FecUncorrectableBlocksPath {
	return &TerminalDevice_Channel_Otn_FecUncorrectableBlocksPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableBlocks (leaf): The number of blocks or frames that were uncorrectable by
// the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-uncorrectable-blocks"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/fec-uncorrectable-blocks"
func (n *TerminalDevice_Channel_OtnPathAny) FecUncorrectableBlocks() *TerminalDevice_Channel_Otn_FecUncorrectableBlocksPathAny {
	return &TerminalDevice_Channel_Otn_FecUncorrectableBlocksPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-blocks"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableWords (leaf): The number of words that were uncorrectable by the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-uncorrectable-words"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/fec-uncorrectable-words"
func (n *TerminalDevice_Channel_OtnPath) FecUncorrectableWords() *TerminalDevice_Channel_Otn_FecUncorrectableWordsPath {
	return &TerminalDevice_Channel_Otn_FecUncorrectableWordsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-words"},
			map[string]interface{}{},
			n,
		),
	}
}

// FecUncorrectableWords (leaf): The number of words that were uncorrectable by the FEC
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/fec-uncorrectable-words"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/fec-uncorrectable-words"
func (n *TerminalDevice_Channel_OtnPathAny) FecUncorrectableWords() *TerminalDevice_Channel_Otn_FecUncorrectableWordsPathAny {
	return &TerminalDevice_Channel_Otn_FecUncorrectableWordsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "fec-uncorrectable-words"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostFecBer (container): Bit error rate after forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/post-fec-ber"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber"
func (n *TerminalDevice_Channel_OtnPath) PostFecBer() *TerminalDevice_Channel_Otn_PostFecBerPath {
	return &TerminalDevice_Channel_Otn_PostFecBerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "post-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PostFecBer (container): Bit error rate after forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/post-fec-ber"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber"
func (n *TerminalDevice_Channel_OtnPathAny) PostFecBer() *TerminalDevice_Channel_Otn_PostFecBerPathAny {
	return &TerminalDevice_Channel_Otn_PostFecBerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "post-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreFecBer (container): Bit error rate before forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/pre-fec-ber"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber"
func (n *TerminalDevice_Channel_OtnPath) PreFecBer() *TerminalDevice_Channel_Otn_PreFecBerPath {
	return &TerminalDevice_Channel_Otn_PreFecBerPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pre-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// PreFecBer (container): Bit error rate before forward error correction -- computed
// value with 18 decimal precision. Note that decimal64
// supports values as small as i x 10^-18 where i is an
// integer. Values smaller than this should be reported as 0
// to inidicate error free or near error free performance.
// Values include the instantaneous, average, minimum, and
// maximum statistics. If avg/min/max statistics are not
// supported, the target is expected to just supply the
// instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/pre-fec-ber"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber"
func (n *TerminalDevice_Channel_OtnPathAny) PreFecBer() *TerminalDevice_Channel_Otn_PreFecBerPathAny {
	return &TerminalDevice_Channel_Otn_PreFecBerPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "pre-fec-ber"},
			map[string]interface{}{},
			n,
		),
	}
}

// QValue (container): Quality value (factor) in dB of a channel with two
// decimal precision. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/q-value"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value"
func (n *TerminalDevice_Channel_OtnPath) QValue() *TerminalDevice_Channel_Otn_QValuePath {
	return &TerminalDevice_Channel_Otn_QValuePath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "q-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// QValue (container): Quality value (factor) in dB of a channel with two
// decimal precision. Values include the instantaneous,
// average, minimum, and maximum statistics. If avg/min/max
// statistics are not supported, the target is expected
// to just supply the instant value
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/q-value"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value"
func (n *TerminalDevice_Channel_OtnPathAny) QValue() *TerminalDevice_Channel_Otn_QValuePathAny {
	return &TerminalDevice_Channel_Otn_QValuePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "q-value"},
			map[string]interface{}{},
			n,
		),
	}
}

// RdiMsg (leaf): Remote defect indication (RDI) message received
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/rdi-msg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/rdi-msg"
func (n *TerminalDevice_Channel_OtnPath) RdiMsg() *TerminalDevice_Channel_Otn_RdiMsgPath {
	return &TerminalDevice_Channel_Otn_RdiMsgPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "rdi-msg"},
			map[string]interface{}{},
			n,
		),
	}
}

// RdiMsg (leaf): Remote defect indication (RDI) message received
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/rdi-msg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/rdi-msg"
func (n *TerminalDevice_Channel_OtnPathAny) RdiMsg() *TerminalDevice_Channel_Otn_RdiMsgPathAny {
	return &TerminalDevice_Channel_Otn_RdiMsgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "rdi-msg"},
			map[string]interface{}{},
			n,
		),
	}
}

// SeverelyErroredSeconds (leaf): The number of seconds that loss of frame is detected OR
// the number of errored blocks, code violations, loss of sync
// or loss of signal is detected exceeds a predefined
// threshold
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/severely-errored-seconds"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/severely-errored-seconds"
func (n *TerminalDevice_Channel_OtnPath) SeverelyErroredSeconds() *TerminalDevice_Channel_Otn_SeverelyErroredSecondsPath {
	return &TerminalDevice_Channel_Otn_SeverelyErroredSecondsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "severely-errored-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// SeverelyErroredSeconds (leaf): The number of seconds that loss of frame is detected OR
// the number of errored blocks, code violations, loss of sync
// or loss of signal is detected exceeds a predefined
// threshold
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/severely-errored-seconds"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/severely-errored-seconds"
func (n *TerminalDevice_Channel_OtnPathAny) SeverelyErroredSeconds() *TerminalDevice_Channel_Otn_SeverelyErroredSecondsPathAny {
	return &TerminalDevice_Channel_Otn_SeverelyErroredSecondsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "severely-errored-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// TributarySlotGranularity (leaf): Granularity value of OPUk or OPUCn tributary slots for OTN
// signal allocation. The currently defined values follow the
// existing ITU-T G.709 standard, which can be extended as
// needed in future.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tributary-slot-granularity"
// Path from root: "/terminal-device/logical-channels/channel/otn/config/tributary-slot-granularity"
func (n *TerminalDevice_Channel_OtnPath) TributarySlotGranularity() *TerminalDevice_Channel_Otn_TributarySlotGranularityPath {
	return &TerminalDevice_Channel_Otn_TributarySlotGranularityPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tributary-slot-granularity"},
			map[string]interface{}{},
			n,
		),
	}
}

// TributarySlotGranularity (leaf): Granularity value of OPUk or OPUCn tributary slots for OTN
// signal allocation. The currently defined values follow the
// existing ITU-T G.709 standard, which can be extended as
// needed in future.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tributary-slot-granularity"
// Path from root: "/terminal-device/logical-channels/channel/otn/config/tributary-slot-granularity"
func (n *TerminalDevice_Channel_OtnPathAny) TributarySlotGranularity() *TerminalDevice_Channel_Otn_TributarySlotGranularityPathAny {
	return &TerminalDevice_Channel_Otn_TributarySlotGranularityPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tributary-slot-granularity"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtiMsgAuto (leaf): Trail trace identifier (TTI) transmit message automatically
// created.  If true, then setting a custom transmit message
// would be invalid.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tti-msg-auto"
// Path from root: "/terminal-device/logical-channels/channel/otn/config/tti-msg-auto"
func (n *TerminalDevice_Channel_OtnPath) TtiMsgAuto() *TerminalDevice_Channel_Otn_TtiMsgAutoPath {
	return &TerminalDevice_Channel_Otn_TtiMsgAutoPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tti-msg-auto"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtiMsgAuto (leaf): Trail trace identifier (TTI) transmit message automatically
// created.  If true, then setting a custom transmit message
// would be invalid.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tti-msg-auto"
// Path from root: "/terminal-device/logical-channels/channel/otn/config/tti-msg-auto"
func (n *TerminalDevice_Channel_OtnPathAny) TtiMsgAuto() *TerminalDevice_Channel_Otn_TtiMsgAutoPathAny {
	return &TerminalDevice_Channel_Otn_TtiMsgAutoPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tti-msg-auto"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtiMsgExpected (leaf): Trail trace identifier (TTI) message expected
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tti-msg-expected"
// Path from root: "/terminal-device/logical-channels/channel/otn/config/tti-msg-expected"
func (n *TerminalDevice_Channel_OtnPath) TtiMsgExpected() *TerminalDevice_Channel_Otn_TtiMsgExpectedPath {
	return &TerminalDevice_Channel_Otn_TtiMsgExpectedPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tti-msg-expected"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtiMsgExpected (leaf): Trail trace identifier (TTI) message expected
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tti-msg-expected"
// Path from root: "/terminal-device/logical-channels/channel/otn/config/tti-msg-expected"
func (n *TerminalDevice_Channel_OtnPathAny) TtiMsgExpected() *TerminalDevice_Channel_Otn_TtiMsgExpectedPathAny {
	return &TerminalDevice_Channel_Otn_TtiMsgExpectedPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tti-msg-expected"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtiMsgRecv (leaf): Trail trace identifier (TTI) message received
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/tti-msg-recv"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/tti-msg-recv"
func (n *TerminalDevice_Channel_OtnPath) TtiMsgRecv() *TerminalDevice_Channel_Otn_TtiMsgRecvPath {
	return &TerminalDevice_Channel_Otn_TtiMsgRecvPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tti-msg-recv"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtiMsgRecv (leaf): Trail trace identifier (TTI) message received
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/tti-msg-recv"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/tti-msg-recv"
func (n *TerminalDevice_Channel_OtnPathAny) TtiMsgRecv() *TerminalDevice_Channel_Otn_TtiMsgRecvPathAny {
	return &TerminalDevice_Channel_Otn_TtiMsgRecvPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "tti-msg-recv"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtiMsgTransmit (leaf): Trail trace identifier (TTI) message transmitted
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tti-msg-transmit"
// Path from root: "/terminal-device/logical-channels/channel/otn/config/tti-msg-transmit"
func (n *TerminalDevice_Channel_OtnPath) TtiMsgTransmit() *TerminalDevice_Channel_Otn_TtiMsgTransmitPath {
	return &TerminalDevice_Channel_Otn_TtiMsgTransmitPath{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tti-msg-transmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// TtiMsgTransmit (leaf): Trail trace identifier (TTI) message transmitted
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "config/tti-msg-transmit"
// Path from root: "/terminal-device/logical-channels/channel/otn/config/tti-msg-transmit"
func (n *TerminalDevice_Channel_OtnPathAny) TtiMsgTransmit() *TerminalDevice_Channel_Otn_TtiMsgTransmitPathAny {
	return &TerminalDevice_Channel_Otn_TtiMsgTransmitPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"config", "tti-msg-transmit"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnavailableSeconds (leaf): The number of seconds during which the link is unavailable
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/unavailable-seconds"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/unavailable-seconds"
func (n *TerminalDevice_Channel_OtnPath) UnavailableSeconds() *TerminalDevice_Channel_Otn_UnavailableSecondsPath {
	return &TerminalDevice_Channel_Otn_UnavailableSecondsPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "unavailable-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// UnavailableSeconds (leaf): The number of seconds during which the link is unavailable
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/unavailable-seconds"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/unavailable-seconds"
func (n *TerminalDevice_Channel_OtnPathAny) UnavailableSeconds() *TerminalDevice_Channel_Otn_UnavailableSecondsPathAny {
	return &TerminalDevice_Channel_Otn_UnavailableSecondsPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "unavailable-seconds"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Otn_EsnrPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr YANG schema element.
type TerminalDevice_Channel_Otn_EsnrPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_EsnrPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr YANG schema element.
type TerminalDevice_Channel_Otn_EsnrPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_AvgPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/avg YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_AvgPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_AvgPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/avg YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_AvgPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_InstantPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/instant YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_InstantPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_InstantPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/instant YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_InstantPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_IntervalPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/interval YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_IntervalPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_IntervalPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/interval YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_IntervalPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_MaxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/max YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_MaxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_MaxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/max YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_MaxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_MaxTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/max-time YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_MaxTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_MaxTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/max-time YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_MaxTimePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_MinPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/min YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_MinPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_MinPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/min YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_MinPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_MinTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/min-time YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_MinTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_Esnr_MinTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/esnr/min-time YANG schema element.
type TerminalDevice_Channel_Otn_Esnr_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/avg"
func (n *TerminalDevice_Channel_Otn_EsnrPath) Avg() *TerminalDevice_Channel_Otn_Esnr_AvgPath {
	return &TerminalDevice_Channel_Otn_Esnr_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/avg"
func (n *TerminalDevice_Channel_Otn_EsnrPathAny) Avg() *TerminalDevice_Channel_Otn_Esnr_AvgPathAny {
	return &TerminalDevice_Channel_Otn_Esnr_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/instant"
func (n *TerminalDevice_Channel_Otn_EsnrPath) Instant() *TerminalDevice_Channel_Otn_Esnr_InstantPath {
	return &TerminalDevice_Channel_Otn_Esnr_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/instant"
func (n *TerminalDevice_Channel_Otn_EsnrPathAny) Instant() *TerminalDevice_Channel_Otn_Esnr_InstantPathAny {
	return &TerminalDevice_Channel_Otn_Esnr_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/interval"
func (n *TerminalDevice_Channel_Otn_EsnrPath) Interval() *TerminalDevice_Channel_Otn_Esnr_IntervalPath {
	return &TerminalDevice_Channel_Otn_Esnr_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/interval"
func (n *TerminalDevice_Channel_Otn_EsnrPathAny) Interval() *TerminalDevice_Channel_Otn_Esnr_IntervalPathAny {
	return &TerminalDevice_Channel_Otn_Esnr_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/max"
func (n *TerminalDevice_Channel_Otn_EsnrPath) Max() *TerminalDevice_Channel_Otn_Esnr_MaxPath {
	return &TerminalDevice_Channel_Otn_Esnr_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/max"
func (n *TerminalDevice_Channel_Otn_EsnrPathAny) Max() *TerminalDevice_Channel_Otn_Esnr_MaxPathAny {
	return &TerminalDevice_Channel_Otn_Esnr_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/max-time"
func (n *TerminalDevice_Channel_Otn_EsnrPath) MaxTime() *TerminalDevice_Channel_Otn_Esnr_MaxTimePath {
	return &TerminalDevice_Channel_Otn_Esnr_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/max-time"
func (n *TerminalDevice_Channel_Otn_EsnrPathAny) MaxTime() *TerminalDevice_Channel_Otn_Esnr_MaxTimePathAny {
	return &TerminalDevice_Channel_Otn_Esnr_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/min"
func (n *TerminalDevice_Channel_Otn_EsnrPath) Min() *TerminalDevice_Channel_Otn_Esnr_MinPath {
	return &TerminalDevice_Channel_Otn_Esnr_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/min"
func (n *TerminalDevice_Channel_Otn_EsnrPathAny) Min() *TerminalDevice_Channel_Otn_Esnr_MinPathAny {
	return &TerminalDevice_Channel_Otn_Esnr_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/min-time"
func (n *TerminalDevice_Channel_Otn_EsnrPath) MinTime() *TerminalDevice_Channel_Otn_Esnr_MinTimePath {
	return &TerminalDevice_Channel_Otn_Esnr_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/esnr/min-time"
func (n *TerminalDevice_Channel_Otn_EsnrPathAny) MinTime() *TerminalDevice_Channel_Otn_Esnr_MinTimePathAny {
	return &TerminalDevice_Channel_Otn_Esnr_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Otn_PostFecBerPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBerPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBerPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBerPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_AvgPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/avg YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_AvgPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_AvgPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/avg YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_AvgPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_InstantPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/instant YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_InstantPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_InstantPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/instant YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_InstantPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_IntervalPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/interval YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_IntervalPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_IntervalPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/interval YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_IntervalPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_MaxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/max YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_MaxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_MaxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/max YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_MaxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_MaxTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/max-time YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_MaxTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_MaxTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/max-time YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_MaxTimePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_MinPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/min YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_MinPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_MinPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/min YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_MinPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_MinTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/min-time YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_MinTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PostFecBer_MinTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/post-fec-ber/min-time YANG schema element.
type TerminalDevice_Channel_Otn_PostFecBer_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/avg"
func (n *TerminalDevice_Channel_Otn_PostFecBerPath) Avg() *TerminalDevice_Channel_Otn_PostFecBer_AvgPath {
	return &TerminalDevice_Channel_Otn_PostFecBer_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/avg"
func (n *TerminalDevice_Channel_Otn_PostFecBerPathAny) Avg() *TerminalDevice_Channel_Otn_PostFecBer_AvgPathAny {
	return &TerminalDevice_Channel_Otn_PostFecBer_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/instant"
func (n *TerminalDevice_Channel_Otn_PostFecBerPath) Instant() *TerminalDevice_Channel_Otn_PostFecBer_InstantPath {
	return &TerminalDevice_Channel_Otn_PostFecBer_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/instant"
func (n *TerminalDevice_Channel_Otn_PostFecBerPathAny) Instant() *TerminalDevice_Channel_Otn_PostFecBer_InstantPathAny {
	return &TerminalDevice_Channel_Otn_PostFecBer_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/interval"
func (n *TerminalDevice_Channel_Otn_PostFecBerPath) Interval() *TerminalDevice_Channel_Otn_PostFecBer_IntervalPath {
	return &TerminalDevice_Channel_Otn_PostFecBer_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/interval"
func (n *TerminalDevice_Channel_Otn_PostFecBerPathAny) Interval() *TerminalDevice_Channel_Otn_PostFecBer_IntervalPathAny {
	return &TerminalDevice_Channel_Otn_PostFecBer_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/max"
func (n *TerminalDevice_Channel_Otn_PostFecBerPath) Max() *TerminalDevice_Channel_Otn_PostFecBer_MaxPath {
	return &TerminalDevice_Channel_Otn_PostFecBer_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/max"
func (n *TerminalDevice_Channel_Otn_PostFecBerPathAny) Max() *TerminalDevice_Channel_Otn_PostFecBer_MaxPathAny {
	return &TerminalDevice_Channel_Otn_PostFecBer_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/max-time"
func (n *TerminalDevice_Channel_Otn_PostFecBerPath) MaxTime() *TerminalDevice_Channel_Otn_PostFecBer_MaxTimePath {
	return &TerminalDevice_Channel_Otn_PostFecBer_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/max-time"
func (n *TerminalDevice_Channel_Otn_PostFecBerPathAny) MaxTime() *TerminalDevice_Channel_Otn_PostFecBer_MaxTimePathAny {
	return &TerminalDevice_Channel_Otn_PostFecBer_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/min"
func (n *TerminalDevice_Channel_Otn_PostFecBerPath) Min() *TerminalDevice_Channel_Otn_PostFecBer_MinPath {
	return &TerminalDevice_Channel_Otn_PostFecBer_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/min"
func (n *TerminalDevice_Channel_Otn_PostFecBerPathAny) Min() *TerminalDevice_Channel_Otn_PostFecBer_MinPathAny {
	return &TerminalDevice_Channel_Otn_PostFecBer_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/min-time"
func (n *TerminalDevice_Channel_Otn_PostFecBerPath) MinTime() *TerminalDevice_Channel_Otn_PostFecBer_MinTimePath {
	return &TerminalDevice_Channel_Otn_PostFecBer_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/post-fec-ber/min-time"
func (n *TerminalDevice_Channel_Otn_PostFecBerPathAny) MinTime() *TerminalDevice_Channel_Otn_PostFecBer_MinTimePathAny {
	return &TerminalDevice_Channel_Otn_PostFecBer_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Otn_PreFecBerPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBerPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBerPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBerPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_AvgPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/avg YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_AvgPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_AvgPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/avg YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_AvgPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_InstantPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/instant YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_InstantPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_InstantPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/instant YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_InstantPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_IntervalPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/interval YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_IntervalPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_IntervalPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/interval YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_IntervalPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_MaxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/max YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_MaxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_MaxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/max YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_MaxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_MaxTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/max-time YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_MaxTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_MaxTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/max-time YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_MaxTimePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_MinPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/min YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_MinPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_MinPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/min YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_MinPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_MinTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/min-time YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_MinTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_PreFecBer_MinTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/min-time YANG schema element.
type TerminalDevice_Channel_Otn_PreFecBer_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/avg"
func (n *TerminalDevice_Channel_Otn_PreFecBerPath) Avg() *TerminalDevice_Channel_Otn_PreFecBer_AvgPath {
	return &TerminalDevice_Channel_Otn_PreFecBer_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/avg"
func (n *TerminalDevice_Channel_Otn_PreFecBerPathAny) Avg() *TerminalDevice_Channel_Otn_PreFecBer_AvgPathAny {
	return &TerminalDevice_Channel_Otn_PreFecBer_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/instant"
func (n *TerminalDevice_Channel_Otn_PreFecBerPath) Instant() *TerminalDevice_Channel_Otn_PreFecBer_InstantPath {
	return &TerminalDevice_Channel_Otn_PreFecBer_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/instant"
func (n *TerminalDevice_Channel_Otn_PreFecBerPathAny) Instant() *TerminalDevice_Channel_Otn_PreFecBer_InstantPathAny {
	return &TerminalDevice_Channel_Otn_PreFecBer_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/interval"
func (n *TerminalDevice_Channel_Otn_PreFecBerPath) Interval() *TerminalDevice_Channel_Otn_PreFecBer_IntervalPath {
	return &TerminalDevice_Channel_Otn_PreFecBer_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/interval"
func (n *TerminalDevice_Channel_Otn_PreFecBerPathAny) Interval() *TerminalDevice_Channel_Otn_PreFecBer_IntervalPathAny {
	return &TerminalDevice_Channel_Otn_PreFecBer_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/max"
func (n *TerminalDevice_Channel_Otn_PreFecBerPath) Max() *TerminalDevice_Channel_Otn_PreFecBer_MaxPath {
	return &TerminalDevice_Channel_Otn_PreFecBer_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/max"
func (n *TerminalDevice_Channel_Otn_PreFecBerPathAny) Max() *TerminalDevice_Channel_Otn_PreFecBer_MaxPathAny {
	return &TerminalDevice_Channel_Otn_PreFecBer_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/max-time"
func (n *TerminalDevice_Channel_Otn_PreFecBerPath) MaxTime() *TerminalDevice_Channel_Otn_PreFecBer_MaxTimePath {
	return &TerminalDevice_Channel_Otn_PreFecBer_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/max-time"
func (n *TerminalDevice_Channel_Otn_PreFecBerPathAny) MaxTime() *TerminalDevice_Channel_Otn_PreFecBer_MaxTimePathAny {
	return &TerminalDevice_Channel_Otn_PreFecBer_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/min"
func (n *TerminalDevice_Channel_Otn_PreFecBerPath) Min() *TerminalDevice_Channel_Otn_PreFecBer_MinPath {
	return &TerminalDevice_Channel_Otn_PreFecBer_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-transport-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/min"
func (n *TerminalDevice_Channel_Otn_PreFecBerPathAny) Min() *TerminalDevice_Channel_Otn_PreFecBer_MinPathAny {
	return &TerminalDevice_Channel_Otn_PreFecBer_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/min-time"
func (n *TerminalDevice_Channel_Otn_PreFecBerPath) MinTime() *TerminalDevice_Channel_Otn_PreFecBer_MinTimePath {
	return &TerminalDevice_Channel_Otn_PreFecBer_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/pre-fec-ber/min-time"
func (n *TerminalDevice_Channel_Otn_PreFecBerPathAny) MinTime() *TerminalDevice_Channel_Otn_PreFecBer_MinTimePathAny {
	return &TerminalDevice_Channel_Otn_PreFecBer_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_Channel_Otn_QValuePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value YANG schema element.
type TerminalDevice_Channel_Otn_QValuePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValuePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value YANG schema element.
type TerminalDevice_Channel_Otn_QValuePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_AvgPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/avg YANG schema element.
type TerminalDevice_Channel_Otn_QValue_AvgPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_AvgPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/avg YANG schema element.
type TerminalDevice_Channel_Otn_QValue_AvgPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_InstantPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/instant YANG schema element.
type TerminalDevice_Channel_Otn_QValue_InstantPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_InstantPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/instant YANG schema element.
type TerminalDevice_Channel_Otn_QValue_InstantPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_IntervalPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/interval YANG schema element.
type TerminalDevice_Channel_Otn_QValue_IntervalPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_IntervalPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/interval YANG schema element.
type TerminalDevice_Channel_Otn_QValue_IntervalPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_MaxPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/max YANG schema element.
type TerminalDevice_Channel_Otn_QValue_MaxPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_MaxPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/max YANG schema element.
type TerminalDevice_Channel_Otn_QValue_MaxPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_MaxTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/max-time YANG schema element.
type TerminalDevice_Channel_Otn_QValue_MaxTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_MaxTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/max-time YANG schema element.
type TerminalDevice_Channel_Otn_QValue_MaxTimePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_MinPath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/min YANG schema element.
type TerminalDevice_Channel_Otn_QValue_MinPath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_MinPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/min YANG schema element.
type TerminalDevice_Channel_Otn_QValue_MinPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_MinTimePath represents the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/min-time YANG schema element.
type TerminalDevice_Channel_Otn_QValue_MinTimePath struct {
	*ygot.NodePath
}

// TerminalDevice_Channel_Otn_QValue_MinTimePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/logical-channels/channel/otn/state/q-value/min-time YANG schema element.
type TerminalDevice_Channel_Otn_QValue_MinTimePathAny struct {
	*ygot.NodePath
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/avg"
func (n *TerminalDevice_Channel_Otn_QValuePath) Avg() *TerminalDevice_Channel_Otn_QValue_AvgPath {
	return &TerminalDevice_Channel_Otn_QValue_AvgPath{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Avg (leaf): The arithmetic mean value of the statistic over the
// time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "avg"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/avg"
func (n *TerminalDevice_Channel_Otn_QValuePathAny) Avg() *TerminalDevice_Channel_Otn_QValue_AvgPathAny {
	return &TerminalDevice_Channel_Otn_QValue_AvgPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"avg"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/instant"
func (n *TerminalDevice_Channel_Otn_QValuePath) Instant() *TerminalDevice_Channel_Otn_QValue_InstantPath {
	return &TerminalDevice_Channel_Otn_QValue_InstantPath{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Instant (leaf): The instantaneous value of the statistic.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "instant"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/instant"
func (n *TerminalDevice_Channel_Otn_QValuePathAny) Instant() *TerminalDevice_Channel_Otn_QValue_InstantPathAny {
	return &TerminalDevice_Channel_Otn_QValue_InstantPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"instant"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/interval"
func (n *TerminalDevice_Channel_Otn_QValuePath) Interval() *TerminalDevice_Channel_Otn_QValue_IntervalPath {
	return &TerminalDevice_Channel_Otn_QValue_IntervalPath{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Interval (leaf): If supported by the system, this reports the time interval
// over which the min/max/average statistics are computed by
// the system.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "interval"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/interval"
func (n *TerminalDevice_Channel_Otn_QValuePathAny) Interval() *TerminalDevice_Channel_Otn_QValue_IntervalPathAny {
	return &TerminalDevice_Channel_Otn_QValue_IntervalPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"interval"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/max"
func (n *TerminalDevice_Channel_Otn_QValuePath) Max() *TerminalDevice_Channel_Otn_QValue_MaxPath {
	return &TerminalDevice_Channel_Otn_QValue_MaxPath{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// Max (leaf): The maximum value of the statistic over the time
// interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/max"
func (n *TerminalDevice_Channel_Otn_QValuePathAny) Max() *TerminalDevice_Channel_Otn_QValue_MaxPathAny {
	return &TerminalDevice_Channel_Otn_QValue_MaxPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/max-time"
func (n *TerminalDevice_Channel_Otn_QValuePath) MaxTime() *TerminalDevice_Channel_Otn_QValue_MaxTimePath {
	return &TerminalDevice_Channel_Otn_QValue_MaxTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MaxTime (leaf): The absolute time at which the maximum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "max-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/max-time"
func (n *TerminalDevice_Channel_Otn_QValuePathAny) MaxTime() *TerminalDevice_Channel_Otn_QValue_MaxTimePathAny {
	return &TerminalDevice_Channel_Otn_QValue_MaxTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"max-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/min"
func (n *TerminalDevice_Channel_Otn_QValuePath) Min() *TerminalDevice_Channel_Otn_QValue_MinPath {
	return &TerminalDevice_Channel_Otn_QValue_MinPath{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// Min (leaf): The minimum value of the statistic over the time interval.
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/min"
func (n *TerminalDevice_Channel_Otn_QValuePathAny) Min() *TerminalDevice_Channel_Otn_QValue_MinPathAny {
	return &TerminalDevice_Channel_Otn_QValue_MinPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/min-time"
func (n *TerminalDevice_Channel_Otn_QValuePath) MinTime() *TerminalDevice_Channel_Otn_QValue_MinTimePath {
	return &TerminalDevice_Channel_Otn_QValue_MinTimePath{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// MinTime (leaf): The absolute time at which the minimum value occurred.
// The value is the timestamp in nanoseconds relative to
//  the Unix Epoch (Jan 1, 1970 00:00:00 UTC).
// ----------------------------------------
// Defining module: "openconfig-types"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "min-time"
// Path from root: "/terminal-device/logical-channels/channel/otn/state/q-value/min-time"
func (n *TerminalDevice_Channel_Otn_QValuePathAny) MinTime() *TerminalDevice_Channel_Otn_QValue_MinTimePathAny {
	return &TerminalDevice_Channel_Otn_QValue_MinTimePathAny{
		NodePath: ygot.NewNodePath(
			[]string{"min-time"},
			map[string]interface{}{},
			n,
		),
	}
}

// TerminalDevice_ModePath represents the /openconfig-terminal-device/terminal-device/operational-modes/mode YANG schema element.
type TerminalDevice_ModePath struct {
	*ygot.NodePath
}

// TerminalDevice_ModePathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/operational-modes/mode YANG schema element.
type TerminalDevice_ModePathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Mode_DescriptionPath represents the /openconfig-terminal-device/terminal-device/operational-modes/mode/state/description YANG schema element.
type TerminalDevice_Mode_DescriptionPath struct {
	*ygot.NodePath
}

// TerminalDevice_Mode_DescriptionPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/operational-modes/mode/state/description YANG schema element.
type TerminalDevice_Mode_DescriptionPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Mode_ModeIdPath represents the /openconfig-terminal-device/terminal-device/operational-modes/mode/state/mode-id YANG schema element.
type TerminalDevice_Mode_ModeIdPath struct {
	*ygot.NodePath
}

// TerminalDevice_Mode_ModeIdPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/operational-modes/mode/state/mode-id YANG schema element.
type TerminalDevice_Mode_ModeIdPathAny struct {
	*ygot.NodePath
}

// TerminalDevice_Mode_VendorIdPath represents the /openconfig-terminal-device/terminal-device/operational-modes/mode/state/vendor-id YANG schema element.
type TerminalDevice_Mode_VendorIdPath struct {
	*ygot.NodePath
}

// TerminalDevice_Mode_VendorIdPathAny represents the wildcard version of the /openconfig-terminal-device/terminal-device/operational-modes/mode/state/vendor-id YANG schema element.
type TerminalDevice_Mode_VendorIdPathAny struct {
	*ygot.NodePath
}

// Description (leaf): Vendor-supplied textual description of the characteristics
// of this operational mode to enable operators to select the
// appropriate mode for the application.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/description"
// Path from root: "/terminal-device/operational-modes/mode/state/description"
func (n *TerminalDevice_ModePath) Description() *TerminalDevice_Mode_DescriptionPath {
	return &TerminalDevice_Mode_DescriptionPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// Description (leaf): Vendor-supplied textual description of the characteristics
// of this operational mode to enable operators to select the
// appropriate mode for the application.
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/description"
// Path from root: "/terminal-device/operational-modes/mode/state/description"
func (n *TerminalDevice_ModePathAny) Description() *TerminalDevice_Mode_DescriptionPathAny {
	return &TerminalDevice_Mode_DescriptionPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "description"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModeId (leaf): Two-octet encoding of the vendor-defined operational
// mode
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/mode-id"
// Path from root: "/terminal-device/operational-modes/mode/state/mode-id"
func (n *TerminalDevice_ModePath) ModeId() *TerminalDevice_Mode_ModeIdPath {
	return &TerminalDevice_Mode_ModeIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mode-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// ModeId (leaf): Two-octet encoding of the vendor-defined operational
// mode
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/mode-id"
// Path from root: "/terminal-device/operational-modes/mode/state/mode-id"
func (n *TerminalDevice_ModePathAny) ModeId() *TerminalDevice_Mode_ModeIdPathAny {
	return &TerminalDevice_Mode_ModeIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "mode-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VendorId (leaf): Identifier to represent the vendor / supplier of the
// platform and the associated operational mode information
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/vendor-id"
// Path from root: "/terminal-device/operational-modes/mode/state/vendor-id"
func (n *TerminalDevice_ModePath) VendorId() *TerminalDevice_Mode_VendorIdPath {
	return &TerminalDevice_Mode_VendorIdPath{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vendor-id"},
			map[string]interface{}{},
			n,
		),
	}
}

// VendorId (leaf): Identifier to represent the vendor / supplier of the
// platform and the associated operational mode information
// ----------------------------------------
// Defining module: "openconfig-terminal-device"
// Instantiating module: "openconfig-terminal-device"
// Path from parent: "state/vendor-id"
// Path from root: "/terminal-device/operational-modes/mode/state/vendor-id"
func (n *TerminalDevice_ModePathAny) VendorId() *TerminalDevice_Mode_VendorIdPathAny {
	return &TerminalDevice_Mode_VendorIdPathAny{
		NodePath: ygot.NewNodePath(
			[]string{"state", "vendor-id"},
			map[string]interface{}{},
			n,
		),
	}
}
